/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/arrays","vs/base/common/strings","vs/platform/telemetry/common/telemetry","os","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/platform/environment/electron-main/environmentMainService","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/node/state","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/common/ipc","vs/base/common/json","vs/base/common/labels","child_process","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/severity","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","net","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/parts/ipc/node/ipc.net","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(x){for(var e=[],E=0,A=x.length;E<A;E++)e[E]=te[x[E]];return e};define(te[133],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(P,f){const l=Math.pow(10,f);return Math.round(P*l)/l}class A{constructor(f,l,w,m=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=E(Math.max(Math.min(1,m),0),3)}static equals(f,l){return f.r===l.r&&f.g===l.g&&f.b===l.b&&f.a===l.a}}e.RGBA=A;class r{constructor(f,l,w,m){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.l=E(Math.max(Math.min(1,w),0),3),this.a=E(Math.max(Math.min(1,m),0),3)}static equals(f,l){return f.h===l.h&&f.s===l.s&&f.l===l.l&&f.a===l.a}static fromRGBA(f){const l=f.r/255,w=f.g/255,m=f.b/255,v=f.a,u=Math.max(l,w,m),b=Math.min(l,w,m);let p=0,s=0;const y=(b+u)/2,a=u-b;if(a>0){switch(s=Math.min(y<=.5?a/(2*y):a/(2-2*y),1),u){case l:p=(w-m)/a+(w<m?6:0);break;case w:p=(m-l)/a+2;break;case m:p=(l-w)/a+4;break}p*=60,p=Math.round(p)}return new r(p,s,y,v)}static i(f,l,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?f+(l-f)*6*w:w<1/2?l:w<2/3?f+(l-f)*(2/3-w)*6:f}static toRGBA(f){const l=f.h/360,{s:w,l:m,a:v}=f;let u,b,p;if(w===0)u=b=p=m;else{const s=m<.5?m*(1+w):m+w-m*w,y=2*m-s;u=r.i(y,s,l+1/3),b=r.i(y,s,l),p=r.i(y,s,l-1/3)}return new A(Math.round(u*255),Math.round(b*255),Math.round(p*255),v)}}e.HSLA=r;class O{constructor(f,l,w,m){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.v=E(Math.max(Math.min(1,w),0),3),this.a=E(Math.max(Math.min(1,m),0),3)}static equals(f,l){return f.h===l.h&&f.s===l.s&&f.v===l.v&&f.a===l.a}static fromRGBA(f){const l=f.r/255,w=f.g/255,m=f.b/255,v=Math.max(l,w,m),u=Math.min(l,w,m),b=v-u,p=v===0?0:b/v;let s;return b===0?s=0:v===l?s=((w-m)/b%6+6)%6:v===w?s=(m-l)/b+2:s=(l-w)/b+4,new O(Math.round(s*60),p,v,f.a)}static toRGBA(f){const{h:l,s:w,v:m,a:v}=f,u=m*w,b=u*(1-Math.abs(l/60%2-1)),p=m-u;let[s,y,a]=[0,0,0];return l<60?(s=u,y=b):l<120?(s=b,y=u):l<180?(y=u,a=b):l<240?(y=b,a=u):l<300?(s=b,a=u):l<=360&&(s=u,a=b),s=Math.round((s+p)*255),y=Math.round((y+p)*255),a=Math.round((a+p)*255),new A(s,y,a,v)}}e.HSVA=O;class M{static fromHex(f){return M.Format.CSS.parseHex(f)||M.red}static equals(f,l){return!f&&!l?!0:!f||!l?!1:f.equals(l)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof A)this.rgba=f;else if(f instanceof r)this.i=f,this.rgba=r.toRGBA(f);else if(f instanceof O)this.j=f,this.rgba=O.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&A.equals(this.rgba,f.rgba)&&r.equals(this.hsla,f.hsla)&&O.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=M.k(this.rgba.r),l=M.k(this.rgba.g),w=M.k(this.rgba.b),m=.2126*f+.7152*l+.0722*w;return E(m,4)}static k(f){const l=f/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(f){const l=this.getRelativeLuminance(),w=f.getRelativeLuminance();return l>w?(l+.05)/(w+.05):(w+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const l=this.getRelativeLuminance(),w=f.getRelativeLuminance();return l>w}isDarkerThan(f){const l=this.getRelativeLuminance(),w=f.getRelativeLuminance();return l<w}lighten(f){return new M(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new M(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:l,g:w,b:m,a:v}=this.rgba;return new M(new A(l,w,m,v*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const l=f.rgba,w=this.rgba.a,m=l.a,v=w+m*(1-w);if(v<1e-6)return M.transparent;const u=this.rgba.r*w/v+l.r*m*(1-w)/v,b=this.rgba.g*w/v+l.g*m*(1-w)/v,p=this.rgba.b*w/v+l.b*m*(1-w)/v;return new M(new A(u,b,p,v))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:l,g:w,b:m,a:v}=this.rgba;return new M(new A(f.rgba.r-v*(f.rgba.r-l),f.rgba.g-v*(f.rgba.g-w),f.rgba.b-v*(f.rgba.b-m),1))}flatten(...f){const l=f.reduceRight((w,m)=>M.o(m,w));return M.o(this,l)}static o(f,l){const w=1-f.rgba.a;return new M(new A(w*l.rgba.r+f.rgba.a*f.rgba.r,w*l.rgba.g+f.rgba.a*f.rgba.g,w*l.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=M.Format.CSS.format(this)),this.u}static getLighterColor(f,l,w){if(f.isLighterThan(l))return f;w=w||.5;const m=f.getRelativeLuminance(),v=l.getRelativeLuminance();return w=w*(v-m)/v,f.lighten(w)}static getDarkerColor(f,l,w){if(f.isDarkerThan(l))return f;w=w||.5;const m=f.getRelativeLuminance(),v=l.getRelativeLuminance();return w=w*(m-v)/m,f.darken(w)}}e.Color=M,M.white=new M(new A(255,255,255,1)),M.black=new M(new A(0,0,0,1)),M.red=new M(new A(255,0,0,1)),M.blue=new M(new A(0,0,255,1)),M.green=new M(new A(0,255,0,1)),M.cyan=new M(new A(0,255,255,1)),M.lightgrey=new M(new A(211,211,211,1)),M.transparent=new M(new A(0,0,0,0)),function(P){let f;(function(l){let w;(function(m){function v(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}m.formatRGB=v;function u(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}m.formatRGBA=u;function b(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}m.formatHSL=b;function p(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}m.formatHSLA=p;function s(t){const c=t.toString(16);return c.length!==2?"0"+c:c}function y(t){return`#${s(t.rgba.r)}${s(t.rgba.g)}${s(t.rgba.b)}`}m.formatHex=y;function a(t,c=!1){return c&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${s(t.rgba.r)}${s(t.rgba.g)}${s(t.rgba.b)}${s(Math.round(t.rgba.a*255))}`}m.formatHexA=a;function d(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}m.format=d;function I(t){const c=t.length;if(c===0||t.charCodeAt(0)!==35)return null;if(c===7){const n=16*k(t.charCodeAt(1))+k(t.charCodeAt(2)),i=16*k(t.charCodeAt(3))+k(t.charCodeAt(4)),o=16*k(t.charCodeAt(5))+k(t.charCodeAt(6));return new P(new A(n,i,o,1))}if(c===9){const n=16*k(t.charCodeAt(1))+k(t.charCodeAt(2)),i=16*k(t.charCodeAt(3))+k(t.charCodeAt(4)),o=16*k(t.charCodeAt(5))+k(t.charCodeAt(6)),h=16*k(t.charCodeAt(7))+k(t.charCodeAt(8));return new P(new A(n,i,o,h/255))}if(c===4){const n=k(t.charCodeAt(1)),i=k(t.charCodeAt(2)),o=k(t.charCodeAt(3));return new P(new A(16*n+n,16*i+i,16*o+o))}if(c===5){const n=k(t.charCodeAt(1)),i=k(t.charCodeAt(2)),o=k(t.charCodeAt(3)),h=k(t.charCodeAt(4));return new P(new A(16*n+n,16*i+i,16*o+o,(16*h+h)/255))}return null}m.parseHex=I;function k(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=l.CSS||(l.CSS={}))})(f=P.Format||(P.Format={}))}(M||(e.Color=M={}))}),define(te[55],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(M){return(P,f,l)=>{let w=null,m=null;if(typeof l.value=="function"?(w="value",m=l.value):typeof l.get=="function"&&(w="get",m=l.get),!m)throw new Error("not supported");l[w]=M(m,f)}}function A(M,P,f){let l=null,w=null;if(typeof f.value=="function"?(l="value",w=f.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(l="get",w=f.get),!w)throw new Error("not supported");const m=`$memoize$${P}`;f[l]=function(...v){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,v)}),this[m]}}e.memoize=A;function r(M,P,f){return E((l,w)=>{const m=`$debounce$${w}`,v=`$debounce$result$${w}`;return function(...u){this[v]||(this[v]=f?f():void 0),clearTimeout(this[m]),P&&(this[v]=P(this[v],...u),u=[this[v]]),this[m]=setTimeout(()=>{l.apply(this,u),this[v]=f?f():void 0},M)}})}e.debounce=r;function O(M,P,f){return E((l,w)=>{const m=`$throttle$timer$${w}`,v=`$throttle$result$${w}`,u=`$throttle$lastRun$${w}`,b=`$throttle$pending$${w}`;return function(...p){if(this[v]||(this[v]=f?f():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...p)),this[b])return;const s=this[u]+M;s<=Date.now()?(this[u]=Date.now(),l.apply(this,[this[v]]),this[v]=f?f():void 0):(this[b]=!0,this[m]=setTimeout(()=>{this[b]=!1,this[u]=Date.now(),l.apply(this,[this[v]]),this[v]=f?f():void 0},s-Date.now()))}})}e.throttle=O}),define(te[13],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(c){setTimeout(()=>{throw c.stack?I.isErrorNoTelemetry(c)?new I(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.b.push(c),()=>{this.d(c)}}c(c){this.b.forEach(n=>{n(c)})}d(c){this.b.splice(this.b.indexOf(c),1)}setUnexpectedErrorHandler(c){this.a=c}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(c){this.a(c),this.c(c)}onUnexpectedExternalError(c){this.a(c)}}e.ErrorHandler=E,e.errorHandler=new E;function A(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=A;function r(t){if(!t||typeof t!="object")return!1;const c=t;return c.code==="EPIPE"&&c.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=r;function O(t){l(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=O;function M(t){l(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=M;function P(t){if(t instanceof Error){const{name:c,message:n}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:c,message:n,stack:i,noTelemetry:I.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const f="Canceled";function l(t){return t instanceof w?!0:t instanceof Error&&t.name===f&&t.message===f}e.isCancellationError=l;class w extends Error{constructor(){super(f),this.name=this.message}}e.CancellationError=w;function m(){const t=new Error(f);return t.name=t.message,t}e.canceled=m;function v(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=v;function u(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=u;function b(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function p(t){const c=new Error(`${t} has been disposed`);return c.name="DISPOSED",c}e.disposed=p;function s(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=s;class y extends Error{constructor(c){super("NotImplemented"),c&&(this.message=c)}}e.NotImplementedError=y;class a extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}e.NotSupportedError=a;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class I extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof I)return c;const n=new I;return n.message=c.message,n.stack=c.stack,n}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}e.ErrorNoTelemetry=I;class k extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}e.BugIndicatingError=k}),define(te[24],ie([0,1,13]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(j,$=0){return j[j.length-(1+$)]}e.tail=A;function r(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=r;function O(j,$,K=(se,ue)=>se===ue){if(j===$)return!0;if(!j||!$||j.length!==$.length)return!1;for(let se=0,ue=j.length;se<ue;se++)if(!K(j[se],$[se]))return!1;return!0}e.equals=O;function M(j,$){const K=j.length-1;$<K&&(j[$]=j[K]),j.pop()}e.removeFastWithoutKeepingOrder=M;function P(j,$,K){return f(j.length,se=>K(j[se],$))}e.binarySearch=P;function f(j,$){let K=0,se=j-1;for(;K<=se;){const ue=(K+se)/2|0,be=$(ue);if(be<0)K=ue+1;else if(be>0)se=ue-1;else return ue}return-(K+1)}e.binarySearch2=f;function l(j,$){let K=0,se=j.length;if(se===0)return 0;for(;K<se;){const ue=Math.floor((K+se)/2);$(j[ue])?se=ue:K=ue+1}return K}e.findFirstInSorted=l;function w(j,$,K){if(j=j|0,j>=$.length)throw new TypeError("invalid index");const se=$[Math.floor($.length*Math.random())],ue=[],be=[],ke=[];for(const Me of $){const Ae=K(Me,se);Ae<0?ue.push(Me):Ae>0?be.push(Me):ke.push(Me)}return j<ue.length?w(j,ue,K):j<ue.length+ke.length?ke[0]:w(j-(ue.length+ke.length),be,K)}e.quickSelect=w;function m(j,$){const K=[];let se;for(const ue of j.slice(0).sort($))!se||$(se[0],ue)!==0?(se=[ue],K.push(se)):se.push(ue);return K}e.groupBy=m;function v(j,$,K){const se=[];function ue(Me,Ae,Fe){if(Ae===0&&Fe.length===0)return;const ye=se[se.length-1];ye&&ye.start+ye.deleteCount===Me?(ye.deleteCount+=Ae,ye.toInsert.push(...Fe)):se.push({start:Me,deleteCount:Ae,toInsert:Fe})}let be=0,ke=0;for(;;){if(be===j.length){ue(be,0,$.slice(ke));break}if(ke===$.length){ue(be,j.length-be,[]);break}const Me=j[be],Ae=$[ke],Fe=K(Me,Ae);Fe===0?(be+=1,ke+=1):Fe<0?(ue(be,1,[]),be+=1):Fe>0&&(ue(be,0,[Ae]),ke+=1)}return se}e.sortedDiff=v;function u(j,$,K){const se=v(j,$,K),ue=[],be=[];for(const ke of se)ue.push(...j.slice(ke.start,ke.start+ke.deleteCount)),be.push(...ke.toInsert);return{removed:ue,added:be}}e.delta=u;function b(j,$,K){if(K===0)return[];const se=j.slice(0,K).sort($);return s(j,$,se,K,j.length),se}e.top=b;function p(j,$,K,se,ue){return K===0?Promise.resolve([]):new Promise((be,ke)=>{(async()=>{const Me=j.length,Ae=j.slice(0,K).sort($);for(let Fe=K,ye=Math.min(K+se,Me);Fe<Me;Fe=ye,ye=Math.min(ye+se,Me)){if(Fe>K&&await new Promise(we=>setTimeout(we)),ue&&ue.isCancellationRequested)throw new E.CancellationError;s(j,$,Ae,Fe,ye)}return Ae})().then(be,ke)})}e.topAsync=p;function s(j,$,K,se,ue){for(const be=K.length;se<ue;se++){const ke=j[se];if($(ke,K[be-1])<0){K.pop();const Me=l(K,Ae=>$(ke,Ae)<0);K.splice(Me,0,ke)}}}function y(j){return j.filter($=>!!$)}e.coalesce=y;function a(j){let $=0;for(let K=0;K<j.length;K++)j[K]&&(j[$]=j[K],$+=1);j.length=$}e.coalesceInPlace=a;function d(j,$,K){j.splice(K,0,j.splice($,1)[0])}e.move=d;function I(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=I;function k(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=k;function t(j,$=K=>K){const K=new Set;return j.filter(se=>{const ue=$(se);return K.has(ue)?!1:(K.add(ue),!0)})}e.distinct=t;function c(j){const $=new Set;return K=>{const se=j(K);return $.has(se)?!1:($.add(se),!0)}}e.uniqueFilter=c;function n(j,$){const K=i(j,$);if(K!==-1)return j[K]}e.findLast=n;function i(j,$){for(let K=j.length-1;K>=0;K--){const se=j[K];if($(se))return K}return-1}e.lastIndex=i;function o(j,$){return j.length>0?j[0]:$}e.firstOrDefault=o;function h(j,$){return j.length>0?j[j.length-1]:$}e.lastOrDefault=h;function g(j,$,K=(se,ue)=>se===ue){let se=0;for(let ue=0,be=Math.min(j.length,$.length);ue<be&&K(j[ue],$[ue]);ue++)se++;return se}e.commonPrefixLength=g;function D(j){return[].concat(...j)}e.flatten=D;function R(j,$){let K=typeof $=="number"?j:0;typeof $=="number"?K=j:(K=0,$=j);const se=[];if(K<=$)for(let ue=K;ue<$;ue++)se.push(ue);else for(let ue=K;ue>$;ue--)se.push(ue);return se}e.range=R;function S(j,$,K){return j.reduce((se,ue)=>(se[$(ue)]=K?K(ue):ue,se),Object.create(null))}e.index=S;function L(j,$){return j.push($),()=>T(j,$)}e.insert=L;function T(j,$){const K=j.indexOf($);if(K>-1)return j.splice(K,1),$}e.remove=T;function U(j,$,K){const se=j.slice(0,$),ue=j.slice($);return se.concat(K,ue)}e.arrayInsert=U;function H(j,$){let K;if(typeof $=="number"){let se=$;K=()=>{const ue=Math.sin(se++)*179426549;return ue-Math.floor(ue)}}else K=Math.random;for(let se=j.length-1;se>0;se-=1){const ue=Math.floor(K()*(se+1)),be=j[se];j[se]=j[ue],j[ue]=be}}e.shuffle=H;function re(j,$){const K=j.indexOf($);K>-1&&(j.splice(K,1),j.unshift($))}e.pushToStart=re;function Y(j,$){const K=j.indexOf($);K>-1&&(j.splice(K,1),j.push($))}e.pushToEnd=Y;function ne(j,$){for(const K of $)j.push(K)}e.pushMany=ne;function ce(j,$){return Array.isArray(j)?j.map($):$(j)}e.mapArrayOrNot=ce;function le(j){return Array.isArray(j)?j:[j]}e.asArray=le;function X(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=X;function G(j,$){for(const K of j){const se=$(K);if(se!==void 0)return se}}e.mapFind=G;function N(j,$,K){const se=V(j,$),ue=j.length,be=K.length;j.length=ue+be;for(let ke=ue-1;ke>=se;ke--)j[ke+be]=j[ke];for(let ke=0;ke<be;ke++)j[ke+se]=K[ke]}e.insertInto=N;function F(j,$,K,se){const ue=V(j,$),be=j.splice(ue,K);return N(j,ue,se),be}e.splice=F;function V(j,$){return $<0?Math.max($+j.length,0):Math.min($,j.length)}var J;(function(j){function $(ue){return ue<0}j.isLessThan=$;function K(ue){return ue>0}j.isGreaterThan=K;function se(ue){return ue===0}j.isNeitherLessOrGreaterThan=se,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(J||(e.CompareResult=J={}));function _(j,$){return(K,se)=>$(j(K),j(se))}e.compareBy=_;function ae(...j){return($,K)=>{for(const se of j){const ue=se($,K);if(!J.isNeitherLessOrGreaterThan(ue))return ue}return J.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const oe=(j,$)=>j-$;e.numberComparator=oe;function B(j,$){if(j.length===0)return;let K=j[0];for(let se=1;se<j.length;se++){const ue=j[se];$(ue,K)>0&&(K=ue)}return K}e.findMaxBy=B;function C(j,$){if(j.length===0)return;let K=j[0];for(let se=1;se<j.length;se++){const ue=j[se];$(ue,K)>=0&&(K=ue)}return K}e.findLastMaxBy=C;function W(j,$){return B(j,(K,se)=>-$(K,se))}e.findMinBy=W;class z{constructor($){this.f=$,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile($){let K=this.c;for(;K<this.f.length&&$(this.f[K]);)K++;const se=K===this.c?null:this.f.slice(this.c,K);return this.c=K,se}takeFromEndWhile($){let K=this.d;for(;K>=0&&$(this.f[K]);)K--;const se=K===this.d?null:this.f.slice(K+1,this.d+1);return this.d=K,se}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const $=this.f[this.c];return this.c++,$}removeLast(){const $=this.f[this.d];return this.d--,$}takeCount($){const K=this.f.slice(this.c,this.c+$);return this.c+=$,K}}e.ArrayQueue=z;class q{constructor($){this.iterate=$}forEach($){this.iterate(K=>($(K),!0))}toArray(){const $=[];return this.iterate(K=>($.push(K),!0)),$}filter($){return new q(K=>this.iterate(se=>$(se)?K(se):!0))}map($){return new q(K=>this.iterate(se=>K($(se))))}some($){let K=!1;return this.iterate(se=>(K=$(se),!K)),K}findFirst($){let K;return this.iterate(se=>$(se)?(K=se,!1):!0),K}findLast($){let K;return this.iterate(se=>($(se)&&(K=se),!0)),K}findLastMaxBy($){let K,se=!0;return this.iterate(ue=>((se||J.isGreaterThan($(ue,K)))&&(se=!1,K=ue),!0)),K}}e.CallbackIterable=q,q.empty=new q(j=>{})}),define(te[134],ie([0,1,13]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(f,l){if(!f)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=A;function r(f,l="Unreachable"){throw new Error(l)}e.assertNever=r;function O(f){if(!f)throw new E.BugIndicatingError("Assertion Failed")}e.assert=O;function M(f){if(!f()){debugger;f(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=M;function P(f,l){let w=0;for(;w<f.length-1;){const m=f[w],v=f[w+1];if(!l(m,v))return!1;w++}return!0}e.checkAdjacentItems=P}),define(te[49],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(A){const r=this;let O=!1,M;return function(){return O||(O=!0,M=A.apply(r,arguments)),M}}e.once=E}),define(te[68],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(A){function r(I){return I&&typeof I=="object"&&typeof I[Symbol.iterator]=="function"}A.is=r;const O=Object.freeze([]);function M(){return O}A.empty=M;function*P(I){yield I}A.single=P;function f(I){return r(I)?I:P(I)}A.wrap=f;function l(I){return I||O}A.from=l;function w(I){return!I||I[Symbol.iterator]().next().done===!0}A.isEmpty=w;function m(I){return I[Symbol.iterator]().next().value}A.first=m;function v(I,k){for(const t of I)if(k(t))return!0;return!1}A.some=v;function u(I,k){for(const t of I)if(k(t))return t}A.find=u;function*b(I,k){for(const t of I)k(t)&&(yield t)}A.filter=b;function*p(I,k){let t=0;for(const c of I)yield k(c,t++)}A.map=p;function*s(...I){for(const k of I)for(const t of k)yield t}A.concat=s;function y(I,k,t){let c=t;for(const n of I)c=k(c,n);return c}A.reduce=y;function*a(I,k,t=I.length){for(k<0&&(k+=I.length),t<0?t+=I.length:t>I.length&&(t=I.length);k<t;k++)yield I[k]}A.slice=a;function d(I,k=Number.POSITIVE_INFINITY){const t=[];if(k===0)return[t,I];const c=I[Symbol.iterator]();for(let n=0;n<k;n++){const i=c.next();if(i.done)return[t,A.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return c}}]}A.consume=d})(E||(e.Iterable=E={}))}),define(te[44],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function M(t,c=!1){let n=0;const i=t.length;let o="",h=0,g=16,D=0;function R(Y){let ne=0,ce=0;for(;ne<Y;){const le=t.charCodeAt(n);if(le>=48&&le<=57)ce=ce*16+le-48;else if(le>=65&&le<=70)ce=ce*16+le-65+10;else if(le>=97&&le<=102)ce=ce*16+le-97+10;else break;n++,ne++}return ne<Y&&(ce=-1),ce}function S(Y){n=Y,o="",h=0,g=16,D=0}function L(){const Y=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&l(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&l(t.charCodeAt(n)))for(n++;n<t.length&&l(t.charCodeAt(n));)n++;else return D=3,t.substring(Y,n);let ne=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&l(t.charCodeAt(n))){for(n++;n<t.length&&l(t.charCodeAt(n));)n++;ne=n}else D=3;return t.substring(Y,ne)}function T(){let Y="",ne=n;for(;;){if(n>=i){Y+=t.substring(ne,n),D=2;break}const ce=t.charCodeAt(n);if(ce===34){Y+=t.substring(ne,n),n++;break}if(ce===92){if(Y+=t.substring(ne,n),n++,n>=i){D=2;break}switch(t.charCodeAt(n++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:{const X=R(4);X>=0?Y+=String.fromCharCode(X):D=4;break}default:D=5}ne=n;continue}if(ce>=0&&ce<=31)if(f(ce)){Y+=t.substring(ne,n),D=2;break}else D=6;n++}return Y}function U(){if(o="",D=0,h=n,n>=i)return h=i,g=17;let Y=t.charCodeAt(n);if(P(Y)){do n++,o+=String.fromCharCode(Y),Y=t.charCodeAt(n);while(P(Y));return g=15}if(f(Y))return n++,o+=String.fromCharCode(Y),Y===13&&t.charCodeAt(n)===10&&(n++,o+=`
`),g=14;switch(Y){case 123:return n++,g=1;case 125:return n++,g=2;case 91:return n++,g=3;case 93:return n++,g=4;case 58:return n++,g=6;case 44:return n++,g=5;case 34:return n++,o=T(),g=10;case 47:{const ne=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<i&&!f(t.charCodeAt(n));)n++;return o=t.substring(ne,n),g=12}if(t.charCodeAt(n+1)===42){n+=2;const ce=i-1;let le=!1;for(;n<ce;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,le=!0;break}n++}return le||(n++,D=1),o=t.substring(ne,n),g=13}return o+=String.fromCharCode(Y),n++,g=16}case 45:if(o+=String.fromCharCode(Y),n++,n===i||!l(t.charCodeAt(n)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=L(),g=11;default:for(;n<i&&H(Y);)n++,Y=t.charCodeAt(n);if(h!==n){switch(o=t.substring(h,n),o){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return o+=String.fromCharCode(Y),n++,g=16}}function H(Y){if(P(Y)||f(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let Y;do Y=U();while(Y>=12&&Y<=15);return Y}return{setPosition:S,getPosition:()=>n,scan:c?re:U,getToken:()=>g,getTokenValue:()=>o,getTokenOffset:()=>h,getTokenLength:()=>n-h,getTokenError:()=>D}}e.createScanner=M;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var w;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(w||(w={}));function m(t,c){const n=[],i=new Object;let o;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function D(R,S,L,T){h.value=R,h.offset=S,h.length=L,h.type=T,h.colonOffset=void 0,o=h}try{d(t,{onObjectBegin:(R,S)=>{if(c<=R)throw i;o=void 0,g=c>R,n.push("")},onObjectProperty:(R,S,L)=>{if(c<S||(D(R,S,L,"property"),n[n.length-1]=R,c<=S+L))throw i},onObjectEnd:(R,S)=>{if(c<=R)throw i;o=void 0,n.pop()},onArrayBegin:(R,S)=>{if(c<=R)throw i;o=void 0,n.push(0)},onArrayEnd:(R,S)=>{if(c<=R)throw i;o=void 0,n.pop()},onLiteralValue:(R,S,L)=>{if(c<S||(D(R,S,L,k(R)),c<=S+L))throw i},onSeparator:(R,S,L)=>{if(c<=S)throw i;if(R===":"&&o&&o.type==="property")o.colonOffset=S,g=!1,o=void 0;else if(R===","){const T=n[n.length-1];typeof T=="number"?n[n.length-1]=T+1:(g=!0,n[n.length-1]=""),o=void 0}}})}catch(R){if(R!==i)throw R}return{path:n,previousNode:o,isAtPropertyKey:g,matches:R=>{let S=0;for(let L=0;S<R.length&&L<n.length;L++)if(R[S]===n[L]||R[S]==="*")S++;else if(R[S]!=="**")return!1;return S===R.length}}}e.getLocation=m;function v(t,c=[],n=O.DEFAULT){let i=null,o=[];const h=[];function g(R){Array.isArray(o)?o.push(R):i!==null&&(o[i]=R)}return d(t,{onObjectBegin:()=>{const R={};g(R),h.push(o),o=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const R=[];g(R),h.push(o),o=R,i=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:g,onError:(R,S,L)=>{c.push({error:R,offset:S,length:L})}},n),o[0]}e.parse=v;function u(t,c=[],n=O.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(R){i.type==="property"&&(i.length=R-i.offset,i=i.parent)}function h(R){return i.children.push(R),R}d(t,{onObjectBegin:R=>{i=h({type:"object",offset:R,length:-1,parent:i,children:[]})},onObjectProperty:(R,S,L)=>{i=h({type:"property",offset:S,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:R,offset:S,length:L,parent:i})},onObjectEnd:(R,S)=>{i.length=R+S-i.offset,i=i.parent,o(R+S)},onArrayBegin:(R,S)=>{i=h({type:"array",offset:R,length:-1,parent:i,children:[]})},onArrayEnd:(R,S)=>{i.length=R+S-i.offset,i=i.parent,o(R+S)},onLiteralValue:(R,S,L)=>{h({type:k(R),offset:S,length:L,parent:i,value:R}),o(S+L)},onSeparator:(R,S,L)=>{i.type==="property"&&(R===":"?i.colonOffset=S:R===","&&o(S))},onError:(R,S,L)=>{c.push({error:R,offset:S,length:L})}},n);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=u;function b(t,c){if(!t)return;let n=t;for(const i of c)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const h of n.children)if(Array.isArray(h.children)&&h.children[0].value===i){n=h.children[1],o=!0;break}if(!o)return}else{const o=i;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.findNodeAtLocation=b;function p(t){if(!t.parent||!t.parent.children)return[];const c=p(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;c.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&c.push(n)}return c}e.getNodePath=p;function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const c=Object.create(null);for(const n of t.children){const i=n.children[1];i&&(c[n.children[0].value]=s(i))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=s;function y(t,c,n=!1){return c>=t.offset&&c<t.offset+t.length||n&&c===t.offset+t.length}e.contains=y;function a(t,c,n=!1){if(y(t,c,n)){const i=t.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=c;o++){const h=a(i[o],c,n);if(h)return h}return t}}e.findNodeAtOffset=a;function d(t,c,n=O.DEFAULT){const i=M(t,!1);function o(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function h(_){return _?ae=>_(ae,i.getTokenOffset(),i.getTokenLength()):()=>!0}const g=o(c.onObjectBegin),D=h(c.onObjectProperty),R=o(c.onObjectEnd),S=o(c.onArrayBegin),L=o(c.onArrayEnd),T=h(c.onLiteralValue),U=h(c.onSeparator),H=o(c.onComment),re=h(c.onError),Y=n&&n.disallowComments,ne=n&&n.allowTrailingComma;function ce(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:Y||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(_){case 12:case 13:Y?le(10):H();break;case 16:le(1);break;case 15:case 14:break;default:return _}}}function le(_,ae=[],oe=[]){if(re(_),ae.length+oe.length>0){let B=i.getToken();for(;B!==17;){if(ae.indexOf(B)!==-1){ce();break}else if(oe.indexOf(B)!==-1)break;B=ce()}}}function X(_){const ae=i.getTokenValue();return _?T(ae):D(ae),ce(),!0}function G(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(le(2),_=0)}catch{le(2)}T(_);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return ce(),!0}function N(){return i.getToken()!==10?(le(3,[],[2,5]),!1):(X(!1),i.getToken()===6?(U(":"),ce(),J()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function F(){g(),ce();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||le(4,[],[]),U(","),ce(),i.getToken()===2&&ne)break}else _&&le(6,[],[]);N()||le(4,[],[2,5]),_=!0}return R(),i.getToken()!==2?le(7,[2],[]):ce(),!0}function V(){S(),ce();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||le(4,[],[]),U(","),ce(),i.getToken()===4&&ne)break}else _&&le(6,[],[]);J()||le(4,[],[4,5]),_=!0}return L(),i.getToken()!==4?le(8,[4],[]):ce(),!0}function J(){switch(i.getToken()){case 3:return V();case 1:return F();case 10:return X(!0);default:return G()}}return ce(),i.getToken()===17?n.allowEmptyContent?!0:(le(4,[],[]),!1):J()?(i.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}e.visit=d;function I(t,c){const n=M(t),i=[];let o,h=0,g;do switch(g=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:h!==g&&i.push(t.substring(h,g)),c!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,c)),h=n.getPosition();break}while(o!==17);return i.join("")}e.stripComments=I;function k(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(te[135],ie([0,1,44]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function A(l,w,m){let v,u,b,p,s;if(w){for(p=w.offset,s=p+w.length,b=p;b>0&&!f(l,b-1);)b--;let g=s;for(;g<l.length&&!f(l,g);)g++;u=l.substring(b,g),v=M(u,m)}else u=l,v=0,b=0,p=0,s=l.length;const y=P(m,l);let a=!1,d=0,I;m.insertSpaces?I=O(" ",m.tabSize||4):I="	";const k=(0,E.createScanner)(u,!1);let t=!1;function c(){return y+O(I,v+d)}function n(){let g=k.scan();for(a=!1;g===15||g===14;)a=a||g===14,g=k.scan();return t=g===16||k.getTokenError()!==0,g}const i=[];function o(g,D,R){!t&&D<s&&R>p&&l.substring(D,R)!==g&&i.push({offset:D,length:R-D,content:g})}let h=n();if(h!==17){const g=k.getTokenOffset()+b,D=O(I,v);o(D,b,g)}for(;h!==17;){let g=k.getTokenOffset()+k.getTokenLength()+b,D=n(),R="";for(;!a&&(D===12||D===13);){const L=k.getTokenOffset()+b;o(" ",g,L),g=k.getTokenOffset()+k.getTokenLength()+b,R=D===12?c():"",D=n()}if(D===2)h!==1&&(d--,R=c());else if(D===4)h!==3&&(d--,R=c());else{switch(h){case 3:case 1:d++,R=c();break;case 5:case 12:R=c();break;case 13:a?R=c():R=" ";break;case 6:R=" ";break;case 10:if(D===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?R=" ":D!==5&&D!==17&&(t=!0);break;case 16:t=!0;break}a&&(D===12||D===13)&&(R=c())}const S=k.getTokenOffset()+b;o(R,g,S),h=D}return i}e.format=A;function r(l,w){const m=JSON.stringify(l,void 0,w.insertSpaces?w.tabSize||4:"	");return w.eol!==void 0?m.replace(/\r\n|\r|\n/g,w.eol):m}e.toFormattedString=r;function O(l,w){let m="";for(let v=0;v<w;v++)m+=l;return m}function M(l,w){let m=0,v=0;const u=w.tabSize||4;for(;m<l.length;){const b=l.charAt(m);if(b===" ")v++;else if(b==="	")v+=u;else break;m++}return Math.floor(v/u)}function P(l,w){for(let m=0;m<w.length;m++){const v=w.charAt(m);if(v==="\r")return m+1<w.length&&w.charAt(m+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return l&&l.eol||`
`}e.getEOL=P;function f(l,w){return`\r
`.indexOf(l.charAt(w))!==-1}e.isEOL=f}),define(te[136],ie([0,1,44,135]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function r(l,w,m){return O(l,w,void 0,m)}e.removeProperty=r;function O(l,w,m,v,u){const b=w.slice(),p=[],s=(0,E.parseTree)(l,p);let y,a;for(;b.length>0&&(a=b.pop(),y=(0,E.findNodeAtLocation)(s,b),y===void 0&&m!==void 0);)typeof a=="string"?m={[a]:m}:m=[m];if(y)if(y.type==="object"&&typeof a=="string"&&Array.isArray(y.children)){const d=(0,E.findNodeAtLocation)(y,[a]);if(d!==void 0)if(m===void 0){if(!d.parent)throw new Error("Malformed AST");const I=y.children.indexOf(d.parent);let k,t=d.parent.offset+d.parent.length;if(I>0){const c=y.children[I-1];k=c.offset+c.length}else k=y.offset+1,y.children.length>1&&(t=y.children[1].offset);return M(l,{offset:k,length:t-k,content:""},v)}else return M(l,{offset:d.offset,length:d.length,content:JSON.stringify(m)},v);else{if(m===void 0)return[];const I=`${JSON.stringify(a)}: ${JSON.stringify(m)}`,k=u?u(y.children.map(c=>c.children[0].value)):y.children.length;let t;if(k>0){const c=y.children[k-1];t={offset:c.offset+c.length,length:0,content:","+I}}else y.children.length===0?t={offset:y.offset+1,length:0,content:I}:t={offset:y.offset+1,length:0,content:I+","};return M(l,t,v)}}else if(y.type==="array"&&typeof a=="number"&&Array.isArray(y.children))if(m!==void 0){const d=`${JSON.stringify(m)}`;let I;if(y.children.length===0||a===0)I={offset:y.offset+1,length:0,content:y.children.length===0?d:d+","};else{const k=a===-1||a>y.children.length?y.children.length:a,t=y.children[k-1];I={offset:t.offset+t.length,length:0,content:","+d}}return M(l,I,v)}else{const d=a,I=y.children[d];let k;if(y.children.length===1)k={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===d){const t=y.children[d-1],c=t.offset+t.length,n=y.offset+y.length;k={offset:c,length:n-2-c,content:""}}else k={offset:I.offset,length:y.children[d+1].offset-I.offset,content:""};return M(l,k,v)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${y.type}`);else{if(m===void 0)throw new Error("Can not delete in empty document");return M(l,{offset:s?s.offset:0,length:s?s.length:0,content:JSON.stringify(m)},v)}}e.setProperty=O;function M(l,w,m){let v=P(l,w),u=w.offset,b=w.offset+w.content.length;if(w.length===0||w.content.length===0){for(;u>0&&!(0,A.isEOL)(v,u-1);)u--;for(;b<v.length&&!(0,A.isEOL)(v,b);)b++}const p=(0,A.format)(v,{offset:u,length:b-u},m);for(let y=p.length-1;y>=0;y--){const a=p[y];v=P(v,a),u=Math.min(u,a.offset),b=Math.max(b,a.offset+a.length),b+=a.content.length-a.length}const s=l.length-(v.length-b)-u;return[{offset:u,length:s,content:v.substring(u,b)}]}e.withFormatting=M;function P(l,w){return l.substring(0,w.offset)+w.content+l.substring(w.offset+w.length)}e.applyEdit=P;function f(l,w){const m=w.slice(0).sort((u,b)=>{const p=u.offset-b.offset;return p===0?u.length-b.length:p});let v=l.length;for(let u=m.length-1;u>=0;u--){const b=m[u];if(b.offset+b.length<=v)l=P(l,b);else throw new Error("Overlapping edit");v=b.offset}return l}e.applyEdits=f}),define(te[100],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=E}),define(te[2],ie([0,1,49,68]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const r=!1;let O=null;function M(h){O=h}if(e.setDisposableTracker=M,r){const h="__is_disposable_tracked__";M(new class{trackDisposable(g){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[h]||console.log(D)},3e3)}setParent(g,D){if(g&&g!==a.None)try{g[h]=!0}catch{}}markAsDisposed(g){if(g&&g!==a.None)try{g[h]=!0}catch{}}markAsSingleton(g){}})}function P(h){return O?.trackDisposable(h),h}function f(h){O?.markAsDisposed(h)}function l(h,g){O?.setParent(h,g)}function w(h,g){if(O)for(const D of h)O.setParent(D,g)}function m(h){return O?.markAsSingleton(h),h}e.markAsSingleton=m;function v(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.isDisposable=v;function u(h){if(A.Iterable.is(h)){const g=[];for(const D of h)if(D)try{D.dispose()}catch(R){g.push(R)}if(g.length===1)throw g[0];if(g.length>1)throw new AggregateError(g,"Encountered errors while disposing of store");return Array.isArray(h)?[]:h}else if(h)return h.dispose(),h}e.dispose=u;function b(h){for(const g of h)v(g)&&g.dispose();return[]}e.disposeIfDisposable=b;function p(...h){const g=s(()=>u(h));return w(h,g),g}e.combinedDisposable=p;function s(h){const g=P({dispose:(0,E.once)(()=>{f(g),h()})});return g}e.toDisposable=s;class y{constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return l(g,this),this.g?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(g),g}}e.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this.q=new y,P(this),l(this.q,this)}dispose(){f(this),this.q.dispose()}B(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(g)}}e.Disposable=a,a.None=Object.freeze({dispose(){}});class d{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(g){this.b||g===this.a||(this.a?.dispose(),g&&l(g,this),this.a=g)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const g=this.a;return this.a=void 0,g&&l(g,null),g}}e.MutableDisposable=d;class I{constructor(g){this.b=g,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=I;class k{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(g){let D=g;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,f(this))},this}}e.SafeDisposable=k;class t{constructor(){this.a=new Map}acquire(g,...D){let R=this.a.get(g);R||(R={counter:0,object:this.b(g,...D)},this.a.set(g,R));const{object:S}=R,L=(0,E.once)(()=>{--R.counter===0&&(this.c(g,R.object),this.a.delete(g))});return R.counter++,{object:S,dispose:L}}}e.ReferenceCollection=t;class c{constructor(g){this.a=g}async acquire(g,...D){const R=this.a.acquire(g,...D);try{return{object:await R.object,dispose:()=>R.dispose()}}catch(S){throw R.dispose(),S}}}e.AsyncReferenceCollection=c;class n{constructor(g){this.object=g}dispose(){}}e.ImmortalReference=n;function i(h){const g=new y;try{h(g)}finally{g.dispose()}}e.disposeOnReturn=i;class o{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(g){return this.a.has(g)}get(g){return this.a.get(g)}set(g,D,R=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),R||this.a.get(g)?.dispose(),this.a.set(g,D)}deleteAndDispose(g){this.a.get(g)?.dispose(),this.a.delete(g)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(te[101],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(O){this.element=O,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class A{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let O=this.a;for(;O!==E.Undefined;){const M=O.next;O.prev=E.Undefined,O.next=E.Undefined,O=M}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,M){const P=new E(O);if(this.a===E.Undefined)this.a=P,this.b=P;else if(M){const l=this.b;this.b=P,P.prev=l,l.next=P}else{const l=this.a;this.a=P,P.next=l,l.prev=P}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(P))}}shift(){if(this.a!==E.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==E.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==E.Undefined&&O.next!==E.Undefined){const M=O.prev;M.next=O.next,O.next.prev=M}else O.prev===E.Undefined&&O.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):O.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):O.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==E.Undefined;)yield O.element,O=O.next}}e.LinkedList=A}),define(te[35],ie([0,1]),function(x,e){"use strict";var E,A,r;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function O(p,s,y){let a=p.get(s);return a===void 0&&(a=y,p.set(s,a)),a}e.getOrSet=O;function M(p){const s=[];return p.forEach((y,a)=>{s.push(`${a} => ${y}`)}),`Map(${p.size}) {${s.join(", ")}}`}e.mapToString=M;function P(p){const s=[];return p.forEach(y=>{s.push(y)}),`Set(${p.size}) {${s.join(", ")}}`}e.setToString=P;class f{constructor(s,y){this.uri=s,this.value=y}}class l{constructor(s,y){this[E]="ResourceMap",s instanceof l?(this.b=new Map(s.b),this.c=y??l.a):(this.b=new Map,this.c=s??l.a)}set(s,y){return this.b.set(this.c(s),new f(s,y)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,y){typeof y<"u"&&(s=s.bind(y));for(const[a,d]of this.b)s(d.value,d.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}e.ResourceMap=l,l.a=p=>p.toString();class w{constructor(s,y){this[A]="ResourceSet",!s||typeof s=="function"?this.a=new l(s):(this.a=new l(y),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,y){this.a.forEach((a,d)=>s.call(y,d,d,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=w;var m;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class v{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,y=0){const a=this.a.get(s);if(a)return y!==0&&this.j(a,y),a.value}set(s,y,a=0){let d=this.a.get(s);if(d)d.value=y,a!==0&&this.j(d,a);else{switch(d={key:s,value:y,next:void 0,previous:void 0},a){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(s,d),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const y=this.a.get(s);if(y)return this.a.delete(s),this.i(y),this.d--,y.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,y){const a=this.e;let d=this.b;for(;d;){if(y?s.bind(y)(d.value,d.key,this):s(d.value,d.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const s=this,y=this.e;let a=this.b;const d={[Symbol.iterator](){return d},next(){if(s.e!==y)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:a.key,done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return d}values(){const s=this,y=this.e;let a=this.b;const d={[Symbol.iterator](){return d},next(){if(s.e!==y)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:a.value,done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return d}entries(){const s=this,y=this.e;let a=this.b;const d={[Symbol.iterator](){return d},next(){if(s.e!==y)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:[a.key,a.value],done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return d}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let y=this.b,a=this.size;for(;y&&a>s;)this.a.delete(y.key),y=y.next,a--;this.b=y,this.d=a,y&&(y.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const y=s.next,a=s.previous;if(!y||!a)throw new Error("Invalid list");y.previous=a,a.next=y}s.next=void 0,s.previous=void 0,this.e++}j(s,y){if(!this.b||!this.c)throw new Error("Invalid list");if(!(y!==1&&y!==2)){if(y===1){if(s===this.b)return;const a=s.next,d=s.previous;s===this.c?(d.next=void 0,this.c=d):(a.previous=d,d.next=a),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(y===2){if(s===this.c)return;const a=s.next,d=s.previous;s===this.b?(a.previous=void 0,this.b=a):(a.previous=d,d.next=a),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((y,a)=>{s.push([a,y])}),s}fromJSON(s){this.clear();for(const[y,a]of s)this.set(y,a)}}e.LinkedMap=v;class u extends v{constructor(s,y=1){super(),this.k=s,this.l=Math.min(Math.max(0,y),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,y=2){return super.get(s,y)}peek(s){return super.get(s,0)}set(s,y){return super.set(s,y,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=u;class b{constructor(){this.a=new Map}add(s){return this.a.set(s,(this.a.get(s)||0)+1),this}delete(s){let y=this.a.get(s)||0;return y===0?!1:(y--,y===0?this.a.delete(s):this.a.set(s,y),!0)}has(s){return this.a.has(s)}}e.CounterSet=b}),define(te[83],ie([0,1,35]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new E.LRUCache(1e4);function r(l){return f(l,"NFC",A)}e.normalizeNFC=r;const O=new E.LRUCache(1e4);function M(l){return f(l,"NFD",O)}e.normalizeNFD=M;const P=/[^\u0000-\u0080]/;function f(l,w,m){if(!l)return l;const v=m.get(l);if(v)return v;let u;return P.test(l)?u=l.normalize(w):u=l,m.set(l,u),u}e.removeAccents=function(){const l=/[\u0300-\u036f]/g;return function(w){return M(w).replace(l,"")}}()}),define(te[137],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(P,f,l){return Math.min(Math.max(P,f),l)}e.clamp=E;function A(P,f){return(f+P%f)%f}e.rot=A;class r{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=r;class O{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=O;class M{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const l=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=M}),function(){function x(r){const O=[];typeof r=="number"&&O.push("code/timeOrigin",r);function M(f){O.push(f,Date.now())}function P(){const f=[];for(let l=0;l<O.length;l+=2)f.push({name:O[l],startTime:O[l+1]});return f}return{mark:M,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const M of performance.getEntriesByType("mark"))O.push({name:M.name,startTime:Math.round(r+M.startTime)});return O}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function E(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=E(A))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var A in E)(typeof exports=="object"?exports:x)[A]=E[A]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function E(A){if(e[A])return e[A].exports;var r=e[A]={i:A,l:!1,exports:{}};return x[A].call(r.exports,r,r.exports,E),r.l=!0,r.exports}return E.m=x,E.c=e,E.d=function(A,r,O){E.o(A,r)||Object.defineProperty(A,r,{enumerable:!0,get:O})},E.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},E.t=function(A,r){if(1&r&&(A=E(A)),8&r||4&r&&typeof A=="object"&&A&&A.__esModule)return A;var O=Object.create(null);if(E.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:A}),2&r&&typeof A!="string")for(var M in A)E.d(O,M,function(P){return A[P]}.bind(null,M));return O},E.n=function(A){var r=A&&A.__esModule?function(){return A.default}:function(){return A};return E.d(r,"a",r),r},E.o=function(A,r){return Object.prototype.hasOwnProperty.call(A,r)},E.p="",E(E.s=0)}([function(x,e,E){(function(A){var r;e=x.exports=oe,r=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],f=e.src=[],l=0,w=l++;f[w]="0|[1-9]\\d*";var m=l++;f[m]="[0-9]+";var v=l++;f[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=l++;f[u]="("+f[w]+")\\.("+f[w]+")\\.("+f[w]+")";var b=l++;f[b]="("+f[m]+")\\.("+f[m]+")\\.("+f[m]+")";var p=l++;f[p]="(?:"+f[w]+"|"+f[v]+")";var s=l++;f[s]="(?:"+f[m]+"|"+f[v]+")";var y=l++;f[y]="(?:-("+f[p]+"(?:\\."+f[p]+")*))";var a=l++;f[a]="(?:-?("+f[s]+"(?:\\."+f[s]+")*))";var d=l++;f[d]="[0-9A-Za-z-]+";var I=l++;f[I]="(?:\\+("+f[d]+"(?:\\."+f[d]+")*))";var k=l++,t="v?"+f[u]+f[y]+"?"+f[I]+"?";f[k]="^"+t+"$";var c="[v=\\s]*"+f[b]+f[a]+"?"+f[I]+"?",n=l++;f[n]="^"+c+"$";var i=l++;f[i]="((?:<|>)?=?)";var o=l++;f[o]=f[m]+"|x|X|\\*";var h=l++;f[h]=f[w]+"|x|X|\\*";var g=l++;f[g]="[v=\\s]*("+f[h]+")(?:\\.("+f[h]+")(?:\\.("+f[h]+")(?:"+f[y]+")?"+f[I]+"?)?)?";var D=l++;f[D]="[v=\\s]*("+f[o]+")(?:\\.("+f[o]+")(?:\\.("+f[o]+")(?:"+f[a]+")?"+f[I]+"?)?)?";var R=l++;f[R]="^"+f[i]+"\\s*"+f[g]+"$";var S=l++;f[S]="^"+f[i]+"\\s*"+f[D]+"$";var L=l++;f[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=l++;f[T]="(?:~>?)";var U=l++;f[U]="(\\s*)"+f[T]+"\\s+",P[U]=new RegExp(f[U],"g");var H=l++;f[H]="^"+f[T]+f[g]+"$";var re=l++;f[re]="^"+f[T]+f[D]+"$";var Y=l++;f[Y]="(?:\\^)";var ne=l++;f[ne]="(\\s*)"+f[Y]+"\\s+",P[ne]=new RegExp(f[ne],"g");var ce=l++;f[ce]="^"+f[Y]+f[g]+"$";var le=l++;f[le]="^"+f[Y]+f[D]+"$";var X=l++;f[X]="^"+f[i]+"\\s*("+c+")$|^$";var G=l++;f[G]="^"+f[i]+"\\s*("+t+")$|^$";var N=l++;f[N]="(\\s*)"+f[i]+"\\s*("+c+"|"+f[g]+")",P[N]=new RegExp(f[N],"g");var F=l++;f[F]="^\\s*("+f[g]+")\\s+-\\s+("+f[g]+")\\s*$";var V=l++;f[V]="^\\s*("+f[D]+")\\s+-\\s+("+f[D]+")\\s*$";var J=l++;f[J]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)r(_,f[_]),P[_]||(P[_]=new RegExp(f[_]));function ae(ee,he){if(ee instanceof oe)return ee;if(typeof ee!="string"||ee.length>O||!(he?P[n]:P[k]).test(ee))return null;try{return new oe(ee,he)}catch{return null}}function oe(ee,he){if(ee instanceof oe){if(ee.loose===he)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof oe))return new oe(ee,he);r("SemVer",ee,he),this.loose=he;var fe=ee.trim().match(he?P[n]:P[k]);if(!fe)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var De=+Ce;if(De>=0&&De<M)return De}return Ce}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ee,he){var fe=ae(ee,he);return fe?fe.version:null},e.clean=function(ee,he){var fe=ae(ee.trim().replace(/^[=v]+/,""),he);return fe?fe.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(ee){return r("SemVer.compare",this.version,this.loose,ee),ee instanceof oe||(ee=new oe(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},oe.prototype.compareMain=function(ee){return ee instanceof oe||(ee=new oe(ee,this.loose)),C(this.major,ee.major)||C(this.minor,ee.minor)||C(this.patch,ee.patch)},oe.prototype.comparePre=function(ee){if(ee instanceof oe||(ee=new oe(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var he=0;do{var fe=this.prerelease[he],Ce=ee.prerelease[he];if(r("prerelease compare",he,fe,Ce),fe===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ce)return C(fe,Ce)}while(++he)},oe.prototype.inc=function(ee,he){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,he,fe,Ce){typeof fe=="string"&&(Ce=fe,fe=void 0);try{return new oe(ee,fe).inc(he,Ce).version}catch{return null}},e.diff=function(ee,he){if(j(ee,he))return null;var fe=ae(ee),Ce=ae(he);if(fe.prerelease.length||Ce.prerelease.length){for(var De in fe)if((De==="major"||De==="minor"||De==="patch")&&fe[De]!==Ce[De])return"pre"+De;return"prerelease"}for(var De in fe)if((De==="major"||De==="minor"||De==="patch")&&fe[De]!==Ce[De])return De},e.compareIdentifiers=C;var B=/^[0-9]+$/;function C(ee,he){var fe=B.test(ee),Ce=B.test(he);return fe&&Ce&&(ee=+ee,he=+he),fe&&!Ce?-1:Ce&&!fe?1:ee<he?-1:ee>he?1:0}function W(ee,he,fe){return new oe(ee,fe).compare(new oe(he,fe))}function z(ee,he,fe){return W(ee,he,fe)>0}function q(ee,he,fe){return W(ee,he,fe)<0}function j(ee,he,fe){return W(ee,he,fe)===0}function $(ee,he,fe){return W(ee,he,fe)!==0}function K(ee,he,fe){return W(ee,he,fe)>=0}function se(ee,he,fe){return W(ee,he,fe)<=0}function ue(ee,he,fe,Ce){var De;switch(he){case"===":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),De=ee===fe;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),De=ee!==fe;break;case"":case"=":case"==":De=j(ee,fe,Ce);break;case"!=":De=$(ee,fe,Ce);break;case">":De=z(ee,fe,Ce);break;case">=":De=K(ee,fe,Ce);break;case"<":De=q(ee,fe,Ce);break;case"<=":De=se(ee,fe,Ce);break;default:throw new TypeError("Invalid operator: "+he)}return De}function be(ee,he){if(ee instanceof be){if(ee.loose===he)return ee;ee=ee.value}if(!(this instanceof be))return new be(ee,he);r("comparator",ee,he),this.loose=he,this.parse(ee),this.semver===ke?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(ee,he){return C(he,ee)},e.major=function(ee,he){return new oe(ee,he).major},e.minor=function(ee,he){return new oe(ee,he).minor},e.patch=function(ee,he){return new oe(ee,he).patch},e.compare=W,e.compareLoose=function(ee,he){return W(ee,he,!0)},e.rcompare=function(ee,he,fe){return W(he,ee,fe)},e.sort=function(ee,he){return ee.sort(function(fe,Ce){return e.compare(fe,Ce,he)})},e.rsort=function(ee,he){return ee.sort(function(fe,Ce){return e.rcompare(fe,Ce,he)})},e.gt=z,e.lt=q,e.eq=j,e.neq=$,e.gte=K,e.lte=se,e.cmp=ue,e.Comparator=be;var ke={};function Me(ee,he){if(ee instanceof Me)return ee.loose===he?ee:new Me(ee.raw,he);if(ee instanceof be)return new Me(ee.value,he);if(!(this instanceof Me))return new Me(ee,he);if(this.loose=he,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Ae(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,he,fe,Ce,De,Oe,We,He,$e,ze,qe,je,Q){return((he=Ae(fe)?"":Ae(Ce)?">="+fe+".0.0":Ae(De)?">="+fe+"."+Ce+".0":">="+he)+" "+(He=Ae($e)?"":Ae(ze)?"<"+(+$e+1)+".0.0":Ae(qe)?"<"+$e+"."+(+ze+1)+".0":je?"<="+$e+"."+ze+"."+qe+"-"+je:"<="+He)).trim()}function ye(ee,he){for(var fe=0;fe<ee.length;fe++)if(!ee[fe].test(he))return!1;if(he.prerelease.length){for(fe=0;fe<ee.length;fe++)if(r(ee[fe].semver),ee[fe].semver!==ke&&ee[fe].semver.prerelease.length>0){var Ce=ee[fe].semver;if(Ce.major===he.major&&Ce.minor===he.minor&&Ce.patch===he.patch)return!0}return!1}return!0}function we(ee,he,fe){try{he=new Me(he,fe)}catch{return!1}return he.test(ee)}function Ee(ee,he,fe,Ce){var De,Oe,We,He,$e;switch(ee=new oe(ee,Ce),he=new Me(he,Ce),fe){case">":De=z,Oe=se,We=q,He=">",$e=">=";break;case"<":De=q,Oe=K,We=z,He="<",$e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(ee,he,Ce))return!1;for(var ze=0;ze<he.set.length;++ze){var qe=he.set[ze],je=null,Q=null;if(qe.forEach(function(de){de.semver===ke&&(de=new be(">=0.0.0")),je=je||de,Q=Q||de,De(de.semver,je.semver,Ce)?je=de:We(de.semver,Q.semver,Ce)&&(Q=de)}),je.operator===He||je.operator===$e||(!Q.operator||Q.operator===He)&&Oe(ee,Q.semver)||Q.operator===$e&&We(ee,Q.semver))return!1}return!0}be.prototype.parse=function(ee){var he=this.loose?P[X]:P[G],fe=ee.match(he);if(!fe)throw new TypeError("Invalid comparator: "+ee);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new oe(fe[2],this.loose):this.semver=ke},be.prototype.toString=function(){return this.value},be.prototype.test=function(ee){return r("Comparator.test",ee,this.loose),this.semver===ke||(typeof ee=="string"&&(ee=new oe(ee,this.loose)),ue(ee,this.operator,this.semver,this.loose))},be.prototype.intersects=function(ee,he){if(!(ee instanceof be))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Me(ee.value,he),we(this.value,fe,he);if(ee.operator==="")return fe=new Me(this.value,he),we(ee.semver,fe,he);var Ce=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Oe=this.semver.version===ee.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),He=ue(this.semver,"<",ee.semver,he)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),$e=ue(this.semver,">",ee.semver,he)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Ce||De||Oe&&We||He||$e},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(ee){var he=this.loose;ee=ee.trim(),r("range",ee,he);var fe=he?P[V]:P[F];ee=ee.replace(fe,Fe),r("hyphen replace",ee),ee=ee.replace(P[N],"$1$2$3"),r("comparator trim",ee,P[N]),ee=(ee=(ee=ee.replace(P[U],"$1~")).replace(P[ne],"$1^")).split(/\s+/).join(" ");var Ce=he?P[X]:P[G],De=ee.split(" ").map(function(Oe){return function(We,He){return r("comp",We),We=function($e,ze){return $e.trim().split(/\s+/).map(function(qe){return function(je,Q){r("caret",je,Q);var de=Q?P[le]:P[ce];return je.replace(de,function(ge,me,Se,Le,Ne){var Ke;return r("caret",je,ge,me,Se,Le,Ne),Ae(me)?Ke="":Ae(Se)?Ke=">="+me+".0.0 <"+(+me+1)+".0.0":Ae(Le)?Ke=me==="0"?">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0":">="+me+"."+Se+".0 <"+(+me+1)+".0.0":Ne?(r("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ke=me==="0"?Se==="0"?">="+me+"."+Se+"."+Le+Ne+" <"+me+"."+Se+"."+(+Le+1):">="+me+"."+Se+"."+Le+Ne+" <"+me+"."+(+Se+1)+".0":">="+me+"."+Se+"."+Le+Ne+" <"+(+me+1)+".0.0"):(r("no pr"),Ke=me==="0"?Se==="0"?">="+me+"."+Se+"."+Le+" <"+me+"."+Se+"."+(+Le+1):">="+me+"."+Se+"."+Le+" <"+me+"."+(+Se+1)+".0":">="+me+"."+Se+"."+Le+" <"+(+me+1)+".0.0"),r("caret return",Ke),Ke})}(qe,ze)}).join(" ")}(We,He),r("caret",We),We=function($e,ze){return $e.trim().split(/\s+/).map(function(qe){return function(je,Q){var de=Q?P[re]:P[H];return je.replace(de,function(ge,me,Se,Le,Ne){var Ke;return r("tilde",je,ge,me,Se,Le,Ne),Ae(me)?Ke="":Ae(Se)?Ke=">="+me+".0.0 <"+(+me+1)+".0.0":Ae(Le)?Ke=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0":Ne?(r("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ke=">="+me+"."+Se+"."+Le+Ne+" <"+me+"."+(+Se+1)+".0"):Ke=">="+me+"."+Se+"."+Le+" <"+me+"."+(+Se+1)+".0",r("tilde return",Ke),Ke})}(qe,ze)}).join(" ")}(We,He),r("tildes",We),We=function($e,ze){return r("replaceXRanges",$e,ze),$e.split(/\s+/).map(function(qe){return function(je,Q){je=je.trim();var de=Q?P[S]:P[R];return je.replace(de,function(ge,me,Se,Le,Ne,Ke){r("xRange",je,ge,me,Se,Le,Ne,Ke);var Ze=Ae(Se),Ge=Ze||Ae(Le),Ye=Ge||Ae(Ne);return me==="="&&Ye&&(me=""),Ze?ge=me===">"||me==="<"?"<0.0.0":"*":me&&Ye?(Ge&&(Le=0),Ye&&(Ne=0),me===">"?(me=">=",Ge?(Se=+Se+1,Le=0,Ne=0):Ye&&(Le=+Le+1,Ne=0)):me==="<="&&(me="<",Ge?Se=+Se+1:Le=+Le+1),ge=me+Se+"."+Le+"."+Ne):Ge?ge=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ye&&(ge=">="+Se+"."+Le+".0 <"+Se+"."+(+Le+1)+".0"),r("xRange return",ge),ge})}(qe,ze)}).join(" ")}(We,He),r("xrange",We),We=function($e,ze){return r("replaceStars",$e,ze),$e.trim().replace(P[J],"")}(We,He),r("stars",We),We}(Oe,he)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Oe){return!!Oe.match(Ce)})),De=De.map(function(Oe){return new be(Oe,he)})},Me.prototype.intersects=function(ee,he){if(!(ee instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ce){return ee.set.some(function(De){return De.every(function(Oe){return Ce.intersects(Oe,he)})})})})},e.toComparators=function(ee,he){return new Me(ee,he).set.map(function(fe){return fe.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new oe(ee,this.loose));for(var he=0;he<this.set.length;he++)if(ye(this.set[he],ee))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(ee,he,fe){var Ce=null,De=null;try{var Oe=new Me(he,fe)}catch{return null}return ee.forEach(function(We){Oe.test(We)&&(Ce&&De.compare(We)!==-1||(De=new oe(Ce=We,fe)))}),Ce},e.minSatisfying=function(ee,he,fe){var Ce=null,De=null;try{var Oe=new Me(he,fe)}catch{return null}return ee.forEach(function(We){Oe.test(We)&&(Ce&&De.compare(We)!==1||(De=new oe(Ce=We,fe)))}),Ce},e.validRange=function(ee,he){try{return new Me(ee,he).range||"*"}catch{return null}},e.ltr=function(ee,he,fe){return Ee(ee,he,"<",fe)},e.gtr=function(ee,he,fe){return Ee(ee,he,">",fe)},e.outside=Ee,e.prerelease=function(ee,he){var fe=ae(ee,he);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ee,he,fe){return ee=new Me(ee,fe),he=new Me(he,fe),ee.intersects(he)},e.coerce=function(ee){if(ee instanceof oe)return ee;if(typeof ee!="string")return null;var he=ee.match(P[L]);return he==null?null:ae((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,E(1))},function(x,e){var E,A,r=x.exports={};function O(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function P(s){if(E===setTimeout)return setTimeout(s,0);if((E===O||!E)&&setTimeout)return E=setTimeout,setTimeout(s,0);try{return E(s,0)}catch{try{return E.call(null,s,0)}catch{return E.call(this,s,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:O}catch{E=O}try{A=typeof clearTimeout=="function"?clearTimeout:M}catch{A=M}})();var f,l=[],w=!1,m=-1;function v(){w&&f&&(w=!1,f.length?l=f.concat(l):m=-1,l.length&&u())}function u(){if(!w){var s=P(v);w=!0;for(var y=l.length;y;){for(f=l,l=[];++m<y;)f&&f[m].run();m=-1,y=l.length}f=null,w=!1,function(a){if(A===clearTimeout)return clearTimeout(a);if((A===M||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(a);try{A(a)}catch{try{return A.call(null,a)}catch{return A.call(this,a)}}}(s)}}function b(s,y){this.fun=s,this.array=y}function p(){}r.nextTick=function(s){var y=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)y[a-1]=arguments[a];l.push(new b(s,y)),l.length!==1||w||P(u)},b.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=p,r.addListener=p,r.once=p,r.off=p,r.removeListener=p,r.removeAllListeners=p,r.emit=p,r.prependListener=p,r.prependOnceListener=p,r.listeners=function(s){return[]},r.binding=function(s){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(s){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(te[138],ie([0,1]),function(x,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class A{constructor(P,f,l){this.level=P,this.key=f,this.value=l,this.forward=[]}}const r=void 0;class O{constructor(P,f=2**16){this.comparator=P,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new A(this.c,r,r)}get size(){return this.f}clear(){this.e=new A(this.c,r,r)}has(P){return!!O.g(this,P,this.comparator)}get(P){return O.g(this,P,this.comparator)?.value}set(P,f){return O.h(this,P,f,this.comparator)&&(this.f+=1),this}delete(P){const f=O.k(this,P,this.comparator);return f&&(this.f-=1),f}forEach(P,f){let l=this.e.forward[0];for(;l;)P.call(f,l.value,l.key,this),l=l.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",f=this.e.forward[0];for(;f;)P+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return P}static g(P,f,l){let w=P.e;for(let m=P.d-1;m>=0;m--)for(;w.forward[m]&&l(w.forward[m].key,f)<0;)w=w.forward[m];if(w=w.forward[0],w&&l(w.key,f)===0)return w}static h(P,f,l,w){const m=[];let v=P.e;for(let u=P.d-1;u>=0;u--){for(;v.forward[u]&&w(v.forward[u].key,f)<0;)v=v.forward[u];m[u]=v}if(v=v.forward[0],v&&w(v.key,f)===0)return v.value=l,!1;{const u=O.j(P);if(u>P.d){for(let b=P.d;b<u;b++)m[b]=P.e;P.d=u}v=new A(u,f,l);for(let b=0;b<u;b++)v.forward[b]=m[b].forward[b],m[b].forward[b]=v;return!0}}static j(P,f=.5){let l=1;for(;Math.random()<f&&l<P.c;)l+=1;return l}static k(P,f,l){const w=[];let m=P.e;for(let v=P.d-1;v>=0;v--){for(;m.forward[v]&&l(m.forward[v].key,f)<0;)m=m.forward[v];w[v]=m}if(m=m.forward[0],!m||l(m.key,f)!==0)return!1;for(let v=0;v<P.d&&w[v].forward[v]===m;v++)w[v].forward[v]=m.forward[v];for(;P.d>0&&P.e.forward[P.d-1]===r;)P.d-=1;return!0}}e.SkipList=O}),define(te[61],ie([0,1,13,2]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function r(I){const k=I;return k?typeof k.read=="function":!1}e.isReadable=r;function O(I){const k=I;return k?[k.on,k.pause,k.resume,k.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=O;function M(I){const k=I;return k?O(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.isReadableBufferedStream=M;function P(I,k){return new f(I,k)}e.newWriteableStream=P;class f{constructor(k,t){this.e=k,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(t=>t(k))}h(k){this.c.error.length===0?(0,E.onUnexpectedError)(k):this.c.error.slice(0).forEach(t=>t(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,t){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(k,t){if(this.a.destroyed)return;let c;switch(k){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const n=c.indexOf(t);n>=0&&c.splice(n,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(I,k){const t=[];let c;for(;(c=I.read())!==null;)t.push(c);return k(t)}e.consumeReadable=l;function w(I,k,t){const c=[];let n;for(;(n=I.read())!==null&&c.length<t;)c.push(n);return n===null&&c.length>0?k(c):{read:()=>{if(c.length>0)return c.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return I.read()}}}e.peekReadable=w;function m(I,k){return new Promise((t,c)=>{const n=[];v(I,{onData:i=>{k&&n.push(i)},onError:i=>{k?c(i):t(void 0)},onEnd:()=>{t(k?k(n):void 0)}})})}e.consumeStream=m;function v(I,k){let t=!1;return I.on("error",c=>{t||k.onError(c)}),I.on("end",()=>{t||k.onEnd()}),I.on("data",c=>{t||k.onData(c)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=v;function u(I,k){return new Promise((t,c)=>{const n=new A.DisposableStore,i=[],o=D=>{if(i.push(D),i.length>k)return n.dispose(),I.pause(),t({stream:I,buffer:i,ended:!1})},h=D=>c(D),g=()=>t({stream:I,buffer:i,ended:!0});n.add((0,A.toDisposable)(()=>I.removeListener("error",h))),I.on("error",h),n.add((0,A.toDisposable)(()=>I.removeListener("end",g))),I.on("end",g),n.add((0,A.toDisposable)(()=>I.removeListener("data",o))),I.on("data",o)})}e.peekStream=u;function b(I,k){const t=P(k);return t.end(I),t}e.toStream=b;function p(){const I=P(()=>{throw new Error("not supported")});return I.end(),I}e.emptyStream=p;function s(I){let k=!1;return{read:()=>k?null:(k=!0,I)}}e.toReadable=s;function y(I,k,t){const c=P(t);return v(I,{onData:n=>c.write(k.data(n)),onError:n=>c.error(k.error?k.error(n):n),onEnd:()=>c.end()}),c}e.transform=y;function a(I,k,t){let c=!1;return{read:()=>{const n=k.read();return c?n:(c=!0,n!==null?t([I,n]):I)}}}e.prefixedReadable=a;function d(I,k,t){let c=!1;const n=P(t);return v(k,{onData:i=>c?n.write(i):(c=!0,n.write(t([I,i]))),onError:i=>n.error(i),onEnd:()=>{c||(c=!0,n.write(I)),n.end()}}),n}e.prefixedStream=d}),define(te[17],ie([0,1,100,61]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const r=typeof Buffer<"u",O=new E.Lazy(()=>new Uint8Array(256));let M,P;class f{static alloc(S){return r?new f(Buffer.allocUnsafe(S)):new f(new Uint8Array(S))}static wrap(S){return r&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new f(S)}static fromString(S,L){return!(L?.dontUseNodeBuffer||!1)&&r?new f(Buffer.from(S)):(M||(M=new TextEncoder),new f(M.encode(S)))}static fromByteArray(S){const L=f.alloc(S.length);for(let T=0,U=S.length;T<U;T++)L.buffer[T]=S[T];return L}static concat(S,L){if(typeof L>"u"){L=0;for(let H=0,re=S.length;H<re;H++)L+=S[H].byteLength}const T=f.alloc(L);let U=0;for(let H=0,re=S.length;H<re;H++){const Y=S[H];T.set(Y,U),U+=Y.byteLength}return T}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=f.alloc(this.byteLength);return S.set(this),S}toString(){return r?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(S,L){return new f(this.buffer.subarray(S,L))}set(S,L){if(S instanceof f)this.buffer.set(S.buffer,L);else if(S instanceof Uint8Array)this.buffer.set(S,L);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),L);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return m(this.buffer,S)}writeUInt32BE(S,L){v(this.buffer,S,L)}readUInt32LE(S){return u(this.buffer,S)}writeUInt32LE(S,L){b(this.buffer,S,L)}readUInt8(S){return p(this.buffer,S)}writeUInt8(S,L){s(this.buffer,S,L)}indexOf(S){const L=S instanceof f?S.buffer:S,T=L.byteLength,U=this.buffer,H=U.byteLength;if(T===0)return 0;if(T===1)return U.indexOf(L[0]);if(T>H)return-1;const re=O.value;re.fill(L.length);for(let le=0;le<L.length;le++)re[L[le]]=L.length-le-1;let Y=L.length-1,ne=Y,ce=-1;for(;Y<H;)if(U[Y]===L[ne]){if(ne===0){ce=Y;break}Y--,ne--}else Y+=Math.max(L.length-ne,re[U[Y]]),ne=L.length-1;return ce}}e.VSBuffer=f;function l(R,S){return R[S+0]<<0>>>0|R[S+1]<<8>>>0}e.readUInt16LE=l;function w(R,S,L){R[L+0]=S&255,S=S>>>8,R[L+1]=S&255}e.writeUInt16LE=w;function m(R,S){return R[S]*2**24+R[S+1]*2**16+R[S+2]*2**8+R[S+3]}e.readUInt32BE=m;function v(R,S,L){R[L+3]=S,S=S>>>8,R[L+2]=S,S=S>>>8,R[L+1]=S,S=S>>>8,R[L]=S}e.writeUInt32BE=v;function u(R,S){return R[S+0]<<0>>>0|R[S+1]<<8>>>0|R[S+2]<<16>>>0|R[S+3]<<24>>>0}e.readUInt32LE=u;function b(R,S,L){R[L+0]=S&255,S=S>>>8,R[L+1]=S&255,S=S>>>8,R[L+2]=S&255,S=S>>>8,R[L+3]=S&255}e.writeUInt32LE=b;function p(R,S){return R[S]}e.readUInt8=p;function s(R,S,L){R[L]=S}e.writeUInt8=s;function y(R){return A.consumeReadable(R,S=>f.concat(S))}e.readableToBuffer=y;function a(R){return A.toReadable(R)}e.bufferToReadable=a;function d(R){return A.consumeStream(R,S=>f.concat(S))}e.streamToBuffer=d;async function I(R){return R.ended?f.concat(R.buffer):f.concat([...R.buffer,await d(R.stream)])}e.bufferedStreamToBuffer=I;function k(R){return A.toStream(R,S=>f.concat(S))}e.bufferToStream=k;function t(R){return A.transform(R,{data:S=>typeof S=="string"?f.fromString(S):f.wrap(S)},S=>f.concat(S))}e.streamToBufferReadableStream=t;function c(R){return A.newWriteableStream(S=>f.concat(S),R)}e.newWriteableBufferStream=c;function n(R,S){return A.prefixedReadable(R,S,L=>f.concat(L))}e.prefixedBufferReadable=n;function i(R,S){return A.prefixedStream(R,S,L=>f.concat(L))}e.prefixedBufferStream=i;function o(R){let S=0,L=0,T=0;const U=new Uint8Array(Math.floor(R.length/4*3)),H=Y=>{switch(L){case 3:U[T++]=S|Y,L=0;break;case 2:U[T++]=S|Y>>>2,S=Y<<6,L=3;break;case 1:U[T++]=S|Y>>>4,S=Y<<4,L=2;break;default:S=Y<<2,L=1}};for(let Y=0;Y<R.length;Y++){const ne=R.charCodeAt(Y);if(ne>=65&&ne<=90)H(ne-65);else if(ne>=97&&ne<=122)H(ne-97+26);else if(ne>=48&&ne<=57)H(ne-48+52);else if(ne===43||ne===45)H(62);else if(ne===47||ne===95)H(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${R[Y]}`)}}const re=T;for(;L>0;)H(0);return f.wrap(U).slice(0,re)}e.decodeBase64=o;const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:R},S=!0,L=!1){const T=L?g:h;let U="";const H=R.byteLength%3;let re=0;for(;re<R.byteLength-H;re+=3){const Y=R[re+0],ne=R[re+1],ce=R[re+2];U+=T[Y>>>2],U+=T[(Y<<4|ne>>>4)&63],U+=T[(ne<<2|ce>>>6)&63],U+=T[ce&63]}if(H===1){const Y=R[re+0];U+=T[Y>>>2],U+=T[Y<<4&63],S&&(U+="==")}else if(H===2){const Y=R[re+0],ne=R[re+1];U+=T[Y>>>2],U+=T[(Y<<4|ne>>>4)&63],U+=T[ne<<2&63],S&&(U+="=")}return U}e.encodeBase64=D}),define(te[139],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(te[11],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(c){return typeof c=="string"}e.isString=E;function A(c){return Array.isArray(c)&&c.every(n=>E(n))}e.isStringArray=A;function r(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=r;function O(c){const n=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof n}e.isTypedArray=O;function M(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=M;function P(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=P;function f(c){return c===!0||c===!1}e.isBoolean=f;function l(c){return typeof c>"u"}e.isUndefined=l;function w(c){return!m(c)}e.isDefined=w;function m(c){return l(c)||c===null}e.isUndefinedOrNull=m;function v(c,n){if(!c)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=v;function u(c){if(m(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=u;function b(...c){const n=[];for(let i=0;i<c.length;i++){const o=c[i];if(m(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(o)}return n}e.assertAllDefined=b;const p=Object.prototype.hasOwnProperty;function s(c){if(!r(c))return!1;for(const n in c)if(p.call(c,n))return!1;return!0}e.isEmptyObject=s;function y(c){return typeof c=="function"}e.isFunction=y;function a(...c){return c.length>0&&c.every(y)}e.areFunctions=a;function d(c,n){const i=Math.min(c.length,n.length);for(let o=0;o<i;o++)I(c[o],n[o])}e.validateConstraints=d;function I(c,n){if(E(n)){if(typeof c!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(y(n)){try{if(c instanceof n)return}catch{}if(!m(c)&&c.constructor===n||n.length===1&&n.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=I;function k(c){return c===null?void 0:c}e.withNullAsUndefined=k;function t(c){return typeof c>"u"?null:c}e.withUndefinedAsNull=t}),define(te[69],ie([0,1,11]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function r(P,f){if((0,E.isString)(f)){const l=A[f];if(l===void 0)throw new Error(`${P} references an unknown codicon: ${f}`);f=l}return A[P]=f,{id:P}}function O(){return A}e.getCodiconFontCharacters=O;function M(){return Object.values(e.Codicon)}e.getAllCodicons=M,e.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package_:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,11]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const a=Array.isArray(y)?[]:{};return Object.entries(y).forEach(([d,I])=>{a[d]=I&&typeof I=="object"?A(I):I}),a}e.deepClone=A;function r(y){if(!y||typeof y!="object")return y;const a=[y];for(;a.length>0;){const d=a.shift();Object.freeze(d);for(const I in d)if(O.call(d,I)){const k=d[I];typeof k=="object"&&!Object.isFrozen(k)&&!(0,E.isTypedArray)(k)&&a.push(k)}}return y}e.deepFreeze=r;const O=Object.prototype.hasOwnProperty;function M(y,a){return P(y,a,new Set)}e.cloneAndChange=M;function P(y,a,d){if((0,E.isUndefinedOrNull)(y))return y;const I=a(y);if(typeof I<"u")return I;if(Array.isArray(y)){const k=[];for(const t of y)k.push(P(t,a,d));return k}if((0,E.isObject)(y)){if(d.has(y))throw new Error("Cannot clone recursive data-structure");d.add(y);const k={};for(const t in y)O.call(y,t)&&(k[t]=P(y[t],a,d));return d.delete(y),k}return y}function f(y,a,d=!0){return(0,E.isObject)(y)?((0,E.isObject)(a)&&Object.keys(a).forEach(I=>{I in y?d&&((0,E.isObject)(y[I])&&(0,E.isObject)(a[I])?f(y[I],a[I],d):y[I]=a[I]):y[I]=a[I]}),y):a}e.mixin=f;function l(y,a){if(y===a)return!0;if(y==null||a===null||a===void 0||typeof y!=typeof a||typeof y!="object"||Array.isArray(y)!==Array.isArray(a))return!1;let d,I;if(Array.isArray(y)){if(y.length!==a.length)return!1;for(d=0;d<y.length;d++)if(!l(y[d],a[d]))return!1}else{const k=[];for(I in y)k.push(I);k.sort();const t=[];for(I in a)t.push(I);if(t.sort(),!l(k,t))return!1;for(d=0;d<k.length;d++)if(!l(y[k[d]],a[k[d]]))return!1}return!0}e.equals=l;function w(y){const a=new Set;return JSON.stringify(y,(d,I)=>{if((0,E.isObject)(I)||Array.isArray(I)){if(a.has(I))return"[Circular]";a.add(I)}return I})}e.safeStringify=w;function m(y,a){const d=Object.create(null);return!y||!a||Object.keys(a).forEach(k=>{const t=y[k],c=a[k];l(t,c)||(d[k]=c)}),d}e.distinct=m;function v(y,a){const d=a.toLowerCase(),I=Object.keys(y).find(k=>k.toLowerCase()===d);return I?y[I]:y[a]}e.getCaseInsensitive=v;function u(y,a){const d=Object.create(null);for(const[I,k]of Object.entries(y))a(I,k)&&(d[I]=k);return d}e.filter=u;function b(y){let a=[],d=Object.getPrototypeOf(y);for(;Object.prototype!==d;)a=a.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return a}e.getAllPropertyNames=b;function p(y){const a=[];for(const d of b(y))typeof y[d]=="function"&&a.push(d);return a}e.getAllMethodNames=p;function s(y,a){const d=k=>function(){const t=Array.prototype.slice.call(arguments,0);return a(k,t)},I={};for(const k of y)I[k]=d(k);return I}e.createProxyObject=s}),define(te[102],ie([0,1,69]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(M){function P(f){return f&&typeof f=="object"&&typeof f.id=="string"}M.isThemeColor=P})(A||(e.ThemeColor=A={}));function r(M){return{id:M}}e.themeColorFromId=r;var O;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function f(a){const d=P.exec(a.id);if(!d)return f(E.Codicon.error);const[,I,k]=d,t=["codicon","codicon-"+I];return k&&t.push("codicon-modifier-"+k.substring(1)),t}M.asClassNameArray=f;function l(a){return f(a).join(" ")}M.asClassName=l;function w(a){return"."+f(a).join(".")}M.asCSSSelector=w;function m(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||A.isThemeColor(a.color))}M.isThemeIcon=m;const v=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function u(a){const d=v.exec(a);if(!d)return;const[,I]=d;return{id:I}}M.fromString=u;function b(a){return{id:a}}M.fromId=b;function p(a,d){let I=a.id;const k=I.lastIndexOf("~");return k!==-1&&(I=I.substring(0,k)),d&&(I=`${I}~${d}`),{id:I}}M.modify=p;function s(a){const d=a.id.lastIndexOf("~");if(d!==-1)return a.id.substring(d+1)}M.getModifier=s;function y(a,d){return a.id===d.id&&a.color?.id===d.color?.id}M.isEqual=y})(O||(e.ThemeIcon=O={}))}),define(te[31],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(r){return E.test(r)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(P){for(let f=0;f<P.length;f++)P[f]=Math.floor(Math.random()*256);return P};const O=new Uint8Array(16),M=[];for(let P=0;P<256;P++)M.push(P.toString(16).padStart(2,"0"));return function(){r(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let f=0,l="";return l+=M[O[f++]],l+=M[O[f++]],l+=M[O[f++]],l+=M[O[f++]],l+="-",l+=M[O[f++]],l+=M[O[f++]],l+="-",l+=M[O[f++]],l+=M[O[f++]],l+="-",l+=M[O[f++]],l+=M[O[f++]],l+="-",l+=M[O[f++]],l+=M[O[f++]],l+=M[O[f++]],l+=M[O[f++]],l+=M[O[f++]],l+=M[O[f++]],l}}()}),define(te[140],ie([0,1,70,42,49]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function O(M,P){if(await new Promise((w,m)=>{const v=A.createReadStream(M),u=E.createHash("sha1");v.pipe(u);const b=(0,r.once)((p,s)=>{v.removeAllListeners(),u.removeAllListeners(),p?m(p):w(s)});v.once("error",b),v.once("end",b),u.once("error",b),u.once("data",p=>b(void 0,p.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=O}),define(te[141],ie([0,1,27]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(M){const P=M.replace(/\-/g,":").toLowerCase();return!A.has(P)}function O(){const M=(0,E.networkInterfaces)();for(const P in M){const f=M[P];if(f){for(const{mac:l}of f)if(r(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=O}),define(te[103],ie([0,1,84]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function A(P,f,l,w=1){let m=!1;return new Promise(v=>{const u=setTimeout(()=>{if(!m)return m=!0,v(0)},l);r(P,f,w,b=>{if(!m)return m=!0,clearTimeout(u),v(b)})})}e.findFreePort=A;function r(P,f,l,w){if(f===0)return w(0);const m=new E.Socket;m.once("connect",()=>(M(m),r(P+l,f-1,l,w))),m.once("data",()=>{}),m.once("error",v=>(M(m),v.code!=="ECONNREFUSED"?r(P+l,f-1,l,w):w(P))),m.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(P,f,l,w="127.0.0.1"){let m=!1,v,u=1;const b=E.createServer({pauseOnConnect:!0});function p(s,y){m||(m=!0,b.removeAllListeners(),b.close(),v&&clearTimeout(v),y(s))}return new Promise(s=>{v=setTimeout(()=>{p(0,s)},l),b.on("listening",()=>{p(P,s)}),b.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&u<f?(P++,u++,b.listen(P,w)):p(0,s)}),b.on("close",()=>{p(0,s)}),b.listen(P,w)})}e.findFreePortFaster=O;function M(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(f){console.error(f)}}}),function(){function x(){function e(){return process.uncHostAllowlist}function E(P){const f=new Set;if(Array.isArray(P))for(const l of P)typeof l=="string"&&f.add(l);return Array.from(f)}function A(){const P=e();return P?Array.from(P):[]}function r(P){if(process.platform!=="win32")return;const f=e();if(f)if(typeof P=="string")f.add(P.toLowerCase());else for(const l of E(P))r(l)}function O(P){if(typeof P!="string")return;const f=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let l;for(const w of f){if(P.indexOf(w)!==0)continue;const v=P.indexOf("\\",w.length);if(v===-1)continue;const u=P.substring(w.length,v);if(u){l=u;break}}return l}function M(){process.platform==="win32"&&(process.enableUNCAccessChecks=!1)}return{getUNCHostAllowlist:A,addUNCHostToAllowlist:r,getUNCHost:O,disableUNCAccessRestrictions:M}}typeof define=="function"?define("vs/base/node/unc",[],function(){return x()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[142],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[143],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(r,O){this.a=r,this.onMessage=O}send(r){try{this.a.send("vscode:message",r.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=E}),define(te[38],ie([0,1,15,13]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class r{constructor(){this.a=new WeakMap}on(M,P){const f=(l,...w)=>{this.b(M,l)&&P(l,...w)};return this.a.set(P,f),E.ipcMain.on(M,f),this}once(M,P){return E.ipcMain.once(M,(f,...l)=>{this.b(M,f)&&P(f,...l)}),this}handle(M,P){return E.ipcMain.handle(M,(f,...l)=>this.b(M,f)?P(f,...l):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return E.ipcMain.removeHandler(M),this}removeListener(M,P){const f=this.a.get(P);return f&&(E.ipcMain.removeListener(M,f),this.a.delete(P)),this}b(M,P){if(!M||!M.startsWith("vscode:"))return(0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const f=P.senderFrame,l=f.url;if(!l)return!0;let w="unknown";try{w=new URL(l).host}catch{return(0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${l}'.`),!1}return w!=="vscode-app"?((0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${w}'.`),!1):f.parent!==null?((0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${w}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new r}),define(te[144],ie([0,1,15,38,11,142]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){A.validatedIpcMain.on(O.CONTEXT_MENU_CHANNEL,(f,l,w,m,v)=>{const u=P(f,m,w);u.popup({window:(0,r.withNullAsUndefined)(E.BrowserWindow.fromWebContents(f.sender)),x:v?v.x:void 0,y:v?v.y:void 0,positioningItem:v?v.positioningItem:void 0,callback:()=>{u&&f.sender.send(O.CONTEXT_MENU_CLOSE_CHANNEL,l)}})})}e.registerContextMenuListener=M;function P(f,l,w){const m=new E.Menu;return w.forEach(v=>{let u;v.type==="separator"?u=new E.MenuItem({type:v.type}):Array.isArray(v.submenu)?u=new E.MenuItem({submenu:P(f,l,v.submenu),label:v.label}):u=new E.MenuItem({label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:v.enabled,visible:v.visible,click:(b,p,s)=>f.sender.send(l,v.id,s)}),m.append(u)}),m}}),define(te[145],ie([12,10]),function(x,e){return x.create("vs/base/common/date",e)}),define(te[146],ie([0,1,145]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,r=A*60,O=r*24,M=O*7,P=O*30,f=O*365;function l(m,v,u,b){typeof m!="number"&&(m=m.getTime());const p=Math.round((new Date().getTime()-m)/1e3);if(p<-30)return(0,E.localize)(0,null,l(new Date().getTime()+p*1e3,!1));if(!b&&p<30)return(0,E.localize)(1,null);let s;return p<A?(s=p,v?s===1?u?(0,E.localize)(2,null,s):(0,E.localize)(3,null,s):u?(0,E.localize)(4,null,s):(0,E.localize)(5,null,s):s===1?u?(0,E.localize)(6,null,s):(0,E.localize)(7,null,s):u?(0,E.localize)(8,null,s):(0,E.localize)(9,null,s)):p<r?(s=Math.floor(p/A),v?s===1?u?(0,E.localize)(10,null,s):(0,E.localize)(11,null,s):u?(0,E.localize)(12,null,s):(0,E.localize)(13,null,s):s===1?u?(0,E.localize)(14,null,s):(0,E.localize)(15,null,s):u?(0,E.localize)(16,null,s):(0,E.localize)(17,null,s)):p<O?(s=Math.floor(p/r),v?s===1?u?(0,E.localize)(18,null,s):(0,E.localize)(19,null,s):u?(0,E.localize)(20,null,s):(0,E.localize)(21,null,s):s===1?u?(0,E.localize)(22,null,s):(0,E.localize)(23,null,s):u?(0,E.localize)(24,null,s):(0,E.localize)(25,null,s)):p<M?(s=Math.floor(p/O),v?s===1?(0,E.localize)(26,null,s):(0,E.localize)(27,null,s):s===1?(0,E.localize)(28,null,s):(0,E.localize)(29,null,s)):p<P?(s=Math.floor(p/M),v?s===1?u?(0,E.localize)(30,null,s):(0,E.localize)(31,null,s):u?(0,E.localize)(32,null,s):(0,E.localize)(33,null,s):s===1?u?(0,E.localize)(34,null,s):(0,E.localize)(35,null,s):u?(0,E.localize)(36,null,s):(0,E.localize)(37,null,s)):p<f?(s=Math.floor(p/P),v?s===1?u?(0,E.localize)(38,null,s):(0,E.localize)(39,null,s):u?(0,E.localize)(40,null,s):(0,E.localize)(41,null,s):s===1?u?(0,E.localize)(42,null,s):(0,E.localize)(43,null,s):u?(0,E.localize)(44,null,s):(0,E.localize)(45,null,s)):(s=Math.floor(p/f),v?s===1?u?(0,E.localize)(46,null,s):(0,E.localize)(47,null,s):u?(0,E.localize)(48,null,s):(0,E.localize)(49,null,s):s===1?u?(0,E.localize)(50,null,s):(0,E.localize)(51,null,s):u?(0,E.localize)(52,null,s):(0,E.localize)(53,null,s))}e.fromNow=l;function w(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=w}),define(te[147],ie([12,10]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(te[50],ie([0,1,24,11,147]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function O(m,v){return v&&(m.stack||m.stacktrace)?r.localize(0,null,P(m),M(m.stack)||M(m.stacktrace)):P(m)}function M(m){return Array.isArray(m)?m.join(`
`):m}function P(m){return m.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${m.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?r.localize(1,null,m.message):m.message||r.localize(2,null)}function f(m=null,v=!1){if(!m)return r.localize(3,null);if(Array.isArray(m)){const u=E.coalesce(m),b=f(u[0],v);return u.length>1?r.localize(4,null,b,u.length):b}if(A.isString(m))return m;if(m.detail){const u=m.detail;if(u.error)return O(u.error,v);if(u.exception)return O(u.exception,v)}return m.stack?O(m,v):m.message?m.message:r.localize(5,null)}e.toErrorMessage=f;function l(m){const v=m;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=l;function w(m,v){let u;return typeof m=="string"?u=new Error(m):u=m,u.actions=v,u}e.createErrorWithActions=w}),define(te[148],ie([12,10]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(te[149],ie([0,1,148]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function A(r){switch(r){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=A}),define(te[150],ie([12,10]),function(x,e){return x.create("vs/base/common/platform",e)}),define(te[3],ie([0,1,150]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,r=!1,O=!1,M=!1,P=!1,f=!1,l=!1,w=!1,m=!1,v=!1,u,b=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT,s,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?a=e.globals.vscode.process:typeof process<"u"&&(a=process);const d=typeof a?.versions?.electron=="string",I=d&&a?.type==="renderer";if(typeof navigator=="object"&&!I)y=navigator.userAgent,A=y.indexOf("Windows")>=0,r=y.indexOf("Macintosh")>=0,w=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=y.indexOf("Linux")>=0,v=y?.indexOf("Mobi")>=0,f=!0,u=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,b=u,p=navigator.language;else if(typeof a=="object"){A=a.platform==="win32",r=a.platform==="darwin",O=a.platform==="linux",M=O&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,l=d,m=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT;const D=a.env.VSCODE_NLS_CONFIG;if(D)try{const R=JSON.parse(D),S=R.availableLanguages["*"];u=R.locale,p=R.osLocale,b=S||e.LANGUAGE_DEFAULT,s=R._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var k;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(k||(e.Platform=k={}));function t(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let c=0;r?c=1:A?c=3:O&&(c=2),e.isWindows=A,e.isMacintosh=r,e.isLinux=O,e.isLinuxSnap=M,e.isNative=P,e.isElectron=l,e.isWeb=f,e.isWebWorker=f&&typeof e.globals.importScripts=="function",e.isIOS=w,e.isMobile=v,e.isCI=m,e.platform=c,e.userAgent=y,e.language=b;var n;(function(D){function R(){return e.language}D.value=R;function S(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}D.isDefaultVariant=S;function L(){return e.language==="en"}D.isDefault=L})(n||(e.Language=n={})),e.locale=u,e.platformLocale=p,e.translationsConfigFile=s,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const D=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let L=0,T=D.length;L<T;L++){const U=D[L];if(U.id===S.data.vscodeScheduleAsyncWork){D.splice(L,1),U.callback();return}}});let R=0;return S=>{const L=++R;D.push({id:L,callback:S}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return D=>setTimeout(D)})();var i;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=r||w?2:A?1:3;let o=!0,h=!1;function g(){if(!h){h=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,o=new Uint16Array(D.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=g,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[36],ie([0,1,3]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const r=E.globals.vscode.process;A={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(te[9],ie([0,1,36]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,r=97,O=90,M=122,P=46,f=47,l=92,w=58,m=63;class v extends Error{constructor(c,n,i){let o;typeof n=="string"&&n.indexOf("not ")===0?(o="must not be",n=n.replace(/^not /,"")):o="must be";const h=c.indexOf(".")!==-1?"property":"argument";let g=`The "${c}" ${h} ${o} of type ${n}`;g+=`. Received type ${typeof i}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function u(t,c){if(t===null||typeof t!="object")throw new v(c,"Object",t)}function b(t,c){if(typeof t!="string")throw new v(c,"string",t)}const p=E.platform==="win32";function s(t){return t===f||t===l}function y(t){return t===f}function a(t){return t>=A&&t<=O||t>=r&&t<=M}function d(t,c,n,i){let o="",h=0,g=-1,D=0,R=0;for(let S=0;S<=t.length;++S){if(S<t.length)R=t.charCodeAt(S);else{if(i(R))break;R=f}if(i(R)){if(!(g===S-1||D===1))if(D===2){if(o.length<2||h!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const L=o.lastIndexOf(n);L===-1?(o="",h=0):(o=o.slice(0,L),h=o.length-1-o.lastIndexOf(n)),g=S,D=0;continue}else if(o.length!==0){o="",h=0,g=S,D=0;continue}}c&&(o+=o.length>0?`${n}..`:"..",h=2)}else o.length>0?o+=`${n}${t.slice(g+1,S)}`:o=t.slice(g+1,S),h=S-g-1;g=S,D=0}else R===P&&D!==-1?++D:D=-1}return o}function I(t,c){u(c,"pathObject");const n=c.dir||c.root,i=c.base||`${c.name||""}${c.ext||""}`;return n?n===c.root?`${n}${i}`:`${n}${t}${i}`:i}e.win32={resolve(...t){let c="",n="",i=!1;for(let o=t.length-1;o>=-1;o--){let h;if(o>=0){if(h=t[o],b(h,"path"),h.length===0)continue}else c.length===0?h=E.cwd():(h=E.env[`=${c}`]||E.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==c.toLowerCase()&&h.charCodeAt(2)===l)&&(h=`${c}\\`));const g=h.length;let D=0,R="",S=!1;const L=h.charCodeAt(0);if(g===1)s(L)&&(D=1,S=!0);else if(s(L))if(S=!0,s(h.charCodeAt(1))){let T=2,U=T;for(;T<g&&!s(h.charCodeAt(T));)T++;if(T<g&&T!==U){const H=h.slice(U,T);for(U=T;T<g&&s(h.charCodeAt(T));)T++;if(T<g&&T!==U){for(U=T;T<g&&!s(h.charCodeAt(T));)T++;(T===g||T!==U)&&(R=`\\\\${H}\\${h.slice(U,T)}`,D=T)}}}else D=1;else a(L)&&h.charCodeAt(1)===w&&(R=h.slice(0,2),D=2,g>2&&s(h.charCodeAt(2))&&(S=!0,D=3));if(R.length>0)if(c.length>0){if(R.toLowerCase()!==c.toLowerCase())continue}else c=R;if(i){if(c.length>0)break}else if(n=`${h.slice(D)}\\${n}`,i=S,S&&c.length>0)break}return n=d(n,!i,"\\",s),i?`${c}\\${n}`:`${c}${n}`||"."},normalize(t){b(t,"path");const c=t.length;if(c===0)return".";let n=0,i,o=!1;const h=t.charCodeAt(0);if(c===1)return y(h)?"\\":t;if(s(h))if(o=!0,s(t.charCodeAt(1))){let D=2,R=D;for(;D<c&&!s(t.charCodeAt(D));)D++;if(D<c&&D!==R){const S=t.slice(R,D);for(R=D;D<c&&s(t.charCodeAt(D));)D++;if(D<c&&D!==R){for(R=D;D<c&&!s(t.charCodeAt(D));)D++;if(D===c)return`\\\\${S}\\${t.slice(R)}\\`;D!==R&&(i=`\\\\${S}\\${t.slice(R,D)}`,n=D)}}}else n=1;else a(h)&&t.charCodeAt(1)===w&&(i=t.slice(0,2),n=2,c>2&&s(t.charCodeAt(2))&&(o=!0,n=3));let g=n<c?d(t.slice(n),!o,"\\",s):"";return g.length===0&&!o&&(g="."),g.length>0&&s(t.charCodeAt(c-1))&&(g+="\\"),i===void 0?o?`\\${g}`:g:o?`${i}\\${g}`:`${i}${g}`},isAbsolute(t){b(t,"path");const c=t.length;if(c===0)return!1;const n=t.charCodeAt(0);return s(n)||c>2&&a(n)&&t.charCodeAt(1)===w&&s(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,n;for(let h=0;h<t.length;++h){const g=t[h];b(g,"path"),g.length>0&&(c===void 0?c=n=g:c+=`\\${g}`)}if(c===void 0)return".";let i=!0,o=0;if(typeof n=="string"&&s(n.charCodeAt(0))){++o;const h=n.length;h>1&&s(n.charCodeAt(1))&&(++o,h>2&&(s(n.charCodeAt(2))?++o:i=!1))}if(i){for(;o<c.length&&s(c.charCodeAt(o));)o++;o>=2&&(c=`\\${c.slice(o)}`)}return e.win32.normalize(c)},relative(t,c){if(b(t,"from"),b(c,"to"),t===c)return"";const n=e.win32.resolve(t),i=e.win32.resolve(c);if(n===i||(t=n.toLowerCase(),c=i.toLowerCase(),t===c))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===l;)o++;let h=t.length;for(;h-1>o&&t.charCodeAt(h-1)===l;)h--;const g=h-o;let D=0;for(;D<c.length&&c.charCodeAt(D)===l;)D++;let R=c.length;for(;R-1>D&&c.charCodeAt(R-1)===l;)R--;const S=R-D,L=g<S?g:S;let T=-1,U=0;for(;U<L;U++){const re=t.charCodeAt(o+U);if(re!==c.charCodeAt(D+U))break;re===l&&(T=U)}if(U!==L){if(T===-1)return i}else{if(S>L){if(c.charCodeAt(D+U)===l)return i.slice(D+U+1);if(U===2)return i.slice(D+U)}g>L&&(t.charCodeAt(o+U)===l?T=U:U===2&&(T=3)),T===-1&&(T=0)}let H="";for(U=o+T+1;U<=h;++U)(U===h||t.charCodeAt(U)===l)&&(H+=H.length===0?"..":"\\..");return D+=T,H.length>0?`${H}${i.slice(D,R)}`:(i.charCodeAt(D)===l&&++D,i.slice(D,R))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.win32.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===l){if(c.charCodeAt(1)===l){const n=c.charCodeAt(2);if(n!==m&&n!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(a(c.charCodeAt(0))&&c.charCodeAt(1)===w&&c.charCodeAt(2)===l)return`\\\\?\\${c}`;return t},dirname(t){b(t,"path");const c=t.length;if(c===0)return".";let n=-1,i=0;const o=t.charCodeAt(0);if(c===1)return s(o)?t:".";if(s(o)){if(n=i=1,s(t.charCodeAt(1))){let D=2,R=D;for(;D<c&&!s(t.charCodeAt(D));)D++;if(D<c&&D!==R){for(R=D;D<c&&s(t.charCodeAt(D));)D++;if(D<c&&D!==R){for(R=D;D<c&&!s(t.charCodeAt(D));)D++;if(D===c)return t;D!==R&&(n=i=D+1)}}}}else a(o)&&t.charCodeAt(1)===w&&(n=c>2&&s(t.charCodeAt(2))?3:2,i=n);let h=-1,g=!0;for(let D=c-1;D>=i;--D)if(s(t.charCodeAt(D))){if(!g){h=D;break}}else g=!1;if(h===-1){if(n===-1)return".";h=n}return t.slice(0,h)},basename(t,c){c!==void 0&&b(c,"ext"),b(t,"path");let n=0,i=-1,o=!0,h;if(t.length>=2&&a(t.charCodeAt(0))&&t.charCodeAt(1)===w&&(n=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let g=c.length-1,D=-1;for(h=t.length-1;h>=n;--h){const R=t.charCodeAt(h);if(s(R)){if(!o){n=h+1;break}}else D===-1&&(o=!1,D=h+1),g>=0&&(R===c.charCodeAt(g)?--g===-1&&(i=h):(g=-1,i=D))}return n===i?i=D:i===-1&&(i=t.length),t.slice(n,i)}for(h=t.length-1;h>=n;--h)if(s(t.charCodeAt(h))){if(!o){n=h+1;break}}else i===-1&&(o=!1,i=h+1);return i===-1?"":t.slice(n,i)},extname(t){b(t,"path");let c=0,n=-1,i=0,o=-1,h=!0,g=0;t.length>=2&&t.charCodeAt(1)===w&&a(t.charCodeAt(0))&&(c=i=2);for(let D=t.length-1;D>=c;--D){const R=t.charCodeAt(D);if(s(R)){if(!h){i=D+1;break}continue}o===-1&&(h=!1,o=D+1),R===P?n===-1?n=D:g!==1&&(g=1):n!==-1&&(g=-1)}return n===-1||o===-1||g===0||g===1&&n===o-1&&n===i+1?"":t.slice(n,o)},format:I.bind(null,"\\"),parse(t){b(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const n=t.length;let i=0,o=t.charCodeAt(0);if(n===1)return s(o)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(s(o)){if(i=1,s(t.charCodeAt(1))){let T=2,U=T;for(;T<n&&!s(t.charCodeAt(T));)T++;if(T<n&&T!==U){for(U=T;T<n&&s(t.charCodeAt(T));)T++;if(T<n&&T!==U){for(U=T;T<n&&!s(t.charCodeAt(T));)T++;T===n?i=T:T!==U&&(i=T+1)}}}}else if(a(o)&&t.charCodeAt(1)===w){if(n<=2)return c.root=c.dir=t,c;if(i=2,s(t.charCodeAt(2))){if(n===3)return c.root=c.dir=t,c;i=3}}i>0&&(c.root=t.slice(0,i));let h=-1,g=i,D=-1,R=!0,S=t.length-1,L=0;for(;S>=i;--S){if(o=t.charCodeAt(S),s(o)){if(!R){g=S+1;break}continue}D===-1&&(R=!1,D=S+1),o===P?h===-1?h=S:L!==1&&(L=1):h!==-1&&(L=-1)}return D!==-1&&(h===-1||L===0||L===1&&h===D-1&&h===g+1?c.base=c.name=t.slice(g,D):(c.name=t.slice(g,h),c.base=t.slice(g,D),c.ext=t.slice(h,D))),g>0&&g!==i?c.dir=t.slice(0,g-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(p){const t=/\\/g;return()=>{const c=E.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...t){let c="",n=!1;for(let i=t.length-1;i>=-1&&!n;i--){const o=i>=0?t[i]:k();b(o,"path"),o.length!==0&&(c=`${o}/${c}`,n=o.charCodeAt(0)===f)}return c=d(c,!n,"/",y),n?`/${c}`:c.length>0?c:"."},normalize(t){if(b(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===f,n=t.charCodeAt(t.length-1)===f;return t=d(t,!c,"/",y),t.length===0?c?"/":n?"./":".":(n&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return b(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let c;for(let n=0;n<t.length;++n){const i=t[n];b(i,"path"),i.length>0&&(c===void 0?c=i:c+=`/${i}`)}return c===void 0?".":e.posix.normalize(c)},relative(t,c){if(b(t,"from"),b(c,"to"),t===c||(t=e.posix.resolve(t),c=e.posix.resolve(c),t===c))return"";const n=1,i=t.length,o=i-n,h=1,g=c.length-h,D=o<g?o:g;let R=-1,S=0;for(;S<D;S++){const T=t.charCodeAt(n+S);if(T!==c.charCodeAt(h+S))break;T===f&&(R=S)}if(S===D)if(g>D){if(c.charCodeAt(h+S)===f)return c.slice(h+S+1);if(S===0)return c.slice(h+S)}else o>D&&(t.charCodeAt(n+S)===f?R=S:S===0&&(R=0));let L="";for(S=n+R+1;S<=i;++S)(S===i||t.charCodeAt(S)===f)&&(L+=L.length===0?"..":"/..");return`${L}${c.slice(h+R)}`},toNamespacedPath(t){return t},dirname(t){if(b(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===f;let n=-1,i=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===f){if(!i){n=o;break}}else i=!1;return n===-1?c?"/":".":c&&n===1?"//":t.slice(0,n)},basename(t,c){c!==void 0&&b(c,"ext"),b(t,"path");let n=0,i=-1,o=!0,h;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let g=c.length-1,D=-1;for(h=t.length-1;h>=0;--h){const R=t.charCodeAt(h);if(R===f){if(!o){n=h+1;break}}else D===-1&&(o=!1,D=h+1),g>=0&&(R===c.charCodeAt(g)?--g===-1&&(i=h):(g=-1,i=D))}return n===i?i=D:i===-1&&(i=t.length),t.slice(n,i)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===f){if(!o){n=h+1;break}}else i===-1&&(o=!1,i=h+1);return i===-1?"":t.slice(n,i)},extname(t){b(t,"path");let c=-1,n=0,i=-1,o=!0,h=0;for(let g=t.length-1;g>=0;--g){const D=t.charCodeAt(g);if(D===f){if(!o){n=g+1;break}continue}i===-1&&(o=!1,i=g+1),D===P?c===-1?c=g:h!==1&&(h=1):c!==-1&&(h=-1)}return c===-1||i===-1||h===0||h===1&&c===i-1&&c===n+1?"":t.slice(c,i)},format:I.bind(null,"/"),parse(t){b(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const n=t.charCodeAt(0)===f;let i;n?(c.root="/",i=1):i=0;let o=-1,h=0,g=-1,D=!0,R=t.length-1,S=0;for(;R>=i;--R){const L=t.charCodeAt(R);if(L===f){if(!D){h=R+1;break}continue}g===-1&&(D=!1,g=R+1),L===P?o===-1?o=R:S!==1&&(S=1):o!==-1&&(S=-1)}if(g!==-1){const L=h===0&&n?1:h;o===-1||S===0||S===1&&o===g-1&&o===h+1?c.base=c.name=t.slice(L,g):(c.name=t.slice(L,o),c.base=t.slice(L,g),c.ext=t.slice(o,g))}return h>0?c.dir=t.slice(0,h-1):n&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(te[71],ie([0,1,3]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A||(e.Source=A={}));var r;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function O(P,...f){const l=f.reduce((v,u)=>(v[u]=!0,v),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(v=>!l[v]).forEach(v=>{for(let u=0;u<w.length;u++)if(v.search(w[u])!==-1){delete P[v];break}})}e.sanitizeProcessEnvironment=O;function M(P){P&&(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(te[85],ie([0,1,3]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=E.globals.performance&&typeof E.globals.performance.now=="function";class r{static create(M=!0){return new r(M)}constructor(M){this.a=A&&M,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=r}),define(te[4],ie([0,1,13,49,2,101,85]),function(x,e,E,A,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,f=!1;var l;(function(h){h.None=()=>r.Disposable.None;function g(z){if(f){const{onDidAddListener:q}=z,j=b.create();let $=0;z.onDidAddListener=()=>{++$===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),q?.()}}}function D(z,q){return ne(z,()=>{},0,void 0,!0,void 0,q)}h.defer=D;function R(z){return(q,j=null,$)=>{let K=!1,se;return se=z(ue=>{if(!K)return se?se.dispose():K=!0,q.call(j,ue)},null,$),K&&se.dispose(),se}}h.once=R;function S(z,q,j){return Y(($,K=null,se)=>z(ue=>$.call(K,q(ue)),null,se),j)}h.map=S;function L(z,q,j){return Y(($,K=null,se)=>z(ue=>{q(ue),$.call(K,ue)},null,se),j)}h.forEach=L;function T(z,q,j){return Y(($,K=null,se)=>z(ue=>q(ue)&&$.call(K,ue),null,se),j)}h.filter=T;function U(z){return z}h.signal=U;function H(...z){return(q,j=null,$)=>(0,r.combinedDisposable)(...z.map(K=>K(se=>q.call(j,se),null,$)))}h.any=H;function re(z,q,j,$){let K=j;return S(z,se=>(K=q(K,se),K),$)}h.reduce=re;function Y(z,q){let j;const $={onWillAddFirstListener(){j=z(K.fire,K)},onDidRemoveLastListener(){j?.dispose()}};q||g($);const K=new s($);return q?.add(K),K.event}function ne(z,q,j=100,$=!1,K=!1,se,ue){let be,ke,Me,Ae=0,Fe;const ye={leakWarningThreshold:se,onWillAddFirstListener(){be=z(Ee=>{Ae++,ke=q(ke,Ee),$&&!Me&&(we.fire(ke),ke=void 0),Fe=()=>{const ee=ke;ke=void 0,Me=void 0,(!$||Ae>1)&&we.fire(ee),Ae=0},typeof j=="number"?(clearTimeout(Me),Me=setTimeout(Fe,j)):Me===void 0&&(Me=0,queueMicrotask(Fe))})},onWillRemoveListener(){K&&Ae>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,be.dispose()}};ue||g(ye);const we=new s(ye);return ue?.add(we),we.event}h.debounce=ne;function ce(z,q=0,j){return h.debounce(z,($,K)=>$?($.push(K),$):[K],q,void 0,!0,void 0,j)}h.accumulate=ce;function le(z,q=($,K)=>$===K,j){let $=!0,K;return T(z,se=>{const ue=$||!q(se,K);return $=!1,K=se,ue},j)}h.latch=le;function X(z,q,j){return[h.filter(z,q,j),h.filter(z,$=>!q($),j)]}h.split=X;function G(z,q=!1,j=[]){let $=j.slice(),K=z(be=>{$?$.push(be):ue.fire(be)});const se=()=>{$?.forEach(be=>ue.fire(be)),$=null},ue=new s({onWillAddFirstListener(){K||(K=z(be=>ue.fire(be)))},onDidAddFirstListener(){$&&(q?setTimeout(se):se())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return ue.event}h.buffer=G;class N{constructor(q){this.event=q,this.c=new r.DisposableStore}map(q){return new N(S(this.event,q,this.c))}forEach(q){return new N(L(this.event,q,this.c))}filter(q){return new N(T(this.event,q,this.c))}reduce(q,j){return new N(re(this.event,q,j,this.c))}latch(){return new N(le(this.event,void 0,this.c))}debounce(q,j=100,$=!1,K=!1,se){return new N(ne(this.event,q,j,$,K,se,this.c))}on(q,j,$){return this.event(q,j,$)}once(q,j,$){return R(this.event)(q,j,$)}dispose(){this.c.dispose()}}function F(z){return new N(z)}h.chain=F;function V(z,q,j=$=>$){const $=(...be)=>ue.fire(j(...be)),K=()=>z.on(q,$),se=()=>z.removeListener(q,$),ue=new s({onWillAddFirstListener:K,onDidRemoveLastListener:se});return ue.event}h.fromNodeEventEmitter=V;function J(z,q,j=$=>$){const $=(...be)=>ue.fire(j(...be)),K=()=>z.addEventListener(q,$),se=()=>z.removeEventListener(q,$),ue=new s({onWillAddFirstListener:K,onDidRemoveLastListener:se});return ue.event}h.fromDOMEventEmitter=J;function _(z){return new Promise(q=>R(z)(q))}h.toPromise=_;function ae(z,q){return q(void 0),z(j=>q(j))}h.runAndSubscribe=ae;function oe(z,q){let j=null;function $(se){j?.dispose(),j=new r.DisposableStore,q(se,j)}$(void 0);const K=z(se=>$(se));return(0,r.toDisposable)(()=>{K.dispose(),j?.dispose()})}h.runAndSubscribeWithStore=oe;class B{constructor(q,j){this._observable=q,this.c=0,this.d=!1;const $={onWillAddFirstListener:()=>{q.addObserver(this)},onDidRemoveLastListener:()=>{q.removeObserver(this)}};j||g($),this.emitter=new s($),j&&j.add(this.emitter)}beginUpdate(q){this.c++}handlePossibleChange(q){}handleChange(q,j){this.d=!0}endUpdate(q){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function C(z,q){return new B(z,q).emitter.event}h.fromObservable=C;function W(z){return q=>{let j=0,$=!1;const K={beginUpdate(){j++},endUpdate(){j--,j===0&&(z.reportChanges(),$&&($=!1,q()))},handlePossibleChange(){},handleChange(){$=!0}};return z.addObserver(K),{dispose(){z.removeObserver(K)}}}}h.fromObservableLight=W})(l||(e.Event=l={}));class w{constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${w.c++}`,w.all.add(this)}start(g){this.d=new M.StopWatch(!0),this.listenerCount=g}stop(){if(this.d){const g=this.d.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=w,w.all=new Set,w.c=0;let m=-1;function v(h){const g=m;return m=h,{dispose(){m=g}}}e.setGlobalLeakWarningThreshold=v;class u{constructor(g,D=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=D,this.d=0}dispose(){this.c?.clear()}check(g,D){const R=this.threshold;if(R<=0||D<R)return;this.c||(this.c=new Map);const S=this.c.get(g.value)||0;if(this.c.set(g.value,S+1),this.d-=1,this.d<=0){this.d=R*.5;let L,T=0;for(const[U,H]of this.c)(!L||T<H)&&(L=U,T=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${T}):`),console.warn(L)}return()=>{const L=this.c.get(g.value)||0;this.c.set(g.value,L-1)}}}class b{static create(){return new b(new Error().stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(g,D,R){this.callback=g,this.callbackThis=D,this.stack=R,this.subscription=new r.SafeDisposable}invoke(g){this.callback.call(this.callbackThis,g)}}class s{constructor(g){this.j=!1,this.d=g,this.f=m>0||this.d?.leakWarningThreshold?new u(this.d?.leakWarningThreshold??m):void 0,this.g=this.d?._profName?new w(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const g=Array.from(this.q);queueMicrotask(()=>{for(const D of g)D.subscription.isset()&&(D.subscription.unset(),D.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(g,D,R)=>{if(this.q||(this.q=new O.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;const S=this.q.isEmpty();S&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let L,T;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(T=b.create(),L=this.f.check(T,this.q.size+1)),P&&(T=T??b.create());const U=new p(g,D,T),H=this.q.push(U);S&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,g,D);const re=U.subscription.set(()=>{L?.(),this.j||(this.d?.onWillRemoveListener?.(this),H(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return R instanceof r.DisposableStore?R.add(re):Array.isArray(R)&&R.push(re),re}),this.l}fire(g){if(this.q){this.m||(this.m=new a(this.d?.onListenerError));for(const D of this.q)this.m.push(this,D,g);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=s;class y{constructor(g=E.onUnexpectedError){this.d=g,this.c=new O.LinkedList}get size(){return this.c.size}push(g,D,R){this.c.push(new d(g,D,R))}clear(g){const D=new O.LinkedList;for(const R of this.c)R.emitter!==g&&D.push(R);this.c=D}deliver(){for(;this.c.size>0;){const g=this.c.shift();try{g.listener.invoke(g.event)}catch(D){this.d(D)}}}}e.EventDeliveryQueue=y;class a extends y{clear(g){this.c.clear()}}class d{constructor(g,D,R){this.emitter=g,this.listener=D,this.event=R}}class I extends s{async fireAsync(g,D,R){if(this.q){this.c||(this.c=new O.LinkedList);for(const S of this.q)this.c.push([S,g]);for(;this.c.size>0&&!D.isCancellationRequested;){const[S,L]=this.c.shift(),T=[],U={...L,token:D,waitUntil:H=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");R&&(H=R(H,S.callback)),T.push(H)}};try{S.invoke(U)}catch(H){(0,E.onUnexpectedError)(H);continue}Object.freeze(T),await Promise.allSettled(T).then(H=>{for(const re of H)re.status==="rejected"&&(0,E.onUnexpectedError)(re.reason)})}}}}e.AsyncEmitter=I;class k extends s{get isPaused(){return this.h!==0}constructor(g){super(g),this.h=0,this.s=new O.LinkedList,this.t=g?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const g=Array.from(this.s);this.s.clear(),super.fire(this.t(g))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(g){this.q&&(this.h!==0?this.s.push(g):super.fire(g))}}e.PauseableEmitter=k;class t extends k{constructor(g){super(g),this.c=g.delay??100}fire(g){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(g)}}e.DebounceEmitter=t;class c extends s{constructor(g){super(g),this.c=[],this.h=g?.merge}fire(g){this.hasListeners()&&(this.c.push(g),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(D=>super.fire(D)),this.c=[]}))}}e.MicrotaskEmitter=c;class n{constructor(){this.d=!1,this.f=[],this.c=new s({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(g){const D={event:g,listener:null};this.f.push(D),this.d&&this.j(D);const R=()=>{this.d&&this.k(D);const S=this.f.indexOf(D);this.f.splice(S,1)};return(0,r.toDisposable)((0,A.once)(R))}g(){this.d=!0,this.f.forEach(g=>this.j(g))}h(){this.d=!1,this.f.forEach(g=>this.k(g))}j(g){g.listener=g.event(D=>this.c.fire(D))}k(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=n;class i{constructor(){this.c=[]}wrapEvent(g){return(D,R,S)=>g(L=>{const T=this.c[this.c.length-1];T?T.push(()=>D.call(R,L)):D.call(R,L)},void 0,S)}bufferEvents(g){const D=[];this.c.push(D);const R=g();return this.c.pop(),D.forEach(S=>S()),R}}e.EventBufferer=i;class o{constructor(){this.c=!1,this.d=l.None,this.f=r.Disposable.None,this.g=new s({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(g){this.d=g,this.c&&(this.f.dispose(),this.f=g(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(te[21],ie([0,1,4]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,f){const l=setTimeout(P.bind(f),0);return{dispose(){clearTimeout(l)}}});var r;(function(P){function f(l){return l===P.None||l===P.Cancelled||l instanceof O?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}P.isCancellationToken=f,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(r||(e.CancellationToken=r={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(f){this.a=void 0,this.b=void 0,this.b=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new O),this.a}cancel(){this.a?this.a instanceof O&&this.a.cancel():this.a=r.Cancelled}dispose(f=!1){f&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof O&&this.a.dispose():this.a=r.None}}e.CancellationTokenSource=M}),define(te[151],ie([0,1,21]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new E.CancellationTokenSource,f=this.b(P.token);return this.a={promise:f,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=A;class r{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const f=JSON.stringify(P);return this.b!==f&&(this.b=f,this.a=this.c(P)),this.a}}e.LRUCachedFunction=r;class O{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const f=this.b(P);return this.a.set(P,f),f}}e.CachedFunction=O}),define(te[25],ie([0,1,151,100]),function(x,e,E,A){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function O(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=O;const M=/{(\d+)}/g;function P(Q,...de){return de.length===0?Q:Q.replace(M,function(ge,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=de.length?ge:de[Se]})}e.format=P;const f=/{([^}]+)}/g;function l(Q,de){return Q.replace(f,(ge,me)=>de[me]??ge)}e.format2=l;function w(Q){return Q.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.escape=w;function m(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function v(Q,de){let ge=0;const me=de.charCodeAt(0);for(let Se=Q.length-1;Se>=0;Se--)Q.charCodeAt(Se)===me&&ge++;return ge}e.count=v;function u(Q,de,ge="\u2026"){return Q.length<=de?Q:`${Q.substr(0,de)}${ge}`}e.truncate=u;function b(Q,de=" "){const ge=p(Q,de);return s(ge,de)}e.trim=b;function p(Q,de){if(!Q||!de)return Q;const ge=de.length;if(ge===0||Q.length===0)return Q;let me=0;for(;Q.indexOf(de,me)===me;)me=me+ge;return Q.substring(me)}e.ltrim=p;function s(Q,de){if(!Q||!de)return Q;const ge=de.length,me=Q.length;if(ge===0||me===0)return Q;let Se=me,Le=-1;for(;Le=Q.lastIndexOf(de,Se-1),!(Le===-1||Le+ge!==Se);){if(Le===0)return"";Se=Le}return Q.substring(0,Se)}e.rtrim=s;function y(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function a(Q){return Q.replace(/\*/g,"")}e.stripWildcards=a;function d(Q,de,ge={}){if(!Q)throw new Error("Cannot create regex from empty string");de||(Q=m(Q)),ge.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let me="";return ge.global&&(me+="g"),ge.matchCase||(me+="i"),ge.multiline&&(me+="m"),ge.unicode&&(me+="u"),new RegExp(Q,me)}e.createRegExp=d;function I(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function k(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=k;function t(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=t;function c(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=c;function n(Q){for(let de=0,ge=Q.length;de<ge;de++){const me=Q.charCodeAt(de);if(me!==32&&me!==9)return de}return-1}e.firstNonWhitespaceIndex=n;function i(Q,de=0,ge=Q.length){for(let me=de;me<ge;me++){const Se=Q.charCodeAt(me);if(Se!==32&&Se!==9)return Q.substring(de,me)}return Q.substring(de,ge)}e.getLeadingWhitespace=i;function o(Q,de=Q.length-1){for(let ge=de;ge>=0;ge--){const me=Q.charCodeAt(ge);if(me!==32&&me!==9)return ge}return-1}e.lastNonWhitespaceIndex=o;function h(Q,de,ge){const me=[];let Se=0;for(const Le of Q.matchAll(de)){if(me.push(Q.slice(Se,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Se=Le.index+Le[0].length,me.push(ge(Le[0],...Le.slice(1),Le.index,Q,Le.groups))}return me.push(Q.slice(Se)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=h;function g(Q,de){return Q<de?-1:Q>de?1:0}e.compare=g;function D(Q,de,ge=0,me=Q.length,Se=0,Le=de.length){for(;ge<me&&Se<Le;ge++,Se++){const Ze=Q.charCodeAt(ge),Ge=de.charCodeAt(Se);if(Ze<Ge)return-1;if(Ze>Ge)return 1}const Ne=me-ge,Ke=Le-Se;return Ne<Ke?-1:Ne>Ke?1:0}e.compareSubstring=D;function R(Q,de){return S(Q,de,0,Q.length,0,de.length)}e.compareIgnoreCase=R;function S(Q,de,ge=0,me=Q.length,Se=0,Le=de.length){for(;ge<me&&Se<Le;ge++,Se++){let Ze=Q.charCodeAt(ge),Ge=de.charCodeAt(Se);if(Ze===Ge)continue;if(Ze>=128||Ge>=128)return D(Q.toLowerCase(),de.toLowerCase(),ge,me,Se,Le);T(Ze)&&(Ze-=32),T(Ge)&&(Ge-=32);const Ye=Ze-Ge;if(Ye!==0)return Ye}const Ne=me-ge,Ke=Le-Se;return Ne<Ke?-1:Ne>Ke?1:0}e.compareSubstringIgnoreCase=S;function L(Q){return Q>=48&&Q<=57}e.isAsciiDigit=L;function T(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=T;function U(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=U;function H(Q,de){return Q.length===de.length&&S(Q,de)===0}e.equalsIgnoreCase=H;function re(Q,de){const ge=de.length;return de.length>Q.length?!1:S(Q,de,0,ge)===0}e.startsWithIgnoreCase=re;function Y(Q,de){const ge=Math.min(Q.length,de.length);let me;for(me=0;me<ge;me++)if(Q.charCodeAt(me)!==de.charCodeAt(me))return me;return ge}e.commonPrefixLength=Y;function ne(Q,de){const ge=Math.min(Q.length,de.length);let me;const Se=Q.length-1,Le=de.length-1;for(me=0;me<ge;me++)if(Q.charCodeAt(Se-me)!==de.charCodeAt(Le-me))return me;return ge}e.commonSuffixLength=ne;function ce(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=ce;function le(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=le;function X(Q,de){return(Q-55296<<10)+(de-56320)+65536}e.computeCodePoint=X;function G(Q,de,ge){const me=Q.charCodeAt(ge);if(ce(me)&&ge+1<de){const Se=Q.charCodeAt(ge+1);if(le(Se))return X(me,Se)}return me}e.getNextCodePoint=G;function N(Q,de){const ge=Q.charCodeAt(de-1);if(le(ge)&&de>1){const me=Q.charCodeAt(de-2);if(ce(me))return X(me,ge)}return ge}class F{get offset(){return this.e}constructor(de,ge=0){this.c=de,this.d=de.length,this.e=ge}setOffset(de){this.e=de}prevCodePoint(){const de=N(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=G(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.CodePointIterator=F;class V{get offset(){return this.c.offset}constructor(de,ge=0){this.c=new F(de,ge)}nextGraphemeLength(){const de=De.getInstance(),ge=this.c,me=ge.offset;let Se=de.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Le=ge.offset,Ne=de.getGraphemeBreakType(ge.nextCodePoint());if(fe(Se,Ne)){ge.setOffset(Le);break}Se=Ne}return ge.offset-me}prevGraphemeLength(){const de=De.getInstance(),ge=this.c,me=ge.offset;let Se=de.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Le=ge.offset,Ne=de.getGraphemeBreakType(ge.prevCodePoint());if(fe(Ne,Se)){ge.setOffset(Le);break}Se=Ne}return me-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=V;function J(Q,de){return new V(Q,de).nextGraphemeLength()}e.nextCharLength=J;function _(Q,de){return new V(Q,de).prevGraphemeLength()}e.prevCharLength=_;function ae(Q,de){de>0&&le(Q.charCodeAt(de))&&de--;const ge=de+J(Q,de);return[ge-_(Q,ge),ge]}e.getCharContainingOffset=ae;function oe(Q){const de=new V(Q);let ge=0;for(;!de.eol();)ge++,de.nextGraphemeLength();return ge}e.charCount=oe;let B;function C(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(Q){return B||(B=C()),B.test(Q)}e.containsRTL=W;const z=/^[\t\n\r\x20-\x7E]*$/;function q(Q){return z.test(Q)}e.isBasicASCII=q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=j;function $(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=$;function K(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=K;function se(Q,de){if(Q.length<de)return Q;const ge=/\b/g;let me=0;for(;ge.test(Q)&&!(Q.length-ge.lastIndex<de);)me=ge.lastIndex,ge.lastIndex+=1;return Q.substring(me).replace(/^\s/,"")}e.lcut=se;const ue=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,be=/\x1b\].*?\x07/g;function ke(Q){return Q&&(Q=Q.replace(ue,"").replace(be,"")),Q}e.removeAnsiEscapeCodes=ke,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Me(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Me;function Ae(Q){return Me(Q)?Q.substr(1):Q}e.stripUTF8BOM=Ae;function Fe(Q,de){if(!Q||!de||Q.length<de.length)return!1;const ge=de.length,me=Q.toLowerCase();let Se=0,Le=-1;for(;Se<ge;){const Ne=me.indexOf(de[Se],Le+1);if(Ne<0)return!1;Le=Ne,Se++}return!0}e.fuzzyContains=Fe;function ye(Q,de=!1){return Q?(de&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=ye;function we(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=we;function Ee(Q,de=1){if(de===0)return"";let ge=-1;do ge=Q.indexOf(`
`,ge+1),de--;while(de>0&&ge>=0);return ge===-1?Q:(Q[ge-1]==="\r"&&ge--,Q.substr(0,ge))}e.getNLines=Ee;function ee(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}e.singleLetterHash=ee;function he(Q){return De.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=he;function fe(Q,de){return Q===0?de!==5&&de!==7:Q===2&&de===3?!1:Q===4||Q===2||Q===3||de===4||de===2||de===3?!0:!(Q===8&&(de===8||de===9||de===11||de===12)||(Q===11||Q===9)&&(de===9||de===10)||(Q===12||Q===10)&&de===10||de===5||de===13||de===7||Q===1||Q===13&&de===14||Q===6&&de===6)}var Ce;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(e.GraphemeBreakType=Ce={}));class De{static getInstance(){return De.c||(De.c=new De),De.c}constructor(){this.d=Oe()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const ge=this.d,me=ge.length/3;let Se=1;for(;Se<=me;)if(de<ge[3*Se])Se=2*Se;else if(de>ge[3*Se+1])Se=2*Se+1;else return ge[3*Se+2];return 0}}De.c=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(Q,de){if(Q===0)return 0;const ge=He(Q,de);if(ge!==void 0)return ge;const me=new F(de,Q);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=We;function He(Q,de){const ge=new F(de,Q);let me=ge.prevCodePoint();for(;$e(me)||me===65039||me===8419;){if(ge.offset===0)return;me=ge.prevCodePoint()}if(!K(me))return;let Se=ge.offset;return Se>0&&ge.prevCodePoint()===8205&&(Se=ge.offset),Se}function $e(Q){return 127995<=Q&&Q<=127999}var ze;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class qe{static getInstance(de){return qe.d.get(Array.from(de))}static getLocales(){return qe.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=qe,r=qe,qe.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.d=new E.LRUCachedFunction(Q=>{function de(Ge){const Ye=new Map;for(let tt=0;tt<Ge.length;tt+=2)Ye.set(Ge[tt],Ge[tt+1]);return Ye}function ge(Ge,Ye){const tt=new Map(Ge);for(const[ot,ct]of Ye)tt.set(ot,ct);return tt}function me(Ge,Ye){if(!Ge)return Ye;const tt=new Map;for(const[ot,ct]of Ge)Ye.has(ot)&&tt.set(ot,ct);return tt}const Se=r.c.value;let Le=Q.filter(Ge=>!Ge.startsWith("_")&&Ge in Se);Le.length===0&&(Le=["_default"]);let Ne;for(const Ge of Le){const Ye=de(Se[Ge]);Ne=me(Ne,Ye)}const Ke=de(Se._common),Ze=ge(Ke,Ne);return new qe(Ze)}),qe.e=new A.Lazy(()=>Object.keys(qe.c.value).filter(Q=>!Q.startsWith("_")));class je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(je.c())),this.d}static isInvisibleCharacter(de){return je.e().has(de)}static get codePoints(){return je.e()}}e.InvisibleCharacters=je,je.d=void 0}),define(te[32],ie([0,1,9,3,25,11]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(h){return h===47||h===92}e.isPathSeparator=M;function P(h){return h.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function f(h){return h.indexOf("/")===-1&&(h=P(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.toPosixPath=f;function l(h,g=E.posix.sep){if(!h)return"";const D=h.length,R=h.charCodeAt(0);if(M(R)){if(M(h.charCodeAt(1))&&!M(h.charCodeAt(2))){let L=3;const T=L;for(;L<D&&!M(h.charCodeAt(L));L++);if(T!==L&&!M(h.charCodeAt(L+1))){for(L+=1;L<D;L++)if(M(h.charCodeAt(L)))return h.slice(0,L+1).replace(/[\\/]/g,g)}}return g}else if(y(R)&&h.charCodeAt(1)===58)return M(h.charCodeAt(2))?h.slice(0,2)+g:h.slice(0,2);let S=h.indexOf("://");if(S!==-1){for(S+=3;S<D;S++)if(M(h.charCodeAt(S)))return h.slice(0,S+1)}return""}e.getRoot=l;function w(h){if(!A.isWindows||!h||h.length<5)return!1;let g=h.charCodeAt(0);if(g!==92||(g=h.charCodeAt(1),g!==92))return!1;let D=2;const R=D;for(;D<h.length&&(g=h.charCodeAt(D),g!==92);D++);return!(R===D||(g=h.charCodeAt(D+1),isNaN(g)||g===92))}e.isUNC=w;const m=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(h,g=A.isWindows){const D=g?m:v;return!(!h||h.length===0||/^\s+$/.test(h)||(D.lastIndex=0,D.test(h))||g&&u.test(h)||h==="."||h===".."||g&&h[h.length-1]==="."||g&&h.length!==h.trim().length||h.length>255)}e.isValidBasename=b;function p(h,g,D){const R=h===g;return!D||R?R:!h||!g?!1:(0,r.equalsIgnoreCase)(h,g)}e.isEqual=p;function s(h,g,D,R=E.sep){if(h===g)return!0;if(!h||!g||g.length>h.length)return!1;if(D){if(!(0,r.startsWithIgnoreCase)(h,g))return!1;if(g.length===h.length)return!0;let L=g.length;return g.charAt(g.length-1)===R&&L--,h.charAt(L)===R}return g.charAt(g.length-1)!==R&&(g+=R),h.indexOf(g)===0}e.isEqualOrParent=s;function y(h){return h>=65&&h<=90||h>=97&&h<=122}e.isWindowsDriveLetter=y;function a(h,g){return A.isWindows&&h.endsWith(":")&&(h+=E.sep),(0,E.isAbsolute)(h)||(h=(0,E.join)(g,h)),h=(0,E.normalize)(h),A.isWindows?(h=(0,r.rtrim)(h,E.sep),h.endsWith(":")&&(h+=E.sep)):(h=(0,r.rtrim)(h,E.sep),h||(h=E.sep)),h}e.sanitizeFilePath=a;function d(h){const g=(0,E.normalize)(h);return A.isWindows?h.length>3?!1:I(g)&&(h.length===2||g.charCodeAt(2)===92):g===E.posix.sep}e.isRootOrDriveLetter=d;function I(h,g=A.isWindows){return g?y(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.hasDriveLetter=I;function k(h,g=A.isWindows){return I(h,g)?h[0]:void 0}e.getDriveLetter=k;function t(h,g,D){return g.length>h.length?-1:h===g?0:(D&&(h=h.toLowerCase(),g=g.toLowerCase()),h.indexOf(g))}e.indexOfPath=t;function c(h){const g=h.split(":");let D,R,S;for(const L of g){const T=Number(L);(0,O.isNumber)(T)?R===void 0?R=T:S===void 0&&(S=T):D=D?[D,L].join(":"):L}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:R!==void 0?R:void 0,column:S!==void 0?S:R!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(h,g,D=8){let R="";for(let L=0;L<D;L++){let T;L===0&&A.isWindows&&!g&&(D===3||D===4)?T=i:T=n,R+=T.charAt(Math.floor(Math.random()*T.length))}let S;return g?S=`${g}-${R}`:S=R,h?(0,E.join)(h,S):S}e.randomPath=o}),define(te[56],ie([0,1,25]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(y){return r(y,0)}e.hash=A;function r(y,a){switch(typeof y){case"object":return y===null?O(349,a):Array.isArray(y)?f(y,a):l(y,a);case"string":return P(y,a);case"boolean":return M(y,a);case"number":return O(y,a);case"undefined":return O(937,a);default:return O(617,a)}}e.doHash=r;function O(y,a){return(a<<5)-a+y|0}e.numberHash=O;function M(y,a){return O(y?433:863,a)}function P(y,a){a=O(149417,a);for(let d=0,I=y.length;d<I;d++)a=O(y.charCodeAt(d),a);return a}e.stringHash=P;function f(y,a){return a=O(104579,a),y.reduce((d,I)=>r(I,d),a)}function l(y,a){return a=O(181387,a),Object.keys(y).sort().reduce((d,I)=>(d=P(I,d),r(y[I],d)),a)}class w{constructor(){this.g=0}get value(){return this.g}hash(a){return this.g=r(a,this.g),this.g}}e.Hasher=w;var m;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(m||(m={}));function v(y,a,d=32){const I=d-a,k=~((1<<I)-1);return(y<<a|(k&y)>>>I)>>>0}function u(y,a=0,d=y.byteLength,I=0){for(let k=0;k<d;k++)y[a+k]=I}function b(y,a,d="0"){for(;y.length<a;)y=d+y;return y}function p(y,a=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(d=>d.toString(16).padStart(2,"0")).join(""):b((y>>>0).toString(16),a/4)}e.toHexString=p;class s{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(a){const d=a.length;if(d===0)return;const I=this.p;let k=this.r,t=this.u,c,n;for(t!==0?(c=t,n=-1,t=0):(c=a.charCodeAt(0),n=0);;){let i=c;if(E.isHighSurrogate(c))if(n+1<d){const o=a.charCodeAt(n+1);E.isLowSurrogate(o)?(n++,i=E.computeCodePoint(c,o)):i=65533}else{t=c;break}else E.isLowSurrogate(c)&&(i=65533);if(k=this.w(I,k,i),n++,n<d)c=a.charCodeAt(n);else break}this.r=k,this.u=t}w(a,d,I){return I<128?a[d++]=I:I<2048?(a[d++]=192|(I&1984)>>>6,a[d++]=128|(I&63)>>>0):I<65536?(a[d++]=224|(I&61440)>>>12,a[d++]=128|(I&4032)>>>6,a[d++]=128|(I&63)>>>0):(a[d++]=240|(I&1835008)>>>18,a[d++]=128|(I&258048)>>>12,a[d++]=128|(I&4032)>>>6,a[d++]=128|(I&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const a=8*this.t;this.q.setUint32(56,Math.floor(a/4294967296),!1),this.q.setUint32(60,a%4294967296,!1),this.y()}y(){const a=s.g,d=this.q;for(let g=0;g<64;g+=4)a.setUint32(g,d.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)a.setUint32(g,v(a.getUint32(g-12,!1)^a.getUint32(g-32,!1)^a.getUint32(g-56,!1)^a.getUint32(g-64,!1),1),!1);let I=this.h,k=this.l,t=this.m,c=this.n,n=this.o,i,o,h;for(let g=0;g<80;g++)g<20?(i=k&t|~k&c,o=1518500249):g<40?(i=k^t^c,o=1859775393):g<60?(i=k&t|k&c|t&c,o=2400959708):(i=k^t^c,o=3395469782),h=v(I,5)+i+n+o+a.getUint32(g*4,!1)&4294967295,n=c,c=t,t=v(k,30),k=I,I=h;this.h=this.h+I&4294967295,this.l=this.l+k&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+n&4294967295}}e.StringSHA1=s,s.g=new DataView(new ArrayBuffer(320))}),define(te[72],ie([0,1,25]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(A||(A={})),function(r){const O="error",M="warning",P="warn",f="info",l="ignore";function w(v){return v?E.equalsIgnoreCase(O,v)?r.Error:E.equalsIgnoreCase(M,v)||E.equalsIgnoreCase(P,v)?r.Warning:E.equalsIgnoreCase(f,v)?r.Info:r.Ignore:r.Ignore}r.fromValue=w;function m(v){switch(v){case r.Error:return O;case r.Warning:return M;case r.Info:return f;default:return l}}r.toString=m}(A||(A={})),e.default=A}),define(te[62],ie([0,1,24,25]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class r{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const b=u.charCodeAt(0),p=this.b.charCodeAt(this.c);return b-p}value(){return this.b[this.c]}}e.StringIterator=r;class O{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,A.compareSubstring)(u,this.b,0,u.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=O;class M{constructor(u=!0,b=!0){this.f=u,this.g=b}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let b=u.length-1;b>=0;b--,this.c--){const p=this.b.charCodeAt(b);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===47||this.f&&b===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,A.compareSubstring)(u,this.b,0,u.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=M;var P;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(P||(P={}));class f{constructor(u,b){this.f=u,this.g=b,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(u,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,A.compare)(u,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=f;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(w||(w={}));class m{static forUris(u=()=>!1,b=()=>!1){return new m(new f(u,b))}static forPaths(u=!1){return new m(new M(void 0,!u))}static forStrings(){return new m(new r)}static forConfigKeys(){return new m(new O)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,b){if(b){const p=b.slice(0);(0,E.shuffle)(p);for(const s of p)this.set(s,u)}else{const p=u.slice(0);(0,E.shuffle)(p);for(const s of p)this.set(s[0],s[1])}}set(u,b){const p=this.b.reset(u);let s;this.c||(this.c=new l,this.c.segment=p.value());const y=[];for(s=this.c;;){const d=p.cmp(s.segment);if(d>0)s.left||(s.left=new l,s.left.segment=p.value()),y.push([-1,s]),s=s.left;else if(d<0)s.right||(s.right=new l,s.right.segment=p.value()),y.push([1,s]),s=s.right;else if(p.hasNext())p.next(),s.mid||(s.mid=new l,s.mid.segment=p.value()),y.push([0,s]),s=s.mid;else break}const a=s.value;s.value=b,s.key=u;for(let d=y.length-1;d>=0;d--){const I=y[d][1];I.updateHeight();const k=I.balanceFactor();if(k<-1||k>1){const t=y[d][0],c=y[d+1][0];if(t===1&&c===1)y[d][1]=I.rotateLeft();else if(t===-1&&c===-1)y[d][1]=I.rotateRight();else if(t===1&&c===-1)I.right=y[d+1][1]=y[d+1][1].rotateRight(),y[d][1]=I.rotateLeft();else if(t===-1&&c===1)I.left=y[d+1][1]=y[d+1][1].rotateLeft(),y[d][1]=I.rotateRight();else throw new Error;if(d>0)switch(y[d-1][0]){case-1:y[d-1][1].left=y[d][1];break;case 1:y[d-1][1].right=y[d][1];break;case 0:y[d-1][1].mid=y[d][1];break}else this.c=y[0][1]}}return a}get(u){return this.d(u)?.value}d(u){const b=this.b.reset(u);let p=this.c;for(;p;){const s=b.cmp(p.segment);if(s>0)p=p.left;else if(s<0)p=p.right;else if(b.hasNext())b.next(),p=p.mid;else break}return p}has(u){const b=this.d(u);return!(b?.value===void 0&&b?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,b){const p=this.b.reset(u),s=[];let y=this.c;for(;y;){const a=p.cmp(y.segment);if(a>0)s.push([-1,y]),y=y.left;else if(a<0)s.push([1,y]),y=y.right;else if(p.hasNext())p.next(),s.push([0,y]),y=y.mid;else break}if(y){if(b?(y.left=void 0,y.mid=void 0,y.right=void 0,y.height=1):(y.key=void 0,y.value=void 0),!y.mid&&!y.value)if(y.left&&y.right){const a=this.f(y.right);if(a.key){const{key:d,value:I,segment:k}=a;this.e(a.key,!1),y.key=d,y.value=I,y.segment=k}}else{const a=y.left??y.right;if(s.length>0){const[d,I]=s[s.length-1];switch(d){case-1:I.left=a;break;case 0:I.mid=a;break;case 1:I.right=a;break}}else this.c=a}for(let a=s.length-1;a>=0;a--){const d=s[a][1];d.updateHeight();const I=d.balanceFactor();if(I>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),s[a][1]=d.rotateLeft()):I<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),s[a][1]=d.rotateRight()),a>0)switch(s[a-1][0]){case-1:s[a-1][1].left=s[a][1];break;case 1:s[a-1][1].right=s[a][1];break;case 0:s[a-1][1].mid=s[a][1];break}else this.c=s[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const b=this.b.reset(u);let p=this.c,s;for(;p;){const y=b.cmp(p.segment);if(y>0)p=p.left;else if(y<0)p=p.right;else if(b.hasNext())b.next(),s=p.value||s,p=p.mid;else break}return p&&p.value||s}findSuperstr(u){return this.g(u,!1)}g(u,b){const p=this.b.reset(u);let s=this.c;for(;s;){const y=p.cmp(s.segment);if(y>0)s=s.left;else if(y<0)s=s.right;else if(p.hasNext())p.next(),s=s.mid;else return s.mid?this.h(s.mid):b?s.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[b,p]of this)u(p,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const b=[];return this.j(u,b),b[Symbol.iterator]()}j(u,b){u&&(u.left&&this.j(u.left,b),u.value&&b.push([u.key,u.value]),u.mid&&this.j(u.mid,b),u.right&&this.j(u.right,b))}_isBalanced(){const u=b=>{if(!b)return!0;const p=b.balanceFactor();return p<-1||p>1?!1:u(b.left)&&u(b.right)};return u(this.c)}}e.TernarySearchTree=m}),define(te[8],ie([0,1,9,3]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,O=/^\//,M=/^\/\//;function P(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!r.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!O.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,o){return!i&&!o?"file":i}function l(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==m&&(o=m+o):o=m;break}return o}const w="",m="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(o){return o instanceof u?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,h,g,D,R,S=!1){typeof o=="object"?(this.scheme=o.scheme||w,this.authority=o.authority||w,this.path=o.path||w,this.query=o.query||w,this.fragment=o.fragment||w):(this.scheme=f(o,S),this.authority=h||w,this.path=l(this.scheme,g||w),this.query=D||w,this.fragment=R||w,P(this,S))}get fsPath(){return I(this,!1)}with(o){if(!o)return this;let{scheme:h,authority:g,path:D,query:R,fragment:S}=o;return h===void 0?h=this.scheme:h===null&&(h=w),g===void 0?g=this.authority:g===null&&(g=w),D===void 0?D=this.path:D===null&&(D=w),R===void 0?R=this.query:R===null&&(R=w),S===void 0?S=this.fragment:S===null&&(S=w),h===this.scheme&&g===this.authority&&D===this.path&&R===this.query&&S===this.fragment?this:new s(h,g,D,R,S)}static parse(o,h=!1){const g=v.exec(o);return g?new s(g[2]||w,n(g[4]||w),n(g[5]||w),n(g[7]||w),n(g[9]||w),h):new s(w,w,w,w,w)}static file(o){let h=w;if(A.isWindows&&(o=o.replace(/\\/g,m)),o[0]===m&&o[1]===m){const g=o.indexOf(m,2);g===-1?(h=o.substring(2),o=m):(h=o.substring(2,g),o=o.substring(g)||m)}return new s("file",h,o,w,w)}static from(o,h){return new s(o.scheme,o.authority,o.path,o.query,o.fragment,h)}static joinPath(o,...h){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return A.isWindows&&o.scheme==="file"?g=u.file(E.win32.join(I(o,!0),...h)).path:g=E.posix.join(o.path,...h),o.with({path:g})}toString(o=!1){return k(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof u)return o;{const h=new s(o);return h._formatted=o.external??null,h._fsPath=o._sep===p?o.fsPath??null:null,h}}else return o}}e.URI=u;function b(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=b;const p=A.isWindows?1:void 0;class s extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=I(this,!1)),this._fsPath}toString(o=!1){return o?k(this,!0):(this._formatted||(this._formatted=k(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=p),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(i,o,h){let g,D=-1;for(let R=0;R<i.length;R++){const S=i.charCodeAt(R);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||o&&S===47||h&&S===91||h&&S===93||h&&S===58)D!==-1&&(g+=encodeURIComponent(i.substring(D,R)),D=-1),g!==void 0&&(g+=i.charAt(R));else{g===void 0&&(g=i.substr(0,R));const L=y[S];L!==void 0?(D!==-1&&(g+=encodeURIComponent(i.substring(D,R)),D=-1),g+=L):D===-1&&(D=R)}}return D!==-1&&(g+=encodeURIComponent(i.substring(D))),g!==void 0?g:i}function d(i){let o;for(let h=0;h<i.length;h++){const g=i.charCodeAt(h);g===35||g===63?(o===void 0&&(o=i.substr(0,h)),o+=y[g]):o!==void 0&&(o+=i[h])}return o!==void 0?o:i}function I(i,o){let h;return i.authority&&i.path.length>1&&i.scheme==="file"?h=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?h=i.path.substr(1):h=i.path[1].toLowerCase()+i.path.substr(2):h=i.path,A.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=I;function k(i,o){const h=o?d:a;let g="",{scheme:D,authority:R,path:S,query:L,fragment:T}=i;if(D&&(g+=D,g+=":"),(R||D==="file")&&(g+=m,g+=m),R){let U=R.indexOf("@");if(U!==-1){const H=R.substr(0,U);R=R.substr(U+1),U=H.lastIndexOf(":"),U===-1?g+=h(H,!1,!1):(g+=h(H.substr(0,U),!1,!1),g+=":",g+=h(H.substr(U+1),!1,!0)),g+="@"}R=R.toLowerCase(),U=R.lastIndexOf(":"),U===-1?g+=h(R,!1,!0):(g+=h(R.substr(0,U),!1,!0),g+=R.substr(U))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const U=S.charCodeAt(1);U>=65&&U<=90&&(S=`/${String.fromCharCode(U+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const U=S.charCodeAt(0);U>=65&&U<=90&&(S=`${String.fromCharCode(U+32)}:${S.substr(2)}`)}g+=h(S,!0,!1)}return L&&(g+="?",g+=h(L,!1,!1)),T&&(g+="#",g+=o?T:a(T,!1,!1)),g}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(c)?i.replace(c,o=>t(o)):i}}),define(te[152],ie([0,1,8]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(l){const w=l;return w&&typeof w.type=="string"&&typeof w.severity=="string"}e.isRemoteConsoleLog=A;function r(l){const w=[];let m;try{const v=JSON.parse(l.arguments),u=v[v.length-1];u&&u.__$stack&&(v.pop(),m=u.__$stack),w.push(...v)}catch{w.push("Unable to log remote console arguments",l.arguments)}return{args:w,stack:m}}e.parse=r;function O(l){if(typeof l!="string")return O(r(l).stack);const w=l;if(w){const m=M(w),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(v&&v.length===4)return{uri:E.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=O;function M(l){if(!l)return l;const w=l.indexOf(`
`);return w===-1?l:l.substring(0,w)}function P(l,w){const{args:m,stack:v}=r(l),u=typeof m[0]=="string"&&m.length===1;let b=M(v);b&&(b=`(${b.trim()})`);let p=[];if(typeof m[0]=="string"?b&&u?p=[`%c[${w}] %c${m[0]} %c${b}`,f("blue"),f(""),f("grey")]:p=[`%c[${w}] %c${m[0]}`,f("blue"),f(""),...m.slice(1)]:p=[`%c[${w}]%`,f("blue"),...m],b&&!u&&p.push(b),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,p)}e.log=P;function f(l){return`color: ${l}`}}),define(te[73],ie([0,1,17,25,8]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function O(l){return JSON.stringify(l,P)}e.stringify=O;function M(l){let w=JSON.parse(l);return w=f(w),w}e.parse=M;function P(l,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,A.regExpFlags)(w)}:w}function f(l,w=0){if(!l||w>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return r.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof E.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let m=0;m<l.length;++m)l[m]=f(l[m],w+1);else for(const m in l)Object.hasOwnProperty.call(l,m)&&(l[m]=f(l[m],w+1))}return l}e.revive=f}),define(te[14],ie([0,1,13,3,8]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var O;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractive="vscode-interactive",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(w){this.d=w}setDelegate(w){this.e=w}setServerRootPath(w){this.f=`${w}/${O.vscodeRemoteResource}`}set(w,m,v){this.a[w]=m,this.b[w]=v}setConnectionToken(w,m){this.c[w]=m}getPreferredWebSchema(){return this.d}rewrite(w){if(this.e)try{return this.e(w)}catch(s){return E.onUnexpectedError(s),w}const m=w.authority;let v=this.a[m];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const u=this.b[m],b=this.c[m];let p=`path=${encodeURIComponent(w.path)}`;return typeof b=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(b)}`),r.URI.from({scheme:A.isWeb?this.d:O.vscodeRemoteResource,authority:`${v}:${u}`,path:this.f,query:p})}}e.RemoteAuthorities=new M,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(w){const m=this.b(w,x);return this.uriToBrowserUri(m)}uriToBrowserUri(w){return w.scheme===O.vscodeRemote?e.RemoteAuthorities.rewrite(w):w.scheme===O.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${O.vscodeFileResource}://${P.a}`)?w.with({scheme:O.vscodeFileResource,authority:w.authority||P.a,query:null,fragment:null}):w}asFileUri(w){const m=this.b(w,x);return this.uriToFileUri(m)}uriToFileUri(w){return w.scheme===O.vscodeFileResource?w.with({scheme:O.file,authority:w.authority!==P.a?w.authority:null,query:null,fragment:null}):w}b(w,m){return r.URI.isUri(w)?w:r.URI.parse(m.toUrl(w))}}P.a="vscode-app",e.FileAccess=new P;var f;(function(l){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(w.get("3"));const m="vscode-coi";function v(b){let p;typeof b=="string"?p=new URL(b).searchParams:b instanceof URL?p=b.searchParams:r.URI.isUri(b)&&(p=new URL(b.toString(!0)).searchParams);const s=p?.get(m);if(s)return w.get(s)}l.getHeadersFromQuery=v;function u(b,p,s){if(!globalThis.crossOriginIsolated)return;const y=p&&s?"3":s?"2":"1";b instanceof URLSearchParams?b.set(m,y):b[m]=y}l.addSearchParam=u})(f||(e.COI=f={}))}),define(te[18],ie([0,1,32,14,9,3,25,8]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(u){return(0,P.uriToFsPath)(u,!0)}e.originalFSPath=f;class l{constructor(b){this.a=b}compare(b,p,s=!1){return b===p?0:(0,M.compare)(this.getComparisonKey(b,s),this.getComparisonKey(p,s))}isEqual(b,p,s=!1){return b===p?!0:!b||!p?!1:this.getComparisonKey(b,s)===this.getComparisonKey(p,s)}getComparisonKey(b,p=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,p,s=!1){if(b.scheme===p.scheme){if(b.scheme===A.Schemas.file)return E.isEqualOrParent(f(b),f(p),this.a(b))&&b.query===p.query&&(s||b.fragment===p.fragment);if((0,e.isEqualAuthority)(b.authority,p.authority))return E.isEqualOrParent(b.path,p.path,this.a(b),"/")&&b.query===p.query&&(s||b.fragment===p.fragment)}return!1}joinPath(b,...p){return P.URI.joinPath(b,...p)}basenameOrAuthority(b){return(0,e.basename)(b)||b.authority}basename(b){return r.posix.basename(b.path)}extname(b){return r.posix.extname(b.path)}dirname(b){if(b.path.length===0)return b;let p;return b.scheme===A.Schemas.file?p=P.URI.file(r.dirname(f(b))).path:(p=r.posix.dirname(b.path),b.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),p="/")),b.with({path:p})}normalizePath(b){if(!b.path.length)return b;let p;return b.scheme===A.Schemas.file?p=P.URI.file(r.normalize(f(b))).path:p=r.posix.normalize(b.path),b.with({path:p})}relativePath(b,p){if(b.scheme!==p.scheme||!(0,e.isEqualAuthority)(b.authority,p.authority))return;if(b.scheme===A.Schemas.file){const a=r.relative(f(b),f(p));return O.isWindows?E.toSlashes(a):a}let s=b.path||"/";const y=p.path||"/";if(this.a(b)){let a=0;for(const d=Math.min(s.length,y.length);a<d&&!(s.charCodeAt(a)!==y.charCodeAt(a)&&s.charAt(a).toLowerCase()!==y.charAt(a).toLowerCase());a++);s=y.substr(0,a)+s.substr(a)}return r.posix.relative(s,y)}resolvePath(b,p){if(b.scheme===A.Schemas.file){const s=P.URI.file(r.resolve(f(b),p));return b.with({authority:s.authority,path:s.path})}return p=E.toPosixPath(p),b.with({path:r.posix.resolve(b.path,p)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,p){return b===p||b!==void 0&&p!==void 0&&(0,M.equalsIgnoreCase)(b,p)}hasTrailingPathSeparator(b,p=r.sep){if(b.scheme===A.Schemas.file){const s=f(b);return s.length>E.getRoot(s).length&&s[s.length-1]===p}else{const s=b.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,p=r.sep){return(0,e.hasTrailingPathSeparator)(b,p)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,p=r.sep){let s=!1;if(b.scheme===A.Schemas.file){const y=f(b);s=y!==void 0&&y.length===E.getRoot(y).length&&y[y.length-1]===p}else{p="/";const y=b.path;s=y.length===1&&y.charCodeAt(y.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(b,p)?b.with({path:b.path+"/"}):b}}e.ExtUri=l,e.extUri=new l(()=>!1),e.extUriBiasedIgnorePathCase=new l(u=>u.scheme===A.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new l(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function w(u,b){const p=[];for(let s=0;s<u.length;s++){const y=b(u[s]);u.some((a,d)=>d===s?!1:(0,e.isEqualOrParent)(y,b(a)))||p.push(u[s])}return p}e.distinctParents=w;var m;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function b(p){const s=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(d=>{const[I,k]=d.split(":");I&&k&&s.set(I,k)});const a=p.path.substring(0,p.path.indexOf(";"));return a&&s.set(u.META_DATA_MIME,a),s}u.parseMetaData=b})(m||(e.DataUri=m={}));function v(u,b,p){if(b){let s=u.path;return s&&s[0]!==r.posix.sep&&(s=r.posix.sep+s),u.with({scheme:p,authority:b,path:s})}return u.with({scheme:p})}e.toLocalResource=v}),define(te[7],ie([0,1,21,13,4,2,18,3,139]),function(x,e,E,A,r,O,M,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function l(B){return!!B&&typeof B.then=="function"}e.isThenable=l;function w(B){const C=new E.CancellationTokenSource,W=B(C.token),z=new Promise((q,j)=>{const $=C.token.onCancellationRequested(()=>{$.dispose(),C.dispose(),j(new A.CancellationError)});Promise.resolve(W).then(K=>{$.dispose(),C.dispose(),q(K)},K=>{$.dispose(),C.dispose(),j(K)})});return new class{cancel(){C.cancel()}then(q,j){return z.then(q,j)}catch(q){return this.then(void 0,q)}finally(q){return z.finally(q)}}}e.createCancelablePromise=w;function m(B,C,W){return new Promise((z,q)=>{const j=C.onCancellationRequested(()=>{j.dispose(),z(W)});B.then(z,q).finally(()=>j.dispose())})}e.raceCancellation=m;function v(B,C){return new Promise((W,z)=>{const q=C.onCancellationRequested(()=>{q.dispose(),z(new A.CancellationError)});B.then(W,z).finally(()=>q.dispose())})}e.raceCancellationError=v;async function u(B){let C=-1;const W=B.map((z,q)=>z.then(j=>(C=q,j)));try{return await Promise.race(W)}finally{B.forEach((z,q)=>{q!==C&&z.cancel()})}}e.raceCancellablePromises=u;function b(B,C,W){let z;const q=setTimeout(()=>{z?.(void 0),W?.()},C);return Promise.race([B.finally(()=>clearTimeout(q)),new Promise(j=>z=j)])}e.raceTimeout=b;function p(B){return new Promise((C,W)=>{const z=B();l(z)?z.then(C,W):C(z)})}e.asPromise=p;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(C){if(this.a){if(this.d=C,!this.b){const W=()=>{this.b=null;const z=this.queue(this.d);return this.d=null,z};this.b=new Promise(z=>{this.a.then(W,W).then(z)})}return new Promise((W,z)=>{this.b.then(W,z)})}return this.a=C(),new Promise((W,z)=>{this.a.then(q=>{this.a=null,W(q)},q=>{this.a=null,z(q)})})}}e.Throttler=s;class y{constructor(){this.a=Promise.resolve(null)}queue(C){return this.a=this.a.then(()=>C(),()=>C())}}e.Sequencer=y;class a{constructor(){this.a=new Map}queue(C,W){const q=(this.a.get(C)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.a.get(C)===q&&this.a.delete(C)});return this.a.set(C,q),q}}e.SequencerByKey=a;const d=(B,C)=>{let W=!0;const z=setTimeout(()=>{W=!1,C()},B);return{isTriggered:()=>W,dispose:()=>{clearTimeout(z),W=!1}}},I=B=>{let C=!0;return queueMicrotask(()=>{C&&(C=!1,B())}),{isTriggered:()=>C,dispose:()=>{C=!1}}};class k{constructor(C){this.defaultDelay=C,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(C,W=this.defaultDelay){this.g=C,this.h(),this.b||(this.b=new Promise((q,j)=>{this.d=q,this.f=j}).then(()=>{if(this.b=null,this.d=null,this.g){const q=this.g;return this.g=null,q()}}));const z=()=>{this.a=null,this.d?.(null)};return this.a=W===f.MicrotaskDelay?I(z):d(W,z),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=k;class t{constructor(C){this.a=new k(C),this.b=new s}trigger(C,W){return this.a.trigger(()=>this.b.queue(C),W)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class c{constructor(){this.a=!1,this.b=new Promise((C,W)=>{this.d=C})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=c;class n extends c{constructor(C){super(),this.f=setTimeout(()=>this.open(),C)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=n;function i(B,C){return C?new Promise((W,z)=>{const q=setTimeout(()=>{j.dispose(),W()},B),j=C.onCancellationRequested(()=>{clearTimeout(q),j.dispose(),z(new A.CancellationError)})}):w(W=>i(B,W))}e.timeout=i;function o(B,C=0){const W=setTimeout(B,C);return(0,O.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=o;function h(B){const C=[];let W=0;const z=B.length;function q(){return W<z?B[W++]():null}function j($){$!=null&&C.push($);const K=q();return K?K.then(j):Promise.resolve(C)}return Promise.resolve(null).then(j)}e.sequence=h;function g(B,C=z=>!!z,W=null){let z=0;const q=B.length,j=()=>{if(z>=q)return Promise.resolve(W);const $=B[z++];return Promise.resolve($()).then(se=>C(se)?Promise.resolve(se):j())};return j()}e.first=g;function D(B,C=z=>!!z,W=null){if(B.length===0)return Promise.resolve(W);let z=B.length;const q=()=>{z=-1;for(const j of B)j.cancel?.()};return new Promise((j,$)=>{for(const K of B)K.then(se=>{--z>=0&&C(se)?(q(),j(se)):z===0&&j(W)}).catch(se=>{--z>=0&&(q(),$(se))})})}e.firstParallel=D;class R{constructor(C){this.a=0,this.d=C,this.f=[],this.b=0,this.g=new r.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(C){return this.a++,new Promise((W,z)=>{this.f.push({factory:C,c:W,e:z}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const C=this.f.shift();this.b++;const W=C.factory();W.then(C.c,C.e),W.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=R;class S extends R{constructor(){super(1)}}e.Queue=S;class L{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const C=new F;return this.b.add(C),C.p}d(){for(const[,C]of this.a)if(C.size>0)return!1;return!0}queueFor(C,W=M.extUri){const z=W.getComparisonKey(C);let q=this.a.get(z);return q||(q=new S,r.Event.once(q.onDrained)(()=>{q?.dispose(),this.a.delete(z),this.f()}),this.a.set(z,q)),q}f(){this.d()&&this.g()}g(){for(const C of this.b)C.complete();this.b.clear()}dispose(){for(const[,C]of this.a)C.dispose();this.a.clear(),this.g()}}e.ResourceQueue=L;class T{constructor(C,W){this.a=-1,typeof C=="function"&&typeof W=="number"&&this.setIfNotSet(C,W)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(C,W){this.cancel(),this.a=setTimeout(()=>{this.a=-1,C()},W)}setIfNotSet(C,W){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,C()},W))}}e.TimeoutTimer=T;class U{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(C,W){this.cancel(),this.a=setInterval(()=>{C()},W)}}e.IntervalTimer=U;class H{constructor(C,W){this.b=-1,this.a=C,this.d=W,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(C=this.d){this.cancel(),this.b=setTimeout(this.f,C)}get delay(){return this.d}set delay(C){this.d=C}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=H;class re{constructor(C,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.a=C,this.b=W,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(C=this.b){C%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${C}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(C/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=re;class Y extends H{constructor(C,W){super(C,W),this.j=[]}work(C){this.j.push(C),this.isScheduled()||this.schedule()}h(){const C=this.j;this.j=[],this.a?.(C)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=Y;class ne extends O.Disposable{constructor(C,W){super(),this.g=C,this.h=W,this.a=[],this.b=this.B(new O.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(C){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+C.length>this.g.maxBufferedWork)return!1}else if(this.pending+C.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const W of C)this.a.push(W);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new H(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,P.setTimeout0)(()=>{if(C)return;const W=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let C=!1;return{dispose(){C||(C=!0)}}}:e.runWhenIdle=(B,C)=>{const W=requestIdleCallback(B,typeof C=="number"?{timeout:C}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(W))}}}}();class ce{constructor(C){this.d=!1,this.a=()=>{try{this.f=C()}catch(W){this.g=W}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ce;async function le(B,C,W){let z;for(let q=0;q<W;q++)try{return await B()}catch(j){z=j,await i(C)}throw z}e.retry=le;class X{hasPending(C){return this.a?typeof C=="number"?this.a.taskId===C:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(C,W,z){return this.a={taskId:C,cancel:()=>z?.(),promise:W},W.then(()=>this.d(C),()=>this.d(C)),W}d(C){this.a&&C===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const C=this.b;this.b=void 0,C.run().then(C.promiseResolve,C.promiseReject)}}setNext(C){if(this.b)this.b.run=C;else{let W,z;const q=new Promise((j,$)=>{W=j,z=$});this.b={run:C,promise:q,promiseResolve:W,promiseReject:z}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=X;class G{constructor(C,W=()=>Date.now()){this.d=C,this.f=W,this.a=0,this.b=0}increment(){const C=this.f();return C-this.a>this.d&&(this.a=C,this.b=0),this.b++,this.b}}e.IntervalCounter=G;var N;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(N||(N={}));class F{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((C,W)=>{this.a=C,this.b=W})}complete(C){return new Promise(W=>{this.a(C),this.d={outcome:0,value:C},W()})}error(C){return new Promise(W=>{this.b(C),this.d={outcome:1,value:C},W()})}cancel(){return this.error(new A.CancellationError)}}e.DeferredPromise=F;var V;(function(B){async function C(z){let q;const j=await Promise.all(z.map($=>$.then(K=>K,K=>{q||(q=K)})));if(typeof q<"u")throw q;return j}B.settled=C;function W(z){return new Promise(async(q,j)=>{try{await z(q,j)}catch($){j($)}})}B.withAsyncBody=W})(V||(e.Promises=V={}));var J;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(J||(J={}));class _{static fromArray(C){return new _(W=>{W.emitMany(C)})}static fromPromise(C){return new _(async W=>{W.emitMany(await C)})}static fromPromises(C){return new _(async W=>{await Promise.all(C.map(async z=>W.emitOne(await z)))})}static merge(C){return new _(async W=>{await Promise.all(C.map(async z=>{for await(const q of z)W.emitOne(q)}))})}constructor(C){this.a=0,this.b=[],this.d=null,this.f=new r.Emitter,queueMicrotask(async()=>{const W={emitOne:z=>this.g(z),emitMany:z=>this.h(z),reject:z=>this.k(z)};try{await Promise.resolve(C(W)),this.j()}catch(z){this.k(z)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let C=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(C<this.b.length)return{done:!1,value:this.b[C++]};if(this.a===1)return{done:!0,value:void 0};await r.Event.toPromise(this.f.event)}while(!0)}}}static map(C,W){return new _(async z=>{for await(const q of C)z.emitOne(W(q))})}map(C){return _.map(this,C)}static filter(C,W){return new _(async z=>{for await(const q of C)W(q)&&z.emitOne(q)})}filter(C){return _.filter(this,C)}static coalesce(C){return _.filter(C,W=>!!W)}coalesce(){return _.coalesce(this)}static async toPromise(C){const W=[];for await(const z of C)W.push(z);return W}toPromise(){return _.toPromise(this)}g(C){this.a===0&&(this.b.push(C),this.f.fire())}h(C){this.a===0&&(this.b=this.b.concat(C),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(C){this.a===0&&(this.a=2,this.d=C,this.f.fire())}}e.AsyncIterableObject=_,_.EMPTY=_.fromArray([]);class ae extends _{constructor(C,W){super(W),this.l=C}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ae;function oe(B){const C=new E.CancellationTokenSource,W=B(C.token);return new ae(C,async z=>{const q=C.token.onCancellationRequested(()=>{q.dispose(),C.dispose(),z.reject(new A.CancellationError)});try{for await(const j of W){if(C.token.isCancellationRequested)return;z.emitOne(j)}q.dispose(),C.dispose()}catch(j){q.dispose(),C.dispose(),z.reject(j)}})}e.createCancelableAsyncIterable=oe}),define(te[104],ie([0,1,24,7,32,35,9,3,25]),function(x,e,E,A,r,O,M,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function l(){return Object.create(null)}e.getEmptyExpression=l,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const w="[/\\\\]",m="[^/\\\\]",v=/\//g;function u(G,N){switch(G){case 0:return"";case 1:return`${m}*?`;default:return`(?:${w}|${m}+${w}${N?`|${w}${m}+`:""})*?`}}function b(G,N){if(!G)return[];const F=[];let V=!1,J=!1,_="";for(const ae of G){switch(ae){case N:if(!V&&!J){F.push(_),_="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":J=!0;break;case"]":J=!1;break}_+=ae}return _&&F.push(_),F}e.splitGlobAware=b;function p(G){if(!G)return"";let N="";const F=b(G,e.GLOB_SPLIT);if(F.every(V=>V===e.GLOBSTAR))N=".*";else{let V=!1;F.forEach((J,_)=>{if(J===e.GLOBSTAR){if(V)return;N+=u(2,_===F.length-1)}else{let ae=!1,oe="",B=!1,C="";for(const W of J){if(W!=="}"&&ae){oe+=W;continue}if(B&&(W!=="]"||!C)){let z;W==="-"?z=W:(W==="^"||W==="!")&&!C?z="^":W===e.GLOB_SPLIT?z="":z=(0,f.escapeRegExpCharacters)(W),C+=z;continue}switch(W){case"{":ae=!0;continue;case"[":B=!0;continue;case"}":{const q=`(?:${b(oe,",").map(j=>p(j)).join("|")})`;N+=q,ae=!1,oe="";break}case"]":{N+="["+C+"]",B=!1,C="";break}case"?":N+=m;continue;case"*":N+=u(1);continue;default:N+=(0,f.escapeRegExpCharacters)(W)}}_<F.length-1&&(F[_+1]!==e.GLOBSTAR||_+2<F.length)&&(N+=w)}V=J===e.GLOBSTAR})}return N}const s=/^\*\*\/\*\.[\w\.-]+$/,y=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,I=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.LRUCache(1e4),c=function(){return!1},n=function(){return null};function i(G,N){if(!G)return n;let F;typeof G!="string"?F=G.pattern:F=G,F=F.trim();const V=`${F}_${!!N.trimForExclusions}`;let J=t.get(V);if(J)return o(J,G);let _;return s.test(F)?J=g(F.substr(4),F):(_=y.exec(h(F,N)))?J=D(_[1],F):(N.trimForExclusions?d:a).test(F)?J=R(F,N):(_=I.exec(h(F,N)))?J=S(_[1].substr(1),F,!0):(_=k.exec(h(F,N)))?J=S(_[1],F,!1):J=L(F),t.set(V,J),o(J,G)}function o(G,N){if(typeof N=="string")return G;const F=function(V,J){return(0,r.isEqualOrParent)(V,N.base,!P.isLinux)?G((0,f.ltrim)(V.substr(N.base.length),M.sep),J):null};return F.allBasenames=G.allBasenames,F.allPaths=G.allPaths,F.basenames=G.basenames,F.patterns=G.patterns,F}function h(G,N){return N.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function g(G,N){return function(F,V){return typeof F=="string"&&F.endsWith(G)?N:null}}function D(G,N){const F=`/${G}`,V=`\\${G}`,J=function(ae,oe){return typeof ae!="string"?null:oe?oe===G?N:null:ae===G||ae.endsWith(F)||ae.endsWith(V)?N:null},_=[G];return J.basenames=_,J.patterns=[N],J.allBasenames=_,J}function R(G,N){const F=le(G.slice(1,-1).split(",").map(oe=>i(oe,N)).filter(oe=>oe!==n),G),V=F.length;if(!V)return n;if(V===1)return F[0];const J=function(oe,B){for(let C=0,W=F.length;C<W;C++)if(F[C](oe,B))return G;return null},_=F.find(oe=>!!oe.allBasenames);_&&(J.allBasenames=_.allBasenames);const ae=F.reduce((oe,B)=>B.allPaths?oe.concat(B.allPaths):oe,[]);return ae.length&&(J.allPaths=ae),J}function S(G,N,F){const V=M.sep===M.posix.sep,J=V?G:G.replace(v,M.sep),_=M.sep+J,ae=M.posix.sep+G;let oe;return F?oe=function(B,C){return typeof B=="string"&&(B===J||B.endsWith(_)||!V&&(B===G||B.endsWith(ae)))?N:null}:oe=function(B,C){return typeof B=="string"&&(B===J||!V&&B===G)?N:null},oe.allPaths=[(F?"*/":"./")+G],oe}function L(G){try{const N=new RegExp(`^${p(G)}$`);return function(F){return N.lastIndex=0,typeof F=="string"&&N.test(F)?G:null}}catch{return n}}function T(G,N,F){return!G||typeof N!="string"?!1:U(G)(N,void 0,F)}e.match=T;function U(G,N={}){if(!G)return c;if(typeof G=="string"||H(G)){const F=i(G,N);if(F===n)return c;const V=function(J,_){return!!F(J,_)};return F.allBasenames&&(V.allBasenames=F.allBasenames),F.allPaths&&(V.allPaths=F.allPaths),V}return ne(G,N)}e.parse=U;function H(G){const N=G;return N?typeof N.base=="string"&&typeof N.pattern=="string":!1}e.isRelativePattern=H;function re(G){return G.allBasenames||[]}e.getBasenameTerms=re;function Y(G){return G.allPaths||[]}e.getPathTerms=Y;function ne(G,N){const F=le(Object.getOwnPropertyNames(G).map(oe=>ce(oe,G[oe],N)).filter(oe=>oe!==n)),V=F.length;if(!V)return n;if(!F.some(oe=>!!oe.requiresSiblings)){if(V===1)return F[0];const oe=function(W,z){let q;for(let j=0,$=F.length;j<$;j++){const K=F[j](W,z);if(typeof K=="string")return K;(0,A.isThenable)(K)&&(q||(q=[]),q.push(K))}return q?(async()=>{for(const j of q){const $=await j;if(typeof $=="string")return $}return null})():null},B=F.find(W=>!!W.allBasenames);B&&(oe.allBasenames=B.allBasenames);const C=F.reduce((W,z)=>z.allPaths?W.concat(z.allPaths):W,[]);return C.length&&(oe.allPaths=C),oe}const J=function(oe,B,C){let W,z;for(let q=0,j=F.length;q<j;q++){const $=F[q];$.requiresSiblings&&C&&(B||(B=(0,M.basename)(oe)),W||(W=B.substr(0,B.length-(0,M.extname)(oe).length)));const K=$(oe,B,W,C);if(typeof K=="string")return K;(0,A.isThenable)(K)&&(z||(z=[]),z.push(K))}return z?(async()=>{for(const q of z){const j=await q;if(typeof j=="string")return j}return null})():null},_=F.find(oe=>!!oe.allBasenames);_&&(J.allBasenames=_.allBasenames);const ae=F.reduce((oe,B)=>B.allPaths?oe.concat(B.allPaths):oe,[]);return ae.length&&(J.allPaths=ae),J}function ce(G,N,F){if(N===!1)return n;const V=i(G,F);if(V===n)return n;if(typeof N=="boolean")return V;if(N){const J=N.when;if(typeof J=="string"){const _=(ae,oe,B,C)=>{if(!C||!V(ae,oe))return null;const W=J.replace("$(basename)",()=>B),z=C(W);return(0,A.isThenable)(z)?z.then(q=>q?G:null):z?G:null};return _.requiresSiblings=!0,_}}return V}function le(G,N){const F=G.filter(oe=>!!oe.basenames);if(F.length<2)return G;const V=F.reduce((oe,B)=>{const C=B.basenames;return C?oe.concat(C):oe},[]);let J;if(N){J=[];for(let oe=0,B=V.length;oe<B;oe++)J.push(N)}else J=F.reduce((oe,B)=>{const C=B.patterns;return C?oe.concat(C):oe},[]);const _=function(oe,B){if(typeof oe!="string")return null;if(!B){let W;for(W=oe.length;W>0;W--){const z=oe.charCodeAt(W-1);if(z===47||z===92)break}B=oe.substr(W)}const C=V.indexOf(B);return C!==-1?J[C]:null};_.basenames=V,_.patterns=J,_.allBasenames=V;const ae=G.filter(oe=>!oe.basenames);return ae.push(_),ae}function X(G,N){return(0,E.equals)(G,N,(F,V)=>typeof F=="string"&&typeof V=="string"?F===V:typeof F!="string"&&typeof V!="string"?F.base===V.base&&F.pattern===V.pattern:!1)}e.patternsEquals=X}),define(te[45],ie([0,1,24,32,9,3,18,25]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function f(i,o){const{os:h,tildify:g,relative:D}=o;if(D){const L=l(i,D,h);if(typeof L=="string")return L}let R=i.fsPath;if(h===1&&!O.isWindows?R=R.replace(/\//g,"\\"):h!==1&&O.isWindows&&(R=R.replace(/\\/g,"/")),h!==1&&g?.userHome){const L=g.userHome.fsPath;let T;i.scheme!==g.userHome.scheme&&i.path.startsWith(r.posix.sep)?T=g.userHome.with({path:i.path}).fsPath:T=i.fsPath,R=v(T,L,h)}return(h===1?r.win32:r.posix).normalize(w(R,h===1))}e.getPathLabel=f;function l(i,o,h){const g=h===1?r.win32:r.posix,D=h===3?M.extUri:M.extUriIgnorePathCase,R=o.getWorkspace(),S=(0,E.firstOrDefault)(R.folders);if(!S)return;i.scheme!==S.uri.scheme&&i.path.startsWith(r.posix.sep)&&(i=S.uri.with({path:i.path}));const L=o.getWorkspaceFolder(i);if(!L)return;let T;if(D.isEqual(L.uri,i)?T="":T=D.relativePath(L.uri,i)??"",T&&(T=g.normalize(T)),R.folders.length>1&&!o.noPrefix){const U=L.name?L.name:D.basenameOrAuthority(L.uri);T=T?`${U} \u2022 ${T}`:U}return T}function w(i,o=O.isWindows){return(0,A.hasDriveLetter)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=w;let m=Object.create(null);function v(i,o,h=O.OS){if(h===1||!i||!o)return i;let g=m.original===o?m.normalized:void 0;g||(g=o,O.isWindows&&(g=(0,A.toSlashes)(g)),g=`${(0,P.rtrim)(g,r.posix.sep)}${r.posix.sep}`,m={original:o,normalized:g});let D=i;return O.isWindows&&(D=(0,A.toSlashes)(D)),(h===3?D.startsWith(g):(0,P.startsWithIgnoreCase)(D,g))?`~/${D.substr(g.length)}`:i}e.tildify=v;function u(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=u;const b="\u2026",p="\\\\",s="~";function y(i,o=r.sep){const h=new Array(i.length);let g=!1;for(let D=0;D<i.length;D++){const R=i[D];if(R===""){h[D]=`.${o}`;continue}if(!R){h[D]=R;continue}g=!0;let S="",L=R;L.indexOf(p)===0?(S=L.substr(0,L.indexOf(p)+p.length),L=L.substr(L.indexOf(p)+p.length)):L.indexOf(o)===0?(S=L.substr(0,L.indexOf(o)+o.length),L=L.substr(L.indexOf(o)+o.length)):L.indexOf(s)===0&&(S=L.substr(0,L.indexOf(s)+s.length),L=L.substr(L.indexOf(s)+s.length));const T=L.split(o);for(let U=1;g&&U<=T.length;U++)for(let H=T.length-U;g&&H>=0;H--){g=!1;let re=T.slice(H,H+U).join(o);for(let Y=0;!g&&Y<i.length;Y++)if(Y!==D&&i[Y]&&i[Y].indexOf(re)>-1){const ne=H+U===T.length,ce=H>0&&i[Y].indexOf(o)>-1?o+re:re,le=i[Y].endsWith(ce);g=!ne||le}if(!g){let Y="";(T[0].endsWith(":")||S!=="")&&(H===1&&(H=0,U++,re=T[0]+o+re),H>0&&(Y=T[0]+o),Y=S+Y),H>0&&(Y=Y+b+o),Y=Y+re,H+U<T.length&&(Y=Y+o+b),h[D]=Y}}g&&(h[D]=R)}return h}e.shorten=y;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function d(i,o=Object.create(null)){const h=[];let g=!1,D="";for(const R of i)if(R==="$"||g&&R==="{")D&&h.push({value:D,type:a.TEXT}),D="",g=!0;else if(R==="}"&&g){const S=o[D];if(typeof S=="string")S.length&&h.push({value:S,type:a.VARIABLE});else if(S){const L=h[h.length-1];(!L||L.type!==a.SEPARATOR)&&h.push({value:S.label,type:a.SEPARATOR})}D="",g=!1}else D+=R;return D&&!g&&h.push({value:D,type:a.TEXT}),h.filter((R,S)=>{if(R.type===a.SEPARATOR){const L=h[S-1],T=h[S+1];return[L,T].every(U=>U&&(U.type===a.VARIABLE||U.type===a.TEXT)&&U.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=d;function I(i,o){return O.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=I;function k(i,o){return O.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):O.isWindows?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=k;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function c(i){if(i.endsWith("]")){const o=i.lastIndexOf(" [",i.length-2);if(o!==-1){const h=n(i.substring(0,o));return{name:h.name,parentPath:h.parentPath+i.substring(o)}}}return n(i)}e.splitRecentLabel=c;function n(i){const o=i.indexOf("/")!==-1?r.posix:r.win32,h=o.basename(i),g=o.dirname(i);return h.length?{name:h,parentPath:g}:{name:g,parentPath:""}}}),define(te[153],ie([0,1,17,8]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(m){return m.toJSON()}class O{constructor(v){this.a=v}transformIncoming(v){const u=this.a.transformIncoming(v);return u===v?v:r(A.URI.from(u))}transformOutgoing(v){const u=this.a.transformOutgoing(v);return u===v?v:r(A.URI.from(u))}transformOutgoingURI(v){const u=this.a.transformOutgoing(v);return u===v?v:A.URI.from(u)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function M(m,v,u){if(!m||u>200)return null;if(typeof m=="object"){if(m instanceof A.URI)return v.transformOutgoing(m);for(const b in m)if(Object.hasOwnProperty.call(m,b)){const p=M(m[b],v,u+1);p!==null&&(m[b]=p)}}return null}function P(m,v){const u=M(m,v,0);return u===null?m:u}e.transformOutgoingURIs=P;function f(m,v,u,b){if(!m||b>200)return null;if(typeof m=="object"){if(m.$mid===1)return u?A.URI.revive(v.transformIncoming(m)):v.transformIncoming(m);if(m instanceof E.VSBuffer)return null;for(const p in m)if(Object.hasOwnProperty.call(m,p)){const s=f(m[p],v,u,b+1);s!==null&&(m[p]=s)}}return null}function l(m,v){const u=f(m,v,!1,0);return u===null?m:u}e.transformIncomingURIs=l;function w(m,v){const u=f(m,v,!0,0);return u===null?m:u}e.transformAndReviveIncomingURIs=w}),define(te[86],ie([0,1,27,62,31,141]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(l){return this.a||(this.a=A.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(l)}value(){if(this.b===void 0){let l=0,w=0;const m=(0,E.networkInterfaces)();for(const v in m){const u=m[v];if(u)for(const{mac:b,internal:p}of u)p||(w+=1,this.c(b.toUpperCase())&&(l+=1))}this.b=w>0?l/w:0}return this.b}};let M;async function P(l){return M||(M=(async()=>await f(l)||r.generateUuid())()),M}e.getMachineId=P;async function f(l){try{const w=await new Promise((v,u)=>{x(["crypto"],v,u)}),m=(0,O.getMac)();return w.createHash("sha256").update(m,"utf8").digest("hex")}catch(w){l(w);return}}}),define(te[22],ie([0,1,42,27,154,7,32,83,9,3,18,8]),function(x,e,E,A,r,O,M,P,f,l,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function u(ne,ce=v.UNLINK,le){if((0,M.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");return ce===v.UNLINK?p(ne):b(ne,le)}async function b(ne,ce=(0,M.randomPath)((0,A.tmpdir)())){try{try{await E.promises.rename(ne,ce)}catch(le){return le.code==="ENOENT"?void 0:p(ne)}p(ce).catch(le=>{})}catch(le){if(le.code!=="ENOENT")throw le}}async function p(ne){return(0,r.promisify)(E.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function s(ne){if((0,M.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=s;async function y(ne,ce){return I(await(ce?a(ne):(0,r.promisify)(E.readdir)(ne)))}async function a(ne){try{return await(0,r.promisify)(E.readdir)(ne,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const ce=[],le=await y(ne);for(const X of le){let G=!1,N=!1,F=!1;try{const V=await e.Promises.lstat((0,f.join)(ne,X));G=V.isFile(),N=V.isDirectory(),F=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}ce.push({name:X,isFile:()=>G,isDirectory:()=>N,isSymbolicLink:()=>F})}return ce}function d(ne){return I(E.readdirSync(ne))}e.readdirSync=d;function I(ne){return ne.map(ce=>typeof ce=="string"?l.isMacintosh?(0,P.normalizeNFC)(ce):ce:(ce.name=l.isMacintosh?(0,P.normalizeNFC)(ce.name):ce.name,ce))}async function k(ne){const ce=await y(ne),le=[];for(const X of ce)await c.existsDirectory((0,f.join)(ne,X))&&le.push(X);return le}function t(ne,ce=1e3){return new Promise(le=>{let X=!1;const G=setInterval(()=>{X||(X=!0,E.access(ne,N=>{X=!1,N&&(clearInterval(G),le(void 0))}))},ce)})}e.whenDeleted=t;var c;(function(ne){async function ce(G){let N;try{if(N=await e.Promises.lstat(G),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(l.isWindows&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw V}throw F}}ne.stat=ce;async function le(G){try{const{stat:N,symbolicLink:F}=await ne.stat(G);return N.isFile()&&F?.dangling!==!0}catch{}return!1}ne.existsFile=le;async function X(G){try{const{stat:N,symbolicLink:F}=await ne.stat(G);return N.isDirectory()&&F?.dangling!==!0}catch{}return!1}ne.existsDirectory=X})(c||(e.SymlinkSupport=c={}));const n=new O.ResourceQueue;function i(ne,ce,le){return n.queueFor(m.URI.file(ne),w.extUriBiasedIgnorePathCase).queue(()=>{const X=R(le);return new Promise((G,N)=>g(ne,ce,X,F=>F?N(F):G()))})}let o=!0;function h(ne){o=ne}e.configureFlushOnWrite=h;function g(ne,ce,le,X){if(!o)return E.writeFile(ne,ce,{mode:le.mode,flag:le.flag},X);E.open(ne,le.flag,le.mode,(G,N)=>{if(G)return X(G);E.writeFile(N,ce,F=>{if(F)return E.close(N,()=>X(F));E.fdatasync(N,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),h(!1)),E.close(N,J=>X(J))))})})}function D(ne,ce,le){const X=R(le);if(!o)return E.writeFileSync(ne,ce,{mode:X.mode,flag:X.flag});const G=E.openSync(ne,X.flag,X.mode);try{E.writeFileSync(G,ce);try{E.fdatasyncSync(G)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),h(!1)}}finally{E.closeSync(G)}}e.writeFileSync=D;function R(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function S(ne,ce){if(ne!==ce)try{await e.Promises.rename(ne,ce)}catch(le){if(ne.toLowerCase()!==ce.toLowerCase()&&le.code==="EXDEV"||ne.endsWith("."))await L(ne,ce,{preserveSymlinks:!1}),await u(ne,v.MOVE);else throw le}}async function L(ne,ce,le){return U(ne,ce,{root:{source:ne,target:ce},options:le,handledSourcePaths:new Set})}const T=511;async function U(ne,ce,le){if(le.handledSourcePaths.has(ne))return;le.handledSourcePaths.add(ne);const{stat:X,symbolicLink:G}=await c.stat(ne);if(G){if(le.options.preserveSymlinks)try{return await Y(ne,ce,le)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(G.dangling)return}return X.isDirectory()?H(ne,ce,X.mode&T,le):re(ne,ce,X.mode&T)}async function H(ne,ce,le,X){await e.Promises.mkdir(ce,{recursive:!0,mode:le});const G=await y(ne);for(const N of G)await U((0,f.join)(ne,N),(0,f.join)(ce,N),X)}async function re(ne,ce,le){await e.Promises.copyFile(ne,ce),await e.Promises.chmod(ce,le)}async function Y(ne,ce,le){let X=await e.Promises.readlink(ne);(0,M.isEqualOrParent)(X,le.root.source,!l.isLinux)&&(X=(0,f.join)(le.root.target,X.substr(le.root.source.length+1))),await e.Promises.symlink(X,ce)}e.Promises=new class{get access(){return(0,r.promisify)(E.access)}get stat(){return(0,r.promisify)(E.stat)}get lstat(){return(0,r.promisify)(E.lstat)}get utimes(){return(0,r.promisify)(E.utimes)}get read(){return(ne,ce,le,X,G)=>new Promise((N,F)=>{E.read(ne,ce,le,X,G,(V,J,_)=>V?F(V):N({bytesRead:J,buffer:_}))})}get readFile(){return(0,r.promisify)(E.readFile)}get write(){return(ne,ce,le,X,G)=>new Promise((N,F)=>{E.write(ne,ce,le,X,G,(V,J,_)=>V?F(V):N({bytesWritten:J,buffer:_}))})}get appendFile(){return(0,r.promisify)(E.appendFile)}get fdatasync(){return(0,r.promisify)(E.fdatasync)}get truncate(){return(0,r.promisify)(E.truncate)}get rename(){return(0,r.promisify)(E.rename)}get copyFile(){return(0,r.promisify)(E.copyFile)}get open(){return(0,r.promisify)(E.open)}get close(){return(0,r.promisify)(E.close)}get symlink(){return(0,r.promisify)(E.symlink)}get readlink(){return(0,r.promisify)(E.readlink)}get chmod(){return(0,r.promisify)(E.chmod)}get mkdir(){return(0,r.promisify)(E.mkdir)}get unlink(){return(0,r.promisify)(E.unlink)}get rmdir(){return(0,r.promisify)(E.rmdir)}get realpath(){return(0,r.promisify)(E.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return k}get writeFile(){return i}get rm(){return u}get move(){return S}get copy(){return L}}}),define(te[105],ie([0,1,42,9,3,25,22]),function(x,e,E,A,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(v){if(r.isLinux)return v;const u=(0,A.dirname)(v);if(v===u)return v;const b=((0,A.basename)(v)||v).toLowerCase();try{const s=(0,M.readdirSync)(u).filter(y=>y.toLowerCase()===b);if(s.length===1){const y=P(u);if(y)return(0,A.join)(y,s[0])}else if(s.length>1){const y=s.indexOf(b);if(y>=0){const a=P(u);if(a)return(0,A.join)(a,s[y])}}}catch{}return null}e.realcaseSync=P;async function f(v){if(r.isLinux)return v;const u=(0,A.dirname)(v);if(v===u)return v;const b=((0,A.basename)(v)||v).toLowerCase();try{const s=(await M.Promises.readdir(u)).filter(y=>y.toLowerCase()===b);if(s.length===1){const y=await f(u);if(y)return(0,A.join)(y,s[0])}else if(s.length>1){const y=s.indexOf(b);if(y>=0){const a=await f(u);if(a)return(0,A.join)(a,s[y])}}}catch{}return null}e.realcase=f;async function l(v){try{return await M.Promises.realpath(v)}catch{const b=m(v);return await M.Promises.access(b,E.constants.R_OK),b}}e.realpath=l;function w(v){try{return E.realpathSync(v)}catch{const b=m(v);return E.accessSync(b,E.constants.R_OK),b}}e.realpathSync=w;function m(v){return(0,O.rtrim)((0,A.normalize)(v),A.sep)}}),define(te[106],ie([0,1,27,9,22]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const O=/^\d+$/,M=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var f;(function(I){I[I.x64=0]="x64",I[I.x86=1]="x86",I[I.ARM=2]="ARM"})(f||(f={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class m{constructor(k,t,c){this.exePath=k,this.displayName=t,this.a=c}async exists(){return this.a===void 0&&(this.a=await r.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:I=!1}={}){return I?l===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:I=!1,findPreview:k=!1}={}){const t=v({useAlternateBitness:I});if(!t)return null;const c=A.join(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(c))return null;let n=-1,i=null;for(const g of await r.Promises.readdir(c)){let D=-1;if(k){const S=g.indexOf("-");if(S<0)continue;const L=g.substring(0,S);if(!O.test(L)||g.substring(S+1)!=="preview")continue;D=parseInt(L,10)}else{if(!O.test(g))continue;D=parseInt(g,10)}if(D<=n)continue;const R=A.join(c,g,"pwsh.exe");await r.SymlinkSupport.existsFile(R)&&(i=R,n=D)}if(!i)return null;const o=t.includes("x86")?" (x86)":"",h=k?" Preview":"";return new m(i,`PowerShell${h}${o}`,!0)}async function b({findPreview:I}={}){if(!process.env.LOCALAPPDATA)return null;const k=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(k))return null;const{pwshMsixDirRegex:t,pwshMsixName:c}=I?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const n of await r.Promises.readdir(k))if(t.test(n)){const i=A.join(k,n,"pwsh.exe");return new m(i,c)}return null}function p(){const I=A.join(E.homedir(),".dotnet","tools","pwsh.exe");return new m(I,".NET Core PowerShell Global Tool")}function s(){const I=A.join(process.env.windir,l===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new m(I,"Windows PowerShell",!0)}async function*y(){let I=await u();I&&(yield I),I=await u({useAlternateBitness:!0}),I&&(yield I),I=await b(),I&&(yield I),I=p(),I&&(yield I),I=await u({findPreview:!0}),I&&(yield I),I=await b({findPreview:!0}),I&&(yield I),I=await u({useAlternateBitness:!0,findPreview:!0}),I&&(yield I),I=s(),I&&(yield I)}async function*a(){for await(const I of y())await I.exists()&&(yield I)}e.enumeratePowerShellInstallations=a;async function d(){for await(const I of a())return I;return null}e.getFirstAvailablePowerShellInstallation=d}),define(te[87],ie([0,1,9,3,36,71,11,22]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function f(m=r.env){return m.comspec||"cmd.exe"}e.getWindowsShell=f;function l(m){let v=[],u=!1;const b=function(p){if(u){v.push(p);return}(!m.send(p,y=>{if(y&&console.error(y),u=!1,v.length>0){const a=v.slice(0);v=[],a.forEach(d=>b(d))}})||A.isWindows)&&(u=!0)};return{send:b}}e.createQueuedSender=l;var w;(function(m){async function v(u,b,p){if(E.isAbsolute(u))return u;if(b===void 0&&(b=r.cwd()),E.dirname(u)!=="."||(p===void 0&&M.isString(r.env.PATH)&&(p=r.env.PATH.split(E.delimiter)),p===void 0||p.length===0))return E.join(b,u);async function y(a){if(await P.Promises.exists(a)){let d;try{d=await P.Promises.stat(a)}catch(I){I.message.startsWith("EACCES")&&(d=await P.Promises.lstat(a))}return d?!d.isDirectory():!1}return!1}for(const a of p){let d;if(E.isAbsolute(a)?d=E.join(a,u):d=E.join(b,a,u),await y(d))return d;let I=d+".com";if(await y(I)||(I=d+".exe",await y(I)))return I}return E.join(b,u)}m.findExecutable=v})(w||(e.win32=w={}))}),define(te[107],ie([0,1,46,14]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function r(M){return new Promise((P,f)=>{let l;const w=new Map;function m(u,b,p,s,y){const a=w.get(b);if(u===M||a){const d={name:v(p),cmd:p,pid:u,ppid:b,load:s,mem:y};w.set(u,d),u===M&&(l=d),a&&(a.children||(a.children=[]),a.children.push(d),a.children.length>1&&(a.children=a.children.sort((I,k)=>I.pid-k.pid)))}}function v(u){const b=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,s=/--crashes-directory/i,y=/\\pipe\\winpty-control/i,a=/conhost\.exe/i,d=/--type=([a-zA-Z-]+)/;if(s.exec(u))return"electron-crash-reporter";if(y.exec(u))return"winpty-process";if(a.exec(u))return"console-window-host (Windows internal process)";let I=d.exec(u);if(I&&I.length===2)return I[1]==="renderer"?"window":I[1]==="utility"?b.exec(u)?"utility-network-service":"utility-process":I[1]==="extensionHost"?"extension-host":I[1];const k=/[a-zA-Z-]+\.js/g;let t="";do I=k.exec(u),I&&(t+=I+" ");while(I);return t&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${t})`:p.exec(u)?`electron-nodejs (${u})`:u}if(process.platform==="win32"){const u=b=>b.indexOf("\\\\?\\")===0||b.indexOf("\\??\\")===0?b.substr(4):b.indexOf('"\\\\?\\')===0||b.indexOf('"\\??\\')===0?'"'+b.substr(5):b;new Promise((b,p)=>{x(["@vscode/windows-process-tree"],b,p)}).then(b=>{b.getProcessList(M,p=>{if(!p){f(new Error(`Root process ${M} not found`));return}b.getProcessCpuUsage(p,s=>{const y=new Map;s.forEach(a=>{const d=u(a.commandLine||"");y.set(a.pid,{name:v(d),cmd:d,pid:a.pid,ppid:a.ppid,load:a.cpu||0,mem:a.memory||0})}),l=y.get(M),l?(y.forEach(a=>{const d=y.get(a.ppid);d&&(d.children||(d.children=[]),d.children.push(a))}),y.forEach(a=>{a.children&&(a.children=a.children.sort((d,I)=>d.pid-I.pid))}),P(l)):f(new Error(`Root process ${M} not found`))})},b.ProcessDataFlag.CommandLine|b.ProcessDataFlag.Memory)})}else{let u=function(){let b=[l];const p=[];for(;b.length;){const y=b.shift();y&&(p.push(y.pid),y.children&&(b=b.concat(y.children)))}let s=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);s+=" "+p.join(" "),(0,E.exec)(s,{},(y,a,d)=>{if(y||d)f(y||new Error(d.toString()));else{const I=a.toString().split(`
`);for(let k=0;k<p.length;k++){const t=w.get(p[k]);t.load=parseFloat(I[k])}if(!l){f(new Error(`Root process ${M} not found`));return}P(l)}})};(0,E.exec)("which ps",{},(b,p,s)=>{if(b||s)if(process.platform!=="linux")f(b||new Error(s.toString()));else{const y=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(y,{},(a,d,I)=>{a||I?f(a||new Error(I.toString())):(O(d,m),u())})}else{const y=p.toString().trim(),a="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${y} ${a}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,I,k)=>{d||k&&!k.includes("screen size is bogus")?f(d||new Error(k.toString())):(O(I,m),process.platform==="linux"?u():l?P(l):f(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=r;function O(M,P){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=M.toString().split(`
`);for(const w of l){const m=f.exec(w.trim());m&&m.length===6&&P(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}}),define(te[155],ie([0,1,27,3,106,87]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function M(m,v){return m===1?A.isWindows?w():O.getWindowsShell(v):f(m,v)}e.getSystemShell=M;let P=null;function f(m,v){if(A.isLinux&&m===2||A.isMacintosh&&m===3)return"/bin/bash";if(!P){let u;if(A.isWindows)u="/bin/bash";else{if(u=v.SHELL,!u)try{u=(0,E.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}P=u}return P}let l=null;async function w(){return l||(l=(await(0,r.getFirstAvailablePowerShellInstallation)()).exePath),l}});var ve=this&&this.__decorate||function(x,e,E,A){var r=arguments.length,O=r<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,E):A,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(x,e,E,A);else for(var P=x.length-1;P>=0;P--)(M=x[P])&&(O=(r<3?M(O):r>3?M(e,E,O):M(e,E))||O);return r>3&&O&&Object.defineProperty(e,E,O),O};define(te[43],ie([0,1,24,7,17,21,55,13,4,2,73,25,11]),function(x,e,E,A,r,O,M,P,f,l,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var u;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(u||(u={}));function b(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(p||(p={}));function s(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(y||(y={}));function a(N){let F=0;for(let V=0;;V+=7){const J=N.read(1);if(F|=(J.buffer[0]&127)<<V,!(J.buffer[0]&128))return F}}const d=n(0);function I(N,F){if(F===0){N.write(d);return}let V=0;for(let _=F;_!==0;_=_>>>7)V++;const J=r.VSBuffer.alloc(V);for(let _=0;F!==0;_++)J.buffer[_]=F&127,F=F>>>7,F>0&&(J.buffer[_]|=128);N.write(J)}class k{constructor(F){this.b=F,this.a=0}read(F){const V=this.b.slice(this.a,this.a+F);return this.a+=V.byteLength,V}}e.BufferReader=k;class t{constructor(){this.a=[]}get buffer(){return r.VSBuffer.concat(this.a)}write(F){this.a.push(F)}}e.BufferWriter=t;var c;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object",N[N.Int=6]="Int"})(c||(c={}));function n(N){const F=r.VSBuffer.alloc(1);return F.writeUInt8(N,0),F}const i={Undefined:n(c.Undefined),String:n(c.String),Buffer:n(c.Buffer),VSBuffer:n(c.VSBuffer),Array:n(c.Array),Object:n(c.Object),Uint:n(c.Int)},o=typeof Buffer<"u";function h(N,F){if(typeof F>"u")N.write(i.Undefined);else if(typeof F=="string"){const V=r.VSBuffer.fromString(F);N.write(i.String),I(N,V.byteLength),N.write(V)}else if(o&&Buffer.isBuffer(F)){const V=r.VSBuffer.wrap(F);N.write(i.Buffer),I(N,V.byteLength),N.write(V)}else if(F instanceof r.VSBuffer)N.write(i.VSBuffer),I(N,F.byteLength),N.write(F);else if(Array.isArray(F)){N.write(i.Array),I(N,F.length);for(const V of F)h(N,V)}else if(typeof F=="number"&&(F|0)===F)N.write(i.Uint),I(N,F);else{const V=r.VSBuffer.fromString(JSON.stringify(F));N.write(i.Object),I(N,V.byteLength),N.write(V)}}e.serialize=h;function g(N){switch(N.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return N.read(a(N)).toString();case c.Buffer:return N.read(a(N)).buffer;case c.VSBuffer:return N.read(a(N));case c.Array:{const V=a(N),J=[];for(let _=0;_<V;_++)J.push(g(N));return J}case c.Object:return JSON.parse(N.read(a(N)).toString());case c.Int:return a(N)}}e.deserialize=g;class D{constructor(F,V,J=null,_=1e3){this.h=F,this.j=V,this.k=J,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(F,V){this.b.set(F,V),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const V=this.o([F.type]);this.k?.logOutgoing(V,0,1,s(F.type));return}case 201:case 202:case 204:case 203:{const V=this.o([F.type,F.id],F.data);this.k?.logOutgoing(V,F.id,1,s(F.type),F.data);return}}}o(F,V=void 0){const J=new t;return h(J,F),h(J,V),this.p(J.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const V=new k(F),J=g(V),_=g(V),ae=J[0];switch(ae){case 100:return this.k?.logIncoming(F.byteLength,J[1],1,`${b(ae)}: ${J[2]}.${J[3]}`,_),this.s({type:ae,id:J[1],channelName:J[2],name:J[3],arg:_});case 102:return this.k?.logIncoming(F.byteLength,J[1],1,`${b(ae)}: ${J[2]}.${J[3]}`,_),this.t({type:ae,id:J[1],channelName:J[2],name:J[3],arg:_});case 101:return this.k?.logIncoming(F.byteLength,J[1],1,`${b(ae)}`),this.u({type:ae,id:J[1]});case 103:return this.k?.logIncoming(F.byteLength,J[1],1,`${b(ae)}`),this.u({type:ae,id:J[1]})}}s(F){const V=this.b.get(F.channelName);if(!V){this.v(F);return}const J=new O.CancellationTokenSource;let _;try{_=V.call(this.j,F.name,F.arg,J.token)}catch(B){_=Promise.reject(B)}const ae=F.id;_.then(B=>{this.m({id:ae,data:B,type:201}),this.d.delete(F.id)},B=>{B instanceof Error?this.m({id:ae,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.m({id:ae,data:B,type:203}),this.d.delete(F.id)});const oe=(0,l.toDisposable)(()=>J.cancel());this.d.set(F.id,oe)}t(F){const V=this.b.get(F.channelName);if(!V){this.v(F);return}const J=F.id,ae=V.listen(this.j,F.name,F.arg)(oe=>this.m({id:J,data:oe,type:204}));this.d.set(F.id,ae)}u(F){const V=this.d.get(F.id);V&&(V.dispose(),this.d.delete(F.id))}v(F){let V=this.g.get(F.channelName);V||(V=[],this.g.set(F.channelName,V));const J=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:F,timeoutTimer:J})}w(F){const V=this.g.get(F);if(V){for(const J of V)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=D;var R;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class S{constructor(F,V=null){this.l=F,this.a=!1,this.b=y.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=V}getChannel(F){const V=this;return{call(J,_,ae){return V.a?Promise.reject(new P.CancellationError):V.m(F,J,_,ae)},listen(J,_){return V.a?f.Event.None:V.o(F,J,_)}}}m(F,V,J,_=O.CancellationToken.None){const ae=this.g++,B={id:ae,type:100,channelName:F,name:V,arg:J};if(_.isCancellationRequested)return Promise.reject(new P.CancellationError);let C;return new Promise((z,q)=>{if(_.isCancellationRequested)return q(new P.CancellationError);const j=()=>{const ue=be=>{switch(be.type){case 201:this.f.delete(ae),z(be.data);break;case 202:{this.f.delete(ae);const ke=new Error(be.data.message);ke.stack=Array.isArray(be.data.stack)?be.data.stack.join(`
`):be.data.stack,ke.name=be.data.name,q(ke);break}case 203:this.f.delete(ae),q(be.data);break}};this.f.set(ae,ue),this.p(B)};let $=null;this.b===y.Idle?j():($=(0,A.createCancelablePromise)(ue=>this.u()),$.then(()=>{$=null,j()}));const K=()=>{$?($.cancel(),$=null):this.p({id:ae,type:101}),q(new P.CancellationError)},se=_.onCancellationRequested(K);C=(0,l.combinedDisposable)((0,l.toDisposable)(K),se),this.d.add(C)}).finally(()=>{this.d.delete(C)})}o(F,V,J){const _=this.g++,oe={id:_,type:102,channelName:F,name:V,arg:J};let B=null;const C=new f.Emitter({onWillAddFirstListener:()=>{B=(0,A.createCancelablePromise)(z=>this.u()),B.then(()=>{B=null,this.d.add(C),this.p(oe)})},onDidRemoveLastListener:()=>{B?(B.cancel(),B=null):(this.d.delete(C),this.p({id:_,type:103}))}}),W=z=>C.fire(z.data);return this.f.set(_,W),C.event}p(F){switch(F.type){case 100:case 102:{const V=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(V,F.id,0,`${b(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const V=this.q([F.type,F.id]);this.j?.logOutgoing(V,F.id,0,b(F.type));return}}}q(F,V=void 0){const J=new t;return h(J,F),h(J,V),this.r(J.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const V=new k(F),J=g(V),_=g(V),ae=J[0];switch(ae){case 200:return this.j?.logIncoming(F.byteLength,0,0,s(ae)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,J[1],0,s(ae),_),this.t({type:J[0],id:J[1],data:_})}}t(F){if(F.type===200){this.b=y.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.dispose)(this.d.values()),this.d.clear()}}e.ChannelClient=S,ve([M.memoize],S.prototype,"onDidInitializePromise",null);class L{get connections(){const F=[];return this.f.forEach(V=>F.push(V)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new f.Emitter,this.onDidAddConnection=this.g.event,this.h=new f.Emitter,this.onDidRemoveConnection=this.h.event,F(({protocol:V,onDidClientDisconnect:J})=>{f.Event.once(V.onMessage)(ae=>{const oe=new k(ae),B=g(oe),C=new D(V,B),W=new S(V);this.a.forEach((q,j)=>C.registerChannel(j,q));const z={channelServer:C,channelClient:W,ctx:B};this.f.add(z),this.g.fire(z),J(()=>{C.dispose(),W.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(F,V){const J=this;return{call(_,ae,oe){let B;if((0,v.isFunction)(V)){const W=(0,E.getRandomElement)(J.connections.filter(V));B=W?Promise.resolve(W):f.Event.toPromise(f.Event.filter(J.onDidAddConnection,V))}else B=V.routeCall(J,_,ae);const C=B.then(W=>W.channelClient.getChannel(F));return U(C).call(_,ae,oe)},listen(_,ae){if((0,v.isFunction)(V))return J.j(F,V,_,ae);const oe=V.routeEvent(J,_,ae).then(B=>B.channelClient.getChannel(F));return U(oe).listen(_,ae)}}}j(F,V,J,_){const ae=this;let oe=new l.DisposableStore;const B=new f.Emitter({onWillAddFirstListener:()=>{oe=new l.DisposableStore;const C=new f.EventMultiplexer,W=new Map,z=j=>{const K=j.channelClient.getChannel(F).listen(J,_),se=C.add(K);W.set(j,se)},q=j=>{const $=W.get(j);$&&($.dispose(),W.delete(j))};ae.connections.filter(V).forEach(z),f.Event.filter(ae.onDidAddConnection,V)(z,void 0,oe),ae.onDidRemoveConnection(q,void 0,oe),C.event(B.fire,B,oe),oe.add(C)},onDidRemoveLastListener:()=>{oe.dispose()}});return B.event}registerChannel(F,V){this.a.set(F,V),this.f.forEach(J=>{J.channelServer.registerChannel(F,V)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=L;class T{constructor(F,V,J=null){const _=new t;h(_,V),F.send(_.buffer),this.a=new S(F,J),this.d=new D(F,V,J)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,V){this.d.registerChannel(F,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=T;function U(N){return{call(F,V,J){return N.then(_=>_.call(F,V,J))},listen(F,V){const J=new f.Relay;return N.then(_=>J.input=_.listen(F,V)),J.event}}}e.getDelayedChannel=U;function H(N){let F=!1;return{call(V,J,_){return F?N.call(V,J,_):(0,A.timeout)(0).then(()=>F=!0).then(()=>N.call(V,J,_))},listen(V,J){if(F)return N.listen(V,J);const _=new f.Relay;return(0,A.timeout)(0).then(()=>F=!0).then(()=>_.input=N.listen(V,J)),_.event}}}e.getNextTickChannel=H;class re{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const V of F.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await f.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.StaticRouter=re;var Y;(function(N){function F(ae,oe){const B=ae,C=oe&&oe.disableMarshalling,W=new Map;for(const z in B)J(z)&&W.set(z,f.Event.buffer(B[z],!0));return new class{listen(z,q,j){const $=W.get(q);if($)return $;if(_(q)){const K=B[q];if(typeof K=="function")return K.call(B,j)}throw new Error(`Event not found: ${q}`)}call(z,q,j){const $=B[q];if(typeof $=="function"){if(!C&&Array.isArray(j))for(let K=0;K<j.length;K++)j[K]=(0,w.revive)(j[K]);return $.apply(B,j)}throw new Error(`Method not found: ${q}`)}}}N.fromService=F;function V(ae,oe){const B=oe&&oe.disableMarshalling;return new Proxy({},{get(C,W){if(typeof W=="string")return oe?.properties?.has(W)?oe.properties.get(W):_(W)?function(z){return ae.listen(W,z)}:J(W)?ae.listen(W):async function(...z){let q;oe&&!(0,v.isUndefinedOrNull)(oe.context)?q=[oe.context,...z]:q=z;const j=await ae.call(W,q);return B?j:(0,w.revive)(j)};throw new Error(`Property not found: ${String(W)}`)}})}N.toService=V;function J(ae){return ae[0]==="o"&&ae[1]==="n"&&m.isUpperAsciiLetter(ae.charCodeAt(2))}function _(ae){return/^onDynamic/.test(ae)&&m.isUpperAsciiLetter(ae.charCodeAt(9))}})(Y||(e.ProxyChannel=Y={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const F=N.toString();if(F!=="[object Object]")return F}return N}function le(N){return Array.isArray(N)?N.map(ce):ce(N)}function X(N,F,V,J,_,ae,oe){oe=le(oe);const B=ne[_],C=B[J%B.length];let W=[`%c[${N}]%c[${String(F).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(ae)?(W=W.concat(oe),W.push(")")):W.push(oe),console.log.apply(console,W)}class G{constructor(F,V){this.d=F,this.f=V,this.a=0,this.b=0}logOutgoing(F,V,J,_,ae){this.b+=F,X(this.d,this.b,F,V,J,_,ae)}logIncoming(F,V,J,_,ae){this.a+=F,X(this.f,this.a,F,V,J,_,ae)}}e.IPCLogger=G}),define(te[156],ie([0,1,17,4,43]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class O{constructor(f){this.a=f,this.onMessage=A.Event.fromDOMEventEmitter(this.a,"message",l=>E.VSBuffer.wrap(l.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.Protocol=O;class M extends r.IPCClient{constructor(f,l){const w=new O(f);super(w,l),this.b=w}dispose(){this.b.disconnect()}}e.Client=M}),define(te[108],ie([0,1,7,17,4,2,43]),function(x,e,E,A,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(S){S.Created="created",S.Read="read",S.Write="write",S.Open="open",S.Error="error",S.Close="close",S.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",S.NodeEndReceived="nodeEndReceived",S.NodeEndSent="nodeEndSent",S.NodeDrainBegin="nodeDrainBegin",S.NodeDrainEnd="nodeDrainEnd",S.zlibInflateError="zlibInflateError",S.zlibInflateData="zlibInflateData",S.zlibInflateInitialWrite="zlibInflateInitialWrite",S.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",S.zlibInflateWrite="zlibInflateWrite",S.zlibInflateFlushFired="zlibInflateFlushFired",S.zlibDeflateError="zlibDeflateError",S.zlibDeflateData="zlibDeflateData",S.zlibDeflateWrite="zlibDeflateWrite",S.zlibDeflateFlushFired="zlibDeflateFlushFired",S.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",S.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",S.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",S.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",S.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",S.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",S.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",S.ProtocolHeaderRead="protocolHeaderRead",S.ProtocolMessageRead="protocolMessageRead",S.ProtocolHeaderWrite="protocolHeaderWrite",S.ProtocolMessageWrite="protocolMessageWrite",S.ProtocolWrite="protocolWrite"})(P||(e.SocketDiagnosticsEventType=P={}));var f;(function(S){S.enableDiagnostics=!1,S.records=[];const L=new WeakMap;let T=0;function U(re,Y){if(!L.has(re)){const ne=String(++T);L.set(re,ne)}return L.get(re)}function H(re,Y,ne,ce){if(!S.enableDiagnostics)return;const le=U(re,Y);if(ce instanceof A.VSBuffer||ce instanceof Uint8Array||ce instanceof ArrayBuffer||ArrayBuffer.isView(ce)){const X=A.VSBuffer.alloc(ce.byteLength);X.set(ce),S.records.push({timestamp:Date.now(),id:le,label:Y,type:ne,buff:X})}else S.records.push({timestamp:Date.now(),id:le,label:Y,type:ne,data:ce})}S.traceSocketEvent=H})(f||(e.SocketDiagnostics=f={}));var l;(function(S){S[S.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",S[S.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(l||(e.SocketCloseEventType=l={}));let w=null;function m(){return w||(w=A.VSBuffer.alloc(0)),w}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(L){this.a.push(L),this.b+=L.byteLength}read(L){return this.c(L,!0)}peek(L){return this.c(L,!1)}c(L,T){if(L===0)return m();if(L>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===L){const Y=this.a[0];return T&&(this.a.shift(),this.b-=L),Y}if(this.a[0].byteLength>L){const Y=this.a[0].slice(0,L);return T&&(this.a[0]=this.a[0].slice(L),this.b-=L),Y}const U=A.VSBuffer.alloc(L);let H=0,re=0;for(;L>0;){const Y=this.a[re];if(Y.byteLength>L){const ne=Y.slice(0,L);U.set(ne,H),H+=L,T&&(this.a[re]=Y.slice(L),this.b-=L),L-=L}else U.set(Y,H),H+=Y.byteLength,T?(this.a.shift(),this.b-=Y.byteLength):re++,L-=Y.byteLength}return U}}e.ChunkStream=v;var u;(function(S){S[S.None=0]="None",S[S.Regular=1]="Regular",S[S.Control=2]="Control",S[S.Ack=3]="Ack",S[S.Disconnect=5]="Disconnect",S[S.ReplayRequest=6]="ReplayRequest",S[S.Pause=7]="Pause",S[S.Resume=8]="Resume",S[S.KeepAlive=9]="KeepAlive",S[S.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",S[S.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(u||(u={}));function b(S){switch(S){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var p;(function(S){S[S.HeaderLength=13]="HeaderLength",S[S.AcknowledgeTime=2e3]="AcknowledgeTime",S[S.TimeoutTime=2e4]="TimeoutTime",S[S.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",S[S.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",S[S.KeepAliveSendTime=5e3]="KeepAliveSendTime",S[S.LatencySampleTime=6e4]="LatencySampleTime",S[S.LatencySampleCount=5]="LatencySampleCount",S[S.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",S[S.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(p||(e.ProtocolConstants=p={}));class s{constructor(L,T,U,H){this.type=L,this.id=T,this.ack=U,this.data=H,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends O.Disposable{constructor(L){super(),this.f=this.B(new r.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=L,this.b=!1,this.c=new v,this.B(this.a.onData(T=>this.acceptChunk(T))),this.lastReadTime=Date.now()}acceptChunk(L){if(!(!L||L.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(L);this.c.byteLength>=this.g.readLen;){const T=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=T.readUInt32BE(9),this.g.messageType=T.readUInt8(0),this.g.id=T.readUInt32BE(1),this.g.ack=T.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:b(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const U=this.g.messageType,H=this.g.id,re=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",T),this.f.fire(new s(U,H,re,T)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(L){this.k=null,this.a=!1,this.b=!1,this.c=L,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(L){if(this.a)return;L.writtenTime=Date.now(),this.lastWriteTime=Date.now();const T=A.VSBuffer.alloc(13);T.writeUInt8(L.type,0),T.writeUInt32BE(L.id,1),T.writeUInt32BE(L.ack,5),T.writeUInt32BE(L.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:b(L.type),id:L.id,ack:L.ack,messageSize:L.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",L.data),this.j(T,L.data)}g(L,T){const U=this.f===0;return this.d.push(L,T),this.f+=L.byteLength+T.byteLength,U}h(){const L=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,L}j(L,T){this.g(L,T)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const L=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:L.byteLength}),this.c.write(L)}}class d extends O.Disposable{constructor(L){super(),this.f=new r.Emitter,this.onMessage=this.f.event,this.g=new r.Emitter,this.onDidDispose=this.g.event,this.a=L,this.b=this.B(new a(this.a)),this.c=this.B(new y(this.a)),this.B(this.c.onMessage(T=>{T.type===1&&this.f.fire(T.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(L){this.b.write(new s(1,0,0,L))}}e.Protocol=d;class I extends M.IPCClient{static fromSocket(L,T){return new I(new d(L),T)}get onDidDispose(){return this.b.onDidDispose}constructor(L,T,U=null){super(L,T,U),this.b=L}dispose(){super.dispose();const L=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),L.end()}}e.Client=I;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(L){this.b?this.d.length>0?this.d.push(L):this.a.fire(L):this.d.push(L)}flushBuffer(){this.d=[]}}e.BufferedEmitter=k;class t{constructor(L){this.data=L,this.next=null}}class c{constructor(){this.a=null,this.b=null}length(){let L=0,T=this.a;for(;T;)T=T.next,L++;return L}peek(){return this.a?this.a.data:null}toArray(){const L=[];let T=0,U=this.a;for(;U;)L[T++]=U.data,U=U.next;return L}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(L){const T=new t(L);if(!this.a){this.a=T,this.b=T;return}this.b.next=T,this.b=T}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const L=Date.now();for(let T=0;T<n.a;T++)this.c[T]=L-1e3*T;setInterval(()=>{for(let T=n.a;T>=1;T--)this.c[T]=this.c[T-1];this.c[0]=Date.now()},1e3)}d(){const L=Date.now(),T=(1+n.a)*1e3;let U=0;for(let H=0;H<n.a;H++)L-this.c[H]<=T&&U++;return 1-U/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;var i;(function(S){S[S.Good=0]="Good",S[S.Poor=1]="Poor"})(i||(e.ConnectionHealth=i={}));function o(S){switch(S){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class h{constructor(L){this.connectionHealth=L}}e.ConnectionHealthChangedEvent=h;class g{constructor(L,T){this.roundTripTime=L,this.recentHighRoundTripCount=T}}e.HighRoundTripTimeEvent=g;class D{get unacknowledgedCount(){return this.c-this.d}constructor(L){this.x=new k,this.onControlMessage=this.x.event,this.y=new k,this.onMessage=this.y.event,this.z=new k,this.onDidDispose=this.z.event,this.A=new k,this.onSocketClose=this.A.event,this.B=new k,this.onSocketTimeout=this.B.event,this.C=new k,this.onHighRoundTripTime=this.C.event,this.D=new k,this.onDidChangeConnectionHealth=this.D.event,this.u=L.loadEstimator??n.getInstance(),this.v=L.measureRoundTripTime??!1,this.w=L.sendKeepAlive??!0,this.a=!1,this.b=new c,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new O.DisposableStore,this.o=L.socket,this.p=this.t.add(new a(this.o)),this.q=this.t.add(new y(this.o)),this.t.add(this.q.onMessage(T=>this.E(T))),this.t.add(this.o.onClose(T=>this.A.fire(T))),this.r=this.t.add(new R),this.t.add(this.r.onSendLatencyRequest(T=>this.J(T))),this.t.add(this.r.onHighRoundTripTime(T=>this.C.fire(T))),this.t.add(this.r.onDidChangeConnectionHealth(T=>this.D.fire(T))),this.v&&this.r.start(),L.initialChunk&&this.q.acceptChunk(L.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const L=new s(5,0,0,m());this.p.write(L),this.p.flush()}sendPause(){const L=new s(7,0,0,m());this.p.write(L)}sendResume(){const L=new s(8,0,0,m());this.p.write(L)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(L,T){this.a=!0,this.t.dispose(),this.t=new O.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=L,this.p=this.t.add(new a(this.o)),this.q=this.t.add(new y(this.o)),this.t.add(this.q.onMessage(U=>this.E(U))),this.t.add(this.o.onClose(U=>this.A.fire(U))),this.r=this.t.add(new R),this.t.add(this.r.onSendLatencyRequest(U=>this.J(U))),this.t.add(this.r.onHighRoundTripTime(U=>this.C.fire(U))),this.t.add(this.r.onDidChangeConnectionHealth(U=>this.D.fire(U))),this.q.acceptChunk(T)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const L=new s(3,0,this.h,m());this.p.write(L);const T=this.b.toArray();for(let U=0,H=T.length;U<H;U++)this.p.write(T[U]);this.G()}acceptDisconnect(){this.z.fire()}E(L){if(L.ack>this.d){this.d=L.ack;do{const T=this.b.peek();if(T&&T.id<=L.ack)this.b.pop();else break}while(!0)}switch(L.type){case 0:break;case 1:{if(L.id>this.g)if(L.id!==this.g+1){const T=Date.now();T-this.m>1e4&&(this.m=T,this.p.write(new s(6,0,0,m())))}else this.g=L.id,this.j=Date.now(),this.F(),this.y.fire(L.data);break}case 2:{this.x.fire(L.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const T=this.b.toArray();for(let U=0,H=T.length;U<H;U++)this.p.write(T[U]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(L.data);break}case 11:{this.r.handleResponse(L.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(L){const T=++this.c;this.h=this.g;const U=new s(1,T,this.h,L);this.b.push(U),this.a||(this.p.write(U),this.G())}sendControl(L){const T=new s(2,0,0,L);this.p.write(T)}F(){if(this.g<=this.h||this.k)return;const L=Date.now()-this.j;if(L>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-L+5)}G(){if(this.c<=this.d||this.f||this.a)return;const L=this.b.peek(),T=Date.now()-L.writtenTime,U=Date.now()-this.q.lastReadTime,H=Date.now()-this.n;if(T>=2e4&&U>=2e4&&H>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:T,timeSinceLastReceivedSomeData:U});return}const re=Math.max(2e4-T,2e4-U,2e4-H,500);this.f=setTimeout(()=>{this.f=null,this.G()},re)}H(){if(this.g<=this.h)return;this.h=this.g;const L=new s(3,0,this.h,m());this.p.write(L)}I(){this.h=this.g;const L=new s(9,0,this.h,m());this.p.write(L)}J(L){this.h=this.g;const T=new s(10,0,this.h,L);this.p.write(T)}K(L){this.h=this.g;const T=new s(11,0,this.h,L);this.p.write(T)}}e.PersistentProtocol=D;class R extends O.Disposable{constructor(){super(),this.a=this.B(new r.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new r.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new r.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new E.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},L=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const L=++this.h,T=A.VSBuffer.alloc(4);T.writeUInt32BE(L,0),this.a.fire(T)},6e4)}handleResponse(L){if(L.byteLength!==4)return;const T=L.readUInt32BE(0);if(this.g<=0||T!==this.h)return;const U=Date.now()-this.g,H=this.k++;this.j[H%this.j.length]=U;const re=this.l,Y=this.j.filter(ne=>ne>=1e3).length;this.l=Y>=3?1:0,U>1e3&&this.b.fire(new g(U,Y)),re!==this.l&&this.c.fire(this.l)}}}),define(te[157],ie([0,1,38,17,4,2,43,143]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(w,m){const v=r.Event.fromNodeEventEmitter(E.validatedIpcMain,m,(b,p)=>({event:b,message:p})),u=r.Event.filter(v,({event:b})=>b.sender.id===w);return r.Event.map(u,({message:b})=>b&&A.VSBuffer.wrap(b))}class l extends M.IPCServer{static d(){const m=r.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:v})=>v);return r.Event.map(m,v=>{const u=v.id;l.b.get(u)?.dispose();const p=new r.Emitter;l.b.set(u,(0,O.toDisposable)(()=>p.fire()));const s=f(u,"vscode:message"),y=r.Event.any(r.Event.signal(f(u,"vscode:disconnect")),p.event);return{protocol:new P.Protocol(v,s),onDidClientDisconnect:y}})}constructor(){super(l.d())}}e.Server=l,l.b=new Map}),define(te[109],ie([0,1,38,4,31,156]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends O.Client{constructor(l,w){super({addEventListener:(m,v)=>l.addListener(m,v),removeEventListener:(m,v)=>l.removeListener(m,v),postMessage:m=>l.postMessage(m),start:()=>l.start(),close:()=>l.close()},w)}}e.Client=M;async function P(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,r.generateUuid)();f.webContents.send("vscode:createMessageChannel",l);const w=A.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(v,u)=>({nonce:u,port:v.ports[0]})),{port:m}=await A.Event.toPromise(A.Event.once(A.Event.filter(w,v=>v.nonce===l)));return m}e.connect=P}),define(te[158],ie([0,1,46,7,17,21,152,13,4,2,37,87,71,43]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class b extends u.ChannelServer{constructor(y){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",a=>r.VSBuffer.wrap(Buffer.from(a,"base64")))},y),process.once("disconnect",()=>this.dispose())}}e.Server=b;class p{constructor(y,a){this.i=y,this.j=a,this.c=new Set,this.g=new Map,this.h=new f.Emitter,this.onDidProcessExit=this.h.event;const d=a&&a.timeout?a.timeout:6e4;this.b=new A.Delayer(d),this.d=null,this.f=null}getChannel(y){const a=this;return{call(d,I,k){return a.k(y,d,I,k)},listen(d,I){return a.l(y,d,I)}}}k(y,a,d,I=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(I.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const k=this.n(y),t=(0,A.createCancelablePromise)(i=>k.call(a,d,i)),c=I.onCancellationRequested(()=>t.cancel()),n=(0,l.toDisposable)(()=>t.cancel());return this.c.add(n),t.finally(()=>{c.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(y,a,d){if(!this.b)return f.Event.None;this.b.cancel();let I;const k=new f.Emitter({onWillAddFirstListener:()=>{I=this.n(y).listen(a,d)(k.fire,k),this.c.add(I)},onDidRemoveLastListener:()=>{this.c.delete(I),I.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return k.event}get m(){if(!this.f){const y=this.j&&this.j.args?this.j.args:[],a=Object.create(null);a.env={...(0,w.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(a.env={...a.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(a.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(a.env),this.d=(0,E.fork)(this.i,y,a);const d=new f.Emitter;f.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,M.isRemoteConsoleLog)(o)){(0,M.log)(o,`IPC Library: ${this.j.serverName}`);return}d.fire(r.VSBuffer.wrap(Buffer.from(o,"base64")))});const k=this.j.useQueue?(0,m.createQueuedSender)(this.d):this.d,t=o=>this.d&&this.d.connected&&k.send(o.buffer.toString("base64")),c=d.event,n={send:t,onMessage:c};this.f=new u.ChannelClient(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,h)=>{process.removeListener("exit",i),this.c.forEach(g=>(0,l.dispose)(g)),this.c.clear(),o!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:h})})}return this.f}n(y){let a=this.g.get(y);return a||(a=this.m.getChannel(y),this.g.set(y,a)),a}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=p}),define(te[110],ie([0,1,7,4,2,73,11]),function(x,e,E,A,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var P;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function f(v){const u=v;return u?.changed instanceof Map||u?.deleted instanceof Set}e.isStorageItemsChangeEvent=f;var l;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(l||(e.StorageState=l={}));class w extends r.Disposable{constructor(u,b=Object.create(null)){super(),this.m=u,this.n=b,this.b=this.B(new A.Emitter),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=new E.ThrottledDelayer(w.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(u=>this.r(u)))}r(u){u.changed?.forEach((b,p)=>this.s(p,b)),u.deleted?.forEach(b=>this.s(b,void 0))}s(u,b){if(this.c===l.Closed)return;let p=!1;(0,M.isUndefinedOrNull)(b)?p=this.f.delete(u):this.f.get(u)!==b&&(this.f.set(u,b),p=!0),p&&this.b.fire(u)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.n.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(u,b){const p=this.f.get(u);return(0,M.isUndefinedOrNull)(p)?b:p}getBoolean(u,b){const p=this.get(u);return(0,M.isUndefinedOrNull)(p)?b:p==="true"}getNumber(u,b){const p=this.get(u);return(0,M.isUndefinedOrNull)(p)?b:parseInt(p,10)}getObject(u,b){const p=this.get(u);return(0,M.isUndefinedOrNull)(p)?b:(0,O.parse)(p)}async set(u,b){if(this.c===l.Closed)return;if((0,M.isUndefinedOrNull)(b))return this.delete(u);const p=(0,M.isObject)(b)||Array.isArray(b)?(0,O.stringify)(b):String(b);if(this.f.get(u)!==p)return this.f.set(u,p),this.j.set(u,p),this.h.delete(u),this.b.fire(u),this.w()}async delete(u){if(!(this.c===l.Closed||!this.f.delete(u)))return this.h.has(u)||this.h.add(u),this.j.delete(u),this.b.fire(u),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=l.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const u={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(u).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(u){if(this.u)return this.w(u)}async w(u){return this.g.trigger(()=>this.v(),u)}async whenFlushed(){if(this.u)return new Promise(u=>this.l.push(u))}isInMemory(){return this.n.hint===P.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=w,w.a=100;class m{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(u){u.insert?.forEach((b,p)=>this.a.set(p,b)),u.delete?.forEach(b=>this.a.delete(b))}async close(){}}e.InMemoryStorageDatabase=m}),define(te[159],ie([0,1,7,4,35,9,22]),function(x,e,E,A,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return A.Event.None}constructor(w,m=Object.create(null)){this.g=w,this.h=m,this.c=(0,O.basename)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const w=await this.f,m=new Map;return(await this.s(w,"SELECT * FROM ItemTable")).forEach(u=>m.set(u.key,u.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${m.size} rows`),m}async updateItems(w){const m=await this.f;return this.j(m,w)}j(w,m){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${m.insert?(0,r.mapToString)(m.insert):"0"}), delete(${m.delete?(0,r.setToString)(m.delete):"0"})`),this.t(w,()=>{const v=m.insert,u=m.delete;if(v&&v.size>0){const b=[];b.push([]);let p=0;v.forEach((s,y)=>{let a=b[p];a.length>P.b&&(p++,a=[],b.push(a)),a.push(y,s)}),b.forEach(s=>{this.u(w,`INSERT INTO ItemTable VALUES ${new Array(s.length/2).fill("(?,?)").join(",")}`,y=>y.run(s),()=>{const y=[];let a=0;return v.forEach((d,I)=>{y.push(I),a+=d.length}),`Keys: ${y.join(", ")} Length: ${a}`})})}if(u&&u.size){const b=[];b.push([]);let p=0;u.forEach(s=>{let y=b[p];y.length>P.b&&(p++,y=[],b.push(y)),y.push(s)}),b.forEach(s=>{this.u(w,`DELETE FROM ItemTable WHERE key IN (${new Array(s.length).fill("?").join(",")})`,y=>y.run(s),()=>{const y=[];return u.forEach(a=>{y.push(a)}),`Keys: ${y.join(", ")}`})})}})}async close(w){this.d.trace(`[storage ${this.c}] close()`);const m=await this.f;return this.k(m,w)}k(w,m){return new Promise((v,u)=>{w.db.close(b=>(b&&this.o(w,`[storage ${this.c}] close(): ${b}`),this.g===P.IN_MEMORY_PATH?v():!w.isErroneous&&!w.isInMemory?this.l().then(v,p=>(this.d.error(`[storage ${this.c}] backup(): ${p}`),v())):typeof m=="function"?M.Promises.unlink(this.g).then(()=>this.p(this.g).then(p=>{const s=()=>this.k(p,void 0);return this.j(p,{insert:m()}).then(()=>s(),y=>(s(),Promise.reject(y)))})).then(v,u):u(b||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const w=this.m(this.g);return M.Promises.copy(this.g,w,{preserveSymlinks:!1})}m(w){return`${w}.backup`}async checkIntegrity(w){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${w})`);const m=await this.f,v=await this.r(m,w?"PRAGMA integrity_check":"PRAGMA quick_check"),u=w?v.integrity_check:v.quick_check;return m.isErroneous?`${u} (last error: ${m.lastError})`:m.isInMemory?`${u} (in-memory!)`:u}async n(w,m=!0){this.d.trace(`[storage ${this.c}] open(${w}, retryOnBusy: ${m})`);try{return await this.p(w)}catch(v){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&m)return await(0,E.timeout)(P.a),this.n(w,!1);try{await M.Promises.unlink(w);try{await M.Promises.rename(this.m(w),w)}catch{}return await this.p(w)}catch(u){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${u}`),this.p(P.IN_MEMORY_PATH)}}}o(w,m){w.isErroneous=!0,w.lastError=m,this.d.error(m)}p(w){return new Promise((m,v)=>{new Promise((u,b)=>{x(["@vscode/sqlite3"],u,b)}).then(u=>{const b={db:new(this.d.isTracing?u.verbose().Database:u.Database)(w,p=>p?b.db&&p.code!=="SQLITE_CANTOPEN"?b.db.close(()=>v(p)):v(p):this.q(b,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>m(b),s=>b.db.close(()=>v(s)))),isInMemory:w===P.IN_MEMORY_PATH};b.db.on("error",p=>this.o(b,`[storage ${this.c}] Error (event): ${p}`)),this.d.isTracing&&b.db.on("trace",p=>this.d.trace(`[storage ${this.c}] Trace (event): ${p}`))},v)})}q(w,m){return new Promise((v,u)=>{w.db.exec(m,b=>b?(this.o(w,`[storage ${this.c}] exec(): ${b}`),u(b)):v())})}r(w,m){return new Promise((v,u)=>{w.db.get(m,(b,p)=>b?(this.o(w,`[storage ${this.c}] get(): ${b}`),u(b)):v(p))})}s(w,m){return new Promise((v,u)=>{w.db.all(m,(b,p)=>b?(this.o(w,`[storage ${this.c}] all(): ${b}`),u(b)):v(p))})}t(w,m){return new Promise((v,u)=>{w.db.serialize(()=>{w.db.run("BEGIN TRANSACTION"),m(),w.db.run("END TRANSACTION",b=>b?(this.o(w,`[storage ${this.c}] transaction(): ${b}`),u(b)):v())})})}u(w,m,v,u){const b=w.db.prepare(m),p=s=>{this.o(w,`[storage ${this.c}] prepare(): ${s} (${m}). Details: ${u()}`)};b.on("error",p),v(b),b.finalize(s=>{s&&p(s),b.removeListener("error",p)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.a=2e3,P.b=256;class f{constructor(w){w&&typeof w.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.a=w.logTrace),w&&typeof w.logError=="function"&&(this.b=w.logError)}get isTracing(){return!!this.a}trace(w){this.a?.(w)}error(w){this.b?.(w)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(te[160],ie([12,10]),function(x,e){return x.create("vs/code/electron-main/app",e)}),define(te[161],ie([12,10]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[162],ie([12,10]),function(x,e){return x.create("vs/platform/contextkey/common/contextkey",e)}),define(te[163],ie([12,10]),function(x,e){return x.create("vs/platform/contextkey/common/scanner",e)}),define(te[164],ie([12,10]),function(x,e){return x.create("vs/platform/dialogs/common/dialogs",e)}),define(te[165],ie([12,10]),function(x,e){return x.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[166],ie([12,10]),function(x,e){return x.create("vs/platform/environment/node/argv",e)}),define(te[167],ie([12,10]),function(x,e){return x.create("vs/platform/environment/node/argvHelper",e)}),define(te[168],ie([12,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[169],ie([12,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[170],ie([12,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[171],ie([12,10]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[172],ie([12,10]),function(x,e){return x.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[173],ie([12,10]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(te[174],ie([12,10]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(te[175],ie([12,10]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(te[176],ie([12,10]),function(x,e){return x.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[177],ie([12,10]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[178],ie([12,10]),function(x,e){return x.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[179],ie([12,10]),function(x,e){return x.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[180],ie([12,10]),function(x,e){return x.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[181],ie([12,10]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(te[182],ie([12,10]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(te[183],ie([12,10]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[184],ie([12,10]),function(x,e){return x.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[185],ie([12,10]),function(x,e){return x.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[186],ie([12,10]),function(x,e){return x.create("vs/platform/update/common/update.config.contribution",e)}),define(te[187],ie([12,10]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[188],ie([12,10]),function(x,e){return x.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[189],ie([12,10]),function(x,e){return x.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[190],ie([12,10]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(te[191],ie([12,10]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[192],ie([12,10]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[193],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(r){return r&&r.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function A(r){return r&&r.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=A}),define(te[194],ie([0,1,8]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function A(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=A;function r(M){let P=[];try{Array.isArray(M.workspaces)&&(P=M.workspaces.map(f=>({workspace:{id:f.id,configPath:E.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=r;function O(M){let P=[];try{Array.isArray(M.folders)&&(P=M.folders.map(f=>({folderUri:E.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=O}),define(te[195],ie([0,1,13,163]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var r;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(r||(e.TokenType=r={}));function O(...l){switch(l.length){case 1:return(0,A.localize)(0,null,l[0]);case 2:return(0,A.localize)(1,null,l[0],l[1]);case 3:return(0,A.localize)(2,null,l[0],l[1],l[2]);default:return}}const M=(0,A.localize)(3,null),P=(0,A.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return w.isTripleEq?"===":"==";case 4:return w.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return w.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return w.lexeme;case 18:return w.lexeme;case 19:return w.lexeme;case 20:return"EOF";default:throw(0,E.illegalState)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(w){return this.c=w,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const m=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:m})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const m=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:m})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(w){return this.r()||this.c.charCodeAt(this.e)!==w?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(w){this.f.push({type:w,offset:this.d})}l(w){const m=this.d,v=this.c.substring(this.d,this.e),u={type:19,offset:this.d,lexeme:v};this.g.push({offset:m,lexeme:v,additionalInfo:w}),this.f.push(u)}n(){this.m.lastIndex=this.d;const w=this.m.exec(this.c);if(w){this.e=this.d+w[0].length;const m=this.c.substring(this.d,this.e),v=f.b.get(m);v?this.k(v):this.f.push({type:17,lexeme:m,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let w=this.e,m=!1,v=!1;for(;;){if(w>=this.c.length){this.e=w,this.l(P);return}const b=this.c.charCodeAt(w);if(m)m=!1;else if(b===47&&!v){w++;break}else b===91?v=!0:b===92?m=!0:b===93&&(v=!1);w++}for(;w<this.c.length&&f.a.has(this.c.charCodeAt(w));)w++;this.e=w;const u=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:u,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=f,f.a=new Set(["i","g","s","m","y","u"].map(l=>l.charCodeAt(0))),f.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(te[196],ie([0,1,4,2]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class r{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(P,f,l){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(P,f,l){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=r,r.ChannelName="extensionhostdebugservice";class O extends A.Disposable{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,f,l){this.b.call("attach",[P,f,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,f){this.b.call("terminate",[P,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,f){return this.b.call("openExtensionDevelopmentHostWindow",[P,f])}}e.ExtensionHostDebugChannelClient=O}),define(te[197],ie([0,1,146,55,14,9,36,18,8]),function(x,e,E,A,r,O,M,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,O.dirname)(r.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,O.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.join)(this.userDataPath,"logs",u)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(f.URI.file((0,O.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=M.env.VSCODE_PORTABLE;return u?f.URI.file((0,O.join)(u,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,O.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,O.resolve)(u):(0,O.normalize)((0,O.join)(r.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?f.URI.file((0,O.resolve)(u)):f.URI.file((0,O.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,O.resolve)(u);const b=M.env.VSCODE_EXTENSIONS;if(b)return b;const p=M.env.VSCODE_PORTABLE;return p?(0,O.join)(p,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(b=>/^[^:/?#]+?:\/\//.test(b)?f.URI.parse(b):f.URI.file((0,O.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?f.URI.parse(u):f.URI.file((0,O.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(u))}get extensionLogLevel(){const u=[];for(const b of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(b);p&&p[1]&&p[2]&&u.push([p[1],p[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=M.env.VSCODE_PORTABLE;return u?f.URI.file((0,O.join)(u,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,b,p){this.a=u,this.b=b,this.c=p,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,ve([A.memoize],l.prototype,"appRoot",null),ve([A.memoize],l.prototype,"userHome",null),ve([A.memoize],l.prototype,"userDataPath",null),ve([A.memoize],l.prototype,"appSettingsHome",null),ve([A.memoize],l.prototype,"tmpDir",null),ve([A.memoize],l.prototype,"cacheHome",null),ve([A.memoize],l.prototype,"stateResource",null),ve([A.memoize],l.prototype,"userRoamingDataHome",null),ve([A.memoize],l.prototype,"userDataSyncHome",null),ve([A.memoize],l.prototype,"sync",null),ve([A.memoize],l.prototype,"machineSettingsResource",null),ve([A.memoize],l.prototype,"workspaceStorageHome",null),ve([A.memoize],l.prototype,"localHistoryHome",null),ve([A.memoize],l.prototype,"keyboardLayoutResource",null),ve([A.memoize],l.prototype,"argvResource",null),ve([A.memoize],l.prototype,"isExtensionDevelopment",null),ve([A.memoize],l.prototype,"untitledWorkspacesHome",null),ve([A.memoize],l.prototype,"builtinExtensionsPath",null),ve([A.memoize],l.prototype,"extensionsPath",null),ve([A.memoize],l.prototype,"extensionDevelopmentLocationURI",null),ve([A.memoize],l.prototype,"extensionDevelopmentKind",null),ve([A.memoize],l.prototype,"extensionTestsLocationURI",null),ve([A.memoize],l.prototype,"debugExtensionHost",null),ve([A.memoize],l.prototype,"logLevel",null),ve([A.memoize],l.prototype,"extensionLogLevel",null),ve([A.memoize],l.prototype,"serviceMachineIdResource",null),ve([A.memoize],l.prototype,"disableTelemetry",null),ve([A.memoize],l.prototype,"disableWorkspaceTrust",null),ve([A.memoize],l.prototype,"policyFile",null);function w(v,u){return m(v["inspect-extensions"],v["inspect-brk-extensions"],5870,u,v.debugId,v.extensionEnvironment)}e.parseExtensionHostDebugPort=w;function m(v,u,b,p,s,y){const d=Number(u||v)||(p?null:b),I=d?!!u:!1;let k;if(y)try{k=JSON.parse(y)}catch{}return{port:d,break:I,debugId:s,env:k}}e.parseDebugParams=m}),define(te[111],ie([0,1,305,3,166]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const O={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},category:{type:"string",cat:"e",description:(0,r.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(p,s,y=M){const a=p.find(h=>h.length>0&&h[0]!=="-"),d={},I=["_"],k=[],t={};let c;for(const h in s){const g=s[h];g.type==="subcommand"?h===a&&(c=g):(g.alias&&(d[h]=g.alias),g.type==="string"||g.type==="string[]"?(I.push(h),g.deprecates&&I.push(...g.deprecates)):g.type==="boolean"&&(k.push(h),g.deprecates&&k.push(...g.deprecates)),g.global&&(t[h]=g))}if(c&&a){const h=t;for(const S in c.options)h[S]=c.options[S];const g=p.filter(S=>S!==a),D=y.getSubcommandReporter?y.getSubcommandReporter(a):void 0,R=P(g,h,D);return{[a]:R,_:[]}}const n=E(p,{string:I,boolean:k,alias:d}),i={},o=n;i._=n._.map(h=>String(h)).filter(h=>h.length>0),delete o._;for(const h in s){const g=s[h];if(g.type==="subcommand")continue;g.alias&&delete o[g.alias];let D=o[h];if(g.deprecates)for(const R of g.deprecates)o.hasOwnProperty(R)&&(D||(D=o[R],D&&y.onDeprecatedOption(R,g.deprecationMessage||(0,r.localize)(35,null,h))),delete o[R]);if(typeof D<"u"){if(g.type==="string[]"){if(Array.isArray(D)||(D=[D]),!g.allowEmptyValue){const R=D.filter(S=>S.length>0);R.length!==D.length&&(y.onEmptyValue(h),D=R.length>0?R:void 0)}}else g.type==="string"&&(Array.isArray(D)?(D=D.pop(),y.onMultipleValues(h,D)):!D&&!g.allowEmptyValue&&(y.onEmptyValue(h),D=void 0));i[h]=D,g.deprecationMessage&&y.onDeprecatedOption(h,g.deprecationMessage)}delete o[h]}for(const h in o)y.onUnknownOption(h);return i}e.parseArgs=P;function f(p,s){let y="";return s.args&&(Array.isArray(s.args)?y=` <${s.args.join("> <")}>`:y=` <${s.args}>`),s.alias?`-${s.alias} --${p}${y}`:`--${p}${y}`}function l(p,s){const y=[];for(const a in p){const d=p[a],I=f(a,d);y.push([I,d.description])}return w(y,s)}e.formatOptions=l;function w(p,s){const a=p.reduce((k,t)=>Math.max(k,t[0].length),12)+2+1;if(s-a<25)return p.reduce((k,t)=>k.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const d=s-a-1,I=[];for(const k of p){const t=k[0],c=v(k[1],d),n=m(a-t.length-2);I.push("  "+t+n+c[0]);for(let i=1;i<c.length;i++)I.push(m(a)+c[i])}return I}function m(p){return" ".repeat(p)}function v(p,s){const y=[];for(;p.length;){const a=p.length<s?p.length:p.lastIndexOf(" ",s),d=p.slice(0,a).trim();p=p.slice(a),y.push(d)}return y}function u(p,s,y,a,d){const I=process.stdout.isTTY&&process.stdout.columns||80,k=d?.noInputFiles!==!0?`[${(0,r.localize)(36,null)}...]`:"",t=[`${p} ${y}`];t.push(""),t.push(`${(0,r.localize)(37,null)}: ${s} [${(0,r.localize)(38,null)}]${k}`),t.push(""),d?.noPipe!==!0&&(A.isWindows?t.push((0,r.localize)(39,null,s)):t.push((0,r.localize)(40,null,s)),t.push(""));const c={},n=[];for(const i in a){const o=a[i];if(o.type==="subcommand")o.description&&n.push({command:i,description:o.description});else if(o.description&&o.cat){let h=c[o.cat];h||(c[o.cat]=h={}),h[i]=o}}for(const i in c){const o=i,h=c[o];h&&(t.push(O[o]),t.push(...l(h,I)),t.push(""))}return n.length&&(t.push((0,r.localize)(41,null)),t.push(...w(n.map(i=>[i.command,i.description]),I)),t.push("")),t.join(`
`)}e.buildHelpMessage=u;function b(p,s){return`${p||(0,r.localize)(42,null)}
${s||(0,r.localize)(43,null)}
${process.arch}`}e.buildVersionMessage=b}),define(te[198],ie([0,1,84,196,111]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class O extends A.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.f=P}call(P,f,l){return f==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(P,f,l)}async g(P,f){const l=(0,r.parseArgs)(P,r.OPTIONS);l.debugRenderer=f;const w=l.extensionDevelopmentPath;if(!w)return{success:!1};const[m]=await this.f.openExtensionDevelopmentHostWindow(w,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!f)return{success:!0};const v=m.win;if(!v)return{success:!0};const u=v.webContents.debugger;let b=u.isAttached()?1/0:0;const p=(0,E.createServer)(s=>{b++===0&&u.attach();let y=!1;const a=k=>{y||s.write(JSON.stringify(k)+"\0")},d=(k,t,c,n)=>a({method:t,params:c,sessionId:n});v.on("close",()=>{u.removeListener("message",d),s.end(),y=!0}),u.addListener("message",d);let I=Buffer.alloc(0);s.on("data",k=>{I=Buffer.concat([I,k]);for(let t=I.indexOf(0);t!==-1;t=I.indexOf(0)){let c;try{const n=I.slice(0,t).toString("utf8");I=I.slice(t+1),c=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}u.sendCommand(c.method,c.params,c.sessionId).then(n=>a({id:c.id,sessionId:c.sessionId,result:n})).catch(n=>a({id:c.id,sessionId:c.sessionId,error:{code:0,message:n.message}}))}}),s.on("error",k=>{console.error("error on cdp pipe:",k)}),s.on("close",()=>{y=!0,--b===0&&u.detach()})});return await new Promise(s=>p.listen(0,s)),v.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=O}),define(te[63],ie([0,1,306,167,111]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function O(m,v){const u=(d,I)=>{console.warn((0,A.localize)(0,null,d,I))},b=d=>{console.warn((0,A.localize)(1,null,d))},p=(d,I)=>{console.warn((0,A.localize)(2,null,d,I))},s=d=>({onUnknownOption:I=>{d!=="tunnel"&&console.warn((0,A.localize)(3,null,I,d))},onMultipleValues:u,onEmptyValue:b,onDeprecatedOption:p,getSubcommandReporter:d!=="tunnel"?s:void 0}),y={onUnknownOption:d=>{console.warn((0,A.localize)(4,null,d))},onMultipleValues:u,onEmptyValue:b,onDeprecatedOption:p,getSubcommandReporter:s},a=(0,r.parseArgs)(m,r.OPTIONS,v?y:void 0);return a.goto&&a._.forEach(d=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,A.localize)(5,null))),a}function M(m){const v=m.findIndex(u=>!/^-/.test(u));if(v>-1)return[...m.slice(0,v),...m.slice(v+1)]}function P(m){let[,...v]=m;process.env.VSCODE_DEV&&(v=M(v)||[]);const u=!w(process.env);return O(v,u)}e.parseMainProcessArgv=P;function f(m){let[,,...v]=m;return process.env.VSCODE_DEV&&(v=M(v)||[]),O(v,!0)}e.parseCLIProcessArgv=f;function l(m,...v){const u=m.indexOf("--");return u===-1?m.push(...v):m.splice(u,0,...v),m}e.addArg=l;function w(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function x(e,E,A){function r(M,P){const f=O(M,P),l=[f];return e.isAbsolute(f)||l.unshift(A),e.resolve(...l)}function O(M,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,P);const w=M["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(m,"AppData","Roaming")}break;case"darwin":l=e.join(E.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,P)}return{getUserDataPath:r}}if(typeof define=="function")define(te[199],ie([112,27,36]),function(e,E,A){return x(e,E,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=x(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[88],ie([0,1,27,197,199]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class O extends A.AbstractNativeEnvironmentService{constructor(l,w){super(l,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,r.getUserDataPath)(l,w.nameShort)},w)}}e.NativeEnvironmentService=O;function M(f,l){return(0,A.parseDebugParams)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,l,f.extensionEnvironment)}e.parsePtyHostDebugPort=M;function P(f,l){return(0,A.parseDebugParams)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,l,f.extensionEnvironment)}e.parseSharedProcessDebugPort=P}),define(te[200],ie([0,1,42,27,32]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function O(M){const P=(0,r.randomPath)((0,A.tmpdir)());try{return(0,E.writeFileSync)(P,""),M&&console.log(`Marker file for --wait created: ${P}`),P}catch(f){M&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFileSync=O}),define(te[201],ie([0,1,11,169]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function r(M,P,f){try{O(M,P,f)}catch(l){console.error(l?.message??l)}return M}e.localizeManifest=r;function O(M,P,f){const l=(w,m,v)=>{const u=w[m];if((0,E.isString)(u)){const b=u,p=b.length;if(p>1&&b[0]==="%"&&b[p-1]==="%"){const s=b.substr(1,p-2);let y=P[s];y===void 0&&f&&(y=f[s]);const a=typeof y=="string"?y:y?.message,d=f?.[s],I=typeof d=="string"?d:d?.message;if(!a){I||console.warn(`[${M.name}]: ${(0,A.localize)(0,null,s)}`);return}if(v&&(m==="title"||m==="category")&&I&&I!==a){const k={value:a,original:I};w[m]=k}else w[m]=a}}else if((0,E.isObject)(u))for(const b in u)u.hasOwnProperty(b)&&(b==="commands"?l(u,b,!0):l(u,b,v));else if(Array.isArray(u))for(let b=0;b<u.length;b++)l(u,b,v)};for(const w in M)M.hasOwnProperty(w)&&l(M,w)}}),define(te[202],ie([0,1,18,72,171,203]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function f(y){return y=y.trim(),y==="*"||M.test(y)}e.isValidVersionStr=f;function l(y){if(!f(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=y.match(M);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.parseVersion=l;function w(y){if(!y)return null;const a=y.majorBase,d=y.majorMustEqual,I=y.minorBase;let k=y.minorMustEqual;const t=y.patchBase;let c=y.patchMustEqual;y.hasCaret&&(a===0||(k=!1),c=!1);let n=0;if(y.preRelease){const i=P.exec(y.preRelease);if(i){const[,o,h,g]=i;n=Date.UTC(Number(o),Number(h)-1,Number(g))}}return{majorBase:a,majorMustEqual:d,minorBase:I,minorMustEqual:k,patchBase:t,patchMustEqual:c,isMinimum:y.hasGreaterEquals,notBefore:n}}e.normalizeVersion=w;function m(y,a,d){let I;typeof y=="string"?I=w(l(y)):I=y;let k;a instanceof Date?k=a.getTime():typeof a=="string"&&(k=new Date(a).getTime());let t;if(typeof d=="string"?t=w(l(d)):t=d,!I||!t)return!1;const c=I.majorBase,n=I.minorBase,i=I.patchBase;let o=t.majorBase,h=t.minorBase,g=t.patchBase;const D=t.notBefore;let R=t.majorMustEqual,S=t.minorMustEqual,L=t.patchMustEqual;return t.isMinimum?c>o?!0:c<o?!1:n>h?!0:n<h||k&&k<D?!1:i>=g:(c===1&&o===0&&(!R||!S||!L)&&(o=1,h=0,g=0,R=!0,S=!1,L=!1),c<o?!1:c>o?!R:n<h?!1:n>h?!S:i<g?!1:i>g?!L:!(k&&k<D))}e.isValidVersion=m;function v(y,a,d,I,k){const t=[];if(typeof I.publisher<"u"&&typeof I.publisher!="string")return t.push([A.default.Error,r.localize(0,null)]),t;if(typeof I.name!="string")return t.push([A.default.Error,r.localize(1,null,"name")]),t;if(typeof I.version!="string")return t.push([A.default.Error,r.localize(2,null,"version")]),t;if(!I.engines)return t.push([A.default.Error,r.localize(3,null,"engines")]),t;if(typeof I.engines.vscode!="string")return t.push([A.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof I.extensionDependencies<"u"&&!s(I.extensionDependencies))return t.push([A.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof I.activationEvents<"u"){if(!s(I.activationEvents))return t.push([A.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof I.main>"u"&&typeof I.browser>"u")return t.push([A.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof I.extensionKind<"u"&&typeof I.main>"u"&&t.push([A.default.Warning,r.localize(8,null,"extensionKind")]),typeof I.main<"u"){if(typeof I.main!="string")return t.push([A.default.Error,r.localize(9,null,"main")]),t;{const i=(0,E.joinPath)(d,I.main);(0,E.isEqualOrParent)(i,d)||t.push([A.default.Warning,r.localize(10,null,i.path,d.path)])}}if(typeof I.browser<"u"){if(typeof I.browser!="string")return t.push([A.default.Error,r.localize(11,null,"browser")]),t;{const i=(0,E.joinPath)(d,I.browser);(0,E.isEqualOrParent)(i,d)||t.push([A.default.Warning,r.localize(12,null,i.path,d.path)])}}if(!O.valid(I.version))return t.push([A.default.Error,r.localize(13,null)]),t;const c=[];if(!u(y,a,I,k,c))for(const i of c)t.push([A.default.Error,i]);return t}e.validateExtensionManifest=v;function u(y,a,d,I,k){return I||typeof d.main>"u"&&typeof d.browser>"u"?!0:p(y,a,d.engines.vscode,k)}e.isValidExtensionVersion=u;function b(y,a,d){return y==="*"||p(a,d,y)}e.isEngineValid=b;function p(y,a,d,I=[]){const k=w(l(d));if(!k)return I.push(r.localize(14,null,d)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return I.push(r.localize(15,null,d)),!1}else if(!k.majorMustEqual)return I.push(r.localize(16,null,d)),!1;return m(y,a,k)?!0:(I.push(r.localize(17,null,y,d)),!1)}function s(y){if(!Array.isArray(y))return!1;for(let a=0,d=y.length;a<d;a++)if(typeof y[a]!="string")return!1;return!0}}),define(te[204],ie([0,1,17,31]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function r(O,M,P){let f=P&&P.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const w=(await M.readFile(O.serviceMachineIdResource)).value.toString();f=(0,A.isUUID)(w)?w:null}catch{f=null}if(!f){f=(0,A.generateUuid)();try{await M.writeFile(O.serviceMachineIdResource,E.VSBuffer.fromString(f))}catch{}}return P?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=r}),define(te[74],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(r,O=[],M=!1){this.ctor=r,this.staticArguments=O,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=E}),define(te[205],ie([0,1,74]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var r;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function O(P,f,l){f instanceof E.SyncDescriptor||(f=new E.SyncDescriptor(f,[],!!l)),A.push([P,f])}e.registerSingleton=O;function M(){return A}e.getSingletonServiceDescriptors=M}),define(te[206],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(O,M){this.key=O,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class A{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const M of this.a.values())M.outgoing.size===0&&O.push(M);return O}insertEdge(O,M){const P=this.lookupOrInsertNode(O),f=this.lookupOrInsertNode(M);P.outgoing.set(f.key,f),f.incoming.set(P.key,P)}removeNode(O){const M=this.b(O);this.a.delete(M);for(const P of this.a.values())P.outgoing.delete(M),P.incoming.delete(M)}lookupOrInsertNode(O){const M=this.b(O);let P=this.a.get(M);return P||(P=new E(M,O),this.a.set(M,P)),P}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[M,P]of this.a)O.push(`${M}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,M]of this.a){const P=new Set([O]),f=this.c(M,P);if(f)return f}}c(O,M){for(const[P,f]of O.outgoing){if(M.has(P))return[...M,P].join(" -> ");M.add(P);const l=this.c(f,M);if(l)return l;M.delete(P)}}}e.Graph=A}),define(te[6],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function P(f){return f[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=P})(E||(e._util=E={})),e.IInstantiationService=r("instantiationService");function A(M,P,f){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:M,index:f}):(P[E.DI_DEPENDENCIES]=[{id:M,index:f}],P[E.DI_TARGET]=P)}function r(M){if(E.serviceIds.has(M))return E.serviceIds.get(M);const P=function(f,l,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,f,w)};return P.toString=()=>M,E.serviceIds.set(M,P),P}e.createDecorator=r;function O(M){return M}e.refineServiceDecorator=O}),define(te[64],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(te[19],ie([0,1,11,8,6]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,r.createDecorator)("configurationService");function O(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof A.URI)}e.isConfigurationOverrides=O;function M(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=M;var P;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function f(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function l(s,y){const a=Object.create(null);for(const d in s)w(a,d,s[d],y);return a}e.toValuesTree=l;function w(s,y,a,d){const I=y.split("."),k=I.pop();let t=s;for(let c=0;c<I.length;c++){const n=I[c];let i=t[n];switch(typeof i){case"undefined":i=t[n]=Object.create(null);break;case"object":break;default:d(`Ignoring ${y} as ${I.slice(0,c+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[k]=a}catch{d(`Ignoring ${y} as ${I.join(".")} is ${JSON.stringify(t)}`)}else d(`Ignoring ${y} as ${I.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=w;function m(s,y){const a=y.split(".");v(s,a)}e.removeFromValueTree=m;function v(s,y){const a=y.shift();if(y.length===0){delete s[a];return}if(Object.keys(s).indexOf(a)!==-1){const d=s[a];typeof d=="object"&&!Array.isArray(d)&&(v(d,y),Object.keys(d).length===0&&delete s[a])}}function u(s,y,a){function d(t,c){let n=t;for(const i of c){if(typeof n!="object"||n===null)return;n=n[i]}return n}const I=y.split("."),k=d(s,I);return typeof k>"u"?a:k}e.getConfigurationValue=u;function b(s,y,a){Object.keys(y).forEach(d=>{d!=="__proto__"&&(d in s?E.isObject(s[d])&&E.isObject(y[d])?b(s[d],y[d],a):a&&(s[d]=y[d]):s[d]=y[d])})}e.merge=b;function p(s){return s.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(te[113],ie([0,1,3,25,195,6,162,13]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",E.isMacintosh),f.set("isLinux",E.isLinux),f.set("isWindows",E.isWindows),f.set("isWeb",E.isWeb),f.set("isMacNative",E.isMacintosh&&!E.isWeb),f.set("isEdge",E.isEdge),f.set("isFirefox",E.isFirefox),f.set("isChrome",E.isChrome),f.set("isSafari",E.isSafari);function l(B,C){if(f.get(B)!==void 0)throw(0,P.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(B,C)}e.setConstant=l;const w=Object.prototype.hasOwnProperty;var m;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const v={regexParsingWithErrorRecovery:!0},u=(0,M.localize)(0,null),b=(0,M.localize)(1,null),p=(0,M.localize)(2,null),s=(0,M.localize)(3,null),y=(0,M.localize)(4,null),a=(0,M.localize)(5,null),d=(0,M.localize)(6,null),I=(0,M.localize)(7,null);class k{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(C=v){this.k=C,this.d=new r.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(C){if(C===""){this.h.push({message:u,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(C).scan(),this.g=0,this.h=[];try{const W=this.l();if(!this.E()){const z=this.D(),q=z.type===17?a:void 0;throw this.h.push({message:y,offset:z.offset,lexeme:r.Scanner.getLexeme(z),additionalInfo:q}),k.c}return W}catch(W){if(W!==k.c)throw W;return}}l(){return this.m()}m(){const C=[this.o()];for(;this.y(16);){const W=this.o();C.push(W)}return C.length===1?C[0]:t.or(...C)}o(){const C=[this.s()];for(;this.y(15);){const W=this.s();C.push(W)}return C.length===1?C[0]:t.and(...C)}s(){if(this.y(2)){const C=this.D();switch(C.type){case 11:return this.z(),o.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const W=this.l();return this.A(1,s),W?.negate()}case 17:return this.z(),T.create(C.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",C)}}return this.t()}t(){const C=this.D();switch(C.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const W=this.l();return this.A(1,s),W}case 17:{const W=C.lexeme;if(this.z(),this.y(9)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==10)throw this.B("REGEX",q);const j=q.lexeme,$=j.lastIndexOf("/"),K=$===j.length-1?void 0:this.w(j.substring($+1));let se;try{se=new RegExp(j.substring(1,$),K)}catch{throw this.B("REGEX",q)}return ce.create(W,se)}switch(q.type){case 10:case 19:{const j=[q.lexeme];this.z();let $=this.D(),K=0;for(let Me=0;Me<q.lexeme.length;Me++)q.lexeme.charCodeAt(Me)===40?K++:q.lexeme.charCodeAt(Me)===41&&K--;for(;!this.E()&&$.type!==15&&$.type!==16;){switch($.type){case 0:K++;break;case 1:K--;break;case 10:case 18:for(let Me=0;Me<$.lexeme.length;Me++)$.lexeme.charCodeAt(Me)===40?K++:q.lexeme.charCodeAt(Me)===41&&K--}if(K<0)break;j.push(r.Scanner.getLexeme($)),this.z(),$=this.D()}const se=j.join(""),ue=se.lastIndexOf("/"),be=ue===se.length-1?void 0:this.w(se.substring(ue+1));let ke;try{ke=new RegExp(se.substring(1,ue),be)}catch{throw this.B("REGEX",q)}return t.regex(W,ke)}case 18:{const j=q.lexeme;this.z();let $=null;if(!(0,A.isFalsyOrWhitespace)(j)){const K=j.indexOf("/"),se=j.lastIndexOf("/");if(K!==se&&K>=0){const ue=j.slice(K+1,se),be=j[se+1]==="i"?"i":"";try{$=new RegExp(ue,be)}catch{throw this.B("REGEX",q)}}}if($===null)throw this.B("REGEX",q);return ce.create(W,$)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const q=this.u();return t.notIn(W,q)}switch(this.D().type){case 3:{this.z();const q=this.u();if(this.x().type===18)return t.equals(W,q);switch(q){case"true":return t.has(W);case"false":return t.not(W);default:return t.equals(W,q)}}case 4:{this.z();const q=this.u();if(this.x().type===18)return t.notEquals(W,q);switch(q){case"true":return t.not(W);case"false":return t.has(W);default:return t.notEquals(W,q)}}case 5:return this.z(),Y.create(W,this.u());case 6:return this.z(),ne.create(W,this.u());case 7:return this.z(),H.create(W,this.u());case 8:return this.z(),re.create(W,this.u());case 13:return this.z(),t.in(W,this.u());default:return t.has(W)}}case 20:throw this.h.push({message:d,offset:C.offset,lexeme:"",additionalInfo:I}),k.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const C=this.D();switch(C.type){case 17:case 18:return this.z(),C.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(C){return C.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(C){return this.C(C)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(C,W){if(this.C(C))return this.z();throw this.B(W,this.D())}B(C,W,z){const q=(0,M.localize)(8,null,C,r.Scanner.getLexeme(W)),j=W.offset,$=r.Scanner.getLexeme(W);return this.h.push({message:q,offset:j,lexeme:$,additionalInfo:z}),k.c}C(C){return this.D().type===C}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=k,k.c=new Error;class t{static false(){return o.INSTANCE}static true(){return h.INSTANCE}static has(C){return g.create(C)}static equals(C,W){return D.create(C,W)}static notEquals(C,W){return L.create(C,W)}static regex(C,W){return ce.create(C,W)}static in(C,W){return R.create(C,W)}static notIn(C,W){return S.create(C,W)}static not(C){return T.create(C)}static and(...C){return G.create(C,null,!0)}static or(...C){return N.create(C,null,!0)}static greater(C,W){return H.create(C,W)}static greaterEquals(C,W){return re.create(C,W)}static smaller(C,W){return Y.create(C,W)}static smallerEquals(C,W){return ne.create(C,W)}static deserialize(C){return C==null?void 0:this.c.parse(C)}}e.ContextKeyExpr=t,t.c=new k({regexParsingWithErrorRecovery:!1});function c(B){const C=new k({regexParsingWithErrorRecovery:!1});return B.map(W=>(C.parse(W),C.lexingErrors.length>0?C.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,M.localize)(9,null,z.additionalInfo):(0,M.localize)(10,null),offset:z.offset,length:z.lexeme.length})):C.parsingErrors.length>0?C.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.validateWhenClauses=c;function n(B,C){const W=B?B.substituteConstants():void 0,z=C?C.substituteConstants():void 0;return!W&&!z?!0:!W||!z?!1:W.equals(z)}e.expressionsAreEqualWithConstantSubstitution=n;function i(B,C){return B.cmp(C)}class o{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=o,o.INSTANCE=new o;class h{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return o.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class g{static create(C,W=null){const z=f.get(C);return typeof z=="boolean"?z?h.INSTANCE:o.INSTANCE:new g(C,W)}constructor(C,W){this.key=C,this.c=W,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:V(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=f.get(this.key);return typeof C=="boolean"?C?h.INSTANCE:o.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=g;class D{static create(C,W,z=null){if(typeof W=="boolean")return W?g.create(C,z):T.create(C,z);const q=f.get(C);return typeof q=="boolean"?W===(q?"true":"false")?h.INSTANCE:o.INSTANCE:new D(C,W,z)}constructor(C,W,z){this.c=C,this.d=W,this.f=z,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:J(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=f.get(this.c);if(typeof C=="boolean"){const W=C?"true":"false";return this.d===W?h.INSTANCE:o.INSTANCE}return this}evaluate(C){return C.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(C){return C.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=D;class R{static create(C,W){return new R(C,W)}constructor(C,W){this.d=C,this.f=W,this.type=10,this.c=null}cmp(C){return C.type!==this.type?this.type-C.type:J(this.d,this.f,C.d,C.f)}equals(C){return C.type===this.type?this.d===C.d&&this.f===C.f:!1}substituteConstants(){return this}evaluate(C){const W=C.getValue(this.f),z=C.getValue(this.d);return Array.isArray(W)?W.includes(z):typeof z=="string"&&typeof W=="object"&&W!==null?w.call(W,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(C){return C.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=R;class S{static create(C,W){return new S(C,W)}constructor(C,W){this.d=C,this.f=W,this.type=11,this.c=R.create(C,W)}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(C){return C.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=S;class L{static create(C,W,z=null){if(typeof W=="boolean")return W?T.create(C,z):g.create(C,z);const q=f.get(C);return typeof q=="boolean"?W===(q?"true":"false")?o.INSTANCE:h.INSTANCE:new L(C,W,z)}constructor(C,W,z){this.c=C,this.d=W,this.f=z,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:J(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=f.get(this.c);if(typeof C=="boolean"){const W=C?"true":"false";return this.d===W?o.INSTANCE:h.INSTANCE}return this}evaluate(C){return C.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(C){return C.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=L;class T{static create(C,W=null){const z=f.get(C);return typeof z=="boolean"?z?o.INSTANCE:h.INSTANCE:new T(C,W)}constructor(C,W){this.c=C,this.d=W,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:V(this.c,C.c)}equals(C){return C.type===this.type?this.c===C.c:!1}substituteConstants(){const C=f.get(this.c);return typeof C=="boolean"?C?o.INSTANCE:h.INSTANCE:this}evaluate(C){return!C.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(C){return C.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.ContextKeyNotExpr=T;function U(B,C){if(typeof B=="string"){const W=parseFloat(B);isNaN(W)||(B=W)}return typeof B=="string"||typeof B=="number"?C(B):o.INSTANCE}class H{static create(C,W,z=null){return U(W,q=>new H(C,q,z))}constructor(C,W,z){this.c=C,this.d=W,this.f=z,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:J(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=H;class re{static create(C,W,z=null){return U(W,q=>new re(C,q,z))}constructor(C,W,z){this.c=C,this.d=W,this.f=z,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:J(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=re;class Y{static create(C,W,z=null){return U(W,q=>new Y(C,q,z))}constructor(C,W,z){this.c=C,this.d=W,this.f=z,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:J(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=Y;class ne{static create(C,W,z=null){return U(W,q=>new ne(C,q,z))}constructor(C,W,z){this.c=C,this.d=W,this.f=z,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:J(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=ne;class ce{static create(C,W){return new ce(C,W)}constructor(C,W){this.d=C,this.f=W,this.type=7,this.c=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.d<C.d)return-1;if(this.d>C.d)return 1;const W=this.f?this.f.source:"",z=C.f?C.f.source:"";return W<z?-1:W>z?1:0}equals(C){if(C.type===this.type){const W=this.f?this.f.source:"",z=C.f?C.f.source:"";return this.d===C.d&&W===z}return!1}substituteConstants(){return this}evaluate(C){const W=C.getValue(this.d);return this.f?this.f.test(W):!1}serialize(){const C=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${C}`}keys(){return[this.d]}map(C){return C.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=le.create(this)),this.c}}e.ContextKeyRegexExpr=ce;class le{static create(C){return new le(C)}constructor(C){this.c=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(C){return new le(this.c.map(C))}negate(){return this.c}}e.ContextKeyNotRegexExpr=le;function X(B){let C=null;for(let W=0,z=B.length;W<z;W++){const q=B[W].substituteConstants();if(B[W]!==q&&C===null){C=[];for(let j=0;j<W;j++)C[j]=B[j]}C!==null&&(C[W]=q)}return C===null?B:C}class G{static create(C,W,z){return G.d(C,W,z)}constructor(C,W){this.expr=C,this.c=W,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let W=0,z=this.expr.length;W<z;W++){const q=i(this.expr[W],C.expr[W]);if(q!==0)return q}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let W=0,z=this.expr.length;W<z;W++)if(!this.expr[W].equals(C.expr[W]))return!1;return!0}return!1}substituteConstants(){const C=X(this.expr);return C===this.expr?this:G.create(C,this.c,!1)}evaluate(C){for(let W=0,z=this.expr.length;W<z;W++)if(!this.expr[W].evaluate(C))return!1;return!0}static d(C,W,z){const q=[];let j=!1;for(const $ of C)if($){if($.type===1){j=!0;continue}if($.type===0)return o.INSTANCE;if($.type===6){q.push(...$.expr);continue}q.push($)}if(q.length===0&&j)return h.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(i);for(let $=1;$<q.length;$++)q[$-1].equals(q[$])&&(q.splice($,1),$--);if(q.length===1)return q[0];for(;q.length>1;){const $=q[q.length-1];if($.type!==9)break;q.pop();const K=q.pop(),se=q.length===0,ue=N.create($.expr.map(be=>G.create([be,K],null,z)),null,se);ue&&(q.push(ue),q.sort(i))}if(q.length===1)return q[0];if(z){for(let $=0;$<q.length;$++)for(let K=$+1;K<q.length;K++)if(q[$].negate().equals(q[K]))return o.INSTANCE;if(q.length===1)return q[0]}return new G(q,W)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const W of this.expr)C.push(...W.keys());return C}map(C){return new G(this.expr.map(W=>W.map(C)),null)}negate(){if(!this.c){const C=[];for(const W of this.expr)C.push(W.negate());this.c=N.create(C,this,!0)}return this.c}}e.ContextKeyAndExpr=G;class N{static create(C,W,z){return N.d(C,W,z)}constructor(C,W){this.expr=C,this.c=W,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let W=0,z=this.expr.length;W<z;W++){const q=i(this.expr[W],C.expr[W]);if(q!==0)return q}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let W=0,z=this.expr.length;W<z;W++)if(!this.expr[W].equals(C.expr[W]))return!1;return!0}return!1}substituteConstants(){const C=X(this.expr);return C===this.expr?this:N.create(C,this.c,!1)}evaluate(C){for(let W=0,z=this.expr.length;W<z;W++)if(this.expr[W].evaluate(C))return!0;return!1}static d(C,W,z){let q=[],j=!1;if(C){for(let $=0,K=C.length;$<K;$++){const se=C[$];if(se){if(se.type===0){j=!0;continue}if(se.type===1)return h.INSTANCE;if(se.type===9){q=q.concat(se.expr);continue}q.push(se)}}if(q.length===0&&j)return o.INSTANCE;q.sort(i)}if(q.length!==0){if(q.length===1)return q[0];for(let $=1;$<q.length;$++)q[$-1].equals(q[$])&&(q.splice($,1),$--);if(q.length===1)return q[0];if(z){for(let $=0;$<q.length;$++)for(let K=$+1;K<q.length;K++)if(q[$].negate().equals(q[K]))return h.INSTANCE;if(q.length===1)return q[0]}return new N(q,W)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const W of this.expr)C.push(...W.keys());return C}map(C){return new N(this.expr.map(W=>W.map(C)),null)}negate(){if(!this.c){const C=[];for(const W of this.expr)C.push(W.negate());for(;C.length>1;){const W=C.shift(),z=C.shift(),q=[];for(const j of oe(W))for(const $ of oe(z))q.push(G.create([j,$],null,!1));C.unshift(N.create(q,null,!1))}this.c=N.create(C,this,!0)}return this.c}}e.ContextKeyOrExpr=N;class F extends g{static all(){return F.d.values()}constructor(C,W,z){super(C,null),this.f=W,typeof z=="object"?F.d.push({...z,key:C}):z!==!0&&F.d.push({key:C,description:z,type:W!=null?typeof W:void 0})}bindTo(C){return C.createKey(this.key,this.f)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return D.create(this.key,C)}notEqualsTo(C){return L.create(this.key,C)}}e.RawContextKey=F,F.d=[],e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function V(B,C){return B<C?-1:B>C?1:0}function J(B,C,W,z){return B<W?-1:B>W?1:C<z?-1:C>z?1:0}function _(B,C){if(B.type===0||C.type===1)return!0;if(B.type===9)return C.type===9?ae(B.expr,C.expr):!1;if(C.type===9){for(const W of C.expr)if(_(B,W))return!0;return!1}if(B.type===6){if(C.type===6)return ae(C.expr,B.expr);for(const W of B.expr)if(_(W,C))return!0;return!1}return B.equals(C)}e.implies=_;function ae(B,C){let W=0,z=0;for(;W<B.length&&z<C.length;){const q=B[W].cmp(C[z]);if(q<0)return!1;q===0&&W++,z++}return W===B.length}function oe(B){return B.type===9?B.expr:[B]}}),define(te[75],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class A{constructor(){this.a={}}async getPassword(O,M){return this.a[O]?.[M]??null}async setPassword(O,M,P){this.a[O]=this.a[O]??{},this.a[O][M]=P}async deletePassword(O,M){return this.a[O]?.[M]?(delete this.a[O][M],Object.keys(this.a[O]).length===0&&delete this.a[O],!0):!1}async findPassword(O){return JSON.stringify(this.a[O])??null}async findCredentials(O){const M=[];for(const P of Object.keys(this.a[O]||{}))M.push({account:P,password:this.a[O][P]});return M}async clear(){this.a={}}}e.InMemoryCredentialsProvider=A}),define(te[89],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function A(O){return!!O.hostName&&!!O.errorMessage}e.isRemoteDiagnosticError=A;class r{async getPerformanceInfo(M,P){return{}}async getSystemInfo(M,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,P){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=r}),define(te[90],ie([0,1,18,72,164,6,45,3,37]),function(x,e,E,A,r,O,M,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,O.createDecorator)("dialogService");var l;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(l||(l={}));class w{a(s){return this.d(s,l.Confirmation)}b(s){return this.d(s,l.Prompt)}c(s){return this.d(s,l.Input)}d(s,y){const a=[];switch(y){case l.Confirmation:{const d=s;d.primaryButton?a.push(d.primaryButton):a.push((0,r.localize)(0,null)),d.cancelButton?a.push(d.cancelButton):a.push((0,r.localize)(1,null));break}case l.Prompt:{const d=s;Array.isArray(d.buttons)&&d.buttons.length>0&&a.push(...d.buttons.map(I=>I.label)),d.cancelButton&&(d.cancelButton===!0?a.push((0,r.localize)(2,null)):typeof d.cancelButton=="string"?a.push(d.cancelButton):d.cancelButton.label?a.push(d.cancelButton.label):a.push((0,r.localize)(3,null))),a.length===0&&a.push((0,r.localize)(4,null));break}case l.Input:{const d=s;d.primaryButton?a.push(d.primaryButton):a.push((0,r.localize)(5,null)),d.cancelButton?a.push(d.cancelButton):a.push((0,r.localize)(6,null));break}}return a}e(s){if(typeof s=="string")return s;if(typeof s=="number")return s===A.default.Info?"info":s===A.default.Error?"error":s===A.default.Warning?"warning":"none"}async f(s,y,a){const d=[...s.buttons??[]];return s.cancelButton&&typeof s.cancelButton!="string"&&typeof s.cancelButton!="boolean"&&d.push(s.cancelButton),{result:await d[y]?.run({checkboxChecked:a}),checkboxChecked:a}}}e.AbstractDialogHandler=w,e.IFileDialogService=(0,O.createDecorator)("fileDialogService");var m;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(m||(e.ConfirmResult=m={}));const v=10;function u(p){const s=[];return s.push(...p.slice(0,v).map(y=>typeof y=="string"?y:(0,E.basename)(y))),p.length>v&&(p.length-v===1?s.push((0,r.localize)(7,null)):s.push((0,r.localize)(8,null,p.length-v))),s.push(""),s.join(`
`)}e.getFileNamesMessage=u;function b(p,s){const y=(0,f.deepClone)(p);let a=(y.buttons??[]).map(t=>(0,M.mnemonicButtonLabel)(t)),d=(p.buttons||[]).map((t,c)=>c),I=0,k=y.cancelId??a.length-1;if(a.length>1){const t=typeof k=="number"?a[k]:void 0;if(P.isLinux||P.isMacintosh){if(typeof t=="string"&&a.length>1&&k!==1){a.splice(k,1),a.splice(1,0,t);const c=d[k];d.splice(k,1),d.splice(1,0,c),k=1}P.isLinux&&a.length>1&&(a=a.reverse(),d=d.reverse(),I=a.length-1,typeof t=="string"&&(k=I-1))}else if(P.isWindows&&typeof t=="string"&&a.length>1&&k!==a.length-1){a.splice(k,1),a.push(t);const c=d[k];d.splice(k,1),d.push(c),k=a.length-1}}return y.buttons=a,y.defaultId=I,y.cancelId=k,y.noLink=!0,y.title=y.title||s.nameLong,{options:y,buttonIndeces:d}}e.massageMessageBoxOptions=b}),define(te[114],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(te[33],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(te[115],ie([0,1,168,6]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function r(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=r;function O(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=O;function M(a,d){switch(a){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function P(a,d){return d==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function f(a,d,I){return P(d,I)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===I?!0:l(I).includes(a)}e.isTargetPlatformCompatible=f;function l(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function w(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=w;var m;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(m||(e.SortBy=m={}));var v;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var u;(function(a){a.Install="install",a.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var b;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var p;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var s;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class y extends Error{constructor(d,I){super(d),this.code=I,this.name=I}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,E.localize)(1,null),original:"Preferences"}}),define(te[207],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(te[208],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[116],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(te[209],ie([0,1,46,14,9,3,71,22,87,172,116]),function(x,e,E,A,r,O,M,P,f,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const m=l.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:u.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class u extends v{openTerminal(I,k){return this.spawnTerminal(E,I,f.getWindowsShell(),k)}spawnTerminal(I,k,t,c){const n=k.windowsExec||u.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const i=r.basename(n,".exe").toLowerCase();if(i==="cmder")return I.spawn(n,c?[c]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return n.indexOf(" ")>=0&&o.push('""'),o.push(n),i==="wt"&&o.push("-d ."),new Promise((h,g)=>{const D=s(process),R=I.spawn(t,o,{cwd:c,env:D});R.on("error",g),R.on("exit",()=>h())})}runInTerminal(I,k,t,c,n){const i="windowsExec"in n&&n.windowsExec?n.windowsExec:u.getDefaultTerminalWindows();return new Promise((o,h)=>{const g=`"${k} - ${m}"`,D=`""${t.join('" "')}" & pause"`,R=Object.assign({},s(process),c);Object.keys(R).filter(H=>R[H]===null).forEach(H=>delete R[H]);const S={cwd:k,env:R,windowsVerbatimArguments:!0};let L,T;r.basename(i,".exe")==="wt"?(L=i,T=["-d",".",u.b,"/c",D]):(L=u.b,T=["/c","start",g,"/wait",i,"/c",D]),E.spawn(L,T,S).on("error",H=>{h(y(H))}),o(void 0)})}static getDefaultTerminalWindows(){if(!u.d){const I=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${I?"Sysnative":"System32"}\\cmd.exe`}return u.d}}e.WindowsExternalTerminalService=u,u.b="cmd.exe";class b extends v{openTerminal(I,k){return this.spawnTerminal(E,I,k)}runInTerminal(I,k,t,c,n){const i=n.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((o,h)=>{if(i===w.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const g=i===w.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${g}.scpt`).fsPath,"-t",I||m,"-w",k];for(const T of t)R.push("-a"),R.push(T);if(c){const T=Object.assign({},s(process),c);for(const U in T){const H=T[U];H===null?(R.push("-u"),R.push(U)):(R.push("-e"),R.push(`${U}=${H}`))}}let S="";const L=E.spawn(b.b,R);L.on("error",T=>{h(y(T))}),L.stderr.on("data",T=>{S+=T.toString()}),L.on("exit",T=>{if(T===0)o(void 0);else if(S){const U=S.split(`
`,1);h(new Error(U[0]))}else h(new Error(l.localize(1,null,g,T)))})}else h(new Error(l.localize(2,null,i)))})}spawnTerminal(I,k,t){const c=k.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((n,i)=>{const o=["-a",c];t&&o.push(t);const h=s(process),g=I.spawn("/usr/bin/open",o,{cwd:t,env:h});g.on("error",i),g.on("exit",()=>n())})}}e.MacExternalTerminalService=b,b.b="/usr/bin/osascript";class p extends v{openTerminal(I,k){return this.spawnTerminal(E,I,k)}runInTerminal(I,k,t,c,n){const i=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((o,h)=>{const g=[];i.then(D=>{D.indexOf("gnome-terminal")>=0?g.push("-x"):g.push("-e"),g.push("bash"),g.push("-c");const R=`${a(t)}; echo; read -p "${p.b}" -n1;`;g.push(`''${R}''`);const S=Object.assign({},s(process),c);Object.keys(S).filter(H=>S[H]===null).forEach(H=>delete S[H]);const L={cwd:k,env:S};let T="";const U=E.spawn(D,g,L);U.on("error",H=>{h(y(H))}),U.stderr.on("data",H=>{T+=H.toString()}),U.on("exit",H=>{if(H===0)o(void 0);else if(T){const re=T.split(`
`,1);h(new Error(re[0]))}else h(new Error(l.localize(4,null,D,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!O.isLinux)p.d=Promise.resolve("xterm");else{const I=await P.Promises.exists("/etc/debian_version");p.d=new Promise(k=>{I?k("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?k("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?k("konsole"):process.env.COLORTERM?k(process.env.COLORTERM):process.env.TERM?k(process.env.TERM):k("xterm")})}return p.d}spawnTerminal(I,k,t){const c=k.linuxExec?Promise.resolve(k.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,i)=>{c.then(o=>{const h=s(process),g=I.spawn(o,[],{cwd:t,env:h});g.on("error",i),g.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=p,p.b=l.localize(3,null);function s(d){const I={...d.env};return(0,M.sanitizeProcessEnvironment)(I),I}function y(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(l.localize(5,null,d.path)):d}function a(d){let I="";for(const k of d)k.indexOf(" ")>=0?I+='"'+k+'"':I+=k,I+=" ";return I}}),define(te[16],ie([0,1,62,9,25,11,8,174,6,3,14]),function(x,e,E,A,r,O,M,P,f,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function m(F){return F.create===!0}e.isFileOpenForWriteOptions=m;var v;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var u;(function(F){F[F.Readonly=1]="Readonly",F[F.Locked=2]="Locked"})(u||(e.FilePermission=u={}));var b;(function(F){F[F.None=0]="None",F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileAtomicWrite=32768]="FileAtomicWrite",F[F.FileAtomicDelete=65536]="FileAtomicDelete",F[F.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function p(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=p;function s(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=s;function y(F){return!!(F.capabilities&131072)}e.hasFileCloneCapability=y;function a(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function d(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=d;function I(F){return p(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=I;function k(F){return p(F)?!!(F.capabilities&32768):!1}e.hasFileAtomicWriteCapability=k;function t(F){return!!(F.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;var c;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsStorageQuota="EntryExceedsStorageQuota",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class n extends Error{static create(V,J){const _=new n(V.toString(),J);return h(_,J),_}constructor(V,J){super(V),this.code=J}}e.FileSystemProviderError=n;function i(F,V){return n.create(F,V)}e.createFileSystemProviderError=i;function o(F){return F||i((0,P.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=o;function h(F,V){return F.name=V?`${V} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=h;function g(F){if(!F)return c.Unknown;if(F instanceof n)return F.code;const V=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!V)return c.Unknown;switch(V[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=g;function D(F){if(F instanceof H)return F.fileOperationResult;switch(g(F)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=D;var R;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(R||(e.FileOperation=R={}));class S{constructor(V,J,_){this.resource=V,this.operation=J,this.target=_}isOperation(V){return this.operation===V}}e.FileOperationEvent=S;var L;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class T{constructor(V,J){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const _=new Map;for(const ae of V){const oe=_.get(ae.type);switch(oe?oe.push([ae.resource,ae]):_.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,oe]of _)switch(ae){case 1:this.a=E.TernarySearchTree.forUris(()=>J),this.a.fill(oe);break;case 0:this.b=E.TernarySearchTree.forUris(()=>J),this.b.fill(oe);break;case 2:this.c=E.TernarySearchTree.forUris(()=>J),this.c.fill(oe);break}}contains(V,...J){return this.d(V,{includeChildren:!1},...J)}affects(V,...J){return this.d(V,{includeChildren:!0},...J)}d(V,J,..._){if(!V)return!1;const ae=_.length>0;return!!((!ae||_.includes(1))&&(this.a?.get(V)||J.includeChildren&&this.a?.findSuperstr(V))||(!ae||_.includes(0))&&(this.b?.get(V)||J.includeChildren&&this.b?.findSuperstr(V))||(!ae||_.includes(2))&&(this.c?.findSubstr(V)||J.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=T;function U(F,V,J){return!F||!V||F===V||V.length>F.length?!1:(V.charAt(V.length-1)!==A.sep&&(V+=A.sep),J?(0,r.startsWithIgnoreCase)(F,V):F.indexOf(V)===0)}e.isParent=U;class H extends Error{constructor(V,J,_){super(V),this.fileOperationResult=J,this.options=_}}e.FileOperationError=H;class re extends H{constructor(V,J,_,ae){super(V,J,ae),this.fileOperationResult=J,this.size=_}}e.TooLargeFileOperationError=re;class Y extends H{constructor(V,J,_){super(V,2,_),this.stat=J}}e.NotModifiedSinceFileOperationError=Y;var ne;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ce;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.ETAG_DISABLED="";function le(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=le;async function X(F,V){if(!V.hasProvider(M.URI.from({scheme:F.scheme})))return new Promise(J=>{const _=V.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===F.scheme&&ae.added&&(_.dispose(),J())})})}e.whenProviderRegistered=X;class G{static formatSize(V){return(0,O.isNumber)(V)||(V=0),V<G.KB?(0,P.localize)(1,null,V.toFixed(0)):V<G.MB?(0,P.localize)(2,null,(V/G.KB).toFixed(2)):V<G.GB?(0,P.localize)(3,null,(V/G.MB).toFixed(2)):V<G.TB?(0,P.localize)(4,null,(V/G.GB).toFixed(2)):(0,P.localize)(5,null,(V/G.TB).toFixed(2))}}e.ByteSize=G,G.KB=1024,G.MB=G.KB*G.KB,G.GB=G.MB*G.KB,G.TB=G.GB*G.KB;function N(F){const V=typeof F=="string"||F?.scheme===w.Schemas.vscodeRemote;return typeof F!="string"&&F?.scheme===w.Schemas.file?1024*G.MB:V?10*G.MB:l.isWeb?50*G.MB:1024*G.MB}e.getLargeFileConfirmationLimit=N}),define(te[210],ie([0,1,17,50,13,4,2,61,8,31,16]),function(x,e,E,A,r,O,M,P,f,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class m extends M.Disposable{constructor(u,b){super(),this.a=u,this.b=b,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new O.Emitter),this.onDidWatchError=this.g.event,this.h=(0,l.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,b){const{buffer:p}=await this.a.call("readFile",[u,b]);return p}readFileStream(u,b,p){const s=(0,P.newWriteableStream)(a=>E.VSBuffer.concat(a.map(d=>E.VSBuffer.wrap(d))).buffer),y=this.a.listen("readFileStream",[u,b])(a=>{if(a instanceof E.VSBuffer)s.write(a.buffer);else{if(a==="end")s.end();else{let d;if(a instanceof Error)d=a;else{const I=a;d=(0,w.createFileSystemProviderError)(I.message??(0,A.toErrorMessage)(I),I.code??w.FileSystemProviderErrorCode.Unknown)}s.error(d),s.end()}y.dispose()}});return p.onCancellationRequested(()=>{s.error((0,r.canceled)()),s.end(),y.dispose()}),s}writeFile(u,b,p){return this.a.call("writeFile",[u,E.VSBuffer.wrap(b),p])}open(u,b){return this.a.call("open",[u,b])}close(u){return this.a.call("close",[u])}async read(u,b,p,s,y){const[a,d]=await this.a.call("read",[u,b,y]);return p.set(a.buffer.slice(0,d),s),d}write(u,b,p,s,y){return this.a.call("write",[u,b,E.VSBuffer.wrap(p),s,y])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,b){return this.a.call("delete",[u,b])}rename(u,b,p){return this.a.call("rename",[u,b,p])}copy(u,b,p){return this.a.call("copy",[u,b,p])}cloneFile(u,b){return this.a.call("cloneFile",[u,b])}i(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const b=u;this.f.fire(b.map(p=>({resource:f.URI.revive(p.resource),type:p.type})))}else{const b=u;this.g.fire(b)}}))}watch(u,b){const p=(0,l.generateUuid)();return this.a.call("watch",[this.h,p,u,b]),(0,M.toDisposable)(()=>this.a.call("unwatch",[this.h,p]))}}e.DiskFileSystemProviderClient=m}),define(te[117],ie([0,1,17,13,175,16]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(w,m,v,u,b,p){let s;try{await P(w,m,v,u,b,p)}catch(y){s=y}finally{s&&b.errorTransformer&&(s=b.errorTransformer(s)),typeof s<"u"&&v.error(s),v.end()}}e.readFileIntoStream=M;async function P(w,m,v,u,b,p){f(p);const s=await w.open(m,{create:!1});try{f(p);let y=0,a=0,d=b&&typeof b.length=="number"?b.length:void 0,I=E.VSBuffer.alloc(Math.min(b.bufferSize,typeof d=="number"?d:b.bufferSize)),k=b&&typeof b.position=="number"?b.position:0,t=0;do a=await w.read(s,k,I.buffer,t,I.byteLength-t),k+=a,t+=a,y+=a,typeof d=="number"&&(d-=a),t===I.byteLength&&(await v.write(u(I)),I=E.VSBuffer.alloc(Math.min(b.bufferSize,typeof d=="number"?d:b.bufferSize)),t=0);while(a>0&&(typeof d!="number"||d>0)&&f(p)&&l(y,b));if(t>0){let c=t;typeof d=="number"&&(c=Math.min(t,d)),v.write(u(I.slice(0,c)))}}catch(y){throw(0,O.ensureFileSystemProviderError)(y)}finally{await w.close(s)}}function f(w){if(w.isCancellationRequested)throw(0,A.canceled)();return!0}function l(w,m){if(typeof m?.limits?.size=="number"&&w>m.limits.size)throw(0,O.createFileSystemProviderError)((0,r.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[76],ie([0,1,104,2,9,3,8,16]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function f(y){return y.recursive===!0}e.isRecursiveWatchRequest=f;class l extends A.Disposable{constructor(a,d,I,k){super(),this.h=a,this.i=d,this.j=I,this.k=k,this.c=this.B(new A.MutableDisposable),this.f=void 0,this.g=0}m(){const a=new A.DisposableStore;this.c.value=a,this.b=this.l(a),this.b.setVerboseLogging(this.j),a.add(this.b.onDidChangeFile(d=>this.h(d))),a.add(this.b.onDidLogMessage(d=>this.i(d))),a.add(this.b.onDidError(d=>this.n(d)))}n(a){this.k.restartOnError?this.g<l.a&&this.f?(this.r(`restarting watcher after error: ${a}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${a}`):this.r(a)}p(a){this.g++,this.m(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.j=a,await this.b?.setVerboseLogging(a)}r(a){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${a}`})}s(a){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=l,l.a=5;class w extends l{constructor(a,d,I){super(a,d,I,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=w;class m extends l{constructor(a,d,I){super(a,d,I,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=m;function v(y){return y.map(a=>({type:a.type,resource:M.URI.file(a.path)}))}e.toFileChanges=v;function u(y){const a=new s;for(const d of y)a.processEvent(d);return a.coalesce()}e.coalesceEvents=u;function b(y,a){return typeof a=="string"&&!a.startsWith(E.GLOBSTAR)&&!(0,r.isAbsolute)(a)?{base:y,pattern:a}:a}e.normalizeWatcherPattern=b;function p(y,a){const d=[];for(const I of a)d.push((0,E.parse)(b(y,I)));return d}e.parseWatcherPatterns=p;class s{constructor(){this.a=new Set,this.b=new Map}c(a){return O.isLinux?a.path:a.path.toLowerCase()}processEvent(a){const d=this.b.get(this.c(a));let I=!1;if(d){const k=d.type,t=a.type;d.path!==a.path&&(a.type===2||a.type===1)?I=!0:k===1&&t===2?(this.b.delete(this.c(a)),this.a.delete(d)):k===2&&t===1?d.type=0:k===1&&t===0||(d.type=t)}else I=!0;I&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],d=[];return Array.from(this.a).filter(I=>I.type!==2?(a.push(I),!1):!0).sort((I,k)=>I.path.length-k.path.length).filter(I=>d.some(k=>(0,P.isParent)(I.path,k,!O.isLinux))?!1:(d.push(I.path),!0)).concat(a)}}}),define(te[211],ie([0,1,42,7,21,32,2,83,9,3,105,22,76]),function(x,e,E,A,r,O,M,P,f,l,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends M.Disposable{constructor(s,y,a,d){super(),this.j=s,this.k=y,this.l=a,this.m=d,this.c=this.B(new A.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},I=>this.k(I))),this.f=this.B(new A.RunOnceWorker(I=>this.u(I),u.b)),this.g=(0,v.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,v.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new r.CancellationTokenSource,this.ready=this.n()}async n(){try{const s=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const y=await m.Promises.stat(s);this.B(await this.s(s,y.isDirectory()))}catch(s){s.code!=="ENOENT"?this.w(s):this.z(s)}}async r(s){let y=s.path;try{y=await m.Promises.realpath(s.path),s.path===y&&(y=await(0,w.realcase)(s.path)??s.path),s.path!==y&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${s.path}, real: ${y})`)}catch{}return y}async s(s,y){if(l.isMacintosh&&(0,O.isEqualOrParent)(s,"/Volumes/",!0))return this.w(`Refusing to watch ${s} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const a=new r.CancellationTokenSource(this.i.token),d=new M.DisposableStore;try{const I=(0,f.basename)(s),k=(0,E.watch)(s);d.add((0,M.toDisposable)(()=>{k.removeAllListeners(),k.close()})),this.z(`Started watching: '${s}'`);const t=new Set;if(y)try{for(const n of await m.Promises.readdir(s))t.add(n)}catch(n){this.w(n)}const c=new Map;d.add((0,M.toDisposable)(()=>{for(const[,n]of c)n.dispose();c.clear()})),k.on("error",(n,i)=>{this.w(`Failed to watch ${s} for changes using fs.watch() (${n}, ${i})`),this.dispose()}),k.on("change",(n,i)=>{if(a.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${i}`);let o="";if(i&&(o=i.toString(),l.isMacintosh&&(o=(0,P.normalizeNFC)(o))),!(!o||n!=="change"&&n!=="rename"))if(y)if(n==="rename"){c.get(o)?.dispose();const h=setTimeout(async()=>{if(c.delete(o),o===I&&!await m.Promises.exists(s)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const g=await this.v((0,f.join)(s,o));if(a.token.isCancellationRequested)return;let D;g?t.has(o)?D=0:(D=1,t.add(o)):(t.delete(o),D=2),this.t({path:(0,f.join)(this.j.path,o),type:D})},u.a);c.set(o,(0,M.toDisposable)(()=>clearTimeout(h)))}else{let h;t.has(o)?h=0:(h=1,t.add(o)),this.t({path:(0,f.join)(this.j.path,o),type:h})}else if(n==="rename"||o!==I){const h=setTimeout(async()=>{const g=await m.Promises.exists(s);a.token.isCancellationRequested||(g?(this.t({path:this.j.path,type:0},!0),d.add(await this.s(s,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},u.a);d.clear(),d.add((0,M.toDisposable)(()=>clearTimeout(h)))}else this.t({path:this.j.path,type:0},!0)})}catch(I){await m.Promises.exists(s)&&!a.token.isCancellationRequested&&this.w(`Failed to watch ${s} for changes using fs.watch() (${I.toString()})`)}return(0,M.toDisposable)(()=>{a.dispose(!0),d.dispose()})}t(s,y=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.path}`),!y&&this.g.some(a=>a(s.path))?this.m&&this.z(` >> ignored (excluded) ${s.path}`):!y&&this.h&&this.h.length>0&&!this.h.some(a=>a(s.path))?this.m&&this.z(` >> ignored (not included) ${s.path}`):this.f.work(s))}u(s){const y=(0,v.coalesceEvents)(s);if(y.length>0){if(this.m)for(const d of y)this.z(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);this.c.work(y)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${y[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${y.length}, most recent change: ${y[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(s){if(l.isLinux)return m.Promises.exists(s);try{const y=(0,f.basename)(s);return(await m.Promises.readdir((0,f.dirname)(s))).some(d=>d===y)}catch(y){return this.z(y),!1}}setVerboseLogging(s){this.m=s}w(s){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${s}`})}y(s){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${s}`})}z(s){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${s}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u,u.a=100,u.b=75;async function b(p,s,y,a,d=512){const I=await m.Promises.open(p,"r"),k=Buffer.allocUnsafe(d),t=new r.CancellationTokenSource(a);let c,n=!1;const i={path:p,excludes:[],recursive:!1},o=new u(i,h=>{(async()=>{for(const{type:g}of h)if(g===0){if(n)return;n=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:D}=await m.Promises.read(I,k,0,d,null);if(!D||t.token.isCancellationRequested)break;s(k.slice(0,D))}}catch(D){c=new Error(D),t.dispose(!0)}finally{n=!1}}})()});return await o.ready,y(),new Promise((h,g)=>{t.token.onCancellationRequested(async()=>{o.dispose();try{await m.Promises.close(I)}catch(D){c=new Error(D)}c?g(c):h()})})}e.watchFileContents=b}),define(te[212],ie([0,1,4,104,2,3,211]),function(x,e,E,A,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends r.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(l){const w=this.i(l),m=w.filter(u=>{const b=this.c.get(u.path);return b?!(0,A.patternsEquals)(b.request.excludes,u.excludes)||!(0,A.patternsEquals)(b.request.includes,u.includes):!0}),v=Array.from(this.c.values()).filter(({request:u})=>!w.find(b=>b.path===u.path&&(0,A.patternsEquals)(b.excludes,u.excludes)&&(0,A.patternsEquals)(b.includes,u.includes))).map(({request:u})=>u.path);m.length&&this.j(`Request to start watching: ${m.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),v.length&&this.j(`Request to stop watching: ${v.join(",")}`);for(const u of v)this.h(u);for(const u of m)this.g(u)}g(l){const w=new M.NodeJSFileWatcherLibrary(l,v=>this.a.fire(v),v=>this.b.fire(v),this.f),m={request:l,instance:w};this.c.set(l.path,m)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const w=this.c.get(l);w&&(this.c.delete(l),w.instance.dispose())}i(l){const w=new Map;for(const m of l){const v=O.isLinux?m.path:m.path.toLowerCase();w.set(v,m)}return Array.from(w.values())}async setVerboseLogging(l){this.f=l;for(const[,w]of this.c)w.instance.setVerboseLogging(l)}j(l){this.f&&this.b.fire({type:"trace",message:this.k(l)})}k(l,w){return w?`[File Watcher (node.js)] ${l} (path: ${w.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=P}),define(te[213],ie([0,1,76,212]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class r extends E.AbstractNonRecursiveWatcherClient{constructor(M,P,f){super(M,P,f),this.m()}l(){return new A.NodeJSWatcher}}e.NodeJSWatcherClient=r}),define(te[214],ie([0,1,14,43,158,76]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends O.AbstractUniversalWatcherClient{constructor(f,l,w){super(f,l,w),this.m()}l(f){const l=f.add(new r.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(l.onDidProcessExit(({code:w,signal:m})=>this.n(`terminated by itself with code ${w}, signal: ${m}`))),A.ProxyChannel.toService((0,A.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(te[91],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...r){this.a=new Map;for(const[O,M]of r)this.set(O,M)}set(r,O){const M=this.a.get(r);return this.a.set(r,O),M}has(r){return this.a.has(r)}get(r){return this.a.get(r)}}e.ServiceCollection=E}),define(te[215],ie([0,1,7,13,2,74,206,6,91,101]),function(x,e,E,A,r,O,M,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class m extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class v{constructor(s=new f.ServiceCollection,y=!1,a,d=w){this.f=s,this.g=y,this.h=a,this.i=d,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=d?a?._globalGraph??new M.Graph(I=>I):void 0}createChild(s){return new v(s,this.g,this,this.i)}invokeFunction(s,...y){const a=b.traceInvocation(this.i,s);let d=!1;try{return s({get:k=>{if(d)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(k,a);if(!t)throw new Error(`[invokeFunction] unknown service '${k}'`);return t}},...y)}finally{d=!0,a.stop()}}createInstance(s,...y){let a,d;return s instanceof O.SyncDescriptor?(a=b.traceCreation(this.i,s.ctor),d=this.j(s.ctor,s.staticArguments.concat(y),a)):(a=b.traceCreation(this.i,s),d=this.j(s,y,a)),a.stop(),d}j(s,y=[],a){const d=P._util.getServiceDependencies(s).sort((t,c)=>t.index-c.index),I=[];for(const t of d){const c=this.m(t.id,a);c||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),I.push(c)}const k=d.length>0?d[0].index:y.length;if(y.length!==k){console.trace(`[createInstance] First service dependency of ${s.name} at position ${k+1} conflicts with ${y.length} static arguments`);const t=k-y.length;t>0?y=y.concat(new Array(t)):y=y.slice(0,k)}return Reflect.construct(s,y.concat(I))}k(s,y){if(this.f.get(s)instanceof O.SyncDescriptor)this.f.set(s,y);else if(this.h)this.h.k(s,y);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const y=this.f.get(s);return!y&&this.h?this.h.l(s):y}m(s,y){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const a=this.l(s);return a instanceof O.SyncDescriptor?this.q(s,a,y.branch(s,!0)):(y.branch(s,!1),a)}q(s,y,a){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,y,a)}finally{this.o.delete(s)}}r(s,y,a){const d=new M.Graph(t=>t.id.toString());let I=0;const k=[{id:s,desc:y,_trace:a}];for(;k.length;){const t=k.pop();if(d.lookupOrInsertNode(t),I++>1e3)throw new m(d);for(const c of P._util.getServiceDependencies(t.desc.ctor)){const n=this.l(c.id);if(n||this.u(`[createInstance] ${s} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),n instanceof O.SyncDescriptor){const i={id:c.id,desc:n,_trace:t._trace.branch(c.id,!0)};d.insertEdge(t,i),k.push(i)}}}for(;;){const t=d.roots();if(t.length===0){if(!d.isEmpty())throw new m(d);break}for(const{data:c}of t){if(this.l(c.id)instanceof O.SyncDescriptor){const i=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,i)}d.removeNode(c)}}return this.l(s)}s(s,y,a=[],d,I){if(this.f.get(s)instanceof O.SyncDescriptor)return this.t(s,y,a,d,I);if(this.h)return this.h.s(s,y,a,d,I);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}t(s,y,a=[],d,I){if(d){const k=new v(void 0,this.g,this,this.i);k.c=String(s);const t=new Map,c=new E.IdleValue(()=>{const n=k.j(y,a,I);for(const[i,o]of t){const h=n[i];if(typeof h=="function")for(const g of o)h.apply(n,g)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!c.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let g=t.get(i);return g||(g=new l.LinkedList,t.set(i,g)),(R,S,L)=>{const T=g.push([R,S,L]);return(0,r.toDisposable)(T)}}if(i in n)return n[i];const o=c.value;let h=o[i];return typeof h!="function"||(h=h.bind(o),n[i]=h),h},set(n,i,o){return c.value[i]=o,!0},getPrototypeOf(n){return y.prototype}})}else return this.j(y,a,I)}u(s,y){if(y&&console.warn(s),this.g)throw new Error(s)}}e.InstantiationService=v;var u;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(u||(u={}));class b{static traceInvocation(s,y){return s?new b(2,y.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(s,y){return s?new b(1,y.name):b.c}constructor(s,y){this.type=s,this.name=y,this.g=Date.now(),this.h=[]}branch(s,y){const a=new b(3,s.toString());return this.h.push([s,y,a]),a}stop(){const s=Date.now()-this.g;b.f+=s;let y=!1;function a(I,k){const t=[],c=new Array(I+1).join("	");for(const[n,i,o]of k.h)if(i&&o){y=!0,t.push(`${c}CREATES -> ${n}`);const h=a(I+1,o);h&&t.push(h)}else t.push(`${c}uses -> ${n}`);return t.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(s>2||y)&&b.all.add(d.join(`
`))}}e.Trace=b,b.all=new Set,b.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}},b.f=0}),define(te[216],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var A;(function(r){r[r.Bug=0]="Bug",r[r.PerformanceIssue=1]="PerformanceIssue",r[r.FeatureRequest=2]="FeatureRequest"})(A||(e.IssueType=A={})),e.IIssueMainService=(0,E.createDecorator)("issueService")}),define(te[5],ie([0,1,50,4,56,2,35,3,18,11,8,113,6]),function(x,e,E,A,r,O,M,P,f,l,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function u(){return new Date().toISOString()}function b(R){return(0,l.isNumber)(R)}e.isLogLevel=b;var p;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(p||(e.LogLevel=p={})),e.DEFAULT_LOG_LEVEL=p.Info;function s(R,S,L){switch(S){case p.Trace:R.trace(L);break;case p.Debug:R.debug(L);break;case p.Info:R.info(L);break;case p.Warning:R.warn(L);break;case p.Error:R.error(L);break;case p.Off:break;default:throw new Error(`Invalid log level ${S}`)}}e.log=s;function y(R,S=!1){let L="";for(let T=0;T<R.length;T++){let U=R[T];if(U instanceof Error&&(U=(0,E.toErrorMessage)(U,S)),typeof U=="object")try{U=JSON.stringify(U)}catch{}L+=(T>0?" ":"")+U}return L}class a extends O.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(S){this.b!==S&&(this.b=S,this.c.fire(this.b))}getLevel(){return this.b}f(S){return this.b!==p.Off&&this.b<=S}}e.AbstractLogger=a;class d extends a{constructor(S){super(),this.h=S}f(S){return this.h||super.f(S)}trace(S,...L){this.f(p.Trace)&&this.g(p.Trace,y([S,...L],!0))}debug(S,...L){this.f(p.Debug)&&this.g(p.Debug,y([S,...L]))}info(S,...L){this.f(p.Info)&&this.g(p.Info,y([S,...L]))}warn(S,...L){this.f(p.Warning)&&this.g(p.Warning,y([S,...L]))}error(S,...L){if(this.f(p.Error))if(S instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=S.stack,this.g(p.Error,y(T))}else this.g(p.Error,y([S,...L]))}flush(){}}e.AbstractMessageLogger=d;class I extends a{constructor(S=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(S),this.g=!P.isWindows}trace(S,...L){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,S,...L):console.log(`[main ${u()}]`,S,...L))}debug(S,...L){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,S,...L):console.log(`[main ${u()}]`,S,...L))}info(S,...L){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,S,...L):console.log(`[main ${u()}]`,S,...L))}warn(S,...L){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,S,...L):console.warn(`[main ${u()}]`,S,...L))}error(S,...L){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,S,...L):console.error(`[main ${u()}]`,S,...L))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class k extends a{constructor(S=e.DEFAULT_LOG_LEVEL,L=!0){super(),this.g=L,this.setLevel(S)}trace(S,...L){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",S,...L):console.log(S,...L))}debug(S,...L){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",S,...L):console.log(S,...L))}info(S,...L){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",S,...L):console.log(S,...L))}warn(S,...L){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",S,...L):console.log(S,...L))}error(S,...L){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",S,...L):console.error(S,...L))}dispose(){}flush(){}}e.ConsoleLogger=k;class t extends a{constructor(S,L=e.DEFAULT_LOG_LEVEL){super(),this.g=S,this.setLevel(L)}trace(S,...L){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(S),...L])}debug(S,...L){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(S),...L])}info(S,...L){this.f(p.Info)&&this.g.log(p.Info,[this.h(S),...L])}warn(S,...L){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(S),...L])}error(S,...L){this.f(p.Error)&&this.g.log(p.Error,[this.h(S),...L])}h(S){return typeof S=="string"?S:(0,E.toErrorMessage)(S,this.f(p.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class c extends a{constructor(S){super(),this.g=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const L of this.g)L.setLevel(S);super.setLevel(S)}trace(S,...L){for(const T of this.g)T.trace(S,...L)}debug(S,...L){for(const T of this.g)T.debug(S,...L)}info(S,...L){for(const T of this.g)T.info(S,...L)}warn(S,...L){for(const T of this.g)T.warn(S,...L)}error(S,...L){for(const T of this.g)T.error(S,...L)}flush(){for(const S of this.g)S.flush()}dispose(){for(const S of this.g)S.dispose()}}e.MultiplexLogger=c;class n extends O.Disposable{constructor(S,L,T){if(super(),this.h=S,this.j=L,this.b=new M.ResourceMap,this.c=this.B(new A.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeVisibility=this.g.event,T)for(const U of T)this.b.set(U.resource,{logger:void 0,info:U})}k(S){return(0,l.isString)(S)?[...this.b.values()].find(L=>L.info.id===S):this.b.get(S)}getLogger(S){return this.k(S)?.logger}createLogger(S,L){const T=this.l(S),U=(0,l.isString)(S)?S:L?.id??(0,r.hash)(T.toString()).toString(16);let H=this.b.get(T)?.logger;const re=L?.logLevel==="always"?p.Trace:L?.logLevel;H||(H=this.m(T,re??this.getLogLevel(T)??this.h,{...L,id:U}));const Y={logger:H,info:{resource:T,id:U,logLevel:re,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(Y.info),this.b.set(T,Y),H}l(S){return(0,l.isString)(S)?(0,f.joinPath)(this.j,`${S}.log`):S}setLogLevel(S,L){if(w.URI.isUri(S)){const T=S,U=L,H=this.b.get(T);H&&U!==H.info.logLevel&&(H.info.logLevel=U===this.h?void 0:U,H.logger?.setLevel(U),this.b.set(H.info.resource,H),this.f.fire([T,U]))}else{this.h=S;for(const[T,U]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(S,L){const T=this.k(S);T&&L!==!T.info.hidden&&(T.info.hidden=!L,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,L]))}getLogLevel(S){let L;return S&&(L=this.b.get(S)?.info.logLevel),L??this.h}registerLogger(S){const L=this.b.get(S.resource);L?L.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this.b.set(S.resource,{info:S,logger:void 0}),this.c.fire({added:[S],removed:[]}))}deregisterLogger(S){const L=this.b.get(S);L&&(L.logger&&L.logger.dispose(),this.b.delete(S),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const S of this.b.values())yield S.info}getRegisteredLogger(S){return this.b.get(S)?.info}dispose(){this.b.forEach(S=>S.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=n;class i{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(S){}getLevel(){return p.Info}trace(S,...L){}debug(S,...L){}info(S,...L){}warn(S,...L){}error(S,...L){}critical(S,...L){}dispose(){}flush(){}}e.NullLogger=i;class o extends i{}e.NullLogService=o;function h(R){if(R.verbose)return p.Trace;if(typeof R.logLevel=="string"){const S=D(R.logLevel.toLowerCase());if(S!==void 0)return S}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function g(R){switch(R){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.LogLevelToString=g;function D(R){switch(R){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new m.RawContextKey("logLevel",g(p.Info))});var Z=this&&this.__param||function(x,e){return function(E,A){e(E,A,x)}};define(te[217],ie([0,1,75,4,2,5,3,7]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let f=e.BaseCredentialsMainService=class ht extends r.Disposable{constructor(w){super(),this.h=w,this.c=this.B(new A.Emitter),this.onDidChangePassword=this.c.event,this.g=new P.SequencerByKey}async getPassword(w,m){this.h.trace("Going to get password from keytar:",w,m);let v;try{v=await this.i()}catch{return null}return await this.g.queue(w+m,()=>this.k(v,w,m))}async k(w,m,v){this.h.trace("Doing get password from keytar:",m,v);const u=await(0,P.retry)(()=>w.getPassword(m,v),50,3);if(!u)return this.h.trace("Did not get a password from keytar for account:",v),u;let b,p;try{const s=JSON.parse(u);b=s.content,p=s.hasNextChunk}catch{}if(!b||!p)return this.h.trace("Got password from keytar for account:",v),u;try{let s=1;for(;p;){const y=await(0,P.retry)(()=>w.getPassword(m,`${v}-${s}`),50,3),a=JSON.parse(y);b+=a.content,p=a.hasNextChunk,s++}return this.h.trace(`Got ${s}-chunked password from keytar for account:`,v),b}catch(s){return this.h.error(s),u}}async setPassword(w,m,v){this.h.trace("Going to set password using keytar:",w,m);let u;try{u=await this.i()}catch(b){throw this.j?.(b),b}await this.g.queue(w+m,()=>this.l(u,w,m,v)),this.c.fire({service:w,account:m})}async l(w,m,v,u){if(this.h.trace("Doing set password from keytar:",m,v),!M.isWindows){await(0,P.retry)(()=>w.setPassword(m,v,u),50,3),this.h.trace("Set password from keytar for account:",v);return}if(await this.m(w,m,v),u.length<=ht.b){await(0,P.retry)(()=>w.setPassword(m,v,u),50,3),this.h.trace("Set password from keytar for account:",v);return}let b=0,p=0,s=!0;for(;s;){const y=u.substring(b,b+ht.b);b+=ht.b,s=u.length-b>0;const a={content:y,hasNextChunk:s};await(0,P.retry)(()=>w.setPassword(m,p?`${v}-${p}`:v,JSON.stringify(a)),50,3),p++}this.h.trace(`Set${p?` ${p}-chunked`:""} password from keytar for account:`,v)}async deletePassword(w,m){this.h.trace("Going to delete password using keytar:",w,m);let v;try{v=await this.i()}catch(b){throw this.j?.(b),b}const u=await this.g.queue(w+m,()=>this.m(v,w,m));return u&&this.c.fire({service:w,account:m}),u}async m(w,m,v){this.h.trace("Doing delete password from keytar:",m,v);const u=await w.getPassword(m,v);if(!u)return this.h.trace("Did not get a password to delete from keytar for account:",v),!1;let b,p;try{const y=JSON.parse(u);b=y.content,p=y.hasNextChunk}catch{}let s=0;if(b&&p)try{for(s++;p;){const y=`${v}-${s}`,a=await w.getPassword(m,y);await w.deletePassword(m,y),p=JSON.parse(a).hasNextChunk,s++}}catch(y){this.h.error(y)}return await w.deletePassword(m,v)?(this.h.trace(`Deleted${s?` ${s}-chunked`:""} password from keytar for account:`,v),!0):(this.h.trace(`Keytar failed to delete${s?` ${s}-chunked`:""} password for account:`,v),!1)}async findPassword(w){let m;try{m=await this.i()}catch{return null}return await m.findPassword(w)}async findCredentials(w){let m;try{m=await this.i()}catch{return[]}return await m.findCredentials(w)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};f.a=2500,f.b=f.a-100,e.BaseCredentialsMainService=f=ve([Z(0,O.ILogService)],f)}),define(te[218],ie([0,1,5]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let A=e.EncryptionMainService=class{constructor(O,M){this.a=O,this.b=M}c(){return new Promise((O,M)=>x(["vscode-encrypt"],O,M))}async encrypt(O){let M;try{M=await this.c()}catch{return O}try{return M.encrypt(this.a,O)}catch(P){return this.b.error(P),O}}async decrypt(O){let M;try{M=await this.c()}catch{return O}try{return M.decrypt(this.a,O)}catch(P){return this.b.error(P),O}}};e.EncryptionMainService=A=ve([Z(1,E.ILogService)],A)}),define(te[219],ie([0,1,24,7,13,4,2,9,76,5]),function(x,e,E,A,r,O,M,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class w extends M.Disposable{constructor(v,u){super(),this.a=v,this.b=u,this.c=this.B(new O.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new O.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new A.ThrottledDelayer(0)),this.s=[],this.t=this.B(new A.ThrottledDelayer(0))}watch(v,u){return u.recursive||this.b?.watcher?.forceUniversal?this.l(v,u):this.u(v,u)}l(v,u){const b={path:this.C(v),excludes:u.excludes,includes:u.includes,recursive:u.recursive},p=(0,E.insert)(this.j,b);return this.m(),(0,M.toDisposable)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(v=>(0,r.onUnexpectedError)(v))}n(){this.h||(this.h=this.B(this.p(u=>this.c.fire((0,f.toFileChanges)(u)),u=>this.z(u),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const u of this.j)(0,f.isRecursiveWatchRequest)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const u of this.j)(0,f.isRecursiveWatchRequest)(u)&&v.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(v,u){const b={path:this.C(v),excludes:u.excludes,includes:u.includes,recursive:!1},p=(0,E.insert)(this.s,b);return this.v(),(0,M.toDisposable)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(v=>(0,r.onUnexpectedError)(v))}w(){return this.r||(this.r=this.B(this.y(v=>this.c.fire((0,f.toFileChanges)(v)),v=>this.z(v),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.r.watch(this.s)}z(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}C(v){return(0,P.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=w}),define(te[220],ie([0,1,24,7,17,21,4,56,68,2,62,14,65,18,61,173,16,117,5,13]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=e.FileService=class extends l.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new M.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new M.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new M.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new M.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new A.ResourceQueue)}registerProvider(t,c){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${t}`);const n=new l.DisposableStore;return this.h.set(t,c),this.c.fire({added:!0,scheme:t,provider:c}),n.add(c.onDidChangeFile(i=>this.R.fire(new s.FileChangesEvent(i,!this.O(c))))),typeof c.onDidWatchError=="function"&&n.add(c.onDidWatchError(i=>this.S.fire(new Error(i)))),n.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:t}))),(0,l.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:c}),this.h.delete(t),(0,l.dispose)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const c=[];this.f.fire({scheme:t,join(n){c.push(n)}}),!this.h.has(t)&&await A.Promises.settled(c)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,c){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&c)}listCapabilities(){return f.Iterable.map(this.h,([t,c])=>({scheme:t,capabilities:c.capabilities}))}async j(t){if(!(0,u.isAbsolutePath)(t))throw new s.FileOperationError((0,p.localize)(0,null,this.ob(t)),8);await this.activateProvider(t.scheme);const c=this.h.get(t.scheme);if(!c){const n=new d.ErrorNoTelemetry;throw n.message=(0,p.localize)(1,null,t.toString()),n}return c}async k(t){const c=await this.j(t);if((0,s.hasOpenReadWriteCloseCapability)(c)||(0,s.hasReadWriteCapability)(c)||(0,s.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const c=await this.j(t);if((0,s.hasOpenReadWriteCloseCapability)(c)||(0,s.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,c){try{return await this.n(t,c)}catch(n){throw(0,s.toFileSystemProviderErrorCode)(n)===s.FileSystemProviderErrorCode.FileNotFound?new s.FileOperationError((0,p.localize)(2,null,this.ob(t)),1):(0,s.ensureFileSystemProviderError)(n)}}async n(t,c){const n=await this.j(t),i=this.O(n),o=c?.resolveTo,h=c?.resolveSingleChildDescendants,g=c?.resolveMetadata,D=await n.stat(t);let R;return this.p(n,t,D,void 0,!!g,(S,L)=>(R||(R=w.TernarySearchTree.forUris(()=>!i),R.set(t,!0),o&&R.fill(!0,o)),R.get(S.resource)||R.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&h?L===1:!1))}async p(t,c,n,i,o,h){const{providerExtUri:g}=this.N(t),D={resource:c,name:g.basename(c),isFile:(n.type&s.FileType.File)!==0,isDirectory:(n.type&s.FileType.Directory)!==0,isSymbolicLink:(n.type&s.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&s.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((n.permissions??0)&s.FilePermission.Locked),etag:(0,s.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(D.isDirectory&&h(D,i)){try{const R=await t.readdir(c),S=await A.Promises.settled(R.map(async([L,T])=>{try{const U=g.joinPath(c,L),H=o?await t.stat(U):{type:T};return await this.p(t,U,H,R.length,o,h)}catch(U){return this.b.trace(U),null}}));D.children=(0,E.coalesce)(S)}catch(R){this.b.trace(R),D.children=[]}return D}return D}async resolveAll(t){return A.Promises.settled(t.map(async c=>{try{return{stat:await this.n(c.resource,c.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const c=await this.j(t),n=await c.stat(t);return this.p(c,t,n,void 0,!0,()=>!1)}async exists(t){const c=await this.j(t);try{return!!await c.stat(t)}catch{return!1}}async canCreateFile(t,c){try{await this.r(t,c)}catch(n){return n}return!0}async r(t,c){if(!c?.overwrite&&await this.exists(t))throw new s.FileOperationError((0,p.localize)(3,null,this.ob(t)),3,c)}async createFile(t,c=r.VSBuffer.fromString(""),n){await this.r(t,n);const i=await this.writeFile(t,c);return this.m.fire(new s.FileOperationEvent(t,0,i)),i}async writeFile(t,c,n){const i=this.mb(await this.l(t),t),{providerExtUri:o}=this.N(i);try{await this.s(i,t,n)||await this.P(i,o.dirname(t));let g;if((0,s.hasReadWriteCapability)(i)&&!(c instanceof r.VSBuffer))if((0,b.isReadableStream)(c)){const D=await(0,b.peekStream)(c,3);D.ended?g=r.VSBuffer.concat(D.buffer):g=D}else g=(0,b.peekReadable)(c,D=>r.VSBuffer.concat(D),3);else g=c;if(!(0,s.hasOpenReadWriteCloseCapability)(i)||(0,s.hasReadWriteCapability)(i)&&g instanceof r.VSBuffer)await this.db(i,t,n,g);else{const D=g instanceof r.VSBuffer?(0,r.bufferToReadable)(g):g;n?.atomic!==!1&&n?.atomic?.postfix?await this.Y(i,t,(0,u.joinPath)((0,u.dirname)(t),`${(0,u.basename)(t)}${n.atomic.postfix}`),n,D):await this.Z(i,t,n,D)}this.m.fire(new s.FileOperationEvent(t,4))}catch(h){throw new s.FileOperationError((0,p.localize)(4,null,this.ob(t),(0,s.ensureFileSystemProviderError)(h).toString()),(0,s.toFileOperationResult)(h),n)}return this.resolve(t,{resolveMetadata:!0})}async s(t,c,n){const i=!!n?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.ob(c)));if(!!n?.atomic){if(!(t.capabilities&32768))throw new Error((0,p.localize)(6,null,this.ob(c)));if(i)throw new Error((0,p.localize)(7,null,this.ob(c)))}let h;try{h=await t.stat(c)}catch{return}if(h.type&s.FileType.Directory)throw new s.FileOperationError((0,p.localize)(8,null,this.ob(c)),0,n);if(this.nb(c,h),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==s.ETAG_DISABLED&&typeof h.mtime=="number"&&typeof h.size=="number"&&n.mtime<h.mtime&&n.etag!==(0,s.etag)({mtime:n.mtime,size:h.size}))throw new s.FileOperationError((0,p.localize)(9,null),3,n);return h}async readFile(t,c,n){const i=await this.k(t);return c?.atomic?this.t(i,t,c,n):this.u(i,t,c,n)}async t(t,c,n,i){return new Promise((o,h)=>{this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{try{const g=await this.u(t,c,n,i);o(g)}catch(g){h(g)}})})}async u(t,c,n,i){const o=await this.v(t,c,{...n,preferUnbuffered:!0},i);return{...o,value:await(0,r.streamToBuffer)(o.value)}}async readFileStream(t,c,n){const i=await this.k(t);return this.v(i,t,c,n)}async v(t,c,n,i){const o=new O.CancellationTokenSource(i),h=this.F(c,n).then(D=>D,D=>{throw o.cancel(),D});let g;try{return typeof n?.etag=="string"&&n.etag!==s.ETAG_DISABLED&&await h,n?.atomic&&(0,s.hasFileAtomicReadCapability)(t)||!((0,s.hasOpenReadWriteCloseCapability)(t)||(0,s.hasFileReadStreamCapability)(t))||(0,s.hasReadWriteCapability)(t)&&n?.preferUnbuffered?g=this.D(t,c,n):(0,s.hasFileReadStreamCapability)(t)?g=this.z(t,c,o.token,n):g=this.C(t,c,o.token,n),{...await h,value:g}}catch(D){throw g&&await(0,b.consumeStream)(g),this.w(D,c,n)}}w(t,c,n){const i=(0,p.localize)(10,null,this.ob(c),(0,s.ensureFileSystemProviderError)(t).toString());return t instanceof s.NotModifiedSinceFileOperationError?new s.NotModifiedSinceFileOperationError(i,t.stat,n):t instanceof s.TooLargeFileOperationError?new s.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new s.FileOperationError(i,(0,s.toFileOperationResult)(t),n)}z(t,c,n,i=Object.create(null)){const o=t.readFileStream(c,i,n);return(0,b.transform)(o,{data:h=>h instanceof r.VSBuffer?h:r.VSBuffer.wrap(h),error:h=>this.w(h,c,i)},h=>r.VSBuffer.concat(h))}C(t,c,n,i=Object.create(null)){const o=(0,r.newWriteableBufferStream)();return(0,y.readFileIntoStream)(t,c,o,h=>h,{...i,bufferSize:this.a,errorTransformer:h=>this.w(h,c,i)},n),o}D(t,c,n){const i=(0,b.newWriteableStream)(o=>r.VSBuffer.concat(o));return(async()=>{try{let o;n?.atomic&&(0,s.hasFileAtomicReadCapability)(t)?o=await t.readFile(c,{atomic:!0}):o=await t.readFile(c),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.G(c,o.byteLength,n),i.end(r.VSBuffer.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async F(t,c){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new s.FileOperationError((0,p.localize)(11,null,this.ob(t)),0,c);if(typeof c?.etag=="string"&&c.etag!==s.ETAG_DISABLED&&c.etag===n.etag)throw new s.NotModifiedSinceFileOperationError((0,p.localize)(12,null),n,c);return this.G(t,n.size,c),n}G(t,c,n){if(typeof n?.limits?.size=="number"&&c>n.limits.size)throw new s.TooLargeFileOperationError((0,p.localize)(13,null,this.ob(t)),7,c,n)}async canMove(t,c,n){return this.H(t,c,"move",n)}async canCopy(t,c,n){return this.H(t,c,"copy",n)}async H(t,c,n,i){if(t.toString()!==c.toString())try{const o=n==="move"?this.mb(await this.l(t),t):await this.k(t),h=this.mb(await this.l(c),c);await this.M(o,t,h,c,n,i)}catch(o){return o}return!0}async move(t,c,n){const i=this.mb(await this.l(t),t),o=this.mb(await this.l(c),c),h=await this.I(i,t,o,c,"move",!!n),g=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new s.FileOperationEvent(t,h==="move"?2:3,g)),g}async copy(t,c,n){const i=await this.k(t),o=this.mb(await this.l(c),c),h=await this.I(i,t,o,c,"copy",!!n),g=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new s.FileOperationEvent(t,h==="copy"?3:2,g)),g}async I(t,c,n,i,o,h){if(c.toString()===i.toString())return o;const{exists:g,isSameResourceWithDifferentPathCase:D}=await this.M(t,c,n,i,o,h);if(g&&!D&&h&&await this.del(i,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(i)),o==="copy"){if(t===n&&(0,s.hasFileFolderCopyCapability)(t))await t.copy(c,i,{overwrite:h});else{const R=await this.resolve(c);R.isDirectory?await this.L(t,R,n,i):await this.J(t,c,n,i)}return o}else return t===n?(await t.rename(c,i,{overwrite:h}),o):(await this.I(t,c,n,i,"copy",h),await this.del(c,{recursive:!0}),"copy")}async J(t,c,n,i){if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(n))return this.fb(t,c,n,i);if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasReadWriteCapability)(n))return this.lb(t,c,n,i);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(n))return this.jb(t,c,n,i);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasReadWriteCapability)(n))return this.hb(t,c,n,i)}async L(t,c,n,i){await n.mkdir(i),Array.isArray(c.children)&&await A.Promises.settled(c.children.map(async o=>{const h=this.N(n).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.L(t,await this.resolve(o.resource),n,h):this.J(t,o.resource,n,h)}))}async M(t,c,n,i,o,h){let g=!1;if(t===n){const{providerExtUri:R,isPathCaseSensitive:S}=this.N(t);if(S||(g=R.isEqual(c,i)),g&&o==="copy")throw new Error((0,p.localize)(14,null,this.ob(c),this.ob(i)));if(!g&&R.isEqualOrParent(i,c))throw new Error((0,p.localize)(15,null,this.ob(c),this.ob(i)))}const D=await this.exists(i);if(D&&!g){if(!h)throw new s.FileOperationError((0,p.localize)(16,null,this.ob(c),this.ob(i)),4);if(t===n){const{providerExtUri:R}=this.N(t);if(R.isEqualOrParent(c,i))throw new Error((0,p.localize)(17,null,this.ob(c),this.ob(i)))}}return{exists:D,isSameResourceWithDifferentPathCase:g}}N(t){const c=this.O(t);return{providerExtUri:c?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:c}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const c=this.mb(await this.j(t),t);await this.P(c,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new s.FileOperationEvent(t,0,n)),n}async P(t,c){const n=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(c,i.dirname(c));)try{if(!((await t.stat(c)).type&s.FileType.Directory))throw new Error((0,p.localize)(18,null,this.ob(c)));break}catch(o){if((0,s.toFileSystemProviderErrorCode)(o)!==s.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(i.basename(c)),c=i.dirname(c)}for(let o=n.length-1;o>=0;o--){c=i.joinPath(c,n[o]);try{await t.mkdir(c)}catch(h){if((0,s.toFileSystemProviderErrorCode)(h)!==s.FileSystemProviderErrorCode.FileExists)throw h}}}async canDelete(t,c){try{await this.Q(t,c)}catch(n){return n}return!0}async Q(t,c){const n=this.mb(await this.j(t),t),i=!!c?.useTrash;if(i&&!(n.capabilities&4096))throw new Error((0,p.localize)(19,null,this.ob(t)));const o=c?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,p.localize)(20,null,this.ob(t)));if(i&&o)throw new Error((0,p.localize)(21,null,this.ob(t)));let h;try{h=await n.stat(t)}catch{}if(h)this.nb(t,h);else throw new s.FileOperationError((0,p.localize)(22,null,this.ob(t)),1);if(!!!c?.recursive){const D=await this.resolve(t);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,p.localize)(23,null,this.ob(t)))}return n}async del(t,c){const n=await this.Q(t,c),i=!!c?.useTrash,o=!!c?.recursive,h=c?.atomic??!1;await n.delete(t,{recursive:o,useTrash:i,atomic:h}),this.m.fire(new s.FileOperationEvent(t,1))}async cloneFile(t,c){const n=await this.j(t),i=this.mb(await this.l(c),c);if(n===i&&this.N(n).providerExtUri.isEqual(t,c))return;if(n===i&&(0,s.hasFileCloneCapability)(n))return n.cloneFile(t,c);await this.P(i,this.N(i).providerExtUri.dirname(c));const o=this.X.queueFor(t,this.N(n).providerExtUri);return n===i&&(0,s.hasFileFolderCopyCapability)(n)?o.queue(()=>n.copy(t,c,{overwrite:!0})):o.queue(()=>this.J(n,t,i,c))}watch(t,c={recursive:!1,excludes:[]}){const n=new l.DisposableStore;let i=!1,o=()=>{i=!0};return n.add((0,l.toDisposable)(()=>o())),(async()=>{try{const h=await this.W(t,c);i?(0,l.dispose)(h):o=()=>(0,l.dispose)(h)}catch(h){this.b.error(h)}})(),n}async W(t,c){const n=await this.j(t),i=(0,P.hash)([this.N(n).providerExtUri.getComparisonKey(t),c]);let o=this.U.get(i);return o||(o={count:0,disposable:n.watch(t,c)},this.U.set(i,o)),o.count+=1,(0,l.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,l.dispose)(o.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,l.dispose)(t.disposable);this.U.clear()}async Y(t,c,n,i,o){await this.Z(t,n,i,o);try{await t.rename(n,c,{overwrite:!0})}catch(h){try{await t.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw h}}async Z(t,c,n,i){return this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{const o=await t.open(c,{create:!0,unlock:n?.unlock??!1});try{(0,b.isReadableStream)(i)||(0,b.isReadableBufferedStream)(i)?await this.ab(t,o,i):await this.bb(t,o,i)}catch(h){throw(0,s.ensureFileSystemProviderError)(h)}finally{await t.close(o)}})}async ab(t,c,n){let i=0,o;if((0,b.isReadableBufferedStream)(n)){if(n.buffer.length>0){const h=r.VSBuffer.concat(n.buffer);await this.cb(t,c,h,h.byteLength,i,0),i+=h.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((h,g)=>{(0,b.listenStream)(o,{onData:async D=>{o.pause();try{await this.cb(t,c,D,D.byteLength,i,0)}catch(R){return g(R)}i+=D.byteLength,setTimeout(()=>o.resume())},onError:D=>g(D),onEnd:()=>h()})})}async bb(t,c,n){let i=0,o;for(;(o=n.read())!==null;)await this.cb(t,c,o,o.byteLength,i,0),i+=o.byteLength}async cb(t,c,n,i,o,h){let g=0;for(;g<i;){const D=await t.write(c,o+g,n.buffer,h+g,i-g);g+=D}}async db(t,c,n,i){return this.X.queueFor(c,this.N(t).providerExtUri).queue(()=>this.eb(t,c,n,i))}async eb(t,c,n,i){let o;i instanceof r.VSBuffer?o=i:(0,b.isReadableStream)(i)?o=await(0,r.streamToBuffer)(i):(0,b.isReadableBufferedStream)(i)?o=await(0,r.bufferedStreamToBuffer)(i):o=(0,r.readableToBuffer)(i),await t.writeFile(c,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async fb(t,c,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.gb(t,c,n,i))}async gb(t,c,n,i){let o,h;try{o=await t.open(c,{create:!1}),h=await n.open(i,{create:!0,unlock:!1});const g=r.VSBuffer.alloc(this.a);let D=0,R=0,S=0;do S=await t.read(o,D,g.buffer,R,g.byteLength-R),await this.cb(n,h,g,S,D,R),D+=S,R+=S,R===g.byteLength&&(R=0);while(S>0)}catch(g){throw(0,s.ensureFileSystemProviderError)(g)}finally{await A.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof h=="number"?n.close(h):Promise.resolve()])}}async hb(t,c,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.ib(t,c,n,i))}async ib(t,c,n,i){return n.writeFile(i,await t.readFile(c),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async jb(t,c,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.kb(t,c,n,i))}async kb(t,c,n,i){const o=await n.open(i,{create:!0,unlock:!1});try{const h=await t.readFile(c);await this.cb(n,o,r.VSBuffer.wrap(h),h.byteLength,0,0)}catch(h){throw(0,s.ensureFileSystemProviderError)(h)}finally{await n.close(o)}}async lb(t,c,n,i){const o=await(0,r.streamToBuffer)(this.C(t,c,O.CancellationToken.None));await this.db(n,i,void 0,o)}mb(t,c){if(t.capabilities&2048)throw new s.FileOperationError((0,p.localize)(24,null,this.ob(c)),6);return t}nb(t,c){if((c.permissions??0)&s.FilePermission.Readonly)throw new s.FileOperationError((0,p.localize)(25,null,this.ob(t)),6)}ob(t){return t.scheme===m.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=I=ve([Z(0,a.ILogService)],I)}),define(te[92],ie([0,1,42,307,7,35,17,4,32,2,9,3,18,61,22,177,16,117,219,50,214,213]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a,d,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,A.gracefulify)(E)}catch(c){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(c)}`)}})();class t extends a.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=P.Event.None,this.I=new O.ResourceMap(o=>v.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,m.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:i,symbolicLink:o}=await b.SymlinkSupport.stat(this.C(n));return{type:this.H(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:s.FilePermission.Locked}}catch(i){throw this.bb(i)}}async G(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await b.Promises.readdir(this.C(n),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async h=>{try{let g;h.isSymbolicLink()?g=(await this.stat((0,v.joinPath)(n,h.name))).type:g=this.H(h),o.push([h.name,g])}catch(g){this.a.trace(g)}})),o}catch(i){throw this.bb(i)}}H(n,i){let o;return i?.dangling?o=s.FileType.Unknown:n.isFile()?o=s.FileType.File:n.isDirectory()?o=s.FileType.Directory:o=s.FileType.Unknown,i&&(o|=s.FileType.SymbolicLink),o}async J(n){const i=this.C(n);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.I.get(n);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const h=new r.Barrier;return this.I.set(n,h),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.toDisposable)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.I.get(n)===h&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.I.delete(n)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),h.open()})}async readFile(n,i){let o;try{i?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),o=await this.J(n));const h=this.C(n);return await b.Promises.readFile(h)}catch(h){throw this.bb(h)}finally{o?.dispose()}}L(n){t.D&&this.a.trace(n)}readFileStream(n,i,o){const h=(0,u.newWriteableStream)(g=>M.VSBuffer.concat(g.map(D=>M.VSBuffer.wrap(D))).buffer);return(0,y.readFileIntoStream)(this,n,h,g=>g.buffer,{...i,bufferSize:256*1024},o),h}async writeFile(n,i,o){return o?.atomic!==!1&&o?.atomic?.postfix?this.M(n,(0,v.joinPath)((0,v.dirname)(n),`${(0,v.basename)(n)}${o.atomic.postfix}`),i,o):this.N(n,i,o)}async M(n,i,o,h){await this.N(i,o,h);try{await this.rename(i,n,{overwrite:!0})}catch(g){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw g}}async N(n,i,o){let h;try{const g=this.C(n);if(!o.create||!o.overwrite){if(await b.Promises.exists(g)){if(!o.overwrite)throw(0,s.createFileSystemProviderError)((0,p.localize)(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,s.createFileSystemProviderError)((0,p.localize)(1,null),s.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(n,{create:!0,unlock:o.unlock}),await this.write(h,0,i,0,i.byteLength)}catch(g){throw await this.cb(n,g)}finally{typeof h=="number"&&await this.close(h)}}static configureFlushOnWrite(n){t.R=n}async open(n,i){const o=this.C(n);let h;(0,s.isFileOpenForWriteOptions)(i)&&(h=await this.J(n));let g;try{if((0,s.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:R}=await b.SymlinkSupport.stat(o);R.mode&128||await b.Promises.chmod(o,R.mode|128)}catch(R){R.code!=="ENOENT"&&this.a.trace(R)}let D;if((0,s.isFileOpenForWriteOptions)(i)){if(m.isWindows)try{await b.Promises.truncate(o,0),D="r+"}catch(R){R.code!=="ENOENT"&&this.a.trace(R)}D||(D="w")}else D="r";g=await b.Promises.open(o,D)}catch(D){throw h?.dispose(),(0,s.isFileOpenForWriteOptions)(i)?await this.cb(n,D):this.bb(D)}if(this.O.set(g,0),(0,s.isFileOpenForWriteOptions)(i)&&this.Q.set(g,n),h){const D=this.P.get(g);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${g} (${o})`),this.P.set(g,h),D&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${g} (${o})`),D.dispose())}return g}async close(n){const i=this.P.get(n);try{if(this.O.delete(n),this.Q.delete(n)&&t.R)try{await b.Promises.fdatasync(n)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await b.Promises.close(n)}catch(o){throw this.bb(o)}finally{i&&(this.P.get(n)===i&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.P.delete(n)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,o,h,g){const D=this.S(n,i);let R=null;try{R=(await b.Promises.read(n,o,h,g,D)).bytesRead}catch(S){throw this.bb(S)}finally{this.U(n,D,R)}return R}S(n,i){return i===this.O.get(n)?null:i}U(n,i,o){const h=this.O.get(n);typeof h=="number"&&(typeof i=="number"||(typeof o=="number"?this.O.set(n,h+o):this.O.delete(n)))}async write(n,i,o,h,g){return(0,r.retry)(()=>this.W(n,i,o,h,g),100,3)}async W(n,i,o,h,g){const D=this.S(n,i);let R=null;try{R=(await b.Promises.write(n,o,h,g,D)).bytesWritten}catch(S){throw await this.cb(this.Q.get(n),S)}finally{this.U(n,D,R)}return R}async mkdir(n){try{await b.Promises.mkdir(this.C(n))}catch(i){throw this.bb(i)}}async delete(n,i){try{const o=this.C(n);if(i.recursive){let h;i?.atomic!==!1&&i.atomic.postfix&&(h=(0,w.join)((0,w.dirname)(o),`${(0,w.basename)(o)}${i.atomic.postfix}`)),await b.Promises.rm(o,b.RimRafMode.MOVE,h)}else try{await b.Promises.unlink(o)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let g=!1;try{const{stat:D,symbolicLink:R}=await b.SymlinkSupport.stat(o);g=D.isDirectory()&&!R}catch{}if(g)await b.Promises.rmdir(o);else throw h}else throw h}}catch(o){throw this.bb(o)}}async rename(n,i,o){const h=this.C(n),g=this.C(i);if(h!==g)try{await this.X(n,i,"move",o.overwrite),await b.Promises.move(h,g)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,p.localize)(2,null,(0,w.basename)(h),(0,w.basename)((0,w.dirname)(g)),D.toString()))),this.bb(D)}}async copy(n,i,o){const h=this.C(n),g=this.C(i);if(h!==g)try{await this.X(n,i,"copy",o.overwrite),await b.Promises.copy(h,g,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,p.localize)(3,null,(0,w.basename)(h),(0,w.basename)((0,w.dirname)(g)),D.toString()))),this.bb(D)}}async X(n,i,o,h){const g=this.C(n),D=this.C(i);let R=!1;if(!!(this.capabilities&1024)||(R=(0,f.isEqual)(g,D,!0)),R){if(o==="copy")throw(0,s.createFileSystemProviderError)((0,p.localize)(4,null),s.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const L=await this.G(n);if(!L)throw(0,s.createFileSystemProviderError)((0,p.localize)(5,null),s.FileSystemProviderErrorCode.FileNotFound);const T=await this.G(i);if(T){if(!h)throw(0,s.createFileSystemProviderError)((0,p.localize)(6,null),s.FileSystemProviderErrorCode.FileExists);L.type&s.FileType.File&&T.type&s.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.Y(n,i,!1)}async Y(n,i,o){const h=this.C(n),g=this.C(i),D=!!(this.capabilities&1024);if((0,f.isEqual)(h,g,!D))return;const R=new l.DisposableStore;try{const[S,L]=await Promise.all([this.J(n),this.J(i)]);R.add(S),R.add(L),o&&await b.Promises.mkdir((0,w.dirname)(g),{recursive:!0}),await b.Promises.copyFile(h,g)}catch(S){if(S.code==="ENOENT"&&!o)return this.Y(n,i,!0);throw this.bb(S)}finally{R.dispose()}}p(n,i,o){return new I.UniversalWatcherClient(h=>n(h),h=>i(h),o)}y(n,i,o){return new k.NodeJSWatcherClient(h=>n(h),h=>i(h),o)}bb(n){if(n instanceof s.FileSystemProviderError)return n;let i=n,o;switch(n.code){case"ENOENT":o=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=s.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=s.FileSystemProviderErrorCode.Unknown;break;default:o=s.FileSystemProviderErrorCode.Unknown}return(0,s.createFileSystemProviderError)(i,o)}async cb(n,i){let o=this.bb(i);if(n&&o.code===s.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await b.SymlinkSupport.stat(this.C(n));h.mode&128||(o=(0,s.createFileSystemProviderError)(i,s.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return o}}e.DiskFileSystemProvider=t,t.D=!1,t.R=!0}),define(te[221],ie([0,1,4,92,2,17,61,21]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends r.Disposable{constructor(m,v){super(),this.a=m,this.b=v,this.w=new Map,this.y=new Map}call(m,v,u){const b=this.c(m);switch(v){case"stat":return this.g(b,u[0]);case"readdir":return this.h(b,u[0]);case"open":return this.l(b,u[0],u[1]);case"close":return this.m(u[0]);case"read":return this.n(u[0],u[1],u[2]);case"readFile":return this.i(b,u[0],u[1]);case"write":return this.p(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.k(b,u[0],u[1],u[2]);case"rename":return this.t(b,u[0],u[1],u[2]);case"copy":return this.u(b,u[0],u[1],u[2]);case"cloneFile":return this.v(b,u[0],u[1]);case"mkdir":return this.r(b,u[0]);case"delete":return this.s(b,u[0],u[1]);case"watch":return this.C(b,u[0],u[1],u[2],u[3]);case"unwatch":return this.D(u[0],u[1])}throw new Error(`IPC Command ${v} not found`)}listen(m,v,u){const b=this.c(m);switch(v){case"fileChange":return this.z(b,u[0]);case"readFileStream":return this.j(b,u[0],u[1])}throw new Error(`Unknown event ${v}`)}g(m,v){const u=this.f(m,v,!0);return this.a.stat(u)}h(m,v){const u=this.f(m,v);return this.a.readdir(u)}async i(m,v,u){const b=this.f(m,v,!0),p=await this.a.readFile(b,u);return O.VSBuffer.wrap(p)}j(m,v,u){const b=this.f(m,v,!0),p=new P.CancellationTokenSource,s=new E.Emitter({onDidRemoveLastListener:()=>{p.cancel()}}),y=this.a.readFileStream(b,u,p.token);return(0,M.listenStream)(y,{onData:a=>s.fire(O.VSBuffer.wrap(a)),onError:a=>s.fire(a),onEnd:()=>{s.fire("end"),s.dispose(),p.dispose()}}),s.event}k(m,v,u,b){const p=this.f(m,v);return this.a.writeFile(p,u.buffer,b)}l(m,v,u){const b=this.f(m,v,!0);return this.a.open(b,u)}m(m){return this.a.close(m)}async n(m,v,u){const b=O.VSBuffer.alloc(u),p=0,s=await this.a.read(m,v,b.buffer,p,u);return[b,s]}p(m,v,u,b,p){return this.a.write(m,v,u.buffer,b,p)}r(m,v){const u=this.f(m,v);return this.a.mkdir(u)}s(m,v,u){const b=this.f(m,v);return this.a.delete(b,u)}t(m,v,u,b){const p=this.f(m,v),s=this.f(m,u);return this.a.rename(p,s,b)}u(m,v,u,b){const p=this.f(m,v),s=this.f(m,u);return this.a.copy(p,s,b)}v(m,v,u){const b=this.f(m,v),p=this.f(m,u);return this.a.cloneFile(b,p)}z(m,v){const u=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(v,this.F(m,u))},onDidRemoveLastListener:()=>{(0,r.dispose)(this.w.get(v)),this.w.delete(v)}});return u.event}async C(m,v,u,b,p){const s=this.w.get(v);if(s){const y=this.f(m,b),a=s.watch(u,y,p);this.y.set(v+u,a)}}async D(m,v){const u=m+v,b=this.y.get(u);b&&((0,r.dispose)(b),this.y.delete(u))}dispose(){super.dispose();for(const[,m]of this.y)m.dispose();this.y.clear();for(const[,m]of this.w)m.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class l extends r.Disposable{constructor(m,v,u,b){super(),this.c=m,this.f=u,this.g=b,this.a=new Map,this.b=this.B(new A.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(v)}h(m){const v=this.B(new E.Emitter);this.B(v.event(u=>{m.fire(u.map(b=>({resource:this.c.transformOutgoingURI(b.resource),type:b.type})))})),this.B(this.b.onDidChangeFile(u=>v.fire(u))),this.B(this.b.onDidWatchError(u=>m.fire(u)))}i(m){}j(m){}watch(m,v,u){const b=this.j(this.g);return Array.isArray(b)&&(u.excludes=[...u.excludes,...b]),this.a.set(m,this.b.watch(v,u)),(0,r.toDisposable)(()=>{(0,r.dispose)(this.a.get(m)),this.a.delete(m)})}dispose(){super.dispose();for(const[,m]of this.a)m.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=l}),define(te[222],ie([0,1,15,176,3,8,16,9,221,153]),function(x,e,E,A,r,O,M,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class w extends f.AbstractDiskFileSystemProviderChannel{constructor(u,b,p){super(u,b),this.G=p}c(u){return l.DefaultURITransformer}f(u,b){return O.URI.revive(b)}async s(u,b,p){if(!p.useTrash)return super.s(u,b,p);const s=this.f(u,b),y=(0,P.normalize)(s.fsPath);try{await E.shell.trashItem(y)}catch{throw(0,M.createFileSystemProviderError)(r.isWindows?(0,A.localize)(0,null,(0,P.basename)(y)):(0,A.localize)(1,null,(0,P.basename)(y)),M.FileSystemProviderErrorCode.Unknown)}}F(u,b){return new m(u,b,this.b,this.G)}}e.DiskFileSystemProviderChannel=w;class m extends f.AbstractSessionFileWatcher{watch(u,b,p){if(p.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(u,b,p)}}}),define(te[223],ie([0,1,5]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class A extends E.AbstractMessageLogger{constructor(O=E.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(O),this.B(this.onDidChangeLogLevel(M=>{this.l?.setLevel(M)}))}set logger(O){this.l=O;for(const{level:M,message:P}of this.k)(0,E.log)(O,M,P);this.k=[]}g(O,M){this.l?(0,E.log)(this.l,O,M):this.getLevel()<=O&&this.k.push({level:O,message:M})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=A}),define(te[224],ie([0,1,8,4,5,2]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class M extends r.AbstractLoggerService{constructor(m,v,u,b,p){super(v,u,b),this.n=m,this.p=p,this.B(p.listen("onDidChangeLogLevel",m)(s=>{(0,r.isLogLevel)(s)?super.setLogLevel(s):super.setLogLevel(E.URI.revive(s[0]),s[1])})),this.B(p.listen("onDidChangeVisibility",m)(([s,y])=>super.setVisibility(E.URI.revive(s),y))),this.B(p.listen("onDidChangeLoggers",m)(({added:s,removed:y})=>{for(const a of s)super.registerLogger({...a,resource:E.URI.revive(a.resource)});for(const a of y)super.deregisterLogger(a.resource)}))}createConsoleMainLogger(){return new r.AdapterLogger({log:(m,v)=>{this.p.call("consoleLog",[m,v])}})}registerLogger(m){super.registerLogger(m),this.p.call("registerLogger",[m,this.n])}deregisterLogger(m){super.deregisterLogger(m),this.p.call("deregisterLogger",[m,this.n])}setLogLevel(m,v){super.setLogLevel(m,v),this.p.call("setLogLevel",[m,v])}setVisibility(m,v){super.setVisibility(m,v),this.p.call("setVisibility",[this.l(m),v])}m(m,v,u){return new P(this.p,m,v,u,this.n)}static setLogLevel(m,v,u){return m.call("setLogLevel",[v,u])}}e.LoggerChannelClient=M;class P extends r.AbstractMessageLogger{constructor(m,v,u,b,p){super(b?.logLevel==="always"),this.m=m,this.n=v,this.k=!1,this.l=[],this.setLevel(u),this.m.call("createLogger",[v,b,p]).then(()=>{this.r(this.l),this.k=!0})}g(m,v){const u=[[m,v]];this.k?this.r(u):this.l.push(...u)}r(m){this.m.call("log",[this.n,m])}}class f{constructor(m,v){this.a=m,this.b=v}listen(m,v){const u=this.b(m);switch(v){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,b=>({added:[...b.added].map(p=>this.c(p,u)),removed:[...b.removed].map(p=>this.c(p,u))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,b=>[u.transformOutgoingURI(b[0]),b[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,b=>(0,r.isLogLevel)(b)?b:[u.transformOutgoingURI(b[0]),b[1]])}throw new Error(`Event not found: ${v}`)}async call(m,v,u){const b=this.b(m);switch(v){case"setLogLevel":return(0,r.isLogLevel)(u[0])?this.a.setLogLevel(u[0]):this.a.setLogLevel(E.URI.revive(b.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,b)))}throw new Error(`Call not found: ${v}`)}c(m,v){return{...m,resource:v.transformOutgoingURI(m.resource)}}}e.LoggerChannel=f;class l extends O.Disposable{constructor(m,v){super(),v.call("setLogLevel",[m.getLogLevel()]),this.B(m.onDidChangeLogLevel(u=>v.call("setLogLevel",[u]))),v.call("getRegisteredLoggers").then(u=>{for(const b of u)m.registerLogger({...b,resource:E.URI.revive(b.resource)})}),this.B(v.listen("onDidChangeVisibility")(([u,b])=>m.setVisibility(E.URI.revive(u),b))),this.B(v.listen("onDidChangeLoggers")(({added:u,removed:b})=>{for(const p of u)m.registerLogger({...p,resource:E.URI.revive(p.resource)});for(const p of b)m.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=l}),define(te[225],ie([0,1,2,5]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class r extends E.Disposable{constructor(M,P=[]){super(),this.a=new A.MultiplexLogger([M,...P]),this.B(M.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...P){this.a.trace(M,...P)}debug(M,...P){this.a.debug(M,...P)}info(M,...P){this.a.info(M,...P)}warn(M,...P){this.a.warn(M,...P)}error(M,...P){this.a.error(M,...P)}flush(){this.a.flush()}}e.LogService=r}),define(te[226],ie([0,1,35,8,5]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class O{constructor(P){this.b=P,this.a=new E.ResourceMap}listen(P,f,l){switch(f){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(P,f,l){switch(f){case"createLogger":this.c(A.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(A.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,r.isLogLevel)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(A.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(A.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:A.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(A.URI.revive(l[0]))}throw new Error(`Call not found: ${f}`)}c(P,f,l){this.a.set(P,this.b.createLogger(P,f,l))}d(P,f){let l=console.log;switch(P){case r.LogLevel.Error:l=console.error;break;case r.LogLevel.Warning:l=console.warn;break;case r.LogLevel.Info:l=console.info;break}l.call(console,...f)}e(P,f){const l=this.a.get(P);if(!l)throw new Error("Create the logger before logging");for(const[w,m]of f)(0,r.log)(l,w,m)}}e.LoggerChannel=O}),define(te[227],ie([0,1,16,5]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var r;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(r||(r={}));async function O(l,w,m,v,u){try{const b=await new Promise((s,y)=>{x(["@vscode/spdlog"],s,y)});b.setFlushOn(r.Trace);const p=await b.createAsyncRotatingLogger(l,w,m,v);return u?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(b){console.error(b)}return null}function M(l,w,m){switch(w){case A.LogLevel.Trace:l.trace(m);break;case A.LogLevel.Debug:l.debug(m);break;case A.LogLevel.Info:l.info(m);break;case A.LogLevel.Warning:l.warn(m);break;case A.LogLevel.Error:l.error(m);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function P(l,w){switch(w){case A.LogLevel.Trace:l.setLevel(r.Trace);break;case A.LogLevel.Debug:l.setLevel(r.Debug);break;case A.LogLevel.Info:l.setLevel(r.Info);break;case A.LogLevel.Warning:l.setLevel(r.Warning);break;case A.LogLevel.Error:l.setLevel(r.Error);break;case A.LogLevel.Off:l.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class f extends A.AbstractMessageLogger{constructor(w,m,v,u,b){super(),this.k=[],this.setLevel(b),this.l=this.n(w,m,v,u),this.B(this.onDidChangeLogLevel(p=>{this.m&&P(this.m,p)}))}async n(w,m,v,u){const b=v?6:1,p=30/b*E.ByteSize.MB,s=await O(w,m,p,b,u);if(s){this.m=s,P(this.m,this.getLevel());for(const{level:y,message:a}of this.k)M(this.m,y,a);this.k=[]}}g(w,m){this.m?M(this.m,w,m):this.getLevel()<=w&&this.k.push({level:w,message:m})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=f}),define(te[228],ie([0,1,31,5,227]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class O extends A.AbstractLoggerService{m(P,f,l){return new r.SpdLogLogger((0,E.generateUuid)(),P.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,f)}}e.LoggerService=O}),define(te[66],ie([0,1,35,4,6,5,228]),function(x,e,E,A,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,r.refineServiceDecorator)(O.ILoggerService);class P extends M.LoggerService{constructor(){super(...arguments),this.p=new E.ResourceMap}createLogger(l,w,m){m!==void 0&&this.p.set(this.l(l),m);try{return super.createLogger(l,w)}catch(v){throw this.p.delete(this.l(l)),v}}registerLogger(l,w){w!==void 0&&this.p.set(l.resource,w),super.registerLogger(l)}deregisterLogger(l){this.p.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const w=[];for(const m of super.getRegisteredLoggers())l===this.p.get(m.resource)&&w.push(m);return w}getOnDidChangeLogLevelEvent(l){return A.Event.filter(this.onDidChangeLogLevel,w=>(0,O.isLogLevel)(w)||this.s(w[0],l))}getOnDidChangeVisibilityEvent(l){return A.Event.filter(this.onDidChangeVisibility,([w])=>this.s(w,l))}getOnDidChangeLoggersEvent(l){return A.Event.filter(A.Event.map(this.onDidChangeLoggers,w=>({added:[...w.added].filter(v=>this.s(v.resource,l)),removed:[...w.removed].filter(v=>this.s(v.resource,l))})),w=>w.added.length>0||w.removed.length>0)}deregisterLoggers(l){for(const[w,m]of this.p)m===l&&this.deregisterLogger(w)}s(l,w){const m=this.p.get(l);return m===void 0||m===w}dispose(){super.dispose(),this.p.clear()}}e.LoggerMainService=P}),define(te[229],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function A(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=A;function r(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=r;function O(M){return!E(M)&&!A(M)&&!r(M)}e.isMenubarMenuItemAction=O}),define(te[39],ie([0,1,4,68,2,6]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,O.createDecorator)("policy");class M extends r.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const w=Object.keys(this.f).length;return this.f={...l,...this.f},w!==Object.keys(this.f).length&&await this.i(l),A.Iterable.reduce(this.g.entries(),(m,[v,u])=>({...m,[v]:u}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(l,[w,m])=>({...l,[w]:{definition:m,value:this.g.get(w)}}),{})}}e.AbstractPolicyService=M;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(te[230],ie([0,1,7,4,68,11,16,5,39]),function(x,e,E,A,r,O,M,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(m,v){const u=[];for(const b of new Set(r.Iterable.concat(m.keys(),v.keys())))m.get(b)!==v.get(b)&&u.push(b);return u}let w=e.FilePolicyService=class extends f.AbstractPolicyService{constructor(v,u,b){super(),this.j=v,this.k=u,this.l=b,this.c=this.B(new E.ThrottledDelayer(500));const p=A.Event.filter(u.onDidFilesChange,s=>s.affects(v));this.B(u.watch(v)),this.B(p(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const v=new Map;try{const u=await this.k.readFile(this.j),b=JSON.parse(u.value.toString());if(!(0,O.isObject)(b))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(b))this.f[p]&&v.set(p,b[p])}catch(u){u.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",u)}return v}async p(){const v=await this.n(),u=l(this.g,v);this.g=v,u.length>0&&this.h.fire(u)}};e.FilePolicyService=w=ve([Z(1,M.IFileService),Z(2,P.ILogService)],w)}),define(te[231],ie([0,1,4,2,39]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class O{constructor(f){this.b=f,this.a=new A.DisposableStore}listen(f,l){switch(l){case"onDidChange":return E.Event.map(this.b.onDidChange,w=>w.reduce((m,v)=>({...m,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(f,l,w){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(w)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.PolicyChannel=O;class M extends r.AbstractPolicyService{constructor(f,l){super(),this.a=l;for(const w in f){const{definition:m,value:v}=f[w];this.f[w]=m,v!==void 0&&this.g.set(w,v)}this.a.listen("onDidChange")(w=>{for(const m in w){const v=w[m];v===null?this.g.delete(m):this.g.set(m,v)}this.h.fire(Object.keys(w))})}async i(f){const l=await this.a.call("updatePolicyDefinitions",f);for(const w in l)this.g.set(w,l[w])}}e.PolicyChannelClient=M}),define(te[232],ie([0,1,39,7,308,2,5]),function(x,e,E,A,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=e.NativePolicyService=class extends E.AbstractPolicyService{constructor(l,w){super(),this.j=l,this.k=w,this.a=new A.Throttler,this.b=this.B(new O.MutableDisposable)}async i(l){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((w,m)=>{try{this.b.value=(0,r.createWatcher)(this.k,l,v=>{this.m(v),w()})}catch(v){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),m(v)}}))}m(l){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const w in l){const m=l[w];m===void 0?this.g.delete(w):this.g.set(w,m)}this.h.fire(Object.keys(l))}};e.NativePolicyService=P=ve([Z(0,M.ILogService)],P)}),define(te[77],ie([0,1,3,36]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const O=E.globals.vscode.context.configuration();if(O)r=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:O.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(te[23],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[233],ie([0,1,70,5,23]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let O=e.ExtensionUrlTrustService=class{constructor(P,f){this.b=P,this.c=f,this.a=new Map}async isExtensionUrlTrusted(P,f){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const l=/^(.*)#([^#]+)$/.exec(f);if(!l)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,w,m]=l;let v=this.a.get(P);if(!v){if(v=this.b.trustedExtensionUrlPublicKeys[P],!v||v.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.a.set(P,[...v])}const u=Buffer.from(decodeURIComponent(m),"base64");if(u.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const b=u.slice(0,6),p=u.readUIntBE(0,6),s=Date.now()-p;if(s<0||s>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const y=u.slice(6),a=E.createVerify("SHA256");a.write(b),a.write(Buffer.from(w)),a.end();for(let d=0;d<v.length;d++){let I=v[d];if(I!==null){if(typeof I=="string")try{I=E.createPublicKey({key:Buffer.from(I,"base64"),format:"der",type:"spki"}),v[d]=I}catch(k){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${d+1} for ${P}:`,k),v[d]=null;continue}if(a.verify(I,y))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};e.ExtensionUrlTrustService=O=ve([Z(0,r.IProductService),Z(1,A.ILogService)],O)}),define(te[234],ie([0,1,7,5]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let r=e.WindowProfiler=class{constructor(M,P,f){this.a=M,this.b=P,this.c=f}async inspect(M){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.timeout)(M);const f=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const M=this.a.webContents.debugger;M.attach(),await M.sendCommand("Profiler.enable")}async e(){const M=this.a.webContents.debugger;await M.sendCommand("Profiler.disable"),M.detach()}};e.WindowProfiler=r=ve([Z(2,A.ILogService)],r)}),define(te[78],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(te[47],ie([0,1,134,11]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class r{constructor(){this.a=new Map}add(M,P){E.ok(A.isString(M)),E.ok(A.isObject(P)),E.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,P)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.Registry=new r}),define(te[235],ie([0,1,4,47]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function r(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class O{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,l){this.a[r(f)]=l,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const M=new O;A.Registry.add(e.Extensions.JSONContribution,M)}),define(te[57],ie([0,1,24,4,11,161,19,235,47]),function(x,e,E,A,r,O,M,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w||(e.ConfigurationScope=w={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const m=f.Registry.as(P.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const n=new Set;this.n(t,c,n),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const c=new Set;this.o(t,c),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const n=new Set;this.o(c,n),this.n(t,!1,n),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const n=[];for(const{overrides:i,source:o}of t)for(const h in i)if(c.add(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const g=this.a.get(h),D=g?.valuesSources??new Map;if(o)for(const T of Object.keys(i[h]))D.set(T,o);const R={...g?.value||{},...i[h]};this.a.set(h,{source:o,value:R,valuesSources:D});const S=(0,M.getLanguageTagSettingPlainKey)(h),L={type:"object",default:R,description:O.localize(1,null,S),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:r.isString(o)?void 0:o,defaultValueSource:o};n.push(...p(h)),this.d[h]=L,this.b.properties[h]=L}else{this.a.set(h,{value:i[h],source:o});const g=this.d[h];g&&(this.w(h,g),this.r(h,g))}this.m(n)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:n,source:i}of t)for(const o in n){const h=this.a.get(o),g=r.isString(i)?i:i?.id,D=r.isString(h?.source)?h?.source:h?.source?.id;if(g===D)if(c.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const R=this.d[o];R&&(this.w(o,R),this.r(o,R))}}this.u()}deltaConfiguration(t){let c=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,n){t.forEach(i=>{this.p(i,c,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(t,c){const n=i=>{if(i.properties)for(const o in i.properties){c.add(o);const h=this.d[o];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[o],this.s(o,i.properties[o])}i.allOf?.forEach(o=>n(o))};for(const i of t){n(i);const o=this.c.indexOf(i);o!==-1&&this.c.splice(o,1)}}p(t,c=!0,n,i,o=3,h){o=r.isUndefinedOrNull(t.scope)?o:t.scope;const g=t.properties;if(g)for(const R in g){const S=g[R];if(c&&d(R,S)){delete g[R];continue}if(S.source=n,S.defaultDefaultValue=g[R].default,this.w(R,S),e.OVERRIDE_PROPERTY_REGEX.test(R)?S.scope=void 0:(S.scope=r.isUndefinedOrNull(S.scope)?o:S.scope,S.restricted=r.isUndefinedOrNull(S.restricted)?!!i?.includes(R):S.restricted),g[R].hasOwnProperty("included")&&!g[R].included){this.f[R]=g[R],delete g[R];continue}else this.d[R]=g[R],g[R].policy?.name&&this.e.set(g[R].policy.name,R);!g[R].deprecationMessage&&g[R].markdownDeprecationMessage&&(g[R].deprecationMessage=g[R].markdownDeprecationMessage),h.add(R)}const D=t.allOf;if(D)for(const R of D)this.p(R,c,n,i,o,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=n=>{const i=n.properties;if(i)for(const h in i)this.r(h,i[h]);n.allOf?.forEach(c)};c(t)}r(t,c){switch(e.allSettings.properties[t]=c,c.scope){case 1:e.applicationSettings.properties[t]=c;break;case 2:e.machineSettings.properties[t]=c;break;case 6:e.machineOverridableSettings.properties[t]=c;break;case 3:e.windowSettings.properties[t]=c;break;case 4:e.resourceSettings.properties[t]=c;break;case 5:e.resourceSettings.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.allSettings.properties[t],c.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,n={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(c,n),e.allSettings.properties[c]=n,e.applicationSettings.properties[c]=n,e.machineSettings.properties[c]=n,e.machineOverridableSettings.properties[c]=n,e.windowSettings.properties[c]=n,e.resourceSettings.properties[c]=n}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,c){const n=this.a.get(t);let i=n?.value,o=n?.source;r.isUndefined(i)&&(i=c.defaultDefaultValue,o=void 0),r.isUndefined(i)&&(i=y(c.type)),c.default=i,c.defaultValueSource=o}}const u="\\[([^\\]]+)\\]",b=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(k){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(k)){let c=b.exec(k);for(;c?.length;){const n=c[1].trim();n&&t.push(n),c=b.exec(k)}}return(0,E.distinct)(t)}e.overrideIdentifiersFromKey=p;function s(k){return k.reduce((t,c)=>`${t}[${c}]`,"")}e.keyFromOverrideIdentifiers=s;function y(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const a=new v;f.Registry.add(e.Extensions.Configuration,a);function d(k,t){return k.trim()?e.OVERRIDE_PROPERTY_REGEX.test(k)?O.localize(7,null,k):a.getConfigurationProperties()[k]!==void 0?O.localize(8,null,k):t.policy?.name&&a.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,k,t.policy?.name,a.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}e.validateProperty=d;function I(){const k=[],t=a.getConfigurationProperties();for(const c of Object.keys(t))k.push([c,t[c].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=I}),define(te[118],ie([0,1,24,4,44,2,35,37,11,8,19,57,47]),function(x,e,E,A,r,O,M,P,f,l,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function u(c){return Object.isFrozen(c)?c:P.deepFreeze(c)}class b{constructor(n={},i=[],o=[],h){this.b=n,this.c=i,this.d=o,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof b)return i;const o=new p("");return o.parseRaw(i),o.configurationModel});this.f=n.reduce((i,o)=>o===i?o:i.merge(o),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,w.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const o=this.rawConfiguration.getValue(n),h=i?this.rawConfiguration.getOverrideValue(n,i):void 0,g=i?this.rawConfiguration.override(i).getValue(n):o;return{value:o,override:h,merged:g}}getOverrideValue(n,i){const o=this.i(i);return o?n?(0,w.getConfigurationValue)(o,n):o:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const o of this.overrides)o.identifiers.includes(n)&&i.push(...o.keys);return E.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return E.distinct(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=P.deepClone(this.contents),o=P.deepClone(this.overrides),h=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const D of n)if(g.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(i,D.contents);for(const R of D.overrides){const[S]=o.filter(L=>E.equals(L.identifiers,R.identifiers));S?(this.h(S.contents,R.contents),S.keys.push(...R.keys),S.keys=E.distinct(S.keys)):o.push(P.deepClone(R))}for(const R of D.keys)h.indexOf(R)===-1&&h.push(R)}return new b(i,h,o,g.every(D=>D instanceof b)?void 0:g)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const h of E.distinct([...Object.keys(this.contents),...Object.keys(i)])){let g=this.contents[h];const D=i[h];D&&(typeof g=="object"&&typeof D=="object"?(g=P.deepClone(g),this.h(g,D)):g=D),o[h]=g}return new b(o,this.keys,this.overrides)}h(n,i){for(const o of Object.keys(i)){if(o in n&&f.isObject(n[o])&&f.isObject(i[o])){this.h(n[o],i[o]);continue}n[o]=P.deepClone(i[o])}}i(n){let i=null,o=null;const h=g=>{g&&(o?this.h(o,g):o=P.deepClone(g))};for(const g of this.overrides)E.equals(g.identifiers,[n])?i=g.contents:g.identifiers.includes(n)&&h(g.contents);return h(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,w.removeFromValueTree)(this.contents,n),m.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(o=>E.equals(o.identifiers,(0,m.overrideIdentifiersFromKey)(n))),1))}j(n,i,o){(0,w.addToValueTree)(this.contents,n,i,h=>console.error(h)),o=o||this.keys.indexOf(n)===-1,o&&this.keys.push(n),m.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,m.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,w.toValuesTree)(this.contents[n],h=>console.error(h))})}}e.ConfigurationModel=b;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!f.isUndefinedOrNull(n)){const o=this.g(n);this.parseRaw(o,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:o,keys:h,overrides:g,restricted:D,hasExcludedProperties:R}=this.h(n,i);this.b=new b(o,h,g,R?[n]:void 0),this.c=D||[]}g(n){let i={},o=null,h=[];const g=[],D=[];function R(L){Array.isArray(h)?h.push(L):o!==null&&(h[o]=L)}const S={onObjectBegin:()=>{const L={};R(L),g.push(h),h=L,o=null},onObjectProperty:L=>{o=L},onObjectEnd:()=>{h=g.pop()},onArrayBegin:()=>{const L=[];R(L),g.push(h),h=L,o=null},onArrayEnd:()=>{h=g.pop()},onLiteralValue:R,onError:(L,T,U)=>{D.push({error:L,offset:T,length:U})}};if(n)try{r.visit(n,S),i=h[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return i}h(n,i){const o=v.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),h=this.i(n,o,!0,i);n=h.raw;const g=(0,w.toValuesTree)(n,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),D=Object.keys(n),R=this.j(n,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:g,keys:D,overrides:R,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(n,i,o,h){let g=!1;if(!h?.scopes&&!h?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:g};const D={},R=[];for(const S in n)if(m.OVERRIDE_PROPERTY_REGEX.test(S)&&o){const L=this.i(n[S],i,!1,h);D[S]=L.raw,g=g||L.hasExcludedProperties,R.push(...L.restricted)}else{const L=i[S],T=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&R.push(S),(T===void 0||h.scopes===void 0||h.scopes.includes(T))&&!(h.skipRestricted&&L?.restricted)?D[S]=n[S]:g=!0}return{raw:D,restricted:R,hasExcludedProperties:g}}j(n,i){const o=[];for(const h of Object.keys(n))if(m.OVERRIDE_PROPERTY_REGEX.test(h)){const g={};for(const D in n[h])g[D]=n[h][D];o.push({identifiers:(0,m.overrideIdentifiersFromKey)(h),keys:Object.keys(g),contents:(0,w.toValuesTree)(g,i)})}return o}}e.ConfigurationModelParser=p;class s extends O.Disposable{constructor(n,i,o,h){super(),this.f=n,this.g=i,this.h=h,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new p(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,g=>g.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,g=>(g.isOperation(0)||g.isOperation(3)||g.isOperation(1)||g.isOperation(4))&&o.isEqual(g.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new b}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=s;class y{constructor(n,i,o,h,g,D,R,S,L,T,U,H,re){this.a=n,this.b=i,this.c=o,this.overrideIdentifiers=h,this.d=g,this.f=D,this.g=R,this.h=S,this.i=L,this.j=T,this.k=U,this.l=H,this.m=re}get value(){return u(this.c)}n(n,i,o){const h=n.inspect(i,o);return{get value(){return u(h.value)},get override(){return u(h.override)},get merged(){return u(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(n,i,o,h,g=new b,D=new b,R=new M.ResourceMap,S=new b,L=new M.ResourceMap){this.c=n,this.d=i,this.f=o,this.g=h,this.h=g,this.i=D,this.j=R,this.l=S,this.m=L,this.a=null,this.b=new M.ResourceMap,this.n=null}getValue(n,i,o){return this.q(n,i,o).getValue(n)}updateValue(n,i,o={}){let h;o.resource?(h=this.m.get(o.resource),h||(h=new b,this.m.set(o.resource,h))):h=this.l,i===void 0?h.removeValue(n):h.setValue(n,i),o.resource||(this.a=null)}inspect(n,i,o){const h=this.q(n,i,o),g=this.u(i.resource,o),D=i.resource?this.m.get(i.resource)||this.l:this.l,R=new Set;for(const S of h.overrides)for(const L of S.identifiers)h.getOverrideValue(n,L)!==void 0&&R.add(L);return new y(n,i,h.getValue(n),R.size?[...R]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,g||void 0,D)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const o=[];if(!i){const{added:h,updated:g,removed:D}=k(this.c,n);i=[...h,...g,...D]}for(const h of i)for(const g of(0,m.overrideIdentifiersFromKey)(h)){const D=this.c.getKeysForOverrideIdentifier(g),R=n.getKeysForOverrideIdentifier(g),S=[...R.filter(L=>D.indexOf(L)===-1),...D.filter(L=>R.indexOf(L)===-1),...D.filter(L=>!P.equals(this.c.override(g).getValue(L),n.override(g).getValue(L)))];o.push([g,S])}return this.updateDefaultConfiguration(n),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:o,removed:h}=k(this.d,n),g=[...i,...o,...h];return g.length&&this.updatePolicyConfiguration(n),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:o,removed:h,overrides:g}=k(this.applicationConfiguration,n),D=[...i,...o,...h];return D.length&&this.updateApplicationConfiguration(n),{keys:D,overrides:g}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:o,removed:h,overrides:g}=k(this.localUserConfiguration,n),D=[...i,...o,...h];return D.length&&this.updateLocalUserConfiguration(n),{keys:D,overrides:g}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:o,removed:h,overrides:g}=k(this.remoteUserConfiguration,n),D=[...i,...o,...h];return D.length&&this.updateRemoteUserConfiguration(n),{keys:D,overrides:g}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:o,removed:h,overrides:g}=k(this.workspaceConfiguration,n),D=[...i,...o,...h];return D.length&&this.updateWorkspaceConfiguration(n),{keys:D,overrides:g}}compareAndUpdateFolderConfiguration(n,i){const o=this.p.get(n),{added:h,updated:g,removed:D,overrides:R}=k(o,i),S=[...h,...g,...D];return(S.length||!o)&&this.updateFolderConfiguration(n,i),{keys:S,overrides:R}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:o,updated:h,removed:g,overrides:D}=k(i,void 0);return{keys:[...o,...h,...g],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,o){let h=this.r(i,o);return i.overrideIdentifier&&(h=h.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(h=h.merge(this.d)),h}r({resource:n},i){let o=this.s();if(i&&n){const h=i.getFolder(n);h&&(o=this.t(h.uri)||o);const g=this.m.get(n);g&&(o=o.merge(g))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const o=this.s(),h=this.j.get(n);h?(i=o.merge(h),this.b.set(n,i)):i=o}return i}u(n,i){if(i&&n){const o=i.getFolder(n);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:o,overrides:h,keys:g}=this.j.get(i);return n.push([i,{contents:o,overrides:h,keys:g}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(o=>n.add(o))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(o=>n.add(o))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this.i.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(n).forEach(h=>i.add(h))),[...i.values()]}static parse(n){const i=this.x(n.defaults),o=this.x(n.policy),h=this.x(n.application),g=this.x(n.user),D=this.x(n.workspace),R=n.folders.reduce((S,L)=>(S.set(l.URI.revive(L[0]),this.x(L[1])),S),new M.ResourceMap);return new a(i,o,h,g,new b,D,R,new b,new M.ResourceMap)}static x(n){return new b(n.contents,n.keys,n.overrides)}}e.Configuration=a;function d(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const n=new Set,i=new Map;for(const h of c)h.keys.forEach(g=>n.add(g)),h.overrides.forEach(([g,D])=>{const R=(0,M.getOrSet)(i,g,new Set);D.forEach(S=>R.add(S))});const o=[];return i.forEach((h,g)=>o.push([g,[...h.values()]])),{keys:[...n.values()],overrides:o}}e.mergeChanges=d;class I{constructor(n,i,o,h){this.change=n,this.f=i,this.g=o,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const g of n.keys)this.affectedKeys.add(g);for(const[,g]of n.overrides)for(const D of g)this.affectedKeys.add(D);this.d=this.a;for(const g of this.affectedKeys)this.d+=g+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(n,i){const o=this.a+n,h=this.d.indexOf(o);if(h<0)return!1;const g=h+o.length;if(g>=this.d.length)return!1;const D=this.d.charCodeAt(g);if(D!==this.b&&D!==this.c)return!1;if(i){const R=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,S=this.g.getValue(n,i,this.h);return!P.equals(R,S)}return!0}}e.ConfigurationChangeEvent=I;function k(c,n){const{added:i,removed:o,updated:h}=t(n?.rawConfiguration,c?.rawConfiguration),g=[],D=c?.getAllOverrideIdentifiers()||[],R=n?.getAllOverrideIdentifiers()||[];if(n){const S=R.filter(L=>!D.includes(L));for(const L of S)g.push([L,n.getKeysForOverrideIdentifier(L)])}if(c){const S=D.filter(L=>!R.includes(L));for(const L of S)g.push([L,c.getKeysForOverrideIdentifier(L)])}if(n&&c){for(const S of D)if(R.includes(S)){const L=t({contents:c.getOverrideValue(void 0,S)||{},keys:c.getKeysForOverrideIdentifier(S)},{contents:n.getOverrideValue(void 0,S)||{},keys:n.getKeysForOverrideIdentifier(S)});g.push([S,[...L.added,...L.removed,...L.updated]])}}return{added:i,removed:o,updated:h,overrides:g}}function t(c,n){const i=c?n?c.keys.filter(g=>n.keys.indexOf(g)===-1):[...c.keys]:[],o=n?c?n.keys.filter(g=>c.keys.indexOf(g)===-1):[...n.keys]:[],h=[];if(c&&n){for(const g of n.keys)if(c.keys.indexOf(g)!==-1){const D=(0,w.getConfigurationValue)(n.contents,g),R=(0,w.getConfigurationValue)(c.contents,g);P.equals(D,R)||h.push(g)}}return{added:i,removed:o,updated:h}}}),define(te[236],ie([0,1,24,4,2,37,11,118,57,5,39,47]),function(x,e,E,A,r,O,M,P,f,l,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class v extends r.Disposable{constructor(){super(...arguments),this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(m.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:s,defaultsOverrides:y})=>this.c(Array.from(s),y))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(s,y){this.h(s,m.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:s})}f(){return{}}g(){this.b=new P.ConfigurationModel;const s=m.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(s),s)}h(s,y){const a=this.f();for(const d of s){const I=a[d],k=y[d];I!==void 0?this.b.addValue(d,I):k?this.b.addValue(d,k.default):this.b.removeValue(d)}}}e.DefaultConfiguration=v;class u{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=u;let b=e.PolicyConfiguration=class extends r.Disposable{get configurationModel(){return this.b}constructor(s,y,a){super(),this.c=s,this.f=y,this.g=a,this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(s=>this.i(s))),this.B(this.c.onDidChangeConfiguration(async({properties:s})=>this.j(await this.h(s),!0))),this.b}async h(s){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",s);const y={},a=[],d=m.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const I of s){const k=d[I];if(!k){a.push(I);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.g.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}a.push(I),y[k.policy.name]={type:k.type}}}return(0,M.isEmptyObject)(y)||await this.f.updatePolicyDefinitions(y),a}i(s){this.g.trace("PolicyConfiguration#onDidChangePolicies",s);const y=m.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),a=(0,E.coalesce)(s.map(d=>y.get(d)));this.j(a,!0)}j(s,y){this.g.trace("PolicyConfiguration#update",s);const a=m.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),d=[],I=this.b.isEmpty();for(const k of s){const t=a[k]?.policy?.name;if(t){const c=this.f.getPolicyValue(t);(I?c!==void 0:!(0,O.equals)(this.b.getValue(k),c))&&d.push([k,c])}else this.b.getValue(k)!==void 0&&d.push([k,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const k=this.b;this.b=new P.ConfigurationModel;for(const t of k.keys)this.b.setValue(t,k.getValue(t));for(const[t,c]of d)c===void 0?this.b.removeValue(t):this.b.setValue(t,c);y&&this.a.fire(this.b)}}};e.PolicyConfiguration=b=ve([Z(1,w.IPolicyService),Z(2,l.ILogService)],b)}),define(te[237],ie([0,1,7,4,2,18,19,118,236,39]),function(x,e,E,A,r,O,M,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class w extends r.Disposable{constructor(v,u,b,p){super(),this.i=v,this.h=this.B(new A.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.DefaultConfiguration),this.c=b instanceof l.NullPolicyService?new f.NullPolicyConfiguration:this.B(new f.PolicyConfiguration(this.b,b,p)),this.f=this.B(new P.UserSettings(this.i,void 0,O.extUriBiasedIgnorePathCase,u)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:y})=>this.k(s,y))),this.B(this.c.onDidChangeConfiguration(s=>this.l(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,u,b]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(v,u,new P.ConfigurationModel,b)}getConfigurationData(){return this.a.toData()}getValue(v,u){const b=typeof v=="string"?v:void 0,p=(0,M.isConfigurationOverrides)(v)?v:(0,M.isConfigurationOverrides)(u)?u:{};return this.a.getValue(b,p,void 0)}updateValue(v,u,b,p){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.j(v)}j(v){const u=this.a.toData(),b=this.a.compareAndUpdateLocalUserConfiguration(v);this.m(b,u,2)}k(v,u){const b=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(v,u);this.m(p,b,7)}l(v){const u=this.a.toData(),b=this.a.compareAndUpdatePolicyConfiguration(v);this.m(b,u,7)}m(v,u,b){const p=new P.ConfigurationChangeEvent(v,{data:u},this.a);p.source=b,p.sourceConfig=this.n(b),this.h.fire(p)}n(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=w}),define(te[238],ie([0,1,13,6]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var r;(function(w){w[w.WebSocket=0]="WebSocket",w[w.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class O{constructor(m){this.id=m,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class M{constructor(m,v){this.host=m,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=M;var P;(function(w){w.Unknown="Unknown",w.NotAvailable="NotAvailable",w.TemporarilyNotAvailable="TemporarilyNotAvailable",w.NoResolverFound="NoResolverFound"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class f extends E.ErrorNoTelemetry{static isNotAvailable(m){return m instanceof f&&m._code===P.NotAvailable}static isTemporarilyNotAvailable(m){return m instanceof f&&m._code===P.TemporarilyNotAvailable}static isNoResolverFound(m){return m instanceof f&&m._code===P.NoResolverFound}static isHandled(m){return m instanceof f&&m.isHandled}constructor(m,v=P.Unknown,u){super(m),this._message=m,this._code=v,this._detail=u,this.isHandled=v===P.NotAvailable&&u===!0,Object.setPrototypeOf(this,f.prototype)}}e.RemoteAuthorityResolverError=f;function l(w){const m=w.indexOf("+");return m===-1?w:w.substring(0,m)}e.getRemoteAuthorityPrefix=l}),define(te[58],ie([0,1,14]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(l){return l.scheme===E.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=A;function r(l){if(!l)return;const w=l.indexOf("+");return w<0?l:l.substr(0,w)}e.getRemoteName=r;function O(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=O;function M(l){const{host:w,port:m}=f(l);if(typeof m>"u")throw new Error("Remote authority doesn't contain a port!");return{host:w,port:m}}e.parseAuthorityWithPort=M;function P(l,w){let{host:m,port:v}=f(l);return typeof v>"u"&&(v=w),{host:m,port:v}}e.parseAuthorityWithOptionalPort=P;function f(l){const w=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const m=l.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const v=l.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:l,port:void 0}}}),define(te[119],ie([0,1,25,6,58]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var M;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(M||(e.ExtensionType=M={}));var P;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class f{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,y){if(typeof s>"u"||s===null)return typeof y>"u"||y===null;if(typeof y>"u"||y===null)return!1;if(typeof s=="string"||typeof y=="string"){const a=typeof s=="string"?s:s.value,d=typeof y=="string"?y:y.value;return E.equalsIgnoreCase(a,d)}return s._lower===y._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.ExtensionIdentifier=f;class l{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const y of s)this.add(y)}add(s){this.c.add(f.toKey(s))}delete(s){return this.c.delete(f.toKey(s))}has(s){return this.c.has(f.toKey(s))}}e.ExtensionIdentifierSet=l;class w{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(f.toKey(s))}get(s){return this.c.get(f.toKey(s))}has(s){return this.c.has(f.toKey(s))}set(s,y){this.c.set(f.toKey(s),y)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=w;function m(p){return v(p)}e.isApplicationScopedExtension=m;function v(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function u(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=u;function b(p,s){if(s){const y=`onResolveRemoteAuthority:${(0,r.getRemoteName)(s)}`;return!!p.activationEvents?.includes(y)}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[239],ie([0,1,7,17,21,13,4,2,65,85,31,108,238,58]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var p;(function(C){C[C.Management=1]="Management",C[C.ExtensionHost=2]="ExtensionHost",C[C.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function s(C){switch(C){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function y(C){const W=new r.CancellationTokenSource;return setTimeout(()=>W.cancel(),C),W.token}function a(C,W){if(C.isCancellationRequested||W.isCancellationRequested)return r.CancellationToken.Cancelled;const z=new r.CancellationTokenSource;return C.onCancellationRequested(()=>z.cancel()),W.onCancellationRequested(()=>z.cancel()),z.token}class d{get didTimeout(){return this.c==="timedout"}constructor(W){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((z,q)=>{this.f=z,this.g=q}),W.isCancellationRequested?this.h():this.d.add(W.onCancellationRequested(()=>this.h()))}registerDisposable(W){this.c==="pending"?this.d.add(W):W.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(W))}reject(W){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(W))}}function I(C,W){const z=new d(W);return z.registerDisposable(C.onControlMessage(q=>{const j=JSON.parse(q.toString()),$=V(j);$?z.reject($):z.resolve(j)})),z.promise}function k(C,W,z,q,j,$,K,se){const ue=new d(se),be=l.StopWatch.create(!1);return C.info(`Creating a socket (${K})...`),f.mark(`code/willCreateSocket/${$}`),W.connect(z,q,j,K).then(ke=>{ue.didTimeout?(f.mark(`code/didCreateSocketError/${$}`),C.info(`Creating a socket (${K}) finished after ${be.elapsed()} ms, but this is too late and has timed out already.`),ke?.dispose()):(f.mark(`code/didCreateSocketOK/${$}`),C.info(`Creating a socket (${K}) was successful after ${be.elapsed()} ms.`),ue.resolve(ke))},ke=>{f.mark(`code/didCreateSocketError/${$}`),C.info(`Creating a socket (${K}) returned an error after ${be.elapsed()} ms.`),C.error(ke),ue.reject(ke)}),ue.promise}function t(C,W){const z=new d(W);return C.then(q=>{z.didTimeout||z.resolve(q)},q=>{z.didTimeout||z.reject(q)}),z.promise}async function c(C,W,z,q){const j=oe(C,W);C.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let $;try{$=await k(C.logService,C.remoteSocketFactoryService,C.connectTo,(0,u.getRemoteServerRootPath)(C),`reconnectionToken=${C.reconnectionToken}&reconnection=${C.reconnectionProtocol?"true":"false"}`,s(W),`renderer-${s(W)}-${C.reconnectionToken}`,q)}catch(ke){throw C.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),C.logService.error(ke),ke}C.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let K,se;C.reconnectionProtocol?(C.reconnectionProtocol.beginAcceptReconnection($,null),K=C.reconnectionProtocol,se=!1):(K=new m.PersistentProtocol({socket:$,measureRoundTripTime:!0}),se=!0),C.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const ue=await t(C.signService.createNewMessage((0,w.generateUuid)()),q),be={type:"auth",auth:C.connectionToken||"00000000000000000000",data:ue.data};K.sendControl(A.VSBuffer.fromString(JSON.stringify(be)));try{const ke=await I(K,a(q,y(1e4)));if(ke.type!=="sign"||typeof ke.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(C.logService.trace(`${j} 4/6. received SignRequest control message.`),!await t(C.signService.validate(ue,ke.signedData),q)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const Ae=await t(C.signService.sign(ke.data),q),Fe={type:"connectionType",commit:C.commit,signedData:Ae,desiredConnectionType:W};return z&&(Fe.args=z),C.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),K.sendControl(A.VSBuffer.fromString(JSON.stringify(Fe))),{protocol:K,ownsProtocol:se}}catch(ke){throw ke&&ke.code==="ETIMEDOUT"&&(C.logService.error(`${j} the handshake timed out. Error:`),C.logService.error(ke)),ke&&ke.code==="VSCODE_CONNECTION_ERROR"&&(C.logService.error(`${j} received error control message when negotiating connection. Error:`),C.logService.error(ke)),se&&F(K),ke}}async function n(C,W,z,q){const j=Date.now(),$=oe(C,W),{protocol:K,ownsProtocol:se}=await c(C,W,z,q),ue=new d(q);return ue.registerDisposable(K.onControlMessage(be=>{const ke=JSON.parse(be.toString()),Me=V(ke);Me?(C.logService.error(`${$} received error control message when negotiating connection. Error:`),C.logService.error(Me),se&&F(K),ue.reject(Me)):(C.reconnectionProtocol?.endAcceptReconnection(),C.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${B(j)}!`),ue.resolve({protocol:K,firstMessage:ke}))})),ue.promise}async function i(C,W){const{protocol:z}=await n(C,1,void 0,W);return{protocol:z}}async function o(C,W,z){const{protocol:q,firstMessage:j}=await n(C,2,W,z),$=j&&j.debugPort;return{protocol:q,debugPort:$}}async function h(C,W,z){const q=Date.now(),j=oe(C,3),{protocol:$}=await c(C,3,W,z);return C.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${B(q)}!`),$}async function g(C,W,z){const{connectTo:q,connectionToken:j}=await C.addressProvider.getAddress();return{commit:C.commit,quality:C.quality,connectTo:q,connectionToken:j,reconnectionToken:W,reconnectionProtocol:z,remoteSocketFactoryService:C.remoteSocketFactoryService,signService:C.signService,logService:C.logService}}async function D(C,W,z){return S(C,async q=>{const{protocol:j}=await i(q,r.CancellationToken.None);return new G(C,W,z,q.reconnectionToken,j)})}e.connectRemoteAgentManagement=D;async function R(C,W){return S(C,async z=>{const{protocol:q,debugPort:j}=await o(z,W,r.CancellationToken.None);return new N(C,W,z.reconnectionToken,q,j)})}e.connectRemoteAgentExtensionHost=R;async function S(C,W){for(let q=1;;q++)try{const j=(0,w.generateUuid)(),$=await g(C,j,null);return await W($)}catch(j){if(q<5)C.logService.error(`[remote-connection][attempt ${q}] An error occurred in initial connection! Will retry... Error:`),C.logService.error(j);else throw C.logService.error(`[remote-connection][attempt ${q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),C.logService.error(j),X.triggerPermanentFailure(0,0,v.RemoteAuthorityResolverError.isHandled(j)),j}}async function L(C,W,z){const q=await g(C,(0,w.generateUuid)(),null);return await h(q,{host:W,port:z},r.CancellationToken.None)}e.connectRemoteAgentTunnel=L;function T(C){return(0,E.createCancelablePromise)(W=>new Promise((z,q)=>{const j=setTimeout(z,C*1e3);W.onCancellationRequested(()=>{clearTimeout(j),z()})}))}var U;(function(C){C[C.ConnectionLost=0]="ConnectionLost",C[C.ReconnectionWait=1]="ReconnectionWait",C[C.ReconnectionRunning=2]="ReconnectionRunning",C[C.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",C[C.ConnectionGain=4]="ConnectionGain",C[C.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(U||(e.PersistentConnectionEventType=U={}));class H{constructor(W,z){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.type=0}}e.ConnectionLostEvent=H;class re{constructor(W,z,q,j){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.durationSeconds=q,this.c=j,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=re;class Y{constructor(W,z,q){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=Y;class ne{constructor(W,z,q){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.attempt=q,this.type=4}}e.ConnectionGainEvent=ne;class ce{constructor(W,z){this.reconnectionToken=W,this.connectionHealth=z,this.type=5}}e.ConnectionHealthChangedEvent=ce;class le{constructor(W,z,q,j){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.attempt=q,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=le;class X extends P.Disposable{static triggerPermanentFailure(W,z,q){this._permanentFailure=!0,this.f=W,this.g=z,this.h=q,this.i.forEach(j=>j.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(W=>W.s())}static debugPauseSocketWriting(){this.i.forEach(W=>W.w())}get k(){return this.c||X._permanentFailure}constructor(W,z,q,j,$){super(),this.n=W,this.p=z,this.reconnectionToken=q,this.protocol=j,this.r=$,this.j=this.B(new M.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new ne(this.reconnectionToken,0,0)),this.B(j.onSocketClose(K=>{const se=ae(this.n,this.reconnectionToken,!0);K?K.type===0?(this.p.logService.info(`${se} received socket close event (hadError: ${K.hadError}).`),K.error&&this.p.logService.error(K.error)):(this.p.logService.info(`${se} received socket close event (wasClean: ${K.wasClean}, code: ${K.code}, reason: ${K.reason}).`),K.event&&this.p.logService.error(K.event)):this.p.logService.info(`${se} received socket close event.`),this.s()})),this.B(j.onSocketTimeout(K=>{const se=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${K.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${K.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${K.timeSinceLastReceivedSomeData}).`),this.s()})),this.B(j.onHighRoundTripTime(K=>{const se=_(this.n,this.reconnectionToken);this.p.logService.info(`${se} high roundtrip time: ${K.roundTripTime}ms (${K.recentHighRoundTripCount} of 5 recent samples)`)})),this.B(j.onDidChangeConnectionHealth(K=>{this.j.fire(new ce(this.reconnectionToken,K))})),X.i.push(this),this.B((0,P.toDisposable)(()=>{const K=X.i.indexOf(this);K>=0&&X.i.splice(K,1)})),this.k&&this.v(X.f,X.g,X.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const W=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const z=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const j=q<z.length?z[q]:z[z.length-1];try{if(j>0){const K=T(j);this.j.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,K)),this.p.logService.info(`${W} waiting for ${j} seconds before reconnecting...`);try{await K}catch{}}if(this.k){this.p.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this.p.logService.info(`${W} resolving connection...`);const $=await g(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${W} connecting to ${$.connectTo}...`),await this.y($,y(b)),this.p.logService.info(`${W} reconnected!`),this.j.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error($),this.u(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this.p.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error($),this.u(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(v.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this.p.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this.p.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace($);continue}if((0,O.isCancellationError)($)){this.p.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace($);continue}if($ instanceof v.RemoteAuthorityResolverError){this.p.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error($),this.u(this.protocol.getMillisSinceLastIncomingData(),q+1,v.RemoteAuthorityResolverError.isHandled($));break}this.p.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error($),this.u(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!this.k&&!this.m)}u(W,z,q){this.r?X.triggerPermanentFailure(W,z,q):this.v(W,z,q)}v(W,z,q){this.j.fire(new le(this.reconnectionToken,W,z,q)),F(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=X,X._permanentFailure=!1,X.f=0,X.g=0,X.h=!1,X.i=[];class G extends X{constructor(W,z,q,j,$){super(1,W,j,$,!0),this.client=this.B(new m.Client($,{remoteAuthority:z,clientId:q},W.ipcLogger))}async y(W,z){await i(W,z)}}e.ManagementPersistentConnection=G;class N extends X{constructor(W,z,q,j,$){super(2,W,q,j,!1),this.z=z,this.debugPort=$}async y(W,z){await o(W,this.z,z)}}e.ExtensionHostPersistentConnection=N;function F(C){try{C.acceptDisconnect();const W=C.getSocket();C.dispose(),W.dispose()}catch(W){(0,O.onUnexpectedError)(W)}}function V(C){if(C&&C.type==="error"){const W=new Error(`Connection error: ${C.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function J(C,W){for(;C.length<W;)C+=" ";return C}function _(C,W){return`[remote-connection][${J(s(C),13)}][${W.substr(0,5)}\u2026]`}function ae(C,W,z){return`${_(C,W)}[${z?"reconnect":"initial"}]`}function oe(C,W){return`${ae(W,C.reconnectionToken,!!C.reconnectionProtocol)}[${C.connectTo}]`}function B(C){return`${Date.now()-C} ms`}}),define(te[240],ie([0,1,2,6]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,A.createDecorator)("remoteSocketFactoryService");class r{constructor(){this.a={}}register(M,P){return this.a[M]??=[],this.a[M].push(P),(0,E.toDisposable)(()=>{const f=this.a[M]?.indexOf(P);typeof f=="number"&&f>=0&&this.a[M]?.splice(f,1)})}b(M){return(this.a[M.type]||[]).find(f=>f.supports(M))}connect(M,P,f,l){const w=this.b(M);if(!w)throw new Error(`No socket factory found for ${M}`);return w.connect(M,P,f,l)}}e.RemoteSocketFactoryService=r}),define(te[241],ie([0,1,27,46,42,112]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function P(u=!1){return(M===void 0||u)&&(M=f()),M}e.hasWSLFeatureInstalled=P;async function f(){const u=l();if(u===void 0)return!1;if(u>=22e3){const b=m();if(b)return new Promise(p=>{A.execFile(b,["--status"],s=>p(!s))})}else{const b=v();if(b)try{if((await r.promises.stat(b)).isFile())return!0}catch{}}return!1}function l(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(u)return parseInt(u[3])}function w(u){const b=process.env.SystemRoot;if(b){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return O.join(b,p?"Sysnative":"System32",u)}}function m(){return w("wsl.exe")}function v(){return w("lxss\\LxssManager.dll")}}),define(te[51],ie([0,1,17,13,2,181,57,6,5,47]),function(x,e,E,A,r,O,M,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,P.createDecorator)("requestService");class w{constructor(k){this.b=k}toJSON(){if(!this.a){const k=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?k[t]="*****":k[t]=this.b[t];this.a=k}return this.a}}class m extends r.Disposable{constructor(k){super(),this.b=0,this.a=k.createLogger("network",{name:(0,O.localize)(0,null),when:f.CONTEXT_LOG_LEVEL.isEqualTo((0,f.LogLevelToString)(f.LogLevel.Trace)).serialize()})}async c(k,t,c){const n=`${k} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new w(t.headers??{}));try{const i=await c();return this.a.trace(`${n} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,t.type,(0,A.getErrorMessage)(i)),i}}}e.AbstractRequestService=m;function v(I){return I.res.statusCode&&I.res.statusCode>=200&&I.res.statusCode<300||I.res.statusCode===1223}e.isSuccess=v;function u(I){return I.res.statusCode===204}async function b(I){return u(I)?null:(await(0,E.streamToBuffer)(I.stream)).toString()}e.asText=b;async function p(I){if(!v(I))throw new Error("Server returned "+I.res.statusCode);return b(I)}e.asTextOrError=p;async function s(I){if(!v(I))throw new Error("Server returned "+I.res.statusCode);if(u(I))return null;const t=(await(0,E.streamToBuffer)(I.stream)).toString();try{return JSON.parse(t)}catch(c){throw c.message+=`:
`+t,c}}e.asJson=s;function y(I){d(I)}e.updateProxyConfigurationsScope=y;let a;function d(I){const k=l.Registry.as(M.Extensions.Configuration),t=a;a={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:I,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(5,null),(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null)],default:"override",description:(0,O.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(10,null),restricted:!0}}},k.updateConfigurations({add:[a],remove:t?[t]:[]})}d(1)}),define(te[242],ie([0,1,17,21]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class r{constructor(P){this.a=P}listen(P,f){throw new Error("Invalid listen")}call(P,f,l,w=A.CancellationToken.None){switch(f){case"request":return this.a.request(l[0],w).then(async({res:m,stream:v})=>{const u=await(0,E.streamToBuffer)(v);return[{statusCode:m.statusCode,headers:m.headers},u]});case"resolveProxy":return this.a.resolveProxy(l[0])}throw new Error("Invalid call")}}e.RequestChannel=r;class O{constructor(P){this.a=P}async request(P,f){const[l,w]=await this.a.call("request",[P],f);return{res:l,stream:(0,E.bufferToStream)(w)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=O}),define(te[243],ie([0,1,244,11]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function r(M,P){return M.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:M.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function O(M,P,f={}){const l=(0,E.parse)(M),w=f.proxyUrl||r(l,P);if(!w)return null;const m=(0,E.parse)(w);if(!/^https?:$/.test(m.protocol||""))return null;const v={host:m.hostname||"",port:m.port||(m.protocol==="https"?"443":"80"),auth:m.auth,rejectUnauthorized:(0,A.isBoolean)(f.strictSSL)?f.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((u,b)=>{x(["http-proxy-agent"],u,b)}))(v):new(await new Promise((u,b)=>{x(["https-proxy-agent"],u,b)}))(v)}e.getProxyAgent=O}),define(te[93],ie([0,1,46,9,182,21,50,13,3,31,155,63,7,137]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let b;async function p(y,a,d,I){return d["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,m.isLaunchedFromCli)(I)&&!d["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,m.isLaunchedFromCli)(I)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=v.Promises.withAsyncBody(async(k,t)=>{const c=new O.CancellationTokenSource;let n=1e4;const i=y.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(n=(0,u.clamp)(i,1,120)*1e3);const o=setTimeout(()=>{c.dispose(!0),t(new Error((0,r.localize)(0,null)))},n);try{k(await s(a,c.token))}catch(h){!(0,P.isCancellationError)(h)&&!c.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,M.toErrorMessage)(h)))):k({})}finally{clearTimeout(o),c.dispose()}})),b)}e.getResolvedShellEnv=p;async function s(y,a){const d=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",d);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",I);const k=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(k+"({.*})"+k),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};y.trace("getUnixShellEnvironment#env",c);const n=await(0,w.getSystemShell)(f.OS,c);return y.trace("getUnixShellEnvironment#shell",n),new Promise((i,o)=>{if(a.isCancellationRequested)return o(new P.CancellationError);const h=(0,A.basename)(n);let g,D;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(g=`& '${process.execPath}' ${R} -p '''${k}'' + JSON.stringify(process.env) + ''${k}'''`,D=["-Login","-Command"]):h==="nu"?(g=`^'${process.execPath}' ${R} -p '"${k}" + JSON.stringify(process.env) + "${k}"'`,D=["-i","-l","-c"]):(g=`'${process.execPath}' ${R} -p '"${k}" + JSON.stringify(process.env) + "${k}"'`,h==="tcsh"||h==="csh"?D=["-ic"]:D=["-i","-l","-c"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),g);const S=(0,E.spawn)(n,[...D,g],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});a.onCancellationRequested(()=>(S.kill(),o(new P.CancellationError))),S.on("error",U=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(U)),o(U)});const L=[];S.stdout.on("data",U=>L.push(U));const T=[];S.stderr.on("data",U=>T.push(U)),S.on("close",(U,H)=>{const re=Buffer.concat(L).toString("utf8");y.trace("getUnixShellEnvironment#raw",re);const Y=Buffer.concat(T).toString("utf8");if(Y.trim()&&y.trace("getUnixShellEnvironment#stderr",Y),U||H)return o(new Error((0,r.localize)(2,null,U,H)));const ne=t.exec(re),ce=ne?ne[1]:"{}";try{const le=JSON.parse(ce);d?le.ELECTRON_RUN_AS_NODE=d:delete le.ELECTRON_RUN_AS_NODE,I?le.ELECTRON_NO_ATTACH_CONSOLE=I:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",le),i(le)}catch(le){y.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(le)),o(le)}})})}}),define(te[245],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class E{constructor(){this.b=new Map}async createNewMessage(r){try{const O=await this.c();if(O){const M=String(E.a++);return this.b.set(M,O),{id:M,data:O.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,O){if(!r.id)return!0;const M=this.b.get(r.id);if(!M)return!1;this.b.delete(r.id);try{return M.validate(O)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(r){try{return await this.d(r)}catch{}return r}}e.AbstractSignService=E,E.a=1}),define(te[94],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[246],ie([0,1,245]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class A extends E.AbstractSignService{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(M=>new M.signer().sign(O))}h(){return new Promise((O,M)=>x(["vsda"],O,M))}}e.SignService=A}),define(te[34],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,E.createDecorator)("stateReadService"),e.IStateService=(0,E.createDecorator)("stateService")}),define(te[120],ie([0,1,7,17,11,33,16,5]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var f;(function(v){v[v.IMMEDIATE=0]="IMMEDIATE",v[v.DELAYED=1]="DELAYED"})(f||(e.SaveStrategy=f={}));class l{constructor(u,b,p,s){this.f=u,this.g=p,this.h=s,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=b===0?void 0:new E.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(u){u.fileOperationResult!==1&&this.g.error(u)}}getItem(u,b){const p=this.a[u];return(0,r.isUndefinedOrNull)(p)?b:p}setItem(u,b){this.setItems([{key:u,data:b}])}setItems(u){let b=!1;for(const{key:p,data:s}of u)this.a[p]!==s&&((0,r.isUndefinedOrNull)(s)?(0,r.isUndefined)(this.a[p])||(this.a[p]=void 0,b=!0):(this.a[p]=s,b=!0));b&&this.j()}removeItem(u){(0,r.isUndefined)(this.a[u])||(this.a[u]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const u=JSON.stringify(this.a,null,4);if(u!==this.b)try{await this.h.writeFile(this.f,A.VSBuffer.fromString(u),{atomic:{postfix:".vsctmp"}}),this.b=u}catch(b){this.g.error(b)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=l;let w=e.StateReadonlyService=class{constructor(u,b,p,s){this.a=new l(b.stateResource,u,p,s)}async init(){await this.a.init()}getItem(u,b){return this.a.getItem(u,b)}};e.StateReadonlyService=w=ve([Z(1,O.IEnvironmentService),Z(2,P.ILogService),Z(3,M.IFileService)],w);class m extends w{setItem(u,b){this.a.setItem(u,b)}setItems(u){this.a.setItems(u)}removeItem(u){this.a.removeItem(u)}close(){return this.a.close()}}e.StateService=m}),define(te[121],ie([0,1,3,36,31]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(f){if(E.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function M(f,l,w,m,v,u,b,p){const s=Object.create(null);s["common.machineId"]=u,s.sessionID=(0,r.generateUuid)()+Date.now(),s.commitHash=m,s.version=v,s["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,E.PlatformToString)(E.platform),s["common.nodePlatform"]=A.platform,s["common.nodeArch"]=w,s["common.product"]=p||"desktop",b&&(s["common.msftInternal"]=b);let y=0;const a=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>y++,enumerable:!0}}),E.isLinuxSnap&&(s["common.snap"]="true");const d=O(l);return d&&(s["common.platformDetail"]=d),s}e.resolveCommonProperties=M;function P(f){const l=A.env.USERDNSDOMAIN;if(!l)return!1;const w=l.toLowerCase();return f.some(m=>w===m)}e.verifyMicrosoftInternalDomain=P}),define(te[26],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var r;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(te[247],ie([0,1,27,7,44,14,9,3,8,86,22,107,89,16,23,26]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const s=new Map;async function y(t,c){const n=`${t}::${c.join(":")}`,i=s.get(n);if(i)return i;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],h=new Map,g=new Map,D=2e4;function R(L,T,U,H){const re=T.substring(L.length+1);return A.Promises.withAsyncBody(async Y=>{let ne;try{ne=await w.Promises.readdir(T,{withFileTypes:!0})}catch{Y();return}if(H.count>=D){H.count+=ne.length,H.maxReached=!0,Y();return}let ce=ne.length;if(ce===0){Y();return}let le=ne;H.count+ne.length>D&&(H.maxReached=!0,ce=D-H.count,le=ne.slice(0,ce)),H.count+=ne.length;for(const X of le)if(X.isDirectory()){if(U.includes(X.name)||await R(L,(0,M.join)(T,X.name),U,H),--ce===0){Y();return}}else{const G=X.name.lastIndexOf(".");if(G>=0){const N=X.name.substring(G+1);N&&h.set(N,(h.get(N)??0)+1)}for(const N of o)N.relativePathPattern?.test(re)!==!1&&N.filePattern.test(X.name)&&g.set(N.tag,(g.get(N.tag)??0)+1);if(--ce===0){Y();return}}})}const S=A.Promises.withAsyncBody(async L=>{const T={count:0,maxReached:!1};await R(t,t,c,T);const U=await I(t);L({configFiles:a(g),fileTypes:a(h),fileCount:T.count,maxFilesReached:T.maxReached,launchConfigFiles:U})});return s.set(n,S),S}e.collectWorkspaceStats=y;function a(t){return Array.from(t.entries(),([c,n])=>({name:c,count:n})).sort((c,n)=>n.count-c.count)}function d(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.virtualMachineHint.value()*100)}%`},c=E.cpus();return c&&c.length>0&&(t.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),t}e.getMachineInfo=d;async function I(t){try{const c=new Map,n=(0,M.join)(t,".vscode","launch.json"),i=await w.Promises.readFile(n),o=[],h=(0,r.parse)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${n}`),[];if((0,r.getNodeType)(h)==="object"&&h.configurations)for(const g of h.configurations){const D=g.type;D&&(c.has(D)?c.set(D,c.get(D)+1):c.set(D,1))}return a(c)}catch{return[]}}e.collectLaunchConfigs=I;let k=e.DiagnosticsService=class{constructor(c,n){this.c=c,this.d=n}f(c){const n=[];return n.push(`OS Version:       ${c.os}`),n.push(`CPUs:             ${c.cpus}`),n.push(`Memory (System):  ${c.memory}`),n.push(`VM:               ${c.vmHint}`),n.join(`
`)}g(c){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const i=E.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||n.push(`Load (avg):       ${E.loadavg().map(o=>Math.round(o)).join(", ")}`),n.push(`VM:               ${Math.round(l.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${c.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(c,n){return Promise.all([(0,m.listProcesses)(c.mainPID),this.k(c)]).then(async i=>{let[o,h]=i,g=this.m(c,o);return n.forEach(D=>{if((0,v.isRemoteDiagnosticError)(D))g+=`
${D.errorMessage}`,h+=`
${D.errorMessage}`;else if(g+=`

Remote: ${D.hostName}`,D.processes&&(g+=`
${this.m(c,D.processes)}`),D.workspaceMetadata){h+=`
|  Remote: ${D.hostName}`;for(const R of Object.keys(D.workspaceMetadata)){const S=D.workspaceMetadata[R];let L=`${S.fileCount} files`;S.maxFilesReached&&(L=`more than ${L}`),h+=`|    Folder (${R}): ${L}`,h+=this.h(S)}}}),{processInfo:g,workspaceInfo:h}})}async getSystemInfo(c,n){const{memory:i,vmHint:o,os:h,cpus:g}=d(),D={os:h,memory:i,cpus:g,vmHint:o,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:n};return P.isWindows||(D.load=`${E.loadavg().map(R=>Math.round(R)).join(", ")}`),P.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(c,n){const i=[];return(0,m.listProcesses)(c.mainPID).then(async o=>(i.push(""),i.push(this.g(c)),i.push(""),i.push(this.m(c,o)),c.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(c))),n.forEach(h=>{if((0,v.isRemoteDiagnosticError)(h))i.push(`
${h.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${h.hostName}`),i.push(this.f(h.machineInfo)),h.processes&&i.push(this.m(c,h.processes)),h.workspaceMetadata)for(const g of Object.keys(h.workspaceMetadata)){const D=h.workspaceMetadata[g];let R=`${D.fileCount} files`;D.maxFilesReached&&(R=`more than ${R}`),i.push(`Folder (${g}): ${R}`),i.push(this.h(D))}}),i.push(""),i.push(""),i.join(`
`)))}h(c){const n=[];let o=0;const h=(S,L)=>{const T=` ${S}(${L})`;o+T.length>60?(n.push(g),g="|                 ",o=g.length):o+=T.length,g+=T};let g="|      File types:";const D=10,R=c.fileTypes.length>D?D:c.fileTypes.length;for(let S=0;S<R;S++){const L=c.fileTypes[S];h(L.name,L.count)}if(n.push(g),c.configFiles.length>=0&&(g="|      Conf files:",o=0,c.configFiles.forEach(S=>{h(S.name,S.count)}),n.push(g)),c.launchConfigFiles.length>0){let S="|      Launch Configs:";c.launchConfigFiles.forEach(L=>{const T=L.count>1?` ${L.name}(${L.count})`:` ${L.name}`;S+=T}),n.push(S)}return n.join(`
`)}j(c){const n=Math.max(...Object.keys(c).map(i=>i.length));return Object.keys(c).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${c[i]}`).join(`
                  `)}k(c){const n=[],i=[];return c.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(n.push(`|  Window (${o.title})`),o.folderURIs.forEach(h=>{const g=f.URI.revive(h);if(g.scheme===O.Schemas.file){const D=g.fsPath;i.push(y(D,["node_modules",".git"]).then(R=>{let S=`${R.fileCount} files`;R.maxFilesReached&&(S=`more than ${S}`),n.push(`|    Folder (${(0,M.basename)(D)}): ${S}`),n.push(this.h(R))}).catch(R=>{n.push(`|      Error: Unable to collect workspace stats for folder ${D} (${R.toString()})`)}))}else n.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>n.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(c,n){const i=new Map;c.windows.forEach(h=>i.set(h.pid,`window [${h.id}] (${h.title})`)),c.pidToNames.forEach(({pid:h,name:g})=>i.set(h,g));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),n&&this.n(c.mainPID,i,o,n,0),o.join(`
`)}n(c,n,i,o,h){const g=h===0;let D;g?D=o.pid===c?`${this.d.applicationName} main`:"remote agent":n.has(o.pid)?D=n.get(o.pid):D=`${"  ".repeat(h)} ${o.name}`;const R=process.platform==="win32"?o.mem:E.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(R/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(o.children)&&o.children.forEach(S=>this.n(c,n,i,S,h+1))}async getWorkspaceFileExtensions(c){const n=new Set;for(const{uri:i}of c.folders){const o=f.URI.revive(i);if(o.scheme!==O.Schemas.file)continue;const h=o.fsPath;try{(await y(h,["node_modules",".git"])).fileTypes.forEach(D=>n.add(D.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(c){for(const{uri:n}of c.folders){const i=f.URI.revive(n);if(i.scheme!==O.Schemas.file)continue;const o=i.fsPath;try{const h=await y(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),h.fileTypes.forEach(g=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:g.name,count:g.count})}),h.launchConfigFiles.forEach(g=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:g.name,count:g.count})}),h.configFiles.forEach(g=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};e.DiagnosticsService=k=ve([Z(0,p.ITelemetryService),Z(1,b.IProductService)],k)}),define(te[248],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(O){this.b=O}listen(O,M){throw new Error(`Event not found: ${M}`)}call(O,M,{eventName:P,data:f}){return this.b.forEach(l=>l.log(P,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class A{constructor(O){this.b=O}log(O,M){return this.b.call("log",{eventName:O,data:M}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(te[52],ie([0,1,37,11,4,19,58,121,26]),function(x,e,E,A,r,O,M,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class l{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=l;class w{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=w,e.NullTelemetryService=new w;class m{async publicLog(o,h,g){}async publicLogError(o,h,g){}}e.NullEndpointTelemetryService=m,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,o){return r.Event.debounce(o.onDidChangeConfiguration,(g,D)=>{const R=g?new Set([...g.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:R}},1e3,!0)(g=>{g.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,O.ConfigurationTargetToString)(g.source),configurationKeys:Array.from(g.affectedKeys)})})}e.configurationTelemetry=v;function u(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=u;function b(i,o){return!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=b;function p(i){const o=i.getValue(f.TELEMETRY_SETTING_ID),h=i.getValue(f.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(f.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function s(i){const o={},h={},g={};d(i,g);for(let D in g){D=D.length>150?D.substr(D.length-149):D;const R=g[D];typeof R=="number"?h[D]=R:typeof R=="boolean"?h[D]=R?1:0:typeof R=="string"?(R.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${R.length}`),o[D]=R.substring(0,8191)):typeof R<"u"&&R!==null&&(o[D]=R)}return{properties:o,measurements:h}}e.validateTelemetryData=s;const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(i){if(!i)return"none";const o=(0,M.getRemoteName)(i);return y.has(o)?o:"other"}e.cleanRemoteAuthority=a;function d(i,o,h=0,g){if(i)for(const D of Object.getOwnPropertyNames(i)){const R=i[D],S=g?g+D:D;Array.isArray(R)?o[S]=(0,E.safeStringify)(R):R instanceof Date?o[S]=R.toISOString():(0,A.isObject)(R)?h<2?d(R,o,h+1,S+"."):o[S]=(0,E.safeStringify)(R):o[S]=R}}function I(i,o){const h=i.msftInternalDomains||[],g=o.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(h)||g}e.isInternalTelemetry=I;function k(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=k;function t(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let h=i;const g=[];for(const L of o)for(;;){const T=L.exec(i);if(!T)break;g.push([T.index,L.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,R=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(h="";;){const L=R.exec(i);if(!L)break;const T=g.some(([U,H])=>L.index<H&&U<R.lastIndex);!D.test(L[0])&&!T&&(h+=i.substring(S,L.index)+"<REDACTED: user-file-path>",S=R.lastIndex)}return S<i.length&&(h+=i.substr(S)),h}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of o)if(h.regex.test(i))return`<REDACTED: ${h.label}>`;return i}function n(i,o){return(0,E.cloneAndChange)(i,h=>{if(h instanceof l||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let g=h.replaceAll("%20"," ");g=t(g,o);for(const D of o)g=g.replace(D,"");return g=c(g),g}})}e.cleanData=n}),define(te[122],ie([0,1,25,115,119,3,8,13,36,52]),function(x,e,E,A,r,O,M,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function w(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,E.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=w;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const o=i.manifest?i.manifest.version:i.version,h=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,o,h)}static parse(i){const o=m.exec(i);return o&&o[1]&&o[2]?new v({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,h="undefined"){this.version=o,this.targetPlatform=h,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?w(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=v;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(n){const i=u.exec(n);return i&&i[1]?[s(i[1]),i[2]]:[s(n),void 0]}e.getIdAndVersion=b;function p(n,i){return`${n}.${i}`}e.getExtensionId=p;function s(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=s;function y(n,i){return s(p(n??r.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=y;function a(n,i){const o=[],h=g=>{for(const D of o)if(D.some(R=>w(i(R),i(g))))return D;return null};for(const g of n){const D=h(g);D?D.push(g):o.push([g])}return o}e.groupByExtension=a;function d(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=d;function I(n){return{id:new l.TelemetryTrustedValue(n.identifier.id),name:new l.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge");function k(n,i){const o=[],h=i.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const g=h.shift();if(g&&o.every(D=>!w(D.identifier,{id:g}))){const D=n.filter(R=>w(R.identifier,{id:g}));D.length===1&&(o.push(D[0]),h.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=k;async function t(n,i){if(!O.isLinux)return!1;let o;try{o=(await n.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await n.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(g))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(n,i){const o=await t(n,i),h=(0,A.getTargetPlatform)(o?"alpine":O.platform,f.arch);return i.debug("ComputeTargetPlatform:",h),h}e.computeTargetPlatform=c}),define(te[249],ie([0,1,204,52]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function r(O,M,P,f,l,w,m){const v={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${M.nameShort})`};if((0,A.supportsTelemetry)(M,P)&&(0,A.getTelemetryLevel)(f)===3){const u=await(0,E.getServiceMachineId)(P,l,w);v["X-Market-User-Id"]=u,v["VSCode-SessionId"]=m.machineId||u}return v}e.resolveMarketplaceHeaders=r}),define(te[250],ie([0,1,2,37,3,25,183,19,57,77,23,47,26,52]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=e.TelemetryService=class{constructor(y,a,d){this.k=a,this.l=d,this.d={},this.i=new E.DisposableStore,this.j=[],this.b=y.appenders,this.c=y.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=y.piiPaths||[],this.g=3,this.h=!!y.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const I of this.f)this.j.push(new RegExp((0,O.escapeRegExpCharacters)(I),"gi")),I.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.escapeRegExpCharacters)(I.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(I=>{(I.affectsConfiguration(v.TELEMETRY_SETTING_ID)||I.affectsConfiguration(v.TELEMETRY_OLD_SETTING_ID)||I.affectsConfiguration(v.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(y,a){this.d[y]=a}m(){let y=(0,u.getTelemetryLevel)(this.k);const a=this.l.enabledTelemetryLevels;if(a){this.h=this.sendErrorTelemetry?a.error:!1;const d=a.usage?3:a.error?2:0;y=Math.min(y,d)}this.g=y}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(y,a,d){this.g<a||(d=(0,A.mixin)(d,this.d),d=(0,u.cleanData)(d,this.j),d=(0,A.mixin)(d,this.c),this.b.forEach(I=>I.log(y,d)))}publicLog(y,a){this.n(y,3,a)}publicLog2(y,a){this.publicLog(y,a)}publicLogError(y,a){this.h&&this.n(y,2,a)}publicLogError2(y,a){this.publicLogError(y,a)}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=b=ve([Z(1,P.IConfigurationService),Z(2,w.IProductService)],b);function p(){const s=(0,M.localize)(0,null,l.default.nameLong),y=l.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),a=r.isWeb?"":(0,M.localize)(3,null),d=(0,M.localize)(4,null),I=(0,M.localize)(5,null),k=(0,M.localize)(6,null),t=(0,M.localize)(7,null),c=`
|       | ${d} | ${I} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,M.localize)(8,null);return`
${s} ${y} ${a}

&nbsp;

${t}
${c}

&nbsp;

${n}
`}m.Registry.as(f.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,M.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(f.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,M.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,M.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[251],ie([0,1,3,86,26]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function O(M,P){let f=M.getItem(r.machineIdKey);return(typeof f!="string"||E.isMacintosh&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,A.getMachineId)(P.error.bind(P))),f}e.resolveMachineId=O}),define(te[252],ie([0,1,26,251]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function r(O,M){const P=await(0,A.resolveMachineId)(O,M);return O.setItem(E.machineIdKey,P),P}e.resolveMachineId=r}),define(te[123],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var E;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(E||(e.EnvironmentVariableMutatorType=E={}))}),define(te[253],ie([0,1,3,123]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const r=new Map([[A.EnvironmentVariableMutatorType.Append,"APPEND"],[A.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[A.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class O{constructor(w){this.collections=w,this.a=new Map,this.b=new Map,w.forEach((m,v)=>{this.d(m,v);const u=m.map.entries();let b=u.next();for(;!b.done;){const p=b.value[1],s=b.value[0];let y=this.a.get(s);if(y||(y=[],this.a.set(s,y)),y.length>0&&y[0].type===A.EnvironmentVariableMutatorType.Replace){b=u.next();continue}const a={extensionIdentifier:v,value:p.value,type:p.type,scope:p.scope,variable:p.variable,options:p.options};a.scope||delete a.scope,y.unshift(a),b=u.next()}})}async applyToProcessEnvironment(w,m,v){let u;E.isWindows&&(u={},Object.keys(w).forEach(b=>u[b.toLowerCase()]=b));for(const[b,p]of this.getVariableMap(m)){const s=E.isWindows&&u[b.toLowerCase()]||b;for(const y of p){const a=v?await v(y.value):y.value;if(y.options?.applyAtProcessCreation??!0)switch(y.type){case A.EnvironmentVariableMutatorType.Append:w[s]=(w[s]||"")+a;break;case A.EnvironmentVariableMutatorType.Prepend:w[s]=a+(w[s]||"");break;case A.EnvironmentVariableMutatorType.Replace:w[s]=a;break}if(y.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${r.get(y.type)}`;w[d]=(w[d]?w[d]+":":"")+b+"="+this.c(a)}}}}c(w){return w.replaceAll(":","\\x3a")}diff(w,m){const v=new Map,u=new Map,b=new Map;if(w.getVariableMap(m).forEach((p,s)=>{const y=this.getVariableMap(m).get(s),a=P(p,y);a&&v.set(s,a)}),this.getVariableMap(m).forEach((p,s)=>{const y=w.getVariableMap(m).get(s),a=P(p,y);a&&b.set(s,a)}),this.getVariableMap(m).forEach((p,s)=>{const y=w.getVariableMap(m).get(s),a=f(p,y);a&&u.set(s,a)}),!(v.size===0&&u.size===0&&b.size===0))return{added:v,changed:u,removed:b}}getVariableMap(w){const m=new Map;return this.a.forEach((v,u)=>{const b=v.filter(p=>M(p,w));b.length>0&&m.set(b[0].variable,b)}),m}getDescriptionMap(w){const m=new Map;return this.b.forEach((v,u)=>{const b=v.filter(p=>M(p,w,!0));b.length>0&&m.set(b[0].extensionIdentifier,b[0].description)}),m}d(w,m){if(!w.descriptionMap)return;const v=w.descriptionMap.entries();let u=v.next();for(;!u.done;){const b=u.value[1],p=u.value[0];let s=this.b.get(p);s||(s=[],this.b.set(p,s));const y={extensionIdentifier:m,scope:b.scope,description:b.description};y.scope||delete y.scope,s.push(y),u=v.next()}}}e.MergedEnvironmentVariableCollection=O;function M(l,w,m=!1){return l.scope?!!(l.scope.workspaceFolder&&w?.workspaceFolder&&l.scope.workspaceFolder.index===w.workspaceFolder.index):m?w===l.scope:!0}function P(l,w){if(!w)return l;const m=new Set;w.forEach(u=>m.add(u.extensionIdentifier));const v=[];return l.forEach(u=>{m.has(u.extensionIdentifier)||v.push(u)}),v.length===0?void 0:v}function f(l,w){if(!w)return;const m=new Map;w.forEach(u=>m.set(u.extensionIdentifier,u));const v=[];return l.forEach(u=>{const b=m.get(u.extensionIdentifier);b&&(u.type!==b.type||u.value!==b.value||u.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index)&&v.push(b)}),v.length===0?void 0:v}}),define(te[254],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function E(f){return[...f.entries()]}e.serializeEnvironmentVariableCollection=E;function A(f){return f?[...f.entries()]:[]}e.serializeEnvironmentDescriptionMap=A;function r(f){return new Map(f)}e.deserializeEnvironmentVariableCollection=r;function O(f){return new Map(f??[])}e.deserializeEnvironmentDescriptionMap=O;function M(f){return Array.from(f.entries()).map(l=>[l[0],E(l[1].map),A(l[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=M;function P(f){return new Map(f.map(l=>[l[0],{map:r(l[1]),descriptionMap:O(l[2])}]))}e.deserializeEnvironmentVariableCollections=P}),define(te[255],ie([0,1,7,21,4,2,5]),function(x,e,E,A,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=e.RequestStore=class extends O.Disposable{constructor(l,w){super(),this.h=w,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new r.Emitter),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l}createRequest(l){return new Promise((w,m)=>{const v=++this.a;this.c.set(v,w),this.g.fire({requestId:v,...l});const u=new A.CancellationTokenSource;(0,E.timeout)(this.b,u.token).then(()=>m(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,O.toDisposable)(()=>u.cancel())])})}acceptReply(l,w){const m=this.c.get(l);m?(this.c.delete(l),(0,O.dispose)(this.f.get(l)||[]),this.f.delete(l),m(w)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.RequestStore=P=ve([Z(1,M.ILogService)],P)}),define(te[124],ie([0,1,6,113]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new A.RawContextKey("terminalTabFocusMode",!1,!0);var r;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(r||(e.TerminalSettingPrefix=r={}));var O;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsDefaultColor="terminal.integrated.tabs.defaultColor",d.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.TabStopWidth="terminal.integrated.tabStopWidth",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.TabFocusMode="terminal.integrated.tabFocusMode",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",d.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",d.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",d.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",d.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",d.ExperimentalImageSupport="terminal.integrated.experimentalImageSupport",d.SmoothScrolling="terminal.integrated.smoothScrolling"})(O||(e.TerminalSettingId=O={}));var M;(function(d){d.PowerShell="pwsh",d.Bash="bash",d.Fish="fish",d.Sh="sh",d.Csh="csh",d.Ksh="ksh",d.Zsh="zsh"})(M||(e.PosixShellType=M={}));var P;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(P||(e.WindowsShellType=P={}));var f;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(f||(e.TitleEventSource=f={}));var l;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.PtyHostWindow="ptyHostWindow",d.Logger="logger",d.Heartbeat="heartbeat"})(l||(e.TerminalIpcChannels=l={})),e.IPtyService=(0,E.createDecorator)("ptyService");var w;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions",d.FailedShellIntegrationActivation="failedShellIntegrationActivation",d.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={}));var m;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(m||(e.HeartbeatConstants=m={}));var v;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(v||(e.TerminalLocation=v={}));var u;(function(d){d.TerminalView="view",d.Editor="editor"})(u||(e.TerminalLocationString=u={}));var b;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(b||(e.LocalReconnectConstants=b={}));var p;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var s;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(s||(e.ProfileSource=s={}));var y;(function(d){d[d.Off=0]="Off",d[d.FinalTerm=1]="FinalTerm",d[d.VSCode=2]="VSCode"})(y||(e.ShellIntegrationStatus=y={}));var a;(function(d){d[d.Unknown=0]="Unknown",d[d.Shutdown=1]="Shutdown",d[d.Process=2]="Process",d[d.User=3]="User",d[d.Extension=4]="Extension"})(a||(e.TerminalExitReason=a={})),e.ILocalPtyService=(0,E.createDecorator)("localPtyService")}),define(te[256],ie([0,1,69,8,185,102]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function M(v,u){const b=[{name:null,description:(0,r.localize)(0,null)}];return b.push(...v.map(p=>({name:p.profileName,description:P(p)}))),u&&b.push(...u.map(p=>({name:p.title,description:f(p)}))),{values:b.map(p=>p.name),markdownDescriptions:b.map(p=>p.description)}}e.createProfileSchemaEnums=M;function P(v){let u=`$(${O.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:E.Codicon.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?u+=`
- args: "${v.args}"`:u+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(u+=`
- overrideName: ${v.overrideName}`),v.color&&(u+=`
- color: ${v.color}`),v.env&&(u+=`
- env: ${JSON.stringify(v.env)}`),u}function f(v){return`$(${O.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:E.Codicon.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function l(v,u){if(!v&&!u)return!0;if(typeof v=="string"&&typeof u=="string")return v===u;if(Array.isArray(v)&&Array.isArray(u)){if(v.length!==u.length)return!1;for(let b=0;b<v.length;b++)if(v[b]!==u[b])return!1;return!0}return!1}e.terminalProfileArgsMatch=l;function w(v,u){if(!v&&!u)return!0;if(!v||!u)return!1;if(O.ThemeIcon.isThemeIcon(v)&&O.ThemeIcon.isThemeIcon(u))return v.id===u.id&&v.color===u.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof u=="object"&&"light"in u&&"dark"in u){const b=v,p=u;if((A.URI.isUri(b.light)||m(b.light))&&(A.URI.isUri(b.dark)||m(b.dark))&&(A.URI.isUri(p.light)||m(p.light))&&(A.URI.isUri(p.dark)||m(p.dark)))return b.light.path===p.light.path&&b.dark.path===p.dark.path}if(A.URI.isUri(v)&&A.URI.isUri(u)||m(v)||m(u)){const b=v,p=u;return b.path===p.path&&b.scheme===p.scheme}return!1}e.terminalIconsEqual=w;function m(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.isUriComponents=m}),define(te[257],ie([0,1,69,3,184,57,47,256]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,E.getAllCodicons)(),t=>t.id),markdownEnumDescriptions:Array.from((0,E.getAllCodicons)(),t=>`$(${t.id})`)};const f={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},w={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function m(t){const c=t===2?"linux":t===1?"osx":"windows";return(0,r.localize)(7,null,(0,A.PlatformToString)(t),'```json\n"terminal.integrated.profile.'+c+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v=(0,r.localize)(8,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),u=(0,r.localize)(9,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),b=(0,r.localize)(10,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,r.localize)(11,null,"`#terminal.integrated.automationProfile.linux#`"),s=(0,r.localize)(12,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,r.localize)(13,null,"`#terminal.integrated.automationProfile.windows#`"),a={id:"terminal",order:100,title:(0,r.localize)(14,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(15,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(16,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:s},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(17,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(18,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(19,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(20,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:u},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(23,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(24,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:v},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(25,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:u},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(26,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,r.localize)(27,null)}},{type:"string",markdownDescription:(0,r.localize)(28,null)}],default:[],markdownDeprecationMessage:b},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:m(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(29,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(30,null),type:"string"},id:{description:(0,r.localize)(31,null),type:"string"},title:{description:(0,r.localize)(32,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:m(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(33,null),type:"string"},id:{description:(0,r.localize)(34,null),type:"string"},title:{description:(0,r.localize)(35,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:m(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(36,null),type:"string"},id:{description:(0,r.localize)(37,null),type:"string"},title:{description:(0,r.localize)(38,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(39,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(40,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(41,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,r.localize)(43,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){M.Registry.as(O.Extensions.Configuration).registerConfiguration(a),k()}e.registerTerminalPlatformConfiguration=d;let I;function k(t,c){const n=M.Registry.as(O.Extensions.Configuration);let i;t&&(i=(0,P.createProfileSchemaEnums)(t?.profiles,c));const o=I;I={id:"terminal",order:100,title:(0,r.localize)(44,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(45,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:t?.os===3?i?.values:void 0,markdownEnumDescriptions:t?.os===3?i?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(46,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:t?.os===2?i?.values:void 0,markdownEnumDescriptions:t?.os===2?i?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(47,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:t?.os===1?i?.values:void 0,markdownEnumDescriptions:t?.os===1?i?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[I],remove:o?[o]:[]})}e.registerTerminalDefaultProfileConfiguration=k}),define(te[258],ie([0,1,27,14,37,9,3,36,25,11,22,123,254,253]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let o=0;return i&&i.length===4&&(o=parseInt(i[3])),o}e.getWindowsBuildNumber=b;async function p(i,o,h,g=P.env,D=w.Promises.exists){if(O.isAbsolute(i))return await D(i)?i:void 0;if(o===void 0&&(o=P.cwd()),O.dirname(i)!=="."){const T=O.join(o,i);return await D(T)?T:void 0}const S=(0,r.getCaseInsensitive)(g,"PATH");if(h===void 0&&(0,l.isString)(S)&&(h=S.split(O.delimiter)),h===void 0||h.length===0){const T=O.join(o,i);return await D(T)?T:void 0}for(const T of h){let U;if(O.isAbsolute(T)?U=O.join(T,i):U=O.join(o,T,i),await D(U))return U;if(M.isWindows){let H=U+".com";if(await D(H)||(H=U+".exe",await D(H)))return H}}const L=O.join(o,i);return await D(L)?L:void 0}e.findExecutable=p;function s(i,o,h,g,D){const R=M.isWindows&&(!o.windowsEnableConpty||b()<18309);if(!o.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||R)return;const S=i.args,L=P.platform==="win32"?O.basename(i.executable).toLowerCase():O.basename(i.executable),T=O.dirname(A.FileAccess.asFileUri("").fsPath);let U;const H={VSCODE_INJECTION:"1"};if(o.shellIntegration.nonce&&(H.VSCODE_NONCE=o.shellIntegration.nonce),M.isWindows){if(L==="pwsh.exe"||L==="powershell.exe")return!S||c(S)?U=d.get(a.WindowsPwsh):t(S)&&(U=d.get(a.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,f.format)(U[U.length-1],T,""),{newArgs:U,envMixin:H}):void 0;g.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(L){case"bash":return!S||S.length===0?U=d.get(a.Bash):n(S)&&(H.VSCODE_SHELL_LOGIN="1",y(o,H),U=d.get(a.Bash)),U?(U=[...U],U[U.length-1]=(0,f.format)(U[U.length-1],T),{newArgs:U,envMixin:H}):void 0;case"fish":return;case"pwsh":return!S||c(S)?U=d.get(a.Pwsh):t(S)&&(U=d.get(a.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,f.format)(U[U.length-1],T,""),{newArgs:U,envMixin:H}):void 0;case"zsh":{if(!S||S.length===0?U=d.get(a.Zsh):n(S)?(U=d.get(a.ZshLogin),y(o,H)):(S===d.get(a.Zsh)||S===d.get(a.ZshLogin))&&(U=S),!U)return;U=[...U],U[U.length-1]=(0,f.format)(U[U.length-1],T);let re;try{re=E.userInfo().username}catch{re="unknown"}const Y=O.join(E.tmpdir(),`${re}-${D.applicationName}-zsh`);H.ZDOTDIR=Y;const ne=h?.ZDOTDIR??E.homedir()??"~";H.USER_ZDOTDIR=ne;const ce=[];return ce.push({source:O.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.join(Y,".zshrc")}),ce.push({source:O.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.join(Y,".zprofile")}),ce.push({source:O.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.join(Y,".zshenv")}),ce.push({source:O.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.join(Y,".zlogin")}),{newArgs:U,envMixin:H,filesToCopy:ce}}}g.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=s;function y(i,o){if(M.isMacintosh&&i.environmentVariableCollections){const h=(0,v.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),D=new u.MergedEnvironmentVariableCollection(h).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),R=[];if(D)for(const S of D)S.type===m.EnvironmentVariableMutatorType.Prepend&&R.push(S.value);R.length>0&&(o.VSCODE_PATH_PREFIX=R.join(""))}}var a;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(a||(a={}));const d=new Map;d.set(a.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(a.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(a.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(a.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(a.Zsh,["-i"]),d.set(a.ZshLogin,["-il"]),d.set(a.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const I=["-login","-l"],k=["-nol","-nologo"];function t(i){return typeof i=="string"?I.includes(i.toLowerCase()):i.length===1&&I.includes(i[0].toLowerCase())||i.length===2&&(I.includes(i[0].toLowerCase())||I.includes(i[1].toLowerCase()))&&(k.includes(i[0].toLowerCase())||k.includes(i[1].toLowerCase()))}function c(i){return typeof i=="string"?k.includes(i.toLowerCase()):i.length===0||i?.length===1&&k.includes(i[0].toLowerCase())}function n(i){return i==="string"&&I.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&I.includes(i[0].toLowerCase())}}),define(te[259],ie([0,1,46,69,9,3,11,22,106,258,112]),function(x,e,E,A,r,O,M,P,f,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let m,v=!0;function u(i,o,h,g,D=process.env,R,S,L,T){return R=R||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},O.isWindows?b(h,R,D,S,g.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:g.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:g.getValue("terminal.integrated.defaultProfile.windows"),T,L):t(R,S,h,i&&typeof i=="object"?{...i}:g.getValue(O.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:g.getValue(O.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,L,D)}e.detectAvailableProfiles=u;async function b(i,o,h,g,D,R,S,L,T){const U=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),H=`${process.env.windir}\\${U?"Sysnative":"System32"}`;let re=!1;(0,l.getWindowsBuildNumber)()>=16299&&(re=!0),await y(L);const Y=new Map;if(i){Y.set("PowerShell",{source:"PowerShell",icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),Y.set("Windows PowerShell",{path:`${H}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),Y.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),Y.set("Command Prompt",{path:`${H}\\cmd.exe`,icon:A.Codicon.terminalCmd,isAutoDetected:!0}),Y.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),Y.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:A.Codicon.terminalBash,isAutoDetected:!0});const ce=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;Y.set("Cmder",{path:`${H}\\cmd.exe`,args:["/K",ce],requiresPath:process.env.CMDER_ROOT?ce:{path:ce,isUnsafe:!0},isAutoDetected:!0})}c(R,Y);const ne=await p(Y.entries(),S,o,h,g,T);if(i||D)try{const ce=await I(`${H}\\${re?"wsl":"bash"}.exe`,S);for(const le of ce)(!R||!(le.profileName in R))&&ne.push(le)}catch{v&&(g?.info("WSL is not installed, so could not detect WSL profiles"),v=!1)}return ne}async function p(i,o,h,g=process.env,D,R){const S=[];for(const[L,T]of i){if(T===null)continue;let U,H,re;if("source"in T&&!("path"in T)){const le=m?.get(T.source);if(!le)continue;U=le.paths,H=T.args||le.args,T.icon?re=s(T.icon):le.icon&&(re=le.icon)}else U=Array.isArray(T.path)?T.path:[T.path],H=O.isWindows||Array.isArray(T.args)?T.args:void 0,re=s(T.icon);let Y;if(R){const le=U.map(G=>typeof G=="string"?G:G.path),X=await R(le);Y=new Array(U.length);for(let G=0;G<U.length;G++)typeof U[G]=="string"?Y[G]=X[G]:Y[G]={path:X[G],isUnsafe:!0}}else Y=U.slice();let ne;if(T.requiresPath){let le;if((0,M.isString)(T.requiresPath)?le=T.requiresPath:(le=T.requiresPath.path,T.requiresPath.isUnsafe&&(ne=le)),!await h.existsFile(le))continue}const ce=await n(L,o,Y,h,g,H,T.env,T.overrideName,T.isAutoDetected,ne);ce?(ce.isAutoDetected=T.isAutoDetected,ce.icon=re,ce.color=T.color,S.push(ce)):D?.debug("Terminal profile not validated",L,U)}return D?.debug("Validated terminal profiles",S),S}function s(i){return typeof i=="string"?{id:i}:i}async function y(i){if(m&&!i)return;const[o,h]=await Promise.all([a(),i||d()]);m=new Map,m.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),m.set("PowerShell",{profileName:"PowerShell",paths:h,icon:A.Codicon.terminalPowershell})}async function a(){const i=new Set,o=await(0,l.findExecutable)("git.exe");if(o){const D=(0,w.dirname)(o);i.add((0,w.resolve)(D,"../.."))}function h(D,R){R&&D.add(R)}h(i,process.env.ProgramW6432),h(i,process.env.ProgramFiles),h(i,process.env["ProgramFiles(X86)"]),h(i,`${process.env.LocalAppData}\\Program`);const g=[];for(const D of i)g.push(`${D}\\Git\\bin\\bash.exe`,`${D}\\Git\\usr\\bin\\bash.exe`,`${D}\\usr\\bin\\bash.exe`);return g.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),g}async function d(){const i=[];for await(const o of(0,f.enumeratePowerShellInstallations)())i.push(o.exePath);return i}async function I(i,o){const h=[],g=await new Promise((S,L)=>{E.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,U)=>{if(T)return L("Problem occurred when getting wsl distros");S(U)})});if(!g)return[];const D=new RegExp(/[\r?\n]/),R=g.split(D).filter(S=>S.trim().length>0&&S!=="");for(const S of R){if(S===""||S.startsWith("docker-desktop"))continue;const L=`${S} (WSL)`,T={profileName:L,path:i,args:["-d",`${S}`],isDefault:L===o,icon:k(S),isAutoDetected:!1};h.push(T)}return h}function k(i){return i.includes("Ubuntu")?A.Codicon.terminalUbuntu:i.includes("Debian")?A.Codicon.terminalDebian:A.Codicon.terminalLinux}async function t(i,o,h,g,D,R,S,L){const T=new Map;if(h){const U=(await i.readFile("/etc/shells")).toString(),H=R||U.split(`
`).filter(Y=>Y.trim().includes("#")&&Y.trim().length>0),re=new Map;for(const Y of H){let ne=(0,r.basename)(Y),ce=re.get(ne)||0;ce++,ce>1&&(ne=`${ne} (${ce})`),re.set(ne,ce),T.set(ne,{path:Y,isAutoDetected:!0})}}return c(g,T),await p(T.entries(),D,i,L,o,S)}function c(i,o){if(i)for(const[h,g]of Object.entries(i))g===null||typeof g!="object"||!("path"in g)&&!("source"in g)?o.delete(h):(g.icon=g.icon||o.get(h)?.icon,o.set(h,g))}async function n(i,o,h,g,D,R,S,L,T,U){if(h.length===0)return Promise.resolve(void 0);const H=h.shift();if(H==="")return n(i,o,h,g,D,R,S,L,T);const re=typeof H!="string"&&H.isUnsafe,Y=typeof H=="string"?H:H.path,ne={profileName:i,path:Y,args:R,env:S,overrideName:L,isAutoDetected:T,isDefault:i===o,isUnsafePath:re,requiresUnsafePath:U};if((0,r.basename)(Y)===Y){const le=D.PATH?D.PATH.split(r.delimiter):void 0,X=await(0,l.findExecutable)(Y,void 0,le,void 0,g.existsFile);return X?(ne.path=X,ne.isFromPath=!0,ne):n(i,o,h,g,D,R)}return await g.existsFile((0,r.normalize)(Y))?ne:n(i,o,h,g,D,R,S,L,T)}}),define(te[260],ie([0,1,4,2,3,43,19,5,224,93,255,124,257,259]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var b;(function(y){y[y.MaxRestarts=5]="MaxRestarts"})(b||(b={}));let p=0,s=e.PtyHostService=class extends A.Disposable{get c(){return this.g(),this.a}get f(){return this.g(),this.b}g(){this.a||([this.a,this.b]=this.O())}constructor(a,d,I,k){super(),this.G=a,this.H=d,this.I=I,this.J=k,this.i=!1,this.j=0,this.k=!0,this.l=!1,this.p=this.B(new E.Emitter),this.onPtyHostExit=this.p.event,this.r=this.B(new E.Emitter),this.onPtyHostStart=this.r.event,this.s=this.B(new E.Emitter),this.onPtyHostUnresponsive=this.s.event,this.t=this.B(new E.Emitter),this.onPtyHostResponsive=this.t.event,this.u=this.B(new E.Emitter),this.onPtyHostRequestResolveVariables=this.u.event,this.v=this.B(new E.Emitter),this.onProcessData=this.v.event,this.w=this.B(new E.Emitter),this.onProcessReady=this.w.event,this.y=this.B(new E.Emitter),this.onProcessReplay=this.y.event,this.z=this.B(new E.Emitter),this.onProcessOrphanQuestion=this.z.event,this.C=this.B(new E.Emitter),this.onDidRequestDetach=this.C.event,this.D=this.B(new E.Emitter),this.onDidChangeProperty=this.D.event,this.F=this.B(new E.Emitter),this.onProcessExit=this.F.event,(0,v.registerTerminalPlatformConfiguration)(),this.B((0,A.toDisposable)(()=>this.P())),this.h=this.B(new w.RequestStore(void 0,this.I)),this.h.onCreateRequest(this.u.fire,this.u),this.G.onBeforeWindowConnection?E.Event.once(this.G.onBeforeWindowConnection)(()=>this.g()):this.g(),this.G.onWillShutdown?.(()=>this.i=!0)}get L(){return this.H.getValue("terminal.integrated.ignoreProcessNames")}async M(){return this.f.refreshIgnoreProcessNames?.(this.L)}async N(){if(r.isWindows)return process.env;try{return await(0,l.getResolvedShellEnv)(this.H,this.I,{_:[]},process.env)}catch(a){return this.I.error("ptyHost was unable to resolve shell environment",a),{}}}O(){const a=this.G.start(p),d=a.client;this.r.fire(),O.ProxyChannel.toService(d.getChannel(m.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.Q()),this.Q(),this.B(a.onDidProcessExit(t=>{this.p.fire(t.code),!this.i&&!this.l&&(this.j<=b.MaxRestarts?(this.I.error(`ptyHost terminated unexpectedly with code ${t.code}`),this.j++,this.restartPtyHost()):this.I.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const k=O.ProxyChannel.toService(d.getChannel(m.TerminalIpcChannels.PtyHost));return this.B(k.onProcessData(t=>this.v.fire(t))),this.B(k.onProcessReady(t=>this.w.fire(t))),this.B(k.onProcessExit(t=>this.F.fire(t))),this.B(k.onDidChangeProperty(t=>this.D.fire(t))),this.B(k.onProcessReplay(t=>this.y.fire(t))),this.B(k.onProcessOrphanQuestion(t=>this.z.fire(t))),this.B(k.onDidRequestDetach(t=>this.C.fire(t))),E.Event.once(E.Event.any(k.onProcessReady,k.onProcessReplay))(()=>{this.B(new f.RemoteLoggerChannelClient(this.J,d.getChannel(m.TerminalIpcChannels.Logger)))}),this.a=a,this.b=k,this.B(this.H.onDidChangeConfiguration(async t=>{t.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.M()})),this.M(),[a,k]}dispose(){this.l=!0,super.dispose()}async createProcess(a,d,I,k,t,c,n,i,o,h,g){const D=setTimeout(()=>this.U(),m.HeartbeatConstants.CreateProcessTimeout),R=await this.f.createProcess(a,d,I,k,t,c,n,i,o,h,g);return clearTimeout(D),p=Math.max(p,R),R}updateTitle(a,d,I){return this.f.updateTitle(a,d,I)}updateIcon(a,d,I,k){return this.f.updateIcon(a,d,I,k)}attachToProcess(a){return this.f.attachToProcess(a)}detachFromProcess(a,d){return this.f.detachFromProcess(a,d)}listProcesses(){return this.f.listProcesses()}reduceConnectionGraceTime(){return this.f.reduceConnectionGraceTime()}start(a){return this.f.start(a)}shutdown(a,d){return this.f.shutdown(a,d)}input(a,d){return this.f.input(a,d)}processBinary(a,d){return this.f.processBinary(a,d)}resize(a,d,I){return this.f.resize(a,d,I)}acknowledgeDataEvent(a,d){return this.f.acknowledgeDataEvent(a,d)}setUnicodeVersion(a,d){return this.f.setUnicodeVersion(a,d)}getInitialCwd(a){return this.f.getInitialCwd(a)}getCwd(a){return this.f.getCwd(a)}getLatency(a){return this.f.getLatency(a)}orphanQuestionReply(a){return this.f.orphanQuestionReply(a)}installAutoReply(a,d){return this.f.installAutoReply(a,d)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(a){return this.f.uninstallAutoReply(a)}getDefaultSystemShell(a){return this.f.getDefaultSystemShell(a)}async getProfiles(a,d,I,k=!1){const t=await this.N();return(0,u.detectAvailableProfiles)(d,I,k,this.H,t,void 0,this.I,this.X.bind(this,a))}getEnvironment(){return this.f.getEnvironment()}getWslPath(a,d){return this.f.getWslPath(a,d)}getRevivedPtyNewId(a){return this.f.getRevivedPtyNewId(a)}setTerminalLayoutInfo(a){return this.f.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this.f.getTerminalLayoutInfo(a)}async requestDetachInstance(a,d){return this.f.requestDetachInstance(a,d)}async acceptDetachInstanceReply(a,d){return this.f.acceptDetachInstanceReply(a,d)}async freePortKillProcess(a){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(a)}async serializeTerminalState(a){return this.f.serializeTerminalState(a)}async reviveTerminalProcesses(a,d){return this.f.reviveTerminalProcesses(a,d)}async refreshProperty(a,d){return this.f.refreshProperty(a,d)}async updateProperty(a,d,I){return this.f.updateProperty(a,d,I)}async restartPtyHost(){this.P(),this.k=!0,this.O()}P(){this.f.shutdownAll?.(),this.c.store.dispose()}Q(){this.W(),this.m=setTimeout(()=>this.R(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier),this.k||(this.k=!0,this.t.fire())}R(){this.I.warn(`No ptyHost heartbeat after ${m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.m=void 0,this.n=setTimeout(()=>this.S(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.SecondWaitMultiplier)}S(){this.I.error(`No ptyHost heartbeat after ${(m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier+m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.n=void 0,this.k&&(this.k=!1,this.s.fire())}U(){this.W(),this.I.error(`No ptyHost response to createProcess after ${m.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.k&&(this.k=!1,this.s.fire())}W(){this.m&&(clearTimeout(this.m),this.m=void 0),this.n&&(clearTimeout(this.n),this.n=void 0)}X(a,d){return this.h.createRequest({workspaceId:a,originalText:d})}async acceptPtyHostResolvedVariables(a,d){this.h.acceptReply(a,d)}};e.PtyHostService=s=ve([Z(1,M.IConfigurationService),Z(2,P.ILogService),Z(3,P.ILoggerService)],s)}),define(te[79],ie([0,1,15,4,2,3,19,6,34]),function(x,e,E,A,r,O,M,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const l="#FFFFFF",w="#1E1E1E",m="#000000",v="#FFFFFF",u="theme",b="themeBackground",p="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let s=e.ThemeMainService=class extends r.Disposable{constructor(a,d){super(),this.b=a,this.c=d,this.a=this.B(new A.Emitter),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(O.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(O.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(O.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const a=this.getColorScheme();if(a.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return a.dark?m:v;let d=this.b.getItem(b,null);if(!d)switch(this.b.getItem(u,"vs-dark").split(" ")[0]){case"vs":d=l;break;case"hc-black":d=m;break;case"hc-light":d=v;break;default:d=w}return O.isMacintosh&&d.toUpperCase()===w&&(d="#171717"),d}saveWindowSplash(a,d){this.b.setItems([{key:u,data:d.baseTheme},{key:b,data:d.colorInfo.background},{key:p,data:d}]),typeof a=="number"&&this.f(a,d)}f(a,d){for(const I of E.BrowserWindow.getAllWindows())if(I.id===a){I.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(p)}};e.ThemeMainService=s=ve([Z(0,f.IStateService),Z(1,M.IConfigurationService)],s)}),define(te[125],ie([0,1,4,19,6,5]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,r.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,r.createDecorator)("sharedTunnelsService");var M;(function(p){p.Http="http",p.Https="https"})(M||(e.TunnelProtocol=M={}));var P;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(P||(e.TunnelPrivacyId=P={}));var f;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function l(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=l,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=m;function v(p,s,y,a){if(y===1)return!1;if(y===2&&m(s)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(d?.length===4&&parseInt(d[1])>=18)return!1}return p<1024}e.isPortPrivileged=v;class u{constructor(s,y,a){this.remoteAddress=s,this.localAddress=y,this.b=a,this.a=new E.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=u;let b=e.AbstractTunnelService=class{constructor(s,y){this.i=s,this.j=y,this.a=new E.Emitter,this.onTunnelOpened=this.a.event,this.b=new E.Emitter,this.onTunnelClosed=this.b.event,this.c=new E.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const s=this.j.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.e=s,s?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.f=s.elevation,this.g=s.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const s=[],y=Array.from(this.d.values());for(const a of y){const d=Array.from(a.values());for(const I of d){const k=await I.value;k&&s.push(k)}}return s}async dispose(){for(const s of this.d.values()){for(const{value:y}of s.values())await y.then(a=>a?.dispose());s.clear()}this.d.clear()}setEnvironmentTunnel(s,y,a,d,I){this.o(s,y,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:y,localAddress:a,privacy:d,protocol:I,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,y){(m(s)||w(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const a=this.q(s,y);if(a)return++a.refcount,a.value}openTunnel(s,y,a,d,I,k=!1,t,c){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${y}:${a} on local port ${I}.`),!s)return;if(y||(y="localhost"),d||(d=this.k),this.e&&this.h.has(a)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.r(s,y,a,d,I,k,t,c);return n?n.then(i=>{if(!i){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(y,a);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(i);return(i.tunnelRemoteHost!==y||i.tunnelRemotePort!==a)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),t&&i.privacy!==t&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}m(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const y=this.d.get(s.tunnelRemoteHost);if(y){const a=y.get(s.tunnelRemotePort);a&&(a.refcount--,await this.n(s.tunnelRemoteHost,s.tunnelRemotePort,a))}}}}async n(s,y,a){if(a.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${y}.`);const d=a.value.then(async I=>{I&&(await I.dispose(!0),this.b.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this.d.has(s)&&this.d.get(s).delete(y),d}}async closeTunnel(s,y){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${y} `);const a=this.d.get(s);if(a&&a.has(y)){const d=a.get(y);d.refcount=0,await this.n(s,y,d)}}o(s,y,a){this.d.has(s)||this.d.set(s,new Map),this.d.get(s).set(y,{refcount:1,value:a})}async p(s,y){const a=this.d.get(s);a&&(await a.get(y)||a.delete(y),a.size===0&&this.d.delete(s))}q(s,y){const a=[s];w(s)?(a.push(...e.LOCALHOST_ADDRESSES),a.push(...e.ALL_INTERFACES_ADDRESSES)):m(s)&&a.push(...e.ALL_INTERFACES_ADDRESSES);const d=a.map(I=>this.d.get(I));for(const I of d){const k=I?.get(y);if(k)return k}}canTunnel(s){return!!l(s)}s(s,y,a,d,I,k,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${y}:${a} on local port ${d}.`);const c=a;this.h.add(c);const n=d===void 0?a:d,i={elevationRequired:I?this.isPortPrivileged(n):!1},o={remoteAddress:{host:y,port:a},localAddressPort:d,privacy:k,public:k?k!==P.Private:void 0,protocol:t},h=s.forwardPort(o,i);return h?(this.o(y,a,h),h.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(c)})):this.h.delete(c),h}};e.AbstractTunnelService=b=ve([Z(0,O.ILogService),Z(1,A.IConfigurationService)],b)}),define(te[261],ie([0,1,84,27,103,7,2,19,5,23,239,125,94,3,240]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(I,k,t,c,n){let i;for(let o=3;o&&(i?.dispose(),i=await new s(I,k,t,c,n).waitForReady(),!(n&&r.BROWSER_RESTRICTED_PORTS[n]||!r.BROWSER_RESTRICTED_PORTS[i.tunnelLocalPort]));o--);return i}class s extends M.Disposable{constructor(k,t,c,n,i){super(),this.j=t,this.k=i,this.privacy=m.TunnelPrivacyId.Private,this.i=new Map,this.a=k,this.b=E.createServer(),this.c=new O.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.l(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const k=this.k??this.tunnelRemotePort,t=(0,m.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let c=await(0,r.findFreePortFaster)(k,2,1e3,t),n=null;return this.b.listen(c,this.j),await this.c.wait(),n=this.b.address(),n||(c=0,this.b.listen(c,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(k){k.pause();const t=(0,m.isLocalhost)(this.tunnelRemoteHost)||(0,m.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,w.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),n=c.getSocket().socket,i=c.readEntireBuffer();c.dispose(),i.byteLength>0&&k.write(i.buffer),k.on("end",()=>{k.localAddress&&this.i.delete(k.localAddress),n.end()}),k.on("close",()=>n.end()),k.on("error",()=>{k.localAddress&&this.i.delete(k.localAddress),n.destroy()}),n.on("end",()=>k.end()),n.on("close",()=>k.end()),n.on("error",()=>{k.destroy()}),k.pipe(n),n.pipe(k),k.localAddress&&this.i.set(k.localAddress,()=>{k.end(),n.end()})}}let y=e.BaseTunnelService=class extends m.AbstractTunnelService{constructor(k,t,c,n,i){super(t,i),this.t=k,this.u=c,this.v=n}isPortPrivileged(k){return(0,m.isPortPrivileged)(k,this.k,u.OS,A.release())}r(k,t,c,n,i,o,h,g){const D=this.q(t,c);if(D)return++D.refcount,D.value;if(this.e)return this.s(this.e,t,c,i,o,h,g);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${c} on local port ${i}.`);const R={commit:this.v.commit,quality:this.v.quality,addressProvider:k,remoteSocketFactoryService:this.t,signService:this.u,logService:this.i,ipcLogger:null},S=p(R,n,t,c,i);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,c,S),S}}};e.BaseTunnelService=y=ve([Z(0,b.IRemoteSocketFactoryService),Z(1,f.ILogService),Z(2,v.ISignService),Z(3,l.IProductService),Z(4,P.IConfigurationService)],y);let a=e.TunnelService=class extends y{constructor(k,t,c,n,i){super(k,t,c,n,i)}};e.TunnelService=a=ve([Z(0,b.IRemoteSocketFactoryService),Z(1,f.ILogService),Z(2,v.ISignService),Z(3,l.IProductService),Z(4,P.IConfigurationService)],a);let d=e.SharedTunnelsService=class extends M.Disposable{constructor(k,t,c,n,i){super(),this.b=k,this.c=t,this.f=c,this.g=n,this.h=i,this.a=new Map}async openTunnel(k,t,c,n,i,o,h,g,D){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${n} on local port ${o}.`),!this.a.has(k)){const R=new a(this.b,this.c,this.g,this.f,this.h);this.B(R),this.a.set(k,R),R.onTunnelClosed(async()=>{(await R.tunnels).length===0&&(R.dispose(),this.a.delete(k))})}return this.a.get(k).openTunnel(t,c,n,i,o,h,g,D)}};e.SharedTunnelsService=d=ve([Z(0,b.IRemoteSocketFactoryService),Z(1,f.ILogService),Z(2,l.IProductService),Z(3,v.ISignService),Z(4,P.IConfigurationService)],d)}),define(te[48],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var A;(function(O){O.Uninitialized="uninitialized",O.Idle="idle",O.CheckingForUpdates="checking for updates",O.AvailableForDownload="available for download",O.Downloading="downloading",O.Downloaded="downloaded",O.Updating="updating",O.Ready="ready"})(A||(e.StateType=A={}));var r;(function(O){O[O.Setup=0]="Setup",O[O.Archive=1]="Archive",O[O.Snap=2]="Snap"})(r||(e.UpdateType=r={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(O,M)=>({type:"idle",updateType:O,error:M}),CheckingForUpdates:O=>({type:"checking for updates",explicit:O}),AvailableForDownload:O=>({type:"available for download",update:O}),Downloading:O=>({type:"downloading",update:O}),Downloaded:O=>({type:"downloaded",update:O}),Updating:O=>({type:"updating",update:O}),Ready:O=>({type:"ready",update:O})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(te[262],ie([0,1,3,186,57,47]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),O.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[263],ie([0,1,4,48]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class r{constructor(P){this.a=P}listen(P,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(P,f,l){switch(f){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=r;class O{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new E.Emitter,this.onStateChange=this.a.event,this.b=A.State.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=O}),define(te[40],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(te[264],ie([0,1,40,205,16,18,138,4,2]),function(x,e,E,A,r,O,M,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{constructor(v){this.uri=v,this.time=l._clock++}touch(){return this.time=l._clock++,this}}l._clock=0;let w=e.UriIdentityService=class{constructor(v){this.g=v,this.c=new f.DisposableStore,this.f=2**16;const u=new Map,b=p=>{let s=u.get(p.scheme);return s===void 0&&(s=v.hasProvider(p)&&!this.g.hasCapability(p,1024),u.set(p.scheme,s)),s};this.c.add(P.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(p=>{u.delete(p.scheme)})),this.extUri=new O.ExtUri(b),this.d=new M.SkipList((p,s)=>this.extUri.compare(p,s,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,O.normalizePath)(v));const u=this.d.get(v);return u?u.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new l(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((b,p)=>b[1].time<p[1].time?1:b[1].time>p[1].time?-1:0);l._clock=0,this.d.clear();const u=this.f*.5;for(let b=0;b<u;b++)this.d.set(v[b][0],v[b][1].touch())}};e.UriIdentityService=w=ve([Z(0,r.IFileService)],w),(0,A.registerSingleton)(E.IUriIdentityService,w,1)}),define(te[126],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(te[265],ie([0,1,8]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class A{constructor(P){this.a=P}listen(P,f){throw new Error(`Event not found: ${f}`)}call(P,f,l){switch(f){case"handleURL":return this.a.handleURL(E.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=A;class r{constructor(P){this.a=P}handleURL(P,f){return this.a.call("handleURL",[P.toJSON(),f])}}e.URLHandlerChannelClient=r;class O{constructor(P,f){this.a=P,this.b=f}async routeCall(P,f,l,w){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(l)&&l.length>0){const m=E.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",m.toString(!0)),m.query){const v=/\bwindowId=(\d+)/.exec(m.query);if(v){const u=v[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${u}"`,m.toString(!0));const b=new RegExp(`window:${u}`),p=P.connections.find(s=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",s.ctx),b.test(s.ctx)));if(p)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",m.toString(!0)),p;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",m.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",m.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,f,l,w)}routeEvent(P,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=O}),define(te[266],ie([0,1,7,2,8,23]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends A.Disposable{constructor(){super(...arguments),this.a=new Set}open(l,w){const m=[...this.a.values()];return(0,E.first)(m.map(v=>()=>v.handleURL(l,w)),void 0,!1).then(v=>v||!1)}registerHandler(l){return this.a.add(l),(0,A.toDisposable)(()=>this.a.delete(l))}}e.AbstractURLService=M;let P=e.NativeURLService=class extends M{constructor(l){super(),this.b=l}create(l){let{authority:w,path:m,query:v,fragment:u}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return w&&m&&m.indexOf("/")!==0&&(m=`/${m}`),r.URI.from({scheme:this.b.urlProtocol,authority:w,path:m,query:v,fragment:u})}};e.NativeURLService=P=ve([Z(0,O.IProductService)],P)}),define(te[267],ie([0,1,15,7,4,2,3,8]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class f{constructor(w,m,v,u,b,p){if(this.f=m,this.g=p,this.a=[],this.b=0,this.c=O.Disposable.None,this.d=new O.DisposableStore,w&&(p.trace("ElectronURLListener initialUrisToHandle:",w.map(a=>a.originalUrl)),this.a=w),M.isWindows){const a=u.isBuilt?[]:[`"${u.appRoot}"`];a.push("--open-url","--"),E.app.setAsDefaultProtocolClient(b.urlProtocol,process.execPath,a)}const s=r.Event.map(r.Event.fromNodeEventEmitter(E.app,"open-url",(a,d)=>({event:a,url:d})),({event:a,url:d})=>(a.preventDefault(),d));this.d.add(s(a=>{const d=this.h(a);d&&this.f.open(d,{originalUrl:a})})),v.getWindows().filter(a=>a.isReady).length>0?(p.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(p.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),r.Event.once(v.onDidSignalReadyWindow)(this.i,this,this.d))}h(w){try{return P.URI.parse(w)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const w=[];for(const m of this.a)await this.f.open(m.uri,{originalUrl:m.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",m.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",m.originalUrl),w.push(m));w.length!==0&&(this.a=w,this.c=(0,A.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=f}),define(te[268],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(te[269],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(te[270],ie([0,1,15,2,14,8]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends A.Disposable{constructor(){super();const f=this.b.bind(this);E.protocol.registerFileProtocol(r.Schemas.vscodeWebview,f)}b(f,l){try{const w=O.URI.parse(f.url),m=M.a.get(w.path);if(typeof m=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${m}`,u=r.FileAccess.asFileUri(v);return l({path:u.fsPath,headers:{...r.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.WebviewProtocolProvider=M,M.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(te[80],ie([0,1,3]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(w){return!!w.workspaceUri}e.isWorkspaceToOpen=A;function r(w){return!!w.folderUri}e.isFolderToOpen=r;function O(w){return!!w.fileUri}e.isFileToOpen=O;function M(w){const m=P(w),v=w.getValue("window.menuBarVisibility");return v==="default"||m==="native"&&v==="compact"||E.isMacintosh&&E.isNative?"classic":v}e.getMenuBarVisibility=M;function P(w){if(E.isWeb)return"custom";const m=w.getValue("window");if(m){if(E.isMacintosh&&m.nativeTabs===!0||E.isMacintosh&&m.nativeFullScreen===!1)return"native";const b=m.titleBarStyle;if(b==="native"||b==="custom")return b}return E.isLinux?"native":"custom"}e.getTitleBarStyle=P;function f(w){if(!E.isWindows||E.isWeb||P(w)==="native")return!1;const m=w.getValue("window.experimental.windowControlsOverlay.enabled");return typeof m=="boolean"?m:!0}e.useWindowControlsOverlay=f;function l(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=l}),define(te[127],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(E||(e.LoadReason=E={}));var A;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(A||(e.UnloadReason=A={}));const r=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=r;var O;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(O||(e.WindowMode=O={}));var M;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(M||(e.WindowError=M={}))}),define(te[28],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var A;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(A||(e.OpenContext=A={}))}),define(te[271],ie([0,1,15,21,4,56,2,31,75,114,5,23,28]),function(x,e,E,A,r,O,M,P,f,l,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var u;(function(p){p[p.Initial=1]="Initial",p[p.StoredCredentialsUsed=2]="StoredCredentialsUsed",p[p.LoginDialogShown=3]="LoginDialogShown"})(u||(u={}));let b=e.ProxyAuthHandler=class extends M.Disposable{constructor(s,y,a,d,I){super(),this.g=s,this.h=y,this.i=a,this.j=d,this.k=I,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=u.Initial,this.f=void 0,this.l()}l(){const s=r.Event.fromNodeEventEmitter(E.app,"login",(y,a,d,I,k)=>({event:y,webContents:a,req:d,authInfo:I,callback:k}));this.B(s(this.m,this))}async m({event:s,authInfo:y,req:a,callback:d}){if(!y.isProxy)return;if(!this.b&&this.c===u.LoginDialogShown&&a.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}s.preventDefault();let I;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),I=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(y);try{I=await this.b}finally{this.b=void 0}}d(I?.username,I?.password)}async n(s){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const y=await this.p(s);if(y)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),y;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(s){this.g.trace("auth#doResolveProxyCredentials - enter",s);const y=String((0,O.hash)({scheme:s.scheme,host:s.host,port:s.port}));let a,d;try{const c=await this.i.getPassword(this.a,y);if(c){const n=JSON.parse(await this.j.decrypt(c));a=n.username,d=n.password}}catch(c){this.g.error(c)}if(this.c!==u.StoredCredentialsUsed&&typeof a=="string"&&typeof d=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=u.StoredCredentialsUsed,{username:a,password:d};const I=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!I){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${I.id} to handle proxy login`);const k={authInfo:s,username:this.f?.username??a,password:this.f?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};I.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,k),this.c=u.LoginDialogShown;const t=await new Promise(c=>{const n=async(i,o,h)=>{if(o===k.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${I.id}`),I.win?.webContents.off("ipc-message",n),h){const g={username:h.username,password:h.password};try{if(h.remember){const D=await this.j.encrypt(JSON.stringify(g));await this.i.setPassword(this.a,y,D)}else await this.i.deletePassword(this.a,y)}catch(D){this.g.error(D)}c({username:g.username,password:g.password})}else c(void 0)};I.win?.webContents.on("ipc-message",n)});return this.f=t,t}};e.ProxyAuthHandler=b=ve([Z(0,w.ILogService),Z(1,v.IWindowsMainService),Z(2,f.ICredentialsMainService),Z(3,l.IEncryptionMainService),Z(4,m.IProductService)],b)}),define(te[272],ie([0,1,75,5,33,23,28,217]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let f=e.CredentialsNativeMainService=class extends P.BaseCredentialsMainService{constructor(w,m,v,u){super(w),this.n=m,this.p=v,this.r=u,this.j=b=>{this.r.sendToFocused("vscode:showCredentialsError",b.message??b)}}async getSecretStoragePrefix(){return Promise.resolve(this.p.urlProtocol)}async i(){if(this.f)return this.f;if(this.n.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;const w=await new Promise((m,v)=>{x(["keytar"],m,v)});return await w.findCredentials("test-keytar-loads"),this.f=w,this.f}};e.CredentialsNativeMainService=f=ve([Z(0,A.ILogService),Z(1,r.INativeEnvironmentService),Z(2,O.IProductService),Z(3,M.IWindowsMainService)],f)}),define(te[273],ie([0,1,15,24,3,8,22,19,63,6,5,126,28]),function(x,e,E,A,r,O,M,P,f,l,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,l.createDecorator)(e.ID);let u=e.LaunchMainService=class{constructor(p,s,y,a){this.a=p,this.b=s,this.c=y,this.d=a}async start(p,s){this.a.trace("Received data from other instance: ",p,s),r.isMacintosh&&E.app.focus({steal:!0});const y=this.e(p);if(y.length){let a=Promise.resolve();if(this.b.getWindowCount()===0){const d=(0,A.firstOrDefault)(await this.b.openEmptyWindow({context:4}));d&&(a=d.ready())}a.then(()=>{for(const{uri:d,originalUrl:I}of y)this.c.open(d,{originalUrl:I})})}else return this.f(p,s)}e(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,A.coalesce)(p._urls.map(s=>{try{return{uri:O.URI.parse(s),originalUrl:s}}catch{return null}})):[]}async f(p,s){const y=(0,f.isLaunchedFromCli)(s)?0:4;let a=[];const d=p.wait&&p.waitMarkerFilePath?O.URI.file(p.waitMarkerFilePath):void 0,I=p.remote||void 0,k={context:y,cli:p,userEnv:s,waitMarkerFileURI:d,remoteAuthority:I,forceProfile:p.profile,forceTempProfile:p["profile-temp"]};if(p.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,k);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let t=!1;if(p["new-window"]||p["unity-launch"]||k.forceProfile||k.forceTempProfile)t=!0;else if(p["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!r.isMacintosh}if(t)a=await this.b.open({...k,forceNewWindow:!0,forceEmpty:!0});else{const c=this.b.getLastActiveWindow();c?(this.b.openExistingWindow(c,k),a=[c]):a=await this.b.open({...k,forceEmpty:!0})}}else a=await this.b.open({...k,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(d&&a.length===1&&a[0])return Promise.race([a[0].whenClosedOrLoaded,(0,M.whenDeleted)(d.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=u=ve([Z(0,w.ILogService),Z(1,v.IWindowsMainService),Z(2,m.IURLService),Z(3,P.IConfigurationService)],u)}),define(te[274],ie([0,1,15,4,2,270,28]),function(x,e,E,A,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=e.WebviewMainService=class extends r.Disposable{constructor(l){super(),this.b=l,this.a=this.B(new A.Emitter),this.onFoundInFrame=this.a.event,this.B(new O.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(l,w){let m;if(typeof l.windowId=="number"){const{windowId:v}=l,u=this.b.getWindowById(v);if(!u?.win)throw new Error(`Invalid windowId: ${v}`);m=u.win.webContents}else{const{webContentsId:v}=l;if(m=E.webContents.fromId(v),!m)throw new Error(`Invalid webContentsId: ${v}`)}m.isDestroyed()||m.setIgnoreMenuShortcuts(w)}async findInFrame(l,w,m,v){const b=this.c(l,w);if(typeof b.findInFrame=="function"){b.findInFrame(m,{findNext:v.findNext,forward:v.forward});const p=(s,y)=>{y.finalUpdate&&(this.a.fire(y),b.removeListener("found-in-frame",p))};b.on("found-in-frame",p)}}async stopFindInFrame(l,w,m){const u=this.c(l,w);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(m.keepSelection?"keepSelection":"clearSelection")}c(l,w){const m=this.b.getWindowById(l.windowId);if(!m?.win)throw new Error(`Invalid windowId: ${l}`);const v=m.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===w);if(!v)throw new Error(`Unknown frame: ${w}`);return v}};e.WebviewMainService=P=ve([Z(0,M.IWindowsMainService)],P)}),define(te[275],ie([0,1,7,4,2]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class O extends r.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:f,getActiveWindowId:l}){super(),this.a=this.B(new r.DisposableStore),A.Event.latch(A.Event.any(P,f))(this.f,this,this.a),this.b=(0,E.createCancelablePromise)(()=>l()),(async()=>{try{const m=await this.b;this.c=typeof this.c=="number"?this.c:m}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=O}),define(te[29],ie([0,1,190,9,62,18,8,6,14]),function(x,e,E,A,r,O,M,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function l(i){const o=i;return typeof o?.id=="string"&&M.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=l;function w(i){return typeof i?.id=="string"&&!l(i)&&!v(i)}e.isEmptyWorkspaceIdentifier=w,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function m(i,o){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,A.basename)(i)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const h=i;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.toWorkspaceIdentifier=m;function v(i){const o=i;return typeof o?.id=="string"&&M.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=v;function u(i){const o=i;if(o?.uri)return{id:o.id,uri:M.URI.revive(o.uri)};const h=i;if(h?.configPath)return{id:h.id,configPath:M.URI.revive(h.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=u;var b;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function p(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=p;function s(i){const o=i;return!!(o&&typeof o=="object"&&M.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=s;class y{constructor(o,h,g,D,R){this.h=o,this.j=g,this.k=D,this.l=R,this.c=r.TernarySearchTree.forUris(this.l,()=>!0),this.folders=h}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=r.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class a{constructor(o,h){this.raw=h,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,O.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=a;function d(i){return new a({uri:i,index:0,name:(0,O.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=d,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(i,o){return O.extUriBiasedIgnorePathCase.isEqualOrParent(i,o.untitledWorkspacesHome)}e.isUntitledWorkspace=I;function k(i){let o;return M.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=k,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function c(i,o){return!I(i,o)&&!k(i)}e.isSavedWorkspace=c;function n(i){return(typeof i=="string"?(0,A.extname)(i):(0,O.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(te[59],ie([0,1,15,7,56,45,2,83,3,11,22,165,90,6,5,23,29]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,u.createDecorator)("dialogMainService");let y=e.DialogMainService=class{constructor(d,I){this.d=d,this.e=I,this.a=new Map,this.b=new Map,this.c=new A.Queue}pickFileFolder(d,I){return this.f({...d,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},I)}pickFolder(d,I){return this.f({...d,pickFolders:!0,title:(0,m.localize)(1,null)},I)}pickFile(d,I){return this.f({...d,pickFiles:!0,title:(0,m.localize)(2,null)},I)}pickWorkspace(d,I){const k=(0,m.localize)(3,null),t=(0,O.mnemonicButtonLabel)((0,m.localize)(4,null)),c=s.WORKSPACE_FILTER;return this.f({...d,pickFiles:!0,title:k,filters:c,buttonLabel:t},I)}async f(d,I){const k={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters,defaultPath:d.defaultPath};(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(k.properties=void 0,d.pickFiles&&d.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&k.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(k,(0,l.withNullAsUndefined)(I||E.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(d){if(d){let I=this.b.get(d.id);return I||(I=new A.Queue,this.b.set(d.id,I)),I}else return this.c}showMessageBox(d,I){return this.g(I).queue(async()=>{const{options:k,buttonIndeces:t}=(0,v.massageMessageBoxOptions)(d,this.e);let c;return I?c=await E.dialog.showMessageBox(I,k):c=await E.dialog.showMessageBox(k),{response:t[c.response],checkboxChecked:c.checkboxChecked}})}async showSaveDialog(d,I){const k=this.j(d,I);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(I).queue(async()=>{let t;return I?t=await E.dialog.showSaveDialog(I,d):t=await E.dialog.showSaveDialog(d),t.filePath=this.h(t.filePath),t})}finally{(0,M.dispose)(k)}}h(d){return d&&f.isMacintosh&&(d=(0,P.normalizeNFC)(d)),d}i(d){return d.map(I=>this.h(I))}async showOpenDialog(d,I){d.defaultPath&&(await w.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const k=this.j(d,I);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(I).queue(async()=>{let t;return I?t=await E.dialog.showOpenDialog(I,d):t=await E.dialog.showOpenDialog(d),t.filePaths=this.i(t.filePaths),t})}finally{(0,M.dispose)(k)}}j(d,I){if(!I)return M.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",d);let k=this.a.get(I.id);k||(k=new Set,this.a.set(I.id,k));const t=(0,r.hash)(d);if(!k.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",d),k.add(t),(0,M.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",d),k?.delete(t),k?.size===0&&this.a.delete(I.id)})}};e.DialogMainService=y=ve([Z(0,b.ILogService),Z(1,p.IProductService)],y)}),define(te[276],ie([0,1,4,2,73,29]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends A.Disposable{constructor(f,l){super(),this.f=f,this.g=l,this.b=this.B(new E.Emitter),this.c=new Map,this.h(l.applicationStorage,this.b)}h(f,l){this.B(E.Event.debounce(f.onDidChangeStorage,(w,m)=>(w?w.push(m):w=[m],w),M.a)(w=>{w.length&&l.fire(this.i(w,f))}))}i(f,l){const w=new Map,m=new Set;return f.forEach(v=>{const u=l.get(v.key);typeof u=="string"?w.set(v.key,u):m.add(v.key)}),{changed:Array.from(w.entries()),deleted:Array.from(m.values())}}listen(f,l,w){switch(l){case"onDidChangeStorage":{const m=w.profile?(0,r.revive)(w.profile):void 0;if(!m)return this.b.event;let v=this.c.get(m.id);return v||(v=this.B(new E.Emitter),this.h(this.g.profileStorage(m),v),this.c.set(m.id,v)),v.event}}throw new Error(`Event not found: ${l}`)}async call(f,l,w){const m=w.profile?(0,r.revive)(w.profile):void 0,v=(0,O.reviveIdentifier)(w.workspace),u=await this.j(m,v);switch(l){case"getItems":return Array.from(u.items.entries());case"updateItems":{const b=w;if(b.insert)for(const[p,s]of b.insert)u.set(p,s);b.delete?.forEach(p=>u.delete(p));break}case"isUsed":{const b=w.payload;if(typeof b=="string")return this.g.isUsed(b)}default:throw new Error(`Call not found: ${l}`)}}async j(f,l){let w;l?w=this.g.workspaceStorage(l):f?w=this.g.profileStorage(f):w=this.g.applicationStorage;try{await w.init()}catch(m){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":f?"profile":"application"} storage due to ${m}`)}return w}}e.StorageDatabaseChannel=M,M.a=100}),define(te[41],ie([0,1,56,4,2,18,8,187,33,16,6,5,29,35,40,7,31,25,11]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function d(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&M.URI.isUri(i.location)&&M.URI.isUri(i.globalStorageHome)&&M.URI.isUri(i.settingsResource)&&M.URI.isUri(i.keybindingsResource)&&M.URI.isUri(i.tasksResource)&&M.URI.isUri(i.snippetsHome)&&M.URI.isUri(i.extensionsResource))}e.isUserDataProfile=d,e.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function I(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:M.URI.revive(n.location).with({scheme:i}),globalStorageHome:M.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:M.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:M.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:M.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:M.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:M.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:M.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=I;function k(n,i,o,h,g){return{id:n,name:i,location:o,isDefault:!1,shortName:g?.shortName,globalStorageHome:(0,O.joinPath)(o,"globalStorage"),settingsResource:(0,O.joinPath)(o,"settings.json"),keybindingsResource:(0,O.joinPath)(o,"keybindings.json"),tasksResource:(0,O.joinPath)(o,"tasks.json"),snippetsHome:(0,O.joinPath)(o,"snippets"),extensionsResource:(0,O.joinPath)(o,"extensions.json"),cacheHome:(0,O.joinPath)(h,n),useDefaultFlags:g?.useDefaultFlags,isTransient:g?.transient}}e.toUserDataProfile=k;let t=e.UserDataProfilesService=class extends r.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,o,h,g){super(),this.n=i,this.r=o,this.s=h,this.t=g,this.f=!0,this.h=this.B(new A.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new A.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new A.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new A.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new u.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,O.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=[];if(this.f)try{for(const D of this.J()){if(!D.name||!(0,a.isString)(D.name)||!D.location){this.t.warn("Skipping the invalid stored profile",D.location||D.name);continue}i.push(k((0,O.basename)(D.location),D.name,D.location,this.g,{shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}))}}catch(D){this.t.error(D)}const o=new u.ResourceMap,h=new Map,g=this.w();if(i.unshift({...g,extensionsResource:this.O()??g.extensionsResource,isDefault:!0}),i.length)try{const D=this.M();if(D.workspaces)for(const[R,S]of Object.entries(D.workspaces)){const L=M.URI.parse(R),T=i.find(U=>U.id===S);T&&o.set(L,T)}if(D.emptyWindows)for(const[R,S]of Object.entries(D.emptyWindows)){const L=i.find(T=>T.id===S);L&&h.set(R,L)}}catch(D){this.t.error(D)}this.u={profiles:i,workspaces:o,emptyWindows:h}}return this.u}w(){return k("__default__profile__",(0,P.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(i){const o="Temp",h=new RegExp(`${(0,y.escapeRegExpCharacters)(o)}\\s(\\d+)`);let g=0;for(const R of this.profiles){const S=h.exec(R.name),L=S?parseInt(S[1]):0;g=L>g?L:g}const D=`${o} ${g+1}`;return this.createProfile((0,E.hash)((0,s.generateUuid)()).toString(16),D,{transient:!0},i)}async createNamedProfile(i,o,h){return this.createProfile((0,E.hash)((0,s.generateUuid)()).toString(16),i,o,h)}async createProfile(i,o,h,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.y(i,o,h);return g&&await this.setProfileForWorkspace(g,D),D}async y(i,o,h){if(!(0,a.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let g=this.l.get(o);return g||(g=(async()=>{try{const D=this.profiles.find(L=>L.name===o||L.id===i);if(D)return D;const R=k(i,o,(0,O.joinPath)(this.profilesHome,i),this.g,h);await this.r.createFolder(R.location);const S=[];return this.i.fire({profile:R,join(L){S.push(L)}}),await p.Promises.settled(S),this.D([R],[],[]),R}finally{this.l.delete(o)}})(),this.l.set(o,g)),g}async updateProfile(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let h=this.profiles.find(g=>g.id===i.id);if(!h)throw new Error(`Profile '${i.name}' does not exist`);return h=k(h.id,o.name??h.name,h.location,this.g,{shortName:o.shortName??h.shortName,transient:o.transient??h.isTransient,useDefaultFlags:o.useDefaultFlags??h.useDefaultFlags}),this.D([],[],[h]),h}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(g=>g.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);const h=[];this.j.fire({profile:o,join(g){h.push(g)}});try{await Promise.allSettled(h)}catch(g){this.t.error(g)}for(const g of[...this.v.emptyWindows.keys()])o.id===this.v.emptyWindows.get(g)?.id&&this.v.emptyWindows.delete(g);for(const g of[...this.v.workspaces.keys()])o.id===this.v.workspaces.get(g)?.id&&this.v.workspaces.delete(g);this.H(),this.D([],[o],[]);try{await this.r.del(o.cacheHome,{recursive:!0})}catch(g){(0,l.toFileOperationResult)(g)!==1&&this.t.error(g)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(o.location,{recursive:!0})}catch(g){this.t.error(g)}}async setProfileForWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=this.profiles.find(g=>g.id===o.id);if(!h)throw new Error(`Profile '${o.name}' does not exist`);this.G(i,h)}unsetWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,o)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(o=>o.isDirectory&&this.profiles.every(h=>!this.s.extUri.isEqual(h.location,o.resource))).map(o=>this.r.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(o=>!this.C(o));await Promise.allSettled(i.map(o=>this.removeProfile(o)))}getProfileForWorkspace(i){const o=this.z(i);return M.URI.isUri(o)?this.m.workspaces.get(o)??this.v.workspaces.get(o):this.m.emptyWindows.get(o)??this.v.emptyWindows.get(o)}z(i){return(0,v.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,v.isWorkspaceIdentifier)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,i.location))||[...this.m.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,i.location))||[...this.v.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,i.location))||[...this.v.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,i.location)))}D(i,o,h){const g=[...this.profiles,...i],D=[];this.m.profiles=[];for(let R of g)R.isDefault||o.some(S=>R.id===S.id)||(R=h.find(S=>R.id===S.id)??R,R.isTransient?this.m.profiles.push(R):D.push({location:R.location,name:R.name,shortName:R.shortName,useDefaultFlags:R.useDefaultFlags}));this.L(D),this.u=void 0,this.F(i,o,h)}F(i,o,h){this.h.fire({added:i,removed:o,updated:h,all:this.profiles})}G(i,o,h){h=o?.isTransient?!0:h,h||this.G(i,void 0,!0);const g=this.z(i),D=h?this.m:this.v;M.URI.isUri(g)?(D.workspaces.delete(g),o&&D.workspaces.set(g,o)):(D.emptyWindows.delete(g),o&&D.emptyWindows.set(g,o)),h||this.H()}H(){const i={};for(const[h,g]of this.v.workspaces.entries())i[h.toString()]=g.id;const o={};for(const[h,g]of this.v.emptyWindows.entries())o[h.toString()]=g.id;this.N({workspaces:i,emptyWindows:o}),this.u=void 0}I(i){const o={},h=this.w();if(i.workspaces)for(const[D,R]of Object.entries(i.workspaces)){const S=M.URI.parse(R);o[D]=this.s.extUri.isEqual(S,h.location)?h.id:this.s.extUri.basename(S)}const g={};if(i.emptyWindows)for(const[D,R]of Object.entries(i.emptyWindows)){const S=M.URI.parse(R);g[D]=this.s.extUri.isEqual(S,h.location)?h.id:this.s.extUri.basename(S)}return{workspaces:o,emptyWindows:g}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",e.UserDataProfilesService=t=ve([Z(0,f.IEnvironmentService),Z(1,l.IFileService),Z(2,b.IUriIdentityService),Z(3,m.ILogService)],t);class c extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.InMemoryUserDataProfilesService=c}),define(te[81],ie([0,1,7,17,2,4,35,8,115,122,16,6,5,41,40,11,13,26]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var a;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(a||(e.ExtensionsProfileScanningErrorCode=a={}));class d extends Error{constructor(n,i){super(n),this.code=i}}e.ExtensionsProfileScanningError=d,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let I=e.AbstractExtensionsProfileScannerService=class extends r.Disposable{constructor(n,i,o,h,g,D){super(),this.i=n,this.j=i,this.k=o,this.l=h,this.m=g,this.n=D,this.b=this.B(new O.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new O.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new M.ResourceMap}scanProfileExtensions(n,i){return this.p(n,void 0,i)}async addExtensionsToProfile(n,i){const o=[],h=[];try{return await this.p(i,g=>{const D=[];for(const R of g)n.some(([S])=>(0,l.areSameExtensions)(S.identifier,R.identifier)&&S.manifest.version!==R.version)?o.push(R):D.push(R);for(const[R,S]of n)if(!D.some(L=>(0,l.areSameExtensions)(L.identifier,R.identifier)&&L.version===R.manifest.version)){const L={identifier:R.identifier,version:R.manifest.version,location:R.location,metadata:S};h.push(L),D.push(L)}return h.length&&this.b.fire({extensions:h,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),D}),h.length&&this.c.fire({extensions:h,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),h}catch(g){throw h.length&&this.c.fire({extensions:h,error:g,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:g,profileLocation:i}),g}}async updateMetadata(n,i){const o=[];return await this.p(i,h=>{const g=[];for(const D of h){const R=n.find(([S])=>(0,l.areSameExtensions)(S.identifier,D.identifier)&&S.manifest.version===D.version);R&&(D.metadata={...D.metadata,...R[1]},o.push(D)),g.push(D)}return g}),o}async removeExtensionFromProfile(n,i){const o=[];this.f.fire({extensions:o,profileLocation:i});try{await this.p(i,h=>{const g=[];for(const D of h)(0,l.areSameExtensions)(D.identifier,n.identifier)?o.push(D):g.push(D);return o.length&&this.f.fire({extensions:o,profileLocation:i}),g}),o.length&&this.g.fire({extensions:o,profileLocation:i})}catch(h){throw o.length&&this.g.fire({extensions:o,error:h,profileLocation:i}),h}}async p(n,i,o){return this.w(n).queue(async()=>{let h=[],g;try{const D=await this.j.readFile(n);g=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,w.toFileOperationResult)(D)!==1)throw D;if(this.l.extUri.isEqual(n,this.k.defaultProfile.extensionsResource)&&(g=await this.v()),!g&&o?.bailOutWhenFileNotFound)throw new d((0,s.getErrorMessage)(D),"ERROR_PROFILE_NOT_FOUND")}if(g){Array.isArray(g)||this.r(n);let D=!1;for(const R of g){k(R)||this.r(n);let S;if((0,p.isString)(R.relativeLocation)&&R.relativeLocation)S=this.t(R.relativeLocation);else if((0,p.isString)(R.location))S=this.t(R.location),D=!0,R.relativeLocation=R.location,R.location=S.toJSON();else{S=P.URI.revive(R.location);const L=this.s(S);L&&(D=!0,R.relativeLocation=L)}h.push({identifier:R.identifier,location:S,version:R.version,metadata:R.metadata})}D&&await this.j.writeFile(n,A.VSBuffer.fromString(JSON.stringify(g)))}if(i){h=i(h);const D=h.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.s(R.location),metadata:R.metadata}));await this.j.writeFile(n,A.VSBuffer.fromString(JSON.stringify(D)))}return h})}r(n){const i=new d(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(n){return this.l.extUri.isEqual(this.l.extUri.dirname(n),this.i)?this.l.extUri.basename(n):void 0}t(n){return this.l.extUri.joinPath(this.i,n)}async v(){return this.u||(this.u=(async()=>{const n=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let o;try{o=(await this.j.readFile(n)).value.toString()}catch(g){if((0,w.toFileOperationResult)(g)===1)return;throw g}this.n.info("Migrating extensions from old default profile location",n.toString());let h;try{const g=JSON.parse(o);Array.isArray(g)&&g.every(D=>k(D))?h=g:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",g)}catch(g){this.n.error(g)}if(h)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify(h)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",n.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(g){if((0,w.toFileOperationResult)(g)===3)this.n.info("Migration from old default profile location to new location is done by another window",n.toString(),this.k.defaultProfile.extensionsResource.toString());else throw g}try{await this.j.del(n)}catch(g){(0,w.toFileOperationResult)(g)!==1&&this.n.error(g)}try{await this.j.del(i)}catch(g){(0,w.toFileOperationResult)(g)!==1&&this.n.error(g)}return h})()),this.u}w(n){let i=this.h.get(n);return i||(i=new E.Queue,this.h.set(n,i)),i}};e.AbstractExtensionsProfileScannerService=I=ve([Z(1,w.IFileService),Z(2,u.IUserDataProfilesService),Z(3,b.IUriIdentityService),Z(4,y.ITelemetryService),Z(5,v.ILogService)],I);function k(c){return(0,p.isObject)(c)&&(0,f.isIExtensionIdentifier)(c.identifier)&&(t(c.location)||(0,p.isString)(c.location)&&c.location)&&((0,p.isUndefined)(c.relativeLocation)||(0,p.isString)(c.relativeLocation))&&c.version&&(0,p.isString)(c.version)}function t(c){return c?(0,p.isString)(c.path)&&(0,p.isString)(c.scheme):!1}}),define(te[128],ie([0,1,24,7,37,17,13,44,149,2,14,9,3,18,203,72,11,8,170,33,122,119,202,16,6,5,23,4,73,81,41,40,201]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a,d,I,k,t,c,n,i,o,h,g,D,R,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var T;(function(le){function X(G,N){if(G===N)return!0;const F=Object.keys(G),V=new Set;for(const J of Object.keys(N))V.add(J);if(F.length!==V.size)return!1;for(const J of F){if(G[J]!==N[J])return!1;V.delete(J)}return V.size===0}le.equals=X})(T||(e.Translations=T={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let U=e.AbstractExtensionsScannerService=class extends l.Disposable{constructor(X,G,N,F,V,J,_,ae,oe,B,C,W){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=G,this.l=N,this.m=F,this.n=V,this.r=J,this.s=_,this.t=ae,this.u=oe,this.v=B,this.w=C,this.y=W,this.g=this.B(new h.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,u.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(Y,this.m,this.h)),this.j=this.B(this.y.createInstance(Y,this.m,this.h)),this.k=this.B(this.y.createInstance(re,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,I.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions(X,G,N){const[F,V]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(G)]),J=N?await this.scanExtensionsUnderDevelopment(X,[...F,...V]):[];return this.G(F,V,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const G=[];G.push(this.H(!!X.useCache,X.language)),G.push(this.I(X.language,!!X.checkControlFile));const[N,F]=await Promise.all(G);return this.F([...N,...F],0,X,!1)}async scanUserExtensions(X){const G=X.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",G);const N=this.w.extUri.isEqual(X.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.L(G,!!X.profileLocation,1,!X.includeUninstalled,X.language,!0,N),V=X.useCache&&!F.devMode&&F.excludeObsolete?this.j:this.k;let J;try{J=await V.scanExtensions(F)}catch(_){if(_ instanceof D.ExtensionsProfileScanningError&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),J=await V.scanExtensions(F);else throw _}return J=await this.F(J,1,X,!0),this.t.trace("Scanned user extensions:",J.length),J}async scanExtensionsUnderDevelopment(X,G){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const N=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(F=>F.scheme===w.Schemas.file).map(async F=>{const V=await this.L(F,!1,1,!0,X.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(V)).map(_=>(_.type=G.find(ae=>(0,I.areSameExtensions)(ae.identifier,_.identifier))?.type??_.type,this.k.validate(_,V)))}))).flat();return this.F(N,"development",X,!0)}return[]}async scanExistingExtension(X,G,N){const F=await this.L(X,!1,G,!0,N.language,!0,void 0),V=await this.k.scanExtension(F);return!V||!N.includeInvalid&&!V.isValid?null:V}async scanOneOrMultipleExtensions(X,G,N){const F=await this.L(X,!1,G,!0,N.language,!0,void 0),V=await this.k.scanOneOrMultipleExtensions(F);return this.F(V,G,N,!0)}async scanMetadata(X){const G=(0,u.joinPath)(X,"package.json"),N=(await this.s.readFile(G)).value.toString();return JSON.parse(N).__metadata}async updateMetadata(X,G){const N=(0,u.joinPath)(X,"package.json"),F=(await this.s.readFile(N)).value.toString(),V=JSON.parse(F);G.isMachineScoped=G.isMachineScoped||void 0,G.isBuiltin=G.isBuiltin||void 0,V.__metadata={...V.__metadata,...G},await this.s.writeFile((0,u.joinPath)(X,"package.json"),O.VSBuffer.fromString(JSON.stringify(V,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(X){if(X instanceof D.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw X}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const X=await this.scanUserExtensions({includeInvalid:!0});if(X.length)await this.r.addExtensionsToProfile(X.map(G=>[G,G.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify([])))}catch(G){(0,c.toFileOperationResult)(G)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,M.getErrorMessage)(G))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(X){this.t.error(X)}finally{this.C=void 0}})()),this.C}async F(X,G,N,F){return N.includeAllVersions||(X=this.G(G===0?X:void 0,G===1?X:void 0,G==="development"?X:void 0,await this.getTargetPlatform(),F)),N.includeInvalid||(X=X.filter(V=>V.isValid)),X.sort((V,J)=>{const _=m.basename(V.location.fsPath),ae=m.basename(J.location.fsPath);return _<ae?-1:_>ae?1:0})}G(X,G,N,F,V){const J=(ae,oe,B)=>{if(ae.isValid&&!oe.isValid)return!1;if(ae.isValid===oe.isValid){if(V&&b.gt(ae.manifest.version,oe.manifest.version))return this.t.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(b.eq(ae.manifest.version,oe.manifest.version)){if(ae.type===0)return this.t.debug(`Skipping extension ${oe.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===F)return this.t.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return B?this.t.warn(`Overwriting user extension ${ae.location.path} with ${oe.location.path}.`):this.t.debug(`Overwriting user extension ${ae.location.path} with ${oe.location.path}.`),!0},_=new k.ExtensionIdentifierMap;return X?.forEach(ae=>{const oe=_.get(ae.identifier.id);(!oe||J(oe,ae,!1))&&_.set(ae.identifier.id,ae)}),G?.forEach(ae=>{const oe=_.get(ae.identifier.id);if(!oe&&X&&ae.type===0){this.t.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!oe||J(oe,ae,!1))&&_.set(ae.identifier.id,ae)}),N?.forEach(ae=>{const oe=_.get(ae.identifier.id);(!oe||J(oe,ae,!0))&&_.set(ae.identifier.id,ae),_.set(ae.identifier.id,ae)}),[..._.values()]}async H(X,G){this.t.trace("Started scanning system extensions");const N=await this.L(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0),V=await(X&&!N.devMode?this.i:this.k).scanExtensions(N);return this.t.trace("Scanned system extensions:",V.length),V}async I(X,G){const N=this.u.isBuilt?[]:this.v.builtInExtensions;if(!N?.length)return[];this.t.trace("Started scanning dev system extensions");const F=G?await this.J():{},V=[],J=y.URI.file(m.normalize(m.join(w.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of N){const oe=F[ae.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":V.push((0,u.joinPath)(J,ae.name));break;default:V.push(y.URI.file(oe));break}}const _=await Promise.all(V.map(async ae=>this.k.scanExtension(await this.L(ae,!1,0,!0,X,!0,void 0))));return this.t.trace("Scanned dev system extensions:",_.length),(0,E.coalesce)(_)}async J(){try{const X=await this.s.readFile(this.l);return JSON.parse(X.value.toString())}catch{return{}}}async L(X,G,N,F,V,J,_){const ae=await this.f(V??v.language),oe=await this.M(X),B=G&&!this.w.extUri.isEqual(X,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,C=B?await this.M(B):void 0;return new H(X,oe,B,C,G,_,N,F,J,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,V,ae)}async M(X){try{const G=await this.s.stat(X);if(typeof G.mtime=="number")return G.mtime}catch{}}};e.AbstractExtensionsScannerService=U=ve([Z(4,R.IUserDataProfilesService),Z(5,D.IExtensionsProfileScannerService),Z(6,c.IFileService),Z(7,i.ILogService),Z(8,d.IEnvironmentService),Z(9,o.IProductService),Z(10,S.IUriIdentityService),Z(11,n.IInstantiationService)],U);class H{constructor(X,G,N,F,V,J,_,ae,oe,B,C,W,z,q,j){this.location=X,this.mtime=G,this.applicationExtensionslocation=N,this.applicationExtensionslocationMtime=F,this.profile=V,this.profileScanOptions=J,this.type=_,this.excludeObsolete=ae,this.validate=oe,this.productVersion=B,this.productDate=C,this.productCommit=W,this.devMode=z,this.language=q,this.translations=j}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,G){return(0,u.isEqual)(X.location,G.location)&&X.mtime===G.mtime&&(0,u.isEqual)(X.applicationExtensionslocation,G.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&X.profile===G.profile&&r.equals(X.profileScanOptions,G.profileScanOptions)&&X.type===G.type&&X.excludeObsolete===G.excludeObsolete&&X.validate===G.validate&&X.productVersion===G.productVersion&&X.productDate===G.productDate&&X.productCommit===G.productCommit&&X.devMode===G.devMode&&X.language===G.language&&T.equals(X.translations,G.translations)}}e.ExtensionScannerInput=H;let re=class extends l.Disposable{constructor(X,G,N,F,V){super(),this.f=X,this.g=G,this.h=N,this.i=F,this.j=V}async scanExtensions(X){const G=X.profile?await this.l(X):await this.k(X);let N={};if(X.excludeObsolete&&X.type===1)try{const F=(await this.i.readFile(this.f)).value.toString();N=JSON.parse(F)}catch{}return(0,s.isEmptyObject)(N)?G:G.filter(F=>!N[I.ExtensionKey.create(F).toString()])}async k(X){const G=await this.i.resolve(X.location);if(!G.children?.length)return[];const N=await Promise.all(G.children.map(async F=>{if(!F.isDirectory||X.type===1&&(0,u.basename)(F.resource).indexOf(".")===0)return null;const V=new H(F.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(V)}));return(0,E.coalesce)(N).sort((F,V)=>F.location.path<V.location.path?-1:1)}async l(X){let G=await this.m(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.h.extUri.isEqual(X.location,X.applicationExtensionslocation)){G=G.filter(F=>!F.metadata?.isApplicationScoped);const N=await this.m(X.applicationExtensionslocation,F=>!!F.metadata?.isBuiltin||!!F.metadata?.isApplicationScoped,X);G.push(...N)}return G}async m(X,G,N){const F=await this.g.scanProfileExtensions(X,N.profileScanOptions);if(!F.length)return[];const V=await Promise.all(F.map(async J=>{if(G(J)){const _=new H(J.location,N.mtime,N.applicationExtensionslocation,N.applicationExtensionslocationMtime,N.profile,N.profileScanOptions,N.type,N.excludeObsolete,N.validate,N.productVersion,N.productDate,N.productCommit,N.devMode,N.language,N.translations);return this.scanExtension(_,J.metadata)}return null}));return(0,E.coalesce)(V)}async scanOneOrMultipleExtensions(X){try{if(await this.i.exists((0,u.joinPath)(X.location,"package.json"))){const G=await this.scanExtension(X);return G?[G]:[]}else return await this.scanExtensions(X)}catch(G){return this.j.error(`Error scanning extensions at ${X.location.path}:`,(0,M.getErrorMessage)(G)),[]}}async scanExtension(X,G){try{let N=await this.scanExtensionManifest(X.location);if(N){N.publisher||(N.publisher=k.UNDEFINED_PUBLISHER),G=G??N.__metadata,delete N.__metadata;const F=(0,I.getGalleryExtensionId)(N.publisher,N.name),V=G?.id?{id:F,uuid:G.id}:{id:F},J=G?.isSystem?0:X.type,_=J===0||!!G?.isBuiltin;N=await this.n(X.location,N,H.createNlsConfiguration(X));const ae={type:J,identifier:V,manifest:N,location:X.location,isBuiltin:_,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return X.validate?this.validate(ae,X):ae}}catch(N){X.type!==0&&this.j.error(N)}return null}validate(X,G){let N=!0;const F=(0,t.validateExtensionManifest)(G.productVersion,G.productDate,G.location,X.manifest,X.isBuiltin);for(const[V,J]of F)V===p.default.Error&&(N=!1,this.j.error(this.u(G.location,J)));return X.isValid=N,X.validations=F,X}async scanExtensionManifest(X){const G=(0,u.joinPath)(X,"package.json");let N;try{N=(await this.i.readFile(G)).value.toString()}catch(V){return(0,c.toFileOperationResult)(V)!==1&&this.j.error(this.u(X,(0,a.localize)(0,null,G.path,V.message))),null}let F;try{F=JSON.parse(N)}catch{const J=[];(0,P.parse)(N,J);for(const _ of J)this.j.error(this.u(X,(0,a.localize)(1,null,G.path,_.offset,_.length,(0,f.getParseErrorMessage)(_.error))));return null}return(0,P.getNodeType)(F)!=="object"?(this.j.error(this.u(X,(0,a.localize)(2,null,G.path))),null):F}async n(X,G,N){const F=await this.r(X,G,N);if(F)try{const V=[],J=await this.s(F.default,V);if(V.length>0)return V.forEach(ae=>{this.j.error(this.u(X,(0,a.localize)(3,null,F.default?.path,(0,f.getParseErrorMessage)(ae.error))))}),G;if((0,P.getNodeType)(F)!=="object")return this.j.error(this.u(X,(0,a.localize)(4,null,F.default?.path))),G;const _=F.values||Object.create(null);return(0,L.localizeManifest)(G,_,J)}catch{}return G}async r(X,G,N){const F=(0,u.joinPath)(X,"package.nls.json"),V=(oe,B)=>{B.forEach(C=>{this.j.error(this.u(X,(0,a.localize)(5,null,oe?.path,(0,f.getParseErrorMessage)(C.error))))})},J=oe=>{this.j.error(this.u(X,(0,a.localize)(6,null,oe?.path)))},_=`${G.publisher}.${G.name}`,ae=N.translations[_];if(ae)try{const oe=y.URI.file(ae),B=(await this.i.readFile(oe)).value.toString(),C=[],W=(0,P.parse)(B,C);return C.length>0?(V(oe,C),{values:void 0,default:F}):(0,P.getNodeType)(W)!=="object"?(J(oe),{values:void 0,default:F}):{values:W.contents?W.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.i.exists(F))return;let B;try{B=await this.t(X,N)}catch{return}if(!B.localized)return{values:void 0,default:B.original};try{const C=(await this.i.readFile(B.localized)).value.toString(),W=[],z=(0,P.parse)(C,W);return W.length>0?(V(B.localized,W),{values:void 0,default:B.original}):(0,P.getNodeType)(z)!=="object"?(J(B.localized),{values:void 0,default:B.original}):{values:z,default:B.original}}catch{return{values:void 0,default:B.original}}}}async s(X,G){if(X)try{const N=(await this.i.readFile(X)).value.toString();return(0,P.parse)(N,G)}catch{}}t(X,G){return new Promise((N,F)=>{const V=J=>{const _=(0,u.joinPath)(X,`package.nls.${J}.json`);this.i.exists(_).then(ae=>{ae&&N({localized:_,original:(0,u.joinPath)(X,"package.nls.json")});const oe=J.lastIndexOf("-");oe===-1?N({localized:(0,u.joinPath)(X,"package.nls.json"),original:null}):(J=J.substring(0,oe),V(J))})};if(G.devMode||G.pseudo||!G.language)return N({localized:(0,u.joinPath)(X,"package.nls.json"),original:null});V(G.language)})}u(X,G){return`[${X.path}]: ${G}`}};re=ve([Z(1,D.IExtensionsProfileScannerService),Z(2,S.IUriIdentityService),Z(3,c.IFileService),Z(4,i.ILogService)],re);let Y=class extends re{constructor(X,G,N,F,V,J,_){super(G,F,V,J,_),this.z=X,this.C=N,this.w=this.B(new A.ThrottledDelayer(3e3)),this.y=this.B(new h.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions(X){const G=this.H(X),N=await this.D(G);if(this.v=X,N&&N.input&&H.equals(N.input,this.v))return this.j.debug("Using cached extensions scan result",X.location.toString()),this.w.trigger(()=>this.G()),N.result.map(V=>(V.location=y.URI.revive(V.location),V));const F=await super.scanExtensions(X);return await this.F(G,{input:X,result:F}),F}async D(X){try{const G=await this.i.readFile(X),N=JSON.parse(G.value.toString());return{result:N.result,input:(0,g.revive)(N.input)}}catch(G){this.j.debug("Error while reading the extension cache file:",X.path,(0,M.getErrorMessage)(G))}return null}async F(X,G){try{await this.i.writeFile(X,O.VSBuffer.fromString(JSON.stringify(G)))}catch(N){this.j.debug("Error while writing the extension cache file:",X.path,(0,M.getErrorMessage)(N))}}async G(){if(!this.v)return;const X=this.H(this.v),G=await this.D(X);if(!G)return;const N=G.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!r.equals(F,N))try{this.j.info("Invalidating Cache",N,F),await this.i.del(X),this.y.fire()}catch(V){this.j.error(V)}}H(X){const G=this.I(X);return this.h.extUri.joinPath(G.cacheHome,X.type===0?k.BUILTIN_MANIFEST_CACHE_FILE:k.USER_MANIFEST_CACHE_FILE)}I(X){return X.type===0?this.C.defaultProfile:X.profile?this.h.extUri.isEqual(X.location,this.z.extensionsResource)?this.z:this.C.profiles.find(G=>this.h.extUri.isEqual(X.location,G.extensionsResource))??this.z:this.C.defaultProfile}};Y=ve([Z(2,R.IUserDataProfilesService),Z(3,D.IExtensionsProfileScannerService),Z(4,S.IUriIdentityService),Z(5,c.IFileService),Z(6,i.ILogService)],Y);function ne(le,X){const G=(0,I.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:G,identifier:new k.ExtensionIdentifier(G),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:X,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}e.toExtensionDescription=ne;class ce extends U{constructor(X,G,N,F,V,J,_,ae,oe,B,C,W){super(X,G,(0,u.joinPath)(N,".vscode-oss-dev","extensions","control.json"),F,V,J,_,ae,oe,B,C,W),this.N=(async()=>{if(v.translationsConfigFile)try{const z=await this.s.readFile(y.URI.file(v.translationsConfigFile));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(X){return this.N}}e.NativeExtensionsScannerService=ce}),define(te[277],ie([0,1,5,41,40,26,81,16,33,8]),function(x,e,E,A,r,O,M,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let w=e.ExtensionsProfileScannerService=class extends M.AbstractExtensionsProfileScannerService{constructor(v,u,b,p,s,y){super(l.URI.file(v.extensionsPath),u,b,p,s,y)}};e.ExtensionsProfileScannerService=w=ve([Z(0,f.INativeEnvironmentService),Z(1,P.IFileService),Z(2,A.IUserDataProfilesService),Z(3,r.IUriIdentityService),Z(4,O.ITelemetryService),Z(5,E.ILogService)],w)}),define(te[278],ie([0,1,8,33,81,128,16,6,5,23,40,41]),function(x,e,E,A,r,O,M,P,f,l,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let v=e.ExtensionsScannerService=class extends O.NativeExtensionsScannerService{constructor(b,p,s,y,a,d,I,k){super(E.URI.file(a.builtinExtensionsPath),E.URI.file(a.extensionsPath),a.userHome,b.defaultProfile,b,p,s,y,a,d,I,k)}};e.ExtensionsScannerService=v=ve([Z(0,m.IUserDataProfilesService),Z(1,r.IExtensionsProfileScannerService),Z(2,M.IFileService),Z(3,f.ILogService),Z(4,A.INativeEnvironmentService),Z(5,l.IProductService),Z(6,w.IUriIdentityService),Z(7,P.IInstantiationService)],v)}),define(te[279],ie([0,1,15,2,14,9,3,62,8,31,38,33,5,41]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let b=e.ProtocolMainService=class extends A.Disposable{constructor(s,y,a){super(),this.c=s,this.f=a,this.a=P.TernarySearchTree.forPaths(!M.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(s.appRoot),this.addValidFileRoot(s.extensionsPath),this.addValidFileRoot(y.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(s.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:s}=E.session;s.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(y,a)=>this.i(y,a)),s.protocol.interceptFileProtocol(r.Schemas.file,(y,a)=>this.h(y,a)),this.B((0,A.toDisposable)(()=>{s.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),s.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(s){const y=(0,O.normalize)(s);return this.a.get(y)?A.Disposable.None:(this.a.set(y,!0),(0,A.toDisposable)(()=>this.a.delete(y)))}h(s,y){const a=f.URI.parse(s.url);return this.f.error(`Refused to load resource ${a.fsPath} from ${r.Schemas.file}: protocol (original URL: ${s.url})`),y({error:-3})}i(s,y){const a=this.j(s);let d;return this.c.crossOriginIsolated&&((0,O.basename)(a)==="workbench.html"||(0,O.basename)(a)==="workbench-dev.html"?d=r.COI.CoopAndCoep:d=r.COI.getHeadersFromQuery(s.url)),this.a.findSubstr(a)?y({path:a,headers:d}):this.b.has((0,O.extname)(a).toLowerCase())?y({path:a}):(this.f.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${a} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${s.url})`),y({error:-3}))}j(s){const y=f.URI.parse(s.url),a=r.FileAccess.uriToFileUri(y);return(0,O.normalize)(a.fsPath)}createIPCObjectUrl(){let s;const y=f.URI.from({scheme:"vscode",path:(0,l.generateUuid)()}),a=y.toString(),d=async()=>s;return w.validatedIpcMain.handle(a,d),this.f.trace(`IPC Object URL: Registered new channel ${a}.`),{resource:y,update:I=>s=I,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${a}.`),w.validatedIpcMain.removeHandler(a)}}}};e.ProtocolMainService=b=ve([Z(0,m.INativeEnvironmentService),Z(1,u.IUserDataProfilesService),Z(2,v.ILogService)],b)}),define(te[95],ie([0,1,7,4,2,65,11,110,6,41]),function(x,e,E,A,r,O,M,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var w;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(w||(e.WillSaveStateReason=w={}));var m;(function(a){a[a.APPLICATION=-1]="APPLICATION",a[a.PROFILE=0]="PROFILE",a[a.WORKSPACE=1]="WORKSPACE"})(m||(e.StorageScope=m={}));var v;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function u(a){const d=a.get(e.TARGET_KEY);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.loadKeyTargets=u;class b extends r.Disposable{constructor(d={flushInterval:b.a}){super(),this.j=d,this.b=this.B(new A.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new A.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new r.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,r.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.J()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(d,I){if(I===e.TARGET_KEY){switch(d){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:I,target:this.F(d)[I]})}r(d){this.f.fire({reason:d})}get(d,I,k){return this.L(I)?.get(d,k)}getBoolean(d,I,k){return this.L(I)?.getBoolean(d,k)}getNumber(d,I,k){return this.L(I)?.getNumber(d,k)}getObject(d,I,k){return this.L(I)?.getObject(d,k)}store(d,I,k,t){if((0,M.isUndefinedOrNull)(I)){this.remove(d,k);return}this.t(()=>{this.u(d,k,t),this.L(k)?.set(d,I)})}remove(d,I){this.t(()=>{this.u(d,I,void 0),this.L(I)?.delete(d)})}t(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,I){const k=[],t=this.F(d);for(const c of Object.keys(t))t[c]===I&&k.push(c);return k}u(d,I,k){const t=this.F(I);typeof k=="number"?t[d]!==k&&(t[d]=k,this.L(I)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[d]=="number"&&(delete t[d],this.L(I)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(d){switch(d){case-1:return this.D;case 0:return this.z;default:return this.w}}G(d){const I=this.L(d);return I?u(I):Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=w.NONE){this.f.fire({reason:d});const I=this.L(-1),k=this.L(0),t=this.L(1);switch(d){case w.NONE:await E.Promises.settled([I?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await E.Promises.settled([I?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.L(-1)?.items??new Map,I=this.L(0)?.items??new Map,k=this.L(1)?.items??new Map;return y(d,I,k,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(d,I){return this.r(w.NONE),(0,l.isUserDataProfile)(d)?this.N(d,I):this.O(d,I)}H(d,I){return!(d.id===I.id||p(I)&&p(d))}I(d,I,k,t){this.t(()=>{if(t)for(const[c,n]of d)I.set(c,n);else{const c=new Set;for(const[n,i]of d)c.add(n),I.get(n)!==i&&this.n(k,n);for(const[n]of I.items)c.has(n)||this.n(k,n)}})}}e.AbstractStorageService=b,b.a=60*1e3;function p(a){return a.isDefault||!!a.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class s extends b{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(d=>this.n(1,d))),this.B(this.P.onDidChangeStorage(d=>this.n(0,d))),this.B(this.p.onDidChangeStorage(d=>this.n(-1,d)))}L(d){switch(d){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(d){return!1}}e.InMemoryStorageService=s;async function y(a,d,I,k,t,c){const n=T=>{try{return JSON.parse(T)}catch{return T}},i=new Map,o=new Map;a.forEach((T,U)=>{i.set(U,T),o.set(U,n(T))});const h=new Map,g=new Map;d.forEach((T,U)=>{h.set(U,T),g.set(U,n(T))});const D=new Map,R=new Map;I.forEach((T,U)=>{D.set(U,T),R.set(U,n(T))}),console.group(k!==t?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const S=[];if(i.forEach((T,U)=>{S.push({key:U,value:T})}),console.table(S),console.groupEnd(),console.log(o),k!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const T=[];h.forEach((U,H)=>{T.push({key:H,value:U})}),console.table(T),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${c})`);const L=[];D.forEach((T,U)=>{L.push({key:U,value:T})}),console.table(L),console.groupEnd(),console.log(R)}e.logStorage=y}),define(te[280],ie([0,1,24,7,4,2,9,85,8,22,110,159,5,95,26,29]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class s extends O.Disposable{get storage(){return this.f}constructor(c,n){super(),this.j=c,this.k=n,this.b=this.B(new r.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new r.Emitter),this.onDidCloseStorage=this.c.event,this.f=new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new A.DeferredPromise,this.whenInit=this.h.p,this.i=w.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===w.StorageState.None)try{const c=await this.n();this.f.dispose(),this.f=c,this.B(c.onDidChangeStorage(i=>this.b.fire({key:i}))),await this.m(c);const n=c.getBoolean(u.IS_NEW_KEY);n===void 0?c.set(u.IS_NEW_KEY,!0):n&&c.set(u.IS_NEW_KEY,!1)}catch(c){this.j.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.i=w.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===v.LogLevel.Trace?c=>this.j.trace(c):void 0,logError:c=>this.j.error(c)}}m(c){return c.init()}get items(){return this.f.items}get(c,n){return this.f.get(c,n)}set(c,n){return this.f.set(c,n)}delete(c){return this.f.delete(c)}async close(){const c=new P.StopWatch(!1);await this.s(),c.stop(),c.elapsed()>s.a&&await this.r(c),this.c.fire()}async r(c){if(this.path)try{const n=(0,E.top)(Array.from(this.f.items.entries()).map(([o,h])=>({key:o,length:h.length})),(o,h)=>h.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),i=(await this.k.stat(f.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${i}b, Large Keys: ${n}`)}catch(n){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async s(){this.g&&await this.g,this.i=w.StorageState.Closed,await this.f.close()}}s.a=2e3;class y extends s{get path(){if(!this.v.useInMemoryStorage)return(0,M.join)(this.u.globalStorageHome.fsPath,y.t)}constructor(c,n,i,o){super(i,o),this.u=c,this.v=n}async n(){return new w.Storage(new m.SQLiteStorageDatabase(this.path??m.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:w.StorageHint.STORAGE_IN_MEMORY})}}y.t="state.vscdb";class a extends y{constructor(c,n,i,o){super(c,n,i,o)}}e.ProfileStorageMain=a;class d extends y{constructor(c,n,i,o){super(n.defaultProfile,c,i,o)}async m(c){await super.m(c),this.z(c)}z(c){c.get(b.firstSessionDateStorageKey,void 0)===void 0&&c.set(b.firstSessionDateStorageKey,new Date().toUTCString());const i=c.get(b.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();c.set(b.lastSessionDateStorageKey,typeof i>"u"?null:i),c.set(b.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=d;class I extends s{get path(){if(!this.w.useInMemoryStorage)return(0,M.join)(this.y.workspaceStorageHome.fsPath,this.v.id,I.t)}constructor(c,n,i,o,h){super(i,h),this.v=c,this.w=n,this.y=o}async n(){const{storageFilePath:c,wasCreated:n}=await this.C();return new w.Storage(new m.SQLiteStorageDatabase(c,{logging:this.l()}),{hint:this.w.useInMemoryStorage?w.StorageHint.STORAGE_IN_MEMORY:n?w.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:m.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const c=(0,M.join)(this.y.workspaceStorageHome.fsPath,this.v.id),n=(0,M.join)(c,I.t);return await l.Promises.exists(c)?{storageFilePath:n,wasCreated:!1}:(await l.Promises.mkdir(c,{recursive:!0}),this.D(c),{storageFilePath:n,wasCreated:!0})}async D(c){let n;if((0,p.isSingleFolderWorkspaceIdentifier)(this.v)?n={folder:this.v.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.v)&&(n={workspace:this.v.configPath.toString()}),n)try{const i=(0,M.join)(c,I.u);await l.Promises.exists(i)||await l.Promises.writeFile(i,JSON.stringify(n,void 0,2))}catch(i){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${i}`)}}}e.WorkspaceStorageMain=I,I.t="state.vscdb",I.u="workspace.json";class k extends s{get path(){}async n(){return new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=k}),define(te[281],ie([0,1,4,2,95]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class O extends A.Disposable{constructor(P,f,l){super(),this.b=P,this.c=f,this.f=l;const w=this.B(new A.MutableDisposable);this.a=this.B(new E.Emitter({onWillAddFirstListener:()=>w.value=this.g(),onDidRemoveLastListener:()=>w.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new A.DisposableStore;return P.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,l)=>(f?f.push(l.key):f=[l.key],f),100)(f=>this.h(f))),P.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(f,l)=>{f||(f=new Map);let w=f.get(l.profile.id);return w||f.set(l.profile.id,w={profile:l.profile,keys:[],storage:l.storage}),w.keys.push(l.key),f},100)(f=>this.i(f))),P}h(P){const f=P.includes(r.TARGET_KEY)?[this.c.defaultProfile]:[],l=[];if(P=P.filter(w=>w!==r.TARGET_KEY),P.length){const w=(0,r.loadKeyTargets)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:P.map(m=>({key:m,scope:0,target:w[m]}))})}this.j(f,l)}i(P){const f=[],l=new Map;for(const[w,m]of P.entries()){m.keys.includes(r.TARGET_KEY)&&f.push(m.profile);const v=m.keys.filter(u=>u!==r.TARGET_KEY);if(v.length){const u=(0,r.loadKeyTargets)(m.storage.storage);l.set(w,{profile:m.profile,changes:v.map(b=>({key:b,scope:0,target:u[b]}))})}}this.j(f,[...l.values()])}j(P,f){(P.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:P})}listen(P,f,l){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(P,f){throw new Error(`Call not found: ${f}`)}}e.ProfileStorageChangesListenerChannel=O}),define(te[282],ie([0,1,8,33,16,5,34,40,41,11,120]),function(x,e,E,A,r,O,M,P,f,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let m=e.UserDataProfilesReadonlyService=class dt extends f.UserDataProfilesService{constructor(p,s,y,a,d){super(y,a,s,d),this.P=p,this.Q=y}J(){return this.P.getItem(dt.b,[]).map(s=>({...s,location:(0,l.isString)(s.location)?this.s.extUri.joinPath(this.profilesHome,s.location):E.URI.revive(s.location)}))}M(){const p=this.P.getItem(dt.c,{});return this.P.getItem(dt.a,!1)?p:this.I(p)}O(){return this.s.extUri.joinPath(E.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};m.a="profileAssociationsMigration",e.UserDataProfilesReadonlyService=m=ve([Z(0,M.IStateReadService),Z(1,P.IUriIdentityService),Z(2,A.INativeEnvironmentService),Z(3,r.IFileService),Z(4,O.ILogService)],m);let v=e.UserDataProfilesService=class st extends m{constructor(p,s,y,a,d){super(p,s,y,a,d),this.W=p}L(p){p.length?this.W.setItem(st.b,p.map(s=>({...s,location:this.s.extUri.basename(s.location)}))):this.W.removeItem(st.b)}J(){const p=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(p),this.W.setItem("userDataProfilesMigration",!0)),p}N(p){p.emptyWindows||p.workspaces?this.W.setItem(st.c,p):this.W.removeItem(st.c)}M(){const p="workspaceAndProfileInfo",s=this.W.getItem(p,void 0);if(s){this.W.removeItem(p);const a=s.reduce((d,{workspace:I,profile:k})=>(d[E.URI.revive(I).toString()]=E.URI.revive(k).toString(),d),{});this.W.setItem(st.c,{workspaces:a})}const y=super.M();return this.W.getItem(st.a,!1)||(this.N(y),this.W.setItem(st.a,!0)),y}};e.UserDataProfilesService=v=ve([Z(0,M.IStateService),Z(1,P.IUriIdentityService),Z(2,A.INativeEnvironmentService),Z(3,r.IFileService),Z(4,O.ILogService)],v);let u=e.ServerUserDataProfilesService=class extends v{constructor(p,s,y,a){super(new w.StateService(0,s,a,y),p,s,y,a)}async init(){return await this.W.init(),super.init()}};e.ServerUserDataProfilesService=u=ve([Z(0,P.IUriIdentityService),Z(1,A.INativeEnvironmentService),Z(2,r.IFileService),Z(3,O.ILogService)],u)}),define(te[53],ie([0,1,33,16,6,5,40,41,282,34]),function(x,e,E,A,r,O,M,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,r.refineServiceDecorator)(P.IUserDataProfilesService);let w=e.UserDataProfilesMainService=class extends f.UserDataProfilesService{constructor(v,u,b,p,s){super(v,u,b,p,s)}getAssociatedEmptyWindows(){const v=[];for(const u of this.v.emptyWindows.keys())v.push({id:u});return v}};e.UserDataProfilesMainService=w=ve([Z(0,l.IStateService),Z(1,M.IUriIdentityService),Z(2,E.INativeEnvironmentService),Z(3,A.IFileService),Z(4,O.ILogService)],w)}),define(te[129],ie([0,1,18,8,29]),function(x,e,E,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function O(f,l,w){for(const v of f){const u=v.openedWorkspace;if((0,r.isWorkspaceIdentifier)(u)){const b=await w(u);if(b){if(b.folders.some(p=>E.extUriBiasedIgnorePathCase.isEqualOrParent(l,p.uri)))return v}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(l,u.configPath))return v}}const m=f.filter(v=>(0,r.isSingleFolderWorkspaceIdentifier)(v.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(l,v.openedWorkspace.uri));if(m.length)return m.sort((v,u)=>-(v.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=O;function M(f,l){for(const w of f)if((0,r.isWorkspaceIdentifier)(w.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(w.openedWorkspace.configPath,l)||(0,r.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(w.openedWorkspace.uri,l))return w}e.findWindowOnWorkspaceOrFolder=M;function P(f,l){const w=m=>l.some(v=>E.extUriBiasedIgnorePathCase.isEqual(A.URI.file(v),A.URI.file(m)));for(const m of f)if(m.config?.extensionDevelopmentPath?.some(v=>w(v)))return m}e.findWindowOnExtensionDevelopmentPath=P}),define(te[96],ie([0,1,32,44,136,45,14,9,3,18,8,6,58,29]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function b(R){return R.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function p(R){return R.hasOwnProperty("folderUri")}e.isRecentFolder=p;function s(R){return R.hasOwnProperty("fileUri")}e.isRecentFile=s;function y(R){return a(R)||d(R)}e.isStoredWorkspaceFolder=y;function a(R){const S=R;return typeof S?.path=="string"&&(!S.name||typeof S.name=="string")}function d(R){const S=R;return typeof S?.uri=="string"&&(!S.name||typeof S.name=="string")}function I(R,S,L,T,U){if(R.scheme!==T.scheme)return{name:L,uri:R.toString(!0)};let H=S?void 0:U.relativePath(T,R);if(H!==void 0)H.length===0?H=".":f.isWindows&&(H=k(H));else if(R.scheme===M.Schemas.file)H=R.fsPath,f.isWindows&&(H=k(H));else if(U.isEqualAuthority(R.authority,T.authority))H=R.path;else return{name:L,uri:R.toString(!0)};return{name:L,path:H}}e.getStoredWorkspaceFolder=I;function k(R){return R=(0,O.normalizeDriveLetter)(R),(0,E.isUNC)(R)||(R=(0,E.toSlashes)(R)),R}function t(R,S,L){const T=[],U=new Set,H=L.dirname(S);for(const re of R){let Y;if(a(re))re.path&&(Y=L.resolvePath(H,re.path));else if(d(re))try{Y=w.URI.parse(re.uri),Y.path[0]!==P.posix.sep&&(Y=Y.with({path:P.posix.sep+Y.path}))}catch(ne){console.warn(ne)}if(Y){const ne=L.getComparisonKey(Y);if(!U.has(ne)){U.add(ne);const ce=re.name||L.basenameOrAuthority(Y);T.push(new u.WorkspaceFolder({uri:Y,name:ce,index:T.length},re))}}}return T}e.toWorkspaceFolders=t;function c(R,S,L,T,U){const H=n(S,R),re=U.dirname(S),Y=U.dirname(T),ne=[];for(const G of H.folders){const N=a(G)?U.resolvePath(re,G.path):w.URI.parse(G.uri);let F;L?F=!1:F=!a(G)||(0,P.isAbsolute)(G.path),ne.push(I(N,F,G.name,Y,U))}const ce={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},le=r.setProperty(R,["folders"],ne,ce);let X=r.applyEdits(R,le);return(0,l.isEqualAuthority)(H.remoteAuthority,(0,v.getRemoteAuthority)(T))&&(X=r.applyEdits(X,r.removeProperty(X,["remoteAuthority"],ce))),X}e.rewriteWorkspaceFileForNewLocation=c;function n(R,S){const L=A.parse(S);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(T=>y(T));else throw new Error(`${R} looks like an invalid workspace file.`);return L}function i(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function o(R){return typeof R.folderUri=="string"}function h(R){return typeof R.fileUri=="string"}function g(R,S){const L={workspaces:[],files:[]};if(R){const T=function(H,re){for(let Y=0;Y<H.length;Y++)try{re(H[Y],Y)}catch(ne){S.warn(`Error restoring recent entry ${JSON.stringify(H[Y])}: ${ne.toString()}. Skip entry.`)}},U=R;Array.isArray(U.entries)&&T(U.entries,H=>{const re=H.label,Y=H.remoteAuthority;i(H)?L.workspaces.push({label:re,remoteAuthority:Y,workspace:{id:H.workspace.id,configPath:w.URI.parse(H.workspace.configPath)}}):o(H)?L.workspaces.push({label:re,remoteAuthority:Y,folderUri:w.URI.parse(H.folderUri)}):h(H)&&L.files.push({label:re,remoteAuthority:Y,fileUri:w.URI.parse(H.fileUri)})})}return L}e.restoreRecentlyOpened=g;function D(R){const S={entries:[]};for(const L of R.workspaces)p(L)?S.entries.push({folderUri:L.folderUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority}):S.entries.push({workspace:{id:L.workspace.id,configPath:L.workspace.configPath.toString()},label:L.label,remoteAuthority:L.remoteAuthority});for(const L of R.files)S.entries.push({fileUri:L.fileUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority});return S}e.toStoreData=D}),define(te[97],ie([0,1,70,14,3,18]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function M(l){function w(){let m=l.scheme===A.Schemas.file?(0,O.originalFSPath)(l):l.toString();return r.isLinux||(m=m.toLowerCase()),(0,E.createHash)("md5").update(m).digest("hex")}return{id:w(),configPath:l}}e.getWorkspaceIdentifier=M;function P(l,w){function m(){if(l.scheme!==A.Schemas.file)return(0,E.createHash)("md5").update(l.toString()).digest("hex");if(!w)return;let u;return r.isLinux?u=w.ino:r.isMacintosh?u=w.birthtime.getTime():r.isWindows&&(typeof w.birthtimeMs=="number"?u=Math.floor(w.birthtimeMs):u=w.birthtime.getTime()),(0,E.createHash)("md5").update(l.fsPath).update(u?String(u):"").digest("hex")}const v=m();if(typeof v=="string")return{id:v,uri:l}}e.getSingleFolderWorkspaceIdentifier=P;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=f}),define(te[130],ie([0,1,70,84,27,283,17,13,4,2,9,3,31,43,108]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{traceSocketEvent(S,L){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,L)}constructor(S,L=""){this.f=!0,this.debugLabel=L,this.socket=S,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=T=>{if(this.traceSocketEvent("error",{code:T?.code,message:T?.message}),T){if(T.code==="EPIPE")return;(0,P.onUnexpectedError)(T)}},this.socket.on("error",this.a),this.b=T=>{this.traceSocketEvent("close",{hadError:T}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const L=T=>{this.traceSocketEvent("read",T),S(M.VSBuffer.wrap(T))};return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(S){const L=T=>{S({type:0,hadError:T,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(S){const L=()=>{S()};return this.socket.on("end",L),{dispose:()=>this.socket.off("end",L)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",S),this.socket.write(S.buffer,L=>{if(L){if(L.code==="EPIPE")return;(0,P.onUnexpectedError)(L)}})}catch(L){if(L.code==="EPIPE")return;(0,P.onUnexpectedError)(L)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((S,L)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),S();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent("nodeDrainEnd"),S()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=p;var s;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize",R[R.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(s||(s={}));var y;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})(y||(y={}));class a extends l.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,L){this.socket.traceSocketEvent(S,L)}constructor(S,L,T,U){super(),this.f=this.B(new f.Emitter),this.g=this.B(new f.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=S,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:L,inflateBytesLength:T?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new d(this,L,T,U,this.f,(H,re)=>this.k(H,re))),this.B(this.a.onError(H=>{console.error(H),(0,P.onUnexpectedError)(H),this.g.fire({type:0,hadError:!0,error:H})})),this.b=new b.ChunkStream,this.B(this.socket.onData(H=>this.l(H))),this.B(this.socket.onClose(async H=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(H)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let L=0;for(;L<S.byteLength;)this.a.writeMessage(S.slice(L,Math.min(L+262144,S.byteLength))),L+=262144}k(S,L){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",S);let T=2;S.byteLength<126?T+=0:S.byteLength<2**16?T+=2:T+=8;const U=M.VSBuffer.alloc(T);if(L?U.writeUInt8(194,0):U.writeUInt8(130,0),S.byteLength<126)U.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){U.writeUInt8(126,1);let H=1;U.writeUInt8(S.byteLength>>>8&255,++H),U.writeUInt8(S.byteLength>>>0&255,++H)}else{U.writeUInt8(127,1);let H=1;U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(S.byteLength>>>24&255,++H),U.writeUInt8(S.byteLength>>>16&255,++H),U.writeUInt8(S.byteLength>>>8&255,++H),U.writeUInt8(S.byteLength>>>0&255,++H)}this.socket.write(M.VSBuffer.concat([U,S]))}end(){this.h=!0,this.socket.end()}l(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const L=this.b.peek(this.j.readLen),T=L.readUInt8(0),U=(T&128)>>>7,H=(T&64)>>>6,re=L.readUInt8(1),Y=(re&128)>>>7,ne=re&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(ne===126?2:0)+(ne===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!H),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const L=this.b.read(this.j.readLen),T=L.readUInt8(1),U=(T&128)>>>7;let H=T&127,re=1;H===126?H=L.readUInt8(++re)*2**8+L.readUInt8(++re):H===127&&(H=L.readUInt8(++re)*0+L.readUInt8(++re)*0+L.readUInt8(++re)*0+L.readUInt8(++re)*0+L.readUInt8(++re)*2**24+L.readUInt8(++re)*2**16+L.readUInt8(++re)*2**8+L.readUInt8(++re));let Y=0;U&&(Y=L.readUInt8(++re)*2**24+L.readUInt8(++re)*2**16+L.readUInt8(++re)*2**8+L.readUInt8(++re)),this.j.state=3,this.j.readLen=H,this.j.mask=Y,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const L=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",L),t(L,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",L),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(L,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=a;class d extends l.Disposable{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.VSBuffer.alloc(0)}constructor(S,L,T,U,H,re){super(),this.l=S,this.m=H,this.n=re,this.a=this.B(new f.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new f.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,L?(this.b=this.B(new I(this.l,U,T,{windowBits:15})),this.f=this.B(new k(this.l,{windowBits:15})),this.B(this.b.onError(Y=>this.a.fire(Y))),this.B(this.f.onError(Y=>this.a.fire(Y)))):(this.b=null,this.f=null)}writeMessage(S){this.g.push(S),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const S=this.g.shift();if(this.f){const L=await this.s(this.f,S);this.n(L,!0)}else this.n(S,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(S,L){return new Promise((T,U)=>{S.write(L),S.flush(H=>T(H))})}acceptFrame(S,L,T){this.h.push({data:S,isCompressed:L,isLastFrameOfMessage:T}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const L=await this.w(this.b,S.data,S.isLastFrameOfMessage);this.m.fire(L)}else this.m.fire(S.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(S,L,T){return new Promise((U,H)=>{S.write(L),T&&S.write(M.VSBuffer.fromByteArray([0,0,255,255])),S.flush(re=>U(re))})}}class I extends l.Disposable{get recordedInflateBytes(){return this.j?M.VSBuffer.concat(this.f):M.VSBuffer.alloc(0)}constructor(S,L,T,U){super(),this.h=S,this.j=L,this.a=this.B(new f.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(U),this.b.on("error",H=>{this.h.traceSocketEvent("zlibInflateError",{message:H?.message,code:H?.code}),this.a.fire(H)}),this.b.on("data",H=>{this.h.traceSocketEvent("zlibInflateData",H),this.g.push(M.VSBuffer.wrap(H))}),T&&(this.h.traceSocketEvent("zlibInflateInitialWrite",T.buffer),this.b.write(T.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent("zlibInflateWrite",S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const L=M.VSBuffer.concat(this.g);this.g.length=0,S(L)})}}class k extends l.Disposable{constructor(S,L){super(),this.g=S,this.a=this.B(new f.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",T=>{this.g.traceSocketEvent("zlibDeflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.g.traceSocketEvent("zlibDeflateData",T),this.f.push(M.VSBuffer.wrap(T))})}write(S){this.g.traceSocketEvent("zlibDeflateWrite",S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let L=M.VSBuffer.concat(this.f);this.f.length=0,L=L.slice(0,L.byteLength-4),S(L)})}}function t(R,S){if(S===0)return;const L=R.byteLength>>>2;for(let ne=0;ne<L;ne++){const ce=R.readUInt32BE(ne*4);R.writeUInt32BE(ce^S,ne*4)}const T=L*4,U=R.byteLength-T,H=S>>>24&255,re=S>>>16&255,Y=S>>>8&255;U>=1&&R.writeUInt8(R.readUInt8(T)^H,T),U>=2&&R.writeUInt8(R.readUInt8(T+1)^re,T+1),U>=3&&R.writeUInt8(R.readUInt8(T+2)^Y,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function n(){const R=(0,v.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;const S=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,r.tmpdir)(),L=(0,w.join)(S,`vscode-ipc-${R}.sock`);return o(L),L}e.createRandomIPCHandle=n;function i(R,S,L){const T=(0,E.createHash)("md5").update(R).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${L}-${S}-sock`;const U=L.substr(0,4),H=S.substr(0,6),re=T.substr(0,8);let Y;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Y=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${re}-${U}-${H}.sock`):Y=(0,w.join)(R,`${U}-${H}.sock`),o(Y),Y}e.createStaticIPCHandle=i;function o(R){const S=c[m.platform];typeof S=="number"&&R.length>=S&&console.warn(`WARNING: IPC handle "${R}" is longer than ${S} chars, try a shorter --user-data-dir`)}class h extends u.IPCServer{static b(S){const L=f.Event.fromNodeEventEmitter(S,"connection");return f.Event.map(L,T=>({protocol:new b.Protocol(new p(T,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(T,"close"))}))}constructor(S){super(h.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=h;function g(R){return new Promise((S,L)=>{const T=(0,A.createServer)();T.on("error",L),T.listen(R,()=>{T.removeListener("error",L),S(new h(T))})})}e.serve=g;function D(R,S){return new Promise((L,T)=>{const U=(0,A.createConnection)(R,()=>{U.removeListener("error",T),L(b.Client.fromSocket(new p(U,`ipc-client${S}`),S))});U.once("error",T)})}e.connect=D}),define(te[30],ie([0,1,55,9,130,33,88,6]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(O.IEnvironmentService);class f extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,A.join)(this.userDataPath,"clp")}get backupHome(){return(0,A.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,r.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,A.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}e.EnvironmentMainService=f,ve([E.memoize],f.prototype,"cachedLanguagesPath",null),ve([E.memoize],f.prototype,"backupHome",null),ve([E.memoize],f.prototype,"mainIPCHandle",null),ve([E.memoize],f.prototype,"mainLockfile",null),ve([E.memoize],f.prototype,"disableUpdates",null),ve([E.memoize],f.prototype,"disableKeytar",null),ve([E.memoize],f.prototype,"crossOriginIsolated",null),ve([E.memoize],f.prototype,"codeCachePath",null),ve([E.memoize],f.prototype,"useCodeCache",null)}),define(te[284],ie([0,1,70,32,14,9,3,18,22,194,19,30,34,16,5,193,29,97]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let a=e.BackupMainService=class yt{constructor(I,k,t,c){this.j=I,this.k=k,this.l=t,this.m=c,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.extUriBiasedIgnorePathCase,this.i={isEqual:(n,i)=>(0,A.isEqual)(n,i,!M.isLinux)}}async initialize(){const I=this.m.getItem(yt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(I.emptyWindows),this.d=await this.u((0,l.deserializeWorkspaceInfos)(I)),this.e=await this.v((0,l.deserializeFolderInfos)(I)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==u.HotExitConfiguration.OFF}q(){return this.s()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(I,k){this.d.some(c=>I.workspace.id===c.workspace.id)||(this.d.push(I),this.C());const t=(0,O.join)(this.c,I.workspace.id);return k?this.t(t,k).then(()=>t):t}async t(I,k){if(await f.Promises.exists(I)&&await this.z(I),await f.Promises.exists(k))try{await f.Promises.rename(k,I)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(I){return this.e.some(k=>this.h.isEqual(I.folderUri,k.folderUri))||(this.e.push(I),this.C()),(0,O.join)(this.c,this.D(I))}registerEmptyWindowBackup(I){return this.g.some(k=>!!k.backupFolder&&this.i.isEqual(k.backupFolder,I.backupFolder))||(this.g.push(I),this.C()),(0,O.join)(this.c,I.backupFolder)}async u(I){if(!Array.isArray(I))return[];const k=new Set,t=[];for(const c of I){const n=c.workspace;if(!(0,s.isWorkspaceIdentifier)(n))return[];if(!k.has(n.id)){k.add(n.id);const i=(0,O.join)(this.c,n.id);await this.B(i)?n.configPath.scheme!==r.Schemas.file||await f.Promises.exists(n.configPath.fsPath)?t.push(c):await this.z(i):await this.x(i)}}return t}async v(I){if(!Array.isArray(I))return[];const k=[],t=new Set;for(const c of I){const n=c.folderUri,i=this.h.getComparisonKey(n);if(!t.has(i)){t.add(i);const o=(0,O.join)(this.c,this.D(c));await this.B(o)?n.scheme!==r.Schemas.file||await f.Promises.exists(n.fsPath)?k.push(c):await this.z(o):await this.x(o)}}return k}async w(I){if(!Array.isArray(I))return[];const k=[],t=new Set;for(const c of I){const n=c.backupFolder;if(typeof n!="string")return[];if(!t.has(n)){t.add(n);const i=(0,O.join)(this.c,n);await this.B(i)?k.push(c):await this.x(i)}}return k}async x(I){try{await f.Promises.rm(I,f.RimRafMode.MOVE)}catch(k){this.l.error(`Backup: Could not delete stale backup: ${k.toString()}`)}}y(){let I=(0,y.createEmptyWorkspaceIdentifier)();for(;this.g.some(k=>!!k.backupFolder&&this.i.isEqual(k.backupFolder,I.id));)I=(0,y.createEmptyWorkspaceIdentifier)();return{backupFolder:I.id}}async z(I){const k=this.y(),t=(0,O.join)(this.c,k.backupFolder);try{await f.Promises.rename(I,t)}catch(c){return this.l.error(`Backup: Could not rename backup folder: ${c.toString()}`),!1}return this.g.push(k),!0}async getDirtyWorkspaces(){const I=[];for(const k of this.d)await this.A(k)&&I.push(k);for(const k of this.e)await this.A(k)&&I.push(k);return I}A(I){let k;return(0,l.isEmptyWindowBackupInfo)(I)?k=(0,O.join)(this.c,I.backupFolder):(0,p.isFolderBackupInfo)(I)?k=(0,O.join)(this.c,this.D(I)):k=(0,O.join)(this.c,I.workspace.id),this.B(k)}async B(I){try{const k=await f.Promises.readdir(I);for(const t of k)try{if((await f.Promises.readdir((0,O.join)(I,t))).length>0)return!0}catch{}}catch{}return!1}C(){const I={workspaces:this.d.map(({workspace:k,remoteAuthority:t})=>{const c={id:k.id,configURIPath:k.configPath.toString()};return t&&(c.remoteAuthority=t),c}),folders:this.e.map(({folderUri:k,remoteAuthority:t})=>{const c={folderUri:k.toString()};return t&&(c.remoteAuthority=t),c}),emptyWindows:this.g.map(({backupFolder:k,remoteAuthority:t})=>{const c={backupFolder:k};return t&&(c.remoteAuthority=t),c})};this.m.setItem(yt.a,I)}D(I){const k=I.folderUri;let t;return k.scheme===r.Schemas.file?t=M.isLinux?k.fsPath:k.fsPath.toLowerCase():t=k.toString().toLowerCase(),(0,E.createHash)("md5").update(t).digest("hex")}};a.a="backupWorkspaces",e.BackupMainService=a=ve([Z(0,m.IEnvironmentMainService),Z(1,w.IConfigurationService),Z(2,b.ILogService),Z(3,v.IStateService)],a)}),define(te[20],ie([0,1,15,38,7,4,2,3,36,11,6,5,34,30]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var b;(function(y){y[y.QUIT=1]="QUIT",y[y.KILL=2]="KILL"})(b||(e.ShutdownReason=b={}));var p;(function(y){y[y.Starting=1]="Starting",y[y.Ready=2]="Ready",y[y.AfterWindowOpen=3]="AfterWindowOpen",y[y.Eventually=4]="Eventually"})(p||(e.LifecycleMainPhase=p={}));let s=e.LifecycleMainService=class ft extends M.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(a,d,I){super(),this.v=a,this.w=d,this.y=I,this.c=this.B(new O.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new O.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new O.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new O.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(ft.b),this.j&&this.w.removeItem(ft.b)}C(){const a=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.isMacintosh&&this.n===0&&this.D(1))};E.app.addListener("before-quit",a);const d=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!P.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",d),E.app.once("will-quit",I=>{this.L("Lifecycle#app.on(will-quit) - begin"),I.preventDefault(),this.D(1).finally(()=>{this.L("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.H(!1),E.app.removeListener("before-quit",a),E.app.removeListener("window-all-closed",d),this.L("Lifecycle#app.on(will-quit) - calling app.quit()"),E.app.quit()})})}D(a){if(this.s)return this.s;const d=this.v;this.L("Lifecycle#onWillShutdown.fire()");const I=[];return this.f.fire({reason:a,join(k,t){d.trace(`Lifecycle#onWillShutdown - begin '${k}'`),I.push(t.finally(()=>{d.trace(`Lifecycle#onWillShutdown - end '${k}'`)}))}}),this.s=(async()=>{try{await r.Promises.settled(I)}catch(k){this.v.error(k)}try{await this.w.close()}catch(k){this.v.error(k)}})(),this.s}set phase(a){if(a<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===a)return;this.L(`lifecycle (main): phase changed (value: ${a})`),this.k=a;const d=this.u.get(this.k);d&&(d.open(),this.u.delete(this.k))}async when(a){if(a<=this.k)return;let d=this.u.get(a);d||(d=new r.Barrier,this.u.set(a,d)),await d.wait()}registerWindow(a){const d=new M.DisposableStore;this.n++,d.add(a.onWillLoad(k=>this.g.fire({window:a,workspace:k.workspace,reason:k.reason})));const I=(0,l.assertIsDefined)(a.win);I.on("close",k=>{const t=a.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${a.id}`),k.preventDefault(),this.unload(a,1).then(c=>{if(c){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(a),a.close()})}),I.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${a.id}`),this.n--,d.dispose(),this.n===0&&(!P.isMacintosh||this.i)&&this.D(1)})}async reload(a,d){await this.unload(a,3)||a.reload(d)}unload(a,d){const I=this.t.get(a.id);if(I)return I;const k=this.F(a,d).finally(()=>{this.t.delete(a.id)});return this.t.set(a.id,k),k}async F(a,d){if(!a.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${a.id}`);const I=this.i?2:d,k=await this.I(a,I);return k?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${a.id})`),this.G(k)):(await this.J(a,I),!1)}G(a){return a?(this.H(!0),this.i=!1,!0):!1}H(a){this.r&&(this.r(a),this.r=void 0,this.p=void 0)}I(a,d){return new Promise(I=>{const k=this.m++,t=`vscode:ok${k}`,c=`vscode:cancel${k}`;A.validatedIpcMain.once(t,()=>{I(!1)}),A.validatedIpcMain.once(c,()=>{I(!0)}),a.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:c,reason:d})})}J(a,d){return new Promise(I=>{const t=`vscode:reply${this.m++}`;A.validatedIpcMain.once(t,()=>I()),a.send("vscode:onWillUnload",{replyChannel:t,reason:d})})}quit(a){return this.L(`Lifecycle#quit() - begin (willRestart: ${a})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(a&&this.w.setItem(ft.b,!0),this.p=new Promise(d=>{this.r=d,this.L("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}L(a){this.y.args["enable-smoke-test-driver"]?this.v.info(a):this.v.trace(a)}async relaunch(a){this.L("Lifecycle#relaunch()");const d=process.argv.slice(1);if(a?.addArgs&&d.push(...a.addArgs),a?.removeArgs)for(const t of a.removeArgs){const c=d.indexOf(t);c>=0&&d.splice(c,1)}const I=()=>{try{if(P.isWindows){const t=(0,f.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:d})};E.app.once("quit",I),await this.quit(!0)&&E.app.removeListener("quit",I)}async kill(a){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const d of E.BrowserWindow.getAllWindows())if(d&&!d.isDestroyed()){let I;d.webContents&&!d.webContents.isDestroyed()?I=new Promise(k=>d.once("closed",k)):I=Promise.resolve(),d.destroy(),await I}})()]),E.app.exit(a)}};s.b="lifecycle.quitAndRestart",e.LifecycleMainService=s=ve([Z(0,m.ILogService),Z(1,v.IStateService),Z(2,u.IEnvironmentMainService)],s)}),define(te[285],ie([0,1,3,4,2,6,20]),function(x,e,E,A,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,O.createDecorator)("keyboardLayoutMainService");let P=e.KeyboardLayoutMainService=class extends r.Disposable{constructor(w){super(),this.a=this.B(new A.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,w.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const w=await new Promise((m,v)=>{x(["native-keymap"],m,v)});this.c=f(w),E.isCI||w.onDidChangeKeyboardLayout(()=>{this.c=f(w),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.KeyboardLayoutMainService=P=ve([Z(0,M.ILifecycleMainService)],P);function f(l){const w=l.getKeyMap(),m=l.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:m}}}),define(te[286],ie([0,1,244,7,17,13,11,19,33,93,5,51,243,283]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let b=e.RequestService=class extends m.AbstractRequestService{constructor(a,d,I,k){super(k),this.j=a,this.k=d,this.l=I,this.m(),this.B(a.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const a=this.j.getValue("http");this.f=a?.proxy,this.g=!!a?.proxyStrictSSL,this.h=a?.proxyAuthorization}async request(a,d){const{f:I,g:k}=this;let t;try{t=await(0,l.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,O.getErrorMessage)(i)))}const c={...process.env,...t},n=a.agent?a.agent:await(0,v.getProxyAgent)(a.url||"",c,{proxyUrl:I,strictSSL:k});return a.agent=n,a.strictSSL=k,this.h&&(a.headers={...a.headers||{},"Proxy-Authorization":this.h}),this.c(a.isChromiumNetwork?"electron":"node",a,()=>s(a,d))}async resolveProxy(a){}};e.RequestService=b=ve([Z(0,P.IConfigurationService),Z(1,f.INativeEnvironmentService),Z(2,w.ILogService),Z(3,w.ILoggerService)],b);async function p(y){return((0,E.parse)(y.url).protocol==="https:"?await new Promise((I,k)=>{x(["https"],I,k)}):await new Promise((I,k)=>{x(["http"],I,k)})).request}async function s(y,a){return A.Promises.withAsyncBody(async(d,I)=>{const k=(0,E.parse)(y.url),t=y.getRawRequest?y.getRawRequest(y):await p(y),c={hostname:k.hostname,port:k.port?parseInt(k.port):k.protocol==="https:"?443:80,protocol:k.protocol,path:k.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,M.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(c.auth=y.user+":"+y.password);const n=t(c,i=>{const o=(0,M.isNumber)(y.followRedirects)?y.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)s({...y,url:i.headers.location,followRedirects:o-1},a).then(d,I);else{let h=i;!y.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(h=i.pipe((0,u.createGunzip)())),d({res:i,stream:(0,r.streamToBufferReadableStream)(h)})}});n.on("error",I),y.timeout&&n.setTimeout(y.timeout),y.isChromiumNetwork&&n.removeHeader("Content-Length"),y.data&&typeof y.data=="string"&&n.write(y.data),n.end(),a.onCancellationRequested(()=>{n.abort(),I(new O.CancellationError)})})}e.nodeRequest=s}),define(te[287],ie([0,1,15,286]),function(x,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function r(M){return E.net.request}class O extends A.RequestService{request(P,f){return super.request({...P||{},getRawRequest:r,isChromiumNetwork:!0},f)}}e.RequestMainService=O}),define(te[98],ie([0,1,8,49,4,2,33,16,6,20,5,95,280,41,53,40]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,f.createDecorator)("storageMainService");let s=e.StorageMainService=class extends O.Disposable{constructor(d,I,k,t,c,n){super(),this.c=d,this.f=I,this.g=k,this.h=t,this.i=c,this.j=n,this.a=void 0,this.b=this.B(new r.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(d=>{d.window.profile&&this.profileStorage(d.window.profile).init(),d.workspace&&this.workspaceStorage(d.workspace).init()})),this.B(this.h.onWillShutdown(d=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=d.reason,d.join("applicationStorage",this.applicationStorage.close());for(const[,I]of this.n)d.join("profileStorage",I.close());for(const[,I]of this.r)d.join("workspaceStorage",I.close())})),this.B(this.g.onWillCreateProfile(d=>{d.join((async()=>{await this.i.exists(d.profile.globalStorageHome)||await this.i.createFolder(d.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(d=>{const I=this.n.get(d.profile.id);I&&d.join(I.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const d=new v.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,A.once)(d.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),d}profileStorage(d){if((0,m.isProfileUsingDefaultStorage)(d))return this.applicationStorage;let I=this.n.get(d.id);if(!I){this.c.trace(`StorageMainService: creating profile storage (${d.name})`),I=this.p(d),this.n.set(d.id,I);const k=this.B(I.onDidChangeStorage(t=>this.b.fire({...t,storage:I,profile:d})));(0,A.once)(I.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${d.name})`),this.n.delete(d.id),k.dispose()})}return I}p(d){return this.a===2?new v.InMemoryStorageMain(this.c,this.i):new v.ProfileStorageMain(d,this.k(),this.c,this.i)}workspaceStorage(d){let I=this.r.get(d.id);return I||(this.c.trace(`StorageMainService: creating workspace storage (${d.id})`),I=this.s(d),this.r.set(d.id,I),(0,A.once)(I.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${d.id})`),this.r.delete(d.id)})),I}s(d){return this.a===2?new v.InMemoryStorageMain(this.c,this.i):new v.WorkspaceStorageMain(d,this.k(),this.c,this.f,this.i)}isUsed(d){const I=E.URI.file(d);for(const k of[this.applicationStorage,...this.n.values(),...this.r.values()])if(k.path&&this.j.extUri.isEqualOrParent(E.URI.file(k.path),I))return!0;return!1}};e.StorageMainService=s=ve([Z(0,w.ILogService),Z(1,M.IEnvironmentService),Z(2,b.IUserDataProfilesMainService),Z(3,l.ILifecycleMainService),Z(4,P.IFileService),Z(5,p.IUriIdentityService)],s),e.IApplicationStorageMainService=(0,f.createDecorator)("applicationStorageMainService");let y=e.ApplicationStorageMainService=class extends m.AbstractStorageService{constructor(d,I){super(),this.p=d,this.s=I,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(d){if(d===-1)return this.s.applicationStorage.storage}M(d){if(d===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=y=ve([Z(0,u.IUserDataProfilesService),Z(1,e.IStorageMainService)],y)}),define(te[99],ie([0,1,7,21,4,19,30,20,5,23,51,48]),function(x,e,E,A,r,O,M,P,f,l,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function v(b,p,s){return`${s.updateUrl}/api/update/${b}/${p}/${s.commit}`}e.createUpdateURL=v;let u=e.AbstractUpdateService=class{get state(){return this.b}d(p){this.j.info("update#setState",p.type),this.b=p,this.c.fire(p)}constructor(p,s,y,a,d,I){this.f=p,this.g=s,this.h=y,this.i=a,this.j=d,this.k=I,this.b=m.State.Uninitialized,this.c=new r.Emitter,this.onStateChange=this.c.event,p.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.g.getValue("update.mode"),s=this.m(p);if(!s){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(s),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(m.State.Idle(this.q())),p==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,y=>this.j.error(y))}m(p){return p==="none"?void 0:this.k.quality}n(p=60*60*1e3){return(0,E.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(p){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(p)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(p){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},A.CancellationToken.None)).res.statusCode===204}catch(s){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(s);return}}async _applySpecificUpdate(p){}q(){return 1}r(){}};e.AbstractUpdateService=u=ve([Z(0,P.ILifecycleMainService),Z(1,O.IConfigurationService),Z(2,M.IEnvironmentMainService),Z(3,w.IRequestService),Z(4,f.ILogService),Z(5,l.IProductService)],u)}),define(te[288],ie([0,1,15,55,4,2,19,30,20,5,23,51,26,48,99]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let p=e.DarwinUpdateService=class extends b.AbstractUpdateService{get v(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"error",(y,a)=>a)}get w(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(y,a,d)=>({url:a,version:d,productVersion:d}))}get y(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(y,a,d,I)=>({releaseNotes:a,version:d,productVersion:d,date:I}))}constructor(y,a,d,I,k,t,c){super(y,a,I,k,t,c),this.z=d,this.u=new O.DisposableStore}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(y){this.j.error("UpdateService error:",y);const a=this.state.type==="checking for updates"&&this.state.explicit?y:void 0;this.d(u.State.Idle(1,a))}s(y){let a;this.k.darwinUniversalAssetId?a=this.k.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,b.createUpdateURL)(a,y,this.k);try{E.autoUpdater.setFeedURL({url:d})}catch(I){this.j.error("Failed to set update feed URL",I);return}return d}t(y){this.d(u.State.CheckingForUpdates(y)),E.autoUpdater.checkForUpdates()}E(y){this.state.type==="checking for updates"&&this.d(u.State.Downloading(y))}F(y){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:y.version}),this.d(u.State.Ready(y)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(u.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};ve([A.memoize],p.prototype,"v",null),ve([A.memoize],p.prototype,"w",null),ve([A.memoize],p.prototype,"x",null),ve([A.memoize],p.prototype,"y",null),e.DarwinUpdateService=p=ve([Z(0,f.ILifecycleMainService),Z(1,M.IConfigurationService),Z(2,v.ITelemetryService),Z(3,P.IEnvironmentMainService),Z(4,m.IRequestService),Z(5,l.ILogService),Z(6,w.IProductService)],p)}),define(te[289],ie([0,1,46,42,7,4,9,30,20,5,26,48]),function(x,e,E,A,r,O,M,P,f,l,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let v=class{get state(){return this.a}d(p){this.g.info("update#setState",p.type),this.a=p,this.b.fire(p)}constructor(p,s,y){if(this.f=p,this.g=y,this.a=m.State.Uninitialized,this.b=new O.Emitter,this.onStateChange=this.b.event,s.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(m.State.Idle(this.k())),this.h(30*1e3).then(void 0,a=>this.g.error(a))}h(p=60*60*1e3){return(0,r.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(p){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(p)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(p){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(p){}};v=ve([Z(0,f.ILifecycleMainService),Z(1,P.IEnvironmentMainService),Z(2,l.ILogService)],v);let u=e.SnapUpdateService=class extends v{constructor(p,s,y,a,d,I){super(y,a,d),this.o=p,this.p=s,this.q=I;const k=(0,A.watch)(M.dirname(this.o)),t=O.Event.fromNodeEventEmitter(k,"change",(o,h)=>h),c=O.Event.filter(t,o=>o==="current"),i=O.Event.debounce(c,(o,h)=>h,2e3)(()=>this.checkForUpdates(!1));y.onWillShutdown(()=>{i.dispose(),k.close()})}m(){this.d(m.State.CheckingForUpdates(!1)),this.u().then(p=>{p?this.d(m.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(m.State.Idle(2)))},p=>{this.g.error(p),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(m.State.Idle(2,p.message||p))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const p=await new Promise((y,a)=>(0,A.realpath)(`${M.dirname(this.o)}/current`,(d,I)=>d?a(d):y(I))),s=M.basename(p);return this.p!==s}isLatestVersion(){return this.u().then(void 0,p=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=u=ve([Z(2,f.ILifecycleMainService),Z(3,P.IEnvironmentMainService),Z(4,l.ILogService),Z(5,w.ITelemetryService)],u)}),define(te[290],ie([0,1,2,20,53,29,7,28]),function(x,e,E,A,r,O,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let f=e.UserDataProfilesHandler=class extends E.Disposable{constructor(w,m,v){super(),this.a=m,this.b=v,this.B(w.onWillLoadWindow(u=>{u.reason===2&&this.c(u.window)})),this.B(w.onBeforeCloseWindow(u=>this.c(u))),this.B(new M.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(w){const m=this.f(w),v=this.a.getProfileForWorkspace(m);v?.isTransient&&(this.a.unsetWorkspace(m,v.isTransient),v.isTransient&&await this.a.cleanUpTransientProfiles())}f(w){return w.openedWorkspace??(0,O.toWorkspaceIdentifier)(w.backupPath,w.isExtensionDevelopmentHost)}g(){const w=this.a.getAssociatedEmptyWindows();if(w.length===0)return;const m=this.b.getWindows().map(v=>this.f(v));for(const v of w)m.some(u=>u.id===v.id)||this.a.unsetWorkspace(v,!1)}};e.UserDataProfilesHandler=f=ve([Z(0,A.ILifecycleMainService),Z(1,r.IUserDataProfilesMainService),Z(2,P.IWindowsMainService)],f)}),define(te[60],ie([0,1,15,2,4,5,309,7,14,28,72,26,20,71,37,3,131]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function y(I){return typeof I.responseWindowId=="number"}let a=e.UtilityProcess=class ut extends A.Disposable{static getAll(){return Array.from(ut.b.values())}constructor(k,t,c){super(),this.n=k,this.p=t,this.r=c,this.c=String(++ut.a),this.f=this.B(new r.Emitter),this.onStdout=this.f.event,this.g=this.B(new r.Emitter),this.onStderr=this.g.event,this.h=this.B(new r.Emitter),this.onMessage=this.h.event,this.i=this.B(new r.Emitter),this.onExit=this.i.event,this.j=this.B(new r.Emitter),this.onCrash=this.j.event,this.k=void 0,this.l=void 0,this.m=void 0}s(k,t){let c;switch(this.m?.correlationId?c=`[UtilityProcess id: ${this.m?.correlationId}, type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${k}`:c=`[UtilityProcess type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${k}`,t){case w.default.Error:this.n.error(c);break;case w.default.Warning:this.n.warn(c);break;case w.default.Info:this.n.trace(c);break}}t(){return this.k?(this.s("Cannot start utility process because it is already running...",w.default.Error),!1):!0}start(k){const t=this.u(k);return t&&k.payload&&this.postMessage(k.payload),t}u(k){if(!this.t())return!1;this.m=k;const t=`${this.m.type}-${this.c}`,c=f.FileAccess.asFileUri("bootstrap-fork.js").fsPath,n=this.m.args??[],i=this.m.execArgv??[],o=this.m.allowLoadingUnsignedLibraries,h=this.m.forceAllocationsToV8Sandbox,g="pipe",D=this.v(k);return this.s("creating new...",w.default.Info),this.k=E.utilityProcess.fork(c,n,{serviceName:t,env:D,execArgv:i,allowLoadingUnsignedLibraries:o,forceAllocationsToV8Sandbox:h,stdio:g}),this.w(this.k,this.m,t),!0}v(k){const t=k.env?{...k.env}:{...(0,b.deepClone)(process.env)};t.VSCODE_AMD_ENTRYPOINT=k.entryPoint,typeof k.parentLifecycleBound=="number"&&(t.VSCODE_PARENT_PID=String(k.parentLifecycleBound)),t.VSCODE_CRASH_REPORTER_PROCESS_TYPE=k.type,p.isWindows&&(t.NODE_UNC_HOST_ALLOWLIST=(0,s.getUNCHostAllowlist)().join("\\")),(0,u.removeDangerousEnvVariables)(t);for(const c of Object.keys(t))t[c]=String(t[c]);return t}w(k,t,c){if(k.stdout){const n=new M.StringDecoder("utf-8");this.B(r.Event.fromNodeEventEmitter(k.stdout,"data")(i=>this.f.fire(typeof i=="string"?i:n.write(i))))}if(k.stderr){const n=new M.StringDecoder("utf-8");this.B(r.Event.fromNodeEventEmitter(k.stderr,"data")(i=>this.g.fire(typeof i=="string"?i:n.write(i))))}this.B(r.Event.fromNodeEventEmitter(k,"message")(n=>this.h.fire(n))),this.B(r.Event.fromNodeEventEmitter(k,"spawn")(()=>{this.l=k.pid,typeof k.pid=="number"&&ut.b.set(k.pid,{pid:k.pid,name:y(t)?`${t.type} [${t.responseWindowId}]`:t.type}),this.s("successfully created",w.default.Info)})),this.B(r.Event.fromNodeEventEmitter(k,"exit")(n=>{this.s(`received exit event with code ${n}`,w.default.Info),this.i.fire({pid:this.l,code:n,signal:"unknown"}),this.y()})),this.B(r.Event.fromNodeEventEmitter(E.app,"child-process-gone",(n,i)=>({event:n,details:i}))(({details:n})=>{n.type==="Utility"&&n.name===c&&(this.s(`crashed with code ${n.exitCode} and reason '${n.reason}'`,w.default.Error),this.p.publicLog2("utilityprocesscrash",{type:t.type,reason:n.reason,code:n.exitCode}),this.j.fire({pid:this.l,code:n.exitCode,reason:n.reason}),this.y())}))}once(k,t){const c=this.B(this.h.event(n=>{n===k&&(c.dispose(),t())}))}postMessage(k,t){this.k&&this.k.postMessage(k,t)}connect(k){const{port1:t,port2:c}=new E.MessageChannelMain;return this.postMessage(k,[c]),t}enableInspectPort(){if(!this.k||typeof this.l!="number")return!1;this.s("enabling inspect port",w.default.Info);const k=process;return typeof k._debugProcess=="function"?(k._debugProcess(this.l),!0):!1}kill(){if(!this.k)return;this.s("attempting to kill the process...",w.default.Info),this.k.kill()?(this.s("successfully killed the process",w.default.Info),this.y()):this.s("unable to kill the process",w.default.Warning)}y(){typeof this.l=="number"&&ut.b.delete(this.l),this.k=void 0}async waitForExit(k){this.k&&(this.s("waiting to exit...",w.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,P.timeout)(k)]),this.k&&(this.s(`did not exit within ${k}ms, will kill it now...`,w.default.Info),this.kill()))}};a.a=0,a.b=new Map,e.UtilityProcess=a=ve([Z(0,O.ILogService),Z(1,m.ITelemetryService),Z(2,v.ILifecycleMainService)],a);let d=e.WindowUtilityProcess=class extends a{constructor(k,t,c,n){super(k,c,n),this.z=t}start(k){const t=this.z.getWindowById(k.responseWindowId);if(!t?.win||t.win.isDestroyed()||t.win.webContents.isDestroyed())return this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",w.default.Error),!0;if(!super.u(k))return!1;this.C(t.win,k);const n=this.connect(k.payload);return t.win.webContents.postMessage(k.responseChannel,k.responseNonce,[n]),!0}C(k,t){t.windowLifecycleBound&&(this.B(r.Event.filter(this.r.onWillLoadWindow,c=>c.window.win===k)(()=>this.kill())),this.B(r.Event.fromNodeEventEmitter(k,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=d=ve([Z(0,O.ILogService),Z(1,l.IWindowsMainService),Z(2,m.ITelemetryService),Z(3,v.ILifecycleMainService)],d)}),define(te[291],ie([0,1,13,5,20,7,60,28,26]),function(x,e,E,A,r,O,M,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let l=e.ExtensionHostStarter=class Dt{constructor(m,v,u,b){this.d=m,this.f=v,this.g=u,this.h=b,this.b=new Map,this.c=!1,this.f.onWillShutdown(p=>{this.c=!0,p.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(m){const v=this.b.get(m);if(!v)throw new Error("Unknown extension host!");return v}onDynamicStdout(m){return this.i(m).onStdout}onDynamicStderr(m){return this.i(m).onStderr}onDynamicMessage(m){return this.i(m).onMessage}onDynamicExit(m){return this.i(m).onExit}async createExtensionHost(){if(this.c)throw(0,E.canceled)();const m=String(++Dt.a),v=new M.WindowUtilityProcess(this.d,this.g,this.h,this.f);return this.b.set(m,v),v.onExit(({pid:u,code:b,signal:p})=>{this.d.info(`Extension host with pid ${u} exited with code: ${b}, signal: ${p}.`),setTimeout(()=>{v.dispose(),this.b.delete(m)})}),{id:m}}async start(m,v){if(this.c)throw(0,E.canceled)();this.i(m).start({...v,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:v.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:m})}async enableInspectPort(m){if(this.c)throw(0,E.canceled)();const v=this.b.get(m);return v?v.enableInspectPort():!1}async kill(m){if(this.c)throw(0,E.canceled)();const v=this.b.get(m);v&&v.kill()}async _killAllNow(){for(const[,m]of this.b)m.kill()}async _waitForAllExit(m){const v=[];for(const[,u]of this.b)v.push(u.waitForExit(m));return O.Promises.settled(v).then(()=>{})}};l.a=0,e.ExtensionHostStarter=l=ve([Z(0,A.ILogService),Z(1,r.ILifecycleMainService),Z(2,P.IWindowsMainService),Z(3,f.ITelemetryService)],l)}),define(te[292],ie([0,1,38,7,2,30,20,5,41,39,66,60,52,88,11]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let p=e.SharedProcess=class extends r.Disposable{constructor(y,a,d,I,k,t,c){super(),this.c=y,this.f=a,this.g=d,this.h=I,this.i=k,this.j=t,this.k=c,this.a=new A.Barrier,this.b=void 0,this.r=void 0,this.s=void 0,this.l()}l(){E.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(y,a)=>this.m(y,a)),this.B(this.h.onWillShutdown(()=>this.n()))}async m(y,a){this.i.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const d=await this.connect();if(y.sender.isDestroyed())return d.close();y.sender.postMessage("vscode:createSharedProcessMessageChannelResult",a,[d])}n(){this.i.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage("vscode:electron-main->shared-process=exit"),this.b=void 0}whenReady(){return this.r||(this.r=(async()=>{await this.t;const y=new A.DeferredPromise;this.b?this.b.once("vscode:shared-process->electron-main=init-done",()=>y.complete()):E.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>y.complete()),await y.p,this.i.trace("[SharedProcess] Overall ready")})()),this.r}get t(){return this.s||(this.s=(async()=>{await this.a.wait(),this.u();const y=new A.DeferredPromise;this.b?this.b.once("vscode:shared-process->electron-main=ipc-ready",()=>y.complete()):E.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>y.complete()),await y.p,this.i.trace("[SharedProcess] IPC ready")})()),this.s}u(){this.b=this.B(new m.UtilityProcess(this.i,v.NullTelemetryService,this.h));const y=(0,u.parseSharedProcessDebugPort)(this.f.args,this.f.isBuilt);let a;y.port&&(a=["--nolazy"],y.break?a.push(`--inspect-brk=${y.port}`):a.push(`--inspect=${y.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.v(),execArgv:a})}v(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.j.getLogLevel(),loggers:this.j.getRegisteredLoggers(),policiesData:this.k.serialize()}}async connect(){return await this.t,(0,b.assertIsDefined)(this.b).connect()}};e.SharedProcess=p=ve([Z(1,O.IEnvironmentMainService),Z(2,f.IUserDataProfilesService),Z(3,M.ILifecycleMainService),Z(4,P.ILogService),Z(5,w.ILoggerMainService),Z(6,l.IPolicyService)],p)}),define(te[293],ie([0,1,33,88,20,5,52,60,109,38,2,4,37]),function(x,e,E,A,r,O,M,P,f,l,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let u=e.ElectronPtyHostStarter=class{constructor(p,s,y,a){this.d=p,this.f=s,this.g=y,this.h=a,this.a=void 0,this.b=new m.Emitter,this.onBeforeWindowConnection=this.b.event,this.c=new m.Emitter,this.onWillShutdown=this.c.event,this.g.onWillShutdown(()=>this.c.fire()),l.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(d,I)=>this.j(d,I))}start(p){this.a=new P.UtilityProcess(this.h,M.NullTelemetryService,this.g);const s=(0,A.parsePtyHostDebugPort)(this.f.args,this.f.isBuilt);let y;s&&(y=["--nolazy"],s.break?y.push(`--inspect-brk=${s.port}`):s.break||y.push(`--inspect=${s.port}`)),this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:y,env:this.i(p)});const a=this.a.connect(),d=new f.Client(a,"ptyHost"),I=new w.DisposableStore;return I.add(d),I.add(this.a),I.add((0,w.toDisposable)(()=>{l.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel"),this.a=void 0})),{client:d,store:I,onDidProcessExit:this.a.onExit}}i(p){return{...(0,v.deepClone)(process.env),VSCODE_LAST_PTY_ID:String(p),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.d.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.d.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.d.scrollback)}}j(p,s){this.b.fire();const y=this.a.connect();if(p.sender.isDestroyed()){y.close();return}p.sender.postMessage("vscode:createPtyHostMessageChannelResult",s,[y])}};e.ElectronPtyHostStarter=u=ve([Z(1,E.IEnvironmentService),Z(2,r.ILifecycleMainService),Z(3,O.ILogService)],u)}),define(te[294],ie([0,1,2,6,5,28,60,26,56,4,7,20]),function(x,e,E,A,r,O,M,P,f,l,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,A.createDecorator)("utilityProcessWorker");let v=e.UtilityProcessWorkerMainService=class extends E.Disposable{constructor(p,s,y,a){super(),this.b=p,this.c=s,this.f=y,this.g=a,this.a=new Map}async createWorker(p){const s=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${s})`);const y=this.h(p);this.a.has(y)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${s})`),this.disposeWorker(p));const a=new u(this.b,this.c,this.f,this.g,p);if(!a.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(y,a);const d=new w.DeferredPromise;return l.Event.once(a.onDidTerminate)(I=>{I.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${I.code}, signal: ${I.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${I.code}, signal: ${I.signal}`),this.a.delete(y),d.complete({reason:I})}),d.p}h(p){return(0,f.hash)({moduleId:p.process.moduleId,windowId:p.reply.windowId})}async disposeWorker(p){const s=this.h(p),y=this.a.get(s);y&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),y.kill(),this.a.delete(s))}};e.UtilityProcessWorkerMainService=v=ve([Z(0,r.ILogService),Z(1,O.IWindowsMainService),Z(2,P.ITelemetryService),Z(3,m.ILifecycleMainService)],v);let u=class extends E.Disposable{constructor(p,s,y,a,d){super(),this.c=p,this.f=s,this.g=y,this.h=a,this.i=d,this.a=this.B(new l.Emitter),this.onDidTerminate=this.a.event,this.b=new M.WindowUtilityProcess(this.c,this.f,this.g,this.h),this.j()}j(){this.B(this.b.onExit(p=>this.a.fire({code:p.code,signal:p.signal}))),this.B(this.b.onCrash(p=>this.a.fire({code:p.code,signal:"ECRASH"})))}spawn(){const s=this.f.getWindowById(this.i.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.i.process.type,entryPoint:this.i.process.moduleId,parentLifecycleBound:s,windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce})}kill(){this.b.kill()}};u=ve([Z(0,r.ILogService),Z(1,O.IWindowsMainService),Z(2,P.ITelemetryService),Z(3,m.ILifecycleMainService)],u)}),define(te[295],ie([0,1,15,2,3,18,8,19,20,5,34,28,127,29]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let b=e.WindowsStateHandler=class vt extends A.Disposable{get state(){return this.b}constructor(I,k,t,c,n){super(),this.g=I,this.h=k,this.i=t,this.j=c,this.k=n,this.b=p(this.h.getItem(vt.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(I=>this.p(I)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(I=>{I.newCount-I.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(I=>this.p(I))}m(){this.f=!0,this.n()}n(){const I=new Set,k={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!k.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(i=>!i.isExtensionDevelopmentHost)),n&&(k.lastActiveWindow=this.r(n),k.lastActiveWindow.uiState.mode===3&&I.add(k.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);t&&(k.lastPluginDevelopmentHostWindow=this.r(t),k.lastPluginDevelopmentHostWindow.uiState.mode===3&&(I.has(k.lastPluginDevelopmentHostWindow.uiState.display)?r.isMacintosh&&!t.win?.isSimpleFullScreen()&&(k.lastPluginDevelopmentHostWindow.uiState.mode=1):I.add(k.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(k.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const i=this.r(n);return i.uiState.mode===3&&(I.has(i.uiState.display)?r.isMacintosh&&i.windowId!==k.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(i.uiState.mode=1):I.add(i.uiState.display)),i}));const c=y(k);this.h.setItem(vt.a,c),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",c)}p(I){if(this.i.quitRequested)return;const k=this.r(I);I.isExtensionDevelopmentHost&&!I.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=k:!I.isExtensionDevelopmentHost&&I.openedWorkspace&&this.b.openedWindows.forEach(t=>{const c=(0,u.isWorkspaceIdentifier)(I.openedWorkspace)&&t.workspace?.id===I.openedWorkspace.id,n=(0,u.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&t.folderUri&&O.extUriBiasedIgnorePathCase.isEqual(t.folderUri,I.openedWorkspace.uri);(c||n)&&(t.uiState=k.uiState)}),this.g.getWindowCount()===1&&(this.c=k)}r(I){return{windowId:I.id,workspace:(0,u.isWorkspaceIdentifier)(I.openedWorkspace)?I.openedWorkspace:void 0,folderUri:(0,u.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)?I.openedWorkspace.uri:void 0,backupPath:I.backupPath,remoteAuthority:I.remoteAuthority,uiState:I.serializeWindowState()}}getNewWindowState(I){const k=this.s(I),t=this.k.getValue("window");if(k.mode===3){let c;k.hasDefaultState?c=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):c=!!(this.i.wasRestarted||t?.restoreFullscreen),c||(k.mode=1)}return k}s(I){const k=this.g.getLastActiveWindow();if(!I.extensionTestsPath){if(I.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=I.workspace;if((0,u.isWorkspaceIdentifier)(h)){const D=this.state.openedWindows.filter(R=>R.workspace&&R.workspace.id===h.id).map(R=>R.uiState);if(D.length)return D[0]}if((0,u.isSingleFolderWorkspaceIdentifier)(h)){const D=this.state.openedWindows.filter(R=>R.folderUri&&O.extUriBiasedIgnorePathCase.isEqual(R.folderUri,h.uri)).map(R=>R.uiState);if(D.length)return D[0]}else if(I.backupPath){const D=this.state.openedWindows.filter(R=>R.backupPath===I.backupPath).map(R=>R.uiState);if(D.length)return D[0]}const g=this.c||this.state.lastActiveWindow;if(!k&&g)return g.uiState}let t;const c=E.screen.getAllDisplays();if(c.length===1)t=c[0];else{if(r.isMacintosh){const h=E.screen.getCursorScreenPoint();t=E.screen.getDisplayNearestPoint(h)}!t&&k&&(t=E.screen.getDisplayMatching(k.getBounds())),t||(t=E.screen.getPrimaryDisplay()||c[0])}let n=(0,v.defaultWindowState)();n.x=Math.round(t.bounds.x+t.bounds.width/2-n.width/2),n.y=Math.round(t.bounds.y+t.bounds.height/2-n.height/2);const i=this.k.getValue("window");let o=!0;if(i?.newWindowDimensions){if(i.newWindowDimensions==="maximized")n.mode=0,o=!1;else if(i.newWindowDimensions==="fullscreen")n.mode=3,o=!1;else if((i.newWindowDimensions==="inherit"||i.newWindowDimensions==="offset")&&k){const h=k.serializeWindowState();h.mode===3?n.mode=3:n=h,o=n.mode!==3&&i.newWindowDimensions==="offset"}}return o&&(n=this.t(n)),n.hasDefaultState=!0,n}t(I){if(this.g.getWindows().length===0)return I;I.x=typeof I.x=="number"?I.x:0,I.y=typeof I.y=="number"?I.y:0;const k=this.g.getWindows().map(t=>t.getBounds());for(;k.some(t=>t.x===I.x||t.y===I.y);)I.x+=30,I.y+=30;return I}};b.a="windowsState",e.WindowsStateHandler=b=ve([Z(0,m.IWindowsMainService),Z(1,w.IStateService),Z(2,f.ILifecycleMainService),Z(3,l.ILogService),Z(4,P.IConfigurationService)],b);function p(d){const I={openedWindows:[]},k=d||{openedWindows:[]};return k.lastActiveWindow&&(I.lastActiveWindow=s(k.lastActiveWindow)),k.lastPluginDevelopmentHostWindow&&(I.lastPluginDevelopmentHostWindow=s(k.lastPluginDevelopmentHostWindow)),Array.isArray(k.openedWindows)&&(I.openedWindows=k.openedWindows.map(t=>s(t))),I}e.restoreWindowsState=p;function s(d){const I={uiState:d.uiState};return d.backupPath&&(I.backupPath=d.backupPath),d.remoteAuthority&&(I.remoteAuthority=d.remoteAuthority),d.folder&&(I.folderUri=M.URI.parse(d.folder)),d.workspaceIdentifier&&(I.workspace={id:d.workspaceIdentifier.id,configPath:M.URI.parse(d.workspaceIdentifier.configURIPath)}),I}function y(d){return{lastActiveWindow:d.lastActiveWindow&&a(d.lastActiveWindow),lastPluginDevelopmentHostWindow:d.lastPluginDevelopmentHostWindow&&a(d.lastPluginDevelopmentHostWindow),openedWindows:d.openedWindows.map(I=>a(I))}}e.getWindowsStateStoreData=y;function a(d){return{workspaceIdentifier:d.workspace&&{id:d.workspace.id,configURIPath:d.workspace.configPath.toString()},folder:d.folderUri&&d.folderUri.toString(),backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.uiState}}}),define(te[54],ie([0,1,15,4,44,2,14,9,18,11,22,192,64,59,30,6,5,53,129,29,96,97]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a,d,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,p.createDecorator)("workspacesManagementMainService");let t=e.WorkspacesManagementMainService=class extends O.Disposable{constructor(n,i,o,h,g){super(),this.g=n,this.h=i,this.i=o,this.j=h,this.k=g,this.a=this.B(new A.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new A.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const n=(await w.Promises.readdir(this.c.fsPath)).map(i=>(0,f.joinPath)(this.c,i,d.UNTITLED_WORKSPACE_NAME));for(const i of n){const o=(0,k.getWorkspaceIdentifier)(i),h=await this.resolveLocalWorkspace(i);h?this.f.push({workspace:o,remoteAuthority:h.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(n){n.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${n}).`)}}resolveLocalWorkspace(n){return this.l(n,i=>w.Promises.readFile(i,"utf8"))}l(n,i){if(this.m(n)&&n.scheme===M.Schemas.file)try{const o=i(n.fsPath);return o instanceof Promise?o.then(h=>this.n(n,h),h=>{}):this.n(n,o)}catch{return}}m(n){return(0,d.isUntitledWorkspace)(n,this.g)||(0,d.hasWorkspaceFileExtension)(n)}n(n,i){try{const o=this.p(n,i),h=(0,k.getWorkspaceIdentifier)(n);return{id:h.id,configPath:h.configPath,folders:(0,I.toWorkspaceFolders)(o.folders,h.configPath,f.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}p(n,i){const o=(0,r.parse)(i);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(h=>(0,I.isStoredWorkspaceFolder)(h));else throw new Error(`${n.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(n,i){const{workspace:o,storedWorkspace:h}=this.r(n,i),g=o.configPath.fsPath;return await w.Promises.mkdir((0,P.dirname)(g),{recursive:!0}),await w.Promises.writeFile(g,JSON.stringify(h,null,"	")),this.f.push({workspace:o,remoteAuthority:i}),o}r(n=[],i){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),h=(0,f.joinPath)(this.c,o),g=(0,f.joinPath)(h,d.UNTITLED_WORKSPACE_NAME),D=[];for(const R of n)D.push((0,I.getStoredWorkspaceFolder)(R.uri,!0,R.name,h,f.extUriBiasedIgnorePathCase));return{workspace:(0,k.getWorkspaceIdentifier)(g),storedWorkspace:{folders:D,remoteAuthority:i}}}async getWorkspaceIdentifier(n){return(0,k.getWorkspaceIdentifier)(n)}isUntitledWorkspace(n){return(0,d.isUntitledWorkspace)(n.configPath,this.g)}async deleteUntitledWorkspace(n){this.isUntitledWorkspace(n)&&(await this.s(n),this.i.isEnabled()&&this.i.unsetWorkspace(n),this.a.fire(n))}async s(n){const i=(0,f.originalFSPath)(n.configPath);try{await w.Promises.rm((0,P.dirname)(i));const o=(0,P.join)(this.g.workspaceStorageHome.fsPath,n.id);await w.Promises.exists(o)&&await w.Promises.writeFile((0,P.join)(o,"obsolete"),""),this.f=this.f.filter(h=>h.workspace.id!==n.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${i} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(n,i,o){if(!n||!n.win||!n.isReady||!await this.t(n,i,o))return;const g=await this.u(n,(0,k.getWorkspaceIdentifier)(o));if(g)return this.b.fire({window:n,workspace:g.workspace}),g}async t(n,i,o){return o?(0,d.isWorkspaceIdentifier)(n.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(n.openedWorkspace.configPath,o)?!1:(0,a.findWindowOnWorkspaceOrFolder)(i,o)?(await this.k.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:(0,m.localize)(1,null,(0,f.basename)(o)),detail:(0,m.localize)(2,null)},(0,l.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1):!0:!0}async u(n,i){if(!n.config)return;n.focus();let o;return n.config.extensionDevelopmentPath||(n.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:i,remoteAuthority:n.remoteAuthority},n.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:i,remoteAuthority:n.remoteAuthority})),(0,d.isWorkspaceIdentifier)(n.openedWorkspace)&&this.isUntitledWorkspace(n.openedWorkspace)&&await this.deleteUntitledWorkspace(n.openedWorkspace),n.config.workspace=i,n.config.backupPath=o,{workspace:i,backupPath:o}}};e.WorkspacesManagementMainService=t=ve([Z(0,b.IEnvironmentMainService),Z(1,s.ILogService),Z(2,y.IUserDataProfilesMainService),Z(3,v.IBackupMainService),Z(4,u.IDialogMainService)],t)}),define(te[132],ie([0,1,15,38,21,6,28,29,54,11,5,60]),function(x,e,E,A,r,O,M,P,f,l,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,O.createDecorator)(e.ID);let v=e.DiagnosticsMainService=class{constructor(b,p,s){this.a=b,this.b=p,this.c=s}async getRemoteDiagnostics(b){const p=this.a.getWindows();return(await Promise.all(p.map(async y=>{const a=y.remoteAuthority;if(!a)return;const d=`vscode:getDiagnosticInfoResponse${y.id}`,I={includeProcesses:b.includeProcesses,folders:b.includeWorkspaceMetadata?await this.f(y):void 0};return new Promise(k=>{y.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:d,args:I}),A.validatedIpcMain.once(d,(t,c)=>{c||k({hostName:a,errorMessage:`Unable to resolve connection to '${a}'.`}),k(c)}),setTimeout(()=>{k({hostName:a,errorMessage:`Connection to '${a}' could not be established`})},5e3)})}))).filter(y=>!!y)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const b=[];for(const s of E.BrowserWindow.getAllWindows()){const y=this.a.getWindowById(s.id);y?b.push(await this.d(y)):b.push(this.e(s))}const p=[];for(const{pid:s,name:y}of m.UtilityProcess.getAll())p.push({pid:s,name:y});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:b,pidToNames:p,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(b){const p=await this.f(b),s=(0,l.assertIsDefined)(b.win);return this.e(s,p,b.remoteAuthority)}e(b,p=[],s){return{id:b.id,pid:b.webContents.getOSProcessId(),title:b.getTitle(),folderURIs:p,remoteAuthority:s}}async f(b){const p=[],s=b.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(s))p.push(s.uri);else if((0,P.isWorkspaceIdentifier)(s)){const y=await this.b.resolveLocalWorkspace(s.configPath);y&&y.folders.forEach(d=>{p.push(d.uri)})}return p}};e.DiagnosticsMainService=v=ve([Z(0,M.IWindowsMainService),Z(1,f.IWorkspacesManagementMainService),Z(2,w.ILogService)],v)}),define(te[67],ie([0,1,46,15,27,154,55,4,2,14,9,3,8,105,86,22,103,180,59,30,6,20,5,23,79,28,29,54,17,241,234]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a,d,I,k,t,c,n,i,o,h,g,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,I.createDecorator)("nativeHostMainService");let S=e.NativeHostMainService=class extends f.Disposable{constructor(T,U,H,re,Y,ne,ce,le){super(),this.a=T,this.b=U,this.c=H,this.f=re,this.g=Y,this.h=ne,this.i=ce,this.j=le,this.onDidOpenWindow=P.Event.map(this.a.onDidOpenWindow,X=>X.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:X,x:G,y:N})=>({windowId:X.id,x:G,y:N})),({windowId:X})=>!!this.a.getWindowById(X)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-maximize",(X,G)=>G.id),X=>!!this.a.getWindowById(X)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-unmaximize",(X,G)=>G.id),X=>!!this.a.getWindowById(X)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(X,G)=>G.id),X=>!!this.a.getWindowById(X)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),X=>!!X),X=>X.id),P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(X,G)=>G.id),X=>!!this.a.getWindowById(X))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this.onDidChangeColorScheme=this.i.onDidChangeColorScheme,this.k=this.B(new P.Emitter),this.onDidChangePassword=this.k.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(X,G,N)=>N),X=>!(Array.isArray(X)&&X.length===1&&X[0]==="workArea")),P.Event.fromNodeEventEmitter(A.screen,"display-added"),P.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace??(0,o.toWorkspaceIdentifier)(U.backupPath,U.isExtensionDevelopmentHost),title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(T){return this.a.getWindowCount()}async getActiveWindowId(T){const U=A.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(U)return U.id}openWindow(T,U,H){return Array.isArray(U)?this.l(T,U,H):this.m(T,U)}async l(T,U,H=Object.create(null)){U.length>0&&await this.a.open({context:5,contextWindowId:T,urisToOpen:U,cli:this.f.args,forceNewWindow:H.forceNewWindow,forceReuseWindow:H.forceReuseWindow,preferNewWindow:H.preferNewWindow,diffMode:H.diffMode,mergeMode:H.mergeMode,addMode:H.addMode,gotoLineMode:H.gotoLineMode,noRecentEntry:H.noRecentEntry,waitMarkerFileURI:H.waitMarkerFileURI,remoteAuthority:H.remoteAuthority||void 0,forceProfile:H.forceProfile,forceTempProfile:H.forceTempProfile})}async m(T,U){await this.a.openEmptyWindow({context:5,contextWindowId:T},U)}async toggleFullScreen(T){this.u(T)?.toggleFullScreen()}async handleTitleDoubleClick(T){this.u(T)?.handleTitleDoubleClick()}async isMaximized(T){const U=this.u(T);return U?.win?U.win.isMaximized():!1}async maximizeWindow(T){const U=this.u(T);U?.win&&U.win.maximize()}async unmaximizeWindow(T){const U=this.u(T);U?.win&&U.win.unmaximize()}async minimizeWindow(T){const U=this.u(T);U?.win&&U.win.minimize()}async updateWindowControls(T,U){const H=this.u(T);H&&H.updateWindowControls(U)}async focusWindow(T,U){U&&typeof U.windowId=="number"&&(T=U.windowId),this.u(T)?.focus({force:U?.force??!1})}async setMinimumSize(T,U,H){const re=this.u(T);if(re?.win){const[Y,ne]=re.win.getSize(),[ce,le]=re.win.getMinimumSize(),[X,G]=[U??ce,H??le],[N,F]=[Math.max(Y,X),Math.max(ne,G)];(ce!==X||le!==G)&&re.win.setMinimumSize(X,G),(Y!==N||ne!==F)&&re.win.setSize(N,F)}}async saveWindowSplash(T,U){this.i.saveWindowSplash(T,U)}async installShellCommand(T){const{source:U,target:H}=await this.n();try{const{symbolicLink:re}=await p.SymlinkSupport.stat(U);if(re&&!re.dangling){const Y=await(0,u.realpath)(U);if(H===Y)return}await p.Promises.unlink(U)}catch(re){if(re.code!=="ENOENT")throw re}try{await p.Promises.symlink(H,U)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:Y}=await this.showMessageBox(T,{type:"info",message:(0,y.localize)(0,null,this.h.nameShort),buttons:[(0,y.localize)(1,null),(0,y.localize)(2,null)]});if(Y===0)try{const ne=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${H}' '${U}'\\" with administrator privileges"`;await(0,O.promisify)(E.exec)(ne)}catch{throw new Error((0,y.localize)(3,null,U))}}}async uninstallShellCommand(T){const{source:U}=await this.n();try{await p.Promises.unlink(U)}catch(H){switch(H.code){case"EACCES":{const{response:re}=await this.showMessageBox(T,{type:"info",message:(0,y.localize)(4,null,this.h.nameShort),buttons:[(0,y.localize)(5,null),(0,y.localize)(6,null)]});if(re===0)try{const Y=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,O.promisify)(E.exec)(Y)}catch{throw new Error((0,y.localize)(7,null,U))}break}case"ENOENT":break;default:throw H}}}async n(){const T=(0,w.resolve)(this.f.appRoot,"bin","code"),U=`/usr/local/bin/${this.h.applicationName}`;if(!await p.Promises.exists(T))throw new Error((0,y.localize)(8,null,T));return{source:U,target:T}}async showMessageBox(T,U){return this.b.showMessageBox(U,this.p(T))}async showSaveDialog(T,U){return this.b.showSaveDialog(U,this.p(T))}async showOpenDialog(T,U){return this.b.showOpenDialog(U,this.p(T))}p(T){const U=this.u(T);if(U?.win)return U.win}async pickFileFolderAndOpen(T,U){const H=await this.b.pickFileFolder(U);H&&await this.r(await Promise.all(H.map(async re=>await p.SymlinkSupport.existsDirectory(re)?{folderUri:v.URI.file(re)}:{fileUri:v.URI.file(re)})),U,T)}async pickFolderAndOpen(T,U){const H=await this.b.pickFolder(U);H&&await this.r(H.map(re=>({folderUri:v.URI.file(re)})),U,T)}async pickFileAndOpen(T,U){const H=await this.b.pickFile(U);H&&await this.r(H.map(re=>({fileUri:v.URI.file(re)})),U,T)}async pickWorkspaceAndOpen(T,U){const H=await this.b.pickWorkspace(U);H&&await this.r(H.map(re=>({workspaceUri:v.URI.file(re)})),U,T)}async r(T,U,H){await this.a.open({context:3,contextWindowId:H,cli:this.f.args,urisToOpen:T,forceNewWindow:U.forceNewWindow})}async showItemInFolder(T,U){A.shell.showItemInFolder(U)}async setRepresentedFilename(T,U){this.u(T)?.setRepresentedFilename(U)}async setDocumentEdited(T,U){this.u(T)?.setDocumentEdited(U)}async openExternal(T,U){return m.isLinuxSnap?this.s(U):A.shell.openExternal(U),!0}s(T){const U=process.env.GDK_PIXBUF_MODULE_FILE,H=process.env.GDK_PIXBUF_MODULEDIR,re=process.env.GTK_IM_MODULE_FILE,Y=process.env.GDK_BACKEND,ne=process.env.GIO_MODULE_DIR,ce=process.env.GTK_EXE_PREFIX,le=process.env.GSETTINGS_SCHEMA_DIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,delete process.env.GTK_IM_MODULE_FILE,delete process.env.GDK_BACKEND,delete process.env.GIO_MODULE_DIR,delete process.env.GTK_EXE_PREFIX,delete process.env.GSETTINGS_SCHEMA_DIR,A.shell.openExternal(T),process.env.GDK_PIXBUF_MODULE_FILE=U,process.env.GDK_PIXBUF_MODULEDIR=H,process.env.GTK_IM_MODULE_FILE=re,process.env.GDK_BACKEND=Y,process.env.GIO_MODULE_DIR=ne,process.env.GTK_EXE_PREFIX=ce,process.env.GSETTINGS_SCHEMA_DIR=le}moveItemToTrash(T,U){return A.shell.trashItem(U)}async isAdmin(){let T;return m.isWindows?T=(await new Promise((U,H)=>{x(["native-is-elevated"],U,H)}))():T=process.getuid()===0,T}async writeElevated(T,U,H,re){const Y=await new Promise((ne,ce)=>{x(["@vscode/sudo-prompt"],ne,ce)});return new Promise((ne,ce)=>{const le=[`"${this.t}"`];re?.unlock&&le.push("--file-chmod"),le.push("--file-write",`"${U.fsPath}"`,`"${H.fsPath}"`);const X={name:this.h.nameLong.replace("-",""),icns:m.isMacintosh&&this.f.isBuilt?(0,w.join)((0,w.dirname)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};Y.exec(le.join(" "),X,(G,N,F)=>{N&&this.g.trace(`[sudo-prompt] received stdout: ${N}`),F&&this.g.trace(`[sudo-prompt] received stderr: ${F}`),G?ce(G):ne(void 0)})})}get t(){return m.isWindows?this.f.isBuilt?(0,w.join)((0,w.dirname)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,w.join)(this.f.appRoot,"scripts","code-cli.bat"):m.isLinux?this.f.isBuilt?(0,w.join)((0,w.dirname)(process.execPath),"bin",`${this.h.applicationName}`):(0,w.join)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,w.join)(this.f.appRoot,"bin","code"):(0,w.join)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return b.virtualMachineHint.value()}async getOSColorScheme(){return this.i.getColorScheme()}async hasWSLFeatureInstalled(){return m.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(T,U,H){process.kill(U,H)}async readClipboardText(T,U){return A.clipboard.readText(U)}async writeClipboardText(T,U,H){return A.clipboard.writeText(U,H)}async readClipboardFindText(T){return A.clipboard.readFindText()}async writeClipboardFindText(T,U){return A.clipboard.writeFindText(U)}async writeClipboardBuffer(T,U,H,re){return A.clipboard.writeBuffer(U,Buffer.from(H.buffer),re)}async readClipboardBuffer(T,U){return g.VSBuffer.wrap(A.clipboard.readBuffer(U))}async hasClipboard(T,U,H){return A.clipboard.has(U,H)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(T,U){this.u(T)?.updateTouchBar(U)}async notifyReady(T){this.u(T)?.setReady()}async relaunch(T,U){return this.c.relaunch(U)}async reload(T,U){const H=this.u(T);if(H){if((0,o.isWorkspaceIdentifier)(H.openedWorkspace)){const re=H.openedWorkspace.configPath;if(re.scheme===l.Schemas.file&&(await this.j.resolveLocalWorkspace(re))?.transient)return this.openWindow(H.id,{forceReuseWindow:!0})}return this.c.reload(H,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(T){this.closeWindowById(T,T)}async closeWindowById(T,U){const H=this.u(U);if(H?.win)return H.win.close()}async quit(T){const U=this.a.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&U.win?U.win.close():this.c.quit()}async exit(T,U){await this.c.kill(U)}async resolveProxy(T,U){return this.u(T)?.win?.webContents?.session?.resolveProxy(U)}findFreePort(T,U,H,re,Y=1){return(0,s.findFreePort)(U,H,re,Y)}async openDevTools(T,U){const H=this.u(T);H?.win&&H.win.webContents.openDevTools(U)}async toggleDevTools(T){const U=this.u(T);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(T,U){const H=this.u(T);H?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&H.win.webContents.sendInputEvent(U)}async profileRenderer(T,U,H){const re=this.u(T);if(!re||!re.win)throw new Error;return await new R.WindowProfiler(re.win,U,this.g).inspect(H)}async windowsGetStringRegKey(T,U,H,re){if(!m.isWindows)return;const Y=await new Promise((ne,ce)=>{x(["@vscode/windows-registry"],ne,ce)});try{return Y.GetStringRegKey(U,H,re)}catch{return}}u(T){if(typeof T=="number")return this.a.getWindowById(T)}};ve([M.memoize],S.prototype,"t",null),e.NativeHostMainService=S=ve([Z(0,i.IWindowsMainService),Z(1,a.IDialogMainService),Z(2,k.ILifecycleMainService),Z(3,d.IEnvironmentMainService),Z(4,t.ILogService),Z(5,c.IProductService),Z(6,n.IThemeMainService),Z(7,h.IWorkspacesManagementMainService)],S)}),define(te[296],ie([0,1,15,38,27,2,14,3,107,178,89,132,59,30,5,67,77,23,78,80,32,11,34,60,21,8,28,7]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a,d,I,k,t,c,n,i,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const g="issue.processExplorerWindowState";let D=e.IssueMainService=class Rt{constructor(L,T,U,H,re,Y,ne,ce,le,X,G){this.g=L,this.h=T,this.i=U,this.j=H,this.k=re,this.l=Y,this.m=ne,this.n=ce,this.o=le,this.p=X,this.q=G,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){A.validatedIpcMain.on("vscode:listProcesses",async L=>{const T=[];try{T.push({name:(0,l.localize)(0,null),rootProcess:await(0,f.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(H=>{(0,w.isRemoteDiagnosticError)(H)?T.push({name:H.hostName,rootProcess:H}):H.processes&&T.push({name:H.hostName,rootProcess:H.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(L,"vscode:listProcessesResponse",T)}),A.validatedIpcMain.on("vscode:workbenchCommand",(L,T)=>{const{id:U,from:H,args:re}=T;let Y;switch(H){case"processExplorer":Y=this.f;break;default:throw new Error(`Unexpected command source: ${H}`)}Y?.webContents.send("vscode:runAction",{id:U,from:H,args:re})}),A.validatedIpcMain.on("vscode:closeProcessExplorer",L=>{this.d?.close()}),A.validatedIpcMain.on("vscode:pidToNameRequest",async L=>{const T=await this.k.getMainDiagnostics(),U=[];for(const H of T.windows)U.push([H.pid,`window [${H.id}] (${H.title})`]);for(const{pid:H,name:re}of c.UtilityProcess.getAll())U.push([H,re]);this.t(L,"vscode:pidToNameResponse",U)})}async openReporter(L){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const T=new O.DisposableStore,U=T.add(this.n.createIPCObjectUrl()),H=this.v(this.c,700,800);this.b=this.u(H,U,{backgroundColor:L.styles.backgroundColor,title:(0,l.localize)(1,null),zoomLevel:L.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:L,disableExtensions:!!this.h.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:s.default}),this.b.loadURL(M.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,T.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,T.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(L){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const T=new O.DisposableStore,U=T.add(this.n.createIPCObjectUrl()),H=this.p.getItem(g,void 0),re=R(H)?H:this.v(this.f,800,500);this.d=this.u(re,U,{backgroundColor:L.styles.backgroundColor,title:(0,l.localize)(2,null),zoomLevel:L.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:L,product:s.default}),this.d.loadURL(M.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,T.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,T.dispose())});const Y=()=>{if(!this.d)return;const ne=this.d.getSize(),ce=this.d.getPosition();if(!ne||!ce)return;const le={width:ne[0],height:ne[1],x:ce[0],y:ce[1]};this.p.setItem(g,le)};this.d.on("moved",Y),this.d.on("resized",Y)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const L=await E.contentTracing.stopRecording(`${(0,I.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,l.localize)(3,null),detail:(0,l.localize)(4,null,L),buttons:[(0,l.localize)(5,null)]},(0,k.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,L)}async getSystemStatus(){const[L,T]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(L,T)}async $getSystemInfo(){const[L,T]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(L,T)}async $getPerformanceInfo(){try{const[L,T]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(L,T)}catch(L){throw this.i.warn("issueService#getPerformanceInfo ",L.message),L}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(L){this.i.error(L)}}async $showConfirmCloseDialog(){if(this.b){const{response:L}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(6,null),buttons:[(0,l.localize)(7,null),(0,l.localize)(8,null)]},this.b);L===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:L}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(9,null),buttons:[(0,l.localize)(10,null),(0,l.localize)(11,null)]},this.b);return L===0}return!1}async $getIssueReporterUri(L){if(!this.c)throw new Error("Issue reporter window not available");const T=this.q.getWindowById(this.c.id);if(!T)throw new Error("Window not found");const U=`vscode:triggerIssueUriRequestHandlerResponse${T.id}`;return h.Promises.withAsyncBody(async(H,re)=>{const Y=new n.CancellationTokenSource;T.sendWhenReady("vscode:triggerIssueUriRequestHandler",Y.token,{replyChannel:U,extensionId:L}),A.validatedIpcMain.once(U,(ne,ce)=>{H(i.URI.parse(ce))});try{await(0,h.timeout)(5e3),Y.cancel(),re(new Error("Timed out waiting for issue reporter URI"))}finally{A.validatedIpcMain.removeHandler(U)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(L){L.isMinimized()&&L.restore(),L.focus()}t(L,T,...U){L.sender.isDestroyed()||L.sender.send(T,...U)}u(L,T,U,H){const re=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:L.width,height:L.height,minWidth:300,minHeight:200,x:L.x,y:L.y,title:U.title,backgroundColor:U.backgroundColor||Rt.a,webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${T.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,d.zoomLevelToZoomFactor)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return re.setMenuBarVisibility(!1),re}v(L,T,U){let H;const re=E.screen.getAllDisplays();if(re.length===1)H=re[0];else{if(P.isMacintosh){const ce=E.screen.getCursorScreenPoint();H=E.screen.getDisplayNearestPoint(ce)}!H&&L&&(H=E.screen.getDisplayMatching(L.getBounds())),H||(H=E.screen.getPrimaryDisplay()||re[0])}const Y=H.bounds,ne={width:T,height:U,x:Y.x+Y.width/2-T/2,y:Y.y+Y.height/2-U/2};return Y.width>0&&Y.height>0&&(ne.x<Y.x&&(ne.x=Y.x),ne.y<Y.y&&(ne.y=Y.y),ne.x>Y.x+Y.width&&(ne.x=Y.x),ne.y>Y.y+Y.height&&(ne.y=Y.y),ne.width>Y.width&&(ne.width=Y.width),ne.height>Y.height&&(ne.height=Y.height)),ne}};D.a="#1E1E1E",e.IssueMainService=D=ve([Z(1,u.IEnvironmentMainService),Z(2,b.ILogService),Z(3,w.IDiagnosticsService),Z(4,m.IDiagnosticsMainService),Z(5,v.IDialogMainService),Z(6,p.INativeHostMainService),Z(7,a.IProtocolMainService),Z(8,y.IProductService),Z(9,t.IStateService),Z(10,o.IWindowsMainService)],D);function R(S){return typeof S!="object"||S===null?!1:"x"in S&&"y"in S&&"width"in S&&"height"in S}}),define(te[297],ie([0,1,21,19,30,20,5,67,23,51,26,48,99]),function(x,e,E,A,r,O,M,P,f,l,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let u=e.LinuxUpdateService=class extends v.AbstractUpdateService{constructor(p,s,y,a,d,I,k,t){super(p,s,a,d,I,t),this.e=y,this.u=k}s(p){return(0,v.createUpdateURL)(`linux-${process.arch}`,p,this.k)}t(p){this.a&&(this.d(m.State.CheckingForUpdates(p)),this.i.request({url:this.a},E.CancellationToken.None).then(l.asJson).then(s=>{!s||!s.url||!s.version||!s.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!p}),this.d(m.State.Idle(1))):this.d(m.State.AvailableForDownload(s))}).then(void 0,s=>{this.j.error(s),this.e.publicLog2("update:notAvailable",{explicit:!!p});const y=p?s.message||s:void 0;this.d(m.State.Idle(1,y))}))}async o(p){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):p.update.url&&this.u.openExternal(void 0,p.update.url),this.d(m.State.Idle(1))}};e.LinuxUpdateService=u=ve([Z(0,O.ILifecycleMainService),Z(1,A.IConfigurationService),Z(2,w.ITelemetryService),Z(3,r.IEnvironmentMainService),Z(4,l.IRequestService),Z(5,M.ILogService),Z(6,P.INativeHostMainService),Z(7,f.IProductService)],u)}),define(te[298],ie([0,1,46,42,27,7,21,55,9,8,140,22,19,30,16,20,5,67,23,51,26,48,99]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a,d,I,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function c(h,g=1e3){for(;!h();)await(0,O.timeout)(g)}let n;function i(){return typeof n>"u"&&(n=A.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),n}let o=e.Win32UpdateService=class extends t.AbstractUpdateService{get cachePath(){const g=f.join((0,r.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return m.Promises.mkdir(g,{recursive:!0}).then(()=>g)}constructor(g,D,R,S,L,T,U,H,re){super(g,D,S,L,T,re),this.u=R,this.v=U,this.w=H}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(g){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),i()===1?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,t.createUpdateURL)(D,g,this.k)}t(g){this.a&&(this.d(k.State.CheckingForUpdates(g)),this.i.request({url:this.a},M.CancellationToken.None).then(d.asJson).then(D=>{const R=i();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!g}),this.d(k.State.Idle(R)),Promise.resolve(null)):R===1?(this.d(k.State.AvailableForDownload(D)),Promise.resolve(null)):(this.d(k.State.Downloading(D)),this.C(D.version).then(()=>this.B(D.version).then(S=>m.Promises.exists(S).then(L=>{if(L)return Promise.resolve(S);const T=D.url,U=D.hash,H=`${S}.tmp`;return this.i.request({url:T},M.CancellationToken.None).then(re=>this.v.writeFile(l.URI.file(H),re.stream)).then(U?()=>(0,w.checksum)(H,D.hash):()=>{}).then(()=>m.Promises.rename(H,S)).then(()=>S)})).then(S=>{const L=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:S},L&&D.supportsFastUpdate?this.k.target==="user"?this.p():this.d(k.State.Downloaded(D)):this.d(k.State.Ready(D))})))}).then(void 0,D=>{this.j.error(D),this.u.publicLog2("update:notAvailable",{explicit:!!g});const R=g?D.message||D:void 0;this.d(k.State.Idle(i(),R))}))}async o(g){g.update.url&&this.w.openExternal(void 0,g.update.url),this.d(k.State.Idle(i()))}async B(g){const D=await this.cachePath;return f.join(D,`CodeSetup-${this.k.quality}-${g}.exe`)}async C(g=null){const D=g?T=>!new RegExp(`${this.k.quality}-${g}\\.exe$`).test(T):()=>!0,R=await this.cachePath,L=(await m.Promises.readdir(R)).filter(D).map(async T=>{try{await m.Promises.unlink(f.join(R,T))}catch{}});await Promise.all(L)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const g=this.state.update;this.d(k.State.Updating(g));const D=await this.cachePath;this.e.updateFilePath=f.join(D,`CodeSetup-${this.k.quality}-${g.version}.flag`),await m.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(k.State.Idle(i()))});const S=`${this.k.win32MutexName}-ready`,L=await new Promise((T,U)=>{x(["@vscode/windows-mutex"],T,U)});c(()=>L.isActive(S)).then(()=>this.d(k.State.Ready(g)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?A.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return i()}async _applySpecificUpdate(g){if(this.state.type!=="idle")return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),R={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!D};this.d(k.State.Downloading(R)),this.e={packagePath:g},D?this.k.target==="user"?this.p():this.d(k.State.Downloaded(R)):this.d(k.State.Ready(R))}};ve([P.memoize],o.prototype,"cachePath",null),e.Win32UpdateService=o=ve([Z(0,p.ILifecycleMainService),Z(1,v.IConfigurationService),Z(2,I.ITelemetryService),Z(3,u.IEnvironmentMainService),Z(4,d.IRequestService),Z(5,s.ILogService),Z(6,b.IFileService),Z(7,y.INativeHostMainService),Z(8,a.IProductService)],o)}),define(te[299],ie([0,1,15,7,21,50,4,2,14,9,65,3,8,188,64,19,59,30,63,16,20,5,23,78,249,98,26,102,79,80,28,29,54,127,133,39,34,53,66,24]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a,d,I,k,t,c,n,i,o,h,g,D,R,S,L,T,U,H,re,Y,ne,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var le;(function(G){G[G.NONE=0]="NONE",G[G.NAVIGATING=1]="NAVIGATING",G[G.READY=2]="READY"})(le||(le={}));let X=e.CodeWindow=class bt extends P.Disposable{get id(){return this.j}get win(){return this.k}get lastFocusTime(){return this.l}get backupPath(){return this.m?.backupPath}get openedWorkspace(){return this.m?.workspace}get profile(){if(!this.config)return;const N=this.O.profiles.find(F=>F.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&N?N:this.O.getProfileForWorkspace(this.config.workspace??(0,S.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.O.defaultProfile}get remoteAuthority(){return this.m?.remoteAuthority}get config(){return this.m}get isExtensionDevelopmentHost(){return!!this.m?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.m?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.m?.debugId}constructor(N,F,V,J,_,ae,oe,B,C,W,z,q,j,$,K,se,ue,be,ke,Me){super(),this.J=F,this.L=V,this.M=J,this.N=_,this.O=ae,this.P=oe,this.Q=B,this.R=C,this.S=W,this.U=z,this.W=q,this.X=j,this.Y=$,this.Z=K,this.ab=se,this.bb=ue,this.db=be,this.eb=ke,this.fb=Me,this.b=this.B(new M.Emitter),this.onWillLoad=this.b.event,this.c=this.B(new M.Emitter),this.onDidSignalReady=this.c.event,this.f=this.B(new M.Emitter),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new M.Emitter),this.onDidClose=this.g.event,this.h=this.B(new M.Emitter),this.onDidDestroy=this.h.event,this.l=-1,this.s=void 0,this.t=void 0,this.w=!1,this.z=[],this.C=[],this.D=void 0,this.F=void 0,this.G=this.B(this.db.createIPCObjectUrl()),this.I=!1,this.gb=0;{const[Ae,Fe]=this.qb(N.state);this.n=Ae,this.J.trace("window#ctor: using window state",Ae);const ye=this.n.mode===0||this.n.mode===3,we=this.S.getValue("window"),Ee={width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y,backgroundColor:this.U.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!ye,title:this.bb.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.G.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(we?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};m.isLinux?Ee.icon=(0,l.join)(this.M.appRoot,"resources/linux/code.png"):m.isWindows&&!this.M.isBuilt&&(Ee.icon=(0,l.join)(this.M.appRoot,"resources/win32/code_150x150.png")),m.isMacintosh&&!this.xb()&&(Ee.fullscreenable=!1),m.isMacintosh&&(Ee.acceptFirstMouse=!0,we?.clickThroughInactive===!1&&(Ee.acceptFirstMouse=!1));const ee=m.isMacintosh&&we?.nativeTabs===!0;ee&&(Ee.tabbingIdentifier=this.bb.nameShort);const he=(0,D.getTitleBarStyle)(this.S)==="custom";if(he&&(Ee.titleBarStyle="hidden",m.isMacintosh||(Ee.frame=!1),(0,D.useWindowControlsOverlay)(this.S))){const fe=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Ce=U.Color.fromHex(fe).isDarker()?"#FFFFFF":"#000000";Ee.titleBarOverlay={height:29,color:fe,symbolColor:Ce},this.w=!0}if((0,w.mark)("code/willCreateCodeBrowserWindow"),this.k=new E.BrowserWindow(Ee),(0,w.mark)("code/didCreateCodeBrowserWindow"),this.j=this.k.id,m.isMacintosh&&he&&this.k.setSheetOffset(22),he&&(m.isWindows&&(0,D.useWindowControlsOverlay)(this.S)||m.isMacintosh)){const fe=this.fb.getItem(bt.a);fe&&this.updateWindowControls({height:fe})}m.isWindows&&he&&this.k.hookWindowMessage(278,()=>{const[Ce,De]=this.k.getPosition(),Oe=E.screen.getCursorScreenPoint(),We=Oe.x-Ce,He=Oe.y-De;return(()=>!(We>30&&He>=0&&He<=Math.max(this.k.getBounds().height*.15,35)))()||(this.k.setEnabled(!1),this.k.setEnabled(!0),this.f.fire({x:We,y:He})),0}),(m.isMacintosh||m.isWindows)&&Fe&&(!ee||E.BrowserWindow.getAllWindows().length===1)&&[this.n.width,this.n.height,this.n.x,this.n.y].every(fe=>typeof fe=="number")&&this.k.setBounds({width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y}),ye&&((0,w.mark)("code/willMaximizeCodeWindow"),this.k.maximize(),this.n.mode===3&&this.tb(!0),this.k.show(),(0,w.mark)("code/didMaximizeCodeWindow")),this.l=Date.now()}this.M.args["open-devtools"]===!0&&this.k.webContents.openDevTools(),this.nb(),this.Bb(),this.hb()}setRepresentedFilename(N){m.isMacintosh?this.k.setRepresentedFilename(N):this.u=N}getRepresentedFilename(){return m.isMacintosh?this.k.getRepresentedFilename():this.u}setDocumentEdited(N){m.isMacintosh&&this.k.setDocumentEdited(N),this.v=N}isDocumentEdited(){return m.isMacintosh?this.k.isDocumentEdited():!!this.v}focus(N){m.isMacintosh&&N?.force&&E.app.focus({steal:!0}),this.k&&(this.k.isMinimized()&&this.k.restore(),this.k.focus())}setReady(){for(this.J.trace(`window#load: window reported ready (id: ${this.j})`),this.gb=2;this.z.length;)this.z.pop()(this);this.c.fire()}ready(){return new Promise(N=>{if(this.isReady)return N(this);this.z.push(N)})}get isReady(){return this.gb===2}get whenClosedOrLoaded(){return new Promise(N=>{function F(){V.dispose(),J.dispose(),N()}const V=this.onDidClose(()=>F()),J=this.onWillLoad(()=>F())})}hb(){this.k.on("unresponsive",()=>this.kb(1)),this.k.webContents.on("render-process-gone",(F,V)=>this.kb(2,{...V})),this.k.webContents.on("did-fail-load",(F,V,J)=>this.kb(3,{reason:J,exitCode:V})),this.k.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this.k.on("closed",()=>{this.g.fire(),this.dispose()}),this.k.webContents.on("did-finish-load",()=>{this.H&&(this.m=this.H,this.H=void 0)}),this.k.on("focus",()=>{this.l=Date.now()}),this.k.on("maximize",F=>{this.m&&(this.m.maximized=!0),E.app.emit("browser-window-maximize",F,this.k)}),this.k.on("unmaximize",F=>{this.m&&(this.m.maximized=!1),E.app.emit("browser-window-unmaximize",F,this.k)}),this.k.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.k.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.B(this.S.onDidChangeConfiguration(F=>this.nb(F))),this.B(this.W.onDidDeleteUntitledWorkspace(F=>this.mb(F)));const N=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.k.webContents.session.webRequest.onBeforeSendHeaders({urls:N},async(F,V)=>{const J=await this.jb();V({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,J)})})}jb(){return this.ib||(this.ib=(0,n.resolveMarketplaceHeaders)(this.bb.version,this.bb,this.M,this.S,this.P,this.Q,this.Y)),this.ib}async kb(N,F){switch(N){case 2:this.J.error(`CodeWindow: renderer process gone (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.J.error("CodeWindow: detected unresponsive");break;case 3:this.J.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:N,reason:F?.reason,code:F?.exitCode}),N){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.ab.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.lb(!1,!1),this.ab.quit();return}if(N===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.k&&this.k.webContents&&this.k.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:J}=await this.Z.showMessageBox({type:"warning",buttons:[(0,u.localize)(0,null),(0,u.localize)(1,null),(0,u.localize)(2,null)],message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null),checkboxLabel:this.m?.workspace?(0,u.localize)(5,null):void 0},this.k);if(V!==2){const _=V===0;await this.lb(_,J)}}else if(N===2){let V;F?V=(0,u.localize)(7,null,F.reason,F.exitCode??"<unknown>"):V=(0,u.localize)(6,null);const{response:J,checkboxChecked:_}=await this.Z.showMessageBox({type:"warning",buttons:[this.m?.workspace?(0,u.localize)(8,null):(0,u.localize)(9,null),(0,u.localize)(10,null)],message:V,detail:this.m?.workspace?(0,u.localize)(11,null):(0,u.localize)(12,null),checkboxLabel:this.m?.workspace?(0,u.localize)(13,null):void 0},this.k),ae=J===0;await this.lb(ae,_)}break}}async lb(N,F){const V=this.m?.workspace;if(F&&V)try{const J=this.R.workspaceStorage(V);await J.init(),J.delete("memento/workbench.parts.editor"),await J.close()}catch(J){this.J.error(J)}if(this.h.fire(),this.k?.destroy(),N&&this.m){let J,_;(0,S.isSingleFolderWorkspaceIdentifier)(V)?J={folderUri:V.uri}:(0,S.isWorkspaceIdentifier)(V)?J={workspaceUri:V.configPath}:_=!0,(0,ce.firstOrDefault)(await this.eb.open({context:5,userEnv:this.m.userEnv,cli:{...this.M.args,_:[]},urisToOpen:J?[J]:void 0,forceEmpty:_,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}mb(N){this.m?.workspace?.id===N.id&&(this.m.workspace=void 0)}nb(N){if(!N||N.affectsConfiguration("window.menuBarVisibility")){const F=this.yb();F!==this.r&&(this.r=F,this.zb(F))}if(!N||N.affectsConfiguration("http.proxy")){let F=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;F?.endsWith("/")&&(F=F.substr(0,F.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((F||"").indexOf("@")===-1&&(F!==this.D||V!==this.F)){this.D=F,this.F=V;const J=F||"",_=V?`${V},<local>`:"<local>";this.J.trace(`Setting proxy to '${J}', bypassing '${_}'`),this.k.webContents.session.setProxy({proxyRules:J,proxyBypassRules:_,pacScript:""})}}}addTabbedWindow(N){m.isMacintosh&&N.win&&this.k.addTabbedWindow(N.win)}load(N,F=Object.create(null)){this.J.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!F.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.k.setTitle(this.bb.nameLong)),this.ob(N,F),this.gb===0?this.m=N:this.H=N,this.gb=1,this.k.loadURL(f.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.I;this.I=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new A.RunOnceScheduler(()=>{this.k&&!this.k.isVisible()&&!this.k.isMinimized()&&(this.k.show(),this.focus({force:!0}),this.k.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:N.workspace,reason:F.isReload?3:V?2:1})}ob(N,F){const V=(this.m??this.H)?.userEnv;if(V){const J=(0,a.isLaunchedFromCli)(V)&&!(0,a.isLaunchedFromCli)(N.userEnv),_=this.isExtensionDevelopmentHost;(J||_)&&(N.userEnv={...V,...N.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(N.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(N["disable-extensions"]=F.disableExtensions),N.fullscreen=this.isFullScreen,N.maximized=this.k.isMaximized(),N.partsSplash=this.U.getWindowSplash(),(0,w.mark)("code/willOpenNewWindow"),N.perfMarks=(0,w.getMarks)(),this.G.update(N)}async reload(N){const F=Object.assign({},this.m);F.workspace=await this.pb(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToMerge,delete F.filesToWait,this.isExtensionDevelopmentHost&&N&&(F.verbose=N.verbose,F.debugId=N.debugId,F.extensionEnvironment=N.extensionEnvironment,F["inspect-extensions"]=N["inspect-extensions"],F["inspect-brk-extensions"]=N["inspect-brk-extensions"],F["extensions-dir"]=N["extensions-dir"]),F.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),F.isInitialStartup=!1,F.policiesData=this.N.serialize(),F.continueOn=this.M.continueOn,F.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile,home:this.O.profilesHome},F.logLevel=this.L.getLogLevel(),F.loggers={window:this.L.getRegisteredLoggers(this.id),global:this.L.getRegisteredLoggers()},this.load(F,{isReload:!0,disableExtensions:N?.["disable-extensions"]})}async pb(N){if((0,S.isWorkspaceIdentifier)(N.workspace)){const F=N.workspace.configPath;if(F.scheme===f.Schemas.file&&!await this.P.exists(F))return}else if((0,S.isSingleFolderWorkspaceIdentifier)(N.workspace)){const F=N.workspace.uri;if(F.scheme===f.Schemas.file&&!await this.P.exists(F))return}return N.workspace}serializeWindowState(){if(!this.k)return(0,T.defaultWindowState)();if(this.isFullScreen){let V;try{V=E.screen.getDisplayMatching(this.getBounds())}catch{}const J=(0,T.defaultWindowState)();return{mode:3,display:V?V.id:void 0,width:this.n.width||J.width,height:this.n.height||J.height,x:this.n.x||0,y:this.n.y||0}}const N=Object.create(null);let F;if(!m.isMacintosh&&this.k.isMaximized()?F=0:F=1,F===0?N.mode=0:N.mode=1,F===1||F===0){let V;F===1?V=this.getBounds():V=this.k.getNormalBounds(),N.x=V.x,N.y=V.y,N.width=V.width,N.height=V.height}return N}updateWindowControls(N){if(N.height&&this.fb.setItem(bt.a,N.height),m.isWindows&&this.w)this.k.setTitleBarOverlay({color:N.backgroundColor?.trim()===""?void 0:N.backgroundColor,symbolColor:N.foregroundColor?.trim()===""?void 0:N.foregroundColor,height:N.height?N.height-1:void 0});else if(m.isMacintosh&&N.height!==void 0){const F=(N.height-15)/2;this.k.setTrafficLightPosition({x:F,y:F})}}qb(N){(0,w.mark)("code/willRestoreCodeWindowState");let F=!1;if(N)try{const V=E.screen.getAllDisplays();F=V.length>1,N=this.rb(N,V)}catch(V){this.J.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}return(0,w.mark)("code/didRestoreCodeWindowState"),[N||(0,T.defaultWindowState)(),F]}rb(N,F){if(this.J.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,N),typeof N.x!="number"||typeof N.y!="number"||typeof N.width!="number"||typeof N.height!="number"){this.J.trace("window#validateWindowState: unexpected type of state values");return}if(N.width<=0||N.height<=0){this.J.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const _=this.sb(F[0]);if(_){let ae=function(){!N||typeof N.x!="number"||typeof N.y!="number"||!_||(N.x<_.x&&(N.x=_.x),N.y<_.y&&(N.y=_.y))};this.J.trace("window#validateWindowState: 1 monitor working area",_),ae(),N.width>_.width&&(N.width=_.width),N.height>_.height&&(N.height=_.height),N.x>_.x+_.width-128&&(N.x=_.x+_.width-N.width),N.y>_.y+_.height-128&&(N.y=_.y+_.height-N.height),ae()}return N}if(N.display&&N.mode===3){const _=F.find(ae=>ae.id===N.display);if(_&&typeof _.bounds?.x=="number"&&typeof _.bounds?.y=="number"){this.J.trace("window#validateWindowState: restoring fullscreen to previous display");const ae=(0,T.defaultWindowState)(3);return ae.x=_.bounds.x,ae.y=_.bounds.y,ae}}let V,J;try{V=E.screen.getDisplayMatching({x:N.x,y:N.y,width:N.width,height:N.height}),J=this.sb(V)}catch{}if(V&&J&&N.x+N.width>J.x&&N.y+N.height>J.y&&N.x<J.x+J.width&&N.y<J.y+J.height)return this.J.trace("window#validateWindowState: multi-monitor working area",J),N}sb(N){if(N.workArea.width>0&&N.workArea.height>0)return N.workArea;if(N.bounds.width>0&&N.bounds.height>0)return N.bounds}getBounds(){const[N,F]=this.k.getPosition(),[V,J]=this.k.getSize();return{x:N,y:F,width:V,height:J}}toggleFullScreen(){this.tb(!this.isFullScreen)}tb(N){this.xb()?this.ub(N):this.wb(N),this.sendWhenReady(N?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.r&&this.zb(this.r,!1)}get isFullScreen(){return m.isMacintosh&&typeof this.s=="boolean"?this.s:this.k.isFullScreen()||this.k.isSimpleFullScreen()}ub(N){this.k.isSimpleFullScreen()&&this.k.setSimpleFullScreen(!1),this.vb(N)}vb(N){m.isMacintosh&&(this.s=N,this.t=new A.DeferredPromise,Promise.race([this.t.p,(0,A.timeout)(1e3)]).finally(()=>this.s=void 0)),this.k.setFullScreen(N)}wb(N){this.k.isFullScreen()&&this.vb(!1),this.k.setSimpleFullScreen(N),this.k.webContents.focus()}xb(){const N=this.S.getValue("window");return!N||typeof N.nativeFullScreen!="boolean"||N.nativeTabs?!0:N.nativeFullScreen!==!1}isMinimized(){return this.k.isMinimized()}yb(){let N=(0,D.getMenuBarVisibility)(this.S);return["visible","toggle","hidden"].indexOf(N)<0&&(N="classic"),N}zb(N,F=!0){m.isMacintosh||(N==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,u.localize)(14,null)),N==="hidden"?setTimeout(()=>{this.Ab(N)}):this.Ab(N))}Ab(N){const F=this.isFullScreen;switch(N){case"classic":this.k.setMenuBarVisibility(!F),this.k.autoHideMenuBar=F;break;case"visible":this.k.setMenuBarVisibility(!0),this.k.autoHideMenuBar=!1;break;case"toggle":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!0;break;case"hidden":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.k.minimize();break;case"None":break;case"Maximize":default:this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}else this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}close(){this.k?.close()}sendWhenReady(N,F,...V){this.isReady?this.send(N,...V):this.ready().then(()=>{F.isCancellationRequested||this.send(N,...V)})}send(N,...F){if(this.k){if(this.k.isDestroyed()||this.k.webContents.isDestroyed()){this.J.warn(`Sending IPC message to channel '${N}' for window that is destroyed`);return}try{this.k.webContents.send(N,...F)}catch(V){this.J.warn(`Error sending IPC message to channel '${N}' of window ${this.j}: ${(0,O.toErrorMessage)(V)}`)}}}updateTouchBar(N){m.isMacintosh&&this.C.forEach((F,V)=>{const J=N[V];F.segments=this.Db(J)})}Bb(){if(m.isMacintosh){for(let N=0;N<10;N++){const F=this.Cb();this.C.push(F)}this.k.setTouchBar(new E.TouchBar({items:this.C}))}}Cb(N=[]){const F=this.Db(N),V=new E.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:J=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:V.segments[J].id,from:"touchbar"})}});return V}Db(N=[]){return N.map(V=>{let J;V.icon&&!h.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===f.Schemas.file&&(J=E.nativeImage.createFromPath(v.URI.revive(V.icon.dark).fsPath),J.isEmpty()&&(J=void 0));let _;return typeof V.title=="string"?_=V.title:_=V.title.value,{id:V.id,label:J?void 0:_,icon:J}})}dispose(){super.dispose(),this.L.deregisterLoggers(this.id),this.k=null}};X.a="windowControlHeight",e.CodeWindow=X=ve([Z(1,k.ILogService),Z(2,ne.ILoggerMainService),Z(3,y.IEnvironmentMainService),Z(4,H.IPolicyService),Z(5,Y.IUserDataProfilesMainService),Z(6,d.IFileService),Z(7,i.IApplicationStorageMainService),Z(8,i.IStorageMainService),Z(9,p.IConfigurationService),Z(10,g.IThemeMainService),Z(11,L.IWorkspacesManagementMainService),Z(12,b.IBackupMainService),Z(13,o.ITelemetryService),Z(14,s.IDialogMainService),Z(15,I.ILifecycleMainService),Z(16,t.IProductService),Z(17,c.IProtocolMainService),Z(18,R.IWindowsMainService),Z(19,re.IStateService)],X)}),define(te[82],ie([0,1,15,24,7,4,45,2,14,3,18,8,22,191,6,20,5,98,96,29,54,35]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a,d,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,b.createDecorator)("workspacesHistoryMainService");let t=e.WorkspacesHistoryMainService=class nt extends P.Disposable{constructor(n,i,o,h){super(),this.f=n,this.g=i,this.h=o,this.j=h,this.c=this.B(new O.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new r.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let i=[],o=[];for(const g of n)if((0,a.isRecentWorkspace)(g))!this.g.isUntitledWorkspace(g.workspace)&&!this.r(i,g.workspace)&&i.push(g);else if((0,a.isRecentFolder)(g))this.s(i,g.folderUri)||i.push(g);else{const D=this.t(o,g.fileUri),R=g.fileUri.scheme===f.Schemas.file&&nt.y.indexOf((0,w.basename)(g.fileUri))>=0;!D&&!R&&(o.push(g),l.isWindows&&g.fileUri.scheme===f.Schemas.file&&E.app.addRecentDocument(g.fileUri.fsPath))}const h=await this.l({workspaces:i,files:o});i=h.workspaces,o=h.files,i.length>nt.a&&(i.length=nt.a),o.length>nt.a&&(o.length=nt.a),await this.n({workspaces:i,files:o}),this.c.fire(),l.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(n){const i=D=>{const R=this.p(D);for(const S of n)if(w.extUriBiasedIgnorePathCase.isEqual(S,R))return!1;return!0},o=await this.getRecentlyOpened(),h=o.workspaces.filter(i),g=o.files.filter(i);(h.length!==o.workspaces.length||g.length!==o.files.length)&&(await this.n({files:g,workspaces:h}),this.c.fire(),l.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(n){const i=new k.ResourceMap(g=>w.extUriBiasedIgnorePathCase.getComparisonKey(g));if(n?.workspaces)for(const g of n.workspaces)i.set(this.p(g),g);const o=new k.ResourceMap(g=>w.extUriBiasedIgnorePathCase.getComparisonKey(g));if(n?.files)for(const g of n.files)o.set(this.p(g),g);const h=await this.m();for(const g of h.workspaces){const D=i.get(this.p(g));D?D.label=D.label??g.label:i.set(this.p(g),g)}for(const g of h.files){const D=o.get(this.p(g));D?D.label=D.label??g.label:o.set(this.p(g),g)}return{workspaces:[...i.values()],files:[...o.values()]}}async m(){await this.j.whenReady;let n;const i=this.j.get(nt.b,-1);if(typeof i=="string")try{n=JSON.parse(i)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,a.restoreRecentlyOpened)(n,this.f)}async n(n){await this.j.whenReady,this.j.store(nt.b,JSON.stringify((0,a.toStoreData)(n)),-1,1)}p(n){return(0,a.isRecentFolder)(n)?n.folderUri:(0,a.isRecentFile)(n)?n.fileUri:n.workspace.configPath}r(n,i){return!!n.find(o=>(0,a.isRecentWorkspace)(o)&&o.workspace.id===i.id)}s(n,i){return!!n.find(o=>(0,a.isRecentFolder)(o)&&w.extUriBiasedIgnorePathCase.isEqual(o.folderUri,i))}t(n,i){return!!n.find(o=>w.extUriBiasedIgnorePathCase.isEqual(o.fileUri,i))}async C(){l.isWindows&&(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!l.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(0,null),description:(0,u.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const g of E.app.getJumpListSettings().removedItems){const D=g.args;if(D){const R=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(D);R&&i.push(m.URI.parse(R[2]))}}await this.removeRecentlyOpened(i);let o=!1;const h=(0,A.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.w).map(g=>{const D=(0,a.isRecentWorkspace)(g)?g.workspace:g.folderUri,{title:R,description:S}=this.F(D,g.label);let L;return m.URI.isUri(D)?L=`--folder-uri "${D.toString()}"`:(o=!0,L=`--file-uri "${D.configPath.toString()}"`),{type:"task",title:R.substr(0,255),description:S.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));h.length>0&&n.push({type:"custom",name:o?(0,u.localize)(2,null):(0,u.localize)(3,null),items:h})}n.push({type:"recent"});try{const i=E.app.setJumpList(n);i&&i!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.f.warn("updateWindowsJumpList#setJumpList",i)}}F(n,i){if(i)return{title:(0,M.splitRecentLabel)(i).name,description:i};if(m.URI.isUri(n))return{title:(0,w.basename)(n),description:this.G(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,u.localize)(4,null),description:""};let o=(0,w.basename)(n.configPath);return o.endsWith(d.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-d.WORKSPACE_EXTENSION.length-1)),{title:(0,u.localize)(5,null,o),description:this.G(n.configPath)}}G(n){return n.scheme==="file"?(0,M.normalizeDriveLetter)(n.fsPath):n.toString()}async H(){if(!l.isMacintosh)return;E.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),i=[];let o=0;for(let g=0;g<n.workspaces.length&&o<nt.u;g++){const D=this.p(n.workspaces[g]);if(D.scheme===f.Schemas.file){const R=(0,w.originalFSPath)(D);await v.Promises.exists(R)&&(i.push(R),o++)}}const h=[];for(let g=0;g<n.files.length&&o<nt.v;g++){const D=this.p(n.files[g]);if(D.scheme===f.Schemas.file){const R=(0,w.originalFSPath)(D);if(nt.y.includes((0,w.basename)(D))||i.includes(R))continue;await v.Promises.exists(R)&&(h.push(R),o++)}}h.reverse().forEach(g=>E.app.addRecentDocument(g)),i.reverse().forEach(g=>E.app.addRecentDocument(g))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.u=7,t.v=10,t.w=7,t.y=["COMMIT_EDITMSG","MERGE_MSG"],e.WorkspacesHistoryMainService=t=ve([Z(0,s.ILogService),Z(1,I.IWorkspacesManagementMainService),Z(2,p.ILifecycleMainService),Z(3,y.IApplicationStorageMainService)],t)}),define(te[300],ie([0,1,15,7,21,45,3,8,179,19,30,20,5,229,67,23,34,26,48,80,28,82]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a,d,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let c=e.Menubar=class St{constructor(o,h,g,D,R,S,L,T,U,H,re){this.n=o,this.o=h,this.p=g,this.q=D,this.r=R,this.s=S,this.t=L,this.u=T,this.v=U,this.w=H,this.x=re,this.m=Object.create(null),this.g=new A.RunOnceScheduler(()=>this.E(),0),this.h=new A.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(M.isMacintosh||(0,d.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(St.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(S,L,T)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.newWindow"]=(S,L,T)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.files.openFileFolder"]=(S,L,T)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(T),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(S,L,T)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(T),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(S,L,T)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(T),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.twitterUrl;o&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(o,"openTwitterUrl"));const h=this.x.requestFeatureUrl;h&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(h,"openUserVoiceUrl"));const g=this.x.reportIssueUrl;g&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(g,"openReportIssues"));const D=this.x.licenseUrl;D&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(M.language){const S=D.indexOf("?")>0?"&":"?";this.Z(`${D}${S}lang=${M.language}`,"openLicenseUrl")}else this.Z(D,"openLicenseUrl")});const R=this.x.privacyStatementUrl;R&&D&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(R,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!M.isMacintosh)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,h){this.k=o.menus,this.l=o.keybindings,this.t.setItem(St.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){M.isMacintosh&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){M.isMacintosh&&(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=E.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(M.isMacintosh?new E.Menu:null);return}const h=new E.Menu;let g;if(M.isMacintosh){const R=new E.Menu;g=new E.MenuItem({label:this.x.nameShort,submenu:R}),this.I(R),h.append(g)}if(M.isMacintosh&&!this.c){this.c=!0;const R=new E.Menu;R.append(new E.MenuItem({label:this.bb(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(R)}if(this.K("File")){const R=new E.Menu,S=new E.MenuItem({label:this.bb(f.localize(1,null)),submenu:R});this.M(R,"File"),h.append(S)}if(this.K("Edit")){const R=new E.Menu,S=new E.MenuItem({label:this.bb(f.localize(2,null)),submenu:R});this.M(R,"Edit"),h.append(S)}if(this.K("Selection")){const R=new E.Menu,S=new E.MenuItem({label:this.bb(f.localize(3,null)),submenu:R});this.M(R,"Selection"),h.append(S)}if(this.K("View")){const R=new E.Menu,S=new E.MenuItem({label:this.bb(f.localize(4,null)),submenu:R});this.M(R,"View"),h.append(S)}if(this.K("Go")){const R=new E.Menu,S=new E.MenuItem({label:this.bb(f.localize(5,null)),submenu:R});this.M(R,"Go"),h.append(S)}if(this.K("Run")){const R=new E.Menu,S=new E.MenuItem({label:this.bb(f.localize(6,null)),submenu:R});this.M(R,"Run"),h.append(S)}if(this.K("Terminal")){const R=new E.Menu,S=new E.MenuItem({label:this.bb(f.localize(7,null)),submenu:R});this.M(R,"Terminal"),h.append(S)}let D;if(this.K("Window")){const R=new E.Menu;D=new E.MenuItem({label:this.bb(f.localize(8,null)),submenu:R,role:"window"}),this.S(R)}if(D&&h.append(D),this.K("Help")){const R=new E.Menu,S=new E.MenuItem({label:this.bb(f.localize(9,null)),submenu:R,role:"help"});this.M(R,"Help"),h.append(S)}h.items&&h.items.length>0?E.Menu.setApplicationMenu(h):E.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const h=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),g=this.T();let D;if(this.K("Preferences")){const Y=new E.Menu;this.M(Y,"Preferences"),D=new E.MenuItem({label:this.bb(f.localize(11,null)),submenu:Y})}const R=new E.Menu,S=new E.MenuItem({label:f.localize(12,null),role:"services",submenu:R}),L=new E.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),T=new E.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),U=new E.MenuItem({label:f.localize(15,null),role:"unhide"}),H=new E.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(Y,ne,ce)=>{const le=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||E.BrowserWindow.getFocusedWindow()||le?.isMinimized())&&await this.J(ce)&&this.w.quit(void 0)}})),re=[h];re.push(...g),D&&re.push(n(),D),re.push(n(),S,n(),L,T,U,n(),H),re.forEach(Y=>o.append(Y))}async J(o){if(this.p.getWindowCount()===0)return!0;const h=this.o.getValue("window.confirmBeforeClose");if(h==="always"||h==="keyboardOnly"&&this.Q(o)){const{response:g}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return g===0}return!0}K(o){if(!M.isMacintosh&&(0,d.getTitleBarStyle)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(M.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(M.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,h){h.forEach(g=>{if((0,u.isMenubarMenuItemSeparator)(g))o.append(n());else if((0,u.isMenubarMenuItemSubmenu)(g)){const D=new E.Menu,R=new E.MenuItem({label:this.bb(g.label),submenu:D});this.L(D,g.submenu.items),o.append(R)}else(0,u.isMenubarMenuItemRecentAction)(g)?o.append(this.O(g)):(0,u.isMenubarMenuItemAction)(g)&&(g.id==="workbench.action.showAboutDialog"&&this.N(o),M.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[g.id]?o.append(new E.MenuItem(this.Y(g.id,{label:this.bb(g.label),click:this.m[g.id]}))):o.append(this.U(g.label,g.id,!1,g.checked)):o.append(this.U(g.label,g.id,g.enabled!==!1,!!g.checked)):o.append(this.U(g.label,g.id,g.enabled!==!1,!!g.checked)))})}M(o,h){this.k&&this.k[h]&&this.L(o,this.k[h].items)}N(o){const h=this.T();h.length&&(h.forEach(g=>o.append(g)),o.append(n()))}O(o){const h=P.URI.revive(o.uri),g=o.id,D=g==="openRecentFile"?{fileUri:h}:g==="openRecentWorkspace"?{workspaceUri:h}:{folderUri:h};return new E.MenuItem(this.Y(g,{label:o.label,click:async(R,S,L)=>{const T=this.P(L);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[D],forceNewWindow:T,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([h])}},!1))}P(o){return!!(o&&(!M.isMacintosh&&(o.ctrlKey||o.shiftKey)||M.isMacintosh&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,h,g){const D={label:this.bb(o),role:g,enabled:!0};return new E.MenuItem(this.X(h,D))}S(o){const h=new E.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),g=new E.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),D=new E.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),R=this.U(f.localize(23,null),"workbench.action.switchWindow"),S=[];this.C&&(S.push(n()),S.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),S.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),S.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),S.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),S.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[h,g,n(),R,...S,n(),D].forEach(L=>o.append(L))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.bb(f.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.bb(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.bb(f.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.bb(f.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(o,h,g,D){const R=this.bb(o),S=typeof h=="function"?h:(re,Y,ne)=>{const ce=re?re.userSettingsLabel:null;let le=h;Array.isArray(h)&&(le=this.P(ne)?h[1]:h[0]),ce&&ne.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ce}):this.W({type:"commandId",commandId:le})},L=typeof g=="boolean"?g:this.p.getWindowCount()>0,T=typeof D=="boolean"?D:!1,U={label:R,click:S,enabled:L};T&&(U.type="checkbox",U.checked=T);let H;return typeof h=="string"?H=h:Array.isArray(h)&&(H=h[0]),M.isMacintosh&&(H==="editor.action.clipboardCutAction"?U.role="cut":H==="editor.action.clipboardCopyAction"?U.role="copy":H==="editor.action.clipboardPasteAction"&&(U.role="paste"),H==="undo"?U.click=this.V(S,{inDevTools:re=>re.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):H==="redo"?U.click=this.V(S,{inDevTools:re=>re.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):H==="editor.action.selectAll"&&(U.click=this.V(S,{inDevTools:re=>re.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(H,U))}V(o,h){return(g,D,R)=>{const S=E.BrowserWindow.getFocusedWindow();if(!S)return h.inNoWindow();if(S.webContents.isDevToolsFocused()&&S.webContents.devToolsWebContents)return h.inDevTools(S.webContents.devToolsWebContents);o(g,D||S,R)}}W(o){let h=E.BrowserWindow.getFocusedWindow();if(!h){const D=this.p.getLastActiveWindow();D?.isMinimized()&&(h=D.win)}const g=h?this.p.getWindowById(h.id):void 0;if(g){if(this.v.trace("menubar#runActionInRenderer",o),M.isMacintosh&&!this.q.isBuilt&&!g.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const D={id:o.commandId,from:"menu"};g.sendWhenReady("vscode:runAction",r.CancellationToken.None,D)}else{const D={userSettingsLabel:o.userSettingsLabel};g.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,D)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,h){const g=typeof o=="string"?this.l[o]:void 0;if(g?.label){if(g.isNative!==!1)h.accelerator=g.label,h.userSettingsLabel=g.userSettingsLabel;else if(typeof h.label=="string"){const D=h.label.indexOf("[");D>=0?h.label=`${h.label.substr(0,D)} [${g.label}]`:h.label=`${h.label} [${g.label}]`}}else h.accelerator=void 0;return h}Y(o,h,g=!h.accelerator){g&&(h=this.X(o,h));const D=h.click;return h.click=(R,S,L)=>{this.ab(o),D?.(R,S,L)},h}Z(o,h){this.w.openExternal(void 0,o),this.ab(h)}ab(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:t})}bb(o){return(0,O.mnemonicMenuLabel)(o,!this.B)}};c.a="lastKnownMenubarData",e.Menubar=c=ve([Z(0,a.IUpdateService),Z(1,l.IConfigurationService),Z(2,I.IWindowsMainService),Z(3,w.IEnvironmentMainService),Z(4,y.ITelemetryService),Z(5,k.IWorkspacesHistoryMainService),Z(6,s.IStateService),Z(7,m.ILifecycleMainService),Z(8,v.ILogService),Z(9,b.INativeHostMainService),Z(10,p.IProductService)],c);function n(){return new E.MenuItem({type:"separator"})}}),define(te[301],ie([0,1,6,20,5,300]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let M=e.MenubarMainService=class{constructor(f,l,w){this.b=f,this.c=l,this.d=w,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(O.Menubar)}async updateMenubar(f,l){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(l,f)}};e.MenubarMainService=M=ve([Z(0,E.IInstantiationService),Z(1,A.ILifecycleMainService),Z(2,r.ILogService)],M)}),define(te[302],ie([0,1,15,22,131,27,24,21,4,32,49,45,2,14,9,65,3,36,18,11,8,189,64,19,59,30,16,6,20,5,77,78,58,34,80,299,129,295,29,97,82,54,79,39,53,66]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a,d,I,k,t,c,n,i,o,h,g,D,R,S,L,T,U,H,re,Y,ne,ce,le,X,G,N,F,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function J(oe){return(0,ne.isWorkspaceIdentifier)(oe?.workspace)}function _(oe){return(0,ne.isSingleFolderWorkspaceIdentifier)(oe?.workspace)}let ae=e.WindowsMainService=class at extends v.Disposable{constructor(B,C,W,z,q,j,$,K,se,ue,be,ke,Me,Ae,Fe,ye,we,Ee){super(),this.k=B,this.l=C,this.m=W,this.n=z,this.r=q,this.s=j,this.t=$,this.u=K,this.v=se,this.w=ue,this.z=be,this.C=ke,this.D=Me,this.F=Ae,this.G=Fe,this.H=ye,this.I=we,this.J=Ee,this.b=this.B(new f.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new f.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new f.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new f.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new f.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new Y.WindowsStateHandler(this,this.r,this.v,this.m,this.z)),this.L()}L(){this.B(this.D.onDidEnterWorkspace(B=>this.c.fire(B.window))),this.B(this.onDidSignalReadyWindow(B=>{if(B.config?.extensionDevelopmentPath||B.config?.extensionTestsPath){const C=new v.DisposableStore;if(C.add(f.Event.any(B.onDidClose,B.onDidDestroy)(()=>C.dispose())),B.config.extensionDevelopmentPath)for(const W of B.config.extensionDevelopmentPath)C.add(this.I.addValidFileRoot(W));B.config.extensionTestsPath&&C.add(this.I.addValidFileRoot(B.config.extensionTestsPath))}}))}openEmptyWindow(B,C){const W=this.t.args,z=C?.remoteAuthority||void 0,q=!0,j=C?.forceReuseWindow,$=!j;return this.open({...B,cli:W,forceEmpty:q,forceNewWindow:$,forceReuseWindow:j,remoteAuthority:z})}openExistingWindow(B,C){B.focus(),this.M(C,[B])}async open(B){this.m.trace("windowsManager#open"),B.addMode&&(B.initialStartup||!this.getLastActiveWindow())&&(B.addMode=!1);const C=[],W=[],z=[],q=[],j=[];let $,K=0;const se=await this.S(B);this.m.trace("windowsManager#open pathsToOpen",se);for(const Ae of se)_(Ae)?B.addMode?C.push(Ae):W.push(Ae):J(Ae)?z.push(Ae):Ae.fileUri?($||($={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ae.remoteAuthority}),$.filesToOpenOrCreate.push(Ae)):Ae.backupPath?j.push({backupFolder:(0,b.basename)(Ae.backupPath),remoteAuthority:Ae.remoteAuthority}):K++;B.diffMode&&$&&$.filesToOpenOrCreate.length>=2&&($.filesToDiff=$.filesToOpenOrCreate.slice(0,2),$.filesToOpenOrCreate=[]),B.mergeMode&&$&&$.filesToOpenOrCreate.length===4&&($.filesToMerge=$.filesToOpenOrCreate.slice(0,4),$.filesToOpenOrCreate=[],$.filesToDiff=[]),$&&B.waitMarkerFileURI&&($.filesToWait={paths:(0,M.coalesce)([...$.filesToDiff,$.filesToMerge[3],...$.filesToOpenOrCreate]),waitMarkerFileUri:B.waitMarkerFileURI}),B.initialStartup?(q.push(...this.D.getUntitledWorkspaces()),z.push(...q),j.push(...this.w.getEmptyWindowBackups())):j.length=0;const{windows:ue,filesOpenedInWindow:be}=await this.N(B,z,W,j,K,$,C);if(this.m.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${W.length}, emptyToRestore: ${j.length}, emptyToOpen: ${K})`),ue.length>1)if(be)be.focus();else{const Ae=this.j.state.lastActiveWindow&&!B.forceEmpty&&!B.cli._.length&&!B.cli["file-uri"]&&!B.cli["folder-uri"]&&!(B.urisToOpen&&B.urisToOpen.length);let Fe=!0,ye=!0;if(Ae){const we=ue.filter(Ee=>this.j.state.lastActiveWindow&&Ee.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Fe=!1,ye=!1)}if(Fe)for(let we=ue.length-1;we>=0;we--){const Ee=ue[we];if(!(Ee.openedWorkspace&&q.some(ee=>Ee.openedWorkspace&&ee.workspace.id===Ee.openedWorkspace.id)||Ee.backupPath&&j.some(ee=>Ee.backupPath&&ee.backupFolder===(0,b.basename)(Ee.backupPath)))){Ee.focus(),ye=!1;break}}ye&&ue[ue.length-1].focus()}const ke=$&&$.filesToDiff.length>0,Me=$&&$.filesToMerge.length>0;if(!ue.some(Ae=>Ae.isExtensionDevelopmentHost)&&!ke&&!Me&&!B.noRecentEntry){const Ae=[];for(const Fe of se)J(Fe)&&!Fe.transient?Ae.push({label:Fe.label,workspace:Fe.workspace,remoteAuthority:Fe.remoteAuthority}):_(Fe)?Ae.push({label:Fe.label,folderUri:Fe.workspace.uri,remoteAuthority:Fe.remoteAuthority}):Fe.fileUri&&Ae.push({label:Fe.label,fileUri:Fe.fileUri,remoteAuthority:Fe.remoteAuthority});this.C.addRecentlyOpened(Ae)}return this.M(B,ue),ue}M(B,C){const W=B.waitMarkerFileURI;B.context===0&&W&&C.length===1&&C[0]&&(async()=>{await C[0].whenClosedOrLoaded;try{await this.H.del(W)}catch{}})()}async N(B,C,W,z,q,j,$){const K=[];let se;function ue(we,Ee){K.push(we),Ee&&(se=we,j=void 0)}let{openFolderInNewWindow:be,openFilesInNewWindow:ke}=this.gb(B);if(!B.initialStartup&&$.length>0){const we=$[0].remoteAuthority,Ee=this.lb(we);Ee&&ue(this.P(Ee,$.map(ee=>ee.workspace.uri)))}const Me=W.length+C.length+z.length;if(j&&Me===0){const we=j.filesToOpenOrCreate[0]||j.filesToDiff[0]||j.filesToMerge[3],Ee=this.getWindows().filter(he=>j&&(0,a.isEqualAuthority)(he.remoteAuthority,j.remoteAuthority));let ee;we?.fileUri&&!ke&&((B.context===4||B.context===0||B.context===1)&&(ee=await(0,re.findWindowOnFile)(Ee,we.fileUri,async he=>he.configPath.scheme===u.Schemas.file?this.D.resolveLocalWorkspace(he.configPath):void 0)),ee||(ee=this.mb(Ee))),ee?(0,ne.isWorkspaceIdentifier)(ee.openedWorkspace)?C.push({workspace:ee.openedWorkspace,remoteAuthority:ee.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(ee.openedWorkspace)?W.push({workspace:ee.openedWorkspace,remoteAuthority:ee.remoteAuthority}):ue(this.O(B,ee,j),!0):ue(await this.hb({userEnv:B.userEnv,cli:B.cli,initialStartup:B.initialStartup,filesToOpen:j,forceNewWindow:!0,remoteAuthority:j.remoteAuthority,forceNewTabbedWindow:B.forceNewTabbedWindow,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile}),!0)}const Ae=(0,M.distinct)(C,we=>we.workspace.id);if(Ae.length>0){const we=(0,M.coalesce)(Ae.map(Ee=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ee.workspace.configPath)));if(we.length>0){const Ee=we[0],ee=(0,a.isEqualAuthority)(j?.remoteAuthority,Ee.remoteAuthority)?j:void 0;ue(this.O(B,Ee,ee),!!ee),be=!0}for(const Ee of Ae){if(we.some(fe=>fe.openedWorkspace&&fe.openedWorkspace.id===Ee.workspace.id))continue;const ee=Ee.remoteAuthority,he=(0,a.isEqualAuthority)(j?.remoteAuthority,ee)?j:void 0;ue(await this.R(B,Ee,be,he),!!he),be=!0}}const Fe=(0,M.distinct)(W,we=>a.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Fe.length>0){const we=(0,M.coalesce)(Fe.map(Ee=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ee.workspace.uri)));if(we.length>0){const Ee=we[0],ee=(0,a.isEqualAuthority)(j?.remoteAuthority,Ee.remoteAuthority)?j:void 0;ue(this.O(B,Ee,ee),!!ee),be=!0}for(const Ee of Fe){if(we.some(fe=>(0,ne.isSingleFolderWorkspaceIdentifier)(fe.openedWorkspace)&&a.extUriBiasedIgnorePathCase.isEqual(fe.openedWorkspace.uri,Ee.workspace.uri)))continue;const ee=Ee.remoteAuthority,he=(0,a.isEqualAuthority)(j?.remoteAuthority,ee)?j:void 0;ue(await this.R(B,Ee,be,he),!!he),be=!0}}const ye=(0,M.distinct)(z,we=>we.backupFolder);if(ye.length>0)for(const we of ye){const Ee=we.remoteAuthority,ee=(0,a.isEqualAuthority)(j?.remoteAuthority,Ee)?j:void 0;ue(await this.Q(B,!0,Ee,ee,we),!!ee),be=!0}if(K.length===0||j){j&&!q&&q++;const we=j?j.remoteAuthority:B.remoteAuthority;for(let Ee=0;Ee<q;Ee++)ue(await this.Q(B,be,we,j),!!j),be=!0}return{windows:(0,M.distinct)(K),filesOpenedInWindow:se}}O(B,C,W){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),C.focus();const z={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:B?.userEnv?.TERM_PROGRAM};return C.sendWhenReady("vscode:openFiles",P.CancellationToken.None,z),C}P(B,C){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:C}),B.focus();const W={foldersToAdd:C};return B.sendWhenReady("vscode:addFolders",P.CancellationToken.None,W),B}Q(B,C,W,z,q){this.m.trace("windowsManager#doOpenEmpty",{restore:!!q,remoteAuthority:W,filesToOpen:z,forceNewWindow:C});let j;return!C&&typeof B.contextWindowId=="number"&&(j=this.getWindowById(B.contextWindowId)),this.hb({userEnv:B.userEnv,cli:B.cli,initialStartup:B.initialStartup,remoteAuthority:W,forceNewWindow:C,forceNewTabbedWindow:B.forceNewTabbedWindow,filesToOpen:z,windowToUse:j,emptyWindowBackupInfo:q,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}R(B,C,W,z,q){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:C,filesToOpen:z}),!W&&!q&&typeof B.contextWindowId=="number"&&(q=this.getWindowById(B.contextWindowId)),this.hb({workspace:C.workspace,userEnv:B.userEnv,cli:B.cli,initialStartup:B.initialStartup,remoteAuthority:C.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:B.forceNewTabbedWindow,filesToOpen:z,windowToUse:q,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async S(B){let C,W=!1,z=!1;if(B.urisToOpen&&B.urisToOpen.length>0?(C=await this.U(B),W=!0):B.forceEmpty?C=[Object.create(null)]:B.cli._.length||B.cli["folder-uri"]||B.cli["file-uri"]?(C=await this.W(B.cli),C.length===0&&C.push(Object.create(null)),W=!0):(C=await this.Y(),C.length===0&&C.push(Object.create(null)),z=!0),!B.addMode&&W){const q=C.filter(j=>_(j));if(q.length>1){const j=q[0].remoteAuthority;if(q.every($=>(0,a.isEqualAuthority)($.remoteAuthority,j))){const $=await this.D.createUntitledWorkspace(q.map(K=>({uri:K.workspace.uri})));C.push({workspace:$,remoteAuthority:j}),C=C.filter(K=>!_(K))}}}if(B.initialStartup&&!z&&this.z.getValue("window")?.restoreWindows==="preserve"){const q=await this.Y();C.unshift(...q.filter(j=>J(j)||_(j)||j.backupPath))}return C}async U(B){const C={gotoLineMode:B.gotoLineMode,remoteAuthority:B.remoteAuthority},W=await Promise.all((0,M.coalesce)(B.urisToOpen||[]).map(async z=>{const q=await this.ab(z,C);if(q)return q.label=z.label,q;const j=this.cb(z);this.G.showMessageBox({type:"info",buttons:[(0,k.localize)(0,null)],message:j.scheme===u.Schemas.file?(0,k.localize)(1,null):(0,k.localize)(2,null),detail:j.scheme===u.Schemas.file?(0,k.localize)(3,null,(0,m.getPathLabel)(j,{os:s.OS,tildify:this.t})):(0,k.localize)(4,null,j.toString(!0))},(0,d.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,M.coalesce)(W)}async W(B){const C=[],W={ignoreFileNotFound:!0,gotoLineMode:B.goto,remoteAuthority:B.remote||void 0,forceOpenWorkspaceAsFile:B.diff&&B._.length===2||B.merge&&B._.length===4},z=B["folder-uri"];if(z){const $=await Promise.all(z.map(K=>{const se=this.X(K);if(se)return this.ab({folderUri:se},W)}));C.push(...(0,M.coalesce)($))}const q=B["file-uri"];if(q){const $=await Promise.all(q.map(K=>{const se=this.X(K);if(se)return this.ab((0,ne.hasWorkspaceFileExtension)(K)?{workspaceUri:se}:{fileUri:se},W)}));C.push(...(0,M.coalesce)($))}const j=await Promise.all(B._.map($=>W.remoteAuthority?this.fb($,W):this.db($,W)));return C.push(...(0,M.coalesce)(j)),C}X(B){try{const C=I.URI.parse(B);if(!C.scheme){this.m.error(`Invalid URI input string, scheme missing: ${B}`);return}return C}catch(C){this.m.error(`Invalid URI input string: ${B}, ${C.message}`)}}async Y(){const B=this.Z();switch(B){case"none":return[];case"one":case"all":case"preserve":case"folders":{const C=[];B!=="one"&&C.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&C.push(this.j.state.lastActiveWindow);const W=await Promise.all(C.map(async z=>{if(z.workspace){const q=await this.ab({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(J(q))return q}else if(z.folderUri){const q=await this.ab({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(_(q))return q}else if(B!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,M.coalesce)(W)}}}Z(){let B;return this.v.wasRestarted?B="all":(B=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(B)||(B="all")),B}async ab(B,C=Object.create(null)){const W=this.cb(B);return W.scheme===u.Schemas.file?((0,U.isFileToOpen)(B)&&(C={...C,forceOpenWorkspaceAsFile:!0}),this.db(W.fsPath,C)):this.bb(B,C)}bb(B,C){let W=this.cb(B);const z=(0,L.getRemoteAuthority)(W)||C.remoteAuthority;if(W=(0,a.removeTrailingPathSeparator)((0,a.normalizePath)(W)),(0,U.isFileToOpen)(B)){if(C.gotoLineMode){const{path:q,line:j,column:$}=(0,l.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:q}),options:{selection:j?{startLineNumber:j,startColumn:$||1}:void 0},remoteAuthority:z}}return{fileUri:W,remoteAuthority:z}}else if((0,U.isWorkspaceToOpen)(B))return{workspace:(0,ce.getWorkspaceIdentifier)(W),remoteAuthority:z};return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:z}}cb(B){return(0,U.isWorkspaceToOpen)(B)?B.workspaceUri:(0,U.isFolderToOpen)(B)?B.folderUri:B.fileUri}async db(B,C,W){let z,q;C.gotoLineMode&&({path:B,line:z,column:q}=(0,l.parseLineAndColumnAware)(B)),B=(0,l.sanitizeFilePath)((0,b.normalize)(B),(0,y.cwd)());try{const j=await A.Promises.stat(B);if(j.isFile()){if(!C.forceOpenWorkspaceAsFile){const $=await this.D.resolveLocalWorkspace(I.URI.file(B));if($)return $.transient&&C.rejectTransientWorkspaces?void 0:{workspace:{id:$.id,configPath:$.configPath},type:o.FileType.File,exists:!0,remoteAuthority:$.remoteAuthority,transient:$.transient}}return{fileUri:I.URI.file(B),type:o.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:q||1}:void 0}}}else{if(j.isDirectory())return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(I.URI.file(B),j),type:o.FileType.Directory,exists:!0};if(!s.isWindows&&B==="/dev/null")return{fileUri:I.URI.file(B),type:o.FileType.File,exists:!0}}}catch(j){if(j.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!W)return this.eb(B,C);const $=I.URI.file(B);if(this.C.removeRecentlyOpened([$]),C.ignoreFileNotFound)return{fileUri:$,type:o.FileType.File,exists:!1}}}async eb(B,C){const W=I.URI.file(B),{response:z,checkboxChecked:q}=await this.G.showMessageBox({type:"warning",buttons:[(0,k.localize)(5,null),(0,k.localize)(6,null),(0,k.localize)(7,null)],message:(0,k.localize)(8,null,W.authority),detail:(0,k.localize)(9,null,(0,m.getPathLabel)(W,{os:s.OS,tildify:this.t})),checkboxLabel:(0,k.localize)(10,null,W.authority),cancelId:1});if(z===0)return(0,r.addUNCHostToAllowlist)(W.authority),q&&this.B(f.Event.once(this.onDidOpenWindow)(j=>{j.sendWhenReady("vscode:configureAllowedUNCHost",P.CancellationToken.None,W.authority)})),this.db(B,C,!0);if(z===2)return E.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.eb(B,C)}fb(B,C){const W=B.charCodeAt(0),z=C.remoteAuthority;let q,j;C.gotoLineMode&&({path:B,line:q,column:j}=(0,l.parseLineAndColumnAware)(B)),W!==47&&((0,l.isWindowsDriveLetter)(W)&&B.charCodeAt(B.charCodeAt(1))===58&&(B=(0,l.toSlashes)(B)),B=`/${B}`);const $=I.URI.from({scheme:u.Schemas.vscodeRemote,authority:z,path:B});if(B.charCodeAt(B.length-1)!==47){if((0,ne.hasWorkspaceFileExtension)(B))return C.forceOpenWorkspaceAsFile?{fileUri:$,options:{selection:q?{startLineNumber:q,startColumn:j||1}:void 0},remoteAuthority:C.remoteAuthority}:{workspace:(0,ce.getWorkspaceIdentifier)($),remoteAuthority:z};if(C.gotoLineMode||b.posix.basename(B).indexOf(".")!==-1)return{fileUri:$,options:{selection:q?{startLineNumber:q,startColumn:j||1}:void 0},remoteAuthority:z}}return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:z}}gb(B){const C=this.z.getValue("window"),W=C?.openFoldersInNewWindow||"default",z=C?.openFilesInNewWindow||"off";let q=(B.preferNewWindow||B.forceNewWindow)&&!B.forceReuseWindow;!B.forceNewWindow&&!B.forceReuseWindow&&(W==="on"||W==="off")&&(q=W==="on");let j=!1;return B.forceNewWindow||B.forceReuseWindow?j=!!B.forceNewWindow&&!B.forceReuseWindow:(s.isMacintosh?B.context===1&&(j=!0):B.context!==3&&B.context!==2&&!(B.userEnv&&B.userEnv.TERM_PROGRAM==="vscode")&&(j=!0),!B.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(j=z==="on")),{openFolderInNewWindow:!!q,openFilesInNewWindow:j}}async openExtensionDevelopmentHostWindow(B,C){const W=(0,re.findWindowOnExtensionDevelopmentPath)(this.getWindows(),B);if(W)return this.v.reload(W,C.cli),W.focus(),[W];let z=C.cli["folder-uri"]||[],q=C.cli["file-uri"]||[],j=C.cli._;if(!j.length&&!z.length&&!q.length&&!C.cli.extensionTestsPath){const se=this.j.state.lastPluginDevelopmentHostWindow,ue=se?.workspace??se?.folderUri;ue&&(I.URI.isUri(ue)?ue.scheme===u.Schemas.file?j=[ue.fsPath]:z=[ue.toString()]:ue.configPath.scheme===u.Schemas.file?j=[(0,a.originalFSPath)(ue.configPath)]:q=[ue.configPath.toString()])}let $=C.remoteAuthority;for(const se of B)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=I.URI.parse(se),be=(0,L.getRemoteAuthority)(ue);be&&($?(0,a.isEqualAuthority)(be,$)||this.m.error("more than one extension development path authority"):$=be)}j=j.filter(se=>{const ue=I.URI.file(se);return(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:(0,a.isEqualAuthority)((0,L.getRemoteAuthority)(ue),$)}),z=z.filter(se=>{const ue=this.X(se);return ue&&(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,a.isEqualAuthority)((0,L.getRemoteAuthority)(ue),$):!1}),q=q.filter(se=>{const ue=this.X(se);return ue&&(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,a.isEqualAuthority)((0,L.getRemoteAuthority)(ue),$):!1}),C.cli._=j,C.cli["folder-uri"]=z,C.cli["file-uri"]=q;const K={context:C.context,cli:C.cli,forceNewWindow:!0,forceEmpty:!j.length&&!z.length&&!q.length,userEnv:C.userEnv,noRecentEntry:!0,waitMarkerFileURI:C.waitMarkerFileURI,remoteAuthority:$,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile};return this.open(K)}async hb(B){const C=this.z.getValue("window"),W=this.getLastActiveWindow(),z=W?.profile??this.u.defaultProfile;let q;!B.forceNewWindow&&!B.forceNewTabbedWindow&&(q=B.windowToUse||W,q&&q.focus());const j={...this.t.args,...B.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:B.emptyWindowBackupInfo?(0,b.join)(this.t.backupHome,B.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.u.profilesHome,all:this.u.profiles,profile:z},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:B.remoteAuthority,workspace:B.workspace,userEnv:{...this.l,...B.userEnv},filesToOpenOrCreate:B.filesToOpen?.filesToOpenOrCreate,filesToDiff:B.filesToOpen?.filesToDiff,filesToMerge:B.filesToOpen?.filesToMerge,filesToWait:B.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsHome.fsPath,product:R.default,isInitialStartup:B.initialStartup,perfMarks:(0,p.getMarks)(),os:{release:(0,O.release)(),hostname:(0,O.hostname)()},zoomLevel:typeof C?.zoomLevel=="number"?C.zoomLevel:void 0,autoDetectHighContrast:C?.autoDetectHighContrast??!0,autoDetectColorScheme:C?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if(q){const $=q.config;!j.extensionDevelopmentPath&&$?.extensionDevelopmentPath&&(j.extensionDevelopmentPath=$.extensionDevelopmentPath,j.extensionDevelopmentKind=$.extensionDevelopmentKind,j["enable-proposed-api"]=$["enable-proposed-api"],j.verbose=$.verbose,j["inspect-extensions"]=$["inspect-extensions"],j["inspect-brk-extensions"]=$["inspect-brk-extensions"],j.debugId=$.debugId,j.extensionEnvironment=$.extensionEnvironment,j["extensions-dir"]=$["extensions-dir"],j["disable-extensions"]=$["disable-extensions"]),j.loggers={global:j.loggers.global,window:$?.loggers.window??j.loggers.window}}else{const $=this.j.getNewWindowState(j);(0,p.mark)("code/willCreateCodeWindow");const K=q=this.F.createInstance(H.CodeWindow,{state:$,extensionDevelopmentPath:j.extensionDevelopmentPath,isExtensionTestHost:!!j.extensionTestsPath});(0,p.mark)("code/didCreateCodeWindow"),B.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(K),at.a.push(K),this.b.fire(K),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(K.onDidSignalReady)(()=>this.c.fire(K)),(0,w.once)(K.onDidClose)(()=>this.kb(K)),(0,w.once)(K.onDidDestroy)(()=>this.f.fire(K)),K.onDidTriggerSystemContextMenu(({x:ue,y:be})=>this.h.fire({window:K,x:ue,y:be}));const se=(0,d.assertIsDefined)(K.win?.webContents);se.removeAllListeners("devtools-reload-page"),se.on("devtools-reload-page",()=>this.v.reload(K)),this.v.registerWindow(K)}return j.windowId=q.id,q.isReady?this.v.unload(q,4).then(async $=>{$||await this.ib(q,j,B,z)}):await this.ib(q,j,B,z),q}async ib(B,C,W,z){if(C.extensionDevelopmentPath||((0,ne.isWorkspaceIdentifier)(C.workspace)?C.backupPath=this.w.registerWorkspaceBackup({workspace:C.workspace,remoteAuthority:C.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(C.workspace)?C.backupPath=this.w.registerFolderBackup({folderUri:C.workspace.uri,remoteAuthority:C.remoteAuthority}):C.backupPath=this.w.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,ce.createEmptyWorkspaceIdentifier)().id,remoteAuthority:C.remoteAuthority})),this.u.isEnabled()){const q=C.workspace??(0,ne.toWorkspaceIdentifier)(C.backupPath,!1),j=this.jb(W,q,z),$=j instanceof Promise?await j:j;C.profiles.profile=$,C.extensionDevelopmentPath||await this.u.setProfileForWorkspace(q,$)}B.load(C)}jb(B,C,W){return B.forceProfile?this.u.profiles.find(z=>z.name===B.forceProfile)??this.u.createNamedProfile(B.forceProfile):B.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(C)??W}kb(B){const C=at.a.indexOf(B);at.a.splice(C,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const B=E.BrowserWindow.getFocusedWindow();if(B)return this.getWindowById(B.id)}getLastActiveWindow(){return this.mb(this.getWindows())}lb(B){return this.mb(this.getWindows().filter(C=>(0,a.isEqualAuthority)(C.remoteAuthority,B)))}mb(B){const C=Math.max.apply(Math,B.map(W=>W.lastFocusTime));return B.find(W=>W.lastFocusTime===C)}sendToFocused(B,...C){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(B,P.CancellationToken.None,...C)}sendToAll(B,C,W){for(const z of this.getWindows())W&&W.indexOf(z.id)>=0||z.sendWhenReady(B,P.CancellationToken.None,C)}getWindows(){return at.a}getWindowCount(){return at.a.length}getWindowById(B){const C=this.getWindows().filter(W=>W.id===B);return(0,M.firstOrDefault)(C)}getWindowByWebContents(B){const C=E.BrowserWindow.fromWebContents(B);if(C)return this.getWindowById(C.id)}};ae.a=[],e.WindowsMainService=ae=ve([Z(2,D.ILogService),Z(3,V.ILoggerMainService),Z(4,T.IStateService),Z(5,N.IPolicyService),Z(6,i.IEnvironmentMainService),Z(7,F.IUserDataProfilesMainService),Z(8,g.ILifecycleMainService),Z(9,t.IBackupMainService),Z(10,c.IConfigurationService),Z(11,le.IWorkspacesHistoryMainService),Z(12,X.IWorkspacesManagementMainService),Z(13,h.IInstantiationService),Z(14,n.IDialogMainService),Z(15,o.IFileService),Z(16,S.IProtocolMainService),Z(17,G.IThemeMainService)],ae)}),define(te[303],ie([0,1,64,28,82,54]),function(x,e,E,A,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=e.WorkspacesMainService=class{constructor(f,l,w,m){this.a=f,this.b=l,this.c=w,this.d=m,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,l){const w=this.b.getWindowById(f);if(w)return this.a.enterWorkspace(w,this.b.getWindows(),l)}createUntitledWorkspace(f,l,w){return this.a.createUntitledWorkspace(l,w)}deleteUntitledWorkspace(f,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(f,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(f,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.WorkspacesMainService=M=ve([Z(0,O.IWorkspacesManagementMainService),Z(1,A.IWindowsMainService),Z(2,r.IWorkspacesHistoryMainService),Z(3,E.IBackupMainService)],M)}),define(te[304],ie([0,1,15,131,38,27,17,50,13,32,49,44,45,2,14,9,3,11,8,31,144,43,157,109,271,160,64,284,19,75,198,89,132,59,114,218,30,63,93,207,233,208,291,116,209,210,16,222,92,74,6,91,216,296,285,273,20,5,301,67,23,58,292,94,34,276,98,121,26,248,250,52,48,263,288,297,289,298,126,265,266,267,269,274,28,302,275,29,96,82,303,54,272,39,231,53,242,51,81,128,278,290,281,7,252,277,226,66,90,294,268,24,124,293,260]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a,d,I,k,t,c,n,i,o,h,g,D,R,S,L,T,U,H,re,Y,ne,ce,le,X,G,N,F,V,J,_,ae,oe,B,C,W,z,q,j,$,K,se,ue,be,ke,Me,Ae,Fe,ye,we,Ee,ee,he,fe,Ce,De,Oe,We,He,$e,ze,qe,je,Q,de,ge,me,Se,Le,Ne,Ke,Ze,Ge,Ye,tt,ot,ct,Mt,gt,At,Lt,Ot,Tt,Ft,Wt,Ut,mt,Nt,Bt,jt,zt,$t,pt,qt,Et,wt,Ht,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let It=e.CodeApplication=class extends u.Disposable{constructor(Pe,Ie,pe,Te,Re,Be,Je,Qe,Ue,Ve,xe,Xe){super(),this.c=Pe,this.f=Ie,this.g=pe,this.h=Te,this.i=Re,this.j=Be,this.k=Je,this.l=Qe,this.m=Ue,this.n=Ve,this.p=xe,this.r=Xe,this.s(),this.t()}s(){const Pe=Ue=>Ue?.startsWith(`${b.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Ue,Ve,xe,Xe)=>Pe(Xe.requestingUrl)?xe(Ie.has(Ve)):xe(!1)),E.session.defaultSession.setPermissionCheckHandler((Ue,Ve,xe,Xe)=>Pe(Xe.requestingUrl)?Ie.has(Ve):!1);const pe=new Set([b.Schemas.file,b.Schemas.vscodeFileResource,b.Schemas.vscodeRemoteResource,"devtools"]),Te=Ue=>{for(let Ve=Ue;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${b.Schemas.vscodeWebview}://`))return!0;return!1},Re=Ue=>Ue.resourceType==="xhr"||Te(Ue.frame),Be=Ue=>{const Ve=Ue.frame;if(!Ve||!this.a)return!1;const xe=E.BrowserWindow.getAllWindows();for(const Xe of xe)if(Ve.processId===Xe.webContents.mainFrame.processId)return!0;return!1},Je=(Ue,Ve)=>{if(Ue.path!=="/index.html")return!0;const xe=Ve.frame;if(!xe||!this.a)return!1;for(const Xe of this.a.getWindows())if(Xe.win&&xe.processId===Xe.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Ue,Ve)=>{const xe=a.URI.parse(Ue.url);return xe.scheme===b.Schemas.vscodeWebview&&!Je(xe,Ue)?(this.h.error("Blocked vscode-webview request",Ue.url),Ve({cancel:!0})):xe.scheme===b.Schemas.vscodeFileResource&&!Be(Ue)?(this.h.error("Blocked vscode-file request",Ue.url),Ve({cancel:!0})):xe.path.endsWith(".svg")&&!pe.has(xe.scheme)?Ve({cancel:!Re(Ue)}):Ve({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Ue,Ve)=>{const xe=Ue.responseHeaders,Xe=xe["content-type"]||xe["Content-Type"];if(Xe&&Array.isArray(Xe)){const _e=a.URI.parse(Ue.url);if(_e.path.endsWith(".svg")&&pe.has(_e.scheme))return xe["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:xe});if(!_e.path.endsWith(b.Schemas.vscodeRemoteResource)&&Xe.some(rt=>rt.toLowerCase().includes("image/svg")))return Ve({cancel:!Re(Ue)})}return Ve({cancel:!1})});const Qe=E.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.j.codeCachePath&&Qe.setCodeCachePath((0,p.join)(this.j.codeCachePath,"chrome")),s.isWindows&&(this.l.getValue("security.restrictUNCAccess")===!1?(0,A.disableUNCAccessRestrictions)():(0,A.addUNCHostToAllowlist)(this.l.getValue("security.allowedUNCHosts")))}t(){(0,f.setUnexpectedErrorHandler)(pe=>this.v(pe)),process.on("uncaughtException",pe=>(0,f.onUnexpectedError)(pe)),process.on("unhandledRejection",pe=>(0,f.onUnexpectedError)(pe)),this.k.onWillShutdown(()=>this.dispose()),(0,I.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(pe,Te)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Te)}),E.app.on("activate",async(pe,Te)=>{this.h.trace("app#activate"),Te||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(pe,Te)=>{Te.on("will-navigate",Re=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Re.preventDefault()}),Te.setWindowOpenHandler(({url:Re})=>(this.b?.openExternal(void 0,Re),{action:"deny"}))});let Pe=[],Ie;E.app.on("open-file",(pe,Te)=>{this.h.trace("app#open-file: ",Te),pe.preventDefault(),Pe.push((0,Ke.hasWorkspaceFileExtension)(Te)?{workspaceUri:a.URI.file(Te)}:{fileUri:a.URI.file(Te)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.a?.open({context:1,cli:this.j.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ie=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),r.validatedIpcMain.handle("vscode:fetchShellEnv",pe=>{const Te=this.a?.getWindowByWebContents(pe.sender);let Re,Be;return Te?.config?(Re=Te.config,Be={...process.env,...Te.config.userEnv}):(Re=this.j.args,Be=process.env),this.M(Re,Be,!1)}),r.validatedIpcMain.handle("vscode:writeNlsFile",(pe,Te,Re)=>{const Be=this.u([Te]);if(!Be||typeof Re!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.n.writeFile(Be,M.VSBuffer.fromString(Re))}),r.validatedIpcMain.handle("vscode:readNlsFile",async(pe,...Te)=>{const Re=this.u(Te);if(!Re)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.n.readFile(Re)).value.toString()}),r.validatedIpcMain.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),r.validatedIpcMain.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),r.validatedIpcMain.on("vscode:reloadWindow",pe=>pe.sender.reload())}u(Pe){let Ie;for(const pe of Pe)typeof pe=="string"&&(typeof Ie!="string"?Ie=pe:Ie=(0,p.join)(Ie,pe));if(!(typeof Ie!="string"||!(0,p.isAbsolute)(Ie)||!(0,l.isEqualOrParent)(Ie,this.j.cachedLanguagesPath,!s.isLinux)))return a.URI.file(Ie)}v(Pe){if(Pe){const Ie={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.h.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.h.error(Pe.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.j.appRoot}`),this.h.debug("args:",this.j.args);const Pe=this.p.win32AppUserModelId;s.isWindows&&Pe&&E.app.setAppUserModelId(Pe);try{s.isMacintosh&&this.l.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.h.error(Ue)}const Ie=new t.Server;this.k.onWillShutdown(Ue=>{Ue.reason===2&&Ie.dispose()}),this.h.trace("Resolving machine identifier...");const pe=await(0,Nt.resolveMachineId)(this.m,this.h);this.h.trace(`Resolved machine identifier: ${pe}`);const{sharedProcessReady:Te,sharedProcessClient:Re}=this.F(pe),Be=await this.G(pe,Te);this.B(Be.createInstance(n.ProxyAuthHandler)),this.B(Be.createInstance(Wt.UserDataProfilesHandler)),Be.invokeFunction(Ue=>this.H(Ue,Ie,Re));const Je=Be.invokeFunction(Ue=>this.w(Ue,Ie));this.k.phase=2,await Be.invokeFunction(Ue=>this.I(Ue,Je)),this.k.phase=3,this.J(),this.B(new mt.RunOnceScheduler(()=>{this.B((0,mt.runWhenIdle)(()=>this.k.phase=4,2500))},2500)).schedule()}w(Pe,Ie){const pe=this.a=Pe.get(Se.IWindowsMainService),Te=Pe.get(qe.IURLService),Re=this.b=Pe.get(ue.INativeHostMainService),Be=this;Te.registerHandler({async handleURL(Xe,_e){return Be.D(pe,Te,Xe,_e)}});const Je=this.B(new Ne.ActiveWindowManager({onDidOpenWindow:Re.onDidOpenWindow,onDidFocusWindow:Re.onDidFocusWindow,getActiveWindowId:()=>Re.getActiveWindowId(-1)})),Qe=new k.StaticRouter(Xe=>Je.getActiveClientId().then(_e=>Xe===_e)),Ue=new je.URLHandlerRouter(Qe,this.h),Ve=Ie.getChannel("urlHandler",Ue);Te.registerHandler(new je.URLHandlerChannelClient(Ve));const xe=this.y();return this.B(new de.ElectronURLListener(xe?.urls,Te,pe,this.j,this.p,this.h)),xe}y(){const Pe=this.j.args["open-url"]?this.j.args._urls||[]:[];Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Pe);const Ie=global.getOpenUrls()||[];if(Ie.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ie),Pe.length+Ie.length===0)return;const pe=[];return{urls:[...Pe,...Ie].map(Re=>{try{return{uri:a.URI.parse(Re),originalUrl:Re}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Re);return}}).filter(Re=>{if(!Re)return!1;if(this.z(Re.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Re.uri.toString(!0)),!1;const Be=this.C(Re.uri);return Be?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Re.uri.toString(!0),Be),pe.push(Be),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Re.uri.toString(!0)),!0)}),openables:pe}}z(Pe){if(Pe.authority===b.Schemas.file&&s.isWindows){const{options:Ie,buttonIndeces:pe}=(0,$t.massageMessageBoxOptions)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,v.getPathLabel)(Pe,{os:s.OS,tildify:this.j}),this.p.nameShort),detail:(0,i.localize)(3,null)},this.p);if(pe[E.dialog.showMessageBoxSync(Ie)]===1)return!0}return!1}C(Pe){if(Pe.path){if(Pe.authority===b.Schemas.file){const Ie=a.URI.file(Pe.fsPath);return(0,Ke.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Pe.authority===b.Schemas.vscodeRemote){const Ie=Pe.path.indexOf(p.posix.sep,1);if(Ie!==-1){const pe=Pe.path.substring(1,Ie),Te=Pe.path.substring(Ie),Re=a.URI.from({scheme:b.Schemas.vscodeRemote,authority:pe,path:Te,query:Pe.query,fragment:Pe.fragment});return(0,Ke.hasWorkspaceFileExtension)(Te)?{workspaceUri:Re}:/:[\d]+$/.test(Te)?{fileUri:Re}:{folderUri:Re}}}}}async D(Pe,Ie,pe,Te){if(this.h.trace("app#handleProtocolUrl():",pe.toString(!0),Te),pe.scheme===this.p.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:a.URI.parse(pe.query).path,query:""})),this.z(pe))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let Re=!1;const Be=new URLSearchParams(pe.query);Be.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Be.delete("windowId"),pe=pe.with({query:Be.toString()}),Re=!0):s.isMacintosh&&Pe.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Re=!0);const Je=Be.get("continueOn");Je!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),Be.delete("continueOn"),pe=pe.with({query:Be.toString()}),this.j.continueOn=Je??void 0);const Qe=this.C(pe);return Qe?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,pe.toString(!0)),(0,Et.firstOrDefault)(await Pe.open({context:5,cli:{...this.j.args},urisToOpen:[Qe],forceNewWindow:Re,gotoLineMode:!0}))?.focus(),!0):Re?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,Et.firstOrDefault)(await Pe.open({context:5,cli:{...this.j.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ke.getRemoteAuthority)(pe)}))?.ready(),Ie.open(pe,Te)):(this.h.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Te),!1)}F(Pe){const Ie=this.B(this.g.createInstance(Me.SharedProcess,Pe)),pe=(async()=>{this.h.trace("Main->SharedProcess#connect");const Re=await Ie.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new c.Client(Re,"main")})();return{sharedProcessReady:(async()=>(await Ie.whenReady(),pe))(),sharedProcessClient:pe}}async G(Pe,Ie){const pe=new C.ServiceCollection;switch(process.platform){case"win32":pe.set(De.IUpdateService,new oe.SyncDescriptor(ze.Win32UpdateService));break;case"linux":s.isLinuxSnap?pe.set(De.IUpdateService,new oe.SyncDescriptor($e.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(De.IUpdateService,new oe.SyncDescriptor(He.LinuxUpdateService));break;case"darwin":pe.set(De.IUpdateService,new oe.SyncDescriptor(We.DarwinUpdateService));break}pe.set(Se.IWindowsMainService,new oe.SyncDescriptor(Le.WindowsMainService,[Pe,this.f],!1));const Te=new T.DialogMainService(this.h,this.p);pe.set(T.IDialogMainService,Te),pe.set(j.ILaunchMainService,new oe.SyncDescriptor(j.LaunchMainService,void 0,!1)),pe.set(L.IDiagnosticsMainService,new oe.SyncDescriptor(L.DiagnosticsMainService,void 0,!1)),pe.set(S.IDiagnosticsService,k.ProxyChannel.toService((0,k.getDelayedChannel)(Ie.then(Ue=>Ue.getChannel("diagnostics"))))),pe.set(W.IIssueMainService,new oe.SyncDescriptor(z.IssueMainService,[this.f])),pe.set(U.IEncryptionMainService,new oe.SyncDescriptor(H.EncryptionMainService,[Pe])),pe.set(q.IKeyboardLayoutMainService,new oe.SyncDescriptor(q.KeyboardLayoutMainService)),pe.set(ue.INativeHostMainService,new oe.SyncDescriptor(ue.NativeHostMainService,void 0,!1)),pe.set(D.ICredentialsMainService,new oe.SyncDescriptor(ot.CredentialsNativeMainService)),pe.set(ge.IWebviewManagerService,new oe.SyncDescriptor(me.WebviewMainService)),pe.set(se.IMenubarMainService,new oe.SyncDescriptor(se.MenubarMainService)),pe.set(ce.IExtensionUrlTrustService,new oe.SyncDescriptor(le.ExtensionUrlTrustService)),pe.set(X.IExtensionHostStarter,new oe.SyncDescriptor(G.ExtensionHostStarter)),pe.set(we.IStorageMainService,new oe.SyncDescriptor(we.StorageMainService)),pe.set(we.IApplicationStorageMainService,new oe.SyncDescriptor(we.ApplicationStorageMainService));const Re=new Ht.ElectronPtyHostStarter({graceTime:6e4,shortGraceTime:6e3,scrollback:this.l.getValue("terminal.integrated.persistentSessionScrollback")??100},this.j,this.k,this.h),Be=new Vt.PtyHostService(Re,this.l,this.h,this.i);pe.set(wt.ILocalPtyService,Be),s.isWindows?pe.set(N.IExternalTerminalMainService,new oe.SyncDescriptor(F.WindowsExternalTerminalService)):s.isMacintosh?pe.set(N.IExternalTerminalMainService,new oe.SyncDescriptor(F.MacExternalTerminalService)):s.isLinux&&pe.set(N.IExternalTerminalMainService,new oe.SyncDescriptor(F.LinuxExternalTerminalService));const Je=new h.BackupMainService(this.j,this.l,this.h,this.m);pe.set(o.IBackupMainService,Je);const Qe=new tt.WorkspacesManagementMainService(this.j,this.h,this.r,Je,Te);if(pe.set(tt.IWorkspacesManagementMainService,Qe),pe.set(Ze.IWorkspacesService,new oe.SyncDescriptor(Ye.WorkspacesMainService,void 0,!1)),pe.set(Ge.IWorkspacesHistoryMainService,new oe.SyncDescriptor(Ge.WorkspacesHistoryMainService,void 0,!1)),pe.set(qe.IURLService,new oe.SyncDescriptor(Q.NativeURLService,void 0,!1)),(0,Ce.supportsTelemetry)(this.p,this.j)){const Ue=(0,Ce.isInternalTelemetry)(this.p,this.l),Ve=(0,k.getDelayedChannel)(Ie.then(it=>it.getChannel("telemetryAppender"))),xe=new he.TelemetryAppenderClient(Ve),Xe=(0,Ee.resolveCommonProperties)((0,O.release)(),(0,O.hostname)(),process.arch,this.p.commit,this.p.version,Pe,Ue),_e=(0,Ce.getPiiPathsFromEnvironment)(this.j),rt={appenders:[xe],commonProperties:Xe,piiPaths:_e,sendErrorTelemetry:!0};pe.set(ee.ITelemetryService,new oe.SyncDescriptor(fe.TelemetryService,[rt],!1))}else pe.set(ee.ITelemetryService,Ce.NullTelemetryService);return pe.set(Ot.IExtensionsProfileScannerService,new oe.SyncDescriptor(Bt.ExtensionsProfileScannerService,void 0,!0)),pe.set(Tt.IExtensionsScannerService,new oe.SyncDescriptor(Ft.ExtensionsScannerService,void 0,!0)),pe.set(pt.IUtilityProcessWorkerMainService,new oe.SyncDescriptor(pt.UtilityProcessWorkerMainService,void 0,!0)),await mt.Promises.settled([Je.initialize(),Qe.initialize()]),this.g.createChild(pe)}H(Pe,Ie,pe){const Te=k.ProxyChannel.fromService(Pe.get(j.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Te);const Re=k.ProxyChannel.fromService(Pe.get(L.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Re);const Be=new Mt.PolicyChannel(Pe.get(ct.IPolicyService));Ie.registerChannel("policy",Be),pe.then(et=>et.registerChannel("policy",Be));const Je=this.n.getProvider(b.Schemas.file);(0,y.assertType)(Je instanceof ae.DiskFileSystemProvider);const Qe=new _.DiskFileSystemProviderChannel(Je,this.h,this.j);Ie.registerChannel(V.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe),pe.then(et=>et.registerChannel(V.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe));const Ue=k.ProxyChannel.fromService(Pe.get(gt.IUserDataProfilesMainService));Ie.registerChannel("userDataProfiles",Ue),pe.then(et=>et.registerChannel("userDataProfiles",Ue));const Ve=new At.RequestChannel(Pe.get(Lt.IRequestService));pe.then(et=>et.registerChannel("request",Ve));const xe=new Oe.UpdateChannel(Pe.get(De.IUpdateService));Ie.registerChannel("update",xe);const Xe=k.ProxyChannel.fromService(Pe.get(W.IIssueMainService));Ie.registerChannel("issue",Xe);const _e=k.ProxyChannel.fromService(Pe.get(U.IEncryptionMainService));Ie.registerChannel("encryption",_e);const rt=k.ProxyChannel.fromService(Pe.get(D.ICredentialsMainService));Ie.registerChannel("credentials",rt);const it=k.ProxyChannel.fromService(Pe.get(Ae.ISignService));Ie.registerChannel("sign",it);const lt=k.ProxyChannel.fromService(Pe.get(q.IKeyboardLayoutMainService));Ie.registerChannel("keyboardLayout",lt),this.b=Pe.get(ue.INativeHostMainService);const Pt=k.ProxyChannel.fromService(this.b);Ie.registerChannel("nativeHost",Pt),pe.then(et=>et.registerChannel("nativeHost",Pt));const xt=k.ProxyChannel.fromService(Pe.get(Ze.IWorkspacesService));Ie.registerChannel("workspaces",xt);const Gt=k.ProxyChannel.fromService(Pe.get(se.IMenubarMainService));Ie.registerChannel("menubar",Gt);const Kt=k.ProxyChannel.fromService(Pe.get(qe.IURLService));Ie.registerChannel("url",Kt);const Xt=k.ProxyChannel.fromService(Pe.get(ce.IExtensionUrlTrustService));Ie.registerChannel("extensionUrlTrust",Xt);const Jt=k.ProxyChannel.fromService(Pe.get(ge.IWebviewManagerService));Ie.registerChannel("webview",Jt);const kt=this.B(new ye.StorageDatabaseChannel(this.h,Pe.get(we.IStorageMainService)));Ie.registerChannel("storage",kt),pe.then(et=>et.registerChannel("storage",kt));const Yt=this.B(new Ut.ProfileStorageChangesListenerChannel(Pe.get(we.IStorageMainService),Pe.get(gt.IUserDataProfilesMainService),this.h));pe.then(et=>et.registerChannel("profileStorageListener",Yt));const Qt=k.ProxyChannel.fromService(Pe.get(wt.ILocalPtyService));Ie.registerChannel(wt.TerminalIpcChannels.LocalPty,Qt);const Zt=k.ProxyChannel.fromService(Pe.get(N.IExternalTerminalMainService));Ie.registerChannel("externalTerminal",Zt);const Ct=new jt.LoggerChannel(Pe.get(zt.ILoggerMainService));Ie.registerChannel("logger",Ct),pe.then(et=>et.registerChannel("logger",Ct));const _t=new R.ElectronExtensionHostDebugBroadcastChannel(Pe.get(Se.IWindowsMainService));Ie.registerChannel("extensionhostdebugservice",_t);const ei=k.ProxyChannel.fromService(Pe.get(X.IExtensionHostStarter));Ie.registerChannel(X.ipcExtensionHostStarterChannelName,ei);const ti=k.ProxyChannel.fromService(Pe.get(pt.IUtilityProcessWorkerMainService));Ie.registerChannel(qt.ipcUtilityProcessWorkerChannelName,ti)}async I(Pe,Ie){const pe=this.a=Pe.get(Se.IWindowsMainService),Te=(0,Y.isLaunchedFromCli)(process.env)?0:4,Re=this.j.args;if(Ie){if(Ie.openables.length>0)return pe.open({context:Te,cli:Re,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const it of Ie.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),pe.open({context:Te,cli:Re,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Be=global.macOpenFiles,Je=Re._.length,Qe=!!Re["folder-uri"],Ue=!!Re["file-uri"],Ve=Re["skip-add-to-recently-opened"]===!0,xe=Re.wait&&Re.waitMarkerFilePath?a.URI.file(Re.waitMarkerFilePath):void 0,Xe=Re.remote||void 0,_e=Re.profile,rt=Re["profile-temp"];if(!Je&&!Qe&&!Ue){if(Re["new-window"]||_e||rt)return pe.open({context:Te,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Xe,forceProfile:_e,forceTempProfile:rt});if(Be.length)return pe.open({context:1,cli:Re,urisToOpen:Be.map(it=>(0,Ke.hasWorkspaceFileExtension)(it)?{workspaceUri:a.URI.file(it)}:{fileUri:a.URI.file(it)}),noRecentEntry:Ve,waitMarkerFileURI:xe,initialStartup:!0})}return pe.open({context:Te,cli:Re,forceNewWindow:Re["new-window"]||!Je&&Re["unity-launch"],diffMode:Re.diff,mergeMode:Re.merge,noRecentEntry:Ve,waitMarkerFileURI:xe,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:Xe,forceProfile:_e,forceTempProfile:rt})}J(){this.L(),E.protocol.registerHttpProtocol(b.Schemas.vscodeRemoteResource,(Pe,Ie)=>{Ie({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.M(this.j.args,process.env,!0),this.N()}async L(){const Pe=this.p.win32MutexName;if(s.isWindows&&Pe)try{const Ie=await new Promise((Te,Re)=>{x(["@vscode/windows-mutex"],Te,Re)}),pe=new Ie.Mutex(Pe);(0,w.once)(this.k.onWillShutdown)(()=>pe.release())}catch(Ie){this.h.error(Ie)}}async M(Pe,Ie,pe){try{return await(0,ne.getResolvedShellEnv)(this.l,this.h,Pe,Ie)}catch(Te){const Re=(0,P.toErrorMessage)(Te);pe?this.a?.sendToFocused("vscode:showResolveShellEnvError",Re):this.h.error(Re)}return{}}async N(){try{const Ie=(await this.n.readFile(this.j.argvResource)).value.toString(),pe=JSON.parse((0,m.stripComments)(Ie)),Re=(0,Ce.getTelemetryLevel)(this.l)>=1;if(pe["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Re},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,d.generateUuid)()}"`,"}"],Je=Ie.substring(0,Ie.length-2).concat(`,
`,Be.join(`
`));await this.n.writeFile(this.j.argvResource,M.VSBuffer.fromString(Je))}else{const Be=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Re},`);Be!==Ie&&await this.n.writeFile(this.j.argvResource,M.VSBuffer.fromString(Be))}}catch(Pe){this.h.error(Pe)}}};e.CodeApplication=It=ve([Z(2,B.IInstantiationService),Z(3,K.ILogService),Z(4,K.ILoggerService),Z(5,re.IEnvironmentMainService),Z(6,$.ILifecycleMainService),Z(7,g.IConfigurationService),Z(8,Fe.IStateService),Z(9,J.IFileService),Z(10,be.IProductService),Z(11,gt.IUserDataProfilesMainService)],It)}),define(te[310],ie([0,1,15,42,8,24,7,50,13,32,49,45,14,9,65,3,36,25,22,43,130,304,10,19,237,247,30,63,200,16,220,92,74,215,91,20,223,5,77,23,78,279,125,261,51,287,94,246,34,52,79,53,39,232,230,2,40,264,66,225,90,120,262]),function(x,e,E,A,r,O,M,P,f,l,w,m,v,u,b,p,s,y,a,d,I,k,t,c,n,i,o,h,g,D,R,S,L,T,U,H,re,Y,ne,ce,le,X,G,N,F,V,J,_,ae,oe,B,C,W,z,q,j,$,K,se,ue,be,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Me{main(){try{this.a()}catch(ye){console.error(ye.message),E.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[ye,we,Ee,ee,he,fe,Ce,De]=this.b();try{try{await this.d(Ee,De,ee,he,Ce)}catch(Oe){throw this.f(Ee,Ce,Oe),Oe}await ye.invokeFunction(async Oe=>{const We=Oe.get(Y.ILogService),He=Oe.get(H.ILifecycleMainService),$e=Oe.get(D.IFileService),ze=Oe.get(Y.ILoggerService),qe=await this.e(We,Ee,He,ye,Ce,!0);return a.Promises.writeFile(Ee.mainLockfile,String(process.pid)).catch(je=>{We.warn(`app#startup(): Error writing main lockfile: ${je.stack}`)}),fe.logger=ze.createLogger("main",{name:(0,t.localize)(0,null)}),(0,w.once)(He.onWillShutdown)(je=>{$e.dispose(),ee.dispose(),je.join("instanceLockfile",a.Promises.unlink(Ee.mainLockfile).catch(()=>{}))}),ye.createInstance(k.CodeApplication,qe,we).startup()})}catch(Oe){ye.invokeFunction(this.i,Oe)}}b(){const ye=new U.ServiceCollection,we=new j.DisposableStore;process.once("exit",()=>we.dispose());const Ee={_serviceBrand:void 0,...ne.default};ye.set(ce.IProductService,Ee);const ee=new o.EnvironmentMainService(this.j(),Ee),he=this.c(ee);ye.set(o.IEnvironmentMainService,ee);const fe=new se.LoggerMainService((0,Y.getLogLevel)(ee),ee.logsHome);ye.set(se.ILoggerMainService,fe);const Ce=new re.BufferLogger(fe.getLogLevel()),De=we.add(new ue.LogService(Ce,[new Y.ConsoleMainLogger(fe.getLogLevel())]));ye.set(Y.ILogService,De);const Oe=new R.FileService(De);ye.set(D.IFileService,Oe);const We=new S.DiskFileSystemProvider(De);Oe.registerProvider(v.Schemas.file,We);const He=new K.UriIdentityService(Oe);ye.set($.IUriIdentityService,He);const $e=new ke.StateService(1,ee,De,Oe);ye.set(ae.IStateReadService,$e),ye.set(ae.IStateService,$e);const ze=new C.UserDataProfilesMainService($e,He,ee,Oe,De);ye.set(C.IUserDataProfilesMainService,ze);const qe=p.isWindows&&Ee.win32RegValueName?we.add(new z.NativePolicyService(De,Ee.win32RegValueName)):ee.policyFile?we.add(new q.FilePolicyService(ee.policyFile,Oe,De)):new W.NullPolicyService;ye.set(W.IPolicyService,qe);const je=new n.ConfigurationService(ze.defaultProfile.settingsResource,Oe,qe,De);return ye.set(c.IConfigurationService,je),ye.set(H.ILifecycleMainService,new L.SyncDescriptor(H.LifecycleMainService,void 0,!1)),ye.set(F.IRequestService,new L.SyncDescriptor(V.RequestMainService,void 0,!0)),ye.set(B.IThemeMainService,new L.SyncDescriptor(B.ThemeMainService)),ye.set(J.ISignService,new L.SyncDescriptor(_.SignService,void 0,!1)),ye.set(G.ITunnelService,new L.SyncDescriptor(N.TunnelService)),ye.set(le.IProtocolMainService,new X.ProtocolMainService(ee,ze,De)),[new T.InstantiationService(ye,!0),he,ee,je,$e,Ce,Ee,ze]}c(ye){const we={VSCODE_IPC_HOOK:ye.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const ee=process.env[Ee];typeof ee=="string"&&(we[Ee]=ee)}),Object.assign(process.env,we),we}async d(ye,we,Ee,ee,he){await M.Promises.settled([Promise.all([ye.extensionsPath,ye.codeCachePath,ye.logsHome.fsPath,we.defaultProfile.globalStorageHome.fsPath,ye.workspaceStorageHome.fsPath,ye.localHistoryHome.fsPath,ye.backupHome].map(fe=>fe?a.Promises.mkdir(fe,{recursive:!0}):void 0)),ee.init(),Ee.initialize()]),we.init()}async e(ye,we,Ee,ee,he,fe){let Ce;try{(0,b.mark)("code/willStartMainServer"),Ce=await(0,I.serve)(we.mainIPCHandle),(0,b.mark)("code/didStartMainServer"),(0,w.once)(Ee.onWillShutdown)(()=>Ce.dispose())}catch(De){if(De.code!=="EADDRINUSE")throw this.f(we,he,De),De;let Oe;try{Oe=await(0,I.connect)(we.mainIPCHandle,"main")}catch(ze){if(!fe||p.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.g((0,t.localize)(1,null,he.nameShort),(0,t.localize)(2,null),he),ze;try{(0,A.unlinkSync)(we.mainIPCHandle)}catch(qe){throw ye.warn("Could not delete obsolete instance handle",qe),qe}return this.e(ye,we,Ee,ee,he,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ze=`Running extension tests from the command line is currently only supported if no other instance of ${he.nameShort} is running.`;throw ye.error(ze),Oe.dispose(),new Error(ze)}let We;!we.args.wait&&!we.args.status&&(We=setTimeout(()=>{this.g((0,t.localize)(3,null,he.nameShort),(0,t.localize)(4,null),he)},1e4));const He=d.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),$e=d.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return ee.invokeFunction(async()=>{const ze=new i.DiagnosticsService(oe.NullTelemetryService,he),qe=await $e.getMainDiagnostics(),je=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Q=await ze.getDiagnostics(qe,je);throw console.log(Q),new f.ExpectedError});throw p.isWindows&&await this.h(He,ye),ye.trace("Sending env to running instance..."),await He.start(we.args,process.env),Oe.dispose(),We&&clearTimeout(We),new f.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw ye.warn((0,t.localize)(5,null,he.nameShort)),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ce}f(ye,we,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const ee=(0,O.coalesce)([ye.userDataPath,ye.extensionsPath,I.XDG_RUNTIME_DIR]).map(he=>(0,m.getPathLabel)(r.URI.file(he),{os:p.OS,tildify:ye}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,P.toErrorMessage)(Ee),ee.join(`
`)),we)}}g(ye,we,Ee){E.dialog.showMessageBoxSync((0,be.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ye,detail:we},Ee).options)}async h(ye,we){if(p.isWindows){const Ee=await ye.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((ee,he)=>{x(["windows-foreground-love"],ee,he)})).allowSetForegroundWindow(Ee)}catch(ee){we.error(ee)}}}i(ye,we){const Ee=ye.get(Y.ILogService),ee=ye.get(H.ILifecycleMainService);let he=0;we&&(we.isExpected?we.message&&Ee.trace(we.message):(he=1,we.stack?Ee.error(we.stack):Ee.error(`Startup error: ${we.toString()}`))),ee.kill(he)}j(){const ye=this.k((0,h.parseMainProcessArgv)(process.argv));if(ye.wait&&!ye.waitMarkerFilePath){const we=(0,g.createWaitMarkerFileSync)(ye.verbose);we&&((0,h.addArg)(process.argv,"--waitMarkerFilePath",we),ye.waitMarkerFilePath=we)}return ye}k(ye){if(ye["open-url"]&&(ye._urls=ye._,ye._=[]),!ye.remote){const we=this.l(ye._,ye.goto);ye._=we}return ye}l(ye,we){const Ee=(0,s.cwd)(),ee=ye.map(Ce=>{let De=String(Ce),Oe;we&&(Oe=(0,l.parseLineAndColumnAware)(De),De=Oe.path),De&&(De=this.m(Ee,De));const We=(0,l.sanitizeFilePath)(De,Ee),He=(0,u.basename)(We);return He&&!(0,l.isValidBasename)(He)?null:we&&Oe?(Oe.path=We,this.n(Oe)):We}),he=p.isWindows||p.isMacintosh,fe=(0,O.distinct)(ee,Ce=>Ce&&he?Ce.toLowerCase():Ce||"");return(0,O.coalesce)(fe)}m(ye,we){return p.isWindows&&(we=(0,y.rtrim)(we,'"')),we=(0,y.trim)((0,y.trim)(we," "),"	"),p.isWindows&&(we=(0,u.resolve)(ye,we),we=(0,y.rtrim)(we,".")),we}n(ye){const we=[ye.path];return typeof ye.line=="number"&&we.push(String(ye.line)),typeof ye.column=="number"&&we.push(String(ye.column)),we.join(":")}}new Me().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b380da4ef1ee00e224a15c1d4d9793e27c2b6302/core/vs/code/electron-main/main.js.map
