/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/nls","vs/base/common/arrays","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/browser","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/lazy","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],me=function(te){for(var t=[],E=0,L=te.length;E<L;E++)t[E]=ge[te[E]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function _t(te){if(Array.isArray(te)){for(var t=0,E=Array(te.length);t<te.length;t++)E[t]=te[t];return E}else return Array.from(te)}var jt=Object.hasOwnProperty,Nt=Object.setPrototypeOf,Vt=Object.isFrozen,qt=Object.getPrototypeOf,Kt=Object.getOwnPropertyDescriptor,tt=Object.freeze,at=Object.seal,Gt=Object.create,It=typeof Reflect<"u"&&Reflect,wt=It.apply,At=It.construct;wt||(wt=function(t,E,L){return t.apply(E,L)}),tt||(tt=function(t){return t}),at||(at=function(t){return t}),At||(At=function(t,E){return new(Function.prototype.bind.apply(t,[null].concat(_t(E))))});var Yt=st(Array.prototype.forEach),Mt=st(Array.prototype.pop),gt=st(Array.prototype.push),ht=st(String.prototype.toLowerCase),Pt=st(String.prototype.match),ut=st(String.prototype.replace),Xt=st(String.prototype.indexOf),Zt=st(String.prototype.trim),lt=st(RegExp.prototype.test),Rt=Qt(TypeError);function st(te){return function(t){for(var E=arguments.length,L=Array(E>1?E-1:0),i=1;i<E;i++)L[i-1]=arguments[i];return wt(te,t,L)}}function Qt(te){return function(){for(var t=arguments.length,E=Array(t),L=0;L<t;L++)E[L]=arguments[L];return At(te,E)}}function He(te,t){Nt&&Nt(te,null);for(var E=t.length;E--;){var L=t[E];if(typeof L=="string"){var i=ht(L);i!==L&&(Vt(t)||(t[E]=i),L=i)}te[L]=!0}return te}function ct(te){var t=Gt(null),E=void 0;for(E in te)wt(jt,te,[E])&&(t[E]=te[E]);return t}function Dt(te,t){for(;te!==null;){var E=Kt(te,t);if(E){if(E.get)return st(E.get);if(typeof E.value=="function")return st(E.value)}te=qt(te)}function L(i){return console.warn("fallback value for",i),null}return L}var Ot=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),St=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Jt=tt(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Ft=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),ei=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Bt=tt(["#text"]),Ht=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),kt=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),zt=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ti=at(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ii=at(/<%[\s\S]*|[\s\S]*%>/gm),ni=at(/^data-[\-\w.\u00B7-\uFFFF]/),si=at(/^aria-[\-\w]+$/),ri=at(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),oi=at(/^(?:\w+script|data):/i),ai=at(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),mt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(te){return typeof te}:function(te){return te&&typeof Symbol=="function"&&te.constructor===Symbol&&te!==Symbol.prototype?"symbol":typeof te};function ot(te){if(Array.isArray(te)){for(var t=0,E=Array(te.length);t<te.length;t++)E[t]=te[t];return E}else return Array.from(te)}var li=function(){return typeof window>"u"?null:window},ui=function(t,E){if((typeof t>"u"?"undefined":mt(t))!=="object"||typeof t.createPolicy!="function")return null;var L=null,i="data-tt-policy-suffix";E.currentScript&&E.currentScript.hasAttribute(i)&&(L=E.currentScript.getAttribute(i));var W="dompurify"+(L?"#"+L:"");try{return t.createPolicy(W,{createHTML:function(y){return y}})}catch{return console.warn("TrustedTypes policy "+W+" could not be created."),null}};function Ut(){var te=arguments.length>0&&arguments[0]!==void 0?arguments[0]:li(),t=function(he){return Ut(he)};if(t.version="2.3.1",t.removed=[],!te||!te.document||te.document.nodeType!==9)return t.isSupported=!1,t;var E=te.document,L=te.document,i=te.DocumentFragment,W=te.HTMLTemplateElement,D=te.Node,y=te.Element,h=te.NodeFilter,l=te.NamedNodeMap,d=l===void 0?te.NamedNodeMap||te.MozNamedAttrMap:l,N=te.Text,r=te.Comment,u=te.DOMParser,e=te.trustedTypes,a=y.prototype,n=Dt(a,"cloneNode"),c=Dt(a,"nextSibling"),s=Dt(a,"childNodes"),w=Dt(a,"parentNode");if(typeof W=="function"){var v=L.createElement("template");v.content&&v.content.ownerDocument&&(L=v.content.ownerDocument)}var F=ui(e,E),f=F&&Y?F.createHTML(""):"",b=L,B=b.implementation,M=b.createNodeIterator,m=b.createDocumentFragment,g=b.getElementsByTagName,p=E.importNode,I={};try{I=ct(L).documentMode?L.documentMode:{}}catch{}var O={};t.isSupported=typeof w=="function"&&B&&typeof B.createHTMLDocument<"u"&&I!==9;var U=ti,Z=ii,ne=ni,se=si,ce=oi,ue=ai,ae=ri,oe=null,ye=He({},[].concat(ot(Ot),ot(St),ot(Ct),ot(Ft),ot(Bt))),ke=null,Be=He({},[].concat(ot(Ht),ot(kt),ot(zt),ot(yt))),Me=null,fe=null,$=!0,ie=!0,q=!1,V=!1,A=!1,K=!1,x=!1,o=!1,k=!1,_=!0,Y=!1,C=!0,T=!0,R=!1,S={},z=null,H=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),P=null,j=He({},["audio","video","img","source","image","track"]),G=null,ee=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),re="http://www.w3.org/1998/Math/MathML",pe="http://www.w3.org/2000/svg",we="http://www.w3.org/1999/xhtml",Ne=we,Se=!1,ve=null,Pe=L.createElement("form"),Le=function(he){ve&&ve===he||((!he||(typeof he>"u"?"undefined":mt(he))!=="object")&&(he={}),he=ct(he),oe="ALLOWED_TAGS"in he?He({},he.ALLOWED_TAGS):ye,ke="ALLOWED_ATTR"in he?He({},he.ALLOWED_ATTR):Be,G="ADD_URI_SAFE_ATTR"in he?He(ct(ee),he.ADD_URI_SAFE_ATTR):ee,P="ADD_DATA_URI_TAGS"in he?He(ct(j),he.ADD_DATA_URI_TAGS):j,z="FORBID_CONTENTS"in he?He({},he.FORBID_CONTENTS):H,Me="FORBID_TAGS"in he?He({},he.FORBID_TAGS):{},fe="FORBID_ATTR"in he?He({},he.FORBID_ATTR):{},S="USE_PROFILES"in he?he.USE_PROFILES:!1,$=he.ALLOW_ARIA_ATTR!==!1,ie=he.ALLOW_DATA_ATTR!==!1,q=he.ALLOW_UNKNOWN_PROTOCOLS||!1,V=he.SAFE_FOR_TEMPLATES||!1,A=he.WHOLE_DOCUMENT||!1,o=he.RETURN_DOM||!1,k=he.RETURN_DOM_FRAGMENT||!1,_=he.RETURN_DOM_IMPORT!==!1,Y=he.RETURN_TRUSTED_TYPE||!1,x=he.FORCE_BODY||!1,C=he.SANITIZE_DOM!==!1,T=he.KEEP_CONTENT!==!1,R=he.IN_PLACE||!1,ae=he.ALLOWED_URI_REGEXP||ae,Ne=he.NAMESPACE||we,V&&(ie=!1),k&&(o=!0),S&&(oe=He({},[].concat(ot(Bt))),ke=[],S.html===!0&&(He(oe,Ot),He(ke,Ht)),S.svg===!0&&(He(oe,St),He(ke,kt),He(ke,yt)),S.svgFilters===!0&&(He(oe,Ct),He(ke,kt),He(ke,yt)),S.mathMl===!0&&(He(oe,Ft),He(ke,zt),He(ke,yt))),he.ADD_TAGS&&(oe===ye&&(oe=ct(oe)),He(oe,he.ADD_TAGS)),he.ADD_ATTR&&(ke===Be&&(ke=ct(ke)),He(ke,he.ADD_ATTR)),he.ADD_URI_SAFE_ATTR&&He(G,he.ADD_URI_SAFE_ATTR),he.FORBID_CONTENTS&&(z===H&&(z=ct(z)),He(z,he.FORBID_CONTENTS)),T&&(oe["#text"]=!0),A&&He(oe,["html","head","body"]),oe.table&&(He(oe,["tbody"]),delete Me.tbody),tt&&tt(he),ve=he)},Ve=He({},["mi","mo","mn","ms","mtext"]),ze=He({},["foreignobject","desc","title","annotation-xml"]),We=He({},St);He(We,Ct),He(We,Jt);var Je=He({},Ft);He(Je,ei);var it=function(he){var Ee=w(he);(!Ee||!Ee.tagName)&&(Ee={namespaceURI:we,tagName:"template"});var Ie=ht(he.tagName),Ue=ht(Ee.tagName);if(he.namespaceURI===pe)return Ee.namespaceURI===we?Ie==="svg":Ee.namespaceURI===re?Ie==="svg"&&(Ue==="annotation-xml"||Ve[Ue]):!!We[Ie];if(he.namespaceURI===re)return Ee.namespaceURI===we?Ie==="math":Ee.namespaceURI===pe?Ie==="math"&&ze[Ue]:!!Je[Ie];if(he.namespaceURI===we){if(Ee.namespaceURI===pe&&!ze[Ue]||Ee.namespaceURI===re&&!Ve[Ue])return!1;var Xe=He({},["title","style","font","a","script"]);return!Je[Ie]&&(Xe[Ie]||!We[Ie])}return!1},Oe=function(he){gt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{try{he.outerHTML=f}catch{he.remove()}}},je=function(he,Ee){try{gt(t.removed,{attribute:Ee.getAttributeNode(he),from:Ee})}catch{gt(t.removed,{attribute:null,from:Ee})}if(Ee.removeAttribute(he),he==="is"&&!ke[he])if(o||k)try{Oe(Ee)}catch{}else try{Ee.setAttribute(he,"")}catch{}},X=function(he){var Ee=void 0,Ie=void 0;if(x)he="<remove></remove>"+he;else{var Ue=Pt(he,/^[\r\n\t ]+/);Ie=Ue&&Ue[0]}var Xe=F?F.createHTML(he):he;if(Ne===we)try{Ee=new u().parseFromString(Xe,"text/html")}catch{}if(!Ee||!Ee.documentElement){Ee=B.createDocument(Ne,"template",null);try{Ee.documentElement.innerHTML=Se?"":Xe}catch{}}var Ze=Ee.body||Ee.documentElement;return he&&Ie&&Ze.insertBefore(L.createTextNode(Ie),Ze.childNodes[0]||null),Ne===we?g.call(Ee,A?"html":"body")[0]:A?Ee.documentElement:Ze},le=function(he){return M.call(he.ownerDocument||he,he,h.SHOW_ELEMENT|h.SHOW_COMMENT|h.SHOW_TEXT,null,!1)},be=function(he){return he instanceof N||he instanceof r?!1:typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof d)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"},De=function(he){return(typeof D>"u"?"undefined":mt(D))==="object"?he instanceof D:he&&(typeof he>"u"?"undefined":mt(he))==="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},Ae=function(he,Ee,Ie){O[he]&&Yt(O[he],function(Ue){Ue.call(t,Ee,Ie,ve)})},Re=function(he){var Ee=void 0;if(Ae("beforeSanitizeElements",he,null),be(he)||Pt(he.nodeName,/[\u0080-\uFFFF]/))return Oe(he),!0;var Ie=ht(he.nodeName);if(Ae("uponSanitizeElement",he,{tagName:Ie,allowedTags:oe}),!De(he.firstElementChild)&&(!De(he.content)||!De(he.content.firstElementChild))&&lt(/<[/\w]/g,he.innerHTML)&&lt(/<[/\w]/g,he.textContent)||Ie==="select"&&lt(/<template/i,he.innerHTML))return Oe(he),!0;if(!oe[Ie]||Me[Ie]){if(T&&!z[Ie]){var Ue=w(he)||he.parentNode,Xe=s(he)||he.childNodes;if(Xe&&Ue)for(var Ze=Xe.length,Qe=Ze-1;Qe>=0;--Qe)Ue.insertBefore(n(Xe[Qe],!0),c(he))}return Oe(he),!0}return he instanceof y&&!it(he)||(Ie==="noscript"||Ie==="noembed")&&lt(/<\/no(script|embed)/i,he.innerHTML)?(Oe(he),!0):(V&&he.nodeType===3&&(Ee=he.textContent,Ee=ut(Ee,U," "),Ee=ut(Ee,Z," "),he.textContent!==Ee&&(gt(t.removed,{element:he.cloneNode()}),he.textContent=Ee)),Ae("afterSanitizeElements",he,null),!1)},$e=function(he,Ee,Ie){if(C&&(Ee==="id"||Ee==="name")&&(Ie in L||Ie in Pe))return!1;if(!(ie&&!fe[Ee]&&lt(ne,Ee))){if(!($&&lt(se,Ee))){if(!ke[Ee]||fe[Ee])return!1;if(!G[Ee]){if(!lt(ae,ut(Ie,ue,""))){if(!((Ee==="src"||Ee==="xlink:href"||Ee==="href")&&he!=="script"&&Xt(Ie,"data:")===0&&P[he])){if(!(q&&!lt(ce,ut(Ie,ue,"")))){if(Ie)return!1}}}}}}return!0},Ge=function(he){var Ee=void 0,Ie=void 0,Ue=void 0,Xe=void 0;Ae("beforeSanitizeAttributes",he,null);var Ze=he.attributes;if(Ze){var Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ke};for(Xe=Ze.length;Xe--;){Ee=Ze[Xe];var rt=Ee,dt=rt.name,bt=rt.namespaceURI;if(Ie=Zt(Ee.value),Ue=ht(dt),Qe.attrName=Ue,Qe.attrValue=Ie,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,Ae("uponSanitizeAttribute",he,Qe),Ie=Qe.attrValue,!Qe.forceKeepAttr&&(je(dt,he),!!Qe.keepAttr)){if(lt(/\/>/i,Ie)){je(dt,he);continue}V&&(Ie=ut(Ie,U," "),Ie=ut(Ie,Z," "));var Tt=he.nodeName.toLowerCase();if($e(Tt,Ue,Ie))try{bt?he.setAttributeNS(bt,dt,Ie):he.setAttribute(dt,Ie),Mt(t.removed)}catch{}}}Ae("afterSanitizeAttributes",he,null)}},et=function Fe(he){var Ee=void 0,Ie=le(he);for(Ae("beforeSanitizeShadowDOM",he,null);Ee=Ie.nextNode();)Ae("uponSanitizeShadowNode",Ee,null),!Re(Ee)&&(Ee.content instanceof i&&Fe(Ee.content),Ge(Ee));Ae("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(Fe,he){var Ee=void 0,Ie=void 0,Ue=void 0,Xe=void 0,Ze=void 0;if(Se=!Fe,Se&&(Fe="<!-->"),typeof Fe!="string"&&!De(Fe)){if(typeof Fe.toString!="function")throw Rt("toString is not a function");if(Fe=Fe.toString(),typeof Fe!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(mt(te.toStaticHTML)==="object"||typeof te.toStaticHTML=="function"){if(typeof Fe=="string")return te.toStaticHTML(Fe);if(De(Fe))return te.toStaticHTML(Fe.outerHTML)}return Fe}if(K||Le(he),t.removed=[],typeof Fe=="string"&&(R=!1),!R)if(Fe instanceof D)Ee=X("<!---->"),Ie=Ee.ownerDocument.importNode(Fe,!0),Ie.nodeType===1&&Ie.nodeName==="BODY"||Ie.nodeName==="HTML"?Ee=Ie:Ee.appendChild(Ie);else{if(!o&&!V&&!A&&Fe.indexOf("<")===-1)return F&&Y?F.createHTML(Fe):Fe;if(Ee=X(Fe),!Ee)return o?null:f}Ee&&x&&Oe(Ee.firstChild);for(var Qe=le(R?Fe:Ee);Ue=Qe.nextNode();)Ue.nodeType===3&&Ue===Xe||Re(Ue)||(Ue.content instanceof i&&et(Ue.content),Ge(Ue),Xe=Ue);if(Xe=null,R)return Fe;if(o){if(k)for(Ze=m.call(Ee.ownerDocument);Ee.firstChild;)Ze.appendChild(Ee.firstChild);else Ze=Ee;return _&&(Ze=p.call(E,Ze,!0)),Ze}var rt=A?Ee.outerHTML:Ee.innerHTML;return V&&(rt=ut(rt,U," "),rt=ut(rt,Z," ")),F&&Y?F.createHTML(rt):rt},t.setConfig=function(Fe){Le(Fe),K=!0},t.clearConfig=function(){ve=null,K=!1},t.isValidAttribute=function(Fe,he,Ee){ve||Le({});var Ie=ht(Fe),Ue=ht(he);return $e(Ie,Ue,Ee)},t.addHook=function(Fe,he){typeof he=="function"&&(O[Fe]=O[Fe]||[],gt(O[Fe],he))},t.removeHook=function(Fe){O[Fe]&&Mt(O[Fe])},t.removeHooks=function(Fe){O[Fe]&&(O[Fe]=[])},t.removeAllHooks=function(){O={}},t}var hi=Ut();define("vs/base/browser/dompurify/dompurify",function(){return hi}),define(ge[39],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class E{constructor(D){this.domNode=D,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(D){const y=L(D);this.a!==y&&(this.a=y,this.domNode.style.maxWidth=this.a)}setWidth(D){const y=L(D);this.b!==y&&(this.b=y,this.domNode.style.width=this.b)}setHeight(D){const y=L(D);this.c!==y&&(this.c=y,this.domNode.style.height=this.c)}setTop(D){const y=L(D);this.d!==y&&(this.d=y,this.domNode.style.top=this.d)}setLeft(D){const y=L(D);this.e!==y&&(this.e=y,this.domNode.style.left=this.e)}setBottom(D){const y=L(D);this.f!==y&&(this.f=y,this.domNode.style.bottom=this.f)}setRight(D){const y=L(D);this.g!==y&&(this.g=y,this.domNode.style.right=this.g)}setPaddingTop(D){const y=L(D);this.h!==y&&(this.h=y,this.domNode.style.paddingTop=this.h)}setPaddingLeft(D){const y=L(D);this.i!==y&&(this.i=y,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(D){const y=L(D);this.j!==y&&(this.j=y,this.domNode.style.paddingBottom=this.j)}setPaddingRight(D){const y=L(D);this.k!==y&&(this.k=y,this.domNode.style.paddingRight=this.k)}setFontFamily(D){this.l!==D&&(this.l=D,this.domNode.style.fontFamily=this.l)}setFontWeight(D){this.m!==D&&(this.m=D,this.domNode.style.fontWeight=this.m)}setFontSize(D){const y=L(D);this.n!==y&&(this.n=y,this.domNode.style.fontSize=this.n)}setFontStyle(D){this.o!==D&&(this.o=D,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(D){this.p!==D&&(this.p=D,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(D){this.q!==D&&(this.q=D,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(D){this.r!==D&&(this.r=D,this.domNode.style.textDecoration=this.r)}setLineHeight(D){const y=L(D);this.s!==y&&(this.s=y,this.domNode.style.lineHeight=this.s)}setLetterSpacing(D){const y=L(D);this.t!==y&&(this.t=y,this.domNode.style.letterSpacing=this.t)}setClassName(D){this.u!==D&&(this.u=D,this.domNode.className=this.u)}toggleClassName(D,y){this.domNode.classList.toggle(D,y),this.u=this.domNode.className}setDisplay(D){this.v!==D&&(this.v=D,this.domNode.style.display=this.v)}setPosition(D){this.w!==D&&(this.w=D,this.domNode.style.position=this.w)}setVisibility(D){this.x!==D&&(this.x=D,this.domNode.style.visibility=this.x)}setColor(D){this.y!==D&&(this.y=D,this.domNode.style.color=this.y)}setBackgroundColor(D){this.z!==D&&(this.z=D,this.domNode.style.backgroundColor=this.z)}setLayerHinting(D){this.A!==D&&(this.A=D,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(D){this.C!==D&&(this.C=D,this.domNode.style.boxShadow=D)}setContain(D){this.B!==D&&(this.B=D,this.domNode.style.contain=this.B)}setAttribute(D,y){this.domNode.setAttribute(D,y)}removeAttribute(D){this.domNode.removeAttribute(D)}appendChild(D){this.domNode.appendChild(D.domNode)}removeChild(D){this.domNode.removeChild(D.domNode)}}t.FastDomNode=E;function L(W){return typeof W=="number"?`${W}px`:W}function i(W){return new E(W)}t.createFastDomNode=i}),define(ge[66],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let E=!1,L=null;function i(D){if(!D.parent||D.parent===D)return null;try{const y=D.location,h=D.parent.location;if(y.origin!=="null"&&h.origin!=="null"&&y.origin!==h.origin)return E=!0,null}catch{return E=!0,null}return D.parent}class W{static getSameOriginWindowChain(){if(!L){L=[];let y=window,h;do h=i(y),h?L.push({window:y,iframeElement:y.frameElement||null}):L.push({window:y,iframeElement:null}),y=h;while(y)}return L.slice(0)}static hasDifferentOriginAncestor(){return L||this.getSameOriginWindowChain(),E}static getPositionOfChildWindowRelativeToAncestorWindow(y,h){if(!h||y===h)return{top:0,left:0};let l=0,d=0;const N=this.getSameOriginWindowChain();for(const r of N){if(l+=r.window.scrollY,d+=r.window.scrollX,r.window===h||!r.iframeElement)break;const u=r.iframeElement.getBoundingClientRect();l+=u.top,d+=u.left}return{top:l,left:d}}}t.IframeUtils=W}),define(ge[67],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var E;(function(W){W[W.Copy=0]="Copy",W[W.Move=1]="Move"})(E||(t.ListDragOverEffect=E={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class L extends Error{constructor(D,y){super(`ListError [${D}] ${y}`)}}t.ListError=L;class i{constructor(){this.c=new WeakMap}getHeight(D){return this.c.get(D)??this.d(D)}setDynamicHeight(D,y){y>0&&this.c.set(D,y)}}t.CachedListVirtualDelegate=i}),define(ge[68],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class E{constructor(i){this.a=i}splice(i,W,D){this.a.forEach(y=>y.splice(i,W,D))}}t.CombinedSpliceable=E}),define(ge[40],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const E=20;class L{constructor(W,D,y,h,l,d){this.a=Math.round(D),this.b=Math.round(y),this.c=Math.round(W),this.d=h,this.e=l,this.f=d,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new L(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(W){const D=Math.round(W);return this.d!==D?(this.d=D,this.m(),!0):!1}setScrollSize(W){const D=Math.round(W);return this.e!==D?(this.e=D,this.m(),!0):!1}setScrollPosition(W){const D=Math.round(W);return this.f!==D?(this.f=D,this.m(),!0):!1}setScrollbarSize(W){this.a=Math.round(W)}setOppositeScrollbarSize(W){this.b=Math.round(W)}static l(W,D,y,h,l){const d=Math.max(0,y-W),N=Math.max(0,d-2*D),r=h>0&&h>y;if(!r)return{computedAvailableSize:Math.round(d),computedIsNeeded:r,computedSliderSize:Math.round(N),computedSliderRatio:0,computedSliderPosition:0};const u=Math.round(Math.max(E,Math.floor(y*N/h))),e=(N-u)/(h-y),a=l*e;return{computedAvailableSize:Math.round(d),computedIsNeeded:r,computedSliderSize:Math.round(u),computedSliderRatio:e,computedSliderPosition:Math.round(a)}}m(){const W=L.l(this.b,this.c,this.d,this.e,this.f);this.g=W.computedAvailableSize,this.h=W.computedIsNeeded,this.i=W.computedSliderSize,this.j=W.computedSliderRatio,this.k=W.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(W){if(!this.h)return 0;const D=W-this.c-this.i/2;return Math.round(D/this.j)}getDesiredScrollPositionFromOffsetPaged(W){if(!this.h)return 0;const D=W-this.c;let y=this.f;return D<this.k?y-=this.d:y+=this.d,y}getDesiredScrollPositionFromDelta(W){if(!this.h)return 0;const D=this.k+W;return Math.round(D/this.j)}}t.ScrollbarState=L}),define(ge[24],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var E;(function(h){h[h.Hidden=0]="Hidden",h[h.Visible=1]="Visible",h[h.Recurse=2]="Recurse"})(E||(t.TreeVisibility=E={}));var L;(function(h){h[h.Expanded=0]="Expanded",h[h.Collapsed=1]="Collapsed",h[h.PreserveOrExpanded=2]="PreserveOrExpanded",h[h.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(L||(t.ObjectTreeElementCollapseState=L={}));var i;(function(h){h[h.Unknown=0]="Unknown",h[h.Twistie=1]="Twistie",h[h.Element=2]="Element",h[h.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var W;(function(h){h[h.Down=0]="Down",h[h.Up=1]="Up"})(W||(t.TreeDragOverBubble=W={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(h=!1){return{accept:!0,bubble:0,autoExpand:h}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(h=!1){return{accept:!0,bubble:0,effect:0,autoExpand:h}}};class D extends Error{constructor(l,d){super(`TreeError [${l}] ${d}`)}}t.TreeError=D;class y{constructor(l){this.a=l,this.b=new WeakMap}map(l){let d=this.b.get(l);return d||(d=this.a(l),this.b.set(l,d)),d}}t.WeakMapper=y}),define(ge[69],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function E(D,y){const h=Object.create(null);for(const l of D){const d=y(l);let N=h[d];N||(N=h[d]=[]),N.push(l)}return h}t.groupBy=E;function L(D,y){const h=[],l=[];for(const d of D)y.has(d)||h.push(d);for(const d of y)D.has(d)||l.push(d);return{removed:h,added:l}}t.diffSets=L;function i(D,y){const h=[],l=[];for(const[d,N]of D)y.has(d)||h.push(N);for(const[d,N]of y)D.has(d)||l.push(N);return{removed:h,added:l}}t.diffMaps=i;class W{constructor(){this.a=new Map}add(y,h){let l=this.a.get(y);l||(l=new Set,this.a.set(y,l)),l.add(h)}delete(y,h){const l=this.a.get(y);l&&(l.delete(h),l.size===0&&this.a.delete(y))}forEach(y,h){const l=this.a.get(y);l&&l.forEach(h)}}t.SetMap=W}),define(ge[70],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function E(y,h){const l=Math.pow(10,h);return Math.round(y*l)/l}class L{constructor(h,l,d,N=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=E(Math.max(Math.min(1,N),0),3)}static equals(h,l){return h.r===l.r&&h.g===l.g&&h.b===l.b&&h.a===l.a}}t.RGBA=L;class i{constructor(h,l,d,N){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.l=E(Math.max(Math.min(1,d),0),3),this.a=E(Math.max(Math.min(1,N),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.l===l.l&&h.a===l.a}static fromRGBA(h){const l=h.r/255,d=h.g/255,N=h.b/255,r=h.a,u=Math.max(l,d,N),e=Math.min(l,d,N);let a=0,n=0;const c=(e+u)/2,s=u-e;if(s>0){switch(n=Math.min(c<=.5?s/(2*c):s/(2-2*c),1),u){case l:a=(d-N)/s+(d<N?6:0);break;case d:a=(N-l)/s+2;break;case N:a=(l-d)/s+4;break}a*=60,a=Math.round(a)}return new i(a,n,c,r)}static i(h,l,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?h+(l-h)*6*d:d<1/2?l:d<2/3?h+(l-h)*(2/3-d)*6:h}static toRGBA(h){const l=h.h/360,{s:d,l:N,a:r}=h;let u,e,a;if(d===0)u=e=a=N;else{const n=N<.5?N*(1+d):N+d-N*d,c=2*N-n;u=i.i(c,n,l+1/3),e=i.i(c,n,l),a=i.i(c,n,l-1/3)}return new L(Math.round(u*255),Math.round(e*255),Math.round(a*255),r)}}t.HSLA=i;class W{constructor(h,l,d,N){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.v=E(Math.max(Math.min(1,d),0),3),this.a=E(Math.max(Math.min(1,N),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.v===l.v&&h.a===l.a}static fromRGBA(h){const l=h.r/255,d=h.g/255,N=h.b/255,r=Math.max(l,d,N),u=Math.min(l,d,N),e=r-u,a=r===0?0:e/r;let n;return e===0?n=0:r===l?n=((d-N)/e%6+6)%6:r===d?n=(N-l)/e+2:n=(l-d)/e+4,new W(Math.round(n*60),a,r,h.a)}static toRGBA(h){const{h:l,s:d,v:N,a:r}=h,u=N*d,e=u*(1-Math.abs(l/60%2-1)),a=N-u;let[n,c,s]=[0,0,0];return l<60?(n=u,c=e):l<120?(n=e,c=u):l<180?(c=u,s=e):l<240?(c=e,s=u):l<300?(n=e,s=u):l<=360&&(n=u,s=e),n=Math.round((n+a)*255),c=Math.round((c+a)*255),s=Math.round((s+a)*255),new L(n,c,s,r)}}t.HSVA=W;class D{static fromHex(h){return D.Format.CSS.parseHex(h)||D.red}static equals(h,l){return!h&&!l?!0:!h||!l?!1:h.equals(l)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:W.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof L)this.rgba=h;else if(h instanceof i)this.i=h,this.rgba=i.toRGBA(h);else if(h instanceof W)this.j=h,this.rgba=W.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&L.equals(this.rgba,h.rgba)&&i.equals(this.hsla,h.hsla)&&W.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=D.k(this.rgba.r),l=D.k(this.rgba.g),d=D.k(this.rgba.b),N=.2126*h+.7152*l+.0722*d;return E(N,4)}static k(h){const l=h/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(h){const l=this.getRelativeLuminance(),d=h.getRelativeLuminance();return l>d?(l+.05)/(d+.05):(d+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const l=this.getRelativeLuminance(),d=h.getRelativeLuminance();return l>d}isDarkerThan(h){const l=this.getRelativeLuminance(),d=h.getRelativeLuminance();return l<d}lighten(h){return new D(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new D(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:l,g:d,b:N,a:r}=this.rgba;return new D(new L(l,d,N,r*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const l=h.rgba,d=this.rgba.a,N=l.a,r=d+N*(1-d);if(r<1e-6)return D.transparent;const u=this.rgba.r*d/r+l.r*N*(1-d)/r,e=this.rgba.g*d/r+l.g*N*(1-d)/r,a=this.rgba.b*d/r+l.b*N*(1-d)/r;return new D(new L(u,e,a,r))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:l,g:d,b:N,a:r}=this.rgba;return new D(new L(h.rgba.r-r*(h.rgba.r-l),h.rgba.g-r*(h.rgba.g-d),h.rgba.b-r*(h.rgba.b-N),1))}flatten(...h){const l=h.reduceRight((d,N)=>D.o(N,d));return D.o(this,l)}static o(h,l){const d=1-h.rgba.a;return new D(new L(d*l.rgba.r+h.rgba.a*h.rgba.r,d*l.rgba.g+h.rgba.a*h.rgba.g,d*l.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(h,l,d){if(h.isLighterThan(l))return h;d=d||.5;const N=h.getRelativeLuminance(),r=l.getRelativeLuminance();return d=d*(r-N)/r,h.lighten(d)}static getDarkerColor(h,l,d){if(h.isDarkerThan(l))return h;d=d||.5;const N=h.getRelativeLuminance(),r=l.getRelativeLuminance();return d=d*(N-r)/N,h.darken(d)}}t.Color=D,D.white=new D(new L(255,255,255,1)),D.black=new D(new L(0,0,0,1)),D.red=new D(new L(255,0,0,1)),D.blue=new D(new L(0,0,255,1)),D.green=new D(new L(0,255,0,1)),D.cyan=new D(new L(0,255,255,1)),D.lightgrey=new D(new L(211,211,211,1)),D.transparent=new D(new L(0,0,0,0)),function(y){let h;(function(l){let d;(function(N){function r(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:y.Format.CSS.formatRGBA(f)}N.formatRGB=r;function u(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}N.formatRGBA=u;function e(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(f)}N.formatHSL=e;function a(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}N.formatHSLA=a;function n(f){const b=f.toString(16);return b.length!==2?"0"+b:b}function c(f){return`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}`}N.formatHex=c;function s(f,b=!1){return b&&f.rgba.a===1?y.Format.CSS.formatHex(f):`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}${n(Math.round(f.rgba.a*255))}`}N.formatHexA=s;function w(f){return f.isOpaque()?y.Format.CSS.formatHex(f):y.Format.CSS.formatRGBA(f)}N.format=w;function v(f){const b=f.length;if(b===0||f.charCodeAt(0)!==35)return null;if(b===7){const B=16*F(f.charCodeAt(1))+F(f.charCodeAt(2)),M=16*F(f.charCodeAt(3))+F(f.charCodeAt(4)),m=16*F(f.charCodeAt(5))+F(f.charCodeAt(6));return new y(new L(B,M,m,1))}if(b===9){const B=16*F(f.charCodeAt(1))+F(f.charCodeAt(2)),M=16*F(f.charCodeAt(3))+F(f.charCodeAt(4)),m=16*F(f.charCodeAt(5))+F(f.charCodeAt(6)),g=16*F(f.charCodeAt(7))+F(f.charCodeAt(8));return new y(new L(B,M,m,g/255))}if(b===4){const B=F(f.charCodeAt(1)),M=F(f.charCodeAt(2)),m=F(f.charCodeAt(3));return new y(new L(16*B+B,16*M+M,16*m+m))}if(b===5){const B=F(f.charCodeAt(1)),M=F(f.charCodeAt(2)),m=F(f.charCodeAt(3)),g=F(f.charCodeAt(4));return new y(new L(16*B+B,16*M+M,16*m+m,(16*g+g)/255))}return null}N.parseHex=v;function F(f){switch(f){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=l.CSS||(l.CSS={}))})(h=y.Format||(y.Format={}))}(D||(t.Color=D={}))}),define(ge[25],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function E(D){return(y,h,l)=>{let d=null,N=null;if(typeof l.value=="function"?(d="value",N=l.value):typeof l.get=="function"&&(d="get",N=l.get),!N)throw new Error("not supported");l[d]=D(N,h)}}function L(D,y,h){let l=null,d=null;if(typeof h.value=="function"?(l="value",d=h.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(l="get",d=h.get),!d)throw new Error("not supported");const N=`$memoize$${y}`;h[l]=function(...r){return this.hasOwnProperty(N)||Object.defineProperty(this,N,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,r)}),this[N]}}t.memoize=L;function i(D,y,h){return E((l,d)=>{const N=`$debounce$${d}`,r=`$debounce$result$${d}`;return function(...u){this[r]||(this[r]=h?h():void 0),clearTimeout(this[N]),y&&(this[r]=y(this[r],...u),u=[this[r]]),this[N]=setTimeout(()=>{l.apply(this,u),this[r]=h?h():void 0},D)}})}t.debounce=i;function W(D,y,h){return E((l,d)=>{const N=`$throttle$timer$${d}`,r=`$throttle$result$${d}`,u=`$throttle$lastRun$${d}`,e=`$throttle$pending$${d}`;return function(...a){if(this[r]||(this[r]=h?h():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),y&&(this[r]=y(this[r],...a)),this[e])return;const n=this[u]+D;n<=Date.now()?(this[u]=Date.now(),l.apply(this,[this[r]]),this[r]=h?h():void 0):(this[e]=!0,this[N]=setTimeout(()=>{this[e]=!1,this[u]=Date.now(),l.apply(this,[this[r]]),this[r]=h?h():void 0},n-Date.now()))}})}t.throttle=W}),define(ge[71],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class E{constructor(i,W,D,y){this.originalStart=i,this.originalLength=W,this.modifiedStart=D,this.modifiedLength=y}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=E}),define(ge[7],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(b){setTimeout(()=>{throw b.stack?v.isErrorNoTelemetry(b)?new v(b.message+`

`+b.stack):new Error(b.message+`

`+b.stack):b},0)}}addListener(b){return this.b.push(b),()=>{this.d(b)}}c(b){this.b.forEach(B=>{B(b)})}d(b){this.b.splice(this.b.indexOf(b),1)}setUnexpectedErrorHandler(b){this.a=b}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(b){this.a(b),this.c(b)}onUnexpectedExternalError(b){this.a(b)}}t.ErrorHandler=E,t.errorHandler=new E;function L(f){t.errorHandler.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=L;function i(f){if(!f||typeof f!="object")return!1;const b=f;return b.code==="EPIPE"&&b.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function W(f){l(f)||t.errorHandler.onUnexpectedError(f)}t.onUnexpectedError=W;function D(f){l(f)||t.errorHandler.onUnexpectedExternalError(f)}t.onUnexpectedExternalError=D;function y(f){if(f instanceof Error){const{name:b,message:B}=f,M=f.stacktrace||f.stack;return{$isError:!0,name:b,message:B,stack:M,noTelemetry:v.isErrorNoTelemetry(f)}}return f}t.transformErrorForSerialization=y;const h="Canceled";function l(f){return f instanceof d?!0:f instanceof Error&&f.name===h&&f.message===h}t.isCancellationError=l;class d extends Error{constructor(){super(h),this.name=this.message}}t.CancellationError=d;function N(){const f=new Error(h);return f.name=f.message,f}t.canceled=N;function r(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.illegalArgument=r;function u(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.illegalState=u;function e(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function a(f){const b=new Error(`${f} has been disposed`);return b.name="DISPOSED",b}t.disposed=a;function n(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.getErrorMessage=n;class c extends Error{constructor(b){super("NotImplemented"),b&&(this.message=b)}}t.NotImplementedError=c;class s extends Error{constructor(b){super("NotSupported"),b&&(this.message=b)}}t.NotSupportedError=s;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=w;class v extends Error{constructor(b){super(b),this.name="CodeExpectedError"}static fromError(b){if(b instanceof v)return b;const B=new v;return B.message=b.message,B.stack=b.stack,B}static isErrorNoTelemetry(b){return b.name==="CodeExpectedError"}}t.ErrorNoTelemetry=v;class F extends Error{constructor(b){super(b||"An unexpected bug occurred."),Object.setPrototypeOf(this,F.prototype)}}t.BugIndicatingError=F}),define(ge[13],me([1,0,7]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function L(C,T=0){return C[C.length-(1+T)]}t.tail=L;function i(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}t.tail2=i;function W(C,T,R=(S,z)=>S===z){if(C===T)return!0;if(!C||!T||C.length!==T.length)return!1;for(let S=0,z=C.length;S<z;S++)if(!R(C[S],T[S]))return!1;return!0}t.equals=W;function D(C,T){const R=C.length-1;T<R&&(C[T]=C[R]),C.pop()}t.removeFastWithoutKeepingOrder=D;function y(C,T,R){return h(C.length,S=>R(C[S],T))}t.binarySearch=y;function h(C,T){let R=0,S=C-1;for(;R<=S;){const z=(R+S)/2|0,H=T(z);if(H<0)R=z+1;else if(H>0)S=z-1;else return z}return-(R+1)}t.binarySearch2=h;function l(C,T){let R=0,S=C.length;if(S===0)return 0;for(;R<S;){const z=Math.floor((R+S)/2);T(C[z])?S=z:R=z+1}return R}t.findFirstInSorted=l;function d(C,T,R){if(C=C|0,C>=T.length)throw new TypeError("invalid index");const S=T[Math.floor(T.length*Math.random())],z=[],H=[],P=[];for(const j of T){const G=R(j,S);G<0?z.push(j):G>0?H.push(j):P.push(j)}return C<z.length?d(C,z,R):C<z.length+P.length?P[0]:d(C-(z.length+P.length),H,R)}t.quickSelect=d;function N(C,T){const R=[];let S;for(const z of C.slice(0).sort(T))!S||T(S[0],z)!==0?(S=[z],R.push(S)):S.push(z);return R}t.groupBy=N;function r(C,T,R){const S=[];function z(j,G,ee){if(G===0&&ee.length===0)return;const re=S[S.length-1];re&&re.start+re.deleteCount===j?(re.deleteCount+=G,re.toInsert.push(...ee)):S.push({start:j,deleteCount:G,toInsert:ee})}let H=0,P=0;for(;;){if(H===C.length){z(H,0,T.slice(P));break}if(P===T.length){z(H,C.length-H,[]);break}const j=C[H],G=T[P],ee=R(j,G);ee===0?(H+=1,P+=1):ee<0?(z(H,1,[]),H+=1):ee>0&&(z(H,0,[G]),P+=1)}return S}t.sortedDiff=r;function u(C,T,R){const S=r(C,T,R),z=[],H=[];for(const P of S)z.push(...C.slice(P.start,P.start+P.deleteCount)),H.push(...P.toInsert);return{removed:z,added:H}}t.delta=u;function e(C,T,R){if(R===0)return[];const S=C.slice(0,R).sort(T);return n(C,T,S,R,C.length),S}t.top=e;function a(C,T,R,S,z){return R===0?Promise.resolve([]):new Promise((H,P)=>{(async()=>{const j=C.length,G=C.slice(0,R).sort(T);for(let ee=R,re=Math.min(R+S,j);ee<j;ee=re,re=Math.min(re+S,j)){if(ee>R&&await new Promise(pe=>setTimeout(pe)),z&&z.isCancellationRequested)throw new E.CancellationError;n(C,T,G,ee,re)}return G})().then(H,P)})}t.topAsync=a;function n(C,T,R,S,z){for(const H=R.length;S<z;S++){const P=C[S];if(T(P,R[H-1])<0){R.pop();const j=l(R,G=>T(P,G)<0);R.splice(j,0,P)}}}function c(C){return C.filter(T=>!!T)}t.coalesce=c;function s(C){let T=0;for(let R=0;R<C.length;R++)C[R]&&(C[T]=C[R],T+=1);C.length=T}t.coalesceInPlace=s;function w(C,T,R){C.splice(R,0,C.splice(T,1)[0])}t.move=w;function v(C){return!Array.isArray(C)||C.length===0}t.isFalsyOrEmpty=v;function F(C){return Array.isArray(C)&&C.length>0}t.isNonEmptyArray=F;function f(C,T=R=>R){const R=new Set;return C.filter(S=>{const z=T(S);return R.has(z)?!1:(R.add(z),!0)})}t.distinct=f;function b(C){const T=new Set;return R=>{const S=C(R);return T.has(S)?!1:(T.add(S),!0)}}t.uniqueFilter=b;function B(C,T){const R=M(C,T);if(R!==-1)return C[R]}t.findLast=B;function M(C,T){for(let R=C.length-1;R>=0;R--){const S=C[R];if(T(S))return R}return-1}t.lastIndex=M;function m(C,T){return C.length>0?C[0]:T}t.firstOrDefault=m;function g(C,T){return C.length>0?C[C.length-1]:T}t.lastOrDefault=g;function p(C,T,R=(S,z)=>S===z){let S=0;for(let z=0,H=Math.min(C.length,T.length);z<H&&R(C[z],T[z]);z++)S++;return S}t.commonPrefixLength=p;function I(C){return[].concat(...C)}t.flatten=I;function O(C,T){let R=typeof T=="number"?C:0;typeof T=="number"?R=C:(R=0,T=C);const S=[];if(R<=T)for(let z=R;z<T;z++)S.push(z);else for(let z=R;z>T;z--)S.push(z);return S}t.range=O;function U(C,T,R){return C.reduce((S,z)=>(S[T(z)]=R?R(z):z,S),Object.create(null))}t.index=U;function Z(C,T){return C.push(T),()=>ne(C,T)}t.insert=Z;function ne(C,T){const R=C.indexOf(T);if(R>-1)return C.splice(R,1),T}t.remove=ne;function se(C,T,R){const S=C.slice(0,T),z=C.slice(T);return S.concat(R,z)}t.arrayInsert=se;function ce(C,T){let R;if(typeof T=="number"){let S=T;R=()=>{const z=Math.sin(S++)*179426549;return z-Math.floor(z)}}else R=Math.random;for(let S=C.length-1;S>0;S-=1){const z=Math.floor(R()*(S+1)),H=C[S];C[S]=C[z],C[z]=H}}t.shuffle=ce;function ue(C,T){const R=C.indexOf(T);R>-1&&(C.splice(R,1),C.unshift(T))}t.pushToStart=ue;function ae(C,T){const R=C.indexOf(T);R>-1&&(C.splice(R,1),C.push(T))}t.pushToEnd=ae;function oe(C,T){for(const R of T)C.push(R)}t.pushMany=oe;function ye(C,T){return Array.isArray(C)?C.map(T):T(C)}t.mapArrayOrNot=ye;function ke(C){return Array.isArray(C)?C:[C]}t.asArray=ke;function Be(C){return C[Math.floor(Math.random()*C.length)]}t.getRandomElement=Be;function Me(C,T){for(const R of C){const S=T(R);if(S!==void 0)return S}}t.mapFind=Me;function fe(C,T,R){const S=ie(C,T),z=C.length,H=R.length;C.length=z+H;for(let P=z-1;P>=S;P--)C[P+H]=C[P];for(let P=0;P<H;P++)C[P+S]=R[P]}t.insertInto=fe;function $(C,T,R,S){const z=ie(C,T),H=C.splice(z,R);return fe(C,z,S),H}t.splice=$;function ie(C,T){return T<0?Math.max(T+C.length,0):Math.min(T,C.length)}var q;(function(C){function T(z){return z<0}C.isLessThan=T;function R(z){return z>0}C.isGreaterThan=R;function S(z){return z===0}C.isNeitherLessOrGreaterThan=S,C.greaterThan=1,C.lessThan=-1,C.neitherLessOrGreaterThan=0})(q||(t.CompareResult=q={}));function V(C,T){return(R,S)=>T(C(R),C(S))}t.compareBy=V;function A(...C){return(T,R)=>{for(const S of C){const z=S(T,R);if(!q.isNeitherLessOrGreaterThan(z))return z}return q.neitherLessOrGreaterThan}}t.tieBreakComparators=A;const K=(C,T)=>C-T;t.numberComparator=K;function x(C,T){if(C.length===0)return;let R=C[0];for(let S=1;S<C.length;S++){const z=C[S];T(z,R)>0&&(R=z)}return R}t.findMaxBy=x;function o(C,T){if(C.length===0)return;let R=C[0];for(let S=1;S<C.length;S++){const z=C[S];T(z,R)>=0&&(R=z)}return R}t.findLastMaxBy=o;function k(C,T){return x(C,(R,S)=>-T(R,S))}t.findMinBy=k;class _{constructor(T){this.f=T,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(T){let R=this.c;for(;R<this.f.length&&T(this.f[R]);)R++;const S=R===this.c?null:this.f.slice(this.c,R);return this.c=R,S}takeFromEndWhile(T){let R=this.d;for(;R>=0&&T(this.f[R]);)R--;const S=R===this.d?null:this.f.slice(R+1,this.d+1);return this.d=R,S}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const T=this.f[this.c];return this.c++,T}removeLast(){const T=this.f[this.d];return this.d--,T}takeCount(T){const R=this.f.slice(this.c,this.c+T);return this.c+=T,R}}t.ArrayQueue=_;class Y{constructor(T){this.iterate=T}forEach(T){this.iterate(R=>(T(R),!0))}toArray(){const T=[];return this.iterate(R=>(T.push(R),!0)),T}filter(T){return new Y(R=>this.iterate(S=>T(S)?R(S):!0))}map(T){return new Y(R=>this.iterate(S=>R(T(S))))}some(T){let R=!1;return this.iterate(S=>(R=T(S),!R)),R}findFirst(T){let R;return this.iterate(S=>T(S)?(R=S,!1):!0),R}findLast(T){let R;return this.iterate(S=>(T(S)&&(R=S),!0)),R}findLastMaxBy(T){let R,S=!0;return this.iterate(z=>((S||q.isGreaterThan(T(z,R)))&&(S=!1,R=z),!0)),R}}t.CallbackIterable=Y,Y.empty=new Y(C=>{})}),define(ge[72],me([1,0,7]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function L(h,l){if(!h)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}t.ok=L;function i(h,l="Unreachable"){throw new Error(l)}t.assertNever=i;function W(h){if(!h)throw new E.BugIndicatingError("Assertion Failed")}t.assert=W;function D(h){if(!h()){debugger;h(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}t.assertFn=D;function y(h,l){let d=0;for(;d<h.length-1;){const N=h[d],r=h[d+1];if(!l(N,r))return!1;d++}return!0}t.checkAdjacentItems=y}),define(ge[41],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function E(L){const i=this;let W=!1,D;return function(){return W||(W=!0,D=L.apply(i,arguments)),D}}t.once=E}),define(ge[73],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class E{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.IdGenerator=E,t.defaultGenerator=new E("id#")}),define(ge[26],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var E;(function(L){function i(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}L.is=i;const W=Object.freeze([]);function D(){return W}L.empty=D;function*y(v){yield v}L.single=y;function h(v){return i(v)?v:y(v)}L.wrap=h;function l(v){return v||W}L.from=l;function d(v){return!v||v[Symbol.iterator]().next().done===!0}L.isEmpty=d;function N(v){return v[Symbol.iterator]().next().value}L.first=N;function r(v,F){for(const f of v)if(F(f))return!0;return!1}L.some=r;function u(v,F){for(const f of v)if(F(f))return f}L.find=u;function*e(v,F){for(const f of v)F(f)&&(yield f)}L.filter=e;function*a(v,F){let f=0;for(const b of v)yield F(b,f++)}L.map=a;function*n(...v){for(const F of v)for(const f of F)yield f}L.concat=n;function c(v,F,f){let b=f;for(const B of v)b=F(b,B);return b}L.reduce=c;function*s(v,F,f=v.length){for(F<0&&(F+=v.length),f<0?f+=v.length:f>v.length&&(f=v.length);F<f;F++)yield v[F]}L.slice=s;function w(v,F=Number.POSITIVE_INFINITY){const f=[];if(F===0)return[f,v];const b=v[Symbol.iterator]();for(let B=0;B<F;B++){const M=b.next();if(M.done)return[f,L.empty()];f.push(M.value)}return[f,{[Symbol.iterator](){return b}}]}L.consume=w})(E||(t.Iterable=E={}))}),define(ge[42],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var E;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(E||(t.KeyCode=E={}));var L;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(L||(t.ScanCode=L={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(a,n){this._keyCodeToStr[a]=n,this._strToKeyCode[n.toLowerCase()]=a}keyCodeToStr(a){return this._keyCodeToStr[a]}strToKeyCode(a){return this._strToKeyCode[a.toLowerCase()]||0}}const W=new i,D=new i,y=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const h=[],l=Object.create(null),d=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>d[e]||0,toEnum:e=>l[e]||0,toString:e=>h[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",a=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],n=[],c=[];for(const s of a){const[w,v,F,f,b,B,M,m,g]=s;if(c[v]||(c[v]=!0,h[v]=F,l[F]=v,d[F.toLowerCase()]=v,w&&(t.IMMUTABLE_CODE_TO_KEY_CODE[v]=f,f!==0&&f!==3&&f!==5&&f!==4&&f!==6&&f!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[f]=v))),!n[f]){if(n[f]=!0,!b)throw new Error(`String representation missing for key code ${f} around scan code ${F}`);W.define(f,b),D.define(f,m||b),y.define(f,g||m||b)}B&&(t.EVENT_KEY_CODE_MAP[B]=f),M&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[M]=f)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var N;(function(e){function a(F){return W.keyCodeToStr(F)}e.toString=a;function n(F){return W.strToKeyCode(F)}e.fromString=n;function c(F){return D.keyCodeToStr(F)}e.toUserSettingsUS=c;function s(F){return y.keyCodeToStr(F)}e.toUserSettingsGeneral=s;function w(F){return D.strToKeyCode(F)||y.strToKeyCode(F)}e.fromUserSettings=w;function v(F){if(F>=98&&F<=113)return null;switch(F){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return W.keyCodeToStr(F)}e.toElectronAccelerator=v})(N||(t.KeyCodeUtils=N={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r||(t.KeyMod=r={}));function u(e,a){const n=(a&65535)<<16>>>0;return(e|n)>>>0}t.KeyChord=u}),define(ge[74],me([1,0,7]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=t.createSimpleKeybinding=t.decodeKeybinding=void 0;var L;(function(N){N[N.CtrlCmd=2048]="CtrlCmd",N[N.Shift=1024]="Shift",N[N.Alt=512]="Alt",N[N.WinCtrl=256]="WinCtrl",N[N.KeyCode=255]="KeyCode"})(L||(L={}));function i(N,r){if(typeof N=="number"){if(N===0)return null;const u=(N&65535)>>>0,e=(N&4294901760)>>>16;return e!==0?new h([W(u,r),W(e,r)]):new h([W(u,r)])}else{const u=[];for(let e=0;e<N.length;e++)u.push(W(N[e],r));return new h(u)}}t.decodeKeybinding=i;function W(N,r){const u=!!(N&2048),e=!!(N&256),a=r===2?e:u,n=!!(N&1024),c=!!(N&512),s=r===2?u:e,w=N&255;return new D(a,n,c,s,w)}t.createSimpleKeybinding=W;class D{constructor(r,u,e,a,n){this.ctrlKey=r,this.shiftKey=u,this.altKey=e,this.metaKey=a,this.keyCode=n}equals(r){return r instanceof D&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",u=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`K${r}${u}${e}${a}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new h([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.KeyCodeChord=D;class y{constructor(r,u,e,a,n){this.ctrlKey=r,this.shiftKey=u,this.altKey=e,this.metaKey=a,this.scanCode=n}equals(r){return r instanceof y&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",u=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`S${r}${u}${e}${a}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeChord=y;class h{constructor(r){if(r.length===0)throw(0,E.illegalArgument)("chords");this.chords=r}getHashCode(){let r="";for(let u=0,e=this.chords.length;u<e;u++)u!==0&&(r+=";"),r+=this.chords[u].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let u=0;u<this.chords.length;u++)if(!this.chords[u].equals(r.chords[u]))return!1;return!0}}t.Keybinding=h;class l{constructor(r,u,e,a,n,c){this.ctrlKey=r,this.shiftKey=u,this.altKey=e,this.metaKey=a,this.keyLabel=n,this.keyAriaLabel=c}}t.ResolvedChord=l;class d{}t.ResolvedKeybinding=d}),define(ge[30],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class E{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.Lazy=E}),define(ge[2],me([1,0,41,26]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let W=null;function D(g){W=g}if(t.setDisposableTracker=D,i){const g="__is_disposable_tracked__";D(new class{trackDisposable(p){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[g]||console.log(I)},3e3)}setParent(p,I){if(p&&p!==s.None)try{p[g]=!0}catch{}}markAsDisposed(p){if(p&&p!==s.None)try{p[g]=!0}catch{}}markAsSingleton(p){}})}function y(g){return W?.trackDisposable(g),g}function h(g){W?.markAsDisposed(g)}function l(g,p){W?.setParent(g,p)}function d(g,p){if(W)for(const I of g)W.setParent(I,p)}function N(g){return W?.markAsSingleton(g),g}t.markAsSingleton=N;function r(g){return typeof g.dispose=="function"&&g.dispose.length===0}t.isDisposable=r;function u(g){if(L.Iterable.is(g)){const p=[];for(const I of g)if(I)try{I.dispose()}catch(O){p.push(O)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}t.dispose=u;function e(g){for(const p of g)r(p)&&p.dispose();return[]}t.disposeIfDisposable=e;function a(...g){const p=n(()=>u(g));return d(g,p),p}t.combinedDisposable=a;function n(g){const p=y({dispose:(0,E.once)(()=>{h(p),g()})});return p}t.toDisposable=n;class c{constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(h(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return l(p,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(p),p}}t.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class s{constructor(){this.q=new c,y(this),l(this.q,this)}dispose(){h(this),this.q.dispose()}B(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(p)}}t.Disposable=s,s.None=Object.freeze({dispose(){}});class w{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(p){this.b||p===this.a||(this.a?.dispose(),p&&l(p,this),this.a=p)}clear(){this.value=void 0}dispose(){this.b=!0,h(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const p=this.a;return this.a=void 0,p&&l(p,null),p}}t.MutableDisposable=w;class v{constructor(p){this.b=p,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=v;class F{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(p){let I=p;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,h(this))},this}}t.SafeDisposable=F;class f{constructor(){this.a=new Map}acquire(p,...I){let O=this.a.get(p);O||(O={counter:0,object:this.b(p,...I)},this.a.set(p,O));const{object:U}=O,Z=(0,E.once)(()=>{--O.counter===0&&(this.c(p,O.object),this.a.delete(p))});return O.counter++,{object:U,dispose:Z}}}t.ReferenceCollection=f;class b{constructor(p){this.a=p}async acquire(p,...I){const O=this.a.acquire(p,...I);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(U){throw O.dispose(),U}}}t.AsyncReferenceCollection=b;class B{constructor(p){this.object=p}dispose(){}}t.ImmortalReference=B;function M(g){const p=new c;try{g(p)}finally{p.dispose()}}t.disposeOnReturn=M;class m{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){h(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(p){return this.a.has(p)}get(p){return this.a.get(p)}set(p,I,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(p)?.dispose(),this.a.set(p,I)}deleteAndDispose(p){this.a.get(p)?.dispose(),this.a.delete(p)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=m}),define(ge[43],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class E{constructor(W){this.element=W,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class L{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let W=this.a;for(;W!==E.Undefined;){const D=W.next;W.prev=E.Undefined,W.next=E.Undefined,W=D}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(W){return this.d(W,!1)}push(W){return this.d(W,!0)}d(W,D){const y=new E(W);if(this.a===E.Undefined)this.a=y,this.b=y;else if(D){const l=this.b;this.b=y,y.prev=l,l.next=y}else{const l=this.a;this.a=y,y.next=l,l.prev=y}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(y))}}shift(){if(this.a!==E.Undefined){const W=this.a.element;return this.e(this.a),W}}pop(){if(this.b!==E.Undefined){const W=this.b.element;return this.e(this.b),W}}e(W){if(W.prev!==E.Undefined&&W.next!==E.Undefined){const D=W.prev;D.next=W.next,W.next.prev=D}else W.prev===E.Undefined&&W.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):W.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):W.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let W=this.a;for(;W!==E.Undefined;)yield W.element,W=W.next}}t.LinkedList=L}),define(ge[75],me([1,0]),function(te,t){"use strict";var E,L,i;Object.defineProperty(t,"__esModule",{value:!0}),t.CounterSet=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function W(a,n,c){let s=a.get(n);return s===void 0&&(s=c,a.set(n,s)),s}t.getOrSet=W;function D(a){const n=[];return a.forEach((c,s)=>{n.push(`${s} => ${c}`)}),`Map(${a.size}) {${n.join(", ")}}`}t.mapToString=D;function y(a){const n=[];return a.forEach(c=>{n.push(c)}),`Set(${a.size}) {${n.join(", ")}}`}t.setToString=y;class h{constructor(n,c){this.uri=n,this.value=c}}class l{constructor(n,c){this[E]="ResourceMap",n instanceof l?(this.b=new Map(n.b),this.c=c??l.a):(this.b=new Map,this.c=n??l.a)}set(n,c){return this.b.set(this.c(n),new h(n,c)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,c){typeof c<"u"&&(n=n.bind(c));for(const[s,w]of this.b)n(w.value,w.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}t.ResourceMap=l,l.a=a=>a.toString();class d{constructor(n,c){this[L]="ResourceSet",!n||typeof n=="function"?this.a=new l(n):(this.a=new l(c),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,c){this.a.forEach((s,w)=>n.call(c,w,w,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=d;var N;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(N||(t.Touch=N={}));class r{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,c=0){const s=this.a.get(n);if(s)return c!==0&&this.j(s,c),s.value}set(n,c,s=0){let w=this.a.get(n);if(w)w.value=c,s!==0&&this.j(w,s);else{switch(w={key:n,value:c,next:void 0,previous:void 0},s){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(n,w),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const c=this.a.get(n);if(c)return this.a.delete(n),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,c){const s=this.e;let w=this.b;for(;w;){if(c?n.bind(c)(w.value,w.key,this):n(w.value,w.key,this),this.e!==s)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const n=this,c=this.e;let s=this.b;const w={[Symbol.iterator](){return w},next(){if(n.e!==c)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.key,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return w}values(){const n=this,c=this.e;let s=this.b;const w={[Symbol.iterator](){return w},next(){if(n.e!==c)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.value,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return w}entries(){const n=this,c=this.e;let s=this.b;const w={[Symbol.iterator](){return w},next(){if(n.e!==c)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:[s.key,s.value],done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return w}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let c=this.b,s=this.size;for(;c&&s>n;)this.a.delete(c.key),c=c.next,s--;this.b=c,this.d=s,c&&(c.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const c=n.next,s=n.previous;if(!c||!s)throw new Error("Invalid list");c.previous=s,s.next=c}n.next=void 0,n.previous=void 0,this.e++}j(n,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(n===this.b)return;const s=n.next,w=n.previous;n===this.c?(w.next=void 0,this.c=w):(s.previous=w,w.next=s),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(c===2){if(n===this.c)return;const s=n.next,w=n.previous;n===this.b?(s.previous=void 0,this.b=s):(s.previous=w,w.next=s),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((c,s)=>{n.push([s,c])}),n}fromJSON(n){this.clear();for(const[c,s]of n)this.set(c,s)}}t.LinkedMap=r;class u extends r{constructor(n,c=1){super(),this.k=n,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,c=2){return super.get(n,c)}peek(n){return super.get(n,0)}set(n,c){return super.set(n,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.LRUCache=u;class e{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let c=this.a.get(n)||0;return c===0?!1:(c--,c===0?this.a.delete(n):this.a.set(n,c),!0)}has(n){return this.a.has(n)}}t.CounterSet=e}),function(te,t){typeof define=="function"&&define.amd?define(ge[76],me([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(te=typeof globalThis<"u"?globalThis:te||self,t(te.marked={}))}(this,function(te){"use strict";function t(C,T){for(var R=0;R<T.length;R++){var S=T[R];S.enumerable=S.enumerable||!1,S.configurable=!0,"value"in S&&(S.writable=!0),Object.defineProperty(C,S.key,S)}}function E(C,T,R){return T&&t(C.prototype,T),R&&t(C,R),Object.defineProperty(C,"prototype",{writable:!1}),C}function L(C,T){if(C){if(typeof C=="string")return i(C,T);var R=Object.prototype.toString.call(C).slice(8,-1);if(R==="Object"&&C.constructor&&(R=C.constructor.name),R==="Map"||R==="Set")return Array.from(C);if(R==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(R))return i(C,T)}}function i(C,T){(T==null||T>C.length)&&(T=C.length);for(var R=0,S=new Array(T);R<T;R++)S[R]=C[R];return S}function W(C,T){var R=typeof Symbol<"u"&&C[Symbol.iterator]||C["@@iterator"];if(R)return(R=R.call(C)).next.bind(R);if(Array.isArray(C)||(R=L(C))||T&&C&&typeof C.length=="number"){R&&(C=R);var S=0;return function(){return S>=C.length?{done:!0}:{done:!1,value:C[S++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=D();function y(C){te.defaults=C}var h=/[&<>"']/,l=/[&<>"']/g,d=/[<>"']|&(?!#?\w+;)/,N=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(T){return r[T]};function e(C,T){if(T){if(h.test(C))return C.replace(l,u)}else if(d.test(C))return C.replace(N,u);return C}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(C){return C.replace(a,function(T,R){return R=R.toLowerCase(),R==="colon"?":":R.charAt(0)==="#"?R.charAt(1)==="x"?String.fromCharCode(parseInt(R.substring(2),16)):String.fromCharCode(+R.substring(1)):""})}var c=/(^|[^\[])\^/g;function s(C,T){C=typeof C=="string"?C:C.source,T=T||"";var R={replace:function(z,H){return H=H.source||H,H=H.replace(c,"$1"),C=C.replace(z,H),R},getRegex:function(){return new RegExp(C,T)}};return R}var w=/[^\w:]/g,v=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function F(C,T,R){if(C){var S;try{S=decodeURIComponent(n(R)).replace(w,"").toLowerCase()}catch{return null}if(S.indexOf("javascript:")===0||S.indexOf("vbscript:")===0||S.indexOf("data:")===0)return null}T&&!v.test(R)&&(R=m(T,R));try{R=encodeURI(R).replace(/%25/g,"%")}catch{return null}return R}var f={},b=/^[^:]+:\/*[^/]*$/,B=/^([^:]+:)[\s\S]*$/,M=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(C,T){f[" "+C]||(b.test(C)?f[" "+C]=C+"/":f[" "+C]=O(C,"/",!0)),C=f[" "+C];var R=C.indexOf(":")===-1;return T.substring(0,2)==="//"?R?T:C.replace(B,"$1")+T:T.charAt(0)==="/"?R?T:C.replace(M,"$1")+T:C+T}var g={exec:function(){}};function p(C){for(var T=1,R,S;T<arguments.length;T++){R=arguments[T];for(S in R)Object.prototype.hasOwnProperty.call(R,S)&&(C[S]=R[S])}return C}function I(C,T){var R=C.replace(/\|/g,function(H,P,j){for(var G=!1,ee=P;--ee>=0&&j[ee]==="\\";)G=!G;return G?"|":" |"}),S=R.split(/ \|/),z=0;if(S[0].trim()||S.shift(),S.length>0&&!S[S.length-1].trim()&&S.pop(),S.length>T)S.splice(T);else for(;S.length<T;)S.push("");for(;z<S.length;z++)S[z]=S[z].trim().replace(/\\\|/g,"|");return S}function O(C,T,R){var S=C.length;if(S===0)return"";for(var z=0;z<S;){var H=C.charAt(S-z-1);if(H===T&&!R)z++;else if(H!==T&&R)z++;else break}return C.slice(0,S-z)}function U(C,T){if(C.indexOf(T[1])===-1)return-1;for(var R=C.length,S=0,z=0;z<R;z++)if(C[z]==="\\")z++;else if(C[z]===T[0])S++;else if(C[z]===T[1]&&(S--,S<0))return z;return-1}function Z(C){C&&C.sanitize&&!C.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function ne(C,T){if(T<1)return"";for(var R="";T>1;)T&1&&(R+=C),T>>=1,C+=C;return R+C}function se(C,T,R,S){var z=T.href,H=T.title?e(T.title):null,P=C[1].replace(/\\([\[\]])/g,"$1");if(C[0].charAt(0)!=="!"){S.state.inLink=!0;var j={type:"link",raw:R,href:z,title:H,text:P,tokens:S.inlineTokens(P)};return S.state.inLink=!1,j}return{type:"image",raw:R,href:z,title:H,text:e(P)}}function ce(C,T){var R=C.match(/^(\s+)(?:```)/);if(R===null)return T;var S=R[1];return T.split(`
`).map(function(z){var H=z.match(/^\s+/);if(H===null)return z;var P=H[0];return P.length>=S.length?z.slice(S.length):z}).join(`
`)}var ue=function(){function C(R){this.options=R||te.defaults}var T=C.prototype;return T.space=function(S){var z=this.rules.block.newline.exec(S);if(z&&z[0].length>0)return{type:"space",raw:z[0]}},T.code=function(S){var z=this.rules.block.code.exec(S);if(z){var H=z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:z[0],codeBlockStyle:"indented",text:this.options.pedantic?H:O(H,`
`)}}},T.fences=function(S){var z=this.rules.block.fences.exec(S);if(z){var H=z[0],P=ce(H,z[3]||"");return{type:"code",raw:H,lang:z[2]?z[2].trim():z[2],text:P}}},T.heading=function(S){var z=this.rules.block.heading.exec(S);if(z){var H=z[2].trim();if(/#$/.test(H)){var P=O(H,"#");(this.options.pedantic||!P||/ $/.test(P))&&(H=P.trim())}return{type:"heading",raw:z[0],depth:z[1].length,text:H,tokens:this.lexer.inline(H)}}},T.hr=function(S){var z=this.rules.block.hr.exec(S);if(z)return{type:"hr",raw:z[0]}},T.blockquote=function(S){var z=this.rules.block.blockquote.exec(S);if(z){var H=z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:z[0],tokens:this.lexer.blockTokens(H,[]),text:H}}},T.list=function(S){var z=this.rules.block.list.exec(S);if(z){var H,P,j,G,ee,re,pe,we,Ne,Se,ve,Pe,Le=z[1].trim(),Ve=Le.length>1,ze={type:"list",raw:"",ordered:Ve,start:Ve?+Le.slice(0,-1):"",loose:!1,items:[]};Le=Ve?"\\d{1,9}\\"+Le.slice(-1):"\\"+Le,this.options.pedantic&&(Le=Ve?Le:"[*+-]");for(var We=new RegExp("^( {0,3}"+Le+")((?:[	 ][^\\n]*)?(?:\\n|$))");S&&(Pe=!1,!(!(z=We.exec(S))||this.rules.block.hr.test(S)));){if(H=z[0],S=S.substring(H.length),we=z[2].split(`
`,1)[0],Ne=S.split(`
`,1)[0],this.options.pedantic?(G=2,ve=we.trimLeft()):(G=z[2].search(/[^ ]/),G=G>4?1:G,ve=we.slice(G),G+=z[1].length),re=!1,!we&&/^ *$/.test(Ne)&&(H+=Ne+`
`,S=S.substring(Ne.length+1),Pe=!0),!Pe)for(var Je=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),je=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");S&&(Se=S.split(`
`,1)[0],we=Se,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(we)||je.test(we)||Je.test(we)||it.test(S)));){if(we.search(/[^ ]/)>=G||!we.trim())ve+=`
`+we.slice(G);else if(!re)ve+=`
`+we;else break;!re&&!we.trim()&&(re=!0),H+=Se+`
`,S=S.substring(Se.length+1)}ze.loose||(pe?ze.loose=!0:/\n *\n *$/.test(H)&&(pe=!0)),this.options.gfm&&(P=/^\[[ xX]\] /.exec(ve),P&&(j=P[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:H,task:!!P,checked:j,loose:!1,text:ve}),ze.raw+=H}ze.items[ze.items.length-1].raw=H.trimRight(),ze.items[ze.items.length-1].text=ve.trimRight(),ze.raw=ze.raw.trimRight();var X=ze.items.length;for(ee=0;ee<X;ee++){this.lexer.state.top=!1,ze.items[ee].tokens=this.lexer.blockTokens(ze.items[ee].text,[]);var le=ze.items[ee].tokens.filter(function(De){return De.type==="space"}),be=le.every(function(De){for(var Ae=De.raw.split(""),Re=0,$e=W(Ae),Ge;!(Ge=$e()).done;){var et=Ge.value;if(et===`
`&&(Re+=1),Re>1)return!0}return!1});!ze.loose&&le.length&&be&&(ze.loose=!0,ze.items[ee].loose=!0)}return ze}},T.html=function(S){var z=this.rules.block.html.exec(S);if(z){var H={type:"html",raw:z[0],pre:!this.options.sanitizer&&(z[1]==="pre"||z[1]==="script"||z[1]==="style"),text:z[0]};if(this.options.sanitize){var P=this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]);H.type="paragraph",H.text=P,H.tokens=this.lexer.inline(P)}return H}},T.def=function(S){var z=this.rules.block.def.exec(S);if(z){z[3]&&(z[3]=z[3].substring(1,z[3].length-1));var H=z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:H,raw:z[0],href:z[2],title:z[3]}}},T.table=function(S){var z=this.rules.block.table.exec(S);if(z){var H={type:"table",header:I(z[1]).map(function(pe){return{text:pe}}),align:z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:z[3]&&z[3].trim()?z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=z[0];var P=H.align.length,j,G,ee,re;for(j=0;j<P;j++)/^ *-+: *$/.test(H.align[j])?H.align[j]="right":/^ *:-+: *$/.test(H.align[j])?H.align[j]="center":/^ *:-+ *$/.test(H.align[j])?H.align[j]="left":H.align[j]=null;for(P=H.rows.length,j=0;j<P;j++)H.rows[j]=I(H.rows[j],H.header.length).map(function(pe){return{text:pe}});for(P=H.header.length,G=0;G<P;G++)H.header[G].tokens=this.lexer.inline(H.header[G].text);for(P=H.rows.length,G=0;G<P;G++)for(re=H.rows[G],ee=0;ee<re.length;ee++)re[ee].tokens=this.lexer.inline(re[ee].text);return H}}},T.lheading=function(S){var z=this.rules.block.lheading.exec(S);if(z)return{type:"heading",raw:z[0],depth:z[2].charAt(0)==="="?1:2,text:z[1],tokens:this.lexer.inline(z[1])}},T.paragraph=function(S){var z=this.rules.block.paragraph.exec(S);if(z){var H=z[1].charAt(z[1].length-1)===`
`?z[1].slice(0,-1):z[1];return{type:"paragraph",raw:z[0],text:H,tokens:this.lexer.inline(H)}}},T.text=function(S){var z=this.rules.block.text.exec(S);if(z)return{type:"text",raw:z[0],text:z[0],tokens:this.lexer.inline(z[0])}},T.escape=function(S){var z=this.rules.inline.escape.exec(S);if(z)return{type:"escape",raw:z[0],text:e(z[1])}},T.tag=function(S){var z=this.rules.inline.tag.exec(S);if(z)return!this.lexer.state.inLink&&/^<a /i.test(z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]):z[0]}},T.link=function(S){var z=this.rules.inline.link.exec(S);if(z){var H=z[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var P=O(H.slice(0,-1),"\\");if((H.length-P.length)%2===0)return}else{var j=U(z[2],"()");if(j>-1){var G=z[0].indexOf("!")===0?5:4,ee=G+z[1].length+j;z[2]=z[2].substring(0,j),z[0]=z[0].substring(0,ee).trim(),z[3]=""}}var re=z[2],pe="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(re);we&&(re=we[1],pe=we[3])}else pe=z[3]?z[3].slice(1,-1):"";return re=re.trim(),/^</.test(re)&&(this.options.pedantic&&!/>$/.test(H)?re=re.slice(1):re=re.slice(1,-1)),se(z,{href:re&&re.replace(this.rules.inline._escapes,"$1"),title:pe&&pe.replace(this.rules.inline._escapes,"$1")},z[0],this.lexer)}},T.reflink=function(S,z){var H;if((H=this.rules.inline.reflink.exec(S))||(H=this.rules.inline.nolink.exec(S))){var P=(H[2]||H[1]).replace(/\s+/g," ");if(P=z[P.toLowerCase()],!P||!P.href){var j=H[0].charAt(0);return{type:"text",raw:j,text:j}}return se(H,P,H[0],this.lexer)}},T.emStrong=function(S,z,H){H===void 0&&(H="");var P=this.rules.inline.emStrong.lDelim.exec(S);if(P&&!(P[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=P[1]||P[2]||"";if(!j||j&&(H===""||this.rules.inline.punctuation.exec(H))){var G=P[0].length-1,ee,re,pe=G,we=0,Ne=P[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,z=z.slice(-1*S.length+G);(P=Ne.exec(z))!=null;)if(ee=P[1]||P[2]||P[3]||P[4]||P[5]||P[6],!!ee){if(re=ee.length,P[3]||P[4]){pe+=re;continue}else if((P[5]||P[6])&&G%3&&!((G+re)%3)){we+=re;continue}if(pe-=re,!(pe>0)){if(re=Math.min(re,re+pe+we),Math.min(G,re)%2){var Se=S.slice(1,G+P.index+re);return{type:"em",raw:S.slice(0,G+P.index+re+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var ve=S.slice(2,G+P.index+re-1);return{type:"strong",raw:S.slice(0,G+P.index+re+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},T.codespan=function(S){var z=this.rules.inline.code.exec(S);if(z){var H=z[2].replace(/\n/g," "),P=/[^ ]/.test(H),j=/^ /.test(H)&&/ $/.test(H);return P&&j&&(H=H.substring(1,H.length-1)),H=e(H,!0),{type:"codespan",raw:z[0],text:H}}},T.br=function(S){var z=this.rules.inline.br.exec(S);if(z)return{type:"br",raw:z[0]}},T.del=function(S){var z=this.rules.inline.del.exec(S);if(z)return{type:"del",raw:z[0],text:z[2],tokens:this.lexer.inlineTokens(z[2])}},T.autolink=function(S,z){var H=this.rules.inline.autolink.exec(S);if(H){var P,j;return H[2]==="@"?(P=e(this.options.mangle?z(H[1]):H[1]),j="mailto:"+P):(P=e(H[1]),j=P),{type:"link",raw:H[0],text:P,href:j,tokens:[{type:"text",raw:P,text:P}]}}},T.url=function(S,z){var H;if(H=this.rules.inline.url.exec(S)){var P,j;if(H[2]==="@")P=e(this.options.mangle?z(H[0]):H[0]),j="mailto:"+P;else{var G;do G=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(G!==H[0]);P=e(H[0]),H[1]==="www."?j="http://"+P:j=P}return{type:"link",raw:H[0],text:P,href:j,tokens:[{type:"text",raw:P,text:P}]}}},T.inlineText=function(S,z){var H=this.rules.inline.text.exec(S);if(H){var P;return this.lexer.state.inRawBlock?P=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):e(H[0]):H[0]:P=e(this.options.smartypants?z(H[0]):H[0]),{type:"text",raw:H[0],text:P}}},C}(),ae={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ae._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ae._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ae.def=s(ae.def).replace("label",ae._label).replace("title",ae._title).getRegex(),ae.bullet=/(?:[*+-]|\d{1,9}[.)])/,ae.listItemStart=s(/^( *)(bull) */).replace("bull",ae.bullet).getRegex(),ae.list=s(ae.list).replace(/bull/g,ae.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ae.def.source+")").getRegex(),ae._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ae._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ae.html=s(ae.html,"i").replace("comment",ae._comment).replace("tag",ae._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ae.paragraph=s(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.blockquote=s(ae.blockquote).replace("paragraph",ae.paragraph).getRegex(),ae.normal=p({},ae),ae.gfm=p({},ae.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ae.gfm.table=s(ae.gfm.table).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.gfm.paragraph=s(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ae.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.pedantic=p({},ae.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ae._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:s(ae.normal._paragraph).replace("hr",ae.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ae.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=s(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=s(ae._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=s(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=s(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=s(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=s(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=s(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=s(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=s(oe.reflink).replace("label",oe._label).replace("ref",ae._label).getRegex(),oe.nolink=s(oe.nolink).replace("ref",ae._label).getRegex(),oe.reflinkSearch=s(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=p({},oe),oe.pedantic=p({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=p({},oe.normal,{escape:s(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=s(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=p({},oe.gfm,{br:s(oe.br).replace("{2,}","*").getRegex(),text:s(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ye(C){return C.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ke(C){var T="",R,S,z=C.length;for(R=0;R<z;R++)S=C.charCodeAt(R),Math.random()>.5&&(S="x"+S.toString(16)),T+="&#"+S+";";return T}var Be=function(){function C(R){this.tokens=[],this.tokens.links=Object.create(null),this.options=R||te.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var S={block:ae.normal,inline:oe.normal};this.options.pedantic?(S.block=ae.pedantic,S.inline=oe.pedantic):this.options.gfm&&(S.block=ae.gfm,this.options.breaks?S.inline=oe.breaks:S.inline=oe.gfm),this.tokenizer.rules=S}C.lex=function(S,z){var H=new C(z);return H.lex(S)},C.lexInline=function(S,z){var H=new C(z);return H.inlineTokens(S)};var T=C.prototype;return T.lex=function(S){S=S.replace(/\r\n|\r/g,`
`),this.blockTokens(S,this.tokens);for(var z;z=this.inlineQueue.shift();)this.inlineTokens(z.src,z.tokens);return this.tokens},T.blockTokens=function(S,z){var H=this;z===void 0&&(z=[]),this.options.pedantic?S=S.replace(/\t/g,"    ").replace(/^ +$/gm,""):S=S.replace(/^( *)(\t+)/gm,function(pe,we,Ne){return we+"    ".repeat(Ne.length)});for(var P,j,G,ee;S;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(pe){return(P=pe.call({lexer:H},S,z))?(S=S.substring(P.raw.length),z.push(P),!0):!1}))){if(P=this.tokenizer.space(S)){S=S.substring(P.raw.length),P.raw.length===1&&z.length>0?z[z.length-1].raw+=`
`:z.push(P);continue}if(P=this.tokenizer.code(S)){S=S.substring(P.raw.length),j=z[z.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+P.raw,j.text+=`
`+P.text,this.inlineQueue[this.inlineQueue.length-1].src=j.text):z.push(P);continue}if(P=this.tokenizer.fences(S)){S=S.substring(P.raw.length),z.push(P);continue}if(P=this.tokenizer.heading(S)){S=S.substring(P.raw.length),z.push(P);continue}if(P=this.tokenizer.hr(S)){S=S.substring(P.raw.length),z.push(P);continue}if(P=this.tokenizer.blockquote(S)){S=S.substring(P.raw.length),z.push(P);continue}if(P=this.tokenizer.list(S)){S=S.substring(P.raw.length),z.push(P);continue}if(P=this.tokenizer.html(S)){S=S.substring(P.raw.length),z.push(P);continue}if(P=this.tokenizer.def(S)){S=S.substring(P.raw.length),j=z[z.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+P.raw,j.text+=`
`+P.raw,this.inlineQueue[this.inlineQueue.length-1].src=j.text):this.tokens.links[P.tag]||(this.tokens.links[P.tag]={href:P.href,title:P.title});continue}if(P=this.tokenizer.table(S)){S=S.substring(P.raw.length),z.push(P);continue}if(P=this.tokenizer.lheading(S)){S=S.substring(P.raw.length),z.push(P);continue}if(G=S,this.options.extensions&&this.options.extensions.startBlock&&function(){var pe=1/0,we=S.slice(1),Ne=void 0;H.options.extensions.startBlock.forEach(function(Se){Ne=Se.call({lexer:this},we),typeof Ne=="number"&&Ne>=0&&(pe=Math.min(pe,Ne))}),pe<1/0&&pe>=0&&(G=S.substring(0,pe+1))}(),this.state.top&&(P=this.tokenizer.paragraph(G))){j=z[z.length-1],ee&&j.type==="paragraph"?(j.raw+=`
`+P.raw,j.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):z.push(P),ee=G.length!==S.length,S=S.substring(P.raw.length);continue}if(P=this.tokenizer.text(S)){S=S.substring(P.raw.length),j=z[z.length-1],j&&j.type==="text"?(j.raw+=`
`+P.raw,j.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):z.push(P);continue}if(S){var re="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(re);break}else throw new Error(re)}}return this.state.top=!0,z},T.inline=function(S,z){return z===void 0&&(z=[]),this.inlineQueue.push({src:S,tokens:z}),z},T.inlineTokens=function(S,z){var H=this;z===void 0&&(z=[]);var P,j,G,ee=S,re,pe,we;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(re=this.tokenizer.rules.inline.reflinkSearch.exec(ee))!=null;)Ne.includes(re[0].slice(re[0].lastIndexOf("[")+1,-1))&&(ee=ee.slice(0,re.index)+"["+ne("a",re[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(re=this.tokenizer.rules.inline.blockSkip.exec(ee))!=null;)ee=ee.slice(0,re.index)+"["+ne("a",re[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(re=this.tokenizer.rules.inline.escapedEmSt.exec(ee))!=null;)ee=ee.slice(0,re.index)+"++"+ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;S;)if(pe||(we=""),pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(P=ve.call({lexer:H},S,z))?(S=S.substring(P.raw.length),z.push(P),!0):!1}))){if(P=this.tokenizer.escape(S)){S=S.substring(P.raw.length),z.push(P);continue}if(P=this.tokenizer.tag(S)){S=S.substring(P.raw.length),j=z[z.length-1],j&&P.type==="text"&&j.type==="text"?(j.raw+=P.raw,j.text+=P.text):z.push(P);continue}if(P=this.tokenizer.link(S)){S=S.substring(P.raw.length),z.push(P);continue}if(P=this.tokenizer.reflink(S,this.tokens.links)){S=S.substring(P.raw.length),j=z[z.length-1],j&&P.type==="text"&&j.type==="text"?(j.raw+=P.raw,j.text+=P.text):z.push(P);continue}if(P=this.tokenizer.emStrong(S,ee,we)){S=S.substring(P.raw.length),z.push(P);continue}if(P=this.tokenizer.codespan(S)){S=S.substring(P.raw.length),z.push(P);continue}if(P=this.tokenizer.br(S)){S=S.substring(P.raw.length),z.push(P);continue}if(P=this.tokenizer.del(S)){S=S.substring(P.raw.length),z.push(P);continue}if(P=this.tokenizer.autolink(S,ke)){S=S.substring(P.raw.length),z.push(P);continue}if(!this.state.inLink&&(P=this.tokenizer.url(S,ke))){S=S.substring(P.raw.length),z.push(P);continue}if(G=S,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Pe=S.slice(1),Le=void 0;H.options.extensions.startInline.forEach(function(Ve){Le=Ve.call({lexer:this},Pe),typeof Le=="number"&&Le>=0&&(ve=Math.min(ve,Le))}),ve<1/0&&ve>=0&&(G=S.substring(0,ve+1))}(),P=this.tokenizer.inlineText(G,ye)){S=S.substring(P.raw.length),P.raw.slice(-1)!=="_"&&(we=P.raw.slice(-1)),pe=!0,j=z[z.length-1],j&&j.type==="text"?(j.raw+=P.raw,j.text+=P.text):z.push(P);continue}if(S){var Se="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return z},E(C,null,[{key:"rules",get:function(){return{block:ae,inline:oe}}}]),C}(),Me=function(){function C(R){this.options=R||te.defaults}var T=C.prototype;return T.code=function(S,z,H){var P=(z||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(S,P);j!=null&&j!==S&&(H=!0,S=j)}return S=S.replace(/\n$/,"")+`
`,P?'<pre><code class="'+this.options.langPrefix+e(P,!0)+'">'+(H?S:e(S,!0))+`</code></pre>
`:"<pre><code>"+(H?S:e(S,!0))+`</code></pre>
`},T.blockquote=function(S){return`<blockquote>
`+S+`</blockquote>
`},T.html=function(S){return S},T.heading=function(S,z,H,P){if(this.options.headerIds){var j=this.options.headerPrefix+P.slug(H);return"<h"+z+' id="'+j+'">'+S+"</h"+z+`>
`}return"<h"+z+">"+S+"</h"+z+`>
`},T.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},T.list=function(S,z,H){var P=z?"ol":"ul",j=z&&H!==1?' start="'+H+'"':"";return"<"+P+j+`>
`+S+"</"+P+`>
`},T.listitem=function(S){return"<li>"+S+`</li>
`},T.checkbox=function(S){return"<input "+(S?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},T.paragraph=function(S){return"<p>"+S+`</p>
`},T.table=function(S,z){return z&&(z="<tbody>"+z+"</tbody>"),`<table>
<thead>
`+S+`</thead>
`+z+`</table>
`},T.tablerow=function(S){return`<tr>
`+S+`</tr>
`},T.tablecell=function(S,z){var H=z.header?"th":"td",P=z.align?"<"+H+' align="'+z.align+'">':"<"+H+">";return P+S+("</"+H+`>
`)},T.strong=function(S){return"<strong>"+S+"</strong>"},T.em=function(S){return"<em>"+S+"</em>"},T.codespan=function(S){return"<code>"+S+"</code>"},T.br=function(){return this.options.xhtml?"<br/>":"<br>"},T.del=function(S){return"<del>"+S+"</del>"},T.link=function(S,z,H){if(S=F(this.options.sanitize,this.options.baseUrl,S),S===null)return H;var P='<a href="'+e(S)+'"';return z&&(P+=' title="'+z+'"'),P+=">"+H+"</a>",P},T.image=function(S,z,H){if(S=F(this.options.sanitize,this.options.baseUrl,S),S===null)return H;var P='<img src="'+S+'" alt="'+H+'"';return z&&(P+=' title="'+z+'"'),P+=this.options.xhtml?"/>":">",P},T.text=function(S){return S},C}(),fe=function(){function C(){}var T=C.prototype;return T.strong=function(S){return S},T.em=function(S){return S},T.codespan=function(S){return S},T.del=function(S){return S},T.html=function(S){return S},T.text=function(S){return S},T.link=function(S,z,H){return""+H},T.image=function(S,z,H){return""+H},T.br=function(){return""},C}(),$=function(){function C(){this.seen={}}var T=C.prototype;return T.serialize=function(S){return S.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},T.getNextSafeSlug=function(S,z){var H=S,P=0;if(this.seen.hasOwnProperty(H)){P=this.seen[S];do P++,H=S+"-"+P;while(this.seen.hasOwnProperty(H))}return z||(this.seen[S]=P,this.seen[H]=0),H},T.slug=function(S,z){z===void 0&&(z={});var H=this.serialize(S);return this.getNextSafeSlug(H,z.dryrun)},C}(),ie=function(){function C(R){this.options=R||te.defaults,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new $}C.parse=function(S,z){var H=new C(z);return H.parse(S)},C.parseInline=function(S,z){var H=new C(z);return H.parseInline(S)};var T=C.prototype;return T.parse=function(S,z){z===void 0&&(z=!0);var H="",P,j,G,ee,re,pe,we,Ne,Se,ve,Pe,Le,Ve,ze,We,Je,it,Oe,je,X=S.length;for(P=0;P<X;P++){if(ve=S[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(je=this.options.extensions.renderers[ve.type].call({parser:this},ve),je!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){H+=je||"";continue}switch(ve.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,n(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Ne="",we="",ee=ve.header.length,j=0;j<ee;j++)we+=this.renderer.tablecell(this.parseInline(ve.header[j].tokens),{header:!0,align:ve.align[j]});for(Ne+=this.renderer.tablerow(we),Se="",ee=ve.rows.length,j=0;j<ee;j++){for(pe=ve.rows[j],we="",re=pe.length,G=0;G<re;G++)we+=this.renderer.tablecell(this.parseInline(pe[G].tokens),{header:!1,align:ve.align[G]});Se+=this.renderer.tablerow(we)}H+=this.renderer.table(Ne,Se);continue}case"blockquote":{Se=this.parse(ve.tokens),H+=this.renderer.blockquote(Se);continue}case"list":{for(Pe=ve.ordered,Le=ve.start,Ve=ve.loose,ee=ve.items.length,Se="",j=0;j<ee;j++)We=ve.items[j],Je=We.checked,it=We.task,ze="",We.task&&(Oe=this.renderer.checkbox(Je),Ve?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=Oe+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=Oe+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:Oe}):ze+=Oe),ze+=this.parse(We.tokens,Ve),Se+=this.renderer.listitem(ze,it,Je);H+=this.renderer.list(Se,Pe,Le);continue}case"html":{H+=this.renderer.html(ve.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Se=ve.tokens?this.parseInline(ve.tokens):ve.text;P+1<X&&S[P+1].type==="text";)ve=S[++P],Se+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);H+=z?this.renderer.paragraph(Se):Se;continue}default:{var le='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(le);return}else throw new Error(le)}}}return H},T.parseInline=function(S,z){z=z||this.renderer;var H="",P,j,G,ee=S.length;for(P=0;P<ee;P++){if(j=S[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(G=this.options.extensions.renderers[j.type].call({parser:this},j),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(j.type))){H+=G||"";continue}switch(j.type){case"escape":{H+=z.text(j.text);break}case"html":{H+=z.html(j.text);break}case"link":{H+=z.link(j.href,j.title,this.parseInline(j.tokens,z));break}case"image":{H+=z.image(j.href,j.title,j.text);break}case"strong":{H+=z.strong(this.parseInline(j.tokens,z));break}case"em":{H+=z.em(this.parseInline(j.tokens,z));break}case"codespan":{H+=z.codespan(j.text);break}case"br":{H+=z.br();break}case"del":{H+=z.del(this.parseInline(j.tokens,z));break}case"text":{H+=z.text(j.text);break}default:{var re='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(re);return}else throw new Error(re)}}}return H},C}();function q(C,T,R){if(typeof C>"u"||C===null)throw new Error("marked(): input parameter is undefined or null");if(typeof C!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(C)+", string expected");if(typeof T=="function"&&(R=T,T=null),T=p({},q.defaults,T||{}),Z(T),R){var S=T.highlight,z;try{z=Be.lex(C,T)}catch(ee){return R(ee)}var H=function(re){var pe;if(!re)try{T.walkTokens&&q.walkTokens(z,T.walkTokens),pe=ie.parse(z,T)}catch(we){re=we}return T.highlight=S,re?R(re):R(null,pe)};if(!S||S.length<3||(delete T.highlight,!z.length))return H();var P=0;q.walkTokens(z,function(ee){ee.type==="code"&&(P++,setTimeout(function(){S(ee.text,ee.lang,function(re,pe){if(re)return H(re);pe!=null&&pe!==ee.text&&(ee.text=pe,ee.escaped=!0),P--,P===0&&H()})},0))}),P===0&&H();return}function j(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,T.silent)return"<p>An error occurred:</p><pre>"+e(ee.message+"",!0)+"</pre>";throw ee}try{var G=Be.lex(C,T);if(T.walkTokens){if(T.async)return Promise.all(q.walkTokens(G,T.walkTokens)).then(function(){return ie.parse(G,T)}).catch(j);q.walkTokens(G,T.walkTokens)}return ie.parse(G,T)}catch(ee){j(ee)}}q.options=q.setOptions=function(C){return p(q.defaults,C),y(q.defaults),q},q.getDefaults=D,q.defaults=te.defaults,q.use=function(){for(var C=arguments.length,T=new Array(C),R=0;R<C;R++)T[R]=arguments[R];var S=p.apply(void 0,[{}].concat(T)),z=q.defaults.extensions||{renderers:{},childTokens:{}},H;T.forEach(function(P){if(P.extensions&&(H=!0,P.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var ee=z.renderers?z.renderers[G.name]:null;ee?z.renderers[G.name]=function(){for(var re=arguments.length,pe=new Array(re),we=0;we<re;we++)pe[we]=arguments[we];var Ne=G.renderer.apply(this,pe);return Ne===!1&&(Ne=ee.apply(this,pe)),Ne}:z.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");z[G.level]?z[G.level].unshift(G.tokenizer):z[G.level]=[G.tokenizer],G.start&&(G.level==="block"?z.startBlock?z.startBlock.push(G.start):z.startBlock=[G.start]:G.level==="inline"&&(z.startInline?z.startInline.push(G.start):z.startInline=[G.start]))}G.childTokens&&(z.childTokens[G.name]=G.childTokens)})),P.renderer&&function(){var G=q.defaults.renderer||new Me,ee=function(we){var Ne=G[we];G[we]=function(){for(var Se=arguments.length,ve=new Array(Se),Pe=0;Pe<Se;Pe++)ve[Pe]=arguments[Pe];var Le=P.renderer[we].apply(G,ve);return Le===!1&&(Le=Ne.apply(G,ve)),Le}};for(var re in P.renderer)ee(re);S.renderer=G}(),P.tokenizer&&function(){var G=q.defaults.tokenizer||new ue,ee=function(we){var Ne=G[we];G[we]=function(){for(var Se=arguments.length,ve=new Array(Se),Pe=0;Pe<Se;Pe++)ve[Pe]=arguments[Pe];var Le=P.tokenizer[we].apply(G,ve);return Le===!1&&(Le=Ne.apply(G,ve)),Le}};for(var re in P.tokenizer)ee(re);S.tokenizer=G}(),P.walkTokens){var j=q.defaults.walkTokens;S.walkTokens=function(G){var ee=[];return ee.push(P.walkTokens.call(this,G)),j&&(ee=ee.concat(j.call(this,G))),ee}}H&&(S.extensions=z),q.setOptions(S)})},q.walkTokens=function(C,T){for(var R=[],S=function(){var j=H.value;switch(R=R.concat(T.call(q,j)),j.type){case"table":{for(var G=W(j.header),ee;!(ee=G()).done;){var re=ee.value;R=R.concat(q.walkTokens(re.tokens,T))}for(var pe=W(j.rows),we;!(we=pe()).done;)for(var Ne=we.value,Se=W(Ne),ve;!(ve=Se()).done;){var Pe=ve.value;R=R.concat(q.walkTokens(Pe.tokens,T))}break}case"list":{R=R.concat(q.walkTokens(j.items,T));break}default:q.defaults.extensions&&q.defaults.extensions.childTokens&&q.defaults.extensions.childTokens[j.type]?q.defaults.extensions.childTokens[j.type].forEach(function(Le){R=R.concat(q.walkTokens(j[Le],T))}):j.tokens&&(R=R.concat(q.walkTokens(j.tokens,T)))}},z=W(C),H;!(H=z()).done;)S();return R},q.parseInline=function(C,T){if(typeof C>"u"||C===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof C!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(C)+", string expected");T=p({},q.defaults,T||{}),Z(T);try{var R=Be.lexInline(C,T);return T.walkTokens&&q.walkTokens(R,T.walkTokens),ie.parseInline(R,T)}catch(S){if(S.message+=`
Please report this to https://github.com/markedjs/marked.`,T.silent)return"<p>An error occurred:</p><pre>"+e(S.message+"",!0)+"</pre>";throw S}},q.Parser=ie,q.parser=ie.parse,q.Renderer=Me,q.TextRenderer=fe,q.Lexer=Be,q.lexer=Be.lex,q.Tokenizer=ue,q.Slugger=$,q.parse=q;var V=q.options,A=q.setOptions,K=q.use,x=q.walkTokens,o=q.parseInline,k=q,_=ie.parse,Y=Be.lex;te.Lexer=Be,te.Parser=ie,te.Renderer=Me,te.Slugger=$,te.TextRenderer=fe,te.Tokenizer=ue,te.getDefaults=D,te.lexer=Y,te.marked=q,te.options=V,te.parse=k,te.parseInline=o,te.parser=_,te.setOptions=A,te.use=K,te.walkTokens=x,Object.defineProperty(te,"__esModule",{value:!0})}),define(ge[77],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class E{constructor(i,W=0,D=i.length,y=W-1){this.a=i,this.b=W,this.c=D,this.d=y}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.ArrayNavigator=E}),define(ge[78],me([1,0,77]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class L{constructor(D=[],y=10){this.h(D),this.b=y,this.d()}getHistory(){return this.j}add(D){this.a.delete(D),this.a.add(D),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(D){return this.a.has(D)}clear(){this.h([]),this.d()}d(){this.f();const D=this.j;this.c=new E.ArrayNavigator(D,0,D.length,D.length)}f(){const D=this.j;D.length>this.b&&this.h(D.slice(D.length-this.b))}g(){const D=this.c.current();return D?this.j.indexOf(D):-1}h(D){this.a=new Set;for(const y of D)this.a.add(y)}get j(){const D=[];return this.a.forEach(y=>D.push(y)),D}}t.HistoryNavigator=L;class i{constructor(D,y=10){if(this.g=y,D.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:D[0],previous:void 0,next:void 0},this.a=new Set([D[0]]);for(let h=1;h<D.length;h++)this.add(D[h])}add(D){const y={value:D,previous:this.c,next:void 0};for(this.c.next=y,this.c=y,this.d=this.c,this.f++,this.a.has(D)?this.h(D):this.a.add(D);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(D){if(this.c.value===D)return D;const y=this.c.value;return this.a.delete(y),this.c.value=D,this.a.has(D)?this.h(D):this.a.add(D),y}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(D){return this.a.has(D)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let D=this.b;for(;D;)yield D.value,D=D.next}h(D){let y=this.b;for(;y!==this.c;)y.value===D&&(y===this.b?(this.b=this.b.next,this.b.previous=void 0):(y.previous.next=y.next,y.next.previous=y.previous),this.f--),y=y.next}}t.HistoryNavigator2=i}),define(ge[44],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function E(y,h,l){return Math.min(Math.max(y,h),l)}t.clamp=E;function L(y,h){return(h+y%h)%h}t.rot=L;class i{constructor(){this.a=0}getNext(){return this.a++}}t.Counter=i;class W{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.MovingAverage=W;class D{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const l=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.SlidingWindowAverage=D}),define(ge[45],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var E;(function(L){function i(h,l){if(h.start>=l.end||l.start>=h.end)return{start:0,end:0};const d=Math.max(h.start,l.start),N=Math.min(h.end,l.end);return N-d<=0?{start:0,end:0}:{start:d,end:N}}L.intersect=i;function W(h){return h.end-h.start<=0}L.isEmpty=W;function D(h,l){return!W(i(h,l))}L.intersects=D;function y(h,l){const d=[],N={start:h.start,end:Math.min(l.start,h.end)},r={start:Math.max(l.end,h.start),end:h.end};return W(N)||d.push(N),W(r)||d.push(r),d}L.relativeComplement=y})(E||(t.Range=E={}))}),define(ge[79],me([1,0,45]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function L(h,l){const d=[];for(const N of l){if(h.start>=N.range.end)continue;if(h.end<N.range.start)break;const r=E.Range.intersect(h,N.range);E.Range.isEmpty(r)||d.push({range:r,size:N.size})}return d}t.groupIntersect=L;function i({start:h,end:l},d){return{start:h+d,end:l+d}}t.shift=i;function W(h){const l=[];let d=null;for(const N of h){const r=N.range.start,u=N.range.end,e=N.size;if(d&&e===d.size){d.range.end=u;continue}d={range:{start:r,end:u},size:e},l.push(d)}return l}t.consolidate=W;function D(...h){return W(h.reduce((l,d)=>l.concat(d),[]))}class y{constructor(){this.a=[],this.b=0}splice(l,d,N=[]){const r=N.length-d,u=L({start:0,end:l},this.a),e=L({start:l+d,end:Number.POSITIVE_INFINITY},this.a).map(n=>({range:i(n.range,r),size:n.size})),a=N.map((n,c)=>({range:{start:l+c,end:l+c+1},size:n.size}));this.a=D(u,a,e),this.b=this.a.reduce((n,c)=>n+c.size*(c.range.end-c.range.start),0)}get count(){const l=this.a.length;return l?this.a[l-1].range.end:0}get size(){return this.b}indexAt(l){if(l<0)return-1;let d=0,N=0;for(const r of this.a){const u=r.range.end-r.range.start,e=N+u*r.size;if(l<e)return d+Math.floor((l-N)/r.size);d+=u,N=e}return d}indexAfter(l){return Math.min(this.indexAt(l)+1,this.count)}positionAt(l){if(l<0)return-1;let d=0,N=0;for(const r of this.a){const u=r.range.end-r.range.start,e=N+u;if(l<e)return d+(l-N)*r.size;d+=u*r.size,N=e}return-1}}t.RangeMap=y}),define(ge[80],me([1,0,7,2]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function i(v){const F=v;return F?typeof F.read=="function":!1}t.isReadable=i;function W(v){const F=v;return F?[F.on,F.pause,F.resume,F.destroy].every(f=>typeof f=="function"):!1}t.isReadableStream=W;function D(v){const F=v;return F?W(F.stream)&&Array.isArray(F.buffer)&&typeof F.ended=="boolean":!1}t.isReadableBufferedStream=D;function y(v,F){return new h(v,F)}t.newWriteableStream=y;class h{constructor(F,f){this.e=F,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(F){if(!this.a.destroyed){if(this.a.flowing)this.g(F);else if(this.b.data.push(F),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(F){this.a.destroyed||(this.a.flowing?this.h(F):this.b.error.push(F))}end(F){this.a.destroyed||(typeof F<"u"&&this.write(F),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(F){this.c.data.slice(0).forEach(f=>f(F))}h(F){this.c.error.length===0?(0,E.onUnexpectedError)(F):this.c.error.slice(0).forEach(f=>f(F))}i(){this.c.end.slice(0).forEach(F=>F())}on(F,f){if(!this.a.destroyed)switch(F){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(F,f){if(this.a.destroyed)return;let b;switch(F){case"data":b=this.c.data;break;case"end":b=this.c.end;break;case"error":b=this.c.error;break}if(b){const B=b.indexOf(f);B>=0&&b.splice(B,1)}}j(){if(this.b.data.length>0){const F=this.e(this.b.data);this.g(F),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(b=>b())}}k(){if(this.c.error.length>0){for(const F of this.b.error)this.h(F);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(v,F){const f=[];let b;for(;(b=v.read())!==null;)f.push(b);return F(f)}t.consumeReadable=l;function d(v,F,f){const b=[];let B;for(;(B=v.read())!==null&&b.length<f;)b.push(B);return B===null&&b.length>0?F(b):{read:()=>{if(b.length>0)return b.shift();if(typeof B<"u"){const M=B;return B=void 0,M}return v.read()}}}t.peekReadable=d;function N(v,F){return new Promise((f,b)=>{const B=[];r(v,{onData:M=>{F&&B.push(M)},onError:M=>{F?b(M):f(void 0)},onEnd:()=>{f(F?F(B):void 0)}})})}t.consumeStream=N;function r(v,F){let f=!1;return v.on("error",b=>{f||F.onError(b)}),v.on("end",()=>{f||F.onEnd()}),v.on("data",b=>{f||F.onData(b)}),(0,L.toDisposable)(()=>f=!0)}t.listenStream=r;function u(v,F){return new Promise((f,b)=>{const B=new L.DisposableStore,M=[],m=I=>{if(M.push(I),M.length>F)return B.dispose(),v.pause(),f({stream:v,buffer:M,ended:!1})},g=I=>b(I),p=()=>f({stream:v,buffer:M,ended:!0});B.add((0,L.toDisposable)(()=>v.removeListener("error",g))),v.on("error",g),B.add((0,L.toDisposable)(()=>v.removeListener("end",p))),v.on("end",p),B.add((0,L.toDisposable)(()=>v.removeListener("data",m))),v.on("data",m)})}t.peekStream=u;function e(v,F){const f=y(F);return f.end(v),f}t.toStream=e;function a(){const v=y(()=>{throw new Error("not supported")});return v.end(),v}t.emptyStream=a;function n(v){let F=!1;return{read:()=>F?null:(F=!0,v)}}t.toReadable=n;function c(v,F,f){const b=y(f);return r(v,{onData:B=>b.write(F.data(B)),onError:B=>b.error(F.error?F.error(B):B),onEnd:()=>b.end()}),b}t.transform=c;function s(v,F,f){let b=!1;return{read:()=>{const B=F.read();return b?B:(b=!0,B!==null?f([v,B]):v)}}}t.prefixedReadable=s;function w(v,F,f){let b=!1;const B=y(f);return r(F,{onData:M=>b?B.write(M):(b=!0,B.write(f([v,M]))),onError:M=>B.error(M),onEnd:()=>{b||(b=!0,B.write(v)),B.end()}}),B}t.prefixedStream=w}),define(ge[31],me([1,0,30,80]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer<"u",W=new E.Lazy(()=>new Uint8Array(256));let D,y;class h{static alloc(U){return i?new h(Buffer.allocUnsafe(U)):new h(new Uint8Array(U))}static wrap(U){return i&&!Buffer.isBuffer(U)&&(U=Buffer.from(U.buffer,U.byteOffset,U.byteLength)),new h(U)}static fromString(U,Z){return!(Z?.dontUseNodeBuffer||!1)&&i?new h(Buffer.from(U)):(D||(D=new TextEncoder),new h(D.encode(U)))}static fromByteArray(U){const Z=h.alloc(U.length);for(let ne=0,se=U.length;ne<se;ne++)Z.buffer[ne]=U[ne];return Z}static concat(U,Z){if(typeof Z>"u"){Z=0;for(let ce=0,ue=U.length;ce<ue;ce++)Z+=U[ce].byteLength}const ne=h.alloc(Z);let se=0;for(let ce=0,ue=U.length;ce<ue;ce++){const ae=U[ce];ne.set(ae,se),se+=ae.byteLength}return ne}constructor(U){this.buffer=U,this.byteLength=this.buffer.byteLength}clone(){const U=h.alloc(this.byteLength);return U.set(this),U}toString(){return i?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(U,Z){return new h(this.buffer.subarray(U,Z))}set(U,Z){if(U instanceof h)this.buffer.set(U.buffer,Z);else if(U instanceof Uint8Array)this.buffer.set(U,Z);else if(U instanceof ArrayBuffer)this.buffer.set(new Uint8Array(U),Z);else if(ArrayBuffer.isView(U))this.buffer.set(new Uint8Array(U.buffer,U.byteOffset,U.byteLength),Z);else throw new Error("Unknown argument 'array'")}readUInt32BE(U){return N(this.buffer,U)}writeUInt32BE(U,Z){r(this.buffer,U,Z)}readUInt32LE(U){return u(this.buffer,U)}writeUInt32LE(U,Z){e(this.buffer,U,Z)}readUInt8(U){return a(this.buffer,U)}writeUInt8(U,Z){n(this.buffer,U,Z)}indexOf(U){const Z=U instanceof h?U.buffer:U,ne=Z.byteLength,se=this.buffer,ce=se.byteLength;if(ne===0)return 0;if(ne===1)return se.indexOf(Z[0]);if(ne>ce)return-1;const ue=W.value;ue.fill(Z.length);for(let ke=0;ke<Z.length;ke++)ue[Z[ke]]=Z.length-ke-1;let ae=Z.length-1,oe=ae,ye=-1;for(;ae<ce;)if(se[ae]===Z[oe]){if(oe===0){ye=ae;break}ae--,oe--}else ae+=Math.max(Z.length-oe,ue[se[ae]]),oe=Z.length-1;return ye}}t.VSBuffer=h;function l(O,U){return O[U+0]<<0>>>0|O[U+1]<<8>>>0}t.readUInt16LE=l;function d(O,U,Z){O[Z+0]=U&255,U=U>>>8,O[Z+1]=U&255}t.writeUInt16LE=d;function N(O,U){return O[U]*2**24+O[U+1]*2**16+O[U+2]*2**8+O[U+3]}t.readUInt32BE=N;function r(O,U,Z){O[Z+3]=U,U=U>>>8,O[Z+2]=U,U=U>>>8,O[Z+1]=U,U=U>>>8,O[Z]=U}t.writeUInt32BE=r;function u(O,U){return O[U+0]<<0>>>0|O[U+1]<<8>>>0|O[U+2]<<16>>>0|O[U+3]<<24>>>0}t.readUInt32LE=u;function e(O,U,Z){O[Z+0]=U&255,U=U>>>8,O[Z+1]=U&255,U=U>>>8,O[Z+2]=U&255,U=U>>>8,O[Z+3]=U&255}t.writeUInt32LE=e;function a(O,U){return O[U]}t.readUInt8=a;function n(O,U,Z){O[Z]=U}t.writeUInt8=n;function c(O){return L.consumeReadable(O,U=>h.concat(U))}t.readableToBuffer=c;function s(O){return L.toReadable(O)}t.bufferToReadable=s;function w(O){return L.consumeStream(O,U=>h.concat(U))}t.streamToBuffer=w;async function v(O){return O.ended?h.concat(O.buffer):h.concat([...O.buffer,await w(O.stream)])}t.bufferedStreamToBuffer=v;function F(O){return L.toStream(O,U=>h.concat(U))}t.bufferToStream=F;function f(O){return L.transform(O,{data:U=>typeof U=="string"?h.fromString(U):h.wrap(U)},U=>h.concat(U))}t.streamToBufferReadableStream=f;function b(O){return L.newWriteableStream(U=>h.concat(U),O)}t.newWriteableBufferStream=b;function B(O,U){return L.prefixedReadable(O,U,Z=>h.concat(Z))}t.prefixedBufferReadable=B;function M(O,U){return L.prefixedStream(O,U,Z=>h.concat(Z))}t.prefixedBufferStream=M;function m(O){let U=0,Z=0,ne=0;const se=new Uint8Array(Math.floor(O.length/4*3)),ce=ae=>{switch(Z){case 3:se[ne++]=U|ae,Z=0;break;case 2:se[ne++]=U|ae>>>2,U=ae<<6,Z=3;break;case 1:se[ne++]=U|ae>>>4,U=ae<<4,Z=2;break;default:U=ae<<2,Z=1}};for(let ae=0;ae<O.length;ae++){const oe=O.charCodeAt(ae);if(oe>=65&&oe<=90)ce(oe-65);else if(oe>=97&&oe<=122)ce(oe-97+26);else if(oe>=48&&oe<=57)ce(oe-48+52);else if(oe===43||oe===45)ce(62);else if(oe===47||oe===95)ce(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${O[ae]}`)}}const ue=ne;for(;Z>0;)ce(0);return h.wrap(se).slice(0,ue)}t.decodeBase64=m;const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:O},U=!0,Z=!1){const ne=Z?p:g;let se="";const ce=O.byteLength%3;let ue=0;for(;ue<O.byteLength-ce;ue+=3){const ae=O[ue+0],oe=O[ue+1],ye=O[ue+2];se+=ne[ae>>>2],se+=ne[(ae<<4|oe>>>4)&63],se+=ne[(oe<<2|ye>>>6)&63],se+=ne[ye&63]}if(ce===1){const ae=O[ue+0];se+=ne[ae>>>2],se+=ne[ae<<4&63],U&&(se+="==")}else if(ce===2){const ae=O[ue+0],oe=O[ue+1];se+=ne[ae>>>2],se+=ne[(ae<<4|oe>>>4)&63],se+=ne[oe<<2&63],U&&(se+="=")}return se}t.encodeBase64=I}),define(ge[46],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ge[6],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function E(b){return typeof b=="string"}t.isString=E;function L(b){return Array.isArray(b)&&b.every(B=>E(B))}t.isStringArray=L;function i(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}t.isObject=i;function W(b){const B=Object.getPrototypeOf(Uint8Array);return typeof b=="object"&&b instanceof B}t.isTypedArray=W;function D(b){return typeof b=="number"&&!isNaN(b)}t.isNumber=D;function y(b){return!!b&&typeof b[Symbol.iterator]=="function"}t.isIterable=y;function h(b){return b===!0||b===!1}t.isBoolean=h;function l(b){return typeof b>"u"}t.isUndefined=l;function d(b){return!N(b)}t.isDefined=d;function N(b){return l(b)||b===null}t.isUndefinedOrNull=N;function r(b,B){if(!b)throw new Error(B?`Unexpected type, expected '${B}'`:"Unexpected type")}t.assertType=r;function u(b){if(N(b))throw new Error("Assertion Failed: argument is undefined or null");return b}t.assertIsDefined=u;function e(...b){const B=[];for(let M=0;M<b.length;M++){const m=b[M];if(N(m))throw new Error(`Assertion Failed: argument at index ${M} is undefined or null`);B.push(m)}return B}t.assertAllDefined=e;const a=Object.prototype.hasOwnProperty;function n(b){if(!i(b))return!1;for(const B in b)if(a.call(b,B))return!1;return!0}t.isEmptyObject=n;function c(b){return typeof b=="function"}t.isFunction=c;function s(...b){return b.length>0&&b.every(c)}t.areFunctions=s;function w(b,B){const M=Math.min(b.length,B.length);for(let m=0;m<M;m++)v(b[m],B[m])}t.validateConstraints=w;function v(b,B){if(E(B)){if(typeof b!==B)throw new Error(`argument does not match constraint: typeof ${B}`)}else if(c(B)){try{if(b instanceof B)return}catch{}if(!N(b)&&b.constructor===B||B.length===1&&B.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=v;function F(b){return b===null?void 0:b}t.withNullAsUndefined=F;function f(b){return typeof b>"u"?null:b}t.withUndefinedAsNull=f}),define(ge[16],me([1,0,6]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const L=Object.create(null);function i(y,h){if((0,E.isString)(h)){const l=L[h];if(l===void 0)throw new Error(`${y} references an unknown codicon: ${h}`);h=l}return L[y]=h,{id:y}}function W(){return L}t.getCodiconFontCharacters=W;function D(){return Object.values(t.Codicon)}t.getAllCodicons=D,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(ge[47],me([1,0,6]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function L(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const s=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([w,v])=>{s[w]=v&&typeof v=="object"?L(v):v}),s}t.deepClone=L;function i(c){if(!c||typeof c!="object")return c;const s=[c];for(;s.length>0;){const w=s.shift();Object.freeze(w);for(const v in w)if(W.call(w,v)){const F=w[v];typeof F=="object"&&!Object.isFrozen(F)&&!(0,E.isTypedArray)(F)&&s.push(F)}}return c}t.deepFreeze=i;const W=Object.prototype.hasOwnProperty;function D(c,s){return y(c,s,new Set)}t.cloneAndChange=D;function y(c,s,w){if((0,E.isUndefinedOrNull)(c))return c;const v=s(c);if(typeof v<"u")return v;if(Array.isArray(c)){const F=[];for(const f of c)F.push(y(f,s,w));return F}if((0,E.isObject)(c)){if(w.has(c))throw new Error("Cannot clone recursive data-structure");w.add(c);const F={};for(const f in c)W.call(c,f)&&(F[f]=y(c[f],s,w));return w.delete(c),F}return c}function h(c,s,w=!0){return(0,E.isObject)(c)?((0,E.isObject)(s)&&Object.keys(s).forEach(v=>{v in c?w&&((0,E.isObject)(c[v])&&(0,E.isObject)(s[v])?h(c[v],s[v],w):c[v]=s[v]):c[v]=s[v]}),c):s}t.mixin=h;function l(c,s){if(c===s)return!0;if(c==null||s===null||s===void 0||typeof c!=typeof s||typeof c!="object"||Array.isArray(c)!==Array.isArray(s))return!1;let w,v;if(Array.isArray(c)){if(c.length!==s.length)return!1;for(w=0;w<c.length;w++)if(!l(c[w],s[w]))return!1}else{const F=[];for(v in c)F.push(v);F.sort();const f=[];for(v in s)f.push(v);if(f.sort(),!l(F,f))return!1;for(w=0;w<F.length;w++)if(!l(c[F[w]],s[F[w]]))return!1}return!0}t.equals=l;function d(c){const s=new Set;return JSON.stringify(c,(w,v)=>{if((0,E.isObject)(v)||Array.isArray(v)){if(s.has(v))return"[Circular]";s.add(v)}return v})}t.safeStringify=d;function N(c,s){const w=Object.create(null);return!c||!s||Object.keys(s).forEach(F=>{const f=c[F],b=s[F];l(f,b)||(w[F]=b)}),w}t.distinct=N;function r(c,s){const w=s.toLowerCase(),v=Object.keys(c).find(F=>F.toLowerCase()===w);return v?c[v]:c[s]}t.getCaseInsensitive=r;function u(c,s){const w=Object.create(null);for(const[v,F]of Object.entries(c))s(v,F)&&(w[v]=F);return w}t.filter=u;function e(c){let s=[],w=Object.getPrototypeOf(c);for(;Object.prototype!==w;)s=s.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return s}t.getAllPropertyNames=e;function a(c){const s=[];for(const w of e(c))typeof c[w]=="function"&&s.push(w);return s}t.getAllMethodNames=a;function n(c,s){const w=F=>function(){const f=Array.prototype.slice.call(arguments,0);return s(F,f)},v={};for(const F of c)v[F]=w(F);return v}t.createProxyObject=n}),define(ge[17],me([1,0,16]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.themeColorFromId=t.ThemeColor=void 0;var L;(function(D){function y(h){return h&&typeof h=="object"&&typeof h.id=="string"}D.isThemeColor=y})(L||(t.ThemeColor=L={}));function i(D){return{id:D}}t.themeColorFromId=i;var W;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function h(s){const w=y.exec(s.id);if(!w)return h(E.Codicon.error);const[,v,F]=w,f=["codicon","codicon-"+v];return F&&f.push("codicon-modifier-"+F.substring(1)),f}D.asClassNameArray=h;function l(s){return h(s).join(" ")}D.asClassName=l;function d(s){return"."+h(s).join(".")}D.asCSSSelector=d;function N(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||L.isThemeColor(s.color))}D.isThemeIcon=N;const r=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function u(s){const w=r.exec(s);if(!w)return;const[,v]=w;return{id:v}}D.fromString=u;function e(s){return{id:s}}D.fromId=e;function a(s,w){let v=s.id;const F=v.lastIndexOf("~");return F!==-1&&(v=v.substring(0,F)),w&&(v=`${v}~${w}`),{id:v}}D.modify=a;function n(s){const w=s.id.lastIndexOf("~");if(w!==-1)return s.id.substring(w+1)}D.getModifier=n;function c(s,w){return s.id===w.id&&s.color?.id===w.color?.id}D.isEqual=c})(W||(t.ThemeIcon=W={}))}),define(ge[81],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ge[82],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class E{constructor(i,W){this.a=i,this.onMessage=W}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.Protocol=E}),define(ge[48],me([8]),{}),define(ge[83],me([8]),{}),define(ge[84],me([8]),{}),define(ge[85],me([8]),{}),define(ge[86],me([1,0,84,85]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(ge[87],me([8]),{}),define(ge[88],me([8]),{}),define(ge[89],me([8]),{}),define(ge[90],me([8]),{}),define(ge[91],me([8]),{}),define(ge[92],me([8]),{}),define(ge[93],me([8]),{}),define(ge[94],me([8]),{}),define(ge[95],me([8]),{}),define(ge[96],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(ge[97],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/findinput/findInput",t)}),define(ge[98],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(ge[99],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(ge[100],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(ge[101],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(ge[102],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/tree/abstractTree",t)}),define(ge[103],me([12,10]),function(te,t){return te.create("vs/base/common/actions",t)}),define(ge[104],me([12,10]),function(te,t){return te.create("vs/base/common/platform",t)}),define(ge[5],me([1,0,104]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let L=!1,i=!1,W=!1,D=!1,y=!1,h=!1,l=!1,d=!1,N=!1,r=!1,u,e=t.LANGUAGE_DEFAULT,a=t.LANGUAGE_DEFAULT,n,c;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?s=t.globals.vscode.process:typeof process<"u"&&(s=process);const w=typeof s?.versions?.electron=="string",v=w&&s?.type==="renderer";if(typeof navigator=="object"&&!v)c=navigator.userAgent,L=c.indexOf("Windows")>=0,i=c.indexOf("Macintosh")>=0,d=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=c.indexOf("Linux")>=0,r=c?.indexOf("Mobi")>=0,h=!0,u=E.getConfiguredDefaultLocale(E.localize(0,null))||t.LANGUAGE_DEFAULT,e=u,a=navigator.language;else if(typeof s=="object"){L=s.platform==="win32",i=s.platform==="darwin",W=s.platform==="linux",D=W&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,l=w,N=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const I=s.env.VSCODE_NLS_CONFIG;if(I)try{const O=JSON.parse(I),U=O.availableLanguages["*"];u=O.locale,a=O.osLocale,e=U||t.LANGUAGE_DEFAULT,n=O._translationsConfigFile}catch{}y=!0}else console.error("Unable to resolve platform.");var F;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(F||(t.Platform=F={}));function f(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=f;let b=0;i?b=1:L?b=3:W&&(b=2),t.isWindows=L,t.isMacintosh=i,t.isLinux=W,t.isLinuxSnap=D,t.isNative=y,t.isElectron=l,t.isWeb=h,t.isWebWorker=h&&typeof t.globals.importScripts=="function",t.isIOS=d,t.isMobile=r,t.isCI=N,t.platform=b,t.userAgent=c,t.language=e;var B;(function(I){function O(){return t.language}I.value=O;function U(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}I.isDefaultVariant=U;function Z(){return t.language==="en"}I.isDefault=Z})(B||(t.Language=B={})),t.locale=u,t.platformLocale=a,t.translationsConfigFile=n,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const I=[];t.globals.addEventListener("message",U=>{if(U.data&&U.data.vscodeScheduleAsyncWork)for(let Z=0,ne=I.length;Z<ne;Z++){const se=I[Z];if(se.id===U.data.vscodeScheduleAsyncWork){I.splice(Z,1),se.callback();return}}});let O=0;return U=>{const Z=++O;I.push({id:Z,callback:U}),t.globals.postMessage({vscodeScheduleAsyncWork:Z},"*")}}return I=>setTimeout(I)})();var M;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(M||(t.OperatingSystem=M={})),t.OS=i||d?2:L?1:3;let m=!0,g=!1;function p(){if(!g){g=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,m=new Uint16Array(I.buffer)[0]===(2<<8)+1}return m}t.isLittleEndian=p,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(ge[105],me([1,0,5]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let L;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;L={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=L.cwd,t.env=L.env,t.platform=L.platform,t.arch=L.arch}),define(ge[22],me([1,0,105]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const L=65,i=97,W=90,D=122,y=46,h=47,l=92,d=58,N=63;class r extends Error{constructor(b,B,M){let m;typeof B=="string"&&B.indexOf("not ")===0?(m="must not be",B=B.replace(/^not /,"")):m="must be";const g=b.indexOf(".")!==-1?"property":"argument";let p=`The "${b}" ${g} ${m} of type ${B}`;p+=`. Received type ${typeof M}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function u(f,b){if(f===null||typeof f!="object")throw new r(b,"Object",f)}function e(f,b){if(typeof f!="string")throw new r(b,"string",f)}const a=E.platform==="win32";function n(f){return f===h||f===l}function c(f){return f===h}function s(f){return f>=L&&f<=W||f>=i&&f<=D}function w(f,b,B,M){let m="",g=0,p=-1,I=0,O=0;for(let U=0;U<=f.length;++U){if(U<f.length)O=f.charCodeAt(U);else{if(M(O))break;O=h}if(M(O)){if(!(p===U-1||I===1))if(I===2){if(m.length<2||g!==2||m.charCodeAt(m.length-1)!==y||m.charCodeAt(m.length-2)!==y){if(m.length>2){const Z=m.lastIndexOf(B);Z===-1?(m="",g=0):(m=m.slice(0,Z),g=m.length-1-m.lastIndexOf(B)),p=U,I=0;continue}else if(m.length!==0){m="",g=0,p=U,I=0;continue}}b&&(m+=m.length>0?`${B}..`:"..",g=2)}else m.length>0?m+=`${B}${f.slice(p+1,U)}`:m=f.slice(p+1,U),g=U-p-1;p=U,I=0}else O===y&&I!==-1?++I:I=-1}return m}function v(f,b){u(b,"pathObject");const B=b.dir||b.root,M=b.base||`${b.name||""}${b.ext||""}`;return B?B===b.root?`${B}${M}`:`${B}${f}${M}`:M}t.win32={resolve(...f){let b="",B="",M=!1;for(let m=f.length-1;m>=-1;m--){let g;if(m>=0){if(g=f[m],e(g,"path"),g.length===0)continue}else b.length===0?g=E.cwd():(g=E.env[`=${b}`]||E.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==b.toLowerCase()&&g.charCodeAt(2)===l)&&(g=`${b}\\`));const p=g.length;let I=0,O="",U=!1;const Z=g.charCodeAt(0);if(p===1)n(Z)&&(I=1,U=!0);else if(n(Z))if(U=!0,n(g.charCodeAt(1))){let ne=2,se=ne;for(;ne<p&&!n(g.charCodeAt(ne));)ne++;if(ne<p&&ne!==se){const ce=g.slice(se,ne);for(se=ne;ne<p&&n(g.charCodeAt(ne));)ne++;if(ne<p&&ne!==se){for(se=ne;ne<p&&!n(g.charCodeAt(ne));)ne++;(ne===p||ne!==se)&&(O=`\\\\${ce}\\${g.slice(se,ne)}`,I=ne)}}}else I=1;else s(Z)&&g.charCodeAt(1)===d&&(O=g.slice(0,2),I=2,p>2&&n(g.charCodeAt(2))&&(U=!0,I=3));if(O.length>0)if(b.length>0){if(O.toLowerCase()!==b.toLowerCase())continue}else b=O;if(M){if(b.length>0)break}else if(B=`${g.slice(I)}\\${B}`,M=U,U&&b.length>0)break}return B=w(B,!M,"\\",n),M?`${b}\\${B}`:`${b}${B}`||"."},normalize(f){e(f,"path");const b=f.length;if(b===0)return".";let B=0,M,m=!1;const g=f.charCodeAt(0);if(b===1)return c(g)?"\\":f;if(n(g))if(m=!0,n(f.charCodeAt(1))){let I=2,O=I;for(;I<b&&!n(f.charCodeAt(I));)I++;if(I<b&&I!==O){const U=f.slice(O,I);for(O=I;I<b&&n(f.charCodeAt(I));)I++;if(I<b&&I!==O){for(O=I;I<b&&!n(f.charCodeAt(I));)I++;if(I===b)return`\\\\${U}\\${f.slice(O)}\\`;I!==O&&(M=`\\\\${U}\\${f.slice(O,I)}`,B=I)}}}else B=1;else s(g)&&f.charCodeAt(1)===d&&(M=f.slice(0,2),B=2,b>2&&n(f.charCodeAt(2))&&(m=!0,B=3));let p=B<b?w(f.slice(B),!m,"\\",n):"";return p.length===0&&!m&&(p="."),p.length>0&&n(f.charCodeAt(b-1))&&(p+="\\"),M===void 0?m?`\\${p}`:p:m?`${M}\\${p}`:`${M}${p}`},isAbsolute(f){e(f,"path");const b=f.length;if(b===0)return!1;const B=f.charCodeAt(0);return n(B)||b>2&&s(B)&&f.charCodeAt(1)===d&&n(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let b,B;for(let g=0;g<f.length;++g){const p=f[g];e(p,"path"),p.length>0&&(b===void 0?b=B=p:b+=`\\${p}`)}if(b===void 0)return".";let M=!0,m=0;if(typeof B=="string"&&n(B.charCodeAt(0))){++m;const g=B.length;g>1&&n(B.charCodeAt(1))&&(++m,g>2&&(n(B.charCodeAt(2))?++m:M=!1))}if(M){for(;m<b.length&&n(b.charCodeAt(m));)m++;m>=2&&(b=`\\${b.slice(m)}`)}return t.win32.normalize(b)},relative(f,b){if(e(f,"from"),e(b,"to"),f===b)return"";const B=t.win32.resolve(f),M=t.win32.resolve(b);if(B===M||(f=B.toLowerCase(),b=M.toLowerCase(),f===b))return"";let m=0;for(;m<f.length&&f.charCodeAt(m)===l;)m++;let g=f.length;for(;g-1>m&&f.charCodeAt(g-1)===l;)g--;const p=g-m;let I=0;for(;I<b.length&&b.charCodeAt(I)===l;)I++;let O=b.length;for(;O-1>I&&b.charCodeAt(O-1)===l;)O--;const U=O-I,Z=p<U?p:U;let ne=-1,se=0;for(;se<Z;se++){const ue=f.charCodeAt(m+se);if(ue!==b.charCodeAt(I+se))break;ue===l&&(ne=se)}if(se!==Z){if(ne===-1)return M}else{if(U>Z){if(b.charCodeAt(I+se)===l)return M.slice(I+se+1);if(se===2)return M.slice(I+se)}p>Z&&(f.charCodeAt(m+se)===l?ne=se:se===2&&(ne=3)),ne===-1&&(ne=0)}let ce="";for(se=m+ne+1;se<=g;++se)(se===g||f.charCodeAt(se)===l)&&(ce+=ce.length===0?"..":"\\..");return I+=ne,ce.length>0?`${ce}${M.slice(I,O)}`:(M.charCodeAt(I)===l&&++I,M.slice(I,O))},toNamespacedPath(f){if(typeof f!="string"||f.length===0)return f;const b=t.win32.resolve(f);if(b.length<=2)return f;if(b.charCodeAt(0)===l){if(b.charCodeAt(1)===l){const B=b.charCodeAt(2);if(B!==N&&B!==y)return`\\\\?\\UNC\\${b.slice(2)}`}}else if(s(b.charCodeAt(0))&&b.charCodeAt(1)===d&&b.charCodeAt(2)===l)return`\\\\?\\${b}`;return f},dirname(f){e(f,"path");const b=f.length;if(b===0)return".";let B=-1,M=0;const m=f.charCodeAt(0);if(b===1)return n(m)?f:".";if(n(m)){if(B=M=1,n(f.charCodeAt(1))){let I=2,O=I;for(;I<b&&!n(f.charCodeAt(I));)I++;if(I<b&&I!==O){for(O=I;I<b&&n(f.charCodeAt(I));)I++;if(I<b&&I!==O){for(O=I;I<b&&!n(f.charCodeAt(I));)I++;if(I===b)return f;I!==O&&(B=M=I+1)}}}}else s(m)&&f.charCodeAt(1)===d&&(B=b>2&&n(f.charCodeAt(2))?3:2,M=B);let g=-1,p=!0;for(let I=b-1;I>=M;--I)if(n(f.charCodeAt(I))){if(!p){g=I;break}}else p=!1;if(g===-1){if(B===-1)return".";g=B}return f.slice(0,g)},basename(f,b){b!==void 0&&e(b,"ext"),e(f,"path");let B=0,M=-1,m=!0,g;if(f.length>=2&&s(f.charCodeAt(0))&&f.charCodeAt(1)===d&&(B=2),b!==void 0&&b.length>0&&b.length<=f.length){if(b===f)return"";let p=b.length-1,I=-1;for(g=f.length-1;g>=B;--g){const O=f.charCodeAt(g);if(n(O)){if(!m){B=g+1;break}}else I===-1&&(m=!1,I=g+1),p>=0&&(O===b.charCodeAt(p)?--p===-1&&(M=g):(p=-1,M=I))}return B===M?M=I:M===-1&&(M=f.length),f.slice(B,M)}for(g=f.length-1;g>=B;--g)if(n(f.charCodeAt(g))){if(!m){B=g+1;break}}else M===-1&&(m=!1,M=g+1);return M===-1?"":f.slice(B,M)},extname(f){e(f,"path");let b=0,B=-1,M=0,m=-1,g=!0,p=0;f.length>=2&&f.charCodeAt(1)===d&&s(f.charCodeAt(0))&&(b=M=2);for(let I=f.length-1;I>=b;--I){const O=f.charCodeAt(I);if(n(O)){if(!g){M=I+1;break}continue}m===-1&&(g=!1,m=I+1),O===y?B===-1?B=I:p!==1&&(p=1):B!==-1&&(p=-1)}return B===-1||m===-1||p===0||p===1&&B===m-1&&B===M+1?"":f.slice(B,m)},format:v.bind(null,"\\"),parse(f){e(f,"path");const b={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return b;const B=f.length;let M=0,m=f.charCodeAt(0);if(B===1)return n(m)?(b.root=b.dir=f,b):(b.base=b.name=f,b);if(n(m)){if(M=1,n(f.charCodeAt(1))){let ne=2,se=ne;for(;ne<B&&!n(f.charCodeAt(ne));)ne++;if(ne<B&&ne!==se){for(se=ne;ne<B&&n(f.charCodeAt(ne));)ne++;if(ne<B&&ne!==se){for(se=ne;ne<B&&!n(f.charCodeAt(ne));)ne++;ne===B?M=ne:ne!==se&&(M=ne+1)}}}}else if(s(m)&&f.charCodeAt(1)===d){if(B<=2)return b.root=b.dir=f,b;if(M=2,n(f.charCodeAt(2))){if(B===3)return b.root=b.dir=f,b;M=3}}M>0&&(b.root=f.slice(0,M));let g=-1,p=M,I=-1,O=!0,U=f.length-1,Z=0;for(;U>=M;--U){if(m=f.charCodeAt(U),n(m)){if(!O){p=U+1;break}continue}I===-1&&(O=!1,I=U+1),m===y?g===-1?g=U:Z!==1&&(Z=1):g!==-1&&(Z=-1)}return I!==-1&&(g===-1||Z===0||Z===1&&g===I-1&&g===p+1?b.base=b.name=f.slice(p,I):(b.name=f.slice(p,g),b.base=f.slice(p,I),b.ext=f.slice(g,I))),p>0&&p!==M?b.dir=f.slice(0,p-1):b.dir=b.root,b},sep:"\\",delimiter:";",win32:null,posix:null};const F=(()=>{if(a){const f=/\\/g;return()=>{const b=E.cwd().replace(f,"/");return b.slice(b.indexOf("/"))}}return()=>E.cwd()})();t.posix={resolve(...f){let b="",B=!1;for(let M=f.length-1;M>=-1&&!B;M--){const m=M>=0?f[M]:F();e(m,"path"),m.length!==0&&(b=`${m}/${b}`,B=m.charCodeAt(0)===h)}return b=w(b,!B,"/",c),B?`/${b}`:b.length>0?b:"."},normalize(f){if(e(f,"path"),f.length===0)return".";const b=f.charCodeAt(0)===h,B=f.charCodeAt(f.length-1)===h;return f=w(f,!b,"/",c),f.length===0?b?"/":B?"./":".":(B&&(f+="/"),b?`/${f}`:f)},isAbsolute(f){return e(f,"path"),f.length>0&&f.charCodeAt(0)===h},join(...f){if(f.length===0)return".";let b;for(let B=0;B<f.length;++B){const M=f[B];e(M,"path"),M.length>0&&(b===void 0?b=M:b+=`/${M}`)}return b===void 0?".":t.posix.normalize(b)},relative(f,b){if(e(f,"from"),e(b,"to"),f===b||(f=t.posix.resolve(f),b=t.posix.resolve(b),f===b))return"";const B=1,M=f.length,m=M-B,g=1,p=b.length-g,I=m<p?m:p;let O=-1,U=0;for(;U<I;U++){const ne=f.charCodeAt(B+U);if(ne!==b.charCodeAt(g+U))break;ne===h&&(O=U)}if(U===I)if(p>I){if(b.charCodeAt(g+U)===h)return b.slice(g+U+1);if(U===0)return b.slice(g+U)}else m>I&&(f.charCodeAt(B+U)===h?O=U:U===0&&(O=0));let Z="";for(U=B+O+1;U<=M;++U)(U===M||f.charCodeAt(U)===h)&&(Z+=Z.length===0?"..":"/..");return`${Z}${b.slice(g+O)}`},toNamespacedPath(f){return f},dirname(f){if(e(f,"path"),f.length===0)return".";const b=f.charCodeAt(0)===h;let B=-1,M=!0;for(let m=f.length-1;m>=1;--m)if(f.charCodeAt(m)===h){if(!M){B=m;break}}else M=!1;return B===-1?b?"/":".":b&&B===1?"//":f.slice(0,B)},basename(f,b){b!==void 0&&e(b,"ext"),e(f,"path");let B=0,M=-1,m=!0,g;if(b!==void 0&&b.length>0&&b.length<=f.length){if(b===f)return"";let p=b.length-1,I=-1;for(g=f.length-1;g>=0;--g){const O=f.charCodeAt(g);if(O===h){if(!m){B=g+1;break}}else I===-1&&(m=!1,I=g+1),p>=0&&(O===b.charCodeAt(p)?--p===-1&&(M=g):(p=-1,M=I))}return B===M?M=I:M===-1&&(M=f.length),f.slice(B,M)}for(g=f.length-1;g>=0;--g)if(f.charCodeAt(g)===h){if(!m){B=g+1;break}}else M===-1&&(m=!1,M=g+1);return M===-1?"":f.slice(B,M)},extname(f){e(f,"path");let b=-1,B=0,M=-1,m=!0,g=0;for(let p=f.length-1;p>=0;--p){const I=f.charCodeAt(p);if(I===h){if(!m){B=p+1;break}continue}M===-1&&(m=!1,M=p+1),I===y?b===-1?b=p:g!==1&&(g=1):b!==-1&&(g=-1)}return b===-1||M===-1||g===0||g===1&&b===M-1&&b===B+1?"":f.slice(b,M)},format:v.bind(null,"/"),parse(f){e(f,"path");const b={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return b;const B=f.charCodeAt(0)===h;let M;B?(b.root="/",M=1):M=0;let m=-1,g=0,p=-1,I=!0,O=f.length-1,U=0;for(;O>=M;--O){const Z=f.charCodeAt(O);if(Z===h){if(!I){g=O+1;break}continue}p===-1&&(I=!1,p=O+1),Z===y?m===-1?m=O:U!==1&&(U=1):m!==-1&&(U=-1)}if(p!==-1){const Z=g===0&&B?1:g;m===-1||U===0||U===1&&m===p-1&&m===g+1?b.base=b.name=f.slice(Z,p):(b.name=f.slice(Z,m),b.base=f.slice(Z,p),b.ext=f.slice(m,p))}return g>0?b.dir=f.slice(0,g-1):B&&(b.dir="/"),b},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=a?t.win32.normalize:t.posix.normalize,t.isAbsolute=a?t.win32.isAbsolute:t.posix.isAbsolute,t.join=a?t.win32.join:t.posix.join,t.resolve=a?t.win32.resolve:t.posix.resolve,t.relative=a?t.win32.relative:t.posix.relative,t.dirname=a?t.win32.dirname:t.posix.dirname,t.basename=a?t.win32.basename:t.posix.basename,t.extname=a?t.win32.extname:t.posix.extname,t.format=a?t.win32.format:t.posix.format,t.parse=a?t.win32.parse:t.posix.parse,t.toNamespacedPath=a?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=a?t.win32.sep:t.posix.sep,t.delimiter=a?t.win32.delimiter:t.posix.delimiter}),define(ge[106],me([1,0,22]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function W(d){const N=(0,E.extname)(d),r=L[N.toLowerCase()];return r!==void 0?r:D(d)}t.getMediaOrTextMime=W;function D(d){const N=(0,E.extname)(d);return i[N.toLowerCase()]}t.getMediaMime=D;function y(d){for(const N in i)if(i[N]===d)return N}t.getExtensionForMimeType=y;const h=/^(.+)\/(.+?)(;.+)?$/;function l(d,N){const r=h.exec(d);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:N?void 0:d}t.normalizeMimeType=l}),define(ge[107],me([1,0,5]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const L=E.globals.performance&&typeof E.globals.performance.now=="function";class i{static create(D=!0){return new i(D)}constructor(D){this.a=L&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}t.StopWatch=i}),define(ge[3],me([1,0,7,41,2,43,107]),function(te,t,E,L,i,W,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const y=!1,h=!1;var l;(function(g){g.None=()=>i.Disposable.None;function p(_){if(h){const{onDidAddListener:Y}=_,C=e.create();let T=0;_.onDidAddListener=()=>{++T===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),C.print()),Y?.()}}}function I(_,Y){return oe(_,()=>{},0,void 0,!0,void 0,Y)}g.defer=I;function O(_){return(Y,C=null,T)=>{let R=!1,S;return S=_(z=>{if(!R)return S?S.dispose():R=!0,Y.call(C,z)},null,T),R&&S.dispose(),S}}g.once=O;function U(_,Y,C){return ae((T,R=null,S)=>_(z=>T.call(R,Y(z)),null,S),C)}g.map=U;function Z(_,Y,C){return ae((T,R=null,S)=>_(z=>{Y(z),T.call(R,z)},null,S),C)}g.forEach=Z;function ne(_,Y,C){return ae((T,R=null,S)=>_(z=>Y(z)&&T.call(R,z),null,S),C)}g.filter=ne;function se(_){return _}g.signal=se;function ce(..._){return(Y,C=null,T)=>(0,i.combinedDisposable)(..._.map(R=>R(S=>Y.call(C,S),null,T)))}g.any=ce;function ue(_,Y,C,T){let R=C;return U(_,S=>(R=Y(R,S),R),T)}g.reduce=ue;function ae(_,Y){let C;const T={onWillAddFirstListener(){C=_(R.fire,R)},onDidRemoveLastListener(){C?.dispose()}};Y||p(T);const R=new n(T);return Y?.add(R),R.event}function oe(_,Y,C=100,T=!1,R=!1,S,z){let H,P,j,G=0,ee;const re={leakWarningThreshold:S,onWillAddFirstListener(){H=_(we=>{G++,P=Y(P,we),T&&!j&&(pe.fire(P),P=void 0),ee=()=>{const Ne=P;P=void 0,j=void 0,(!T||G>1)&&pe.fire(Ne),G=0},typeof C=="number"?(clearTimeout(j),j=setTimeout(ee,C)):j===void 0&&(j=0,queueMicrotask(ee))})},onWillRemoveListener(){R&&G>0&&ee?.()},onDidRemoveLastListener(){ee=void 0,H.dispose()}};z||p(re);const pe=new n(re);return z?.add(pe),pe.event}g.debounce=oe;function ye(_,Y=0,C){return g.debounce(_,(T,R)=>T?(T.push(R),T):[R],Y,void 0,!0,void 0,C)}g.accumulate=ye;function ke(_,Y=(T,R)=>T===R,C){let T=!0,R;return ne(_,S=>{const z=T||!Y(S,R);return T=!1,R=S,z},C)}g.latch=ke;function Be(_,Y,C){return[g.filter(_,Y,C),g.filter(_,T=>!Y(T),C)]}g.split=Be;function Me(_,Y=!1,C=[]){let T=C.slice(),R=_(H=>{T?T.push(H):z.fire(H)});const S=()=>{T?.forEach(H=>z.fire(H)),T=null},z=new n({onWillAddFirstListener(){R||(R=_(H=>z.fire(H)))},onDidAddFirstListener(){T&&(Y?setTimeout(S):S())},onDidRemoveLastListener(){R&&R.dispose(),R=null}});return z.event}g.buffer=Me;class fe{constructor(Y){this.event=Y,this.c=new i.DisposableStore}map(Y){return new fe(U(this.event,Y,this.c))}forEach(Y){return new fe(Z(this.event,Y,this.c))}filter(Y){return new fe(ne(this.event,Y,this.c))}reduce(Y,C){return new fe(ue(this.event,Y,C,this.c))}latch(){return new fe(ke(this.event,void 0,this.c))}debounce(Y,C=100,T=!1,R=!1,S){return new fe(oe(this.event,Y,C,T,R,S,this.c))}on(Y,C,T){return this.event(Y,C,T)}once(Y,C,T){return O(this.event)(Y,C,T)}dispose(){this.c.dispose()}}function $(_){return new fe(_)}g.chain=$;function ie(_,Y,C=T=>T){const T=(...H)=>z.fire(C(...H)),R=()=>_.on(Y,T),S=()=>_.removeListener(Y,T),z=new n({onWillAddFirstListener:R,onDidRemoveLastListener:S});return z.event}g.fromNodeEventEmitter=ie;function q(_,Y,C=T=>T){const T=(...H)=>z.fire(C(...H)),R=()=>_.addEventListener(Y,T),S=()=>_.removeEventListener(Y,T),z=new n({onWillAddFirstListener:R,onDidRemoveLastListener:S});return z.event}g.fromDOMEventEmitter=q;function V(_){return new Promise(Y=>O(_)(Y))}g.toPromise=V;function A(_,Y){return Y(void 0),_(C=>Y(C))}g.runAndSubscribe=A;function K(_,Y){let C=null;function T(S){C?.dispose(),C=new i.DisposableStore,Y(S,C)}T(void 0);const R=_(S=>T(S));return(0,i.toDisposable)(()=>{R.dispose(),C?.dispose()})}g.runAndSubscribeWithStore=K;class x{constructor(Y,C){this._observable=Y,this.c=0,this.d=!1;const T={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};C||p(T),this.emitter=new n(T),C&&C.add(this.emitter)}beginUpdate(Y){this.c++}handlePossibleChange(Y){}handleChange(Y,C){this.d=!0}endUpdate(Y){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function o(_,Y){return new x(_,Y).emitter.event}g.fromObservable=o;function k(_){return Y=>{let C=0,T=!1;const R={beginUpdate(){C++},endUpdate(){C--,C===0&&(_.reportChanges(),T&&(T=!1,Y()))},handlePossibleChange(){},handleChange(){T=!0}};return _.addObserver(R),{dispose(){_.removeObserver(R)}}}}g.fromObservableLight=k})(l||(t.Event=l={}));class d{constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${d.c++}`,d.all.add(this)}start(p){this.d=new D.StopWatch(!0),this.listenerCount=p}stop(){if(this.d){const p=this.d.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.d=void 0}}}t.EventProfiling=d,d.all=new Set,d.c=0;let N=-1;function r(g){const p=N;return N=g,{dispose(){N=p}}}t.setGlobalLeakWarningThreshold=r;class u{constructor(p,I=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=I,this.d=0}dispose(){this.c?.clear()}check(p,I){const O=this.threshold;if(O<=0||I<O)return;this.c||(this.c=new Map);const U=this.c.get(p.value)||0;if(this.c.set(p.value,U+1),this.d-=1,this.d<=0){this.d=O*.5;let Z,ne=0;for(const[se,ce]of this.c)(!Z||ne<ce)&&(Z=se,ne=ce);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${ne}):`),console.warn(Z)}return()=>{const Z=this.c.get(p.value)||0;this.c.set(p.value,Z-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class a{constructor(p,I,O){this.callback=p,this.callbackThis=I,this.stack=O,this.subscription=new i.SafeDisposable}invoke(p){this.callback.call(this.callbackThis,p)}}class n{constructor(p){this.j=!1,this.d=p,this.f=N>0||this.d?.leakWarningThreshold?new u(this.d?.leakWarningThreshold??N):void 0,this.g=this.d?._profName?new d(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(y){const p=Array.from(this.q);queueMicrotask(()=>{for(const I of p)I.subscription.isset()&&(I.subscription.unset(),I.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(p,I,O)=>{if(this.q||(this.q=new W.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const U=this.q.isEmpty();U&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let Z,ne;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(ne=e.create(),Z=this.f.check(ne,this.q.size+1)),y&&(ne=ne??e.create());const se=new a(p,I,ne),ce=this.q.push(se);U&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,p,I);const ue=se.subscription.set(()=>{Z?.(),this.j||(this.d?.onWillRemoveListener?.(this),ce(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return O instanceof i.DisposableStore?O.add(ue):Array.isArray(O)&&O.push(ue),ue}),this.l}fire(p){if(this.q){this.m||(this.m=new s(this.d?.onListenerError));for(const I of this.q)this.m.push(this,I,p);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=n;class c{constructor(p=E.onUnexpectedError){this.d=p,this.c=new W.LinkedList}get size(){return this.c.size}push(p,I,O){this.c.push(new w(p,I,O))}clear(p){const I=new W.LinkedList;for(const O of this.c)O.emitter!==p&&I.push(O);this.c=I}deliver(){for(;this.c.size>0;){const p=this.c.shift();try{p.listener.invoke(p.event)}catch(I){this.d(I)}}}}t.EventDeliveryQueue=c;class s extends c{clear(p){this.c.clear()}}class w{constructor(p,I,O){this.emitter=p,this.listener=I,this.event=O}}class v extends n{async fireAsync(p,I,O){if(this.q){this.c||(this.c=new W.LinkedList);for(const U of this.q)this.c.push([U,p]);for(;this.c.size>0&&!I.isCancellationRequested;){const[U,Z]=this.c.shift(),ne=[],se={...Z,token:I,waitUntil:ce=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");O&&(ce=O(ce,U.callback)),ne.push(ce)}};try{U.invoke(se)}catch(ce){(0,E.onUnexpectedError)(ce);continue}Object.freeze(ne),await Promise.allSettled(ne).then(ce=>{for(const ue of ce)ue.status==="rejected"&&(0,E.onUnexpectedError)(ue.reason)})}}}}t.AsyncEmitter=v;class F extends n{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new W.LinkedList,this.t=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.t(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.q&&(this.h!==0?this.s.push(p):super.fire(p))}}t.PauseableEmitter=F;class f extends F{constructor(p){super(p),this.c=p.delay??100}fire(p){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(p)}}t.DebounceEmitter=f;class b extends n{constructor(p){super(p),this.c=[],this.h=p?.merge}fire(p){this.hasListeners()&&(this.c.push(p),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(I=>super.fire(I)),this.c=[]}))}}t.MicrotaskEmitter=b;class B{constructor(){this.d=!1,this.f=[],this.c=new n({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(p){const I={event:p,listener:null};this.f.push(I),this.d&&this.j(I);const O=()=>{this.d&&this.k(I);const U=this.f.indexOf(I);this.f.splice(U,1)};return(0,i.toDisposable)((0,L.once)(O))}g(){this.d=!0,this.f.forEach(p=>this.j(p))}h(){this.d=!1,this.f.forEach(p=>this.k(p))}j(p){p.listener=p.event(I=>this.c.fire(I))}k(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=B;class M{constructor(){this.c=[]}wrapEvent(p){return(I,O,U)=>p(Z=>{const ne=this.c[this.c.length-1];ne?ne.push(()=>I.call(O,Z)):I.call(O,Z)},void 0,U)}bufferEvents(p){const I=[];this.c.push(I);const O=p();return this.c.pop(),I.forEach(U=>U()),O}}t.EventBufferer=M;class m{constructor(){this.c=!1,this.d=l.None,this.f=i.Disposable.None,this.g=new n({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(p){this.d=p,this.c&&(this.f.dispose(),this.f=p(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=m}),define(ge[18],me([1,0,3,2]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOEnabled=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class i{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new E.Emitter,this.onDidChangeFullscreen=this.d.event}getZoomLevel(){return this.a}setZoomLevel(v,F){this.a!==v&&(this.a=v)}getZoomFactor(){return this.b}setZoomFactor(v){this.b=v}setFullscreen(v){this.c!==v&&(this.c=v,this.d.fire())}isFullscreen(){return this.c}}i.INSTANCE=new i;class W extends L.Disposable{constructor(){super(),this.a=this.B(new E.Emitter),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(v){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),v&&this.a.fire()}}class D extends L.Disposable{get value(){return this.b}constructor(){super(),this.a=this.B(new E.Emitter),this.onDidChange=this.a.event,this.b=this.c();const v=this.B(new W);this.B(v.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const v=document.createElement("canvas").getContext("2d"),F=window.devicePixelRatio||1,f=v.webkitBackingStorePixelRatio||v.mozBackingStorePixelRatio||v.msBackingStorePixelRatio||v.oBackingStorePixelRatio||v.backingStorePixelRatio||1;return F/f}}class y{constructor(){this.a=null}b(){return this.a||(this.a=(0,L.markAsSingleton)(new D)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function h(w,v){typeof w=="string"&&(w=window.matchMedia(w)),w.addEventListener("change",v)}t.addMatchMediaChangeListener=h,t.PixelRatio=new y;function l(w,v){i.INSTANCE.setZoomLevel(w,v)}t.setZoomLevel=l;function d(){return i.INSTANCE.getZoomLevel()}t.getZoomLevel=d;function N(){return i.INSTANCE.getZoomFactor()}t.getZoomFactor=N;function r(w){i.INSTANCE.setZoomFactor(w)}t.setZoomFactor=r;function u(w){i.INSTANCE.setFullscreen(w)}t.setFullscreen=u;function e(){return i.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=i.INSTANCE.onDidChangeFullscreen;const a=navigator.userAgent;t.isFirefox=a.indexOf("Firefox")>=0,t.isWebKit=a.indexOf("AppleWebKit")>=0,t.isChrome=a.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&a.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=a.indexOf("Electron/")>=0,t.isAndroid=a.indexOf("Android")>=0;let n=!1;if(window.matchMedia){const w=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),v=window.matchMedia("(display-mode: fullscreen)");n=w.matches,h(w,({matches:F})=>{n&&v.matches||(n=F)})}function c(){return n}t.isStandalone=c;function s(){return navigator?.windowControlsOverlay?.visible}t.isWCOEnabled=s}),define(ge[108],me([1,0,18,5]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var i;(function(W){W[W.Always=0]="Always",W[W.FullScreen=1]="FullScreen",W[W.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.BrowserFeatures={clipboard:{writeText:L.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:L.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>L.isNative||E.isStandalone()?0:navigator.keyboard||E.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(ge[20],me([1,0,3]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class L{get event(){return this.a.event}constructor(W,D,y){const h=l=>this.a.fire(l);this.a=new E.Emitter({onWillAddFirstListener:()=>W.addEventListener(D,h,y),onDidRemoveLastListener:()=>W.removeEventListener(D,h,y)})}dispose(){this.a.dispose()}}t.DomEmitter=L}),define(ge[14],me([1,0,18,42,74,5]),function(te,t,E,L,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function D(e){if(e.charCode){const n=String.fromCharCode(e.charCode).toUpperCase();return L.KeyCodeUtils.fromString(n)}const a=e.keyCode;if(a===3)return 7;if(E.isFirefox)switch(a){case 59:return 85;case 60:if(W.isLinux)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(W.isMacintosh)return 57;break}else if(E.isWebKit){if(W.isMacintosh&&a===93)return 57;if(!W.isMacintosh&&a===92)return 57}return L.EVENT_KEY_CODE_MAP[a]||0}const y=W.isMacintosh?256:2048,h=512,l=1024,d=W.isMacintosh?2048:256;function N(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=N;function r(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${L.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=r;class u{constructor(a){this._standardKeyboardEventBrand=!0;const n=a;this.browserEvent=n,this.target=n.target,this.ctrlKey=n.ctrlKey,this.shiftKey=n.shiftKey,this.altKey=n.altKey,this.metaKey=n.metaKey,this.altGraphKey=n.getModifierState("AltGraph"),this.keyCode=D(n),this.code=n.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(a){return this.a===a}c(){let a=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode);let n=0;return this.ctrlKey&&(n|=y),this.altKey&&(n|=h),this.shiftKey&&(n|=l),this.metaKey&&(n|=d),n|=a,n}d(){let a=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode),new i.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,a)}}t.StandardKeyboardEvent=u}),define(ge[21],me([1,0,18,66,5]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class W{constructor(l){this.timestamp=Date.now(),this.browserEvent=l,this.leftButton=l.button===0,this.middleButton=l.button===1,this.rightButton=l.button===2,this.buttons=l.buttons,this.target=l.target,this.detail=l.detail||1,l.type==="dblclick"&&(this.detail=2),this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,typeof l.pageX=="number"?(this.posx=l.pageX,this.posy=l.pageY):(this.posx=l.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=l.clientY+document.body.scrollTop+document.documentElement.scrollTop);const d=L.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(window,l.view);this.posx-=d.left,this.posy-=d.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=W;class D extends W{constructor(l){super(l),this.dataTransfer=l.dataTransfer}}t.DragMouseEvent=D;class y{constructor(l,d=0,N=0){if(this.browserEvent=l||null,this.target=l?l.target||l.targetNode||l.srcElement:null,this.deltaY=N,this.deltaX=d,l){const r=l,u=l;if(typeof r.wheelDeltaY<"u")this.deltaY=r.wheelDeltaY/120;else if(typeof u.VERTICAL_AXIS<"u"&&u.axis===u.VERTICAL_AXIS)this.deltaY=-u.detail/3;else if(l.type==="wheel"){const e=l;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!i.isMacintosh?this.deltaY=-l.deltaY/3:this.deltaY=-l.deltaY:this.deltaY=-l.deltaY/40}if(typeof r.wheelDeltaX<"u")E.isSafari&&i.isWindows?this.deltaX=-(r.wheelDeltaX/120):this.deltaX=r.wheelDeltaX/120;else if(typeof u.HORIZONTAL_AXIS<"u"&&u.axis===u.HORIZONTAL_AXIS)this.deltaX=-l.detail/3;else if(l.type==="wheel"){const e=l;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!i.isMacintosh?this.deltaX=-l.deltaX/3:this.deltaX=-l.deltaX:this.deltaX=-l.deltaX/40}this.deltaY===0&&this.deltaX===0&&l.wheelDelta&&(this.deltaY=l.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=y}),define(ge[32],me([1,0,3,2,103]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class W extends L.Disposable{constructor(r,u="",e="",a=!0,n){super(),this.h=this.B(new E.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=r,this.m=u,this.u=e,this.w=a,this.C=n}get id(){return this.j}get label(){return this.m}set label(r){this.D(r)}D(r){this.m!==r&&(this.m=r,this.h.fire({label:r}))}get tooltip(){return this.n||""}set tooltip(r){this.F(r)}F(r){this.n!==r&&(this.n=r,this.h.fire({tooltip:r}))}get class(){return this.u}set class(r){this.G(r)}G(r){this.u!==r&&(this.u=r,this.h.fire({class:r}))}get enabled(){return this.w}set enabled(r){this.H(r)}H(r){this.w!==r&&(this.w=r,this.h.fire({enabled:r}))}get checked(){return this.z}set checked(r){this.I(r)}I(r){this.z!==r&&(this.z=r,this.h.fire({checked:r}))}async run(r,u){this.C&&await this.C(r)}}t.Action=W;class D extends L.Disposable{constructor(){super(...arguments),this.f=this.B(new E.Emitter),this.onWillRun=this.f.event,this.h=this.B(new E.Emitter),this.onDidRun=this.h.event}async run(r,u){if(!r.enabled)return;this.f.fire({action:r});let e;try{await this.k(r,u)}catch(a){e=a}this.h.fire({action:r,error:e})}async k(r,u){await r.run(u)}}t.ActionRunner=D;class y{constructor(){this.id=y.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let u=[];for(const e of r)e.length&&(u.length?u=[...u,new y,...e]:u=e);return u}async run(){}}t.Separator=y,y.ID="vs.actions.separator";class h{get actions(){return this.a}constructor(r,u,e,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=u,this.class=a,this.a=e}async run(){}}t.SubmenuAction=h;class l extends W{constructor(){super(l.ID,i.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=l,l.ID="vs.actions.empty";function d(N){return{id:N.id,label:N.label,class:void 0,enabled:N.enabled??!0,checked:N.checked??!1,run:async()=>N.run(),tooltip:N.label}}t.toAction=d}),define(ge[27],me([1,0,3]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const L=Object.freeze(function(y,h){const l=setTimeout(y.bind(h),0);return{dispose(){clearTimeout(l)}}});var i;(function(y){function h(l){return l===y.None||l===y.Cancelled||l instanceof W?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}y.isCancellationToken=h,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(i||(t.CancellationToken=i={}));class W{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(h){this.a=void 0,this.b=void 0,this.b=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new W),this.a}cancel(){this.a?this.a instanceof W&&this.a.cancel():this.a=i.Cancelled}dispose(h=!1){h&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof W&&this.a.dispose():this.a=i.None}}t.CancellationTokenSource=D}),define(ge[109],me([1,0,27]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class L{constructor(y){this.b=y,this.a=null}get(){if(this.a)return this.a;const y=new E.CancellationTokenSource,h=this.b(y.token);return this.a={promise:h,dispose:()=>{this.a=null,y.cancel(),y.dispose()}},this.a}}t.Cache=L;class i{constructor(y){this.c=y,this.a=void 0,this.b=void 0}get(y){const h=JSON.stringify(y);return this.b!==h&&(this.b=h,this.a=this.c(y)),this.a}}t.LRUCachedFunction=i;class W{get cachedValues(){return this.a}constructor(y){this.b=y,this.a=new Map}get(y){if(this.a.has(y))return this.a.get(y);const h=this.b(y);return this.a.set(y,h),h}}t.CachedFunction=W}),define(ge[49],me([1,0,3,2]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var i;(function(u){u[u.Auto=1]="Auto",u[u.Hidden=2]="Hidden",u[u.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class W{constructor(e,a,n,c,s,w,v){this.c=e,this._scrollStateBrand=void 0,this.c&&(a=a|0,n=n|0,c=c|0,s=s|0,w=w|0,v=v|0),this.rawScrollLeft=c,this.rawScrollTop=v,a<0&&(a=0),c+a>n&&(c=n-a),c<0&&(c=0),s<0&&(s=0),v+s>w&&(v=w-s),v<0&&(v=0),this.width=a,this.scrollWidth=n,this.scrollLeft=c,this.height=s,this.scrollHeight=w,this.scrollTop=v}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,a){return new W(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new W(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,a){const n=this.width!==e.width,c=this.scrollWidth!==e.scrollWidth,s=this.scrollLeft!==e.scrollLeft,w=this.height!==e.height,v=this.scrollHeight!==e.scrollHeight,F=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:a,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:n,scrollWidthChanged:c,scrollLeftChanged:s,heightChanged:w,scrollHeightChanged:v,scrollTopChanged:F}}}t.ScrollState=W;class D extends L.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this.i=this.B(new E.Emitter),this.onScroll=this.i.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new W(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,a){const n=this.g.withScrollDimensions(e,a);this.k(n,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const a=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.k(a,!1)}setScrollPositionSmooth(e,a){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const n=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===n.scrollLeft&&this.h.to.scrollTop===n.scrollTop)return;let c;a?c=new d(this.h.from,n,this.h.startTime,this.h.duration):c=this.h.combine(this.g,n,this.c),this.h.dispose(),this.h=c}else{const n=this.g.withScrollPosition(e);this.h=d.start(this.g,n,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.j())})}hasPendingScrollAnimation(){return!!this.h}j(){if(!this.h)return;const e=this.h.tick(),a=this.g.withScrollPosition(e);if(this.k(a,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.j())})}}k(e,a){const n=this.g;n.equals(e)||(this.g=e,this.i.fire(this.g.createScrollEvent(n,a)))}}t.Scrollable=D;class y{constructor(e,a,n){this.scrollLeft=e,this.scrollTop=a,this.isDone=n}}t.SmoothScrollingUpdate=y;function h(u,e){const a=e-u;return function(n){return u+a*r(n)}}function l(u,e,a){return function(n){return n<a?u(n/a):e((n-a)/(1-a))}}class d{constructor(e,a,n,c){this.from=e,this.to=a,this.duration=c,this.startTime=n,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,a,n){if(Math.abs(e-a)>2.5*n){let s,w;return e<a?(s=e+.75*n,w=a-.75*n):(s=e-.75*n,w=a+.75*n),l(h(e,s),h(w,a),.33)}return h(e,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const a=(e-this.startTime)/this.duration;if(a<1){const n=this.c(a),c=this.d(a);return new y(n,c,!1)}return new y(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,a,n){return d.start(e,a,n)}static start(e,a,n){n=n+10;const c=Date.now()-10;return new d(e,a,c,n)}}t.SmoothScrollingOperation=d;function N(u){return Math.pow(u,3)}function r(u){return 1-N(1-u)}}),define(ge[11],me([1,0,109,30]),function(te,t,E,L){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function W(X){return!X||typeof X!="string"?!0:X.trim().length===0}t.isFalsyOrWhitespace=W;const D=/{(\d+)}/g;function y(X,...le){return le.length===0?X:X.replace(D,function(be,De){const Ae=parseInt(De,10);return isNaN(Ae)||Ae<0||Ae>=le.length?be:le[Ae]})}t.format=y;const h=/{([^}]+)}/g;function l(X,le){return X.replace(h,(be,De)=>le[De]??be)}t.format2=l;function d(X){return X.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}t.escape=d;function N(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=N;function r(X,le){let be=0;const De=le.charCodeAt(0);for(let Ae=X.length-1;Ae>=0;Ae--)X.charCodeAt(Ae)===De&&be++;return be}t.count=r;function u(X,le,be="\u2026"){return X.length<=le?X:`${X.substr(0,le)}${be}`}t.truncate=u;function e(X,le=" "){const be=a(X,le);return n(be,le)}t.trim=e;function a(X,le){if(!X||!le)return X;const be=le.length;if(be===0||X.length===0)return X;let De=0;for(;X.indexOf(le,De)===De;)De=De+be;return X.substring(De)}t.ltrim=a;function n(X,le){if(!X||!le)return X;const be=le.length,De=X.length;if(be===0||De===0)return X;let Ae=De,Re=-1;for(;Re=X.lastIndexOf(le,Ae-1),!(Re===-1||Re+be!==Ae);){if(Re===0)return"";Ae=Re}return X.substring(0,Ae)}t.rtrim=n;function c(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=c;function s(X){return X.replace(/\*/g,"")}t.stripWildcards=s;function w(X,le,be={}){if(!X)throw new Error("Cannot create regex from empty string");le||(X=N(X)),be.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let De="";return be.global&&(De+="g"),be.matchCase||(De+="i"),be.multiline&&(De+="m"),be.unicode&&(De+="u"),new RegExp(X,De)}t.createRegExp=w;function v(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}t.regExpLeadsToEndlessLoop=v;function F(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=F;function f(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}t.regExpFlags=f;function b(X){return X.split(/\r\n|\r|\n/)}t.splitLines=b;function B(X){for(let le=0,be=X.length;le<be;le++){const De=X.charCodeAt(le);if(De!==32&&De!==9)return le}return-1}t.firstNonWhitespaceIndex=B;function M(X,le=0,be=X.length){for(let De=le;De<be;De++){const Ae=X.charCodeAt(De);if(Ae!==32&&Ae!==9)return X.substring(le,De)}return X.substring(le,be)}t.getLeadingWhitespace=M;function m(X,le=X.length-1){for(let be=le;be>=0;be--){const De=X.charCodeAt(be);if(De!==32&&De!==9)return be}return-1}t.lastNonWhitespaceIndex=m;function g(X,le,be){const De=[];let Ae=0;for(const Re of X.matchAll(le)){if(De.push(X.slice(Ae,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Ae=Re.index+Re[0].length,De.push(be(Re[0],...Re.slice(1),Re.index,X,Re.groups))}return De.push(X.slice(Ae)),Promise.all(De).then(Re=>Re.join(""))}t.replaceAsync=g;function p(X,le){return X<le?-1:X>le?1:0}t.compare=p;function I(X,le,be=0,De=X.length,Ae=0,Re=le.length){for(;be<De&&Ae<Re;be++,Ae++){const et=X.charCodeAt(be),Fe=le.charCodeAt(Ae);if(et<Fe)return-1;if(et>Fe)return 1}const $e=De-be,Ge=Re-Ae;return $e<Ge?-1:$e>Ge?1:0}t.compareSubstring=I;function O(X,le){return U(X,le,0,X.length,0,le.length)}t.compareIgnoreCase=O;function U(X,le,be=0,De=X.length,Ae=0,Re=le.length){for(;be<De&&Ae<Re;be++,Ae++){let et=X.charCodeAt(be),Fe=le.charCodeAt(Ae);if(et===Fe)continue;if(et>=128||Fe>=128)return I(X.toLowerCase(),le.toLowerCase(),be,De,Ae,Re);ne(et)&&(et-=32),ne(Fe)&&(Fe-=32);const he=et-Fe;if(he!==0)return he}const $e=De-be,Ge=Re-Ae;return $e<Ge?-1:$e>Ge?1:0}t.compareSubstringIgnoreCase=U;function Z(X){return X>=48&&X<=57}t.isAsciiDigit=Z;function ne(X){return X>=97&&X<=122}t.isLowerAsciiLetter=ne;function se(X){return X>=65&&X<=90}t.isUpperAsciiLetter=se;function ce(X,le){return X.length===le.length&&U(X,le)===0}t.equalsIgnoreCase=ce;function ue(X,le){const be=le.length;return le.length>X.length?!1:U(X,le,0,be)===0}t.startsWithIgnoreCase=ue;function ae(X,le){const be=Math.min(X.length,le.length);let De;for(De=0;De<be;De++)if(X.charCodeAt(De)!==le.charCodeAt(De))return De;return be}t.commonPrefixLength=ae;function oe(X,le){const be=Math.min(X.length,le.length);let De;const Ae=X.length-1,Re=le.length-1;for(De=0;De<be;De++)if(X.charCodeAt(Ae-De)!==le.charCodeAt(Re-De))return De;return be}t.commonSuffixLength=oe;function ye(X){return 55296<=X&&X<=56319}t.isHighSurrogate=ye;function ke(X){return 56320<=X&&X<=57343}t.isLowSurrogate=ke;function Be(X,le){return(X-55296<<10)+(le-56320)+65536}t.computeCodePoint=Be;function Me(X,le,be){const De=X.charCodeAt(be);if(ye(De)&&be+1<le){const Ae=X.charCodeAt(be+1);if(ke(Ae))return Be(De,Ae)}return De}t.getNextCodePoint=Me;function fe(X,le){const be=X.charCodeAt(le-1);if(ke(be)&&le>1){const De=X.charCodeAt(le-2);if(ye(De))return Be(De,be)}return be}class ${get offset(){return this.e}constructor(le,be=0){this.c=le,this.d=le.length,this.e=be}setOffset(le){this.e=le}prevCodePoint(){const le=fe(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=Me(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}t.CodePointIterator=$;class ie{get offset(){return this.c.offset}constructor(le,be=0){this.c=new $(le,be)}nextGraphemeLength(){const le=Le.getInstance(),be=this.c,De=be.offset;let Ae=le.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Re=be.offset,$e=le.getGraphemeBreakType(be.nextCodePoint());if(ve(Ae,$e)){be.setOffset(Re);break}Ae=$e}return be.offset-De}prevGraphemeLength(){const le=Le.getInstance(),be=this.c,De=be.offset;let Ae=le.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Re=be.offset,$e=le.getGraphemeBreakType(be.prevCodePoint());if(ve($e,Ae)){be.setOffset(Re);break}Ae=$e}return De-be.offset}eol(){return this.c.eol()}}t.GraphemeIterator=ie;function q(X,le){return new ie(X,le).nextGraphemeLength()}t.nextCharLength=q;function V(X,le){return new ie(X,le).prevGraphemeLength()}t.prevCharLength=V;function A(X,le){le>0&&ke(X.charCodeAt(le))&&le--;const be=le+q(X,le);return[be-V(X,be),be]}t.getCharContainingOffset=A;function K(X){const le=new ie(X);let be=0;for(;!le.eol();)be++,le.nextGraphemeLength();return be}t.charCount=K;let x;function o(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function k(X){return x||(x=o()),x.test(X)}t.containsRTL=k;const _=/^[\t\n\r\x20-\x7E]*$/;function Y(X){return _.test(X)}t.isBasicASCII=Y,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function C(X){return t.UNUSUAL_LINE_TERMINATORS.test(X)}t.containsUnusualLineTerminators=C;function T(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}t.isFullWidthCharacter=T;function R(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}t.isEmojiImprecise=R;function S(X,le){if(X.length<le)return X;const be=/\b/g;let De=0;for(;be.test(X)&&!(X.length-be.lastIndex<le);)De=be.lastIndex,be.lastIndex+=1;return X.substring(De).replace(/^\s/,"")}t.lcut=S;const z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,H=/\x1b\].*?\x07/g;function P(X){return X&&(X=X.replace(z,"").replace(H,"")),X}t.removeAnsiEscapeCodes=P,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function j(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}t.startsWithUTF8BOM=j;function G(X){return j(X)?X.substr(1):X}t.stripUTF8BOM=G;function ee(X,le){if(!X||!le||X.length<le.length)return!1;const be=le.length,De=X.toLowerCase();let Ae=0,Re=-1;for(;Ae<be;){const $e=De.indexOf(le[Ae],Re+1);if($e<0)return!1;Re=$e,Ae++}return!0}t.fuzzyContains=ee;function re(X,le=!1){return X?(le&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}t.containsUppercaseCharacter=re;function pe(X){return X.charAt(0).toUpperCase()+X.slice(1)}t.uppercaseFirstLetter=pe;function we(X,le=1){if(le===0)return"";let be=-1;do be=X.indexOf(`
`,be+1),le--;while(le>0&&be>=0);return be===-1?X:(X[be-1]==="\r"&&be--,X.substr(0,be))}t.getNLines=we;function Ne(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}t.singleLetterHash=Ne;function Se(X){return Le.getInstance().getGraphemeBreakType(X)}t.getGraphemeBreakType=Se;function ve(X,le){return X===0?le!==5&&le!==7:X===2&&le===3?!1:X===4||X===2||X===3||le===4||le===2||le===3?!0:!(X===8&&(le===8||le===9||le===11||le===12)||(X===11||X===9)&&(le===9||le===10)||(X===12||X===10)&&le===10||le===5||le===13||le===7||X===1||X===13&&le===14||X===6&&le===6)}var Pe;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(t.GraphemeBreakType=Pe={}));class Le{static getInstance(){return Le.c||(Le.c=new Le),Le.c}constructor(){this.d=Ve()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const be=this.d,De=be.length/3;let Ae=1;for(;Ae<=De;)if(le<be[3*Ae])Ae=2*Ae;else if(le>be[3*Ae+1])Ae=2*Ae+1;else return be[3*Ae+2];return 0}}Le.c=null;function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(X,le){if(X===0)return 0;const be=We(X,le);if(be!==void 0)return be;const De=new $(le,X);return De.prevCodePoint(),De.offset}t.getLeftDeleteOffset=ze;function We(X,le){const be=new $(le,X);let De=be.prevCodePoint();for(;Je(De)||De===65039||De===8419;){if(be.offset===0)return;De=be.prevCodePoint()}if(!R(De))return;let Ae=be.offset;return Ae>0&&be.prevCodePoint()===8205&&(Ae=be.offset),Ae}function Je(X){return 127995<=X&&X<=127999}var it;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),t.noBreakWhitespace="\xA0";class Oe{static getInstance(le){return Oe.d.get(Array.from(le))}static getLocales(){return Oe.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.AmbiguousCharacters=Oe,i=Oe,Oe.c=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.d=new E.LRUCachedFunction(X=>{function le(Fe){const he=new Map;for(let Ee=0;Ee<Fe.length;Ee+=2)he.set(Fe[Ee],Fe[Ee+1]);return he}function be(Fe,he){const Ee=new Map(Fe);for(const[Ie,Ue]of he)Ee.set(Ie,Ue);return Ee}function De(Fe,he){if(!Fe)return he;const Ee=new Map;for(const[Ie,Ue]of Fe)he.has(Ie)&&Ee.set(Ie,Ue);return Ee}const Ae=i.c.value;let Re=X.filter(Fe=>!Fe.startsWith("_")&&Fe in Ae);Re.length===0&&(Re=["_default"]);let $e;for(const Fe of Re){const he=le(Ae[Fe]);$e=De($e,he)}const Ge=le(Ae._common),et=be(Ge,$e);return new Oe(et)}),Oe.e=new L.Lazy(()=>Object.keys(Oe.c.value).filter(X=>!X.startsWith("_")));class je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(je.c())),this.d}static isInvisibleCharacter(le){return je.e().has(le)}static get codePoints(){return je.e()}}t.InvisibleCharacters=je,je.d=void 0}),define(ge[110],me([1,0,22,5,11,6]),function(te,t,E,L,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function D(g){return g===47||g===92}t.isPathSeparator=D;function y(g){return g.replace(/[\\/]/g,E.posix.sep)}t.toSlashes=y;function h(g){return g.indexOf("/")===-1&&(g=y(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}t.toPosixPath=h;function l(g,p=E.posix.sep){if(!g)return"";const I=g.length,O=g.charCodeAt(0);if(D(O)){if(D(g.charCodeAt(1))&&!D(g.charCodeAt(2))){let Z=3;const ne=Z;for(;Z<I&&!D(g.charCodeAt(Z));Z++);if(ne!==Z&&!D(g.charCodeAt(Z+1))){for(Z+=1;Z<I;Z++)if(D(g.charCodeAt(Z)))return g.slice(0,Z+1).replace(/[\\/]/g,p)}}return p}else if(c(O)&&g.charCodeAt(1)===58)return D(g.charCodeAt(2))?g.slice(0,2)+p:g.slice(0,2);let U=g.indexOf("://");if(U!==-1){for(U+=3;U<I;U++)if(D(g.charCodeAt(U)))return g.slice(0,U+1)}return""}t.getRoot=l;function d(g){if(!L.isWindows||!g||g.length<5)return!1;let p=g.charCodeAt(0);if(p!==92||(p=g.charCodeAt(1),p!==92))return!1;let I=2;const O=I;for(;I<g.length&&(p=g.charCodeAt(I),p!==92);I++);return!(O===I||(p=g.charCodeAt(I+1),isNaN(p)||p===92))}t.isUNC=d;const N=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(g,p=L.isWindows){const I=p?N:r;return!(!g||g.length===0||/^\s+$/.test(g)||(I.lastIndex=0,I.test(g))||p&&u.test(g)||g==="."||g===".."||p&&g[g.length-1]==="."||p&&g.length!==g.trim().length||g.length>255)}t.isValidBasename=e;function a(g,p,I){const O=g===p;return!I||O?O:!g||!p?!1:(0,i.equalsIgnoreCase)(g,p)}t.isEqual=a;function n(g,p,I,O=E.sep){if(g===p)return!0;if(!g||!p||p.length>g.length)return!1;if(I){if(!(0,i.startsWithIgnoreCase)(g,p))return!1;if(p.length===g.length)return!0;let Z=p.length;return p.charAt(p.length-1)===O&&Z--,g.charAt(Z)===O}return p.charAt(p.length-1)!==O&&(p+=O),g.indexOf(p)===0}t.isEqualOrParent=n;function c(g){return g>=65&&g<=90||g>=97&&g<=122}t.isWindowsDriveLetter=c;function s(g,p){return L.isWindows&&g.endsWith(":")&&(g+=E.sep),(0,E.isAbsolute)(g)||(g=(0,E.join)(p,g)),g=(0,E.normalize)(g),L.isWindows?(g=(0,i.rtrim)(g,E.sep),g.endsWith(":")&&(g+=E.sep)):(g=(0,i.rtrim)(g,E.sep),g||(g=E.sep)),g}t.sanitizeFilePath=s;function w(g){const p=(0,E.normalize)(g);return L.isWindows?g.length>3?!1:v(p)&&(g.length===2||p.charCodeAt(2)===92):p===E.posix.sep}t.isRootOrDriveLetter=w;function v(g,p=L.isWindows){return p?c(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}t.hasDriveLetter=v;function F(g,p=L.isWindows){return v(g,p)?g[0]:void 0}t.getDriveLetter=F;function f(g,p,I){return p.length>g.length?-1:g===p?0:(I&&(g=g.toLowerCase(),p=p.toLowerCase()),g.indexOf(p))}t.indexOfPath=f;function b(g){const p=g.split(":");let I,O,U;for(const Z of p){const ne=Number(Z);(0,W.isNumber)(ne)?O===void 0?O=ne:U===void 0&&(U=ne):I=I?[I,Z].join(":"):Z}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:O!==void 0?O:void 0,column:U!==void 0?U:O!==void 0?1:void 0}}t.parseLineAndColumnAware=b;const B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",M="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(g,p,I=8){let O="";for(let Z=0;Z<I;Z++){let ne;Z===0&&L.isWindows&&!p&&(I===3||I===4)?ne=M:ne=B,O+=ne.charAt(Math.floor(Math.random()*ne.length))}let U;return p?U=`${p}-${O}`:U=O,g?(0,E.join)(g,U):U}t.randomPath=m}),define(ge[33],me([1,0,75,11]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function i(...H){return function(P,j){for(let G=0,ee=H.length;G<ee;G++){const re=H[G](P,j);if(re)return re}return null}}t.or=i,t.matchesStrictPrefix=W.bind(void 0,!1),t.matchesPrefix=W.bind(void 0,!0);function W(H,P,j){if(!j||j.length<P.length)return null;let G;return H?G=L.startsWithIgnoreCase(j,P):G=j.indexOf(P)===0,G?P.length>0?[{start:0,end:P.length}]:[]:null}function D(H,P){const j=P.toLowerCase().indexOf(H.toLowerCase());return j===-1?null:[{start:j,end:j+H.length}]}t.matchesContiguousSubString=D;function y(H,P){return h(H.toLowerCase(),P.toLowerCase(),0,0)}t.matchesSubString=y;function h(H,P,j,G){if(j===H.length)return[];if(G===P.length)return null;if(H[j]===P[G]){let ee=null;return(ee=h(H,P,j+1,G+1))?c({start:G,end:G+1},ee):null}return h(H,P,j,G+1)}function l(H){return 97<=H&&H<=122}function d(H){return 65<=H&&H<=90}t.isUpper=d;function N(H){return 48<=H&&H<=57}function r(H){return H===32||H===9||H===10||H===13}const u=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(H=>u.add(H.charCodeAt(0)));function e(H){return r(H)||u.has(H)}function a(H,P){return H===P||e(H)&&e(P)}function n(H){return l(H)||d(H)||N(H)}function c(H,P){return P.length===0?P=[H]:H.end===P[0].start?P[0].start=H.start:P.unshift(H),P}function s(H,P){for(let j=P;j<H.length;j++){const G=H.charCodeAt(j);if(d(G)||N(G)||j>0&&!n(H.charCodeAt(j-1)))return j}return H.length}function w(H,P,j,G){if(j===H.length)return[];if(G===P.length)return null;if(H[j]!==P[G].toLowerCase())return null;{let ee=null,re=G+1;for(ee=w(H,P,j+1,G+1);!ee&&(re=s(P,re))<P.length;)ee=w(H,P,j+1,re),re++;return ee===null?null:c({start:G,end:G+1},ee)}}function v(H){let P=0,j=0,G=0,ee=0,re=0;for(let ve=0;ve<H.length;ve++)re=H.charCodeAt(ve),d(re)&&P++,l(re)&&j++,n(re)&&G++,N(re)&&ee++;const pe=P/H.length,we=j/H.length,Ne=G/H.length,Se=ee/H.length;return{upperPercent:pe,lowerPercent:we,alphaPercent:Ne,numericPercent:Se}}function F(H){const{upperPercent:P,lowerPercent:j}=H;return j===0&&P>.6}function f(H){const{upperPercent:P,lowerPercent:j,alphaPercent:G,numericPercent:ee}=H;return j>.2&&P<.8&&G>.6&&ee<.2}function b(H){let P=0,j=0,G=0,ee=0;for(let re=0;re<H.length;re++)G=H.charCodeAt(re),d(G)&&P++,l(G)&&j++,r(G)&&ee++;return(P===0||j===0)&&ee===0?H.length<=30:P<=5}function B(H,P){if(!P||(P=P.trim(),P.length===0)||!b(H)||P.length>60)return null;const j=v(P);if(!f(j)){if(!F(j))return null;P=P.toLowerCase()}let G=null,ee=0;for(H=H.toLowerCase();ee<P.length&&(G=w(H,P,0,ee))===null;)ee=s(P,ee+1);return G}t.matchesCamelCase=B;function M(H,P,j=!1){if(!P||P.length===0)return null;let G=null,ee=0;for(H=H.toLowerCase(),P=P.toLowerCase();ee<P.length&&(G=m(H,P,0,ee,j))===null;)ee=g(P,ee+1);return G}t.matchesWords=M;function m(H,P,j,G,ee){if(j===H.length)return[];if(G===P.length)return null;if(a(H.charCodeAt(j),P.charCodeAt(G))){let re=null,pe=G+1;if(re=m(H,P,j+1,G+1,ee),!ee)for(;!re&&(pe=g(P,pe))<P.length;)re=m(H,P,j+1,pe,ee),pe++;return re?H.charCodeAt(j)!==P.charCodeAt(G)?re:c({start:G,end:G+1},re):null}else return null}function g(H,P){for(let j=P;j<H.length;j++)if(e(H.charCodeAt(j))||j>0&&e(H.charCodeAt(j-1)))return j;return H.length}const p=i(t.matchesPrefix,B,D),I=i(t.matchesPrefix,B,y),O=new E.LRUCache(1e4);function U(H,P,j=!1){if(typeof H!="string"||typeof P!="string")return null;let G=O.get(H);G||(G=new RegExp(L.convertSimple2RegExpPattern(H),"i"),O.set(H,G));const ee=G.exec(P);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:j?I(H,P):p(H,P)}t.matchesFuzzy=U;function Z(H,P){const j=_(H,H.toLowerCase(),0,P,P.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?se(j):null}t.matchesFuzzy2=Z;function ne(H,P,j,G,ee,re){const pe=Math.min(13,H.length);for(;j<pe;j++){const we=_(H,P,j,G,ee,re,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,re]}t.anyScore=ne;function se(H){if(typeof H>"u")return[];const P=[],j=H[1];for(let G=H.length-1;G>1;G--){const ee=H[G]+j,re=P[P.length-1];re&&re.end===ee?re.end=ee+1:P.push({start:ee,end:ee+1})}return P}t.createMatches=se;const ce=128;function ue(){const H=[],P=[];for(let j=0;j<=ce;j++)P[j]=0;for(let j=0;j<=ce;j++)H.push(P.slice(0));return H}function ae(H){const P=[];for(let j=0;j<=H;j++)P[j]=0;return P}const oe=ae(2*ce),ye=ae(2*ce),ke=ue(),Be=ue(),Me=ue(),fe=!1;function $(H,P,j,G,ee){function re(we,Ne,Se=" "){for(;we.length<Ne;)we=Se+we;return we}let pe=` |   |${G.split("").map(we=>re(we,3)).join("|")}
`;for(let we=0;we<=j;we++)we===0?pe+=" |":pe+=`${P[we-1]}|`,pe+=H[we].slice(0,ee+1).map(Ne=>re(Ne.toString(),3)).join("|")+`
`;return pe}function ie(H,P,j,G){H=H.substr(P),j=j.substr(G),console.log($(Be,H,H.length,j,j.length)),console.log($(Me,H,H.length,j,j.length)),console.log($(ke,H,H.length,j,j.length))}function q(H,P){if(P<0||P>=H.length)return!1;const j=H.codePointAt(P);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(j)}}function V(H,P){if(P<0||P>=H.length)return!1;switch(H.charCodeAt(P)){case 32:case 9:return!0;default:return!1}}function A(H,P,j){return P[H]!==j[H]}function K(H,P,j,G,ee,re,pe=!1){for(;P<j&&ee<re;)H[P]===G[ee]&&(pe&&(oe[P]=ee),P+=1),ee+=1;return P===j}t.isPatternInWord=K;var x;(function(H){H[H.Diag=1]="Diag",H[H.Left=2]="Left",H[H.LeftLeft=3]="LeftLeft"})(x||(x={}));var o;(function(H){H.Default=[-100,0];function P(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}H.isDefault=P})(o||(t.FuzzyScore=o={}));class k{constructor(P,j){this.firstMatchCanBeWeak=P,this.boostFullMatch=j}}t.FuzzyScoreOptions=k,k.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function _(H,P,j,G,ee,re,pe=k.default){const we=H.length>ce?ce:H.length,Ne=G.length>ce?ce:G.length;if(j>=we||re>=Ne||we-j>Ne-re||!K(P,j,we,ee,re,Ne,!0))return;Y(we,Ne,j,re,P,ee);let Se=1,ve=1,Pe=j,Le=re;const Ve=[!1];for(Se=1,Pe=j;Pe<we;Se++,Pe++){const Oe=oe[Pe],je=ye[Pe],X=Pe+1<we?ye[Pe+1]:Ne;for(ve=Oe-re+1,Le=Oe;Le<X;ve++,Le++){let le=Number.MIN_SAFE_INTEGER,be=!1;Le<=je&&(le=C(H,P,Pe,j,G,ee,Le,Ne,re,ke[Se-1][ve-1]===0,Ve));let De=0;le!==Number.MAX_SAFE_INTEGER&&(be=!0,De=le+Be[Se-1][ve-1]);const Ae=Le>Oe,Re=Ae?Be[Se][ve-1]+(ke[Se][ve-1]>0?-5:0):0,$e=Le>Oe+1&&ke[Se][ve-1]>0,Ge=$e?Be[Se][ve-2]+(ke[Se][ve-2]>0?-5:0):0;if($e&&(!Ae||Ge>=Re)&&(!be||Ge>=De))Be[Se][ve]=Ge,Me[Se][ve]=3,ke[Se][ve]=0;else if(Ae&&(!be||Re>=De))Be[Se][ve]=Re,Me[Se][ve]=2,ke[Se][ve]=0;else if(be)Be[Se][ve]=De,Me[Se][ve]=1,ke[Se][ve]=ke[Se-1][ve-1]+1;else throw new Error("not possible")}}if(fe&&ie(H,j,G,re),!Ve[0]&&!pe.firstMatchCanBeWeak)return;Se--,ve--;const ze=[Be[Se][ve],re];let We=0,Je=0;for(;Se>=1;){let Oe=ve;do{const je=Me[Se][Oe];if(je===3)Oe=Oe-2;else if(je===2)Oe=Oe-1;else break}while(Oe>=1);We>1&&P[j+Se-1]===ee[re+ve-1]&&!A(Oe+re-1,G,ee)&&We+1>ke[Se][Oe]&&(Oe=ve),Oe===ve?We++:We=1,Je||(Je=Oe),Se--,ve=Oe-1,ze.push(ve)}Ne===we&&pe.boostFullMatch&&(ze[0]+=2);const it=Je-we;return ze[0]-=it,ze}t.fuzzyScore=_;function Y(H,P,j,G,ee,re){let pe=H-1,we=P-1;for(;pe>=j&&we>=G;)ee[pe]===re[we]&&(ye[pe]=we,pe--),we--}function C(H,P,j,G,ee,re,pe,we,Ne,Se,ve){if(P[j]!==re[pe])return Number.MIN_SAFE_INTEGER;let Pe=1,Le=!1;return pe===j-G?Pe=H[j]===ee[pe]?7:5:A(pe,ee,re)&&(pe===0||!A(pe-1,ee,re))?(Pe=H[j]===ee[pe]?7:5,Le=!0):q(re,pe)&&(pe===0||!q(re,pe-1))?Pe=5:(q(re,pe-1)||V(re,pe-1))&&(Pe=5,Le=!0),Pe>1&&j===G&&(ve[0]=!0),Le||(Le=A(pe,ee,re)||q(re,pe-1)||V(re,pe-1)),j===G?pe>Ne&&(Pe-=Le?3:5):Se?Pe+=Le?2:0:Pe+=Le?0:1,pe+1===we&&(Pe-=Le?3:5),Pe}function T(H,P,j,G,ee,re,pe){return S(H,P,j,G,ee,re,!0,pe)}t.fuzzyScoreGracefulAggressive=T;function R(H,P,j,G,ee,re,pe){return S(H,P,j,G,ee,re,!1,pe)}t.fuzzyScoreGraceful=R;function S(H,P,j,G,ee,re,pe,we){let Ne=_(H,P,j,G,ee,re,we);if(Ne&&!pe)return Ne;if(H.length>=3){const Se=Math.min(7,H.length-1);for(let ve=j+1;ve<Se;ve++){const Pe=z(H,ve);if(Pe){const Le=_(Pe,Pe.toLowerCase(),j,G,ee,re,we);Le&&(Le[0]-=3,(!Ne||Le[0]>Ne[0])&&(Ne=Le))}}}return Ne}function z(H,P){if(P+1>=H.length)return;const j=H[P],G=H[P+1];if(j!==G)return H.slice(0,P)+G+j+H.slice(P+2)}}),define(ge[111],me([1,0,11]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function L(c){return i(c,0)}t.hash=L;function i(c,s){switch(typeof c){case"object":return c===null?W(349,s):Array.isArray(c)?h(c,s):l(c,s);case"string":return y(c,s);case"boolean":return D(c,s);case"number":return W(c,s);case"undefined":return W(937,s);default:return W(617,s)}}t.doHash=i;function W(c,s){return(s<<5)-s+c|0}t.numberHash=W;function D(c,s){return W(c?433:863,s)}function y(c,s){s=W(149417,s);for(let w=0,v=c.length;w<v;w++)s=W(c.charCodeAt(w),s);return s}t.stringHash=y;function h(c,s){return s=W(104579,s),c.reduce((w,v)=>i(v,w),s)}function l(c,s){return s=W(181387,s),Object.keys(c).sort().reduce((w,v)=>(w=y(v,w),i(c[v],w)),s)}class d{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=i(s,this.g),this.g}}t.Hasher=d;var N;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(N||(N={}));function r(c,s,w=32){const v=w-s,F=~((1<<v)-1);return(c<<s|(F&c)>>>v)>>>0}function u(c,s=0,w=c.byteLength,v=0){for(let F=0;F<w;F++)c[s+F]=v}function e(c,s,w="0"){for(;c.length<s;)c=w+c;return c}function a(c,s=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(w=>w.toString(16).padStart(2,"0")).join(""):e((c>>>0).toString(16),s/4)}t.toHexString=a;class n{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const w=s.length;if(w===0)return;const v=this.p;let F=this.r,f=this.u,b,B;for(f!==0?(b=f,B=-1,f=0):(b=s.charCodeAt(0),B=0);;){let M=b;if(E.isHighSurrogate(b))if(B+1<w){const m=s.charCodeAt(B+1);E.isLowSurrogate(m)?(B++,M=E.computeCodePoint(b,m)):M=65533}else{f=b;break}else E.isLowSurrogate(b)&&(M=65533);if(F=this.w(v,F,M),B++,B<w)b=s.charCodeAt(B);else break}this.r=F,this.u=f}w(s,w,v){return v<128?s[w++]=v:v<2048?(s[w++]=192|(v&1984)>>>6,s[w++]=128|(v&63)>>>0):v<65536?(s[w++]=224|(v&61440)>>>12,s[w++]=128|(v&4032)>>>6,s[w++]=128|(v&63)>>>0):(s[w++]=240|(v&1835008)>>>18,s[w++]=128|(v&258048)>>>12,s[w++]=128|(v&4032)>>>6,s[w++]=128|(v&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,s[0]=s[64+0],s[1]=s[64+1],s[2]=s[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=n.g,w=this.q;for(let p=0;p<64;p+=4)s.setUint32(p,w.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)s.setUint32(p,r(s.getUint32(p-12,!1)^s.getUint32(p-32,!1)^s.getUint32(p-56,!1)^s.getUint32(p-64,!1),1),!1);let v=this.h,F=this.l,f=this.m,b=this.n,B=this.o,M,m,g;for(let p=0;p<80;p++)p<20?(M=F&f|~F&b,m=1518500249):p<40?(M=F^f^b,m=1859775393):p<60?(M=F&f|F&b|f&b,m=2400959708):(M=F^f^b,m=3395469782),g=r(v,5)+M+B+m+s.getUint32(p*4,!1)&4294967295,B=b,b=f,f=r(F,30),F=v,v=g;this.h=this.h+v&4294967295,this.l=this.l+F&4294967295,this.m=this.m+f&4294967295,this.n=this.n+b&4294967295,this.o=this.o+B&4294967295}}t.StringSHA1=n,n.g=new DataView(new ArrayBuffer(320))}),define(ge[112],me([1,0,71,111]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(r){this.a=r}getElements(){const r=this.a,u=new Int32Array(r.length);for(let e=0,a=r.length;e<a;e++)u[e]=r.charCodeAt(e);return u}}t.StringDiffSequence=i;function W(N,r,u){return new d(new i(N),new i(r)).ComputeDiff(u).changes}t.stringDiff=W;class D{static Assert(r,u){if(!r)throw new Error(u)}}class y{static Copy(r,u,e,a,n){for(let c=0;c<n;c++)e[a+c]=r[u+c]}static Copy2(r,u,e,a,n){for(let c=0;c<n;c++)e[a+c]=r[u+c]}}var h;(function(N){N[N.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(h||(h={}));class l{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new E.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(r,u){this.b=Math.min(this.b,r),this.c=Math.min(this.c,u),this.d++}AddModifiedElement(r,u){this.b=Math.min(this.b,r),this.c=Math.min(this.c,u),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class d{constructor(r,u,e=null){this.a=e,this.b=r,this.c=u;const[a,n,c]=d.o(r),[s,w,v]=d.o(u);this.d=c&&v,this.e=a,this.f=n,this.g=s,this.h=w,this.k=[],this.m=[]}static n(r){return r.length>0&&typeof r[0]=="string"}static o(r){const u=r.getElements();if(d.n(u)){const e=new Int32Array(u.length);for(let a=0,n=u.length;a<n;a++)e[a]=(0,L.stringHash)(u[a],0);return[u,e,!0]}return u instanceof Int32Array?[[],u,!1]:[[],new Int32Array(u),!1]}p(r,u){return this.f[r]!==this.h[u]?!1:this.d?this.e[r]===this.g[u]:!0}q(r,u){if(!this.p(r,u))return!1;const e=d.r(this.b,r),a=d.r(this.c,u);return e===a}static r(r,u){return typeof r.getStrictElement=="function"?r.getStrictElement(u):null}s(r,u){return this.f[r]!==this.f[u]?!1:this.d?this.e[r]===this.e[u]:!0}u(r,u){return this.h[r]!==this.h[u]?!1:this.d?this.g[r]===this.g[u]:!0}ComputeDiff(r){return this.v(0,this.f.length-1,0,this.h.length-1,r)}v(r,u,e,a,n){const c=[!1];let s=this.w(r,u,e,a,c);return n&&(s=this.z(s)),{quitEarly:c[0],changes:s}}w(r,u,e,a,n){for(n[0]=!1;r<=u&&e<=a&&this.p(r,e);)r++,e++;for(;u>=r&&a>=e&&this.p(u,a);)u--,a--;if(r>u||e>a){let f;return e<=a?(D.Assert(r===u+1,"originalStart should only be one more than originalEnd"),f=[new E.DiffChange(r,0,e,a-e+1)]):r<=u?(D.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),f=[new E.DiffChange(r,u-r+1,e,0)]):(D.Assert(r===u+1,"originalStart should only be one more than originalEnd"),D.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const c=[0],s=[0],w=this.y(r,u,e,a,c,s,n),v=c[0],F=s[0];if(w!==null)return w;if(!n[0]){const f=this.w(r,v,e,F,n);let b=[];return n[0]?b=[new E.DiffChange(v+1,u-(v+1)+1,F+1,a-(F+1)+1)]:b=this.w(v+1,u,F+1,a,n),this.H(f,b)}return[new E.DiffChange(r,u-r+1,e,a-e+1)]}x(r,u,e,a,n,c,s,w,v,F,f,b,B,M,m,g,p,I){let O=null,U=null,Z=new l,ne=u,se=e,ce=B[0]-g[0]-a,ue=-1073741824,ae=this.k.length-1;do{const oe=ce+r;oe===ne||oe<se&&v[oe-1]<v[oe+1]?(f=v[oe+1],M=f-ce-a,f<ue&&Z.MarkNextChange(),ue=f,Z.AddModifiedElement(f+1,M),ce=oe+1-r):(f=v[oe-1]+1,M=f-ce-a,f<ue&&Z.MarkNextChange(),ue=f-1,Z.AddOriginalElement(f,M+1),ce=oe-1-r),ae>=0&&(v=this.k[ae],r=v[0],ne=1,se=v.length-1)}while(--ae>=-1);if(O=Z.getReverseChanges(),I[0]){let oe=B[0]+1,ye=g[0]+1;if(O!==null&&O.length>0){const ke=O[O.length-1];oe=Math.max(oe,ke.getOriginalEnd()),ye=Math.max(ye,ke.getModifiedEnd())}U=[new E.DiffChange(oe,b-oe+1,ye,m-ye+1)]}else{Z=new l,ne=c,se=s,ce=B[0]-g[0]-w,ue=1073741824,ae=p?this.m.length-1:this.m.length-2;do{const oe=ce+n;oe===ne||oe<se&&F[oe-1]>=F[oe+1]?(f=F[oe+1]-1,M=f-ce-w,f>ue&&Z.MarkNextChange(),ue=f+1,Z.AddOriginalElement(f+1,M+1),ce=oe+1-n):(f=F[oe-1],M=f-ce-w,f>ue&&Z.MarkNextChange(),ue=f,Z.AddModifiedElement(f+1,M+1),ce=oe-1-n),ae>=0&&(F=this.m[ae],n=F[0],ne=1,se=F.length-1)}while(--ae>=-1);U=Z.getChanges()}return this.H(O,U)}y(r,u,e,a,n,c,s){let w=0,v=0,F=0,f=0,b=0,B=0;r--,e--,n[0]=0,c[0]=0,this.k=[],this.m=[];const M=u-r+(a-e),m=M+1,g=new Int32Array(m),p=new Int32Array(m),I=a-e,O=u-r,U=r-e,Z=u-a,se=(O-I)%2===0;g[I]=r,p[O]=u,s[0]=!1;for(let ce=1;ce<=M/2+1;ce++){let ue=0,ae=0;F=this.J(I-ce,ce,I,m),f=this.J(I+ce,ce,I,m);for(let ye=F;ye<=f;ye+=2){ye===F||ye<f&&g[ye-1]<g[ye+1]?w=g[ye+1]:w=g[ye-1]+1,v=w-(ye-I)-U;const ke=w;for(;w<u&&v<a&&this.p(w+1,v+1);)w++,v++;if(g[ye]=w,w+v>ue+ae&&(ue=w,ae=v),!se&&Math.abs(ye-O)<=ce-1&&w>=p[ye])return n[0]=w,c[0]=v,ke<=p[ye]&&1447>0&&ce<=1447+1?this.x(I,F,f,U,O,b,B,Z,g,p,w,u,n,v,a,c,se,s):null}const oe=(ue-r+(ae-e)-ce)/2;if(this.a!==null&&!this.a(ue,oe))return s[0]=!0,n[0]=ue,c[0]=ae,oe>0&&1447>0&&ce<=1447+1?this.x(I,F,f,U,O,b,B,Z,g,p,w,u,n,v,a,c,se,s):(r++,e++,[new E.DiffChange(r,u-r+1,e,a-e+1)]);b=this.J(O-ce,ce,O,m),B=this.J(O+ce,ce,O,m);for(let ye=b;ye<=B;ye+=2){ye===b||ye<B&&p[ye-1]>=p[ye+1]?w=p[ye+1]-1:w=p[ye-1],v=w-(ye-O)-Z;const ke=w;for(;w>r&&v>e&&this.p(w,v);)w--,v--;if(p[ye]=w,se&&Math.abs(ye-I)<=ce&&w<=g[ye])return n[0]=w,c[0]=v,ke>=g[ye]&&1447>0&&ce<=1447+1?this.x(I,F,f,U,O,b,B,Z,g,p,w,u,n,v,a,c,se,s):null}if(ce<=1447){let ye=new Int32Array(f-F+2);ye[0]=I-F+1,y.Copy2(g,F,ye,1,f-F+1),this.k.push(ye),ye=new Int32Array(B-b+2),ye[0]=O-b+1,y.Copy2(p,b,ye,1,B-b+1),this.m.push(ye)}}return this.x(I,F,f,U,O,b,B,Z,g,p,w,u,n,v,a,c,se,s)}z(r){for(let u=0;u<r.length;u++){const e=r[u],a=u<r.length-1?r[u+1].originalStart:this.f.length,n=u<r.length-1?r[u+1].modifiedStart:this.h.length,c=e.originalLength>0,s=e.modifiedLength>0;for(;e.originalStart+e.originalLength<a&&e.modifiedStart+e.modifiedLength<n&&(!c||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!s||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const v=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!v)break;e.originalStart++,e.modifiedStart++}const w=[null];if(u<r.length-1&&this.I(r[u],r[u+1],w)){r[u]=w[0],r.splice(u+1,1),u--;continue}}for(let u=r.length-1;u>=0;u--){const e=r[u];let a=0,n=0;if(u>0){const f=r[u-1];a=f.originalStart+f.originalLength,n=f.modifiedStart+f.modifiedLength}const c=e.originalLength>0,s=e.modifiedLength>0;let w=0,v=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let f=1;;f++){const b=e.originalStart-f,B=e.modifiedStart-f;if(b<a||B<n||c&&!this.s(b,b+e.originalLength)||s&&!this.u(B,B+e.modifiedLength))break;const m=(b===a&&B===n?5:0)+this.G(b,e.originalLength,B,e.modifiedLength);m>v&&(v=m,w=f)}e.originalStart-=w,e.modifiedStart-=w;const F=[null];if(u>0&&this.I(r[u-1],r[u],F)){r[u-1]=F[0],r.splice(u,1),u++;continue}}if(this.d)for(let u=1,e=r.length;u<e;u++){const a=r[u-1],n=r[u],c=n.originalStart-a.originalStart-a.originalLength,s=a.originalStart,w=n.originalStart+n.originalLength,v=w-s,F=a.modifiedStart,f=n.modifiedStart+n.modifiedLength,b=f-F;if(c<5&&v<20&&b<20){const B=this.A(s,v,F,b,c);if(B){const[M,m]=B;(M!==a.originalStart+a.originalLength||m!==a.modifiedStart+a.modifiedLength)&&(a.originalLength=M-a.originalStart,a.modifiedLength=m-a.modifiedStart,n.originalStart=M+c,n.modifiedStart=m+c,n.originalLength=w-n.originalStart,n.modifiedLength=f-n.modifiedStart)}}}return r}A(r,u,e,a,n){if(u<n||a<n)return null;const c=r+u-n+1,s=e+a-n+1;let w=0,v=0,F=0;for(let f=r;f<c;f++)for(let b=e;b<s;b++){const B=this.B(f,b,n);B>0&&B>w&&(w=B,v=f,F=b)}return w>0?[v,F]:null}B(r,u,e){let a=0;for(let n=0;n<e;n++){if(!this.p(r+n,u+n))return 0;a+=this.e[r+n].length}return a}C(r){return r<=0||r>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[r])}D(r,u){if(this.C(r)||this.C(r-1))return!0;if(u>0){const e=r+u;if(this.C(e-1)||this.C(e))return!0}return!1}E(r){return r<=0||r>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[r])}F(r,u){if(this.E(r)||this.E(r-1))return!0;if(u>0){const e=r+u;if(this.E(e-1)||this.E(e))return!0}return!1}G(r,u,e,a){const n=this.D(r,u)?1:0,c=this.F(e,a)?1:0;return n+c}H(r,u){const e=[];if(r.length===0||u.length===0)return u.length>0?u:r;if(this.I(r[r.length-1],u[0],e)){const a=new Array(r.length+u.length-1);return y.Copy(r,0,a,0,r.length-1),a[r.length-1]=e[0],y.Copy(u,1,a,r.length,u.length-1),a}else{const a=new Array(r.length+u.length);return y.Copy(r,0,a,0,r.length),y.Copy(u,0,a,r.length,u.length),a}}I(r,u,e){if(D.Assert(r.originalStart<=u.originalStart,"Left change is not less than or equal to right change"),D.Assert(r.modifiedStart<=u.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=u.originalStart||r.modifiedStart+r.modifiedLength>=u.modifiedStart){const a=r.originalStart;let n=r.originalLength;const c=r.modifiedStart;let s=r.modifiedLength;return r.originalStart+r.originalLength>=u.originalStart&&(n=u.originalStart+u.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=u.modifiedStart&&(s=u.modifiedStart+u.modifiedLength-r.modifiedStart),e[0]=new E.DiffChange(a,n,c,s),!0}else return e[0]=null,!1}J(r,u,e,a){if(r>=0&&r<a)return r;const n=e,c=a-e-1,s=u%2===0;if(r<0){const w=n%2===0;return s===w?0:1}else{const w=c%2===0;return s===w?a-1:a-2}}}t.LcsDiff=d}),define(ge[34],me([1,0,33,11,17]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.getCodiconAriaLabel=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const W="$(",D=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${D.source}`,"g");function h(c){return c.replace(y,(s,w)=>w?s:`\\${s}`)}t.escapeIcons=h;const l=new RegExp(`\\\\${D.source}`,"g");function d(c){return c.replace(l,s=>`\\${s}`)}t.markdownEscapeEscapedIcons=d;const N=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function r(c){return c.indexOf(W)===-1?c:c.replace(N,(s,w,v,F)=>v?s:w||F||"")}t.stripIcons=r;function u(c){return c?c.replace(/\$\((.*?)\)/g,(s,w)=>` ${w} `).trim():""}t.getCodiconAriaLabel=u;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(c){e.lastIndex=0;let s="";const w=[];let v=0;for(;;){const F=e.lastIndex,f=e.exec(c),b=c.substring(F,f?.index);if(b.length>0){s+=b;for(let B=0;B<b.length;B++)w.push(v)}if(!f)break;v+=f[0].length}return{text:s,iconOffsets:w}}t.parseLabelWithIcons=a;function n(c,s,w=!1){const{text:v,iconOffsets:F}=s;if(!F||F.length===0)return(0,E.matchesFuzzy)(c,v,w);const f=(0,L.ltrim)(v," "),b=v.length-f.length,B=(0,E.matchesFuzzy)(c,f,w);if(B)for(const M of B){const m=F[M.start+b]+b;M.start+=m,M.end+=m}return B}t.matchesFuzzyIconAware=n}),define(ge[113],me([1,0,13,11]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class i{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const e=u.charCodeAt(0),a=this.b.charCodeAt(this.c);return e-a}value(){return this.b[this.c]}}t.StringIterator=i;class W{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,L.compareSubstring)(u,this.b,0,u.length,this.c,this.d):(0,L.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.ConfigKeysIterator=W;class D{constructor(u=!0,e=!0){this.f=u,this.g=e}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let e=u.length-1;e>=0;e--,this.c--){const a=this.b.charCodeAt(e);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,L.compareSubstring)(u,this.b,0,u.length,this.d,this.e):(0,L.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.PathIterator=D;var y;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(y||(y={}));class h{constructor(u,e){this.f=u,this.g=e,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,L.compareIgnoreCase)(u,this.c.scheme);if(this.d[this.e]===2)return(0,L.compareIgnoreCase)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,L.compare)(u,this.c.query);if(this.d[this.e]===5)return(0,L.compare)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.UriIterator=h;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(d||(d={}));class N{static forUris(u=()=>!1,e=()=>!1){return new N(new h(u,e))}static forPaths(u=!1){return new N(new D(void 0,!u))}static forStrings(){return new N(new i)}static forConfigKeys(){return new N(new W)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,e){if(e){const a=e.slice(0);(0,E.shuffle)(a);for(const n of a)this.set(n,u)}else{const a=u.slice(0);(0,E.shuffle)(a);for(const n of a)this.set(n[0],n[1])}}set(u,e){const a=this.b.reset(u);let n;this.c||(this.c=new l,this.c.segment=a.value());const c=[];for(n=this.c;;){const w=a.cmp(n.segment);if(w>0)n.left||(n.left=new l,n.left.segment=a.value()),c.push([-1,n]),n=n.left;else if(w<0)n.right||(n.right=new l,n.right.segment=a.value()),c.push([1,n]),n=n.right;else if(a.hasNext())a.next(),n.mid||(n.mid=new l,n.mid.segment=a.value()),c.push([0,n]),n=n.mid;else break}const s=n.value;n.value=e,n.key=u;for(let w=c.length-1;w>=0;w--){const v=c[w][1];v.updateHeight();const F=v.balanceFactor();if(F<-1||F>1){const f=c[w][0],b=c[w+1][0];if(f===1&&b===1)c[w][1]=v.rotateLeft();else if(f===-1&&b===-1)c[w][1]=v.rotateRight();else if(f===1&&b===-1)v.right=c[w+1][1]=c[w+1][1].rotateRight(),c[w][1]=v.rotateLeft();else if(f===-1&&b===1)v.left=c[w+1][1]=c[w+1][1].rotateLeft(),c[w][1]=v.rotateRight();else throw new Error;if(w>0)switch(c[w-1][0]){case-1:c[w-1][1].left=c[w][1];break;case 1:c[w-1][1].right=c[w][1];break;case 0:c[w-1][1].mid=c[w][1];break}else this.c=c[0][1]}}return s}get(u){return this.d(u)?.value}d(u){const e=this.b.reset(u);let a=this.c;for(;a;){const n=e.cmp(a.segment);if(n>0)a=a.left;else if(n<0)a=a.right;else if(e.hasNext())e.next(),a=a.mid;else break}return a}has(u){const e=this.d(u);return!(e?.value===void 0&&e?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,e){const a=this.b.reset(u),n=[];let c=this.c;for(;c;){const s=a.cmp(c.segment);if(s>0)n.push([-1,c]),c=c.left;else if(s<0)n.push([1,c]),c=c.right;else if(a.hasNext())a.next(),n.push([0,c]),c=c.mid;else break}if(c){if(e?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const s=this.f(c.right);if(s.key){const{key:w,value:v,segment:F}=s;this.e(s.key,!1),c.key=w,c.value=v,c.segment=F}}else{const s=c.left??c.right;if(n.length>0){const[w,v]=n[n.length-1];switch(w){case-1:v.left=s;break;case 0:v.mid=s;break;case 1:v.right=s;break}}else this.c=s}for(let s=n.length-1;s>=0;s--){const w=n[s][1];w.updateHeight();const v=w.balanceFactor();if(v>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),n[s][1]=w.rotateLeft()):v<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),n[s][1]=w.rotateRight()),s>0)switch(n[s-1][0]){case-1:n[s-1][1].left=n[s][1];break;case 1:n[s-1][1].right=n[s][1];break;case 0:n[s-1][1].mid=n[s][1];break}else this.c=n[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const e=this.b.reset(u);let a=this.c,n;for(;a;){const c=e.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(e.hasNext())e.next(),n=a.value||n,a=a.mid;else break}return a&&a.value||n}findSuperstr(u){return this.g(u,!1)}g(u,e){const a=this.b.reset(u);let n=this.c;for(;n;){const c=a.cmp(n.segment);if(c>0)n=n.left;else if(c<0)n=n.right;else if(a.hasNext())a.next(),n=n.mid;else return n.mid?this.h(n.mid):e?n.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[e,a]of this)u(a,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const e=[];return this.j(u,e),e[Symbol.iterator]()}j(u,e){u&&(u.left&&this.j(u.left,e),u.value&&e.push([u.key,u.value]),u.mid&&this.j(u.mid,e),u.right&&this.j(u.right,e))}_isBalanced(){const u=e=>{if(!e)return!0;const a=e.balanceFactor();return a<-1||a>1?!1:u(e.left)&&u(e.right)};return u(this.c)}}t.TernarySearchTree=N}),define(ge[15],me([1,0,22,5]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.isUriComponents=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,W=/^\//,D=/^\/\//;function y(M,m){if(!M.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${M.authority}", path: "${M.path}", query: "${M.query}", fragment: "${M.fragment}"}`);if(M.scheme&&!i.test(M.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(M.path){if(M.authority){if(!W.test(M.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(M.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(M,m){return!M&&!m?"file":M}function l(M,m){switch(M){case"https":case"http":case"file":m?m[0]!==N&&(m=N+m):m=N;break}return m}const d="",N="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(m){return m instanceof u?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}constructor(m,g,p,I,O,U=!1){typeof m=="object"?(this.scheme=m.scheme||d,this.authority=m.authority||d,this.path=m.path||d,this.query=m.query||d,this.fragment=m.fragment||d):(this.scheme=h(m,U),this.authority=g||d,this.path=l(this.scheme,p||d),this.query=I||d,this.fragment=O||d,y(this,U))}get fsPath(){return v(this,!1)}with(m){if(!m)return this;let{scheme:g,authority:p,path:I,query:O,fragment:U}=m;return g===void 0?g=this.scheme:g===null&&(g=d),p===void 0?p=this.authority:p===null&&(p=d),I===void 0?I=this.path:I===null&&(I=d),O===void 0?O=this.query:O===null&&(O=d),U===void 0?U=this.fragment:U===null&&(U=d),g===this.scheme&&p===this.authority&&I===this.path&&O===this.query&&U===this.fragment?this:new n(g,p,I,O,U)}static parse(m,g=!1){const p=r.exec(m);return p?new n(p[2]||d,B(p[4]||d),B(p[5]||d),B(p[7]||d),B(p[9]||d),g):new n(d,d,d,d,d)}static file(m){let g=d;if(L.isWindows&&(m=m.replace(/\\/g,N)),m[0]===N&&m[1]===N){const p=m.indexOf(N,2);p===-1?(g=m.substring(2),m=N):(g=m.substring(2,p),m=m.substring(p)||N)}return new n("file",g,m,d,d)}static from(m,g){return new n(m.scheme,m.authority,m.path,m.query,m.fragment,g)}static joinPath(m,...g){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return L.isWindows&&m.scheme==="file"?p=u.file(E.win32.join(v(m,!0),...g)).path:p=E.posix.join(m.path,...g),m.with({path:p})}toString(m=!1){return F(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof u)return m;{const g=new n(m);return g._formatted=m.external??null,g._fsPath=m._sep===a?m.fsPath??null:null,g}}else return m}}t.URI=u;function e(M){return!M||typeof M!="object"?!1:typeof M.scheme=="string"&&(typeof M.authority=="string"||typeof M.authority>"u")&&(typeof M.path=="string"||typeof M.path>"u")&&(typeof M.query=="string"||typeof M.query>"u")&&(typeof M.fragment=="string"||typeof M.fragment>"u")}t.isUriComponents=e;const a=L.isWindows?1:void 0;class n extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(m=!1){return m?F(this,!0):(this._formatted||(this._formatted=F(this,!1)),this._formatted)}toJSON(){const m={$mid:1};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=a),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function s(M,m,g){let p,I=-1;for(let O=0;O<M.length;O++){const U=M.charCodeAt(O);if(U>=97&&U<=122||U>=65&&U<=90||U>=48&&U<=57||U===45||U===46||U===95||U===126||m&&U===47||g&&U===91||g&&U===93||g&&U===58)I!==-1&&(p+=encodeURIComponent(M.substring(I,O)),I=-1),p!==void 0&&(p+=M.charAt(O));else{p===void 0&&(p=M.substr(0,O));const Z=c[U];Z!==void 0?(I!==-1&&(p+=encodeURIComponent(M.substring(I,O)),I=-1),p+=Z):I===-1&&(I=O)}}return I!==-1&&(p+=encodeURIComponent(M.substring(I))),p!==void 0?p:M}function w(M){let m;for(let g=0;g<M.length;g++){const p=M.charCodeAt(g);p===35||p===63?(m===void 0&&(m=M.substr(0,g)),m+=c[p]):m!==void 0&&(m+=M[g])}return m!==void 0?m:M}function v(M,m){let g;return M.authority&&M.path.length>1&&M.scheme==="file"?g=`//${M.authority}${M.path}`:M.path.charCodeAt(0)===47&&(M.path.charCodeAt(1)>=65&&M.path.charCodeAt(1)<=90||M.path.charCodeAt(1)>=97&&M.path.charCodeAt(1)<=122)&&M.path.charCodeAt(2)===58?m?g=M.path.substr(1):g=M.path[1].toLowerCase()+M.path.substr(2):g=M.path,L.isWindows&&(g=g.replace(/\//g,"\\")),g}t.uriToFsPath=v;function F(M,m){const g=m?w:s;let p="",{scheme:I,authority:O,path:U,query:Z,fragment:ne}=M;if(I&&(p+=I,p+=":"),(O||I==="file")&&(p+=N,p+=N),O){let se=O.indexOf("@");if(se!==-1){const ce=O.substr(0,se);O=O.substr(se+1),se=ce.lastIndexOf(":"),se===-1?p+=g(ce,!1,!1):(p+=g(ce.substr(0,se),!1,!1),p+=":",p+=g(ce.substr(se+1),!1,!0)),p+="@"}O=O.toLowerCase(),se=O.lastIndexOf(":"),se===-1?p+=g(O,!1,!0):(p+=g(O.substr(0,se),!1,!0),p+=O.substr(se))}if(U){if(U.length>=3&&U.charCodeAt(0)===47&&U.charCodeAt(2)===58){const se=U.charCodeAt(1);se>=65&&se<=90&&(U=`/${String.fromCharCode(se+32)}:${U.substr(3)}`)}else if(U.length>=2&&U.charCodeAt(1)===58){const se=U.charCodeAt(0);se>=65&&se<=90&&(U=`${String.fromCharCode(se+32)}:${U.substr(2)}`)}p+=g(U,!0,!1)}return Z&&(p+="?",p+=g(Z,!1,!1)),ne&&(p+="#",p+=m?ne:s(ne,!1,!1)),p}function f(M){try{return decodeURIComponent(M)}catch{return M.length>3?M.substr(0,3)+f(M.substr(3)):M}}const b=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function B(M){return M.match(b)?M.replace(b,m=>f(m)):M}}),define(ge[50],me([1,0,31,11,15]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function W(l){return JSON.stringify(l,y)}t.stringify=W;function D(l){let d=JSON.parse(l);return d=h(d),d}t.parse=D;function y(l,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:(0,L.regExpFlags)(d)}:d}function h(l,d=0){if(!l||d>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return i.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof E.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let N=0;N<l.length;++N)l[N]=h(l[N],d+1);else for(const N in l)Object.hasOwnProperty.call(l,N)&&(l[N]=h(l[N],d+1))}return l}t.revive=h}),define(ge[28],me([1,0,7,5,15]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var W;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractive="vscode-interactive",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(W||(t.Schemas=W={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${W.vscodeRemoteResource}`}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d){this.f=`${d}/${W.vscodeRemoteResource}`}set(d,N,r){this.a[d]=N,this.b[d]=r}setConnectionToken(d,N){this.c[d]=N}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(n){return E.onUnexpectedError(n),d}const N=d.authority;let r=this.a[N];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const u=this.b[N],e=this.c[N];let a=`path=${encodeURIComponent(d.path)}`;return typeof e=="string"&&(a+=`&${t.connectionTokenQueryName}=${encodeURIComponent(e)}`),i.URI.from({scheme:L.isWeb?this.d:W.vscodeRemoteResource,authority:`${r}:${u}`,path:this.f,query:a})}}t.RemoteAuthorities=new D,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class y{asBrowserUri(d){const N=this.b(d,te);return this.uriToBrowserUri(N)}uriToBrowserUri(d){return d.scheme===W.vscodeRemote?t.RemoteAuthorities.rewrite(d):d.scheme===W.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${W.vscodeFileResource}://${y.a}`)?d.with({scheme:W.vscodeFileResource,authority:d.authority||y.a,query:null,fragment:null}):d}asFileUri(d){const N=this.b(d,te);return this.uriToFileUri(N)}uriToFileUri(d){return d.scheme===W.vscodeFileResource?d.with({scheme:W.file,authority:d.authority!==y.a?d.authority:null,query:null,fragment:null}):d}b(d,N){return i.URI.isUri(d)?d:i.URI.parse(N.toUrl(d))}}y.a="vscode-app",t.FileAccess=new y;var h;(function(l){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(d.get("3"));const N="vscode-coi";function r(e){let a;typeof e=="string"?a=new URL(e).searchParams:e instanceof URL?a=e.searchParams:i.URI.isUri(e)&&(a=new URL(e.toString(!0)).searchParams);const n=a?.get(N);if(n)return d.get(n)}l.getHeadersFromQuery=r;function u(e,a,n){if(!globalThis.crossOriginIsolated)return;const c=a&&n?"3":n?"2":"1";e instanceof URLSearchParams?e.set(N,c):e[N]=c}l.addSearchParam=u})(h||(t.COI=h={}))}),define(ge[35],me([1,0,110,28,22,5,11,15]),function(te,t,E,L,i,W,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function h(u){return(0,y.uriToFsPath)(u,!0)}t.originalFSPath=h;class l{constructor(e){this.a=e}compare(e,a,n=!1){return e===a?0:(0,D.compare)(this.getComparisonKey(e,n),this.getComparisonKey(a,n))}isEqual(e,a,n=!1){return e===a?!0:!e||!a?!1:this.getComparisonKey(e,n)===this.getComparisonKey(a,n)}getComparisonKey(e,a=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,a,n=!1){if(e.scheme===a.scheme){if(e.scheme===L.Schemas.file)return E.isEqualOrParent(h(e),h(a),this.a(e))&&e.query===a.query&&(n||e.fragment===a.fragment);if((0,t.isEqualAuthority)(e.authority,a.authority))return E.isEqualOrParent(e.path,a.path,this.a(e),"/")&&e.query===a.query&&(n||e.fragment===a.fragment)}return!1}joinPath(e,...a){return y.URI.joinPath(e,...a)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return i.posix.basename(e.path)}extname(e){return i.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let a;return e.scheme===L.Schemas.file?a=y.URI.file(i.dirname(h(e))).path:(a=i.posix.dirname(e.path),e.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),a="/")),e.with({path:a})}normalizePath(e){if(!e.path.length)return e;let a;return e.scheme===L.Schemas.file?a=y.URI.file(i.normalize(h(e))).path:a=i.posix.normalize(e.path),e.with({path:a})}relativePath(e,a){if(e.scheme!==a.scheme||!(0,t.isEqualAuthority)(e.authority,a.authority))return;if(e.scheme===L.Schemas.file){const s=i.relative(h(e),h(a));return W.isWindows?E.toSlashes(s):s}let n=e.path||"/";const c=a.path||"/";if(this.a(e)){let s=0;for(const w=Math.min(n.length,c.length);s<w&&!(n.charCodeAt(s)!==c.charCodeAt(s)&&n.charAt(s).toLowerCase()!==c.charAt(s).toLowerCase());s++);n=c.substr(0,s)+n.substr(s)}return i.posix.relative(n,c)}resolvePath(e,a){if(e.scheme===L.Schemas.file){const n=y.URI.file(i.resolve(h(e),a));return e.with({authority:n.authority,path:n.path})}return a=E.toPosixPath(a),e.with({path:i.posix.resolve(e.path,a)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,a){return e===a||e!==void 0&&a!==void 0&&(0,D.equalsIgnoreCase)(e,a)}hasTrailingPathSeparator(e,a=i.sep){if(e.scheme===L.Schemas.file){const n=h(e);return n.length>E.getRoot(n).length&&n[n.length-1]===a}else{const n=e.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,a=i.sep){return(0,t.hasTrailingPathSeparator)(e,a)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,a=i.sep){let n=!1;if(e.scheme===L.Schemas.file){const c=h(e);n=c!==void 0&&c.length===E.getRoot(c).length&&c[c.length-1]===a}else{a="/";const c=e.path;n=c.length===1&&c.charCodeAt(c.length-1)===47}return!n&&!(0,t.hasTrailingPathSeparator)(e,a)?e.with({path:e.path+"/"}):e}}t.ExtUri=l,t.extUri=new l(()=>!1),t.extUriBiasedIgnorePathCase=new l(u=>u.scheme===L.Schemas.file?!W.isLinux:!0),t.extUriIgnorePathCase=new l(u=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function d(u,e){const a=[];for(let n=0;n<u.length;n++){const c=e(u[n]);u.some((s,w)=>w===n?!1:(0,t.isEqualOrParent)(c,e(s)))||a.push(u[n])}return a}t.distinctParents=d;var N;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function e(a){const n=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(w=>{const[v,F]=w.split(":");v&&F&&n.set(v,F)});const s=a.path.substring(0,a.path.indexOf(";"));return s&&n.set(u.META_DATA_MIME,s),n}u.parseMetaData=e})(N||(t.DataUri=N={}));function r(u,e,a){if(e){let n=u.path;return n&&n[0]!==i.posix.sep&&(n=i.posix.sep+n),u.with({scheme:a,authority:e,path:n})}return u.with({scheme:a})}t.toLocalResource=r}),define(ge[9],me([1,0,27,7,3,2,35,5,46]),function(te,t,E,L,i,W,D,y,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function l(x){return!!x&&typeof x.then=="function"}t.isThenable=l;function d(x){const o=new E.CancellationTokenSource,k=x(o.token),_=new Promise((Y,C)=>{const T=o.token.onCancellationRequested(()=>{T.dispose(),o.dispose(),C(new L.CancellationError)});Promise.resolve(k).then(R=>{T.dispose(),o.dispose(),Y(R)},R=>{T.dispose(),o.dispose(),C(R)})});return new class{cancel(){o.cancel()}then(Y,C){return _.then(Y,C)}catch(Y){return this.then(void 0,Y)}finally(Y){return _.finally(Y)}}}t.createCancelablePromise=d;function N(x,o,k){return new Promise((_,Y)=>{const C=o.onCancellationRequested(()=>{C.dispose(),_(k)});x.then(_,Y).finally(()=>C.dispose())})}t.raceCancellation=N;function r(x,o){return new Promise((k,_)=>{const Y=o.onCancellationRequested(()=>{Y.dispose(),_(new L.CancellationError)});x.then(k,_).finally(()=>Y.dispose())})}t.raceCancellationError=r;async function u(x){let o=-1;const k=x.map((_,Y)=>_.then(C=>(o=Y,C)));try{return await Promise.race(k)}finally{x.forEach((_,Y)=>{Y!==o&&_.cancel()})}}t.raceCancellablePromises=u;function e(x,o,k){let _;const Y=setTimeout(()=>{_?.(void 0),k?.()},o);return Promise.race([x.finally(()=>clearTimeout(Y)),new Promise(C=>_=C)])}t.raceTimeout=e;function a(x){return new Promise((o,k)=>{const _=x();l(_)?_.then(o,k):o(_)})}t.asPromise=a;class n{constructor(){this.a=null,this.b=null,this.d=null}queue(o){if(this.a){if(this.d=o,!this.b){const k=()=>{this.b=null;const _=this.queue(this.d);return this.d=null,_};this.b=new Promise(_=>{this.a.then(k,k).then(_)})}return new Promise((k,_)=>{this.b.then(k,_)})}return this.a=o(),new Promise((k,_)=>{this.a.then(Y=>{this.a=null,k(Y)},Y=>{this.a=null,_(Y)})})}}t.Throttler=n;class c{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}t.Sequencer=c;class s{constructor(){this.a=new Map}queue(o,k){const Y=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(k).finally(()=>{this.a.get(o)===Y&&this.a.delete(o)});return this.a.set(o,Y),Y}}t.SequencerByKey=s;const w=(x,o)=>{let k=!0;const _=setTimeout(()=>{k=!1,o()},x);return{isTriggered:()=>k,dispose:()=>{clearTimeout(_),k=!1}}},v=x=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,x())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class F{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,k=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((Y,C)=>{this.d=Y,this.f=C}).then(()=>{if(this.b=null,this.d=null,this.g){const Y=this.g;return this.g=null,Y()}}));const _=()=>{this.a=null,this.d?.(null)};return this.a=k===h.MicrotaskDelay?v(_):w(k,_),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.Delayer=F;class f{constructor(o){this.a=new F(o),this.b=new n}trigger(o,k){return this.a.trigger(()=>this.b.queue(o),k)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}t.ThrottledDelayer=f;class b{constructor(){this.a=!1,this.b=new Promise((o,k)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.Barrier=b;class B extends b{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}t.AutoOpenBarrier=B;function M(x,o){return o?new Promise((k,_)=>{const Y=setTimeout(()=>{C.dispose(),k()},x),C=o.onCancellationRequested(()=>{clearTimeout(Y),C.dispose(),_(new L.CancellationError)})}):d(k=>M(x,k))}t.timeout=M;function m(x,o=0){const k=setTimeout(x,o);return(0,W.toDisposable)(()=>clearTimeout(k))}t.disposableTimeout=m;function g(x){const o=[];let k=0;const _=x.length;function Y(){return k<_?x[k++]():null}function C(T){T!=null&&o.push(T);const R=Y();return R?R.then(C):Promise.resolve(o)}return Promise.resolve(null).then(C)}t.sequence=g;function p(x,o=_=>!!_,k=null){let _=0;const Y=x.length,C=()=>{if(_>=Y)return Promise.resolve(k);const T=x[_++];return Promise.resolve(T()).then(S=>o(S)?Promise.resolve(S):C())};return C()}t.first=p;function I(x,o=_=>!!_,k=null){if(x.length===0)return Promise.resolve(k);let _=x.length;const Y=()=>{_=-1;for(const C of x)C.cancel?.()};return new Promise((C,T)=>{for(const R of x)R.then(S=>{--_>=0&&o(S)?(Y(),C(S)):_===0&&C(k)}).catch(S=>{--_>=0&&(Y(),T(S))})})}t.firstParallel=I;class O{constructor(o){this.a=0,this.d=o,this.f=[],this.b=0,this.g=new i.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(o){return this.a++,new Promise((k,_)=>{this.f.push({factory:o,c:k,e:_}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const o=this.f.shift();this.b++;const k=o.factory();k.then(o.c,o.e),k.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.Limiter=O;class U extends O{constructor(){super(1)}}t.Queue=U;class Z{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const o=new $;return this.b.add(o),o.p}d(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueFor(o,k=D.extUri){const _=k.getComparisonKey(o);let Y=this.a.get(_);return Y||(Y=new U,i.Event.once(Y.onDrained)(()=>{Y?.dispose(),this.a.delete(_),this.f()}),this.a.set(_,Y)),Y}f(){this.d()&&this.g()}g(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.g()}}t.ResourceQueue=Z;class ne{constructor(o,k){this.a=-1,typeof o=="function"&&typeof k=="number"&&this.setIfNotSet(o,k)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,k){this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},k)}setIfNotSet(o,k){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},k))}}t.TimeoutTimer=ne;class se{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(o,k){this.cancel(),this.a=setInterval(()=>{o()},k)}}t.IntervalTimer=se;class ce{constructor(o,k){this.b=-1,this.a=o,this.d=k,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.RunOnceScheduler=ce;class ue{constructor(o,k){k%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${k}ms is not a multiple of 1000ms.`),this.a=o,this.b=k,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.ProcessTimeRunOnceScheduler=ue;class ae extends ce{constructor(o,k){super(o,k),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}t.RunOnceWorker=ae;class oe extends W.Disposable{constructor(o,k){super(),this.g=o,this.h=k,this.a=[],this.b=this.B(new W.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const k of o)this.a.push(k);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ce(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.ThrottledWorker=oe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=x=>{(0,y.setTimeout0)(()=>{if(o)return;const k=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,k-Date.now())}}))});let o=!1;return{dispose(){o||(o=!0)}}}:t.runWhenIdle=(x,o)=>{const k=requestIdleCallback(x,typeof o=="number"?{timeout:o}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(k))}}}}();class ye{constructor(o){this.d=!1,this.a=()=>{try{this.f=o()}catch(k){this.g=k}finally{this.d=!0}},this.b=(0,t.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.IdleValue=ye;async function ke(x,o,k){let _;for(let Y=0;Y<k;Y++)try{return await x()}catch(C){_=C,await M(o)}throw _}t.retry=ke;class Be{hasPending(o){return this.a?typeof o=="number"?this.a.taskId===o:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(o,k,_){return this.a={taskId:o,cancel:()=>_?.(),promise:k},k.then(()=>this.d(o),()=>this.d(o)),k}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}setNext(o){if(this.b)this.b.run=o;else{let k,_;const Y=new Promise((C,T)=>{k=C,_=T});this.b={run:o,promise:Y,promiseResolve:k,promiseReject:_}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.TaskSequentializer=Be;class Me{constructor(o,k=()=>Date.now()){this.d=o,this.f=k,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}t.IntervalCounter=Me;var fe;(function(x){x[x.Resolved=0]="Resolved",x[x.Rejected=1]="Rejected"})(fe||(fe={}));class ${get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((o,k)=>{this.a=o,this.b=k})}complete(o){return new Promise(k=>{this.a(o),this.d={outcome:0,value:o},k()})}error(o){return new Promise(k=>{this.b(o),this.d={outcome:1,value:o},k()})}cancel(){return this.error(new L.CancellationError)}}t.DeferredPromise=$;var ie;(function(x){async function o(_){let Y;const C=await Promise.all(_.map(T=>T.then(R=>R,R=>{Y||(Y=R)})));if(typeof Y<"u")throw Y;return C}x.settled=o;function k(_){return new Promise(async(Y,C)=>{try{await _(Y,C)}catch(T){C(T)}})}x.withAsyncBody=k})(ie||(t.Promises=ie={}));var q;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(q||(q={}));class V{static fromArray(o){return new V(k=>{k.emitMany(o)})}static fromPromise(o){return new V(async k=>{k.emitMany(await o)})}static fromPromises(o){return new V(async k=>{await Promise.all(o.map(async _=>k.emitOne(await _)))})}static merge(o){return new V(async k=>{await Promise.all(o.map(async _=>{for await(const Y of _)k.emitOne(Y)}))})}constructor(o){this.a=0,this.b=[],this.d=null,this.f=new i.Emitter,queueMicrotask(async()=>{const k={emitOne:_=>this.g(_),emitMany:_=>this.h(_),reject:_=>this.k(_)};try{await Promise.resolve(o(k)),this.j()}catch(_){this.k(_)}finally{k.emitOne=void 0,k.emitMany=void 0,k.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(o,k){return new V(async _=>{for await(const Y of o)_.emitOne(k(Y))})}map(o){return V.map(this,o)}static filter(o,k){return new V(async _=>{for await(const Y of o)k(Y)&&_.emitOne(Y)})}filter(o){return V.filter(this,o)}static coalesce(o){return V.filter(o,k=>!!k)}coalesce(){return V.coalesce(this)}static async toPromise(o){const k=[];for await(const _ of o)k.push(_);return k}toPromise(){return V.toPromise(this)}g(o){this.a===0&&(this.b.push(o),this.f.fire())}h(o){this.a===0&&(this.b=this.b.concat(o),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(o){this.a===0&&(this.a=2,this.d=o,this.f.fire())}}t.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class A extends V{constructor(o,k){super(k),this.l=o}cancel(){this.l.cancel()}}t.CancelableAsyncIterableObject=A;function K(x){const o=new E.CancellationTokenSource,k=x(o.token);return new A(o,async _=>{const Y=o.token.onCancellationRequested(()=>{Y.dispose(),o.dispose(),_.reject(new L.CancellationError)});try{for await(const C of k){if(o.token.isCancellationRequested)return;_.emitOne(C)}Y.dispose(),o.dispose()}catch(C){Y.dispose(),o.dispose(),_.reject(C)}})}t.createCancelableAsyncIterable=K}),define(ge[4],me([1,0,18,108,14,21,9,7,3,114,2,28,5,6,15]),function(te,t,E,L,i,W,D,y,h,l,d,N,r,u,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCssValueWithDefault=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.setVisibility=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.isEventLike=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function a(J){for(;J.firstChild;)J.firstChild.remove()}t.clearNode=a;function n(J){return J?.isConnected??!1}t.isInDOM=n;class c{constructor(Q,de,Ce,Te){this.f=Q,this.g=de,this.d=Ce,this.j=Te||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function s(J,Q,de,Ce){return new c(J,Q,de,Ce)}t.addDisposableListener=s;function w(J){return function(Q){return J(new W.StandardMouseEvent(Q))}}function v(J){return function(Q){return J(new i.StandardKeyboardEvent(Q))}}const F=function(Q,de,Ce,Te){let _e=Ce;return de==="click"||de==="mousedown"?_e=w(Ce):(de==="keydown"||de==="keypress"||de==="keyup")&&(_e=v(Ce)),s(Q,de,_e,Te)};t.addStandardDisposableListener=F;const f=function(Q,de,Ce){const Te=w(de);return B(Q,Te,Ce)};t.addStandardDisposableGenericMouseDownListener=f;const b=function(Q,de,Ce){const Te=w(de);return m(Q,Te,Ce)};t.addStandardDisposableGenericMouseUpListener=b;function B(J,Q,de){return s(J,r.isIOS&&L.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,Q,de)}t.addDisposableGenericMouseDownListener=B;function M(J,Q,de){return s(J,r.isIOS&&L.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,Q,de)}t.addDisposableGenericMouseMoveListener=M;function m(J,Q,de){return s(J,r.isIOS&&L.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,Q,de)}t.addDisposableGenericMouseUpListener=m;class g{constructor(Q,de=0){this.d=Q,this.priority=de,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Q){(0,y.onUnexpectedError)(Q)}}static sort(Q,de){return de.priority-Q.priority}}(function(){let J=[],Q=null,de=!1,Ce=!1;const Te=()=>{for(de=!1,Q=J,J=[],Ce=!0;Q.length>0;)Q.sort(g.sort),Q.shift().execute();Ce=!1};t.scheduleAtNextAnimationFrame=(_e,xe=0)=>{const Ye=new g(_e,xe);return J.push(Ye),de||(de=!0,requestAnimationFrame(Te)),Ye},t.runAtThisOrScheduleAtNextAnimationFrame=(_e,xe)=>{if(Ce){const Ye=new g(_e,xe);return Q.push(Ye),Ye}else return(0,t.scheduleAtNextAnimationFrame)(_e,xe)}})();function p(J){return(0,t.scheduleAtNextAnimationFrame)(J,1e4)}t.measure=p;function I(J){return(0,t.scheduleAtNextAnimationFrame)(J,-1e4)}t.modify=I;const O=8,U=function(J,Q){return Q};class Z extends d.Disposable{constructor(Q,de,Ce,Te=U,_e=O){super();let xe=null,Ye=0;const nt=this.B(new D.TimeoutTimer),Ke=()=>{Ye=new Date().getTime(),Ce(xe),xe=null};this.B(s(Q,de,vt=>{xe=Te(xe,vt);const Et=new Date().getTime()-Ye;Et>=_e?(nt.cancel(),Ke()):nt.setIfNotSet(Ke,_e-Et)}))}}function ne(J,Q,de,Ce,Te){return new Z(J,Q,de,Ce,Te)}t.addDisposableThrottledListener=ne;function se(J){return document.defaultView.getComputedStyle(J,null)}t.getComputedStyle=se;function ce(J){if(J!==document.body)return new ae(J.clientWidth,J.clientHeight);if(r.isIOS&&window.visualViewport)return new ae(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new ae(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new ae(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new ae(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=ce;class ue{static d(Q,de){return parseFloat(de)||0}static f(Q,de,Ce){const Te=se(Q),_e=Te?Te.getPropertyValue(de):"0";return ue.d(Q,_e)}static getBorderLeftWidth(Q){return ue.f(Q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Q){return ue.f(Q,"border-right-width","borderRightWidth")}static getBorderTopWidth(Q){return ue.f(Q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Q){return ue.f(Q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Q){return ue.f(Q,"padding-left","paddingLeft")}static getPaddingRight(Q){return ue.f(Q,"padding-right","paddingRight")}static getPaddingTop(Q){return ue.f(Q,"padding-top","paddingTop")}static getPaddingBottom(Q){return ue.f(Q,"padding-bottom","paddingBottom")}static getMarginLeft(Q){return ue.f(Q,"margin-left","marginLeft")}static getMarginTop(Q){return ue.f(Q,"margin-top","marginTop")}static getMarginRight(Q){return ue.f(Q,"margin-right","marginRight")}static getMarginBottom(Q){return ue.f(Q,"margin-bottom","marginBottom")}}class ae{constructor(Q,de){this.width=Q,this.height=de}with(Q=this.width,de=this.height){return Q!==this.width||de!==this.height?new ae(Q,de):this}static is(Q){return typeof Q=="object"&&typeof Q.height=="number"&&typeof Q.width=="number"}static lift(Q){return Q instanceof ae?Q:new ae(Q.width,Q.height)}static equals(Q,de){return Q===de?!0:!Q||!de?!1:Q.width===de.width&&Q.height===de.height}}t.Dimension=ae,ae.None=new ae(0,0);function oe(J){let Q=J.offsetParent,de=J.offsetTop,Ce=J.offsetLeft;for(;(J=J.parentNode)!==null&&J!==document.body&&J!==document.documentElement;){de-=J.scrollTop;const Te=R(J)?null:se(J);Te&&(Ce-=Te.direction!=="rtl"?J.scrollLeft:-J.scrollLeft),J===Q&&(Ce+=ue.getBorderLeftWidth(J),de+=ue.getBorderTopWidth(J),de+=J.offsetTop,Ce+=J.offsetLeft,Q=J.offsetParent)}return{left:Ce,top:de}}t.getTopLeftOffset=oe;function ye(J,Q,de){typeof Q=="number"&&(J.style.width=`${Q}px`),typeof de=="number"&&(J.style.height=`${de}px`)}t.size=ye;function ke(J,Q,de,Ce,Te,_e="absolute"){typeof Q=="number"&&(J.style.top=`${Q}px`),typeof de=="number"&&(J.style.right=`${de}px`),typeof Ce=="number"&&(J.style.bottom=`${Ce}px`),typeof Te=="number"&&(J.style.left=`${Te}px`),J.style.position=_e}t.position=ke;function Be(J){const Q=J.getBoundingClientRect();return{left:Q.left+window.scrollX,top:Q.top+window.scrollY,width:Q.width,height:Q.height}}t.getDomNodePagePosition=Be;function Me(J){let Q=J,de=1;do{const Ce=se(Q).zoom;Ce!=null&&Ce!=="1"&&(de*=Ce),Q=Q.parentElement}while(Q!==null&&Q!==document.documentElement);return de}t.getDomNodeZoomLevel=Me;function fe(J){const Q=ue.getMarginLeft(J)+ue.getMarginRight(J);return J.offsetWidth+Q}t.getTotalWidth=fe;function $(J){const Q=ue.getBorderLeftWidth(J)+ue.getBorderRightWidth(J),de=ue.getPaddingLeft(J)+ue.getPaddingRight(J);return J.offsetWidth-Q-de}t.getContentWidth=$;function ie(J){const Q=ue.getMarginLeft(J)+ue.getMarginRight(J);return J.scrollWidth+Q}t.getTotalScrollWidth=ie;function q(J){const Q=ue.getBorderTopWidth(J)+ue.getBorderBottomWidth(J),de=ue.getPaddingTop(J)+ue.getPaddingBottom(J);return J.offsetHeight-Q-de}t.getContentHeight=q;function V(J){const Q=ue.getMarginTop(J)+ue.getMarginBottom(J);return J.offsetHeight+Q}t.getTotalHeight=V;function A(J,Q){if(J===null)return 0;const de=oe(J),Ce=oe(Q);return de.left-Ce.left}function K(J,Q){const de=Q.map(Te=>Math.max(ie(Te),fe(Te))+A(Te,J)||0);return Math.max(...de)}t.getLargestChildWidth=K;function x(J,Q){for(;J;){if(J===Q)return!0;J=J.parentNode}return!1}t.isAncestor=x;const o="parentFlowToElementId";function k(J,Q){J.dataset[o]=Q.id}t.setParentFlowTo=k;function _(J){const Q=J.dataset[o];return typeof Q=="string"?document.getElementById(Q):null}function Y(J,Q){let de=J;for(;de;){if(de===Q)return!0;if(de instanceof HTMLElement){const Ce=_(de);if(Ce){de=Ce;continue}}de=de.parentNode}return!1}t.isAncestorUsingFlowTo=Y;function C(J,Q,de){for(;J&&J.nodeType===J.ELEMENT_NODE;){if(J.classList.contains(Q))return J;if(de){if(typeof de=="string"){if(J.classList.contains(de))return null}else if(J===de)return null}J=J.parentNode}return null}t.findParentWithClass=C;function T(J,Q,de){return!!C(J,Q,de)}t.hasParentWithClass=T;function R(J){return J&&!!J.host&&!!J.mode}t.isShadowRoot=R;function S(J){return!!z(J)}t.isInShadowDOM=S;function z(J){for(;J.parentNode;){if(J===document.body)return null;J=J.parentNode}return R(J)?J:null}t.getShadowRoot=z;function H(){let J=document.activeElement;for(;J?.shadowRoot;)J=J.shadowRoot.activeElement;return J}t.getActiveElement=H;function P(J=document.getElementsByTagName("head")[0],Q){const de=document.createElement("style");return de.type="text/css",de.media="screen",Q?.(de),J.appendChild(de),de}t.createStyleSheet=P;function j(J=document.getElementsByTagName("head")[0]){const Q=document.createElement("meta");return J.appendChild(Q),Q}t.createMetaElement=j;let G=null;function ee(){return G||(G=P()),G}function re(J){return J?.sheet?.rules?J.sheet.rules:J?.sheet?.cssRules?J.sheet.cssRules:[]}function pe(J,Q,de=ee()){!de||!Q||de.sheet.insertRule(J+"{"+Q+"}",0)}t.createCSSRule=pe;function we(J,Q=ee()){if(!Q)return;const de=re(Q),Ce=[];for(let Te=0;Te<de.length;Te++)de[Te].selectorText.indexOf(J)!==-1&&Ce.push(Te);for(let Te=Ce.length-1;Te>=0;Te--)Q.sheet.deleteRule(Ce[Te])}t.removeCSSRulesContainingSelector=we;function Ne(J){return typeof HTMLElement=="object"?J instanceof HTMLElement:J&&typeof J=="object"&&J.nodeType===1&&typeof J.nodeName=="string"}t.isHTMLElement=Ne,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:E.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:E.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:E.isWebKit?"webkitAnimationIteration":"animationiteration"};function Se(J){const Q=J;return!!(Q&&typeof Q.preventDefault=="function"&&typeof Q.stopPropagation=="function")}t.isEventLike=Se,t.EventHelper={stop:(J,Q)=>(J.preventDefault(),Q&&J.stopPropagation(),J)};function ve(J){const Q=[];for(let de=0;J&&J.nodeType===J.ELEMENT_NODE;de++)Q[de]=J.scrollTop,J=J.parentNode;return Q}t.saveParentsScrollTop=ve;function Pe(J,Q){for(let de=0;J&&J.nodeType===J.ELEMENT_NODE;de++)J.scrollTop!==Q[de]&&(J.scrollTop=Q[de]),J=J.parentNode}t.restoreParentsScrollTop=Pe;class Le extends d.Disposable{static l(Q){const de=z(Q),Ce=de?de.activeElement:document.activeElement;return x(Ce,Q)}constructor(Q){super(),this.f=this.B(new h.Emitter),this.onDidFocus=this.f.event,this.g=this.B(new h.Emitter),this.onDidBlur=this.g.event;let de=Le.l(Q),Ce=!1;const Te=()=>{Ce=!1,de||(de=!0,this.f.fire())},_e=()=>{de&&(Ce=!0,window.setTimeout(()=>{Ce&&(Ce=!1,de=!1,this.g.fire())},0))};this.j=()=>{Le.l(Q)!==de&&(de?_e():Te())},this.B(s(Q,t.EventType.FOCUS,Te,!0)),this.B(s(Q,t.EventType.BLUR,_e,!0)),this.B(s(Q,t.EventType.FOCUS_IN,()=>this.j())),this.B(s(Q,t.EventType.FOCUS_OUT,()=>this.j()))}refreshState(){this.j()}}function Ve(J){return new Le(J)}t.trackFocus=Ve;function ze(J,Q){return J.after(Q),Q}t.after=ze;function We(J,...Q){if(J.append(...Q),Q.length===1&&typeof Q[0]!="string")return Q[0]}t.append=We;function Je(J,Q){return J.insertBefore(Q,J.firstChild),Q}t.prepend=Je;function it(J,...Q){J.innerText="",We(J,...Q)}t.reset=it;const Oe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var je;(function(J){J.HTML="http://www.w3.org/1999/xhtml",J.SVG="http://www.w3.org/2000/svg"})(je||(t.Namespace=je={}));function X(J,Q,de,...Ce){const Te=Oe.exec(Q);if(!Te)throw new Error("Bad use of emmet");const _e=Te[1]||"div";let xe;return J!==je.HTML?xe=document.createElementNS(J,_e):xe=document.createElement(_e),Te[3]&&(xe.id=Te[3]),Te[4]&&(xe.className=Te[4].replace(/\./g," ").trim()),de&&Object.entries(de).forEach(([Ye,nt])=>{typeof nt>"u"||(/^on\w+$/.test(Ye)?xe[Ye]=nt:Ye==="selected"?nt&&xe.setAttribute(Ye,"true"):xe.setAttribute(Ye,nt))}),xe.append(...Ce),xe}function le(J,Q,...de){return X(je.HTML,J,Q,...de)}t.$=le,le.SVG=function(J,Q,...de){return X(je.SVG,J,Q,...de)};function be(J,Q){const de=[];return J.forEach((Ce,Te)=>{Te>0&&(Q instanceof Node?de.push(Q.cloneNode()):de.push(document.createTextNode(Q))),de.push(Ce)}),de}t.join=be;function De(J,...Q){J?Ae(...Q):Re(...Q)}t.setVisibility=De;function Ae(...J){for(const Q of J)Q.style.display="",Q.removeAttribute("aria-hidden")}t.show=Ae;function Re(...J){for(const Q of J)Q.style.display="none",Q.setAttribute("aria-hidden","true")}t.hide=Re;function $e(J,Q){for(;J&&J.nodeType===J.ELEMENT_NODE;){if(J instanceof HTMLElement&&J.hasAttribute(Q))return J;J=J.parentNode}return null}function Ge(J){!J||!J.hasAttribute("tabIndex")||(document.activeElement===J&&$e(J.parentElement,"tabIndex")?.focus(),J.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Ge;function et(J){return Q=>{Q.preventDefault(),Q.stopPropagation(),J(Q)}}t.finalHandler=et;function Fe(){return new Promise(J=>{document.readyState==="complete"||document&&document.body!==null?J(void 0):window.addEventListener("DOMContentLoaded",J,!1)})}t.domContentLoaded=Fe;function he(J){const Q=window.devicePixelRatio*J;return Math.max(1,Math.floor(Q))/window.devicePixelRatio}t.computeScreenAwareSize=he;function Ee(J){window.open(J,"_blank","noopener")}t.windowOpenNoOpener=Ee;const Ie=780,Ue=640;function Xe(J){const Q=Math.floor(window.screenLeft+window.innerWidth/2-Ie/2),de=Math.floor(window.screenTop+window.innerHeight/2-Ue/2);window.open(J,"_blank",`width=${Ie},height=${Ue},top=${de},left=${Q}`)}t.windowOpenPopup=Xe;function Ze(J,Q=!0){const de=window.open();return de?(Q&&(de.opener=null),de.location.href=J,!0):!1}t.windowOpenWithSuccess=Ze;function Qe(J){const Q=()=>{J(),de=(0,t.scheduleAtNextAnimationFrame)(Q)};let de=(0,t.scheduleAtNextAnimationFrame)(Q);return(0,d.toDisposable)(()=>de.dispose())}t.animate=Qe,N.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function rt(J){return J?`url('${N.FileAccess.uriToBrowserUri(J).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=rt;function dt(J){return`'${J.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=dt;function bt(J,Q){if(J!==void 0){const de=J.match(/^\s*var\((.+)\)$/);if(de){const Ce=de[1].split(",",2);return Ce.length===2&&(Q=bt(Ce[1].trim(),Q)),`var(${Ce[0]}, ${Q})`}return J}return Q}t.asCssValueWithDefault=bt;function Tt(J,Q){let de;if(e.URI.isUri(J))de=J.toString(!0);else{const Te=new Blob([J]);de=URL.createObjectURL(Te),setTimeout(()=>URL.revokeObjectURL(de))}const Ce=document.createElement("a");document.body.appendChild(Ce),Ce.download=Q,Ce.href=de,Ce.click(),setTimeout(()=>document.body.removeChild(Ce))}t.triggerDownload=Tt;function Wt(){return new Promise(J=>{const Q=document.createElement("input");document.body.appendChild(Q),Q.type="file",Q.multiple=!0,h.Event.once(h.Event.fromDOMEventEmitter(Q,"input"))(()=>{J((0,u.withNullAsUndefined)(Q.files))}),Q.click(),setTimeout(()=>document.body.removeChild(Q))})}t.triggerUpload=Wt;var pt;(function(J){J[J.DOCUMENT=1]="DOCUMENT",J[J.BROWSER=2]="BROWSER"})(pt||(t.DetectedFullscreenMode=pt={}));function di(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:pt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:pt.BROWSER,guess:!1}:(r.isMacintosh||r.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:pt.BROWSER,guess:!0}:null}t.detectFullscreen=di;function xt(J,Q=!1){const de=document.createElement("a");return l.addHook("afterSanitizeAttributes",Ce=>{for(const Te of["href","src"])if(Ce.hasAttribute(Te)){const _e=Ce.getAttribute(Te);if(Te==="href"&&_e.startsWith("#"))continue;if(de.href=_e,!J.includes(de.protocol.replace(/:$/,""))){if(Q&&Te==="src"&&de.href.startsWith("data:"))continue;Ce.removeAttribute(Te)}}}),(0,d.toDisposable)(()=>{l.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=xt;const fi=[N.Schemas.http,N.Schemas.https,N.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const gi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function mi(J,Q){const de=xt(fi);try{const Ce=l.sanitize(Q,gi);J.innerHTML=Ce}finally{de.dispose()}}t.safeInnerHtml=mi;function bi(J){const Q=new Uint16Array(J.length);for(let Te=0;Te<Q.length;Te++)Q[Te]=J.charCodeAt(Te);let de="";const Ce=new Uint8Array(Q.buffer);for(let Te=0;Te<Ce.length;Te++)de+=String.fromCharCode(Ce[Te]);return de}function pi(J){return btoa(bi(J))}t.multibyteAwareBtoa=pi;class ft extends h.Emitter{constructor(){super(),this.s=new d.DisposableStore,this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(s(window,"keydown",Q=>{if(Q.defaultPrevented)return;const de=new i.StandardKeyboardEvent(Q);if(!(de.keyCode===6&&Q.repeat)){if(Q.altKey&&!this.t.altKey)this.t.lastKeyPressed="alt";else if(Q.ctrlKey&&!this.t.ctrlKey)this.t.lastKeyPressed="ctrl";else if(Q.metaKey&&!this.t.metaKey)this.t.lastKeyPressed="meta";else if(Q.shiftKey&&!this.t.shiftKey)this.t.lastKeyPressed="shift";else if(de.keyCode!==6)this.t.lastKeyPressed=void 0;else return;this.t.altKey=Q.altKey,this.t.ctrlKey=Q.ctrlKey,this.t.metaKey=Q.metaKey,this.t.shiftKey=Q.shiftKey,this.t.lastKeyPressed&&(this.t.event=Q,this.fire(this.t))}},!0)),this.s.add(s(window,"keyup",Q=>{Q.defaultPrevented||(!Q.altKey&&this.t.altKey?this.t.lastKeyReleased="alt":!Q.ctrlKey&&this.t.ctrlKey?this.t.lastKeyReleased="ctrl":!Q.metaKey&&this.t.metaKey?this.t.lastKeyReleased="meta":!Q.shiftKey&&this.t.shiftKey?this.t.lastKeyReleased="shift":this.t.lastKeyReleased=void 0,this.t.lastKeyPressed!==this.t.lastKeyReleased&&(this.t.lastKeyPressed=void 0),this.t.altKey=Q.altKey,this.t.ctrlKey=Q.ctrlKey,this.t.metaKey=Q.metaKey,this.t.shiftKey=Q.shiftKey,this.t.lastKeyReleased&&(this.t.event=Q,this.fire(this.t)))},!0)),this.s.add(s(document.body,"mousedown",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(s(document.body,"mouseup",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(s(document.body,"mousemove",Q=>{Q.buttons&&(this.t.lastKeyPressed=void 0)},!0)),this.s.add(s(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.t}get isModifierPressed(){return this.t.altKey||this.t.ctrlKey||this.t.metaKey||this.t.shiftKey}resetKeyStatus(){this.v(),this.fire(this.t)}v(){this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.u||(ft.u=new ft),ft.u}dispose(){super.dispose(),this.s.dispose()}}t.ModifierKeyEmitter=ft;function vi(J){const Q=document.cookie.match("(^|[^;]+)\\s*"+J+"\\s*=\\s*([^;]+)");return Q?Q.pop():void 0}t.getCookieValue=vi;class wi extends d.Disposable{constructor(Q,de){super(),this.j=Q,this.l=de,this.f=0,this.g=0,this.m()}m(){this.B(s(this.j,t.EventType.DRAG_ENTER,Q=>{this.f++,this.g=Q.timeStamp,this.l.onDragEnter(Q)})),this.B(s(this.j,t.EventType.DRAG_OVER,Q=>{Q.preventDefault(),this.l.onDragOver?.(Q,Q.timeStamp-this.g)})),this.B(s(this.j,t.EventType.DRAG_LEAVE,Q=>{this.f--,this.f===0&&(this.g=0,this.l.onDragLeave(Q))})),this.B(s(this.j,t.EventType.DRAG_END,Q=>{this.f=0,this.g=0,this.l.onDragEnd(Q)})),this.B(s(this.j,t.EventType.DROP,Q=>{this.f=0,this.g=0,this.l.onDrop(Q)}))}}t.DragAndDropObserver=wi;const Di=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function yi(J,...Q){let de,Ce;Array.isArray(Q[0])?(de={},Ce=Q[0]):(de=Q[0]||{},Ce=Q[1]);const Te=Di.exec(J);if(!Te||!Te.groups)throw new Error("Bad use of h");const _e=Te.groups.tag||"div",xe=document.createElement(_e);Te.groups.id&&(xe.id=Te.groups.id);const Ye=[];if(Te.groups.class)for(const Ke of Te.groups.class.split("."))Ke!==""&&Ye.push(Ke);if(de.className!==void 0)for(const Ke of de.className.split("."))Ke!==""&&Ye.push(Ke);Ye.length>0&&(xe.className=Ye.join(" "));const nt={};if(Te.groups.name&&(nt[Te.groups.name]=xe),Ce)for(const Ke of Ce)Ke instanceof HTMLElement?xe.appendChild(Ke):typeof Ke=="string"?xe.append(Ke):"root"in Ke&&(Object.assign(nt,Ke),xe.appendChild(Ke.root));for(const[Ke,vt]of Object.entries(de))if(Ke!=="className")if(Ke==="style")for(const[Et,Lt]of Object.entries(vt))xe.style.setProperty($t(Et),typeof Lt=="number"?Lt+"px":""+Lt);else Ke==="tabIndex"?xe.tabIndex=vt:xe.setAttribute($t(Ke),vt.toString());return nt.root=xe,nt}t.h=yi;function $t(J){return J.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(ge[51],me([1,0,4,2,106]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class W extends L.Disposable{constructor(h,l){super(),this.B((0,E.addDisposableListener)(h,"dragover",d=>{d.preventDefault(),this.a||(this.a=setTimeout(()=>{l(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(d=>{this.B((0,E.addDisposableListener)(h,d,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.DelayedDragHandler=W,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.Mimes.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function D(y,h,l,d,N){const r=document.createElement("div");r.className=l,r.textContent=h,N&&(r.style.color=N),d&&(r.style.background=d),y.dataTransfer&&(document.body.appendChild(r),y.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>document.body.removeChild(r),0))}t.applyDragImage=D}),define(ge[52],me([1,0,4]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function L(r,u={}){const e=W(u);return e.textContent=r,e}t.renderText=L;function i(r,u={}){const e=W(u);return h(e,l(r,!!u.renderCodeSegments),u.actionHandler,u.renderCodeSegments),e}t.renderFormattedText=i;function W(r){const u=r.inline?"span":"div",e=document.createElement(u);return r.className&&(e.className=r.className),e}t.createElement=W;class D{constructor(u){this.b=u,this.c=0}eos(){return this.c>=this.b.length}next(){const u=this.peek();return this.advance(),u}peek(){return this.b[this.c]}advance(){this.c++}}var y;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(y||(y={}));function h(r,u,e,a){let n;if(u.type===2)n=document.createTextNode(u.content||"");else if(u.type===3)n=document.createElement("b");else if(u.type===4)n=document.createElement("i");else if(u.type===7&&a)n=document.createElement("code");else if(u.type===5&&e){const c=document.createElement("a");e.disposables.add(E.addStandardDisposableListener(c,"click",s=>{e.callback(String(u.index),s)})),n=c}else u.type===8?n=document.createElement("br"):u.type===1&&(n=r);n&&r!==n&&r.appendChild(n),n&&Array.isArray(u.children)&&u.children.forEach(c=>{h(n,c,e,a)})}function l(r,u){const e={type:1,children:[]};let a=0,n=e;const c=[],s=new D(r);for(;!s.eos();){let w=s.next();const v=w==="\\"&&N(s.peek(),u)!==0;if(v&&(w=s.next()),!v&&d(w,u)&&w===s.peek()){s.advance(),n.type===2&&(n=c.pop());const F=N(w,u);if(n.type===F||n.type===5&&F===6)n=c.pop();else{const f={type:F,children:[]};F===5&&(f.index=a,a++),n.children.push(f),c.push(n),n=f}}else if(w===`
`)n.type===2&&(n=c.pop()),n.children.push({type:8});else if(n.type!==2){const F={type:2,content:w};n.children.push(F),c.push(n),n=F}else n.content+=w}return n.type===2&&(n=c.pop()),c.length,e}function d(r,u){return N(r,u)!==0}function N(r,u){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return u?7:0;default:return 0}}}),define(ge[53],me([1,0,4,2]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class i{constructor(){this.a=new L.DisposableStore,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(D,y){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const h=this.c;this.c=null,D&&h&&h(y)}isMonitoring(){return!!this.b}startMonitoring(D,y,h,l,d){this.isMonitoring()&&this.stopMonitoring(!1),this.b=l,this.c=d;let N=D;try{D.setPointerCapture(y),this.a.add((0,L.toDisposable)(()=>{try{D.releasePointerCapture(y)}catch{}}))}catch{N=window}this.a.add(E.addDisposableListener(N,E.EventType.POINTER_MOVE,r=>{if(r.buttons!==h){this.stopMonitoring(!0);return}r.preventDefault(),this.b(r)})),this.a.add(E.addDisposableListener(N,E.EventType.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=i});var qe=this&&this.__decorate||function(te,t,E,L){var i=arguments.length,W=i<3?t:L===null?L=Object.getOwnPropertyDescriptor(t,E):L,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(te,t,E,L);else for(var y=te.length-1;y>=0;y--)(D=te[y])&&(W=(i<3?D(W):i>3?D(t,E,W):D(t,E))||W);return i>3&&W&&Object.defineProperty(t,E,W),W};define(ge[23],me([1,0,4,13,25,2,43]),function(te,t,E,L,i,W,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var y;(function(l){l.Tap="-monaco-gesturetap",l.Change="-monaco-gesturechange",l.Start="-monaco-gesturestart",l.End="-monaco-gesturesend",l.Contextmenu="-monaco-gesturecontextmenu"})(y||(t.EventType=y={}));class h extends W.Disposable{constructor(){super(),this.f=!1,this.g=new D.LinkedList,this.h=new D.LinkedList,this.k={},this.j=null,this.l=0,this.B(E.addDisposableListener(document,"touchstart",d=>this.n(d),{passive:!1})),this.B(E.addDisposableListener(document,"touchend",d=>this.p(d))),this.B(E.addDisposableListener(document,"touchmove",d=>this.v(d),{passive:!1}))}static addTarget(d){if(!h.isTouchDevice())return W.Disposable.None;h.b||(h.b=new h);const N=h.b.g.push(d);return(0,W.toDisposable)(N)}static ignoreTarget(d){if(!h.isTouchDevice())return W.Disposable.None;h.b||(h.b=new h);const N=h.b.h.push(d);return(0,W.toDisposable)(N)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}n(d){const N=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let r=0,u=d.targetTouches.length;r<u;r++){const e=d.targetTouches.item(r);this.k[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:N,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[N],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const a=this.r(y.Start,e.target);a.pageX=e.pageX,a.pageY=e.pageY,this.s(a)}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}p(d){const N=Date.now(),r=Object.keys(this.k).length;for(let u=0,e=d.changedTouches.length;u<e;u++){const a=d.changedTouches.item(u);if(!this.k.hasOwnProperty(String(a.identifier))){console.warn("move of an UNKNOWN touch",a);continue}const n=this.k[a.identifier],c=Date.now()-n.initialTimeStamp;if(c<h.c&&Math.abs(n.initialPageX-L.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-L.tail(n.rollingPageY))<30){const s=this.r(y.Tap,n.initialTarget);s.pageX=L.tail(n.rollingPageX),s.pageY=L.tail(n.rollingPageY),this.s(s)}else if(c>=h.c&&Math.abs(n.initialPageX-L.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-L.tail(n.rollingPageY))<30){const s=this.r(y.Contextmenu,n.initialTarget);s.pageX=L.tail(n.rollingPageX),s.pageY=L.tail(n.rollingPageY),this.s(s)}else if(r===1){const s=L.tail(n.rollingPageX),w=L.tail(n.rollingPageY),v=L.tail(n.rollingTimestamps)-n.rollingTimestamps[0],F=s-n.rollingPageX[0],f=w-n.rollingPageY[0],b=[...this.g].filter(B=>n.initialTarget instanceof Node&&B.contains(n.initialTarget));this.u(b,N,Math.abs(F)/v,F>0?1:-1,s,Math.abs(f)/v,f>0?1:-1,w)}this.s(this.r(y.End,n.initialTarget)),delete this.k[a.identifier]}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}r(d,N){const r=document.createEvent("CustomEvent");return r.initEvent(d,!1,!0),r.initialTarget=N,r.tapCount=0,r}s(d){if(d.type===y.Tap){const N=new Date().getTime();let r=0;N-this.l>h.m?r=1:r=2,this.l=N,d.tapCount=r}else(d.type===y.Change||d.type===y.Contextmenu)&&(this.l=0);if(d.initialTarget instanceof Node){for(const N of this.h)if(N.contains(d.initialTarget))return;for(const N of this.g)N.contains(d.initialTarget)&&(N.dispatchEvent(d),this.f=!0)}}u(d,N,r,u,e,a,n,c){this.j=E.scheduleAtNextAnimationFrame(()=>{const s=Date.now(),w=s-N;let v=0,F=0,f=!0;r+=h.a*w,a+=h.a*w,r>0&&(f=!1,v=u*r*w),a>0&&(f=!1,F=n*a*w);const b=this.r(y.Change);b.translationX=v,b.translationY=F,d.forEach(B=>B.dispatchEvent(b)),f||this.u(d,s,r,u,e+v,a,n,c+F)})}v(d){const N=Date.now();for(let r=0,u=d.changedTouches.length;r<u;r++){const e=d.changedTouches.item(r);if(!this.k.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const a=this.k[e.identifier],n=this.r(y.Change,a.initialTarget);n.translationX=e.pageX-L.tail(a.rollingPageX),n.translationY=e.pageY-L.tail(a.rollingPageY),n.pageX=e.pageX,n.pageY=e.pageY,this.s(n),a.rollingPageX.length>3&&(a.rollingPageX.shift(),a.rollingPageY.shift(),a.rollingTimestamps.shift()),a.rollingPageX.push(e.pageX),a.rollingPageY.push(e.pageY),a.rollingTimestamps.push(N)}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}}t.Gesture=h,h.a=-.005,h.c=700,h.m=400,qe([i.memoize],h,"isTouchDevice",null)}),define(ge[54],me([1,0,4,5,83]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const i=2e4;let W,D,y,h,l;function d(e){W=document.createElement("div"),W.className="monaco-aria-container";const a=()=>{const c=document.createElement("div");return c.className="monaco-alert",c.setAttribute("role","alert"),c.setAttribute("aria-atomic","true"),W.appendChild(c),c};D=a(),y=a();const n=()=>{const c=document.createElement("div");return c.className="monaco-status",c.setAttribute("role","complementary"),c.setAttribute("aria-live","polite"),c.setAttribute("aria-atomic","true"),W.appendChild(c),c};h=n(),l=n(),e.appendChild(W)}t.setARIAContainer=d;function N(e){W&&(D.textContent!==e?(E.clearNode(y),u(D,e)):(E.clearNode(D),u(y,e)))}t.alert=N;function r(e){W&&(L.isMacintosh?N(e):h.textContent!==e?(E.clearNode(l),u(h,e)):(E.clearNode(h),u(l,e)))}t.status=r;function u(e,a){E.clearNode(e),a.length>i&&(a=a.substr(0,i)),e.textContent=a,e.style.visibility="hidden",e.style.visibility="visible"}}),define(ge[115],me([1,0,4,17]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const i=new RegExp(`(\\\\)?\\$\\((${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?)\\)`,"g");function W(y){const h=new Array;let l,d=0,N=0;for(;(l=i.exec(y))!==null;){N=l.index||0,d<N&&h.push(y.substring(d,N)),d=(l.index||0)+l[0].length;const[,r,u]=l;h.push(r?`$(${u})`:D({id:u}))}return d<y.length&&h.push(y.substring(d)),h}t.renderLabelWithIcons=W;function D(y){const h=E.$("span");return h.classList.add(...L.ThemeIcon.asClassNameArray(y)),h}t.renderIcon=D}),define(ge[116],me([1,0,4]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function L(W){try{W.parentElement?.removeChild(W)}catch{}}class i{constructor(D){this.d=D,this.a=new Map,this.b=new Set,this.c=!1}alloc(D){let y=this.h(D).pop(),h=!1;if(y)h=this.b.has(y.domNode),h&&this.b.delete(y.domNode);else{const l=(0,E.$)(".monaco-list-row"),N=this.i(D).renderTemplate(l);y={domNode:l,templateId:D,templateData:N}}return{row:y,isReusingConnectedDomNode:h}}release(D){D&&this.f(D)}transact(D){if(this.c)throw new Error("Already in transaction");this.c=!0;try{D()}finally{for(const y of this.b)this.g(y);this.b.clear(),this.c=!1}}f(D){const{domNode:y,templateId:h}=D;y&&(this.c?this.b.add(y):this.g(y)),this.h(h).push(D)}g(D){D.classList.remove("scrolling"),L(D)}h(D){let y=this.a.get(D);return y||(y=[],this.a.set(D,y)),y}dispose(){this.a.forEach((D,y)=>{for(const h of D)this.i(y).disposeTemplate(h.templateData),h.templateData=null}),this.a.clear(),this.b.clear()}i(D){const y=this.d.get(D);if(!y)throw new Error(`No renderer found for ${D}`);return y}}t.RowCache=i}),define(ge[117],me([1,0,9,2]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class i extends L.Disposable{constructor(D,y,h){super(),this.a=D,this.b=y,this.c=h,this.f=null,this.j=!1,this.i=!1,this.g=!1,this.h=!1,this.k=this.B(new E.TimeoutTimer)}setVisibility(D){this.a!==D&&(this.a=D,this.m())}setShouldBeVisible(D){this.g=D,this.m()}l(){return this.a===2?!1:this.a===3?!0:this.g}m(){const D=this.l();this.h!==D&&(this.h=D,this.ensureVisibility())}setIsNeeded(D){this.i!==D&&(this.i=D,this.ensureVisibility())}setDomNode(D){this.f=D,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.i){this.p(!1);return}this.h?this.n():this.p(!0)}n(){this.j||(this.j=!0,this.k.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}p(D){this.k.cancel(),this.j&&(this.j=!1,this.f?.setClassName(this.c+(D?" fade":"")))}}t.ScrollbarVisibilityController=i}),define(ge[118],me([1,0,4,23,13,3,2,5]),function(te,t,E,L,i,W,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class h extends D.Disposable{constructor(d,N,r,u){super(),this.f=0,this.b=u||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new W.Emitter),this.h=r,this.i(),this.setOptions(d,N)}i(){this.B(L.Gesture.addTarget(this.a)),[L.EventType.Tap].forEach(d=>{this.B(E.addDisposableListener(this.a,d,N=>{this.a.focus()}))}),this.B(E.addStandardDisposableListener(this.a,"click",d=>{E.EventHelper.stop(d,!0)})),this.B(E.addStandardDisposableListener(this.a,"change",d=>{this.a.title=d.target.value,this.g.fire({index:d.target.selectedIndex,selected:d.target.value})})),this.B(E.addStandardDisposableListener(this.a,"keydown",d=>{let N=!1;y.isMacintosh?(d.keyCode===18||d.keyCode===16||d.keyCode===10)&&(N=!0):(d.keyCode===18&&d.altKey||d.keyCode===10||d.keyCode===3)&&(N=!0),N&&d.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(d,N){(!this.c||!i.equals(this.c,d))&&(this.c=d,this.a.options.length=0,this.c.forEach((r,u)=>{this.a.add(this.j(r.text,u,r.isDisabled))})),N!==void 0&&this.select(N)}select(d){this.c.length===0?this.f=0:d>=0&&d<this.c.length?this.f=d:d>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(d){this.b.ariaLabel=d,this.a.setAttribute("aria-label",d)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(d){this.a.tabIndex=d?0:-1}render(d){d.classList.add("select-container"),d.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(d){this.h=d,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}j(d,N,r){const u=document.createElement("option");return u.value=d,u.text=d,u.disabled=!!r,u}}t.SelectBoxNative=h}),define(ge[55],me([1,0,24,13,9,46,112,3,26]),function(te,t,E,L,i,W,D,y,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function l(u){return typeof u=="object"&&"visibility"in u&&"data"in u}t.isFilterResult=l;function d(u){switch(u){case!0:return 1;case!1:return 0;default:return u}}t.getVisibleState=d;function N(u){return typeof u.collapsible=="boolean"}class r{constructor(e,a,n,c={}){this.o=e,this.p=a,this.rootRef=[],this.d=new y.EventBufferer,this.f=new y.Emitter,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new y.Emitter,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new y.Emitter,this.onDidSplice=this.l.event,this.m=new i.Delayer(W.MicrotaskDelay),this.h=typeof c.collapseByDefault>"u"?!1:c.collapseByDefault,this.j=c.filter,this.k=typeof c.autoExpandSingleChildren>"u"?!1:c.autoExpandSingleChildren,this.c={parent:void 0,element:n,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,a,n=h.Iterable.empty(),c={}){if(e.length===0)throw new E.TreeError(this.o,"Invalid tree location");c.diffIdentityProvider?this.q(c.diffIdentityProvider,e,a,n,c):this.s(e,a,n,c)}q(e,a,n,c=h.Iterable.empty(),s,w=s.diffDepth??0){const{parentNode:v}=this.G(a);if(!v.lastDiffIds)return this.s(a,n,c,s);const F=[...c],f=a[a.length-1],b=new D.LcsDiff({getElements:()=>v.lastDiffIds},{getElements:()=>[...v.children.slice(0,f),...F,...v.children.slice(f+n)].map(p=>e.getId(p.element).toString())}).ComputeDiff(!1);if(b.quitEarly)return v.lastDiffIds=void 0,this.s(a,n,F,s);const B=a.slice(0,-1),M=(p,I,O)=>{if(w>0)for(let U=0;U<O;U++)p--,I--,this.q(e,[...B,p,0],Number.MAX_SAFE_INTEGER,F[I].children,s,w-1)};let m=Math.min(v.children.length,f+n),g=F.length;for(const p of b.changes.sort((I,O)=>O.originalStart-I.originalStart))M(m,g,m-(p.originalStart+p.originalLength)),m=p.originalStart,g=p.modifiedStart-f,this.s([...B,m],p.originalLength,h.Iterable.slice(F,g,g+p.modifiedLength),s);M(m,g,m)}s(e,a,n=h.Iterable.empty(),{onDidCreateNode:c,onDidDeleteNode:s,diffIdentityProvider:w}){const{parentNode:v,listIndex:F,revealed:f,visible:b}=this.G(e),B=[],M=h.Iterable.map(n,ue=>this.w(ue,v,v.visible?1:0,f,B,c)),m=e[e.length-1],g=v.children.length>0;let p=0;for(let ue=m;ue>=0&&ue<v.children.length;ue--){const ae=v.children[ue];if(ae.visible){p=ae.visibleChildIndex;break}}const I=[];let O=0,U=0;for(const ue of M)I.push(ue),U+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=p+O++);const Z=(0,L.splice)(v.children,m,a,I);w?v.lastDiffIds?(0,L.splice)(v.lastDiffIds,m,a,I.map(ue=>w.getId(ue.element).toString())):v.lastDiffIds=v.children.map(ue=>w.getId(ue.element).toString()):v.lastDiffIds=void 0;let ne=0;for(const ue of Z)ue.visible&&ne++;if(ne!==0)for(let ue=m+I.length;ue<v.children.length;ue++){const ae=v.children[ue];ae.visible&&(ae.visibleChildIndex-=ne)}if(v.visibleChildrenCount+=O-ne,f&&b){const ue=Z.reduce((ae,oe)=>ae+(oe.visible?oe.renderNodeCount:0),0);this.B(v,U-ue),this.p.splice(F,ue,B)}if(Z.length>0&&s){const ue=ae=>{s(ae),ae.children.forEach(ue)};Z.forEach(ue)}this.l.fire({insertedNodes:I,deletedNodes:Z});const se=v.children.length>0;g!==se&&this.setCollapsible(e.slice(0,-1),se);let ce=v;for(;ce;){if(ce.visibility===2){this.m.trigger(()=>this.refilter());break}ce=ce.parent}}rerender(e){if(e.length===0)throw new E.TreeError(this.o,"Invalid tree location");const{node:a,listIndex:n,revealed:c}=this.F(e);a.visible&&c&&this.p.splice(n,1,[a])}updateElementHeight(e,a){if(e.length===0)throw new E.TreeError(this.o,"Invalid tree location");const{listIndex:n}=this.F(e);this.p.updateElementHeight(n,a)}has(e){return this.D(e)}getListIndex(e){const{listIndex:a,visible:n,revealed:c}=this.F(e);return n&&c?a:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,a){const n=this.E(e);typeof a>"u"&&(a=!n.collapsible);const c={collapsible:a};return this.d.bufferEvents(()=>this.t(e,c))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,a,n){const c=this.E(e);typeof a>"u"&&(a=!c.collapsed);const s={collapsed:a,recursive:n||!1};return this.d.bufferEvents(()=>this.t(e,s))}t(e,a){const{node:n,listIndex:c,revealed:s}=this.F(e),w=this.u(n,c,s,a);if(n!==this.c&&this.k&&w&&!N(a)&&n.collapsible&&!n.collapsed&&!a.recursive){let v=-1;for(let F=0;F<n.children.length;F++)if(n.children[F].visible)if(v>-1){v=-1;break}else v=F;v>-1&&this.t([...e,v],a)}return w}u(e,a,n,c){const s=this.v(e,c,!1);if(!n||!e.visible||!s)return s;const w=e.renderNodeCount,v=this.x(e),F=w-(a===-1?0:1);return this.p.splice(a+1,F,v.slice(1)),s}v(e,a,n){let c;if(e===this.c?c=!1:(N(a)?(c=e.collapsible!==a.collapsible,e.collapsible=a.collapsible):e.collapsible?(c=e.collapsed!==a.collapsed,e.collapsed=a.collapsed):c=!1,c&&this.f.fire({node:e,deep:n})),!N(a)&&a.recursive)for(const s of e.children)c=this.v(s,a,!0)||c;return c}expandTo(e){this.d.bufferEvents(()=>{let a=this.E(e);for(;a.parent;)a=a.parent,e=e.slice(0,e.length-1),a.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,a=this.z(this.c);this.p.splice(0,e,a),this.m.cancel()}w(e,a,n,c,s,w){const v={parent:a,element:e.element,children:[],depth:a.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},F=this.C(v,n);v.visibility=F,c&&s.push(v);const f=e.children||h.Iterable.empty(),b=c&&F!==0&&!v.collapsed;let B=0,M=1;for(const m of f){const g=this.w(m,v,F,b,s,w);v.children.push(g),M+=g.renderNodeCount,g.visible&&(g.visibleChildIndex=B++)}return v.collapsible=v.collapsible||v.children.length>0,v.visibleChildrenCount=B,v.visible=F===2?B>0:F===1,v.visible?v.collapsed||(v.renderNodeCount=M):(v.renderNodeCount=0,c&&s.pop()),w?.(v),v}x(e){const a=e.renderNodeCount,n=[];return this.y(e,n),this.B(e.parent,n.length-a),n}y(e,a){if(e.visible===!1)return 0;if(a.push(e),e.renderNodeCount=1,!e.collapsed)for(const n of e.children)e.renderNodeCount+=this.y(n,a);return this.g.fire(e),e.renderNodeCount}z(e){const a=e.renderNodeCount,n=[];return this.A(e,e.visible?1:0,n),this.B(e.parent,n.length-a),n}A(e,a,n,c=!0){let s;if(e!==this.c){if(s=this.C(e,a),s===0)return e.visible=!1,e.renderNodeCount=0,!1;c&&n.push(e)}const w=n.length;e.renderNodeCount=e===this.c?0:1;let v=!1;if(!e.collapsed||s!==0){let F=0;for(const f of e.children)v=this.A(f,s,n,c&&!e.collapsed)||v,f.visible&&(f.visibleChildIndex=F++);e.visibleChildrenCount=F}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=s===2?v:s===1,e.visibility=s),e.visible?e.collapsed||(e.renderNodeCount+=n.length-w):(e.renderNodeCount=0,c&&n.pop()),this.g.fire(e),e.visible}B(e,a){if(a!==0)for(;e;)e.renderNodeCount+=a,this.g.fire(e),e=e.parent}C(e,a){const n=this.j?this.j.filter(e.element,a):1;return typeof n=="boolean"?(e.filterData=void 0,n?1:0):l(n)?(e.filterData=n.data,d(n.visibility)):(e.filterData=void 0,d(n))}D(e,a=this.c){if(!e||e.length===0)return!0;const[n,...c]=e;return n<0||n>a.children.length?!1:this.D(c,a.children[n])}E(e,a=this.c){if(!e||e.length===0)return a;const[n,...c]=e;if(n<0||n>a.children.length)throw new E.TreeError(this.o,"Invalid tree location");return this.E(c,a.children[n])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:a,listIndex:n,revealed:c,visible:s}=this.G(e),w=e[e.length-1];if(w<0||w>a.children.length)throw new E.TreeError(this.o,"Invalid tree location");const v=a.children[w];return{node:v,listIndex:n,revealed:c,visible:s&&v.visible}}G(e,a=this.c,n=0,c=!0,s=!0){const[w,...v]=e;if(w<0||w>a.children.length)throw new E.TreeError(this.o,"Invalid tree location");for(let F=0;F<w;F++)n+=a.children[F].renderNodeCount;return c=c&&!a.collapsed,s=s&&a.visible,v.length===0?{parentNode:a,listIndex:n,revealed:c,visible:s}:this.G(v,a.children[w],n+1,c,s)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const a=[];let n=e;for(;n.parent;)a.push(n.parent.children.indexOf(n)),n=n.parent;return a.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,L.tail2)(e)[0]}getFirstElementChild(e){const a=this.E(e);if(a.children.length!==0)return a.children[0].element}getLastElementAncestor(e=[]){const a=this.E(e);if(a.children.length!==0)return this.H(a)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.IndexTreeModel=r}),define(ge[119],me([1,0,55,24,26]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class W{get size(){return this.d.size}constructor(y,h,l={}){this.k=y,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new E.IndexTreeModel(y,h,null,l),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,l.sorter&&(this.j={compare(d,N){return l.sorter.compare(d.element,N.element)}}),this.h=l.identityProvider}setChildren(y,h=i.Iterable.empty(),l={}){const d=this.o(y);this.l(d,this.m(h),l)}l(y,h=i.Iterable.empty(),l){const d=new Set,N=new Set,r=e=>{if(e.element===null)return;const a=e;if(d.add(a.element),this.d.set(a.element,a),this.h){const n=this.h.getId(a.element).toString();N.add(n),this.f.set(n,a)}l.onDidCreateNode?.(a)},u=e=>{if(e.element===null)return;const a=e;if(d.has(a.element)||this.d.delete(a.element),this.h){const n=this.h.getId(a.element).toString();N.has(n)||this.f.delete(n)}l.onDidDeleteNode?.(a)};this.c.splice([...y,0],Number.MAX_VALUE,h,{...l,onDidCreateNode:r,onDidDeleteNode:u})}m(y=i.Iterable.empty()){return this.j&&(y=[...y].sort(this.j.compare.bind(this.j))),i.Iterable.map(y,h=>{let l=this.d.get(h.element);if(!l&&this.h){const r=this.h.getId(h.element).toString();l=this.f.get(r)}if(!l){let r;return typeof h.collapsed>"u"?r=void 0:h.collapsed===L.ObjectTreeElementCollapseState.Collapsed||h.collapsed===L.ObjectTreeElementCollapseState.PreserveOrCollapsed?r=!0:h.collapsed===L.ObjectTreeElementCollapseState.Expanded||h.collapsed===L.ObjectTreeElementCollapseState.PreserveOrExpanded?r=!1:r=!!h.collapsed,{...h,children:this.m(h.children),collapsed:r}}const d=typeof h.collapsible=="boolean"?h.collapsible:l.collapsible;let N;return typeof h.collapsed>"u"||h.collapsed===L.ObjectTreeElementCollapseState.PreserveOrCollapsed||h.collapsed===L.ObjectTreeElementCollapseState.PreserveOrExpanded?N=l.collapsed:h.collapsed===L.ObjectTreeElementCollapseState.Collapsed?N=!0:h.collapsed===L.ObjectTreeElementCollapseState.Expanded?N=!1:N=!!h.collapsed,{...h,collapsible:d,collapsed:N,children:this.m(h.children)}})}rerender(y){const h=this.o(y);this.c.rerender(h)}updateElementHeight(y,h){const l=this.o(y);this.c.updateElementHeight(l,h)}resort(y=null,h=!0){if(!this.j)return;const l=this.o(y),d=this.c.getNode(l);this.l(l,this.n(d,h),{})}n(y,h,l=!0){let d=[...y.children];return(h||l)&&(d=d.sort(this.j.compare.bind(this.j))),i.Iterable.map(d,N=>({element:N.element,collapsible:N.collapsible,collapsed:N.collapsed,children:this.n(N,h,!1)}))}getFirstElementChild(y=null){const h=this.o(y);return this.c.getFirstElementChild(h)}getLastElementAncestor(y=null){const h=this.o(y);return this.c.getLastElementAncestor(h)}has(y){return this.d.has(y)}getListIndex(y){const h=this.o(y);return this.c.getListIndex(h)}getListRenderCount(y){const h=this.o(y);return this.c.getListRenderCount(h)}isCollapsible(y){const h=this.o(y);return this.c.isCollapsible(h)}setCollapsible(y,h){const l=this.o(y);return this.c.setCollapsible(l,h)}isCollapsed(y){const h=this.o(y);return this.c.isCollapsed(h)}setCollapsed(y,h,l){const d=this.o(y);return this.c.setCollapsed(d,h,l)}expandTo(y){const h=this.o(y);this.c.expandTo(h)}refilter(){this.c.refilter()}getNode(y=null){if(y===null)return this.c.getNode(this.c.rootRef);const h=this.d.get(y);if(!h)throw new L.TreeError(this.k,`Tree element not found: ${y}`);return h}getNodeLocation(y){return y.element}getParentNodeLocation(y){if(y===null)throw new L.TreeError(this.k,"Invalid getParentNodeLocation call");const h=this.d.get(y);if(!h)throw new L.TreeError(this.k,`Tree element not found: ${y}`);const l=this.c.getNodeLocation(h),d=this.c.getParentNodeLocation(l);return this.c.getNode(d).element}o(y){if(y===null)return[];const h=this.d.get(y);if(!h)throw new L.TreeError(this.k,`Tree element not found: ${y}`);return this.c.getNodeLocation(h)}}t.ObjectTreeModel=W}),define(ge[19],me([1,0,4,14,21,23,2]),function(te,t,E,L,i,W,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class y extends D.Disposable{f(l,d){this.B(E.addDisposableListener(l,E.EventType.CLICK,N=>d(new i.StandardMouseEvent(N))))}j(l,d){this.B(E.addDisposableListener(l,E.EventType.MOUSE_DOWN,N=>d(new i.StandardMouseEvent(N))))}k(l,d){this.B(E.addDisposableListener(l,E.EventType.MOUSE_OVER,N=>d(new i.StandardMouseEvent(N))))}m(l,d){this.B(E.addDisposableListener(l,E.EventType.MOUSE_LEAVE,N=>d(new i.StandardMouseEvent(N))))}p(l,d){this.B(E.addDisposableListener(l,E.EventType.KEY_DOWN,N=>d(new L.StandardKeyboardEvent(N))))}u(l,d){this.B(E.addDisposableListener(l,E.EventType.KEY_UP,N=>d(new L.StandardKeyboardEvent(N))))}z(l,d){this.B(E.addDisposableListener(l,E.EventType.INPUT,d))}C(l,d){this.B(E.addDisposableListener(l,E.EventType.BLUR,d))}D(l,d){this.B(E.addDisposableListener(l,E.EventType.FOCUS,d))}F(l,d){this.B(E.addDisposableListener(l,E.EventType.CHANGE,d))}G(l){return W.Gesture.ignoreTarget(l)}}t.Widget=y}),define(ge[36],me([1,0,53,19,9,17,4]),function(te,t,E,L,i,W,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class y extends L.Widget{constructor(l){super(),this.a=l.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=l.bgWidth+"px",this.bgDomNode.style.height=l.bgHeight+"px",typeof l.top<"u"&&(this.bgDomNode.style.top="0px"),typeof l.left<"u"&&(this.bgDomNode.style.left="0px"),typeof l.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof l.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=l.className,this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(l.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof l.top<"u"&&(this.domNode.style.top=l.top+"px"),typeof l.left<"u"&&(this.domNode.style.left=l.left+"px"),typeof l.bottom<"u"&&(this.domNode.style.bottom=l.bottom+"px"),typeof l.right<"u"&&(this.domNode.style.right=l.right+"px"),this.g=this.B(new E.GlobalPointerMoveMonitor),this.B(D.addStandardDisposableListener(this.bgDomNode,D.EventType.POINTER_DOWN,d=>this.h(d))),this.B(D.addStandardDisposableListener(this.domNode,D.EventType.POINTER_DOWN,d=>this.h(d))),this.b=this.B(new i.IntervalTimer),this.c=this.B(new i.TimeoutTimer)}h(l){if(!l.target||!(l.target instanceof Element))return;const d=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(d,200),this.g.startMonitoring(l.target,l.pointerId,l.buttons,N=>{},()=>{this.b.cancel(),this.c.cancel()}),l.preventDefault()}}t.ScrollbarArrow=y}),define(ge[56],me([1,0,4,39,53,36,117,19,5]),function(te,t,E,L,i,W,D,y,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const l=140;class d extends y.Widget{constructor(r){super(),this.g=r.lazyRender,this.a=r.host,this.b=r.scrollable,this.c=r.scrollByPage,this.h=r.scrollbarState,this.i=this.B(new D.ScrollbarVisibilityController(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this.i.setIsNeeded(this.h.isNeeded()),this.l=this.B(new i.GlobalPointerMoveMonitor),this.n=!0,this.domNode=(0,L.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.i.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(E.addDisposableListener(this.domNode.domNode,E.EventType.POINTER_DOWN,u=>this.y(u)))}r(r){const u=this.B(new W.ScrollbarArrow(r));this.domNode.domNode.appendChild(u.bgDomNode),this.domNode.domNode.appendChild(u.domNode)}s(r,u,e,a){this.slider=(0,L.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(u),typeof e=="number"&&this.slider.setWidth(e),typeof a=="number"&&this.slider.setHeight(a),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(E.addDisposableListener(this.slider.domNode,E.EventType.POINTER_DOWN,n=>{n.button===0&&(n.preventDefault(),this.I(n))})),this.f(this.slider.domNode,n=>{n.leftButton&&n.stopPropagation()})}t(r){return this.h.setVisibleSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}v(r){return this.h.setScrollSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}w(r){return this.h.setScrollPosition(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}beginReveal(){this.i.setShouldBeVisible(!0)}beginHide(){this.i.setShouldBeVisible(!1)}render(){this.n&&(this.n=!1,this.L(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.M(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}y(r){r.target===this.domNode.domNode&&this.H(r)}delegatePointerDown(r){const u=this.domNode.domNode.getClientRects()[0].top,e=u+this.h.getSliderPosition(),a=u+this.h.getSliderPosition()+this.h.getSliderSize(),n=this.O(r);e<=n&&n<=a?r.button===0&&(r.preventDefault(),this.I(r)):this.H(r)}H(r){let u,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")u=r.offsetX,e=r.offsetY;else{const n=E.getDomNodePagePosition(this.domNode.domNode);u=r.pageX-n.left,e=r.pageY-n.top}const a=this.N(u,e);this.J(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(a):this.h.getDesiredScrollPositionFromOffset(a)),r.button===0&&(r.preventDefault(),this.I(r))}I(r){if(!r.target||!(r.target instanceof Element))return;const u=this.O(r),e=this.P(r),a=this.h.clone();this.slider.toggleClassName("active",!0),this.l.startMonitoring(r.target,r.pointerId,r.buttons,n=>{const c=this.P(n),s=Math.abs(c-e);if(h.isWindows&&s>l){this.J(a.getScrollPosition());return}const v=this.O(n)-u;this.J(a.getDesiredScrollPositionFromDelta(v))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}J(r){const u={};this.writeScrollPosition(u,r),this.b.setScrollPositionNow(u)}updateScrollbarSize(r){this.Q(r),this.h.setScrollbarSize(r),this.n=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.AbstractScrollbar=d}),define(ge[120],me([1,0,21,56,36,40,16]),function(te,t,E,L,i,W,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class y extends L.AbstractScrollbar{constructor(l,d,N){const r=l.getScrollDimensions(),u=l.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:N,scrollbarState:new W.ScrollbarState(d.horizontalHasArrows?d.arrowSize:0,d.horizontal===2?0:d.horizontalScrollbarSize,d.vertical===2?0:d.verticalScrollbarSize,r.width,r.scrollWidth,u.scrollLeft),visibility:d.horizontal,extraScrollbarClassName:"horizontal",scrollable:l,scrollByPage:d.scrollByPage}),d.horizontalHasArrows){const e=(d.arrowSize-i.ARROW_IMG_SIZE)/2,a=(d.horizontalScrollbarSize-i.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:D.Codicon.scrollbarButtonLeft,top:a,left:e,bottom:void 0,right:void 0,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,1,0))}),this.r({className:"scra",icon:D.Codicon.scrollbarButtonRight,top:a,left:void 0,bottom:void 0,right:e,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,-1,0))})}this.s(Math.floor((d.horizontalScrollbarSize-d.horizontalSliderSize)/2),0,void 0,d.horizontalSliderSize)}M(l,d){this.slider.setWidth(l),this.slider.setLeft(d)}L(l,d){this.domNode.setWidth(l),this.domNode.setHeight(d),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(l){return this.n=this.v(l.scrollWidth)||this.n,this.n=this.w(l.scrollLeft)||this.n,this.n=this.t(l.width)||this.n,this.n}N(l,d){return l}O(l){return l.pageX}P(l){return l.pageY}Q(l){this.slider.setHeight(l)}writeScrollPosition(l,d){l.scrollLeft=d}updateOptions(l){this.updateScrollbarSize(l.horizontal===2?0:l.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(l.vertical===2?0:l.verticalScrollbarSize),this.i.setVisibility(l.horizontal),this.c=l.scrollByPage}}t.HorizontalScrollbar=y}),define(ge[121],me([1,0,21,56,36,40,16]),function(te,t,E,L,i,W,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class y extends L.AbstractScrollbar{constructor(l,d,N){const r=l.getScrollDimensions(),u=l.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:N,scrollbarState:new W.ScrollbarState(d.verticalHasArrows?d.arrowSize:0,d.vertical===2?0:d.verticalScrollbarSize,0,r.height,r.scrollHeight,u.scrollTop),visibility:d.vertical,extraScrollbarClassName:"vertical",scrollable:l,scrollByPage:d.scrollByPage}),d.verticalHasArrows){const e=(d.arrowSize-i.ARROW_IMG_SIZE)/2,a=(d.verticalScrollbarSize-i.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:D.Codicon.scrollbarButtonUp,top:e,left:a,bottom:void 0,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,0,1))}),this.r({className:"scra",icon:D.Codicon.scrollbarButtonDown,top:void 0,left:a,bottom:e,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,0,-1))})}this.s(0,Math.floor((d.verticalScrollbarSize-d.verticalSliderSize)/2),d.verticalSliderSize,void 0)}M(l,d){this.slider.setHeight(l),this.slider.setTop(d)}L(l,d){this.domNode.setWidth(d),this.domNode.setHeight(l),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(l){return this.n=this.v(l.scrollHeight)||this.n,this.n=this.w(l.scrollTop)||this.n,this.n=this.t(l.height)||this.n,this.n}N(l,d){return d}O(l){return l.pageY}P(l){return l.pageX}Q(l){this.slider.setWidth(l)}writeScrollPosition(l,d){l.scrollTop=d}updateOptions(l){this.updateScrollbarSize(l.vertical===2?0:l.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.i.setVisibility(l.vertical),this.c=l.scrollByPage}}t.VerticalScrollbar=y}),define(ge[57],me([1,0,18,4,39,21,120,121,19,9,3,2,5,49,90]),function(te,t,E,L,i,W,D,y,h,l,d,N,r,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,a=50,n=!0;class c{constructor(M,m,g){this.timestamp=M,this.deltaX=m,this.deltaY=g,this.score=0}}class s{constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let M=1,m=0,g=1,p=this.d;do{const I=p===this.c?M:Math.pow(2,-g);if(M-=I,m+=this.b[p].score*I,p===this.c)break;p=(this.a+p-1)%this.a,g++}while(!0);return m<=.5}acceptStandardWheelEvent(M){const m=window.devicePixelRatio/(0,E.getZoomFactor)();r.isWindows||r.isLinux?this.accept(Date.now(),M.deltaX/m,M.deltaY/m):this.accept(Date.now(),M.deltaX,M.deltaY)}accept(M,m,g){const p=new c(M,m,g);p.score=this.f(p),this.c===-1&&this.d===-1?(this.b[0]=p,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=p)}f(M){if(Math.abs(M.deltaX)>0&&Math.abs(M.deltaY)>0)return 1;let m=.5;const g=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(M.deltaX)||!this.g(M.deltaY))&&(m+=.25),Math.min(Math.max(m,0),1)}g(M){return Math.abs(Math.round(M)-M)<.01}}t.MouseWheelClassifier=s,s.INSTANCE=new s;class w extends h.Widget{get options(){return this.a}constructor(M,m,g){super(),this.I=this.B(new d.Emitter),this.onScroll=this.I.event,this.J=this.B(new d.Emitter),this.onWillScroll=this.J.event,M.style.overflow="hidden",this.a=b(m),this.b=g,this.B(this.b.onScroll(I=>{this.J.fire(I),this.N(I),this.I.fire(I)}));const p={onMouseWheel:I=>this.M(I),onDragStart:()=>this.P(),onDragEnd:()=>this.Q()};this.c=this.B(new y.VerticalScrollbar(this.b,this.a,p)),this.g=this.B(new D.HorizontalScrollbar(this.b,this.a,p)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(M),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.i=(0,i.createFastDomNode)(document.createElement("div")),this.i.setClassName("shadow"),this.h.appendChild(this.i.domNode),this.l=(0,i.createFastDomNode)(document.createElement("div")),this.l.setClassName("shadow"),this.h.appendChild(this.l.domNode),this.n=(0,i.createFastDomNode)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode)):(this.i=null,this.l=null,this.n=null),this.r=this.a.listenOnDomNode||this.h,this.s=[],this.L(this.a.handleMouseWheel),this.k(this.r,I=>this.S(I)),this.m(this.r,I=>this.R(I)),this.w=this.B(new l.TimeoutTimer),this.t=!1,this.v=!1,this.y=!0,this.H=!0}dispose(){this.s=(0,N.dispose)(this.s),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(M){this.c.delegatePointerDown(M)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(M){this.b.setScrollDimensions(M,!1)}updateClassName(M){this.a.className=M,r.isMacintosh&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(M){typeof M.handleMouseWheel<"u"&&(this.a.handleMouseWheel=M.handleMouseWheel,this.L(this.a.handleMouseWheel)),typeof M.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=M.mouseWheelScrollSensitivity),typeof M.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=M.fastScrollSensitivity),typeof M.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=M.scrollPredominantAxis),typeof M.horizontal<"u"&&(this.a.horizontal=M.horizontal),typeof M.vertical<"u"&&(this.a.vertical=M.vertical),typeof M.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=M.horizontalScrollbarSize),typeof M.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=M.verticalScrollbarSize),typeof M.scrollByPage<"u"&&(this.a.scrollByPage=M.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.O()}setRevealOnScroll(M){this.H=M}delegateScrollFromMouseWheelEvent(M){this.M(new W.StandardWheelEvent(M))}L(M){if(this.s.length>0!==M&&(this.s=(0,N.dispose)(this.s),M)){const g=p=>{this.M(new W.StandardWheelEvent(p))};this.s.push(L.addDisposableListener(this.r,L.EventType.MOUSE_WHEEL,g,{passive:!1}))}}M(M){const m=s.INSTANCE;n&&m.acceptStandardWheelEvent(M);let g=!1;if(M.deltaY||M.deltaX){let I=M.deltaY*this.a.mouseWheelScrollSensitivity,O=M.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(Math.abs(I)>=Math.abs(O)?O=0:I=0),this.a.flipAxes&&([I,O]=[O,I]);const U=!r.isMacintosh&&M.browserEvent&&M.browserEvent.shiftKey;(this.a.scrollYToX||U)&&!O&&(O=I,I=0),M.browserEvent&&M.browserEvent.altKey&&(O=O*this.a.fastScrollSensitivity,I=I*this.a.fastScrollSensitivity);const Z=this.b.getFutureScrollPosition();let ne={};if(I){const se=a*I,ce=Z.scrollTop-(se<0?Math.floor(se):Math.ceil(se));this.c.writeScrollPosition(ne,ce)}if(O){const se=a*O,ce=Z.scrollLeft-(se<0?Math.floor(se):Math.ceil(se));this.g.writeScrollPosition(ne,ce)}ne=this.b.validateScrollPosition(ne),(Z.scrollLeft!==ne.scrollLeft||Z.scrollTop!==ne.scrollTop)&&(n&&this.a.mouseWheelSmoothScroll&&m.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(ne):this.b.setScrollPositionNow(ne),g=!0)}let p=g;!p&&this.a.alwaysConsumeMouseWheel&&(p=!0),!p&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(p=!0),p&&(M.preventDefault(),M.stopPropagation())}N(M){this.y=this.g.onDidScroll(M)||this.y,this.y=this.c.onDidScroll(M)||this.y,this.a.useShadows&&(this.y=!0),this.H&&this.U(),this.a.lazyRender||this.O()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.O()}O(){if(this.y&&(this.y=!1,this.g.render(),this.c.render(),this.a.useShadows)){const M=this.b.getCurrentScrollPosition(),m=M.scrollTop>0,g=M.scrollLeft>0,p=g?" left":"",I=m?" top":"",O=g||m?" top-left-corner":"";this.i.setClassName(`shadow${p}`),this.l.setClassName(`shadow${I}`),this.n.setClassName(`shadow${O}${I}${p}`)}}P(){this.t=!0,this.U()}Q(){this.t=!1,this.W()}R(M){this.v=!1,this.W()}S(M){this.v=!0,this.U()}U(){this.c.beginReveal(),this.g.beginReveal(),this.X()}W(){!this.v&&!this.t&&(this.c.beginHide(),this.g.beginHide())}X(){!this.v&&!this.t&&this.w.cancelAndSet(()=>this.W(),e)}}t.AbstractScrollableElement=w;class v extends w{constructor(M,m){m=m||{},m.mouseWheelSmoothScroll=!1;const g=new u.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:p=>L.scheduleAtNextAnimationFrame(p)});super(M,m,g),this.B(g)}setScrollPosition(M){this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.ScrollableElement=v;class F extends w{constructor(M,m,g){super(M,m,g)}setScrollPosition(M){M.reuseAnimation?this.b.setScrollPositionSmooth(M,M.reuseAnimation):this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.SmoothScrollableElement=F;class f extends w{constructor(M,m){m=m||{},m.mouseWheelSmoothScroll=!1;const g=new u.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:p=>L.scheduleAtNextAnimationFrame(p)});super(M,m,g),this.B(g),this.Y=M,this.onScroll(p=>{p.scrollTopChanged&&(this.Y.scrollTop=p.scrollTop),p.scrollLeftChanged&&(this.Y.scrollLeft=p.scrollLeft)}),this.scanDomNode()}setScrollPosition(M){this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.Y.clientWidth,scrollWidth:this.Y.scrollWidth,height:this.Y.clientHeight,scrollHeight:this.Y.scrollHeight}),this.setScrollPosition({scrollLeft:this.Y.scrollLeft,scrollTop:this.Y.scrollTop})}}t.DomScrollableElement=f;function b(B){const M={lazyRender:typeof B.lazyRender<"u"?B.lazyRender:!1,className:typeof B.className<"u"?B.className:"",useShadows:typeof B.useShadows<"u"?B.useShadows:!0,handleMouseWheel:typeof B.handleMouseWheel<"u"?B.handleMouseWheel:!0,flipAxes:typeof B.flipAxes<"u"?B.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof B.consumeMouseWheelIfScrollbarIsNeeded<"u"?B.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof B.alwaysConsumeMouseWheel<"u"?B.alwaysConsumeMouseWheel:!1,scrollYToX:typeof B.scrollYToX<"u"?B.scrollYToX:!1,mouseWheelScrollSensitivity:typeof B.mouseWheelScrollSensitivity<"u"?B.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof B.fastScrollSensitivity<"u"?B.fastScrollSensitivity:5,scrollPredominantAxis:typeof B.scrollPredominantAxis<"u"?B.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof B.mouseWheelSmoothScroll<"u"?B.mouseWheelSmoothScroll:!0,arrowSize:typeof B.arrowSize<"u"?B.arrowSize:11,listenOnDomNode:typeof B.listenOnDomNode<"u"?B.listenOnDomNode:null,horizontal:typeof B.horizontal<"u"?B.horizontal:1,horizontalScrollbarSize:typeof B.horizontalScrollbarSize<"u"?B.horizontalScrollbarSize:10,horizontalSliderSize:typeof B.horizontalSliderSize<"u"?B.horizontalSliderSize:0,horizontalHasArrows:typeof B.horizontalHasArrows<"u"?B.horizontalHasArrows:!1,vertical:typeof B.vertical<"u"?B.vertical:1,verticalScrollbarSize:typeof B.verticalScrollbarSize<"u"?B.verticalScrollbarSize:10,verticalHasArrows:typeof B.verticalHasArrows<"u"?B.verticalHasArrows:!1,verticalSliderSize:typeof B.verticalSliderSize<"u"?B.verticalSliderSize:0,scrollByPage:typeof B.scrollByPage<"u"?B.scrollByPage:!1};return M.horizontalSliderSize=typeof B.horizontalSliderSize<"u"?B.horizontalSliderSize:M.horizontalScrollbarSize,M.verticalSliderSize=typeof B.verticalSliderSize<"u"?B.verticalSliderSize:M.verticalScrollbarSize,r.isMacintosh&&(M.className+=" mac"),M}}),define(ge[58],me([1,0,51,4,20,23,57,13,9,25,3,2,45,49,79,116,7]),function(te,t,E,L,i,W,D,y,h,l,d,N,r,u,e,a,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const c={CurrentDragAndDropData:void 0},s={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(M){return[M]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class w{get context(){return this.d}set context(m){this.d=m}constructor(m){this.elements=m}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=w;class v{constructor(m){this.elements=m}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=v;class F{constructor(){this.types=[],this.files=[]}update(m){if(m.types&&this.types.splice(0,this.types.length,...m.types),m.files){this.files.splice(0,this.files.length);for(let g=0;g<m.files.length;g++){const p=m.files.item(g);p&&(p.size||p.type)&&this.files.push(p)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=F;function f(M,m){return Array.isArray(M)&&Array.isArray(m)?(0,y.equals)(M,m):M===m}class b{constructor(m){m?.getSetSize?this.getSetSize=m.getSetSize.bind(m):this.getSetSize=(g,p,I)=>I,m?.getPosInSet?this.getPosInSet=m.getPosInSet.bind(m):this.getPosInSet=(g,p)=>p+1,m?.getRole?this.getRole=m.getRole.bind(m):this.getRole=g=>"listitem",m?.isChecked?this.isChecked=m.isChecked.bind(m):this.isChecked=g=>{}}}class B{get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(m){if(m!==this.O){if(m&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=m,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const g of this.d)this.Y(g);this.V(),this.q.setScrollDimensions({width:(0,L.getContentWidth)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(m,g,p,I=s){if(this.Q=g,this.domId=`list_id_${++B.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new h.Delayer(50),this.v=!1,this.x=N.Disposable.None,this.y=0,this.G=!1,this.J=N.Disposable.None,this.K=N.Disposable.None,this.L=new N.DisposableStore,this.M=new d.Emitter,this.N=new d.Emitter,this.onDidChangeContentHeight=d.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=d.Event.latch(this.N.event,void 0,this.L),this.O=!1,I.horizontalScrolling&&I.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.RangeMap;for(const U of p)this.j.set(U.templateId,U);this.h=this.L.add(new a.RowCache(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof I.mouseSupport=="boolean"?I.mouseSupport:!0),this.O=I.horizontalScrolling??s.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof I.additionalScrollHeight>"u"?0:I.additionalScrollHeight,this.D=new b(I.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(I.transformOptimization??s.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(W.Gesture.addTarget(this.o)),this.p=new u.Scrollable({forceIntegerValues:!0,smoothScrollDuration:I.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:U=>(0,L.scheduleAtNextAnimationFrame)(U)}),this.q=this.L.add(new D.SmoothScrollableElement(this.o,{alwaysConsumeMouseWheel:I.alwaysConsumeMouseWheel??s.alwaysConsumeMouseWheel,horizontal:1,vertical:I.verticalScrollMode??s.verticalScrollMode,useShadows:I.useShadows??s.useShadows,mouseWheelScrollSensitivity:I.mouseWheelScrollSensitivity,fastScrollSensitivity:I.fastScrollSensitivity,scrollByPage:I.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),m.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,L.addDisposableListener)(this.o,W.EventType.Change,U=>this.hb(U))),this.L.add((0,L.addDisposableListener)(this.q.getDomNode(),"scroll",U=>U.target.scrollTop=0)),this.L.add((0,L.addDisposableListener)(this.domNode,"dragover",U=>this.jb(this.fb(U)))),this.L.add((0,L.addDisposableListener)(this.domNode,"drop",U=>this.lb(this.fb(U)))),this.L.add((0,L.addDisposableListener)(this.domNode,"dragleave",U=>this.kb(this.fb(U)))),this.L.add((0,L.addDisposableListener)(this.domNode,"dragend",U=>this.mb(U))),this.z=I.setRowLineHeight??s.setRowLineHeight,this.A=I.setRowHeight??s.setRowHeight,this.B=I.supportDynamicHeights??s.supportDynamicHeights,this.F=I.dnd??s.dnd,this.layout(I.initialSize?.height,I.initialSize?.width)}updateOptions(m){m.additionalScrollHeight!==void 0&&(this.C=m.additionalScrollHeight,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),m.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(m.smoothScrolling?125:0),m.horizontalScrolling!==void 0&&(this.P=m.horizontalScrolling);let g;m.scrollByPage!==void 0&&(g={...g??{},scrollByPage:m.scrollByPage}),m.mouseWheelScrollSensitivity!==void 0&&(g={...g??{},mouseWheelScrollSensitivity:m.mouseWheelScrollSensitivity}),m.fastScrollSensitivity!==void 0&&(g={...g??{},fastScrollSensitivity:m.fastScrollSensitivity}),g&&this.q.updateOptions(g)}delegateScrollFromMouseWheelEvent(m){this.q.delegateScrollFromMouseWheelEvent(m)}delegateVerticalScrollbarPointerDown(m){this.q.delegateVerticalScrollbarPointerDown(m)}updateElementHeight(m,g,p){if(m<0||m>=this.d.length)return;const I=this.d[m].size;if(typeof g>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[m].lastDynamicHeightWidth=void 0,g=I+this.ub(m)}if(I===g)return;const O=this.sb(this.k,this.m);let U=0;m<O.start||p!==null&&p>m&&p<=O.end?U=g-I:U=0,this.g.splice(m,1,[{size:g}]),this.d[m].size=g,this.W(O,Math.max(0,this.k+U),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(m,g,p=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(m,g,p)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(m,g,p=[]){const I=this.sb(this.k,this.m),O={start:m,end:m+g},U=r.Range.intersect(I,O),Z=new Map;for(let V=U.end-1;V>=U.start;V--){const A=this.d[V];if(A.dragStartDisposable.dispose(),A.checkedDisposable.dispose(),A.row){let K=Z.get(A.templateId);K||(K=[],Z.set(A.templateId,K));const x=this.j.get(A.templateId);x&&x.disposeElement&&x.disposeElement(A.element,V,A.row.templateData,A.size),K.push(A.row)}A.row=null}const ne={start:m+g,end:this.d.length},se=r.Range.intersect(ne,I),ce=r.Range.relativeComplement(ne,I),ue=p.map(V=>({id:String(this.f++),element:V,templateId:this.Q.getTemplateId(V),size:this.Q.getHeight(V),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(V),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:N.Disposable.None,checkedDisposable:N.Disposable.None}));let ae;m===0&&g>=this.d.length?(this.g=new e.RangeMap,this.g.splice(0,0,ue),ae=this.d,this.d=ue):(this.g.splice(m,g,ue),ae=this.d.splice(m,g,...ue));const oe=p.length-g,ye=this.sb(this.k,this.m),ke=(0,e.shift)(se,oe),Be=r.Range.intersect(ye,ke);for(let V=Be.start;V<Be.end;V++)this.Z(this.d[V],V);const Me=r.Range.relativeComplement(ke,ye);for(const V of Me)for(let A=V.start;A<V.end;A++)this.ab(A);const fe=ce.map(V=>(0,e.shift)(V,oe)),ie=[{start:m,end:m+p.length},...fe].map(V=>r.Range.intersect(ye,V)),q=this.vb(ie);for(const V of ie)for(let A=V.start;A<V.end;A++){const K=this.d[A],o=Z.get(K.templateId)?.pop();this.X(A,q,o)}for(const V of Z.values())for(const A of V)this.h.release(A);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),ae.map(V=>V.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,L.scheduleAtNextAnimationFrame)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let m=0;for(const g of this.d)typeof g.width<"u"&&(m=Math.max(m,g.width));this.E=m,this.q.setScrollDimensions({scrollWidth:m===0?0:m+10}),this.N.fire(this.E)}updateWidth(m){if(!this.P||typeof this.E>"u")return;const g=this.d[m];this.Y(g),typeof g.width<"u"&&g.width>this.E&&(this.E=g.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const m of this.d)m.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const m=this.sb(this.k,this.m),g=this.g.positionAt(m.start),p=this.g.positionAt(m.start+1);return p!==-1&&(p-g)/2+g<this.scrollTop?m.start+1:m.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(m){return this.d[m].element}indexOf(m){return this.d.findIndex(g=>g.element===m)}domElement(m){const g=this.d[m].row;return g&&g.domNode}elementHeight(m){return this.d[m].size}elementTop(m){return this.g.positionAt(m)}indexAt(m){return this.g.indexAt(m)}indexAfter(m){return this.g.indexAfter(m)}layout(m,g){const p={height:typeof m=="number"?m:(0,L.getContentHeight)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,p.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(p),typeof g<"u"&&(this.n=g,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof g=="number"?g:(0,L.getContentWidth)(this.domNode)})}W(m,g,p,I,O,U=!1){const Z=this.sb(g,p),ne=r.Range.relativeComplement(Z,m),se=r.Range.relativeComplement(m,Z),ce=this.vb(ne);if(U){const ue=r.Range.intersect(m,Z);for(let ae=ue.start;ae<ue.end;ae++)this.Z(this.d[ae],ae)}this.h.transact(()=>{for(const ue of se)for(let ae=ue.start;ae<ue.end;ae++)this.ab(ae);for(const ue of ne)for(let ae=ue.start;ae<ue.end;ae++)this.X(ae,ce)}),I!==void 0&&(this.o.style.left=`-${I}px`),this.o.style.top=`-${g}px`,this.P&&O!==void 0&&(this.o.style.width=`${Math.max(O,this.n)}px`),this.k=g,this.m=p}X(m,g,p){const I=this.d[m];let O=!1;if(!I.row)if(p)I.row=p;else{const ce=this.h.alloc(I.templateId);I.row=ce.row,O=ce.isReusingConnectedDomNode}const U=this.D.getRole(I.element)||"listitem";I.row.domNode.setAttribute("role",U);const Z=this.D.isChecked(I.element);if(typeof Z=="boolean")I.row.domNode.setAttribute("aria-checked",String(!!Z));else if(Z){const ce=ue=>I.row.domNode.setAttribute("aria-checked",String(!!ue));ce(Z.value),I.checkedDisposable=Z.onDidChange(ce)}(O||!I.row.domNode.parentElement)&&(g?this.o.insertBefore(I.row.domNode,g):this.o.appendChild(I.row.domNode)),this.Z(I,m);const ne=this.j.get(I.templateId);if(!ne)throw new Error(`No renderer found for template id ${I.templateId}`);ne?.renderElement(I.element,m,I.row.templateData,I.size);const se=this.F.getDragURI(I.element);I.dragStartDisposable.dispose(),I.row.domNode.draggable=!!se,se&&(I.dragStartDisposable=(0,L.addDisposableListener)(I.row.domNode,"dragstart",ce=>this.ib(I.element,se,ce))),this.P&&(this.Y(I),this.U())}Y(m){if(!m.row||!m.row.domNode)return;m.row.domNode.style.width="fit-content",m.width=(0,L.getContentWidth)(m.row.domNode);const g=window.getComputedStyle(m.row.domNode);g.paddingLeft&&(m.width+=parseFloat(g.paddingLeft)),g.paddingRight&&(m.width+=parseFloat(g.paddingRight)),m.row.domNode.style.width=""}Z(m,g){m.row.domNode.style.top=`${this.elementTop(g)}px`,this.A&&(m.row.domNode.style.height=`${m.size}px`),this.z&&(m.row.domNode.style.lineHeight=`${m.size}px`),m.row.domNode.setAttribute("data-index",`${g}`),m.row.domNode.setAttribute("data-last-element",g===this.length-1?"true":"false"),m.row.domNode.setAttribute("data-parity",g%2===0?"even":"odd"),m.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(m.element,g,this.length))),m.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(m.element,g))),m.row.domNode.setAttribute("id",this.getElementDomId(g)),m.row.domNode.classList.toggle("drop-target",m.dropTarget)}ab(m){const g=this.d[m];if(g.dragStartDisposable.dispose(),g.checkedDisposable.dispose(),g.row){const p=this.j.get(g.templateId);p&&p.disposeElement&&p.disposeElement(g.element,m,g.row.templateData,g.size),this.h.release(g.row),g.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(m,g){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:m,reuseAnimation:g})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(m){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:m})}get scrollTop(){return this.getScrollTop()}set scrollTop(m){this.setScrollTop(m)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return d.Event.map(this.L.add(new i.DomEmitter(this.domNode,"click")).event,m=>this.bb(m),this.L)}get onMouseDblClick(){return d.Event.map(this.L.add(new i.DomEmitter(this.domNode,"dblclick")).event,m=>this.bb(m),this.L)}get onMouseMiddleClick(){return d.Event.filter(d.Event.map(this.L.add(new i.DomEmitter(this.domNode,"auxclick")).event,m=>this.bb(m),this.L),m=>m.browserEvent.button===1,this.L)}get onMouseUp(){return d.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mouseup")).event,m=>this.bb(m),this.L)}get onMouseDown(){return d.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mousedown")).event,m=>this.bb(m),this.L)}get onMouseOver(){return d.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mouseover")).event,m=>this.bb(m),this.L)}get onMouseMove(){return d.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mousemove")).event,m=>this.bb(m),this.L)}get onMouseOut(){return d.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mouseout")).event,m=>this.bb(m),this.L)}get onContextMenu(){return d.Event.any(d.Event.map(this.L.add(new i.DomEmitter(this.domNode,"contextmenu")).event,m=>this.bb(m),this.L),d.Event.map(this.L.add(new i.DomEmitter(this.domNode,W.EventType.Contextmenu)).event,m=>this.eb(m),this.L))}get onTouchStart(){return d.Event.map(this.L.add(new i.DomEmitter(this.domNode,"touchstart")).event,m=>this.db(m),this.L)}get onTap(){return d.Event.map(this.L.add(new i.DomEmitter(this.o,W.EventType.Tap)).event,m=>this.eb(m),this.L)}bb(m){const g=this.rb(m.target||null),p=typeof g>"u"?void 0:this.d[g],I=p&&p.element;return{browserEvent:m,index:g,element:I}}db(m){const g=this.rb(m.target||null),p=typeof g>"u"?void 0:this.d[g],I=p&&p.element;return{browserEvent:m,index:g,element:I}}eb(m){const g=this.rb(m.initialTarget||null),p=typeof g>"u"?void 0:this.d[g],I=p&&p.element;return{browserEvent:m,index:g,element:I}}fb(m){const g=this.rb(m.target||null),p=typeof g>"u"?void 0:this.d[g],I=p&&p.element;return{browserEvent:m,index:g,element:I}}gb(m){try{const g=this.sb(this.k,this.m);this.W(g,m.scrollTop,m.height,m.scrollLeft,m.scrollWidth),this.B&&this.tb(m.scrollTop,m.height,m.inSmoothScrolling)}catch(g){throw console.error("Got bad scroll event:",m),g}}hb(m){m.preventDefault(),m.stopPropagation(),this.scrollTop-=m.translationY}ib(m,g,p){if(!p.dataTransfer)return;const I=this.F.getDragElements(m);if(p.dataTransfer.effectAllowed="copyMove",p.dataTransfer.setData(E.DataTransfers.TEXT,g),p.dataTransfer.setDragImage){let O;this.F.getDragLabel&&(O=this.F.getDragLabel(I,p)),typeof O>"u"&&(O=String(I.length));const U=(0,L.$)(".monaco-drag-image");U.textContent=O;const ne=(se=>{for(;se&&!se.classList.contains("monaco-workbench");)se=se.parentElement;return se||document.body})(this.domNode);ne.appendChild(U),p.dataTransfer.setDragImage(U,-10,-10),setTimeout(()=>ne.removeChild(U),0)}this.domNode.classList.add("dragging"),this.H=new w(I),c.CurrentDragAndDropData=new v(I),this.F.onDragStart?.(this.H,p)}jb(m){if(m.browserEvent.preventDefault(),this.K.dispose(),c.CurrentDragAndDropData&&c.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(m.browserEvent),!m.browserEvent.dataTransfer))return!1;if(!this.H)if(c.CurrentDragAndDropData)this.H=c.CurrentDragAndDropData;else{if(!m.browserEvent.dataTransfer.types)return!1;this.H=new F}const g=this.F.onDragOver(this.H,m.element,m.index,m.browserEvent);if(this.G=typeof g=="boolean"?g:g.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;m.browserEvent.dataTransfer.dropEffect=typeof g!="boolean"&&g.effect===0?"copy":"move";let p;if(typeof g!="boolean"&&g.feedback?p=g.feedback:typeof m.index>"u"?p=[-1]:p=[m.index],p=(0,y.distinct)(p).filter(I=>I>=-1&&I<this.length).sort((I,O)=>I-O),p=p[0]===-1?[-1]:p,f(this.I,p))return!0;if(this.I=p,this.J.dispose(),p[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,N.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const I of p){const O=this.d[I];O.dropTarget=!0,O.row?.domNode.classList.add("drop-target")}this.J=(0,N.toDisposable)(()=>{for(const I of p){const O=this.d[I];O.dropTarget=!1,O.row?.domNode.classList.remove("drop-target")}})}return!0}kb(m){this.K.dispose(),this.K=(0,h.disposableTimeout)(()=>this.nb(),100),this.H&&this.F.onDragLeave?.(this.H,m.element,m.index,m.browserEvent)}lb(m){if(!this.G)return;const g=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,c.CurrentDragAndDropData=void 0,!(!g||!m.browserEvent.dataTransfer)&&(m.browserEvent.preventDefault(),g.update(m.browserEvent.dataTransfer),this.F.drop(g,m.element,m.index,m.browserEvent))}mb(m){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,c.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(m)}nb(){this.I=void 0,this.J.dispose(),this.J=N.Disposable.None}ob(m){if(!this.w){const g=(0,L.getTopLeftOffset)(this.domNode).top;this.w=(0,L.animate)(this.pb.bind(this,g))}this.x.dispose(),this.x=(0,h.disposableTimeout)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=m.pageY}pb(m){if(this.y===void 0)return;const g=this.y-m,p=this.renderHeight-35;g<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(g-35))):g>p&&(this.scrollTop+=Math.min(14,Math.floor(.3*(g-p))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(m){const g=this.q.getDomNode();let p=m;for(;p instanceof HTMLElement&&p!==this.o&&g.contains(p);){const I=p.getAttribute("data-index");if(I){const O=Number(I);if(!isNaN(O))return O}p=p.parentElement}}sb(m,g){return{start:this.g.indexAt(m),end:this.g.indexAfter(m+g-1)}}tb(m,g,p){const I=this.sb(m,g);let O,U;m===this.elementTop(I.start)?(O=I.start,U=0):I.end-I.start>1&&(O=I.start+1,U=this.elementTop(O)-m);let Z=0;for(;;){const ne=this.sb(m,g);let se=!1;for(let ce=ne.start;ce<ne.end;ce++){const ue=this.ub(ce);ue!==0&&this.g.splice(ce,1,[this.d[ce]]),Z+=ue,se=se||ue!==0}if(!se){Z!==0&&this.S();const ce=r.Range.relativeComplement(I,ne);for(const ae of ce)for(let oe=ae.start;oe<ae.end;oe++)this.d[oe].row&&this.ab(oe);const ue=r.Range.relativeComplement(ne,I);for(const ae of ue)for(let oe=ae.start;oe<ae.end;oe++){const ye=oe+1,ke=ye<this.d.length?this.d[ye].row:null,Be=ke?ke.domNode:null;this.X(oe,Be)}for(let ae=ne.start;ae<ne.end;ae++)this.d[ae].row&&this.Z(this.d[ae],ae);if(typeof O=="number"){const ae=this.p.getFutureScrollPosition().scrollTop-m,oe=this.elementTop(O)-U+ae;this.setScrollTop(oe,p)}this.M.fire(this.contentHeight);return}}}ub(m){const g=this.d[m];if(this.Q.getDynamicHeight){const U=this.Q.getDynamicHeight(g.element);if(U!==null){const Z=g.size;return g.size=U,g.lastDynamicHeightWidth=this.n,U-Z}}if(!g.hasDynamicHeight||g.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(g.element))return 0;const p=g.size;if(g.row)return g.row.domNode.style.height="",g.size=g.row.domNode.offsetHeight,g.lastDynamicHeightWidth=this.n,g.size-p;const{row:I}=this.h.alloc(g.templateId);I.domNode.style.height="",this.o.appendChild(I.domNode);const O=this.j.get(g.templateId);if(!O)throw new n.BugIndicatingError("Missing renderer for templateId: "+g.templateId);return O.renderElement(g.element,m,I.templateData,void 0),g.size=I.domNode.offsetHeight,O.disposeElement?.(g.element,m,I.templateData,void 0),this.Q.setDynamicHeight?.(g.element,g.size),g.lastDynamicHeightWidth=this.n,this.o.removeChild(I.domNode),this.h.release(I),g.size-p}vb(m){const g=m[m.length-1];if(!g)return null;const p=this.d[g.end];return!p||!p.row?null:p.row.domNode}getElementDomId(m){return`${this.domId}_${m}`}dispose(){if(this.d){for(const m of this.d)if(m.row){const g=this.j.get(m.row.templateId);g&&(g.disposeElement?.(m.element,-1,m.row.templateData,void 0),g.disposeTemplate(m.row.templateData))}this.d=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,N.dispose)(this.L)}}t.ListView=B,B.c=0,qe([l.memoize],B.prototype,"onMouseClick",null),qe([l.memoize],B.prototype,"onMouseDblClick",null),qe([l.memoize],B.prototype,"onMouseMiddleClick",null),qe([l.memoize],B.prototype,"onMouseUp",null),qe([l.memoize],B.prototype,"onMouseDown",null),qe([l.memoize],B.prototype,"onMouseOver",null),qe([l.memoize],B.prototype,"onMouseMove",null),qe([l.memoize],B.prototype,"onMouseOut",null),qe([l.memoize],B.prototype,"onContextMenu",null),qe([l.memoize],B.prototype,"onTouchStart",null),qe([l.memoize],B.prototype,"onTap",null)}),define(ge[37],me([1,0,4,20,14,23,54,68,13,9,70,25,3,33,2,44,5,6,67,58,89]),function(te,t,E,L,i,W,D,y,h,l,d,N,r,u,e,a,n,c,s,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class v{constructor(A){this.d=A,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(A){return A}renderElement(A,K,x){const o=this.c.findIndex(k=>k.templateData===x);if(o>=0){const k=this.c[o];this.d.unrender(x),k.index=K}else{const k={index:K,templateData:x};this.c.push(k)}this.d.renderIndex(K,x)}splice(A,K,x){const o=[];for(const k of this.c)k.index<A?o.push(k):k.index>=A+K&&o.push({index:k.index+x-K,templateData:k.templateData});this.c=o}renderIndexes(A){for(const{index:K,templateData:x}of this.c)A.indexOf(K)>-1&&this.d.renderIndex(K,x)}disposeTemplate(A){const K=this.c.findIndex(x=>x.templateData===A);K<0||this.c.splice(K,1)}}class F{get name(){return this.h}get renderer(){return new v(this)}constructor(A){this.h=A,this.c=0,this.d=[],this.f=[],this.g=new r.Emitter,this.onChange=this.g.event}splice(A,K,x){K=Math.max(0,Math.min(K,this.c-A));const o=x.length-K,k=A+K,_=[...this.f.filter(C=>C<A),...x.map((C,T)=>C?T+A:-1).filter(C=>C!==-1),...this.f.filter(C=>C>=k).map(C=>C+o)],Y=this.c+o;if(this.f.length>0&&_.length===0&&Y>0){const C=this.f.find(T=>T>=A)??Y-1;_.push(Math.min(C,Y-1))}this.renderer.splice(A,K,x.length),this.k(_,_),this.c=Y}renderIndex(A,K){K.classList.toggle(this.h,this.contains(A))}unrender(A){A.classList.remove(this.h)}set(A,K){return this.k(A,[...A].sort(Me),K)}k(A,K,x){const o=this.d,k=this.f;this.d=A,this.f=K;const _=ke(k,A);return this.renderer.renderIndexes(_),this.g.fire({indexes:A,browserEvent:x}),o}get(){return this.d}contains(A){return(0,h.binarySearch)(this.f,A,Me)>=0}dispose(){(0,e.dispose)(this.g)}}qe([N.memoize],F.prototype,"renderer",null);class f extends F{constructor(A){super("selected"),this.l=A}renderIndex(A,K){super.renderIndex(A,K),this.l&&(this.contains(A)?K.setAttribute("aria-selected","true"):K.setAttribute("aria-selected","false"))}}class b{constructor(A,K,x){this.c=A,this.d=K,this.f=x}splice(A,K,x){if(!this.f)return this.c.splice(A,K,x.map(()=>!1));const o=this.c.get().map(_=>this.f.getId(this.d.element(_)).toString()),k=x.map(_=>o.indexOf(this.f.getId(_).toString())>-1);this.c.splice(A,K,k)}}function B(V){return V.tagName==="INPUT"||V.tagName==="TEXTAREA"}t.isInputElement=B;function M(V){return V.classList.contains("monaco-editor")?!0:V.classList.contains("monaco-list")||!V.parentElement?!1:M(V.parentElement)}t.isMonacoEditor=M;function m(V){return V.tagName==="A"&&V.classList.contains("monaco-button")||V.tagName==="DIV"&&V.classList.contains("monaco-button-dropdown")?!0:V.classList.contains("monaco-list")||!V.parentElement?!1:m(V.parentElement)}t.isButton=m;class g{get f(){return this.c.add(r.Event.chain(this.c.add(new L.DomEmitter(this.h.domNode,"keydown")).event).filter(A=>!B(A.target)).map(A=>new i.StandardKeyboardEvent(A)))}constructor(A,K,x){this.g=A,this.h=K,this.c=new e.DisposableStore,this.d=new e.DisposableStore,this.f.filter(o=>o.keyCode===3).on(this.k,this,this.c),this.f.filter(o=>o.keyCode===16).on(this.l,this,this.c),this.f.filter(o=>o.keyCode===18).on(this.o,this,this.c),this.f.filter(o=>o.keyCode===11).on(this.p,this,this.c),this.f.filter(o=>o.keyCode===12).on(this.q,this,this.c),this.f.filter(o=>o.keyCode===9).on(this.t,this,this.c),x.multipleSelectionSupport!==!1&&this.f.filter(o=>(n.isMacintosh?o.metaKey:o.ctrlKey)&&o.keyCode===31).on(this.s,this,this.d)}updateOptions(A){A.multipleSelectionSupport!==void 0&&(this.d.clear(),A.multipleSelectionSupport&&this.f.filter(K=>(n.isMacintosh?K.metaKey:K.ctrlKey)&&K.keyCode===31).on(this.s,this,this.d))}k(A){A.preventDefault(),A.stopPropagation(),this.g.setSelection(this.g.getFocus(),A.browserEvent)}l(A){A.preventDefault(),A.stopPropagation(),this.g.focusPrevious(1,!1,A.browserEvent);const K=this.g.getFocus()[0];this.g.setAnchor(K),this.g.reveal(K),this.h.domNode.focus()}o(A){A.preventDefault(),A.stopPropagation(),this.g.focusNext(1,!1,A.browserEvent);const K=this.g.getFocus()[0];this.g.setAnchor(K),this.g.reveal(K),this.h.domNode.focus()}p(A){A.preventDefault(),A.stopPropagation(),this.g.focusPreviousPage(A.browserEvent);const K=this.g.getFocus()[0];this.g.setAnchor(K),this.g.reveal(K),this.h.domNode.focus()}q(A){A.preventDefault(),A.stopPropagation(),this.g.focusNextPage(A.browserEvent);const K=this.g.getFocus()[0];this.g.setAnchor(K),this.g.reveal(K),this.h.domNode.focus()}s(A){A.preventDefault(),A.stopPropagation(),this.g.setSelection((0,h.range)(this.g.length),A.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus()}t(A){this.g.getSelection().length&&(A.preventDefault(),A.stopPropagation(),this.g.setSelection([],A.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}qe([N.memoize],g.prototype,"f",null);var p;(function(V){V[V.Automatic=0]="Automatic",V[V.Trigger=1]="Trigger"})(p||(t.TypeNavigationMode=p={}));var I;(function(V){V[V.Idle=0]="Idle",V[V.Typing=1]="Typing"})(I||(I={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(V){return V.ctrlKey||V.metaKey||V.altKey?!1:V.keyCode>=31&&V.keyCode<=56||V.keyCode>=21&&V.keyCode<=30||V.keyCode>=98&&V.keyCode<=107||V.keyCode>=85&&V.keyCode<=95}};class O{constructor(A,K,x,o,k){this.o=A,this.p=K,this.q=x,this.s=o,this.t=k,this.c=!1,this.d=I.Idle,this.f=p.Automatic,this.g=!1,this.h=-1,this.k=new e.DisposableStore,this.l=new e.DisposableStore,this.updateOptions(A.options)}updateOptions(A){A.typeNavigationEnabled??!0?this.u():this.v(),this.f=A.typeNavigationMode??p.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let A=!1;const K=this.k.add(r.Event.chain(this.k.add(new L.DomEmitter(this.p.domNode,"keydown")).event)).filter(k=>!B(k.target)).filter(()=>this.f===p.Automatic||this.g).map(k=>new i.StandardKeyboardEvent(k)).filter(k=>A||this.s(k)).filter(k=>this.t.mightProducePrintableCharacter(k)).forEach(k=>E.EventHelper.stop(k,!0)).map(k=>k.browserEvent.key).event,x=r.Event.debounce(K,()=>null,800,void 0,void 0,void 0,this.k);r.Event.reduce(r.Event.any(K,x),(k,_)=>_===null?null:(k||"")+_,void 0,this.k)(this.z,this,this.k),x(this.w,this,this.k),K(()=>A=!0,void 0,this.k),x(()=>A=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const A=this.o.getFocus();if(A.length>0&&A[0]===this.h){const K=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(A[0]));K&&(0,D.alert)(K)}this.h=-1}z(A){if(!A){this.d=I.Idle,this.g=!1;return}const K=this.o.getFocus(),x=K.length>0?K[0]:0,o=this.d===I.Idle?1:0;this.d=I.Typing;for(let k=0;k<this.o.length;k++){const _=(x+k+o)%this.o.length,Y=this.q.getKeyboardNavigationLabel(this.p.element(_)),C=Y&&Y.toString();if(typeof C>"u"||(0,u.matchesPrefix)(A,C)){this.h=x,this.o.setFocus([_]),this.o.reveal(_);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class U{constructor(A,K){this.d=A,this.f=K,this.c=new e.DisposableStore,this.c.add(r.Event.chain(this.c.add(new L.DomEmitter(K.domNode,"keydown")).event)).filter(o=>!B(o.target)).map(o=>new i.StandardKeyboardEvent(o)).filter(o=>o.keyCode===2&&!o.ctrlKey&&!o.metaKey&&!o.shiftKey&&!o.altKey).on(this.g,this,this.c)}g(A){if(A.target!==this.f.domNode)return;const K=this.d.getFocus();if(K.length===0)return;const x=this.f.domElement(K[0]);if(!x)return;const o=x.querySelector("[tabIndex]");if(!o||!(o instanceof HTMLElement)||o.tabIndex===-1)return;const k=window.getComputedStyle(o);k.visibility==="hidden"||k.display==="none"||(A.preventDefault(),A.stopPropagation(),o.focus())}dispose(){this.c.dispose()}}function Z(V){return n.isMacintosh?V.browserEvent.metaKey:V.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=Z;function ne(V){return V.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ne;function se(V){return V instanceof MouseEvent&&V.button===2}const ce={isSelectionSingleChangeEvent:Z,isSelectionRangeChangeEvent:ne};class ue{constructor(A){this.k=A,this.f=new e.DisposableStore,this.g=new r.Emitter,this.onPointer=this.g.event,A.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ce),this.d=typeof A.options.mouseSupport>"u"||!!A.options.mouseSupport,this.d&&(A.onMouseDown(this.s,this,this.f),A.onContextMenu(this.t,this,this.f),A.onMouseDblClick(this.v,this,this.f),A.onTouchStart(this.s,this,this.f),this.f.add(W.Gesture.addTarget(A.getHTMLElement()))),r.Event.any(A.onMouseClick,A.onMouseMiddleClick,A.onTap)(this.u,this,this.f)}updateOptions(A){A.multipleSelectionSupport!==void 0&&(this.c=void 0,A.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ce))}o(A){return this.c?this.c.isSelectionSingleChangeEvent(A):!1}p(A){return this.c?this.c.isSelectionRangeChangeEvent(A):!1}q(A){return this.o(A)||this.p(A)}s(A){M(A.browserEvent.target)||document.activeElement!==A.browserEvent.target&&this.k.domFocus()}t(A){if(B(A.browserEvent.target)||M(A.browserEvent.target))return;const K=typeof A.index>"u"?[]:[A.index];this.k.setFocus(K,A.browserEvent)}u(A){if(!this.d||B(A.browserEvent.target)||M(A.browserEvent.target)||A.browserEvent.isHandledByList)return;A.browserEvent.isHandledByList=!0;const K=A.index;if(typeof K>"u"){this.k.setFocus([],A.browserEvent),this.k.setSelection([],A.browserEvent),this.k.setAnchor(void 0);return}if(this.p(A))return this.w(A);if(this.q(A))return this.w(A);this.k.setFocus([K],A.browserEvent),this.k.setAnchor(K),se(A.browserEvent)||this.k.setSelection([K],A.browserEvent),this.g.fire(A)}v(A){if(B(A.browserEvent.target)||M(A.browserEvent.target)||this.q(A)||A.browserEvent.isHandledByList)return;A.browserEvent.isHandledByList=!0;const K=this.k.getFocus();this.k.setSelection(K,A.browserEvent)}w(A){const K=A.index;let x=this.k.getAnchor();if(this.p(A)){typeof x>"u"&&(x=this.k.getFocus()[0]??K,this.k.setAnchor(x));const o=Math.min(x,K),k=Math.max(x,K),_=(0,h.range)(o,k+1),Y=this.k.getSelection(),C=ye(ke(Y,[x]),x);if(C.length===0)return;const T=ke(_,Be(Y,C));this.k.setSelection(T,A.browserEvent),this.k.setFocus([K],A.browserEvent)}else if(this.o(A)){const o=this.k.getSelection(),k=o.filter(_=>_!==K);this.k.setFocus([K]),this.k.setAnchor(K),o.length===k.length?this.k.setSelection([...k,K],A.browserEvent):this.k.setSelection(k,A.browserEvent)}}dispose(){this.f.dispose()}}t.MouseController=ue;class ae{constructor(A,K){this.c=A,this.d=K}style(A){const K=this.d&&`.${this.d}`,x=[];A.listBackground&&x.push(`.monaco-list${K} .monaco-list-rows { background: ${A.listBackground}; }`),A.listFocusBackground&&(x.push(`.monaco-list${K}:focus .monaco-list-row.focused { background-color: ${A.listFocusBackground}; }`),x.push(`.monaco-list${K}:focus .monaco-list-row.focused:hover { background-color: ${A.listFocusBackground}; }`)),A.listFocusForeground&&x.push(`.monaco-list${K}:focus .monaco-list-row.focused { color: ${A.listFocusForeground}; }`),A.listActiveSelectionBackground&&(x.push(`.monaco-list${K}:focus .monaco-list-row.selected { background-color: ${A.listActiveSelectionBackground}; }`),x.push(`.monaco-list${K}:focus .monaco-list-row.selected:hover { background-color: ${A.listActiveSelectionBackground}; }`)),A.listActiveSelectionForeground&&x.push(`.monaco-list${K}:focus .monaco-list-row.selected { color: ${A.listActiveSelectionForeground}; }`),A.listActiveSelectionIconForeground&&x.push(`.monaco-list${K}:focus .monaco-list-row.selected .codicon { color: ${A.listActiveSelectionIconForeground}; }`),A.listFocusAndSelectionBackground&&x.push(`
				.monaco-drag-image,
				.monaco-list${K}:focus .monaco-list-row.selected.focused { background-color: ${A.listFocusAndSelectionBackground}; }
			`),A.listFocusAndSelectionForeground&&x.push(`
				.monaco-drag-image,
				.monaco-list${K}:focus .monaco-list-row.selected.focused { color: ${A.listFocusAndSelectionForeground}; }
			`),A.listInactiveFocusForeground&&(x.push(`.monaco-list${K} .monaco-list-row.focused { color:  ${A.listInactiveFocusForeground}; }`),x.push(`.monaco-list${K} .monaco-list-row.focused:hover { color:  ${A.listInactiveFocusForeground}; }`)),A.listInactiveSelectionIconForeground&&x.push(`.monaco-list${K} .monaco-list-row.focused .codicon { color:  ${A.listInactiveSelectionIconForeground}; }`),A.listInactiveFocusBackground&&(x.push(`.monaco-list${K} .monaco-list-row.focused { background-color:  ${A.listInactiveFocusBackground}; }`),x.push(`.monaco-list${K} .monaco-list-row.focused:hover { background-color:  ${A.listInactiveFocusBackground}; }`)),A.listInactiveSelectionBackground&&(x.push(`.monaco-list${K} .monaco-list-row.selected { background-color:  ${A.listInactiveSelectionBackground}; }`),x.push(`.monaco-list${K} .monaco-list-row.selected:hover { background-color:  ${A.listInactiveSelectionBackground}; }`)),A.listInactiveSelectionForeground&&x.push(`.monaco-list${K} .monaco-list-row.selected { color: ${A.listInactiveSelectionForeground}; }`),A.listHoverBackground&&x.push(`.monaco-list${K}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${A.listHoverBackground}; }`),A.listHoverForeground&&x.push(`.monaco-list${K}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${A.listHoverForeground}; }`);const o=(0,E.asCssValueWithDefault)(A.listFocusAndSelectionOutline,(0,E.asCssValueWithDefault)(A.listSelectionOutline,A.listFocusOutline??""));o&&x.push(`.monaco-list${K}:focus .monaco-list-row.focused.selected { outline: 1px solid ${o}; outline-offset: -1px;}`),A.listFocusOutline&&x.push(`
				.monaco-drag-image,
				.monaco-list${K}:focus .monaco-list-row.focused { outline: 1px solid ${A.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${K}.last-focused .monaco-list-row.focused { outline: 1px solid ${A.listFocusOutline}; outline-offset: -1px; }
			`);const k=(0,E.asCssValueWithDefault)(A.listSelectionOutline,A.listInactiveFocusOutline??"");k&&x.push(`.monaco-list${K} .monaco-list-row.focused.selected { outline: 1px dotted ${k}; outline-offset: -1px; }`),A.listSelectionOutline&&x.push(`.monaco-list${K} .monaco-list-row.selected { outline: 1px dotted ${A.listSelectionOutline}; outline-offset: -1px; }`),A.listInactiveFocusOutline&&x.push(`.monaco-list${K} .monaco-list-row.focused { outline: 1px dotted ${A.listInactiveFocusOutline}; outline-offset: -1px; }`),A.listHoverOutline&&x.push(`.monaco-list${K} .monaco-list-row:hover { outline: 1px dashed ${A.listHoverOutline}; outline-offset: -1px; }`),A.listDropBackground&&x.push(`
				.monaco-list${K}.drop-target,
				.monaco-list${K} .monaco-list-rows.drop-target,
				.monaco-list${K} .monaco-list-row.drop-target { background-color: ${A.listDropBackground} !important; color: inherit !important; }
			`),A.tableColumnsBorder&&x.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${A.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),A.tableOddRowsBackgroundColor&&x.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${A.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=x.join(`
`)}}t.DefaultStyleController=ae,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:d.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:d.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:d.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const oe={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function ye(V,A){const K=V.indexOf(A);if(K===-1)return[];const x=[];let o=K-1;for(;o>=0&&V[o]===A-(K-o);)x.push(V[o--]);for(x.reverse(),o=K;o<V.length&&V[o]===A+(o-K);)x.push(V[o++]);return x}function ke(V,A){const K=[];let x=0,o=0;for(;x<V.length||o<A.length;)if(x>=V.length)K.push(A[o++]);else if(o>=A.length)K.push(V[x++]);else if(V[x]===A[o]){K.push(V[x]),x++,o++;continue}else V[x]<A[o]?K.push(V[x++]):K.push(A[o++]);return K}function Be(V,A){const K=[];let x=0,o=0;for(;x<V.length||o<A.length;)if(x>=V.length)K.push(A[o++]);else if(o>=A.length)K.push(V[x++]);else if(V[x]===A[o]){x++,o++;continue}else V[x]<A[o]?K.push(V[x++]):o++;return K}const Me=(V,A)=>V-A;class fe{constructor(A,K){this.c=A,this.d=K}get templateId(){return this.c}renderTemplate(A){return this.d.map(K=>K.renderTemplate(A))}renderElement(A,K,x,o){let k=0;for(const _ of this.d)_.renderElement(A,K,x[k++],o)}disposeElement(A,K,x,o){let k=0;for(const _ of this.d)_.disposeElement?.(A,K,x[k],o),k+=1}disposeTemplate(A){let K=0;for(const x of this.d)x.disposeTemplate(A[K++])}}class ${constructor(A){this.c=A,this.templateId="a18n"}renderTemplate(A){return A}renderElement(A,K,x){const o=this.c.getAriaLabel(A);o?x.setAttribute("aria-label",o):x.removeAttribute("aria-label");const k=this.c.getAriaLevel&&this.c.getAriaLevel(A);typeof k=="number"?x.setAttribute("aria-level",`${k}`):x.removeAttribute("aria-level")}disposeTemplate(A){}}class ie{constructor(A,K){this.c=A,this.d=K}getDragElements(A){const K=this.c.getSelectedElements();return K.indexOf(A)>-1?K:[A]}getDragURI(A){return this.d.getDragURI(A)}getDragLabel(A,K){if(this.d.getDragLabel)return this.d.getDragLabel(A,K)}onDragStart(A,K){this.d.onDragStart?.(A,K)}onDragOver(A,K,x,o){return this.d.onDragOver(A,K,x,o)}onDragLeave(A,K,x,o){this.d.onDragLeave?.(A,K,x,o)}onDragEnd(A){this.d.onDragEnd?.(A)}drop(A,K,x,o){this.d.drop(A,K,x,o)}}class q{get onDidChangeFocus(){return r.Event.map(this.g.wrapEvent(this.c.onChange),A=>this.I(A),this.A)}get onDidChangeSelection(){return r.Event.map(this.g.wrapEvent(this.d.onChange),A=>this.I(A),this.A)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let A=!1;const K=this.A.add(r.Event.chain(this.A.add(new L.DomEmitter(this.k.domNode,"keydown")).event)).map(k=>new i.StandardKeyboardEvent(k)).filter(k=>A=k.keyCode===58||k.shiftKey&&k.keyCode===68).map(k=>E.EventHelper.stop(k,!0)).filter(()=>!1).event,x=this.A.add(r.Event.chain(this.A.add(new L.DomEmitter(this.k.domNode,"keyup")).event)).forEach(()=>A=!1).map(k=>new i.StandardKeyboardEvent(k)).filter(k=>k.keyCode===58||k.shiftKey&&k.keyCode===68).map(k=>E.EventHelper.stop(k,!0)).map(({browserEvent:k})=>{const _=this.getFocus(),Y=_.length?_[0]:void 0,C=typeof Y<"u"?this.k.element(Y):void 0,T=typeof Y<"u"?this.k.domElement(Y):this.k.domNode;return{index:Y,element:C,anchor:T,browserEvent:k}}).event,o=this.A.add(r.Event.chain(this.k.onContextMenu)).filter(k=>!A).map(({element:k,index:_,browserEvent:Y})=>({element:k,index:_,anchor:{x:Y.pageX+1,y:Y.pageY},browserEvent:Y})).event;return r.Event.any(K,x,o)}get onKeyDown(){return this.A.add(new L.DomEmitter(this.k.domNode,"keydown")).event}get onKeyUp(){return this.A.add(new L.DomEmitter(this.k.domNode,"keyup")).event}get onKeyPress(){return this.A.add(new L.DomEmitter(this.k.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.A.add(new L.DomEmitter(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.A.add(new L.DomEmitter(this.k.domNode,"blur",!0)).event)}constructor(A,K,x,o,k=oe){this.C=A,this.D=k,this.c=new F("focused"),this.f=new F("anchor"),this.g=new r.EventBufferer,this.z="",this.A=new e.DisposableStore,this.B=new r.Emitter,this.onDidDispose=this.B.event;const _=this.D.accessibilityProvider&&this.D.accessibilityProvider.getWidgetRole?this.D.accessibilityProvider?.getWidgetRole():"list";this.d=new f(_!=="listbox");const Y=[this.c.renderer,this.d.renderer];this.u=k.accessibilityProvider,this.u&&(Y.push(new $(this.u)),this.u.onDidChangeActiveDescendant?.(this.K,this,this.A)),o=o.map(T=>new fe(T.templateId,[...Y,T]));const C={...k,dnd:k.dnd&&new ie(this,k.dnd)};if(this.k=this.E(K,x,o,C),this.k.domNode.setAttribute("role",_),k.styleController)this.q=k.styleController(this.k.domId);else{const T=(0,E.createStyleSheet)(this.k.domNode);this.q=new ae(T,this.k.domId)}if(this.o=new y.CombinedSpliceable([new b(this.c,this.k,k.identityProvider),new b(this.d,this.k,k.identityProvider),new b(this.f,this.k,k.identityProvider),this.k]),this.A.add(this.c),this.A.add(this.d),this.A.add(this.f),this.A.add(this.k),this.A.add(this.B),this.A.add(new U(this,this.k)),(typeof k.keyboardSupport!="boolean"||k.keyboardSupport)&&(this.v=new g(this,this.k,k),this.A.add(this.v)),k.keyboardNavigationLabelProvider){const T=k.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.t=new O(this,this.k,k.keyboardNavigationLabelProvider,k.keyboardNavigationEventFilter??(()=>!0),T),this.A.add(this.t)}this.w=this.F(k),this.A.add(this.w),this.onDidChangeFocus(this.J,this,this.A),this.onDidChangeSelection(this.L,this,this.A),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.D.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}E(A,K,x,o){return new w.ListView(A,K,x,o)}F(A){return new ue(this)}updateOptions(A={}){this.D={...this.D,...A},this.t?.updateOptions(this.D),this.D.multipleSelectionController!==void 0&&(this.D.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(A),this.v?.updateOptions(A),this.k.updateOptions(A)}get options(){return this.D}splice(A,K,x=[]){if(A<0||A>this.k.length)throw new s.ListError(this.C,`Invalid start index: ${A}`);if(K<0)throw new s.ListError(this.C,`Invalid delete count: ${K}`);K===0&&x.length===0||this.g.bufferEvents(()=>this.o.splice(A,K,x))}updateWidth(A){this.k.updateWidth(A)}updateElementHeight(A,K){this.k.updateElementHeight(A,K,null)}rerender(){this.k.rerender()}element(A){return this.k.element(A)}indexOf(A){return this.k.indexOf(A)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(A){this.k.setScrollTop(A)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(A){this.k.setScrollLeft(A)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.z}set ariaLabel(A){this.z=A,this.k.domNode.setAttribute("aria-label",A)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(A,K){this.k.layout(A,K)}triggerTypeNavigation(){this.t?.trigger()}setSelection(A,K){for(const x of A)if(x<0||x>=this.length)throw new s.ListError(this.C,`Invalid index ${x}`);this.d.set(A,K)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(A=>this.k.element(A))}setAnchor(A){if(typeof A>"u"){this.f.set([]);return}if(A<0||A>=this.length)throw new s.ListError(this.C,`Invalid index ${A}`);this.f.set([A])}getAnchor(){return(0,h.firstOrDefault)(this.f.get(),void 0)}getAnchorElement(){const A=this.getAnchor();return typeof A>"u"?void 0:this.element(A)}setFocus(A,K){for(const x of A)if(x<0||x>=this.length)throw new s.ListError(this.C,`Invalid index ${x}`);this.c.set(A,K)}focusNext(A=1,K=!1,x,o){if(this.length===0)return;const k=this.c.get(),_=this.G(k.length>0?k[0]+A:0,K,o);_>-1&&this.setFocus([_],x)}focusPrevious(A=1,K=!1,x,o){if(this.length===0)return;const k=this.c.get(),_=this.H(k.length>0?k[0]-A:0,K,o);_>-1&&this.setFocus([_],x)}async focusNextPage(A,K){let x=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);x=x===0?0:x-1;const o=this.getFocus()[0];if(o!==x&&(o===void 0||x>o)){const k=this.H(x,!1,K);k>-1&&o!==k?this.setFocus([k],A):this.setFocus([x],A)}else{const k=this.k.getScrollTop();let _=k+this.k.renderHeight;x>o&&(_-=this.k.elementHeight(x)),this.k.setScrollTop(_),this.k.getScrollTop()!==k&&(this.setFocus([]),await(0,l.timeout)(0),await this.focusNextPage(A,K))}}async focusPreviousPage(A,K){let x;const o=this.k.getScrollTop();o===0?x=this.k.indexAt(o):x=this.k.indexAfter(o-1);const k=this.getFocus()[0];if(k!==x&&(k===void 0||k>=x)){const _=this.G(x,!1,K);_>-1&&k!==_?this.setFocus([_],A):this.setFocus([x],A)}else{const _=o;this.k.setScrollTop(o-this.k.renderHeight),this.k.getScrollTop()!==_&&(this.setFocus([]),await(0,l.timeout)(0),await this.focusPreviousPage(A,K))}}focusLast(A,K){if(this.length===0)return;const x=this.H(this.length-1,!1,K);x>-1&&this.setFocus([x],A)}focusFirst(A,K){this.focusNth(0,A,K)}focusNth(A,K,x){if(this.length===0)return;const o=this.G(A,!1,x);o>-1&&this.setFocus([o],K)}G(A,K=!1,x){for(let o=0;o<this.length;o++){if(A>=this.length&&!K)return-1;if(A=A%this.length,!x||x(this.element(A)))return A;A++}return-1}H(A,K=!1,x){for(let o=0;o<this.length;o++){if(A<0&&!K)return-1;if(A=(this.length+A%this.length)%this.length,!x||x(this.element(A)))return A;A--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(A=>this.k.element(A))}reveal(A,K){if(A<0||A>=this.length)throw new s.ListError(this.C,`Invalid index ${A}`);const x=this.k.getScrollTop(),o=this.k.elementTop(A),k=this.k.elementHeight(A);if((0,c.isNumber)(K)){const _=k-this.k.renderHeight;this.k.setScrollTop(_*(0,a.clamp)(K,0,1)+o)}else{const _=o+k,Y=x+this.k.renderHeight;o<x&&_>=Y||(o<x||_>=Y&&k>=this.k.renderHeight?this.k.setScrollTop(o):_>=Y&&this.k.setScrollTop(_-this.k.renderHeight))}}getRelativeTop(A){if(A<0||A>=this.length)throw new s.ListError(this.C,`Invalid index ${A}`);const K=this.k.getScrollTop(),x=this.k.elementTop(A),o=this.k.elementHeight(A);if(x<K||x+o>K+this.k.renderHeight)return null;const k=o-this.k.renderHeight;return Math.abs((K-x)/k)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(A){return this.k.getElementDomId(A)}style(A){this.q.style(A)}I({indexes:A,browserEvent:K}){return{indexes:A,elements:A.map(x=>this.k.element(x)),browserEvent:K}}J(){const A=this.c.get();this.k.domNode.classList.toggle("element-focused",A.length>0),this.K()}K(){const A=this.c.get();if(A.length>0){let K;this.u?.getActiveDescendantId&&(K=this.u.getActiveDescendantId(this.k.element(A[0]))),this.k.domNode.setAttribute("aria-activedescendant",K||this.k.getElementDomId(A[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}L(){const A=this.d.get();this.k.domNode.classList.toggle("selection-none",A.length===0),this.k.domNode.classList.toggle("selection-single",A.length===1),this.k.domNode.classList.toggle("selection-multiple",A.length>1)}dispose(){this.B.fire(),this.A.dispose(),this.B.dispose()}}t.List=q,qe([N.memoize],q.prototype,"onDidChangeFocus",null),qe([N.memoize],q.prototype,"onDidChangeSelection",null),qe([N.memoize],q.prototype,"onContextMenu",null),qe([N.memoize],q.prototype,"onKeyDown",null),qe([N.memoize],q.prototype,"onKeyUp",null),qe([N.memoize],q.prototype,"onKeyPress",null),qe([N.memoize],q.prototype,"onDidFocus",null),qe([N.memoize],q.prototype,"onDidBlur",null)}),define(ge[59],me([1,0,7,34,35,11,15]),function(te,t,E,L,i,W,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var y;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(y||(t.MarkdownStringTextNewlineStyle=y={}));class h{constructor(c="",s=!1){if(this.value=c,typeof this.value!="string")throw(0,E.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(c,s=0){return this.value+=r(this.supportThemeIcons?(0,L.escapeIcons)(c):c).replace(/([ \t]+)/g,(w,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,s){return this.value+="\n```",this.value+=c,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(c,s,w){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String(c),")"),w&&(this.value+=` "${this.c(this.c(w,'"'),")")}"`),this.value+=")",this}c(c,s){const w=new RegExp((0,W.escapeRegExpCharacters)(s),"g");return c.replace(w,(v,F)=>c.charAt(F-1)!=="\\"?`\\${v}`:v)}}t.MarkdownString=h;function l(n){return d(n)?!n.value:Array.isArray(n)?n.every(l):!0}t.isEmptyMarkdownString=l;function d(n){return n instanceof h?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||typeof n.isTrusted=="object"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}t.isMarkdownString=d;function N(n,c){return n===c?!0:!n||!c?!1:n.value===c.value&&n.isTrusted===c.isTrusted&&n.supportThemeIcons===c.supportThemeIcons&&n.supportHtml===c.supportHtml&&(n.baseUri===c.baseUri||!!n.baseUri&&!!c.baseUri&&(0,i.isEqual)(D.URI.from(n.baseUri),D.URI.from(c.baseUri)))}t.markdownStringEqual=N;function r(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=r;function u(n){return n.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=u;function e(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.removeMarkdownEscapes=e;function a(n){const c=[],s=n.split("|").map(v=>v.trim());n=s[0];const w=s[1];if(w){const v=/height=(\d+)/.exec(w),F=/width=(\d+)/.exec(w),f=v?v[1]:"",b=F?F[1]:"",B=isFinite(parseInt(b)),M=isFinite(parseInt(f));B&&c.push(`width="${b}"`),M&&c.push(`height="${f}"`)}return{href:n,dimensions:c}}t.parseHrefAndDimensions=a}),define(ge[122],me([1,0,4,114,20,52,14,21,115,7,3,59,34,73,30,2,76,50,28,47,35,11,15]),function(te,t,E,L,i,W,D,y,h,l,d,N,r,u,e,a,n,c,s,w,v,F,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fillInIncompleteTokens=t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const b=Object.freeze({image:(q,V,A)=>{let K=[],x=[];return q&&({href:q,dimensions:K}=(0,N.parseHrefAndDimensions)(q),x.push(`src="${(0,N.escapeDoubleQuotes)(q)}"`)),A&&x.push(`alt="${(0,N.escapeDoubleQuotes)(A)}"`),V&&x.push(`title="${(0,N.escapeDoubleQuotes)(V)}"`),K.length&&(x=x.concat(K)),"<img "+x.join(" ")+">"},paragraph:q=>`<p>${q}</p>`,link:(q,V,A)=>typeof q!="string"?"":(q===A&&(A=(0,N.removeMarkdownEscapes)(A)),V=typeof V=="string"?(0,N.escapeDoubleQuotes)((0,N.removeMarkdownEscapes)(V)):"",q=(0,N.removeMarkdownEscapes)(q),q=q.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${q}" title="${V||q}">${A}</a>`)});function B(q,V={},A={}){const K=new a.DisposableStore;let x=!1;const o=(0,W.createElement)(V),k=function(P){let j;try{j=(0,c.parse)(decodeURIComponent(P))}catch{}return j?(j=(0,w.cloneAndChange)(j,G=>{if(q.uris&&q.uris[G])return f.URI.revive(q.uris[G])}),encodeURIComponent(JSON.stringify(j))):P},_=function(P,j){const G=q.uris&&q.uris[P];let ee=f.URI.revive(G);return j?P.startsWith(s.Schemas.data+":")?P:(ee||(ee=f.URI.parse(P)),s.FileAccess.uriToBrowserUri(ee).toString(!0)):!ee||f.URI.parse(P).toString()===ee.toString()?P:(ee.query&&(ee=ee.with({query:k(ee.query)})),ee.toString())},Y=new n.marked.Renderer;Y.image=b.image,Y.link=b.link,Y.paragraph=b.paragraph;const C=[],T=[];if(V.codeBlockRendererSync?Y.code=(P,j)=>{const G=u.defaultGenerator.nextId(),ee=V.codeBlockRendererSync(M(j),P);return T.push([G,ee]),`<div class="code" data-code="${G}">${(0,F.escape)(P)}</div>`}:V.codeBlockRenderer&&(Y.code=(P,j)=>{const G=u.defaultGenerator.nextId(),ee=V.codeBlockRenderer(M(j),P);return C.push(ee.then(re=>[G,re])),`<div class="code" data-code="${G}">${(0,F.escape)(P)}</div>`}),V.actionHandler){const P=function(ee){let re=ee.target;if(!(re.tagName!=="A"&&(re=re.parentElement,!re||re.tagName!=="A")))try{let pe=re.dataset.href;pe&&(q.baseUri&&(pe=m(f.URI.from(q.baseUri),pe)),V.actionHandler.callback(pe,ee))}catch(pe){(0,l.onUnexpectedError)(pe)}finally{ee.preventDefault()}},j=V.actionHandler.disposables.add(new i.DomEmitter(o,"click")),G=V.actionHandler.disposables.add(new i.DomEmitter(o,"auxclick"));V.actionHandler.disposables.add(d.Event.any(j.event,G.event)(ee=>{const re=new y.StandardMouseEvent(ee);!re.leftButton&&!re.middleButton||P(re)})),V.actionHandler.disposables.add(E.addDisposableListener(o,"keydown",ee=>{const re=new D.StandardKeyboardEvent(ee);!re.equals(10)&&!re.equals(3)||P(re)}))}q.supportHtml||(A.sanitizer=P=>(q.isTrusted?P.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?P:"",A.sanitize=!0,A.silent=!0),A.renderer=Y;let R=q.value??"";R.length>1e5&&(R=`${R.substr(0,1e5)}\u2026`),q.supportThemeIcons&&(R=(0,r.markdownEscapeEscapedIcons)(R));let S;if(V.fillInIncompleteTokens){const P={...n.marked.defaults,...A},j=n.marked.lexer(R,P),G=ce(j);S=n.marked.parser(G,P)}else S=n.marked.parse(R,A);q.supportThemeIcons&&(S=(0,h.renderLabelWithIcons)(S).map(j=>typeof j=="string"?j:j.outerHTML).join(""));const H=new DOMParser().parseFromString(g(q,S),"text/html");if(H.body.querySelectorAll("img").forEach(P=>{const j=P.getAttribute("src");if(j){let G=j;try{q.baseUri&&(G=m(f.URI.from(q.baseUri),G))}catch{}P.src=_(G,!0)}}),H.body.querySelectorAll("a").forEach(P=>{const j=P.getAttribute("href");if(P.setAttribute("href",""),!j||/^data:|javascript:/i.test(j)||/^command:/i.test(j)&&!q.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(j))P.replaceWith(...P.childNodes);else{let G=_(j,!1);q.baseUri&&(G=m(f.URI.from(q.baseUri),j)),P.dataset.href=G}}),o.innerHTML=g(q,H.body.innerHTML),C.length>0)Promise.all(C).then(P=>{if(x)return;const j=new Map(P),G=o.querySelectorAll("div[data-code]");for(const ee of G){const re=j.get(ee.dataset.code??"");re&&E.reset(ee,re)}V.asyncRenderCallback?.()});else if(T.length>0){const P=new Map(T),j=o.querySelectorAll("div[data-code]");for(const G of j){const ee=P.get(G.dataset.code??"");ee&&E.reset(G,ee)}}if(V.asyncRenderCallback)for(const P of o.getElementsByTagName("img")){const j=K.add(E.addDisposableListener(P,"load",()=>{j.dispose(),V.asyncRenderCallback()}))}return{element:o,dispose:()=>{x=!0,K.dispose()}}}t.renderMarkdown=B;function M(q){if(!q)return"";const V=q.split(/[\s+|:|,|\{|\?]/,1);return V.length?V[0]:q}function m(q,V){return/^\w[\w\d+.-]*:/.test(V)?V:q.path.endsWith("/")?(0,v.resolvePath)(q,V).toString():(0,v.resolvePath)((0,v.dirname)(q),V).toString()}function g(q,V){const{config:A,allowedSchemes:K}=p(q);L.addHook("uponSanitizeAttribute",(o,k)=>{if(k.attrName==="style"||k.attrName==="class"){if(o.tagName==="SPAN"){if(k.attrName==="style"){k.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(k.attrValue);return}else if(k.attrName==="class"){k.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(k.attrValue);return}}k.keepAttr=!1;return}});const x=E.hookDomPurifyHrefAndSrcSanitizer(K);try{return L.sanitize(V,{...A,RETURN_TRUSTED_TYPE:!0})}finally{L.removeHook("uponSanitizeAttribute"),x.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function p(q){const V=[s.Schemas.http,s.Schemas.https,s.Schemas.mailto,s.Schemas.data,s.Schemas.file,s.Schemas.vscodeFileResource,s.Schemas.vscodeRemote,s.Schemas.vscodeRemoteResource];return q.isTrusted&&V.push(s.Schemas.command),{config:{ALLOWED_TAGS:[...E.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:V}}function I(q){return typeof q=="string"?q:O(q)}t.renderStringAsPlaintext=I;function O(q){let V=q.value??"";V.length>1e5&&(V=`${V.substr(0,1e5)}\u2026`);const A=n.marked.parse(V,{renderer:Z.value}).replace(/&(#\d+|[a-zA-Z]+);/g,K=>U.get(K)??K);return g({isTrusted:!1},A).toString()}t.renderMarkdownAsPlaintext=O;const U=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),Z=new e.Lazy(()=>{const q=new n.marked.Renderer;return q.code=V=>V,q.blockquote=V=>V,q.html=V=>"",q.heading=(V,A,K)=>V+`
`,q.hr=()=>"",q.list=(V,A)=>V,q.listitem=V=>V+`
`,q.paragraph=V=>V+`
`,q.table=(V,A)=>V+A+`
`,q.tablerow=V=>V,q.tablecell=(V,A)=>V+" ",q.strong=V=>V,q.em=V=>V,q.codespan=V=>V,q.br=()=>`
`,q.del=V=>V,q.image=(V,A,K)=>"",q.text=V=>V,q.link=(V,A,K)=>K,q});function ne(q){let V="";return q.forEach(A=>{V+=A.raw}),V}function se(q){for(const V of q.tokens)if(V.type==="text"){const A=V.raw.split(`
`),K=A[A.length-1];if(K.includes("`"))return ae(q);if(K.includes("**"))return Me(q);if(K.match(/\*\w/))return oe(q);if(K.match(/(^|\s)__\w/))return fe(q);if(K.match(/(^|\s)_\w/))return ye(q);if(K.match(/(^|\s)\[.*\]\(\w*/))return ke(q);if(K.match(/(^|\s)\[\w/))return Be(q)}}function ce(q){let V,A;for(V=0;V<q.length;V++){const K=q[V];if(K.type==="paragraph"&&K.raw.match(/(\n|^)```/)){A=ue(q.slice(V));break}if(K.type==="paragraph"&&K.raw.match(/(\n|^)\|/)){A=ie(q.slice(V));break}if(V===q.length-1&&K.type==="paragraph"){const x=se(K);if(x){A=[x];break}}}if(A){const K=[...q.slice(0,V),...A];return K.links=q.links,K}return q}t.fillInIncompleteTokens=ce;function ue(q){const V=ne(q);return n.marked.lexer(V+"\n```")}function ae(q){return $(q,"`")}function oe(q){return $(q,"*")}function ye(q){return $(q,"_")}function ke(q){return $(q,")")}function Be(q){return $(q,"](about:blank)")}function Me(q){return $(q,"**")}function fe(q){return $(q,"__")}function $(q,V){const A=ne(Array.isArray(q)?q:[q]);return n.marked.lexer(A+V)[0]}function ie(q){const V=ne(q),A=V.split(`
`);let K,x=!1;for(let o=0;o<A.length;o++){const k=A[o].trim();if(typeof K>"u"&&k.match(/^\s*\|/)){const _=k.match(/(\|[^\|]+)(?=\||$)/g);_&&(K=_.length)}else if(typeof K=="number")if(k.match(/^\s*\|/)){if(o!==A.length-1)return;x=!0}else return}if(typeof K=="number"&&K>0){const o=x?A.slice(0,-1).join(`
`):V,k=!!o.match(/\|\s*$/),_=o+(k?"":"|")+`
|${" --- |".repeat(K)}`;return n.marked.lexer(_)}}}),define(ge[123],me([1,0,4,9,27,59,34,2,6,99]),function(te,t,E,L,i,W,D,y,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function d(u,e){(0,h.isString)(e)?u.title=(0,D.stripIcons)(e):e?.markdownNotSupportedFallback?u.title=e.markdownNotSupportedFallback:u.removeAttribute("title")}t.setupNativeHover=d;class N{constructor(e,a,n){this.c=e,this.d=a,this.f=n}async update(e,a,n){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let c;if(e===void 0||(0,h.isString)(e)||e instanceof HTMLElement)c=e;else if(!(0,h.isFunction)(e.markdown))c=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,l.localize)(0,null),a),this.b=new i.CancellationTokenSource;const s=this.b.token;if(c=await e.markdown(s),c===void 0&&(c=e.markdownNotSupportedFallback),this.isDisposed||s.isCancellationRequested)return}this.g(c,a,n)}g(e,a,n){const c=this.a;if(this.h(e)){const s={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!c,...n};this.a=this.c.showHover(s,a)}c?.dispose()}h(e){return e?(0,W.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function r(u,e,a,n){let c,s;const w=(B,M)=>{const m=s!==void 0;B&&(s?.dispose(),s=void 0),M&&(c?.dispose(),c=void 0),m&&u.onDidHideHover?.()},v=(B,M,m)=>new L.TimeoutTimer(async()=>{(!s||s.isDisposed)&&(s=new N(u,m||e,B>0),await s.update(a,M,n))},B),F=()=>{if(c)return;const B=new y.DisposableStore,M=p=>w(!1,p.fromElement===e);B.add(E.addDisposableListener(e,E.EventType.MOUSE_LEAVE,M,!0));const m=()=>w(!0,!0);B.add(E.addDisposableListener(e,E.EventType.MOUSE_DOWN,m,!0));const g={targetElements:[e],dispose:()=>{}};if(u.placement===void 0||u.placement==="mouse"){const p=I=>{g.x=I.x+10,I.target instanceof HTMLElement&&I.target.classList.contains("action-label")&&w(!0,!0)};B.add(E.addDisposableListener(e,E.EventType.MOUSE_MOVE,p,!0))}B.add(v(u.delay,!1,g)),c=B},f=E.addDisposableListener(e,E.EventType.MOUSE_OVER,F,!0);return{show:B=>{w(!1,!0),v(0,B)},hide:()=>{w(!0,!0)},update:async(B,M)=>{a=B,await s?.update(a,void 0,M)},dispose:()=>{f.dispose(),w(!0,!0)}}}t.setupCustomHover=r}),define(ge[124],me([1,0,4,20,14,122,37,13,3,42,2,5,101,92]),function(te,t,E,L,i,W,D,y,h,l,d,N,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const u=E.$,e="selectOption.entry.template";class a{get templateId(){return e}renderTemplate(s){const w=Object.create(null);return w.root=s,w.text=E.append(s,u(".option-text")),w.detail=E.append(s,u(".option-detail")),w.decoratorRight=E.append(s,u(".option-decorator-right")),w}renderElement(s,w,v){const F=v,f=s.text,b=s.detail,B=s.decoratorRight,M=s.isDisabled;F.text.textContent=f,F.detail.textContent=b||"",F.decoratorRight.innerText=B||"",M?F.root.classList.add("option-disabled"):F.root.classList.remove("option-disabled")}disposeTemplate(s){}}class n extends d.Disposable{constructor(s,w,v,F,f){super(),this.k=[],this.y=0,this.C=!1,this.F=!1,this.H=!1,this.f=!1,this.n=F,this.g=f||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=n.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.m=new h.Emitter,this.B(this.m),this.J(),this.I(v),this.l=w||0,s&&this.setOptions(s,w),this.M()}getHeight(){return 22}getTemplateId(){return e}I(s){this.r=s,this.s=E.$(".monaco-select-box-dropdown-container"),this.s.classList.add("monaco-select-box-dropdown-padding"),this.D=E.append(this.s,u(".select-box-details-pane"));const w=E.append(this.s,u(".select-box-dropdown-container-width-control")),v=E.append(w,u(".width-control-div"));this.w=document.createElement("span"),this.w.className="option-text-width-control",E.append(v,this.w),this.z=0,this.t=E.createStyleSheet(this.s),this.s.setAttribute("draggable","true"),this.B(E.addDisposableListener(this.s,E.EventType.DRAG_START,F=>{E.EventHelper.stop(F,!0)}))}J(){this.B(E.addStandardDisposableListener(this.h,"change",w=>{this.l=w.target.selectedIndex,this.m.fire({index:w.target.selectedIndex,selected:w.target.value}),this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)})),this.B(E.addDisposableListener(this.h,E.EventType.CLICK,w=>{E.EventHelper.stop(w),this.f?this.R(!0):this.Q()})),this.B(E.addDisposableListener(this.h,E.EventType.MOUSE_DOWN,w=>{E.EventHelper.stop(w)}));let s;this.B(E.addDisposableListener(this.h,"touchstart",w=>{s=this.f})),this.B(E.addDisposableListener(this.h,"touchend",w=>{E.EventHelper.stop(w),s?this.R(!0):this.Q()})),this.B(E.addDisposableListener(this.h,E.EventType.KEY_DOWN,w=>{const v=new i.StandardKeyboardEvent(w);let F=!1;N.isMacintosh?(v.keyCode===18||v.keyCode===16||v.keyCode===10||v.keyCode===3)&&(F=!0):(v.keyCode===18&&v.altKey||v.keyCode===16&&v.altKey||v.keyCode===10||v.keyCode===3)&&(F=!0),F&&(this.Q(),E.EventHelper.stop(w,!0))}))}get onDidSelect(){return this.m.event}setOptions(s,w){y.equals(this.k,s)||(this.k=s,this.h.options.length=0,this.C=!1,this.G=void 0,this.k.forEach((v,F)=>{this.h.add(this.P(v.text,F,v.isDisabled)),typeof v.description=="string"&&(this.C=!0)})),w!==void 0&&(this.select(w),this.y=this.l)}L(){this.u?.splice(0,this.u.length,this.k)}select(s){s>=0&&s<this.k.length?this.l=s:s>this.k.length-1?this.select(this.k.length-1):this.l<0&&(this.l=0),this.h.selectedIndex=this.l,this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)}setAriaLabel(s){this.g.ariaLabel=s,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(s){this.h.tabIndex=s?0:-1}render(s){this.j=s,s.classList.add("select-container"),s.appendChild(this.h),this.N()}M(){const s=[];this.n.listFocusBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.n.listFocusBackground} !important; }`),this.n.listFocusForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.n.listFocusForeground} !important; }`),this.n.decoratorRightForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.n.decoratorRightForeground}; }`),this.n.selectBackground&&this.n.selectBorder&&this.n.selectBorder!==this.n.selectBackground?(s.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.n.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectBorder} } `)):this.n.selectListBorder&&(s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectListBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectListBorder} } `)),this.n.listHoverForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.n.listHoverForeground} !important; }`),this.n.listHoverBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.n.listHoverBackground} !important; }`),this.n.listFocusOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.n.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.n.listHoverOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.n.listHoverOutline} !important; outline-offset: -1.6px !important; }`),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.t.textContent=s.join(`
`)}N(){const s=this.n.selectBackground??"",w=this.n.selectForeground??"",v=this.n.selectBorder??"";this.h.style.backgroundColor=s,this.h.style.color=w,this.h.style.borderColor=v}O(){const s=this.n.selectBackground??"",w=E.asCssValueWithDefault(this.n.selectListBackground,s);this.v.style.backgroundColor=w,this.D.style.backgroundColor=w;const v=this.n.focusBorder??"";this.s.style.outlineColor=v,this.s.style.outlineOffset="-1px",this.u.style(this.n)}P(s,w,v){const F=document.createElement("option");return F.value=s,F.text=s,F.disabled=!!v,F}Q(){this.D.innerText="",!(!this.r||this.f)&&(this.Y(this.s),this.L(),this.r.showContextView({getAnchor:()=>this.h,render:s=>this.S(s,!0),layout:()=>{this.W()},onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.R(!1),this.r.showContextView({getAnchor:()=>this.h,render:s=>this.S(s),layout:()=>this.W(),onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.y=this.l,this.f=!0,this.h.setAttribute("aria-expanded","true"))}R(s){!this.r||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),s&&this.h.focus(),this.r.hideContextView())}S(s,w){return s.appendChild(this.s),this.W(w),{dispose:()=>{try{s.removeChild(this.s)}catch{}}}}U(){let s=0;return this.k.forEach((w,v)=>{this.db(v),this.D.offsetHeight>s&&(s=this.D.offsetHeight)}),s}W(s){if(this.F)return!1;if(this.u){this.s.classList.add("visible");const w=E.getDomNodePagePosition(this.h),v=getComputedStyle(this.h),F=parseFloat(v.getPropertyValue("--dropdown-padding-top"))+parseFloat(v.getPropertyValue("--dropdown-padding-bottom")),f=window.innerHeight-w.top-w.height-(this.g.minBottomMargin||0),b=w.top-n.b,B=this.h.offsetWidth,M=this.X(this.w),m=Math.max(M,Math.round(B)).toString()+"px";this.s.style.width=m,this.u.getHTMLElement().style.height="",this.u.layout();let g=this.u.contentHeight;this.C&&this.G===void 0&&(this.G=this.U());const p=this.C?this.G:0,I=g+F+p,O=Math.floor((f-F-p)/this.getHeight()),U=Math.floor((b-F-p)/this.getHeight());if(s)return w.top+w.height>window.innerHeight-22||w.top<n.b||O<1&&U<1?!1:(O<n.c&&U>O&&this.k.length>O?(this.z=1,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.D),this.s.appendChild(this.v),this.D.classList.remove("border-top"),this.D.classList.add("border-bottom")):(this.z=0,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.v),this.s.appendChild(this.D),this.D.classList.remove("border-bottom"),this.D.classList.add("border-top")),!0);if(w.top+w.height>window.innerHeight-22||w.top<n.b||this.z===0&&O<1||this.z===1&&U<1)return this.R(!0),!1;if(this.z===0){if(this.f&&O+U<1)return this.R(!0),!1;I>f&&(g=O*this.getHeight())}else I>b&&(g=U*this.getHeight());return this.u.layout(g),this.u.domFocus(),this.u.length>0&&(this.u.setFocus([this.l||0]),this.u.reveal(this.u.getFocus()[0]||0)),this.C?(this.u.getHTMLElement().style.height=g+F+"px",this.s.style.height=""):this.s.style.height=g+F+"px",this.db(this.l),this.s.style.width=m,this.v.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.s.classList.add("synthetic-focus"),!0}else return!1}X(s){let w=0;if(s){let v=0,F=0;this.k.forEach((f,b)=>{const B=f.detail?f.detail.length:0,M=f.decoratorRight?f.decoratorRight.length:0,m=f.text.length+B+M;m>F&&(v=b,F=m)}),s.textContent=this.k[v].text+(this.k[v].decoratorRight?this.k[v].decoratorRight+" ":""),w=E.getTotalWidth(s)}return w}Y(s){if(this.u)return;this.v=E.append(s,u(".select-box-dropdown-list-container")),this.p=new a,this.u=new D.List("SelectBoxCustom",this.v,this,[this.p],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:F=>{let f=F.text;return F.detail&&(f+=`. ${F.detail}`),F.decoratorRight&&(f+=`. ${F.decoratorRight}`),F.description&&(f+=`. ${F.description}`),f},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>N.isMacintosh?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.u.ariaLabel=this.g.ariaLabel);const w=this.B(new L.DomEmitter(this.v,"keydown")),v=h.Event.chain(w.event).filter(()=>this.u.length>0).map(F=>new i.StandardKeyboardEvent(F));this.B(v.filter(F=>F.keyCode===3).on(F=>this.fb(F),this)),this.B(v.filter(F=>F.keyCode===2).on(F=>this.fb(F),this)),this.B(v.filter(F=>F.keyCode===9).on(F=>this.eb(F),this)),this.B(v.filter(F=>F.keyCode===16).on(F=>this.hb(F),this)),this.B(v.filter(F=>F.keyCode===18).on(F=>this.gb(F),this)),this.B(v.filter(F=>F.keyCode===12).on(this.jb,this)),this.B(v.filter(F=>F.keyCode===11).on(this.ib,this)),this.B(v.filter(F=>F.keyCode===14).on(this.kb,this)),this.B(v.filter(F=>F.keyCode===13).on(this.lb,this)),this.B(v.filter(F=>F.keyCode>=21&&F.keyCode<=56||F.keyCode>=85&&F.keyCode<=113).on(this.mb,this)),this.B(E.addDisposableListener(this.u.getHTMLElement(),E.EventType.POINTER_UP,F=>this.Z(F))),this.B(this.u.onMouseOver(F=>typeof F.index<"u"&&this.u.setFocus([F.index]))),this.B(this.u.onDidChangeFocus(F=>this.cb(F))),this.B(E.addDisposableListener(this.s,E.EventType.FOCUS_OUT,F=>{!this.f||E.isAncestor(F.relatedTarget,this.s)||this.ab()})),this.u.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.u.getHTMLElement().setAttribute("aria-expanded","true"),this.O()}Z(s){if(!this.u.length)return;E.EventHelper.stop(s);const w=s.target;if(!w||w.classList.contains("slider"))return;const v=w.closest(".monaco-list-row");if(!v)return;const F=Number(v.getAttribute("data-index")),f=v.classList.contains("option-disabled");F>=0&&F<this.k.length&&!f&&(this.l=F,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.R(!0))}ab(){this.H||(this.l!==this.y&&this.select(this.y),this.R(!1))}bb(s,w){const v=f=>{for(let b=0;b<f.childNodes.length;b++){const B=f.childNodes.item(b);(B.tagName&&B.tagName.toLowerCase())==="img"?f.removeChild(B):v(B)}},F=(0,W.renderMarkdown)({value:s,supportThemeIcons:!0},{actionHandler:w});return F.element.classList.add("select-box-description-markdown"),v(F.element),F.element}cb(s){!this.f||!this.C||this.db(s.indexes[0])}db(s){this.D.innerText="";const w=this.k[s],v=w?.description??"",F=w?.descriptionIsMarkdown??!1;if(v){if(F){const f=w.descriptionMarkdownActionHandler;this.D.appendChild(this.bb(v,f))}else this.D.innerText=v;this.D.style.display="block"}else this.D.style.display="none";this.F=!0,this.r.layout(),this.F=!1}eb(s){E.EventHelper.stop(s),this.select(this.y),this.R(!0)}fb(s){E.EventHelper.stop(s),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.R(!0)}gb(s){if(this.l<this.k.length-1){E.EventHelper.stop(s,!0);const w=this.k[this.l+1].isDisabled;if(w&&this.k.length>this.l+2)this.l+=2;else{if(w)return;this.l++}this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0])}}hb(s){this.l>0&&(E.EventHelper.stop(s,!0),this.k[this.l-1].isDisabled&&this.l>1?this.l-=2:this.l--,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]))}ib(s){E.EventHelper.stop(s),this.u.focusPreviousPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l<this.k.length-1&&(this.l++,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}jb(s){E.EventHelper.stop(s),this.u.focusNextPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l>0&&(this.l--,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}kb(s){E.EventHelper.stop(s),!(this.k.length<2)&&(this.l=0,this.k[this.l].isDisabled&&this.l>1&&this.l++,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}lb(s){E.EventHelper.stop(s),!(this.k.length<2)&&(this.l=this.k.length-1,this.k[this.l].isDisabled&&this.l>1&&this.l--,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}mb(s){const w=l.KeyCodeUtils.toString(s.keyCode);let v=-1;for(let F=0;F<this.k.length-1;F++)if(v=(F+this.l+1)%this.k.length,this.k[v].text.charAt(0).toUpperCase()===w&&!this.k[v].isDisabled){this.select(v),this.u.setFocus([v]),this.u.reveal(this.u.getFocus()[0]),E.EventHelper.stop(s);break}}dispose(){this.R(!1),super.dispose()}}t.SelectBoxList=n,n.a=32,n.b=2,n.c=3}),define(ge[125],me([1,0,37,124,118,19,5,91]),function(te,t,E,L,i,W,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...E.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class y extends W.Widget{constructor(l,d,N,r,u){super(),D.isMacintosh&&!u?.useCustomDrawn?this.a=new i.SelectBoxNative(l,d,r,u):this.a=new L.SelectBoxList(l,d,N,r,u),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(l,d){this.a.setOptions(l,d)}select(l){this.a.select(l)}setAriaLabel(l){this.a.setAriaLabel(l)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(l){this.a.setFocusable(l)}render(l){this.a.render(l)}}t.SelectBox=y}),define(ge[60],me([1,0,18,51,4,23,123,125,32,2,5,6,96,48]),function(te,t,E,L,i,W,D,y,h,l,d,N,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class u extends l.Disposable{get action(){return this._action}constructor(c,s,w={}){super(),this.m=w,this._context=c||this,this._action=s,s instanceof h.Action&&this.B(s.onDidChange(v=>{this.element&&this.t(v)}))}t(c){c.enabled!==void 0&&this.u(),c.checked!==void 0&&this.G(),c.class!==void 0&&this.F(),c.label!==void 0&&(this.w(),this.C()),c.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new h.ActionRunner)),this.j}set actionRunner(c){this.j=c}isEnabled(){return this._action.enabled}setActionContext(c){this._context=c}render(c){const s=this.element=c;this.B(W.Gesture.addTarget(c));const w=this.m&&this.m.draggable;w&&(c.draggable=!0,E.isFirefox&&this.B((0,i.addDisposableListener)(c,i.EventType.DRAG_START,v=>v.dataTransfer?.setData(L.DataTransfers.TEXT,this._action.label)))),this.B((0,i.addDisposableListener)(s,W.EventType.Tap,v=>this.onClick(v,!0))),this.B((0,i.addDisposableListener)(s,i.EventType.MOUSE_DOWN,v=>{w||i.EventHelper.stop(v,!0),this._action.enabled&&v.button===0&&s.classList.add("active")})),d.isMacintosh&&this.B((0,i.addDisposableListener)(s,i.EventType.CONTEXT_MENU,v=>{v.button===0&&v.ctrlKey===!0&&this.onClick(v)})),this.B((0,i.addDisposableListener)(s,i.EventType.CLICK,v=>{i.EventHelper.stop(v,!0),this.m&&this.m.isMenu||this.onClick(v)})),this.B((0,i.addDisposableListener)(s,i.EventType.DBLCLICK,v=>{i.EventHelper.stop(v,!0)})),[i.EventType.MOUSE_UP,i.EventType.MOUSE_OUT].forEach(v=>{this.B((0,i.addDisposableListener)(s,v,F=>{i.EventHelper.stop(F),s.classList.remove("active")}))})}onClick(c,s=!1){i.EventHelper.stop(c,!0);const w=N.isUndefinedOrNull(this._context)?this.m?.useEventAsContext?c:{preserveFocus:s}:this._context;this.actionRunner.run(this._action,w)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(c){this.element&&(this.element.tabIndex=c?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const c=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(c):(this.f=(0,D.setupCustomHover)(this.m.hoverDelegate,this.element,c),this.q.add(this.f))):this.element.title=c}D(){if(this.element){const c=this.z()??"";this.element.setAttribute("aria-label",c)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=u;class e extends u{constructor(c,s,w){super(c,s,w),this.m=w,this.m.icon=w.icon!==void 0?w.icon:!1,this.m.label=w.label!==void 0?w.label:!0,this.I=""}render(c){super.render(c),this.element&&(this.p=(0,i.append)(this.element,(0,i.$)("a.action-label"))),this.p&&this.p.setAttribute("role",this.J()),this.m.label&&this.m.keybinding&&this.element&&((0,i.append)(this.element,(0,i.$)("span.keybinding")).textContent=this.m.keybinding),this.F(),this.w(),this.C(),this.u(),this.G()}J(){return this._action.id===h.Separator.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.p&&(this.p.tabIndex=0,this.p.focus())}isFocused(){return!!this.p&&this.p?.tabIndex===0}blur(){this.p&&(this.p.tabIndex=-1)}setFocusable(c){this.p&&(this.p.tabIndex=c?0:-1)}w(){this.m.label&&this.p&&(this.p.textContent=this.action.label)}z(){let c=null;return this.action.tooltip?c=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(c=this.action.label,this.m.keybinding&&(c=r.localize(0,null,c,this.m.keybinding))),c??void 0}F(){this.I&&this.p&&this.p.classList.remove(...this.I.split(" ")),this.m.icon?(this.I=this.action.class,this.p&&(this.p.classList.add("codicon"),this.I&&this.p.classList.add(...this.I.split(" "))),this.u()):this.p?.classList.remove("codicon")}u(){this.action.enabled?(this.p&&(this.p.removeAttribute("aria-disabled"),this.p.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.p&&(this.p.setAttribute("aria-disabled","true"),this.p.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.p){const c=this.z()??"";this.p.setAttribute("aria-label",c)}}G(){this.p&&(this.action.checked!==void 0?(this.p.classList.toggle("checked",this.action.checked),this.p.setAttribute("aria-checked",this.action.checked?"true":"false"),this.p.setAttribute("role","checkbox")):(this.p.classList.remove("checked"),this.p.setAttribute("aria-checked",""),this.p.setAttribute("role",this.J())))}}t.ActionViewItem=e;class a extends u{constructor(c,s,w,v,F,f,b){super(c,s),this.b=new y.SelectBox(w,v,F,f,b),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(c,s){this.b.setOptions(c,s)}select(c){this.b.select(c)}g(){this.B(this.b.onDidSelect(c=>this.k(c.selected,c.index)))}k(c,s){this.actionRunner.run(this._action,this.n(c,s))}n(c,s){return c}setFocusable(c){this.b.setFocusable(c)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(c){this.b.render(c)}}t.SelectActionViewItem=a}),define(ge[61],me([1,0,4,14,60,32,3,2,6,48]),function(te,t,E,L,i,W,D,y,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var l;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(l||(t.ActionsOrientation=l={}));class d extends y.Disposable{constructor(u,e={}){super(),this.g=this.B(new y.DisposableStore),this.n=this.B(new y.DisposableMap),this.t=!1,this.u=!0,this.w=this.B(new D.Emitter),this.onDidBlur=this.w.event,this.y=this.B(new D.Emitter({onWillAddFirstListener:()=>this.z=!0})),this.onDidCancel=this.y.event,this.z=!1,this.C=this.B(new D.Emitter),this.onDidRun=this.C.event,this.D=this.B(new D.Emitter),this.onWillRun=this.D.event,this.b=e,this.j=e.context??null,this.l=this.b.orientation??0,this.m={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new W.ActionRunner,this.g.add(this.f)),this.g.add(this.f.onDidRun(c=>this.C.fire(c))),this.g.add(this.f.onWillRun(c=>this.D.fire(c))),this.viewItems=[],this.r=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let a,n;switch(this.l){case 0:a=[15],n=[17];break;case 1:a=[16],n=[18],this.domNode.className+=" vertical";break}this.B(E.addDisposableListener(this.domNode,E.EventType.KEY_DOWN,c=>{const s=new L.StandardKeyboardEvent(c);let w=!0;const v=typeof this.r=="number"?this.viewItems[this.r]:void 0;a&&(s.equals(a[0])||s.equals(a[1]))?w=this.M():n&&(s.equals(n[0])||s.equals(n[1]))?w=this.L():s.equals(9)&&this.z?this.y.fire():s.equals(14)?w=this.I():s.equals(13)?w=this.J():s.equals(2)&&v instanceof i.BaseActionViewItem&&v.trapsArrowNavigation?w=this.L():this.G(s)?this.m.keyDown?this.O(s):this.t=!0:w=!1,w&&(s.preventDefault(),s.stopPropagation())})),this.B(E.addDisposableListener(this.domNode,E.EventType.KEY_UP,c=>{const s=new L.StandardKeyboardEvent(c);this.G(s)?(!this.m.keyDown&&this.t&&(this.t=!1,this.O(s)),s.preventDefault(),s.stopPropagation()):(s.equals(2)||s.equals(1026))&&this.H()})),this.s=this.B(E.trackFocus(this.domNode)),this.B(this.s.onDidBlur(()=>{(E.getActiveElement()===this.domNode||!E.isAncestor(E.getActiveElement(),this.domNode))&&(this.w.fire(),this.r=void 0,this.p=void 0,this.t=!1)})),this.B(this.s.onDidFocus(()=>this.H())),this.v=document.createElement("ul"),this.v.className="actions-container",this.v.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.v.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.v),u.appendChild(this.domNode)}F(){this.length()>=2?this.v.setAttribute("role",this.b.ariaRole||"toolbar"):this.v.setAttribute("role","presentation")}setAriaLabel(u){u?this.v.setAttribute("aria-label",u):this.v.removeAttribute("aria-label")}setFocusable(u){if(this.u=u,this.u){const e=this.viewItems.find(a=>a instanceof i.BaseActionViewItem&&a.isEnabled());e instanceof i.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.BaseActionViewItem&&e.setFocusable(!1)})}G(u){let e=!1;return this.m.keys.forEach(a=>{e=e||u.equals(a)}),e}H(){for(let u=0;u<this.v.children.length;u++){const e=this.v.children[u];if(E.isAncestor(E.getActiveElement(),e)){this.r=u;break}}}get context(){return this.j}set context(u){this.j=u,this.viewItems.forEach(e=>e.setActionContext(u))}get actionRunner(){return this.f}set actionRunner(u){this.f=u,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.C.fire(e))),this.g.add(this.f.onWillRun(e=>this.D.fire(e))),this.viewItems.forEach(e=>e.actionRunner=u)}getContainer(){return this.domNode}hasAction(u){return this.viewItems.findIndex(e=>e.action.id===u.id)!==-1}getAction(u){if(typeof u=="number")return this.viewItems[u]?.action;if(u instanceof HTMLElement){for(;u.parentElement!==this.v;){if(!u.parentElement)return;u=u.parentElement}for(let e=0;e<this.v.childNodes.length;e++)if(this.v.childNodes[e]===u)return this.viewItems[e].action}}push(u,e={}){const a=Array.isArray(u)?u:[u];let n=h.isNumber(e.index)?e.index:null;a.forEach(c=>{const s=document.createElement("li");s.className="action-item",s.setAttribute("role","presentation");let w;const v={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(w=this.b.actionViewItemProvider(c,v)),w||(w=new i.ActionViewItem(this.context,c,v)),this.b.allowContextMenu||this.n.set(w,E.addDisposableListener(s,E.EventType.CONTEXT_MENU,F=>{E.EventHelper.stop(F,!0)})),w.actionRunner=this.f,w.setActionContext(this.context),w.render(s),this.u&&w instanceof i.BaseActionViewItem&&this.viewItems.length===0&&w.setFocusable(!0),n===null||n<0||n>=this.v.children.length?(this.v.appendChild(s),this.viewItems.push(w)):(this.v.insertBefore(s,this.v.children[n]),this.viewItems.splice(n,0,w),n++)}),typeof this.r=="number"&&this.focus(this.r),this.F()}getWidth(u){if(u>=0&&u<this.v.children.length){const e=this.v.children.item(u);if(e)return e.clientWidth}return 0}getHeight(u){if(u>=0&&u<this.v.children.length){const e=this.v.children.item(u);if(e)return e.clientHeight}return 0}pull(u){u>=0&&u<this.viewItems.length&&(this.v.removeChild(this.v.childNodes[u]),this.n.deleteAndDispose(this.viewItems[u]),(0,y.dispose)(this.viewItems.splice(u,1)),this.F())}clear(){this.isEmpty()||(this.viewItems=(0,y.dispose)(this.viewItems),this.n.clearAndDisposeAll(),E.clearNode(this.v),this.F())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(u){let e=!1,a;if(u===void 0?e=!0:typeof u=="number"?a=u:typeof u=="boolean"&&(e=u),e&&typeof this.r>"u"){const n=this.viewItems.findIndex(c=>c.isEnabled());this.r=n===-1?void 0:n,this.N(void 0,void 0,!0)}else a!==void 0&&(this.r=a),this.N(void 0,void 0,!0)}I(){return this.r=this.length()-1,this.L(!0)}J(){return this.r=0,this.M(!0)}L(u){if(typeof this.r>"u")this.r=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.r;let a;do{if(!u&&this.b.preventLoopNavigation&&this.r+1>=this.viewItems.length)return this.r=e,!1;this.r=(this.r+1)%this.viewItems.length,a=this.viewItems[this.r]}while(this.r!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===W.Separator.ID));return this.N(),!0}M(u){if(typeof this.r>"u")this.r=0;else if(this.viewItems.length<=1)return!1;const e=this.r;let a;do{if(this.r=this.r-1,this.r<0){if(!u&&this.b.preventLoopNavigation)return this.r=e,!1;this.r=this.viewItems.length-1}a=this.viewItems[this.r]}while(this.r!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===W.Separator.ID));return this.N(!0),!0}N(u,e,a=!1){typeof this.r>"u"&&this.v.focus({preventScroll:e}),this.p!==void 0&&this.p!==this.r&&this.viewItems[this.p]?.blur();const n=this.r!==void 0&&this.viewItems[this.r];if(n){let c=!0;h.isFunction(n.focus)||(c=!1),this.b.focusOnlyEnabledItems&&h.isFunction(n.isEnabled)&&!n.isEnabled()&&(c=!1),n.action.id===W.Separator.ID&&(c=!1),c?(a||this.p!==this.r)&&(n.focus(u),this.p=this.r):(this.v.focus({preventScroll:e}),this.p=void 0)}}O(u){if(typeof this.r>"u")return;const e=this.viewItems[this.r];if(e instanceof i.BaseActionViewItem){const a=e._context===null||e._context===void 0?u:e._context;this.run(e._action,a)}}async run(u,e){await this.f.run(u,e)}dispose(){this.j=void 0,this.viewItems=(0,y.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=d;function N(r){if(!r.length)return r;let u=-1;for(let a=0;a<r.length;a++)if(r[a].id!==W.Separator.ID){u=a;break}if(u===-1)return[];r=r.slice(u);for(let a=r.length-1;a>=0&&r[a].id===W.Separator.ID;a--)r.splice(a,1);let e=!1;for(let a=r.length-1;a>=0;a--){const n=r[a].id===W.Separator.ID;n&&!e?r.splice(a,1):n?n&&(e=!1):e=!0}return r}t.prepareActions=N}),define(ge[62],me([1,0,4,20,52,61,54,57,19,3,78,47,100,88]),function(te,t,E,L,i,W,D,y,h,l,d,N,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const u=E.$;var e;(function(c){c[c.INFO=1]="INFO",c[c.WARNING=2]="WARNING",c[c.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class a extends h.Widget{constructor(s,w,v){super(),this.s="idle",this.y=Number.POSITIVE_INFINITY,this.I=this.B(new l.Emitter),this.onDidChange=this.I.event,this.J=this.B(new l.Emitter),this.onDidHeightChange=this.J.event,this.a=w,this.g=v,this.h=null,this.i=this.g.placeholder||"",this.l=this.g.tooltip??(this.i||""),this.n=this.g.ariaLabel||"",this.g.validationOptions&&(this.r=this.g.validationOptions.validation),this.element=E.append(s,u(".monaco-inputbox.idle"));const F=this.g.flexibleHeight?"textarea":"input",f=E.append(this.element,u(".ibwrapper"));if(this.b=E.append(f,u(F+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.D(this.b,()=>this.element.classList.add("synthetic-focus")),this.C(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.y=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.t=E.append(f,u("div.mirror")),this.t.innerText="\xA0",this.H=new y.ScrollableElement(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.t.style.whiteSpace="pre",this.t.style.wordWrap="initial"),E.append(s,this.H.getDomNode()),this.B(this.H),this.B(this.H.onScroll(M=>this.b.scrollTop=M.scrollTop));const b=this.B(new L.DomEmitter(document,"selectionchange")),B=l.Event.filter(b.event,()=>document.getSelection()?.anchorNode===f);this.B(B(this.N,this)),this.B(this.onDidHeightChange(this.N,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.n&&this.b.setAttribute("aria-label",this.n),this.i&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.i),this.l&&this.setTooltip(this.l),this.z(this.b,()=>this.R()),this.C(this.b,()=>this.L()),this.D(this.b,()=>this.M()),this.B(this.G(this.b)),setTimeout(()=>this.S(),0),this.g.actions&&(this.c=this.B(new W.ActionBar(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.U()}L(){this.Q(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}M(){this.P(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.i||"")}setPlaceHolder(s){this.i=s,this.b.setAttribute("placeholder",s)}setTooltip(s){this.l=s,this.b.title=s}setAriaLabel(s){this.n=s,s?this.b.setAttribute("aria-label",this.n):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.n}get mirrorElement(){return this.t}get inputElement(){return this.b}get value(){return this.b.value}set value(s){this.b.value!==s&&(this.b.value=s,this.R())}get step(){return this.b.step}set step(s){this.b.step=s}get height(){return typeof this.v=="number"?this.v:E.getTotalHeight(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(s=null){this.b.select(),s&&(this.b.setSelectionRange(s.start,s.end),s.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Q()}setEnabled(s){s?this.enable():this.disable()}get width(){return E.getTotalWidth(this.b)}set width(s){if(this.g.flexibleHeight&&this.g.flexibleWidth){let w=0;if(this.t){const v=parseFloat(this.t.style.paddingLeft||"")||0,F=parseFloat(this.t.style.paddingRight||"")||0;w=v+F}this.b.style.width=s-w+"px"}else this.b.style.width=s+"px";this.t&&(this.t.style.width=s+"px")}set paddingRight(s){this.b.style.width=`calc(100% - ${s}px)`,this.t&&(this.t.style.paddingRight=s+"px")}N(){if(typeof this.w!="number"||typeof this.v!="number"||!this.H)return;const s=this.w,w=this.v,v=this.b.scrollTop;this.H.setScrollDimensions({scrollHeight:s,height:w}),this.H.setScrollPosition({scrollTop:v})}showMessage(s,w){if(this.s==="open"&&(0,N.equals)(this.h,s))return;this.h=s,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.O(s.type));const v=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${E.asCssValueWithDefault(v.border,"transparent")}`,this.h.content&&(this.hasFocus()||w)&&this.P()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Q(),this.U()}isInputValid(){return!!this.r&&!this.r(this.value)}validate(){let s=null;return this.r&&(s=this.r(this.value),s?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(s)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),s?.type}stylesForType(s){const w=this.g.inputBoxStyles;switch(s){case 1:return{border:w.inputValidationInfoBorder,background:w.inputValidationInfoBackground,foreground:w.inputValidationInfoForeground};case 2:return{border:w.inputValidationWarningBorder,background:w.inputValidationWarningBackground,foreground:w.inputValidationWarningForeground};default:return{border:w.inputValidationErrorBorder,background:w.inputValidationErrorBackground,foreground:w.inputValidationErrorForeground}}}O(s){switch(s){case 1:return"info";case 2:return"warning";default:return"error"}}P(){if(!this.a||!this.h)return;let s;const w=()=>s.style.width=E.getTotalWidth(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:F=>{if(!this.h)return null;s=E.append(F,u(".monaco-inputbox-container")),w();const f={inline:!0,className:"monaco-inputbox-message"},b=this.h.formatContent?(0,i.renderFormattedText)(this.h.content,f):(0,i.renderText)(this.h.content,f);b.classList.add(this.O(this.h.type));const B=this.stylesForType(this.h.type);return b.style.backgroundColor=B.background??"",b.style.color=B.foreground??"",b.style.border=B.border?`1px solid ${B.border}`:"",E.append(s,b),null},onHide:()=>{this.s="closed"},layout:w});let v;this.h.type===3?v=r.localize(0,null,this.h.content):this.h.type===2?v=r.localize(1,null,this.h.content):v=r.localize(2,null,this.h.content),D.alert(v),this.s="open"}Q(){this.a&&(this.s==="open"&&this.a.hideContextView(),this.s="idle")}R(){this.I.fire(this.value),this.validate(),this.S(),this.b.classList.toggle("empty",!this.value),this.s==="open"&&this.a&&this.a.layout()}S(){if(!this.t)return;const s=this.value,v=s.charCodeAt(s.length-1)===10?" ":"";(s+v).replace(/\u000c/g,"")?this.t.textContent=s+v:this.t.innerText="\xA0",this.layout()}U(){const s=this.g.inputBoxStyles,w=s.inputBackground??"",v=s.inputForeground??"",F=s.inputBorder??"";this.element.style.backgroundColor=w,this.element.style.color=v,this.b.style.backgroundColor="inherit",this.b.style.color=v,this.element.style.border=`1px solid ${E.asCssValueWithDefault(F,"transparent")}`}layout(){if(!this.t)return;const s=this.w;this.w=E.getTotalHeight(this.t),s!==this.w&&(this.v=Math.min(this.w,this.y),this.b.style.height=this.v+"px",this.J.fire(this.w))}insertAtCursor(s){const w=this.inputElement,v=w.selectionStart,F=w.selectionEnd,f=w.value;v!==null&&F!==null&&(this.value=f.substr(0,v)+s+f.substr(F),w.setSelectionRange(v+1,v+1),this.layout())}dispose(){this.Q(),this.h=null,this.c?.dispose(),super.dispose()}}t.InputBox=a;class n extends a{constructor(s,w,v){const F=r.localize(3,null),f=` or \u21C5 ${F}`,b=` (\u21C5 ${F})`;super(s,w,v),this.Y=this.B(new l.Emitter),this.onDidFocus=this.Y.event,this.Z=this.B(new l.Emitter),this.onDidBlur=this.Z.event,this.W=new d.HistoryNavigator(v.history,100);const B=()=>{if(v.showHistoryHint&&v.showHistoryHint()&&!this.i.endsWith(f)&&!this.i.endsWith(b)&&this.W.getHistory().length){const M=this.i.endsWith(")")?f:b,m=this.i+M;v.showPlaceholderOnFocus&&document.activeElement!==this.b?this.i=m:this.setPlaceHolder(m)}};this.X=new MutationObserver((M,m)=>{M.forEach(g=>{g.target.textContent||B()})}),this.X.observe(this.b,{attributeFilter:["class"]}),this.D(this.b,()=>B()),this.C(this.b,()=>{const M=m=>{if(this.i.endsWith(m)){const g=this.i.slice(0,this.i.length-m.length);return v.showPlaceholderOnFocus?this.i=g:this.setPlaceHolder(g),!0}else return!1};M(b)||M(f)})}dispose(){super.dispose(),this.X&&(this.X.disconnect(),this.X=void 0)}addToHistory(s){this.value&&(s||this.value!==this.cb())&&this.W.add(this.value)}getHistory(){return this.W.getHistory()}isAtFirstInHistory(){return this.W.isFirst()}isAtLastInHistory(){return this.W.isLast()}isNowhereInHistory(){return this.W.isNowhere()}showNextValue(){this.W.has(this.value)||this.addToHistory();let s=this.eb();s&&(s=s===this.value?this.eb():s),this.value=s??"",D.status(this.value?this.value:r.localize(4,null))}showPreviousValue(){this.W.has(this.value)||this.addToHistory();let s=this.db();s&&(s=s===this.value?this.db():s),s&&(this.value=s,D.status(this.value))}clearHistory(){this.W.clear()}L(){super.L(),this.Z.fire()}M(){super.M(),this.Y.fire()}cb(){let s=this.W.current();return s||(s=this.W.last(),this.W.next()),s}db(){return this.W.previous()||this.W.first()}eb(){return this.W.next()}}t.HistoryInputBox=n}),define(ge[63],me([1,0,60,19,16,17,3,93]),function(te,t,E,L,i,W,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class y extends E.BaseActionViewItem{constructor(N,r,u){super(N,r,u),this.a=this.B(new h({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:u.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:u.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:u.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(N){this.element=N,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(N){this.a.domNode.tabIndex=N?0:-1}}t.ToggleActionViewItem=y;class h extends L.Widget{constructor(N){super(),this.a=this.B(new D.Emitter),this.onChange=this.a.event,this.b=this.B(new D.Emitter),this.onKeyDown=this.b.event,this.c=N,this.s=this.c.isChecked;const r=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,r.push(...W.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&r.push(...this.c.actionClassName.split(" ")),this.s&&r.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...r),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,u=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),u.preventDefault())}),this.B(this.G(this.domNode)),this.p(this.domNode,u=>{if(u.keyCode===10||u.keyCode===3){this.checked=!this.s,this.a.fire(!0),u.preventDefault(),u.stopPropagation();return}this.b.fire(u)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(N){this.s=N,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(N){this.g&&this.domNode.classList.remove(...W.ThemeIcon.asClassNameArray(this.g)),this.g=N,this.g&&this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(N){this.domNode.title=N,this.domNode.setAttribute("aria-label",N)}}t.Toggle=h;class l extends L.Widget{constructor(N,r,u){super(),this.c=N,this.g=r,this.a=new h({title:this.c,isChecked:this.g,icon:i.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.a.domNode,this.b=u,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(N){this.a.checked=N,this.h()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.Checkbox=l}),define(ge[126],me([1,0,63,16,98]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const W=i.localize(0,null),D=i.localize(1,null),y=i.localize(2,null);class h extends E.Toggle{constructor(r){super({icon:L.Codicon.caseSensitive,title:W+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.CaseSensitiveToggle=h;class l extends E.Toggle{constructor(r){super({icon:L.Codicon.wholeWord,title:D+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.WholeWordsToggle=l;class d extends E.Toggle{constructor(r){super({icon:L.Codicon.regex,title:y+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.RegexToggle=d}),define(ge[127],me([1,0,4,126,62,19,3,97,2,87]),function(te,t,E,L,i,W,D,y,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const l=y.localize(0,null);class d extends W.Widget{constructor(r,u,e){super(),this.i=!0,this.l=!1,this.n=new h.DisposableStore,this.H=[],this.I=this.B(new D.Emitter),this.onDidOptionChange=this.I.event,this.J=this.B(new D.Emitter),this.onKeyDown=this.J.event,this.L=this.B(new D.Emitter),this.onMouseDown=this.L.event,this.M=this.B(new D.Emitter),this.onInput=this.M.event,this.N=this.B(new D.Emitter),this.onKeyUp=this.N.event,this.O=this.B(new D.Emitter),this.onCaseSensitiveKeyDown=this.O.event,this.P=this.B(new D.Emitter),this.onRegexKeyDown=this.P.event,this.R=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||l,this.h=!!e.showCommonFindToggles;const a=e.appendCaseSensitiveLabel||"",n=e.appendWholeWordsLabel||"",c=e.appendRegexLabel||"",s=e.history||[],w=!!e.flexibleHeight,v=!!e.flexibleWidth,F=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.HistoryInputBox(this.domNode,u,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:s,showHistoryHint:e.showHistoryHint,flexibleHeight:w,flexibleWidth:v,flexibleMaxHeight:F,inputBoxStyles:e.inputBoxStyles})),this.h){this.v=this.B(new L.RegexToggle({appendTitle:c,isChecked:!1,...e.toggleStyles})),this.B(this.v.onChange(b=>{this.I.fire(b),!b&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.v.onKeyDown(b=>{this.P.fire(b)})),this.w=this.B(new L.WholeWordsToggle({appendTitle:n,isChecked:!1,...e.toggleStyles})),this.B(this.w.onChange(b=>{this.I.fire(b),!b&&this.i&&this.inputBox.focus(),this.validate()})),this.y=this.B(new L.CaseSensitiveToggle({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.B(this.y.onChange(b=>{this.I.fire(b),!b&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.y.onKeyDown(b=>{this.O.fire(b)}));const f=[this.y.domNode,this.w.domNode,this.v.domNode];this.p(this.domNode,b=>{if(b.equals(15)||b.equals(17)||b.equals(9)){const B=f.indexOf(document.activeElement);if(B>=0){let M=-1;b.equals(17)?M=(B+1)%f.length:b.equals(15)&&(B===0?M=f.length-1:M=B-1),b.equals(9)?(f[B].blur(),this.inputBox.focus()):M>=0&&f[M].focus(),E.EventHelper.stop(b,!0)}}})}this.s=document.createElement("div"),this.s.className="controls",this.s.style.display=this.h?"":"none",this.y&&this.s.append(this.y.domNode),this.w&&this.s.appendChild(this.w.domNode),this.v&&this.s.appendChild(this.v.domNode),this.setAdditionalToggles(e?.additionalToggles),this.s&&this.domNode.appendChild(this.s),r?.appendChild(this.domNode),this.B(E.addDisposableListener(this.inputBox.inputElement,"compositionstart",f=>{this.l=!0})),this.B(E.addDisposableListener(this.inputBox.inputElement,"compositionend",f=>{this.l=!1,this.M.fire()})),this.p(this.inputBox.inputElement,f=>this.J.fire(f)),this.u(this.inputBox.inputElement,f=>this.N.fire(f)),this.z(this.inputBox.inputElement,f=>this.M.fire()),this.j(this.inputBox.inputElement,f=>this.L.fire(f))}get isImeSessionInProgress(){return this.l}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.Q(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.v?.enable(),this.w?.enable(),this.y?.enable();for(const r of this.H)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.v?.disable(),this.w?.disable(),this.y?.disable();for(const r of this.H)r.disable()}setFocusInputOnOptionClick(r){this.i=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const u of this.H)u.domNode.remove();this.H=[],this.n.dispose(),this.n=new h.DisposableStore;for(const u of r??[])this.n.add(u),this.s.appendChild(u.domNode),this.n.add(u.onChange(e=>{this.I.fire(e),!e&&this.i&&this.inputBox.focus()})),this.H.push(u);this.H.length>0&&(this.s.style.display=""),this.Q()}Q(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.y?.width()??0)+(this.w?.width()??0)+(this.v?.width()??0)+this.H.reduce((u,e)=>u+e.width(),0)}clear(){this.S(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.y?.checked??!1}setCaseSensitive(r){this.y&&(this.y.checked=r)}getWholeWords(){return this.w?.checked??!1}setWholeWords(r){this.w&&(this.w.checked=r)}getRegex(){return this.v?.checked??!1}setRegex(r){this.v&&(this.v.checked=r,this.validate())}focusOnCaseSensitive(){this.y?.focus()}focusOnRegex(){this.v?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.R),this.R=1-this.R,this.domNode.classList.add("highlight-"+this.R)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}S(){this.inputBox.hideMessage()}}t.FindInput=d,d.OPTION_CHANGE="optionChange"}),define(ge[128],me([1,0,4,20,14,61,127,62,58,37,63,55,24,32,13,9,16,17,69,3,33,2,44,6,102,94]),function(te,t,E,L,i,W,D,y,h,l,d,N,r,u,e,a,n,c,s,w,v,F,f,b,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class M extends h.ElementsDragAndDropData{set context(o){this.c.context=o}get context(){return this.c.context}constructor(o){super(o.elements.map(k=>k.element)),this.c=o}}function m(x){return x instanceof h.ElementsDragAndDropData?new M(x):x}class g{constructor(o,k){this.c=o,this.d=k,this.b=F.Disposable.None}getDragURI(o){return this.d.getDragURI(o.element)}getDragLabel(o,k){if(this.d.getDragLabel)return this.d.getDragLabel(o.map(_=>_.element),k)}onDragStart(o,k){this.d.onDragStart?.(m(o),k)}onDragOver(o,k,_,Y,C=!0){const T=this.d.onDragOver(m(o),k&&k.element,_,Y),R=this.a!==k;if(R&&(this.b.dispose(),this.a=k),typeof k>"u")return T;if(R&&typeof T!="boolean"&&T.autoExpand&&(this.b=(0,a.disposableTimeout)(()=>{const j=this.c(),G=j.getNodeLocation(k);j.isCollapsed(G)&&j.setCollapsed(G,!1),this.a=void 0},500)),typeof T=="boolean"||!T.accept||typeof T.bubble>"u"||T.feedback){if(!C){const j=typeof T=="boolean"?T:T.accept,G=typeof T=="boolean"?void 0:T.effect;return{accept:j,effect:G,feedback:[_]}}return T}if(T.bubble===1){const j=this.c(),G=j.getNodeLocation(k),ee=j.getParentNodeLocation(G),re=j.getNode(ee),pe=ee&&j.getListIndex(ee);return this.onDragOver(o,re,pe,Y,!1)}const S=this.c(),z=S.getNodeLocation(k),H=S.getListIndex(z),P=S.getListRenderCount(z);return{...T,feedback:(0,e.range)(H,H+P)}}drop(o,k,_,Y){this.b.dispose(),this.a=void 0,this.d.drop(m(o),k&&k.element,_,Y)}onDragEnd(o){this.d.onDragEnd?.(o)}}function p(x,o){return o&&{...o,identityProvider:o.identityProvider&&{getId(k){return o.identityProvider.getId(k.element)}},dnd:o.dnd&&new g(x,o.dnd),multipleSelectionController:o.multipleSelectionController&&{isSelectionSingleChangeEvent(k){return o.multipleSelectionController.isSelectionSingleChangeEvent({...k,element:k.element})},isSelectionRangeChangeEvent(k){return o.multipleSelectionController.isSelectionRangeChangeEvent({...k,element:k.element})}},accessibilityProvider:o.accessibilityProvider&&{...o.accessibilityProvider,getSetSize(k){const _=x(),Y=_.getNodeLocation(k),C=_.getParentNodeLocation(Y);return _.getNode(C).visibleChildrenCount},getPosInSet(k){return k.visibleChildIndex+1},isChecked:o.accessibilityProvider&&o.accessibilityProvider.isChecked?k=>o.accessibilityProvider.isChecked(k.element):void 0,getRole:o.accessibilityProvider&&o.accessibilityProvider.getRole?k=>o.accessibilityProvider.getRole(k.element):()=>"treeitem",getAriaLabel(k){return o.accessibilityProvider.getAriaLabel(k.element)},getWidgetAriaLabel(){return o.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:o.accessibilityProvider&&o.accessibilityProvider.getWidgetRole?()=>o.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:o.accessibilityProvider&&o.accessibilityProvider.getAriaLevel?k=>o.accessibilityProvider.getAriaLevel(k.element):k=>k.depth,getActiveDescendantId:o.accessibilityProvider.getActiveDescendantId&&(k=>o.accessibilityProvider.getActiveDescendantId(k.element))},keyboardNavigationLabelProvider:o.keyboardNavigationLabelProvider&&{...o.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(k){return o.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(k.element)}}}}class I{constructor(o){this.a=o}getHeight(o){return this.a.getHeight(o.element)}getTemplateId(o){return this.a.getTemplateId(o.element)}hasDynamicHeight(o){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(o.element)}setDynamicHeight(o,k){this.a.setDynamicHeight?.(o.element,k)}}t.ComposedTreeDelegate=I;class O{static lift(o){return o instanceof O?o:new O(o)}static empty(o=0){return new O({focus:[],selection:[],expanded:Object.create(null),scrollTop:o})}constructor(o){if(this.focus=new Set(o.focus),this.selection=new Set(o.selection),o.expanded instanceof Array){this.expanded=Object.create(null);for(const k of o.expanded)this.expanded[k]=1}else this.expanded=o.expanded;this.expanded=o.expanded,this.scrollTop=o.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=O;var U;(function(x){x.None="none",x.OnHover="onHover",x.Always="always"})(U||(t.RenderIndentGuides=U={}));class Z{get elements(){return this.b}constructor(o,k=[]){this.b=k,this.a=new F.DisposableStore,this.onDidChange=w.Event.forEach(o,_=>this.b=_,this.a)}dispose(){this.a.dispose()}}class ne{constructor(o,k,_,Y,C,T={}){this.o=o,this.p=k,this.q=Y,this.s=C,this.b=new Map,this.c=new Map,this.d=ne.a,this.f=!1,this.g=!1,this.j=new Set,this.k=F.Disposable.None,this.m=new F.DisposableStore,this.templateId=o.templateId,this.updateOptions(T),w.Event.map(_,R=>R.node)(this.u,this,this.m),o.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(o={}){if(typeof o.indent<"u"){const k=(0,f.clamp)(o.indent,0,40);if(k!==this.d){this.d=k;for(const[_,Y]of this.c)this.v(_,Y)}}if(typeof o.renderIndentGuides<"u"){const k=o.renderIndentGuides!==U.None;if(k!==this.g){this.g=k;for(const[_,Y]of this.c)this.w(_,Y);if(this.k.dispose(),k){const _=new F.DisposableStore;this.q.onDidChange(this.x,this,_),this.k=_,this.x(this.q.elements)}}}typeof o.hideTwistiesOfChildlessElements<"u"&&(this.f=o.hideTwistiesOfChildlessElements)}renderTemplate(o){const k=(0,E.append)(o,(0,E.$)(".monaco-tl-row")),_=(0,E.append)(k,(0,E.$)(".monaco-tl-indent")),Y=(0,E.append)(k,(0,E.$)(".monaco-tl-twistie")),C=(0,E.append)(k,(0,E.$)(".monaco-tl-contents")),T=this.o.renderTemplate(C);return{container:o,indent:_,twistie:Y,indentGuidesDisposable:F.Disposable.None,templateData:T}}renderElement(o,k,_,Y){this.c.set(o,_),this.b.set(o.element,o),this.v(o,_),this.o.renderElement(o,k,_.templateData,Y)}disposeElement(o,k,_,Y){_.indentGuidesDisposable.dispose(),this.o.disposeElement?.(o,k,_.templateData,Y),typeof Y=="number"&&(this.c.delete(o),this.b.delete(o.element))}disposeTemplate(o){this.o.disposeTemplate(o.templateData)}t(o){const k=this.b.get(o);k&&this.u(k)}u(o){const k=this.c.get(o);k&&(this.x(this.q.elements),this.v(o,k))}v(o,k){const _=ne.a+(o.depth-1)*this.d;k.twistie.style.paddingLeft=`${_}px`,k.indent.style.width=`${_+this.d-16}px`,o.collapsible?k.container.setAttribute("aria-expanded",String(!o.collapsed)):k.container.removeAttribute("aria-expanded"),k.twistie.classList.remove(...c.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded));let Y=!1;this.o.renderTwistie&&(Y=this.o.renderTwistie(o.element,k.twistie)),o.collapsible&&(!this.f||o.visibleChildrenCount>0)?(Y||k.twistie.classList.add(...c.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded)),k.twistie.classList.add("collapsible"),k.twistie.classList.toggle("collapsed",o.collapsed)):k.twistie.classList.remove("collapsible","collapsed"),this.w(o,k)}w(o,k){if((0,E.clearNode)(k.indent),k.indentGuidesDisposable.dispose(),!this.g)return;const _=new F.DisposableStore,Y=this.p();for(;;){const C=Y.getNodeLocation(o),T=Y.getParentNodeLocation(C);if(!T)break;const R=Y.getNode(T),S=(0,E.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(R)&&S.classList.add("active"),k.indent.childElementCount===0?k.indent.appendChild(S):k.indent.insertBefore(S,k.indent.firstElementChild),this.s.add(R,S),_.add((0,F.toDisposable)(()=>this.s.delete(R,S))),o=R}k.indentGuidesDisposable=_}x(o){if(!this.g)return;const k=new Set,_=this.p();o.forEach(Y=>{const C=_.getNodeLocation(Y);try{const T=_.getParentNodeLocation(C);Y.collapsible&&Y.children.length>0&&!Y.collapsed?k.add(Y):T&&k.add(_.getNode(T))}catch{}}),this.j.forEach(Y=>{k.has(Y)||this.s.forEach(Y,C=>C.classList.remove("active"))}),k.forEach(Y=>{this.j.has(Y)||this.s.forEach(Y,C=>C.classList.add("active"))}),this.j=k}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,F.dispose)(this.m)}}ne.a=8;class se{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(o){this.c=o,this.d=o.toLowerCase()}constructor(o,k,_){this.g=o,this.j=k,this.k=_,this.a=0,this.b=0,this.c="",this.d="",this.f=new F.DisposableStore,o.onWillRefilter(this.m,this,this.f)}filter(o,k){let _=1;if(this.k){const T=this.k.filter(o,k);if(typeof T=="boolean"?_=T?1:0:(0,N.isFilterResult)(T)?_=(0,N.getVisibleState)(T.visibility):_=T,_===0)return!1}if(this.a++,!this.c)return this.b++,{data:v.FuzzyScore.Default,visibility:_};const Y=this.j.getKeyboardNavigationLabel(o),C=Array.isArray(Y)?Y:[Y];for(const T of C){const R=T&&T.toString();if(typeof R>"u")return{data:v.FuzzyScore.Default,visibility:_};let S;if(this.g.findMatchType===ye.Contiguous){const z=R.toLowerCase().indexOf(this.d);if(z>-1){S=[Number.MAX_SAFE_INTEGER,0];for(let H=this.d.length;H>0;H--)S.push(z+H-1)}}else S=(0,v.fuzzyScore)(this.c,this.d,0,R,R.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(S)return this.b++,C.length===1?{data:S,visibility:_}:{data:{label:R,score:S},visibility:_}}return this.g.findMode===oe.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(o):2:{data:v.FuzzyScore.Default,visibility:_}}m(){this.a=0,this.b=0}dispose(){(0,F.dispose)(this.f)}}class ce extends d.Toggle{constructor(o){super({icon:n.Codicon.listFilter,title:(0,B.localize)(0,null),isChecked:o.isChecked??!1,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.ModeToggle=ce;class ue extends d.Toggle{constructor(o){super({icon:n.Codicon.searchFuzzy,title:(0,B.localize)(1,null),isChecked:o.isChecked??!1,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.FuzzyToggle=ue;const ae={inputBoxStyles:y.unthemedInboxStyles,toggleStyles:d.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var oe;(function(x){x[x.Highlight=0]="Highlight",x[x.Filter=1]="Filter"})(oe||(t.TreeFindMode=oe={}));var ye;(function(x){x[x.Fuzzy=0]="Fuzzy",x[x.Contiguous=1]="Contiguous"})(ye||(t.TreeFindMatchType=ye={}));class ke extends F.Disposable{set mode(o){this.b.checked=o===oe.Filter,this.f.inputBox.setPlaceHolder(o===oe.Filter?(0,B.localize)(2,null):(0,B.localize)(3,null))}set matchType(o){this.c.checked=o===ye.Fuzzy}get value(){return this.f.inputBox.value}set value(o){this.f.inputBox.value=o}constructor(o,k,_,Y,C,T){super(),this.p=k,this.a=(0,E.h)(".monaco-tree-type-filter",[(0,E.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,E.h)(".monaco-tree-type-filter-input@findInput"),(0,E.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.k=0,this.m=0,this._onDidDisable=new w.Emitter,this.onDidDisable=this._onDidDisable.event,o.appendChild(this.a.root),this.B((0,F.toDisposable)(()=>o.removeChild(this.a.root)));const R=T?.styles??ae;R.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=R.listFilterWidgetBackground),R.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${R.listFilterWidgetShadow}`),this.b=this.B(new ce({...R.toggleStyles,isChecked:Y===oe.Filter})),this.c=this.B(new ue({...R.toggleStyles,isChecked:C===ye.Fuzzy})),this.onDidChangeMode=w.Event.map(this.b.onChange,()=>this.b.checked?oe.Filter:oe.Highlight,this.q),this.onDidChangeMatchType=w.Event.map(this.c.onChange,()=>this.c.checked?ye.Fuzzy:ye.Contiguous,this.q),this.f=this.B(new D.FindInput(this.a.findInput,_,{label:(0,B.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:R.inputBoxStyles,toggleStyles:R.toggleStyles,history:T?.history})),this.g=this.B(new W.ActionBar(this.a.actionbar)),this.mode=Y;const S=this.B(new L.DomEmitter(this.f.inputBox.inputElement,"keydown")),z=this.B(w.Event.chain(S.event)).map(G=>new i.StandardKeyboardEvent(G)).event;this.B(z(G=>{if(G.equals(3)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.addToHistory(),this.p.domFocus();return}if(G.equals(18)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.p.domFocus()):this.f.inputBox.showNextValue();return}if(G.equals(16)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const H=this.B(new u.Action("close",(0,B.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(H,{icon:!0,label:!1});const P=this.B(new L.DomEmitter(this.a.grab,"mousedown"));this.B(P.event(G=>{const ee=new F.DisposableStore,re=ee.add(new L.DomEmitter(window,"mousemove")),pe=ee.add(new L.DomEmitter(window,"mouseup")),we=this.k,Ne=G.pageX,Se=this.m,ve=G.pageY;this.a.grab.classList.add("grabbing");const Pe=this.a.root.style.transition;this.a.root.style.transition="unset";const Le=Ve=>{const ze=Ve.pageX-Ne;this.k=we-ze;const We=Ve.pageY-ve;this.m=Se+We,this.layout()};ee.add(re.event(Le)),ee.add(pe.event(Ve=>{Le(Ve),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Pe,ee.dispose()}))}));const j=this.B(w.Event.chain(this.B(new L.DomEmitter(this.a.grab,"keydown")).event)).map(G=>new i.StandardKeyboardEvent(G)).event;this.B(j(G=>{let ee,re;if(G.keyCode===15?ee=Number.POSITIVE_INFINITY:G.keyCode===17?ee=0:G.keyCode===10&&(ee=this.k===0?Number.POSITIVE_INFINITY:0),G.keyCode===16?re=0:G.keyCode===18&&(re=Number.POSITIVE_INFINITY),ee!==void 0&&(G.preventDefault(),G.stopPropagation(),this.k=ee,this.layout()),re!==void 0){G.preventDefault(),G.stopPropagation(),this.m=re;const pe=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=pe},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(o=this.j){this.j=o,this.k=(0,f.clamp)(this.k,0,Math.max(0,o-212)),this.a.root.style.right=`${this.k}px`,this.m=(0,f.clamp)(this.m,0,24),this.a.root.style.top=`${this.m}px`}showMessage(o){this.f.showMessage(o)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,a.timeout)(300),super.dispose()}}class Be{get pattern(){return this.b}get mode(){return this.d}set mode(o){o!==this.d&&(this.d=o,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(o))}get matchType(){return this.f}set matchType(o){o!==this.f&&(this.f=o,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(o))}constructor(o,k,_,Y,C,T={}){this.t=o,this.u=_,this.v=Y,this.w=C,this.x=T,this.b="",this.c="",this.j=0,this.k=new w.Emitter,this.onDidChangeMode=this.k.event,this.m=new w.Emitter,this.onDidChangeMatchType=this.m.event,this.o=new w.Emitter,this.onDidChangePattern=this.o.event,this.p=new w.Emitter,this.onDidChangeOpenState=this.p.event,this.q=new F.DisposableStore,this.s=new F.DisposableStore,this.d=o.options.defaultFindMode??oe.Highlight,this.f=o.options.defaultFindMatchType??ye.Fuzzy,k.onDidSplice(this.z,this,this.s)}updateOptions(o={}){o.defaultFindMode!==void 0&&(this.mode=o.defaultFindMode),o.defaultFindMatchType!==void 0&&(this.matchType=o.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new ke(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(o=>this.mode=o,void 0,this.q),this.g.onDidChangeMatchType(o=>this.matchType=o,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.dispose(),this.q=new F.DisposableStore,this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(o){this.b=o,this.o.fire(o),this.v.pattern=o,this.t.refilter(),o&&this.t.focusNext(0,!0,void 0,_=>!v.FuzzyScore.isDefault(_.filterData));const k=this.t.getFocus();if(k.length>0){const _=k[0];this.t.getRelativeTop(_)===null&&this.t.reveal(_,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const o=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&o?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,B.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(o){return!this.g||!this.pattern||this.d===oe.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!v.FuzzyScore.isDefault(o.filterData)}layout(o){this.j=o,this.g?.layout(o)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Me(x){let o=r.TreeMouseEventTarget.Unknown;return(0,E.hasParentWithClass)(x.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?o=r.TreeMouseEventTarget.Twistie:(0,E.hasParentWithClass)(x.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?o=r.TreeMouseEventTarget.Element:(0,E.hasParentWithClass)(x.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(o=r.TreeMouseEventTarget.Filter),{browserEvent:x.browserEvent,element:x.element?x.element.element:null,target:o}}function fe(x){return{element:x.element?x.element.element:null,browserEvent:x.browserEvent,anchor:x.anchor}}function $(x,o){o(x),x.children.forEach(k=>$(k,o))}class ie{get f(){return this.d||(this.d=this.m()),this.d}constructor(o,k){this.g=o,this.j=k,this.a=[],this.c=new w.Emitter,this.onDidChange=this.c.event}set(o,k){!k?.__forceEvent&&(0,e.equals)(this.a,o)||this.k(o,!1,k)}k(o,k,_){if(this.a=[...o],this.b=void 0,this.d=void 0,!k){const Y=this;this.c.fire({get elements(){return Y.get()},browserEvent:_})}}get(){return this.b||(this.b=this.a.map(o=>o.element)),[...this.b]}getNodes(){return this.a}has(o){return this.f.has(o)}onDidModelSplice({insertedNodes:o,deletedNodes:k}){if(!this.j){const S=this.m(),z=H=>S.delete(H);k.forEach(H=>$(H,z)),this.set([...S.values()]);return}const _=new Set,Y=S=>_.add(this.j.getId(S.element).toString());k.forEach(S=>$(S,Y));const C=new Map,T=S=>C.set(this.j.getId(S.element).toString(),S);o.forEach(S=>$(S,T));const R=[];for(const S of this.a){const z=this.j.getId(S.element).toString();if(!_.has(z))R.push(S);else{const P=C.get(z);P&&P.visible&&R.push(P)}}if(this.a.length>0&&R.length===0){const S=this.g();S&&R.push(S)}this.k(R,!0)}m(){const o=new Set;for(const k of this.a)o.add(k);return o}}class q extends l.MouseController{constructor(o,k){super(o),this.z=k}u(o){if((0,l.isButton)(o.browserEvent.target)||(0,l.isInputElement)(o.browserEvent.target)||(0,l.isMonacoEditor)(o.browserEvent.target)||o.browserEvent.isHandledByList)return;const k=o.element;if(!k)return super.u(o);if(this.p(o)||this.o(o))return super.u(o);const _=o.browserEvent.target,Y=_.classList.contains("monaco-tl-twistie")||_.classList.contains("monaco-icon-label")&&_.classList.contains("folder-icon")&&o.browserEvent.offsetX<16;let C=!1;if(typeof this.z.expandOnlyOnTwistieClick=="function"?C=this.z.expandOnlyOnTwistieClick(k.element):C=!!this.z.expandOnlyOnTwistieClick,C&&!Y&&o.browserEvent.detail!==2)return super.u(o);if(!this.z.expandOnDoubleClick&&o.browserEvent.detail===2)return super.u(o);if(k.collapsible){const T=this.z.getNodeLocation(k),R=o.browserEvent.altKey;if(this.z.setFocus([T]),this.z.toggleCollapsed(T,R),C&&Y){o.browserEvent.isHandledByList=!0;return}}super.u(o)}v(o){o.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.z.expandOnDoubleClick||o.browserEvent.isHandledByList||super.v(o)}}class V extends l.List{constructor(o,k,_,Y,C,T,R,S){super(o,k,_,Y,S),this.p=C,this.s=T,this.M=R}F(o){return new q(this,o.tree)}splice(o,k,_=[]){if(super.splice(o,k,_),_.length===0)return;const Y=[],C=[];let T;_.forEach((R,S)=>{this.p.has(R)&&Y.push(o+S),this.s.has(R)&&C.push(o+S),this.M.has(R)&&(T=o+S)}),Y.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...Y])),C.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...C])),typeof T=="number"&&super.setAnchor(T)}setFocus(o,k,_=!1){super.setFocus(o,k),_||this.p.set(o.map(Y=>this.element(Y)),k)}setSelection(o,k,_=!1){super.setSelection(o,k),_||this.s.set(o.map(Y=>this.element(Y)),k)}setAnchor(o,k=!1){super.setAnchor(o),k||(typeof o>"u"?this.M.set([]):this.M.set([this.element(o)]))}}class A{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return w.Event.map(this.j.onMouseClick,Me)}get onMouseDblClick(){return w.Event.filter(w.Event.map(this.j.onMouseDblClick,Me),o=>o.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return w.Event.map(this.j.onContextMenu,fe)}get onTap(){return w.Event.map(this.j.onTap,Me)}get onPointer(){return w.Event.map(this.j.onPointer,Me)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return w.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??oe.Highlight}set findMode(o){this.x&&(this.x.mode=o)}get findMatchType(){return this.x?.matchType??ye.Fuzzy}set findMatchType(o){this.x&&(this.x.matchType=o)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:w.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(o,k,_,Y,C={}){this.D=o,this.E=C,this.w=new w.EventBufferer,this.onDidChangeFindOpenState=w.Event.None,this.A=new F.DisposableStore,this.B=new w.Emitter,this.onWillRefilter=this.B.event,this.C=new w.Emitter,this.onDidUpdateOptions=this.C.event;const T=new I(_),R=new w.Relay,S=new w.Relay,z=this.A.add(new Z(S.event)),H=new s.SetMap;this.k=Y.map(G=>new ne(G,()=>this.o,R.event,z,H,C));for(const G of this.k)this.A.add(G);let P;C.keyboardNavigationLabelProvider&&(P=new se(this,C.keyboardNavigationLabelProvider,C.filter),C={...C,filter:P},this.A.add(P)),this.p=new ie(()=>this.j.getFocusedElements()[0],C.identityProvider),this.q=new ie(()=>this.j.getSelectedElements()[0],C.identityProvider),this.u=new ie(()=>this.j.getAnchorElement(),C.identityProvider),this.j=new V(o,k,T,this.k,this.p,this.q,this.u,{...p(()=>this.o,C),tree:this}),this.o=this.I(o,this.j,C),R.input=this.o.onDidChangeCollapseState;const j=w.Event.forEach(this.o.onDidSplice,G=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(G),this.q.onDidModelSplice(G)})},this.A);if(j(()=>null,null,this.A),S.input=w.Event.chain(w.Event.any(j,this.p.onDidChange,this.q.onDidChange)).debounce(()=>null,0).map(()=>{const G=new Set;for(const ee of this.p.getNodes())G.add(ee);for(const ee of this.q.getNodes())G.add(ee);return[...G.values()]}).event,C.keyboardSupport!==!1){const G=w.Event.chain(this.j.onKeyDown).filter(ee=>!(0,l.isInputElement)(ee.target)).map(ee=>new i.StandardKeyboardEvent(ee));G.filter(ee=>ee.keyCode===15).on(this.F,this,this.A),G.filter(ee=>ee.keyCode===17).on(this.G,this,this.A),G.filter(ee=>ee.keyCode===10).on(this.H,this,this.A)}if((C.findWidgetEnabled??!0)&&C.keyboardNavigationLabelProvider&&C.contextViewProvider){const G=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Be(this,this.o,this.j,P,C.contextViewProvider,G),this.y=ee=>this.x.shouldAllowFocus(ee),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=w.Event.None,this.onDidChangeFindMatchType=w.Event.None;this.z=(0,E.createStyleSheet)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===U.Always)}updateOptions(o={}){this.E={...this.E,...o};for(const k of this.k)k.updateOptions(o);this.j.updateOptions(this.E),this.x?.updateOptions(o),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===U.Always)}get options(){return this.E}updateWidth(o){const k=this.o.getListIndex(o);k!==-1&&this.j.updateWidth(k)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(o){this.j.scrollTop=o}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(o){this.j.scrollLeft=o}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const o=this.j.firstVisibleIndex;return o<0||o>=this.j.length?void 0:this.j.element(o).element}get lastVisibleElement(){const o=this.j.lastVisibleIndex;return this.j.element(o).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(o){this.j.ariaLabel=o}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(o,k){this.j.layout(o,k),(0,b.isNumber)(k)&&this.x?.layout(k)}style(o){const k=`.${this.j.domId}`,_=[];o.treeIndentGuidesStroke&&(_.push(`.monaco-list${k}:hover .monaco-tl-indent > .indent-guide, .monaco-list${k}.always .monaco-tl-indent > .indent-guide  { border-color: ${o.treeInactiveIndentGuidesStroke}; }`),_.push(`.monaco-list${k} .monaco-tl-indent > .indent-guide.active { border-color: ${o.treeIndentGuidesStroke}; }`)),this.z.textContent=_.join(`
`),this.j.style(o)}getParentElement(o){const k=this.o.getParentNodeLocation(o);return this.o.getNode(k).element}getFirstElementChild(o){return this.o.getFirstElementChild(o)}getNode(o){return this.o.getNode(o)}getNodeLocation(o){return this.o.getNodeLocation(o)}collapse(o,k=!1){return this.o.setCollapsed(o,!0,k)}expand(o,k=!1){return this.o.setCollapsed(o,!1,k)}toggleCollapsed(o,k=!1){return this.o.setCollapsed(o,void 0,k)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(o){return this.o.isCollapsible(o)}setCollapsible(o,k){return this.o.setCollapsible(o,k)}isCollapsed(o){return this.o.isCollapsed(o)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(o){if(typeof o>"u")return this.j.setAnchor(void 0);const k=this.o.getNode(o);this.u.set([k]);const _=this.o.getListIndex(o);_>-1&&this.j.setAnchor(_,!0)}getAnchor(){return(0,e.firstOrDefault)(this.u.get(),void 0)}setSelection(o,k){const _=o.map(C=>this.o.getNode(C));this.q.set(_,k);const Y=o.map(C=>this.o.getListIndex(C)).filter(C=>C>-1);this.j.setSelection(Y,k,!0)}getSelection(){return this.q.get()}setFocus(o,k){const _=o.map(C=>this.o.getNode(C));this.p.set(_,k);const Y=o.map(C=>this.o.getListIndex(C)).filter(C=>C>-1);this.j.setFocus(Y,k,!0)}focusNext(o=1,k=!1,_,Y=this.y){this.j.focusNext(o,k,_,Y)}focusPrevious(o=1,k=!1,_,Y=this.y){this.j.focusPrevious(o,k,_,Y)}focusNextPage(o,k=this.y){return this.j.focusNextPage(o,k)}focusPreviousPage(o,k=this.y){return this.j.focusPreviousPage(o,k)}focusLast(o,k=this.y){this.j.focusLast(o,k)}focusFirst(o,k=this.y){this.j.focusFirst(o,k)}getFocus(){return this.p.get()}reveal(o,k){this.o.expandTo(o);const _=this.o.getListIndex(o);_!==-1&&this.j.reveal(_,k)}getRelativeTop(o){const k=this.o.getListIndex(o);return k===-1?null:this.j.getRelativeTop(k)}getViewState(o=this.options.identityProvider){if(!o)throw new r.TreeError(this.D,"Can't get tree view state without an identity provider");const k=T=>o.getId(T).toString(),_=O.empty(this.scrollTop);for(const T of this.getFocus())_.focus.add(k(T));for(const T of this.getSelection())_.selection.add(k(T));const Y=this.o.getNode(),C=[Y];for(;C.length>0;){const T=C.shift();T!==Y&&T.collapsible&&(_.expanded[k(T.element)]=T.collapsed?0:1),C.push(...T.children)}return _}F(o){o.preventDefault(),o.stopPropagation();const k=this.j.getFocusedElements();if(k.length===0)return;const _=k[0],Y=this.o.getNodeLocation(_);if(!this.o.setCollapsed(Y,!0)){const T=this.o.getParentNodeLocation(Y);if(!T)return;const R=this.o.getListIndex(T);this.j.reveal(R),this.j.setFocus([R])}}G(o){o.preventDefault(),o.stopPropagation();const k=this.j.getFocusedElements();if(k.length===0)return;const _=k[0],Y=this.o.getNodeLocation(_);if(!this.o.setCollapsed(Y,!1)){if(!_.children.some(S=>S.visible))return;const[T]=this.j.getFocus(),R=T+1;this.j.reveal(R),this.j.setFocus([R])}}H(o){o.preventDefault(),o.stopPropagation();const k=this.j.getFocusedElements();if(k.length===0)return;const _=k[0],Y=this.o.getNodeLocation(_),C=o.browserEvent.altKey;this.o.setCollapsed(Y,void 0,C)}navigate(o){return new K(this.j,this.o,o)}dispose(){(0,F.dispose)(this.A),this.j.dispose()}}t.AbstractTree=A;class K{constructor(o,k,_){this.b=o,this.c=k,_?this.a=this.c.getListIndex(_):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(ge[129],me([1,0,128,119,24,26]),function(te,t,E,L,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class D extends E.AbstractTree{constructor(h,l,d,N,r,u={}){super(h,l,d,N,u),this.f=h,this.g=r,this.d=new Map,this.c=u.identityProvider}getInput(){return this.b}setInput(h,l){if(l&&!this.c)throw new i.TreeError(this.f,"Can't restore tree view state without an identity provider");if(this.b=h,!h){this.d.clear(),this.o.setChildren(null,W.Iterable.empty());return}if(!l){this.m(h);return}const d=[],N=[],r=e=>{const a=this.c.getId(e).toString();return!l.expanded[a]},u=e=>{const a=this.c.getId(e.element).toString();l.focus.has(a)&&d.push(e.element),l.selection.has(a)&&N.push(e.element)};this.m(h,r,u),this.setFocus(d),this.setSelection(N),l&&typeof l.scrollTop=="number"&&(this.scrollTop=l.scrollTop)}updateChildren(h=this.b){if(typeof this.b>"u")throw new i.TreeError(this.f,"Tree input not set");let l;this.c&&(l=d=>{const N=this.c.getId(d).toString(),r=this.d.get(N);if(r)return r.collapsed}),this.m(h,l)}resort(h=this.b,l=!0){this.o.resort(h===this.b?null:h,l)}refresh(h){if(h===void 0){this.j.rerender();return}this.o.rerender(h)}m(h,l,d){let N;if(this.c){const r=new Set,u=d;d=e=>{const a=this.c.getId(e.element).toString();r.add(a),this.d.set(a,e),u?.(e)},N=e=>{const a=this.c.getId(e.element).toString();r.has(a)||this.d.delete(a)}}this.o.setChildren(h===this.b?null:h,this.s(h,l).elements,{onDidCreateNode:d,onDidDeleteNode:N})}s(h,l){const d=[...this.g.getChildren(h)];return{elements:W.Iterable.map(d,r=>{const{elements:u,size:e}=this.s(r,l),a=this.g.hasChildren?this.g.hasChildren(r):void 0,n=e===0?void 0:l&&l(r);return{element:r,children:u,collapsible:a,collapsed:n}}),size:d.length}}I(h,l,d){return new L.ObjectTreeModel(h,l,d)}}t.DataTree=D}),define(ge[64],me([1,0,13,9,31,27,25,7,3,2,50,11,6]),function(te,t,E,L,i,W,D,y,h,l,d,N,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.deserialize=t.serialize=t.BufferWriter=t.BufferReader=void 0;var u;(function(fe){fe[fe.Promise=100]="Promise",fe[fe.PromiseCancel=101]="PromiseCancel",fe[fe.EventListen=102]="EventListen",fe[fe.EventDispose=103]="EventDispose"})(u||(u={}));function e(fe){switch(fe){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(fe){fe[fe.Initialize=200]="Initialize",fe[fe.PromiseSuccess=201]="PromiseSuccess",fe[fe.PromiseError=202]="PromiseError",fe[fe.PromiseErrorObj=203]="PromiseErrorObj",fe[fe.EventFire=204]="EventFire"})(a||(a={}));function n(fe){switch(fe){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(fe){fe[fe.Uninitialized=0]="Uninitialized",fe[fe.Idle=1]="Idle"})(c||(c={}));function s(fe){let $=0;for(let ie=0;;ie+=7){const q=fe.read(1);if($|=(q.buffer[0]&127)<<ie,!(q.buffer[0]&128))return $}}const w=B(0);function v(fe,$){if($===0){fe.write(w);return}let ie=0;for(let V=$;V!==0;V=V>>>7)ie++;const q=i.VSBuffer.alloc(ie);for(let V=0;$!==0;V++)q.buffer[V]=$&127,$=$>>>7,$>0&&(q.buffer[V]|=128);fe.write(q)}class F{constructor($){this.b=$,this.a=0}read($){const ie=this.b.slice(this.a,this.a+$);return this.a+=ie.byteLength,ie}}t.BufferReader=F;class f{constructor(){this.a=[]}get buffer(){return i.VSBuffer.concat(this.a)}write($){this.a.push($)}}t.BufferWriter=f;var b;(function(fe){fe[fe.Undefined=0]="Undefined",fe[fe.String=1]="String",fe[fe.Buffer=2]="Buffer",fe[fe.VSBuffer=3]="VSBuffer",fe[fe.Array=4]="Array",fe[fe.Object=5]="Object",fe[fe.Int=6]="Int"})(b||(b={}));function B(fe){const $=i.VSBuffer.alloc(1);return $.writeUInt8(fe,0),$}const M={Undefined:B(b.Undefined),String:B(b.String),Buffer:B(b.Buffer),VSBuffer:B(b.VSBuffer),Array:B(b.Array),Object:B(b.Object),Uint:B(b.Int)},m=typeof Buffer<"u";function g(fe,$){if(typeof $>"u")fe.write(M.Undefined);else if(typeof $=="string"){const ie=i.VSBuffer.fromString($);fe.write(M.String),v(fe,ie.byteLength),fe.write(ie)}else if(m&&Buffer.isBuffer($)){const ie=i.VSBuffer.wrap($);fe.write(M.Buffer),v(fe,ie.byteLength),fe.write(ie)}else if($ instanceof i.VSBuffer)fe.write(M.VSBuffer),v(fe,$.byteLength),fe.write($);else if(Array.isArray($)){fe.write(M.Array),v(fe,$.length);for(const ie of $)g(fe,ie)}else if(typeof $=="number"&&($|0)===$)fe.write(M.Uint),v(fe,$);else{const ie=i.VSBuffer.fromString(JSON.stringify($));fe.write(M.Object),v(fe,ie.byteLength),fe.write(ie)}}t.serialize=g;function p(fe){switch(fe.read(1).readUInt8(0)){case b.Undefined:return;case b.String:return fe.read(s(fe)).toString();case b.Buffer:return fe.read(s(fe)).buffer;case b.VSBuffer:return fe.read(s(fe));case b.Array:{const ie=s(fe),q=[];for(let V=0;V<ie;V++)q.push(p(fe));return q}case b.Object:return JSON.parse(fe.read(s(fe)).toString());case b.Int:return s(fe)}}t.deserialize=p;class I{constructor($,ie,q=null,V=1e3){this.h=$,this.j=ie,this.k=q,this.l=V,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(A=>this.q(A)),this.m({type:200})}registerChannel($,ie){this.b.set($,ie),setTimeout(()=>this.w($),0)}m($){switch($.type){case 200:{const ie=this.o([$.type]);this.k?.logOutgoing(ie,0,1,n($.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([$.type,$.id],$.data);this.k?.logOutgoing(ie,$.id,1,n($.type),$.data);return}}}o($,ie=void 0){const q=new f;return g(q,$),g(q,ie),this.p(q.buffer)}p($){try{return this.h.send($),$.byteLength}catch{return 0}}q($){const ie=new F($),q=p(ie),V=p(ie),A=q[0];switch(A){case 100:return this.k?.logIncoming($.byteLength,q[1],1,`${e(A)}: ${q[2]}.${q[3]}`,V),this.s({type:A,id:q[1],channelName:q[2],name:q[3],arg:V});case 102:return this.k?.logIncoming($.byteLength,q[1],1,`${e(A)}: ${q[2]}.${q[3]}`,V),this.t({type:A,id:q[1],channelName:q[2],name:q[3],arg:V});case 101:return this.k?.logIncoming($.byteLength,q[1],1,`${e(A)}`),this.u({type:A,id:q[1]});case 103:return this.k?.logIncoming($.byteLength,q[1],1,`${e(A)}`),this.u({type:A,id:q[1]})}}s($){const ie=this.b.get($.channelName);if(!ie){this.v($);return}const q=new W.CancellationTokenSource;let V;try{V=ie.call(this.j,$.name,$.arg,q.token)}catch(x){V=Promise.reject(x)}const A=$.id;V.then(x=>{this.m({id:A,data:x,type:201}),this.d.delete($.id)},x=>{x instanceof Error?this.m({id:A,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.m({id:A,data:x,type:203}),this.d.delete($.id)});const K=(0,l.toDisposable)(()=>q.cancel());this.d.set($.id,K)}t($){const ie=this.b.get($.channelName);if(!ie){this.v($);return}const q=$.id,A=ie.listen(this.j,$.name,$.arg)(K=>this.m({id:q,data:K,type:204}));this.d.set($.id,A)}u($){const ie=this.d.get($.id);ie&&(ie.dispose(),this.d.delete($.id))}v($){let ie=this.g.get($.channelName);ie||(ie=[],this.g.set($.channelName,ie));const q=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.m({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:$,timeoutTimer:q})}w($){const ie=this.g.get($);if(ie){for(const q of ie)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.s(q.request);break;case 102:this.t(q.request);break}this.g.delete($)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.dispose)(this.d.values()),this.d.clear()}}t.ChannelServer=I;var O;(function(fe){fe[fe.LocalSide=0]="LocalSide",fe[fe.OtherSide=1]="OtherSide"})(O||(t.RequestInitiator=O={}));class U{constructor($,ie=null){this.l=$,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(q=>this.s(q)),this.j=ie}getChannel($){const ie=this;return{call(q,V,A){return ie.a?Promise.reject(new y.CancellationError):ie.m($,q,V,A)},listen(q,V){return ie.a?h.Event.None:ie.o($,q,V)}}}m($,ie,q,V=W.CancellationToken.None){const A=this.g++,x={id:A,type:100,channelName:$,name:ie,arg:q};if(V.isCancellationRequested)return Promise.reject(new y.CancellationError);let o;return new Promise((_,Y)=>{if(V.isCancellationRequested)return Y(new y.CancellationError);const C=()=>{const z=H=>{switch(H.type){case 201:this.f.delete(A),_(H.data);break;case 202:{this.f.delete(A);const P=new Error(H.data.message);P.stack=Array.isArray(H.data.stack)?H.data.stack.join(`
`):H.data.stack,P.name=H.data.name,Y(P);break}case 203:this.f.delete(A),Y(H.data);break}};this.f.set(A,z),this.p(x)};let T=null;this.b===c.Idle?C():(T=(0,L.createCancelablePromise)(z=>this.u()),T.then(()=>{T=null,C()}));const R=()=>{T?(T.cancel(),T=null):this.p({id:A,type:101}),Y(new y.CancellationError)},S=V.onCancellationRequested(R);o=(0,l.combinedDisposable)((0,l.toDisposable)(R),S),this.d.add(o)}).finally(()=>{this.d.delete(o)})}o($,ie,q){const V=this.g++,K={id:V,type:102,channelName:$,name:ie,arg:q};let x=null;const o=new h.Emitter({onWillAddFirstListener:()=>{x=(0,L.createCancelablePromise)(_=>this.u()),x.then(()=>{x=null,this.d.add(o),this.p(K)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(o),this.p({id:V,type:103}))}}),k=_=>o.fire(_.data);return this.f.set(V,k),o.event}p($){switch($.type){case 100:case 102:{const ie=this.q([$.type,$.id,$.channelName,$.name],$.arg);this.j?.logOutgoing(ie,$.id,0,`${e($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const ie=this.q([$.type,$.id]);this.j?.logOutgoing(ie,$.id,0,e($.type));return}}}q($,ie=void 0){const q=new f;return g(q,$),g(q,ie),this.r(q.buffer)}r($){try{return this.l.send($),$.byteLength}catch{return 0}}s($){const ie=new F($),q=p(ie),V=p(ie),A=q[0];switch(A){case 200:return this.j?.logIncoming($.byteLength,0,0,n(A)),this.t({type:q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming($.byteLength,q[1],0,n(A),V),this.t({type:q[0],id:q[1],data:V})}}t($){if($.type===200){this.b=c.Idle,this.k.fire();return}this.f.get($.id)?.($)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.dispose)(this.d.values()),this.d.clear()}}t.ChannelClient=U,qe([D.memoize],U.prototype,"onDidInitializePromise",null);class Z{get connections(){const $=[];return this.f.forEach(ie=>$.push(ie)),$}constructor($){this.a=new Map,this.f=new Set,this.g=new h.Emitter,this.onDidAddConnection=this.g.event,this.h=new h.Emitter,this.onDidRemoveConnection=this.h.event,$(({protocol:ie,onDidClientDisconnect:q})=>{h.Event.once(ie.onMessage)(A=>{const K=new F(A),x=p(K),o=new I(ie,x),k=new U(ie);this.a.forEach((Y,C)=>o.registerChannel(C,Y));const _={channelServer:o,channelClient:k,ctx:x};this.f.add(_),this.g.fire(_),q(()=>{o.dispose(),k.dispose(),this.f.delete(_),this.h.fire(_)})})})}getChannel($,ie){const q=this;return{call(V,A,K){let x;if((0,r.isFunction)(ie)){const k=(0,E.getRandomElement)(q.connections.filter(ie));x=k?Promise.resolve(k):h.Event.toPromise(h.Event.filter(q.onDidAddConnection,ie))}else x=ie.routeCall(q,V,A);const o=x.then(k=>k.channelClient.getChannel($));return se(o).call(V,A,K)},listen(V,A){if((0,r.isFunction)(ie))return q.j($,ie,V,A);const K=ie.routeEvent(q,V,A).then(x=>x.channelClient.getChannel($));return se(K).listen(V,A)}}}j($,ie,q,V){const A=this;let K=new l.DisposableStore;const x=new h.Emitter({onWillAddFirstListener:()=>{K=new l.DisposableStore;const o=new h.EventMultiplexer,k=new Map,_=C=>{const R=C.channelClient.getChannel($).listen(q,V),S=o.add(R);k.set(C,S)},Y=C=>{const T=k.get(C);T&&(T.dispose(),k.delete(C))};A.connections.filter(ie).forEach(_),h.Event.filter(A.onDidAddConnection,ie)(_,void 0,K),A.onDidRemoveConnection(Y,void 0,K),o.event(x.fire,x,K),K.add(o)},onDidRemoveLastListener:()=>{K.dispose()}});return x.event}registerChannel($,ie){this.a.set($,ie),this.f.forEach(q=>{q.channelServer.registerChannel($,ie)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}t.IPCServer=Z;class ne{constructor($,ie,q=null){const V=new f;g(V,ie),$.send(V.buffer),this.a=new U($,q),this.d=new I($,ie,q)}getChannel($){return this.a.getChannel($)}registerChannel($,ie){this.d.registerChannel($,ie)}dispose(){this.a.dispose(),this.d.dispose()}}t.IPCClient=ne;function se(fe){return{call($,ie,q){return fe.then(V=>V.call($,ie,q))},listen($,ie){const q=new h.Relay;return fe.then(V=>q.input=V.listen($,ie)),q.event}}}t.getDelayedChannel=se;function ce(fe){let $=!1;return{call(ie,q,V){return $?fe.call(ie,q,V):(0,L.timeout)(0).then(()=>$=!0).then(()=>fe.call(ie,q,V))},listen(ie,q){if($)return fe.listen(ie,q);const V=new h.Relay;return(0,L.timeout)(0).then(()=>$=!0).then(()=>V.input=fe.listen(ie,q)),V.event}}}t.getNextTickChannel=ce;class ue{constructor($){this.a=$}routeCall($){return this.b($)}routeEvent($){return this.b($)}async b($){for(const ie of $.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await h.Event.toPromise($.onDidAddConnection),await this.b($)}}t.StaticRouter=ue;var ae;(function(fe){function $(A,K){const x=A,o=K&&K.disableMarshalling,k=new Map;for(const _ in x)q(_)&&k.set(_,h.Event.buffer(x[_],!0));return new class{listen(_,Y,C){const T=k.get(Y);if(T)return T;if(V(Y)){const R=x[Y];if(typeof R=="function")return R.call(x,C)}throw new Error(`Event not found: ${Y}`)}call(_,Y,C){const T=x[Y];if(typeof T=="function"){if(!o&&Array.isArray(C))for(let R=0;R<C.length;R++)C[R]=(0,d.revive)(C[R]);return T.apply(x,C)}throw new Error(`Method not found: ${Y}`)}}}fe.fromService=$;function ie(A,K){const x=K&&K.disableMarshalling;return new Proxy({},{get(o,k){if(typeof k=="string")return K?.properties?.has(k)?K.properties.get(k):V(k)?function(_){return A.listen(k,_)}:q(k)?A.listen(k):async function(..._){let Y;K&&!(0,r.isUndefinedOrNull)(K.context)?Y=[K.context,..._]:Y=_;const C=await A.call(k,Y);return x?C:(0,d.revive)(C)};throw new Error(`Property not found: ${String(k)}`)}})}fe.toService=ie;function q(A){return A[0]==="o"&&A[1]==="n"&&N.isUpperAsciiLetter(A.charCodeAt(2))}function V(A){return/^onDynamic/.test(A)&&N.isUpperAsciiLetter(A.charCodeAt(9))}})(ae||(t.ProxyChannel=ae={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ye(fe){if(Array.isArray(fe))return fe;if(fe&&typeof fe=="object"&&typeof fe.toString=="function"){const $=fe.toString();if($!=="[object Object]")return $}return fe}function ke(fe){return Array.isArray(fe)?fe.map(ye):ye(fe)}function Be(fe,$,ie,q,V,A,K){K=ke(K);const x=oe[V],o=x[q%x.length];let k=[`%c[${fe}]%c[${String($).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${o}`];/\($/.test(A)?(k=k.concat(K),k.push(")")):k.push(K),console.log.apply(console,k)}class Me{constructor($,ie){this.d=$,this.f=ie,this.a=0,this.b=0}logOutgoing($,ie,q,V,A){this.b+=$,Be(this.d,this.b,$,ie,q,V,A)}logIncoming($,ie,q,V,A){this.a+=$,Be(this.f,this.a,$,ie,q,V,A)}}t.IPCLogger=Me}),define(ge[29],me([1,0,5]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=E.globals.vscode.ipcRenderer,t.ipcMessagePort=E.globals.vscode.ipcMessagePort,t.webFrame=E.globals.vscode.webFrame,t.process=E.globals.vscode.process,t.context=E.globals.vscode.context}),define(ge[130],me([1,0,81,29]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let i=0;function W(y,h,l){const d=[],N=i++,r=`vscode:onContextMenu${N}`,u=(e,a,n)=>{d[a].click?.(n)};L.ipcRenderer.once(r,u),L.ipcRenderer.once(E.CONTEXT_MENU_CLOSE_CHANNEL,(e,a)=>{a===N&&(L.ipcRenderer.removeListener(r,u),l?.())}),L.ipcRenderer.send(E.CONTEXT_MENU_CHANNEL,N,y.map(e=>D(e,d)),r,h)}t.popup=W;function D(y,h){const l={id:h.length,label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:typeof y.enabled=="boolean"?y.enabled:!0,visible:typeof y.visible=="boolean"?y.visible:!0};return h.push(y),Array.isArray(y.submenu)&&(l.submenu=y.submenu.map(d=>D(d,h))),l}}),define(ge[131],me([1,0,31,3,64,82,29]),function(te,t,E,L,i,W,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class y extends i.IPCClient{static f(){const l=L.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:message",(d,N)=>E.VSBuffer.wrap(N));return D.ipcRenderer.send("vscode:hello"),new W.Protocol(D.ipcRenderer,l)}constructor(l){const d=y.f();super(d,l),this.b=d}dispose(){this.b.disconnect()}}t.Client=y}),define(ge[132],me([12,10]),function(te,t){return te.create("vs/platform/files/common/files",t)}),define(ge[133],me([12,10]),function(te,t){return te.create("vs/platform/theme/common/iconRegistry",t)}),define(ge[38],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var E;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(h){return h[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(E||(t._util=E={})),t.IInstantiationService=i("instantiationService");function L(D,y,h){y[E.DI_TARGET]===y?y[E.DI_DEPENDENCIES].push({id:D,index:h}):(y[E.DI_DEPENDENCIES]=[{id:D,index:h}],y[E.DI_TARGET]=y)}function i(D){if(E.serviceIds.has(D))return E.serviceIds.get(D);const y=function(h,l,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(y,h,d)};return y.toString=()=>D,E.serviceIds.set(D,y),y}t.createDecorator=i;function W(D){return D}t.refineServiceDecorator=W}),define(ge[134],me([1,0,38]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,E.createDecorator)(t.ID);function L(W){return!!W.hostName&&!!W.errorMessage}t.isRemoteDiagnosticError=L;class i{async getPerformanceInfo(D,y){return{}}async getSystemInfo(D,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,y){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}t.NullDiagnosticsService=i}),define(ge[135],me([1,0,113,22,11,6,15,132,38,5,28]),function(te,t,E,L,i,W,D,y,h,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLargeFileConfirmationLimit=t.ByteSize=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_READONLY_FROM_PERMISSIONS_CONFIG=t.FILES_READONLY_EXCLUDE_CONFIG=t.FILES_READONLY_INCLUDE_CONFIG=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicDeleteCapability=t.hasFileAtomicWriteCapability=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,h.createDecorator)("fileService");function N($){return $.create===!0}t.isFileOpenForWriteOptions=N;var r;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(r||(t.FileType=r={}));var u;(function($){$[$.Readonly=1]="Readonly",$[$.Locked=2]="Locked"})(u||(t.FilePermission=u={}));var e;(function($){$[$.None=0]="None",$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileAtomicWrite=32768]="FileAtomicWrite",$[$.FileAtomicDelete=65536]="FileAtomicDelete",$[$.FileClone=131072]="FileClone"})(e||(t.FileSystemProviderCapabilities=e={}));function a($){return!!($.capabilities&2)}t.hasReadWriteCapability=a;function n($){return!!($.capabilities&8)}t.hasFileFolderCopyCapability=n;function c($){return!!($.capabilities&131072)}t.hasFileCloneCapability=c;function s($){return!!($.capabilities&4)}t.hasOpenReadWriteCloseCapability=s;function w($){return!!($.capabilities&16)}t.hasFileReadStreamCapability=w;function v($){return a($)?!!($.capabilities&16384):!1}t.hasFileAtomicReadCapability=v;function F($){return a($)?!!($.capabilities&32768):!1}t.hasFileAtomicWriteCapability=F;function f($){return!!($.capabilities&65536)}t.hasFileAtomicDeleteCapability=f;var b;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsStorageQuota="EntryExceedsStorageQuota",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(b||(t.FileSystemProviderErrorCode=b={}));class B extends Error{static create(ie,q){const V=new B(ie.toString(),q);return g(V,q),V}constructor(ie,q){super(ie),this.code=q}}t.FileSystemProviderError=B;function M($,ie){return B.create($,ie)}t.createFileSystemProviderError=M;function m($){return $||M((0,y.localize)(0,null),b.Unknown)}t.ensureFileSystemProviderError=m;function g($,ie){return $.name=ie?`${ie} (FileSystemError)`:"FileSystemError",$}t.markAsFileSystemProviderError=g;function p($){if(!$)return b.Unknown;if($ instanceof B)return $.code;const ie=/^(.+) \(FileSystemError\)$/.exec($.name);if(!ie)return b.Unknown;switch(ie[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}t.toFileSystemProviderErrorCode=p;function I($){if($ instanceof ce)return $.fileOperationResult;switch(p($)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}t.toFileOperationResult=I;var O;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(O||(t.FileOperation=O={}));class U{constructor(ie,q,V){this.resource=ie,this.operation=q,this.target=V}isOperation(ie){return this.operation===ie}}t.FileOperationEvent=U;var Z;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(Z||(t.FileChangeType=Z={}));class ne{constructor(ie,q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const V=new Map;for(const A of ie){const K=V.get(A.type);switch(K?K.push([A.resource,A]):V.set(A.type,[[A.resource,A]]),A.type){case 1:this.rawAdded.push(A.resource);break;case 0:this.rawUpdated.push(A.resource);break;case 2:this.rawDeleted.push(A.resource);break}}for(const[A,K]of V)switch(A){case 1:this.a=E.TernarySearchTree.forUris(()=>q),this.a.fill(K);break;case 0:this.b=E.TernarySearchTree.forUris(()=>q),this.b.fill(K);break;case 2:this.c=E.TernarySearchTree.forUris(()=>q),this.c.fill(K);break}}contains(ie,...q){return this.d(ie,{includeChildren:!1},...q)}affects(ie,...q){return this.d(ie,{includeChildren:!0},...q)}d(ie,q,...V){if(!ie)return!1;const A=V.length>0;return!!((!A||V.includes(1))&&(this.a?.get(ie)||q.includeChildren&&this.a?.findSuperstr(ie))||(!A||V.includes(0))&&(this.b?.get(ie)||q.includeChildren&&this.b?.findSuperstr(ie))||(!A||V.includes(2))&&(this.c?.findSubstr(ie)||q.includeChildren&&this.c?.findSuperstr(ie)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.FileChangesEvent=ne;function se($,ie,q){return!$||!ie||$===ie||ie.length>$.length?!1:(ie.charAt(ie.length-1)!==L.sep&&(ie+=L.sep),q?(0,i.startsWithIgnoreCase)($,ie):$.indexOf(ie)===0)}t.isParent=se;class ce extends Error{constructor(ie,q,V){super(ie),this.fileOperationResult=q,this.options=V}}t.FileOperationError=ce;class ue extends ce{constructor(ie,q,V,A){super(ie,q,A),this.fileOperationResult=q,this.size=V}}t.TooLargeFileOperationError=ue;class ae extends ce{constructor(ie,q,V){super(ie,2,V),this.stat=q}}t.NotModifiedSinceFileOperationError=ae;var oe;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(oe||(t.FileOperationResult=oe={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",t.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",t.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",t.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ye;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(ye||(t.FileKind=ye={})),t.ETAG_DISABLED="";function ke($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}t.etag=ke;async function Be($,ie){if(!ie.hasProvider(D.URI.from({scheme:$.scheme})))return new Promise(q=>{const V=ie.onDidChangeFileSystemProviderRegistrations(A=>{A.scheme===$.scheme&&A.added&&(V.dispose(),q())})})}t.whenProviderRegistered=Be;class Me{static formatSize(ie){return(0,W.isNumber)(ie)||(ie=0),ie<Me.KB?(0,y.localize)(1,null,ie.toFixed(0)):ie<Me.MB?(0,y.localize)(2,null,(ie/Me.KB).toFixed(2)):ie<Me.GB?(0,y.localize)(3,null,(ie/Me.MB).toFixed(2)):ie<Me.TB?(0,y.localize)(4,null,(ie/Me.GB).toFixed(2)):(0,y.localize)(5,null,(ie/Me.TB).toFixed(2))}}t.ByteSize=Me,Me.KB=1024,Me.MB=Me.KB*Me.KB,Me.GB=Me.MB*Me.KB,Me.TB=Me.GB*Me.KB;function fe($){const ie=typeof $=="string"||$?.scheme===d.Schemas.vscodeRemote;return typeof $!="string"&&$?.scheme===d.Schemas.file?1024*Me.MB:ie?10*Me.MB:l.isWeb?50*Me.MB:1024*Me.MB}t.getLargeFileConfirmationLimit=fe}),define(ge[136],me([1,0,38]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,E.createDecorator)("mainProcessService");class L{constructor(W,D){this.a=W,this.b=D}getChannel(W){return this.a.getChannel(W,this.b)}registerChannel(W,D){this.a.registerChannel(W,D)}}t.MainProcessService=L}),define(ge[137],me([1,0,2,131]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class i extends E.Disposable{constructor(D){super(),this.a=this.B(new L.Client(`window:${D}`))}getChannel(D){return this.a.getChannel(D)}registerChannel(D,y){this.a.registerChannel(D,y)}}t.ElectronIPCMainProcessService=i});var ci=this&&this.__param||function(te,t){return function(E,L){t(E,L,te)}};define(ge[138],me([1,0,64,136]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let i=t.NativeHostService=class{constructor(D,y){return this.windowId=D,E.ProxyChannel.toService(y.getChannel("nativeHost"),{context:D,properties:(()=>{const h=new Map;return h.set("windowId",D),h})()})}};t.NativeHostService=i=qe([ci(1,L.IMainProcessService)],i)}),define(ge[65],me([1,0,72,6]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class i{constructor(){this.a=new Map}add(D,y){E.ok(L.isString(D)),E.ok(L.isObject(y)),E.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,y)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}t.Registry=new i}),define(ge[139],me([1,0,3,65]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function i(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class W{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,l){this.a[i(h)]=l,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const D=new W;L.Registry.add(t.Extensions.JSONContribution,D)}),define(ge[140],me([1,0,9,16,17,3,6,15,133,139,65]),function(te,t,E,L,i,W,D,y,h,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var N;(function(v){function F(f,b){let B=f.defaults;for(;i.ThemeIcon.isThemeIcon(B);){const M=e.getIcon(B.id);if(!M)return;B=M.defaults}return B}v.getDefinition=F})(N||(t.IconContribution=N={}));var r;(function(v){function F(b){return{weight:b.weight,style:b.style,src:b.src.map(B=>({format:B.format,location:B.location.toString()}))}}v.toJSONObject=F;function f(b){const B=M=>(0,D.isString)(M)?M:void 0;if(b&&Array.isArray(b.src)&&b.src.every(M=>(0,D.isString)(M.format)&&(0,D.isString)(M.location)))return{weight:B(b.weight),style:B(b.style),src:b.src.map(M=>({format:M.format,location:y.URI.parse(M.location)}))}}v.fromJSONObject=f})(r||(t.IconFontDefinition=r={}));class u{constructor(){this.a=new W.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,h.localize)(0,null)},fontCharacter:{type:"string",description:(0,h.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(F,f,b,B){const M=this.b[F];if(M){if(b&&!M.description){M.description=b,this.d.properties[F].markdownDescription=`${b} $(${F})`;const p=this.e.enum.indexOf(F);p!==-1&&(this.e.enumDescriptions[p]=b),this.a.fire()}return M}const m={id:F,description:b,defaults:f,deprecationMessage:B};this.b[F]=m;const g={$ref:"#/definitions/icons"};return B&&(g.deprecationMessage=B),b&&(g.markdownDescription=`${b}: $(${F})`),this.d.properties[F]=g,this.e.enum.push(F),this.e.enumDescriptions.push(b||""),this.a.fire(),{id:F}}deregisterIcon(F){delete this.b[F],delete this.d.properties[F];const f=this.e.enum.indexOf(F);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(F=>this.b[F])}getIcon(F){return this.b[F]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(F,f){const b=this.f[F];return b||(this.f[F]=f,this.a.fire(),f)}deregisterIconFont(F){delete this.f[F]}getIconFont(F){return this.f[F]}toString(){const F=(M,m)=>M.id.localeCompare(m.id),f=M=>{for(;i.ThemeIcon.isThemeIcon(M.defaults);)M=this.b[M.defaults.id];return`codicon codicon-${M?M.id:""}`},b=[];b.push("| preview     | identifier                        | default codicon ID                | description"),b.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const B=Object.keys(this.b).map(M=>this.b[M]);for(const M of B.filter(m=>!!m.description).sort(F))b.push(`|<i class="${f(M)}"></i>|${M.id}|${i.ThemeIcon.isThemeIcon(M.defaults)?M.defaults.id:M.id}|${M.description||""}|`);b.push("| preview     | identifier                        "),b.push("| ----------- | --------------------------------- |");for(const M of B.filter(m=>!i.ThemeIcon.isThemeIcon(m.defaults)).sort(F))b.push(`|<i class="${f(M)}"></i>|${M.id}|`);return b.join(`
`)}}const e=new u;d.Registry.add(t.Extensions.IconContribution,e);function a(v,F,f,b){return e.registerIcon(v,F,f,b)}t.registerIcon=a;function n(){return e}t.getIconRegistry=n;function c(){const v=(0,L.getCodiconFontCharacters)();for(const F in v){const f="\\"+v[F].toString(16);e.registerIcon(F,{fontCharacter:f})}}c(),t.iconsSchemaId="vscode://schemas/icons";const s=d.Registry.as(l.Extensions.JSONContribution);s.registerSchema(t.iconsSchemaId,e.getIconSchema());const w=new E.RunOnceScheduler(()=>s.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{w.isScheduled()||w.schedule()}),t.widgetClose=a("widget-close",L.Codicon.close,(0,h.localize)(2,null)),t.gotoPreviousLocation=a("goto-previous-location",L.Codicon.arrowUp,(0,h.localize)(3,null)),t.gotoNextLocation=a("goto-next-location",L.Codicon.arrowDown,(0,h.localize)(4,null)),t.syncing=i.ThemeIcon.modify(L.Codicon.sync,"spin"),t.spinningLoading=i.ThemeIcon.modify(L.Codicon.loading,"spin")}),define(ge[141],me([1,0,4,3,17,140]),function(te,t,E,L,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function D(h){const l=new L.Emitter,d=(0,W.getIconRegistry)();return d.onDidChange(()=>l.fire()),h?.onDidProductIconThemeChange(()=>l.fire()),{onDidChange:l.event,getCSS(){const N=h?h.getProductIconTheme():new y,r={},u=a=>{const n=N.getIcon(a);if(!n)return;const c=n.font;return c?(r[c.id]=c.definition,`.codicon-${a.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,E.asCSSPropertyValue)(c.id)}; }`):`.codicon-${a.id}:before { content: '${n.fontCharacter}'; }`},e=[];for(const a of d.getIcons()){const n=u(a);n&&e.push(n)}for(const a in r){const n=r[a],c=n.weight?`font-weight: ${n.weight};`:"",s=n.style?`font-style: ${n.style};`:"",w=n.src.map(v=>`${(0,E.asCSSUrl)(v.location)} format('${v.format}')`).join(", ");e.push(`@font-face { src: ${w}; font-family: ${(0,E.asCSSPropertyValue)(a)};${c}${s} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=D;class y{getIcon(l){const d=(0,W.getIconRegistry)();let N=l.defaults;for(;i.ThemeIcon.isThemeIcon(N);){const r=d.getIcon(N.id);if(!r)return;N=r.defaults}return N}}t.UnthemedProductIconTheme=y}),define(ge[142],me([1,0,5]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(d){return!!d.workspaceUri}t.isWorkspaceToOpen=L;function i(d){return!!d.folderUri}t.isFolderToOpen=i;function W(d){return!!d.fileUri}t.isFileToOpen=W;function D(d){const N=y(d),r=d.getValue("window.menuBarVisibility");return r==="default"||N==="native"&&r==="compact"||E.isMacintosh&&E.isNative?"classic":r}t.getMenuBarVisibility=D;function y(d){if(E.isWeb)return"custom";const N=d.getValue("window");if(N){if(E.isMacintosh&&N.nativeTabs===!0||E.isMacintosh&&N.nativeFullScreen===!1)return"native";const e=N.titleBarStyle;if(e==="native"||e==="custom")return e}return E.isLinux?"native":"custom"}t.getTitleBarStyle=y;function h(d){if(!E.isWindows||E.isWeb||y(d)==="native")return!1;const N=d.getValue("window.experimental.windowControlsOverlay.enabled");return typeof N=="boolean"?N:!0}t.useWindowControlsOverlay=h;function l(d=0){return Math.pow(1.2,d)}t.zoomLevelToZoomFactor=l}),define(ge[143],me([1,0,18,29,142]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function W(h){L.webFrame.setZoomLevel(h),(0,E.setZoomFactor)((0,i.zoomLevelToZoomFactor)(h)),(0,E.setZoomLevel)(h,!1)}t.applyZoom=W;function D(){W((0,E.getZoomLevel)()+1)}t.zoomIn=D;function y(){W((0,E.getZoomLevel)()-1)}t.zoomOut=y}),define(ge[144],me([1,0,10,4,129,9,130,29,134,135,137,138,141,143,14,95,86]),function(te,t,E,L,i,W,D,y,h,l,d,N,r,u,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const a=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,n=/\s--inspect-port=(?<port>\d+)/;class c{getHeight(O){return 22}getTemplateId(O){return M(O)?"process":b(O)?"machine":(0,h.isRemoteDiagnosticError)(O)?"error":B(O)?"header":""}}class s{hasChildren(O){return(0,h.isRemoteDiagnosticError)(O)?!1:M(O)?!!O.children?.length:!0}getChildren(O){return M(O)?O.children?O.children:[]:(0,h.isRemoteDiagnosticError)(O)?[]:B(O)?O.processRoots.length>1?O.processRoots:[O.processRoots[0].rootProcess]:b(O)?[O.rootProcess]:[O.processes]}}class w{constructor(){this.templateId="header"}renderTemplate(O){const U=(0,L.append)(O,(0,L.$)(".row")),Z=(0,L.append)(U,(0,L.$)(".nameLabel")),ne=(0,L.append)(U,(0,L.$)(".cpu")),se=(0,L.append)(U,(0,L.$)(".memory")),ce=(0,L.append)(U,(0,L.$)(".pid"));return{name:Z,CPU:ne,memory:se,PID:ce}}renderElement(O,U,Z,ne){Z.name.textContent=(0,E.localize)(0,null),Z.CPU.textContent=(0,E.localize)(1,null),Z.PID.textContent=(0,E.localize)(2,null),Z.memory.textContent=(0,E.localize)(3,null)}disposeTemplate(O){}}class v{constructor(){this.templateId="machine"}renderTemplate(O){const U=Object.create(null),Z=(0,L.append)(O,(0,L.$)(".row"));return U.name=(0,L.append)(Z,(0,L.$)(".nameLabel")),U}renderElement(O,U,Z,ne){Z.name.textContent=O.element.name}disposeTemplate(O){}}class F{constructor(){this.templateId="error"}renderTemplate(O){const U=Object.create(null),Z=(0,L.append)(O,(0,L.$)(".row"));return U.name=(0,L.append)(Z,(0,L.$)(".nameLabel")),U}renderElement(O,U,Z,ne){Z.name.textContent=O.element.errorMessage}disposeTemplate(O){}}class f{constructor(O,U,Z){this.a=O,this.b=U,this.c=Z,this.templateId="process"}renderTemplate(O){const U=(0,L.append)(O,(0,L.$)(".row")),Z=(0,L.append)(U,(0,L.$)(".nameLabel")),ne=(0,L.append)(U,(0,L.$)(".cpu")),se=(0,L.append)(U,(0,L.$)(".memory")),ce=(0,L.append)(U,(0,L.$)(".pid"));return{name:Z,CPU:ne,PID:ce,memory:se}}renderElement(O,U,Z,ne){const{element:se}=O,ce=se.pid.toFixed(0);let ue=se.name;this.c.has(se.pid)&&(ue=this.c.get(se.pid)),Z.name.textContent=ue,Z.name.title=se.cmd,Z.CPU.textContent=se.load.toFixed(0),Z.PID.textContent=ce,Z.PID.parentElement.id=`pid-${ce}`;const ae=this.a==="win32"?se.mem:this.b*(se.mem/100);Z.memory.textContent=(ae/l.ByteSize.MB).toFixed(0)}disposeTemplate(O){}}function b(I){return!!I.name&&!!I.rootProcess}function B(I){return!!I.processRoots}function M(I){return!!I.pid}class m{constructor(O,U){this.f=U,this.b=new Map;const Z=new d.ElectronIPCMainProcessService(O);this.c=new N.NativeHostService(O,Z),this.k(U.styles),this.g(U),y.ipcRenderer.on("vscode:pidToNameResponse",(ne,se)=>{this.b=new Map;for(const[ce,ue]of se)this.b.set(ce,ue)}),y.ipcRenderer.on("vscode:listProcessesResponse",async(ne,se)=>{se.forEach((ce,ue)=>{M(ce.rootProcess)&&(ce.rootProcess.name=ue===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:se}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(se),this.m(0)}),this.a=Date.now(),y.ipcRenderer.send("vscode:pidToNameRequest"),y.ipcRenderer.send("vscode:listProcesses")}g(O){document.onkeydown=U=>{const Z=O.platform==="darwin"?U.metaKey:U.ctrlKey;Z&&U.keyCode===87&&(U.stopPropagation(),U.preventDefault(),y.ipcRenderer.send("vscode:closeProcessExplorer")),Z&&U.keyCode===187&&(0,u.zoomIn)(),Z&&U.keyCode===189&&(0,u.zoomOut)()}}async h(O){const U=document.getElementById("process-list");if(!U)return;const{totalmem:Z}=await this.c.getOSStatistics(),ne=[new f(this.f.platform,Z,this.b),new w,new v,new F];this.d=new i.DataTree("processExplorer",U,new c,ne,new s,{identityProvider:{getId:se=>M(se)?se.pid.toString():(0,h.isRemoteDiagnosticError)(se)?se.hostName:B(se)?"processes":b(se)?se.name:"header"}}),this.d.setInput({processes:{processRoots:O}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(se=>{const ce=new e.StandardKeyboardEvent(se);if(ce.keyCode===35&&ce.altKey){const ue=this.n();Promise.all(ue.map(ae=>this.c.killProcess(ae,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(se=>{M(se.element)&&this.l(se.element,!0)}),U.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{U.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(O){const U=a.exec(O);return U&&U.groups.port!=="0"||O.indexOf("node ")>=0||O.indexOf("node.exe")>=0}j(O){const U={type:"node",request:"attach",name:`process ${O.pid}`};let Z=a.exec(O.cmd);Z?U.port=Number(Z.groups.port):U.processId=String(O.pid),Z=n.exec(O.cmd),Z&&(U.port=Number(Z.groups.port)),y.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[U]})}k(O){const U=(0,L.createStyleSheet)(),Z=[];O.listFocusBackground&&(Z.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${O.listFocusBackground}; }`),Z.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${O.listFocusBackground}; }`)),O.listFocusForeground&&Z.push(`.monaco-list:focus .monaco-list-row.focused { color: ${O.listFocusForeground}; }`),O.listActiveSelectionBackground&&(Z.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${O.listActiveSelectionBackground}; }`),Z.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${O.listActiveSelectionBackground}; }`)),O.listActiveSelectionForeground&&Z.push(`.monaco-list:focus .monaco-list-row.selected { color: ${O.listActiveSelectionForeground}; }`),O.listHoverBackground&&Z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${O.listHoverBackground}; }`),O.listHoverForeground&&Z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${O.listHoverForeground}; }`),O.listFocusOutline&&Z.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${O.listFocusOutline}; outline-offset: -1px; }`),O.listHoverOutline&&Z.push(`.monaco-list-row:hover { outline: 1px dashed ${O.listHoverOutline}; outline-offset: -1px; }`),O.scrollbarShadowColor&&Z.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${O.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),O.scrollbarSliderBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${O.scrollbarSliderBackgroundColor};
				}
			`),O.scrollbarSliderHoverBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${O.scrollbarSliderHoverBackgroundColor};
				}
			`),O.scrollbarSliderActiveBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${O.scrollbarSliderActiveBackgroundColor};
				}
			`),U.textContent=Z.join(`
`),O.color&&(document.body.style.color=O.color)}l(O,U){const Z=[],ne=Number(O.pid);U&&(Z.push({accelerator:"Alt+E",label:(0,E.localize)(4,null),click:()=>{this.c.killProcess(ne,"SIGTERM")}}),Z.push({label:(0,E.localize)(5,null),click:()=>{this.c.killProcess(ne,"SIGKILL")}}),Z.push({type:"separator"})),Z.push({label:(0,E.localize)(6,null),click:()=>{const se=this.n();se?.includes(ne)||(se.length=0,se.push(ne));const ce=se?.map(ue=>document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(ce){const ue=ce.map(ae=>ae.innerText).filter(ae=>!!ae);this.c.writeClipboardText(ue.join(`
`))}}}),Z.push({label:(0,E.localize)(7,null),click:()=>{const se=document.getElementById("process-list");se&&this.c.writeClipboardText(se.innerText)}}),O&&U&&this.i(O.cmd)&&(Z.push({type:"separator"}),Z.push({label:(0,E.localize)(8,null),click:()=>{this.j(O)}})),(0,D.popup)(Z)}m(O){setTimeout(()=>{const U=Date.now(),Z=O+U-this.a;this.a=U,Z>1e3?(y.ipcRenderer.send("vscode:pidToNameRequest"),y.ipcRenderer.send("vscode:listProcesses")):this.m(Z)},200)}n(){return this.d?.getSelection()?.map(O=>{if(!(!O||!("pid"in O)))return O.pid}).filter(O=>!!O)}}function g(){const I=(0,L.createStyleSheet)();I.id="codiconStyles";const O=(0,r.getIconsStyleSheet)(void 0);function U(){I.textContent=O.getCSS()}const Z=new W.RunOnceScheduler(U,0);O.onDidChange(()=>Z.schedule()),Z.schedule()}function p(I){const O=I.data.platform==="win32"?"windows":I.data.platform==="linux"?"linux":"mac";document.body.classList.add(O),g(),(0,u.applyZoom)(I.data.zoomLevel),new m(I.windowId,I.data)}t.startup=p})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b380da4ef1ee00e224a15c1d4d9793e27c2b6302/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
