/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/hash","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(G){for(var e=[],T=0,L=G.length;T<L;T++)e[T]=ne[G[T]];return e};define(ne[51],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(C){return(w,h,l)=>{let R=null,I=null;if(typeof l.value=="function"?(R="value",I=l.value):typeof l.get=="function"&&(R="get",I=l.get),!I)throw new Error("not supported");l[R]=C(I,h)}}function L(C,w,h){let l=null,R=null;if(typeof h.value=="function"?(l="value",R=h.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(l="get",R=h.get),!R)throw new Error("not supported");const I=`$memoize$${w}`;h[l]=function(...v){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,v)}),this[I]}}e.memoize=L;function k(C,w,h){return T((l,R)=>{const I=`$debounce$${R}`,v=`$debounce$result$${R}`;return function(...g){this[v]||(this[v]=h?h():void 0),clearTimeout(this[I]),w&&(this[v]=w(this[v],...g),g=[this[v]]),this[I]=setTimeout(()=>{l.apply(this,g),this[v]=h?h():void 0},C)}})}e.debounce=k;function A(C,w,h){return T((l,R)=>{const I=`$throttle$timer$${R}`,v=`$throttle$result$${R}`,g=`$throttle$lastRun$${R}`,N=`$throttle$pending$${R}`;return function(...S){if(this[v]||(this[v]=h?h():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),w&&(this[v]=w(this[v],...S)),this[N])return;const u=this[g]+C;u<=Date.now()?(this[g]=Date.now(),l.apply(this,[this[v]]),this[v]=h?h():void 0):(this[N]=!0,this[I]=setTimeout(()=>{this[N]=!1,this[g]=Date.now(),l.apply(this,[this[v]]),this[v]=h?h():void 0},u-Date.now()))}})}e.throttle=A}),define(ne[70],re([0,1,9]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(h,l){if(!h)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=L;function k(h,l="Unreachable"){throw new Error(l)}e.assertNever=k;function A(h){if(!h)throw new T.BugIndicatingError("Assertion Failed")}e.assert=A;function C(h){if(!h()){debugger;h(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function w(h,l){let R=0;for(;R<h.length-1;){const I=h[R],v=h[R+1];if(!l(I,v))return!1;R++}return!0}e.checkAdjacentItems=w}),define(ne[52],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(T||(e.ScanError=T={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function C(t,a=!1){let n=0;const i=t.length;let r="",o=0,c=16,D=0;function y(Q){let ce=0,oe=0;for(;ce<Q;){const se=t.charCodeAt(n);if(se>=48&&se<=57)oe=oe*16+se-48;else if(se>=65&&se<=70)oe=oe*16+se-65+10;else if(se>=97&&se<=102)oe=oe*16+se-97+10;else break;n++,ce++}return ce<Q&&(oe=-1),oe}function m(Q){n=Q,r="",o=0,c=16,D=0}function M(){const Q=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&l(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&l(t.charCodeAt(n)))for(n++;n<t.length&&l(t.charCodeAt(n));)n++;else return D=3,t.substring(Q,n);let ce=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&l(t.charCodeAt(n))){for(n++;n<t.length&&l(t.charCodeAt(n));)n++;ce=n}else D=3;return t.substring(Q,ce)}function J(){let Q="",ce=n;for(;;){if(n>=i){Q+=t.substring(ce,n),D=2;break}const oe=t.charCodeAt(n);if(oe===34){Q+=t.substring(ce,n),n++;break}if(oe===92){if(Q+=t.substring(ce,n),n++,n>=i){D=2;break}switch(t.charCodeAt(n++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:{const $=y(4);$>=0?Q+=String.fromCharCode($):D=4;break}default:D=5}ce=n;continue}if(oe>=0&&oe<=31)if(h(oe)){Q+=t.substring(ce,n),D=2;break}else D=6;n++}return Q}function K(){if(r="",D=0,o=n,n>=i)return o=i,c=17;let Q=t.charCodeAt(n);if(w(Q)){do n++,r+=String.fromCharCode(Q),Q=t.charCodeAt(n);while(w(Q));return c=15}if(h(Q))return n++,r+=String.fromCharCode(Q),Q===13&&t.charCodeAt(n)===10&&(n++,r+=`
`),c=14;switch(Q){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,r=J(),c=10;case 47:{const ce=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<i&&!h(t.charCodeAt(n));)n++;return r=t.substring(ce,n),c=12}if(t.charCodeAt(n+1)===42){n+=2;const oe=i-1;let se=!1;for(;n<oe;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,se=!0;break}n++}return se||(n++,D=1),r=t.substring(ce,n),c=13}return r+=String.fromCharCode(Q),n++,c=16}case 45:if(r+=String.fromCharCode(Q),n++,n===i||!l(t.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=M(),c=11;default:for(;n<i&&ie(Q);)n++,Q=t.charCodeAt(n);if(o!==n){switch(r=t.substring(o,n),r){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return r+=String.fromCharCode(Q),n++,c=16}}function ie(Q){if(w(Q)||h(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let Q;do Q=K();while(Q>=12&&Q<=15);return Q}return{setPosition:m,getPosition:()=>n,scan:a?ue:K,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>D}}e.createScanner=C;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function I(t,a){const n=[],i=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function D(y,m,M,J){o.value=y,o.offset=m,o.length=M,o.type=J,o.colonOffset=void 0,r=o}try{E(t,{onObjectBegin:(y,m)=>{if(a<=y)throw i;r=void 0,c=a>y,n.push("")},onObjectProperty:(y,m,M)=>{if(a<m||(D(y,m,M,"property"),n[n.length-1]=y,a<=m+M))throw i},onObjectEnd:(y,m)=>{if(a<=y)throw i;r=void 0,n.pop()},onArrayBegin:(y,m)=>{if(a<=y)throw i;r=void 0,n.push(0)},onArrayEnd:(y,m)=>{if(a<=y)throw i;r=void 0,n.pop()},onLiteralValue:(y,m,M)=>{if(a<m||(D(y,m,M,b(y)),a<=m+M))throw i},onSeparator:(y,m,M)=>{if(a<=m)throw i;if(y===":"&&r&&r.type==="property")r.colonOffset=m,c=!1,r=void 0;else if(y===","){const J=n[n.length-1];typeof J=="number"?n[n.length-1]=J+1:(c=!0,n[n.length-1]=""),r=void 0}}})}catch(y){if(y!==i)throw y}return{path:n,previousNode:r,isAtPropertyKey:c,matches:y=>{let m=0;for(let M=0;m<y.length&&M<n.length;M++)if(y[m]===n[M]||y[m]==="*")m++;else if(y[m]!=="**")return!1;return m===y.length}}}e.getLocation=I;function v(t,a=[],n=A.DEFAULT){let i=null,r=[];const o=[];function c(y){Array.isArray(r)?r.push(y):i!==null&&(r[i]=y)}return E(t,{onObjectBegin:()=>{const y={};c(y),o.push(r),r=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const y=[];c(y),o.push(r),r=y,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:c,onError:(y,m,M)=>{a.push({error:y,offset:m,length:M})}},n),r[0]}e.parse=v;function g(t,a=[],n=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function o(y){return i.children.push(y),y}E(t,{onObjectBegin:y=>{i=o({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,m,M)=>{i=o({type:"property",offset:m,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:m,length:M,parent:i})},onObjectEnd:(y,m)=>{i.length=y+m-i.offset,i=i.parent,r(y+m)},onArrayBegin:(y,m)=>{i=o({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,m)=>{i.length=y+m-i.offset,i=i.parent,r(y+m)},onLiteralValue:(y,m,M)=>{o({type:b(y),offset:m,length:M,parent:i,value:y}),r(m+M)},onSeparator:(y,m,M)=>{i.type==="property"&&(y===":"?i.colonOffset=m:y===","&&r(m))},onError:(y,m,M)=>{a.push({error:y,offset:m,length:M})}},n);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=g;function N(t,a){if(!t)return;let n=t;for(const i of a)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===i){n=o.children[1],r=!0;break}if(!r)return}else{const r=i;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=N;function S(t){if(!t.parent||!t.parent.children)return[];const a=S(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;a.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&a.push(n)}return a}e.getNodePath=S;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const a=Object.create(null);for(const n of t.children){const i=n.children[1];i&&(a[n.children[0].value]=u(i))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function d(t,a,n=!1){return a>=t.offset&&a<t.offset+t.length||n&&a===t.offset+t.length}e.contains=d;function f(t,a,n=!1){if(d(t,a,n)){const i=t.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=a;r++){const o=f(i[r],a,n);if(o)return o}return t}}e.findNodeAtOffset=f;function E(t,a,n=A.DEFAULT){const i=C(t,!1);function r(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Y){return Y?j=>Y(j,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=r(a.onObjectBegin),D=o(a.onObjectProperty),y=r(a.onObjectEnd),m=r(a.onArrayBegin),M=r(a.onArrayEnd),J=o(a.onLiteralValue),K=o(a.onSeparator),ie=r(a.onComment),ue=o(a.onError),Q=n&&n.disallowComments,ce=n&&n.allowTrailingComma;function oe(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:Q||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(Y){case 12:case 13:Q?se(10):ie();break;case 16:se(1);break;case 15:case 14:break;default:return Y}}}function se(Y,j=[],z=[]){if(ue(Y),j.length+z.length>0){let O=i.getToken();for(;O!==17;){if(j.indexOf(O)!==-1){oe();break}else if(z.indexOf(O)!==-1)break;O=oe()}}}function $(Y){const j=i.getTokenValue();return Y?J(j):D(j),oe(),!0}function q(){switch(i.getToken()){case 11:{let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(se(2),Y=0)}catch{se(2)}J(Y);break}case 7:J(null);break;case 8:J(!0);break;case 9:J(!1);break;default:return!1}return oe(),!0}function x(){return i.getToken()!==10?(se(3,[],[2,5]),!1):($(!1),i.getToken()===6?(K(":"),oe(),H()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function F(){c(),oe();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||se(4,[],[]),K(","),oe(),i.getToken()===2&&ce)break}else Y&&se(6,[],[]);x()||se(4,[],[2,5]),Y=!0}return y(),i.getToken()!==2?se(7,[2],[]):oe(),!0}function W(){m(),oe();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||se(4,[],[]),K(","),oe(),i.getToken()===4&&ce)break}else Y&&se(6,[],[]);H()||se(4,[],[4,5]),Y=!0}return M(),i.getToken()!==4?se(8,[4],[]):oe(),!0}function H(){switch(i.getToken()){case 3:return W();case 1:return F();case 10:return $(!0);default:return q()}}return oe(),i.getToken()===17?n.allowEmptyContent?!0:(se(4,[],[]),!1):H()?(i.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=E;function p(t,a){const n=C(t),i=[];let r,o=0,c;do switch(c=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:o!==c&&i.push(t.substring(o,c)),a!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,a)),o=n.getPosition();break}while(r!==17);return i.join("")}e.stripComments=p;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(ne[71],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function T(w,h,l){return Math.min(Math.max(w,h),l)}e.clamp=T;function L(w,h){return(h+w%h)%h}e.rot=L;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class A{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class C{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const l=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function G(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function C(h){A.push(h,Date.now())}function w(){const h=[];for(let l=0;l<A.length;l+=2)h.push({name:A[l],startTime:A[l+1]});return h}return{mark:C,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const C of performance.getEntriesByType("mark"))A.push({name:C.name,startTime:Math.round(k+C.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function T(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=T(L))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var L in T)(typeof exports=="object"?exports:G)[L]=T[L]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function T(L){if(e[L])return e[L].exports;var k=e[L]={i:L,l:!1,exports:{}};return G[L].call(k.exports,k,k.exports,T),k.l=!0,k.exports}return T.m=G,T.c=e,T.d=function(L,k,A){T.o(L,k)||Object.defineProperty(L,k,{enumerable:!0,get:A})},T.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},T.t=function(L,k){if(1&k&&(L=T(L)),8&k||4&k&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(T.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&k&&typeof L!="string")for(var C in L)T.d(A,C,function(w){return L[w]}.bind(null,C));return A},T.n=function(L){var k=L&&L.__esModule?function(){return L.default}:function(){return L};return T.d(k,"a",k),k},T.o=function(L,k){return Object.prototype.hasOwnProperty.call(L,k)},T.p="",T(T.s=0)}([function(G,e,T){(function(L){var k;e=G.exports=z,k=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],h=e.src=[],l=0,R=l++;h[R]="0|[1-9]\\d*";var I=l++;h[I]="[0-9]+";var v=l++;h[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=l++;h[g]="("+h[R]+")\\.("+h[R]+")\\.("+h[R]+")";var N=l++;h[N]="("+h[I]+")\\.("+h[I]+")\\.("+h[I]+")";var S=l++;h[S]="(?:"+h[R]+"|"+h[v]+")";var u=l++;h[u]="(?:"+h[I]+"|"+h[v]+")";var d=l++;h[d]="(?:-("+h[S]+"(?:\\."+h[S]+")*))";var f=l++;h[f]="(?:-?("+h[u]+"(?:\\."+h[u]+")*))";var E=l++;h[E]="[0-9A-Za-z-]+";var p=l++;h[p]="(?:\\+("+h[E]+"(?:\\."+h[E]+")*))";var b=l++,t="v?"+h[g]+h[d]+"?"+h[p]+"?";h[b]="^"+t+"$";var a="[v=\\s]*"+h[N]+h[f]+"?"+h[p]+"?",n=l++;h[n]="^"+a+"$";var i=l++;h[i]="((?:<|>)?=?)";var r=l++;h[r]=h[I]+"|x|X|\\*";var o=l++;h[o]=h[R]+"|x|X|\\*";var c=l++;h[c]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[d]+")?"+h[p]+"?)?)?";var D=l++;h[D]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[f]+")?"+h[p]+"?)?)?";var y=l++;h[y]="^"+h[i]+"\\s*"+h[c]+"$";var m=l++;h[m]="^"+h[i]+"\\s*"+h[D]+"$";var M=l++;h[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var J=l++;h[J]="(?:~>?)";var K=l++;h[K]="(\\s*)"+h[J]+"\\s+",w[K]=new RegExp(h[K],"g");var ie=l++;h[ie]="^"+h[J]+h[c]+"$";var ue=l++;h[ue]="^"+h[J]+h[D]+"$";var Q=l++;h[Q]="(?:\\^)";var ce=l++;h[ce]="(\\s*)"+h[Q]+"\\s+",w[ce]=new RegExp(h[ce],"g");var oe=l++;h[oe]="^"+h[Q]+h[c]+"$";var se=l++;h[se]="^"+h[Q]+h[D]+"$";var $=l++;h[$]="^"+h[i]+"\\s*("+a+")$|^$";var q=l++;h[q]="^"+h[i]+"\\s*("+t+")$|^$";var x=l++;h[x]="(\\s*)"+h[i]+"\\s*("+a+"|"+h[c]+")",w[x]=new RegExp(h[x],"g");var F=l++;h[F]="^\\s*("+h[c]+")\\s+-\\s+("+h[c]+")\\s*$";var W=l++;h[W]="^\\s*("+h[D]+")\\s+-\\s+("+h[D]+")\\s*$";var H=l++;h[H]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)k(Y,h[Y]),w[Y]||(w[Y]=new RegExp(h[Y]));function j(V,Z){if(V instanceof z)return V;if(typeof V!="string"||V.length>A||!(Z?w[n]:w[b]).test(V))return null;try{return new z(V,Z)}catch{return null}}function z(V,Z){if(V instanceof z){if(V.loose===Z)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof z))return new z(V,Z);k("SemVer",V,Z),this.loose=Z;var ee=V.trim().match(Z?w[n]:w[b]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ye=+me;if(ye>=0&&ye<C)return ye}return me}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=j,e.valid=function(V,Z){var ee=j(V,Z);return ee?ee.version:null},e.clean=function(V,Z){var ee=j(V.trim().replace(/^[=v]+/,""),Z);return ee?ee.version:null},e.SemVer=z,z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},z.prototype.toString=function(){return this.version},z.prototype.compare=function(V){return k("SemVer.compare",this.version,this.loose,V),V instanceof z||(V=new z(V,this.loose)),this.compareMain(V)||this.comparePre(V)},z.prototype.compareMain=function(V){return V instanceof z||(V=new z(V,this.loose)),s(this.major,V.major)||s(this.minor,V.minor)||s(this.patch,V.patch)},z.prototype.comparePre=function(V){if(V instanceof z||(V=new z(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Z=0;do{var ee=this.prerelease[Z],me=V.prerelease[Z];if(k("prerelease compare",Z,ee,me),ee===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(ee===void 0)return-1;if(ee!==me)return s(ee,me)}while(++Z)},z.prototype.inc=function(V,Z){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Z,ee,me){typeof ee=="string"&&(me=ee,ee=void 0);try{return new z(V,ee).inc(Z,me).version}catch{return null}},e.diff=function(V,Z){if(X(V,Z))return null;var ee=j(V),me=j(Z);if(ee.prerelease.length||me.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==me[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==me[ye])return ye},e.compareIdentifiers=s;var O=/^[0-9]+$/;function s(V,Z){var ee=O.test(V),me=O.test(Z);return ee&&me&&(V=+V,Z=+Z),ee&&!me?-1:me&&!ee?1:V<Z?-1:V>Z?1:0}function P(V,Z,ee){return new z(V,ee).compare(new z(Z,ee))}function U(V,Z,ee){return P(V,Z,ee)>0}function B(V,Z,ee){return P(V,Z,ee)<0}function X(V,Z,ee){return P(V,Z,ee)===0}function _(V,Z,ee){return P(V,Z,ee)!==0}function le(V,Z,ee){return P(V,Z,ee)>=0}function de(V,Z,ee){return P(V,Z,ee)<=0}function pe(V,Z,ee,me){var ye;switch(Z){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=X(V,ee,me);break;case"!=":ye=_(V,ee,me);break;case">":ye=U(V,ee,me);break;case">=":ye=le(V,ee,me);break;case"<":ye=B(V,ee,me);break;case"<=":ye=de(V,ee,me);break;default:throw new TypeError("Invalid operator: "+Z)}return ye}function he(V,Z){if(V instanceof he){if(V.loose===Z)return V;V=V.value}if(!(this instanceof he))return new he(V,Z);k("comparator",V,Z),this.loose=Z,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(V,Z){return s(Z,V)},e.major=function(V,Z){return new z(V,Z).major},e.minor=function(V,Z){return new z(V,Z).minor},e.patch=function(V,Z){return new z(V,Z).patch},e.compare=P,e.compareLoose=function(V,Z){return P(V,Z,!0)},e.rcompare=function(V,Z,ee){return P(Z,V,ee)},e.sort=function(V,Z){return V.sort(function(ee,me){return e.compare(ee,me,Z)})},e.rsort=function(V,Z){return V.sort(function(ee,me){return e.rcompare(ee,me,Z)})},e.gt=U,e.lt=B,e.eq=X,e.neq=_,e.gte=le,e.lte=de,e.cmp=pe,e.Comparator=he;var ge={};function ae(V,Z){if(V instanceof ae)return V.loose===Z?V:new ae(V.raw,Z);if(V instanceof he)return new ae(V.value,Z);if(!(this instanceof ae))return new ae(V,Z);if(this.loose=Z,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function fe(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Z,ee,me,ye,Oe,be,Le,De,Ne,je,Ie,Te){return((Z=fe(ee)?"":fe(me)?">="+ee+".0.0":fe(ye)?">="+ee+"."+me+".0":">="+Z)+" "+(Le=fe(De)?"":fe(Ne)?"<"+(+De+1)+".0.0":fe(je)?"<"+De+"."+(+Ne+1)+".0":Ie?"<="+De+"."+Ne+"."+je+"-"+Ie:"<="+Le)).trim()}function Re(V,Z){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(Z))return!1;if(Z.prerelease.length){for(ee=0;ee<V.length;ee++)if(k(V[ee].semver),V[ee].semver!==ge&&V[ee].semver.prerelease.length>0){var me=V[ee].semver;if(me.major===Z.major&&me.minor===Z.minor&&me.patch===Z.patch)return!0}return!1}return!0}function Ce(V,Z,ee){try{Z=new ae(Z,ee)}catch{return!1}return Z.test(V)}function Fe(V,Z,ee,me){var ye,Oe,be,Le,De;switch(V=new z(V,me),Z=new ae(Z,me),ee){case">":ye=U,Oe=de,be=B,Le=">",De=">=";break;case"<":ye=B,Oe=le,be=U,Le="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(V,Z,me))return!1;for(var Ne=0;Ne<Z.set.length;++Ne){var je=Z.set[Ne],Ie=null,Te=null;if(je.forEach(function(Me){Me.semver===ge&&(Me=new he(">=0.0.0")),Ie=Ie||Me,Te=Te||Me,ye(Me.semver,Ie.semver,me)?Ie=Me:be(Me.semver,Te.semver,me)&&(Te=Me)}),Ie.operator===Le||Ie.operator===De||(!Te.operator||Te.operator===Le)&&Oe(V,Te.semver)||Te.operator===De&&be(V,Te.semver))return!1}return!0}he.prototype.parse=function(V){var Z=this.loose?w[$]:w[q],ee=V.match(Z);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new z(ee[2],this.loose):this.semver=ge},he.prototype.toString=function(){return this.value},he.prototype.test=function(V){return k("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new z(V,this.loose)),pe(V,this.operator,this.semver,this.loose))},he.prototype.intersects=function(V,Z){if(!(V instanceof he))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new ae(V.value,Z),Ce(this.value,ee,Z);if(V.operator==="")return ee=new ae(this.value,Z),Ce(V.semver,ee,Z);var me=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Oe=this.semver.version===V.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=pe(this.semver,"<",V.semver,Z)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),De=pe(this.semver,">",V.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return me||ye||Oe&&be||Le||De},e.Range=ae,ae.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ae.prototype.toString=function(){return this.range},ae.prototype.parseRange=function(V){var Z=this.loose;V=V.trim(),k("range",V,Z);var ee=Z?w[W]:w[F];V=V.replace(ee,we),k("hyphen replace",V),V=V.replace(w[x],"$1$2$3"),k("comparator trim",V,w[x]),V=(V=(V=V.replace(w[K],"$1~")).replace(w[ce],"$1^")).split(/\s+/).join(" ");var me=Z?w[$]:w[q],ye=V.split(" ").map(function(Oe){return function(be,Le){return k("comp",be),be=function(De,Ne){return De.trim().split(/\s+/).map(function(je){return function(Ie,Te){k("caret",Ie,Te);var Me=Te?w[se]:w[oe];return Ie.replace(Me,function(Ue,Ee,Se,Pe,ke){var Ae;return k("caret",Ie,Ue,Ee,Se,Pe,ke),fe(Ee)?Ae="":fe(Se)?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(Pe)?Ae=Ee==="0"?">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+".0 <"+(+Ee+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=Ee==="0"?Se==="0"?">="+Ee+"."+Se+"."+Pe+ke+" <"+Ee+"."+Se+"."+(+Pe+1):">="+Ee+"."+Se+"."+Pe+ke+" <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+"."+Pe+ke+" <"+(+Ee+1)+".0.0"):(k("no pr"),Ae=Ee==="0"?Se==="0"?">="+Ee+"."+Se+"."+Pe+" <"+Ee+"."+Se+"."+(+Pe+1):">="+Ee+"."+Se+"."+Pe+" <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+"."+Pe+" <"+(+Ee+1)+".0.0"),k("caret return",Ae),Ae})}(je,Ne)}).join(" ")}(be,Le),k("caret",be),be=function(De,Ne){return De.trim().split(/\s+/).map(function(je){return function(Ie,Te){var Me=Te?w[ue]:w[ie];return Ie.replace(Me,function(Ue,Ee,Se,Pe,ke){var Ae;return k("tilde",Ie,Ue,Ee,Se,Pe,ke),fe(Ee)?Ae="":fe(Se)?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(Pe)?Ae=">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=">="+Ee+"."+Se+"."+Pe+ke+" <"+Ee+"."+(+Se+1)+".0"):Ae=">="+Ee+"."+Se+"."+Pe+" <"+Ee+"."+(+Se+1)+".0",k("tilde return",Ae),Ae})}(je,Ne)}).join(" ")}(be,Le),k("tildes",be),be=function(De,Ne){return k("replaceXRanges",De,Ne),De.split(/\s+/).map(function(je){return function(Ie,Te){Ie=Ie.trim();var Me=Te?w[m]:w[y];return Ie.replace(Me,function(Ue,Ee,Se,Pe,ke,Ae){k("xRange",Ie,Ue,Ee,Se,Pe,ke,Ae);var We=fe(Se),xe=We||fe(Pe),Be=xe||fe(ke);return Ee==="="&&Be&&(Ee=""),We?Ue=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Be?(xe&&(Pe=0),Be&&(ke=0),Ee===">"?(Ee=">=",xe?(Se=+Se+1,Pe=0,ke=0):Be&&(Pe=+Pe+1,ke=0)):Ee==="<="&&(Ee="<",xe?Se=+Se+1:Pe=+Pe+1),Ue=Ee+Se+"."+Pe+"."+ke):xe?Ue=">="+Se+".0.0 <"+(+Se+1)+".0.0":Be&&(Ue=">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0"),k("xRange return",Ue),Ue})}(je,Ne)}).join(" ")}(be,Le),k("xrange",be),be=function(De,Ne){return k("replaceStars",De,Ne),De.trim().replace(w[H],"")}(be,Le),k("stars",be),be}(Oe,Z)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Oe){return!!Oe.match(me)})),ye=ye.map(function(Oe){return new he(Oe,Z)})},ae.prototype.intersects=function(V,Z){if(!(V instanceof ae))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(me){return V.set.some(function(ye){return ye.every(function(Oe){return me.intersects(Oe,Z)})})})})},e.toComparators=function(V,Z){return new ae(V,Z).set.map(function(ee){return ee.map(function(me){return me.value}).join(" ").trim().split(" ")})},ae.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new z(V,this.loose));for(var Z=0;Z<this.set.length;Z++)if(Re(this.set[Z],V))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(V,Z,ee){var me=null,ye=null;try{var Oe=new ae(Z,ee)}catch{return null}return V.forEach(function(be){Oe.test(be)&&(me&&ye.compare(be)!==-1||(ye=new z(me=be,ee)))}),me},e.minSatisfying=function(V,Z,ee){var me=null,ye=null;try{var Oe=new ae(Z,ee)}catch{return null}return V.forEach(function(be){Oe.test(be)&&(me&&ye.compare(be)!==1||(ye=new z(me=be,ee)))}),me},e.validRange=function(V,Z){try{return new ae(V,Z).range||"*"}catch{return null}},e.ltr=function(V,Z,ee){return Fe(V,Z,"<",ee)},e.gtr=function(V,Z,ee){return Fe(V,Z,">",ee)},e.outside=Fe,e.prerelease=function(V,Z){var ee=j(V,Z);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,Z,ee){return V=new ae(V,ee),Z=new ae(Z,ee),V.intersects(Z)},e.coerce=function(V){if(V instanceof z)return V;if(typeof V!="string")return null;var Z=V.match(w[M]);return Z==null?null:j((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,T(1))},function(G,e){var T,L,k=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function w(u){if(T===setTimeout)return setTimeout(u,0);if((T===A||!T)&&setTimeout)return T=setTimeout,setTimeout(u,0);try{return T(u,0)}catch{try{return T.call(null,u,0)}catch{return T.call(this,u,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:A}catch{T=A}try{L=typeof clearTimeout=="function"?clearTimeout:C}catch{L=C}})();var h,l=[],R=!1,I=-1;function v(){R&&h&&(R=!1,h.length?l=h.concat(l):I=-1,l.length&&g())}function g(){if(!R){var u=w(v);R=!0;for(var d=l.length;d;){for(h=l,l=[];++I<d;)h&&h[I].run();I=-1,d=l.length}h=null,R=!1,function(f){if(L===clearTimeout)return clearTimeout(f);if((L===C||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(f);try{L(f)}catch{try{return L.call(null,f)}catch{return L.call(this,f)}}}(u)}}function N(u,d){this.fun=u,this.array=d}function S(){}k.nextTick=function(u){var d=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)d[f-1]=arguments[f];l.push(new N(u,d)),l.length!==1||R||w(g)},N.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(u){return[]},k.binding=function(u){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(u){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[72],re([0,1]),function(G,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(w,h,l){this.level=w,this.key=h,this.value=l,this.forward=[]}}const k=void 0;class A{constructor(w,h=2**16){this.comparator=w,this[T]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new L(this.c,k,k)}get size(){return this.f}clear(){this.e=new L(this.c,k,k)}has(w){return!!A.g(this,w,this.comparator)}get(w){return A.g(this,w,this.comparator)?.value}set(w,h){return A.h(this,w,h,this.comparator)&&(this.f+=1),this}delete(w){const h=A.k(this,w,this.comparator);return h&&(this.f-=1),h}forEach(w,h){let l=this.e.forward[0];for(;l;)w.call(h,l.value,l.key,this),l=l.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this.e.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this.e.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this.e.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",h=this.e.forward[0];for(;h;)w+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return w}static g(w,h,l){let R=w.e;for(let I=w.d-1;I>=0;I--)for(;R.forward[I]&&l(R.forward[I].key,h)<0;)R=R.forward[I];if(R=R.forward[0],R&&l(R.key,h)===0)return R}static h(w,h,l,R){const I=[];let v=w.e;for(let g=w.d-1;g>=0;g--){for(;v.forward[g]&&R(v.forward[g].key,h)<0;)v=v.forward[g];I[g]=v}if(v=v.forward[0],v&&R(v.key,h)===0)return v.value=l,!1;{const g=A.j(w);if(g>w.d){for(let N=w.d;N<g;N++)I[N]=w.e;w.d=g}v=new L(g,h,l);for(let N=0;N<g;N++)v.forward[N]=I[N].forward[N],I[N].forward[N]=v;return!0}}static j(w,h=.5){let l=1;for(;Math.random()<h&&l<w.c;)l+=1;return l}static k(w,h,l){const R=[];let I=w.e;for(let v=w.d-1;v>=0;v--){for(;I.forward[v]&&l(I.forward[v].key,h)<0;)I=I.forward[v];R[v]=I}if(I=I.forward[0],!I||l(I.key,h)!==0)return!1;for(let v=0;v<w.d&&R[v].forward[v]===I;v++)R[v].forward[v]=I.forward[v];for(;w.d>0&&w.e.forward[w.d-1]===k;)w.d-=1;return!0}}e.SkipList=A}),define(ne[44],re([0,1,9,2]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(p){const b=p;return b?typeof b.read=="function":!1}e.isReadable=k;function A(p){const b=p;return b?[b.on,b.pause,b.resume,b.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function C(p){const b=p;return b?A(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=C;function w(p,b){return new h(p,b)}e.newWriteableStream=w;class h{constructor(b,t){this.e=b,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(t=>t(b))}h(b){this.c.error.length===0?(0,T.onUnexpectedError)(b):this.c.error.slice(0).forEach(t=>t(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,t){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(b,t){if(this.a.destroyed)return;let a;switch(b){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(t);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(p,b){const t=[];let a;for(;(a=p.read())!==null;)t.push(a);return b(t)}e.consumeReadable=l;function R(p,b,t){const a=[];let n;for(;(n=p.read())!==null&&a.length<t;)a.push(n);return n===null&&a.length>0?b(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return p.read()}}}e.peekReadable=R;function I(p,b){return new Promise((t,a)=>{const n=[];v(p,{onData:i=>{b&&n.push(i)},onError:i=>{b?a(i):t(void 0)},onEnd:()=>{t(b?b(n):void 0)}})})}e.consumeStream=I;function v(p,b){let t=!1;return p.on("error",a=>{t||b.onError(a)}),p.on("end",()=>{t||b.onEnd()}),p.on("data",a=>{t||b.onData(a)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=v;function g(p,b){return new Promise((t,a)=>{const n=new L.DisposableStore,i=[],r=D=>{if(i.push(D),i.length>b)return n.dispose(),p.pause(),t({stream:p,buffer:i,ended:!1})},o=D=>a(D),c=()=>t({stream:p,buffer:i,ended:!0});n.add((0,L.toDisposable)(()=>p.removeListener("error",o))),p.on("error",o),n.add((0,L.toDisposable)(()=>p.removeListener("end",c))),p.on("end",c),n.add((0,L.toDisposable)(()=>p.removeListener("data",r))),p.on("data",r)})}e.peekStream=g;function N(p,b){const t=w(b);return t.end(p),t}e.toStream=N;function S(){const p=w(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=S;function u(p){let b=!1;return{read:()=>b?null:(b=!0,p)}}e.toReadable=u;function d(p,b,t){const a=w(t);return v(p,{onData:n=>a.write(b.data(n)),onError:n=>a.error(b.error?b.error(n):n),onEnd:()=>a.end()}),a}e.transform=d;function f(p,b,t){let a=!1;return{read:()=>{const n=b.read();return a?n:(a=!0,n!==null?t([p,n]):p)}}}e.prefixedReadable=f;function E(p,b,t){let a=!1;const n=w(t);return v(b,{onData:i=>a?n.write(i):(a=!0,n.write(t([p,i]))),onError:i=>n.error(i),onEnd:()=>{a||(a=!0,n.write(p)),n.end()}}),n}e.prefixedStream=E}),define(ne[14],re([0,1,161,44]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer<"u",A=new T.Lazy(()=>new Uint8Array(256));let C,w;class h{static alloc(m){return k?new h(Buffer.allocUnsafe(m)):new h(new Uint8Array(m))}static wrap(m){return k&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new h(m)}static fromString(m,M){return!(M?.dontUseNodeBuffer||!1)&&k?new h(Buffer.from(m)):(C||(C=new TextEncoder),new h(C.encode(m)))}static fromByteArray(m){const M=h.alloc(m.length);for(let J=0,K=m.length;J<K;J++)M.buffer[J]=m[J];return M}static concat(m,M){if(typeof M>"u"){M=0;for(let ie=0,ue=m.length;ie<ue;ie++)M+=m[ie].byteLength}const J=h.alloc(M);let K=0;for(let ie=0,ue=m.length;ie<ue;ie++){const Q=m[ie];J.set(Q,K),K+=Q.byteLength}return J}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=h.alloc(this.byteLength);return m.set(this),m}toString(){return k?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(m,M){return new h(this.buffer.subarray(m,M))}set(m,M){if(m instanceof h)this.buffer.set(m.buffer,M);else if(m instanceof Uint8Array)this.buffer.set(m,M);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),M);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return I(this.buffer,m)}writeUInt32BE(m,M){v(this.buffer,m,M)}readUInt32LE(m){return g(this.buffer,m)}writeUInt32LE(m,M){N(this.buffer,m,M)}readUInt8(m){return S(this.buffer,m)}writeUInt8(m,M){u(this.buffer,m,M)}indexOf(m){const M=m instanceof h?m.buffer:m,J=M.byteLength,K=this.buffer,ie=K.byteLength;if(J===0)return 0;if(J===1)return K.indexOf(M[0]);if(J>ie)return-1;const ue=A.value;ue.fill(M.length);for(let se=0;se<M.length;se++)ue[M[se]]=M.length-se-1;let Q=M.length-1,ce=Q,oe=-1;for(;Q<ie;)if(K[Q]===M[ce]){if(ce===0){oe=Q;break}Q--,ce--}else Q+=Math.max(M.length-ce,ue[K[Q]]),ce=M.length-1;return oe}}e.VSBuffer=h;function l(y,m){return y[m+0]<<0>>>0|y[m+1]<<8>>>0}e.readUInt16LE=l;function R(y,m,M){y[M+0]=m&255,m=m>>>8,y[M+1]=m&255}e.writeUInt16LE=R;function I(y,m){return y[m]*2**24+y[m+1]*2**16+y[m+2]*2**8+y[m+3]}e.readUInt32BE=I;function v(y,m,M){y[M+3]=m,m=m>>>8,y[M+2]=m,m=m>>>8,y[M+1]=m,m=m>>>8,y[M]=m}e.writeUInt32BE=v;function g(y,m){return y[m+0]<<0>>>0|y[m+1]<<8>>>0|y[m+2]<<16>>>0|y[m+3]<<24>>>0}e.readUInt32LE=g;function N(y,m,M){y[M+0]=m&255,m=m>>>8,y[M+1]=m&255,m=m>>>8,y[M+2]=m&255,m=m>>>8,y[M+3]=m&255}e.writeUInt32LE=N;function S(y,m){return y[m]}e.readUInt8=S;function u(y,m,M){y[M]=m}e.writeUInt8=u;function d(y){return L.consumeReadable(y,m=>h.concat(m))}e.readableToBuffer=d;function f(y){return L.toReadable(y)}e.bufferToReadable=f;function E(y){return L.consumeStream(y,m=>h.concat(m))}e.streamToBuffer=E;async function p(y){return y.ended?h.concat(y.buffer):h.concat([...y.buffer,await E(y.stream)])}e.bufferedStreamToBuffer=p;function b(y){return L.toStream(y,m=>h.concat(m))}e.bufferToStream=b;function t(y){return L.transform(y,{data:m=>typeof m=="string"?h.fromString(m):h.wrap(m)},m=>h.concat(m))}e.streamToBufferReadableStream=t;function a(y){return L.newWriteableStream(m=>h.concat(m),y)}e.newWriteableBufferStream=a;function n(y,m){return L.prefixedReadable(y,m,M=>h.concat(M))}e.prefixedBufferReadable=n;function i(y,m){return L.prefixedStream(y,m,M=>h.concat(M))}e.prefixedBufferStream=i;function r(y){let m=0,M=0,J=0;const K=new Uint8Array(Math.floor(y.length/4*3)),ie=Q=>{switch(M){case 3:K[J++]=m|Q,M=0;break;case 2:K[J++]=m|Q>>>2,m=Q<<6,M=3;break;case 1:K[J++]=m|Q>>>4,m=Q<<4,M=2;break;default:m=Q<<2,M=1}};for(let Q=0;Q<y.length;Q++){const ce=y.charCodeAt(Q);if(ce>=65&&ce<=90)ie(ce-65);else if(ce>=97&&ce<=122)ie(ce-97+26);else if(ce>=48&&ce<=57)ie(ce-48+52);else if(ce===43||ce===45)ie(62);else if(ce===47||ce===95)ie(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${y[Q]}`)}}const ue=J;for(;M>0;)ie(0);return h.wrap(K).slice(0,ue)}e.decodeBase64=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:y},m=!0,M=!1){const J=M?c:o;let K="";const ie=y.byteLength%3;let ue=0;for(;ue<y.byteLength-ie;ue+=3){const Q=y[ue+0],ce=y[ue+1],oe=y[ue+2];K+=J[Q>>>2],K+=J[(Q<<4|ce>>>4)&63],K+=J[(ce<<2|oe>>>6)&63],K+=J[oe&63]}if(ie===1){const Q=y[ue+0];K+=J[Q>>>2],K+=J[Q<<4&63],m&&(K+="==")}else if(ie===2){const Q=y[ue+0],ce=y[ue+1];K+=J[Q>>>2],K+=J[(Q<<4|ce>>>4)&63],K+=J[ce<<2&63],m&&(K+="=")}return K}e.encodeBase64=D}),define(ne[30],re([0,1,3]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const f=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([E,p])=>{f[E]=p&&typeof p=="object"?L(p):p}),f}e.deepClone=L;function k(d){if(!d||typeof d!="object")return d;const f=[d];for(;f.length>0;){const E=f.shift();Object.freeze(E);for(const p in E)if(A.call(E,p)){const b=E[p];typeof b=="object"&&!Object.isFrozen(b)&&!(0,T.isTypedArray)(b)&&f.push(b)}}return d}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function C(d,f){return w(d,f,new Set)}e.cloneAndChange=C;function w(d,f,E){if((0,T.isUndefinedOrNull)(d))return d;const p=f(d);if(typeof p<"u")return p;if(Array.isArray(d)){const b=[];for(const t of d)b.push(w(t,f,E));return b}if((0,T.isObject)(d)){if(E.has(d))throw new Error("Cannot clone recursive data-structure");E.add(d);const b={};for(const t in d)A.call(d,t)&&(b[t]=w(d[t],f,E));return E.delete(d),b}return d}function h(d,f,E=!0){return(0,T.isObject)(d)?((0,T.isObject)(f)&&Object.keys(f).forEach(p=>{p in d?E&&((0,T.isObject)(d[p])&&(0,T.isObject)(f[p])?h(d[p],f[p],E):d[p]=f[p]):d[p]=f[p]}),d):f}e.mixin=h;function l(d,f){if(d===f)return!0;if(d==null||f===null||f===void 0||typeof d!=typeof f||typeof d!="object"||Array.isArray(d)!==Array.isArray(f))return!1;let E,p;if(Array.isArray(d)){if(d.length!==f.length)return!1;for(E=0;E<d.length;E++)if(!l(d[E],f[E]))return!1}else{const b=[];for(p in d)b.push(p);b.sort();const t=[];for(p in f)t.push(p);if(t.sort(),!l(b,t))return!1;for(E=0;E<b.length;E++)if(!l(d[b[E]],f[b[E]]))return!1}return!0}e.equals=l;function R(d){const f=new Set;return JSON.stringify(d,(E,p)=>{if((0,T.isObject)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.safeStringify=R;function I(d,f){const E=Object.create(null);return!d||!f||Object.keys(f).forEach(b=>{const t=d[b],a=f[b];l(t,a)||(E[b]=a)}),E}e.distinct=I;function v(d,f){const E=f.toLowerCase(),p=Object.keys(d).find(b=>b.toLowerCase()===E);return p?d[p]:d[f]}e.getCaseInsensitive=v;function g(d,f){const E=Object.create(null);for(const[p,b]of Object.entries(d))f(p,b)&&(E[p]=b);return E}e.filter=g;function N(d){let f=[],E=Object.getPrototypeOf(d);for(;Object.prototype!==E;)f=f.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return f}e.getAllPropertyNames=N;function S(d){const f=[];for(const E of N(d))typeof d[E]=="function"&&f.push(E);return f}e.getAllMethodNames=S;function u(d,f){const E=b=>function(){const t=Array.prototype.slice.call(arguments,0);return f(b,t)},p={};for(const b of d)p[b]=E(b);return p}e.createProxyObject=u}),define(ne[28],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(k){return T.test(k)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(w){for(let h=0;h<w.length;h++)w[h]=Math.floor(Math.random()*256);return w};const A=new Uint8Array(16),C=[];for(let w=0;w<256;w++)C.push(w.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let h=0,l="";return l+=C[A[h++]],l+=C[A[h++]],l+=C[A[h++]],l+=C[A[h++]],l+="-",l+=C[A[h++]],l+=C[A[h++]],l+="-",l+=C[A[h++]],l+=C[A[h++]],l+="-",l+=C[A[h++]],l+=C[A[h++]],l+="-",l+=C[A[h++]],l+=C[A[h++]],l+=C[A[h++]],l+=C[A[h++]],l+=C[A[h++]],l+=C[A[h++]],l}}()}),define(ne[73],re([0,1,32]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(C){const w=C.replace(/\-/g,":").toLowerCase();return!L.has(w)}function A(){const C=(0,T.networkInterfaces)();for(const w in C){const h=C[w];if(h){for(const{mac:l}of h)if(k(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ne[74],re([7,4]),function(G,e){return G.create("vs/base/common/date",e)}),define(ne[75],re([0,1,74]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,A=k*24,C=A*7,w=A*30,h=A*365;function l(I,v,g,N){typeof I!="number"&&(I=I.getTime());const S=Math.round((new Date().getTime()-I)/1e3);if(S<-30)return(0,T.localize)(0,null,l(new Date().getTime()+S*1e3,!1));if(!N&&S<30)return(0,T.localize)(1,null);let u;return S<L?(u=S,v?u===1?g?(0,T.localize)(2,null,u):(0,T.localize)(3,null,u):g?(0,T.localize)(4,null,u):(0,T.localize)(5,null,u):u===1?g?(0,T.localize)(6,null,u):(0,T.localize)(7,null,u):g?(0,T.localize)(8,null,u):(0,T.localize)(9,null,u)):S<k?(u=Math.floor(S/L),v?u===1?g?(0,T.localize)(10,null,u):(0,T.localize)(11,null,u):g?(0,T.localize)(12,null,u):(0,T.localize)(13,null,u):u===1?g?(0,T.localize)(14,null,u):(0,T.localize)(15,null,u):g?(0,T.localize)(16,null,u):(0,T.localize)(17,null,u)):S<A?(u=Math.floor(S/k),v?u===1?g?(0,T.localize)(18,null,u):(0,T.localize)(19,null,u):g?(0,T.localize)(20,null,u):(0,T.localize)(21,null,u):u===1?g?(0,T.localize)(22,null,u):(0,T.localize)(23,null,u):g?(0,T.localize)(24,null,u):(0,T.localize)(25,null,u)):S<C?(u=Math.floor(S/A),v?u===1?(0,T.localize)(26,null,u):(0,T.localize)(27,null,u):u===1?(0,T.localize)(28,null,u):(0,T.localize)(29,null,u)):S<w?(u=Math.floor(S/C),v?u===1?g?(0,T.localize)(30,null,u):(0,T.localize)(31,null,u):g?(0,T.localize)(32,null,u):(0,T.localize)(33,null,u):u===1?g?(0,T.localize)(34,null,u):(0,T.localize)(35,null,u):g?(0,T.localize)(36,null,u):(0,T.localize)(37,null,u)):S<h?(u=Math.floor(S/w),v?u===1?g?(0,T.localize)(38,null,u):(0,T.localize)(39,null,u):g?(0,T.localize)(40,null,u):(0,T.localize)(41,null,u):u===1?g?(0,T.localize)(42,null,u):(0,T.localize)(43,null,u):g?(0,T.localize)(44,null,u):(0,T.localize)(45,null,u)):(u=Math.floor(S/h),v?u===1?g?(0,T.localize)(46,null,u):(0,T.localize)(47,null,u):g?(0,T.localize)(48,null,u):(0,T.localize)(49,null,u):u===1?g?(0,T.localize)(50,null,u):(0,T.localize)(51,null,u):g?(0,T.localize)(52,null,u):(0,T.localize)(53,null,u))}e.fromNow=l;function R(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ne[76],re([7,4]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ne[33],re([0,1,19,3,76]),function(G,e,T,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(I,v){return v&&(I.stack||I.stacktrace)?k.localize(0,null,w(I),C(I.stack)||C(I.stacktrace)):w(I)}function C(I){return Array.isArray(I)?I.join(`
`):I}function w(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?k.localize(1,null,I.message):I.message||k.localize(2,null)}function h(I=null,v=!1){if(!I)return k.localize(3,null);if(Array.isArray(I)){const g=T.coalesce(I),N=h(g[0],v);return g.length>1?k.localize(4,null,N,g.length):N}if(L.isString(I))return I;if(I.detail){const g=I.detail;if(g.error)return A(g.error,v);if(g.exception)return A(g.exception,v)}return I.stack?A(I,v):I.message?I.message:k.localize(5,null)}e.toErrorMessage=h;function l(I){const v=I;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=l;function R(I,v){let g;return typeof I=="string"?g=new Error(I):g=I,g.actions=v,g}e.createErrorWithActions=R}),define(ne[77],re([7,4]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ne[78],re([0,1,77]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(k){switch(k){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(ne[53],re([0,1,12]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(L||(e.Source=L={}));var k;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(w,...h){const l=h.reduce((v,g)=>(v[g]=!0,v),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(v=>!l[v]).forEach(v=>{for(let g=0;g<R.length;g++)if(v.search(R[g])!==-1){delete w[v];break}})}e.sanitizeProcessEnvironment=A;function C(w){w&&(delete w.DEBUG,T.isMacintosh&&delete w.DYLD_LIBRARY_PATH,T.isLinux&&delete w.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(ne[45],re([0,1,29]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(d){return k(d,0)}e.hash=L;function k(d,f){switch(typeof d){case"object":return d===null?A(349,f):Array.isArray(d)?h(d,f):l(d,f);case"string":return w(d,f);case"boolean":return C(d,f);case"number":return A(d,f);case"undefined":return A(937,f);default:return A(617,f)}}e.doHash=k;function A(d,f){return(f<<5)-f+d|0}e.numberHash=A;function C(d,f){return A(d?433:863,f)}function w(d,f){f=A(149417,f);for(let E=0,p=d.length;E<p;E++)f=A(d.charCodeAt(E),f);return f}e.stringHash=w;function h(d,f){return f=A(104579,f),d.reduce((E,p)=>k(p,E),f)}function l(d,f){return f=A(181387,f),Object.keys(d).sort().reduce((E,p)=>(E=w(p,E),k(d[p],E)),f)}class R{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=k(f,this.g),this.g}}e.Hasher=R;var I;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function v(d,f,E=32){const p=E-f,b=~((1<<p)-1);return(d<<f|(b&d)>>>p)>>>0}function g(d,f=0,E=d.byteLength,p=0){for(let b=0;b<E;b++)d[f+b]=p}function N(d,f,E="0"){for(;d.length<f;)d=E+d;return d}function S(d,f=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(E=>E.toString(16).padStart(2,"0")).join(""):N((d>>>0).toString(16),f/4)}e.toHexString=S;class u{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const E=f.length;if(E===0)return;const p=this.p;let b=this.r,t=this.u,a,n;for(t!==0?(a=t,n=-1,t=0):(a=f.charCodeAt(0),n=0);;){let i=a;if(T.isHighSurrogate(a))if(n+1<E){const r=f.charCodeAt(n+1);T.isLowSurrogate(r)?(n++,i=T.computeCodePoint(a,r)):i=65533}else{t=a;break}else T.isLowSurrogate(a)&&(i=65533);if(b=this.w(p,b,i),n++,n<E)a=f.charCodeAt(n);else break}this.r=b,this.u=t}w(f,E,p){return p<128?f[E++]=p:p<2048?(f[E++]=192|(p&1984)>>>6,f[E++]=128|(p&63)>>>0):p<65536?(f[E++]=224|(p&61440)>>>12,f[E++]=128|(p&4032)>>>6,f[E++]=128|(p&63)>>>0):(f[E++]=240|(p&1835008)>>>18,f[E++]=128|(p&258048)>>>12,f[E++]=128|(p&4032)>>>6,f[E++]=128|(p&63)>>>0),E>=64&&(this.y(),E-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),S(this.h)+S(this.l)+S(this.m)+S(this.n)+S(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=u.g,E=this.q;for(let c=0;c<64;c+=4)f.setUint32(c,E.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)f.setUint32(c,v(f.getUint32(c-12,!1)^f.getUint32(c-32,!1)^f.getUint32(c-56,!1)^f.getUint32(c-64,!1),1),!1);let p=this.h,b=this.l,t=this.m,a=this.n,n=this.o,i,r,o;for(let c=0;c<80;c++)c<20?(i=b&t|~b&a,r=1518500249):c<40?(i=b^t^a,r=1859775393):c<60?(i=b&t|b&a|t&a,r=2400959708):(i=b^t^a,r=3395469782),o=v(p,5)+i+n+r+f.getUint32(c*4,!1)&4294967295,n=a,a=t,t=v(b,30),b=p,p=o;this.h=this.h+p&4294967295,this.l=this.l+b&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+n&4294967295}}e.StringSHA1=u,u.g=new DataView(new ArrayBuffer(320))}),define(ne[54],re([0,1,29]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(L||(L={})),function(k){const A="error",C="warning",w="warn",h="info",l="ignore";function R(v){return v?T.equalsIgnoreCase(A,v)?k.Error:T.equalsIgnoreCase(C,v)||T.equalsIgnoreCase(w,v)?k.Warning:T.equalsIgnoreCase(h,v)?k.Info:k.Ignore:k.Ignore}k.fromValue=R;function I(v){switch(v){case k.Error:return A;case k.Warning:return C;case k.Info:return h;default:return l}}k.toString=I}(L||(L={})),e.default=L}),define(ne[79],re([0,1,11]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(l){const R=l;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=L;function k(l){const R=[];let I;try{const v=JSON.parse(l.arguments),g=v[v.length-1];g&&g.__$stack&&(v.pop(),I=g.__$stack),R.push(...v)}catch{R.push("Unable to log remote console arguments",l.arguments)}return{args:R,stack:I}}e.parse=k;function A(l){if(typeof l!="string")return A(k(l).stack);const R=l;if(R){const I=C(R),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(v&&v.length===4)return{uri:T.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=A;function C(l){if(!l)return l;const R=l.indexOf(`
`);return R===-1?l:l.substring(0,R)}function w(l,R){const{args:I,stack:v}=k(l),g=typeof I[0]=="string"&&I.length===1;let N=C(v);N&&(N=`(${N.trim()})`);let S=[];if(typeof I[0]=="string"?N&&g?S=[`%c[${R}] %c${I[0]} %c${N}`,h("blue"),h(""),h("grey")]:S=[`%c[${R}] %c${I[0]}`,h("blue"),h(""),...I.slice(1)]:S=[`%c[${R}]%`,h("blue"),...I],N&&!g&&S.push(N),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,S)}e.log=w;function h(l){return`color: ${l}`}}),define(ne[46],re([0,1,14,29,11]),function(G,e,T,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(l){return JSON.stringify(l,w)}e.stringify=A;function C(l){let R=JSON.parse(l);return R=h(R),R}e.parse=C;function w(l,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,L.regExpFlags)(R)}:R}function h(l,R=0){if(!l||R>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return k.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof T.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let I=0;I<l.length;++I)l[I]=h(l[I],R+1);else for(const I in l)Object.hasOwnProperty.call(l,I)&&(l[I]=h(l[I],R+1))}return l}e.revive=h}),define(ne[80],re([0,1,32,55,28,73]),function(G,e,T,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(l){return this.a||(this.a=L.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(l)}value(){if(this.b===void 0){let l=0,R=0;const I=(0,T.networkInterfaces)();for(const v in I){const g=I[v];if(g)for(const{mac:N,internal:S}of g)S||(R+=1,this.c(N.toUpperCase())&&(l+=1))}this.b=R>0?l/R:0}return this.b}};let C;async function w(l){return C||(C=(async()=>await h(l)||k.generateUuid())()),C}e.getMachineId=w;async function h(l){try{const R=await new Promise((v,g)=>{G(["crypto"],v,g)}),I=(0,A.getMac)();return R.createHash("sha256").update(I,"utf8").digest("hex")}catch(R){l(R);return}}}),define(ne[81],re([0,1,32,15,22]),function(G,e,T,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,C=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var h;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(h||(h={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class I{constructor(b,t,a){this.exePath=b,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:p=!1}={}){return p?l===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:p=!1,findPreview:b=!1}={}){const t=v({useAlternateBitness:p});if(!t)return null;const a=L.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let n=-1,i=null;for(const c of await k.Promises.readdir(a)){let D=-1;if(b){const m=c.indexOf("-");if(m<0)continue;const M=c.substring(0,m);if(!A.test(M)||c.substring(m+1)!=="preview")continue;D=parseInt(M,10)}else{if(!A.test(c))continue;D=parseInt(c,10)}if(D<=n)continue;const y=L.join(a,c,"pwsh.exe");await k.SymlinkSupport.existsFile(y)&&(i=y,n=D)}if(!i)return null;const r=t.includes("x86")?" (x86)":"",o=b?" Preview":"";return new I(i,`PowerShell${o}${r}`,!0)}async function N({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const b=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(b))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=p?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(b))if(t.test(n)){const i=L.join(b,n,"pwsh.exe");return new I(i,a)}return null}function S(){const p=L.join(T.homedir(),".dotnet","tools","pwsh.exe");return new I(p,".NET Core PowerShell Global Tool")}function u(){const p=L.join(process.env.windir,l===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(p,"Windows PowerShell",!0)}async function*d(){let p=await g();p&&(yield p),p=await g({useAlternateBitness:!0}),p&&(yield p),p=await N(),p&&(yield p),p=S(),p&&(yield p),p=await g({findPreview:!0}),p&&(yield p),p=await N({findPreview:!0}),p&&(yield p),p=await g({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=u(),p&&(yield p)}async function*f(){for await(const p of d())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=f;async function E(){for await(const p of f())return p;return null}e.getFirstAvailablePowerShellInstallation=E}),define(ne[56],re([0,1,15,12,34,53,3,22]),function(G,e,T,L,k,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function h(I=k.env){return I.comspec||"cmd.exe"}e.getWindowsShell=h;function l(I){let v=[],g=!1;const N=function(S){if(g){v.push(S);return}(!I.send(S,d=>{if(d&&console.error(d),g=!1,v.length>0){const f=v.slice(0);v=[],f.forEach(E=>N(E))}})||L.isWindows)&&(g=!0)};return{send:N}}e.createQueuedSender=l;var R;(function(I){async function v(g,N,S){if(T.isAbsolute(g))return g;if(N===void 0&&(N=k.cwd()),T.dirname(g)!=="."||(S===void 0&&C.isString(k.env.PATH)&&(S=k.env.PATH.split(T.delimiter)),S===void 0||S.length===0))return T.join(N,g);async function d(f){if(await w.Promises.exists(f)){let E;try{E=await w.Promises.stat(f)}catch(p){p.message.startsWith("EACCES")&&(E=await w.Promises.lstat(f))}return E?!E.isDirectory():!1}return!1}for(const f of S){let E;if(T.isAbsolute(f)?E=T.join(f,g):E=T.join(N,f,g),await d(E))return E;let p=E+".com";if(await d(p)||(p=E+".exe",await d(p)))return p}return T.join(N,g)}I.findExecutable=v})(R||(e.win32=R={}))}),define(ne[82],re([0,1,32,12,81,56]),function(G,e,T,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function C(I,v){return I===1?L.isWindows?R():A.getWindowsShell(v):h(I,v)}e.getSystemShell=C;let w=null;function h(I,v){if(L.isLinux&&I===2||L.isMacintosh&&I===3)return"/bin/bash";if(!w){let g;if(L.isWindows)g="/bin/bash";else{if(g=v.SHELL,!g)try{g=(0,T.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}w=g}return w}let l=null;async function R(){return l||(l=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),l}});var ve=this&&this.__decorate||function(G,e,T,L){var k=arguments.length,A=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,T):L,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,T,L);else for(var w=G.length-1;w>=0;w--)(C=G[w])&&(A=(k<3?C(A):k>3?C(e,T,A):C(e,T))||A);return k>3&&A&&Object.defineProperty(e,T,A),A};define(ne[57],re([0,1,19,8,14,23,51,9,5,2,46,29,3]),function(G,e,T,L,k,A,C,w,h,l,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var g;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(g||(g={}));function N(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(S||(S={}));function u(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(d||(d={}));function f(x){let F=0;for(let W=0;;W+=7){const H=x.read(1);if(F|=(H.buffer[0]&127)<<W,!(H.buffer[0]&128))return F}}const E=n(0);function p(x,F){if(F===0){x.write(E);return}let W=0;for(let Y=F;Y!==0;Y=Y>>>7)W++;const H=k.VSBuffer.alloc(W);for(let Y=0;F!==0;Y++)H.buffer[Y]=F&127,F=F>>>7,F>0&&(H.buffer[Y]|=128);x.write(H)}class b{constructor(F){this.b=F,this.a=0}read(F){const W=this.b.slice(this.a,this.a+F);return this.a+=W.byteLength,W}}e.BufferReader=b;class t{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(F){this.a.push(F)}}e.BufferWriter=t;var a;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(a||(a={}));function n(x){const F=k.VSBuffer.alloc(1);return F.writeUInt8(x,0),F}const i={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},r=typeof Buffer<"u";function o(x,F){if(typeof F>"u")x.write(i.Undefined);else if(typeof F=="string"){const W=k.VSBuffer.fromString(F);x.write(i.String),p(x,W.byteLength),x.write(W)}else if(r&&Buffer.isBuffer(F)){const W=k.VSBuffer.wrap(F);x.write(i.Buffer),p(x,W.byteLength),x.write(W)}else if(F instanceof k.VSBuffer)x.write(i.VSBuffer),p(x,F.byteLength),x.write(F);else if(Array.isArray(F)){x.write(i.Array),p(x,F.length);for(const W of F)o(x,W)}else if(typeof F=="number"&&(F|0)===F)x.write(i.Uint),p(x,F);else{const W=k.VSBuffer.fromString(JSON.stringify(F));x.write(i.Object),p(x,W.byteLength),x.write(W)}}e.serialize=o;function c(x){switch(x.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return x.read(f(x)).toString();case a.Buffer:return x.read(f(x)).buffer;case a.VSBuffer:return x.read(f(x));case a.Array:{const W=f(x),H=[];for(let Y=0;Y<W;Y++)H.push(c(x));return H}case a.Object:return JSON.parse(x.read(f(x)).toString());case a.Int:return f(x)}}e.deserialize=c;class D{constructor(F,W,H=null,Y=1e3){this.h=F,this.j=W,this.k=H,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(j=>this.q(j)),this.m({type:200})}registerChannel(F,W){this.b.set(F,W),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const W=this.o([F.type]);this.k?.logOutgoing(W,0,1,u(F.type));return}case 201:case 202:case 204:case 203:{const W=this.o([F.type,F.id],F.data);this.k?.logOutgoing(W,F.id,1,u(F.type),F.data);return}}}o(F,W=void 0){const H=new t;return o(H,F),o(H,W),this.p(H.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const W=new b(F),H=c(W),Y=c(W),j=H[0];switch(j){case 100:return this.k?.logIncoming(F.byteLength,H[1],1,`${N(j)}: ${H[2]}.${H[3]}`,Y),this.s({type:j,id:H[1],channelName:H[2],name:H[3],arg:Y});case 102:return this.k?.logIncoming(F.byteLength,H[1],1,`${N(j)}: ${H[2]}.${H[3]}`,Y),this.t({type:j,id:H[1],channelName:H[2],name:H[3],arg:Y});case 101:return this.k?.logIncoming(F.byteLength,H[1],1,`${N(j)}`),this.u({type:j,id:H[1]});case 103:return this.k?.logIncoming(F.byteLength,H[1],1,`${N(j)}`),this.u({type:j,id:H[1]})}}s(F){const W=this.b.get(F.channelName);if(!W){this.v(F);return}const H=new A.CancellationTokenSource;let Y;try{Y=W.call(this.j,F.name,F.arg,H.token)}catch(O){Y=Promise.reject(O)}const j=F.id;Y.then(O=>{this.m({id:j,data:O,type:201}),this.d.delete(F.id)},O=>{O instanceof Error?this.m({id:j,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.m({id:j,data:O,type:203}),this.d.delete(F.id)});const z=(0,l.toDisposable)(()=>H.cancel());this.d.set(F.id,z)}t(F){const W=this.b.get(F.channelName);if(!W){this.v(F);return}const H=F.id,j=W.listen(this.j,F.name,F.arg)(z=>this.m({id:H,data:z,type:204}));this.d.set(F.id,j)}u(F){const W=this.d.get(F.id);W&&(W.dispose(),this.d.delete(F.id))}v(F){let W=this.g.get(F.channelName);W||(W=[],this.g.set(F.channelName,W));const H=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:F,timeoutTimer:H})}w(F){const W=this.g.get(F);if(W){for(const H of W)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=D;var y;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class m{constructor(F,W=null){this.l=F,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=W}getChannel(F){const W=this;return{call(H,Y,j){return W.a?Promise.reject(new w.CancellationError):W.m(F,H,Y,j)},listen(H,Y){return W.a?h.Event.None:W.o(F,H,Y)}}}m(F,W,H,Y=A.CancellationToken.None){const j=this.g++,O={id:j,type:100,channelName:F,name:W,arg:H};if(Y.isCancellationRequested)return Promise.reject(new w.CancellationError);let s;return new Promise((U,B)=>{if(Y.isCancellationRequested)return B(new w.CancellationError);const X=()=>{const pe=he=>{switch(he.type){case 201:this.f.delete(j),U(he.data);break;case 202:{this.f.delete(j);const ge=new Error(he.data.message);ge.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,ge.name=he.data.name,B(ge);break}case 203:this.f.delete(j),B(he.data);break}};this.f.set(j,pe),this.p(O)};let _=null;this.b===d.Idle?X():(_=(0,L.createCancelablePromise)(pe=>this.u()),_.then(()=>{_=null,X()}));const le=()=>{_?(_.cancel(),_=null):this.p({id:j,type:101}),B(new w.CancellationError)},de=Y.onCancellationRequested(le);s=(0,l.combinedDisposable)((0,l.toDisposable)(le),de),this.d.add(s)}).finally(()=>{this.d.delete(s)})}o(F,W,H){const Y=this.g++,z={id:Y,type:102,channelName:F,name:W,arg:H};let O=null;const s=new h.Emitter({onWillAddFirstListener:()=>{O=(0,L.createCancelablePromise)(U=>this.u()),O.then(()=>{O=null,this.d.add(s),this.p(z)})},onDidRemoveLastListener:()=>{O?(O.cancel(),O=null):(this.d.delete(s),this.p({id:Y,type:103}))}}),P=U=>s.fire(U.data);return this.f.set(Y,P),s.event}p(F){switch(F.type){case 100:case 102:{const W=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(W,F.id,0,`${N(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const W=this.q([F.type,F.id]);this.j?.logOutgoing(W,F.id,0,N(F.type));return}}}q(F,W=void 0){const H=new t;return o(H,F),o(H,W),this.r(H.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const W=new b(F),H=c(W),Y=c(W),j=H[0];switch(j){case 200:return this.j?.logIncoming(F.byteLength,0,0,u(j)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,H[1],0,u(j),Y),this.t({type:H[0],id:H[1],data:Y})}}t(F){if(F.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.dispose)(this.d.values()),this.d.clear()}}e.ChannelClient=m,ve([C.memoize],m.prototype,"onDidInitializePromise",null);class M{get connections(){const F=[];return this.f.forEach(W=>F.push(W)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new h.Emitter,this.onDidAddConnection=this.g.event,this.h=new h.Emitter,this.onDidRemoveConnection=this.h.event,F(({protocol:W,onDidClientDisconnect:H})=>{h.Event.once(W.onMessage)(j=>{const z=new b(j),O=c(z),s=new D(W,O),P=new m(W);this.a.forEach((B,X)=>s.registerChannel(X,B));const U={channelServer:s,channelClient:P,ctx:O};this.f.add(U),this.g.fire(U),H(()=>{s.dispose(),P.dispose(),this.f.delete(U),this.h.fire(U)})})})}getChannel(F,W){const H=this;return{call(Y,j,z){let O;if((0,v.isFunction)(W)){const P=(0,T.getRandomElement)(H.connections.filter(W));O=P?Promise.resolve(P):h.Event.toPromise(h.Event.filter(H.onDidAddConnection,W))}else O=W.routeCall(H,Y,j);const s=O.then(P=>P.channelClient.getChannel(F));return K(s).call(Y,j,z)},listen(Y,j){if((0,v.isFunction)(W))return H.j(F,W,Y,j);const z=W.routeEvent(H,Y,j).then(O=>O.channelClient.getChannel(F));return K(z).listen(Y,j)}}}j(F,W,H,Y){const j=this;let z=new l.DisposableStore;const O=new h.Emitter({onWillAddFirstListener:()=>{z=new l.DisposableStore;const s=new h.EventMultiplexer,P=new Map,U=X=>{const le=X.channelClient.getChannel(F).listen(H,Y),de=s.add(le);P.set(X,de)},B=X=>{const _=P.get(X);_&&(_.dispose(),P.delete(X))};j.connections.filter(W).forEach(U),h.Event.filter(j.onDidAddConnection,W)(U,void 0,z),j.onDidRemoveConnection(B,void 0,z),s.event(O.fire,O,z),z.add(s)},onDidRemoveLastListener:()=>{z.dispose()}});return O.event}registerChannel(F,W){this.a.set(F,W),this.f.forEach(H=>{H.channelServer.registerChannel(F,W)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=M;class J{constructor(F,W,H=null){const Y=new t;o(Y,W),F.send(Y.buffer),this.a=new m(F,H),this.d=new D(F,W,H)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,W){this.d.registerChannel(F,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=J;function K(x){return{call(F,W,H){return x.then(Y=>Y.call(F,W,H))},listen(F,W){const H=new h.Relay;return x.then(Y=>H.input=Y.listen(F,W)),H.event}}}e.getDelayedChannel=K;function ie(x){let F=!1;return{call(W,H,Y){return F?x.call(W,H,Y):(0,L.timeout)(0).then(()=>F=!0).then(()=>x.call(W,H,Y))},listen(W,H){if(F)return x.listen(W,H);const Y=new h.Relay;return(0,L.timeout)(0).then(()=>F=!0).then(()=>Y.input=x.listen(W,H)),Y.event}}}e.getNextTickChannel=ie;class ue{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const W of F.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await h.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.StaticRouter=ue;var Q;(function(x){function F(j,z){const O=j,s=z&&z.disableMarshalling,P=new Map;for(const U in O)H(U)&&P.set(U,h.Event.buffer(O[U],!0));return new class{listen(U,B,X){const _=P.get(B);if(_)return _;if(Y(B)){const le=O[B];if(typeof le=="function")return le.call(O,X)}throw new Error(`Event not found: ${B}`)}call(U,B,X){const _=O[B];if(typeof _=="function"){if(!s&&Array.isArray(X))for(let le=0;le<X.length;le++)X[le]=(0,R.revive)(X[le]);return _.apply(O,X)}throw new Error(`Method not found: ${B}`)}}}x.fromService=F;function W(j,z){const O=z&&z.disableMarshalling;return new Proxy({},{get(s,P){if(typeof P=="string")return z?.properties?.has(P)?z.properties.get(P):Y(P)?function(U){return j.listen(P,U)}:H(P)?j.listen(P):async function(...U){let B;z&&!(0,v.isUndefinedOrNull)(z.context)?B=[z.context,...U]:B=U;const X=await j.call(P,B);return O?X:(0,R.revive)(X)};throw new Error(`Property not found: ${String(P)}`)}})}x.toService=W;function H(j){return j[0]==="o"&&j[1]==="n"&&I.isUpperAsciiLetter(j.charCodeAt(2))}function Y(j){return/^onDynamic/.test(j)&&I.isUpperAsciiLetter(j.charCodeAt(9))}})(Q||(e.ProxyChannel=Q={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function oe(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const F=x.toString();if(F!=="[object Object]")return F}return x}function se(x){return Array.isArray(x)?x.map(oe):oe(x)}function $(x,F,W,H,Y,j,z){z=se(z);const O=ce[Y],s=O[H%O.length];let P=[`%c[${x}]%c[${String(F).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${j}`,"color: darkgreen","color: grey","color: grey",`color: ${s}`];/\($/.test(j)?(P=P.concat(z),P.push(")")):P.push(z),console.log.apply(console,P)}class q{constructor(F,W){this.d=F,this.f=W,this.a=0,this.b=0}logOutgoing(F,W,H,Y,j){this.b+=F,$(this.d,this.b,F,W,H,Y,j)}logIncoming(F,W,H,Y,j){this.a+=F,$(this.f,this.a,F,W,H,Y,j)}}e.IPCLogger=q}),define(ne[83],re([0,1,58,8,14,23,79,9,5,2,30,56,53,57]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class N extends g.ChannelServer{constructor(d){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",f=>k.VSBuffer.wrap(Buffer.from(f,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=N;class S{constructor(d,f){this.i=d,this.j=f,this.c=new Set,this.g=new Map,this.h=new h.Emitter,this.onDidProcessExit=this.h.event;const E=f&&f.timeout?f.timeout:6e4;this.b=new L.Delayer(E),this.d=null,this.f=null}getChannel(d){const f=this;return{call(E,p,b){return f.k(d,E,p,b)},listen(E,p){return f.l(d,E,p)}}}k(d,f,E,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(w.canceled());this.b.cancel();const b=this.n(d),t=(0,L.createCancelablePromise)(i=>b.call(f,E,i)),a=p.onCancellationRequested(()=>t.cancel()),n=(0,l.toDisposable)(()=>t.cancel());return this.c.add(n),t.finally(()=>{a.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(d,f,E){if(!this.b)return h.Event.None;this.b.cancel();let p;const b=new h.Emitter({onWillAddFirstListener:()=>{p=this.n(d).listen(f,E)(b.fire,b),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return b.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(f.env),this.d=(0,T.fork)(this.i,d,f);const E=new h.Emitter;h.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,C.isRemoteConsoleLog)(r)){(0,C.log)(r,`IPC Library: ${this.j.serverName}`);return}E.fire(k.VSBuffer.wrap(Buffer.from(r,"base64")))});const b=this.j.useQueue?(0,I.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&b.send(r.buffer.toString("base64")),a=E.event,n={send:t,onMessage:a};this.f=new g.ChannelClient(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",i),this.c.forEach(c=>(0,l.dispose)(c)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(d){let f=this.g.get(d);return f||(f=this.m.getChannel(d),this.g.set(d,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=S}),define(ne[84],re([0,1,8,5,2,46,3]),function(G,e,T,L,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var w;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function h(v){const g=v;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=h;var l;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(l||(e.StorageState=l={}));class R extends k.Disposable{constructor(g,N=Object.create(null)){super(),this.m=g,this.n=N,this.b=this.B(new L.Emitter),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=new T.ThrottledDelayer(R.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(g=>this.r(g)))}r(g){g.changed?.forEach((N,S)=>this.s(S,N)),g.deleted?.forEach(N=>this.s(N,void 0))}s(g,N){if(this.c===l.Closed)return;let S=!1;(0,C.isUndefinedOrNull)(N)?S=this.f.delete(g):this.f.get(g)!==N&&(this.f.set(g,N),S=!0),S&&this.b.fire(g)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.n.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(g,N){const S=this.f.get(g);return(0,C.isUndefinedOrNull)(S)?N:S}getBoolean(g,N){const S=this.get(g);return(0,C.isUndefinedOrNull)(S)?N:S==="true"}getNumber(g,N){const S=this.get(g);return(0,C.isUndefinedOrNull)(S)?N:parseInt(S,10)}getObject(g,N){const S=this.get(g);return(0,C.isUndefinedOrNull)(S)?N:(0,A.parse)(S)}async set(g,N){if(this.c===l.Closed)return;if((0,C.isUndefinedOrNull)(N))return this.delete(g);const S=(0,C.isObject)(N)||Array.isArray(N)?(0,A.stringify)(N):String(N);if(this.f.get(g)!==S)return this.f.set(g,S),this.j.set(g,S),this.h.delete(g),this.b.fire(g),this.w()}async delete(g){if(!(this.c===l.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire(g),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=l.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(g).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(g){if(this.u)return this.w(g)}async w(g){return this.g.trigger(()=>this.v(),g)}async whenFlushed(){if(this.u)return new Promise(g=>this.l.push(g))}isInMemory(){return this.n.hint===w.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=R,R.a=100;class I{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((N,S)=>this.a.set(S,N)),g.delete?.forEach(N=>this.a.delete(N))}async close(){}}e.InMemoryStorageDatabase=I}),define(ne[85],re([7,4]),function(G,e){return G.create("vs/base/node/zip",e)}),define(ne[86],re([7,4]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[87],re([7,4]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[88],re([7,4]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ne[89],re([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[90],re([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[91],re([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[92],re([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[93],re([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[94],re([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[95],re([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[96],re([7,4]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[97],re([7,4]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ne[98],re([7,4]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ne[99],re([7,4]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[100],re([7,4]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[101],re([7,4]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ne[102],re([7,4]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ne[103],re([7,4]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[104],re([7,4]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[105],re([7,4]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ne[106],re([0,1,9,88]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...l){switch(l.length){case 1:return(0,L.localize)(0,null,l[0]);case 2:return(0,L.localize)(1,null,l[0],l[1]);case 3:return(0,L.localize)(2,null,l[0],l[1],l[2]);default:return}}const C=(0,L.localize)(3,null),w=(0,L.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,T.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const I=this.d,v=this.c.substring(this.d,this.e),g={type:19,offset:this.d,lexeme:v};this.g.push({offset:I,lexeme:v,additionalInfo:R}),this.f.push(g)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const I=this.c.substring(this.d,this.e),v=h.b.get(I);v?this.k(v):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,I=!1,v=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(w);return}const N=this.c.charCodeAt(R);if(I)I=!1;else if(N===47&&!v){R++;break}else N===91?v=!0:N===92?I=!0:N===93&&(v=!1);R++}for(;R<this.c.length&&h.a.has(this.c.charCodeAt(R));)R++;this.e=R;const g=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:g,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=h,h.a=new Set(["i","g","s","m","y","u"].map(l=>l.charCodeAt(0))),h.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(ne[107],re([0,1,75,51,16,15,34,17,11]),function(G,e,T,L,k,A,C,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,A.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,w.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",g)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(h.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,w.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,w.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=C.env.VSCODE_PORTABLE;return g?h.URI.file((0,A.join)(g,"argv.json")):(0,w.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,A.resolve)(g):(0,A.normalize)((0,A.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?h.URI.file((0,A.resolve)(g)):h.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,A.resolve)(g);const N=C.env.VSCODE_EXTENSIONS;if(N)return N;const S=C.env.VSCODE_PORTABLE;return S?(0,A.join)(S,"extensions"):(0,w.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(N=>/^[^:/?#]+?:\/\//.test(N)?h.URI.parse(N):h.URI.file((0,A.normalize)(N)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?h.URI.parse(g):h.URI.file((0,A.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const N of this.args.log||[]){const S=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(N);S&&S[1]&&S[2]&&g.push([S[1],S[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,w.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=C.env.VSCODE_PORTABLE;return g?h.URI.file((0,A.join)(g,"policy.json")):(0,w.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,N,S){this.a=g,this.b=N,this.c=S,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,ve([L.memoize],l.prototype,"appRoot",null),ve([L.memoize],l.prototype,"userHome",null),ve([L.memoize],l.prototype,"userDataPath",null),ve([L.memoize],l.prototype,"appSettingsHome",null),ve([L.memoize],l.prototype,"tmpDir",null),ve([L.memoize],l.prototype,"cacheHome",null),ve([L.memoize],l.prototype,"stateResource",null),ve([L.memoize],l.prototype,"userRoamingDataHome",null),ve([L.memoize],l.prototype,"userDataSyncHome",null),ve([L.memoize],l.prototype,"sync",null),ve([L.memoize],l.prototype,"machineSettingsResource",null),ve([L.memoize],l.prototype,"workspaceStorageHome",null),ve([L.memoize],l.prototype,"localHistoryHome",null),ve([L.memoize],l.prototype,"keyboardLayoutResource",null),ve([L.memoize],l.prototype,"argvResource",null),ve([L.memoize],l.prototype,"isExtensionDevelopment",null),ve([L.memoize],l.prototype,"untitledWorkspacesHome",null),ve([L.memoize],l.prototype,"builtinExtensionsPath",null),ve([L.memoize],l.prototype,"extensionsPath",null),ve([L.memoize],l.prototype,"extensionDevelopmentLocationURI",null),ve([L.memoize],l.prototype,"extensionDevelopmentKind",null),ve([L.memoize],l.prototype,"extensionTestsLocationURI",null),ve([L.memoize],l.prototype,"debugExtensionHost",null),ve([L.memoize],l.prototype,"logLevel",null),ve([L.memoize],l.prototype,"extensionLogLevel",null),ve([L.memoize],l.prototype,"serviceMachineIdResource",null),ve([L.memoize],l.prototype,"disableTelemetry",null),ve([L.memoize],l.prototype,"disableWorkspaceTrust",null),ve([L.memoize],l.prototype,"policyFile",null);function R(v,g){return I(v["inspect-extensions"],v["inspect-brk-extensions"],5870,g,v.debugId,v.extensionEnvironment)}e.parseExtensionHostDebugPort=R;function I(v,g,N,S,u,d){const E=Number(g||v)||(S?null:N),p=E?!!g:!1;let b;if(d)try{b=JSON.parse(d)}catch{}return{port:E,break:p,debugId:u,env:b}}e.parseDebugParams=I}),function(){"use strict";function G(e,T,L){function k(C,w){const h=A(C,w),l=[h];return e.isAbsolute(h)||l.unshift(L),e.resolve(...l)}function A(C,w){process.env.VSCODE_DEV&&(w="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,w);const R=C["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(I,"AppData","Roaming")}break;case"darwin":l=e.join(T.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,w)}return{getUserDataPath:k}}if(typeof define=="function")define(ne[108],re([162,32,34]),function(e,T,L){return G(e,T,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=G(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[109],re([0,1,32,107,108]),function(G,e,T,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(l,R){super(l,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,k.getUserDataPath)(l,R.nameShort)},R)}}e.NativeEnvironmentService=A;function C(h,l){return(0,L.parseDebugParams)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,l,h.extensionEnvironment)}e.parsePtyHostDebugPort=C;function w(h,l){return(0,L.parseDebugParams)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,l,h.extensionEnvironment)}e.parseSharedProcessDebugPort=w}),define(ne[110],re([0,1,3,92]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(C,w,h){try{A(C,w,h)}catch(l){console.error(l?.message??l)}return C}e.localizeManifest=k;function A(C,w,h){const l=(R,I,v)=>{const g=R[I];if((0,T.isString)(g)){const N=g,S=N.length;if(S>1&&N[0]==="%"&&N[S-1]==="%"){const u=N.substr(1,S-2);let d=w[u];d===void 0&&h&&(d=h[u]);const f=typeof d=="string"?d:d?.message,E=h?.[u],p=typeof E=="string"?E:E?.message;if(!f){p||console.warn(`[${C.name}]: ${(0,L.localize)(0,null,u)}`);return}if(v&&(I==="title"||I==="category")&&p&&p!==f){const b={value:f,original:p};R[I]=b}else R[I]=f}}else if((0,T.isObject)(g))for(const N in g)g.hasOwnProperty(N)&&(N==="commands"?l(g,N,!0):l(g,N,v));else if(Array.isArray(g))for(let N=0;N<g.length;N++)l(g,N,v)};for(const R in C)C.hasOwnProperty(R)&&l(C,R)}}),define(ne[47],re([0,1,17,54,96,41]),function(G,e,T,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function h(d){return d=d.trim(),d==="*"||C.test(d)}e.isValidVersionStr=h;function l(d){if(!h(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=d.match(C);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=l;function R(d){if(!d)return null;const f=d.majorBase,E=d.majorMustEqual,p=d.minorBase;let b=d.minorMustEqual;const t=d.patchBase;let a=d.patchMustEqual;d.hasCaret&&(f===0||(b=!1),a=!1);let n=0;if(d.preRelease){const i=w.exec(d.preRelease);if(i){const[,r,o,c]=i;n=Date.UTC(Number(r),Number(o)-1,Number(c))}}return{majorBase:f,majorMustEqual:E,minorBase:p,minorMustEqual:b,patchBase:t,patchMustEqual:a,isMinimum:d.hasGreaterEquals,notBefore:n}}e.normalizeVersion=R;function I(d,f,E){let p;typeof d=="string"?p=R(l(d)):p=d;let b;f instanceof Date?b=f.getTime():typeof f=="string"&&(b=new Date(f).getTime());let t;if(typeof E=="string"?t=R(l(E)):t=E,!p||!t)return!1;const a=p.majorBase,n=p.minorBase,i=p.patchBase;let r=t.majorBase,o=t.minorBase,c=t.patchBase;const D=t.notBefore;let y=t.majorMustEqual,m=t.minorMustEqual,M=t.patchMustEqual;return t.isMinimum?a>r?!0:a<r?!1:n>o?!0:n<o||b&&b<D?!1:i>=c:(a===1&&r===0&&(!y||!m||!M)&&(r=1,o=0,c=0,y=!0,m=!1,M=!1),a<r?!1:a>r?!y:n<o?!1:n>o?!m:i<c?!1:i>c?!M:!(b&&b<D))}e.isValidVersion=I;function v(d,f,E,p,b){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([L.default.Error,k.localize(0,null)]),t;if(typeof p.name!="string")return t.push([L.default.Error,k.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([L.default.Error,k.localize(2,null,"version")]),t;if(!p.engines)return t.push([L.default.Error,k.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([L.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!u(p.extensionDependencies))return t.push([L.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!u(p.activationEvents))return t.push([L.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([L.default.Error,k.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([L.default.Warning,k.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([L.default.Error,k.localize(9,null,"main")]),t;{const i=(0,T.joinPath)(E,p.main);(0,T.isEqualOrParent)(i,E)||t.push([L.default.Warning,k.localize(10,null,i.path,E.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([L.default.Error,k.localize(11,null,"browser")]),t;{const i=(0,T.joinPath)(E,p.browser);(0,T.isEqualOrParent)(i,E)||t.push([L.default.Warning,k.localize(12,null,i.path,E.path)])}}if(!A.valid(p.version))return t.push([L.default.Error,k.localize(13,null)]),t;const a=[];if(!g(d,f,p,b,a))for(const i of a)t.push([L.default.Error,i]);return t}e.validateExtensionManifest=v;function g(d,f,E,p,b){return p||typeof E.main>"u"&&typeof E.browser>"u"?!0:S(d,f,E.engines.vscode,b)}e.isValidExtensionVersion=g;function N(d,f,E){return d==="*"||S(f,E,d)}e.isEngineValid=N;function S(d,f,E,p=[]){const b=R(l(E));if(!b)return p.push(k.localize(14,null,E)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return p.push(k.localize(15,null,E)),!1}else if(!b.majorMustEqual)return p.push(k.localize(16,null,E)),!1;return I(d,f,b)?!0:(p.push(k.localize(17,null,d,E)),!1)}function u(d){if(!Array.isArray(d))return!1;for(let f=0,E=d.length;f<E;f++)if(typeof d[f]!="string")return!1;return!0}}),define(ne[111],re([0,1,14,28]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(A,C,w){let h=w&&w.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const R=(await C.readFile(A.serviceMachineIdResource)).value.toString();h=(0,L.isUUID)(R)?R:null}catch{h=null}if(!h){h=(0,L.generateUuid)();try{await C.writeFile(A.serviceMachineIdResource,T.VSBuffer.fromString(h))}catch{}}return w?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=k}),define(ne[48],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(k,A=[],C=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=T}),define(ne[112],re([0,1,48]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var k;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function A(w,h,l){h instanceof T.SyncDescriptor||(h=new T.SyncDescriptor(h,[],!!l)),L.push([w,h])}e.registerSingleton=A;function C(){return L}e.getSingletonServiceDescriptors=C}),define(ne[113],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(A,C){this.key=A,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class L{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const C of this.a.values())C.outgoing.size===0&&A.push(C);return A}insertEdge(A,C){const w=this.lookupOrInsertNode(A),h=this.lookupOrInsertNode(C);w.outgoing.set(h.key,h),h.incoming.set(w.key,w)}removeNode(A){const C=this.b(A);this.a.delete(C);for(const w of this.a.values())w.outgoing.delete(C),w.incoming.delete(C)}lookupOrInsertNode(A){const C=this.b(A);let w=this.a.get(C);return w||(w=new T(C,A),this.a.set(C,w)),w}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[C,w]of this.a)A.push(`${C}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,C]of this.a){const w=new Set([A]),h=this.c(C,w);if(h)return h}}c(A,C){for(const[w,h]of A.outgoing){if(C.has(w))return[...C,w].join(" -> ");C.add(w);const l=this.c(h,C);if(l)return l;C.delete(w)}}}e.Graph=L}),define(ne[24],re([0,1,3,11,10]),function(G,e,T,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof L.URI)}e.isConfigurationOverrides=A;function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=C;var w;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function h(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function l(u,d){const f=Object.create(null);for(const E in u)R(f,E,u[E],d);return f}e.toValuesTree=l;function R(u,d,f,E){const p=d.split("."),b=p.pop();let t=u;for(let a=0;a<p.length;a++){const n=p[a];let i=t[n];switch(typeof i){case"undefined":i=t[n]=Object.create(null);break;case"object":break;default:E(`Ignoring ${d} as ${p.slice(0,a+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[b]=f}catch{E(`Ignoring ${d} as ${p.join(".")} is ${JSON.stringify(t)}`)}else E(`Ignoring ${d} as ${p.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=R;function I(u,d){const f=d.split(".");v(u,f)}e.removeFromValueTree=I;function v(u,d){const f=d.shift();if(d.length===0){delete u[f];return}if(Object.keys(u).indexOf(f)!==-1){const E=u[f];typeof E=="object"&&!Array.isArray(E)&&(v(E,d),Object.keys(E).length===0&&delete u[f])}}function g(u,d,f){function E(t,a){let n=t;for(const i of a){if(typeof n!="object"||n===null)return;n=n[i]}return n}const p=d.split("."),b=E(u,p);return typeof b>"u"?f:b}e.getConfigurationValue=g;function N(u,d,f){Object.keys(d).forEach(E=>{E!=="__proto__"&&(E in u?T.isObject(u[E])&&T.isObject(d[E])?N(u[E],d[E],f):f&&(u[E]=d[E]):u[E]=d[E])})}e.merge=N;function S(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=S}),define(ne[114],re([0,1,12,29,106,10,87,9]),function(G,e,T,L,k,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",T.isMacintosh),h.set("isLinux",T.isLinux),h.set("isWindows",T.isWindows),h.set("isWeb",T.isWeb),h.set("isMacNative",T.isMacintosh&&!T.isWeb),h.set("isEdge",T.isEdge),h.set("isFirefox",T.isFirefox),h.set("isChrome",T.isChrome),h.set("isSafari",T.isSafari);function l(O,s){if(h.get(O)!==void 0)throw(0,w.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(O,s)}e.setConstant=l;const R=Object.prototype.hasOwnProperty;var I;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const v={regexParsingWithErrorRecovery:!0},g=(0,C.localize)(0,null),N=(0,C.localize)(1,null),S=(0,C.localize)(2,null),u=(0,C.localize)(3,null),d=(0,C.localize)(4,null),f=(0,C.localize)(5,null),E=(0,C.localize)(6,null),p=(0,C.localize)(7,null);class b{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(s=v){this.k=s,this.d=new k.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(s){if(s===""){this.h.push({message:g,offset:0,lexeme:"",additionalInfo:N});return}this.f=this.d.reset(s).scan(),this.g=0,this.h=[];try{const P=this.l();if(!this.E()){const U=this.D(),B=U.type===17?f:void 0;throw this.h.push({message:d,offset:U.offset,lexeme:k.Scanner.getLexeme(U),additionalInfo:B}),b.c}return P}catch(P){if(P!==b.c)throw P;return}}l(){return this.m()}m(){const s=[this.o()];for(;this.y(16);){const P=this.o();s.push(P)}return s.length===1?s[0]:t.or(...s)}o(){const s=[this.s()];for(;this.y(15);){const P=this.s();s.push(P)}return s.length===1?s[0]:t.and(...s)}s(){if(this.y(2)){const s=this.D();switch(s.type){case 11:return this.z(),r.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const P=this.l();return this.A(1,u),P?.negate()}case 17:return this.z(),J.create(s.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",s)}}return this.t()}t(){const s=this.D();switch(s.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const P=this.l();return this.A(1,u),P}case 17:{const P=s.lexeme;if(this.z(),this.y(9)){const B=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),B.type!==10)throw this.B("REGEX",B);const X=B.lexeme,_=X.lastIndexOf("/"),le=_===X.length-1?void 0:this.w(X.substring(_+1));let de;try{de=new RegExp(X.substring(1,_),le)}catch{throw this.B("REGEX",B)}return oe.create(P,de)}switch(B.type){case 10:case 19:{const X=[B.lexeme];this.z();let _=this.D(),le=0;for(let ae=0;ae<B.lexeme.length;ae++)B.lexeme.charCodeAt(ae)===40?le++:B.lexeme.charCodeAt(ae)===41&&le--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let ae=0;ae<_.lexeme.length;ae++)_.lexeme.charCodeAt(ae)===40?le++:B.lexeme.charCodeAt(ae)===41&&le--}if(le<0)break;X.push(k.Scanner.getLexeme(_)),this.z(),_=this.D()}const de=X.join(""),pe=de.lastIndexOf("/"),he=pe===de.length-1?void 0:this.w(de.substring(pe+1));let ge;try{ge=new RegExp(de.substring(1,pe),he)}catch{throw this.B("REGEX",B)}return t.regex(P,ge)}case 18:{const X=B.lexeme;this.z();let _=null;if(!(0,L.isFalsyOrWhitespace)(X)){const le=X.indexOf("/"),de=X.lastIndexOf("/");if(le!==de&&le>=0){const pe=X.slice(le+1,de),he=X[de+1]==="i"?"i":"";try{_=new RegExp(pe,he)}catch{throw this.B("REGEX",B)}}}if(_===null)throw this.B("REGEX",B);return oe.create(P,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,S);const B=this.u();return t.notIn(P,B)}switch(this.D().type){case 3:{this.z();const B=this.u();if(this.x().type===18)return t.equals(P,B);switch(B){case"true":return t.has(P);case"false":return t.not(P);default:return t.equals(P,B)}}case 4:{this.z();const B=this.u();if(this.x().type===18)return t.notEquals(P,B);switch(B){case"true":return t.not(P);case"false":return t.has(P);default:return t.notEquals(P,B)}}case 5:return this.z(),Q.create(P,this.u());case 6:return this.z(),ce.create(P,this.u());case 7:return this.z(),ie.create(P,this.u());case 8:return this.z(),ue.create(P,this.u());case 13:return this.z(),t.in(P,this.u());default:return t.has(P)}}case 20:throw this.h.push({message:E,offset:s.offset,lexeme:"",additionalInfo:p}),b.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const s=this.D();switch(s.type){case 17:case 18:return this.z(),s.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(s){return s.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(s){return this.C(s)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(s,P){if(this.C(s))return this.z();throw this.B(P,this.D())}B(s,P,U){const B=(0,C.localize)(8,null,s,k.Scanner.getLexeme(P)),X=P.offset,_=k.Scanner.getLexeme(P);return this.h.push({message:B,offset:X,lexeme:_,additionalInfo:U}),b.c}C(s){return this.D().type===s}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=b,b.c=new Error;class t{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(s){return c.create(s)}static equals(s,P){return D.create(s,P)}static notEquals(s,P){return M.create(s,P)}static regex(s,P){return oe.create(s,P)}static in(s,P){return y.create(s,P)}static notIn(s,P){return m.create(s,P)}static not(s){return J.create(s)}static and(...s){return q.create(s,null,!0)}static or(...s){return x.create(s,null,!0)}static greater(s,P){return ie.create(s,P)}static greaterEquals(s,P){return ue.create(s,P)}static smaller(s,P){return Q.create(s,P)}static smallerEquals(s,P){return ce.create(s,P)}static deserialize(s){return s==null?void 0:this.c.parse(s)}}e.ContextKeyExpr=t,t.c=new b({regexParsingWithErrorRecovery:!1});function a(O){const s=new b({regexParsingWithErrorRecovery:!1});return O.map(P=>(s.parse(P),s.lexingErrors.length>0?s.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,C.localize)(9,null,U.additionalInfo):(0,C.localize)(10,null),offset:U.offset,length:U.lexeme.length})):s.parsingErrors.length>0?s.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}e.validateWhenClauses=a;function n(O,s){const P=O?O.substituteConstants():void 0,U=s?s.substituteConstants():void 0;return!P&&!U?!0:!P||!U?!1:P.equals(U)}e.expressionsAreEqualWithConstantSubstitution=n;function i(O,s){return O.cmp(s)}class r{constructor(){this.type=0}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!1}serialize(){return"false"}keys(){return[]}map(s){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=r,r.INSTANCE=new r;class o{constructor(){this.type=1}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!0}serialize(){return"true"}keys(){return[]}map(s){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=o,o.INSTANCE=new o;class c{static create(s,P=null){const U=h.get(s);return typeof U=="boolean"?U?o.INSTANCE:r.INSTANCE:new c(s,P)}constructor(s,P){this.key=s,this.c=P,this.type=2}cmp(s){return s.type!==this.type?this.type-s.type:W(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}substituteConstants(){const s=h.get(this.key);return typeof s=="boolean"?s?o.INSTANCE:r.INSTANCE:this}evaluate(s){return!!s.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(s){return s.mapDefined(this.key)}negate(){return this.c||(this.c=J.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=c;class D{static create(s,P,U=null){if(typeof P=="boolean")return P?c.create(s,U):J.create(s,U);const B=h.get(s);return typeof B=="boolean"?P===(B?"true":"false")?o.INSTANCE:r.INSTANCE:new D(s,P,U)}constructor(s,P,U){this.c=s,this.d=P,this.f=U,this.type=4}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){const s=h.get(this.c);if(typeof s=="boolean"){const P=s?"true":"false";return this.d===P?o.INSTANCE:r.INSTANCE}return this}evaluate(s){return s.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(s){return s.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=D;class y{static create(s,P){return new y(s,P)}constructor(s,P){this.d=s,this.f=P,this.type=10,this.c=null}cmp(s){return s.type!==this.type?this.type-s.type:H(this.d,this.f,s.d,s.f)}equals(s){return s.type===this.type?this.d===s.d&&this.f===s.f:!1}substituteConstants(){return this}evaluate(s){const P=s.getValue(this.f),U=s.getValue(this.d);return Array.isArray(P)?P.includes(U):typeof U=="string"&&typeof P=="object"&&P!==null?R.call(P,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(s){return s.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=y;class m{static create(s,P){return new m(s,P)}constructor(s,P){this.d=s,this.f=P,this.type=11,this.c=y.create(s,P)}cmp(s){return s.type!==this.type?this.type-s.type:this.c.cmp(s.c)}equals(s){return s.type===this.type?this.c.equals(s.c):!1}substituteConstants(){return this}evaluate(s){return!this.c.evaluate(s)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(s){return s.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=m;class M{static create(s,P,U=null){if(typeof P=="boolean")return P?J.create(s,U):c.create(s,U);const B=h.get(s);return typeof B=="boolean"?P===(B?"true":"false")?r.INSTANCE:o.INSTANCE:new M(s,P,U)}constructor(s,P,U){this.c=s,this.d=P,this.f=U,this.type=5}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){const s=h.get(this.c);if(typeof s=="boolean"){const P=s?"true":"false";return this.d===P?r.INSTANCE:o.INSTANCE}return this}evaluate(s){return s.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(s){return s.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=M;class J{static create(s,P=null){const U=h.get(s);return typeof U=="boolean"?U?r.INSTANCE:o.INSTANCE:new J(s,P)}constructor(s,P){this.c=s,this.d=P,this.type=3}cmp(s){return s.type!==this.type?this.type-s.type:W(this.c,s.c)}equals(s){return s.type===this.type?this.c===s.c:!1}substituteConstants(){const s=h.get(this.c);return typeof s=="boolean"?s?r.INSTANCE:o.INSTANCE:this}evaluate(s){return!s.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(s){return s.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.ContextKeyNotExpr=J;function K(O,s){if(typeof O=="string"){const P=parseFloat(O);isNaN(P)||(O=P)}return typeof O=="string"||typeof O=="number"?s(O):r.INSTANCE}class ie{static create(s,P,U=null){return K(P,B=>new ie(s,B,U))}constructor(s,P,U){this.c=s,this.d=P,this.f=U,this.type=12}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(s){return s.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=ie;class ue{static create(s,P,U=null){return K(P,B=>new ue(s,B,U))}constructor(s,P,U){this.c=s,this.d=P,this.f=U,this.type=13}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(s){return s.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=ue;class Q{static create(s,P,U=null){return K(P,B=>new Q(s,B,U))}constructor(s,P,U){this.c=s,this.d=P,this.f=U,this.type=14}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(s){return s.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=Q;class ce{static create(s,P,U=null){return K(P,B=>new ce(s,B,U))}constructor(s,P,U){this.c=s,this.d=P,this.f=U,this.type=15}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(s){return s.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=ce;class oe{static create(s,P){return new oe(s,P)}constructor(s,P){this.d=s,this.f=P,this.type=7,this.c=null}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.d<s.d)return-1;if(this.d>s.d)return 1;const P=this.f?this.f.source:"",U=s.f?s.f.source:"";return P<U?-1:P>U?1:0}equals(s){if(s.type===this.type){const P=this.f?this.f.source:"",U=s.f?s.f.source:"";return this.d===s.d&&P===U}return!1}substituteConstants(){return this}evaluate(s){const P=s.getValue(this.d);return this.f?this.f.test(P):!1}serialize(){const s=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${s}`}keys(){return[this.d]}map(s){return s.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=se.create(this)),this.c}}e.ContextKeyRegexExpr=oe;class se{static create(s){return new se(s)}constructor(s){this.c=s,this.type=8}cmp(s){return s.type!==this.type?this.type-s.type:this.c.cmp(s.c)}equals(s){return s.type===this.type?this.c.equals(s.c):!1}substituteConstants(){return this}evaluate(s){return!this.c.evaluate(s)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(s){return new se(this.c.map(s))}negate(){return this.c}}e.ContextKeyNotRegexExpr=se;function $(O){let s=null;for(let P=0,U=O.length;P<U;P++){const B=O[P].substituteConstants();if(O[P]!==B&&s===null){s=[];for(let X=0;X<P;X++)s[X]=O[X]}s!==null&&(s[P]=B)}return s===null?O:s}class q{static create(s,P,U){return q.d(s,P,U)}constructor(s,P){this.expr=s,this.c=P,this.type=6}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let P=0,U=this.expr.length;P<U;P++){const B=i(this.expr[P],s.expr[P]);if(B!==0)return B}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let P=0,U=this.expr.length;P<U;P++)if(!this.expr[P].equals(s.expr[P]))return!1;return!0}return!1}substituteConstants(){const s=$(this.expr);return s===this.expr?this:q.create(s,this.c,!1)}evaluate(s){for(let P=0,U=this.expr.length;P<U;P++)if(!this.expr[P].evaluate(s))return!1;return!0}static d(s,P,U){const B=[];let X=!1;for(const _ of s)if(_){if(_.type===1){X=!0;continue}if(_.type===0)return r.INSTANCE;if(_.type===6){B.push(..._.expr);continue}B.push(_)}if(B.length===0&&X)return o.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(i);for(let _=1;_<B.length;_++)B[_-1].equals(B[_])&&(B.splice(_,1),_--);if(B.length===1)return B[0];for(;B.length>1;){const _=B[B.length-1];if(_.type!==9)break;B.pop();const le=B.pop(),de=B.length===0,pe=x.create(_.expr.map(he=>q.create([he,le],null,U)),null,de);pe&&(B.push(pe),B.sort(i))}if(B.length===1)return B[0];if(U){for(let _=0;_<B.length;_++)for(let le=_+1;le<B.length;le++)if(B[_].negate().equals(B[le]))return r.INSTANCE;if(B.length===1)return B[0]}return new q(B,P)}}serialize(){return this.expr.map(s=>s.serialize()).join(" && ")}keys(){const s=[];for(const P of this.expr)s.push(...P.keys());return s}map(s){return new q(this.expr.map(P=>P.map(s)),null)}negate(){if(!this.c){const s=[];for(const P of this.expr)s.push(P.negate());this.c=x.create(s,this,!0)}return this.c}}e.ContextKeyAndExpr=q;class x{static create(s,P,U){return x.d(s,P,U)}constructor(s,P){this.expr=s,this.c=P,this.type=9}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let P=0,U=this.expr.length;P<U;P++){const B=i(this.expr[P],s.expr[P]);if(B!==0)return B}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let P=0,U=this.expr.length;P<U;P++)if(!this.expr[P].equals(s.expr[P]))return!1;return!0}return!1}substituteConstants(){const s=$(this.expr);return s===this.expr?this:x.create(s,this.c,!1)}evaluate(s){for(let P=0,U=this.expr.length;P<U;P++)if(this.expr[P].evaluate(s))return!0;return!1}static d(s,P,U){let B=[],X=!1;if(s){for(let _=0,le=s.length;_<le;_++){const de=s[_];if(de){if(de.type===0){X=!0;continue}if(de.type===1)return o.INSTANCE;if(de.type===9){B=B.concat(de.expr);continue}B.push(de)}}if(B.length===0&&X)return r.INSTANCE;B.sort(i)}if(B.length!==0){if(B.length===1)return B[0];for(let _=1;_<B.length;_++)B[_-1].equals(B[_])&&(B.splice(_,1),_--);if(B.length===1)return B[0];if(U){for(let _=0;_<B.length;_++)for(let le=_+1;le<B.length;le++)if(B[_].negate().equals(B[le]))return o.INSTANCE;if(B.length===1)return B[0]}return new x(B,P)}}serialize(){return this.expr.map(s=>s.serialize()).join(" || ")}keys(){const s=[];for(const P of this.expr)s.push(...P.keys());return s}map(s){return new x(this.expr.map(P=>P.map(s)),null)}negate(){if(!this.c){const s=[];for(const P of this.expr)s.push(P.negate());for(;s.length>1;){const P=s.shift(),U=s.shift(),B=[];for(const X of z(P))for(const _ of z(U))B.push(q.create([X,_],null,!1));s.unshift(x.create(B,null,!1))}this.c=x.create(s,this,!0)}return this.c}}e.ContextKeyOrExpr=x;class F extends c{static all(){return F.d.values()}constructor(s,P,U){super(s,null),this.f=P,typeof U=="object"?F.d.push({...U,key:s}):U!==!0&&F.d.push({key:s,description:U,type:P!=null?typeof P:void 0})}bindTo(s){return s.createKey(this.key,this.f)}getValue(s){return s.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(s){return D.create(this.key,s)}notEqualsTo(s){return M.create(this.key,s)}}e.RawContextKey=F,F.d=[],e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function W(O,s){return O<s?-1:O>s?1:0}function H(O,s,P,U){return O<P?-1:O>P?1:s<U?-1:s>U?1:0}function Y(O,s){if(O.type===0||s.type===1)return!0;if(O.type===9)return s.type===9?j(O.expr,s.expr):!1;if(s.type===9){for(const P of s.expr)if(Y(O,P))return!0;return!1}if(O.type===6){if(s.type===6)return j(s.expr,O.expr);for(const P of O.expr)if(Y(P,s))return!0;return!1}return O.equals(s)}e.implies=Y;function j(O,s){let P=0,U=0;for(;P<O.length&&U<s.length;){const B=O[P].cmp(s[U]);if(B<0)return!1;B===0&&P++,U++}return P===O.length}function z(O){return O.type===9?O.expr:[O]}}),define(ne[59],re([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(ne[18],re([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[20],re([0,1,90,10]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function k(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function C(f,E){switch(f){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function w(f,E){return E==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function h(f,E,p){return w(E,p)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===p?!0:l(p).includes(f)}e.isTargetPlatformCompatible=h;function l(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function R(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=R;var I;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var v;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var g;(function(f){f.Install="install",f.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var N;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(N||(e.InstallOperation=N={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var S;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var u;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class d extends Error{constructor(E,p){super(E),this.code=p,this.name=p}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,T.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class L{b(){return this.a||(this.a=new Promise((A,C)=>G(["node-vsce-sign"],async w=>A(w),C))),this.a}async verify(A,C,w){let h;try{h=await this.b()}catch{return!1}return h.verify(A,C,w)}}e.ExtensionSignatureVerificationService=L}),define(ne[61],re([0,1,14,9,98,13]),function(G,e,T,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(R,I,v,g,N,S){let u;try{await w(R,I,v,g,N,S)}catch(d){u=d}finally{u&&N.errorTransformer&&(u=N.errorTransformer(u)),typeof u<"u"&&v.error(u),v.end()}}e.readFileIntoStream=C;async function w(R,I,v,g,N,S){h(S);const u=await R.open(I,{create:!1});try{h(S);let d=0,f=0,E=N&&typeof N.length=="number"?N.length:void 0,p=T.VSBuffer.alloc(Math.min(N.bufferSize,typeof E=="number"?E:N.bufferSize)),b=N&&typeof N.position=="number"?N.position:0,t=0;do f=await R.read(u,b,p.buffer,t,p.byteLength-t),b+=f,t+=f,d+=f,typeof E=="number"&&(E-=f),t===p.byteLength&&(await v.write(g(p)),p=T.VSBuffer.alloc(Math.min(N.bufferSize,typeof E=="number"?E:N.bufferSize)),t=0);while(f>0&&(typeof E!="number"||E>0)&&h(S)&&l(d,N));if(t>0){let a=t;typeof E=="number"&&(a=Math.min(t,E)),v.write(g(p.slice(0,a)))}}catch(d){throw(0,A.ensureFileSystemProviderError)(d)}finally{await R.close(u)}}function h(R){if(R.isCancellationRequested)throw(0,L.canceled)();return!0}function l(R,I){if(typeof I?.limits?.size=="number"&&R>I.limits.size)throw(0,A.createFileSystemProviderError)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[115],re([0,1,5,163,2,12,164]),function(G,e,T,L,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class w extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new T.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new T.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=T.Event.None,this.c=new Map,this.f=!1}async watch(l){const R=this.i(l),I=R.filter(g=>{const N=this.c.get(g.path);return N?!(0,L.patternsEquals)(N.request.excludes,g.excludes)||!(0,L.patternsEquals)(N.request.includes,g.includes):!0}),v=Array.from(this.c.values()).filter(({request:g})=>!R.find(N=>N.path===g.path&&(0,L.patternsEquals)(N.excludes,g.excludes)&&(0,L.patternsEquals)(N.includes,g.includes))).map(({request:g})=>g.path);I.length&&this.j(`Request to start watching: ${I.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),v.length&&this.j(`Request to stop watching: ${v.join(",")}`);for(const g of v)this.h(g);for(const g of I)this.g(g)}g(l){const R=new C.NodeJSFileWatcherLibrary(l,v=>this.a.fire(v),v=>this.b.fire(v),this.f),I={request:l,instance:R};this.c.set(l.path,I)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const R=this.c.get(l);R&&(this.c.delete(l),R.instance.dispose())}i(l){const R=new Map;for(const I of l){const v=A.isLinux?I.path:I.path.toLowerCase();R.set(v,I)}return Array.from(R.values())}async setVerboseLogging(l){this.f=l;for(const[,R]of this.c)R.instance.setVerboseLogging(l)}j(l){this.f&&this.b.fire({type:"trace",message:this.k(l)})}k(l,R){return R?`[File Watcher (node.js)] ${l} (path: ${R.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=w}),define(ne[116],re([0,1,62,115]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends T.AbstractNonRecursiveWatcherClient{constructor(C,w,h){super(C,w,h),this.m()}l(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ne[117],re([0,1,16,57,83,62]),function(G,e,T,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class C extends A.AbstractUniversalWatcherClient{constructor(h,l,R){super(h,l,R),this.m()}l(h){const l=h.add(new k.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(l.onDidProcessExit(({code:R,signal:I})=>this.n(`terminated by itself with code ${R}, signal: ${I}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=C}),define(ne[63],re([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...k){this.a=new Map;for(const[A,C]of k)this.set(A,C)}set(k,A){const C=this.a.get(k);return this.a.set(k,A),C}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=T}),define(ne[118],re([0,1,8,9,2,48,113,10,63,165]),function(G,e,T,L,k,A,C,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class I extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class v{constructor(u=new h.ServiceCollection,d=!1,f,E=R){this.f=u,this.g=d,this.h=f,this.i=E,this.o=new Set,this.f.set(w.IInstantiationService,this),this._globalGraph=E?f?._globalGraph??new C.Graph(p=>p):void 0}createChild(u){return new v(u,this.g,this,this.i)}invokeFunction(u,...d){const f=N.traceInvocation(this.i,u);let E=!1;try{return u({get:b=>{if(E)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(b,f);if(!t)throw new Error(`[invokeFunction] unknown service '${b}'`);return t}},...d)}finally{E=!0,f.stop()}}createInstance(u,...d){let f,E;return u instanceof A.SyncDescriptor?(f=N.traceCreation(this.i,u.ctor),E=this.j(u.ctor,u.staticArguments.concat(d),f)):(f=N.traceCreation(this.i,u),E=this.j(u,d,f)),f.stop(),E}j(u,d=[],f){const E=w._util.getServiceDependencies(u).sort((t,a)=>t.index-a.index),p=[];for(const t of E){const a=this.m(t.id,f);a||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(a)}const b=E.length>0?E[0].index:d.length;if(d.length!==b){console.trace(`[createInstance] First service dependency of ${u.name} at position ${b+1} conflicts with ${d.length} static arguments`);const t=b-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,b)}return Reflect.construct(u,d.concat(p))}k(u,d){if(this.f.get(u)instanceof A.SyncDescriptor)this.f.set(u,d);else if(this.h)this.h.k(u,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const d=this.f.get(u);return!d&&this.h?this.h.l(u):d}m(u,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const f=this.l(u);return f instanceof A.SyncDescriptor?this.q(u,f,d.branch(u,!0)):(d.branch(u,!1),f)}q(u,d,f){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,d,f)}finally{this.o.delete(u)}}r(u,d,f){const E=new C.Graph(t=>t.id.toString());let p=0;const b=[{id:u,desc:d,_trace:f}];for(;b.length;){const t=b.pop();if(E.lookupOrInsertNode(t),p++>1e3)throw new I(E);for(const a of w._util.getServiceDependencies(t.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),n instanceof A.SyncDescriptor){const i={id:a.id,desc:n,_trace:t._trace.branch(a.id,!0)};E.insertEdge(t,i),b.push(i)}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new I(E);break}for(const{data:a}of t){if(this.l(a.id)instanceof A.SyncDescriptor){const i=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,i)}E.removeNode(a)}}return this.l(u)}s(u,d,f=[],E,p){if(this.f.get(u)instanceof A.SyncDescriptor)return this.t(u,d,f,E,p);if(this.h)return this.h.s(u,d,f,E,p);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(u,d,f=[],E,p){if(E){const b=new v(void 0,this.g,this,this.i);b.c=String(u);const t=new Map,a=new T.IdleValue(()=>{const n=b.j(d,f,p);for(const[i,r]of t){const o=n[i];if(typeof o=="function")for(const c of r)o.apply(n,c)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let c=t.get(i);return c||(c=new l.LinkedList,t.set(i,c)),(y,m,M)=>{const J=c.push([y,m,M]);return(0,k.toDisposable)(J)}}if(i in n)return n[i];const r=a.value;let o=r[i];return typeof o!="function"||(o=o.bind(r),n[i]=o),o},set(n,i,r){return a.value[i]=r,!0},getPrototypeOf(n){return d.prototype}})}else return this.j(d,f,p)}u(u,d){if(d&&console.warn(u),this.g)throw new Error(u)}}e.InstantiationService=v;var g;(function(S){S[S.None=0]="None",S[S.Creation=1]="Creation",S[S.Invocation=2]="Invocation",S[S.Branch=3]="Branch"})(g||(g={}));class N{static traceInvocation(u,d){return u?new N(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):N.c}static traceCreation(u,d){return u?new N(1,d.name):N.c}constructor(u,d){this.type=u,this.name=d,this.g=Date.now(),this.h=[]}branch(u,d){const f=new N(3,u.toString());return this.h.push([u,d,f]),f}stop(){const u=Date.now()-this.g;N.f+=u;let d=!1;function f(p,b){const t=[],a=new Array(p+1).join("	");for(const[n,i,r]of b.h)if(i&&r){d=!0,t.push(`${a}CREATES -> ${n}`);const o=f(p+1,r);o&&t.push(o)}else t.push(`${a}uses -> ${n}`);return t.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${N.f.toFixed(2)}ms)`];(u>2||d)&&N.all.add(E.join(`
`))}}e.Trace=N,N.all=new Set,N.c=new class extends N{constructor(){super(0,null)}stop(){}branch(){return this}},N.f=0});var te=this&&this.__param||function(G,e){return function(T,L){e(T,L,G)}};define(ne[64],re([0,1,23,2,12,100,20,10]),function(G,e,T,L,k,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function h(R){return R.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=h,e.ILanguagePackService=(0,w.createDecorator)("languagePackService");let l=e.LanguagePackBaseService=class extends L.Disposable{constructor(I){super(),this.c=I}async getAvailableLanguages(){const I=new T.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let v;try{v=await this.c.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const N=v.firstPage.filter(S=>S.properties.localizedLanguages?.length&&S.tags.some(u=>u.startsWith("lp-"))).map(S=>{const u=S.properties.localizedLanguages?.[0],d=h(S);return{...this.f(d,u,S),extensionId:S.identifier.id,galleryExtension:S}});return N.push(this.f("en","English")),N}f(I,v,g){const N=v??I;let S;if(N!==I&&(S=`(${I})`),I.toLowerCase()===k.language.toLowerCase()&&(S??="",S+=(0,A.localize)(0,null)),g?.installCount){S??="";const u=g.installCount;let d;u>1e6?d=`${Math.floor(u/1e5)/10}M`:u>1e3?d=`${Math.floor(u/1e3)}K`:d=String(u),S+=` $(cloud-download) ${d}`}return{id:I,label:N,description:S}}};e.LanguagePackBaseService=l=ve([te(0,C.IExtensionGalleryService)],l)}),define(ne[6],re([0,1,33,5,45,2,35,12,17,3,11,114,10]),function(G,e,T,L,k,A,C,w,h,l,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function g(){return new Date().toISOString()}function N(y){return(0,l.isNumber)(y)}e.isLogLevel=N;var S;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(S||(e.LogLevel=S={})),e.DEFAULT_LOG_LEVEL=S.Info;function u(y,m,M){switch(m){case S.Trace:y.trace(M);break;case S.Debug:y.debug(M);break;case S.Info:y.info(M);break;case S.Warning:y.warn(M);break;case S.Error:y.error(M);break;case S.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=u;function d(y,m=!1){let M="";for(let J=0;J<y.length;J++){let K=y[J];if(K instanceof Error&&(K=(0,T.toErrorMessage)(K,m)),typeof K=="object")try{K=JSON.stringify(K)}catch{}M+=(J>0?" ":"")+K}return M}class f extends A.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==S.Off&&this.b<=m}}e.AbstractLogger=f;class E extends f{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...M){this.f(S.Trace)&&this.g(S.Trace,d([m,...M],!0))}debug(m,...M){this.f(S.Debug)&&this.g(S.Debug,d([m,...M]))}info(m,...M){this.f(S.Info)&&this.g(S.Info,d([m,...M]))}warn(m,...M){this.f(S.Warning)&&this.g(S.Warning,d([m,...M]))}error(m,...M){if(this.f(S.Error))if(m instanceof Error){const J=Array.prototype.slice.call(arguments);J[0]=m.stack,this.g(S.Error,d(J))}else this.g(S.Error,d([m,...M]))}flush(){}}e.AbstractMessageLogger=E;class p extends f{constructor(m=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(m),this.g=!w.isWindows}trace(m,...M){this.f(S.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,m,...M):console.log(`[main ${g()}]`,m,...M))}debug(m,...M){this.f(S.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,m,...M):console.log(`[main ${g()}]`,m,...M))}info(m,...M){this.f(S.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,m,...M):console.log(`[main ${g()}]`,m,...M))}warn(m,...M){this.f(S.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,m,...M):console.warn(`[main ${g()}]`,m,...M))}error(m,...M){this.f(S.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,m,...M):console.error(`[main ${g()}]`,m,...M))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class b extends f{constructor(m=e.DEFAULT_LOG_LEVEL,M=!0){super(),this.g=M,this.setLevel(m)}trace(m,...M){this.f(S.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...M):console.log(m,...M))}debug(m,...M){this.f(S.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...M):console.log(m,...M))}info(m,...M){this.f(S.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...M):console.log(m,...M))}warn(m,...M){this.f(S.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...M):console.log(m,...M))}error(m,...M){this.f(S.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...M):console.error(m,...M))}dispose(){}flush(){}}e.ConsoleLogger=b;class t extends f{constructor(m,M=e.DEFAULT_LOG_LEVEL){super(),this.g=m,this.setLevel(M)}trace(m,...M){this.f(S.Trace)&&this.g.log(S.Trace,[this.h(m),...M])}debug(m,...M){this.f(S.Debug)&&this.g.log(S.Debug,[this.h(m),...M])}info(m,...M){this.f(S.Info)&&this.g.log(S.Info,[this.h(m),...M])}warn(m,...M){this.f(S.Warning)&&this.g.log(S.Warning,[this.h(m),...M])}error(m,...M){this.f(S.Error)&&this.g.log(S.Error,[this.h(m),...M])}h(m){return typeof m=="string"?m:(0,T.toErrorMessage)(m,this.f(S.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends f{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const M of this.g)M.setLevel(m);super.setLevel(m)}trace(m,...M){for(const J of this.g)J.trace(m,...M)}debug(m,...M){for(const J of this.g)J.debug(m,...M)}info(m,...M){for(const J of this.g)J.info(m,...M)}warn(m,...M){for(const J of this.g)J.warn(m,...M)}error(m,...M){for(const J of this.g)J.error(m,...M)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose()}}e.MultiplexLogger=a;class n extends A.Disposable{constructor(m,M,J){if(super(),this.h=m,this.j=M,this.b=new C.ResourceMap,this.c=this.B(new L.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeVisibility=this.g.event,J)for(const K of J)this.b.set(K.resource,{logger:void 0,info:K})}k(m){return(0,l.isString)(m)?[...this.b.values()].find(M=>M.info.id===m):this.b.get(m)}getLogger(m){return this.k(m)?.logger}createLogger(m,M){const J=this.l(m),K=(0,l.isString)(m)?m:M?.id??(0,k.hash)(J.toString()).toString(16);let ie=this.b.get(J)?.logger;const ue=M?.logLevel==="always"?S.Trace:M?.logLevel;ie||(ie=this.m(J,ue??this.getLogLevel(J)??this.h,{...M,id:K}));const Q={logger:ie,info:{resource:J,id:K,logLevel:ue,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(Q.info),this.b.set(J,Q),ie}l(m){return(0,l.isString)(m)?(0,h.joinPath)(this.j,`${m}.log`):m}setLogLevel(m,M){if(R.URI.isUri(m)){const J=m,K=M,ie=this.b.get(J);ie&&K!==ie.info.logLevel&&(ie.info.logLevel=K===this.h?void 0:K,ie.logger?.setLevel(K),this.b.set(ie.info.resource,ie),this.f.fire([J,K]))}else{this.h=m;for(const[J,K]of this.b.entries())this.b.get(J)?.info.logLevel===void 0&&K.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,M){const J=this.k(m);J&&M!==!J.info.hidden&&(J.info.hidden=!M,this.b.set(J.info.resource,J),this.g.fire([J.info.resource,M]))}getLogLevel(m){let M;return m&&(M=this.b.get(m)?.info.logLevel),M??this.h}registerLogger(m){const M=this.b.get(m.resource);M?M.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const M=this.b.get(m);M&&(M.logger&&M.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=n;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(m){}getLevel(){return S.Info}trace(m,...M){}debug(m,...M){}info(m,...M){}warn(m,...M){}error(m,...M){}critical(m,...M){}dispose(){}flush(){}}e.NullLogger=i;class r extends i{}e.NullLogService=r;function o(y){if(y.verbose)return S.Trace;if(typeof y.logLevel=="string"){const m=D(y.logLevel.toLowerCase());if(m!==void 0)return m}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function c(y){switch(y){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Off:return"off"}}e.LogLevelToString=c;function D(y){switch(y){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Error;case"off":return S.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new I.RawContextKey("logLevel",c(S.Info))}),define(ne[119],re([0,1,19,8,9,5,2,15,62,6]),function(G,e,T,L,k,A,C,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class R extends C.Disposable{constructor(v,g){super(),this.a=v,this.b=g,this.c=this.B(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new L.ThrottledDelayer(0)),this.s=[],this.t=this.B(new L.ThrottledDelayer(0))}watch(v,g){return g.recursive||this.b?.watcher?.forceUniversal?this.l(v,g):this.u(v,g)}l(v,g){const N={path:this.C(v),excludes:g.excludes,includes:g.includes,recursive:g.recursive},S=(0,T.insert)(this.j,N);return this.m(),(0,C.toDisposable)(()=>{S(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(v=>(0,k.onUnexpectedError)(v))}n(){this.h||(this.h=this.B(this.p(g=>this.c.fire((0,h.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const g of this.j)(0,h.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const g of this.j)(0,h.isRecursiveWatchRequest)(g)&&v.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(v,g){const N={path:this.C(v),excludes:g.excludes,includes:g.includes,recursive:!1},S=(0,T.insert)(this.s,N);return this.v(),(0,C.toDisposable)(()=>{S(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(v=>(0,k.onUnexpectedError)(v))}w(){return this.r||(this.r=this.B(this.y(v=>this.c.fire((0,h.toFileChanges)(v)),v=>this.z(v),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.r.watch(this.s)}z(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}C(v){return(0,w.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=R}),define(ne[120],re([0,1,19,8,14,23,5,45,65,2,55,16,121,17,44,97,13,61,6,9]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g,N,S,u,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=e.FileService=class extends l.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new C.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new C.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new C.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new L.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${t}`);const n=new l.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),n.add(a.onDidChangeFile(i=>this.R.fire(new u.FileChangesEvent(i,!this.O(a))))),typeof a.onDidWatchError=="function"&&n.add(a.onDidWatchError(i=>this.S.fire(new Error(i)))),n.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,l.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,l.dispose)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(n){a.push(n)}}),!this.h.has(t)&&await L.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&a)}listCapabilities(){return h.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,g.isAbsolutePath)(t))throw new u.FileOperationError((0,S.localize)(0,null,this.ob(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const n=new E.ErrorNoTelemetry;throw n.message=(0,S.localize)(1,null,t.toString()),n}return a}async k(t){const a=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(a)||(0,u.hasReadWriteCapability)(a)||(0,u.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(a)||(0,u.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(n){throw(0,u.toFileSystemProviderErrorCode)(n)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,S.localize)(2,null,this.ob(t)),1):(0,u.ensureFileSystemProviderError)(n)}}async n(t,a){const n=await this.j(t),i=this.O(n),r=a?.resolveTo,o=a?.resolveSingleChildDescendants,c=a?.resolveMetadata,D=await n.stat(t);let y;return this.p(n,t,D,void 0,!!c,(m,M)=>(y||(y=R.TernarySearchTree.forUris(()=>!i),y.set(t,!0),r&&y.fill(!0,r)),y.get(m.resource)||y.findSuperstr(m.resource.with({query:null,fragment:null}))?!0:m.isDirectory&&o?M===1:!1))}async p(t,a,n,i,r,o){const{providerExtUri:c}=this.N(t),D={resource:a,name:c.basename(a),isFile:(n.type&u.FileType.File)!==0,isDirectory:(n.type&u.FileType.Directory)!==0,isSymbolicLink:(n.type&u.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&u.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((n.permissions??0)&u.FilePermission.Locked),etag:(0,u.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(D.isDirectory&&o(D,i)){try{const y=await t.readdir(a),m=await L.Promises.settled(y.map(async([M,J])=>{try{const K=c.joinPath(a,M),ie=r?await t.stat(K):{type:J};return await this.p(t,K,ie,y.length,r,o)}catch(K){return this.b.trace(K),null}}));D.children=(0,T.coalesce)(m)}catch(y){this.b.trace(y),D.children=[]}return D}return D}async resolveAll(t){return L.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),n=await a.stat(t);return this.p(a,t,n,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(n){return n}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new u.FileOperationError((0,S.localize)(3,null,this.ob(t)),3,a)}async createFile(t,a=k.VSBuffer.fromString(""),n){await this.r(t,n);const i=await this.writeFile(t,a);return this.m.fire(new u.FileOperationEvent(t,0,i)),i}async writeFile(t,a,n){const i=this.mb(await this.l(t),t),{providerExtUri:r}=this.N(i);try{await this.s(i,t,n)||await this.P(i,r.dirname(t));let c;if((0,u.hasReadWriteCapability)(i)&&!(a instanceof k.VSBuffer))if((0,N.isReadableStream)(a)){const D=await(0,N.peekStream)(a,3);D.ended?c=k.VSBuffer.concat(D.buffer):c=D}else c=(0,N.peekReadable)(a,D=>k.VSBuffer.concat(D),3);else c=a;if(!(0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i)&&c instanceof k.VSBuffer)await this.db(i,t,n,c);else{const D=c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c;n?.atomic!==!1&&n?.atomic?.postfix?await this.Y(i,t,(0,g.joinPath)((0,g.dirname)(t),`${(0,g.basename)(t)}${n.atomic.postfix}`),n,D):await this.Z(i,t,n,D)}this.m.fire(new u.FileOperationEvent(t,4))}catch(o){throw new u.FileOperationError((0,S.localize)(4,null,this.ob(t),(0,u.ensureFileSystemProviderError)(o).toString()),(0,u.toFileOperationResult)(o),n)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,n){const i=!!n?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,S.localize)(5,null,this.ob(a)));if(!!n?.atomic){if(!(t.capabilities&32768))throw new Error((0,S.localize)(6,null,this.ob(a)));if(i)throw new Error((0,S.localize)(7,null,this.ob(a)))}let o;try{o=await t.stat(a)}catch{return}if(o.type&u.FileType.Directory)throw new u.FileOperationError((0,S.localize)(8,null,this.ob(a)),0,n);if(this.nb(a,o),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==u.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&n.mtime<o.mtime&&n.etag!==(0,u.etag)({mtime:n.mtime,size:o.size}))throw new u.FileOperationError((0,S.localize)(9,null),3,n);return o}async readFile(t,a,n){const i=await this.k(t);return a?.atomic?this.t(i,t,a,n):this.u(i,t,a,n)}async t(t,a,n,i){return new Promise((r,o)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const c=await this.u(t,a,n,i);r(c)}catch(c){o(c)}})})}async u(t,a,n,i){const r=await this.v(t,a,{...n,preferUnbuffered:!0},i);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(t,a,n){const i=await this.k(t);return this.v(i,t,a,n)}async v(t,a,n,i){const r=new A.CancellationTokenSource(i),o=this.F(a,n).then(D=>D,D=>{throw r.cancel(),D});let c;try{return typeof n?.etag=="string"&&n.etag!==u.ETAG_DISABLED&&await o,n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)||!((0,u.hasOpenReadWriteCloseCapability)(t)||(0,u.hasFileReadStreamCapability)(t))||(0,u.hasReadWriteCapability)(t)&&n?.preferUnbuffered?c=this.D(t,a,n):(0,u.hasFileReadStreamCapability)(t)?c=this.z(t,a,r.token,n):c=this.C(t,a,r.token,n),{...await o,value:c}}catch(D){throw c&&await(0,N.consumeStream)(c),this.w(D,a,n)}}w(t,a,n){const i=(0,S.localize)(10,null,this.ob(a),(0,u.ensureFileSystemProviderError)(t).toString());return t instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(i,t.stat,n):t instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new u.FileOperationError(i,(0,u.toFileOperationResult)(t),n)}z(t,a,n,i=Object.create(null)){const r=t.readFileStream(a,i,n);return(0,N.transform)(r,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>this.w(o,a,i)},o=>k.VSBuffer.concat(o))}C(t,a,n,i=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,d.readFileIntoStream)(t,a,r,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.w(o,a,i)},n),r}D(t,a,n){const i=(0,N.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)?r=await t.readFile(a,{atomic:!0}):r=await t.readFile(a),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.G(a,r.byteLength,n),i.end(k.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async F(t,a){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new u.FileOperationError((0,S.localize)(11,null,this.ob(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==u.ETAG_DISABLED&&a.etag===n.etag)throw new u.NotModifiedSinceFileOperationError((0,S.localize)(12,null),n,a);return this.G(t,n.size,a),n}G(t,a,n){if(typeof n?.limits?.size=="number"&&a>n.limits.size)throw new u.TooLargeFileOperationError((0,S.localize)(13,null,this.ob(t)),7,a,n)}async canMove(t,a,n){return this.H(t,a,"move",n)}async canCopy(t,a,n){return this.H(t,a,"copy",n)}async H(t,a,n,i){if(t.toString()!==a.toString())try{const r=n==="move"?this.mb(await this.l(t),t):await this.k(t),o=this.mb(await this.l(a),a);await this.M(r,t,o,a,n,i)}catch(r){return r}return!0}async move(t,a,n){const i=this.mb(await this.l(t),t),r=this.mb(await this.l(a),a),o=await this.I(i,t,r,a,"move",!!n),c=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,o==="move"?2:3,c)),c}async copy(t,a,n){const i=await this.k(t),r=this.mb(await this.l(a),a),o=await this.I(i,t,r,a,"copy",!!n),c=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,o==="copy"?3:2,c)),c}async I(t,a,n,i,r,o){if(a.toString()===i.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:D}=await this.M(t,a,n,i,r,o);if(c&&!D&&o&&await this.del(i,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(i)),r==="copy"){if(t===n&&(0,u.hasFileFolderCopyCapability)(t))await t.copy(a,i,{overwrite:o});else{const y=await this.resolve(a);y.isDirectory?await this.L(t,y,n,i):await this.J(t,a,n,i)}return r}else return t===n?(await t.rename(a,i,{overwrite:o}),r):(await this.I(t,a,n,i,"copy",o),await this.del(a,{recursive:!0}),"copy")}async J(t,a,n,i){if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.fb(t,a,n,i);if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.lb(t,a,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.jb(t,a,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.hb(t,a,n,i)}async L(t,a,n,i){await n.mkdir(i),Array.isArray(a.children)&&await L.Promises.settled(a.children.map(async r=>{const o=this.N(n).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),n,o):this.J(t,r.resource,n,o)}))}async M(t,a,n,i,r,o){let c=!1;if(t===n){const{providerExtUri:y,isPathCaseSensitive:m}=this.N(t);if(m||(c=y.isEqual(a,i)),c&&r==="copy")throw new Error((0,S.localize)(14,null,this.ob(a),this.ob(i)));if(!c&&y.isEqualOrParent(i,a))throw new Error((0,S.localize)(15,null,this.ob(a),this.ob(i)))}const D=await this.exists(i);if(D&&!c){if(!o)throw new u.FileOperationError((0,S.localize)(16,null,this.ob(a),this.ob(i)),4);if(t===n){const{providerExtUri:y}=this.N(t);if(y.isEqualOrParent(a,i))throw new Error((0,S.localize)(17,null,this.ob(a),this.ob(i)))}}return{exists:D,isSameResourceWithDifferentPathCase:c}}N(t){const a=this.O(t);return{providerExtUri:a?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.mb(await this.j(t),t);await this.P(a,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,0,n)),n}async P(t,a){const n=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(a,i.dirname(a));)try{if(!((await t.stat(a)).type&u.FileType.Directory))throw new Error((0,S.localize)(18,null,this.ob(a)));break}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(i.basename(a)),a=i.dirname(a)}for(let r=n.length-1;r>=0;r--){a=i.joinPath(a,n[r]);try{await t.mkdir(a)}catch(o){if((0,u.toFileSystemProviderErrorCode)(o)!==u.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,a){try{await this.Q(t,a)}catch(n){return n}return!0}async Q(t,a){const n=this.mb(await this.j(t),t),i=!!a?.useTrash;if(i&&!(n.capabilities&4096))throw new Error((0,S.localize)(19,null,this.ob(t)));const r=a?.atomic;if(r&&!(n.capabilities&65536))throw new Error((0,S.localize)(20,null,this.ob(t)));if(i&&r)throw new Error((0,S.localize)(21,null,this.ob(t)));let o;try{o=await n.stat(t)}catch{}if(o)this.nb(t,o);else throw new u.FileOperationError((0,S.localize)(22,null,this.ob(t)),1);if(!!!a?.recursive){const D=await this.resolve(t);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,S.localize)(23,null,this.ob(t)))}return n}async del(t,a){const n=await this.Q(t,a),i=!!a?.useTrash,r=!!a?.recursive,o=a?.atomic??!1;await n.delete(t,{recursive:r,useTrash:i,atomic:o}),this.m.fire(new u.FileOperationEvent(t,1))}async cloneFile(t,a){const n=await this.j(t),i=this.mb(await this.l(a),a);if(n===i&&this.N(n).providerExtUri.isEqual(t,a))return;if(n===i&&(0,u.hasFileCloneCapability)(n))return n.cloneFile(t,a);await this.P(i,this.N(i).providerExtUri.dirname(a));const r=this.X.queueFor(t,this.N(n).providerExtUri);return n===i&&(0,u.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(t,a,{overwrite:!0})):r.queue(()=>this.J(n,t,i,a))}watch(t,a={recursive:!1,excludes:[]}){const n=new l.DisposableStore;let i=!1,r=()=>{i=!0};return n.add((0,l.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(t,a);i?(0,l.dispose)(o):r=()=>(0,l.dispose)(o)}catch(o){this.b.error(o)}})(),n}async W(t,a){const n=await this.j(t),i=(0,w.hash)([this.N(n).providerExtUri.getComparisonKey(t),a]);let r=this.U.get(i);return r||(r={count:0,disposable:n.watch(t,a)},this.U.set(i,r)),r.count+=1,(0,l.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,l.dispose)(r.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,l.dispose)(t.disposable);this.U.clear()}async Y(t,a,n,i,r){await this.Z(t,n,i,r);try{await t.rename(n,a,{overwrite:!0})}catch(o){try{await t.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async Z(t,a,n,i){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(a,{create:!0,unlock:n?.unlock??!1});try{(0,N.isReadableStream)(i)||(0,N.isReadableBufferedStream)(i)?await this.ab(t,r,i):await this.bb(t,r,i)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await t.close(r)}})}async ab(t,a,n){let i=0,r;if((0,N.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=k.VSBuffer.concat(n.buffer);await this.cb(t,a,o,o.byteLength,i,0),i+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,c)=>{(0,N.listenStream)(r,{onData:async D=>{r.pause();try{await this.cb(t,a,D,D.byteLength,i,0)}catch(y){return c(y)}i+=D.byteLength,setTimeout(()=>r.resume())},onError:D=>c(D),onEnd:()=>o()})})}async bb(t,a,n){let i=0,r;for(;(r=n.read())!==null;)await this.cb(t,a,r,r.byteLength,i,0),i+=r.byteLength}async cb(t,a,n,i,r,o){let c=0;for(;c<i;){const D=await t.write(a,r+c,n.buffer,o+c,i-c);c+=D}}async db(t,a,n,i){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.eb(t,a,n,i))}async eb(t,a,n,i){let r;i instanceof k.VSBuffer?r=i:(0,N.isReadableStream)(i)?r=await(0,k.streamToBuffer)(i):(0,N.isReadableBufferedStream)(i)?r=await(0,k.bufferedStreamToBuffer)(i):r=(0,k.readableToBuffer)(i),await t.writeFile(a,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async fb(t,a,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.gb(t,a,n,i))}async gb(t,a,n,i){let r,o;try{r=await t.open(a,{create:!1}),o=await n.open(i,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.a);let D=0,y=0,m=0;do m=await t.read(r,D,c.buffer,y,c.byteLength-y),await this.cb(n,o,c,m,D,y),D+=m,y+=m,y===c.byteLength&&(y=0);while(m>0)}catch(c){throw(0,u.ensureFileSystemProviderError)(c)}finally{await L.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async hb(t,a,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.ib(t,a,n,i))}async ib(t,a,n,i){return n.writeFile(i,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async jb(t,a,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.kb(t,a,n,i))}async kb(t,a,n,i){const r=await n.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(a);await this.cb(n,r,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async lb(t,a,n,i){const r=await(0,k.streamToBuffer)(this.C(t,a,A.CancellationToken.None));await this.db(n,i,void 0,r)}mb(t,a){if(t.capabilities&2048)throw new u.FileOperationError((0,S.localize)(24,null,this.ob(a)),6);return t}nb(t,a){if((a.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,S.localize)(25,null,this.ob(t)),6)}ob(t){return t.scheme===I.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=p=ve([te(0,f.ILogService)],p)}),define(ne[122],re([0,1,123,166,8,35,14,5,167,2,15,12,17,44,22,99,13,61,119,33,117,116]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g,N,S,u,d,f,E,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(T)}catch(a){console.error(`Error enabling graceful-fs: ${(0,E.toErrorMessage)(a)}`)}})();class t extends f.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=w.Event.None,this.I=new A.ResourceMap(r=>v.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,I.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:i,symbolicLink:r}=await N.SymlinkSupport.stat(this.C(n));return{type:this.H(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:u.FilePermission.Locked}}catch(i){throw this.bb(i)}}async G(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await N.Promises.readdir(this.C(n),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,v.joinPath)(n,o.name))).type:c=this.H(o),r.push([o.name,c])}catch(c){this.a.trace(c)}})),r}catch(i){throw this.bb(i)}}H(n,i){let r;return i?.dangling?r=u.FileType.Unknown:n.isFile()?r=u.FileType.File:n.isDirectory()?r=u.FileType.Directory:r=u.FileType.Unknown,i&&(r|=u.FileType.SymbolicLink),r}async J(n){const i=this.C(n);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.I.get(n);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const o=new k.Barrier;return this.I.set(n,o),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.toDisposable)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.I.get(n)===o&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.I.delete(n)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(n,i){let r;try{i?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),r=await this.J(n));const o=this.C(n);return await N.Promises.readFile(o)}catch(o){throw this.bb(o)}finally{r?.dispose()}}L(n){t.D&&this.a.trace(n)}readFileStream(n,i,r){const o=(0,g.newWriteableStream)(c=>C.VSBuffer.concat(c.map(D=>C.VSBuffer.wrap(D))).buffer);return(0,d.readFileIntoStream)(this,n,o,c=>c.buffer,{...i,bufferSize:256*1024},r),o}async writeFile(n,i,r){return r?.atomic!==!1&&r?.atomic?.postfix?this.M(n,(0,v.joinPath)((0,v.dirname)(n),`${(0,v.basename)(n)}${r.atomic.postfix}`),i,r):this.N(n,i,r)}async M(n,i,r,o){await this.N(i,r,o);try{await this.rename(i,n,{overwrite:!0})}catch(c){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}async N(n,i,r){let o;try{const c=this.C(n);if(!r.create||!r.overwrite){if(await N.Promises.exists(c)){if(!r.overwrite)throw(0,u.createFileSystemProviderError)((0,S.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,u.createFileSystemProviderError)((0,S.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:r.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(c){throw await this.cb(n,c)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(n){t.R=n}async open(n,i){const r=this.C(n);let o;(0,u.isFileOpenForWriteOptions)(i)&&(o=await this.J(n));let c;try{if((0,u.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:y}=await N.SymlinkSupport.stat(r);y.mode&128||await N.Promises.chmod(r,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let D;if((0,u.isFileOpenForWriteOptions)(i)){if(I.isWindows)try{await N.Promises.truncate(r,0),D="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}D||(D="w")}else D="r";c=await N.Promises.open(r,D)}catch(D){throw o?.dispose(),(0,u.isFileOpenForWriteOptions)(i)?await this.cb(n,D):this.bb(D)}if(this.O.set(c,0),(0,u.isFileOpenForWriteOptions)(i)&&this.Q.set(c,n),o){const D=this.P.get(c);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${r})`),this.P.set(c,o),D&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${r})`),D.dispose())}return c}async close(n){const i=this.P.get(n);try{if(this.O.delete(n),this.Q.delete(n)&&t.R)try{await N.Promises.fdatasync(n)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await N.Promises.close(n)}catch(r){throw this.bb(r)}finally{i&&(this.P.get(n)===i&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.P.delete(n)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,r,o,c){const D=this.S(n,i);let y=null;try{y=(await N.Promises.read(n,r,o,c,D)).bytesRead}catch(m){throw this.bb(m)}finally{this.U(n,D,y)}return y}S(n,i){return i===this.O.get(n)?null:i}U(n,i,r){const o=this.O.get(n);typeof o=="number"&&(typeof i=="number"||(typeof r=="number"?this.O.set(n,o+r):this.O.delete(n)))}async write(n,i,r,o,c){return(0,k.retry)(()=>this.W(n,i,r,o,c),100,3)}async W(n,i,r,o,c){const D=this.S(n,i);let y=null;try{y=(await N.Promises.write(n,r,o,c,D)).bytesWritten}catch(m){throw await this.cb(this.Q.get(n),m)}finally{this.U(n,D,y)}return y}async mkdir(n){try{await N.Promises.mkdir(this.C(n))}catch(i){throw this.bb(i)}}async delete(n,i){try{const r=this.C(n);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,R.join)((0,R.dirname)(r),`${(0,R.basename)(r)}${i.atomic.postfix}`)),await N.Promises.rm(r,N.RimRafMode.MOVE,o)}else try{await N.Promises.unlink(r)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let c=!1;try{const{stat:D,symbolicLink:y}=await N.SymlinkSupport.stat(r);c=D.isDirectory()&&!y}catch{}if(c)await N.Promises.rmdir(r);else throw o}else throw o}}catch(r){throw this.bb(r)}}async rename(n,i,r){const o=this.C(n),c=this.C(i);if(o!==c)try{await this.X(n,i,"move",r.overwrite),await N.Promises.move(o,c)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,S.localize)(2,null,(0,R.basename)(o),(0,R.basename)((0,R.dirname)(c)),D.toString()))),this.bb(D)}}async copy(n,i,r){const o=this.C(n),c=this.C(i);if(o!==c)try{await this.X(n,i,"copy",r.overwrite),await N.Promises.copy(o,c,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,S.localize)(3,null,(0,R.basename)(o),(0,R.basename)((0,R.dirname)(c)),D.toString()))),this.bb(D)}}async X(n,i,r,o){const c=this.C(n),D=this.C(i);let y=!1;if(!!(this.capabilities&1024)||(y=(0,h.isEqual)(c,D,!0)),y){if(r==="copy")throw(0,u.createFileSystemProviderError)((0,S.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const M=await this.G(n);if(!M)throw(0,u.createFileSystemProviderError)((0,S.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const J=await this.G(i);if(J){if(!o)throw(0,u.createFileSystemProviderError)((0,S.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);M.type&u.FileType.File&&J.type&u.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.Y(n,i,!1)}async Y(n,i,r){const o=this.C(n),c=this.C(i),D=!!(this.capabilities&1024);if((0,h.isEqual)(o,c,!D))return;const y=new l.DisposableStore;try{const[m,M]=await Promise.all([this.J(n),this.J(i)]);y.add(m),y.add(M),r&&await N.Promises.mkdir((0,R.dirname)(c),{recursive:!0}),await N.Promises.copyFile(o,c)}catch(m){if(m.code==="ENOENT"&&!r)return this.Y(n,i,!0);throw this.bb(m)}finally{y.dispose()}}p(n,i,r){return new p.UniversalWatcherClient(o=>n(o),o=>i(o),r)}y(n,i,r){return new b.NodeJSWatcherClient(o=>n(o),o=>i(o),r)}bb(n){if(n instanceof u.FileSystemProviderError)return n;let i=n,r;switch(n.code){case"ENOENT":r=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=u.FileSystemProviderErrorCode.Unknown;break;default:r=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(i,r)}async cb(n,i){let r=this.bb(i);if(n&&r.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await N.SymlinkSupport.stat(this.C(n));o.mode&128||(r=(0,u.createFileSystemProviderError)(i,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return r}}e.DiskFileSystemProvider=t,t.D=!1,t.R=!0}),define(ne[124],re([0,1,2,6]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class k extends T.Disposable{constructor(C,w=[]){super(),this.a=new L.MultiplexLogger([C,...w]),this.B(C.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...w){this.a.trace(C,...w)}debug(C,...w){this.a.debug(C,...w)}info(C,...w){this.a.info(C,...w)}warn(C,...w){this.a.warn(C,...w)}error(C,...w){this.a.error(C,...w)}flush(){this.a.flush()}}e.LogService=k}),define(ne[125],re([0,1,13,6]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(k||(k={}));async function A(l,R,I,v,g){try{const N=await new Promise((u,d)=>{G(["@vscode/spdlog"],u,d)});N.setFlushOn(k.Trace);const S=await N.createAsyncRotatingLogger(l,R,I,v);return g?S.clearFormatters():S.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),S}catch(N){console.error(N)}return null}function C(l,R,I){switch(R){case L.LogLevel.Trace:l.trace(I);break;case L.LogLevel.Debug:l.debug(I);break;case L.LogLevel.Info:l.info(I);break;case L.LogLevel.Warning:l.warn(I);break;case L.LogLevel.Error:l.error(I);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function w(l,R){switch(R){case L.LogLevel.Trace:l.setLevel(k.Trace);break;case L.LogLevel.Debug:l.setLevel(k.Debug);break;case L.LogLevel.Info:l.setLevel(k.Info);break;case L.LogLevel.Warning:l.setLevel(k.Warning);break;case L.LogLevel.Error:l.setLevel(k.Error);break;case L.LogLevel.Off:l.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class h extends L.AbstractMessageLogger{constructor(R,I,v,g,N){super(),this.k=[],this.setLevel(N),this.l=this.n(R,I,v,g),this.B(this.onDidChangeLogLevel(S=>{this.m&&w(this.m,S)}))}async n(R,I,v,g){const N=v?6:1,S=30/N*T.ByteSize.MB,u=await A(R,I,S,N,g);if(u){this.m=u,w(this.m,this.getLevel());for(const{level:d,message:f}of this.k)C(this.m,d,f);this.k=[]}}g(R,I){this.m?C(this.m,R,I):this.getLevel()<=R&&this.k.push({level:R,message:I})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=h}),define(ne[126],re([0,1,28,6,125]),function(G,e,T,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends L.AbstractLoggerService{m(w,h,l){return new k.SpdLogLogger((0,T.generateUuid)(),w.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,h)}}e.LoggerService=A}),define(ne[38],re([0,1,5,65,2,10]),function(G,e,T,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class C extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new T.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const R=Object.keys(this.f).length;return this.f={...l,...this.f},R!==Object.keys(this.f).length&&await this.i(l),L.Iterable.reduce(this.g.entries(),(I,[v,g])=>({...I,[v]:g}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(l,[R,I])=>({...l,[R]:{definition:I,value:this.g.get(R)}}),{})}}e.AbstractPolicyService=C;class w{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=w}),define(ne[127],re([0,1,8,5,65,3,13,6,38]),function(G,e,T,L,k,A,C,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(I,v){const g=[];for(const N of new Set(k.Iterable.concat(I.keys(),v.keys())))I.get(N)!==v.get(N)&&g.push(N);return g}let R=e.FilePolicyService=class extends h.AbstractPolicyService{constructor(v,g,N){super(),this.j=v,this.k=g,this.l=N,this.c=this.B(new T.ThrottledDelayer(500));const S=L.Event.filter(g.onDidFilesChange,u=>u.affects(v));this.B(g.watch(v)),this.B(S(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const v=new Map;try{const g=await this.k.readFile(this.j),N=JSON.parse(g.value.toString());if(!(0,A.isObject)(N))throw new Error("Policy file isn't a JSON object");for(const S of Object.keys(N))this.f[S]&&v.set(S,N[S])}catch(g){g.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",g)}return v}async p(){const v=await this.n(),g=l(this.g,v);this.g=v,g.length>0&&this.h.fire(g)}};e.FilePolicyService=R=ve([te(1,C.IFileService),te(2,w.ILogService)],R)}),define(ne[128],re([0,1,38,8,168,2,6]),function(G,e,T,L,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let w=e.NativePolicyService=class extends T.AbstractPolicyService{constructor(l,R){super(),this.j=l,this.k=R,this.a=new L.Throttler,this.b=this.B(new A.MutableDisposable)}async i(l){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((R,I)=>{try{this.b.value=(0,k.createWatcher)(this.k,l,v=>{this.m(v),R()})}catch(v){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),I(v)}}))}m(l){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const R in l){const I=l[R];I===void 0?this.g.delete(R):this.g.set(R,I)}this.h.fire(Object.keys(l))}};e.NativePolicyService=w=ve([te(0,C.ILogService)],w)}),define(ne[31],re([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,70,3]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(C,w){T.ok(L.isString(C)),T.ok(L.isObject(w)),T.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,w)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new k}),define(ne[129],re([0,1,5,36]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class A{constructor(){this.b=new T.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,l){this.a[k(h)]=l,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const C=new A;L.Registry.add(e.Extensions.JSONContribution,C)}),define(ne[42],re([0,1,19,5,3,86,24,129,36]),function(G,e,T,L,k,A,C,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=h.Registry.as(w.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const n=new Set;this.n(t,a,n),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const a=new Set;this.o(t,a),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const n=new Set;this.o(a,n),this.n(t,!1,n),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const n=[];for(const{overrides:i,source:r}of t)for(const o in i)if(a.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const c=this.a.get(o),D=c?.valuesSources??new Map;if(r)for(const J of Object.keys(i[o]))D.set(J,r);const y={...c?.value||{},...i[o]};this.a.set(o,{source:r,value:y,valuesSources:D});const m=(0,C.getLanguageTagSettingPlainKey)(o),M={type:"object",default:y,description:A.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:y,source:k.isString(r)?void 0:r,defaultValueSource:r};n.push(...S(o)),this.d[o]=M,this.b.properties[o]=M}else{this.a.set(o,{value:i[o],source:r});const c=this.d[o];c&&(this.w(o,c),this.r(o,c))}this.m(n)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:n,source:i}of t)for(const r in n){const o=this.a.get(r),c=k.isString(i)?i:i?.id,D=k.isString(o?.source)?o?.source:o?.source?.id;if(c===D)if(a.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const y=this.d[r];y&&(this.w(r,y),this.r(r,y))}}this.u()}deltaConfiguration(t){let a=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,n){t.forEach(i=>{this.p(i,a,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(t,a){const n=i=>{if(i.properties)for(const r in i.properties){a.add(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.s(r,i.properties[r])}i.allOf?.forEach(r=>n(r))};for(const i of t){n(i);const r=this.c.indexOf(i);r!==-1&&this.c.splice(r,1)}}p(t,a=!0,n,i,r=3,o){r=k.isUndefinedOrNull(t.scope)?r:t.scope;const c=t.properties;if(c)for(const y in c){const m=c[y];if(a&&E(y,m)){delete c[y];continue}if(m.source=n,m.defaultDefaultValue=c[y].default,this.w(y,m),e.OVERRIDE_PROPERTY_REGEX.test(y)?m.scope=void 0:(m.scope=k.isUndefinedOrNull(m.scope)?r:m.scope,m.restricted=k.isUndefinedOrNull(m.restricted)?!!i?.includes(y):m.restricted),c[y].hasOwnProperty("included")&&!c[y].included){this.f[y]=c[y],delete c[y];continue}else this.d[y]=c[y],c[y].policy?.name&&this.e.set(c[y].policy.name,y);!c[y].deprecationMessage&&c[y].markdownDeprecationMessage&&(c[y].deprecationMessage=c[y].markdownDeprecationMessage),o.add(y)}const D=t.allOf;if(D)for(const y of D)this.p(y,a,n,i,r,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=n=>{const i=n.properties;if(i)for(const o in i)this.r(o,i[o]);n.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,n),e.allSettings.properties[a]=n,e.applicationSettings.properties[a]=n,e.machineSettings.properties[a]=n,e.machineOverridableSettings.properties[a]=n,e.windowSettings.properties[a]=n,e.resourceSettings.properties[a]=n}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const n=this.a.get(t);let i=n?.value,r=n?.source;k.isUndefined(i)&&(i=a.defaultDefaultValue,r=void 0),k.isUndefined(i)&&(i=d(a.type)),a.default=i,a.defaultValueSource=r}}const g="\\[([^\\]]+)\\]",N=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(b){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let a=N.exec(b);for(;a?.length;){const n=a[1].trim();n&&t.push(n),a=N.exec(b)}}return(0,T.distinct)(t)}e.overrideIdentifiersFromKey=S;function u(b){return b.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=u;function d(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const f=new v;h.Registry.add(e.Extensions.Configuration,f);function E(b,t){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?A.localize(7,null,b):f.getConfigurationProperties()[b]!==void 0?A.localize(8,null,b):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,b,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=E;function p(){const b=[],t=f.getConfigurationProperties();for(const a of Object.keys(t))b.push([a,t[a].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=p}),define(ne[66],re([0,1,19,5,52,2,35,30,3,11,24,42,36]),function(G,e,T,L,k,A,C,w,h,l,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function g(a){return Object.isFrozen(a)?a:w.deepFreeze(a)}class N{constructor(n={},i=[],r=[],o){this.b=n,this.c=i,this.d=r,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof N)return i;const r=new S("");return r.parseRaw(i),r.configurationModel});this.f=n.reduce((i,r)=>r===i?r:i.merge(r),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,R.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const r=this.rawConfiguration.getValue(n),o=i?this.rawConfiguration.getOverrideValue(n,i):void 0,c=i?this.rawConfiguration.override(i).getValue(n):r;return{value:r,override:o,merged:c}}getOverrideValue(n,i){const r=this.i(i);return r?n?(0,R.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const r of this.overrides)r.identifiers.includes(n)&&i.push(...r.keys);return T.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return T.distinct(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=w.deepClone(this.contents),r=w.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const D of n)if(c.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(i,D.contents);for(const y of D.overrides){const[m]=r.filter(M=>T.equals(M.identifiers,y.identifiers));m?(this.h(m.contents,y.contents),m.keys.push(...y.keys),m.keys=T.distinct(m.keys)):r.push(w.deepClone(y))}for(const y of D.keys)o.indexOf(y)===-1&&o.push(y)}return new N(i,o,r,c.every(D=>D instanceof N)?void 0:c)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[o];const D=i[o];D&&(typeof c=="object"&&typeof D=="object"?(c=w.deepClone(c),this.h(c,D)):c=D),r[o]=c}return new N(r,this.keys,this.overrides)}h(n,i){for(const r of Object.keys(i)){if(r in n&&h.isObject(n[r])&&h.isObject(i[r])){this.h(n[r],i[r]);continue}n[r]=w.deepClone(i[r])}}i(n){let i=null,r=null;const o=c=>{c&&(r?this.h(r,c):r=w.deepClone(c))};for(const c of this.overrides)T.equals(c.identifiers,[n])?i=c.contents:c.identifiers.includes(n)&&o(c.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,R.removeFromValueTree)(this.contents,n),I.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(r=>T.equals(r.identifiers,(0,I.overrideIdentifiersFromKey)(n))),1))}j(n,i,r){(0,R.addToValueTree)(this.contents,n,i,o=>console.error(o)),r=r||this.keys.indexOf(n)===-1,r&&this.keys.push(n),I.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,R.toValuesTree)(this.contents[n],o=>console.error(o))})}}e.ConfigurationModel=N;class S{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new N}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!h.isUndefinedOrNull(n)){const r=this.g(n);this.parseRaw(r,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:r,keys:o,overrides:c,restricted:D,hasExcludedProperties:y}=this.h(n,i);this.b=new N(r,o,c,y?[n]:void 0),this.c=D||[]}g(n){let i={},r=null,o=[];const c=[],D=[];function y(M){Array.isArray(o)?o.push(M):r!==null&&(o[r]=M)}const m={onObjectBegin:()=>{const M={};y(M),c.push(o),o=M,r=null},onObjectProperty:M=>{r=M},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const M=[];y(M),c.push(o),o=M,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:y,onError:(M,J,K)=>{D.push({error:M,offset:J,length:K})}};if(n)try{k.visit(n,m),i=o[0]||{}}catch(M){console.error(`Error while parsing settings file ${this.f}: ${M}`),this.d=[M]}return i}h(n,i){const r=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),o=this.i(n,r,!0,i);n=o.raw;const c=(0,R.toValuesTree)(n,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),D=Object.keys(n),y=this.j(n,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:c,keys:D,overrides:y,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(n,i,r,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:c};const D={},y=[];for(const m in n)if(I.OVERRIDE_PROPERTY_REGEX.test(m)&&r){const M=this.i(n[m],i,!1,o);D[m]=M.raw,c=c||M.hasExcludedProperties,y.push(...M.restricted)}else{const M=i[m],J=M?typeof M.scope<"u"?M.scope:3:void 0;M?.restricted&&y.push(m),(J===void 0||o.scopes===void 0||o.scopes.includes(J))&&!(o.skipRestricted&&M?.restricted)?D[m]=n[m]:c=!0}return{raw:D,restricted:y,hasExcludedProperties:c}}j(n,i){const r=[];for(const o of Object.keys(n))if(I.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const D in n[o])c[D]=n[o][D];r.push({identifiers:(0,I.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,i)})}return r}}e.ConfigurationModelParser=S;class u extends A.Disposable{constructor(n,i,r,o){super(),this.f=n,this.g=i,this.h=o,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.a=new S(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(L.Event.any(L.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new N}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=u;class d{constructor(n,i,r,o,c,D,y,m,M,J,K,ie,ue){this.a=n,this.b=i,this.c=r,this.overrideIdentifiers=o,this.d=c,this.f=D,this.g=y,this.h=m,this.i=M,this.j=J,this.k=K,this.l=ie,this.m=ue}get value(){return g(this.c)}n(n,i,r){const o=n.inspect(i,r);return{get value(){return g(o.value)},get override(){return g(o.override)},get merged(){return g(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(n,i,r,o,c=new N,D=new N,y=new C.ResourceMap,m=new N,M=new C.ResourceMap){this.c=n,this.d=i,this.f=r,this.g=o,this.h=c,this.i=D,this.j=y,this.l=m,this.m=M,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(n,i,r){return this.q(n,i,r).getValue(n)}updateValue(n,i,r={}){let o;r.resource?(o=this.m.get(r.resource),o||(o=new N,this.m.set(r.resource,o))):o=this.l,i===void 0?o.removeValue(n):o.setValue(n,i),r.resource||(this.a=null)}inspect(n,i,r){const o=this.q(n,i,r),c=this.u(i.resource,r),D=i.resource?this.m.get(i.resource)||this.l:this.l,y=new Set;for(const m of o.overrides)for(const M of m.identifiers)o.getOverrideValue(n,M)!==void 0&&y.add(M);return new d(n,i,o.getValue(n),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,c||void 0,D)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const r=[];if(!i){const{added:o,updated:c,removed:D}=b(this.c,n);i=[...o,...c,...D]}for(const o of i)for(const c of(0,I.overrideIdentifiersFromKey)(o)){const D=this.c.getKeysForOverrideIdentifier(c),y=n.getKeysForOverrideIdentifier(c),m=[...y.filter(M=>D.indexOf(M)===-1),...D.filter(M=>y.indexOf(M)===-1),...D.filter(M=>!w.equals(this.c.override(c).getValue(M),n.override(c).getValue(M)))];r.push([c,m])}return this.updateDefaultConfiguration(n),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:r,removed:o}=b(this.d,n),c=[...i,...r,...o];return c.length&&this.updatePolicyConfiguration(n),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=b(this.applicationConfiguration,n),D=[...i,...r,...o];return D.length&&this.updateApplicationConfiguration(n),{keys:D,overrides:c}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=b(this.localUserConfiguration,n),D=[...i,...r,...o];return D.length&&this.updateLocalUserConfiguration(n),{keys:D,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=b(this.remoteUserConfiguration,n),D=[...i,...r,...o];return D.length&&this.updateRemoteUserConfiguration(n),{keys:D,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=b(this.workspaceConfiguration,n),D=[...i,...r,...o];return D.length&&this.updateWorkspaceConfiguration(n),{keys:D,overrides:c}}compareAndUpdateFolderConfiguration(n,i){const r=this.p.get(n),{added:o,updated:c,removed:D,overrides:y}=b(r,i),m=[...o,...c,...D];return(m.length||!r)&&this.updateFolderConfiguration(n,i),{keys:m,overrides:y}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:c,overrides:D}=b(i,void 0);return{keys:[...r,...o,...c],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,r){let o=this.r(i,r);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(o=o.merge(this.d)),o}r({resource:n},i){let r=this.s();if(i&&n){const o=i.getFolder(n);o&&(r=this.t(o.uri)||r);const c=this.m.get(n);c&&(r=r.merge(c))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const r=this.s(),o=this.j.get(n);o?(i=r.merge(o),this.b.set(n,i)):i=r}return i}u(n,i){if(i&&n){const r=i.getFolder(n);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:r,overrides:o,keys:c}=this.j.get(i);return n.push([i,{contents:r,overrides:o,keys:c}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(r=>n.add(r))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.i.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o))),[...i.values()]}static parse(n){const i=this.x(n.defaults),r=this.x(n.policy),o=this.x(n.application),c=this.x(n.user),D=this.x(n.workspace),y=n.folders.reduce((m,M)=>(m.set(l.URI.revive(M[0]),this.x(M[1])),m),new C.ResourceMap);return new f(i,r,o,c,new N,D,y,new N,new C.ResourceMap)}static x(n){return new N(n.contents,n.keys,n.overrides)}}e.Configuration=f;function E(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,i=new Map;for(const o of a)o.keys.forEach(c=>n.add(c)),o.overrides.forEach(([c,D])=>{const y=(0,C.getOrSet)(i,c,new Set);D.forEach(m=>y.add(m))});const r=[];return i.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=E;class p{constructor(n,i,r,o){this.change=n,this.f=i,this.g=r,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of n.keys)this.affectedKeys.add(c);for(const[,c]of n.overrides)for(const D of c)this.affectedKeys.add(D);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(n,i){const r=this.a+n,o=this.d.indexOf(r);if(o<0)return!1;const c=o+r.length;if(c>=this.d.length)return!1;const D=this.d.charCodeAt(c);if(D!==this.b&&D!==this.c)return!1;if(i){const y=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,m=this.g.getValue(n,i,this.h);return!w.equals(y,m)}return!0}}e.ConfigurationChangeEvent=p;function b(a,n){const{added:i,removed:r,updated:o}=t(n?.rawConfiguration,a?.rawConfiguration),c=[],D=a?.getAllOverrideIdentifiers()||[],y=n?.getAllOverrideIdentifiers()||[];if(n){const m=y.filter(M=>!D.includes(M));for(const M of m)c.push([M,n.getKeysForOverrideIdentifier(M)])}if(a){const m=D.filter(M=>!y.includes(M));for(const M of m)c.push([M,a.getKeysForOverrideIdentifier(M)])}if(n&&a){for(const m of D)if(y.includes(m)){const M=t({contents:a.getOverrideValue(void 0,m)||{},keys:a.getKeysForOverrideIdentifier(m)},{contents:n.getOverrideValue(void 0,m)||{},keys:n.getKeysForOverrideIdentifier(m)});c.push([m,[...M.added,...M.removed,...M.updated]])}}return{added:i,removed:r,updated:o,overrides:c}}function t(a,n){const i=a?n?a.keys.filter(c=>n.keys.indexOf(c)===-1):[...a.keys]:[],r=n?a?n.keys.filter(c=>a.keys.indexOf(c)===-1):[...n.keys]:[],o=[];if(a&&n){for(const c of n.keys)if(a.keys.indexOf(c)!==-1){const D=(0,R.getConfigurationValue)(n.contents,c),y=(0,R.getConfigurationValue)(a.contents,c);w.equals(D,y)||o.push(c)}}return{added:i,removed:r,updated:o}}}),define(ne[130],re([0,1,19,5,2,30,3,66,42,6,38,36]),function(G,e,T,L,k,A,C,w,h,l,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class v extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new w.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(I.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:d})=>this.c(Array.from(u),d))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(u,d){this.h(u,I.Registry.as(h.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:u})}f(){return{}}g(){this.b=new w.ConfigurationModel;const u=I.Registry.as(h.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(u),u)}h(u,d){const f=this.f();for(const E of u){const p=f[E],b=d[E];p!==void 0?this.b.addValue(E,p):b?this.b.addValue(E,b.default):this.b.removeValue(E)}}}e.DefaultConfiguration=v;class g{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let N=e.PolicyConfiguration=class extends k.Disposable{get configurationModel(){return this.b}constructor(u,d,f){super(),this.c=u,this.f=d,this.g=f,this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new w.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(u=>this.i(u))),this.B(this.c.onDidChangeConfiguration(async({properties:u})=>this.j(await this.h(u),!0))),this.b}async h(u){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",u);const d={},f=[],E=I.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const p of u){const b=E[p];if(!b){f.push(p);continue}if(b.policy){if(b.type!=="string"&&b.type!=="number"){this.g.warn(`Policy ${b.policy.name} has unsupported type ${b.type}`);continue}f.push(p),d[b.policy.name]={type:b.type}}}return(0,C.isEmptyObject)(d)||await this.f.updatePolicyDefinitions(d),f}i(u){this.g.trace("PolicyConfiguration#onDidChangePolicies",u);const d=I.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),f=(0,T.coalesce)(u.map(E=>d.get(E)));this.j(f,!0)}j(u,d){this.g.trace("PolicyConfiguration#update",u);const f=I.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),E=[],p=this.b.isEmpty();for(const b of u){const t=f[b]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(p?a!==void 0:!(0,A.equals)(this.b.getValue(b),a))&&E.push([b,a])}else this.b.getValue(b)!==void 0&&E.push([b,void 0])}if(E.length){this.g.trace("PolicyConfiguration#changed",E);const b=this.b;this.b=new w.ConfigurationModel;for(const t of b.keys)this.b.setValue(t,b.getValue(t));for(const[t,a]of E)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);d&&this.a.fire(this.b)}}};e.PolicyConfiguration=N=ve([te(1,R.IPolicyService),te(2,l.ILogService)],N)}),define(ne[131],re([0,1,8,5,2,17,24,66,130,38]),function(G,e,T,L,k,A,C,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends k.Disposable{constructor(v,g,N,S){super(),this.i=v,this.h=this.B(new L.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.DefaultConfiguration),this.c=N instanceof l.NullPolicyService?new h.NullPolicyConfiguration:this.B(new h.PolicyConfiguration(this.b,N,S)),this.f=this.B(new w.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,g)),this.a=new w.Configuration(this.b.configurationModel,this.c.configurationModel,new w.ConfigurationModel,new w.ConfigurationModel),this.g=this.B(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:u,properties:d})=>this.k(u,d))),this.B(this.c.onDidChangeConfiguration(u=>this.l(u))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,g,N]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new w.Configuration(v,g,new w.ConfigurationModel,N)}getConfigurationData(){return this.a.toData()}getValue(v,g){const N=typeof v=="string"?v:void 0,S=(0,C.isConfigurationOverrides)(v)?v:(0,C.isConfigurationOverrides)(g)?g:{};return this.a.getValue(N,S,void 0)}updateValue(v,g,N,S){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.j(v)}j(v){const g=this.a.toData(),N=this.a.compareAndUpdateLocalUserConfiguration(v);this.m(N,g,2)}k(v,g){const N=this.a.toData(),S=this.a.compareAndUpdateDefaultConfiguration(v,g);this.m(S,N,7)}l(v){const g=this.a.toData(),N=this.a.compareAndUpdatePolicyConfiguration(v);this.m(N,g,7)}m(v,g,N){const S=new w.ConfigurationChangeEvent(v,{data:g},this.a);S.source=N,S.sourceConfig=this.n(N),this.h.fire(S)}n(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(ne[67],re([0,1,16]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(l){return l.scheme===T.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=L;function k(l){if(!l)return;const R=l.indexOf("+");return R<0?l:l.substr(0,R)}e.getRemoteName=k;function A(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=A;function C(l){const{host:R,port:I}=h(l);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:I}}e.parseAuthorityWithPort=C;function w(l,R){let{host:I,port:v}=h(l);return typeof v>"u"&&(v=R),{host:I,port:v}}e.parseAuthorityWithOptionalPort=w;function h(l){const R=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const I=l.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const v=l.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:l,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(G,e,T,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(C||(e.ExtensionType=C={}));var w;(function(S){S.WIN32_X64="win32-x64",S.WIN32_IA32="win32-ia32",S.WIN32_ARM64="win32-arm64",S.LINUX_X64="linux-x64",S.LINUX_ARM64="linux-arm64",S.LINUX_ARMHF="linux-armhf",S.ALPINE_X64="alpine-x64",S.ALPINE_ARM64="alpine-arm64",S.DARWIN_X64="darwin-x64",S.DARWIN_ARM64="darwin-arm64",S.WEB="web",S.UNIVERSAL="universal",S.UNKNOWN="unknown",S.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class h{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,d){if(typeof u>"u"||u===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof u=="string"||typeof d=="string"){const f=typeof u=="string"?u:u.value,E=typeof d=="string"?d:d.value;return T.equalsIgnoreCase(f,E)}return u._lower===d._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.ExtensionIdentifier=h;class l{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const d of u)this.add(d)}add(u){this.c.add(h.toKey(u))}delete(u){return this.c.delete(h.toKey(u))}has(u){return this.c.has(h.toKey(u))}}e.ExtensionIdentifierSet=l;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(h.toKey(u))}get(u){return this.c.get(h.toKey(u))}has(u){return this.c.has(h.toKey(u))}set(u,d){this.c.set(h.toKey(u),d)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function I(S){return v(S)}e.isApplicationScopedExtension=I;function v(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function g(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=g;function N(S,u){if(u){const d=`onResolveRemoteAuthority:${(0,k.getRemoteName)(u)}`;return!!S.activationEvents?.includes(d)}return!1}e.isResolverExtension=N,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[132],re([0,1,2,37,13]),function(G,e,T,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends T.Disposable{constructor(w,h,l,R,I){super(),this.a=w,this.b=h,this.c=l,this.f=I,this.B(R.onDidInstallExtensions(v=>this.g(v))),this.B(R.onDidUninstallExtension(v=>this.h(v)))}g(w){for(const h of w)h.local&&this.invalidate(h.profileLocation)}h(w){w.error||this.invalidate(w.profileLocation)}async invalidate(w){if(w)for(const h of this.a.profiles)this.c.extUri.isEqual(h.extensionsResource,w)&&await this.i(h);else await this.i(this.a.defaultProfile)}async i(w){try{await this.b.del(this.c.extUri.joinPath(w.cacheHome,L.USER_MANIFEST_CACHE_FILE))}catch(h){(0,k.toFileOperationResult)(h)!==1&&this.f.error(h)}}}e.ExtensionsManifestCache=A}),define(ne[43],re([0,1,14,9,2,101,42,10,6,36]),function(G,e,T,L,k,A,C,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,w.createDecorator)("requestService");class R{constructor(b){this.b=b}toJSON(){if(!this.a){const b=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?b[t]="*****":b[t]=this.b[t];this.a=b}return this.a}}class I extends k.Disposable{constructor(b){super(),this.b=0,this.a=b.createLogger("network",{name:(0,A.localize)(0,null),when:h.CONTEXT_LOG_LEVEL.isEqualTo((0,h.LogLevelToString)(h.LogLevel.Trace)).serialize()})}async c(b,t,a){const n=`${b} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new R(t.headers??{}));try{const i=await a();return this.a.trace(`${n} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,t.type,(0,L.getErrorMessage)(i)),i}}}e.AbstractRequestService=I;function v(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=v;function g(p){return p.res.statusCode===204}async function N(p){return g(p)?null:(await(0,T.streamToBuffer)(p.stream)).toString()}e.asText=N;async function S(p){if(!v(p))throw new Error("Server returned "+p.res.statusCode);return N(p)}e.asTextOrError=S;async function u(p){if(!v(p))throw new Error("Server returned "+p.res.statusCode);if(g(p))return null;const t=(await(0,T.streamToBuffer)(p.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.asJson=u;function d(p){E(p)}e.updateProxyConfigurationsScope=d;let f;function E(p){const b=l.Registry.as(C.Extensions.Configuration),t=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(5,null),(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null)],default:"override",description:(0,A.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(10,null),restricted:!0}}},b.updateConfigurations({add:[f],remove:t?[t]:[]})}E(1)}),define(ne[133],re([0,1,23,16,13,43]),function(G,e,T,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let C=e.DownloadService=class{constructor(h,l){this.a=h,this.b=l}async download(h,l,R=T.CancellationToken.None){if(h.scheme===L.Schemas.file||h.scheme===L.Schemas.vscodeRemote){await this.b.copy(h,l);return}const I={type:"GET",url:h.toString(!0)},v=await this.a.request(I,R);if(v.res.statusCode===200)await this.b.writeFile(l,v.stream);else{const g=await(0,A.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${g}`)}}};e.DownloadService=C=ve([te(0,A.IRequestService),te(1,k.IFileService)],C)}),define(ne[134],re([0,1,135,3]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(C,w){return C.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:C.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function A(C,w,h={}){const l=(0,T.parse)(C),R=h.proxyUrl||k(l,w);if(!R)return null;const I=(0,T.parse)(R);if(!/^https?:$/.test(I.protocol||""))return null;const v={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,L.isBoolean)(h.strictSSL)?h.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((g,N)=>{G(["http-proxy-agent"],g,N)}))(v):new(await new Promise((g,N)=>{G(["https-proxy-agent"],g,N)}))(v)}e.getProxyAgent=A}),define(ne[136],re([0,1,58,15,102,23,33,9,12,28,82,169,8,71]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let N;async function S(d,f,E,p){return E["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(p)&&!E["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(p)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),N||(N=v.Promises.withAsyncBody(async(b,t)=>{const a=new A.CancellationTokenSource;let n=1e4;const i=d.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(n=(0,g.clamp)(i,1,120)*1e3);const r=setTimeout(()=>{a.dispose(!0),t(new Error((0,k.localize)(0,null)))},n);try{b(await u(f,a.token))}catch(o){!(0,w.isCancellationError)(o)&&!a.token.isCancellationRequested?t(new Error((0,k.localize)(1,null,(0,C.toErrorMessage)(o)))):b({})}finally{clearTimeout(r),a.dispose()}})),N)}e.getResolvedShellEnv=S;async function u(d,f){const E=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",E);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",p);const b=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(b+"({.*})"+b),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",a);const n=await(0,R.getSystemShell)(h.OS,a);return d.trace("getUnixShellEnvironment#shell",n),new Promise((i,r)=>{if(f.isCancellationRequested)return r(new w.CancellationError);const o=(0,L.basename)(n);let c,D;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${y} -p '''${b}'' + JSON.stringify(process.env) + ''${b}'''`,D=["-Login","-Command"]):o==="nu"?(c=`^'${process.execPath}' ${y} -p '"${b}" + JSON.stringify(process.env) + "${b}"'`,D=["-i","-l","-c"]):(c=`'${process.execPath}' ${y} -p '"${b}" + JSON.stringify(process.env) + "${b}"'`,o==="tcsh"||o==="csh"?D=["-ic"]:D=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),c);const m=(0,T.spawn)(n,[...D,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});f.onCancellationRequested(()=>(m.kill(),r(new w.CancellationError))),m.on("error",K=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(K)),r(K)});const M=[];m.stdout.on("data",K=>M.push(K));const J=[];m.stderr.on("data",K=>J.push(K)),m.on("close",(K,ie)=>{const ue=Buffer.concat(M).toString("utf8");d.trace("getUnixShellEnvironment#raw",ue);const Q=Buffer.concat(J).toString("utf8");if(Q.trim()&&d.trace("getUnixShellEnvironment#stderr",Q),K||ie)return r(new Error((0,k.localize)(2,null,K,ie)));const ce=t.exec(ue),oe=ce?ce[1]:"{}";try{const se=JSON.parse(oe);E?se.ELECTRON_RUN_AS_NODE=E:delete se.ELECTRON_RUN_AS_NODE,p?se.ELECTRON_NO_ATTACH_CONSOLE=p:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",se),i(se)}catch(se){d.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(se)),r(se)}})})}}),define(ne[137],re([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,T.createDecorator)("stateReadService"),e.IStateService=(0,T.createDecorator)("stateService")}),define(ne[68],re([0,1,8,14,3,18,13,6]),function(G,e,T,L,k,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var h;(function(v){v[v.IMMEDIATE=0]="IMMEDIATE",v[v.DELAYED=1]="DELAYED"})(h||(e.SaveStrategy=h={}));class l{constructor(g,N,S,u){this.f=g,this.g=S,this.h=u,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=N===0?void 0:new T.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(g){g.fileOperationResult!==1&&this.g.error(g)}}getItem(g,N){const S=this.a[g];return(0,k.isUndefinedOrNull)(S)?N:S}setItem(g,N){this.setItems([{key:g,data:N}])}setItems(g){let N=!1;for(const{key:S,data:u}of g)this.a[S]!==u&&((0,k.isUndefinedOrNull)(u)?(0,k.isUndefined)(this.a[S])||(this.a[S]=void 0,N=!0):(this.a[S]=u,N=!0));N&&this.j()}removeItem(g){(0,k.isUndefined)(this.a[g])||(this.a[g]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const g=JSON.stringify(this.a,null,4);if(g!==this.b)try{await this.h.writeFile(this.f,L.VSBuffer.fromString(g),{atomic:{postfix:".vsctmp"}}),this.b=g}catch(N){this.g.error(N)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=l;let R=e.StateReadonlyService=class{constructor(g,N,S,u){this.a=new l(N.stateResource,g,S,u)}async init(){await this.a.init()}getItem(g,N){return this.a.getItem(g,N)}};e.StateReadonlyService=R=ve([te(1,A.IEnvironmentService),te(2,w.ILogService),te(3,C.IFileService)],R);class I extends R{setItem(g,N){this.a.setItem(g,N)}setItems(g){this.a.setItems(g)}removeItem(g){this.a.removeItem(g)}close(){return this.a.close()}}e.StateService=I}),define(ne[69],re([0,1,12,34,28]),function(G,e,T,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(h){if(T.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function C(h,l,R,I,v,g,N,S){const u=Object.create(null);u["common.machineId"]=g,u.sessionID=(0,k.generateUuid)()+Date.now(),u.commitHash=I,u.version=v,u["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,T.PlatformToString)(T.platform),u["common.nodePlatform"]=L.platform,u["common.nodeArch"]=R,u["common.product"]=S||"desktop",N&&(u["common.msftInternal"]=N);let d=0;const f=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),T.isLinuxSnap&&(u["common.snap"]="true");const E=A(l);return E&&(u["common.platformDetail"]=E),u}e.resolveCommonProperties=C;function w(h){const l=L.env.USERDNSDOMAIN;if(!l)return!1;const R=l.toLowerCase();return h.some(I=>R===I)}e.verifyMicrosoftInternalDomain=w}),define(ne[25],re([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(ne[39],re([0,1,30,3,5,24,67,69,25]),function(G,e,T,L,k,A,C,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class l{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=l;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=R,e.NullTelemetryService=new R;class I{async publicLog(r,o,c){}async publicLogError(r,o,c){}}e.NullEndpointTelemetryService=I,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,r){return k.Event.debounce(r.onDidChangeConfiguration,(c,D)=>{const y=c?new Set([...c.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:y}},1e3,!0)(c=>{c.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=v;function g(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=g;function N(i,r){return!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=N;function S(i){const r=i.getValue(h.TELEMETRY_SETTING_ID),o=i.getValue(h.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(h.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function u(i){const r={},o={},c={};E(i,c);for(let D in c){D=D.length>150?D.substr(D.length-149):D;const y=c[D];typeof y=="number"?o[D]=y:typeof y=="boolean"?o[D]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${y.length}`),r[D]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(r[D]=y)}return{properties:r,measurements:o}}e.validateTelemetryData=u;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(i){if(!i)return"none";const r=(0,C.getRemoteName)(i);return d.has(r)?r:"other"}e.cleanRemoteAuthority=f;function E(i,r,o=0,c){if(i)for(const D of Object.getOwnPropertyNames(i)){const y=i[D],m=c?c+D:D;Array.isArray(y)?r[m]=(0,T.safeStringify)(y):y instanceof Date?r[m]=y.toISOString():(0,L.isObject)(y)?o<2?E(y,r,o+1,m+"."):r[m]=(0,T.safeStringify)(y):r[m]=y}}function p(i,r){const o=i.msftInternalDomains||[],c=r.getValue("telemetry.internalTesting");return(0,w.verifyMicrosoftInternalDomain)(o)||c}e.isInternalTelemetry=p;function b(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=b;function t(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const c=[];for(const M of r)for(;;){const J=M.exec(i);if(!J)break;c.push([J.index,M.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(o="";;){const M=y.exec(i);if(!M)break;const J=c.some(([K,ie])=>M.index<ie&&K<y.lastIndex);!D.test(M[0])&&!J&&(o+=i.substring(m,M.index)+"<REDACTED: user-file-path>",m=y.lastIndex)}return m<i.length&&(o+=i.substr(m)),o}function a(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of r)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function n(i,r){return(0,T.cloneAndChange)(i,o=>{if(o instanceof l||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let c=o.replaceAll("%20"," ");c=t(c,r);for(const D of r)c=c.replace(D,"");return c=a(c),c}})}e.cleanData=n}),define(ne[26],re([0,1,29,20,37,12,11,9,34,39]),function(G,e,T,L,k,A,C,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,T.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=R;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const r=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,r,o)}static parse(i){const r=I.exec(i);return r&&r[1]&&r[2]?new v({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?R(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=v;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function N(n){const i=g.exec(n);return i&&i[1]?[u(i[1]),i[2]]:[u(n),void 0]}e.getIdAndVersion=N;function S(n,i){return`${n}.${i}`}e.getExtensionId=S;function u(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=u;function d(n,i){return u(S(n??k.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=d;function f(n,i){const r=[],o=c=>{for(const D of r)if(D.some(y=>R(i(y),i(c))))return D;return null};for(const c of n){const D=o(c);D?D.push(c):r.push([c])}return r}e.groupByExtension=f;function E(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function p(n){return{id:new l.TelemetryTrustedValue(n.identifier.id),name:new l.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function b(n,i){const r=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(D=>!R(D.identifier,{id:c}))){const D=n.filter(y=>R(y.identifier,{id:c}));D.length===1&&(r.push(D[0]),o.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=b;async function t(n,i){if(!A.isLinux)return!1;let r;try{r=(await n.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,w.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,i){const r=await t(n,i),o=(0,L.getTargetPlatform)(r?"alpine":A.platform,h.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=a}),define(ne[138],re([0,1,23,9,16,17,41,11,91,20,26,37]),function(G,e,T,L,k,A,C,w,h,l,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const v=u=>(0,h.localize)(0,null,u),g=(0,h.localize)(1,null,"ms-dotnettools.csharp");function N(u,d){return d?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let S=e.ExtensionManagementCLI=class{constructor(d,f,E){this.a=d,this.b=f,this.d=E}get f(){}async listExtensions(d,f,E){let p=await this.b.getInstalled(1,E);const b=I.EXTENSION_CATEGORIES.map(a=>a.toLowerCase());if(f&&f!==""){if(b.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(a=>a.manifest.categories?a.manifest.categories.map(i=>i.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),b.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,h.localize)(2,null,this.f)),p=p.sort((a,n)=>a.identifier.id.localeCompare(n.identifier.id));let t;for(const a of p)t!==a.identifier.id&&(t=a.identifier.id,this.a.info(N(a.manifest,d)))}async installExtensions(d,f,E,p){const b=[];try{const t=[];d.length&&this.a.info(this.f?(0,h.localize)(3,null,this.f):(0,h.localize)(4,null));const a=[];let n=[];const i=(o,c,D)=>{n.push({id:o,version:c!=="prerelease"?c:void 0,installOptions:{...E,isBuiltin:D,installPreReleaseVersion:c==="prerelease"||E.installPreReleaseVersion}})};for(const o of d)if(o instanceof w.URI)a.push({vsix:o,installOptions:E});else{const[c,D]=(0,R.getIdAndVersion)(o);i(c,D,!1)}for(const o of f)if(o instanceof w.URI)a.push({vsix:o,installOptions:{...E,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,D]=(0,R.getIdAndVersion)(o);i(c,D,!0)}const r=await this.b.getInstalled(1,E.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:o,installOptions:c})=>{try{const D=await this.g(o,c,p,r);D&&t.push(D)}catch(D){this.a.error(D),b.push(o.toString())}})),n.length&&(n=n.filter(({id:o,version:c})=>{const D=r.find(y=>(0,R.areSameExtensions)(y.identifier,{id:o}));if(D){if(!p&&(!c||c==="prerelease"&&D.preRelease))return this.a.info((0,h.localize)(5,null,o,D.manifest.version,o)),!1;if(c&&D.manifest.version===c)return this.a.info((0,h.localize)(6,null,`${o}@${c}`)),!1}return!0}),n.length)){const o=await this.h(n);await Promise.all(n.map(async c=>{const D=o.get(c.id.toLowerCase());if(D)try{const y=await this.j(c,D,r);y&&t.push(y)}catch(y){this.a.error(y.message||y.stack||y),b.push(c.id)}else this.a.error(`${v(c.version?`${c.id}@${c.version}`:c.id)}
${g}`),b.push(c.id)}))}}catch(t){throw this.a.error((0,h.localize)(7,null,(0,L.getErrorMessage)(t))),t}if(b.length)throw new Error((0,h.localize)(8,null,b.join(", ")))}async g(d,f,E,p){const b=await this.b.getManifest(d);if(!b)throw new Error("Invalid vsix");if(await this.l(b,E,f.profileLocation,p))try{return await this.b.install(d,f),this.a.info((0,h.localize)(9,null,(0,A.basename)(d))),b}catch(a){if((0,L.isCancellationError)(a))return this.a.info((0,h.localize)(10,null,(0,A.basename)(d))),null;throw a}return null}async h(d){const f=new Map,E=d.some(t=>t.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),b=[];for(const t of d)l.EXTENSION_IDENTIFIER_REGEX.test(t.id)&&b.push({...t,preRelease:E});if(b.length){const t=await this.d.getExtensions(b,{targetPlatform:p},T.CancellationToken.None);for(const a of t)f.set(a.identifier.id.toLowerCase(),a)}return f}async j({id:d,version:f,installOptions:E},p,b){const t=await this.d.getManifest(p,T.CancellationToken.None);if(t&&!this.k(t))return null;const a=b.find(n=>(0,R.areSameExtensions)(n.identifier,p.identifier));if(a){if(p.version===a.manifest.version)return this.a.info((0,h.localize)(11,null,f?`${d}@${f}`:d)),null;this.a.info((0,h.localize)(12,null,d,p.version))}try{E.isBuiltin?this.a.info(f?(0,h.localize)(13,null,d,f):(0,h.localize)(14,null,d)):this.a.info(f?(0,h.localize)(15,null,d,f):(0,h.localize)(16,null,d));const n=await this.b.installFromGallery(p,{...E,installGivenVersion:!!f});return this.a.info((0,h.localize)(17,null,d,n.manifest.version)),t}catch(n){if((0,L.isCancellationError)(n))return this.a.info((0,h.localize)(18,null,d)),null;throw n}}k(d){return!0}async l(d,f,E,p){if(!f){const b={id:(0,R.getGalleryExtensionId)(d.publisher,d.name)},t=p.find(a=>(0,R.areSameExtensions)(b,a.identifier)&&(0,C.gt)(a.manifest.version,d.version));if(t)return this.a.info((0,h.localize)(19,null,t.identifier.id,t.manifest.version,d.version)),!1}return this.k(d)}async uninstallExtensions(d,f,E){const p=async t=>{if(t instanceof w.URI){const a=await this.b.getManifest(t);return N(a)}return t},b=[];for(const t of d){const a=await p(t),i=(await this.b.getInstalled(void 0,E)).filter(r=>(0,R.areSameExtensions)(r.identifier,{id:a}));if(!i.length)throw new Error(`${this.m(a)}
${g}`);if(i.some(r=>r.type===0)){this.a.info((0,h.localize)(20,null,a));return}if(!f&&i.some(r=>r.isBuiltin)){this.a.info((0,h.localize)(21,null,a));return}this.a.info((0,h.localize)(22,null,a));for(const r of i)await this.b.uninstall(r,{profileLocation:E}),b.push(r);this.f?this.a.info((0,h.localize)(23,null,a,this.f)):this.a.info((0,h.localize)(24,null,a))}}async locateExtension(d){const f=await this.b.getInstalled();d.forEach(E=>{f.forEach(p=>{if(p.identifier.id===E&&p.location.scheme===k.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(d){return this.f?(0,h.localize)(25,null,d,this.f):(0,h.localize)(26,null,d)}};e.ExtensionManagementCLI=S=ve([te(1,l.IExtensionManagementService),te(2,l.IExtensionGalleryService)],S)}),define(ne[139],re([0,1,5,2,35,26,37]),function(G,e,T,L,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class w extends L.Disposable{constructor(l,R,I,v,g,N,S){super(),this.f=l,this.g=R,this.h=I,this.i=v,this.j=g,this.k=N,this.l=S,this.a=this.B(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.DisposableMap),this.m().then(null,u=>S.error(u))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(l=>this.p(l.added,l.removed))),this.B(this.i.onAddExtensions(l=>this.r(l))),this.B(this.i.onDidAddExtensions(l=>this.s(l))),this.B(this.i.onRemoveExtensions(l=>this.t(l))),this.B(this.i.onDidRemoveExtensions(l=>this.u(l))),this.B(this.k.onDidFilesChange(l=>this.v(l)))}async p(l,R){try{await Promise.all(R.map(I=>(this.c.deleteAndDispose(I.id),this.z(I.extensionsResource)))),l.length&&await Promise.all(l.map(I=>(this.c.set(I.id,(0,L.combinedDisposable)(this.k.watch(this.j.extUri.dirname(I.extensionsResource)),this.k.watch(I.extensionsResource))),this.y(I.extensionsResource))))}catch(I){throw this.l.error(I),I}}async r(l){for(const R of l.extensions)this.D(this.G(R.identifier,R.version),l.profileLocation)}async s(l){for(const R of l.extensions){const I=this.G(R.identifier,R.version);l.error?this.F(I,l.profileLocation):this.D(I,l.profileLocation)}}async t(l){for(const R of l.extensions)this.F(this.G(R.identifier,R.version),l.profileLocation)}async u(l){const R=[],I=[];for(const v of l.extensions){const g=this.G(v.identifier,v.version);l.error?this.D(g,l.profileLocation):(this.F(g,l.profileLocation),this.b.has(g)||(this.l.debug("Extension is removed from all profiles",v.identifier.id,v.version),I.push(this.f.scanInstalledExtensionAtLocation(v.location).then(N=>{N?R.push(N):this.l.info("Extension not found at the location",v.location.toString())},N=>this.l.error(N)))))}try{await Promise.all(I),R.length&&await this.C(R)}catch(v){this.l.error(v)}}v(l){for(const R of this.h.profiles)l.contains(R.extensionsResource,0,1)&&this.w(R.extensionsResource)}async w(l){const R=[],I=[],v=await this.i.scanProfileExtensions(l),g=new Set,N=new Set;for(const[S,u]of this.b)u.has(l)&&N.add(S);for(const S of v){const u=this.G(S.identifier,S.version);g.add(u),N.has(u)||(R.push(S.identifier),this.D(u,l))}for(const S of N)if(!g.has(S)){const u=this.H(S);u&&(I.push(u.identifier),this.F(S,l))}(R.length||I.length)&&this.a.fire({added:R.length?{extensions:R,profileLocation:l}:void 0,removed:I.length?{extensions:I,profileLocation:l}:void 0})}async y(l){const R=await this.i.scanProfileExtensions(l);for(const I of R)this.D(this.G(I.identifier,I.version),l)}async z(l){for(const R of[...this.b.keys()])this.F(R,l);await this.C()}async C(l){l||(l=(await this.f.scanAllUserInstalledExtensions()).filter(I=>!this.b.has(this.G(I.identifier,I.manifest.version)))),l.length&&await this.f.markAsUninstalled(...l)}D(l,R){let I=this.b.get(l);I||this.b.set(l,I=new k.ResourceSet(v=>this.j.extUri.getComparisonKey(v))),I.add(R)}F(l,R){const I=this.b.get(l);I&&I.delete(R),I?.size||this.b.delete(l)}G(l,R){return`${C.ExtensionIdentifier.toKey(l.id)}@${R}`}H(l){const[R,I]=(0,A.getIdAndVersion)(l);return I?{identifier:{id:R},version:I}:void 0}}e.ExtensionsWatcher=w}),define(ne[140],re([0,1,111,39]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(A,C,w,h,l,R,I){const v={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${C.nameShort})`};if((0,L.supportsTelemetry)(C,w)&&(0,L.getTelemetryLevel)(h)===3){const g=await(0,T.getServiceMachineId)(w,l,R);v["X-Market-User-Id"]=g,v["VSCode-SessionId"]=I.machineId||g}return v}e.resolveMarketplaceHeaders=k}),define(ne[141],re([0,1,170,19,8,2,16,15,22,18,20,26,6,64,11]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let S=e.NativeLanguagePackService=class extends g.LanguagePackBaseService{constructor(E,p,b,t){super(b),this.h=E,this.i=t,this.g=this.B(new u(p,t)),this.h.registerParticipant({postInstall:async a=>this.j(a),postUninstall:async a=>this.k(a)})}async getBuiltInExtensionTranslationsUri(E,p){const t=(await this.g.getLanguagePacks())[p];if(!t){this.i.warn(`No language pack found for ${p}`);return}const a=t.translations[E];return a?N.URI.file(a):void 0}async getInstalledLanguages(){const E=await this.g.getLanguagePacks(),p=Object.keys(E).map(b=>{const t=E[b];return{...this.f(b,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((b,t)=>b.label.localeCompare(t.label)),p}async j(E){E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",E.identifier.id),await this.update())}async k(E){const p=await this.g.getLanguagePacks();Object.keys(p).some(b=>p[b]&&p[b].extensions.some(t=>(0,I.areSameExtensions)(t.extensionIdentifier,E.identifier)))&&(this.i.info("Removing language packs from the extension",E.identifier.id),await this.update())}async update(){const[E,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),b=await this.g.update(p);return!(0,L.equals)(Object.keys(E),Object.keys(b))}};e.NativeLanguagePackService=S=ve([te(0,R.IExtensionManagementService),te(1,l.INativeEnvironmentService),te(2,R.IExtensionGalleryService),te(3,v.ILogService)],S);let u=class extends A.Disposable{constructor(E,p){super(),this.i=p,this.c={},this.f=(0,w.join)(E.userDataPath,"languagepacks.json"),this.g=new k.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(E){return this.m(p=>{Object.keys(p).forEach(b=>delete p[b]),this.j(p,...E)}).then(()=>this.c)}j(E,...p){for(const b of p)b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&this.k(E,b);Object.keys(E).forEach(b=>this.l(E[b]))}k(E,p){const b=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const a of t)if(p.location.scheme===C.Schemas.file&&d(a)){let n=E[a.languageId];n||(n={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},E[a.languageId]=n);const i=n.extensions.filter(r=>(0,I.areSameExtensions)(r.extensionIdentifier,b))[0];i?i.version=p.manifest.version:n.extensions.push({extensionIdentifier:b,version:p.manifest.version});for(const r of a.translations)n.translations[r.id]=(0,w.join)(p.location.fsPath,r.path)}}l(E){if(E){const p=(0,T.createHash)("md5");for(const b of E.extensions)p.update(b.extensionIdentifier.uuid||b.extensionIdentifier.id).update(b.version);E.hash=p.digest("hex")}}m(E=()=>null){return this.g.queue(()=>{let p=null;return h.Promises.readFile(this.f,"utf8").then(void 0,b=>b.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(b)).then(b=>{try{return JSON.parse(b)}catch{return{}}}).then(b=>(p=E(b),b)).then(b=>{for(const a of Object.keys(b))b[a]||delete b[a];this.c=b,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),h.Promises.writeFile(this.f,t)}).then(()=>p,b=>this.i.error(b))})}};u=ve([te(0,l.INativeEnvironmentService),te(1,v.ILogService)],u);function d(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const E of f.translations)if(typeof E.id!="string"||typeof E.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[142],re([0,1,9,30,39]),function(G,e,T,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function w(l,R,I){const v=await new Promise((d,f)=>{G(["@microsoft/1ds-core-js"],d,f)}),g=await new Promise((d,f)=>{G(["@microsoft/1ds-post-js"],d,f)}),N=new v.AppInsightsCore,S=new g.PostChannel,u={instrumentationKey:l,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[S]]};if(I){u.extensionConfig={};const d={alwaysUseXhrOverride:!0,httpXHROverride:I};u.extensionConfig[S.identifier]=d}return N.initialize(u,[]),N.addTelemetryInitializer(d=>{R&&(d.ext=d.ext??{},d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),N}class h{constructor(R,I,v,g,N){this.e=R,this.f=I,this.g=v,this.h=N,this.c=A,this.d=C,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(R){if(this.a){if(typeof this.a!="string"){R(this.a);return}this.b||(this.b=w(this.a,this.e,this.h)),this.b.then(I=>{R(I)},I=>{(0,T.onUnexpectedError)(I),console.error(I)})}}log(R,I){if(!this.a)return;I=(0,L.mixin)(I,this.g),I=(0,k.validateTelemetryData)(I);const v=this.f+"/"+R;try{this.i(g=>{g.pluginVersionString=I?.properties.version??"Unknown",g.track({name:v,baseData:{name:v,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this.a?new Promise(R=>{this.i(I=>{I.unload(!0,()=>{this.a=void 0,R(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=h}),define(ne[143],re([0,1,2,30,12,29,103,24,42,144,31,36,25,39]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let N=e.TelemetryService=class{constructor(d,f,E){this.k=f,this.l=E,this.d={},this.i=new T.DisposableStore,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=3,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(v.TELEMETRY_SETTING_ID)||p.affectsConfiguration(v.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(v.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(d,f){this.d[d]=f}m(){let d=(0,g.getTelemetryLevel)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const E=f.usage?3:f.error?2:0;d=Math.min(d,E)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,f,E){this.g<f||(E=(0,L.mixin)(E,this.d),E=(0,g.cleanData)(E,this.j),E=(0,L.mixin)(E,this.c),this.b.forEach(p=>p.log(d,E)))}publicLog(d,f){this.n(d,3,f)}publicLog2(d,f){this.publicLog(d,f)}publicLogError(d,f){this.h&&this.n(d,2,f)}publicLogError2(d,f){this.publicLogError(d,f)}};N.IDLE_START_EVENT_NAME="UserIdleStart",N.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=N=ve([te(1,w.IConfigurationService),te(2,R.IProductService)],N);function S(){const u=(0,C.localize)(0,null,l.default.nameLong),d=l.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=k.isWeb?"":(0,C.localize)(3,null),E=(0,C.localize)(4,null),p=(0,C.localize)(5,null),b=(0,C.localize)(6,null),t=(0,C.localize)(7,null),a=`
|       | ${E} | ${p} | ${b} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,C.localize)(8,null);return`
${u} ${d} ${f}

&nbsp;

${t}
${a}

&nbsp;

${n}
`}I.Registry.as(h.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(h.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,C.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,C.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[145],re([0,1,171,142]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends L.AbstractOneDataSystemAppender{constructor(C,w,h,l){const R={sendPOST:(I,v)=>{const g={method:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data)}};try{const N=T.request(I.urlString,g,S=>{S.on("data",function(u){v(S.statusCode??200,S.headers,u.toString())}),S.on("error",function(u){v(0,{})})});N.write(I.data),N.end()}catch{v(0,{})}}};super(C,w,h,l,R)}}e.OneDataSystemAppender=k}),define(ne[146],re([0,1,15,22]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(A,C){const w=Object.create(null),h=(R,I)=>{const v=JSON.parse(R);w[I]=v};if(C){const R=[],I=await L.Promises.readdir(C);for(const g of I)try{(await L.Promises.stat((0,T.join)(C,g))).isDirectory()&&R.push(g)}catch{}const v=[];for(const g of R)(await L.Promises.readdir((0,T.join)(C,g))).filter(S=>S==="telemetry.json").length===1&&v.push(g);for(const g of v){const N=(await L.Promises.readFile((0,T.join)(C,g,"telemetry.json"))).toString();h(N,g)}}let l=(await L.Promises.readFile((0,T.join)(A,"telemetry-core.json"))).toString();return h(l,"vscode-core"),l=(await L.Promises.readFile((0,T.join)(A,"telemetry-extensions.json"))).toString(),h(l,"vscode-extensions"),JSON.stringify(w,null,4)}e.buildTelemetryMessage=k}),define(ne[147],re([0,1,12,80,25]),function(G,e,T,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function A(C,w){let h=C.getItem(k.machineIdKey);return(typeof h!="string"||T.isMacintosh&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,L.getMachineId)(w.error.bind(w))),h}e.resolveMachineId=A}),define(ne[27],re([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(ne[148],re([0,1,27,112,13,17,72,5,2]),function(G,e,T,L,k,A,C,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{constructor(v){this.uri=v,this.time=l._clock++}touch(){return this.time=l._clock++,this}}l._clock=0;let R=e.UriIdentityService=class{constructor(v){this.g=v,this.c=new h.DisposableStore,this.f=2**16;const g=new Map,N=S=>{let u=g.get(S.scheme);return u===void 0&&(u=v.hasProvider(S)&&!this.g.hasCapability(S,1024),g.set(S.scheme,u)),u};this.c.add(w.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(S=>{g.delete(S.scheme)})),this.extUri=new A.ExtUri(N),this.d=new C.SkipList((S,u)=>this.extUri.compare(S,u,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,A.normalizePath)(v));const g=this.d.get(v);return g?g.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new l(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((N,S)=>N[1].time<S[1].time?1:N[1].time>S[1].time?-1:0);l._clock=0,this.d.clear();const g=this.f*.5;for(let N=0;N<g;N++)this.d.set(v[N][0],v[N][1].touch())}};e.UriIdentityService=R=ve([te(0,k.IFileService)],R),(0,L.registerSingleton)(T.IUriIdentityService,R,1)}),define(ne[149],re([0,1,105,15,55,17,11,10,16]),function(G,e,T,L,k,A,C,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,w.createDecorator)("contextService");function l(i){const r=i;return typeof r?.id=="string"&&C.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=l;function R(i){return typeof i?.id=="string"&&!l(i)&&!v(i)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=I;function v(i){const r=i;return typeof r?.id=="string"&&C.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=v;function g(i){const r=i;if(r?.uri)return{id:r.id,uri:C.URI.revive(r.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:C.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=g;var N;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(N||(e.WorkbenchState=N={}));function S(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=S;function u(i){const r=i;return!!(r&&typeof r=="object"&&C.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=u;class d{constructor(r,o,c,D,y){this.h=r,this.j=c,this.k=D,this.l=y,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class f{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,A.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function E(i){return new f({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(i,r){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function b(i){let r;return C.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=b,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(i,r){return!p(i,r)&&!b(i)}e.isSavedWorkspace=a;function n(i){return(typeof i=="string"?(0,L.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(ne[21],re([0,1,45,5,2,17,11,104,18,13,10,6,149,35,27,8,28,29,3]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g,N,S,u,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function E(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&C.URI.isUri(i.location)&&C.URI.isUri(i.globalStorageHome)&&C.URI.isUri(i.settingsResource)&&C.URI.isUri(i.keybindingsResource)&&C.URI.isUri(i.tasksResource)&&C.URI.isUri(i.snippetsHome)&&C.URI.isUri(i.extensionsResource))}e.isUserDataProfile=E,e.IUserDataProfilesService=(0,R.createDecorator)("IUserDataProfilesService");function p(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:C.URI.revive(n.location).with({scheme:i}),globalStorageHome:C.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:C.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:C.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:C.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:C.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:C.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:C.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=p;function b(n,i,r,o,c){return{id:n,name:i,location:r,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,A.joinPath)(r,"globalStorage"),settingsResource:(0,A.joinPath)(r,"settings.json"),keybindingsResource:(0,A.joinPath)(r,"keybindings.json"),tasksResource:(0,A.joinPath)(r,"tasks.json"),snippetsHome:(0,A.joinPath)(r,"snippets"),extensionsResource:(0,A.joinPath)(r,"extensions.json"),cacheHome:(0,A.joinPath)(o,n),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=b;let t=e.UserDataProfilesService=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,r,o,c){super(),this.n=i,this.r=r,this.s=o,this.t=c,this.f=!0,this.h=this.B(new L.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new L.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new L.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new L.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new g.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,A.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=[];if(this.f)try{for(const D of this.J()){if(!D.name||!(0,f.isString)(D.name)||!D.location){this.t.warn("Skipping the invalid stored profile",D.location||D.name);continue}i.push(b((0,A.basename)(D.location),D.name,D.location,this.g,{shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}))}}catch(D){this.t.error(D)}const r=new g.ResourceMap,o=new Map,c=this.w();if(i.unshift({...c,extensionsResource:this.O()??c.extensionsResource,isDefault:!0}),i.length)try{const D=this.M();if(D.workspaces)for(const[y,m]of Object.entries(D.workspaces)){const M=C.URI.parse(y),J=i.find(K=>K.id===m);J&&r.set(M,J)}if(D.emptyWindows)for(const[y,m]of Object.entries(D.emptyWindows)){const M=i.find(J=>J.id===m);M&&o.set(y,M)}}catch(D){this.t.error(D)}this.u={profiles:i,workspaces:r,emptyWindows:o}}return this.u}w(){return b("__default__profile__",(0,w.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(i){const r="Temp",o=new RegExp(`${(0,d.escapeRegExpCharacters)(r)}\\s(\\d+)`);let c=0;for(const y of this.profiles){const m=o.exec(y.name),M=m?parseInt(m[1]):0;c=M>c?M:c}const D=`${r} ${c+1}`;return this.createProfile((0,T.hash)((0,u.generateUuid)()).toString(16),D,{transient:!0},i)}async createNamedProfile(i,r,o){return this.createProfile((0,T.hash)((0,u.generateUuid)()).toString(16),i,r,o)}async createProfile(i,r,o,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.y(i,r,o);return c&&await this.setProfileForWorkspace(c,D),D}async y(i,r,o){if(!(0,f.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let c=this.l.get(r);return c||(c=(async()=>{try{const D=this.profiles.find(M=>M.name===r||M.id===i);if(D)return D;const y=b(i,r,(0,A.joinPath)(this.profilesHome,i),this.g,o);await this.r.createFolder(y.location);const m=[];return this.i.fire({profile:y,join(M){m.push(M)}}),await S.Promises.settled(m),this.D([y],[],[]),y}finally{this.l.delete(r)}})(),this.l.set(r,c)),c}async updateProfile(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(c=>c.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);return o=b(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.D([],[],[o]),o}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(c=>c.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const o=[];this.j.fire({profile:r,join(c){o.push(c)}});try{await Promise.allSettled(o)}catch(c){this.t.error(c)}for(const c of[...this.v.emptyWindows.keys()])r.id===this.v.emptyWindows.get(c)?.id&&this.v.emptyWindows.delete(c);for(const c of[...this.v.workspaces.keys()])r.id===this.v.workspaces.get(c)?.id&&this.v.workspaces.delete(c);this.H(),this.D([],[r],[]);try{await this.r.del(r.cacheHome,{recursive:!0})}catch(c){(0,l.toFileOperationResult)(c)!==1&&this.t.error(c)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(r.location,{recursive:!0})}catch(c){this.t.error(c)}}async setProfileForWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(c=>c.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.G(i,o)}unsetWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,r)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.s.extUri.isEqual(o.location,r.resource))).map(r=>this.r.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(r=>!this.C(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.z(i);return C.URI.isUri(r)?this.m.workspaces.get(r)??this.v.workspaces.get(r):this.m.emptyWindows.get(r)??this.v.emptyWindows.get(r)}z(i){return(0,v.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,v.isWorkspaceIdentifier)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.m.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.v.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.v.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,i.location)))}D(i,r,o){const c=[...this.profiles,...i],D=[];this.m.profiles=[];for(let y of c)y.isDefault||r.some(m=>y.id===m.id)||(y=o.find(m=>y.id===m.id)??y,y.isTransient?this.m.profiles.push(y):D.push({location:y.location,name:y.name,shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}));this.L(D),this.u=void 0,this.F(i,r,o)}F(i,r,o){this.h.fire({added:i,removed:r,updated:o,all:this.profiles})}G(i,r,o){o=r?.isTransient?!0:o,o||this.G(i,void 0,!0);const c=this.z(i),D=o?this.m:this.v;C.URI.isUri(c)?(D.workspaces.delete(c),r&&D.workspaces.set(c,r)):(D.emptyWindows.delete(c),r&&D.emptyWindows.set(c,r)),o||this.H()}H(){const i={};for(const[o,c]of this.v.workspaces.entries())i[o.toString()]=c.id;const r={};for(const[o,c]of this.v.emptyWindows.entries())r[o.toString()]=c.id;this.N({workspaces:i,emptyWindows:r}),this.u=void 0}I(i){const r={},o=this.w();if(i.workspaces)for(const[D,y]of Object.entries(i.workspaces)){const m=C.URI.parse(y);r[D]=this.s.extUri.isEqual(m,o.location)?o.id:this.s.extUri.basename(m)}const c={};if(i.emptyWindows)for(const[D,y]of Object.entries(i.emptyWindows)){const m=C.URI.parse(y);c[D]=this.s.extUri.isEqual(m,o.location)?o.id:this.s.extUri.basename(m)}return{workspaces:r,emptyWindows:c}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",e.UserDataProfilesService=t=ve([te(0,h.IEnvironmentService),te(1,l.IFileService),te(2,N.IUriIdentityService),te(3,I.ILogService)],t);class a extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.InMemoryUserDataProfilesService=a}),define(ne[150],re([0,1,19,8,23,9,5,2,12,3,11,89,20,26,37,6,31,25,21]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g,N,S,u,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let E=e.AbstractExtensionManagementService=class extends w.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,r,o,c,D){super(),this.t=i,this.u=r,this.v=o,this.w=c,this.y=D,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new C.Emitter),this.m=this.B(new C.Emitter),this.n=this.B(new C.Emitter),this.p=this.B(new C.Emitter),this.s=[],this.B((0,w.toDisposable)(()=>{this.j.forEach(({task:y})=>y.cancel()),this.k.forEach(y=>y.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,v.isTargetPlatformCompatible)(o,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{if(!this.t.isEnabled())throw new v.ExtensionManagementError(I.localize(0,null),v.ExtensionManagementErrorCode.Internal);const o=await this.G(i,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw t(this.u,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(i),error:o}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(o),b(o)}}async uninstall(i,r={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,r)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,r,o){const c=o.isApplicationScoped||o.isBuiltin||(0,N.isApplicationScopedExtension)(i),D={...o,installOnlyNewlyAddedFromExtensionPack:R.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:c,profileLocation:c?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},y=ue=>`${g.ExtensionKey.create(ue).toString()}${D.profileLocation?`-${D.profileLocation.toString()}`:""}`;if(!R.URI.isUri(r)){const ue=this.j.get(y(r));if(ue)return this.v.info("Extensions is already requested to install",r.identifier.id),ue.task.waitUntilTaskIsFinished()}const m=[],M=[],J=[],K=this.Q(i,r,D);R.URI.isUri(r)||this.j.set(y(r),{task:K,waitingTasks:[]}),this.l.fire({identifier:K.identifier,source:r,profileLocation:D.profileLocation}),this.v.info("Installing extension:",K.identifier.id),m.push({task:K,manifest:i});let ie=!1;try{if(D.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",K.identifier.id);else try{const Q=await this.F(K.identifier,i,!!D.installOnlyNewlyAddedFromExtensionPack,!!D.installPreReleaseVersion,D.profileLocation),ce=await this.getInstalled(void 0,D.profileLocation);for(const{gallery:oe,manifest:se}of(0,T.distinct)(Q,({gallery:$})=>$.identifier.id)){ie=ie||!!se.extensionDependencies?.some(x=>(0,g.areSameExtensions)({id:x},K.identifier));const $=y(oe),q=this.j.get($);if(q){if(this.C(K,q.task)){const x=q.task.identifier;this.v.info("Waiting for already requested installing extension",x.id,K.identifier.id),q.waitingTasks.push(K),M.push(C.Event.toPromise(C.Event.filter(this.onDidInstallExtensions,F=>F.some(W=>(0,g.areSameExtensions)(W.identifier,x)))).then(F=>{if(this.v.info("Finished waiting for already requested installing extension",x.id,K.identifier.id),!F.find(H=>(0,g.areSameExtensions)(H.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else if(!ce.some(({identifier:x})=>(0,g.areSameExtensions)(x,oe.identifier))){const x=this.Q(se,oe,{...D,donotIncludePackAndDependencies:!0});this.j.set($,{task:x,waitingTasks:[K]}),this.l.fire({identifier:x.identifier,source:oe,profileLocation:D.profileLocation}),this.v.info("Installing extension:",x.identifier.id,K.identifier.id),m.push({task:x,manifest:se})}}}catch(Q){if(R.URI.isUri(K.source))(0,T.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",K.identifier.id,Q.message),(0,T.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",K.identifier.id,Q.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",K.identifier.id),Q}const ue=m.reduce((Q,{task:ce,manifest:oe})=>(Q.set(ce.identifier.id.toLowerCase(),{task:ce,manifest:oe}),Q),new Map);for(;ue.size;){let Q;const ce=[...ue.values()].filter(({manifest:oe})=>!oe.extensionDependencies?.some(se=>ue.has(se.toLowerCase())));ce.length?Q=ue.size===1?ce:ce.filter(({task:oe})=>!(oe===K&&!ie)):(this.v.info("Found extensions with circular dependencies",ce.map(({task:oe})=>oe.identifier.id)),Q=[...ue.values()]),await this.D(Q.map(async({task:oe})=>{const se=new Date().getTime();try{const $=await oe.run();if(await this.D(this.s.map(q=>q.postInstall($,oe.source,D,k.CancellationToken.None))),!R.URI.isUri(oe.source)){const q=oe.operation===3,x=q?void 0:(new Date().getTime()-oe.source.lastUpdated)/1e3;if(t(this.u,q?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(oe.source),verificationStatus:oe.verificationStatus,duration:new Date().getTime()-se,durationSinceUpdate:x}),h.isWeb&&oe.operation!==3)try{await this.t.reportStatistic($.manifest.publisher,$.manifest.name,$.manifest.version,"install")}catch{}}J.push({local:$,identifier:oe.identifier,operation:oe.operation,source:oe.source,context:D.context,profileLocation:oe.profileLocation,applicationScoped:$.isApplicationScoped})}catch($){throw R.URI.isUri(oe.source)||t(this.u,oe.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(oe.source),verificationStatus:oe.verificationStatus,duration:new Date().getTime()-se,error:$}),this.v.error("Error while installing the extension:",oe.identifier.id),$}finally{ue.delete(oe.identifier.id.toLowerCase())}}))}return M.length&&await this.D(M),J.forEach(({identifier:Q})=>this.v.info("Extension installed successfully:",Q.id)),this.m.fire(J),J.filter(({identifier:Q})=>(0,g.areSameExtensions)(Q,K.identifier))[0].local}catch(ue){if(m.forEach(({task:Q})=>Q.cancel()),J.length)try{const Q=await Promise.allSettled(J.map(({local:ce})=>this.R(ce,{versionOnly:!0,profileLocation:D.profileLocation}).run()));for(let ce=0;ce<Q.length;ce++){const oe=Q[ce],{identifier:se}=J[ce];oe.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",se.id):this.v.warn("Rollback: Error while uninstalling extension",se.id,(0,A.getErrorMessage)(oe.reason))}}catch(Q){this.v.warn("Error while rolling back extensions",(0,A.getErrorMessage)(Q),J.map(({identifier:ce})=>ce.id))}throw this.m.fire(m.map(({task:Q})=>({identifier:Q.identifier,operation:2,source:Q.source,context:D.context,profileLocation:D.profileLocation}))),ue}finally{for(const{task:ue}of m)ue.source&&!R.URI.isUri(ue.source)&&this.j.delete(y(ue.source))}}C(i,r){for(const[,{task:o,waitingTasks:c}]of this.j.entries())if(o===i&&(c.includes(r)||c.some(D=>this.C(D,r)))||o===r&&c[0]&&!this.C(i,c[0]))return!1;return!0}async D(i){const r=[],o=[],c=await Promise.allSettled(i);for(const D of c)D.status==="fulfilled"?r.push(D.value):o.push(D.reason);if(o.length)throw p(o);return r}async F(i,r,o,c,D){if(!this.t.isEnabled())return[];const y=await this.getInstalled(void 0,D),m=[],M=[],J=async(K,ie)=>{m.push(K);const ue=ie.extensionDependencies||[],Q=[...ue];if(ie.extensionPack){const ce=o?y.find(oe=>(0,g.areSameExtensions)(oe.identifier,K)):void 0;for(const oe of ie.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(se=>(0,g.areSameExtensions)({id:se},{id:oe}))||Q.every(se=>!(0,g.areSameExtensions)({id:se},{id:oe}))&&Q.push(oe)}if(Q.length){const ce=Q.filter(oe=>m.every(se=>!(0,g.areSameExtensions)(se,{id:oe})));if(ce.length){const oe=await this.t.getExtensions(ce.map(se=>({id:se,preRelease:c})),k.CancellationToken.None);for(const se of oe){if(m.find(x=>(0,g.areSameExtensions)(x,se.identifier)))continue;const $=ue.some(x=>(0,g.areSameExtensions)({id:x},se.identifier));let q;try{q=await this.G(se,!1,c)}catch(x){if(x instanceof v.ExtensionManagementError&&x.code===v.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!$){this.v.info("Skipping the packed extension as it cannot be installed",se.identifier.id);continue}else throw x}M.push({gallery:q.extension,manifest:q.manifest}),await J(q.extension.identifier,q.manifest)}}}};return await J(i,r),M}async G(i,r,o){if((await this.getExtensionsControlManifest()).malicious.some(m=>(0,g.areSameExtensions)(i.identifier,m)))throw new v.ExtensionManagementError(I.localize(1,null,i.identifier.id),v.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const m=await this.getTargetPlatform();throw new v.ExtensionManagementError(I.localize(2,null,i.identifier.id,this.w.nameLong,(0,v.TargetPlatformToString)(m)),v.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const D=await this.H(i,r,o);if(D){if(o&&!r&&i.hasPreReleaseVersion&&!D.properties.isPreReleaseVersion)throw new v.ExtensionManagementError(I.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),v.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],k.CancellationToken.None))[0]?new v.ExtensionManagementError(I.localize(4,null,i.identifier.id),v.ExtensionManagementErrorCode.ReleaseVersionNotFound):new v.ExtensionManagementError(I.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),v.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",D.identifier.id);const y=await this.t.getManifest(D,k.CancellationToken.None);if(y===null)throw new v.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,v.ExtensionManagementErrorCode.Invalid);if(y.version!==D.version)throw new v.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,v.ExtensionManagementErrorCode.Invalid);return{extension:D,manifest:y}}async H(i,r,o){const c=await this.getTargetPlatform();let D=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(D=(await this.t.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null),!D&&await this.t.isExtensionCompatible(i,o,c)&&(D=i),D||(r?D=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null:D=await this.t.getCompatibleExtension(i,o,c)),D}async I(i,r){const o={...r,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},c=K=>`${K.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,D=this.k.get(c(i.identifier));if(D)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),D.waitUntilTaskIsFinished();const y=K=>{const ie=this.R(K,o);return this.k.set(c(ie.extension.identifier),ie),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${K.identifier.id}@${K.manifest.version}`),this.n.fire({identifier:K.identifier,profileLocation:o.profileLocation,applicationScoped:K.isApplicationScoped}),ie},m=(K,ie)=>{ie?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,o.profileLocation.toString(),ie.message):this.v.error("Failed to uninstall extension:",`${K.identifier.id}@${K.manifest.version}`,ie.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${K.identifier.id}@${K.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${K.identifier.id}@${K.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(K),error:ie}),this.p.fire({identifier:K.identifier,error:ie?.code,profileLocation:o.profileLocation,applicationScoped:K.isApplicationScoped})},M=[],J=[];try{M.push(y(i));const K=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const ie=this.M(i,K);for(const ue of ie)this.k.has(c(ue.identifier))?this.v.info("Extensions is already requested to uninstall",ue.identifier.id):M.push(y(ue))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(M.map(ie=>ie.extension),K,i),await this.D(M.map(async ie=>{try{if(await ie.run(),await this.D(this.s.map(ue=>ue.postUninstall(ie.extension,o,k.CancellationToken.None))),ie.extension.identifier.uuid)try{await this.t.reportStatistic(ie.extension.manifest.publisher,ie.extension.manifest.name,ie.extension.manifest.version,"uninstall")}catch{}m(ie.extension)}catch(ue){const Q=ue instanceof v.ExtensionManagementError?ue:new v.ExtensionManagementError((0,A.getErrorMessage)(ue),v.ExtensionManagementErrorCode.Internal);throw m(ie.extension,Q),Q}finally{J.push(ie)}}))}catch(K){const ie=K instanceof v.ExtensionManagementError?K:new v.ExtensionManagementError((0,A.getErrorMessage)(K),v.ExtensionManagementErrorCode.Internal);for(const ue of M){try{ue.cancel()}catch{}J.includes(ue)||m(ue.extension,ie)}throw ie}finally{for(const K of M)this.k.delete(c(K.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",K.extension.identifier.id)}}J(i,r,o){for(const c of i){const D=this.N(c,r);if(D.length){const y=D.filter(m=>!i.some(M=>(0,g.areSameExtensions)(M.identifier,m.identifier)));if(y.length)throw new Error(this.L(c,y,o))}}}L(i,r,o){return o===i?r.length===1?I.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(i,r,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const c=i.manifest.extensionPack?i.manifest.extensionPack:[];if(c.length){const D=r.filter(m=>!m.isBuiltin&&c.some(M=>(0,g.areSameExtensions)({id:M},m.identifier))),y=[];for(const m of D)y.push(...this.M(m,r,o));return[...D,...y]}return[]}N(i,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,g.areSameExtensions)({id:c},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};e.AbstractExtensionManagementService=E=ve([te(0,v.IExtensionGalleryService),te(1,d.ITelemetryService),te(2,S.ILogService),te(3,u.IProductService),te(4,f.IUserDataProfilesService)],E);function p(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=p;function b(n){if(n instanceof v.ExtensionManagementError)return n;const i=new v.ExtensionManagementError(n.message,v.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}function t(n,i,{extensionData:r,verificationStatus:o,duration:c,error:D,durationSinceUpdate:y}){let m,M;(0,l.isDefined)(o)&&(o===!0?o="Verified":(o===!1||(m=v.ExtensionManagementErrorCode.Signature,M=o),o="Unverified")),D&&(D instanceof v.ExtensionManagementError?(m=D.code,D.code===v.ExtensionManagementErrorCode.Signature&&(M=D.message)):m=v.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,verificationStatus:o,success:!D,duration:c,errorcode:m,errorcodeDetail:M,durationSinceUpdate:y})}class a{constructor(){this.d=new L.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,L.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.createCancelablePromise)(i=>new Promise((r,o)=>{const c=i.onCancellationRequested(()=>{c.dispose(),o(new A.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=a}),define(ne[40],re([0,1,8,14,2,5,35,11,20,26,13,10,6,21,27,3,9,25]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g,N,S,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class E extends Error{constructor(n,i){super(n),this.code=i}}e.ExtensionsProfileScanningError=E,e.IExtensionsProfileScannerService=(0,I.createDecorator)("IExtensionsProfileScannerService");let p=e.AbstractExtensionsProfileScannerService=class extends k.Disposable{constructor(n,i,r,o,c,D){super(),this.i=n,this.j=i,this.k=r,this.l=o,this.m=c,this.n=D,this.b=this.B(new A.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new A.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new C.ResourceMap}scanProfileExtensions(n,i){return this.p(n,void 0,i)}async addExtensionsToProfile(n,i){const r=[],o=[];try{return await this.p(i,c=>{const D=[];for(const y of c)n.some(([m])=>(0,l.areSameExtensions)(m.identifier,y.identifier)&&m.manifest.version!==y.version)?r.push(y):D.push(y);for(const[y,m]of n)if(!D.some(M=>(0,l.areSameExtensions)(M.identifier,y.identifier)&&M.version===y.manifest.version)){const M={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:m};o.push(M),D.push(M)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),r.length&&this.f.fire({extensions:r,profileLocation:i}),D}),o.length&&this.c.fire({extensions:o,profileLocation:i}),r.length&&this.g.fire({extensions:r,profileLocation:i}),o}catch(c){throw o.length&&this.c.fire({extensions:o,error:c,profileLocation:i}),r.length&&this.g.fire({extensions:r,error:c,profileLocation:i}),c}}async updateMetadata(n,i){const r=[];return await this.p(i,o=>{const c=[];for(const D of o){const y=n.find(([m])=>(0,l.areSameExtensions)(m.identifier,D.identifier)&&m.manifest.version===D.version);y&&(D.metadata={...D.metadata,...y[1]},r.push(D)),c.push(D)}return c}),r}async removeExtensionFromProfile(n,i){const r=[];this.f.fire({extensions:r,profileLocation:i});try{await this.p(i,o=>{const c=[];for(const D of o)(0,l.areSameExtensions)(D.identifier,n.identifier)?r.push(D):c.push(D);return r.length&&this.f.fire({extensions:r,profileLocation:i}),c}),r.length&&this.g.fire({extensions:r,profileLocation:i})}catch(o){throw r.length&&this.g.fire({extensions:r,error:o,profileLocation:i}),o}}async p(n,i,r){return this.w(n).queue(async()=>{let o=[],c;try{const D=await this.j.readFile(n);c=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,R.toFileOperationResult)(D)!==1)throw D;if(this.l.extUri.isEqual(n,this.k.defaultProfile.extensionsResource)&&(c=await this.v()),!c&&r?.bailOutWhenFileNotFound)throw new E((0,u.getErrorMessage)(D),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.r(n);let D=!1;for(const y of c){b(y)||this.r(n);let m;if((0,S.isString)(y.relativeLocation)&&y.relativeLocation)m=this.t(y.relativeLocation);else if((0,S.isString)(y.location))m=this.t(y.location),D=!0,y.relativeLocation=y.location,y.location=m.toJSON();else{m=w.URI.revive(y.location);const M=this.s(m);M&&(D=!0,y.relativeLocation=M)}o.push({identifier:y.identifier,location:m,version:y.version,metadata:y.metadata})}D&&await this.j.writeFile(n,L.VSBuffer.fromString(JSON.stringify(c)))}if(i){o=i(o);const D=o.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.s(y.location),metadata:y.metadata}));await this.j.writeFile(n,L.VSBuffer.fromString(JSON.stringify(D)))}return o})}r(n){const i=new E(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(n){return this.l.extUri.isEqual(this.l.extUri.dirname(n),this.i)?this.l.extUri.basename(n):void 0}t(n){return this.l.extUri.joinPath(this.i,n)}async v(){return this.u||(this.u=(async()=>{const n=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let r;try{r=(await this.j.readFile(n)).value.toString()}catch(c){if((0,R.toFileOperationResult)(c)===1)return;throw c}this.n.info("Migrating extensions from old default profile location",n.toString());let o;try{const c=JSON.parse(r);Array.isArray(c)&&c.every(D=>b(D))?o=c:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.n.error(c)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",n.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(c){if((0,R.toFileOperationResult)(c)===3)this.n.info("Migration from old default profile location to new location is done by another window",n.toString(),this.k.defaultProfile.extensionsResource.toString());else throw c}try{await this.j.del(n)}catch(c){(0,R.toFileOperationResult)(c)!==1&&this.n.error(c)}try{await this.j.del(i)}catch(c){(0,R.toFileOperationResult)(c)!==1&&this.n.error(c)}return o})()),this.u}w(n){let i=this.h.get(n);return i||(i=new T.Queue,this.h.set(n,i)),i}};e.AbstractExtensionsProfileScannerService=p=ve([te(1,R.IFileService),te(2,g.IUserDataProfilesService),te(3,N.IUriIdentityService),te(4,d.ITelemetryService),te(5,v.ILogService)],p);function b(a){return(0,S.isObject)(a)&&(0,h.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,S.isString)(a.location)&&a.location)&&((0,S.isUndefined)(a.relativeLocation)||(0,S.isString)(a.relativeLocation))&&a.version&&(0,S.isString)(a.version)}function t(a){return a?(0,S.isString)(a.path)&&(0,S.isString)(a.scheme):!1}}),define(ne[49],re([0,1,19,8,30,14,9,52,78,2,16,15,12,17,41,54,3,11,93,18,26,37,47,13,10,6,31,5,46,40,21,27,110]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g,N,S,u,d,f,E,p,b,t,a,n,i,r,o,c,D,y,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var J;(function(se){function $(q,x){if(q===x)return!0;const F=Object.keys(q),W=new Set;for(const H of Object.keys(x))W.add(H);if(F.length!==W.size)return!1;for(const H of F){if(q[H]!==x[H])return!1;W.delete(H)}return W.size===0}se.equals=$})(J||(e.Translations=J={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let K=e.AbstractExtensionsScannerService=class extends l.Disposable{constructor($,q,x,F,W,H,Y,j,z,O,s,P){super(),this.systemExtensionsLocation=$,this.userExtensionsLocation=q,this.l=x,this.m=F,this.n=W,this.r=H,this.s=Y,this.t=j,this.u=z,this.v=O,this.w=s,this.y=P,this.g=this.B(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(Q,this.m,this.h)),this.j=this.B(this.y.createInstance(Q,this.m,this.h)),this.k=this.B(this.y.createInstance(ue,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,p.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions($,q,x){const[F,W]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(q)]),H=x?await this.scanExtensionsUnderDevelopment($,[...F,...W]):[];return this.G(F,W,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const q=[];q.push(this.H(!!$.useCache,$.language)),q.push(this.I($.language,!!$.checkControlFile));const[x,F]=await Promise.all(q);return this.F([...x,...F],0,$,!1)}async scanUserExtensions($){const q=$.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",q);const x=this.w.extUri.isEqual($.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.L(q,!!$.profileLocation,1,!$.includeUninstalled,$.language,!0,x),W=$.useCache&&!F.devMode&&F.excludeObsolete?this.j:this.k;let H;try{H=await W.scanExtensions(F)}catch(Y){if(Y instanceof D.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),H=await W.scanExtensions(F);else throw Y}return H=await this.F(H,1,$,!0),this.t.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment($,q){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const x=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(F=>F.scheme===R.Schemas.file).map(async F=>{const W=await this.L(F,!1,1,!0,$.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(Y=>(Y.type=q.find(j=>(0,p.areSameExtensions)(j.identifier,Y.identifier))?.type??Y.type,this.k.validate(Y,W)))}))).flat();return this.F(x,"development",$,!0)}return[]}async scanExistingExtension($,q,x){const F=await this.L($,!1,q,!0,x.language,!0,void 0),W=await this.k.scanExtension(F);return!W||!x.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions($,q,x){const F=await this.L($,!1,q,!0,x.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions(F);return this.F(W,q,x,!0)}async scanMetadata($){const q=(0,g.joinPath)($,"package.json"),x=(await this.s.readFile(q)).value.toString();return JSON.parse(x).__metadata}async updateMetadata($,q){const x=(0,g.joinPath)($,"package.json"),F=(await this.s.readFile(x)).value.toString(),W=JSON.parse(F);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,W.__metadata={...W.__metadata,...q},await this.s.writeFile((0,g.joinPath)($,"package.json"),A.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch($){if($ instanceof D.ExtensionsProfileScanningError&&$.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw $}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const $=await this.scanUserExtensions({includeInvalid:!0});if($.length)await this.r.addExtensionsToProfile($.map(q=>[q,q.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(q){(0,a.toFileOperationResult)(q)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.getErrorMessage)(q))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch($){this.t.error($)}finally{this.C=void 0}})()),this.C}async F($,q,x,F){return x.includeAllVersions||($=this.G(q===0?$:void 0,q===1?$:void 0,q==="development"?$:void 0,await this.getTargetPlatform(),F)),x.includeInvalid||($=$.filter(W=>W.isValid)),$.sort((W,H)=>{const Y=I.basename(W.location.fsPath),j=I.basename(H.location.fsPath);return Y<j?-1:Y>j?1:0})}G($,q,x,F,W){const H=(j,z,O)=>{if(j.isValid&&!z.isValid)return!1;if(j.isValid===z.isValid){if(W&&N.gt(j.manifest.version,z.manifest.version))return this.t.debug(`Skipping extension ${z.location.path} with lower version ${z.manifest.version} in favour of ${j.location.path} with version ${j.manifest.version}`),!1;if(N.eq(j.manifest.version,z.manifest.version)){if(j.type===0)return this.t.debug(`Skipping extension ${z.location.path} in favour of system extension ${j.location.path} with same version`),!1;if(j.targetPlatform===F)return this.t.debug(`Skipping extension ${z.location.path} from different target platform ${z.targetPlatform}`),!1}}return O?this.t.warn(`Overwriting user extension ${j.location.path} with ${z.location.path}.`):this.t.debug(`Overwriting user extension ${j.location.path} with ${z.location.path}.`),!0},Y=new b.ExtensionIdentifierMap;return $?.forEach(j=>{const z=Y.get(j.identifier.id);(!z||H(z,j,!1))&&Y.set(j.identifier.id,j)}),q?.forEach(j=>{const z=Y.get(j.identifier.id);if(!z&&$&&j.type===0){this.t.debug(`Skipping obsolete system extension ${j.location.path}.`);return}(!z||H(z,j,!1))&&Y.set(j.identifier.id,j)}),x?.forEach(j=>{const z=Y.get(j.identifier.id);(!z||H(z,j,!0))&&Y.set(j.identifier.id,j),Y.set(j.identifier.id,j)}),[...Y.values()]}async H($,q){this.t.trace("Started scanning system extensions");const x=await this.L(this.systemExtensionsLocation,!1,0,!0,q,!0,void 0),W=await($&&!x.devMode?this.i:this.k).scanExtensions(x);return this.t.trace("Scanned system extensions:",W.length),W}async I($,q){const x=this.u.isBuilt?[]:this.v.builtInExtensions;if(!x?.length)return[];this.t.trace("Started scanning dev system extensions");const F=q?await this.J():{},W=[],H=d.URI.file(I.normalize(I.join(R.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const j of x){const z=F[j.name]||"marketplace";switch(z){case"disabled":break;case"marketplace":W.push((0,g.joinPath)(H,j.name));break;default:W.push(d.URI.file(z));break}}const Y=await Promise.all(W.map(async j=>this.k.scanExtension(await this.L(j,!1,0,!0,$,!0,void 0))));return this.t.trace("Scanned dev system extensions:",Y.length),(0,T.coalesce)(Y)}async J(){try{const $=await this.s.readFile(this.l);return JSON.parse($.value.toString())}catch{return{}}}async L($,q,x,F,W,H,Y){const j=await this.f(W??v.language),z=await this.M($),O=q&&!this.w.extUri.isEqual($,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,s=O?await this.M(O):void 0;return new ie($,z,O,s,q,Y,x,F,H,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,W,j)}async M($){try{const q=await this.s.stat($);if(typeof q.mtime=="number")return q.mtime}catch{}}};e.AbstractExtensionsScannerService=K=ve([te(4,y.IUserDataProfilesService),te(5,D.IExtensionsProfileScannerService),te(6,a.IFileService),te(7,i.ILogService),te(8,E.IEnvironmentService),te(9,r.IProductService),te(10,m.IUriIdentityService),te(11,n.IInstantiationService)],K);class ie{constructor($,q,x,F,W,H,Y,j,z,O,s,P,U,B,X){this.location=$,this.mtime=q,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=F,this.profile=W,this.profileScanOptions=H,this.type=Y,this.excludeObsolete=j,this.validate=z,this.productVersion=O,this.productDate=s,this.productCommit=P,this.devMode=U,this.language=B,this.translations=X}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,q){return(0,g.isEqual)($.location,q.location)&&$.mtime===q.mtime&&(0,g.isEqual)($.applicationExtensionslocation,q.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&$.profile===q.profile&&k.equals($.profileScanOptions,q.profileScanOptions)&&$.type===q.type&&$.excludeObsolete===q.excludeObsolete&&$.validate===q.validate&&$.productVersion===q.productVersion&&$.productDate===q.productDate&&$.productCommit===q.productCommit&&$.devMode===q.devMode&&$.language===q.language&&J.equals($.translations,q.translations)}}e.ExtensionScannerInput=ie;let ue=class extends l.Disposable{constructor($,q,x,F,W){super(),this.f=$,this.g=q,this.h=x,this.i=F,this.j=W}async scanExtensions($){const q=$.profile?await this.l($):await this.k($);let x={};if($.excludeObsolete&&$.type===1)try{const F=(await this.i.readFile(this.f)).value.toString();x=JSON.parse(F)}catch{}return(0,u.isEmptyObject)(x)?q:q.filter(F=>!x[p.ExtensionKey.create(F).toString()])}async k($){const q=await this.i.resolve($.location);if(!q.children?.length)return[];const x=await Promise.all(q.children.map(async F=>{if(!F.isDirectory||$.type===1&&(0,g.basename)(F.resource).indexOf(".")===0)return null;const W=new ie(F.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.profileScanOptions,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(W)}));return(0,T.coalesce)(x).sort((F,W)=>F.location.path<W.location.path?-1:1)}async l($){let q=await this.m($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.h.extUri.isEqual($.location,$.applicationExtensionslocation)){q=q.filter(F=>!F.metadata?.isApplicationScoped);const x=await this.m($.applicationExtensionslocation,F=>!!F.metadata?.isBuiltin||!!F.metadata?.isApplicationScoped,$);q.push(...x)}return q}async m($,q,x){const F=await this.g.scanProfileExtensions($,x.profileScanOptions);if(!F.length)return[];const W=await Promise.all(F.map(async H=>{if(q(H)){const Y=new ie(H.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(Y,H.metadata)}return null}));return(0,T.coalesce)(W)}async scanOneOrMultipleExtensions($){try{if(await this.i.exists((0,g.joinPath)($.location,"package.json"))){const q=await this.scanExtension($);return q?[q]:[]}else return await this.scanExtensions($)}catch(q){return this.j.error(`Error scanning extensions at ${$.location.path}:`,(0,C.getErrorMessage)(q)),[]}}async scanExtension($,q){try{let x=await this.scanExtensionManifest($.location);if(x){x.publisher||(x.publisher=b.UNDEFINED_PUBLISHER),q=q??x.__metadata,delete x.__metadata;const F=(0,p.getGalleryExtensionId)(x.publisher,x.name),W=q?.id?{id:F,uuid:q.id}:{id:F},H=q?.isSystem?0:$.type,Y=H===0||!!q?.isBuiltin;x=await this.n($.location,x,ie.createNlsConfiguration($));const j={type:H,identifier:W,manifest:x,location:$.location,isBuiltin:Y,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return $.validate?this.validate(j,$):j}}catch(x){$.type!==0&&this.j.error(x)}return null}validate($,q){let x=!0;const F=(0,t.validateExtensionManifest)(q.productVersion,q.productDate,q.location,$.manifest,$.isBuiltin);for(const[W,H]of F)W===S.default.Error&&(x=!1,this.j.error(this.u(q.location,H)));return $.isValid=x,$.validations=F,$}async scanExtensionManifest($){const q=(0,g.joinPath)($,"package.json");let x;try{x=(await this.i.readFile(q)).value.toString()}catch(W){return(0,a.toFileOperationResult)(W)!==1&&this.j.error(this.u($,(0,f.localize)(0,null,q.path,W.message))),null}let F;try{F=JSON.parse(x)}catch{const H=[];(0,w.parse)(x,H);for(const Y of H)this.j.error(this.u($,(0,f.localize)(1,null,q.path,Y.offset,Y.length,(0,h.getParseErrorMessage)(Y.error))));return null}return(0,w.getNodeType)(F)!=="object"?(this.j.error(this.u($,(0,f.localize)(2,null,q.path))),null):F}async n($,q,x){const F=await this.r($,q,x);if(F)try{const W=[],H=await this.s(F.default,W);if(W.length>0)return W.forEach(j=>{this.j.error(this.u($,(0,f.localize)(3,null,F.default?.path,(0,h.getParseErrorMessage)(j.error))))}),q;if((0,w.getNodeType)(F)!=="object")return this.j.error(this.u($,(0,f.localize)(4,null,F.default?.path))),q;const Y=F.values||Object.create(null);return(0,M.localizeManifest)(q,Y,H)}catch{}return q}async r($,q,x){const F=(0,g.joinPath)($,"package.nls.json"),W=(z,O)=>{O.forEach(s=>{this.j.error(this.u($,(0,f.localize)(5,null,z?.path,(0,h.getParseErrorMessage)(s.error))))})},H=z=>{this.j.error(this.u($,(0,f.localize)(6,null,z?.path)))},Y=`${q.publisher}.${q.name}`,j=x.translations[Y];if(j)try{const z=d.URI.file(j),O=(await this.i.readFile(z)).value.toString(),s=[],P=(0,w.parse)(O,s);return s.length>0?(W(z,s),{values:void 0,default:F}):(0,w.getNodeType)(P)!=="object"?(H(z),{values:void 0,default:F}):{values:P.contents?P.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.i.exists(F))return;let O;try{O=await this.t($,x)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const s=(await this.i.readFile(O.localized)).value.toString(),P=[],U=(0,w.parse)(s,P);return P.length>0?(W(O.localized,P),{values:void 0,default:O.original}):(0,w.getNodeType)(U)!=="object"?(H(O.localized),{values:void 0,default:O.original}):{values:U,default:O.original}}catch{return{values:void 0,default:O.original}}}}async s($,q){if($)try{const x=(await this.i.readFile($)).value.toString();return(0,w.parse)(x,q)}catch{}}t($,q){return new Promise((x,F)=>{const W=H=>{const Y=(0,g.joinPath)($,`package.nls.${H}.json`);this.i.exists(Y).then(j=>{j&&x({localized:Y,original:(0,g.joinPath)($,"package.nls.json")});const z=H.lastIndexOf("-");z===-1?x({localized:(0,g.joinPath)($,"package.nls.json"),original:null}):(H=H.substring(0,z),W(H))})};if(q.devMode||q.pseudo||!q.language)return x({localized:(0,g.joinPath)($,"package.nls.json"),original:null});W(q.language)})}u($,q){return`[${$.path}]: ${q}`}};ue=ve([te(1,D.IExtensionsProfileScannerService),te(2,m.IUriIdentityService),te(3,a.IFileService),te(4,i.ILogService)],ue);let Q=class extends ue{constructor($,q,x,F,W,H,Y){super(q,F,W,H,Y),this.z=$,this.C=x,this.w=this.B(new L.ThrottledDelayer(3e3)),this.y=this.B(new o.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions($){const q=this.H($),x=await this.D(q);if(this.v=$,x&&x.input&&ie.equals(x.input,this.v))return this.j.debug("Using cached extensions scan result",$.location.toString()),this.w.trigger(()=>this.G()),x.result.map(W=>(W.location=d.URI.revive(W.location),W));const F=await super.scanExtensions($);return await this.F(q,{input:$,result:F}),F}async D($){try{const q=await this.i.readFile($),x=JSON.parse(q.value.toString());return{result:x.result,input:(0,c.revive)(x.input)}}catch(q){this.j.debug("Error while reading the extension cache file:",$.path,(0,C.getErrorMessage)(q))}return null}async F($,q){try{await this.i.writeFile($,A.VSBuffer.fromString(JSON.stringify(q)))}catch(x){this.j.debug("Error while writing the extension cache file:",$.path,(0,C.getErrorMessage)(x))}}async G(){if(!this.v)return;const $=this.H(this.v),q=await this.D($);if(!q)return;const x=q.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!k.equals(F,x))try{this.j.info("Invalidating Cache",x,F),await this.i.del($),this.y.fire()}catch(W){this.j.error(W)}}H($){const q=this.I($);return this.h.extUri.joinPath(q.cacheHome,$.type===0?b.BUILTIN_MANIFEST_CACHE_FILE:b.USER_MANIFEST_CACHE_FILE)}I($){return $.type===0?this.C.defaultProfile:$.profile?this.h.extUri.isEqual($.location,this.z.extensionsResource)?this.z:this.C.profiles.find(q=>this.h.extUri.isEqual($.location,q.extensionsResource))??this.z:this.C.defaultProfile}};Q=ve([te(2,y.IUserDataProfilesService),te(3,D.IExtensionsProfileScannerService),te(4,m.IUriIdentityService),te(5,a.IFileService),te(6,i.ILogService)],Q);function ce(se,$){const q=(0,p.getExtensionId)(se.manifest.publisher,se.manifest.name);return{id:q,identifier:new b.ExtensionIdentifier(q),isBuiltin:se.type===0,isUserBuiltin:se.type===1&&se.isBuiltin,isUnderDevelopment:$,extensionLocation:se.location,uuid:se.identifier.uuid,targetPlatform:se.targetPlatform,...se.manifest}}e.toExtensionDescription=ce;class oe extends K{constructor($,q,x,F,W,H,Y,j,z,O,s,P){super($,q,(0,g.joinPath)(x,".vscode-oss-dev","extensions","control.json"),F,W,H,Y,j,z,O,s,P),this.N=(async()=>{if(v.translationsConfigFile)try{const U=await this.s.readFile(d.URI.file(v.translationsConfigFile));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}f($){return this.N}}e.NativeExtensionsScannerService=oe}),define(ne[151],re([0,1,58,8,33,5,2,16,15,22,6,21]),function(G,e,T,L,k,A,C,w,h,l,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=e.ExtensionsLifecycle=class extends C.Disposable{constructor(N,S){super(),this.b=N,this.f=S,this.a=new L.Limiter(5)}async postUninstall(N){const S=this.g(N,"uninstall");S&&(this.f.info(N.identifier.id,N.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(S.script,"uninstall",S.args,!0,N),this.f.info("Finished running post uninstall script",N.identifier.id,N.manifest.version)}catch(u){this.f.error("Failed to run post uninstall script",N.identifier.id,N.manifest.version),this.f.error(u)}}));try{await l.Promises.rm(this.j(N))}catch(u){this.f.error("Error while removing extension storage path",N.identifier.id),this.f.error(u)}}g(N,S){const u=`vscode:${S}`;if(N.location.scheme===w.Schemas.file&&N.manifest&&N.manifest.scripts&&typeof N.manifest.scripts[u]=="string"){const d=N.manifest.scripts[u].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(N.identifier.id,N.manifest.version,`${u} should be a node script`),null):{script:(0,h.join)(N.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(N,S,u,d,f){return new Promise((E,p)=>{const b=this.i(N,S,u,f);let t;const a=n=>{t&&(clearTimeout(t),t=null),n?p(n):E(void 0)};b.on("error",n=>{a((0,k.toErrorMessage)(n)||"Unknown")}),b.on("exit",(n,i)=>{a(n?`post-${S} process exited with code ${n}`:void 0)}),d&&(t=setTimeout(()=>{t=null,b.kill(),p("timed out")},5e3))})}i(N,S,u,d){const f={silent:!0,execArgv:void 0},E=(0,T.fork)(N,[`--type=extension-post-${S}`,...u],f);E.stdout.setEncoding("utf8"),E.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(E.stdout,"data"),b=A.Event.fromNodeEventEmitter(E.stderr,"data");p(n=>this.f.info(d.identifier.id,d.manifest.version,`post-${S}`,n)),b(n=>this.f.error(d.identifier.id,d.manifest.version,`post-${S}`,n));const t=A.Event.any(A.Event.map(p,n=>({data:`%c${n}`,format:[""]})),A.Event.map(b,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(t,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(d.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),E}j(N){return(0,h.join)(this.b.defaultProfile.globalStorageHome.fsPath,N.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=v=ve([te(0,I.IUserDataProfilesService),te(1,R.ILogService)],v)}),define(ne[152],re([0,1,6,21,27,25,40,13,18,11]),function(G,e,T,L,k,A,C,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let R=e.ExtensionsProfileScannerService=class extends C.AbstractExtensionsProfileScannerService{constructor(v,g,N,S,u,d){super(l.URI.file(v.extensionsPath),g,N,S,u,d)}};e.ExtensionsProfileScannerService=R=ve([te(0,h.INativeEnvironmentService),te(1,w.IFileService),te(2,L.IUserDataProfilesService),te(3,k.IUriIdentityService),te(4,A.ITelemetryService),te(5,T.ILogService)],R)}),define(ne[153],re([0,1,11,18,40,49,13,10,6,31,27,21]),function(G,e,T,L,k,A,C,w,h,l,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let v=e.ExtensionsScannerService=class extends A.NativeExtensionsScannerService{constructor(N,S,u,d,f,E,p,b){super(T.URI.file(f.builtinExtensionsPath),T.URI.file(f.extensionsPath),f.userHome,N.defaultProfile,N,S,u,d,f,E,p,b)}};e.ExtensionsScannerService=v=ve([te(0,I.IUserDataProfilesService),te(1,k.IExtensionsProfileScannerService),te(2,C.IFileService),te(3,h.ILogService),te(4,L.INativeEnvironmentService),te(5,l.IProductService),te(6,R.IUriIdentityService),te(7,w.IInstantiationService)],v)}),define(ne[154],re([0,1,8,5,2,121,3,84,10,21]),function(G,e,T,L,k,A,C,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var R;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var I;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var v;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function g(f){const E=f.get(e.TARGET_KEY);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}e.loadKeyTargets=g;class N extends k.Disposable{constructor(E={flushInterval:N.a}){super(),this.j=E,this.b=this.B(new L.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new L.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new T.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,T.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(E,p){if(p===e.TARGET_KEY){switch(E){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:E})}else this.b.fire({scope:E,key:p,target:this.F(E)[p]})}r(E){this.f.fire({reason:E})}get(E,p,b){return this.L(p)?.get(E,b)}getBoolean(E,p,b){return this.L(p)?.getBoolean(E,b)}getNumber(E,p,b){return this.L(p)?.getNumber(E,b)}getObject(E,p,b){return this.L(p)?.getObject(E,b)}store(E,p,b,t){if((0,C.isUndefinedOrNull)(p)){this.remove(E,b);return}this.t(()=>{this.u(E,b,t),this.L(b)?.set(E,p)})}remove(E,p){this.t(()=>{this.u(E,p,void 0),this.L(p)?.delete(E)})}t(E){this.b.pause(),this.c.pause();try{E()}finally{this.b.resume(),this.c.resume()}}keys(E,p){const b=[],t=this.F(E);for(const a of Object.keys(t))t[a]===p&&b.push(a);return b}u(E,p,b){const t=this.F(p);typeof b=="number"?t[E]!==b&&(t[E]=b,this.L(p)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[E]=="number"&&(delete t[E],this.L(p)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(E){switch(E){case-1:return this.D;case 0:return this.z;default:return this.w}}G(E){const p=this.L(E);return p?g(p):Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(E=R.NONE){this.f.fire({reason:E});const p=this.L(-1),b=this.L(0),t=this.L(1);switch(E){case R.NONE:await T.Promises.settled([p?.whenFlushed()??Promise.resolve(),b?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await T.Promises.settled([p?.flush(0)??Promise.resolve(),b?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const E=this.L(-1)?.items??new Map,p=this.L(0)?.items??new Map,b=this.L(1)?.items??new Map;return d(E,p,b,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(E,p){return this.r(R.NONE),(0,l.isUserDataProfile)(E)?this.N(E,p):this.O(E,p)}H(E,p){return!(E.id===p.id||S(p)&&S(E))}I(E,p,b,t){this.t(()=>{if(t)for(const[a,n]of E)p.set(a,n);else{const a=new Set;for(const[n,i]of E)a.add(n),p.get(n)!==i&&this.n(b,n);for(const[n]of p.items)a.has(n)||this.n(b,n)}})}}e.AbstractStorageService=N,N.a=60*1e3;function S(f){return f.isDefault||!!f.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class u extends N{constructor(){super(),this.p=this.B(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(E=>this.n(1,E))),this.B(this.P.onDidChangeStorage(E=>this.n(0,E))),this.B(this.p.onDidChangeStorage(E=>this.n(-1,E)))}L(E){switch(E){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(E){switch(E){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(E){return!1}}e.InMemoryStorageService=u;async function d(f,E,p,b,t,a){const n=J=>{try{return JSON.parse(J)}catch{return J}},i=new Map,r=new Map;f.forEach((J,K)=>{i.set(K,J),r.set(K,n(J))});const o=new Map,c=new Map;E.forEach((J,K)=>{o.set(K,J),c.set(K,n(J))});const D=new Map,y=new Map;p.forEach((J,K)=>{D.set(K,J),y.set(K,n(J))}),console.group(b!==t?`Storage: Application (path: ${b})`:`Storage: Application & Profile (path: ${b}, default profile)`);const m=[];if(i.forEach((J,K)=>{m.push({key:K,value:J})}),console.table(m),console.groupEnd(),console.log(r),b!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const J=[];o.forEach((K,ie)=>{J.push({key:ie,value:K})}),console.table(J),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${a})`);const M=[];D.forEach((J,K)=>{M.push({key:K,value:J})}),console.table(M),console.groupEnd(),console.log(y)}e.logStorage=d}),define(ne[155],re([0,1,19,23,9,12,34,3,11,24,18,20,26,47,13,6,31,43,140,154,25]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g,N,S,u,d,f,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const b=A.isWeb?"web":(0,I.getTargetPlatform)(A.platform,C.arch),t="X-Market-Search-Activity-Id";var a;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function n(...O){return String(O.reduce((s,P)=>s|P,0))}var i;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class y{constructor(s=D){this.d=s}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(s,P=this.d.pageSize){return new y({...this.d,pageNumber:s,pageSize:P})}withFilter(s,...P){const U=[...this.d.criteria,...P.length?P.map(B=>({filterType:s,value:B})):[{filterType:s}]];return new y({...this.d,criteria:U})}withSortBy(s){return new y({...this.d,sortBy:s})}withSortOrder(s){return new y({...this.d,sortOrder:s})}withFlags(...s){return new y({...this.d,flags:s.reduce((P,U)=>P|U,0)})}withAssetTypes(...s){return new y({...this.d,assetTypes:s})}withSource(s){return new y({...this.d,source:s})}get raw(){const{criteria:s,pageNumber:P,pageSize:U,sortBy:B,sortOrder:X,flags:_,assetTypes:le}=this.d;return{filters:[{criteria:s,pageNumber:P,pageSize:U,sortBy:B,sortOrder:X}],assetTypes:le,flags:_}}get searchText(){const s=this.d.criteria.filter(P=>P.filterType===i.SearchText)[0];return s&&s.value?s.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(s=>String(s.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function m(O,s){const P=(O||[]).filter(U=>U.statisticName===s)[0];return P?P.value:0}function M(O){const s="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(U=>U.assetType.indexOf(s)===0).reduce((U,B)=>{const X=ie(O,B.assetType);return X&&U.push([B.assetType.substring(s.length),X]),U},[])}function J(O){if(O.properties){const s=O.properties.filter(B=>B.key===r.Repository),P=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=s.filter(B=>P.test(B.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return ie(O,r.Repository)}function K(O){return{uri:`${O.fallbackAssetUri}/${r.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${r.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function ie(O,s){return O.files.filter(U=>U.assetType===s)[0]?{uri:`${O.assetUri}/${s}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${s}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function ue(O,s){const P=O.properties?O.properties.filter(B=>B.key===s):[],U=P.length>0&&P[0].value;return U?U.split(",").map(B=>(0,v.adoptToGalleryExtensionId)(B)):[]}function Q(O){const s=O.properties?O.properties.filter(P=>P.key===o.Engine):[];return s.length>0&&s[0].value||""}function ce(O){const s=O.properties?O.properties.filter(P=>P.key===o.PreRelease):[];return s.length>0&&s[0].value==="true"}function oe(O){const s=O.properties?O.properties.filter(U=>U.key===o.LocalizedLanguages):[],P=s.length>0&&s[0].value||"";return P?P.split(","):[]}function se(O){return O.properties?.find(s=>s.key===o.SponsorLink)?.value}function $(O){return O.indexOf("preview")!==-1}function q(O){return O.targetPlatform?(0,I.toTargetPlatform)(O.targetPlatform):"undefined"}function x(O){const s=(0,T.distinct)(O.versions.map(q)),P=!!O.tags?.includes(I.WEB_EXTENSION_TAG),U=s.indexOf("web");return P?U===-1&&s.push("web"):U!==-1&&s.splice(U,1),s}function F(O,s){const P=(0,I.getFallbackTargetPlarforms)(s);for(let U=0;U<O.length;U++){const B=O[U];if(B.version===O[U-1]?.version){let X=U;const _=q(B);if(_===s)for(;X>0&&O[X-1].version===B.version;)X--;else if(P.includes(_))for(;X>0&&O[X-1].version===B.version&&q(O[X-1])!==s;)X--;X!==U&&(O.splice(U,1),O.splice(X,0,B))}}return O}e.sortExtensionVersions=F;function W(O,s,P){O.telemetryData={index:s,querySource:P,queryActivityId:O.queryContext?.[t]}}function H(O,s,P,U){const B=O.versions[0],X={manifest:ie(s,r.Manifest),readme:ie(s,r.Details),changelog:ie(s,r.Changelog),license:ie(s,r.License),repository:J(s),download:K(s),icon:ie(s,r.Icon),signature:ie(s,r.Signature),coreTranslations:M(s)};return{identifier:{id:(0,v.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:s.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:se(B),description:O.shortDescription||"",installCount:m(O.statistics,"install"),rating:m(O.statistics,"averagerating"),ratingCount:m(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:P,assets:X,properties:{dependencies:ue(s,o.Dependency),extensionPack:ue(s,o.ExtensionPack),engine:Q(s),localizedLanguages:oe(s),targetPlatform:q(s),isPreReleaseVersion:ce(s)},hasPreReleaseVersion:ce(B),hasReleaseVersion:!0,preview:$(O.flags),isSigned:!!X.signature,queryContext:U}}let Y=class{constructor(s,P,U,B,X,_,le,de){this.k=P,this.l=U,this.n=B,this.o=X,this.q=_,this.u=le,this.w=de;const pe=le.extensionsGallery,he=pe?.servicePPEUrl&&de.getValue("_extensionsGallery.enablePPE");this.d=he?pe.servicePPEUrl:pe?.serviceUrl,this.g=he?void 0:pe?.searchUrl,this.h=pe?.controlUrl,this.j=(0,f.resolveMarketplaceHeaders)(le.version,le,this.n,this.w,this.q,s,this.o)}x(s=""){return`${this.d}${s}`}isEnabled(){return!!this.d}async getExtensions(s,P,U){const B=L.CancellationToken.isCancellationToken(P)?{}:P,X=L.CancellationToken.isCancellationToken(P)?P:U,_=[],le=[],de=[],pe=[];let he=!0;for(const fe of s){fe.uuid?le.push(fe.uuid):_.push(fe.id);const we=!!(fe.version||fe.preRelease);de.push({id:fe.id,uuid:fe.uuid,includePreRelease:we}),fe.version&&pe.push({id:fe.id,uuid:fe.uuid,version:fe.version}),he=he&&!!fe.hasPreRelease&&!we}if(!le.length&&!_.length)return[];let ge=new y().withPage(1,s.length);le.length&&(ge=ge.withFilter(i.ExtensionId,...le)),_.length&&(ge=ge.withFilter(i.ExtensionName,..._)),(B.queryAllVersions||he)&&(ge=ge.withFlags(ge.flags,a.IncludeVersions)),B.source&&(ge=ge.withSource(B.source));const{extensions:ae}=await this.z(ge,{targetPlatform:B.targetPlatform??b,includePreRelease:de,versions:pe,compatible:!!B.compatible},X);return B.source&&ae.forEach((fe,we)=>W(fe,we,B.source)),ae}async getCompatibleExtension(s,P,U){if((0,I.isNotWebExtensionInWebTargetPlatform)(s.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(s,P,U))return s;const B=new y().withFlags(a.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,s.identifier.uuid),{extensions:X}=await this.z(B,{targetPlatform:U,compatible:!0,includePreRelease:P},L.CancellationToken.None);return X[0]||null}async isExtensionCompatible(s,P,U){if(!(0,I.isTargetPlatformCompatible)(s.properties.targetPlatform,s.allTargetPlatforms,U)||!P&&s.properties.isPreReleaseVersion)return!1;let B=s.properties.engine;if(!B){const X=await this.getManifest(s,L.CancellationToken.None);if(!X)throw new Error("Manifest was not found");B=X.engines.vscode}return(0,g.isEngineValid)(B,this.u.version,this.u.date)}async y(s,P,U,B,X){if(!(0,I.isTargetPlatformCompatible)(q(s),B,X)||P!=="any"&&ce(s)!==(P==="prerelease"))return!1;if(U)try{const _=await this.E(s);if(!(0,g.isEngineValid)(_,this.u.version,this.u.date))return!1}catch(_){return this.l.error(`Error while getting the engine for the version ${s.version}.`,(0,k.getErrorMessage)(_)),!1}return!0}async query(s,P){let U=s.text||"";const B=s.pageSize??50;let X=new y().withPage(1,B);U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ge,ae)=>(X=X.withFilter(i.Category,ae||ge),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ge,ae)=>(X=X.withFilter(i.Tag,ae||ge),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(i.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),X=X.withFilter(i.SearchText,U)),X=X.withSortBy(0)):s.ids?X=X.withFilter(i.ExtensionId,...s.ids):s.names?X=X.withFilter(i.ExtensionName,...s.names):X=X.withSortBy(4),typeof s.sortBy=="number"&&(X=X.withSortBy(s.sortBy)),typeof s.sortOrder=="number"&&(X=X.withSortOrder(s.sortOrder)),s.source&&(X=X.withSource(s.source));const _=async(he,ge)=>{const{extensions:ae,total:fe}=await this.z(he,{targetPlatform:b,compatible:!1,includePreRelease:!!s.includePreRelease},ge);return ae.forEach((we,Re)=>W(we,(he.pageNumber-1)*he.pageSize+Re,s.source)),{extensions:ae,total:fe}},{extensions:le,total:de}=await _(X,P),pe=async(he,ge)=>{if(ge.isCancellationRequested)throw new k.CancellationError;const{extensions:ae}=await _(X.withPage(he+1),ge);return ae};return{firstPage:le,total:de,pageSize:X.pageSize,getPage:pe}}async z(s,P,U){const B=s.flags;s.flags&a.IncludeLatestVersionOnly&&s.flags&a.IncludeVersions&&(s=s.withFlags(s.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(s.flags&a.IncludeLatestVersionOnly)&&!(s.flags&a.IncludeVersions)&&(s=s.withFlags(s.flags,a.IncludeLatestVersionOnly)),P.versions?.length&&(s=s.withFlags(s.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),s=s.withFlags(s.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:X,total:_,context:le}=await this.B(s,U);if(!(s.flags&a.IncludeLatestVersionOnly)){const ge=[];for(const ae of X){const fe=await this.A(ae,P,le);fe&&ge.push(fe)}return{extensions:ge,total:_}}const pe=[],he=new Map;for(let ge=0;ge<X.length;ge++){const ae=X[ge],fe={id:(0,v.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),uuid:ae.extensionId},we=(0,w.isBoolean)(P.includePreRelease)?P.includePreRelease:!!P.includePreRelease.find(Ce=>(0,v.areSameExtensions)(Ce,fe))?.includePreRelease;if(P.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(x(ae),P.targetPlatform))continue;const Re=await this.A(ae,P,le);!Re||Re.properties.isPreReleaseVersion&&(!we||!Re.hasReleaseVersion)||!Re.properties.isPreReleaseVersion&&Re.properties.targetPlatform!==P.targetPlatform&&Re.hasPreReleaseVersion?he.set(ae.extensionId,ge):pe.push([ge,Re])}if(he.size){const ge=new Date().getTime(),ae=new y().withFlags(B&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,he.size).withFilter(i.ExtensionId,...he.keys()),{extensions:fe}=await this.z(ae,P,U);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:he.size});for(const we of fe){const Re=he.get(we.identifier.uuid);pe.push([Re,we])}}return{extensions:pe.sort((ge,ae)=>ge[0]-ae[0]).map(([,ge])=>ge),total:_}}async A(s,P,U){const B={id:(0,v.getGalleryExtensionId)(s.publisher.publisherName,s.extensionName),uuid:s.extensionId},X=P.versions?.find(pe=>(0,v.areSameExtensions)(pe,B))?.version,_=(0,w.isBoolean)(P.includePreRelease)?P.includePreRelease:!!P.includePreRelease.find(pe=>(0,v.areSameExtensions)(pe,B))?.includePreRelease,le=x(s),de=F(s.versions,P.targetPlatform);if(P.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(le,P.targetPlatform))return null;for(let pe=0;pe<de.length;pe++){const he=de[pe];if(!(X&&he.version!==X)){if(await this.y(he,_?"any":"release",P.compatible,le,P.targetPlatform))return H(s,he,le,U);if(X&&he.version===X)return null}}return X||P.compatible?null:H(s,s.versions[0],le)}async B(s,P){if(!this.isEnabled())throw new Error("No extension gallery service configured.");s=s.withFlags(s.flags,a.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(a.Unpublished));const U=await this.j,B=JSON.stringify(s.raw),X={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},_=new Date().getTime();let le,de,pe=0;try{if(le=await this.k.request({type:"POST",url:this.g&&s.criteria.some(ge=>ge.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:B,headers:X},P),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:pe};const he=await(0,d.asJson)(le);if(he){const ge=he.results[0],ae=ge.extensions,fe=ge.resultMetadata&&ge.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return pe=fe&&fe.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:ae,total:pe,context:{[t]:le.res.headers.activityid}}}return{galleryExtensions:[],total:pe}}catch(he){throw de=he,he}finally{this.o.publicLog2("galleryService:query",{...s.telemetryData,requestBodySize:String(B.length),duration:new Date().getTime()-_,success:!!le&&(0,d.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:de?(0,k.isCancellationError)(de)?"canceled":(0,k.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(pe)})}}async reportStatistic(s,P,U,B){if(!this.isEnabled())return;const X=A.isWeb?this.x(`/itemName/${s}.${P}/version/${U}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${s}/extensions/${P}/${U}/stats?statType=${B}`),_=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",de={...await this.j,Accept:_};try{await this.k.request({type:"POST",url:X,headers:de},L.CancellationToken.None)}catch{}}async download(s,P,U){this.l.trace("ExtensionGalleryService#download",s.identifier.id);const B=(0,v.getGalleryExtensionTelemetryData)(s),X=new Date().getTime(),_=ge=>this.o.publicLog("galleryService:downloadVSIX",{...B,duration:ge}),le=U===2?"install":U===3?"update":"",de=le?{uri:`${s.assets.download.uri}${h.URI.parse(s.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${s.assets.download.fallbackUri}${h.URI.parse(s.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:s.assets.download,pe=s.queryContext?.[t]?{[t]:s.queryContext[t]}:void 0,he=await this.D(de,pe?{headers:pe}:void 0);await this.q.writeFile(P,he.stream),_(new Date().getTime()-X)}async downloadSignatureArchive(s,P){if(!s.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",s.identifier.id);const U=await this.D(s.assets.signature);await this.q.writeFile(P,U.stream)}async getReadme(s,P){if(s.assets.readme){const U=await this.D(s.assets.readme,{},P);return await(0,d.asTextOrError)(U)||""}return""}async getManifest(s,P){if(s.assets.manifest){const U=await this.D(s.assets.manifest,{},P),B=await(0,d.asTextOrError)(U);return B?JSON.parse(B):null}return null}async C(s,P){const U=ie(s,r.Manifest);if(!U)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},X=await this.D(U,{headers:B});return await(0,d.asJson)(X)}async getCoreTranslation(s,P){const U=s.assets.coreTranslations.filter(B=>B[0]===P.toUpperCase())[0];if(U){const B=await this.D(U[1]),X=await(0,d.asTextOrError)(B);return X?JSON.parse(X):null}return null}async getChangelog(s,P){if(s.assets.changelog){const U=await this.D(s.assets.changelog,{},P);return await(0,d.asTextOrError)(U)||""}return""}async getAllCompatibleVersions(s,P,U){let B=new y().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);s.identifier.uuid?B=B.withFilter(i.ExtensionId,s.identifier.uuid):B=B.withFilter(i.ExtensionName,s.identifier.id);const{galleryExtensions:X}=await this.B(B,L.CancellationToken.None);if(!X.length)return[];const _=x(X[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(_,U))return[];const le=[];await Promise.all(X[0].versions.map(async he=>{try{await this.y(he,P?"any":"release",!0,_,U)&&le.push(he)}catch{}}));const de=[],pe=new Set;for(const he of F(le,U))pe.has(he.version)||(pe.add(he.version),de.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:ce(he)}));return de}async D(s,P={},U=L.CancellationToken.None){const B=await this.j,X={type:"GET"},_={...B,...P.headers||{}};P={...P,...X,headers:_};const le=s.uri,de=s.fallbackUri,pe={...P,url:le};try{const he=await this.k.request(pe,U);if(he.res.statusCode===200)return he;const ge=await(0,d.asTextOrError)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${ge}`)}catch(he){if((0,k.isCancellationError)(he))throw he;const ge=(0,k.getErrorMessage)(he);this.o.publicLog2("galleryService:cdnFallback",{url:le,message:ge});const ae={...P,url:de};return this.k.request(ae,U)}}async E(s){let P=Q(s);if(!P){const U=await this.C(s,L.CancellationToken.None);if(!U)throw new Error("Manifest was not found");P=U.engines.vscode}return P}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const s=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(s.res.statusCode!==200)throw new Error("Could not get extensions report.");const P=await(0,d.asJson)(s),U=[],B={};if(P){for(const X of P.malicious)U.push({id:X});if(P.migrateToPreRelease)for(const[X,_]of Object.entries(P.migrateToPreRelease))(!_.engine||(0,g.isEngineValid)(_.engine,this.u.version,this.u.date))&&(B[X.toLowerCase()]={disallowInstall:!0,extension:{id:_.id,displayName:_.displayName,autoMigrate:{storage:!!_.migrateStorage},preRelease:!0}});if(P.deprecated)for(const[X,_]of Object.entries(P.deprecated))_&&(B[X.toLowerCase()]=(0,w.isBoolean)(_)?{}:_)}return{malicious:U,deprecated:B}}};Y=ve([te(1,d.IRequestService),te(2,S.ILogService),te(3,R.IEnvironmentService),te(4,p.ITelemetryService),te(5,N.IFileService),te(6,u.IProductService),te(7,l.IConfigurationService)],Y);let j=e.ExtensionGalleryService=class extends Y{constructor(s,P,U,B,X,_,le,de){super(s,P,U,B,X,_,le,de)}};e.ExtensionGalleryService=j=ve([te(0,E.IStorageService),te(1,d.IRequestService),te(2,S.ILogService),te(3,R.IEnvironmentService),te(4,p.ITelemetryService),te(5,N.IFileService),te(6,u.IProductService),te(7,l.IConfigurationService)],j);let z=e.ExtensionGalleryServiceWithNoStorageService=class extends Y{constructor(s,P,U,B,X,_,le){super(void 0,s,P,U,B,X,_,le)}};e.ExtensionGalleryServiceWithNoStorageService=z=ve([te(0,d.IRequestService),te(1,S.ILogService),te(2,R.IEnvironmentService),te(3,p.ITelemetryService),te(4,N.IFileService),te(5,u.IProductService),te(6,l.IConfigurationService)],z)}),define(ne[156],re([0,1,11,18,13,6,137,27,21,3,68]),function(G,e,T,L,k,A,C,w,h,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let I=e.UserDataProfilesReadonlyService=class Ve extends h.UserDataProfilesService{constructor(S,u,d,f,E){super(d,f,u,E),this.P=S,this.Q=d}J(){return this.P.getItem(Ve.b,[]).map(u=>({...u,location:(0,l.isString)(u.location)?this.s.extUri.joinPath(this.profilesHome,u.location):T.URI.revive(u.location)}))}M(){const S=this.P.getItem(Ve.c,{});return this.P.getItem(Ve.a,!1)?S:this.I(S)}O(){return this.s.extUri.joinPath(T.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};I.a="profileAssociationsMigration",e.UserDataProfilesReadonlyService=I=ve([te(0,C.IStateReadService),te(1,w.IUriIdentityService),te(2,L.INativeEnvironmentService),te(3,k.IFileService),te(4,A.ILogService)],I);let v=e.UserDataProfilesService=class ze extends I{constructor(S,u,d,f,E){super(S,u,d,f,E),this.W=S}L(S){S.length?this.W.setItem(ze.b,S.map(u=>({...u,location:this.s.extUri.basename(u.location)}))):this.W.removeItem(ze.b)}J(){const S=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(S),this.W.setItem("userDataProfilesMigration",!0)),S}N(S){S.emptyWindows||S.workspaces?this.W.setItem(ze.c,S):this.W.removeItem(ze.c)}M(){const S="workspaceAndProfileInfo",u=this.W.getItem(S,void 0);if(u){this.W.removeItem(S);const f=u.reduce((E,{workspace:p,profile:b})=>(E[T.URI.revive(p).toString()]=T.URI.revive(b).toString(),E),{});this.W.setItem(ze.c,{workspaces:f})}const d=super.M();return this.W.getItem(ze.a,!1)||(this.N(d),this.W.setItem(ze.a,!0)),d}};e.UserDataProfilesService=v=ve([te(0,C.IStateService),te(1,w.IUriIdentityService),te(2,L.INativeEnvironmentService),te(3,k.IFileService),te(4,A.ILogService)],v);let g=e.ServerUserDataProfilesService=class extends v{constructor(S,u,d,f){super(new R.StateService(0,u,f,d),S,u,d,f)}async init(){return await this.W.init(),super.init()}};e.ServerUserDataProfilesService=g=ve([te(0,w.IUriIdentityService),te(1,L.INativeEnvironmentService),te(2,k.IFileService),te(3,A.ILogService)],g)}),define(ne[50],re([0,1,123,8,15,3,22,85,172,173]),function(G,e,T,L,k,A,C,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const R=new RegExp(e.CorruptZipMessage);class I extends Error{constructor(a,n){let i=n.message;switch(a){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=a,this.cause=n}}e.ExtractError=I;function v(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(n=>a&n).reduce((n,i)=>n+i,a&61440)}function g(t){if(t instanceof I)return t;let a;return R.test(t.message)&&(a="CorruptZip"),new I(a,t)}function N(t,a,n,i,r,o){const c=k.dirname(a),D=k.join(i,c);if(!D.startsWith(i))return Promise.reject(new Error(w.localize(0,null,a)));const y=k.join(i,a);let m;return o.onCancellationRequested(()=>{m?.destroy()}),Promise.resolve(C.Promises.mkdir(D,{recursive:!0})).then(()=>new Promise((M,J)=>{if(!o.isCancellationRequested)try{m=(0,T.createWriteStream)(y,{mode:n}),m.once("close",()=>M()),m.once("error",J),t.once("error",J),t.pipe(m)}catch(K){J(K)}}))}function S(t,a,n,i){let r=(0,L.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{r.cancel(),t.close()}),new Promise((c,D)=>{const y=new L.Sequencer,m=M=>{M.isCancellationRequested||(o++,t.readEntry())};t.once("error",D),t.once("close",()=>r.then(()=>{i.isCancellationRequested||t.entryCount===o?c():D(new I("Incomplete",new Error(w.localize(1,null,o,t.entryCount))))},D)),t.readEntry(),t.on("entry",M=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(M.fileName)){m(i);return}const J=M.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(J)){const ue=k.join(a,J);r=(0,L.createCancelablePromise)(Q=>C.Promises.mkdir(ue,{recursive:!0}).then(()=>m(Q)).then(void 0,D));return}const K=d(t,M),ie=v(M);r=(0,L.createCancelablePromise)(ue=>y.queue(()=>K.then(Q=>N(Q,J,ie,a,n,ue).then(()=>m(ue)))).then(null,D))})})}function u(t,a=!1){return new Promise((n,i)=>{(0,h.open)(t,a?{lazyEntries:!0}:void 0,(r,o)=>{r?i(g(r)):n((0,A.assertIsDefined)(o))})})}function d(t,a){return new Promise((n,i)=>{t.openReadStream(a,(r,o)=>{r?i(g(r)):n((0,A.assertIsDefined)(o))})})}function f(t,a){return new Promise((n,i)=>{const r=new l.ZipFile;a.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const o=(0,T.createWriteStream)(t);r.outputStream.pipe(o),r.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>n(t))})}e.zip=f;function E(t,a,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=u(t,!0);return n.overwrite&&(o=o.then(c=>C.Promises.rm(a).then(()=>c))),o.then(c=>S(c,a,{sourcePathRegex:r},i))}e.extract=E;function p(t,a){return u(t).then(n=>new Promise((i,r)=>{n.on("entry",o=>{o.fileName===a&&d(n,o).then(c=>i(c),c=>r(c))}),n.once("close",()=>r(new Error(w.localize(2,null,a))))}))}function b(t,a){return p(t,a).then(n=>new Promise((i,r)=>{const o=[];n.once("error",r),n.on("data",c=>o.push(c)),n.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=b}),define(ne[157],re([0,1,8,9,2,16,12,17,41,3,28,22,50,24,18,20,26,60,13,6]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g,N,S,u,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=e.ExtensionsDownloader=class $e extends k.Disposable{constructor(t,a,n,i,r,o){super(),this.h=a,this.i=n,this.j=i,this.k=r,this.l=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,a,n){await this.g;const i=(0,w.joinPath)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,i,o=>this.i.download(t,o,a))}catch(o){throw new S.ExtensionManagementError(o.message,S.ExtensionManagementErrorCode.Download)}let r=!1;if(n&&this.m(t)){const o=await this.n(t);try{r=await this.k.verify(i.fsPath,o.fsPath,this.l.getLevel()===E.LogLevel.Trace)}catch(c){const D=c;if(r=D.code,D.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${D.output}`),r===S.ExtensionSignaturetErrorCode.PackageIsInvalidZip||r===S.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new S.ExtensionManagementError(v.CorruptZipMessage,S.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(c){this.l.error(c)}}}return r===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):r===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${r}': ${t.identifier.id}`),{location:i,verificationStatus:r}}m(t){if(!t.isSigned)return!1;const a=this.j.getValue("extensions.verifySignature");return(0,l.isBoolean)(a)?a:!0}async n(t){await this.g;const a=(0,w.joinPath)(this.extensionsDownloadDir,`${this.v(t)}${$e.c}`);return await this.r(t,a,n=>this.i.downloadSignatureArchive(t,n)),a}async r(t,a,n){if(await this.h.exists(a))return;if(a.scheme!==A.Schemas.file){await n(a);return}const i=(0,w.joinPath)(this.extensionsDownloadDir,`.${(0,R.generateUuid)()}`);await this.h.exists(i)||await n(i);try{await this.t(i,a,Date.now()+2*60*1e3)}catch(r){try{await this.h.del(i)}catch{}if(r.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.l.info(`Rename failed because of ${(0,L.getErrorMessage)(r)}. Deleted the file from downloaded location`,i.path),r}}async delete(t){await this.g,await this.h.del(t)}async t(t,a,n){try{await I.Promises.rename(t.fsPath,a.fsPath)}catch(i){if(C.isWindows&&i&&i.code==="EPERM"&&Date.now()<n)return this.l.info(`Failed renaming ${t} to ${a} with 'EPERM' error. Trying again...`),this.t(t,a,n);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],n=[],i=[];for(const c of t.children)if(c.name.endsWith($e.c))i.push(c.resource);else{const D=u.ExtensionKey.parse(c.name);D&&n.push([D,c])}const r=(0,u.groupByExtension)(n,([c])=>c),o=[];for(const c of r)c.sort((D,y)=>h.rcompare(D[0].version,y[0].version)),a.push(...c.slice(1).map(D=>D[1].resource)),o.push(c[0][1]);o.sort((c,D)=>c.mtime-D.mtime),a.push(...o.slice(0,Math.max(0,o.length-this.f)).map(c=>c.resource)),a.push(...i),await T.Promises.settled(a.map(c=>(this.l.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(t){this.l.error(t)}}v(t){return this.f?u.ExtensionKey.create(t).toString().toLowerCase():(0,R.generateUuid)()}};p.c=".sigzip",e.ExtensionsDownloader=p=ve([te(0,N.INativeEnvironmentService),te(1,f.IFileService),te(2,S.IExtensionGalleryService),te(3,g.IConfigurationService),te(4,d.IExtensionSignatureVerificationService),te(5,E.ILogService)],p)}),define(ne[158],re([0,1,50,95]),function(G,e,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(A){return(0,T.buffer)(A,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}e.getManifest=k}),define(ne[159],re([0,1,8,14,23,33,9,5,2,35,16,15,12,17,41,3,11,28,22,50,94,59,18,150,20,26,40,49,157,151,158,132,139,47,13,10,6,31,25,27,21]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g,N,S,u,d,f,E,p,b,t,a,n,i,r,o,c,D,y,m,M,J,K,ie,ue,Q,ce,oe,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ie.refineServiceDecorator)(n.IExtensionManagementService);let $=e.ExtensionManagementService=class extends a.AbstractExtensionManagementService{constructor(j,z,O,s,P,U,B,X,_,le,de,pe){super(j,z,O,le,pe),this.Z=P,this.ab=U,this.bb=B,this.cb=_,this.db=de,this.X=this.B(new w.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new l.ResourceSet;const he=this.B(X.createInstance(D.ExtensionsLifecycle));this.S=this.B(X.createInstance(q,ae=>he.postUninstall(ae))),this.U=this.B(new m.ExtensionsManifestCache(pe,_,de,this,this.v)),this.W=this.B(X.createInstance(c.ExtensionsDownloader));const ge=this.B(new M.ExtensionsWatcher(this,this.Z,pe,U,de,_,O));this.B(ge.onDidChangeExtensionsByAnotherSource(ae=>this.kb(ae))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(j){this.v.trace("ExtensionManagementService#zip",j.identifier.id);const z=await this.jb(j),O=await(0,E.zip)((0,g.joinPath)(this.W.extensionsDownloadDir,(0,d.generateUuid)()).fsPath,z);return u.URI.file(O)}async unzip(j){return this.v.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const{location:z,cleanup:O}=await this.fb(j),s=I.resolve(z.fsPath);try{return await(0,y.getManifest)(s)}finally{await O()}}getInstalled(j,z=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(j??null,z)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(j){return this.S.scanUserExtensionAtLocation(j)}async install(j,z={}){this.v.trace("ExtensionManagementService#install",j.toString());const{location:O,cleanup:s}=await this.fb(j);try{const P=await(0,y.getManifest)(I.resolve(O.fsPath));if(P.engines&&P.engines.vscode&&!(0,J.isEngineValid)(P.engines.vscode,this.w.version,this.w.date))throw new Error(p.localize(0,null,(0,i.getGalleryExtensionId)(P.publisher,P.name),this.w.version));return await this.z(P,O,z)}finally{await s()}}async installFromLocation(j,z){this.v.trace("ExtensionManagementService#installFromLocation",j.toString());const O=await this.S.scanUserExtensionAtLocation(j);if(!O)throw new Error(`Cannot find a valid extension from the location ${j.toString()}`);return await this.ob([[O,void 0]],z),this.v.info("Successfully installed extension",O.identifier.id,z.toString()),O}async installExtensionsFromProfile(j,z,O){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",j,z.toString(),O.toString());const s=(await this.S.scanExtensions(1,z)).filter(P=>j.some(U=>(0,i.areSameExtensions)(U,P.identifier)));if(s.length){const P=await Promise.all(s.map(U=>this.S.scanMetadata(U,z)));await this.ob(s.map((U,B)=>[U,P[B]]),O),this.v.info("Successfully installed extensions",s.map(U=>U.identifier.id),O.toString())}return s}async updateMetadata(j,z,O=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",j.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.pinned=z.pinned||void 0,j=await this.S.updateMetadata(j,z,O),this.U.invalidate(O),this.X.fire(j),j}async reinstallFromGallery(j){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",j.identifier.id),!this.t.isEnabled())throw new Error(p.localize(1,null));const z=await this.getTargetPlatform(),[O]=await this.t.getExtensions([{...j.identifier,preRelease:j.preRelease}],{targetPlatform:z,compatible:!0},k.CancellationToken.None);if(!O)throw new Error(p.localize(2,null));await this.S.setUninstalled(j);try{await this.S.removeUninstalledExtension(j)}catch(s){throw new Error(p.localize(3,null,(0,A.toErrorMessage)(s)))}return this.installFromGallery(O)}copyExtensions(j,z){return this.S.copyExtensions(j,z)}markAsUninstalled(...j){return this.S.setUninstalled(...j)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(j){this.v.error(j)}}async download(j,z,O){const{location:s}=await this.W.download(j,z,!O);return s}async fb(j){if(j.scheme===R.Schemas.file)return{location:j,async cleanup(){}};this.v.trace("Downloading extension from",j.toString());const z=(0,g.joinPath)(this.W.extensionsDownloadDir,(0,d.generateUuid)());return await this.bb.download(j,z),this.v.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.cb.del(z)}catch(s){this.v.error(s)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(j,z,O){if(u.URI.isUri(z))return new W(j,z,O,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const s=i.ExtensionKey.create(z).toString();let P=this.Y.get(s);return P||(this.Y.set(s,P=new F(j,z,O,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),P.waitUntilTaskIsFinished().finally(()=>this.Y.delete(s))),P}R(j,z){return new H(j,z.profileLocation,this.ab)}async jb(j){const z=async s=>{let P=await f.Promises.readdir(s);P=P.map(X=>I.join(s,X));const U=await Promise.all(P.map(X=>f.Promises.stat(X)));let B=Promise.resolve([]);return U.forEach((X,_)=>{const le=P[_];X.isFile()&&(B=B.then(de=>[...de,le])),X.isDirectory()&&(B=B.then(de=>z(le).then(pe=>[...de,...pe])))}),B};return(await z(j.location.fsPath)).map(s=>({path:`extension/${I.relative(j.location.fsPath,s)}`,localPath:s}))}async kb({added:j,removed:z}){if(z)for(const O of z.extensions)this.v.info("Extensions removed from another source",O.id,z.profileLocation.toString()),this.p.fire({identifier:O,profileLocation:z.profileLocation});if(j){const s=(await this.S.scanExtensions(1,j.profileLocation)).filter(P=>j.extensions.some(U=>(0,i.areSameExtensions)(U,P.identifier)));this.m.fire(s.map(P=>(this.v.info("Extensions added from another source",P.identifier.id,j.profileLocation.toString()),{identifier:P.identifier,local:P,profileLocation:j.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(z=>this.lb.add(z)));const j=await this.cb.resolve(this.Z.userExtensionsLocation);for(const z of j.children??[])z.isDirectory&&this.lb.add(z.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(z=>this.nb(z)))}async nb(j){if(!j.affects(this.Z.userExtensionsLocation,1))return;const z=[];for(const O of j.rawAdded){if(this.lb.has(O)||!this.db.extUri.isEqual(this.db.extUri.dirname(O),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(O,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(O).startsWith(".")||!(await this.cb.stat(O)).isDirectory)continue;const s=await this.S.scanUserExtensionAtLocation(O);s&&s.installedTimestamp===void 0&&(this.lb.add(O),z.push(s))}z.length&&(await this.ob(z.map(O=>[O,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",z.map(O=>O.identifier.id)))}async ob(j,z){const O=j.map(s=>s[0]);await this.pb(O),await this.ab.addExtensionsToProfile(j,z),this.m.fire(O.map(s=>({local:s,identifier:s.identifier,operation:1,profileLocation:z})))}async pb(j){const z=await this.S.getUninstalledExtensions();for(const O of j){const s=i.ExtensionKey.create(O);z[s.toString()]&&(this.v.trace("Removing the extension from uninstalled list:",s.id),await this.S.setInstalled(s),this.v.info("Removed the extension from uninstalled list:",s.id))}}};e.ExtensionManagementService=$=ve([te(0,n.IExtensionGalleryService),te(1,ce.ITelemetryService),te(2,ue.ILogService),te(3,t.INativeEnvironmentService),te(4,o.IExtensionsScannerService),te(5,r.IExtensionsProfileScannerService),te(6,b.IDownloadService),te(7,ie.IInstantiationService),te(8,K.IFileService),te(9,Q.IProductService),te(10,oe.IUriIdentityService),te(11,se.IUserDataProfilesService)],$);let q=e.ExtensionsScanner=class extends h.Disposable{constructor(j,z,O,s,P,U){super(),this.k=j,this.l=z,this.m=O,this.n=s,this.p=P,this.s=U,this.h=this.B(new w.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,g.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new T.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(j,z){const O={includeInvalid:!0,profileLocation:z};let s=[];return j===null||j===0?s.push(...await this.m.scanAllExtensions({includeInvalid:!0},O,!1)):j===1&&s.push(...await this.m.scanUserExtensions(O)),s=j!==null?s.filter(P=>P.type===j):s,Promise.all(s.map(P=>this.y(P)))}async scanAllUserExtensions(j){const z=await this.m.scanUserExtensions({includeAllVersions:!j,includeInvalid:!0});return Promise.all(z.map(O=>this.y(O)))}async scanUserExtensionAtLocation(j){try{const z=await this.m.scanExistingExtension(j,1,{includeInvalid:!0});if(z)return await this.y(z)}catch(z){this.s.error(z)}return null}async extractUserExtension(j,z,O,s){await this.j.catch(()=>{});const P=j.toString(),U=I.join(this.m.userExtensionsLocation.fsPath,`.${(0,d.generateUuid)()}`),B=I.join(this.m.userExtensionsLocation.fsPath,P);try{await f.Promises.rm(B)}catch{throw new n.ExtensionManagementError(p.localize(4,null,B,j.id),n.ExtensionManagementErrorCode.Delete)}await this.u(j,z,U,s),await this.m.updateMetadata(u.URI.file(U),O);try{this.h.fire(u.URI.file(B)),await this.v(j,U,B,Date.now()+2*60*1e3),this.s.info("Renamed to",B)}catch(X){try{await f.Promises.rm(U)}catch{}if(X.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",j.id);else throw this.s.info(`Rename failed because of ${(0,C.getErrorMessage)(X)}. Deleted from extracted location`,U),X}return this.w(u.URI.file(B),1)}async scanMetadata(j,z){return z?(await this.n.scanProfileExtensions(z)).find(s=>(0,i.areSameExtensions)(s.identifier,j.identifier))?.metadata:this.m.scanMetadata(j.location)}async updateMetadata(j,z,O){return O?await this.n.updateMetadata([[j,z]],O):await this.m.updateMetadata(j.location,z),this.w(j.location,j.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...j){const z=j.map(O=>i.ExtensionKey.create(O));await this.t(O=>z.forEach(s=>{O[s.toString()]=!0,this.s.info("Marked extension as uninstalled",s.toString())}))}async setInstalled(j){await this.t(z=>delete z[j.toString()])}async removeExtension(j,z){this.s.trace(`Deleting ${z} extension from disk`,j.identifier.id,j.location.fsPath);const O=this.p.extUri.joinPath(this.p.extUri.dirname(j.location),`._${(0,d.generateUuid)()}`);await this.v(j.identifier,j.location.fsPath,O.fsPath,Date.now()+2*60*1e3),await this.l.del(O,{recursive:!0}),this.s.info("Deleted from disk",j.identifier.id,j.location.fsPath)}async removeUninstalledExtension(j){await this.removeExtension(j,"uninstalled"),await this.t(z=>delete z[i.ExtensionKey.create(j).toString()])}async copyExtensions(j,z){const O=await this.scanExtensions(1,j),s=await Promise.all(O.filter(P=>!P.isApplicationScoped).map(async P=>[P,await this.scanMetadata(P,j)]));await this.n.addExtensionsToProfile(s,z)}async t(j){return this.g.queue(async()=>{let z;try{z=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(s){if((0,K.toFileOperationResult)(s)!==1)throw s}let O={};if(z)try{O=JSON.parse(z)}catch{}return j&&(j(O),Object.keys(O).length?await this.l.writeFile(this.c,L.VSBuffer.fromString(JSON.stringify(O))):await this.l.del(this.c)),O})}async u(j,z,O,s){this.s.trace(`Started extracting the extension from ${z} to ${O}`);try{await f.Promises.rm(O)}catch(P){throw new n.ExtensionManagementError(this.D(P).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,E.extract)(z,O,{sourcePath:"extension",overwrite:!0},s),this.s.info(`Extracted extension to ${O}:`,j.id)}catch(P){try{await f.Promises.rm(O)}catch{}let U=n.ExtensionManagementErrorCode.Extract;throw P instanceof E.ExtractError&&(P.type==="CorruptZip"?U=n.ExtensionManagementErrorCode.CorruptZip:P.type==="Incomplete"&&(U=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(P.message,U)}}async v(j,z,O,s){try{await f.Promises.rename(z,O)}catch(P){if(v.isWindows&&P&&P.code==="EPERM"&&Date.now()<s)return this.s.info(`Failed renaming ${z} to ${O} with 'EPERM' error. Trying again...`,j.id),this.v(j,z,O,s);throw new n.ExtensionManagementError(P.message||p.localize(5,null,z,O),P.code||n.ExtensionManagementErrorCode.Rename)}}async w(j,z){const O=await this.m.scanExistingExtension(j,z,{includeInvalid:!0});if(O)return this.y(O);throw new Error(p.localize(6,null,j.path))}async y(j){const z=await this.l.resolve(j.location);let O,s;return z.children&&(O=z.children.find(({name:P})=>/^readme(\.txt|\.md|)$/i.test(P))?.resource,s=z.children.find(({name:P})=>/^changelog(\.txt|\.md|)$/i.test(P))?.resource),{identifier:j.identifier,type:j.type,isBuiltin:j.isBuiltin||!!j.metadata?.isBuiltin,location:j.location,manifest:j.manifest,targetPlatform:j.targetPlatform,validations:j.validations,isValid:j.isValid,readmeUrl:O,changelogUrl:s,publisherDisplayName:j.metadata?.publisherDisplayName||null,publisherId:j.metadata?.publisherId||null,isApplicationScoped:!!j.metadata?.isApplicationScoped,isMachineScoped:!!j.metadata?.isMachineScoped,isPreReleaseVersion:!!j.metadata?.isPreReleaseVersion,preRelease:!!j.metadata?.preRelease,installedTimestamp:j.metadata?.installedTimestamp,updated:!!j.metadata?.updated,pinned:!!j.metadata?.pinned}}async z(){const j=await this.getUninstalledExtensions();if(Object.keys(j).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys(j));const z=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const P of z)j[i.ExtensionKey.create(P).toString()]||O.add(P.identifier.id.toLowerCase());try{const P=(0,i.groupByExtension)(z,U=>U.identifier);await T.Promises.settled(P.map(async U=>{const B=U.sort((X,_)=>N.rcompare(X.manifest.version,_.manifest.version))[0];O.has(B.identifier.id.toLowerCase())||await this.k(await this.y(B))}))}catch(P){this.s.error(P)}const s=z.filter(P=>P.metadata&&j[i.ExtensionKey.create(P).toString()]);await Promise.allSettled(s.map(P=>this.removeUninstalledExtension(P)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const j=[];let z;try{z=await this.l.resolve(this.m.userExtensionsLocation)}catch(O){(0,K.toFileOperationResult)(O)!==1&&this.s.error(O)}for(const O of z?.children??[])O.isDirectory&&O.name.startsWith("._")&&(0,d.isUUID)(O.name.substring(2))&&j.push((async()=>{this.s.trace("Deleting the generated extension folder",O.resource.toString());try{await this.l.del(O.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",O.resource.toString())}catch(s){this.s.error(s)}})());await Promise.allSettled(j)}D(j){const z=Array.isArray(j)?j:[j];return z.length===1?z[0]instanceof Error?z[0]:new Error(z[0]):z.reduce((O,s)=>new Error(`${O.message}${O.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}};e.ExtensionsScanner=q=ve([te(1,K.IFileService),te(2,o.IExtensionsScannerService),te(3,r.IExtensionsProfileScannerService),te(4,oe.IUriIdentityService),te(5,ue.ILogService)],q);class x extends a.AbstractExtensionTask{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,S.isUndefined)(this.m.operation)?this.l:this.m.operation}constructor(j,z,O,s,P,U,B,X,_){super(),this.identifier=j,this.source=z,this.m=O,this.n=s,this.o=P,this.p=U,this.q=B,this.s=X,this.t=_,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(j){const[z,O]=await this.y(j);return this.j=z.isBuiltin||z.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[z,O]],this.j),z}async v({zipPath:j,key:z,metadata:O},s){let P=await this.w(z);return P||(this.t.trace("Extracting extension...",z.id),P=await this.n.extractUserExtension(z,j,O,s),this.t.info("Extracting extension completed.",z.id)),P}async w(j){return await this.x(j)?(this.t.trace("Removing the extension from uninstalled list:",j.id),await this.n.setInstalled(j),this.t.info("Removed the extension from uninstalled list:",j.id),(await this.n.scanAllUserExtensions(!0)).find(s=>i.ExtensionKey.create(s).equals(j))):void 0}async x(j){return!!(await this.n.getUninstalledExtensions())[j.toString()]}}class F extends x{constructor(j,z,O,s,P,U,B,X,_,le){super(z.identifier,z,O,P,U,B,X,_,le),this.z=z,this.A=s}async y(j){const O=(await this.n.scanExtensions(null,this.m.profileLocation)).find(B=>(0,i.areSameExtensions)(B.identifier,this.z.identifier));O&&(this.l=3);const s={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||O?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||O?.isMachineScoped,isBuiltin:this.m.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,S.isBoolean)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.z.version)return[await this.n.updateMetadata(O,s),s];const{location:P,verificationStatus:U}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=U,this.C(P.fsPath),[await this.v({zipPath:P.fsPath,key:i.ExtensionKey.create(this.z),metadata:s},j),s]}catch(B){try{await this.A.delete(P)}catch(X){this.t.warn("Error while deleting the downloaded file",P.toString(),(0,C.getErrorMessage)(X))}throw B}}async C(j){try{await(0,y.getManifest)(j)}catch(z){throw new n.ExtensionManagementError((0,a.joinErrors)(z).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=F;class W extends x{constructor(j,z,O,s,P,U,B,X,_,le){super({id:(0,i.getGalleryExtensionId)(j.publisher,j.name)},z,O,P,U,B,X,_,le),this.z=j,this.A=z,this.B=s}async h(j){const z=await super.h(j);return this.E(z,j),z}async y(j){const z=new i.ExtensionKey(this.identifier,this.z.version),s=(await this.n.scanExtensions(1,this.m.profileLocation)).find(B=>(0,i.areSameExtensions)(this.identifier,B.identifier)),P={isApplicationScoped:this.m.isApplicationScoped||s?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||s?.isMachineScoped,isBuiltin:this.m.isBuiltin||s?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(s)if(this.l=3,z.equals(new i.ExtensionKey(s.identifier,s.manifest.version)))try{await this.n.removeExtension(s,"existing")}catch{throw new Error(p.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&N.gt(s.manifest.version,this.z.version)&&await this.n.setUninstalled(s);else{const B=await this.w(z);if(B)try{await this.n.removeExtension(B,"existing")}catch{throw new Error(p.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:I.resolve(this.A.fsPath),key:z,metadata:P},j),P]}async E(j,z){try{let[O]=await this.B.getExtensions([{id:j.identifier.id,version:j.manifest.version}],z);if(O||([O]=await this.B.getExtensions([{id:j.identifier.id}],z)),O){const s={id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(j,s,this.m.profileLocation)}}catch{}}}class H extends a.AbstractExtensionTask{constructor(j,z,O){super(),this.extension=j,this.j=z,this.k=O}async h(j){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[160],re([0,1,135,8,14,9,3,24,18,136,6,43,134,174]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let N=e.RequestService=class extends I.AbstractRequestService{constructor(f,E,p,b){super(b),this.j=f,this.k=E,this.l=p,this.m(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const f=this.j.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,E){const{f:p,g:b}=this;let t;try{t=await(0,l.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,A.getErrorMessage)(i)))}const a={...process.env,...t},n=f.agent?f.agent:await(0,v.getProxyAgent)(f.url||"",a,{proxyUrl:p,strictSSL:b});return f.agent=n,f.strictSSL=b,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>u(f,E))}async resolveProxy(f){}};e.RequestService=N=ve([te(0,w.IConfigurationService),te(1,h.INativeEnvironmentService),te(2,R.ILogService),te(3,R.ILoggerService)],N);async function S(d){return((0,T.parse)(d.url).protocol==="https:"?await new Promise((p,b)=>{G(["https"],p,b)}):await new Promise((p,b)=>{G(["http"],p,b)})).request}async function u(d,f){return L.Promises.withAsyncBody(async(E,p)=>{const b=(0,T.parse)(d.url),t=d.getRawRequest?d.getRawRequest(d):await S(d),a={hostname:b.hostname,port:b.port?parseInt(b.port):b.protocol==="https:"?443:80,protocol:b.protocol,path:b.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,C.isBoolean)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(a.auth=d.user+":"+d.password);const n=t(a,i=>{const r=(0,C.isNumber)(d.followRedirects)?d.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)u({...d,url:i.headers.location,followRedirects:r-1},f).then(E,p);else{let o=i;!d.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,g.createGunzip)())),E({res:i,stream:(0,k.streamToBufferReadableStream)(o)})}});n.on("error",p),d.timeout&&n.setTimeout(d.timeout),d.isChromiumNetwork&&n.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&n.write(d.data),n.end(),f.onCancellationRequested(()=>{n.abort(),p(new A.CancellationError)})})}e.nodeRequest=u}),define(ne[175],re([0,1,32,8,33,9,2,16,15,12,34,11,22,24,131,59,133,18,109,155,20,60,138,40,49,159,153,13,120,122,48,118,63,64,141,6,127,38,128,144,31,43,160,68,69,25,143,39,145,146,27,148,21,156,147,152,124,126,4]),function(G,e,T,L,k,A,C,w,h,l,R,I,v,g,N,S,u,d,f,E,p,b,t,a,n,i,r,o,c,D,y,m,M,J,K,ie,ue,Q,ce,oe,se,$,q,x,F,W,H,Y,j,z,O,s,P,U,B,X,_,le,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends C.Disposable{constructor(ae){super(),this.b=ae,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[ae,fe]=await this.f();return ae.invokeFunction(async we=>{const Re=we.get(ie.ILogService),Ce=we.get(o.IFileService),Fe=we.get(d.INativeEnvironmentService),V=we.get(P.IUserDataProfilesService);Re.info("CLI main",this.b),this.g(Re),await this.h(Fe,Ce,V,ae),await Promise.all(fe.map(Z=>{(0,L.raceTimeout)(Z.flush(),1e3)}))})}async f(){const ae=new M.ServiceCollection,fe={_serviceBrand:void 0,...oe.default};ae.set(se.IProductService,fe);const we=new f.NativeEnvironmentService(this.b,fe);ae.set(d.INativeEnvironmentService,we),await Promise.all([we.appSettingsHome.fsPath,we.extensionsPath].map(Ie=>Ie?v.Promises.mkdir(Ie,{recursive:!0}):void 0));const Re=new le.LoggerService((0,ie.getLogLevel)(we),we.logsHome);ae.set(ie.ILoggerService,Re);const Ce=this.B(Re.createLogger("cli",{name:(0,de.localize)(0,null)})),Fe=[];Re.getLogLevel()===ie.LogLevel.Trace&&Fe.push(new ie.ConsoleLogger(Re.getLogLevel()));const V=this.B(new _.LogService(Ce,Fe));ae.set(ie.ILogService,V);const Z=this.B(new c.FileService(V));ae.set(o.IFileService,Z);const ee=this.B(new D.DiskFileSystemProvider(V));Z.registerProvider(w.Schemas.file,ee);const me=new s.UriIdentityService(Z);ae.set(O.IUriIdentityService,me);const ye=new x.StateReadonlyService(1,we,V,Z),Oe=new U.UserDataProfilesReadonlyService(ye,me,we,Z,V);ae.set(P.IUserDataProfilesService,Oe);const be=l.isWindows&&fe.win32RegValueName?this.B(new ce.NativePolicyService(V,fe.win32RegValueName)):we.policyFile?this.B(new ue.FilePolicyService(we.policyFile,Z,V)):new Q.NullPolicyService;ae.set(Q.IPolicyService,be);const Le=this.B(new N.ConfigurationService(Oe.defaultProfile.settingsResource,Z,be,V));ae.set(g.IConfigurationService,Le),await Promise.all([ye.init(),Le.initialize()]);let De;try{De=await(0,B.resolveMachineId)(ye,V)}catch(Ie){Ie.code!=="ENOENT"&&V.error(Ie)}Oe.init(),ae.set(O.IUriIdentityService,new s.UriIdentityService(Z)),ae.set($.IRequestService,new y.SyncDescriptor(q.RequestService,void 0,!0)),ae.set(S.IDownloadService,new y.SyncDescriptor(u.DownloadService,void 0,!0)),ae.set(a.IExtensionsProfileScannerService,new y.SyncDescriptor(X.ExtensionsProfileScannerService,void 0,!0)),ae.set(n.IExtensionsScannerService,new y.SyncDescriptor(r.ExtensionsScannerService,void 0,!0)),ae.set(b.IExtensionSignatureVerificationService,new y.SyncDescriptor(b.ExtensionSignatureVerificationService,void 0,!0)),ae.set(i.INativeServerExtensionManagementService,new y.SyncDescriptor(i.ExtensionManagementService,void 0,!0)),ae.set(p.IExtensionGalleryService,new y.SyncDescriptor(E.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),ae.set(J.ILanguagePackService,new y.SyncDescriptor(K.NativeLanguagePackService,void 0,!1));const Ne=[],je=(0,Y.isInternalTelemetry)(fe,Le);if((0,Y.supportsTelemetry)(fe,we)){fe.aiConfig&&fe.aiConfig.ariaKey&&Ne.push(new j.OneDataSystemAppender(je,"monacoworkbench",null,fe.aiConfig.ariaKey));const Ie={appenders:Ne,sendErrorTelemetry:!1,commonProperties:(0,F.resolveCommonProperties)((0,T.release)(),(0,T.hostname)(),process.arch,fe.commit,fe.version,De,je),piiPaths:(0,Y.getPiiPathsFromEnvironment)(we)};ae.set(W.ITelemetryService,new y.SyncDescriptor(H.TelemetryService,[Ie],!1))}else ae.set(W.ITelemetryService,Y.NullTelemetryService);return[new m.InstantiationService(ae),Ne]}g(ae){(0,A.setUnexpectedErrorHandler)(fe=>{const we=(0,k.toErrorMessage)(fe,!0);we&&ae.error(`[uncaught exception in CLI]: ${we}`)}),process.on("uncaughtException",fe=>{(0,A.isSigPipeError)(fe)||(0,A.onUnexpectedError)(fe)}),process.on("unhandledRejection",fe=>(0,A.onUnexpectedError)(fe))}async h(ae,fe,we,Re){let Ce;if(ae.args.profile&&(Ce=we.profiles.find(V=>V.name===ae.args.profile),!Ce))throw new Error(`Profile '${ae.args.profile}' not found.`);const Fe=(Ce??we.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Re.createInstance(t.ExtensionManagementCLI,new ie.ConsoleLogger(ie.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,Fe);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const V={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Fe};return Re.createInstance(t.ExtensionManagementCLI,new ie.ConsoleLogger(ie.LogLevel.Info,!1)).installExtensions(this.i(this.b["install-extension"]||[]),this.i(this.b["install-builtin-extension"]||[]),V,!!this.b.force)}else{if(this.b["uninstall-extension"])return Re.createInstance(t.ExtensionManagementCLI,new ie.ConsoleLogger(ie.LogLevel.Info,!1)).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Fe);if(this.b["locate-extension"])return Re.createInstance(t.ExtensionManagementCLI,new ie.ConsoleLogger(ie.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,z.buildTelemetryMessage)(ae.appRoot,ae.extensionsPath))}}i(ae){return ae.map(fe=>/\.vsix$/i.test(fe)?I.URI.file((0,h.isAbsolute)(fe)?fe:(0,h.join)((0,R.cwd)(),fe)):fe)}}async function he(ge){const ae=new pe(ge);try{await ae.run()}finally{ae.dispose()}}e.main=he})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b380da4ef1ee00e224a15c1d4d9793e27c2b6302/core/vs/code/node/cliProcessMain.js.map
