/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/types","vs/nls","vs/base/common/uri","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/path","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/network","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","child_process","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/skipList","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(ne){for(var e=[],k=0,U=ne.length;k<U;k++)e[k]=oe[ne[k]];return e};define(oe[59],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(T){return(D,C,m)=>{let P=null,v=null;if(typeof m.value=="function"?(P="value",v=m.value):typeof m.get=="function"&&(P="get",v=m.get),!v)throw new Error("not supported");m[P]=T(v,C)}}function U(T,D,C){let m=null,P=null;if(typeof C.value=="function"?(m="value",P=C.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(m="get",P=C.get),!P)throw new Error("not supported");const v=`$memoize$${D}`;C[m]=function(...S){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,S)}),this[v]}}e.memoize=U;function A(T,D,C){return k((m,P)=>{const v=`$debounce$${P}`,S=`$debounce$result$${P}`;return function(...f){this[S]||(this[S]=C?C():void 0),clearTimeout(this[v]),D&&(this[S]=D(this[S],...f),f=[this[S]]),this[v]=setTimeout(()=>{m.apply(this,f),this[S]=C?C():void 0},T)}})}e.debounce=A;function N(T,D,C){return k((m,P)=>{const v=`$throttle$timer$${P}`,S=`$throttle$result$${P}`,f=`$throttle$lastRun$${P}`,d=`$throttle$pending$${P}`;return function(...w){if(this[S]||(this[S]=C?C():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),D&&(this[S]=D(this[S],...w)),this[d])return;const a=this[f]+T;a<=Date.now()?(this[f]=Date.now(),m.apply(this,[this[S]]),this[S]=C?C():void 0):(this[d]=!0,this[v]=setTimeout(()=>{this[d]=!1,this[f]=Date.now(),m.apply(this,[this[S]]),this[S]=C?C():void 0},a-Date.now()))}})}e.throttle=N}),define(oe[7],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?p.isErrorNoTelemetry(r)?new p(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(t=>{t(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.ErrorHandler=k,e.errorHandler=new k;function U(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=U;function A(n){if(!n||typeof n!="object")return!1;const r=n;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=A;function N(n){m(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=N;function T(n){m(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=T;function D(n){if(n instanceof Error){const{name:r,message:t}=n,i=n.stacktrace||n.stack;return{$isError:!0,name:r,message:t,stack:i,noTelemetry:p.isErrorNoTelemetry(n)}}return n}e.transformErrorForSerialization=D;const C="Canceled";function m(n){return n instanceof P?!0:n instanceof Error&&n.name===C&&n.message===C}e.isCancellationError=m;class P extends Error{constructor(){super(C),this.name=this.message}}e.CancellationError=P;function v(){const n=new Error(C);return n.name=n.message,n}e.canceled=v;function S(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=S;function f(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=f;function d(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function w(n){const r=new Error(`${n} has been disposed`);return r.name="DISPOSED",r}e.disposed=w;function a(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=a;class h extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=h;class u extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=u;class I extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=I;class p extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof p)return r;const t=new p;return t.message=r.message,t.stack=r.stack,t}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=p;class L extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,L.prototype)}}e.BugIndicatingError=L}),define(oe[21],ae([0,1,7]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function U(z,J=0){return z[z.length-(1+J)]}e.tail=U;function A(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=A;function N(z,J,ee=(ce,ue)=>ce===ue){if(z===J)return!0;if(!z||!J||z.length!==J.length)return!1;for(let ce=0,ue=z.length;ce<ue;ce++)if(!ee(z[ce],J[ce]))return!1;return!0}e.equals=N;function T(z,J){const ee=z.length-1;J<ee&&(z[J]=z[ee]),z.pop()}e.removeFastWithoutKeepingOrder=T;function D(z,J,ee){return C(z.length,ce=>ee(z[ce],J))}e.binarySearch=D;function C(z,J){let ee=0,ce=z-1;for(;ee<=ce;){const ue=(ee+ce)/2|0,de=J(ue);if(de<0)ee=ue+1;else if(de>0)ce=ue-1;else return ue}return-(ee+1)}e.binarySearch2=C;function m(z,J){let ee=0,ce=z.length;if(ce===0)return 0;for(;ee<ce;){const ue=Math.floor((ee+ce)/2);J(z[ue])?ce=ue:ee=ue+1}return ee}e.findFirstInSorted=m;function P(z,J,ee){if(z=z|0,z>=J.length)throw new TypeError("invalid index");const ce=J[Math.floor(J.length*Math.random())],ue=[],de=[],Se=[];for(const we of J){const be=ee(we,ce);be<0?ue.push(we):be>0?de.push(we):Se.push(we)}return z<ue.length?P(z,ue,ee):z<ue.length+Se.length?Se[0]:P(z-(ue.length+Se.length),de,ee)}e.quickSelect=P;function v(z,J){const ee=[];let ce;for(const ue of z.slice(0).sort(J))!ce||J(ce[0],ue)!==0?(ce=[ue],ee.push(ce)):ce.push(ue);return ee}e.groupBy=v;function S(z,J,ee){const ce=[];function ue(we,be,De){if(be===0&&De.length===0)return;const ke=ce[ce.length-1];ke&&ke.start+ke.deleteCount===we?(ke.deleteCount+=be,ke.toInsert.push(...De)):ce.push({start:we,deleteCount:be,toInsert:De})}let de=0,Se=0;for(;;){if(de===z.length){ue(de,0,J.slice(Se));break}if(Se===J.length){ue(de,z.length-de,[]);break}const we=z[de],be=J[Se],De=ee(we,be);De===0?(de+=1,Se+=1):De<0?(ue(de,1,[]),de+=1):De>0&&(ue(de,0,[be]),Se+=1)}return ce}e.sortedDiff=S;function f(z,J,ee){const ce=S(z,J,ee),ue=[],de=[];for(const Se of ce)ue.push(...z.slice(Se.start,Se.start+Se.deleteCount)),de.push(...Se.toInsert);return{removed:ue,added:de}}e.delta=f;function d(z,J,ee){if(ee===0)return[];const ce=z.slice(0,ee).sort(J);return a(z,J,ce,ee,z.length),ce}e.top=d;function w(z,J,ee,ce,ue){return ee===0?Promise.resolve([]):new Promise((de,Se)=>{(async()=>{const we=z.length,be=z.slice(0,ee).sort(J);for(let De=ee,ke=Math.min(ee+ce,we);De<we;De=ke,ke=Math.min(ke+ce,we)){if(De>ee&&await new Promise(ze=>setTimeout(ze)),ue&&ue.isCancellationRequested)throw new k.CancellationError;a(z,J,be,De,ke)}return be})().then(de,Se)})}e.topAsync=w;function a(z,J,ee,ce,ue){for(const de=ee.length;ce<ue;ce++){const Se=z[ce];if(J(Se,ee[de-1])<0){ee.pop();const we=m(ee,be=>J(Se,be)<0);ee.splice(we,0,Se)}}}function h(z){return z.filter(J=>!!J)}e.coalesce=h;function u(z){let J=0;for(let ee=0;ee<z.length;ee++)z[ee]&&(z[J]=z[ee],J+=1);z.length=J}e.coalesceInPlace=u;function I(z,J,ee){z.splice(ee,0,z.splice(J,1)[0])}e.move=I;function p(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=p;function L(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=L;function n(z,J=ee=>ee){const ee=new Set;return z.filter(ce=>{const ue=J(ce);return ee.has(ue)?!1:(ee.add(ue),!0)})}e.distinct=n;function r(z){const J=new Set;return ee=>{const ce=z(ee);return J.has(ce)?!1:(J.add(ce),!0)}}e.uniqueFilter=r;function t(z,J){const ee=i(z,J);if(ee!==-1)return z[ee]}e.findLast=t;function i(z,J){for(let ee=z.length-1;ee>=0;ee--){const ce=z[ee];if(J(ce))return ee}return-1}e.lastIndex=i;function s(z,J){return z.length>0?z[0]:J}e.firstOrDefault=s;function o(z,J){return z.length>0?z[z.length-1]:J}e.lastOrDefault=o;function l(z,J,ee=(ce,ue)=>ce===ue){let ce=0;for(let ue=0,de=Math.min(z.length,J.length);ue<de&&ee(z[ue],J[ue]);ue++)ce++;return ce}e.commonPrefixLength=l;function E(z){return[].concat(...z)}e.flatten=E;function y(z,J){let ee=typeof J=="number"?z:0;typeof J=="number"?ee=z:(ee=0,J=z);const ce=[];if(ee<=J)for(let ue=ee;ue<J;ue++)ce.push(ue);else for(let ue=ee;ue>J;ue--)ce.push(ue);return ce}e.range=y;function c(z,J,ee){return z.reduce((ce,ue)=>(ce[J(ue)]=ee?ee(ue):ue,ce),Object.create(null))}e.index=c;function b(z,J){return z.push(J),()=>R(z,J)}e.insert=b;function R(z,J){const ee=z.indexOf(J);if(ee>-1)return z.splice(ee,1),J}e.remove=R;function M(z,J,ee){const ce=z.slice(0,J),ue=z.slice(J);return ce.concat(ee,ue)}e.arrayInsert=M;function F(z,J){let ee;if(typeof J=="number"){let ce=J;ee=()=>{const ue=Math.sin(ce++)*179426549;return ue-Math.floor(ue)}}else ee=Math.random;for(let ce=z.length-1;ce>0;ce-=1){const ue=Math.floor(ee()*(ce+1)),de=z[ce];z[ce]=z[ue],z[ue]=de}}e.shuffle=F;function H(z,J){const ee=z.indexOf(J);ee>-1&&(z.splice(ee,1),z.unshift(J))}e.pushToStart=H;function q(z,J){const ee=z.indexOf(J);ee>-1&&(z.splice(ee,1),z.push(J))}e.pushToEnd=q;function V(z,J){for(const ee of J)z.push(ee)}e.pushMany=V;function Q(z,J){return Array.isArray(z)?z.map(J):J(z)}e.mapArrayOrNot=Q;function te(z){return Array.isArray(z)?z:[z]}e.asArray=te;function Y(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=Y;function x(z,J){for(const ee of z){const ce=J(ee);if(ce!==void 0)return ce}}e.mapFind=x;function G(z,J,ee){const ce=Z(z,J),ue=z.length,de=ee.length;z.length=ue+de;for(let Se=ue-1;Se>=ce;Se--)z[Se+de]=z[Se];for(let Se=0;Se<de;Se++)z[Se+ce]=ee[Se]}e.insertInto=G;function j(z,J,ee,ce){const ue=Z(z,J),de=z.splice(ue,ee);return G(z,ue,ce),de}e.splice=j;function Z(z,J){return J<0?Math.max(J+z.length,0):Math.min(J,z.length)}var ie;(function(z){function J(ue){return ue<0}z.isLessThan=J;function ee(ue){return ue>0}z.isGreaterThan=ee;function ce(ue){return ue===0}z.isNeitherLessOrGreaterThan=ce,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function se(z,J){return(ee,ce)=>J(z(ee),z(ce))}e.compareBy=se;function K(...z){return(J,ee)=>{for(const ce of z){const ue=ce(J,ee);if(!ie.isNeitherLessOrGreaterThan(ue))return ue}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=K;const _=(z,J)=>z-J;e.numberComparator=_;function $(z,J){if(z.length===0)return;let ee=z[0];for(let ce=1;ce<z.length;ce++){const ue=z[ce];J(ue,ee)>0&&(ee=ue)}return ee}e.findMaxBy=$;function g(z,J){if(z.length===0)return;let ee=z[0];for(let ce=1;ce<z.length;ce++){const ue=z[ce];J(ue,ee)>=0&&(ee=ue)}return ee}e.findLastMaxBy=g;function O(z,J){return $(z,(ee,ce)=>-J(ee,ce))}e.findMinBy=O;class B{constructor(J){this.f=J,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(J){let ee=this.c;for(;ee<this.f.length&&J(this.f[ee]);)ee++;const ce=ee===this.c?null:this.f.slice(this.c,ee);return this.c=ee,ce}takeFromEndWhile(J){let ee=this.d;for(;ee>=0&&J(this.f[ee]);)ee--;const ce=ee===this.d?null:this.f.slice(ee+1,this.d+1);return this.d=ee,ce}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const J=this.f[this.c];return this.c++,J}removeLast(){const J=this.f[this.d];return this.d--,J}takeCount(J){const ee=this.f.slice(this.c,this.c+J);return this.c+=J,ee}}e.ArrayQueue=B;class W{constructor(J){this.iterate=J}forEach(J){this.iterate(ee=>(J(ee),!0))}toArray(){const J=[];return this.iterate(ee=>(J.push(ee),!0)),J}filter(J){return new W(ee=>this.iterate(ce=>J(ce)?ee(ce):!0))}map(J){return new W(ee=>this.iterate(ce=>ee(J(ce))))}some(J){let ee=!1;return this.iterate(ce=>(ee=J(ce),!ee)),ee}findFirst(J){let ee;return this.iterate(ce=>J(ce)?(ee=ce,!1):!0),ee}findLast(J){let ee;return this.iterate(ce=>(J(ce)&&(ee=ce),!0)),ee}findLastMaxBy(J){let ee,ce=!0;return this.iterate(ue=>((ce||ie.isGreaterThan(J(ue,ee)))&&(ce=!1,ee=ue),!0)),ee}}e.CallbackIterable=W,W.empty=new W(z=>{})}),define(oe[122],ae([0,1,7]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function U(C,m){if(!C)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=U;function A(C,m="Unreachable"){throw new Error(m)}e.assertNever=A;function N(C){if(!C)throw new k.BugIndicatingError("Assertion Failed")}e.assert=N;function T(C){if(!C()){debugger;C(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function D(C,m){let P=0;for(;P<C.length-1;){const v=C[P],S=C[P+1];if(!m(v,S))return!1;P++}return!0}e.checkAdjacentItems=D}),define(oe[82],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(U){const A=this;let N=!1,T;return function(){return N||(N=!0,T=U.apply(A,arguments)),T}}e.once=k}),define(oe[60],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(U){function A(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}U.is=A;const N=Object.freeze([]);function T(){return N}U.empty=T;function*D(p){yield p}U.single=D;function C(p){return A(p)?p:D(p)}U.wrap=C;function m(p){return p||N}U.from=m;function P(p){return!p||p[Symbol.iterator]().next().done===!0}U.isEmpty=P;function v(p){return p[Symbol.iterator]().next().value}U.first=v;function S(p,L){for(const n of p)if(L(n))return!0;return!1}U.some=S;function f(p,L){for(const n of p)if(L(n))return n}U.find=f;function*d(p,L){for(const n of p)L(n)&&(yield n)}U.filter=d;function*w(p,L){let n=0;for(const r of p)yield L(r,n++)}U.map=w;function*a(...p){for(const L of p)for(const n of L)yield n}U.concat=a;function h(p,L,n){let r=n;for(const t of p)r=L(r,t);return r}U.reduce=h;function*u(p,L,n=p.length){for(L<0&&(L+=p.length),n<0?n+=p.length:n>p.length&&(n=p.length);L<n;L++)yield p[L]}U.slice=u;function I(p,L=Number.POSITIVE_INFINITY){const n=[];if(L===0)return[n,p];const r=p[Symbol.iterator]();for(let t=0;t<L;t++){const i=r.next();if(i.done)return[n,U.empty()];n.push(i.value)}return[n,{[Symbol.iterator](){return r}}]}U.consume=I})(k||(e.Iterable=k={}))}),define(oe[34],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(k||(e.ScanError=k={}));var U;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(U||(e.SyntaxKind=U={}));var A;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var N;(function(n){n.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function T(n,r=!1){let t=0;const i=n.length;let s="",o=0,l=16,E=0;function y(q){let V=0,Q=0;for(;V<q;){const te=n.charCodeAt(t);if(te>=48&&te<=57)Q=Q*16+te-48;else if(te>=65&&te<=70)Q=Q*16+te-65+10;else if(te>=97&&te<=102)Q=Q*16+te-97+10;else break;t++,V++}return V<q&&(Q=-1),Q}function c(q){t=q,s="",o=0,l=16,E=0}function b(){const q=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&m(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&m(n.charCodeAt(t)))for(t++;t<n.length&&m(n.charCodeAt(t));)t++;else return E=3,n.substring(q,t);let V=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&m(n.charCodeAt(t))){for(t++;t<n.length&&m(n.charCodeAt(t));)t++;V=t}else E=3;return n.substring(q,V)}function R(){let q="",V=t;for(;;){if(t>=i){q+=n.substring(V,t),E=2;break}const Q=n.charCodeAt(t);if(Q===34){q+=n.substring(V,t),t++;break}if(Q===92){if(q+=n.substring(V,t),t++,t>=i){E=2;break}switch(n.charCodeAt(t++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const Y=y(4);Y>=0?q+=String.fromCharCode(Y):E=4;break}default:E=5}V=t;continue}if(Q>=0&&Q<=31)if(C(Q)){q+=n.substring(V,t),E=2;break}else E=6;t++}return q}function M(){if(s="",E=0,o=t,t>=i)return o=i,l=17;let q=n.charCodeAt(t);if(D(q)){do t++,s+=String.fromCharCode(q),q=n.charCodeAt(t);while(D(q));return l=15}if(C(q))return t++,s+=String.fromCharCode(q),q===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch(q){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=R(),l=10;case 47:{const V=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!C(n.charCodeAt(t));)t++;return s=n.substring(V,t),l=12}if(n.charCodeAt(t+1)===42){t+=2;const Q=i-1;let te=!1;for(;t<Q;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,te=!0;break}t++}return te||(t++,E=1),s=n.substring(V,t),l=13}return s+=String.fromCharCode(q),t++,l=16}case 45:if(s+=String.fromCharCode(q),t++,t===i||!m(n.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=b(),l=11;default:for(;t<i&&F(q);)t++,q=n.charCodeAt(t);if(o!==t){switch(s=n.substring(o,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(q),t++,l=16}}function F(q){if(D(q)||C(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let q;do q=M();while(q>=12&&q<=15);return q}return{setPosition:c,getPosition:()=>t,scan:r?H:M,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>E}}e.createScanner=T;function D(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function C(n){return n===10||n===13||n===8232||n===8233}function m(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function v(n,r){const t=[],i=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function E(y,c,b,R){o.value=y,o.offset=c,o.length=b,o.type=R,o.colonOffset=void 0,s=o}try{I(n,{onObjectBegin:(y,c)=>{if(r<=y)throw i;s=void 0,l=r>y,t.push("")},onObjectProperty:(y,c,b)=>{if(r<c||(E(y,c,b,"property"),t[t.length-1]=y,r<=c+b))throw i},onObjectEnd:(y,c)=>{if(r<=y)throw i;s=void 0,t.pop()},onArrayBegin:(y,c)=>{if(r<=y)throw i;s=void 0,t.push(0)},onArrayEnd:(y,c)=>{if(r<=y)throw i;s=void 0,t.pop()},onLiteralValue:(y,c,b)=>{if(r<c||(E(y,c,b,L(y)),r<=c+b))throw i},onSeparator:(y,c,b)=>{if(r<=c)throw i;if(y===":"&&s&&s.type==="property")s.colonOffset=c,l=!1,s=void 0;else if(y===","){const R=t[t.length-1];typeof R=="number"?t[t.length-1]=R+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(y){if(y!==i)throw y}return{path:t,previousNode:s,isAtPropertyKey:l,matches:y=>{let c=0;for(let b=0;c<y.length&&b<t.length;b++)if(y[c]===t[b]||y[c]==="*")c++;else if(y[c]!=="**")return!1;return c===y.length}}}e.getLocation=v;function S(n,r=[],t=N.DEFAULT){let i=null,s=[];const o=[];function l(y){Array.isArray(s)?s.push(y):i!==null&&(s[i]=y)}return I(n,{onObjectBegin:()=>{const y={};l(y),o.push(s),s=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const y=[];l(y),o.push(s),s=y,i=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(y,c,b)=>{r.push({error:y,offset:c,length:b})}},t),s[0]}e.parse=S;function f(n,r=[],t=N.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function o(y){return i.children.push(y),y}I(n,{onObjectBegin:y=>{i=o({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,c,b)=>{i=o({type:"property",offset:c,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:c,length:b,parent:i})},onObjectEnd:(y,c)=>{i.length=y+c-i.offset,i=i.parent,s(y+c)},onArrayBegin:(y,c)=>{i=o({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,c)=>{i.length=y+c-i.offset,i=i.parent,s(y+c)},onLiteralValue:(y,c,b)=>{o({type:L(y),offset:c,length:b,parent:i,value:y}),s(c+b)},onSeparator:(y,c,b)=>{i.type==="property"&&(y===":"?i.colonOffset=c:y===","&&s(c))},onError:(y,c,b)=>{r.push({error:y,offset:c,length:b})}},t);const E=i.children[0];return E&&delete E.parent,E}e.parseTree=f;function d(n,r){if(!n)return;let t=n;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],s=!0;break}if(!s)return}else{const s=i;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=d;function w(n){if(!n.parent||!n.parent.children)return[];const r=w(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}e.getNodePath=w;function a(n){switch(n.type){case"array":return n.children.map(a);case"object":{const r=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(r[t.children[0].value]=a(i))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=a;function h(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}e.contains=h;function u(n,r,t=!1){if(h(n,r,t)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=r;s++){const o=u(i[s],r,t);if(o)return o}return n}}e.findNodeAtOffset=u;function I(n,r,t=N.DEFAULT){const i=T(n,!1);function s(se){return se?()=>se(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(se){return se?K=>se(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),E=o(r.onObjectProperty),y=s(r.onObjectEnd),c=s(r.onArrayBegin),b=s(r.onArrayEnd),R=o(r.onLiteralValue),M=o(r.onSeparator),F=s(r.onComment),H=o(r.onError),q=t&&t.disallowComments,V=t&&t.allowTrailingComma;function Q(){for(;;){const se=i.scan();switch(i.getTokenError()){case 4:te(14);break;case 5:te(15);break;case 3:te(13);break;case 1:q||te(11);break;case 2:te(12);break;case 6:te(16);break}switch(se){case 12:case 13:q?te(10):F();break;case 16:te(1);break;case 15:case 14:break;default:return se}}}function te(se,K=[],_=[]){if(H(se),K.length+_.length>0){let $=i.getToken();for(;$!==17;){if(K.indexOf($)!==-1){Q();break}else if(_.indexOf($)!==-1)break;$=Q()}}}function Y(se){const K=i.getTokenValue();return se?R(K):E(K),Q(),!0}function x(){switch(i.getToken()){case 11:{let se=0;try{se=JSON.parse(i.getTokenValue()),typeof se!="number"&&(te(2),se=0)}catch{te(2)}R(se);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return Q(),!0}function G(){return i.getToken()!==10?(te(3,[],[2,5]),!1):(Y(!1),i.getToken()===6?(M(":"),Q(),ie()||te(4,[],[2,5])):te(5,[],[2,5]),!0)}function j(){l(),Q();let se=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(se||te(4,[],[]),M(","),Q(),i.getToken()===2&&V)break}else se&&te(6,[],[]);G()||te(4,[],[2,5]),se=!0}return y(),i.getToken()!==2?te(7,[2],[]):Q(),!0}function Z(){c(),Q();let se=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(se||te(4,[],[]),M(","),Q(),i.getToken()===4&&V)break}else se&&te(6,[],[]);ie()||te(4,[],[4,5]),se=!0}return b(),i.getToken()!==4?te(8,[4],[]):Q(),!0}function ie(){switch(i.getToken()){case 3:return Z();case 1:return j();case 10:return Y(!0);default:return x()}}return Q(),i.getToken()===17?t.allowEmptyContent?!0:(te(4,[],[]),!1):ie()?(i.getToken()!==17&&te(9,[],[]),!0):(te(4,[],[]),!1)}e.visit=I;function p(n,r){const t=T(n),i=[];let s,o=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==l&&i.push(n.substring(o,l)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return i.join("")}e.stripComments=p;function L(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=L}),define(oe[41],ae([0,1,34]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function U(m,P,v){let S,f,d,w,a;if(P){for(w=P.offset,a=w+P.length,d=w;d>0&&!C(m,d-1);)d--;let l=a;for(;l<m.length&&!C(m,l);)l++;f=m.substring(d,l),S=T(f,v)}else f=m,S=0,d=0,w=0,a=m.length;const h=D(v,m);let u=!1,I=0,p;v.insertSpaces?p=N(" ",v.tabSize||4):p="	";const L=(0,k.createScanner)(f,!1);let n=!1;function r(){return h+N(p,S+I)}function t(){let l=L.scan();for(u=!1;l===15||l===14;)u=u||l===14,l=L.scan();return n=l===16||L.getTokenError()!==0,l}const i=[];function s(l,E,y){!n&&E<a&&y>w&&m.substring(E,y)!==l&&i.push({offset:E,length:y-E,content:l})}let o=t();if(o!==17){const l=L.getTokenOffset()+d,E=N(p,S);s(E,d,l)}for(;o!==17;){let l=L.getTokenOffset()+L.getTokenLength()+d,E=t(),y="";for(;!u&&(E===12||E===13);){const b=L.getTokenOffset()+d;s(" ",l,b),l=L.getTokenOffset()+L.getTokenLength()+d,y=E===12?r():"",E=t()}if(E===2)o!==1&&(I--,y=r());else if(E===4)o!==3&&(I--,y=r());else{switch(o){case 3:case 1:I++,y=r();break;case 5:case 12:y=r();break;case 13:u?y=r():y=" ";break;case 6:y=" ";break;case 10:if(E===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?y=" ":E!==5&&E!==17&&(n=!0);break;case 16:n=!0;break}u&&(E===12||E===13)&&(y=r())}const c=L.getTokenOffset()+d;s(y,l,c),o=E}return i}e.format=U;function A(m,P){const v=JSON.stringify(m,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?v.replace(/\r\n|\r|\n/g,P.eol):v}e.toFormattedString=A;function N(m,P){let v="";for(let S=0;S<P;S++)v+=m;return v}function T(m,P){let v=0,S=0;const f=P.tabSize||4;for(;v<m.length;){const d=m.charAt(v);if(d===" ")S++;else if(d==="	")S+=f;else break;v++}return Math.floor(S/f)}function D(m,P){for(let v=0;v<P.length;v++){const S=P.charAt(v);if(S==="\r")return v+1<P.length&&P.charAt(v+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=D;function C(m,P){return`\r
`.indexOf(m.charAt(P))!==-1}e.isEOL=C}),define(oe[83],ae([0,1,34,41]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(m,P,v){return N(m,P,void 0,v)}e.removeProperty=A;function N(m,P,v,S,f){const d=P.slice(),w=[],a=(0,k.parseTree)(m,w);let h,u;for(;d.length>0&&(u=d.pop(),h=(0,k.findNodeAtLocation)(a,d),h===void 0&&v!==void 0);)typeof u=="string"?v={[u]:v}:v=[v];if(h)if(h.type==="object"&&typeof u=="string"&&Array.isArray(h.children)){const I=(0,k.findNodeAtLocation)(h,[u]);if(I!==void 0)if(v===void 0){if(!I.parent)throw new Error("Malformed AST");const p=h.children.indexOf(I.parent);let L,n=I.parent.offset+I.parent.length;if(p>0){const r=h.children[p-1];L=r.offset+r.length}else L=h.offset+1,h.children.length>1&&(n=h.children[1].offset);return T(m,{offset:L,length:n-L,content:""},S)}else return T(m,{offset:I.offset,length:I.length,content:JSON.stringify(v)},S);else{if(v===void 0)return[];const p=`${JSON.stringify(u)}: ${JSON.stringify(v)}`,L=f?f(h.children.map(r=>r.children[0].value)):h.children.length;let n;if(L>0){const r=h.children[L-1];n={offset:r.offset+r.length,length:0,content:","+p}}else h.children.length===0?n={offset:h.offset+1,length:0,content:p}:n={offset:h.offset+1,length:0,content:p+","};return T(m,n,S)}}else if(h.type==="array"&&typeof u=="number"&&Array.isArray(h.children))if(v!==void 0){const I=`${JSON.stringify(v)}`;let p;if(h.children.length===0||u===0)p={offset:h.offset+1,length:0,content:h.children.length===0?I:I+","};else{const L=u===-1||u>h.children.length?h.children.length:u,n=h.children[L-1];p={offset:n.offset+n.length,length:0,content:","+I}}return T(m,p,S)}else{const I=u,p=h.children[I];let L;if(h.children.length===1)L={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===I){const n=h.children[I-1],r=n.offset+n.length,t=h.offset+h.length;L={offset:r,length:t-2-r,content:""}}else L={offset:p.offset,length:h.children[I+1].offset-p.offset,content:""};return T(m,L,S)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${h.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return T(m,{offset:a?a.offset:0,length:a?a.length:0,content:JSON.stringify(v)},S)}}e.setProperty=N;function T(m,P,v){let S=D(m,P),f=P.offset,d=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;f>0&&!(0,U.isEOL)(S,f-1);)f--;for(;d<S.length&&!(0,U.isEOL)(S,d);)d++}const w=(0,U.format)(S,{offset:f,length:d-f},v);for(let h=w.length-1;h>=0;h--){const u=w[h];S=D(S,u),f=Math.min(f,u.offset),d=Math.max(d,u.offset+u.length),d+=u.content.length-u.length}const a=m.length-(S.length-d)-f;return[{offset:f,length:a,content:S.substring(f,d)}]}e.withFormatting=T;function D(m,P){return m.substring(0,P.offset)+P.content+m.substring(P.offset+P.length)}e.applyEdit=D;function C(m,P){const v=P.slice(0).sort((f,d)=>{const w=f.offset-d.offset;return w===0?f.length-d.length:w});let S=m.length;for(let f=v.length-1;f>=0;f--){const d=v[f];if(d.offset+d.length<=S)m=D(m,d);else throw new Error("Overlapping edit");S=d.offset}return m}e.applyEdits=C}),define(oe[84],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=k}),define(oe[2],ae([0,1,82,60]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const A=!1;let N=null;function T(o){N=o}if(e.setDisposableTracker=T,A){const o="__is_disposable_tracked__";T(new class{trackDisposable(l){const E=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[o]||console.log(E)},3e3)}setParent(l,E){if(l&&l!==u.None)try{l[o]=!0}catch{}}markAsDisposed(l){if(l&&l!==u.None)try{l[o]=!0}catch{}}markAsSingleton(l){}})}function D(o){return N?.trackDisposable(o),o}function C(o){N?.markAsDisposed(o)}function m(o,l){N?.setParent(o,l)}function P(o,l){if(N)for(const E of o)N.setParent(E,l)}function v(o){return N?.markAsSingleton(o),o}e.markAsSingleton=v;function S(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=S;function f(o){if(U.Iterable.is(o)){const l=[];for(const E of o)if(E)try{E.dispose()}catch(y){l.push(y)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=f;function d(o){for(const l of o)S(l)&&l.dispose();return[]}e.disposeIfDisposable=d;function w(...o){const l=a(()=>f(o));return P(o,l),l}e.combinedDisposable=w;function a(o){const l=D({dispose:(0,k.once)(()=>{C(l),o()})});return l}e.toDisposable=a;class h{constructor(){this.f=new Set,this.g=!1,D(this)}dispose(){this.g||(C(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return m(l,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(l),l}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this.q=new h,D(this),m(this.q,this)}dispose(){C(this),this.q.dispose()}B(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(l)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class I{constructor(){this.b=!1,D(this)}get value(){return this.b?void 0:this.a}set value(l){this.b||l===this.a||(this.a?.dispose(),l&&m(l,this),this.a=l)}clear(){this.value=void 0}dispose(){this.b=!0,C(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const l=this.a;return this.a=void 0,l&&m(l,null),l}}e.MutableDisposable=I;class p{constructor(l){this.b=l,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=p;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(l){let E=l;return this.unset=()=>E=void 0,this.isset=()=>E!==void 0,this.dispose=()=>{E&&(E(),E=void 0,C(this))},this}}e.SafeDisposable=L;class n{constructor(){this.a=new Map}acquire(l,...E){let y=this.a.get(l);y||(y={counter:0,object:this.b(l,...E)},this.a.set(l,y));const{object:c}=y,b=(0,k.once)(()=>{--y.counter===0&&(this.c(l,y.object),this.a.delete(l))});return y.counter++,{object:c,dispose:b}}}e.ReferenceCollection=n;class r{constructor(l){this.a=l}async acquire(l,...E){const y=this.a.acquire(l,...E);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(c){throw y.dispose(),c}}}e.AsyncReferenceCollection=r;class t{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=t;function i(o){const l=new h;try{o(l)}finally{l.dispose()}}e.disposeOnReturn=i;class s{constructor(){this.a=new Map,this.b=!1,D(this)}dispose(){C(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(l){return this.a.has(l)}get(l){return this.a.get(l)}set(l,E,y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),y||this.a.get(l)?.dispose(),this.a.set(l,E)}deleteAndDispose(l){this.a.get(l)?.dispose(),this.a.delete(l)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(oe[85],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(N){this.element=N,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class U{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let N=this.a;for(;N!==k.Undefined;){const T=N.next;N.prev=k.Undefined,N.next=k.Undefined,N=T}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(N){return this.d(N,!1)}push(N){return this.d(N,!0)}d(N,T){const D=new k(N);if(this.a===k.Undefined)this.a=D,this.b=D;else if(T){const m=this.b;this.b=D,D.prev=m,m.next=D}else{const m=this.a;this.a=D,D.next=m,m.prev=D}this.c+=1;let C=!1;return()=>{C||(C=!0,this.e(D))}}shift(){if(this.a!==k.Undefined){const N=this.a.element;return this.e(this.a),N}}pop(){if(this.b!==k.Undefined){const N=this.b.element;return this.e(this.b),N}}e(N){if(N.prev!==k.Undefined&&N.next!==k.Undefined){const T=N.prev;T.next=N.next,N.next.prev=T}else N.prev===k.Undefined&&N.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):N.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):N.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let N=this.a;for(;N!==k.Undefined;)yield N.element,N=N.next}}e.LinkedList=U}),define(oe[35],ae([0,1]),function(ne,e){"use strict";var k,U,A;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function N(w,a,h){let u=w.get(a);return u===void 0&&(u=h,w.set(a,u)),u}e.getOrSet=N;function T(w){const a=[];return w.forEach((h,u)=>{a.push(`${u} => ${h}`)}),`Map(${w.size}) {${a.join(", ")}}`}e.mapToString=T;function D(w){const a=[];return w.forEach(h=>{a.push(h)}),`Set(${w.size}) {${a.join(", ")}}`}e.setToString=D;class C{constructor(a,h){this.uri=a,this.value=h}}class m{constructor(a,h){this[k]="ResourceMap",a instanceof m?(this.b=new Map(a.b),this.c=h??m.a):(this.b=new Map,this.c=a??m.a)}set(a,h){return this.b.set(this.c(a),new C(a,h)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,h){typeof h<"u"&&(a=a.bind(h));for(const[u,I]of this.b)a(I.value,I.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}e.ResourceMap=m,m.a=w=>w.toString();class P{constructor(a,h){this[U]="ResourceSet",!a||typeof a=="function"?this.a=new m(a):(this.a=new m(h),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,h){this.a.forEach((u,I)=>a.call(h,I,I,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var v;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class S{constructor(){this[A]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,h=0){const u=this.a.get(a);if(u)return h!==0&&this.j(u,h),u.value}set(a,h,u=0){let I=this.a.get(a);if(I)I.value=h,u!==0&&this.j(I,u);else{switch(I={key:a,value:h,next:void 0,previous:void 0},u){case 0:this.h(I);break;case 1:this.g(I);break;case 2:this.h(I);break;default:this.h(I);break}this.a.set(a,I),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const h=this.a.get(a);if(h)return this.a.delete(a),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,h){const u=this.e;let I=this.b;for(;I;){if(h?a.bind(h)(I.value,I.key,this):a(I.value,I.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");I=I.next}}keys(){const a=this,h=this.e;let u=this.b;const I={[Symbol.iterator](){return I},next(){if(a.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.key,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return I}values(){const a=this,h=this.e;let u=this.b;const I={[Symbol.iterator](){return I},next(){if(a.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.value,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return I}entries(){const a=this,h=this.e;let u=this.b;const I={[Symbol.iterator](){return I},next(){if(a.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:[u.key,u.value],done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return I}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let h=this.b,u=this.size;for(;h&&u>a;)this.a.delete(h.key),h=h.next,u--;this.b=h,this.d=u,h&&(h.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const h=a.next,u=a.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}a.next=void 0,a.previous=void 0,this.e++}j(a,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(a===this.b)return;const u=a.next,I=a.previous;a===this.c?(I.next=void 0,this.c=I):(u.previous=I,I.next=u),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(h===2){if(a===this.c)return;const u=a.next,I=a.previous;a===this.b?(u.previous=void 0,this.b=u):(u.previous=I,I.next=u),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((h,u)=>{a.push([u,h])}),a}fromJSON(a){this.clear();for(const[h,u]of a)this.set(h,u)}}e.LinkedMap=S;class f extends S{constructor(a,h=1){super(),this.k=a,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,h=2){return super.get(a,h)}peek(a){return super.get(a,0)}set(a,h){return super.set(a,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=f;class d{constructor(){this.a=new Map}add(a){return this.a.set(a,(this.a.get(a)||0)+1),this}delete(a){let h=this.a.get(a)||0;return h===0?!1:(h--,h===0?this.a.delete(a):this.a.set(a,h),!0)}has(a){return this.a.has(a)}}e.CounterSet=d}),define(oe[86],ae([0,1,35]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const U=new k.LRUCache(1e4);function A(m){return C(m,"NFC",U)}e.normalizeNFC=A;const N=new k.LRUCache(1e4);function T(m){return C(m,"NFD",N)}e.normalizeNFD=T;const D=/[^\u0000-\u0080]/;function C(m,P,v){if(!m)return m;const S=v.get(m);if(S)return S;let f;return D.test(m)?f=m.normalize(P):f=m,v.set(m,f),f}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(P){return T(P).replace(m,"")}}()}),function(){function ne(A){const N=[];typeof A=="number"&&N.push("code/timeOrigin",A);function T(C){N.push(C,Date.now())}function D(){const C=[];for(let m=0;m<N.length;m+=2)C.push({name:N[m],startTime:N[m+1]});return C}return{mark:T,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const T of performance.getEntriesByType("mark"))N.push({name:T.name,startTime:Math.round(A+T.startTime)});return N}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function k(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var U;typeof global=="object"?U=global:typeof self=="object"?U=self:U={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(U)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(U):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),U.perf=k(U))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var U in k)(typeof exports=="object"?exports:ne)[U]=k[U]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function k(U){if(e[U])return e[U].exports;var A=e[U]={i:U,l:!1,exports:{}};return ne[U].call(A.exports,A,A.exports,k),A.l=!0,A.exports}return k.m=ne,k.c=e,k.d=function(U,A,N){k.o(U,A)||Object.defineProperty(U,A,{enumerable:!0,get:N})},k.r=function(U){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(U,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(U,"__esModule",{value:!0})},k.t=function(U,A){if(1&A&&(U=k(U)),8&A||4&A&&typeof U=="object"&&U&&U.__esModule)return U;var N=Object.create(null);if(k.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:U}),2&A&&typeof U!="string")for(var T in U)k.d(N,T,function(D){return U[D]}.bind(null,T));return N},k.n=function(U){var A=U&&U.__esModule?function(){return U.default}:function(){return U};return k.d(A,"a",A),A},k.o=function(U,A){return Object.prototype.hasOwnProperty.call(U,A)},k.p="",k(k.s=0)}([function(ne,e,k){(function(U){var A;e=ne.exports=_,A=typeof U=="object"&&U.env&&U.env.NODE_DEBUG&&/\bsemver\b/i.test(U.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],C=e.src=[],m=0,P=m++;C[P]="0|[1-9]\\d*";var v=m++;C[v]="[0-9]+";var S=m++;C[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=m++;C[f]="("+C[P]+")\\.("+C[P]+")\\.("+C[P]+")";var d=m++;C[d]="("+C[v]+")\\.("+C[v]+")\\.("+C[v]+")";var w=m++;C[w]="(?:"+C[P]+"|"+C[S]+")";var a=m++;C[a]="(?:"+C[v]+"|"+C[S]+")";var h=m++;C[h]="(?:-("+C[w]+"(?:\\."+C[w]+")*))";var u=m++;C[u]="(?:-?("+C[a]+"(?:\\."+C[a]+")*))";var I=m++;C[I]="[0-9A-Za-z-]+";var p=m++;C[p]="(?:\\+("+C[I]+"(?:\\."+C[I]+")*))";var L=m++,n="v?"+C[f]+C[h]+"?"+C[p]+"?";C[L]="^"+n+"$";var r="[v=\\s]*"+C[d]+C[u]+"?"+C[p]+"?",t=m++;C[t]="^"+r+"$";var i=m++;C[i]="((?:<|>)?=?)";var s=m++;C[s]=C[v]+"|x|X|\\*";var o=m++;C[o]=C[P]+"|x|X|\\*";var l=m++;C[l]="[v=\\s]*("+C[o]+")(?:\\.("+C[o]+")(?:\\.("+C[o]+")(?:"+C[h]+")?"+C[p]+"?)?)?";var E=m++;C[E]="[v=\\s]*("+C[s]+")(?:\\.("+C[s]+")(?:\\.("+C[s]+")(?:"+C[u]+")?"+C[p]+"?)?)?";var y=m++;C[y]="^"+C[i]+"\\s*"+C[l]+"$";var c=m++;C[c]="^"+C[i]+"\\s*"+C[E]+"$";var b=m++;C[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=m++;C[R]="(?:~>?)";var M=m++;C[M]="(\\s*)"+C[R]+"\\s+",D[M]=new RegExp(C[M],"g");var F=m++;C[F]="^"+C[R]+C[l]+"$";var H=m++;C[H]="^"+C[R]+C[E]+"$";var q=m++;C[q]="(?:\\^)";var V=m++;C[V]="(\\s*)"+C[q]+"\\s+",D[V]=new RegExp(C[V],"g");var Q=m++;C[Q]="^"+C[q]+C[l]+"$";var te=m++;C[te]="^"+C[q]+C[E]+"$";var Y=m++;C[Y]="^"+C[i]+"\\s*("+r+")$|^$";var x=m++;C[x]="^"+C[i]+"\\s*("+n+")$|^$";var G=m++;C[G]="(\\s*)"+C[i]+"\\s*("+r+"|"+C[l]+")",D[G]=new RegExp(C[G],"g");var j=m++;C[j]="^\\s*("+C[l]+")\\s+-\\s+("+C[l]+")\\s*$";var Z=m++;C[Z]="^\\s*("+C[E]+")\\s+-\\s+("+C[E]+")\\s*$";var ie=m++;C[ie]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)A(se,C[se]),D[se]||(D[se]=new RegExp(C[se]));function K(le,fe){if(le instanceof _)return le;if(typeof le!="string"||le.length>N||!(fe?D[t]:D[L]).test(le))return null;try{return new _(le,fe)}catch{return null}}function _(le,fe){if(le instanceof _){if(le.loose===fe)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof _))return new _(le,fe);A("SemVer",le,fe),this.loose=fe;var ge=le.trim().match(fe?D[t]:D[L]);if(!ge)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Pe=+Ce;if(Pe>=0&&Pe<T)return Pe}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=K,e.valid=function(le,fe){var ge=K(le,fe);return ge?ge.version:null},e.clean=function(le,fe){var ge=K(le.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(le){return A("SemVer.compare",this.version,this.loose,le),le instanceof _||(le=new _(le,this.loose)),this.compareMain(le)||this.comparePre(le)},_.prototype.compareMain=function(le){return le instanceof _||(le=new _(le,this.loose)),g(this.major,le.major)||g(this.minor,le.minor)||g(this.patch,le.patch)},_.prototype.comparePre=function(le){if(le instanceof _||(le=new _(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Ce=le.prerelease[fe];if(A("prerelease compare",fe,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return g(ge,Ce)}while(++fe)},_.prototype.inc=function(le,fe){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,fe,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new _(le,ge).inc(fe,Ce).version}catch{return null}},e.diff=function(le,fe){if(z(le,fe))return null;var ge=K(le),Ce=K(fe);if(ge.prerelease.length||Ce.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return Pe},e.compareIdentifiers=g;var $=/^[0-9]+$/;function g(le,fe){var ge=$.test(le),Ce=$.test(fe);return ge&&Ce&&(le=+le,fe=+fe),ge&&!Ce?-1:Ce&&!ge?1:le<fe?-1:le>fe?1:0}function O(le,fe,ge){return new _(le,ge).compare(new _(fe,ge))}function B(le,fe,ge){return O(le,fe,ge)>0}function W(le,fe,ge){return O(le,fe,ge)<0}function z(le,fe,ge){return O(le,fe,ge)===0}function J(le,fe,ge){return O(le,fe,ge)!==0}function ee(le,fe,ge){return O(le,fe,ge)>=0}function ce(le,fe,ge){return O(le,fe,ge)<=0}function ue(le,fe,ge,Ce){var Pe;switch(fe){case"===":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Pe=le===ge;break;case"!==":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Pe=le!==ge;break;case"":case"=":case"==":Pe=z(le,ge,Ce);break;case"!=":Pe=J(le,ge,Ce);break;case">":Pe=B(le,ge,Ce);break;case">=":Pe=ee(le,ge,Ce);break;case"<":Pe=W(le,ge,Ce);break;case"<=":Pe=ce(le,ge,Ce);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function de(le,fe){if(le instanceof de){if(le.loose===fe)return le;le=le.value}if(!(this instanceof de))return new de(le,fe);A("comparator",le,fe),this.loose=fe,this.parse(le),this.semver===Se?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(le,fe){return g(fe,le)},e.major=function(le,fe){return new _(le,fe).major},e.minor=function(le,fe){return new _(le,fe).minor},e.patch=function(le,fe){return new _(le,fe).patch},e.compare=O,e.compareLoose=function(le,fe){return O(le,fe,!0)},e.rcompare=function(le,fe,ge){return O(fe,le,ge)},e.sort=function(le,fe){return le.sort(function(ge,Ce){return e.compare(ge,Ce,fe)})},e.rsort=function(le,fe){return le.sort(function(ge,Ce){return e.rcompare(ge,Ce,fe)})},e.gt=B,e.lt=W,e.eq=z,e.neq=J,e.gte=ee,e.lte=ce,e.cmp=ue,e.Comparator=de;var Se={};function we(le,fe){if(le instanceof we)return le.loose===fe?le:new we(le.raw,fe);if(le instanceof de)return new we(le.value,fe);if(!(this instanceof we))return new we(le,fe);if(this.loose=fe,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function be(le){return!le||le.toLowerCase()==="x"||le==="*"}function De(le,fe,ge,Ce,Pe,Me,Le,Be,Ne,je,Fe,Ae,re){return((fe=be(ge)?"":be(Ce)?">="+ge+".0.0":be(Pe)?">="+ge+"."+Ce+".0":">="+fe)+" "+(Be=be(Ne)?"":be(je)?"<"+(+Ne+1)+".0.0":be(Fe)?"<"+Ne+"."+(+je+1)+".0":Ae?"<="+Ne+"."+je+"."+Fe+"-"+Ae:"<="+Be)).trim()}function ke(le,fe){for(var ge=0;ge<le.length;ge++)if(!le[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<le.length;ge++)if(A(le[ge].semver),le[ge].semver!==Se&&le[ge].semver.prerelease.length>0){var Ce=le[ge].semver;if(Ce.major===fe.major&&Ce.minor===fe.minor&&Ce.patch===fe.patch)return!0}return!1}return!0}function ze(le,fe,ge){try{fe=new we(fe,ge)}catch{return!1}return fe.test(le)}function Je(le,fe,ge,Ce){var Pe,Me,Le,Be,Ne;switch(le=new _(le,Ce),fe=new we(fe,Ce),ge){case">":Pe=B,Me=ce,Le=W,Be=">",Ne=">=";break;case"<":Pe=W,Me=ee,Le=B,Be="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(le,fe,Ce))return!1;for(var je=0;je<fe.set.length;++je){var Fe=fe.set[je],Ae=null,re=null;if(Fe.forEach(function(he){he.semver===Se&&(he=new de(">=0.0.0")),Ae=Ae||he,re=re||he,Pe(he.semver,Ae.semver,Ce)?Ae=he:Le(he.semver,re.semver,Ce)&&(re=he)}),Ae.operator===Be||Ae.operator===Ne||(!re.operator||re.operator===Be)&&Me(le,re.semver)||re.operator===Ne&&Le(le,re.semver))return!1}return!0}de.prototype.parse=function(le){var fe=this.loose?D[Y]:D[x],ge=le.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+le);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new _(ge[2],this.loose):this.semver=Se},de.prototype.toString=function(){return this.value},de.prototype.test=function(le){return A("Comparator.test",le,this.loose),this.semver===Se||(typeof le=="string"&&(le=new _(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},de.prototype.intersects=function(le,fe){if(!(le instanceof de))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new we(le.value,fe),ze(this.value,ge,fe);if(le.operator==="")return ge=new we(this.value,fe),ze(le.semver,ge,fe);var Ce=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Me=this.semver.version===le.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),Be=ue(this.semver,"<",le.semver,fe)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Ne=ue(this.semver,">",le.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Ce||Pe||Me&&Le||Be||Ne},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(le){var fe=this.loose;le=le.trim(),A("range",le,fe);var ge=fe?D[Z]:D[j];le=le.replace(ge,De),A("hyphen replace",le),le=le.replace(D[G],"$1$2$3"),A("comparator trim",le,D[G]),le=(le=(le=le.replace(D[M],"$1~")).replace(D[V],"$1^")).split(/\s+/).join(" ");var Ce=fe?D[Y]:D[x],Pe=le.split(" ").map(function(Me){return function(Le,Be){return A("comp",Le),Le=function(Ne,je){return Ne.trim().split(/\s+/).map(function(Fe){return function(Ae,re){A("caret",Ae,re);var he=re?D[te]:D[Q];return Ae.replace(he,function(me,ye,pe,Ie,Re){var Oe;return A("caret",Ae,me,ye,pe,Ie,Re),be(ye)?Oe="":be(pe)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":be(Ie)?Oe=ye==="0"?">="+ye+"."+pe+".0 <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+".0 <"+(+ye+1)+".0.0":Re?(A("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Oe=ye==="0"?pe==="0"?">="+ye+"."+pe+"."+Ie+Re+" <"+ye+"."+pe+"."+(+Ie+1):">="+ye+"."+pe+"."+Ie+Re+" <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+"."+Ie+Re+" <"+(+ye+1)+".0.0"):(A("no pr"),Oe=ye==="0"?pe==="0"?">="+ye+"."+pe+"."+Ie+" <"+ye+"."+pe+"."+(+Ie+1):">="+ye+"."+pe+"."+Ie+" <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+"."+Ie+" <"+(+ye+1)+".0.0"),A("caret return",Oe),Oe})}(Fe,je)}).join(" ")}(Le,Be),A("caret",Le),Le=function(Ne,je){return Ne.trim().split(/\s+/).map(function(Fe){return function(Ae,re){var he=re?D[H]:D[F];return Ae.replace(he,function(me,ye,pe,Ie,Re){var Oe;return A("tilde",Ae,me,ye,pe,Ie,Re),be(ye)?Oe="":be(pe)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":be(Ie)?Oe=">="+ye+"."+pe+".0 <"+ye+"."+(+pe+1)+".0":Re?(A("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Oe=">="+ye+"."+pe+"."+Ie+Re+" <"+ye+"."+(+pe+1)+".0"):Oe=">="+ye+"."+pe+"."+Ie+" <"+ye+"."+(+pe+1)+".0",A("tilde return",Oe),Oe})}(Fe,je)}).join(" ")}(Le,Be),A("tildes",Le),Le=function(Ne,je){return A("replaceXRanges",Ne,je),Ne.split(/\s+/).map(function(Fe){return function(Ae,re){Ae=Ae.trim();var he=re?D[c]:D[y];return Ae.replace(he,function(me,ye,pe,Ie,Re,Oe){A("xRange",Ae,me,ye,pe,Ie,Re,Oe);var qe=be(pe),Te=qe||be(Ie),$e=Te||be(Re);return ye==="="&&$e&&(ye=""),qe?me=ye===">"||ye==="<"?"<0.0.0":"*":ye&&$e?(Te&&(Ie=0),$e&&(Re=0),ye===">"?(ye=">=",Te?(pe=+pe+1,Ie=0,Re=0):$e&&(Ie=+Ie+1,Re=0)):ye==="<="&&(ye="<",Te?pe=+pe+1:Ie=+Ie+1),me=ye+pe+"."+Ie+"."+Re):Te?me=">="+pe+".0.0 <"+(+pe+1)+".0.0":$e&&(me=">="+pe+"."+Ie+".0 <"+pe+"."+(+Ie+1)+".0"),A("xRange return",me),me})}(Fe,je)}).join(" ")}(Le,Be),A("xrange",Le),Le=function(Ne,je){return A("replaceStars",Ne,je),Ne.trim().replace(D[ie],"")}(Le,Be),A("stars",Le),Le}(Me,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Me){return!!Me.match(Ce)})),Pe=Pe.map(function(Me){return new de(Me,fe)})},we.prototype.intersects=function(le,fe){if(!(le instanceof we))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return le.set.some(function(Pe){return Pe.every(function(Me){return Ce.intersects(Me,fe)})})})})},e.toComparators=function(le,fe){return new we(le,fe).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},we.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new _(le,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],le))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(le,fe,ge){var Ce=null,Pe=null;try{var Me=new we(fe,ge)}catch{return null}return le.forEach(function(Le){Me.test(Le)&&(Ce&&Pe.compare(Le)!==-1||(Pe=new _(Ce=Le,ge)))}),Ce},e.minSatisfying=function(le,fe,ge){var Ce=null,Pe=null;try{var Me=new we(fe,ge)}catch{return null}return le.forEach(function(Le){Me.test(Le)&&(Ce&&Pe.compare(Le)!==1||(Pe=new _(Ce=Le,ge)))}),Ce},e.validRange=function(le,fe){try{return new we(le,fe).range||"*"}catch{return null}},e.ltr=function(le,fe,ge){return Je(le,fe,"<",ge)},e.gtr=function(le,fe,ge){return Je(le,fe,">",ge)},e.outside=Je,e.prerelease=function(le,fe){var ge=K(le,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(le,fe,ge){return le=new we(le,ge),fe=new we(fe,ge),le.intersects(fe)},e.coerce=function(le){if(le instanceof _)return le;if(typeof le!="string")return null;var fe=le.match(D[b]);return fe==null?null:K((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,k(1))},function(ne,e){var k,U,A=ne.exports={};function N(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function D(a){if(k===setTimeout)return setTimeout(a,0);if((k===N||!k)&&setTimeout)return k=setTimeout,setTimeout(a,0);try{return k(a,0)}catch{try{return k.call(null,a,0)}catch{return k.call(this,a,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:N}catch{k=N}try{U=typeof clearTimeout=="function"?clearTimeout:T}catch{U=T}})();var C,m=[],P=!1,v=-1;function S(){P&&C&&(P=!1,C.length?m=C.concat(m):v=-1,m.length&&f())}function f(){if(!P){var a=D(S);P=!0;for(var h=m.length;h;){for(C=m,m=[];++v<h;)C&&C[v].run();v=-1,h=m.length}C=null,P=!1,function(u){if(U===clearTimeout)return clearTimeout(u);if((U===T||!U)&&clearTimeout)return U=clearTimeout,clearTimeout(u);try{U(u)}catch{try{return U.call(null,u)}catch{return U.call(this,u)}}}(a)}}function d(a,h){this.fun=a,this.array=h}function w(){}A.nextTick=function(a){var h=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)h[u-1]=arguments[u];m.push(new d(a,h)),m.length!==1||P||D(f)},d.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=w,A.addListener=w,A.once=w,A.off=w,A.removeListener=w,A.removeAllListeners=w,A.emit=w,A.prependListener=w,A.prependOnceListener=w,A.listeners=function(a){return[]},A.binding=function(a){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(a){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(oe[123],ae([0,1]),function(ne,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class U{constructor(D,C,m){this.level=D,this.key=C,this.value=m,this.forward=[]}}const A=void 0;class N{constructor(D,C=2**16){this.comparator=D,this[k]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(C)|0),this.e=new U(this.c,A,A)}get size(){return this.f}clear(){this.e=new U(this.c,A,A)}has(D){return!!N.g(this,D,this.comparator)}get(D){return N.g(this,D,this.comparator)?.value}set(D,C){return N.h(this,D,C,this.comparator)&&(this.f+=1),this}delete(D){const C=N.k(this,D,this.comparator);return C&&(this.f-=1),C}forEach(D,C){let m=this.e.forward[0];for(;m;)D.call(C,m.value,m.key,this),m=m.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this.e.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this.e.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this.e.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",C=this.e.forward[0];for(;C;)D+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return D}static g(D,C,m){let P=D.e;for(let v=D.d-1;v>=0;v--)for(;P.forward[v]&&m(P.forward[v].key,C)<0;)P=P.forward[v];if(P=P.forward[0],P&&m(P.key,C)===0)return P}static h(D,C,m,P){const v=[];let S=D.e;for(let f=D.d-1;f>=0;f--){for(;S.forward[f]&&P(S.forward[f].key,C)<0;)S=S.forward[f];v[f]=S}if(S=S.forward[0],S&&P(S.key,C)===0)return S.value=m,!1;{const f=N.j(D);if(f>D.d){for(let d=D.d;d<f;d++)v[d]=D.e;D.d=f}S=new U(f,C,m);for(let d=0;d<f;d++)S.forward[d]=v[d].forward[d],v[d].forward[d]=S;return!0}}static j(D,C=.5){let m=1;for(;Math.random()<C&&m<D.c;)m+=1;return m}static k(D,C,m){const P=[];let v=D.e;for(let S=D.d-1;S>=0;S--){for(;v.forward[S]&&m(v.forward[S].key,C)<0;)v=v.forward[S];P[S]=v}if(v=v.forward[0],!v||m(v.key,C)!==0)return!1;for(let S=0;S<D.d&&P[S].forward[S]===v;S++)P[S].forward[S]=v.forward[S];for(;D.d>0&&D.e.forward[D.d-1]===A;)D.d-=1;return!0}}e.SkipList=N}),define(oe[42],ae([0,1,7,2]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function A(p){const L=p;return L?typeof L.read=="function":!1}e.isReadable=A;function N(p){const L=p;return L?[L.on,L.pause,L.resume,L.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=N;function T(p){const L=p;return L?N(L.stream)&&Array.isArray(L.buffer)&&typeof L.ended=="boolean":!1}e.isReadableBufferedStream=T;function D(p,L){return new C(p,L)}e.newWriteableStream=D;class C{constructor(L,n){this.e=L,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(L){if(!this.a.destroyed){if(this.a.flowing)this.g(L);else if(this.b.data.push(L),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(L){this.a.destroyed||(this.a.flowing?this.h(L):this.b.error.push(L))}end(L){this.a.destroyed||(typeof L<"u"&&this.write(L),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(L){this.c.data.slice(0).forEach(n=>n(L))}h(L){this.c.error.length===0?(0,k.onUnexpectedError)(L):this.c.error.slice(0).forEach(n=>n(L))}i(){this.c.end.slice(0).forEach(L=>L())}on(L,n){if(!this.a.destroyed)switch(L){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(L,n){if(this.a.destroyed)return;let r;switch(L){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const L=this.e(this.b.data);this.g(L),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const L of this.b.error)this.h(L);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(p,L){const n=[];let r;for(;(r=p.read())!==null;)n.push(r);return L(n)}e.consumeReadable=m;function P(p,L,n){const r=[];let t;for(;(t=p.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?L(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return p.read()}}}e.peekReadable=P;function v(p,L){return new Promise((n,r)=>{const t=[];S(p,{onData:i=>{L&&t.push(i)},onError:i=>{L?r(i):n(void 0)},onEnd:()=>{n(L?L(t):void 0)}})})}e.consumeStream=v;function S(p,L){let n=!1;return p.on("error",r=>{n||L.onError(r)}),p.on("end",()=>{n||L.onEnd()}),p.on("data",r=>{n||L.onData(r)}),(0,U.toDisposable)(()=>n=!0)}e.listenStream=S;function f(p,L){return new Promise((n,r)=>{const t=new U.DisposableStore,i=[],s=E=>{if(i.push(E),i.length>L)return t.dispose(),p.pause(),n({stream:p,buffer:i,ended:!1})},o=E=>r(E),l=()=>n({stream:p,buffer:i,ended:!0});t.add((0,U.toDisposable)(()=>p.removeListener("error",o))),p.on("error",o),t.add((0,U.toDisposable)(()=>p.removeListener("end",l))),p.on("end",l),t.add((0,U.toDisposable)(()=>p.removeListener("data",s))),p.on("data",s)})}e.peekStream=f;function d(p,L){const n=D(L);return n.end(p),n}e.toStream=d;function w(){const p=D(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=w;function a(p){let L=!1;return{read:()=>L?null:(L=!0,p)}}e.toReadable=a;function h(p,L,n){const r=D(n);return S(p,{onData:t=>r.write(L.data(t)),onError:t=>r.error(L.error?L.error(t):t),onEnd:()=>r.end()}),r}e.transform=h;function u(p,L,n){let r=!1;return{read:()=>{const t=L.read();return r?t:(r=!0,t!==null?n([p,t]):p)}}}e.prefixedReadable=u;function I(p,L,n){let r=!1;const t=D(n);return S(L,{onData:i=>r?t.write(i):(r=!0,t.write(n([p,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(p)),t.end()}}),t}e.prefixedStream=I}),define(oe[16],ae([0,1,84,42]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u",N=new k.Lazy(()=>new Uint8Array(256));let T,D;class C{static alloc(c){return A?new C(Buffer.allocUnsafe(c)):new C(new Uint8Array(c))}static wrap(c){return A&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new C(c)}static fromString(c,b){return!(b?.dontUseNodeBuffer||!1)&&A?new C(Buffer.from(c)):(T||(T=new TextEncoder),new C(T.encode(c)))}static fromByteArray(c){const b=C.alloc(c.length);for(let R=0,M=c.length;R<M;R++)b.buffer[R]=c[R];return b}static concat(c,b){if(typeof b>"u"){b=0;for(let F=0,H=c.length;F<H;F++)b+=c[F].byteLength}const R=C.alloc(b);let M=0;for(let F=0,H=c.length;F<H;F++){const q=c[F];R.set(q,M),M+=q.byteLength}return R}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=C.alloc(this.byteLength);return c.set(this),c}toString(){return A?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(c,b){return new C(this.buffer.subarray(c,b))}set(c,b){if(c instanceof C)this.buffer.set(c.buffer,b);else if(c instanceof Uint8Array)this.buffer.set(c,b);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),b);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return v(this.buffer,c)}writeUInt32BE(c,b){S(this.buffer,c,b)}readUInt32LE(c){return f(this.buffer,c)}writeUInt32LE(c,b){d(this.buffer,c,b)}readUInt8(c){return w(this.buffer,c)}writeUInt8(c,b){a(this.buffer,c,b)}indexOf(c){const b=c instanceof C?c.buffer:c,R=b.byteLength,M=this.buffer,F=M.byteLength;if(R===0)return 0;if(R===1)return M.indexOf(b[0]);if(R>F)return-1;const H=N.value;H.fill(b.length);for(let te=0;te<b.length;te++)H[b[te]]=b.length-te-1;let q=b.length-1,V=q,Q=-1;for(;q<F;)if(M[q]===b[V]){if(V===0){Q=q;break}q--,V--}else q+=Math.max(b.length-V,H[M[q]]),V=b.length-1;return Q}}e.VSBuffer=C;function m(y,c){return y[c+0]<<0>>>0|y[c+1]<<8>>>0}e.readUInt16LE=m;function P(y,c,b){y[b+0]=c&255,c=c>>>8,y[b+1]=c&255}e.writeUInt16LE=P;function v(y,c){return y[c]*2**24+y[c+1]*2**16+y[c+2]*2**8+y[c+3]}e.readUInt32BE=v;function S(y,c,b){y[b+3]=c,c=c>>>8,y[b+2]=c,c=c>>>8,y[b+1]=c,c=c>>>8,y[b]=c}e.writeUInt32BE=S;function f(y,c){return y[c+0]<<0>>>0|y[c+1]<<8>>>0|y[c+2]<<16>>>0|y[c+3]<<24>>>0}e.readUInt32LE=f;function d(y,c,b){y[b+0]=c&255,c=c>>>8,y[b+1]=c&255,c=c>>>8,y[b+2]=c&255,c=c>>>8,y[b+3]=c&255}e.writeUInt32LE=d;function w(y,c){return y[c]}e.readUInt8=w;function a(y,c,b){y[b]=c}e.writeUInt8=a;function h(y){return U.consumeReadable(y,c=>C.concat(c))}e.readableToBuffer=h;function u(y){return U.toReadable(y)}e.bufferToReadable=u;function I(y){return U.consumeStream(y,c=>C.concat(c))}e.streamToBuffer=I;async function p(y){return y.ended?C.concat(y.buffer):C.concat([...y.buffer,await I(y.stream)])}e.bufferedStreamToBuffer=p;function L(y){return U.toStream(y,c=>C.concat(c))}e.bufferToStream=L;function n(y){return U.transform(y,{data:c=>typeof c=="string"?C.fromString(c):C.wrap(c)},c=>C.concat(c))}e.streamToBufferReadableStream=n;function r(y){return U.newWriteableStream(c=>C.concat(c),y)}e.newWriteableBufferStream=r;function t(y,c){return U.prefixedReadable(y,c,b=>C.concat(b))}e.prefixedBufferReadable=t;function i(y,c){return U.prefixedStream(y,c,b=>C.concat(b))}e.prefixedBufferStream=i;function s(y){let c=0,b=0,R=0;const M=new Uint8Array(Math.floor(y.length/4*3)),F=q=>{switch(b){case 3:M[R++]=c|q,b=0;break;case 2:M[R++]=c|q>>>2,c=q<<6,b=3;break;case 1:M[R++]=c|q>>>4,c=q<<4,b=2;break;default:c=q<<2,b=1}};for(let q=0;q<y.length;q++){const V=y.charCodeAt(q);if(V>=65&&V<=90)F(V-65);else if(V>=97&&V<=122)F(V-97+26);else if(V>=48&&V<=57)F(V-48+52);else if(V===43||V===45)F(62);else if(V===47||V===95)F(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${y[q]}`)}}const H=R;for(;b>0;)F(0);return C.wrap(M).slice(0,H)}e.decodeBase64=s;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:y},c=!0,b=!1){const R=b?l:o;let M="";const F=y.byteLength%3;let H=0;for(;H<y.byteLength-F;H+=3){const q=y[H+0],V=y[H+1],Q=y[H+2];M+=R[q>>>2],M+=R[(q<<4|V>>>4)&63],M+=R[(V<<2|Q>>>6)&63],M+=R[Q&63]}if(F===1){const q=y[H+0];M+=R[q>>>2],M+=R[q<<4&63],c&&(M+="==")}else if(F===2){const q=y[H+0],V=y[H+1];M+=R[q>>>2],M+=R[(q<<4|V>>>4)&63],M+=R[V<<2&63],c&&(M+="=")}return M}e.encodeBase64=E}),define(oe[124],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(oe[10],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function k(r){return typeof r=="string"}e.isString=k;function U(r){return Array.isArray(r)&&r.every(t=>k(t))}e.isStringArray=U;function A(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=A;function N(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=N;function T(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=T;function D(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=D;function C(r){return r===!0||r===!1}e.isBoolean=C;function m(r){return typeof r>"u"}e.isUndefined=m;function P(r){return!v(r)}e.isDefined=P;function v(r){return m(r)||r===null}e.isUndefinedOrNull=v;function S(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=S;function f(r){if(v(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=f;function d(...r){const t=[];for(let i=0;i<r.length;i++){const s=r[i];if(v(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(s)}return t}e.assertAllDefined=d;const w=Object.prototype.hasOwnProperty;function a(r){if(!A(r))return!1;for(const t in r)if(w.call(r,t))return!1;return!0}e.isEmptyObject=a;function h(r){return typeof r=="function"}e.isFunction=h;function u(...r){return r.length>0&&r.every(h)}e.areFunctions=u;function I(r,t){const i=Math.min(r.length,t.length);for(let s=0;s<i;s++)p(r[s],t[s])}e.validateConstraints=I;function p(r,t){if(k(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(h(t)){try{if(r instanceof t)return}catch{}if(!v(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function L(r){return r===null?void 0:r}e.withNullAsUndefined=L;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(oe[31],ae([0,1,10]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function U(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const u=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([I,p])=>{u[I]=p&&typeof p=="object"?U(p):p}),u}e.deepClone=U;function A(h){if(!h||typeof h!="object")return h;const u=[h];for(;u.length>0;){const I=u.shift();Object.freeze(I);for(const p in I)if(N.call(I,p)){const L=I[p];typeof L=="object"&&!Object.isFrozen(L)&&!(0,k.isTypedArray)(L)&&u.push(L)}}return h}e.deepFreeze=A;const N=Object.prototype.hasOwnProperty;function T(h,u){return D(h,u,new Set)}e.cloneAndChange=T;function D(h,u,I){if((0,k.isUndefinedOrNull)(h))return h;const p=u(h);if(typeof p<"u")return p;if(Array.isArray(h)){const L=[];for(const n of h)L.push(D(n,u,I));return L}if((0,k.isObject)(h)){if(I.has(h))throw new Error("Cannot clone recursive data-structure");I.add(h);const L={};for(const n in h)N.call(h,n)&&(L[n]=D(h[n],u,I));return I.delete(h),L}return h}function C(h,u,I=!0){return(0,k.isObject)(h)?((0,k.isObject)(u)&&Object.keys(u).forEach(p=>{p in h?I&&((0,k.isObject)(h[p])&&(0,k.isObject)(u[p])?C(h[p],u[p],I):h[p]=u[p]):h[p]=u[p]}),h):u}e.mixin=C;function m(h,u){if(h===u)return!0;if(h==null||u===null||u===void 0||typeof h!=typeof u||typeof h!="object"||Array.isArray(h)!==Array.isArray(u))return!1;let I,p;if(Array.isArray(h)){if(h.length!==u.length)return!1;for(I=0;I<h.length;I++)if(!m(h[I],u[I]))return!1}else{const L=[];for(p in h)L.push(p);L.sort();const n=[];for(p in u)n.push(p);if(n.sort(),!m(L,n))return!1;for(I=0;I<L.length;I++)if(!m(h[L[I]],u[L[I]]))return!1}return!0}e.equals=m;function P(h){const u=new Set;return JSON.stringify(h,(I,p)=>{if((0,k.isObject)(p)||Array.isArray(p)){if(u.has(p))return"[Circular]";u.add(p)}return p})}e.safeStringify=P;function v(h,u){const I=Object.create(null);return!h||!u||Object.keys(u).forEach(L=>{const n=h[L],r=u[L];m(n,r)||(I[L]=r)}),I}e.distinct=v;function S(h,u){const I=u.toLowerCase(),p=Object.keys(h).find(L=>L.toLowerCase()===I);return p?h[p]:h[u]}e.getCaseInsensitive=S;function f(h,u){const I=Object.create(null);for(const[p,L]of Object.entries(h))u(p,L)&&(I[p]=L);return I}e.filter=f;function d(h){let u=[],I=Object.getPrototypeOf(h);for(;Object.prototype!==I;)u=u.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return u}e.getAllPropertyNames=d;function w(h){const u=[];for(const I of d(h))typeof h[I]=="function"&&u.push(I);return u}e.getAllMethodNames=w;function a(h,u){const I=L=>function(){const n=Array.prototype.slice.call(arguments,0);return u(L,n)},p={};for(const L of h)p[L]=I(L);return p}e.createProxyObject=a}),define(oe[32],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function U(A){return k.test(A)}e.isUUID=U,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(D){for(let C=0;C<D.length;C++)D[C]=Math.floor(Math.random()*256);return D};const N=new Uint8Array(16),T=[];for(let D=0;D<256;D++)T.push(D.toString(16).padStart(2,"0"));return function(){A(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let C=0,m="";return m+=T[N[C++]],m+=T[N[C++]],m+=T[N[C++]],m+=T[N[C++]],m+="-",m+=T[N[C++]],m+=T[N[C++]],m+="-",m+=T[N[C++]],m+=T[N[C++]],m+="-",m+=T[N[C++]],m+=T[N[C++]],m+="-",m+=T[N[C++]],m+=T[N[C++]],m+=T[N[C++]],m+=T[N[C++]],m+=T[N[C++]],m+=T[N[C++]],m}}()}),define(oe[125],ae([0,1,36]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const U=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(T){const D=T.replace(/\-/g,":").toLowerCase();return!U.has(D)}function N(){const T=(0,k.networkInterfaces)();for(const D in T){const C=T[D];if(C){for(const{mac:m}of C)if(A(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=N}),define(oe[126],ae([0,1,61]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function U(D,C,m,P=1){let v=!1;return new Promise(S=>{const f=setTimeout(()=>{if(!v)return v=!0,S(0)},m);A(D,C,P,d=>{if(!v)return v=!0,clearTimeout(f),S(d)})})}e.findFreePort=U;function A(D,C,m,P){if(C===0)return P(0);const v=new k.Socket;v.once("connect",()=>(T(v),A(D+m,C-1,m,P))),v.once("data",()=>{}),v.once("error",S=>(T(v),S.code!=="ECONNREFUSED"?A(D+m,C-1,m,P):P(D))),v.connect(D,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function N(D,C,m,P="127.0.0.1"){let v=!1,S,f=1;const d=k.createServer({pauseOnConnect:!0});function w(a,h){v||(v=!0,d.removeAllListeners(),d.close(),S&&clearTimeout(S),h(a))}return new Promise(a=>{S=setTimeout(()=>{w(0,a)},m),d.on("listening",()=>{w(D,a)}),d.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&f<C?(D++,f++,d.listen(D,P)):w(0,a)}),d.on("close",()=>{w(0,a)}),d.listen(D,P)})}e.findFreePortFaster=N;function T(D){try{D.removeAllListeners("connect"),D.removeAllListeners("error"),D.end(),D.destroy(),D.unref()}catch(C){console.error(C)}}}),define(oe[127],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function k(U){return!!U.parentPort}e.isUtilityProcess=k}),define(oe[128],ae([11,9]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(oe[62],ae([0,1,128]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const U=60,A=U*60,N=A*24,T=N*7,D=N*30,C=N*365;function m(v,S,f,d){typeof v!="number"&&(v=v.getTime());const w=Math.round((new Date().getTime()-v)/1e3);if(w<-30)return(0,k.localize)(0,null,m(new Date().getTime()+w*1e3,!1));if(!d&&w<30)return(0,k.localize)(1,null);let a;return w<U?(a=w,S?a===1?f?(0,k.localize)(2,null,a):(0,k.localize)(3,null,a):f?(0,k.localize)(4,null,a):(0,k.localize)(5,null,a):a===1?f?(0,k.localize)(6,null,a):(0,k.localize)(7,null,a):f?(0,k.localize)(8,null,a):(0,k.localize)(9,null,a)):w<A?(a=Math.floor(w/U),S?a===1?f?(0,k.localize)(10,null,a):(0,k.localize)(11,null,a):f?(0,k.localize)(12,null,a):(0,k.localize)(13,null,a):a===1?f?(0,k.localize)(14,null,a):(0,k.localize)(15,null,a):f?(0,k.localize)(16,null,a):(0,k.localize)(17,null,a)):w<N?(a=Math.floor(w/A),S?a===1?f?(0,k.localize)(18,null,a):(0,k.localize)(19,null,a):f?(0,k.localize)(20,null,a):(0,k.localize)(21,null,a):a===1?f?(0,k.localize)(22,null,a):(0,k.localize)(23,null,a):f?(0,k.localize)(24,null,a):(0,k.localize)(25,null,a)):w<T?(a=Math.floor(w/N),S?a===1?(0,k.localize)(26,null,a):(0,k.localize)(27,null,a):a===1?(0,k.localize)(28,null,a):(0,k.localize)(29,null,a)):w<D?(a=Math.floor(w/T),S?a===1?f?(0,k.localize)(30,null,a):(0,k.localize)(31,null,a):f?(0,k.localize)(32,null,a):(0,k.localize)(33,null,a):a===1?f?(0,k.localize)(34,null,a):(0,k.localize)(35,null,a):f?(0,k.localize)(36,null,a):(0,k.localize)(37,null,a)):w<C?(a=Math.floor(w/D),S?a===1?f?(0,k.localize)(38,null,a):(0,k.localize)(39,null,a):f?(0,k.localize)(40,null,a):(0,k.localize)(41,null,a):a===1?f?(0,k.localize)(42,null,a):(0,k.localize)(43,null,a):f?(0,k.localize)(44,null,a):(0,k.localize)(45,null,a)):(a=Math.floor(w/C),S?a===1?f?(0,k.localize)(46,null,a):(0,k.localize)(47,null,a):f?(0,k.localize)(48,null,a):(0,k.localize)(49,null,a):a===1?f?(0,k.localize)(50,null,a):(0,k.localize)(51,null,a):f?(0,k.localize)(52,null,a):(0,k.localize)(53,null,a))}e.fromNow=m;function P(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(oe[129],ae([11,9]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,10,129]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(v,S){return S&&(v.stack||v.stacktrace)?A.localize(0,null,D(v),T(v.stack)||T(v.stacktrace)):D(v)}function T(v){return Array.isArray(v)?v.join(`
`):v}function D(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?A.localize(1,null,v.message):v.message||A.localize(2,null)}function C(v=null,S=!1){if(!v)return A.localize(3,null);if(Array.isArray(v)){const f=k.coalesce(v),d=C(f[0],S);return f.length>1?A.localize(4,null,d,f.length):d}if(U.isString(v))return v;if(v.detail){const f=v.detail;if(f.error)return N(f.error,S);if(f.exception)return N(f.exception,S)}return v.stack?N(v,S):v.message?v.message:A.localize(5,null)}e.toErrorMessage=C;function m(v){const S=v;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=m;function P(v,S){let f;return typeof v=="string"?f=new Error(v):f=v,f.actions=S,f}e.createErrorWithActions=P}),define(oe[130],ae([11,9]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(oe[131],ae([0,1,130]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function U(A){switch(A){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=U}),define(oe[132],ae([11,9]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,132]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let U=!1,A=!1,N=!1,T=!1,D=!1,C=!1,m=!1,P=!1,v=!1,S=!1,f,d=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT,a,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const I=typeof u?.versions?.electron=="string",p=I&&u?.type==="renderer";if(typeof navigator=="object"&&!p)h=navigator.userAgent,U=h.indexOf("Windows")>=0,A=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,N=h.indexOf("Linux")>=0,S=h?.indexOf("Mobi")>=0,C=!0,f=k.getConfiguredDefaultLocale(k.localize(0,null))||e.LANGUAGE_DEFAULT,d=f,w=navigator.language;else if(typeof u=="object"){U=u.platform==="win32",A=u.platform==="darwin",N=u.platform==="linux",T=N&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,m=I,v=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const E=u.env.VSCODE_NLS_CONFIG;if(E)try{const y=JSON.parse(E),c=y.availableLanguages["*"];f=y.locale,w=y.osLocale,d=c||e.LANGUAGE_DEFAULT,a=y._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var L;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(L||(e.Platform=L={}));function n(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=n;let r=0;A?r=1:U?r=3:N&&(r=2),e.isWindows=U,e.isMacintosh=A,e.isLinux=N,e.isLinuxSnap=T,e.isNative=D,e.isElectron=m,e.isWeb=C,e.isWebWorker=C&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isMobile=S,e.isCI=v,e.platform=r,e.userAgent=h,e.language=d;var t;(function(E){function y(){return e.language}E.value=y;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}E.isDefaultVariant=c;function b(){return e.language==="en"}E.isDefault=b})(t||(e.Language=t={})),e.locale=f,e.platformLocale=w,e.translationsConfigFile=a,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const E=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let b=0,R=E.length;b<R;b++){const M=E[b];if(M.id===c.data.vscodeScheduleAsyncWork){E.splice(b,1),M.callback();return}}});let y=0;return c=>{const b=++y;E.push({id:b,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:b},"*")}}return E=>setTimeout(E)})();var i;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=A||P?2:U?1:3;let s=!0,o=!1;function l(){if(!o){o=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,s=new Uint16Array(E.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[37],ae([0,1,5]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let U;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.process<"u"){const A=k.globals.vscode.process;U={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?U={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:U={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=U.cwd,e.env=U.env,e.platform=U.platform,e.arch=U.arch}),define(oe[15],ae([0,1,37]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const U=65,A=97,N=90,T=122,D=46,C=47,m=92,P=58,v=63;class S extends Error{constructor(r,t,i){let s;typeof t=="string"&&t.indexOf("not ")===0?(s="must not be",t=t.replace(/^not /,"")):s="must be";const o=r.indexOf(".")!==-1?"property":"argument";let l=`The "${r}" ${o} ${s} of type ${t}`;l+=`. Received type ${typeof i}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function f(n,r){if(n===null||typeof n!="object")throw new S(r,"Object",n)}function d(n,r){if(typeof n!="string")throw new S(r,"string",n)}const w=k.platform==="win32";function a(n){return n===C||n===m}function h(n){return n===C}function u(n){return n>=U&&n<=N||n>=A&&n<=T}function I(n,r,t,i){let s="",o=0,l=-1,E=0,y=0;for(let c=0;c<=n.length;++c){if(c<n.length)y=n.charCodeAt(c);else{if(i(y))break;y=C}if(i(y)){if(!(l===c-1||E===1))if(E===2){if(s.length<2||o!==2||s.charCodeAt(s.length-1)!==D||s.charCodeAt(s.length-2)!==D){if(s.length>2){const b=s.lastIndexOf(t);b===-1?(s="",o=0):(s=s.slice(0,b),o=s.length-1-s.lastIndexOf(t)),l=c,E=0;continue}else if(s.length!==0){s="",o=0,l=c,E=0;continue}}r&&(s+=s.length>0?`${t}..`:"..",o=2)}else s.length>0?s+=`${t}${n.slice(l+1,c)}`:s=n.slice(l+1,c),o=c-l-1;l=c,E=0}else y===D&&E!==-1?++E:E=-1}return s}function p(n,r){f(r,"pathObject");const t=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return t?t===r.root?`${t}${i}`:`${t}${n}${i}`:i}e.win32={resolve(...n){let r="",t="",i=!1;for(let s=n.length-1;s>=-1;s--){let o;if(s>=0){if(o=n[s],d(o,"path"),o.length===0)continue}else r.length===0?o=k.cwd():(o=k.env[`=${r}`]||k.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===m)&&(o=`${r}\\`));const l=o.length;let E=0,y="",c=!1;const b=o.charCodeAt(0);if(l===1)a(b)&&(E=1,c=!0);else if(a(b))if(c=!0,a(o.charCodeAt(1))){let R=2,M=R;for(;R<l&&!a(o.charCodeAt(R));)R++;if(R<l&&R!==M){const F=o.slice(M,R);for(M=R;R<l&&a(o.charCodeAt(R));)R++;if(R<l&&R!==M){for(M=R;R<l&&!a(o.charCodeAt(R));)R++;(R===l||R!==M)&&(y=`\\\\${F}\\${o.slice(M,R)}`,E=R)}}}else E=1;else u(b)&&o.charCodeAt(1)===P&&(y=o.slice(0,2),E=2,l>2&&a(o.charCodeAt(2))&&(c=!0,E=3));if(y.length>0)if(r.length>0){if(y.toLowerCase()!==r.toLowerCase())continue}else r=y;if(i){if(r.length>0)break}else if(t=`${o.slice(E)}\\${t}`,i=c,c&&r.length>0)break}return t=I(t,!i,"\\",a),i?`${r}\\${t}`:`${r}${t}`||"."},normalize(n){d(n,"path");const r=n.length;if(r===0)return".";let t=0,i,s=!1;const o=n.charCodeAt(0);if(r===1)return h(o)?"\\":n;if(a(o))if(s=!0,a(n.charCodeAt(1))){let E=2,y=E;for(;E<r&&!a(n.charCodeAt(E));)E++;if(E<r&&E!==y){const c=n.slice(y,E);for(y=E;E<r&&a(n.charCodeAt(E));)E++;if(E<r&&E!==y){for(y=E;E<r&&!a(n.charCodeAt(E));)E++;if(E===r)return`\\\\${c}\\${n.slice(y)}\\`;E!==y&&(i=`\\\\${c}\\${n.slice(y,E)}`,t=E)}}}else t=1;else u(o)&&n.charCodeAt(1)===P&&(i=n.slice(0,2),t=2,r>2&&a(n.charCodeAt(2))&&(s=!0,t=3));let l=t<r?I(n.slice(t),!s,"\\",a):"";return l.length===0&&!s&&(l="."),l.length>0&&a(n.charCodeAt(r-1))&&(l+="\\"),i===void 0?s?`\\${l}`:l:s?`${i}\\${l}`:`${i}${l}`},isAbsolute(n){d(n,"path");const r=n.length;if(r===0)return!1;const t=n.charCodeAt(0);return a(t)||r>2&&u(t)&&n.charCodeAt(1)===P&&a(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let r,t;for(let o=0;o<n.length;++o){const l=n[o];d(l,"path"),l.length>0&&(r===void 0?r=t=l:r+=`\\${l}`)}if(r===void 0)return".";let i=!0,s=0;if(typeof t=="string"&&a(t.charCodeAt(0))){++s;const o=t.length;o>1&&a(t.charCodeAt(1))&&(++s,o>2&&(a(t.charCodeAt(2))?++s:i=!1))}if(i){for(;s<r.length&&a(r.charCodeAt(s));)s++;s>=2&&(r=`\\${r.slice(s)}`)}return e.win32.normalize(r)},relative(n,r){if(d(n,"from"),d(r,"to"),n===r)return"";const t=e.win32.resolve(n),i=e.win32.resolve(r);if(t===i||(n=t.toLowerCase(),r=i.toLowerCase(),n===r))return"";let s=0;for(;s<n.length&&n.charCodeAt(s)===m;)s++;let o=n.length;for(;o-1>s&&n.charCodeAt(o-1)===m;)o--;const l=o-s;let E=0;for(;E<r.length&&r.charCodeAt(E)===m;)E++;let y=r.length;for(;y-1>E&&r.charCodeAt(y-1)===m;)y--;const c=y-E,b=l<c?l:c;let R=-1,M=0;for(;M<b;M++){const H=n.charCodeAt(s+M);if(H!==r.charCodeAt(E+M))break;H===m&&(R=M)}if(M!==b){if(R===-1)return i}else{if(c>b){if(r.charCodeAt(E+M)===m)return i.slice(E+M+1);if(M===2)return i.slice(E+M)}l>b&&(n.charCodeAt(s+M)===m?R=M:M===2&&(R=3)),R===-1&&(R=0)}let F="";for(M=s+R+1;M<=o;++M)(M===o||n.charCodeAt(M)===m)&&(F+=F.length===0?"..":"\\..");return E+=R,F.length>0?`${F}${i.slice(E,y)}`:(i.charCodeAt(E)===m&&++E,i.slice(E,y))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const r=e.win32.resolve(n);if(r.length<=2)return n;if(r.charCodeAt(0)===m){if(r.charCodeAt(1)===m){const t=r.charCodeAt(2);if(t!==v&&t!==D)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(u(r.charCodeAt(0))&&r.charCodeAt(1)===P&&r.charCodeAt(2)===m)return`\\\\?\\${r}`;return n},dirname(n){d(n,"path");const r=n.length;if(r===0)return".";let t=-1,i=0;const s=n.charCodeAt(0);if(r===1)return a(s)?n:".";if(a(s)){if(t=i=1,a(n.charCodeAt(1))){let E=2,y=E;for(;E<r&&!a(n.charCodeAt(E));)E++;if(E<r&&E!==y){for(y=E;E<r&&a(n.charCodeAt(E));)E++;if(E<r&&E!==y){for(y=E;E<r&&!a(n.charCodeAt(E));)E++;if(E===r)return n;E!==y&&(t=i=E+1)}}}}else u(s)&&n.charCodeAt(1)===P&&(t=r>2&&a(n.charCodeAt(2))?3:2,i=t);let o=-1,l=!0;for(let E=r-1;E>=i;--E)if(a(n.charCodeAt(E))){if(!l){o=E;break}}else l=!1;if(o===-1){if(t===-1)return".";o=t}return n.slice(0,o)},basename(n,r){r!==void 0&&d(r,"ext"),d(n,"path");let t=0,i=-1,s=!0,o;if(n.length>=2&&u(n.charCodeAt(0))&&n.charCodeAt(1)===P&&(t=2),r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let l=r.length-1,E=-1;for(o=n.length-1;o>=t;--o){const y=n.charCodeAt(o);if(a(y)){if(!s){t=o+1;break}}else E===-1&&(s=!1,E=o+1),l>=0&&(y===r.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=E))}return t===i?i=E:i===-1&&(i=n.length),n.slice(t,i)}for(o=n.length-1;o>=t;--o)if(a(n.charCodeAt(o))){if(!s){t=o+1;break}}else i===-1&&(s=!1,i=o+1);return i===-1?"":n.slice(t,i)},extname(n){d(n,"path");let r=0,t=-1,i=0,s=-1,o=!0,l=0;n.length>=2&&n.charCodeAt(1)===P&&u(n.charCodeAt(0))&&(r=i=2);for(let E=n.length-1;E>=r;--E){const y=n.charCodeAt(E);if(a(y)){if(!o){i=E+1;break}continue}s===-1&&(o=!1,s=E+1),y===D?t===-1?t=E:l!==1&&(l=1):t!==-1&&(l=-1)}return t===-1||s===-1||l===0||l===1&&t===s-1&&t===i+1?"":n.slice(t,s)},format:p.bind(null,"\\"),parse(n){d(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const t=n.length;let i=0,s=n.charCodeAt(0);if(t===1)return a(s)?(r.root=r.dir=n,r):(r.base=r.name=n,r);if(a(s)){if(i=1,a(n.charCodeAt(1))){let R=2,M=R;for(;R<t&&!a(n.charCodeAt(R));)R++;if(R<t&&R!==M){for(M=R;R<t&&a(n.charCodeAt(R));)R++;if(R<t&&R!==M){for(M=R;R<t&&!a(n.charCodeAt(R));)R++;R===t?i=R:R!==M&&(i=R+1)}}}}else if(u(s)&&n.charCodeAt(1)===P){if(t<=2)return r.root=r.dir=n,r;if(i=2,a(n.charCodeAt(2))){if(t===3)return r.root=r.dir=n,r;i=3}}i>0&&(r.root=n.slice(0,i));let o=-1,l=i,E=-1,y=!0,c=n.length-1,b=0;for(;c>=i;--c){if(s=n.charCodeAt(c),a(s)){if(!y){l=c+1;break}continue}E===-1&&(y=!1,E=c+1),s===D?o===-1?o=c:b!==1&&(b=1):o!==-1&&(b=-1)}return E!==-1&&(o===-1||b===0||b===1&&o===E-1&&o===l+1?r.base=r.name=n.slice(l,E):(r.name=n.slice(l,o),r.base=n.slice(l,E),r.ext=n.slice(o,E))),l>0&&l!==i?r.dir=n.slice(0,l-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const L=(()=>{if(w){const n=/\\/g;return()=>{const r=k.cwd().replace(n,"/");return r.slice(r.indexOf("/"))}}return()=>k.cwd()})();e.posix={resolve(...n){let r="",t=!1;for(let i=n.length-1;i>=-1&&!t;i--){const s=i>=0?n[i]:L();d(s,"path"),s.length!==0&&(r=`${s}/${r}`,t=s.charCodeAt(0)===C)}return r=I(r,!t,"/",h),t?`/${r}`:r.length>0?r:"."},normalize(n){if(d(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===C,t=n.charCodeAt(n.length-1)===C;return n=I(n,!r,"/",h),n.length===0?r?"/":t?"./":".":(t&&(n+="/"),r?`/${n}`:n)},isAbsolute(n){return d(n,"path"),n.length>0&&n.charCodeAt(0)===C},join(...n){if(n.length===0)return".";let r;for(let t=0;t<n.length;++t){const i=n[t];d(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.posix.normalize(r)},relative(n,r){if(d(n,"from"),d(r,"to"),n===r||(n=e.posix.resolve(n),r=e.posix.resolve(r),n===r))return"";const t=1,i=n.length,s=i-t,o=1,l=r.length-o,E=s<l?s:l;let y=-1,c=0;for(;c<E;c++){const R=n.charCodeAt(t+c);if(R!==r.charCodeAt(o+c))break;R===C&&(y=c)}if(c===E)if(l>E){if(r.charCodeAt(o+c)===C)return r.slice(o+c+1);if(c===0)return r.slice(o+c)}else s>E&&(n.charCodeAt(t+c)===C?y=c:c===0&&(y=0));let b="";for(c=t+y+1;c<=i;++c)(c===i||n.charCodeAt(c)===C)&&(b+=b.length===0?"..":"/..");return`${b}${r.slice(o+y)}`},toNamespacedPath(n){return n},dirname(n){if(d(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===C;let t=-1,i=!0;for(let s=n.length-1;s>=1;--s)if(n.charCodeAt(s)===C){if(!i){t=s;break}}else i=!1;return t===-1?r?"/":".":r&&t===1?"//":n.slice(0,t)},basename(n,r){r!==void 0&&d(r,"ext"),d(n,"path");let t=0,i=-1,s=!0,o;if(r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let l=r.length-1,E=-1;for(o=n.length-1;o>=0;--o){const y=n.charCodeAt(o);if(y===C){if(!s){t=o+1;break}}else E===-1&&(s=!1,E=o+1),l>=0&&(y===r.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=E))}return t===i?i=E:i===-1&&(i=n.length),n.slice(t,i)}for(o=n.length-1;o>=0;--o)if(n.charCodeAt(o)===C){if(!s){t=o+1;break}}else i===-1&&(s=!1,i=o+1);return i===-1?"":n.slice(t,i)},extname(n){d(n,"path");let r=-1,t=0,i=-1,s=!0,o=0;for(let l=n.length-1;l>=0;--l){const E=n.charCodeAt(l);if(E===C){if(!s){t=l+1;break}continue}i===-1&&(s=!1,i=l+1),E===D?r===-1?r=l:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||i===-1||o===0||o===1&&r===i-1&&r===t+1?"":n.slice(r,i)},format:p.bind(null,"/"),parse(n){d(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const t=n.charCodeAt(0)===C;let i;t?(r.root="/",i=1):i=0;let s=-1,o=0,l=-1,E=!0,y=n.length-1,c=0;for(;y>=i;--y){const b=n.charCodeAt(y);if(b===C){if(!E){o=y+1;break}continue}l===-1&&(E=!1,l=y+1),b===D?s===-1?s=y:c!==1&&(c=1):s!==-1&&(c=-1)}if(l!==-1){const b=o===0&&t?1:o;s===-1||c===0||c===1&&s===l-1&&s===o+1?r.base=r.name=n.slice(b,l):(r.name=n.slice(b,s),r.base=n.slice(b,l),r.ext=n.slice(s,l))}return o>0?r.dir=n.slice(0,o-1):t&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(oe[133],ae([0,1,15]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const U={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(P){const v=(0,k.extname)(P),S=U[v.toLowerCase()];return S!==void 0?S:T(P)}e.getMediaOrTextMime=N;function T(P){const v=(0,k.extname)(P);return A[v.toLowerCase()]}e.getMediaMime=T;function D(P){for(const v in A)if(A[v]===P)return v}e.getExtensionForMimeType=D;const C=/^(.+)\/(.+?)(;.+)?$/;function m(P,v){const S=C.exec(P);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:v?void 0:P}e.normalizeMimeType=m}),define(oe[87],ae([0,1,5]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var U;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(U||(e.Source=U={}));var A;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function N(D,...C){const m=C.reduce((S,f)=>(S[f]=!0,S),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(S=>!m[S]).forEach(S=>{for(let f=0;f<P.length;f++)if(S.search(P[f])!==-1){delete D[S];break}})}e.sanitizeProcessEnvironment=N;function T(D){D&&(delete D.DEBUG,k.isMacintosh&&delete D.DYLD_LIBRARY_PATH,k.isLinux&&delete D.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(oe[88],ae([0,1,5]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const U=k.globals.performance&&typeof k.globals.performance.now=="function";class A{static create(T=!0){return new A(T)}constructor(T){this.a=U&&T,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?k.globals.performance.now():Date.now()}}e.StopWatch=A}),define(oe[3],ae([0,1,7,82,2,85,88]),function(ne,e,k,U,A,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const D=!1,C=!1;var m;(function(o){o.None=()=>A.Disposable.None;function l(B){if(C){const{onDidAddListener:W}=B,z=d.create();let J=0;B.onDidAddListener=()=>{++J===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),z.print()),W?.()}}}function E(B,W){return V(B,()=>{},0,void 0,!0,void 0,W)}o.defer=E;function y(B){return(W,z=null,J)=>{let ee=!1,ce;return ce=B(ue=>{if(!ee)return ce?ce.dispose():ee=!0,W.call(z,ue)},null,J),ee&&ce.dispose(),ce}}o.once=y;function c(B,W,z){return q((J,ee=null,ce)=>B(ue=>J.call(ee,W(ue)),null,ce),z)}o.map=c;function b(B,W,z){return q((J,ee=null,ce)=>B(ue=>{W(ue),J.call(ee,ue)},null,ce),z)}o.forEach=b;function R(B,W,z){return q((J,ee=null,ce)=>B(ue=>W(ue)&&J.call(ee,ue),null,ce),z)}o.filter=R;function M(B){return B}o.signal=M;function F(...B){return(W,z=null,J)=>(0,A.combinedDisposable)(...B.map(ee=>ee(ce=>W.call(z,ce),null,J)))}o.any=F;function H(B,W,z,J){let ee=z;return c(B,ce=>(ee=W(ee,ce),ee),J)}o.reduce=H;function q(B,W){let z;const J={onWillAddFirstListener(){z=B(ee.fire,ee)},onDidRemoveLastListener(){z?.dispose()}};W||l(J);const ee=new a(J);return W?.add(ee),ee.event}function V(B,W,z=100,J=!1,ee=!1,ce,ue){let de,Se,we,be=0,De;const ke={leakWarningThreshold:ce,onWillAddFirstListener(){de=B(Je=>{be++,Se=W(Se,Je),J&&!we&&(ze.fire(Se),Se=void 0),De=()=>{const le=Se;Se=void 0,we=void 0,(!J||be>1)&&ze.fire(le),be=0},typeof z=="number"?(clearTimeout(we),we=setTimeout(De,z)):we===void 0&&(we=0,queueMicrotask(De))})},onWillRemoveListener(){ee&&be>0&&De?.()},onDidRemoveLastListener(){De=void 0,de.dispose()}};ue||l(ke);const ze=new a(ke);return ue?.add(ze),ze.event}o.debounce=V;function Q(B,W=0,z){return o.debounce(B,(J,ee)=>J?(J.push(ee),J):[ee],W,void 0,!0,void 0,z)}o.accumulate=Q;function te(B,W=(J,ee)=>J===ee,z){let J=!0,ee;return R(B,ce=>{const ue=J||!W(ce,ee);return J=!1,ee=ce,ue},z)}o.latch=te;function Y(B,W,z){return[o.filter(B,W,z),o.filter(B,J=>!W(J),z)]}o.split=Y;function x(B,W=!1,z=[]){let J=z.slice(),ee=B(de=>{J?J.push(de):ue.fire(de)});const ce=()=>{J?.forEach(de=>ue.fire(de)),J=null},ue=new a({onWillAddFirstListener(){ee||(ee=B(de=>ue.fire(de)))},onDidAddFirstListener(){J&&(W?setTimeout(ce):ce())},onDidRemoveLastListener(){ee&&ee.dispose(),ee=null}});return ue.event}o.buffer=x;class G{constructor(W){this.event=W,this.c=new A.DisposableStore}map(W){return new G(c(this.event,W,this.c))}forEach(W){return new G(b(this.event,W,this.c))}filter(W){return new G(R(this.event,W,this.c))}reduce(W,z){return new G(H(this.event,W,z,this.c))}latch(){return new G(te(this.event,void 0,this.c))}debounce(W,z=100,J=!1,ee=!1,ce){return new G(V(this.event,W,z,J,ee,ce,this.c))}on(W,z,J){return this.event(W,z,J)}once(W,z,J){return y(this.event)(W,z,J)}dispose(){this.c.dispose()}}function j(B){return new G(B)}o.chain=j;function Z(B,W,z=J=>J){const J=(...de)=>ue.fire(z(...de)),ee=()=>B.on(W,J),ce=()=>B.removeListener(W,J),ue=new a({onWillAddFirstListener:ee,onDidRemoveLastListener:ce});return ue.event}o.fromNodeEventEmitter=Z;function ie(B,W,z=J=>J){const J=(...de)=>ue.fire(z(...de)),ee=()=>B.addEventListener(W,J),ce=()=>B.removeEventListener(W,J),ue=new a({onWillAddFirstListener:ee,onDidRemoveLastListener:ce});return ue.event}o.fromDOMEventEmitter=ie;function se(B){return new Promise(W=>y(B)(W))}o.toPromise=se;function K(B,W){return W(void 0),B(z=>W(z))}o.runAndSubscribe=K;function _(B,W){let z=null;function J(ce){z?.dispose(),z=new A.DisposableStore,W(ce,z)}J(void 0);const ee=B(ce=>J(ce));return(0,A.toDisposable)(()=>{ee.dispose(),z?.dispose()})}o.runAndSubscribeWithStore=_;class ${constructor(W,z){this._observable=W,this.c=0,this.d=!1;const J={onWillAddFirstListener:()=>{W.addObserver(this)},onDidRemoveLastListener:()=>{W.removeObserver(this)}};z||l(J),this.emitter=new a(J),z&&z.add(this.emitter)}beginUpdate(W){this.c++}handlePossibleChange(W){}handleChange(W,z){this.d=!0}endUpdate(W){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function g(B,W){return new $(B,W).emitter.event}o.fromObservable=g;function O(B){return W=>{let z=0,J=!1;const ee={beginUpdate(){z++},endUpdate(){z--,z===0&&(B.reportChanges(),J&&(J=!1,W()))},handlePossibleChange(){},handleChange(){J=!0}};return B.addObserver(ee),{dispose(){B.removeObserver(ee)}}}}o.fromObservableLight=O})(m||(e.Event=m={}));class P{constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${P.c++}`,P.all.add(this)}start(l){this.d=new T.StopWatch(!0),this.listenerCount=l}stop(){if(this.d){const l=this.d.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=P,P.all=new Set,P.c=0;let v=-1;function S(o){const l=v;return v=o,{dispose(){v=l}}}e.setGlobalLeakWarningThreshold=S;class f{constructor(l,E=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=E,this.d=0}dispose(){this.c?.clear()}check(l,E){const y=this.threshold;if(y<=0||E<y)return;this.c||(this.c=new Map);const c=this.c.get(l.value)||0;if(this.c.set(l.value,c+1),this.d-=1,this.d<=0){this.d=y*.5;let b,R=0;for(const[M,F]of this.c)(!b||R<F)&&(b=M,R=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${R}):`),console.warn(b)}return()=>{const b=this.c.get(l.value)||0;this.c.set(l.value,b-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(l,E,y){this.callback=l,this.callbackThis=E,this.stack=y,this.subscription=new A.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class a{constructor(l){this.j=!1,this.d=l,this.f=v>0||this.d?.leakWarningThreshold?new f(this.d?.leakWarningThreshold??v):void 0,this.g=this.d?._profName?new P(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(D){const l=Array.from(this.q);queueMicrotask(()=>{for(const E of l)E.subscription.isset()&&(E.subscription.unset(),E.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(l,E,y)=>{if(this.q||(this.q=new N.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.Disposable.None;const c=this.q.isEmpty();c&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let b,R;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(R=d.create(),b=this.f.check(R,this.q.size+1)),D&&(R=R??d.create());const M=new w(l,E,R),F=this.q.push(M);c&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,l,E);const H=M.subscription.set(()=>{b?.(),this.j||(this.d?.onWillRemoveListener?.(this),F(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return y instanceof A.DisposableStore?y.add(H):Array.isArray(y)&&y.push(H),H}),this.l}fire(l){if(this.q){this.m||(this.m=new u(this.d?.onListenerError));for(const E of this.q)this.m.push(this,E,l);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=a;class h{constructor(l=k.onUnexpectedError){this.d=l,this.c=new N.LinkedList}get size(){return this.c.size}push(l,E,y){this.c.push(new I(l,E,y))}clear(l){const E=new N.LinkedList;for(const y of this.c)y.emitter!==l&&E.push(y);this.c=E}deliver(){for(;this.c.size>0;){const l=this.c.shift();try{l.listener.invoke(l.event)}catch(E){this.d(E)}}}}e.EventDeliveryQueue=h;class u extends h{clear(l){this.c.clear()}}class I{constructor(l,E,y){this.emitter=l,this.listener=E,this.event=y}}class p extends a{async fireAsync(l,E,y){if(this.q){this.c||(this.c=new N.LinkedList);for(const c of this.q)this.c.push([c,l]);for(;this.c.size>0&&!E.isCancellationRequested;){const[c,b]=this.c.shift(),R=[],M={...b,token:E,waitUntil:F=>{if(Object.isFrozen(R))throw new Error("waitUntil can NOT be called asynchronous");y&&(F=y(F,c.callback)),R.push(F)}};try{c.invoke(M)}catch(F){(0,k.onUnexpectedError)(F);continue}Object.freeze(R),await Promise.allSettled(R).then(F=>{for(const H of F)H.status==="rejected"&&(0,k.onUnexpectedError)(H.reason)})}}}}e.AsyncEmitter=p;class L extends a{get isPaused(){return this.h!==0}constructor(l){super(l),this.h=0,this.s=new N.LinkedList,this.t=l?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const l=Array.from(this.s);this.s.clear(),super.fire(this.t(l))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(l){this.q&&(this.h!==0?this.s.push(l):super.fire(l))}}e.PauseableEmitter=L;class n extends L{constructor(l){super(l),this.c=l.delay??100}fire(l){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(l)}}e.DebounceEmitter=n;class r extends a{constructor(l){super(l),this.c=[],this.h=l?.merge}fire(l){this.hasListeners()&&(this.c.push(l),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(E=>super.fire(E)),this.c=[]}))}}e.MicrotaskEmitter=r;class t{constructor(){this.d=!1,this.f=[],this.c=new a({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(l){const E={event:l,listener:null};this.f.push(E),this.d&&this.j(E);const y=()=>{this.d&&this.k(E);const c=this.f.indexOf(E);this.f.splice(c,1)};return(0,A.toDisposable)((0,U.once)(y))}g(){this.d=!0,this.f.forEach(l=>this.j(l))}h(){this.d=!1,this.f.forEach(l=>this.k(l))}j(l){l.listener=l.event(E=>this.c.fire(E))}k(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class i{constructor(){this.c=[]}wrapEvent(l){return(E,y,c)=>l(b=>{const R=this.c[this.c.length-1];R?R.push(()=>E.call(y,b)):E.call(y,b)},void 0,c)}bufferEvents(l){const E=[];this.c.push(E);const y=l();return this.c.pop(),E.forEach(c=>c()),y}}e.EventBufferer=i;class s{constructor(){this.c=!1,this.d=m.None,this.f=A.Disposable.None,this.g=new a({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(l){this.d=l,this.c&&(this.f.dispose(),this.f=l(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(oe[26],ae([0,1,3]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const U=Object.freeze(function(D,C){const m=setTimeout(D.bind(C),0);return{dispose(){clearTimeout(m)}}});var A;(function(D){function C(m){return m===D.None||m===D.Cancelled||m instanceof N?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}D.isCancellationToken=C,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:U})})(A||(e.CancellationToken=A={}));class N{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?U:(this.b||(this.b=new k.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(C){this.a=void 0,this.b=void 0,this.b=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new N),this.a}cancel(){this.a?this.a instanceof N&&this.a.cancel():this.a=A.Cancelled}dispose(C=!1){C&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof N&&this.a.dispose():this.a=A.None}}e.CancellationTokenSource=T}),define(oe[134],ae([0,1,26]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class U{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new k.CancellationTokenSource,C=this.b(D.token);return this.a={promise:C,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}e.Cache=U;class A{constructor(D){this.c=D,this.a=void 0,this.b=void 0}get(D){const C=JSON.stringify(D);return this.b!==C&&(this.b=C,this.a=this.c(D)),this.a}}e.LRUCachedFunction=A;class N{get cachedValues(){return this.a}constructor(D){this.b=D,this.a=new Map}get(D){if(this.a.has(D))return this.a.get(D);const C=this.b(D);return this.a.set(D,C),C}}e.CachedFunction=N}),define(oe[27],ae([0,1,134,84]),function(ne,e,k,U){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function N(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.isFalsyOrWhitespace=N;const T=/{(\d+)}/g;function D(re,...he){return he.length===0?re:re.replace(T,function(me,ye){const pe=parseInt(ye,10);return isNaN(pe)||pe<0||pe>=he.length?me:he[pe]})}e.format=D;const C=/{([^}]+)}/g;function m(re,he){return re.replace(C,(me,ye)=>he[ye]??me)}e.format2=m;function P(re){return re.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=P;function v(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function S(re,he){let me=0;const ye=he.charCodeAt(0);for(let pe=re.length-1;pe>=0;pe--)re.charCodeAt(pe)===ye&&me++;return me}e.count=S;function f(re,he,me="\u2026"){return re.length<=he?re:`${re.substr(0,he)}${me}`}e.truncate=f;function d(re,he=" "){const me=w(re,he);return a(me,he)}e.trim=d;function w(re,he){if(!re||!he)return re;const me=he.length;if(me===0||re.length===0)return re;let ye=0;for(;re.indexOf(he,ye)===ye;)ye=ye+me;return re.substring(ye)}e.ltrim=w;function a(re,he){if(!re||!he)return re;const me=he.length,ye=re.length;if(me===0||ye===0)return re;let pe=ye,Ie=-1;for(;Ie=re.lastIndexOf(he,pe-1),!(Ie===-1||Ie+me!==pe);){if(Ie===0)return"";pe=Ie}return re.substring(0,pe)}e.rtrim=a;function h(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function u(re){return re.replace(/\*/g,"")}e.stripWildcards=u;function I(re,he,me={}){if(!re)throw new Error("Cannot create regex from empty string");he||(re=v(re)),me.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ye="";return me.global&&(ye+="g"),me.matchCase||(ye+="i"),me.multiline&&(ye+="m"),me.unicode&&(ye+="u"),new RegExp(re,ye)}e.createRegExp=I;function p(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function L(re){return!!re.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=L;function n(re){return(re.global?"g":"")+(re.ignoreCase?"i":"")+(re.multiline?"m":"")+(re.unicode?"u":"")}e.regExpFlags=n;function r(re){return re.split(/\r\n|\r|\n/)}e.splitLines=r;function t(re){for(let he=0,me=re.length;he<me;he++){const ye=re.charCodeAt(he);if(ye!==32&&ye!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function i(re,he=0,me=re.length){for(let ye=he;ye<me;ye++){const pe=re.charCodeAt(ye);if(pe!==32&&pe!==9)return re.substring(he,ye)}return re.substring(he,me)}e.getLeadingWhitespace=i;function s(re,he=re.length-1){for(let me=he;me>=0;me--){const ye=re.charCodeAt(me);if(ye!==32&&ye!==9)return me}return-1}e.lastNonWhitespaceIndex=s;function o(re,he,me){const ye=[];let pe=0;for(const Ie of re.matchAll(he)){if(ye.push(re.slice(pe,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");pe=Ie.index+Ie[0].length,ye.push(me(Ie[0],...Ie.slice(1),Ie.index,re,Ie.groups))}return ye.push(re.slice(pe)),Promise.all(ye).then(Ie=>Ie.join(""))}e.replaceAsync=o;function l(re,he){return re<he?-1:re>he?1:0}e.compare=l;function E(re,he,me=0,ye=re.length,pe=0,Ie=he.length){for(;me<ye&&pe<Ie;me++,pe++){const qe=re.charCodeAt(me),Te=he.charCodeAt(pe);if(qe<Te)return-1;if(qe>Te)return 1}const Re=ye-me,Oe=Ie-pe;return Re<Oe?-1:Re>Oe?1:0}e.compareSubstring=E;function y(re,he){return c(re,he,0,re.length,0,he.length)}e.compareIgnoreCase=y;function c(re,he,me=0,ye=re.length,pe=0,Ie=he.length){for(;me<ye&&pe<Ie;me++,pe++){let qe=re.charCodeAt(me),Te=he.charCodeAt(pe);if(qe===Te)continue;if(qe>=128||Te>=128)return E(re.toLowerCase(),he.toLowerCase(),me,ye,pe,Ie);R(qe)&&(qe-=32),R(Te)&&(Te-=32);const $e=qe-Te;if($e!==0)return $e}const Re=ye-me,Oe=Ie-pe;return Re<Oe?-1:Re>Oe?1:0}e.compareSubstringIgnoreCase=c;function b(re){return re>=48&&re<=57}e.isAsciiDigit=b;function R(re){return re>=97&&re<=122}e.isLowerAsciiLetter=R;function M(re){return re>=65&&re<=90}e.isUpperAsciiLetter=M;function F(re,he){return re.length===he.length&&c(re,he)===0}e.equalsIgnoreCase=F;function H(re,he){const me=he.length;return he.length>re.length?!1:c(re,he,0,me)===0}e.startsWithIgnoreCase=H;function q(re,he){const me=Math.min(re.length,he.length);let ye;for(ye=0;ye<me;ye++)if(re.charCodeAt(ye)!==he.charCodeAt(ye))return ye;return me}e.commonPrefixLength=q;function V(re,he){const me=Math.min(re.length,he.length);let ye;const pe=re.length-1,Ie=he.length-1;for(ye=0;ye<me;ye++)if(re.charCodeAt(pe-ye)!==he.charCodeAt(Ie-ye))return ye;return me}e.commonSuffixLength=V;function Q(re){return 55296<=re&&re<=56319}e.isHighSurrogate=Q;function te(re){return 56320<=re&&re<=57343}e.isLowSurrogate=te;function Y(re,he){return(re-55296<<10)+(he-56320)+65536}e.computeCodePoint=Y;function x(re,he,me){const ye=re.charCodeAt(me);if(Q(ye)&&me+1<he){const pe=re.charCodeAt(me+1);if(te(pe))return Y(ye,pe)}return ye}e.getNextCodePoint=x;function G(re,he){const me=re.charCodeAt(he-1);if(te(me)&&he>1){const ye=re.charCodeAt(he-2);if(Q(ye))return Y(ye,me)}return me}class j{get offset(){return this.e}constructor(he,me=0){this.c=he,this.d=he.length,this.e=me}setOffset(he){this.e=he}prevCodePoint(){const he=G(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=x(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=j;class Z{get offset(){return this.c.offset}constructor(he,me=0){this.c=new j(he,me)}nextGraphemeLength(){const he=Pe.getInstance(),me=this.c,ye=me.offset;let pe=he.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ie=me.offset,Re=he.getGraphemeBreakType(me.nextCodePoint());if(ge(pe,Re)){me.setOffset(Ie);break}pe=Re}return me.offset-ye}prevGraphemeLength(){const he=Pe.getInstance(),me=this.c,ye=me.offset;let pe=he.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ie=me.offset,Re=he.getGraphemeBreakType(me.prevCodePoint());if(ge(Re,pe)){me.setOffset(Ie);break}pe=Re}return ye-me.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Z;function ie(re,he){return new Z(re,he).nextGraphemeLength()}e.nextCharLength=ie;function se(re,he){return new Z(re,he).prevGraphemeLength()}e.prevCharLength=se;function K(re,he){he>0&&te(re.charCodeAt(he))&&he--;const me=he+ie(re,he);return[me-se(re,me),me]}e.getCharContainingOffset=K;function _(re){const he=new Z(re);let me=0;for(;!he.eol();)me++,he.nextGraphemeLength();return me}e.charCount=_;let $;function g(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function O(re){return $||($=g()),$.test(re)}e.containsRTL=O;const B=/^[\t\n\r\x20-\x7E]*$/;function W(re){return B.test(re)}e.isBasicASCII=W,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}e.containsUnusualLineTerminators=z;function J(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.isFullWidthCharacter=J;function ee(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.isEmojiImprecise=ee;function ce(re,he){if(re.length<he)return re;const me=/\b/g;let ye=0;for(;me.test(re)&&!(re.length-me.lastIndex<he);)ye=me.lastIndex,me.lastIndex+=1;return re.substring(ye).replace(/^\s/,"")}e.lcut=ce;const ue=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,de=/\x1b\].*?\x07/g;function Se(re){return re&&(re=re.replace(ue,"").replace(de,"")),re}e.removeAnsiEscapeCodes=Se,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function be(re){return we(re)?re.substr(1):re}e.stripUTF8BOM=be;function De(re,he){if(!re||!he||re.length<he.length)return!1;const me=he.length,ye=re.toLowerCase();let pe=0,Ie=-1;for(;pe<me;){const Re=ye.indexOf(he[pe],Ie+1);if(Re<0)return!1;Ie=Re,pe++}return!0}e.fuzzyContains=De;function ke(re,he=!1){return re?(he&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.containsUppercaseCharacter=ke;function ze(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.uppercaseFirstLetter=ze;function Je(re,he=1){if(he===0)return"";let me=-1;do me=re.indexOf(`
`,me+1),he--;while(he>0&&me>=0);return me===-1?re:(re[me-1]==="\r"&&me--,re.substr(0,me))}e.getNLines=Je;function le(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.singleLetterHash=le;function fe(re){return Pe.getInstance().getGraphemeBreakType(re)}e.getGraphemeBreakType=fe;function ge(re,he){return re===0?he!==5&&he!==7:re===2&&he===3?!1:re===4||re===2||re===3||he===4||he===2||he===3?!0:!(re===8&&(he===8||he===9||he===11||he===12)||(re===11||re===9)&&(he===9||he===10)||(re===12||re===10)&&he===10||he===5||he===13||he===7||re===1||re===13&&he===14||re===6&&he===6)}var Ce;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(e.GraphemeBreakType=Ce={}));class Pe{static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=Me()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const me=this.d,ye=me.length/3;let pe=1;for(;pe<=ye;)if(he<me[3*pe])pe=2*pe;else if(he>me[3*pe+1])pe=2*pe+1;else return me[3*pe+2];return 0}}Pe.c=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(re,he){if(re===0)return 0;const me=Be(re,he);if(me!==void 0)return me;const ye=new j(he,re);return ye.prevCodePoint(),ye.offset}e.getLeftDeleteOffset=Le;function Be(re,he){const me=new j(he,re);let ye=me.prevCodePoint();for(;Ne(ye)||ye===65039||ye===8419;){if(me.offset===0)return;ye=me.prevCodePoint()}if(!ee(ye))return;let pe=me.offset;return pe>0&&me.prevCodePoint()===8205&&(pe=me.offset),pe}function Ne(re){return 127995<=re&&re<=127999}var je;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.noBreakWhitespace="\xA0";class Fe{static getInstance(he){return Fe.d.get(Array.from(he))}static getLocales(){return Fe.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=Fe,A=Fe,Fe.c=new U.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Fe.d=new k.LRUCachedFunction(re=>{function he(Te){const $e=new Map;for(let We=0;We<Te.length;We+=2)$e.set(Te[We],Te[We+1]);return $e}function me(Te,$e){const We=new Map(Te);for(const[_e,nt]of $e)We.set(_e,nt);return We}function ye(Te,$e){if(!Te)return $e;const We=new Map;for(const[_e,nt]of Te)$e.has(_e)&&We.set(_e,nt);return We}const pe=A.c.value;let Ie=re.filter(Te=>!Te.startsWith("_")&&Te in pe);Ie.length===0&&(Ie=["_default"]);let Re;for(const Te of Ie){const $e=he(pe[Te]);Re=ye(Re,$e)}const Oe=he(pe._common),qe=me(Oe,Re);return new Fe(qe)}),Fe.e=new U.Lazy(()=>Object.keys(Fe.c.value).filter(re=>!re.startsWith("_")));class Ae{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ae.c())),this.d}static isInvisibleCharacter(he){return Ae.e().has(he)}static get codePoints(){return Ae.e()}}e.InvisibleCharacters=Ae,Ae.d=void 0}),define(oe[46],ae([0,1,15,5,27,10]),function(ne,e,k,U,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function D(o){return o.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=D;function C(o){return o.indexOf("/")===-1&&(o=D(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=C;function m(o,l=k.posix.sep){if(!o)return"";const E=o.length,y=o.charCodeAt(0);if(T(y)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let b=3;const R=b;for(;b<E&&!T(o.charCodeAt(b));b++);if(R!==b&&!T(o.charCodeAt(b+1))){for(b+=1;b<E;b++)if(T(o.charCodeAt(b)))return o.slice(0,b+1).replace(/[\\/]/g,l)}}return l}else if(h(y)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+l:o.slice(0,2);let c=o.indexOf("://");if(c!==-1){for(c+=3;c<E;c++)if(T(o.charCodeAt(c)))return o.slice(0,c+1)}return""}e.getRoot=m;function P(o){if(!U.isWindows||!o||o.length<5)return!1;let l=o.charCodeAt(0);if(l!==92||(l=o.charCodeAt(1),l!==92))return!1;let E=2;const y=E;for(;E<o.length&&(l=o.charCodeAt(E),l!==92);E++);return!(y===E||(l=o.charCodeAt(E+1),isNaN(l)||l===92))}e.isUNC=P;const v=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,l=U.isWindows){const E=l?v:S;return!(!o||o.length===0||/^\s+$/.test(o)||(E.lastIndex=0,E.test(o))||l&&f.test(o)||o==="."||o===".."||l&&o[o.length-1]==="."||l&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=d;function w(o,l,E){const y=o===l;return!E||y?y:!o||!l?!1:(0,A.equalsIgnoreCase)(o,l)}e.isEqual=w;function a(o,l,E,y=k.sep){if(o===l)return!0;if(!o||!l||l.length>o.length)return!1;if(E){if(!(0,A.startsWithIgnoreCase)(o,l))return!1;if(l.length===o.length)return!0;let b=l.length;return l.charAt(l.length-1)===y&&b--,o.charAt(b)===y}return l.charAt(l.length-1)!==y&&(l+=y),o.indexOf(l)===0}e.isEqualOrParent=a;function h(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=h;function u(o,l){return U.isWindows&&o.endsWith(":")&&(o+=k.sep),(0,k.isAbsolute)(o)||(o=(0,k.join)(l,o)),o=(0,k.normalize)(o),U.isWindows?(o=(0,A.rtrim)(o,k.sep),o.endsWith(":")&&(o+=k.sep)):(o=(0,A.rtrim)(o,k.sep),o||(o=k.sep)),o}e.sanitizeFilePath=u;function I(o){const l=(0,k.normalize)(o);return U.isWindows?o.length>3?!1:p(l)&&(o.length===2||l.charCodeAt(2)===92):l===k.posix.sep}e.isRootOrDriveLetter=I;function p(o,l=U.isWindows){return l?h(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function L(o,l=U.isWindows){return p(o,l)?o[0]:void 0}e.getDriveLetter=L;function n(o,l,E){return l.length>o.length?-1:o===l?0:(E&&(o=o.toLowerCase(),l=l.toLowerCase()),o.indexOf(l))}e.indexOfPath=n;function r(o){const l=o.split(":");let E,y,c;for(const b of l){const R=Number(b);(0,N.isNumber)(R)?y===void 0?y=R:c===void 0&&(c=R):E=E?[E,b].join(":"):b}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:y!==void 0?y:void 0,column:c!==void 0?c:y!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(o,l,E=8){let y="";for(let b=0;b<E;b++){let R;b===0&&U.isWindows&&!l&&(E===3||E===4)?R=i:R=t,y+=R.charAt(Math.floor(Math.random()*R.length))}let c;return l?c=`${l}-${y}`:c=y,o?(0,k.join)(o,c):c}e.randomPath=s}),define(oe[63],ae([0,1,27]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function U(h){return A(h,0)}e.hash=U;function A(h,u){switch(typeof h){case"object":return h===null?N(349,u):Array.isArray(h)?C(h,u):m(h,u);case"string":return D(h,u);case"boolean":return T(h,u);case"number":return N(h,u);case"undefined":return N(937,u);default:return N(617,u)}}e.doHash=A;function N(h,u){return(u<<5)-u+h|0}e.numberHash=N;function T(h,u){return N(h?433:863,u)}function D(h,u){u=N(149417,u);for(let I=0,p=h.length;I<p;I++)u=N(h.charCodeAt(I),u);return u}e.stringHash=D;function C(h,u){return u=N(104579,u),h.reduce((I,p)=>A(p,I),u)}function m(h,u){return u=N(181387,u),Object.keys(h).sort().reduce((I,p)=>(I=D(p,I),A(h[p],I)),u)}class P{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=A(u,this.g),this.g}}e.Hasher=P;var v;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function S(h,u,I=32){const p=I-u,L=~((1<<p)-1);return(h<<u|(L&h)>>>p)>>>0}function f(h,u=0,I=h.byteLength,p=0){for(let L=0;L<I;L++)h[u+L]=p}function d(h,u,I="0"){for(;h.length<u;)h=I+h;return h}function w(h,u=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(I=>I.toString(16).padStart(2,"0")).join(""):d((h>>>0).toString(16),u/4)}e.toHexString=w;class a{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const I=u.length;if(I===0)return;const p=this.p;let L=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=u.charCodeAt(0),t=0);;){let i=r;if(k.isHighSurrogate(r))if(t+1<I){const s=u.charCodeAt(t+1);k.isLowSurrogate(s)?(t++,i=k.computeCodePoint(r,s)):i=65533}else{n=r;break}else k.isLowSurrogate(r)&&(i=65533);if(L=this.w(p,L,i),t++,t<I)r=u.charCodeAt(t);else break}this.r=L,this.u=n}w(u,I,p){return p<128?u[I++]=p:p<2048?(u[I++]=192|(p&1984)>>>6,u[I++]=128|(p&63)>>>0):p<65536?(u[I++]=224|(p&61440)>>>12,u[I++]=128|(p&4032)>>>6,u[I++]=128|(p&63)>>>0):(u[I++]=240|(p&1835008)>>>18,u[I++]=128|(p&258048)>>>12,u[I++]=128|(p&4032)>>>6,u[I++]=128|(p&63)>>>0),I>=64&&(this.y(),I-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=a.g,I=this.q;for(let l=0;l<64;l+=4)u.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)u.setUint32(l,S(u.getUint32(l-12,!1)^u.getUint32(l-32,!1)^u.getUint32(l-56,!1)^u.getUint32(l-64,!1),1),!1);let p=this.h,L=this.l,n=this.m,r=this.n,t=this.o,i,s,o;for(let l=0;l<80;l++)l<20?(i=L&n|~L&r,s=1518500249):l<40?(i=L^n^r,s=1859775393):l<60?(i=L&n|L&r|n&r,s=2400959708):(i=L^n^r,s=3395469782),o=S(p,5)+i+t+s+u.getUint32(l*4,!1)&4294967295,t=r,r=n,n=S(L,30),L=p,p=o;this.h=this.h+p&4294967295,this.l=this.l+L&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=a,a.g=new DataView(new ArrayBuffer(320))}),define(oe[89],ae([0,1,27]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var U;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(U||(U={})),function(A){const N="error",T="warning",D="warn",C="info",m="ignore";function P(S){return S?k.equalsIgnoreCase(N,S)?A.Error:k.equalsIgnoreCase(T,S)||k.equalsIgnoreCase(D,S)?A.Warning:k.equalsIgnoreCase(C,S)?A.Info:A.Ignore:A.Ignore}A.fromValue=P;function v(S){switch(S){case A.Error:return N;case A.Warning:return T;case A.Info:return C;default:return m}}A.toString=v}(U||(U={})),e.default=U}),define(oe[47],ae([0,1,21,27]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class A{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const d=f.charCodeAt(0),w=this.b.charCodeAt(this.c);return d-w}value(){return this.b[this.c]}}e.StringIterator=A;class N{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,U.compareSubstring)(f,this.b,0,f.length,this.c,this.d):(0,U.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=N;class T{constructor(f=!0,d=!0){this.f=f,this.g=d}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let d=f.length-1;d>=0;d--,this.c--){const w=this.b.charCodeAt(d);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,U.compareSubstring)(f,this.b,0,f.length,this.d,this.e):(0,U.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=T;var D;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(D||(D={}));class C{constructor(f,d){this.f=f,this.g=d,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new T(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,U.compareIgnoreCase)(f,this.c.scheme);if(this.d[this.e]===2)return(0,U.compareIgnoreCase)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,U.compare)(f,this.c.query);if(this.d[this.e]===5)return(0,U.compare)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=C;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(P||(P={}));class v{static forUris(f=()=>!1,d=()=>!1){return new v(new C(f,d))}static forPaths(f=!1){return new v(new T(void 0,!f))}static forStrings(){return new v(new A)}static forConfigKeys(){return new v(new N)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,d){if(d){const w=d.slice(0);(0,k.shuffle)(w);for(const a of w)this.set(a,f)}else{const w=f.slice(0);(0,k.shuffle)(w);for(const a of w)this.set(a[0],a[1])}}set(f,d){const w=this.b.reset(f);let a;this.c||(this.c=new m,this.c.segment=w.value());const h=[];for(a=this.c;;){const I=w.cmp(a.segment);if(I>0)a.left||(a.left=new m,a.left.segment=w.value()),h.push([-1,a]),a=a.left;else if(I<0)a.right||(a.right=new m,a.right.segment=w.value()),h.push([1,a]),a=a.right;else if(w.hasNext())w.next(),a.mid||(a.mid=new m,a.mid.segment=w.value()),h.push([0,a]),a=a.mid;else break}const u=a.value;a.value=d,a.key=f;for(let I=h.length-1;I>=0;I--){const p=h[I][1];p.updateHeight();const L=p.balanceFactor();if(L<-1||L>1){const n=h[I][0],r=h[I+1][0];if(n===1&&r===1)h[I][1]=p.rotateLeft();else if(n===-1&&r===-1)h[I][1]=p.rotateRight();else if(n===1&&r===-1)p.right=h[I+1][1]=h[I+1][1].rotateRight(),h[I][1]=p.rotateLeft();else if(n===-1&&r===1)p.left=h[I+1][1]=h[I+1][1].rotateLeft(),h[I][1]=p.rotateRight();else throw new Error;if(I>0)switch(h[I-1][0]){case-1:h[I-1][1].left=h[I][1];break;case 1:h[I-1][1].right=h[I][1];break;case 0:h[I-1][1].mid=h[I][1];break}else this.c=h[0][1]}}return u}get(f){return this.d(f)?.value}d(f){const d=this.b.reset(f);let w=this.c;for(;w;){const a=d.cmp(w.segment);if(a>0)w=w.left;else if(a<0)w=w.right;else if(d.hasNext())d.next(),w=w.mid;else break}return w}has(f){const d=this.d(f);return!(d?.value===void 0&&d?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,d){const w=this.b.reset(f),a=[];let h=this.c;for(;h;){const u=w.cmp(h.segment);if(u>0)a.push([-1,h]),h=h.left;else if(u<0)a.push([1,h]),h=h.right;else if(w.hasNext())w.next(),a.push([0,h]),h=h.mid;else break}if(h){if(d?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const u=this.f(h.right);if(u.key){const{key:I,value:p,segment:L}=u;this.e(u.key,!1),h.key=I,h.value=p,h.segment=L}}else{const u=h.left??h.right;if(a.length>0){const[I,p]=a[a.length-1];switch(I){case-1:p.left=u;break;case 0:p.mid=u;break;case 1:p.right=u;break}}else this.c=u}for(let u=a.length-1;u>=0;u--){const I=a[u][1];I.updateHeight();const p=I.balanceFactor();if(p>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),a[u][1]=I.rotateLeft()):p<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),a[u][1]=I.rotateRight()),u>0)switch(a[u-1][0]){case-1:a[u-1][1].left=a[u][1];break;case 1:a[u-1][1].right=a[u][1];break;case 0:a[u-1][1].mid=a[u][1];break}else this.c=a[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const d=this.b.reset(f);let w=this.c,a;for(;w;){const h=d.cmp(w.segment);if(h>0)w=w.left;else if(h<0)w=w.right;else if(d.hasNext())d.next(),a=w.value||a,w=w.mid;else break}return w&&w.value||a}findSuperstr(f){return this.g(f,!1)}g(f,d){const w=this.b.reset(f);let a=this.c;for(;a;){const h=w.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(w.hasNext())w.next(),a=a.mid;else return a.mid?this.h(a.mid):d?a.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[d,w]of this)f(w,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const d=[];return this.j(f,d),d[Symbol.iterator]()}j(f,d){f&&(f.left&&this.j(f.left,d),f.value&&d.push([f.key,f.value]),f.mid&&this.j(f.mid,d),f.right&&this.j(f.right,d))}_isBalanced(){const f=d=>{if(!d)return!0;const w=d.balanceFactor();return w<-1||w>1?!1:f(d.left)&&f(d.right)};return f(this.c)}}e.TernarySearchTree=v}),define(oe[12],ae([0,1,15,5]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,N=/^\//,T=/^\/\//;function D(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!A.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!N.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(i,s){return!i&&!s?"file":i}function m(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==v&&(s=v+s):s=v;break}return s}const P="",v="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(s){return s instanceof f?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,o,l,E,y,c=!1){typeof s=="object"?(this.scheme=s.scheme||P,this.authority=s.authority||P,this.path=s.path||P,this.query=s.query||P,this.fragment=s.fragment||P):(this.scheme=C(s,c),this.authority=o||P,this.path=m(this.scheme,l||P),this.query=E||P,this.fragment=y||P,D(this,c))}get fsPath(){return p(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:l,path:E,query:y,fragment:c}=s;return o===void 0?o=this.scheme:o===null&&(o=P),l===void 0?l=this.authority:l===null&&(l=P),E===void 0?E=this.path:E===null&&(E=P),y===void 0?y=this.query:y===null&&(y=P),c===void 0?c=this.fragment:c===null&&(c=P),o===this.scheme&&l===this.authority&&E===this.path&&y===this.query&&c===this.fragment?this:new a(o,l,E,y,c)}static parse(s,o=!1){const l=S.exec(s);return l?new a(l[2]||P,t(l[4]||P),t(l[5]||P),t(l[7]||P),t(l[9]||P),o):new a(P,P,P,P,P)}static file(s){let o=P;if(U.isWindows&&(s=s.replace(/\\/g,v)),s[0]===v&&s[1]===v){const l=s.indexOf(v,2);l===-1?(o=s.substring(2),s=v):(o=s.substring(2,l),s=s.substring(l)||v)}return new a("file",o,s,P,P)}static from(s,o){return new a(s.scheme,s.authority,s.path,s.query,s.fragment,o)}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return U.isWindows&&s.scheme==="file"?l=f.file(k.win32.join(p(s,!0),...o)).path:l=k.posix.join(s.path,...o),s.with({path:l})}toString(s=!1){return L(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof f)return s;{const o=new a(s);return o._formatted=s.external??null,o._fsPath=s._sep===w?s.fsPath??null:null,o}}else return s}}e.URI=f;function d(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=d;const w=U.isWindows?1:void 0;class a extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(s=!1){return s?L(this,!0):(this._formatted||(this._formatted=L(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=w),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,s,o){let l,E=-1;for(let y=0;y<i.length;y++){const c=i.charCodeAt(y);if(c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57||c===45||c===46||c===95||c===126||s&&c===47||o&&c===91||o&&c===93||o&&c===58)E!==-1&&(l+=encodeURIComponent(i.substring(E,y)),E=-1),l!==void 0&&(l+=i.charAt(y));else{l===void 0&&(l=i.substr(0,y));const b=h[c];b!==void 0?(E!==-1&&(l+=encodeURIComponent(i.substring(E,y)),E=-1),l+=b):E===-1&&(E=y)}}return E!==-1&&(l+=encodeURIComponent(i.substring(E))),l!==void 0?l:i}function I(i){let s;for(let o=0;o<i.length;o++){const l=i.charCodeAt(o);l===35||l===63?(s===void 0&&(s=i.substr(0,o)),s+=h[l]):s!==void 0&&(s+=i[o])}return s!==void 0?s:i}function p(i,s){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,U.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=p;function L(i,s){const o=s?I:u;let l="",{scheme:E,authority:y,path:c,query:b,fragment:R}=i;if(E&&(l+=E,l+=":"),(y||E==="file")&&(l+=v,l+=v),y){let M=y.indexOf("@");if(M!==-1){const F=y.substr(0,M);y=y.substr(M+1),M=F.lastIndexOf(":"),M===-1?l+=o(F,!1,!1):(l+=o(F.substr(0,M),!1,!1),l+=":",l+=o(F.substr(M+1),!1,!0)),l+="@"}y=y.toLowerCase(),M=y.lastIndexOf(":"),M===-1?l+=o(y,!1,!0):(l+=o(y.substr(0,M),!1,!0),l+=y.substr(M))}if(c){if(c.length>=3&&c.charCodeAt(0)===47&&c.charCodeAt(2)===58){const M=c.charCodeAt(1);M>=65&&M<=90&&(c=`/${String.fromCharCode(M+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===58){const M=c.charCodeAt(0);M>=65&&M<=90&&(c=`${String.fromCharCode(M+32)}:${c.substr(2)}`)}l+=o(c,!0,!1)}return b&&(l+="?",l+=o(b,!1,!1)),R&&(l+="#",l+=s?R:u(R,!1,!1)),l}function n(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+n(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function t(i){return i.match(r)?i.replace(r,s=>n(s)):i}}),define(oe[135],ae([0,1,12]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function U(m){const P=m;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=U;function A(m){const P=[];let v;try{const S=JSON.parse(m.arguments),f=S[S.length-1];f&&f.__$stack&&(S.pop(),v=f.__$stack),P.push(...S)}catch{P.push("Unable to log remote console arguments",m.arguments)}return{args:P,stack:v}}e.parse=A;function N(m){if(typeof m!="string")return N(A(m).stack);const P=m;if(P){const v=T(P),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(S&&S.length===4)return{uri:k.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=N;function T(m){if(!m)return m;const P=m.indexOf(`
`);return P===-1?m:m.substring(0,P)}function D(m,P){const{args:v,stack:S}=A(m),f=typeof v[0]=="string"&&v.length===1;let d=T(S);d&&(d=`(${d.trim()})`);let w=[];if(typeof v[0]=="string"?d&&f?w=[`%c[${P}] %c${v[0]} %c${d}`,C("blue"),C(""),C("grey")]:w=[`%c[${P}] %c${v[0]}`,C("blue"),C(""),...v.slice(1)]:w=[`%c[${P}]%`,C("blue"),...v],d&&!f&&w.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,w)}e.log=D;function C(m){return`color: ${m}`}}),define(oe[64],ae([0,1,16,27,12]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function N(m){return JSON.stringify(m,D)}e.stringify=N;function T(m){let P=JSON.parse(m);return P=C(P),P}e.parse=T;function D(m,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,U.regExpFlags)(P)}:P}function C(m,P=0){if(!m||P>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return A.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof k.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let v=0;v<m.length;++v)m[v]=C(m[v],P+1);else for(const v in m)Object.hasOwnProperty.call(m,v)&&(m[v]=C(m[v],P+1))}return m}e.revive=C}),define(oe[25],ae([0,1,7,5,12]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var N;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractive="vscode-interactive",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(N||(e.Schemas=N={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${N.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${N.vscodeRemoteResource}`}set(P,v,S){this.a[P]=v,this.b[P]=S}setConnectionToken(P,v){this.c[P]=v}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(a){return k.onUnexpectedError(a),P}const v=P.authority;let S=this.a[v];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const f=this.b[v],d=this.c[v];let w=`path=${encodeURIComponent(P.path)}`;return typeof d=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(d)}`),A.URI.from({scheme:U.isWeb?this.d:N.vscodeRemoteResource,authority:`${S}:${f}`,path:this.f,query:w})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{asBrowserUri(P){const v=this.b(P,ne);return this.uriToBrowserUri(v)}uriToBrowserUri(P){return P.scheme===N.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===N.file&&(U.isNative||U.isWebWorker&&U.globals.origin===`${N.vscodeFileResource}://${D.a}`)?P.with({scheme:N.vscodeFileResource,authority:P.authority||D.a,query:null,fragment:null}):P}asFileUri(P){const v=this.b(P,ne);return this.uriToFileUri(v)}uriToFileUri(P){return P.scheme===N.vscodeFileResource?P.with({scheme:N.file,authority:P.authority!==D.a?P.authority:null,query:null,fragment:null}):P}b(P,v){return A.URI.isUri(P)?P:A.URI.parse(v.toUrl(P))}}D.a="vscode-app",e.FileAccess=new D;var C;(function(m){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(P.get("3"));const v="vscode-coi";function S(d){let w;typeof d=="string"?w=new URL(d).searchParams:d instanceof URL?w=d.searchParams:A.URI.isUri(d)&&(w=new URL(d.toString(!0)).searchParams);const a=w?.get(v);if(a)return P.get(a)}m.getHeadersFromQuery=S;function f(d,w,a){if(!globalThis.crossOriginIsolated)return;const h=w&&a?"3":a?"2":"1";d instanceof URLSearchParams?d.set(v,h):d[v]=h}m.addSearchParam=f})(C||(e.COI=C={}))}),define(oe[22],ae([0,1,46,25,15,5,27,12]),function(ne,e,k,U,A,N,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(f){return(0,D.uriToFsPath)(f,!0)}e.originalFSPath=C;class m{constructor(d){this.a=d}compare(d,w,a=!1){return d===w?0:(0,T.compare)(this.getComparisonKey(d,a),this.getComparisonKey(w,a))}isEqual(d,w,a=!1){return d===w?!0:!d||!w?!1:this.getComparisonKey(d,a)===this.getComparisonKey(w,a)}getComparisonKey(d,w=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,w,a=!1){if(d.scheme===w.scheme){if(d.scheme===U.Schemas.file)return k.isEqualOrParent(C(d),C(w),this.a(d))&&d.query===w.query&&(a||d.fragment===w.fragment);if((0,e.isEqualAuthority)(d.authority,w.authority))return k.isEqualOrParent(d.path,w.path,this.a(d),"/")&&d.query===w.query&&(a||d.fragment===w.fragment)}return!1}joinPath(d,...w){return D.URI.joinPath(d,...w)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return A.posix.basename(d.path)}extname(d){return A.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let w;return d.scheme===U.Schemas.file?w=D.URI.file(A.dirname(C(d))).path:(w=A.posix.dirname(d.path),d.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),w="/")),d.with({path:w})}normalizePath(d){if(!d.path.length)return d;let w;return d.scheme===U.Schemas.file?w=D.URI.file(A.normalize(C(d))).path:w=A.posix.normalize(d.path),d.with({path:w})}relativePath(d,w){if(d.scheme!==w.scheme||!(0,e.isEqualAuthority)(d.authority,w.authority))return;if(d.scheme===U.Schemas.file){const u=A.relative(C(d),C(w));return N.isWindows?k.toSlashes(u):u}let a=d.path||"/";const h=w.path||"/";if(this.a(d)){let u=0;for(const I=Math.min(a.length,h.length);u<I&&!(a.charCodeAt(u)!==h.charCodeAt(u)&&a.charAt(u).toLowerCase()!==h.charAt(u).toLowerCase());u++);a=h.substr(0,u)+a.substr(u)}return A.posix.relative(a,h)}resolvePath(d,w){if(d.scheme===U.Schemas.file){const a=D.URI.file(A.resolve(C(d),w));return d.with({authority:a.authority,path:a.path})}return w=k.toPosixPath(w),d.with({path:A.posix.resolve(d.path,w)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,w){return d===w||d!==void 0&&w!==void 0&&(0,T.equalsIgnoreCase)(d,w)}hasTrailingPathSeparator(d,w=A.sep){if(d.scheme===U.Schemas.file){const a=C(d);return a.length>k.getRoot(a).length&&a[a.length-1]===w}else{const a=d.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,w=A.sep){return(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,w=A.sep){let a=!1;if(d.scheme===U.Schemas.file){const h=C(d);a=h!==void 0&&h.length===k.getRoot(h).length&&h[h.length-1]===w}else{w="/";const h=d.path;a=h.length===1&&h.charCodeAt(h.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path+"/"}):d}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(f=>f.scheme===U.Schemas.file?!N.isLinux:!0),e.extUriIgnorePathCase=new m(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(f,d){const w=[];for(let a=0;a<f.length;a++){const h=d(f[a]);f.some((u,I)=>I===a?!1:(0,e.isEqualOrParent)(h,d(u)))||w.push(f[a])}return w}e.distinctParents=P;var v;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function d(w){const a=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(I=>{const[p,L]=I.split(":");p&&L&&a.set(p,L)});const u=w.path.substring(0,w.path.indexOf(";"));return u&&a.set(f.META_DATA_MIME,u),a}f.parseMetaData=d})(v||(e.DataUri=v={}));function S(f,d,w){if(d){let a=f.path;return a&&a[0]!==A.posix.sep&&(a=A.posix.sep+a),f.with({scheme:w,authority:d,path:a})}return f.with({scheme:w})}e.toLocalResource=S}),define(oe[6],ae([0,1,26,7,3,2,22,5,124]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m($){return!!$&&typeof $.then=="function"}e.isThenable=m;function P($){const g=new k.CancellationTokenSource,O=$(g.token),B=new Promise((W,z)=>{const J=g.token.onCancellationRequested(()=>{J.dispose(),g.dispose(),z(new U.CancellationError)});Promise.resolve(O).then(ee=>{J.dispose(),g.dispose(),W(ee)},ee=>{J.dispose(),g.dispose(),z(ee)})});return new class{cancel(){g.cancel()}then(W,z){return B.then(W,z)}catch(W){return this.then(void 0,W)}finally(W){return B.finally(W)}}}e.createCancelablePromise=P;function v($,g,O){return new Promise((B,W)=>{const z=g.onCancellationRequested(()=>{z.dispose(),B(O)});$.then(B,W).finally(()=>z.dispose())})}e.raceCancellation=v;function S($,g){return new Promise((O,B)=>{const W=g.onCancellationRequested(()=>{W.dispose(),B(new U.CancellationError)});$.then(O,B).finally(()=>W.dispose())})}e.raceCancellationError=S;async function f($){let g=-1;const O=$.map((B,W)=>B.then(z=>(g=W,z)));try{return await Promise.race(O)}finally{$.forEach((B,W)=>{W!==g&&B.cancel()})}}e.raceCancellablePromises=f;function d($,g,O){let B;const W=setTimeout(()=>{B?.(void 0),O?.()},g);return Promise.race([$.finally(()=>clearTimeout(W)),new Promise(z=>B=z)])}e.raceTimeout=d;function w($){return new Promise((g,O)=>{const B=$();m(B)?B.then(g,O):g(B)})}e.asPromise=w;class a{constructor(){this.a=null,this.b=null,this.d=null}queue(g){if(this.a){if(this.d=g,!this.b){const O=()=>{this.b=null;const B=this.queue(this.d);return this.d=null,B};this.b=new Promise(B=>{this.a.then(O,O).then(B)})}return new Promise((O,B)=>{this.b.then(O,B)})}return this.a=g(),new Promise((O,B)=>{this.a.then(W=>{this.a=null,O(W)},W=>{this.a=null,B(W)})})}}e.Throttler=a;class h{constructor(){this.a=Promise.resolve(null)}queue(g){return this.a=this.a.then(()=>g(),()=>g())}}e.Sequencer=h;class u{constructor(){this.a=new Map}queue(g,O){const W=(this.a.get(g)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.a.get(g)===W&&this.a.delete(g)});return this.a.set(g,W),W}}e.SequencerByKey=u;const I=($,g)=>{let O=!0;const B=setTimeout(()=>{O=!1,g()},$);return{isTriggered:()=>O,dispose:()=>{clearTimeout(B),O=!1}}},p=$=>{let g=!0;return queueMicrotask(()=>{g&&(g=!1,$())}),{isTriggered:()=>g,dispose:()=>{g=!1}}};class L{constructor(g){this.defaultDelay=g,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(g,O=this.defaultDelay){this.g=g,this.h(),this.b||(this.b=new Promise((W,z)=>{this.d=W,this.f=z}).then(()=>{if(this.b=null,this.d=null,this.g){const W=this.g;return this.g=null,W()}}));const B=()=>{this.a=null,this.d?.(null)};return this.a=O===C.MicrotaskDelay?p(B):I(O,B),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new U.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=L;class n{constructor(g){this.a=new L(g),this.b=new a}trigger(g,O){return this.a.trigger(()=>this.b.queue(g),O)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=n;class r{constructor(){this.a=!1,this.b=new Promise((g,O)=>{this.d=g})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class t extends r{constructor(g){super(),this.f=setTimeout(()=>this.open(),g)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=t;function i($,g){return g?new Promise((O,B)=>{const W=setTimeout(()=>{z.dispose(),O()},$),z=g.onCancellationRequested(()=>{clearTimeout(W),z.dispose(),B(new U.CancellationError)})}):P(O=>i($,O))}e.timeout=i;function s($,g=0){const O=setTimeout($,g);return(0,N.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=s;function o($){const g=[];let O=0;const B=$.length;function W(){return O<B?$[O++]():null}function z(J){J!=null&&g.push(J);const ee=W();return ee?ee.then(z):Promise.resolve(g)}return Promise.resolve(null).then(z)}e.sequence=o;function l($,g=B=>!!B,O=null){let B=0;const W=$.length,z=()=>{if(B>=W)return Promise.resolve(O);const J=$[B++];return Promise.resolve(J()).then(ce=>g(ce)?Promise.resolve(ce):z())};return z()}e.first=l;function E($,g=B=>!!B,O=null){if($.length===0)return Promise.resolve(O);let B=$.length;const W=()=>{B=-1;for(const z of $)z.cancel?.()};return new Promise((z,J)=>{for(const ee of $)ee.then(ce=>{--B>=0&&g(ce)?(W(),z(ce)):B===0&&z(O)}).catch(ce=>{--B>=0&&(W(),J(ce))})})}e.firstParallel=E;class y{constructor(g){this.a=0,this.d=g,this.f=[],this.b=0,this.g=new A.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(g){return this.a++,new Promise((O,B)=>{this.f.push({factory:g,c:O,e:B}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const g=this.f.shift();this.b++;const O=g.factory();O.then(g.c,g.e),O.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=y;class c extends y{constructor(){super(1)}}e.Queue=c;class b{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const g=new j;return this.b.add(g),g.p}d(){for(const[,g]of this.a)if(g.size>0)return!1;return!0}queueFor(g,O=T.extUri){const B=O.getComparisonKey(g);let W=this.a.get(B);return W||(W=new c,A.Event.once(W.onDrained)(()=>{W?.dispose(),this.a.delete(B),this.f()}),this.a.set(B,W)),W}f(){this.d()&&this.g()}g(){for(const g of this.b)g.complete();this.b.clear()}dispose(){for(const[,g]of this.a)g.dispose();this.a.clear(),this.g()}}e.ResourceQueue=b;class R{constructor(g,O){this.a=-1,typeof g=="function"&&typeof O=="number"&&this.setIfNotSet(g,O)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(g,O){this.cancel(),this.a=setTimeout(()=>{this.a=-1,g()},O)}setIfNotSet(g,O){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,g()},O))}}e.TimeoutTimer=R;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(g,O){this.cancel(),this.a=setInterval(()=>{g()},O)}}e.IntervalTimer=M;class F{constructor(g,O){this.b=-1,this.a=g,this.d=O,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(g=this.d){this.cancel(),this.b=setTimeout(this.f,g)}get delay(){return this.d}set delay(g){this.d=g}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=F;class H{constructor(g,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.a=g,this.b=O,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(g=this.b){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(g/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=H;class q extends F{constructor(g,O){super(g,O),this.j=[]}work(g){this.j.push(g),this.isScheduled()||this.schedule()}h(){const g=this.j;this.j=[],this.a?.(g)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=q;class V extends N.Disposable{constructor(g,O){super(),this.g=g,this.h=O,this.a=[],this.b=this.B(new N.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(g){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+g.length>this.g.maxBufferedWork)return!1}else if(this.pending+g.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const O of g)this.a.push(O);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=V,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{(0,D.setTimeout0)(()=>{if(g)return;const O=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let g=!1;return{dispose(){g||(g=!0)}}}:e.runWhenIdle=($,g)=>{const O=requestIdleCallback($,typeof g=="number"?{timeout:g}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(O))}}}}();class Q{constructor(g){this.d=!1,this.a=()=>{try{this.f=g()}catch(O){this.g=O}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=Q;async function te($,g,O){let B;for(let W=0;W<O;W++)try{return await $()}catch(z){B=z,await i(g)}throw B}e.retry=te;class Y{hasPending(g){return this.a?typeof g=="number"?this.a.taskId===g:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(g,O,B){return this.a={taskId:g,cancel:()=>B?.(),promise:O},O.then(()=>this.d(g),()=>this.d(g)),O}d(g){this.a&&g===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const g=this.b;this.b=void 0,g.run().then(g.promiseResolve,g.promiseReject)}}setNext(g){if(this.b)this.b.run=g;else{let O,B;const W=new Promise((z,J)=>{O=z,B=J});this.b={run:g,promise:W,promiseResolve:O,promiseReject:B}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=Y;class x{constructor(g,O=()=>Date.now()){this.d=g,this.f=O,this.a=0,this.b=0}increment(){const g=this.f();return g-this.a>this.d&&(this.a=g,this.b=0),this.b++,this.b}}e.IntervalCounter=x;var G;(function($){$[$.Resolved=0]="Resolved",$[$.Rejected=1]="Rejected"})(G||(G={}));class j{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((g,O)=>{this.a=g,this.b=O})}complete(g){return new Promise(O=>{this.a(g),this.d={outcome:0,value:g},O()})}error(g){return new Promise(O=>{this.b(g),this.d={outcome:1,value:g},O()})}cancel(){return this.error(new U.CancellationError)}}e.DeferredPromise=j;var Z;(function($){async function g(B){let W;const z=await Promise.all(B.map(J=>J.then(ee=>ee,ee=>{W||(W=ee)})));if(typeof W<"u")throw W;return z}$.settled=g;function O(B){return new Promise(async(W,z)=>{try{await B(W,z)}catch(J){z(J)}})}$.withAsyncBody=O})(Z||(e.Promises=Z={}));var ie;(function($){$[$.Initial=0]="Initial",$[$.DoneOK=1]="DoneOK",$[$.DoneError=2]="DoneError"})(ie||(ie={}));class se{static fromArray(g){return new se(O=>{O.emitMany(g)})}static fromPromise(g){return new se(async O=>{O.emitMany(await g)})}static fromPromises(g){return new se(async O=>{await Promise.all(g.map(async B=>O.emitOne(await B)))})}static merge(g){return new se(async O=>{await Promise.all(g.map(async B=>{for await(const W of B)O.emitOne(W)}))})}constructor(g){this.a=0,this.b=[],this.d=null,this.f=new A.Emitter,queueMicrotask(async()=>{const O={emitOne:B=>this.g(B),emitMany:B=>this.h(B),reject:B=>this.k(B)};try{await Promise.resolve(g(O)),this.j()}catch(B){this.k(B)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let g=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(g<this.b.length)return{done:!1,value:this.b[g++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.f.event)}while(!0)}}}static map(g,O){return new se(async B=>{for await(const W of g)B.emitOne(O(W))})}map(g){return se.map(this,g)}static filter(g,O){return new se(async B=>{for await(const W of g)O(W)&&B.emitOne(W)})}filter(g){return se.filter(this,g)}static coalesce(g){return se.filter(g,O=>!!O)}coalesce(){return se.coalesce(this)}static async toPromise(g){const O=[];for await(const B of g)O.push(B);return O}toPromise(){return se.toPromise(this)}g(g){this.a===0&&(this.b.push(g),this.f.fire())}h(g){this.a===0&&(this.b=this.b.concat(g),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(g){this.a===0&&(this.a=2,this.d=g,this.f.fire())}}e.AsyncIterableObject=se,se.EMPTY=se.fromArray([]);class K extends se{constructor(g,O){super(O),this.l=g}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=K;function _($){const g=new k.CancellationTokenSource,O=$(g.token);return new K(g,async B=>{const W=g.token.onCancellationRequested(()=>{W.dispose(),g.dispose(),B.reject(new U.CancellationError)});try{for await(const z of O){if(g.token.isCancellationRequested)return;B.emitOne(z)}W.dispose(),g.dispose()}catch(z){W.dispose(),g.dispose(),B.reject(z)}})}e.createCancelableAsyncIterable=_}),define(oe[90],ae([0,1,21,6,46,35,15,5,27]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",v="[^/\\\\]",S=/\//g;function f(x,G){switch(x){case 0:return"";case 1:return`${v}*?`;default:return`(?:${P}|${v}+${P}${G?`|${P}${v}+`:""})*?`}}function d(x,G){if(!x)return[];const j=[];let Z=!1,ie=!1,se="";for(const K of x){switch(K){case G:if(!Z&&!ie){j.push(se),se="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}se+=K}return se&&j.push(se),j}e.splitGlobAware=d;function w(x){if(!x)return"";let G="";const j=d(x,e.GLOB_SPLIT);if(j.every(Z=>Z===e.GLOBSTAR))G=".*";else{let Z=!1;j.forEach((ie,se)=>{if(ie===e.GLOBSTAR){if(Z)return;G+=f(2,se===j.length-1)}else{let K=!1,_="",$=!1,g="";for(const O of ie){if(O!=="}"&&K){_+=O;continue}if($&&(O!=="]"||!g)){let B;O==="-"?B=O:(O==="^"||O==="!")&&!g?B="^":O===e.GLOB_SPLIT?B="":B=(0,C.escapeRegExpCharacters)(O),g+=B;continue}switch(O){case"{":K=!0;continue;case"[":$=!0;continue;case"}":{const W=`(?:${d(_,",").map(z=>w(z)).join("|")})`;G+=W,K=!1,_="";break}case"]":{G+="["+g+"]",$=!1,g="";break}case"?":G+=v;continue;case"*":G+=f(1);continue;default:G+=(0,C.escapeRegExpCharacters)(O)}}se<j.length-1&&(j[se+1]!==e.GLOBSTAR||se+2<j.length)&&(G+=P)}Z=ie===e.GLOBSTAR})}return G}const a=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,I=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,L=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new N.LRUCache(1e4),r=function(){return!1},t=function(){return null};function i(x,G){if(!x)return t;let j;typeof x!="string"?j=x.pattern:j=x,j=j.trim();const Z=`${j}_${!!G.trimForExclusions}`;let ie=n.get(Z);if(ie)return s(ie,x);let se;return a.test(j)?ie=l(j.substr(4),j):(se=h.exec(o(j,G)))?ie=E(se[1],j):(G.trimForExclusions?I:u).test(j)?ie=y(j,G):(se=p.exec(o(j,G)))?ie=c(se[1].substr(1),j,!0):(se=L.exec(o(j,G)))?ie=c(se[1],j,!1):ie=b(j),n.set(Z,ie),s(ie,x)}function s(x,G){if(typeof G=="string")return x;const j=function(Z,ie){return(0,A.isEqualOrParent)(Z,G.base,!D.isLinux)?x((0,C.ltrim)(Z.substr(G.base.length),T.sep),ie):null};return j.allBasenames=x.allBasenames,j.allPaths=x.allPaths,j.basenames=x.basenames,j.patterns=x.patterns,j}function o(x,G){return G.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function l(x,G){return function(j,Z){return typeof j=="string"&&j.endsWith(x)?G:null}}function E(x,G){const j=`/${x}`,Z=`\\${x}`,ie=function(K,_){return typeof K!="string"?null:_?_===x?G:null:K===x||K.endsWith(j)||K.endsWith(Z)?G:null},se=[x];return ie.basenames=se,ie.patterns=[G],ie.allBasenames=se,ie}function y(x,G){const j=te(x.slice(1,-1).split(",").map(_=>i(_,G)).filter(_=>_!==t),x),Z=j.length;if(!Z)return t;if(Z===1)return j[0];const ie=function(_,$){for(let g=0,O=j.length;g<O;g++)if(j[g](_,$))return x;return null},se=j.find(_=>!!_.allBasenames);se&&(ie.allBasenames=se.allBasenames);const K=j.reduce((_,$)=>$.allPaths?_.concat($.allPaths):_,[]);return K.length&&(ie.allPaths=K),ie}function c(x,G,j){const Z=T.sep===T.posix.sep,ie=Z?x:x.replace(S,T.sep),se=T.sep+ie,K=T.posix.sep+x;let _;return j?_=function($,g){return typeof $=="string"&&($===ie||$.endsWith(se)||!Z&&($===x||$.endsWith(K)))?G:null}:_=function($,g){return typeof $=="string"&&($===ie||!Z&&$===x)?G:null},_.allPaths=[(j?"*/":"./")+x],_}function b(x){try{const G=new RegExp(`^${w(x)}$`);return function(j){return G.lastIndex=0,typeof j=="string"&&G.test(j)?x:null}}catch{return t}}function R(x,G,j){return!x||typeof G!="string"?!1:M(x)(G,void 0,j)}e.match=R;function M(x,G={}){if(!x)return r;if(typeof x=="string"||F(x)){const j=i(x,G);if(j===t)return r;const Z=function(ie,se){return!!j(ie,se)};return j.allBasenames&&(Z.allBasenames=j.allBasenames),j.allPaths&&(Z.allPaths=j.allPaths),Z}return V(x,G)}e.parse=M;function F(x){const G=x;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.isRelativePattern=F;function H(x){return x.allBasenames||[]}e.getBasenameTerms=H;function q(x){return x.allPaths||[]}e.getPathTerms=q;function V(x,G){const j=te(Object.getOwnPropertyNames(x).map(_=>Q(_,x[_],G)).filter(_=>_!==t)),Z=j.length;if(!Z)return t;if(!j.some(_=>!!_.requiresSiblings)){if(Z===1)return j[0];const _=function(O,B){let W;for(let z=0,J=j.length;z<J;z++){const ee=j[z](O,B);if(typeof ee=="string")return ee;(0,U.isThenable)(ee)&&(W||(W=[]),W.push(ee))}return W?(async()=>{for(const z of W){const J=await z;if(typeof J=="string")return J}return null})():null},$=j.find(O=>!!O.allBasenames);$&&(_.allBasenames=$.allBasenames);const g=j.reduce((O,B)=>B.allPaths?O.concat(B.allPaths):O,[]);return g.length&&(_.allPaths=g),_}const ie=function(_,$,g){let O,B;for(let W=0,z=j.length;W<z;W++){const J=j[W];J.requiresSiblings&&g&&($||($=(0,T.basename)(_)),O||(O=$.substr(0,$.length-(0,T.extname)(_).length)));const ee=J(_,$,O,g);if(typeof ee=="string")return ee;(0,U.isThenable)(ee)&&(B||(B=[]),B.push(ee))}return B?(async()=>{for(const W of B){const z=await W;if(typeof z=="string")return z}return null})():null},se=j.find(_=>!!_.allBasenames);se&&(ie.allBasenames=se.allBasenames);const K=j.reduce((_,$)=>$.allPaths?_.concat($.allPaths):_,[]);return K.length&&(ie.allPaths=K),ie}function Q(x,G,j){if(G===!1)return t;const Z=i(x,j);if(Z===t)return t;if(typeof G=="boolean")return Z;if(G){const ie=G.when;if(typeof ie=="string"){const se=(K,_,$,g)=>{if(!g||!Z(K,_))return null;const O=ie.replace("$(basename)",()=>$),B=g(O);return(0,U.isThenable)(B)?B.then(W=>W?x:null):B?x:null};return se.requiresSiblings=!0,se}}return Z}function te(x,G){const j=x.filter(_=>!!_.basenames);if(j.length<2)return x;const Z=j.reduce((_,$)=>{const g=$.basenames;return g?_.concat(g):_},[]);let ie;if(G){ie=[];for(let _=0,$=Z.length;_<$;_++)ie.push(G)}else ie=j.reduce((_,$)=>{const g=$.patterns;return g?_.concat(g):_},[]);const se=function(_,$){if(typeof _!="string")return null;if(!$){let O;for(O=_.length;O>0;O--){const B=_.charCodeAt(O-1);if(B===47||B===92)break}$=_.substr(O)}const g=Z.indexOf($);return g!==-1?ie[g]:null};se.basenames=Z,se.patterns=ie,se.allBasenames=Z;const K=x.filter(_=>!_.basenames);return K.push(se),K}function Y(x,G){return(0,k.equals)(x,G,(j,Z)=>typeof j=="string"&&typeof Z=="string"?j===Z:typeof j!="string"&&typeof Z!="string"?j.base===Z.base&&j.pattern===Z.pattern:!1)}e.patternsEquals=Y}),define(oe[91],ae([0,1,16,12]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function A(v){return v.toJSON()}class N{constructor(S){this.a=S}transformIncoming(S){const f=this.a.transformIncoming(S);return f===S?S:A(U.URI.from(f))}transformOutgoing(S){const f=this.a.transformOutgoing(S);return f===S?S:A(U.URI.from(f))}transformOutgoingURI(S){const f=this.a.transformOutgoing(S);return f===S?S:U.URI.from(f)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.URITransformer=N,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function T(v,S,f){if(!v||f>200)return null;if(typeof v=="object"){if(v instanceof U.URI)return S.transformOutgoing(v);for(const d in v)if(Object.hasOwnProperty.call(v,d)){const w=T(v[d],S,f+1);w!==null&&(v[d]=w)}}return null}function D(v,S){const f=T(v,S,0);return f===null?v:f}e.transformOutgoingURIs=D;function C(v,S,f,d){if(!v||d>200)return null;if(typeof v=="object"){if(v.$mid===1)return f?U.URI.revive(S.transformIncoming(v)):S.transformIncoming(v);if(v instanceof k.VSBuffer)return null;for(const w in v)if(Object.hasOwnProperty.call(v,w)){const a=C(v[w],S,f,d+1);a!==null&&(v[w]=a)}}return null}function m(v,S){const f=C(v,S,!1,0);return f===null?v:f}e.transformIncomingURIs=m;function P(v,S){const f=C(v,S,!0,0);return f===null?v:f}e.transformAndReviveIncomingURIs=P}),define(oe[136],ae([0,1,36,47,32,125]),function(ne,e,k,U,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(m){return this.a||(this.a=U.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,P=0;const v=(0,k.networkInterfaces)();for(const S in v){const f=v[S];if(f)for(const{mac:d,internal:w}of f)w||(P+=1,this.c(d.toUpperCase())&&(m+=1))}this.b=P>0?m/P:0}return this.b}};let T;async function D(m){return T||(T=(async()=>await C(m)||A.generateUuid())()),T}e.getMachineId=D;async function C(m){try{const P=await new Promise((S,f)=>{ne(["crypto"],S,f)}),v=(0,N.getMac)();return P.createHash("sha256").update(v,"utf8").digest("hex")}catch(P){m(P);return}}}),define(oe[30],ae([0,1,51,36,261,6,46,86,15,5,22,12]),function(ne,e,k,U,A,N,T,D,C,m,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(S||(e.RimRafMode=S={}));async function f(V,Q=S.UNLINK,te){if((0,T.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return Q===S.UNLINK?w(V):d(V,te)}async function d(V,Q=(0,T.randomPath)((0,U.tmpdir)())){try{try{await k.promises.rename(V,Q)}catch(te){return te.code==="ENOENT"?void 0:w(V)}w(Q).catch(te=>{})}catch(te){if(te.code!=="ENOENT")throw te}}async function w(V){return(0,A.promisify)(k.rm)(V,{recursive:!0,force:!0,maxRetries:3})}function a(V){if((0,T.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function h(V,Q){return p(await(Q?u(V):(0,A.promisify)(k.readdir)(V)))}async function u(V){try{return await(0,A.promisify)(k.readdir)(V,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const Q=[],te=await h(V);for(const Y of te){let x=!1,G=!1,j=!1;try{const Z=await e.Promises.lstat((0,C.join)(V,Y));x=Z.isFile(),G=Z.isDirectory(),j=Z.isSymbolicLink()}catch(Z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Z)}Q.push({name:Y,isFile:()=>x,isDirectory:()=>G,isSymbolicLink:()=>j})}return Q}function I(V){return p(k.readdirSync(V))}e.readdirSync=I;function p(V){return V.map(Q=>typeof Q=="string"?m.isMacintosh?(0,D.normalizeNFC)(Q):Q:(Q.name=m.isMacintosh?(0,D.normalizeNFC)(Q.name):Q.name,Q))}async function L(V){const Q=await h(V),te=[];for(const Y of Q)await r.existsDirectory((0,C.join)(V,Y))&&te.push(Y);return te}function n(V,Q=1e3){return new Promise(te=>{let Y=!1;const x=setInterval(()=>{Y||(Y=!0,k.access(V,G=>{Y=!1,G&&(clearInterval(x),te(void 0))}))},Q)})}e.whenDeleted=n;var r;(function(V){async function Q(x){let G;try{if(G=await e.Promises.lstat(x),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(m.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(Z){if(Z.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw Z}throw j}}V.stat=Q;async function te(x){try{const{stat:G,symbolicLink:j}=await V.stat(x);return G.isFile()&&j?.dangling!==!0}catch{}return!1}V.existsFile=te;async function Y(x){try{const{stat:G,symbolicLink:j}=await V.stat(x);return G.isDirectory()&&j?.dangling!==!0}catch{}return!1}V.existsDirectory=Y})(r||(e.SymlinkSupport=r={}));const t=new N.ResourceQueue;function i(V,Q,te){return t.queueFor(v.URI.file(V),P.extUriBiasedIgnorePathCase).queue(()=>{const Y=y(te);return new Promise((x,G)=>l(V,Q,Y,j=>j?G(j):x()))})}let s=!0;function o(V){s=V}e.configureFlushOnWrite=o;function l(V,Q,te,Y){if(!s)return k.writeFile(V,Q,{mode:te.mode,flag:te.flag},Y);k.open(V,te.flag,te.mode,(x,G)=>{if(x)return Y(x);k.writeFile(G,Q,j=>{if(j)return k.close(G,()=>Y(j));k.fdatasync(G,Z=>(Z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Z),o(!1)),k.close(G,ie=>Y(ie))))})})}function E(V,Q,te){const Y=y(te);if(!s)return k.writeFileSync(V,Q,{mode:Y.mode,flag:Y.flag});const x=k.openSync(V,Y.flag,Y.mode);try{k.writeFileSync(x,Q);try{k.fdatasyncSync(x)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),o(!1)}}finally{k.closeSync(x)}}e.writeFileSync=E;function y(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function c(V,Q){if(V!==Q)try{await e.Promises.rename(V,Q)}catch(te){if(V.toLowerCase()!==Q.toLowerCase()&&te.code==="EXDEV"||V.endsWith("."))await b(V,Q,{preserveSymlinks:!1}),await f(V,S.MOVE);else throw te}}async function b(V,Q,te){return M(V,Q,{root:{source:V,target:Q},options:te,handledSourcePaths:new Set})}const R=511;async function M(V,Q,te){if(te.handledSourcePaths.has(V))return;te.handledSourcePaths.add(V);const{stat:Y,symbolicLink:x}=await r.stat(V);if(x){if(te.options.preserveSymlinks)try{return await q(V,Q,te)}catch(G){console.warn("[node.js fs] copy of symlink failed: ",G)}if(x.dangling)return}return Y.isDirectory()?F(V,Q,Y.mode&R,te):H(V,Q,Y.mode&R)}async function F(V,Q,te,Y){await e.Promises.mkdir(Q,{recursive:!0,mode:te});const x=await h(V);for(const G of x)await M((0,C.join)(V,G),(0,C.join)(Q,G),Y)}async function H(V,Q,te){await e.Promises.copyFile(V,Q),await e.Promises.chmod(Q,te)}async function q(V,Q,te){let Y=await e.Promises.readlink(V);(0,T.isEqualOrParent)(Y,te.root.source,!m.isLinux)&&(Y=(0,C.join)(te.root.target,Y.substr(te.root.source.length+1))),await e.Promises.symlink(Y,Q)}e.Promises=new class{get access(){return(0,A.promisify)(k.access)}get stat(){return(0,A.promisify)(k.stat)}get lstat(){return(0,A.promisify)(k.lstat)}get utimes(){return(0,A.promisify)(k.utimes)}get read(){return(V,Q,te,Y,x)=>new Promise((G,j)=>{k.read(V,Q,te,Y,x,(Z,ie,se)=>Z?j(Z):G({bytesRead:ie,buffer:se}))})}get readFile(){return(0,A.promisify)(k.readFile)}get write(){return(V,Q,te,Y,x)=>new Promise((G,j)=>{k.write(V,Q,te,Y,x,(Z,ie,se)=>Z?j(Z):G({bytesWritten:ie,buffer:se}))})}get appendFile(){return(0,A.promisify)(k.appendFile)}get fdatasync(){return(0,A.promisify)(k.fdatasync)}get truncate(){return(0,A.promisify)(k.truncate)}get rename(){return(0,A.promisify)(k.rename)}get copyFile(){return(0,A.promisify)(k.copyFile)}get open(){return(0,A.promisify)(k.open)}get close(){return(0,A.promisify)(k.close)}get symlink(){return(0,A.promisify)(k.symlink)}get readlink(){return(0,A.promisify)(k.readlink)}get chmod(){return(0,A.promisify)(k.chmod)}get mkdir(){return(0,A.promisify)(k.mkdir)}get unlink(){return(0,A.promisify)(k.unlink)}get rmdir(){return(0,A.promisify)(k.rmdir)}get realpath(){return(0,A.promisify)(k.realpath)}async exists(V){try{return await e.Promises.access(V),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return L}get writeFile(){return i}get rm(){return f}get move(){return c}get copy(){return b}}}),define(oe[137],ae([0,1,51,15,5,27,30]),function(ne,e,k,U,A,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(S){if(A.isLinux)return S;const f=(0,U.dirname)(S);if(S===f)return S;const d=((0,U.basename)(S)||S).toLowerCase();try{const a=(0,T.readdirSync)(f).filter(h=>h.toLowerCase()===d);if(a.length===1){const h=D(f);if(h)return(0,U.join)(h,a[0])}else if(a.length>1){const h=a.indexOf(d);if(h>=0){const u=D(f);if(u)return(0,U.join)(u,a[h])}}}catch{}return null}e.realcaseSync=D;async function C(S){if(A.isLinux)return S;const f=(0,U.dirname)(S);if(S===f)return S;const d=((0,U.basename)(S)||S).toLowerCase();try{const a=(await T.Promises.readdir(f)).filter(h=>h.toLowerCase()===d);if(a.length===1){const h=await C(f);if(h)return(0,U.join)(h,a[0])}else if(a.length>1){const h=a.indexOf(d);if(h>=0){const u=await C(f);if(u)return(0,U.join)(u,a[h])}}}catch{}return null}e.realcase=C;async function m(S){try{return await T.Promises.realpath(S)}catch{const d=v(S);return await T.Promises.access(d,k.constants.R_OK),d}}e.realpath=m;function P(S){try{return k.realpathSync(S)}catch{const d=v(S);return k.accessSync(d,k.constants.R_OK),d}}e.realpathSync=P;function v(S){return(0,N.rtrim)((0,U.normalize)(S),U.sep)}}),define(oe[138],ae([0,1,15,5,37,87,10,30]),function(ne,e,k,U,A,N,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function C(v=A.env){return v.comspec||"cmd.exe"}e.getWindowsShell=C;function m(v){let S=[],f=!1;const d=function(w){if(f){S.push(w);return}(!v.send(w,h=>{if(h&&console.error(h),f=!1,S.length>0){const u=S.slice(0);S=[],u.forEach(I=>d(I))}})||U.isWindows)&&(f=!0)};return{send:d}}e.createQueuedSender=m;var P;(function(v){async function S(f,d,w){if(k.isAbsolute(f))return f;if(d===void 0&&(d=A.cwd()),k.dirname(f)!=="."||(w===void 0&&T.isString(A.env.PATH)&&(w=A.env.PATH.split(k.delimiter)),w===void 0||w.length===0))return k.join(d,f);async function h(u){if(await D.Promises.exists(u)){let I;try{I=await D.Promises.stat(u)}catch(p){p.message.startsWith("EACCES")&&(I=await D.Promises.lstat(u))}return I?!I.isDirectory():!1}return!1}for(const u of w){let I;if(k.isAbsolute(u)?I=k.join(u,f):I=k.join(d,u,f),await h(I))return I;let p=I+".com";if(await h(p)||(p=I+".exe",await h(p)))return p}return k.join(d,f)}v.findExecutable=S})(P||(e.win32=P={}))}),define(oe[139],ae([0,1,65,25]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(T){return new Promise((D,C)=>{let m;const P=new Map;function v(f,d,w,a,h){const u=P.get(d);if(f===T||u){const I={name:S(w),cmd:w,pid:f,ppid:d,load:a,mem:h};P.set(f,I),f===T&&(m=I),u&&(u.children||(u.children=[]),u.children.push(I),u.children.length>1&&(u.children=u.children.sort((p,L)=>p.pid-L.pid)))}}function S(f){const d=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,a=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,u=/conhost\.exe/i,I=/--type=([a-zA-Z-]+)/;if(a.exec(f))return"electron-crash-reporter";if(h.exec(f))return"winpty-process";if(u.exec(f))return"console-window-host (Windows internal process)";let p=I.exec(f);if(p&&p.length===2)return p[1]==="renderer"?"window":p[1]==="utility"?d.exec(f)?"utility-network-service":"utility-process":p[1]==="extensionHost"?"extension-host":p[1];const L=/[a-zA-Z-]+\.js/g;let n="";do p=L.exec(f),p&&(n+=p+" ");while(p);return n&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${n})`:w.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,w)=>{ne(["@vscode/windows-process-tree"],d,w)}).then(d=>{d.getProcessList(T,w=>{if(!w){C(new Error(`Root process ${T} not found`));return}d.getProcessCpuUsage(w,a=>{const h=new Map;a.forEach(u=>{const I=f(u.commandLine||"");h.set(u.pid,{name:S(I),cmd:I,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),m=h.get(T),m?(h.forEach(u=>{const I=h.get(u.ppid);I&&(I.children||(I.children=[]),I.children.push(u))}),h.forEach(u=>{u.children&&(u.children=u.children.sort((I,p)=>I.pid-p.pid))}),D(m)):C(new Error(`Root process ${T} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let f=function(){let d=[m];const w=[];for(;d.length;){const h=d.shift();h&&(w.push(h.pid),h.children&&(d=d.concat(h.children)))}let a=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+w.join(" "),(0,k.exec)(a,{},(h,u,I)=>{if(h||I)C(h||new Error(I.toString()));else{const p=u.toString().split(`
`);for(let L=0;L<w.length;L++){const n=P.get(w[L]);n.load=parseFloat(p[L])}if(!m){C(new Error(`Root process ${T} not found`));return}D(m)}})};(0,k.exec)("which ps",{},(d,w,a)=>{if(d||a)if(process.platform!=="linux")C(d||new Error(a.toString()));else{const h=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(h,{},(u,I,p)=>{u||p?C(u||new Error(p.toString())):(N(I,v),f())})}else{const h=w.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${h} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(I,p,L)=>{I||L&&!L.includes("screen size is bogus")?C(I||new Error(L.toString())):(N(p,v),process.platform==="linux"?f():m?D(m):C(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=A;function N(T,D){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=T.toString().split(`
`);for(const P of m){const v=C.exec(P.trim());v&&v.length===6&&D(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}});var ve=this&&this.__decorate||function(ne,e,k,U){var A=arguments.length,N=A<3?e:U===null?U=Object.getOwnPropertyDescriptor(e,k):U,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(ne,e,k,U);else for(var D=ne.length-1;D>=0;D--)(T=ne[D])&&(N=(A<3?T(N):A>3?T(e,k,N):T(e,k))||N);return A>3&&N&&Object.defineProperty(e,k,N),N};define(oe[43],ae([0,1,21,6,16,26,59,7,3,2,64,27,10]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(f||(f={}));function d(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(w||(w={}));function a(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(h||(h={}));function u(G){let j=0;for(let Z=0;;Z+=7){const ie=G.read(1);if(j|=(ie.buffer[0]&127)<<Z,!(ie.buffer[0]&128))return j}}const I=t(0);function p(G,j){if(j===0){G.write(I);return}let Z=0;for(let se=j;se!==0;se=se>>>7)Z++;const ie=A.VSBuffer.alloc(Z);for(let se=0;j!==0;se++)ie.buffer[se]=j&127,j=j>>>7,j>0&&(ie.buffer[se]|=128);G.write(ie)}class L{constructor(j){this.b=j,this.a=0}read(j){const Z=this.b.slice(this.a,this.a+j);return this.a+=Z.byteLength,Z}}e.BufferReader=L;class n{constructor(){this.a=[]}get buffer(){return A.VSBuffer.concat(this.a)}write(j){this.a.push(j)}}e.BufferWriter=n;var r;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(r||(r={}));function t(G){const j=A.VSBuffer.alloc(1);return j.writeUInt8(G,0),j}const i={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(G,j){if(typeof j>"u")G.write(i.Undefined);else if(typeof j=="string"){const Z=A.VSBuffer.fromString(j);G.write(i.String),p(G,Z.byteLength),G.write(Z)}else if(s&&Buffer.isBuffer(j)){const Z=A.VSBuffer.wrap(j);G.write(i.Buffer),p(G,Z.byteLength),G.write(Z)}else if(j instanceof A.VSBuffer)G.write(i.VSBuffer),p(G,j.byteLength),G.write(j);else if(Array.isArray(j)){G.write(i.Array),p(G,j.length);for(const Z of j)o(G,Z)}else if(typeof j=="number"&&(j|0)===j)G.write(i.Uint),p(G,j);else{const Z=A.VSBuffer.fromString(JSON.stringify(j));G.write(i.Object),p(G,Z.byteLength),G.write(Z)}}e.serialize=o;function l(G){switch(G.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return G.read(u(G)).toString();case r.Buffer:return G.read(u(G)).buffer;case r.VSBuffer:return G.read(u(G));case r.Array:{const Z=u(G),ie=[];for(let se=0;se<Z;se++)ie.push(l(G));return ie}case r.Object:return JSON.parse(G.read(u(G)).toString());case r.Int:return u(G)}}e.deserialize=l;class E{constructor(j,Z,ie=null,se=1e3){this.h=j,this.j=Z,this.k=ie,this.l=se,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(j,Z){this.b.set(j,Z),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case 200:{const Z=this.o([j.type]);this.k?.logOutgoing(Z,0,1,a(j.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([j.type,j.id],j.data);this.k?.logOutgoing(Z,j.id,1,a(j.type),j.data);return}}}o(j,Z=void 0){const ie=new n;return o(ie,j),o(ie,Z),this.p(ie.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const Z=new L(j),ie=l(Z),se=l(Z),K=ie[0];switch(K){case 100:return this.k?.logIncoming(j.byteLength,ie[1],1,`${d(K)}: ${ie[2]}.${ie[3]}`,se),this.s({type:K,id:ie[1],channelName:ie[2],name:ie[3],arg:se});case 102:return this.k?.logIncoming(j.byteLength,ie[1],1,`${d(K)}: ${ie[2]}.${ie[3]}`,se),this.t({type:K,id:ie[1],channelName:ie[2],name:ie[3],arg:se});case 101:return this.k?.logIncoming(j.byteLength,ie[1],1,`${d(K)}`),this.u({type:K,id:ie[1]});case 103:return this.k?.logIncoming(j.byteLength,ie[1],1,`${d(K)}`),this.u({type:K,id:ie[1]})}}s(j){const Z=this.b.get(j.channelName);if(!Z){this.v(j);return}const ie=new N.CancellationTokenSource;let se;try{se=Z.call(this.j,j.name,j.arg,ie.token)}catch($){se=Promise.reject($)}const K=j.id;se.then($=>{this.m({id:K,data:$,type:201}),this.d.delete(j.id)},$=>{$ instanceof Error?this.m({id:K,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.m({id:K,data:$,type:203}),this.d.delete(j.id)});const _=(0,m.toDisposable)(()=>ie.cancel());this.d.set(j.id,_)}t(j){const Z=this.b.get(j.channelName);if(!Z){this.v(j);return}const ie=j.id,K=Z.listen(this.j,j.name,j.arg)(_=>this.m({id:ie,data:_,type:204}));this.d.set(j.id,K)}u(j){const Z=this.d.get(j.id);Z&&(Z.dispose(),this.d.delete(j.id))}v(j){let Z=this.g.get(j.channelName);Z||(Z=[],this.g.set(j.channelName,Z));const ie=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:j,timeoutTimer:ie})}w(j){const Z=this.g.get(j);if(Z){for(const ie of Z)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=E;var y;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class c{constructor(j,Z=null){this.l=j,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new C.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=Z}getChannel(j){const Z=this;return{call(ie,se,K){return Z.a?Promise.reject(new D.CancellationError):Z.m(j,ie,se,K)},listen(ie,se){return Z.a?C.Event.None:Z.o(j,ie,se)}}}m(j,Z,ie,se=N.CancellationToken.None){const K=this.g++,$={id:K,type:100,channelName:j,name:Z,arg:ie};if(se.isCancellationRequested)return Promise.reject(new D.CancellationError);let g;return new Promise((B,W)=>{if(se.isCancellationRequested)return W(new D.CancellationError);const z=()=>{const ue=de=>{switch(de.type){case 201:this.f.delete(K),B(de.data);break;case 202:{this.f.delete(K);const Se=new Error(de.data.message);Se.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,Se.name=de.data.name,W(Se);break}case 203:this.f.delete(K),W(de.data);break}};this.f.set(K,ue),this.p($)};let J=null;this.b===h.Idle?z():(J=(0,U.createCancelablePromise)(ue=>this.u()),J.then(()=>{J=null,z()}));const ee=()=>{J?(J.cancel(),J=null):this.p({id:K,type:101}),W(new D.CancellationError)},ce=se.onCancellationRequested(ee);g=(0,m.combinedDisposable)((0,m.toDisposable)(ee),ce),this.d.add(g)}).finally(()=>{this.d.delete(g)})}o(j,Z,ie){const se=this.g++,_={id:se,type:102,channelName:j,name:Z,arg:ie};let $=null;const g=new C.Emitter({onWillAddFirstListener:()=>{$=(0,U.createCancelablePromise)(B=>this.u()),$.then(()=>{$=null,this.d.add(g),this.p(_)})},onDidRemoveLastListener:()=>{$?($.cancel(),$=null):(this.d.delete(g),this.p({id:se,type:103}))}}),O=B=>g.fire(B.data);return this.f.set(se,O),g.event}p(j){switch(j.type){case 100:case 102:{const Z=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(Z,j.id,0,`${d(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const Z=this.q([j.type,j.id]);this.j?.logOutgoing(Z,j.id,0,d(j.type));return}}}q(j,Z=void 0){const ie=new n;return o(ie,j),o(ie,Z),this.r(ie.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const Z=new L(j),ie=l(Z),se=l(Z),K=ie[0];switch(K){case 200:return this.j?.logIncoming(j.byteLength,0,0,a(K)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(j.byteLength,ie[1],0,a(K),se),this.t({type:ie[0],id:ie[1],data:se})}}t(j){if(j.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelClient=c,ve([T.memoize],c.prototype,"onDidInitializePromise",null);class b{get connections(){const j=[];return this.f.forEach(Z=>j.push(Z)),j}constructor(j){this.a=new Map,this.f=new Set,this.g=new C.Emitter,this.onDidAddConnection=this.g.event,this.h=new C.Emitter,this.onDidRemoveConnection=this.h.event,j(({protocol:Z,onDidClientDisconnect:ie})=>{C.Event.once(Z.onMessage)(K=>{const _=new L(K),$=l(_),g=new E(Z,$),O=new c(Z);this.a.forEach((W,z)=>g.registerChannel(z,W));const B={channelServer:g,channelClient:O,ctx:$};this.f.add(B),this.g.fire(B),ie(()=>{g.dispose(),O.dispose(),this.f.delete(B),this.h.fire(B)})})})}getChannel(j,Z){const ie=this;return{call(se,K,_){let $;if((0,S.isFunction)(Z)){const O=(0,k.getRandomElement)(ie.connections.filter(Z));$=O?Promise.resolve(O):C.Event.toPromise(C.Event.filter(ie.onDidAddConnection,Z))}else $=Z.routeCall(ie,se,K);const g=$.then(O=>O.channelClient.getChannel(j));return M(g).call(se,K,_)},listen(se,K){if((0,S.isFunction)(Z))return ie.j(j,Z,se,K);const _=Z.routeEvent(ie,se,K).then($=>$.channelClient.getChannel(j));return M(_).listen(se,K)}}}j(j,Z,ie,se){const K=this;let _=new m.DisposableStore;const $=new C.Emitter({onWillAddFirstListener:()=>{_=new m.DisposableStore;const g=new C.EventMultiplexer,O=new Map,B=z=>{const ee=z.channelClient.getChannel(j).listen(ie,se),ce=g.add(ee);O.set(z,ce)},W=z=>{const J=O.get(z);J&&(J.dispose(),O.delete(z))};K.connections.filter(Z).forEach(B),C.Event.filter(K.onDidAddConnection,Z)(B,void 0,_),K.onDidRemoveConnection(W,void 0,_),g.event($.fire,$,_),_.add(g)},onDidRemoveLastListener:()=>{_.dispose()}});return $.event}registerChannel(j,Z){this.a.set(j,Z),this.f.forEach(ie=>{ie.channelServer.registerChannel(j,Z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=b;class R{constructor(j,Z,ie=null){const se=new n;o(se,Z),j.send(se.buffer),this.a=new c(j,ie),this.d=new E(j,Z,ie)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,Z){this.d.registerChannel(j,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=R;function M(G){return{call(j,Z,ie){return G.then(se=>se.call(j,Z,ie))},listen(j,Z){const ie=new C.Relay;return G.then(se=>ie.input=se.listen(j,Z)),ie.event}}}e.getDelayedChannel=M;function F(G){let j=!1;return{call(Z,ie,se){return j?G.call(Z,ie,se):(0,U.timeout)(0).then(()=>j=!0).then(()=>G.call(Z,ie,se))},listen(Z,ie){if(j)return G.listen(Z,ie);const se=new C.Relay;return(0,U.timeout)(0).then(()=>j=!0).then(()=>se.input=G.listen(Z,ie)),se.event}}}e.getNextTickChannel=F;class H{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const Z of j.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await C.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.StaticRouter=H;var q;(function(G){function j(K,_){const $=K,g=_&&_.disableMarshalling,O=new Map;for(const B in $)ie(B)&&O.set(B,C.Event.buffer($[B],!0));return new class{listen(B,W,z){const J=O.get(W);if(J)return J;if(se(W)){const ee=$[W];if(typeof ee=="function")return ee.call($,z)}throw new Error(`Event not found: ${W}`)}call(B,W,z){const J=$[W];if(typeof J=="function"){if(!g&&Array.isArray(z))for(let ee=0;ee<z.length;ee++)z[ee]=(0,P.revive)(z[ee]);return J.apply($,z)}throw new Error(`Method not found: ${W}`)}}}G.fromService=j;function Z(K,_){const $=_&&_.disableMarshalling;return new Proxy({},{get(g,O){if(typeof O=="string")return _?.properties?.has(O)?_.properties.get(O):se(O)?function(B){return K.listen(O,B)}:ie(O)?K.listen(O):async function(...B){let W;_&&!(0,S.isUndefinedOrNull)(_.context)?W=[_.context,...B]:W=B;const z=await K.call(O,W);return $?z:(0,P.revive)(z)};throw new Error(`Property not found: ${String(O)}`)}})}G.toService=Z;function ie(K){return K[0]==="o"&&K[1]==="n"&&v.isUpperAsciiLetter(K.charCodeAt(2))}function se(K){return/^onDynamic/.test(K)&&v.isUpperAsciiLetter(K.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const j=G.toString();if(j!=="[object Object]")return j}return G}function te(G){return Array.isArray(G)?G.map(Q):Q(G)}function Y(G,j,Z,ie,se,K,_){_=te(_);const $=V[se],g=$[ie%$.length];let O=[`%c[${G}]%c[${String(j).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${g}`];/\($/.test(K)?(O=O.concat(_),O.push(")")):O.push(_),console.log.apply(console,O)}class x{constructor(j,Z){this.d=j,this.f=Z,this.a=0,this.b=0}logOutgoing(j,Z,ie,se,K){this.b+=j,Y(this.d,this.b,j,Z,ie,se,K)}logIncoming(j,Z,ie,se,K){this.a+=j,Y(this.f,this.a,j,Z,ie,se,K)}}e.IPCLogger=x}),define(oe[92],ae([0,1,6,16,3,2,43]),function(ne,e,k,U,A,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var C;(function(c){c.enableDiagnostics=!1,c.records=[];const b=new WeakMap;let R=0;function M(H,q){if(!b.has(H)){const V=String(++R);b.set(H,V)}return b.get(H)}function F(H,q,V,Q){if(!c.enableDiagnostics)return;const te=M(H,q);if(Q instanceof U.VSBuffer||Q instanceof Uint8Array||Q instanceof ArrayBuffer||ArrayBuffer.isView(Q)){const Y=U.VSBuffer.alloc(Q.byteLength);Y.set(Q),c.records.push({timestamp:Date.now(),id:te,label:q,type:V,buff:Y})}else c.records.push({timestamp:Date.now(),id:te,label:q,type:V,data:Q})}c.traceSocketEvent=F})(C||(e.SocketDiagnostics=C={}));var m;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m||(e.SocketCloseEventType=m={}));let P=null;function v(){return P||(P=U.VSBuffer.alloc(0)),P}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(b){this.a.push(b),this.b+=b.byteLength}read(b){return this.c(b,!0)}peek(b){return this.c(b,!1)}c(b,R){if(b===0)return v();if(b>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===b){const q=this.a[0];return R&&(this.a.shift(),this.b-=b),q}if(this.a[0].byteLength>b){const q=this.a[0].slice(0,b);return R&&(this.a[0]=this.a[0].slice(b),this.b-=b),q}const M=U.VSBuffer.alloc(b);let F=0,H=0;for(;b>0;){const q=this.a[H];if(q.byteLength>b){const V=q.slice(0,b);M.set(V,F),F+=b,R&&(this.a[H]=q.slice(b),this.b-=b),b-=b}else M.set(q,F),F+=q.byteLength,R?(this.a.shift(),this.b-=q.byteLength):H++,b-=q.byteLength}return M}}e.ChunkStream=S;var f;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive",c[c.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",c[c.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(f||(f={}));function d(c){switch(c){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var w;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime",c[c.LatencySampleTime=6e4]="LatencySampleTime",c[c.LatencySampleCount=5]="LatencySampleCount",c[c.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",c[c.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(w||(e.ProtocolConstants=w={}));class a{constructor(b,R,M,F){this.type=b,this.id=R,this.ack=M,this.data=F,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends N.Disposable{constructor(b){super(),this.f=this.B(new A.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=b,this.b=!1,this.c=new S,this.B(this.a.onData(R=>this.acceptChunk(R))),this.lastReadTime=Date.now()}acceptChunk(b){if(!(!b||b.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(b);this.c.byteLength>=this.g.readLen;){const R=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=R.readUInt32BE(9),this.g.messageType=R.readUInt8(0),this.g.id=R.readUInt32BE(1),this.g.ack=R.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const M=this.g.messageType,F=this.g.id,H=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",R),this.f.fire(new a(M,F,H,R)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(b){this.k=null,this.a=!1,this.b=!1,this.c=b,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(b){if(this.a)return;b.writtenTime=Date.now(),this.lastWriteTime=Date.now();const R=U.VSBuffer.alloc(13);R.writeUInt8(b.type,0),R.writeUInt32BE(b.id,1),R.writeUInt32BE(b.ack,5),R.writeUInt32BE(b.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(b.type),id:b.id,ack:b.ack,messageSize:b.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",b.data),this.j(R,b.data)}g(b,R){const M=this.f===0;return this.d.push(b,R),this.f+=b.byteLength+R.byteLength,M}h(){const b=U.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,b}j(b,R){this.g(b,R)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const b=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:b.byteLength}),this.c.write(b)}}class I extends N.Disposable{constructor(b){super(),this.f=new A.Emitter,this.onMessage=this.f.event,this.g=new A.Emitter,this.onDidDispose=this.g.event,this.a=b,this.b=this.B(new u(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(R=>{R.type===1&&this.f.fire(R.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(b){this.b.write(new a(1,0,0,b))}}e.Protocol=I;class p extends T.IPCClient{static fromSocket(b,R){return new p(new I(b),R)}get onDidDispose(){return this.b.onDidDispose}constructor(b,R,M=null){super(b,R,M),this.b=b}dispose(){super.dispose();const b=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),b.end()}}e.Client=p;class L{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(b){this.b?this.d.length>0?this.d.push(b):this.a.fire(b):this.d.push(b)}flushBuffer(){this.d=[]}}e.BufferedEmitter=L;class n{constructor(b){this.data=b,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let b=0,R=this.a;for(;R;)R=R.next,b++;return b}peek(){return this.a?this.a.data:null}toArray(){const b=[];let R=0,M=this.a;for(;M;)b[R++]=M.data,M=M.next;return b}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(b){const R=new n(b);if(!this.a){this.a=R,this.b=R;return}this.b.next=R,this.b=R}}class t{static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const b=Date.now();for(let R=0;R<t.a;R++)this.c[R]=b-1e3*R;setInterval(()=>{for(let R=t.a;R>=1;R--)this.c[R]=this.c[R-1];this.c[0]=Date.now()},1e3)}d(){const b=Date.now(),R=(1+t.a)*1e3;let M=0;for(let F=0;F<t.a;F++)b-this.c[F]<=R&&M++;return 1-M/t.a}hasHighLoad(){return this.d()>=.5}}t.a=10,t.b=null;var i;(function(c){c[c.Good=0]="Good",c[c.Poor=1]="Poor"})(i||(e.ConnectionHealth=i={}));function s(c){switch(c){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class o{constructor(b){this.connectionHealth=b}}e.ConnectionHealthChangedEvent=o;class l{constructor(b,R){this.roundTripTime=b,this.recentHighRoundTripCount=R}}e.HighRoundTripTimeEvent=l;class E{get unacknowledgedCount(){return this.c-this.d}constructor(b){this.x=new L,this.onControlMessage=this.x.event,this.y=new L,this.onMessage=this.y.event,this.z=new L,this.onDidDispose=this.z.event,this.A=new L,this.onSocketClose=this.A.event,this.B=new L,this.onSocketTimeout=this.B.event,this.C=new L,this.onHighRoundTripTime=this.C.event,this.D=new L,this.onDidChangeConnectionHealth=this.D.event,this.u=b.loadEstimator??t.getInstance(),this.v=b.measureRoundTripTime??!1,this.w=b.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new N.DisposableStore,this.o=b.socket,this.p=this.t.add(new u(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(R=>this.E(R))),this.t.add(this.o.onClose(R=>this.A.fire(R))),this.r=this.t.add(new y),this.t.add(this.r.onSendLatencyRequest(R=>this.J(R))),this.t.add(this.r.onHighRoundTripTime(R=>this.C.fire(R))),this.t.add(this.r.onDidChangeConnectionHealth(R=>this.D.fire(R))),this.v&&this.r.start(),b.initialChunk&&this.q.acceptChunk(b.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const b=new a(5,0,0,v());this.p.write(b),this.p.flush()}sendPause(){const b=new a(7,0,0,v());this.p.write(b)}sendResume(){const b=new a(8,0,0,v());this.p.write(b)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(b,R){this.a=!0,this.t.dispose(),this.t=new N.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=b,this.p=this.t.add(new u(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(M=>this.E(M))),this.t.add(this.o.onClose(M=>this.A.fire(M))),this.r=this.t.add(new y),this.t.add(this.r.onSendLatencyRequest(M=>this.J(M))),this.t.add(this.r.onHighRoundTripTime(M=>this.C.fire(M))),this.t.add(this.r.onDidChangeConnectionHealth(M=>this.D.fire(M))),this.q.acceptChunk(R)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const b=new a(3,0,this.h,v());this.p.write(b);const R=this.b.toArray();for(let M=0,F=R.length;M<F;M++)this.p.write(R[M]);this.G()}acceptDisconnect(){this.z.fire()}E(b){if(b.ack>this.d){this.d=b.ack;do{const R=this.b.peek();if(R&&R.id<=b.ack)this.b.pop();else break}while(!0)}switch(b.type){case 0:break;case 1:{if(b.id>this.g)if(b.id!==this.g+1){const R=Date.now();R-this.m>1e4&&(this.m=R,this.p.write(new a(6,0,0,v())))}else this.g=b.id,this.j=Date.now(),this.F(),this.y.fire(b.data);break}case 2:{this.x.fire(b.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const R=this.b.toArray();for(let M=0,F=R.length;M<F;M++)this.p.write(R[M]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(b.data);break}case 11:{this.r.handleResponse(b.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(b){const R=++this.c;this.h=this.g;const M=new a(1,R,this.h,b);this.b.push(M),this.a||(this.p.write(M),this.G())}sendControl(b){const R=new a(2,0,0,b);this.p.write(R)}F(){if(this.g<=this.h||this.k)return;const b=Date.now()-this.j;if(b>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-b+5)}G(){if(this.c<=this.d||this.f||this.a)return;const b=this.b.peek(),R=Date.now()-b.writtenTime,M=Date.now()-this.q.lastReadTime,F=Date.now()-this.n;if(R>=2e4&&M>=2e4&&F>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:R,timeSinceLastReceivedSomeData:M});return}const H=Math.max(2e4-R,2e4-M,2e4-F,500);this.f=setTimeout(()=>{this.f=null,this.G()},H)}H(){if(this.g<=this.h)return;this.h=this.g;const b=new a(3,0,this.h,v());this.p.write(b)}I(){this.h=this.g;const b=new a(9,0,this.h,v());this.p.write(b)}J(b){this.h=this.g;const R=new a(10,0,this.h,b);this.p.write(R)}K(b){this.h=this.g;const R=new a(11,0,this.h,b);this.p.write(R)}}e.PersistentProtocol=E;class y extends N.Disposable{constructor(){super(),this.a=this.B(new A.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new A.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new A.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new k.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},b=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const b=++this.h,R=U.VSBuffer.alloc(4);R.writeUInt32BE(b,0),this.a.fire(R)},6e4)}handleResponse(b){if(b.byteLength!==4)return;const R=b.readUInt32BE(0);if(this.g<=0||R!==this.h)return;const M=Date.now()-this.g,F=this.k++;this.j[F%this.j.length]=M;const H=this.l,q=this.j.filter(V=>V>=1e3).length;this.l=q>=3?1:0,M>1e3&&this.b.fire(new l(M,q)),H!==this.l&&this.c.fire(this.l)}}}),define(oe[93],ae([0,1,65,6,16,26,135,7,3,2,31,138,87,43]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends f.ChannelServer{constructor(h){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",u=>A.VSBuffer.wrap(Buffer.from(u,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=d;class w{constructor(h,u){this.i=h,this.j=u,this.c=new Set,this.g=new Map,this.h=new C.Emitter,this.onDidProcessExit=this.h.event;const I=u&&u.timeout?u.timeout:6e4;this.b=new U.Delayer(I),this.d=null,this.f=null}getChannel(h){const u=this;return{call(I,p,L){return u.k(h,I,p,L)},listen(I,p){return u.l(h,I,p)}}}k(h,u,I,p=N.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(D.canceled());this.b.cancel();const L=this.n(h),n=(0,U.createCancelablePromise)(i=>L.call(u,I,i)),r=p.onCancellationRequested(()=>n.cancel()),t=(0,m.toDisposable)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(h,u,I){if(!this.b)return C.Event.None;this.b.cancel();let p;const L=new C.Emitter({onWillAddFirstListener:()=>{p=this.n(h).listen(u,I)(L.fire,L),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return L.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,S.removeDangerousEnvVariables)(u.env),this.d=(0,k.fork)(this.i,h,u);const I=new C.Emitter;C.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,T.isRemoteConsoleLog)(s)){(0,T.log)(s,`IPC Library: ${this.j.serverName}`);return}I.fire(A.VSBuffer.wrap(Buffer.from(s,"base64")))});const L=this.j.useQueue?(0,v.createQueuedSender)(this.d):this.d,n=s=>this.d&&this.d.connected&&L.send(s.buffer.toString("base64")),r=I.event,t={send:n,onMessage:r};this.f=new f.ChannelClient(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,o)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,m.dispose)(l)),this.c.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:o})})}return this.f}n(h){let u=this.g.get(h);return u||(u=this.m.getChannel(h),this.g.set(h,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=w}),define(oe[140],ae([0,1,127,16,43,3,10,21]),function(ne,e,k,U,A,N,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class C{constructor(S){this.a=S,this.onMessage=N.Event.fromNodeEventEmitter(this.a,"message",f=>U.VSBuffer.wrap(f.data)),S.start()}send(S){this.a.postMessage(S.buffer)}disconnect(){this.a.close()}}class m extends A.IPCServer{static b(){(0,T.assertType)((0,k.isUtilityProcess)(process),"Electron Utility Process");const S=new N.Emitter;return process.parentPort.on("message",f=>{const d=(0,D.firstOrDefault)(f.ports);d&&S.fire(d)}),N.Event.map(S.event,f=>({protocol:new C(f),onDidClientDisconnect:N.Event.fromNodeEventEmitter(f,"close")}))}constructor(){super(m.b())}}e.Server=m;function P(v,S,f){const d=w=>{w.data===S&&(v.removeListener("message",d),f())};v.on("message",d)}e.once=P}),define(oe[66],ae([0,1,6,3,2,64,10]),function(ne,e,k,U,A,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D||(e.StorageHint=D={}));function C(S){const f=S;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=C;var m;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(m||(e.StorageState=m={}));class P extends A.Disposable{constructor(f,d=Object.create(null)){super(),this.m=f,this.n=d,this.b=this.B(new U.Emitter),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=new k.ThrottledDelayer(P.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(f=>this.r(f)))}r(f){f.changed?.forEach((d,w)=>this.s(w,d)),f.deleted?.forEach(d=>this.s(d,void 0))}s(f,d){if(this.c===m.Closed)return;let w=!1;(0,T.isUndefinedOrNull)(d)?w=this.f.delete(f):this.f.get(f)!==d&&(this.f.set(f,d),w=!0),w&&this.b.fire(f)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.n.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(f,d){const w=this.f.get(f);return(0,T.isUndefinedOrNull)(w)?d:w}getBoolean(f,d){const w=this.get(f);return(0,T.isUndefinedOrNull)(w)?d:w==="true"}getNumber(f,d){const w=this.get(f);return(0,T.isUndefinedOrNull)(w)?d:parseInt(w,10)}getObject(f,d){const w=this.get(f);return(0,T.isUndefinedOrNull)(w)?d:(0,N.parse)(w)}async set(f,d){if(this.c===m.Closed)return;if((0,T.isUndefinedOrNull)(d))return this.delete(f);const w=(0,T.isObject)(d)||Array.isArray(d)?(0,N.stringify)(d):String(d);if(this.f.get(f)!==w)return this.f.set(f,w),this.j.set(f,w),this.h.delete(f),this.b.fire(f),this.w()}async delete(f){if(!(this.c===m.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire(f),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=m.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(f).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(f){if(this.u)return this.w(f)}async w(f){return this.g.trigger(()=>this.v(),f)}async whenFlushed(){if(this.u)return new Promise(f=>this.l.push(f))}isInMemory(){return this.n.hint===D.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=P,P.a=100;class v{constructor(){this.onDidChangeItemsExternal=U.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((d,w)=>this.a.set(w,d)),f.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.InMemoryStorageDatabase=v}),define(oe[141],ae([11,9]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(oe[142],ae([11,9]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[143],ae([11,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[144],ae([11,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(oe[145],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[146],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[147],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[148],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[149],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[150],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[151],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[152],ae([11,9]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(oe[153],ae([11,9]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(oe[154],ae([11,9]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(oe[155],ae([11,9]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[156],ae([11,9]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[157],ae([11,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[158],ae([11,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[159],ae([11,9]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(oe[160],ae([11,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[161],ae([11,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[162],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[163],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[164],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[165],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[166],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[167],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[168],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[169],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[170],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[171],ae([11,9]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(oe[172],ae([0,1,7,144]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var A;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(A||(e.TokenType=A={}));function N(...m){switch(m.length){case 1:return(0,U.localize)(0,null,m[0]);case 2:return(0,U.localize)(1,null,m[0],m[1]);case 3:return(0,U.localize)(2,null,m[0],m[1],m[2]);default:return}}const T=(0,U.localize)(3,null),D=(0,U.localize)(4,null);class C{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,k.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const v=this.d,S=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:S};this.g.push({offset:v,lexeme:S,additionalInfo:P}),this.f.push(f)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const v=this.c.substring(this.d,this.e),S=C.b.get(v);S?this.k(S):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,v=!1,S=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(D);return}const d=this.c.charCodeAt(P);if(v)v=!1;else if(d===47&&!S){P++;break}else d===91?S=!0:d===92?v=!0:d===93&&(S=!1);P++}for(;P<this.c.length&&C.a.has(this.c.charCodeAt(P));)P++;this.e=P;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=C,C.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0))),C.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(oe[173],ae([0,1,62,59,25,15,37,22,12]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,N.dirname)(A.FileAccess.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return C.URI.file((0,N.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.b.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,D.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,D.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.join)(this.userDataPath,"logs",f)}return C.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(C.URI.file((0,N.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,D.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,D.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=T.env.VSCODE_PORTABLE;return f?C.URI.file((0,N.join)(f,"argv.json")):(0,D.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,N.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,N.resolve)(f):(0,N.normalize)((0,N.join)(A.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?C.URI.file((0,N.resolve)(f)):C.URI.file((0,N.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,N.resolve)(f);const d=T.env.VSCODE_EXTENSIONS;if(d)return d;const w=T.env.VSCODE_PORTABLE;return w?(0,N.join)(w,"extensions"):(0,D.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(d=>/^[^:/?#]+?:\/\//.test(d)?C.URI.parse(d):C.URI.file((0,N.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?C.URI.parse(f):C.URI.file((0,N.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const d of this.args.log||[]){const w=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(d);w&&w[1]&&w[2]&&f.push([w[1],w[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,D.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=T.env.VSCODE_PORTABLE;return f?C.URI.file((0,N.join)(f,"policy.json")):(0,D.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,d,w){this.a=f,this.b=d,this.c=w,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=m,ve([U.memoize],m.prototype,"appRoot",null),ve([U.memoize],m.prototype,"userHome",null),ve([U.memoize],m.prototype,"userDataPath",null),ve([U.memoize],m.prototype,"appSettingsHome",null),ve([U.memoize],m.prototype,"tmpDir",null),ve([U.memoize],m.prototype,"cacheHome",null),ve([U.memoize],m.prototype,"stateResource",null),ve([U.memoize],m.prototype,"userRoamingDataHome",null),ve([U.memoize],m.prototype,"userDataSyncHome",null),ve([U.memoize],m.prototype,"sync",null),ve([U.memoize],m.prototype,"machineSettingsResource",null),ve([U.memoize],m.prototype,"workspaceStorageHome",null),ve([U.memoize],m.prototype,"localHistoryHome",null),ve([U.memoize],m.prototype,"keyboardLayoutResource",null),ve([U.memoize],m.prototype,"argvResource",null),ve([U.memoize],m.prototype,"isExtensionDevelopment",null),ve([U.memoize],m.prototype,"untitledWorkspacesHome",null),ve([U.memoize],m.prototype,"builtinExtensionsPath",null),ve([U.memoize],m.prototype,"extensionsPath",null),ve([U.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ve([U.memoize],m.prototype,"extensionDevelopmentKind",null),ve([U.memoize],m.prototype,"extensionTestsLocationURI",null),ve([U.memoize],m.prototype,"debugExtensionHost",null),ve([U.memoize],m.prototype,"logLevel",null),ve([U.memoize],m.prototype,"extensionLogLevel",null),ve([U.memoize],m.prototype,"serviceMachineIdResource",null),ve([U.memoize],m.prototype,"disableTelemetry",null),ve([U.memoize],m.prototype,"disableWorkspaceTrust",null),ve([U.memoize],m.prototype,"policyFile",null);function P(S,f){return v(S["inspect-extensions"],S["inspect-brk-extensions"],5870,f,S.debugId,S.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function v(S,f,d,w,a,h){const I=Number(f||S)||(w?null:d),p=I?!!f:!1;let L;if(h)try{L=JSON.parse(h)}catch{}return{port:I,break:p,debugId:a,env:L}}e.parseDebugParams=v}),function(){"use strict";function ne(e,k,U){function A(T,D){const C=N(T,D),m=[C];return e.isAbsolute(C)||m.unshift(U),e.resolve(...m)}function N(T,D){process.env.VSCODE_DEV&&(D="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,D);const P=T["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(v,"AppData","Roaming")}break;case"darwin":m=e.join(k.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,D)}return{getUserDataPath:A}}if(typeof define=="function")define(oe[174],ae([262,36,37]),function(e,k,U){return ne(e,k,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=ne(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[175],ae([0,1,36,173,174]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class N extends U.AbstractNativeEnvironmentService{constructor(m,P){super(m,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,A.getUserDataPath)(m,P.nameShort)},P)}}e.NativeEnvironmentService=N;function T(C,m){return(0,U.parseDebugParams)(C["inspect-ptyhost"],C["inspect-brk-ptyhost"],5877,m,C.extensionEnvironment)}e.parsePtyHostDebugPort=T;function D(C,m){return(0,U.parseDebugParams)(C["inspect-sharedprocess"],C["inspect-brk-sharedprocess"],5879,m,C.extensionEnvironment)}e.parseSharedProcessDebugPort=D}),define(oe[176],ae([0,1,10,147]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function A(T,D,C){try{N(T,D,C)}catch(m){console.error(m?.message??m)}return T}e.localizeManifest=A;function N(T,D,C){const m=(P,v,S)=>{const f=P[v];if((0,k.isString)(f)){const d=f,w=d.length;if(w>1&&d[0]==="%"&&d[w-1]==="%"){const a=d.substr(1,w-2);let h=D[a];h===void 0&&C&&(h=C[a]);const u=typeof h=="string"?h:h?.message,I=C?.[a],p=typeof I=="string"?I:I?.message;if(!u){p||console.warn(`[${T.name}]: ${(0,U.localize)(0,null,a)}`);return}if(S&&(v==="title"||v==="category")&&p&&p!==u){const L={value:u,original:p};P[v]=L}else P[v]=u}}else if((0,k.isObject)(f))for(const d in f)f.hasOwnProperty(d)&&(d==="commands"?m(f,d,!0):m(f,d,S));else if(Array.isArray(f))for(let d=0;d<f.length;d++)m(f,d,S)};for(const P in T)T.hasOwnProperty(P)&&m(T,P)}}),define(oe[177],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(N){this.a=N}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(N){return this.a.call("promptImportantExtensionsInstallNotification",[N])}promptWorkspaceRecommendations(N){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class U{constructor(N){this.a=N}listen(N,T){throw new Error(`Event not found: ${T}`)}call(N,T,D){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(D[0])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=U}),define(oe[67],ae([0,1,22,89,151,52]),function(ne,e,k,U,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function C(h){return h=h.trim(),h==="*"||T.test(h)}e.isValidVersionStr=C;function m(h){if(!C(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=h.match(T);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=m;function P(h){if(!h)return null;const u=h.majorBase,I=h.majorMustEqual,p=h.minorBase;let L=h.minorMustEqual;const n=h.patchBase;let r=h.patchMustEqual;h.hasCaret&&(u===0||(L=!1),r=!1);let t=0;if(h.preRelease){const i=D.exec(h.preRelease);if(i){const[,s,o,l]=i;t=Date.UTC(Number(s),Number(o)-1,Number(l))}}return{majorBase:u,majorMustEqual:I,minorBase:p,minorMustEqual:L,patchBase:n,patchMustEqual:r,isMinimum:h.hasGreaterEquals,notBefore:t}}e.normalizeVersion=P;function v(h,u,I){let p;typeof h=="string"?p=P(m(h)):p=h;let L;u instanceof Date?L=u.getTime():typeof u=="string"&&(L=new Date(u).getTime());let n;if(typeof I=="string"?n=P(m(I)):n=I,!p||!n)return!1;const r=p.majorBase,t=p.minorBase,i=p.patchBase;let s=n.majorBase,o=n.minorBase,l=n.patchBase;const E=n.notBefore;let y=n.majorMustEqual,c=n.minorMustEqual,b=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||L&&L<E?!1:i>=l:(r===1&&s===0&&(!y||!c||!b)&&(s=1,o=0,l=0,y=!0,c=!1,b=!1),r<s?!1:r>s?!y:t<o?!1:t>o?!c:i<l?!1:i>l?!b:!(L&&L<E))}e.isValidVersion=v;function S(h,u,I,p,L){const n=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return n.push([U.default.Error,A.localize(0,null)]),n;if(typeof p.name!="string")return n.push([U.default.Error,A.localize(1,null,"name")]),n;if(typeof p.version!="string")return n.push([U.default.Error,A.localize(2,null,"version")]),n;if(!p.engines)return n.push([U.default.Error,A.localize(3,null,"engines")]),n;if(typeof p.engines.vscode!="string")return n.push([U.default.Error,A.localize(4,null,"engines.vscode")]),n;if(typeof p.extensionDependencies<"u"&&!a(p.extensionDependencies))return n.push([U.default.Error,A.localize(5,null,"extensionDependencies")]),n;if(typeof p.activationEvents<"u"){if(!a(p.activationEvents))return n.push([U.default.Error,A.localize(6,null,"activationEvents")]),n;if(typeof p.main>"u"&&typeof p.browser>"u")return n.push([U.default.Error,A.localize(7,null,"activationEvents","main","browser")]),n}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&n.push([U.default.Warning,A.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return n.push([U.default.Error,A.localize(9,null,"main")]),n;{const i=(0,k.joinPath)(I,p.main);(0,k.isEqualOrParent)(i,I)||n.push([U.default.Warning,A.localize(10,null,i.path,I.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return n.push([U.default.Error,A.localize(11,null,"browser")]),n;{const i=(0,k.joinPath)(I,p.browser);(0,k.isEqualOrParent)(i,I)||n.push([U.default.Warning,A.localize(12,null,i.path,I.path)])}}if(!N.valid(p.version))return n.push([U.default.Error,A.localize(13,null)]),n;const r=[];if(!f(h,u,p,L,r))for(const i of r)n.push([U.default.Error,i]);return n}e.validateExtensionManifest=S;function f(h,u,I,p,L){return p||typeof I.main>"u"&&typeof I.browser>"u"?!0:w(h,u,I.engines.vscode,L)}e.isValidExtensionVersion=f;function d(h,u,I){return h==="*"||w(u,I,h)}e.isEngineValid=d;function w(h,u,I,p=[]){const L=P(m(I));if(!L)return p.push(A.localize(14,null,I)),!1;if(L.majorBase===0){if(!L.majorMustEqual||!L.minorMustEqual)return p.push(A.localize(15,null,I)),!1}else if(!L.majorMustEqual)return p.push(A.localize(16,null,I)),!1;return v(h,u,L)?!0:(p.push(A.localize(17,null,h,I)),!1)}function a(h){if(!Array.isArray(h))return!1;for(let u=0,I=h.length;u<I;u++)if(typeof h[u]!="string")return!1;return!0}}),define(oe[44],ae([0,1,16,32]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(N,T,D){let C=D&&D.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const P=(await T.readFile(N.serviceMachineIdResource)).value.toString();C=(0,U.isUUID)(P)?P:null}catch{C=null}if(!C){C=(0,U.generateUuid)();try{await T.writeFile(N.serviceMachineIdResource,k.VSBuffer.fromString(C))}catch{}}return D?.store("storage.serviceMachineId",C,-1,1),C}e.getServiceMachineId=A}),define(oe[68],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(A,N=[],T=!1){this.ctor=A,this.staticArguments=N,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=k}),define(oe[178],ae([0,1,68]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const U=[];var A;(function(D){D[D.Eager=0]="Eager",D[D.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function N(D,C,m){C instanceof k.SyncDescriptor||(C=new k.SyncDescriptor(C,[],!!m)),U.push([D,C])}e.registerSingleton=N;function T(){return U}e.getSingletonServiceDescriptors=T}),define(oe[179],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(N,T){this.key=N,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class U{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const T of this.a.values())T.outgoing.size===0&&N.push(T);return N}insertEdge(N,T){const D=this.lookupOrInsertNode(N),C=this.lookupOrInsertNode(T);D.outgoing.set(C.key,C),C.incoming.set(D.key,D)}removeNode(N){const T=this.b(N);this.a.delete(T);for(const D of this.a.values())D.outgoing.delete(T),D.incoming.delete(T)}lookupOrInsertNode(N){const T=this.b(N);let D=this.a.get(T);return D||(D=new k(T,N),this.a.set(T,D)),D}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[T,D]of this.a)N.push(`${T}
	(-> incoming)[${[...D.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...D.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,T]of this.a){const D=new Set([N]),C=this.c(T,D);if(C)return C}}c(N,T){for(const[D,C]of N.outgoing){if(T.has(D))return[...T,D].join(" -> ");T.add(D);const m=this.c(C,T);if(m)return m;T.delete(D)}}}e.Graph=U}),define(oe[4],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function D(C){return C[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=D})(k||(e._util=k={})),e.IInstantiationService=A("instantiationService");function U(T,D,C){D[k.DI_TARGET]===D?D[k.DI_DEPENDENCIES].push({id:T,index:C}):(D[k.DI_DEPENDENCIES]=[{id:T,index:C}],D[k.DI_TARGET]=D)}function A(T){if(k.serviceIds.has(T))return k.serviceIds.get(T);const D=function(C,m,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");U(D,C,P)};return D.toString=()=>T,k.serviceIds.set(T,D),D}e.createDecorator=A;function N(T){return T}e.refineServiceDecorator=N}),define(oe[180],ae([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(oe[18],ae([0,1,10,12,4]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function N(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof U.URI)}e.isConfigurationOverrides=N;function T(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof U.URI)}e.isConfigurationUpdateOverrides=T;var D;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(D||(e.ConfigurationTarget=D={}));function C(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=C;function m(a,h){const u=Object.create(null);for(const I in a)P(u,I,a[I],h);return u}e.toValuesTree=m;function P(a,h,u,I){const p=h.split("."),L=p.pop();let n=a;for(let r=0;r<p.length;r++){const t=p[r];let i=n[t];switch(typeof i){case"undefined":i=n[t]=Object.create(null);break;case"object":break;default:I(`Ignoring ${h} as ${p.slice(0,r+1).join(".")} is ${JSON.stringify(i)}`);return}n=i}if(typeof n=="object"&&n!==null)try{n[L]=u}catch{I(`Ignoring ${h} as ${p.join(".")} is ${JSON.stringify(n)}`)}else I(`Ignoring ${h} as ${p.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=P;function v(a,h){const u=h.split(".");S(a,u)}e.removeFromValueTree=v;function S(a,h){const u=h.shift();if(h.length===0){delete a[u];return}if(Object.keys(a).indexOf(u)!==-1){const I=a[u];typeof I=="object"&&!Array.isArray(I)&&(S(I,h),Object.keys(I).length===0&&delete a[u])}}function f(a,h,u){function I(n,r){let t=n;for(const i of r){if(typeof t!="object"||t===null)return;t=t[i]}return t}const p=h.split("."),L=I(a,p);return typeof L>"u"?u:L}e.getConfigurationValue=f;function d(a,h,u){Object.keys(h).forEach(I=>{I!=="__proto__"&&(I in a?k.isObject(a[I])&&k.isObject(h[I])?d(a[I],h[I],u):u&&(a[I]=h[I]):a[I]=h[I])})}e.merge=d;function w(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(oe[94],ae([0,1,5,27,172,4,143,7]),function(ne,e,k,U,A,N,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",k.isMacintosh),C.set("isLinux",k.isLinux),C.set("isWindows",k.isWindows),C.set("isWeb",k.isWeb),C.set("isMacNative",k.isMacintosh&&!k.isWeb),C.set("isEdge",k.isEdge),C.set("isFirefox",k.isFirefox),C.set("isChrome",k.isChrome),C.set("isSafari",k.isSafari);function m($,g){if(C.get($)!==void 0)throw(0,D.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");C.set($,g)}e.setConstant=m;const P=Object.prototype.hasOwnProperty;var v;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const S={regexParsingWithErrorRecovery:!0},f=(0,T.localize)(0,null),d=(0,T.localize)(1,null),w=(0,T.localize)(2,null),a=(0,T.localize)(3,null),h=(0,T.localize)(4,null),u=(0,T.localize)(5,null),I=(0,T.localize)(6,null),p=(0,T.localize)(7,null);class L{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(g=S){this.k=g,this.d=new A.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(g){if(g===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(g).scan(),this.g=0,this.h=[];try{const O=this.l();if(!this.E()){const B=this.D(),W=B.type===17?u:void 0;throw this.h.push({message:h,offset:B.offset,lexeme:A.Scanner.getLexeme(B),additionalInfo:W}),L.c}return O}catch(O){if(O!==L.c)throw O;return}}l(){return this.m()}m(){const g=[this.o()];for(;this.y(16);){const O=this.o();g.push(O)}return g.length===1?g[0]:n.or(...g)}o(){const g=[this.s()];for(;this.y(15);){const O=this.s();g.push(O)}return g.length===1?g[0]:n.and(...g)}s(){if(this.y(2)){const g=this.D();switch(g.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const O=this.l();return this.A(1,a),O?.negate()}case 17:return this.z(),R.create(g.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",g)}}return this.t()}t(){const g=this.D();switch(g.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const O=this.l();return this.A(1,a),O}case 17:{const O=g.lexeme;if(this.z(),this.y(9)){const W=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),W.type!==10)throw this.B("REGEX",W);const z=W.lexeme,J=z.lastIndexOf("/"),ee=J===z.length-1?void 0:this.w(z.substring(J+1));let ce;try{ce=new RegExp(z.substring(1,J),ee)}catch{throw this.B("REGEX",W)}return Q.create(O,ce)}switch(W.type){case 10:case 19:{const z=[W.lexeme];this.z();let J=this.D(),ee=0;for(let we=0;we<W.lexeme.length;we++)W.lexeme.charCodeAt(we)===40?ee++:W.lexeme.charCodeAt(we)===41&&ee--;for(;!this.E()&&J.type!==15&&J.type!==16;){switch(J.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let we=0;we<J.lexeme.length;we++)J.lexeme.charCodeAt(we)===40?ee++:W.lexeme.charCodeAt(we)===41&&ee--}if(ee<0)break;z.push(A.Scanner.getLexeme(J)),this.z(),J=this.D()}const ce=z.join(""),ue=ce.lastIndexOf("/"),de=ue===ce.length-1?void 0:this.w(ce.substring(ue+1));let Se;try{Se=new RegExp(ce.substring(1,ue),de)}catch{throw this.B("REGEX",W)}return n.regex(O,Se)}case 18:{const z=W.lexeme;this.z();let J=null;if(!(0,U.isFalsyOrWhitespace)(z)){const ee=z.indexOf("/"),ce=z.lastIndexOf("/");if(ee!==ce&&ee>=0){const ue=z.slice(ee+1,ce),de=z[ce+1]==="i"?"i":"";try{J=new RegExp(ue,de)}catch{throw this.B("REGEX",W)}}}if(J===null)throw this.B("REGEX",W);return Q.create(O,J)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const W=this.u();return n.notIn(O,W)}switch(this.D().type){case 3:{this.z();const W=this.u();if(this.x().type===18)return n.equals(O,W);switch(W){case"true":return n.has(O);case"false":return n.not(O);default:return n.equals(O,W)}}case 4:{this.z();const W=this.u();if(this.x().type===18)return n.notEquals(O,W);switch(W){case"true":return n.not(O);case"false":return n.has(O);default:return n.notEquals(O,W)}}case 5:return this.z(),q.create(O,this.u());case 6:return this.z(),V.create(O,this.u());case 7:return this.z(),F.create(O,this.u());case 8:return this.z(),H.create(O,this.u());case 13:return this.z(),n.in(O,this.u());default:return n.has(O)}}case 20:throw this.h.push({message:I,offset:g.offset,lexeme:"",additionalInfo:p}),L.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const g=this.D();switch(g.type){case 17:case 18:return this.z(),g.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(g){return g.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(g){return this.C(g)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(g,O){if(this.C(g))return this.z();throw this.B(O,this.D())}B(g,O,B){const W=(0,T.localize)(8,null,g,A.Scanner.getLexeme(O)),z=O.offset,J=A.Scanner.getLexeme(O);return this.h.push({message:W,offset:z,lexeme:J,additionalInfo:B}),L.c}C(g){return this.D().type===g}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=L,L.c=new Error;class n{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(g){return l.create(g)}static equals(g,O){return E.create(g,O)}static notEquals(g,O){return b.create(g,O)}static regex(g,O){return Q.create(g,O)}static in(g,O){return y.create(g,O)}static notIn(g,O){return c.create(g,O)}static not(g){return R.create(g)}static and(...g){return x.create(g,null,!0)}static or(...g){return G.create(g,null,!0)}static greater(g,O){return F.create(g,O)}static greaterEquals(g,O){return H.create(g,O)}static smaller(g,O){return q.create(g,O)}static smallerEquals(g,O){return V.create(g,O)}static deserialize(g){return g==null?void 0:this.c.parse(g)}}e.ContextKeyExpr=n,n.c=new L({regexParsingWithErrorRecovery:!1});function r($){const g=new L({regexParsingWithErrorRecovery:!1});return $.map(O=>(g.parse(O),g.lexingErrors.length>0?g.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,T.localize)(9,null,B.additionalInfo):(0,T.localize)(10,null),offset:B.offset,length:B.lexeme.length})):g.parsingErrors.length>0?g.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.validateWhenClauses=r;function t($,g){const O=$?$.substituteConstants():void 0,B=g?g.substituteConstants():void 0;return!O&&!B?!0:!O||!B?!1:O.equals(B)}e.expressionsAreEqualWithConstantSubstitution=t;function i($,g){return $.cmp(g)}class s{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=s,s.INSTANCE=new s;class o{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return s.INSTANCE}}e.ContextKeyTrueExpr=o,o.INSTANCE=new o;class l{static create(g,O=null){const B=C.get(g);return typeof B=="boolean"?B?o.INSTANCE:s.INSTANCE:new l(g,O)}constructor(g,O){this.key=g,this.c=O,this.type=2}cmp(g){return g.type!==this.type?this.type-g.type:Z(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=C.get(this.key);return typeof g=="boolean"?g?o.INSTANCE:s.INSTANCE:this}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=l;class E{static create(g,O,B=null){if(typeof O=="boolean")return O?l.create(g,B):R.create(g,B);const W=C.get(g);return typeof W=="boolean"?O===(W?"true":"false")?o.INSTANCE:s.INSTANCE:new E(g,O,B)}constructor(g,O,B){this.c=g,this.d=O,this.f=B,this.type=4}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){const g=C.get(this.c);if(typeof g=="boolean"){const O=g?"true":"false";return this.d===O?o.INSTANCE:s.INSTANCE}return this}evaluate(g){return g.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(g){return g.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=E;class y{static create(g,O){return new y(g,O)}constructor(g,O){this.d=g,this.f=O,this.type=10,this.c=null}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.d,this.f,g.d,g.f)}equals(g){return g.type===this.type?this.d===g.d&&this.f===g.f:!1}substituteConstants(){return this}evaluate(g){const O=g.getValue(this.f),B=g.getValue(this.d);return Array.isArray(O)?O.includes(B):typeof B=="string"&&typeof O=="object"&&O!==null?P.call(O,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(g){return g.mapIn(this.d,this.f)}negate(){return this.c||(this.c=c.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=y;class c{static create(g,O){return new c(g,O)}constructor(g,O){this.d=g,this.f=O,this.type=11,this.c=y.create(g,O)}cmp(g){return g.type!==this.type?this.type-g.type:this.c.cmp(g.c)}equals(g){return g.type===this.type?this.c.equals(g.c):!1}substituteConstants(){return this}evaluate(g){return!this.c.evaluate(g)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(g){return g.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=c;class b{static create(g,O,B=null){if(typeof O=="boolean")return O?R.create(g,B):l.create(g,B);const W=C.get(g);return typeof W=="boolean"?O===(W?"true":"false")?s.INSTANCE:o.INSTANCE:new b(g,O,B)}constructor(g,O,B){this.c=g,this.d=O,this.f=B,this.type=5}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){const g=C.get(this.c);if(typeof g=="boolean"){const O=g?"true":"false";return this.d===O?s.INSTANCE:o.INSTANCE}return this}evaluate(g){return g.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(g){return g.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=b;class R{static create(g,O=null){const B=C.get(g);return typeof B=="boolean"?B?s.INSTANCE:o.INSTANCE:new R(g,O)}constructor(g,O){this.c=g,this.d=O,this.type=3}cmp(g){return g.type!==this.type?this.type-g.type:Z(this.c,g.c)}equals(g){return g.type===this.type?this.c===g.c:!1}substituteConstants(){const g=C.get(this.c);return typeof g=="boolean"?g?s.INSTANCE:o.INSTANCE:this}evaluate(g){return!g.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(g){return g.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.ContextKeyNotExpr=R;function M($,g){if(typeof $=="string"){const O=parseFloat($);isNaN(O)||($=O)}return typeof $=="string"||typeof $=="number"?g($):s.INSTANCE}class F{static create(g,O,B=null){return M(O,W=>new F(g,W,B))}constructor(g,O,B){this.c=g,this.d=O,this.f=B,this.type=12}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(g){return g.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=F;class H{static create(g,O,B=null){return M(O,W=>new H(g,W,B))}constructor(g,O,B){this.c=g,this.d=O,this.f=B,this.type=13}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(g){return g.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=H;class q{static create(g,O,B=null){return M(O,W=>new q(g,W,B))}constructor(g,O,B){this.c=g,this.d=O,this.f=B,this.type=14}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(g){return g.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=q;class V{static create(g,O,B=null){return M(O,W=>new V(g,W,B))}constructor(g,O,B){this.c=g,this.d=O,this.f=B,this.type=15}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(g){return g.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=V;class Q{static create(g,O){return new Q(g,O)}constructor(g,O){this.d=g,this.f=O,this.type=7,this.c=null}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.d<g.d)return-1;if(this.d>g.d)return 1;const O=this.f?this.f.source:"",B=g.f?g.f.source:"";return O<B?-1:O>B?1:0}equals(g){if(g.type===this.type){const O=this.f?this.f.source:"",B=g.f?g.f.source:"";return this.d===g.d&&O===B}return!1}substituteConstants(){return this}evaluate(g){const O=g.getValue(this.d);return this.f?this.f.test(O):!1}serialize(){const g=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${g}`}keys(){return[this.d]}map(g){return g.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=te.create(this)),this.c}}e.ContextKeyRegexExpr=Q;class te{static create(g){return new te(g)}constructor(g){this.c=g,this.type=8}cmp(g){return g.type!==this.type?this.type-g.type:this.c.cmp(g.c)}equals(g){return g.type===this.type?this.c.equals(g.c):!1}substituteConstants(){return this}evaluate(g){return!this.c.evaluate(g)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(g){return new te(this.c.map(g))}negate(){return this.c}}e.ContextKeyNotRegexExpr=te;function Y($){let g=null;for(let O=0,B=$.length;O<B;O++){const W=$[O].substituteConstants();if($[O]!==W&&g===null){g=[];for(let z=0;z<O;z++)g[z]=$[z]}g!==null&&(g[O]=W)}return g===null?$:g}class x{static create(g,O,B){return x.d(g,O,B)}constructor(g,O){this.expr=g,this.c=O,this.type=6}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let O=0,B=this.expr.length;O<B;O++){const W=i(this.expr[O],g.expr[O]);if(W!==0)return W}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let O=0,B=this.expr.length;O<B;O++)if(!this.expr[O].equals(g.expr[O]))return!1;return!0}return!1}substituteConstants(){const g=Y(this.expr);return g===this.expr?this:x.create(g,this.c,!1)}evaluate(g){for(let O=0,B=this.expr.length;O<B;O++)if(!this.expr[O].evaluate(g))return!1;return!0}static d(g,O,B){const W=[];let z=!1;for(const J of g)if(J){if(J.type===1){z=!0;continue}if(J.type===0)return s.INSTANCE;if(J.type===6){W.push(...J.expr);continue}W.push(J)}if(W.length===0&&z)return o.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(i);for(let J=1;J<W.length;J++)W[J-1].equals(W[J])&&(W.splice(J,1),J--);if(W.length===1)return W[0];for(;W.length>1;){const J=W[W.length-1];if(J.type!==9)break;W.pop();const ee=W.pop(),ce=W.length===0,ue=G.create(J.expr.map(de=>x.create([de,ee],null,B)),null,ce);ue&&(W.push(ue),W.sort(i))}if(W.length===1)return W[0];if(B){for(let J=0;J<W.length;J++)for(let ee=J+1;ee<W.length;ee++)if(W[J].negate().equals(W[ee]))return s.INSTANCE;if(W.length===1)return W[0]}return new x(W,O)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(const O of this.expr)g.push(...O.keys());return g}map(g){return new x(this.expr.map(O=>O.map(g)),null)}negate(){if(!this.c){const g=[];for(const O of this.expr)g.push(O.negate());this.c=G.create(g,this,!0)}return this.c}}e.ContextKeyAndExpr=x;class G{static create(g,O,B){return G.d(g,O,B)}constructor(g,O){this.expr=g,this.c=O,this.type=9}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let O=0,B=this.expr.length;O<B;O++){const W=i(this.expr[O],g.expr[O]);if(W!==0)return W}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let O=0,B=this.expr.length;O<B;O++)if(!this.expr[O].equals(g.expr[O]))return!1;return!0}return!1}substituteConstants(){const g=Y(this.expr);return g===this.expr?this:G.create(g,this.c,!1)}evaluate(g){for(let O=0,B=this.expr.length;O<B;O++)if(this.expr[O].evaluate(g))return!0;return!1}static d(g,O,B){let W=[],z=!1;if(g){for(let J=0,ee=g.length;J<ee;J++){const ce=g[J];if(ce){if(ce.type===0){z=!0;continue}if(ce.type===1)return o.INSTANCE;if(ce.type===9){W=W.concat(ce.expr);continue}W.push(ce)}}if(W.length===0&&z)return s.INSTANCE;W.sort(i)}if(W.length!==0){if(W.length===1)return W[0];for(let J=1;J<W.length;J++)W[J-1].equals(W[J])&&(W.splice(J,1),J--);if(W.length===1)return W[0];if(B){for(let J=0;J<W.length;J++)for(let ee=J+1;ee<W.length;ee++)if(W[J].negate().equals(W[ee]))return o.INSTANCE;if(W.length===1)return W[0]}return new G(W,O)}}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(const O of this.expr)g.push(...O.keys());return g}map(g){return new G(this.expr.map(O=>O.map(g)),null)}negate(){if(!this.c){const g=[];for(const O of this.expr)g.push(O.negate());for(;g.length>1;){const O=g.shift(),B=g.shift(),W=[];for(const z of _(O))for(const J of _(B))W.push(x.create([z,J],null,!1));g.unshift(G.create(W,null,!1))}this.c=G.create(g,this,!0)}return this.c}}e.ContextKeyOrExpr=G;class j extends l{static all(){return j.d.values()}constructor(g,O,B){super(g,null),this.f=O,typeof B=="object"?j.d.push({...B,key:g}):B!==!0&&j.d.push({key:g,description:B,type:O!=null?typeof O:void 0})}bindTo(g){return g.createKey(this.key,this.f)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(g){return E.create(this.key,g)}notEqualsTo(g){return b.create(this.key,g)}}e.RawContextKey=j,j.d=[],e.IContextKeyService=(0,N.createDecorator)("contextKeyService");function Z($,g){return $<g?-1:$>g?1:0}function ie($,g,O,B){return $<O?-1:$>O?1:g<B?-1:g>B?1:0}function se($,g){if($.type===0||g.type===1)return!0;if($.type===9)return g.type===9?K($.expr,g.expr):!1;if(g.type===9){for(const O of g.expr)if(se($,O))return!0;return!1}if($.type===6){if(g.type===6)return K(g.expr,$.expr);for(const O of $.expr)if(se(O,g))return!0;return!1}return $.equals(g)}e.implies=se;function K($,g){let O=0,B=0;for(;O<$.length&&B<g.length;){const W=$[O].cmp(g[B]);if(W<0)return!1;W===0&&O++,B++}return O===$.length}function _($){return $.type===9?$.expr:[$]}}),define(oe[95],ae([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function U(N){return!!N.hostName&&!!N.errorMessage}e.isRemoteDiagnosticError=U;class A{async getPerformanceInfo(T,D){return{}}async getSystemInfo(T,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,D){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=A}),define(oe[96],ae([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(oe[14],ae([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[28],ae([0,1,146,4]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function A(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=A;function N(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function T(u,I){switch(u){case 3:return I==="x64"?"win32-x64":I==="ia32"?"win32-ia32":I==="arm64"?"win32-arm64":"unknown";case 2:return I==="x64"?"linux-x64":I==="arm64"?"linux-arm64":I==="arm"?"linux-armhf":"unknown";case"alpine":return I==="x64"?"alpine-x64":I==="arm64"?"alpine-arm64":"unknown";case 1:return I==="x64"?"darwin-x64":I==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function D(u,I){return I==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function C(u,I,p){return D(I,p)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===p?!0:m(p).includes(u)}e.isTargetPlatformCompatible=C;function m(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=P;var v;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(v||(e.SortBy=v={}));var S;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var f;(function(u){u.Install="install",u.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.IExtensionGalleryService=(0,U.createDecorator)("extensionGalleryService");var w;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var a;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class h extends Error{constructor(I,p){super(I),this.code=p,this.name=p}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,U.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,U.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,U.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,k.localize)(1,null),original:"Preferences"}}),define(oe[181],ae([0,1,3,2,31,12,91,28]),function(ne,e,k,U,A,N,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(a,h){return a?N.URI.revive(h?h.transformIncoming(a):a):void 0}function m(a,h){return h?h.transformOutgoingURI(a):a}function P(a,h){h=h||T.DefaultURITransformer;const u=a.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...a,manifest:void 0},h),manifest:u}}function v(a,h){return a?.profileLocation?(0,T.transformAndReviveIncomingURIs)(a,h??T.DefaultURITransformer):a}function S(a,h){return h?(0,A.cloneAndChange)(a,u=>u instanceof N.URI?h.transformOutgoingURI(u):void 0):a}class f{constructor(h,u){this.a=h,this.b=u,this.onInstallExtension=k.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=k.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,u){const I=this.b(h);switch(u){case"onInstallExtension":return k.Event.map(this.onInstallExtension,p=>({...p,profileLocation:p.profileLocation?m(p.profileLocation,I):p.profileLocation}));case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,p=>p.map(L=>({...L,local:L.local?S(L.local,I):L.local,profileLocation:L.profileLocation?m(L.profileLocation,I):L.profileLocation})));case"onUninstallExtension":return k.Event.map(this.onUninstallExtension,p=>({...p,profileLocation:p.profileLocation?m(p.profileLocation,I):p.profileLocation}));case"onDidUninstallExtension":return k.Event.map(this.onDidUninstallExtension,p=>({...p,profileLocation:p.profileLocation?m(p.profileLocation,I):p.profileLocation}));case"onDidUpdateExtensionMetadata":return k.Event.map(this.onDidUpdateExtensionMetadata,p=>S(p,I))}throw new Error("Invalid listen")}async call(h,u,I){const p=this.b(h);switch(u){case"zip":{const L=P(I[0],p),n=await this.a.zip(L);return m(n,p)}case"unzip":return this.a.unzip(C(I[0],p));case"install":return this.a.install(C(I[0],p),v(I[1],p));case"installFromLocation":return this.a.installFromLocation(C(I[0],p),C(I[1],p));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(I[0],C(I[1],p),C(I[2],p));case"getManifest":return this.a.getManifest(C(I[0],p));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(I[0]);case"installFromGallery":return this.a.installFromGallery(I[0],v(I[1],p));case"uninstall":return this.a.uninstall(P(I[0],p),v(I[1],p));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(I[0],p));case"getInstalled":return(await this.a.getInstalled(I[0],C(I[1],p))).map(n=>S(n,p));case"copyExtensions":return this.a.copyExtensions(C(I[0],p),C(I[1],p));case"updateMetadata":{const L=await this.a.updateMetadata(P(I[0],p),I[1],C(I[2],p));return S(L,p)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(I[0],I[1],I[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class d extends U.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.k=h,this.c=this.B(new k.Emitter),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=this.B(new k.Emitter),this.j=this.B(new k.Emitter),this.B(this.k.listen("onInstallExtension")(u=>this.l(this.c,{...u,source:this.m(u.source)?N.URI.revive(u.source):u.source,profileLocation:N.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(u=>this.l(this.f,u.map(I=>({...I,local:I.local?P(I.local,null):I.local,source:this.m(I.source)?N.URI.revive(I.source):I.source,profileLocation:N.URI.revive(I.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(u=>this.l(this.g,{...u,profileLocation:N.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(u=>this.l(this.h,{...u,profileLocation:N.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(P(u,null))))}l(h,u){h.fire(u)}m(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(h){const u=await this.getTargetPlatform();return h.allTargetPlatforms.some(I=>(0,D.isTargetPlatformCompatible)(I,h.allTargetPlatforms,u))}zip(h){return Promise.resolve(this.k.call("zip",[h]).then(u=>N.URI.revive(u)))}unzip(h){return Promise.resolve(this.k.call("unzip",[h]))}install(h,u){return Promise.resolve(this.k.call("install",[h,u])).then(I=>P(I,null))}installFromLocation(h,u){return Promise.resolve(this.k.call("installFromLocation",[h,u])).then(I=>P(I,null))}async installExtensionsFromProfile(h,u,I){return(await this.k.call("installExtensionsFromProfile",[h,u,I])).map(L=>P(L,null))}getManifest(h){return Promise.resolve(this.k.call("getManifest",[h]))}installFromGallery(h,u){return Promise.resolve(this.k.call("installFromGallery",[h,u])).then(I=>P(I,null))}uninstall(h,u){return Promise.resolve(this.k.call("uninstall",[h,u]))}reinstallFromGallery(h){return Promise.resolve(this.k.call("reinstallFromGallery",[h])).then(u=>P(u,null))}getInstalled(h=null,u){return Promise.resolve(this.k.call("getInstalled",[h,u])).then(I=>I.map(p=>P(p,null)))}updateMetadata(h,u,I){return Promise.resolve(this.k.call("updateMetadata",[h,u,I])).then(p=>P(p,null))}copyExtensions(h,u){return this.k.call("copyExtensions",[h,u])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(h,u,I){const p=await this.k.call("download",[h,u,I]);return N.URI.revive(p)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class w{constructor(h){this.a=h}listen(h,u){throw new Error("Invalid listen")}call(h,u,I){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(N.URI.revive(I[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=w}),define(oe[97],ae([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");class U{b(){return this.a||(this.a=new Promise((N,T)=>ne(["node-vsce-sign"],async D=>N(D),T))),this.a}async verify(N,T,D){let C;try{C=await this.b()}catch{return!1}return C.verify(N,T,D)}}e.ExtensionSignatureVerificationService=U}),define(oe[98],ae([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var U;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(U||(e.RecommendationSource=U={}));function A(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=A;var N;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(N||(e.RecommendationsNotificationResult=N={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[13],ae([0,1,47,15,27,10,12,153,4,5,25]),function(ne,e,k,U,A,N,T,D,C,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function v(j){return j.create===!0}e.isFileOpenForWriteOptions=v;var S;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var f;(function(j){j[j.Readonly=1]="Readonly",j[j.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var d;(function(j){j[j.None=0]="None",j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileAtomicWrite=32768]="FileAtomicWrite",j[j.FileAtomicDelete=65536]="FileAtomicDelete",j[j.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function w(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=w;function a(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=a;function h(j){return!!(j.capabilities&131072)}e.hasFileCloneCapability=h;function u(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function I(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=I;function p(j){return w(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;function L(j){return w(j)?!!(j.capabilities&32768):!1}e.hasFileAtomicWriteCapability=L;function n(j){return!!(j.capabilities&65536)}e.hasFileAtomicDeleteCapability=n;var r;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsStorageQuota="EntryExceedsStorageQuota",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class t extends Error{static create(Z,ie){const se=new t(Z.toString(),ie);return o(se,ie),se}constructor(Z,ie){super(Z),this.code=ie}}e.FileSystemProviderError=t;function i(j,Z){return t.create(j,Z)}e.createFileSystemProviderError=i;function s(j){return j||i((0,D.localize)(0,null),r.Unknown)}e.ensureFileSystemProviderError=s;function o(j,Z){return j.name=Z?`${Z} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=o;function l(j){if(!j)return r.Unknown;if(j instanceof t)return j.code;const Z=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!Z)return r.Unknown;switch(Z[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.toFileSystemProviderErrorCode=l;function E(j){if(j instanceof F)return j.fileOperationResult;switch(l(j)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=E;var y;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(y||(e.FileOperation=y={}));class c{constructor(Z,ie,se){this.resource=Z,this.operation=ie,this.target=se}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=c;var b;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(b||(e.FileChangeType=b={}));class R{constructor(Z,ie){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const K of Z){const _=se.get(K.type);switch(_?_.push([K.resource,K]):se.set(K.type,[[K.resource,K]]),K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}}for(const[K,_]of se)switch(K){case 1:this.a=k.TernarySearchTree.forUris(()=>ie),this.a.fill(_);break;case 0:this.b=k.TernarySearchTree.forUris(()=>ie),this.b.fill(_);break;case 2:this.c=k.TernarySearchTree.forUris(()=>ie),this.c.fill(_);break}}contains(Z,...ie){return this.d(Z,{includeChildren:!1},...ie)}affects(Z,...ie){return this.d(Z,{includeChildren:!0},...ie)}d(Z,ie,...se){if(!Z)return!1;const K=se.length>0;return!!((!K||se.includes(1))&&(this.a?.get(Z)||ie.includeChildren&&this.a?.findSuperstr(Z))||(!K||se.includes(0))&&(this.b?.get(Z)||ie.includeChildren&&this.b?.findSuperstr(Z))||(!K||se.includes(2))&&(this.c?.findSubstr(Z)||ie.includeChildren&&this.c?.findSuperstr(Z)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=R;function M(j,Z,ie){return!j||!Z||j===Z||Z.length>j.length?!1:(Z.charAt(Z.length-1)!==U.sep&&(Z+=U.sep),ie?(0,A.startsWithIgnoreCase)(j,Z):j.indexOf(Z)===0)}e.isParent=M;class F extends Error{constructor(Z,ie,se){super(Z),this.fileOperationResult=ie,this.options=se}}e.FileOperationError=F;class H extends F{constructor(Z,ie,se,K){super(Z,ie,K),this.fileOperationResult=ie,this.size=se}}e.TooLargeFileOperationError=H;class q extends F{constructor(Z,ie,se){super(Z,2,se),this.stat=ie}}e.NotModifiedSinceFileOperationError=q;var V;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Q;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.ETAG_DISABLED="";function te(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=te;async function Y(j,Z){if(!Z.hasProvider(T.URI.from({scheme:j.scheme})))return new Promise(ie=>{const se=Z.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===j.scheme&&K.added&&(se.dispose(),ie())})})}e.whenProviderRegistered=Y;class x{static formatSize(Z){return(0,N.isNumber)(Z)||(Z=0),Z<x.KB?(0,D.localize)(1,null,Z.toFixed(0)):Z<x.MB?(0,D.localize)(2,null,(Z/x.KB).toFixed(2)):Z<x.GB?(0,D.localize)(3,null,(Z/x.MB).toFixed(2)):Z<x.TB?(0,D.localize)(4,null,(Z/x.GB).toFixed(2)):(0,D.localize)(5,null,(Z/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;function G(j){const Z=typeof j=="string"||j?.scheme===P.Schemas.vscodeRemote;return typeof j!="string"&&j?.scheme===P.Schemas.file?1024*x.MB:Z?10*x.MB:m.isWeb?50*x.MB:1024*x.MB}e.getLargeFileConfirmationLimit=G});var X=this&&this.__param||function(ne,e){return function(k,U){e(k,U,ne)}};define(oe[182],ae([0,1,69,42,13]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let N=e.ChecksumService=class{constructor(D){this.a=D}async checksum(D){const C=(await this.a.readFileStream(D)).value;return new Promise((m,P)=>{const v=(0,k.createHash)("md5");(0,U.listenStream)(C,{onData:S=>v.update(S.buffer),onError:S=>P(S),onEnd:()=>m(v.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=N=ve([X(0,A.IFileService)],N)}),define(oe[183],ae([0,1,16,38,7,3,2,42,12,32,13]),function(ne,e,k,U,A,N,T,D,C,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class v extends T.Disposable{constructor(f,d){super(),this.a=f,this.b=d,this.onDidChangeCapabilities=N.Event.None,this.f=this.B(new N.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new N.Emitter),this.onDidWatchError=this.g.event,this.h=(0,m.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,d){const{buffer:w}=await this.a.call("readFile",[f,d]);return w}readFileStream(f,d,w){const a=(0,D.newWriteableStream)(u=>k.VSBuffer.concat(u.map(I=>k.VSBuffer.wrap(I))).buffer),h=this.a.listen("readFileStream",[f,d])(u=>{if(u instanceof k.VSBuffer)a.write(u.buffer);else{if(u==="end")a.end();else{let I;if(u instanceof Error)I=u;else{const p=u;I=(0,P.createFileSystemProviderError)(p.message??(0,U.toErrorMessage)(p),p.code??P.FileSystemProviderErrorCode.Unknown)}a.error(I),a.end()}h.dispose()}});return w.onCancellationRequested(()=>{a.error((0,A.canceled)()),a.end(),h.dispose()}),a}writeFile(f,d,w){return this.a.call("writeFile",[f,k.VSBuffer.wrap(d),w])}open(f,d){return this.a.call("open",[f,d])}close(f){return this.a.call("close",[f])}async read(f,d,w,a,h){const[u,I]=await this.a.call("read",[f,d,h]);return w.set(u.buffer.slice(0,I),a),I}write(f,d,w,a,h){return this.a.call("write",[f,d,k.VSBuffer.wrap(w),a,h])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,d){return this.a.call("delete",[f,d])}rename(f,d,w){return this.a.call("rename",[f,d,w])}copy(f,d,w){return this.a.call("copy",[f,d,w])}cloneFile(f,d){return this.a.call("cloneFile",[f,d])}i(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const d=f;this.f.fire(d.map(w=>({resource:C.URI.revive(w.resource),type:w.type})))}else{const d=f;this.g.fire(d)}}))}watch(f,d){const w=(0,m.generateUuid)();return this.a.call("watch",[this.h,w,f,d]),(0,T.toDisposable)(()=>this.a.call("unwatch",[this.h,w]))}}e.DiskFileSystemProviderClient=v}),define(oe[99],ae([0,1,16,7,154,13]),function(ne,e,k,U,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(P,v,S,f,d,w){let a;try{await D(P,v,S,f,d,w)}catch(h){a=h}finally{a&&d.errorTransformer&&(a=d.errorTransformer(a)),typeof a<"u"&&S.error(a),S.end()}}e.readFileIntoStream=T;async function D(P,v,S,f,d,w){C(w);const a=await P.open(v,{create:!1});try{C(w);let h=0,u=0,I=d&&typeof d.length=="number"?d.length:void 0,p=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof I=="number"?I:d.bufferSize)),L=d&&typeof d.position=="number"?d.position:0,n=0;do u=await P.read(a,L,p.buffer,n,p.byteLength-n),L+=u,n+=u,h+=u,typeof I=="number"&&(I-=u),n===p.byteLength&&(await S.write(f(p)),p=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof I=="number"?I:d.bufferSize)),n=0);while(u>0&&(typeof I!="number"||I>0)&&C(w)&&m(h,d));if(n>0){let r=n;typeof I=="number"&&(r=Math.min(n,I)),S.write(f(p.slice(0,r)))}}catch(h){throw(0,N.ensureFileSystemProviderError)(h)}finally{await P.close(a)}}function C(P){if(P.isCancellationRequested)throw(0,U.canceled)();return!0}function m(P,v){if(typeof v?.limits?.size=="number"&&P>v.limits.size)throw(0,N.createFileSystemProviderError)((0,A.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[53],ae([0,1,90,2,15,5,12,13]),function(ne,e,k,U,A,N,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function C(h){return h.recursive===!0}e.isRecursiveWatchRequest=C;class m extends U.Disposable{constructor(u,I,p,L){super(),this.h=u,this.i=I,this.j=p,this.k=L,this.c=this.B(new U.MutableDisposable),this.f=void 0,this.g=0}m(){const u=new U.DisposableStore;this.c.value=u,this.b=this.l(u),this.b.setVerboseLogging(this.j),u.add(this.b.onDidChangeFile(I=>this.h(I))),u.add(this.b.onDidLogMessage(I=>this.i(I))),u.add(this.b.onDidError(I=>this.n(I)))}n(u){this.k.restartOnError?this.g<m.a&&this.f?(this.r(`restarting watcher after error: ${u}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${u}`):this.r(u)}p(u){this.g++,this.m(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.j=u,await this.b?.setVerboseLogging(u)}r(u){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${u}`})}s(u){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.a=5;class P extends m{constructor(u,I,p){super(u,I,p,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class v extends m{constructor(u,I,p){super(u,I,p,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function S(h){return h.map(u=>({type:u.type,resource:T.URI.file(u.path)}))}e.toFileChanges=S;function f(h){const u=new a;for(const I of h)u.processEvent(I);return u.coalesce()}e.coalesceEvents=f;function d(h,u){return typeof u=="string"&&!u.startsWith(k.GLOBSTAR)&&!(0,A.isAbsolute)(u)?{base:h,pattern:u}:u}e.normalizeWatcherPattern=d;function w(h,u){const I=[];for(const p of u)I.push((0,k.parse)(d(h,p)));return I}e.parseWatcherPatterns=w;class a{constructor(){this.a=new Set,this.b=new Map}c(u){return N.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const I=this.b.get(this.c(u));let p=!1;if(I){const L=I.type,n=u.type;I.path!==u.path&&(u.type===2||u.type===1)?p=!0:L===1&&n===2?(this.b.delete(this.c(u)),this.a.delete(I)):L===2&&n===1?I.type=0:L===1&&n===0||(I.type=n)}else p=!0;p&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],I=[];return Array.from(this.a).filter(p=>p.type!==2?(u.push(p),!1):!0).sort((p,L)=>p.path.length-L.path.length).filter(p=>I.some(L=>(0,D.isParent)(p.path,L,!N.isLinux))?!1:(I.push(p.path),!0)).concat(u)}}}),define(oe[184],ae([0,1,51,6,26,46,2,86,15,5,137,30,53]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends T.Disposable{constructor(a,h,u,I){super(),this.j=a,this.k=h,this.l=u,this.m=I,this.c=this.B(new U.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},p=>this.k(p))),this.f=this.B(new U.RunOnceWorker(p=>this.u(p),f.b)),this.g=(0,S.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,S.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new A.CancellationTokenSource,this.ready=this.n()}async n(){try{const a=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const h=await v.Promises.stat(a);this.B(await this.s(a,h.isDirectory()))}catch(a){a.code!=="ENOENT"?this.w(a):this.z(a)}}async r(a){let h=a.path;try{h=await v.Promises.realpath(a.path),a.path===h&&(h=await(0,P.realcase)(a.path)??a.path),a.path!==h&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${h})`)}catch{}return h}async s(a,h){if(m.isMacintosh&&(0,N.isEqualOrParent)(a,"/Volumes/",!0))return this.w(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const u=new A.CancellationTokenSource(this.i.token),I=new T.DisposableStore;try{const p=(0,C.basename)(a),L=(0,k.watch)(a);I.add((0,T.toDisposable)(()=>{L.removeAllListeners(),L.close()})),this.z(`Started watching: '${a}'`);const n=new Set;if(h)try{for(const t of await v.Promises.readdir(a))n.add(t)}catch(t){this.w(t)}const r=new Map;I.add((0,T.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),L.on("error",(t,i)=>{this.w(`Failed to watch ${a} for changes using fs.watch() (${t}, ${i})`),this.dispose()}),L.on("change",(t,i)=>{if(u.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${i}`);let s="";if(i&&(s=i.toString(),m.isMacintosh&&(s=(0,D.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(h)if(t==="rename"){r.get(s)?.dispose();const o=setTimeout(async()=>{if(r.delete(s),s===p&&!await v.Promises.exists(a)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.v((0,C.join)(a,s));if(u.token.isCancellationRequested)return;let E;l?n.has(s)?E=0:(E=1,n.add(s)):(n.delete(s),E=2),this.t({path:(0,C.join)(this.j.path,s),type:E})},f.a);r.set(s,(0,T.toDisposable)(()=>clearTimeout(o)))}else{let o;n.has(s)?o=0:(o=1,n.add(s)),this.t({path:(0,C.join)(this.j.path,s),type:o})}else if(t==="rename"||s!==p){const o=setTimeout(async()=>{const l=await v.Promises.exists(a);u.token.isCancellationRequested||(l?(this.t({path:this.j.path,type:0},!0),I.add(await this.s(a,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);I.clear(),I.add((0,T.toDisposable)(()=>clearTimeout(o)))}else this.t({path:this.j.path,type:0},!0)})}catch(p){await v.Promises.exists(a)&&!u.token.isCancellationRequested&&this.w(`Failed to watch ${a} for changes using fs.watch() (${p.toString()})`)}return(0,T.toDisposable)(()=>{u.dispose(!0),I.dispose()})}t(a,h=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!h&&this.g.some(u=>u(a.path))?this.m&&this.z(` >> ignored (excluded) ${a.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(u=>u(a.path))?this.m&&this.z(` >> ignored (not included) ${a.path}`):this.f.work(a))}u(a){const h=(0,S.coalesceEvents)(a);if(h.length>0){if(this.m)for(const I of h)this.z(`>> normalized ${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`);this.c.work(h)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(a){if(m.isLinux)return v.Promises.exists(a);try{const h=(0,C.basename)(a);return(await v.Promises.readdir((0,C.dirname)(a))).some(I=>I===h)}catch(h){return this.z(h),!1}}setVerboseLogging(a){this.m=a}w(a){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}y(a){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}z(a){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.a=100,f.b=75;async function d(w,a,h,u,I=512){const p=await v.Promises.open(w,"r"),L=Buffer.allocUnsafe(I),n=new A.CancellationTokenSource(u);let r,t=!1;const i={path:w,excludes:[],recursive:!1},s=new f(i,o=>{(async()=>{for(const{type:l}of o)if(l===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:E}=await v.Promises.read(p,L,0,I,null);if(!E||n.token.isCancellationRequested)break;a(L.slice(0,E))}}catch(E){r=new Error(E),n.dispose(!0)}finally{t=!1}}})()});return await s.ready,h(),new Promise((o,l)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await v.Promises.close(p)}catch(E){r=new Error(E)}r?l(r):o()})})}e.watchFileContents=d}),define(oe[185],ae([0,1,3,90,2,5,184]),function(ne,e,k,U,A,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class D extends A.Disposable{constructor(){super(...arguments),this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new k.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=k.Event.None,this.c=new Map,this.f=!1}async watch(m){const P=this.i(m),v=P.filter(f=>{const d=this.c.get(f.path);return d?!(0,U.patternsEquals)(d.request.excludes,f.excludes)||!(0,U.patternsEquals)(d.request.includes,f.includes):!0}),S=Array.from(this.c.values()).filter(({request:f})=>!P.find(d=>d.path===f.path&&(0,U.patternsEquals)(d.excludes,f.excludes)&&(0,U.patternsEquals)(d.includes,f.includes))).map(({request:f})=>f.path);v.length&&this.j(`Request to start watching: ${v.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),S.length&&this.j(`Request to stop watching: ${S.join(",")}`);for(const f of S)this.h(f);for(const f of v)this.g(f)}g(m){const P=new T.NodeJSFileWatcherLibrary(m,S=>this.a.fire(S),S=>this.b.fire(S),this.f),v={request:m,instance:P};this.c.set(m.path,v)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const P=this.c.get(m);P&&(this.c.delete(m),P.instance.dispose())}i(m){const P=new Map;for(const v of m){const S=N.isLinux?v.path:v.path.toLowerCase();P.set(S,v)}return Array.from(P.values())}async setVerboseLogging(m){this.f=m;for(const[,P]of this.c)P.instance.setVerboseLogging(m)}j(m){this.f&&this.b.fire({type:"trace",message:this.k(m)})}k(m,P){return P?`[File Watcher (node.js)] ${m} (path: ${P.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=D}),define(oe[186],ae([0,1,53,185]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class A extends k.AbstractNonRecursiveWatcherClient{constructor(T,D,C){super(T,D,C),this.m()}l(){return new U.NodeJSWatcher}}e.NodeJSWatcherClient=A}),define(oe[187],ae([0,1,25,43,93,53]),function(ne,e,k,U,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends N.AbstractUniversalWatcherClient{constructor(C,m,P){super(C,m,P),this.m()}l(C){const m=C.add(new A.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(m.onDidProcessExit(({code:P,signal:v})=>this.n(`terminated by itself with code ${P}, signal: ${v}`))),U.ProxyChannel.toService((0,U.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(oe[70],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...A){this.a=new Map;for(const[N,T]of A)this.set(N,T)}set(A,N){const T=this.a.get(A);return this.a.set(A,N),T}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.ServiceCollection=k}),define(oe[188],ae([0,1,6,7,2,68,179,4,70,85]),function(ne,e,k,U,A,N,T,D,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class v extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class S{constructor(a=new C.ServiceCollection,h=!1,u,I=P){this.f=a,this.g=h,this.h=u,this.i=I,this.o=new Set,this.f.set(D.IInstantiationService,this),this._globalGraph=I?u?._globalGraph??new T.Graph(p=>p):void 0}createChild(a){return new S(a,this.g,this,this.i)}invokeFunction(a,...h){const u=d.traceInvocation(this.i,a);let I=!1;try{return a({get:L=>{if(I)throw(0,U.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(L,u);if(!n)throw new Error(`[invokeFunction] unknown service '${L}'`);return n}},...h)}finally{I=!0,u.stop()}}createInstance(a,...h){let u,I;return a instanceof N.SyncDescriptor?(u=d.traceCreation(this.i,a.ctor),I=this.j(a.ctor,a.staticArguments.concat(h),u)):(u=d.traceCreation(this.i,a),I=this.j(a,h,u)),u.stop(),I}j(a,h=[],u){const I=D._util.getServiceDependencies(a).sort((n,r)=>n.index-r.index),p=[];for(const n of I){const r=this.m(n.id,u);r||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${n.id}.`,!1),p.push(r)}const L=I.length>0?I[0].index:h.length;if(h.length!==L){console.trace(`[createInstance] First service dependency of ${a.name} at position ${L+1} conflicts with ${h.length} static arguments`);const n=L-h.length;n>0?h=h.concat(new Array(n)):h=h.slice(0,L)}return Reflect.construct(a,h.concat(p))}k(a,h){if(this.f.get(a)instanceof N.SyncDescriptor)this.f.set(a,h);else if(this.h)this.h.k(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const h=this.f.get(a);return!h&&this.h?this.h.l(a):h}m(a,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const u=this.l(a);return u instanceof N.SyncDescriptor?this.q(a,u,h.branch(a,!0)):(h.branch(a,!1),u)}q(a,h,u){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,h,u)}finally{this.o.delete(a)}}r(a,h,u){const I=new T.Graph(n=>n.id.toString());let p=0;const L=[{id:a,desc:h,_trace:u}];for(;L.length;){const n=L.pop();if(I.lookupOrInsertNode(n),p++>1e3)throw new v(I);for(const r of D._util.getServiceDependencies(n.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${a} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof N.SyncDescriptor){const i={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};I.insertEdge(n,i),L.push(i)}}}for(;;){const n=I.roots();if(n.length===0){if(!I.isEmpty())throw new v(I);break}for(const{data:r}of n){if(this.l(r.id)instanceof N.SyncDescriptor){const i=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,i)}I.removeNode(r)}}return this.l(a)}s(a,h,u=[],I,p){if(this.f.get(a)instanceof N.SyncDescriptor)return this.t(a,h,u,I,p);if(this.h)return this.h.s(a,h,u,I,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(a,h,u=[],I,p){if(I){const L=new S(void 0,this.g,this,this.i);L.c=String(a);const n=new Map,r=new k.IdleValue(()=>{const t=L.j(h,u,p);for(const[i,s]of n){const o=t[i];if(typeof o=="function")for(const l of s)o.apply(t,l)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!r.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=n.get(i);return l||(l=new m.LinkedList,n.set(i,l)),(y,c,b)=>{const R=l.push([y,c,b]);return(0,A.toDisposable)(R)}}if(i in t)return t[i];const s=r.value;let o=s[i];return typeof o!="function"||(o=o.bind(s),t[i]=o),o},set(t,i,s){return r.value[i]=s,!0},getPrototypeOf(t){return h.prototype}})}else return this.j(h,u,p)}u(a,h){if(h&&console.warn(a),this.g)throw new Error(a)}}e.InstantiationService=S;var f;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(f||(f={}));class d{static traceInvocation(a,h){return a?new d(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(a,h){return a?new d(1,h.name):d.c}constructor(a,h){this.type=a,this.name=h,this.g=Date.now(),this.h=[]}branch(a,h){const u=new d(3,a.toString());return this.h.push([a,h,u]),u}stop(){const a=Date.now()-this.g;d.f+=a;let h=!1;function u(p,L){const n=[],r=new Array(p+1).join("	");for(const[t,i,s]of L.h)if(i&&s){h=!0,n.push(`${r}CREATES -> ${t}`);const o=u(p+1,s);o&&n.push(o)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const I=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(a>2||h)&&d.all.add(I.join(`
`))}}e.Trace=d,d.all=new Set,d.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}},d.f=0}),define(oe[71],ae([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,k.createDecorator)("mainProcessService");class U{constructor(N,T){this.a=N,this.b=T}getChannel(N){return this.a.getChannel(N,this.b)}registerChannel(N,T){this.a.registerChannel(N,T)}}e.MainProcessService=U}),define(oe[72],ae([0,1,26,2,5,156,28,4]),function(ne,e,k,U,A,N,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function C(P){return P.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=C,e.ILanguagePackService=(0,D.createDecorator)("languagePackService");let m=e.LanguagePackBaseService=class extends U.Disposable{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new k.CancellationTokenSource;setTimeout(()=>v.cancel(),1e3);let S;try{S=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const d=S.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some(a=>a.startsWith("lp-"))).map(w=>{const a=w.properties.localizedLanguages?.[0],h=C(w);return{...this.f(h,a,w),extensionId:w.identifier.id,galleryExtension:w}});return d.push(this.f("en","English")),d}f(v,S,f){const d=S??v;let w;if(d!==v&&(w=`(${v})`),v.toLowerCase()===A.language.toLowerCase()&&(w??="",w+=(0,N.localize)(0,null)),f?.installCount){w??="";const a=f.installCount;let h;a>1e6?h=`${Math.floor(a/1e5)/10}M`:a>1e3?h=`${Math.floor(a/1e3)}K`:h=String(a),w+=` $(cloud-download) ${h}`}return{id:v,label:d,description:w}}};e.LanguagePackBaseService=m=ve([X(0,T.IExtensionGalleryService)],m)}),define(oe[189],ae([0,1,2,72]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=e.LocalizationsUpdater=class extends k.Disposable{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};e.LocalizationsUpdater=A=ve([X(0,U.ILanguagePackService)],A)}),define(oe[8],ae([0,1,38,3,63,2,35,5,22,10,12,94,4]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function f(){return new Date().toISOString()}function d(y){return(0,m.isNumber)(y)}e.isLogLevel=d;var w;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function a(y,c,b){switch(c){case w.Trace:y.trace(b);break;case w.Debug:y.debug(b);break;case w.Info:y.info(b);break;case w.Warning:y.warn(b);break;case w.Error:y.error(b);break;case w.Off:break;default:throw new Error(`Invalid log level ${c}`)}}e.log=a;function h(y,c=!1){let b="";for(let R=0;R<y.length;R++){let M=y[R];if(M instanceof Error&&(M=(0,k.toErrorMessage)(M,c)),typeof M=="object")try{M=JSON.stringify(M)}catch{}b+=(R>0?" ":"")+M}return b}class u extends N.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new U.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(c){this.b!==c&&(this.b=c,this.c.fire(this.b))}getLevel(){return this.b}f(c){return this.b!==w.Off&&this.b<=c}}e.AbstractLogger=u;class I extends u{constructor(c){super(),this.h=c}f(c){return this.h||super.f(c)}trace(c,...b){this.f(w.Trace)&&this.g(w.Trace,h([c,...b],!0))}debug(c,...b){this.f(w.Debug)&&this.g(w.Debug,h([c,...b]))}info(c,...b){this.f(w.Info)&&this.g(w.Info,h([c,...b]))}warn(c,...b){this.f(w.Warning)&&this.g(w.Warning,h([c,...b]))}error(c,...b){if(this.f(w.Error))if(c instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=c.stack,this.g(w.Error,h(R))}else this.g(w.Error,h([c,...b]))}flush(){}}e.AbstractMessageLogger=I;class p extends u{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c),this.g=!D.isWindows}trace(c,...b){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,c,...b):console.log(`[main ${f()}]`,c,...b))}debug(c,...b){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,c,...b):console.log(`[main ${f()}]`,c,...b))}info(c,...b){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,c,...b):console.log(`[main ${f()}]`,c,...b))}warn(c,...b){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,c,...b):console.warn(`[main ${f()}]`,c,...b))}error(c,...b){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,c,...b):console.error(`[main ${f()}]`,c,...b))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class L extends u{constructor(c=e.DEFAULT_LOG_LEVEL,b=!0){super(),this.g=b,this.setLevel(c)}trace(c,...b){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",c,...b):console.log(c,...b))}debug(c,...b){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",c,...b):console.log(c,...b))}info(c,...b){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",c,...b):console.log(c,...b))}warn(c,...b){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",c,...b):console.log(c,...b))}error(c,...b){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",c,...b):console.error(c,...b))}dispose(){}flush(){}}e.ConsoleLogger=L;class n extends u{constructor(c,b=e.DEFAULT_LOG_LEVEL){super(),this.g=c,this.setLevel(b)}trace(c,...b){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(c),...b])}debug(c,...b){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(c),...b])}info(c,...b){this.f(w.Info)&&this.g.log(w.Info,[this.h(c),...b])}warn(c,...b){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(c),...b])}error(c,...b){this.f(w.Error)&&this.g.log(w.Error,[this.h(c),...b])}h(c){return typeof c=="string"?c:(0,k.toErrorMessage)(c,this.f(w.Trace))}dispose(){}flush(){}}e.AdapterLogger=n;class r extends u{constructor(c){super(),this.g=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const b of this.g)b.setLevel(c);super.setLevel(c)}trace(c,...b){for(const R of this.g)R.trace(c,...b)}debug(c,...b){for(const R of this.g)R.debug(c,...b)}info(c,...b){for(const R of this.g)R.info(c,...b)}warn(c,...b){for(const R of this.g)R.warn(c,...b)}error(c,...b){for(const R of this.g)R.error(c,...b)}flush(){for(const c of this.g)c.flush()}dispose(){for(const c of this.g)c.dispose()}}e.MultiplexLogger=r;class t extends N.Disposable{constructor(c,b,R){if(super(),this.h=c,this.j=b,this.b=new T.ResourceMap,this.c=this.B(new U.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new U.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new U.Emitter),this.onDidChangeVisibility=this.g.event,R)for(const M of R)this.b.set(M.resource,{logger:void 0,info:M})}k(c){return(0,m.isString)(c)?[...this.b.values()].find(b=>b.info.id===c):this.b.get(c)}getLogger(c){return this.k(c)?.logger}createLogger(c,b){const R=this.l(c),M=(0,m.isString)(c)?c:b?.id??(0,A.hash)(R.toString()).toString(16);let F=this.b.get(R)?.logger;const H=b?.logLevel==="always"?w.Trace:b?.logLevel;F||(F=this.m(R,H??this.getLogLevel(R)??this.h,{...b,id:M}));const q={logger:F,info:{resource:R,id:M,logLevel:H,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(q.info),this.b.set(R,q),F}l(c){return(0,m.isString)(c)?(0,C.joinPath)(this.j,`${c}.log`):c}setLogLevel(c,b){if(P.URI.isUri(c)){const R=c,M=b,F=this.b.get(R);F&&M!==F.info.logLevel&&(F.info.logLevel=M===this.h?void 0:M,F.logger?.setLevel(M),this.b.set(F.info.resource,F),this.f.fire([R,M]))}else{this.h=c;for(const[R,M]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(c,b){const R=this.k(c);R&&b!==!R.info.hidden&&(R.info.hidden=!b,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,b]))}getLogLevel(c){let b;return c&&(b=this.b.get(c)?.info.logLevel),b??this.h}registerLogger(c){const b=this.b.get(c.resource);b?b.info.hidden!==c.hidden&&this.setVisibility(c.resource,!c.hidden):(this.b.set(c.resource,{info:c,logger:void 0}),this.c.fire({added:[c],removed:[]}))}deregisterLogger(c){const b=this.b.get(c);b&&(b.logger&&b.logger.dispose(),this.b.delete(c),this.c.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const c of this.b.values())yield c.info}getRegisteredLogger(c){return this.b.get(c)?.info}dispose(){this.b.forEach(c=>c.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=t;class i{constructor(){this.onDidChangeLogLevel=new U.Emitter().event}setLevel(c){}getLevel(){return w.Info}trace(c,...b){}debug(c,...b){}info(c,...b){}warn(c,...b){}error(c,...b){}critical(c,...b){}dispose(){}flush(){}}e.NullLogger=i;class s extends i{}e.NullLogService=s;function o(y){if(y.verbose)return w.Trace;if(typeof y.logLevel=="string"){const c=E(y.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function l(y){switch(y){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.LogLevelToString=l;function E(y){switch(y){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.parseLogLevel=E,e.CONTEXT_LOG_LEVEL=new v.RawContextKey("logLevel",l(w.Info))}),define(oe[190],ae([0,1,6,7,2,22,30,14,8]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let m=e.LogsDataCleaner=class extends A.Disposable{constructor(v,S){super(),this.a=v,this.b=S,this.B(new k.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const v=(0,N.basename)(this.a.logsHome),S=(0,N.dirname)(this.a.logsHome),w=(await T.Promises.readdir(S.fsPath)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==v),a=w.slice(0,Math.max(0,w.length-9));a.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${a.join(", ")}'`),await Promise.all(a.map(h=>T.Promises.rm((0,N.joinPath)(S,h).fsPath))))}catch(v){(0,U.onUnexpectedError)(v)}}};e.LogsDataCleaner=m=ve([X(0,D.IEnvironmentService),X(1,C.ILogService)],m)}),define(oe[191],ae([0,1,21,6,7,3,2,15,53,8]),function(ne,e,k,U,A,N,T,D,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends T.Disposable{constructor(S,f){super(),this.a=S,this.b=f,this.c=this.B(new N.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new N.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new U.ThrottledDelayer(0)),this.s=[],this.t=this.B(new U.ThrottledDelayer(0))}watch(S,f){return f.recursive||this.b?.watcher?.forceUniversal?this.l(S,f):this.u(S,f)}l(S,f){const d={path:this.C(S),excludes:f.excludes,includes:f.includes,recursive:f.recursive},w=(0,k.insert)(this.j,d);return this.m(),(0,T.toDisposable)(()=>{w(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(S=>(0,A.onUnexpectedError)(S))}n(){this.h||(this.h=this.B(this.p(f=>this.c.fire((0,C.toFileChanges)(f)),f=>this.z(f),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const S=this.b?.watcher?.recursive?.usePolling;if(S===!0)for(const f of this.j)(0,C.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const f of this.j)(0,C.isRecursiveWatchRequest)(f)&&S.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(S,f){const d={path:this.C(S),excludes:f.excludes,includes:f.includes,recursive:!1},w=(0,k.insert)(this.s,d);return this.v(),(0,T.toDisposable)(()=>{w(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(S=>(0,A.onUnexpectedError)(S))}w(){return this.r||(this.r=this.B(this.y(S=>this.c.fire((0,C.toFileChanges)(S)),S=>this.z(S),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.r.watch(this.s)}z(S){S.type==="error"&&this.g.fire(S.message),this.a[S.type](S.message)}C(S){return(0,D.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(oe[192],ae([0,1,21,6,16,26,3,63,60,2,47,25,100,22,42,152,13,99,8,7]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=e.FileService=class extends m.Disposable{constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new T.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new T.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new T.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new U.ResourceQueue)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${n}`);const t=new m.DisposableStore;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),t.add(r.onDidChangeFile(i=>this.R.fire(new a.FileChangesEvent(i,!this.O(r))))),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(i=>this.S.fire(new Error(i)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,m.toDisposable)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,m.dispose)(t)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(t){r.push(t)}}),!this.h.has(n)&&await U.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const t=this.h.get(n.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return C.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,f.isAbsolutePath)(n))throw new a.FileOperationError((0,w.localize)(0,null,this.ob(n)),8);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const t=new I.ErrorNoTelemetry;throw t.message=(0,w.localize)(1,null,n.toString()),t}return r}async k(n){const r=await this.j(n);if((0,a.hasOpenReadWriteCloseCapability)(r)||(0,a.hasReadWriteCapability)(r)||(0,a.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(n){const r=await this.j(n);if((0,a.hasOpenReadWriteCloseCapability)(r)||(0,a.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.n(n,r)}catch(t){throw(0,a.toFileSystemProviderErrorCode)(t)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,w.localize)(2,null,this.ob(n)),1):(0,a.ensureFileSystemProviderError)(t)}}async n(n,r){const t=await this.j(n),i=this.O(t),s=r?.resolveTo,o=r?.resolveSingleChildDescendants,l=r?.resolveMetadata,E=await t.stat(n);let y;return this.p(t,n,E,void 0,!!l,(c,b)=>(y||(y=P.TernarySearchTree.forUris(()=>!i),y.set(n,!0),s&&y.fill(!0,s)),y.get(c.resource)||y.findSuperstr(c.resource.with({query:null,fragment:null}))?!0:c.isDirectory&&o?b===1:!1))}async p(n,r,t,i,s,o){const{providerExtUri:l}=this.N(n),E={resource:r,name:l.basename(r),isFile:(t.type&a.FileType.File)!==0,isDirectory:(t.type&a.FileType.Directory)!==0,isSymbolicLink:(t.type&a.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&a.FilePermission.Readonly)||!!(n.capabilities&2048),locked:!!((t.permissions??0)&a.FilePermission.Locked),etag:(0,a.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(E.isDirectory&&o(E,i)){try{const y=await n.readdir(r),c=await U.Promises.settled(y.map(async([b,R])=>{try{const M=l.joinPath(r,b),F=s?await n.stat(M):{type:R};return await this.p(n,M,F,y.length,s,o)}catch(M){return this.b.trace(M),null}}));E.children=(0,k.coalesce)(c)}catch(y){this.b.trace(y),E.children=[]}return E}return E}async resolveAll(n){return U.Promises.settled(n.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),t=await r.stat(n);return this.p(r,n,t,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.r(n,r)}catch(t){return t}return!0}async r(n,r){if(!r?.overwrite&&await this.exists(n))throw new a.FileOperationError((0,w.localize)(3,null,this.ob(n)),3,r)}async createFile(n,r=A.VSBuffer.fromString(""),t){await this.r(n,t);const i=await this.writeFile(n,r);return this.m.fire(new a.FileOperationEvent(n,0,i)),i}async writeFile(n,r,t){const i=this.mb(await this.l(n),n),{providerExtUri:s}=this.N(i);try{await this.s(i,n,t)||await this.P(i,s.dirname(n));let l;if((0,a.hasReadWriteCapability)(i)&&!(r instanceof A.VSBuffer))if((0,d.isReadableStream)(r)){const E=await(0,d.peekStream)(r,3);E.ended?l=A.VSBuffer.concat(E.buffer):l=E}else l=(0,d.peekReadable)(r,E=>A.VSBuffer.concat(E),3);else l=r;if(!(0,a.hasOpenReadWriteCloseCapability)(i)||(0,a.hasReadWriteCapability)(i)&&l instanceof A.VSBuffer)await this.db(i,n,t,l);else{const E=l instanceof A.VSBuffer?(0,A.bufferToReadable)(l):l;t?.atomic!==!1&&t?.atomic?.postfix?await this.Y(i,n,(0,f.joinPath)((0,f.dirname)(n),`${(0,f.basename)(n)}${t.atomic.postfix}`),t,E):await this.Z(i,n,t,E)}this.m.fire(new a.FileOperationEvent(n,4))}catch(o){throw new a.FileOperationError((0,w.localize)(4,null,this.ob(n),(0,a.ensureFileSystemProviderError)(o).toString()),(0,a.toFileOperationResult)(o),t)}return this.resolve(n,{resolveMetadata:!0})}async s(n,r,t){const i=!!t?.unlock;if(i&&!(n.capabilities&8192))throw new Error((0,w.localize)(5,null,this.ob(r)));if(!!t?.atomic){if(!(n.capabilities&32768))throw new Error((0,w.localize)(6,null,this.ob(r)));if(i)throw new Error((0,w.localize)(7,null,this.ob(r)))}let o;try{o=await n.stat(r)}catch{return}if(o.type&a.FileType.Directory)throw new a.FileOperationError((0,w.localize)(8,null,this.ob(r)),0,t);if(this.nb(r,o),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==a.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,a.etag)({mtime:t.mtime,size:o.size}))throw new a.FileOperationError((0,w.localize)(9,null),3,t);return o}async readFile(n,r,t){const i=await this.k(n);return r?.atomic?this.t(i,n,r,t):this.u(i,n,r,t)}async t(n,r,t,i){return new Promise((s,o)=>{this.X.queueFor(r,this.N(n).providerExtUri).queue(async()=>{try{const l=await this.u(n,r,t,i);s(l)}catch(l){o(l)}})})}async u(n,r,t,i){const s=await this.v(n,r,{...t,preferUnbuffered:!0},i);return{...s,value:await(0,A.streamToBuffer)(s.value)}}async readFileStream(n,r,t){const i=await this.k(n);return this.v(i,n,r,t)}async v(n,r,t,i){const s=new N.CancellationTokenSource(i),o=this.F(r,t).then(E=>E,E=>{throw s.cancel(),E});let l;try{return typeof t?.etag=="string"&&t.etag!==a.ETAG_DISABLED&&await o,t?.atomic&&(0,a.hasFileAtomicReadCapability)(n)||!((0,a.hasOpenReadWriteCloseCapability)(n)||(0,a.hasFileReadStreamCapability)(n))||(0,a.hasReadWriteCapability)(n)&&t?.preferUnbuffered?l=this.D(n,r,t):(0,a.hasFileReadStreamCapability)(n)?l=this.z(n,r,s.token,t):l=this.C(n,r,s.token,t),{...await o,value:l}}catch(E){throw l&&await(0,d.consumeStream)(l),this.w(E,r,t)}}w(n,r,t){const i=(0,w.localize)(10,null,this.ob(r),(0,a.ensureFileSystemProviderError)(n).toString());return n instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(i,n.stat,t):n instanceof a.TooLargeFileOperationError?new a.TooLargeFileOperationError(i,n.fileOperationResult,n.size,n.options):new a.FileOperationError(i,(0,a.toFileOperationResult)(n),t)}z(n,r,t,i=Object.create(null)){const s=n.readFileStream(r,i,t);return(0,d.transform)(s,{data:o=>o instanceof A.VSBuffer?o:A.VSBuffer.wrap(o),error:o=>this.w(o,r,i)},o=>A.VSBuffer.concat(o))}C(n,r,t,i=Object.create(null)){const s=(0,A.newWriteableBufferStream)();return(0,h.readFileIntoStream)(n,r,s,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.w(o,r,i)},t),s}D(n,r,t){const i=(0,d.newWriteableStream)(s=>A.VSBuffer.concat(s));return(async()=>{try{let s;t?.atomic&&(0,a.hasFileAtomicReadCapability)(n)?s=await n.readFile(r,{atomic:!0}):s=await n.readFile(r),typeof t?.position=="number"&&(s=s.slice(t.position)),typeof t?.length=="number"&&(s=s.slice(0,t.length)),this.G(r,s.byteLength,t),i.end(A.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async F(n,r){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new a.FileOperationError((0,w.localize)(11,null,this.ob(n)),0,r);if(typeof r?.etag=="string"&&r.etag!==a.ETAG_DISABLED&&r.etag===t.etag)throw new a.NotModifiedSinceFileOperationError((0,w.localize)(12,null),t,r);return this.G(n,t.size,r),t}G(n,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new a.TooLargeFileOperationError((0,w.localize)(13,null,this.ob(n)),7,r,t)}async canMove(n,r,t){return this.H(n,r,"move",t)}async canCopy(n,r,t){return this.H(n,r,"copy",t)}async H(n,r,t,i){if(n.toString()!==r.toString())try{const s=t==="move"?this.mb(await this.l(n),n):await this.k(n),o=this.mb(await this.l(r),r);await this.M(s,n,o,r,t,i)}catch(s){return s}return!0}async move(n,r,t){const i=this.mb(await this.l(n),n),s=this.mb(await this.l(r),r),o=await this.I(i,n,s,r,"move",!!t),l=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(n,o==="move"?2:3,l)),l}async copy(n,r,t){const i=await this.k(n),s=this.mb(await this.l(r),r),o=await this.I(i,n,s,r,"copy",!!t),l=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(n,o==="copy"?3:2,l)),l}async I(n,r,t,i,s,o){if(r.toString()===i.toString())return s;const{exists:l,isSameResourceWithDifferentPathCase:E}=await this.M(n,r,t,i,s,o);if(l&&!E&&o&&await this.del(i,{recursive:!0}),await this.P(t,this.N(t).providerExtUri.dirname(i)),s==="copy"){if(n===t&&(0,a.hasFileFolderCopyCapability)(n))await n.copy(r,i,{overwrite:o});else{const y=await this.resolve(r);y.isDirectory?await this.L(n,y,t,i):await this.J(n,r,t,i)}return s}else return n===t?(await n.rename(r,i,{overwrite:o}),s):(await this.I(n,r,t,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async J(n,r,t,i){if((0,a.hasOpenReadWriteCloseCapability)(n)&&(0,a.hasOpenReadWriteCloseCapability)(t))return this.fb(n,r,t,i);if((0,a.hasOpenReadWriteCloseCapability)(n)&&(0,a.hasReadWriteCapability)(t))return this.lb(n,r,t,i);if((0,a.hasReadWriteCapability)(n)&&(0,a.hasOpenReadWriteCloseCapability)(t))return this.jb(n,r,t,i);if((0,a.hasReadWriteCapability)(n)&&(0,a.hasReadWriteCapability)(t))return this.hb(n,r,t,i)}async L(n,r,t,i){await t.mkdir(i),Array.isArray(r.children)&&await U.Promises.settled(r.children.map(async s=>{const o=this.N(t).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.L(n,await this.resolve(s.resource),t,o):this.J(n,s.resource,t,o)}))}async M(n,r,t,i,s,o){let l=!1;if(n===t){const{providerExtUri:y,isPathCaseSensitive:c}=this.N(n);if(c||(l=y.isEqual(r,i)),l&&s==="copy")throw new Error((0,w.localize)(14,null,this.ob(r),this.ob(i)));if(!l&&y.isEqualOrParent(i,r))throw new Error((0,w.localize)(15,null,this.ob(r),this.ob(i)))}const E=await this.exists(i);if(E&&!l){if(!o)throw new a.FileOperationError((0,w.localize)(16,null,this.ob(r),this.ob(i)),4);if(n===t){const{providerExtUri:y}=this.N(n);if(y.isEqualOrParent(r,i))throw new Error((0,w.localize)(17,null,this.ob(r),this.ob(i)))}}return{exists:E,isSameResourceWithDifferentPathCase:l}}N(n){const r=this.O(n);return{providerExtUri:r?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:r}}O(n){return!!(n.capabilities&1024)}async createFolder(n){const r=this.mb(await this.j(n),n);await this.P(r,n);const t=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(n,0,t)),t}async P(n,r){const t=[],{providerExtUri:i}=this.N(n);for(;!i.isEqual(r,i.dirname(r));)try{if(!((await n.stat(r)).type&a.FileType.Directory))throw new Error((0,w.localize)(18,null,this.ob(r)));break}catch(s){if((0,a.toFileSystemProviderErrorCode)(s)!==a.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(i.basename(r)),r=i.dirname(r)}for(let s=t.length-1;s>=0;s--){r=i.joinPath(r,t[s]);try{await n.mkdir(r)}catch(o){if((0,a.toFileSystemProviderErrorCode)(o)!==a.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(n,r){try{await this.Q(n,r)}catch(t){return t}return!0}async Q(n,r){const t=this.mb(await this.j(n),n),i=!!r?.useTrash;if(i&&!(t.capabilities&4096))throw new Error((0,w.localize)(19,null,this.ob(n)));const s=r?.atomic;if(s&&!(t.capabilities&65536))throw new Error((0,w.localize)(20,null,this.ob(n)));if(i&&s)throw new Error((0,w.localize)(21,null,this.ob(n)));let o;try{o=await t.stat(n)}catch{}if(o)this.nb(n,o);else throw new a.FileOperationError((0,w.localize)(22,null,this.ob(n)),1);if(!!!r?.recursive){const E=await this.resolve(n);if(E.isDirectory&&Array.isArray(E.children)&&E.children.length>0)throw new Error((0,w.localize)(23,null,this.ob(n)))}return t}async del(n,r){const t=await this.Q(n,r),i=!!r?.useTrash,s=!!r?.recursive,o=r?.atomic??!1;await t.delete(n,{recursive:s,useTrash:i,atomic:o}),this.m.fire(new a.FileOperationEvent(n,1))}async cloneFile(n,r){const t=await this.j(n),i=this.mb(await this.l(r),r);if(t===i&&this.N(t).providerExtUri.isEqual(n,r))return;if(t===i&&(0,a.hasFileCloneCapability)(t))return t.cloneFile(n,r);await this.P(i,this.N(i).providerExtUri.dirname(r));const s=this.X.queueFor(n,this.N(t).providerExtUri);return t===i&&(0,a.hasFileFolderCopyCapability)(t)?s.queue(()=>t.copy(n,r,{overwrite:!0})):s.queue(()=>this.J(t,n,i,r))}watch(n,r={recursive:!1,excludes:[]}){const t=new m.DisposableStore;let i=!1,s=()=>{i=!0};return t.add((0,m.toDisposable)(()=>s())),(async()=>{try{const o=await this.W(n,r);i?(0,m.dispose)(o):s=()=>(0,m.dispose)(o)}catch(o){this.b.error(o)}})(),t}async W(n,r){const t=await this.j(n),i=(0,D.hash)([this.N(t).providerExtUri.getComparisonKey(n),r]);let s=this.U.get(i);return s||(s={count:0,disposable:t.watch(n,r)},this.U.set(i,s)),s.count+=1,(0,m.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,m.dispose)(s.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,n]of this.U)(0,m.dispose)(n.disposable);this.U.clear()}async Y(n,r,t,i,s){await this.Z(n,t,i,s);try{await n.rename(t,r,{overwrite:!0})}catch(o){try{await n.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async Z(n,r,t,i){return this.X.queueFor(r,this.N(n).providerExtUri).queue(async()=>{const s=await n.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.ab(n,s,i):await this.bb(n,s,i)}catch(o){throw(0,a.ensureFileSystemProviderError)(o)}finally{await n.close(s)}})}async ab(n,r,t){let i=0,s;if((0,d.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=A.VSBuffer.concat(t.buffer);await this.cb(n,r,o,o.byteLength,i,0),i+=o.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise((o,l)=>{(0,d.listenStream)(s,{onData:async E=>{s.pause();try{await this.cb(n,r,E,E.byteLength,i,0)}catch(y){return l(y)}i+=E.byteLength,setTimeout(()=>s.resume())},onError:E=>l(E),onEnd:()=>o()})})}async bb(n,r,t){let i=0,s;for(;(s=t.read())!==null;)await this.cb(n,r,s,s.byteLength,i,0),i+=s.byteLength}async cb(n,r,t,i,s,o){let l=0;for(;l<i;){const E=await n.write(r,s+l,t.buffer,o+l,i-l);l+=E}}async db(n,r,t,i){return this.X.queueFor(r,this.N(n).providerExtUri).queue(()=>this.eb(n,r,t,i))}async eb(n,r,t,i){let s;i instanceof A.VSBuffer?s=i:(0,d.isReadableStream)(i)?s=await(0,A.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?s=await(0,A.bufferedStreamToBuffer)(i):s=(0,A.readableToBuffer)(i),await n.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async fb(n,r,t,i){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.gb(n,r,t,i))}async gb(n,r,t,i){let s,o;try{s=await n.open(r,{create:!1}),o=await t.open(i,{create:!0,unlock:!1});const l=A.VSBuffer.alloc(this.a);let E=0,y=0,c=0;do c=await n.read(s,E,l.buffer,y,l.byteLength-y),await this.cb(t,o,l,c,E,y),E+=c,y+=c,y===l.byteLength&&(y=0);while(c>0)}catch(l){throw(0,a.ensureFileSystemProviderError)(l)}finally{await U.Promises.settled([typeof s=="number"?n.close(s):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async hb(n,r,t,i){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.ib(n,r,t,i))}async ib(n,r,t,i){return t.writeFile(i,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async jb(n,r,t,i){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.kb(n,r,t,i))}async kb(n,r,t,i){const s=await t.open(i,{create:!0,unlock:!1});try{const o=await n.readFile(r);await this.cb(t,s,A.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,a.ensureFileSystemProviderError)(o)}finally{await t.close(s)}}async lb(n,r,t,i){const s=await(0,A.streamToBuffer)(this.C(n,r,N.CancellationToken.None));await this.db(t,i,void 0,s)}mb(n,r){if(n.capabilities&2048)throw new a.FileOperationError((0,w.localize)(24,null,this.ob(r)),6);return n}nb(n,r){if((r.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,w.localize)(25,null,this.ob(n)),6)}ob(n){return n.scheme===v.Schemas.file?n.fsPath:n.toString(!0)}};e.FileService=p=ve([X(0,u.ILogService)],p)}),define(oe[193],ae([0,1,51,263,6,35,16,3,46,2,15,5,22,42,30,155,13,99,191,38,187,186]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u,I,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,U.gracefulify)(k)}catch(r){console.error(`Error enabling graceful-fs: ${(0,I.toErrorMessage)(r)}`)}})();class n extends u.AbstractDiskFileSystemProvider{constructor(t,i){super(t,i),this.onDidChangeCapabilities=D.Event.None,this.I=new N.ResourceMap(s=>S.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,v.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:i,symbolicLink:s}=await d.SymlinkSupport.stat(this.C(t));return{type:this.H(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:a.FilePermission.Locked}}catch(i){throw this.bb(i)}}async G(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await d.Promises.readdir(this.C(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,S.joinPath)(t,o.name))).type:l=this.H(o),s.push([o.name,l])}catch(l){this.a.trace(l)}})),s}catch(i){throw this.bb(i)}}H(t,i){let s;return i?.dangling?s=a.FileType.Unknown:t.isFile()?s=a.FileType.File:t.isDirectory()?s=a.FileType.Directory:s=a.FileType.Unknown,i&&(s|=a.FileType.SymbolicLink),s}async J(t){const i=this.C(t);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.I.get(t);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const o=new A.Barrier;return this.I.set(t,o),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,m.toDisposable)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.I.get(t)===o&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.I.delete(t)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),s=await this.J(t));const o=this.C(t);return await d.Promises.readFile(o)}catch(o){throw this.bb(o)}finally{s?.dispose()}}L(t){n.D&&this.a.trace(t)}readFileStream(t,i,s){const o=(0,f.newWriteableStream)(l=>T.VSBuffer.concat(l.map(E=>T.VSBuffer.wrap(E))).buffer);return(0,h.readFileIntoStream)(this,t,o,l=>l.buffer,{...i,bufferSize:256*1024},s),o}async writeFile(t,i,s){return s?.atomic!==!1&&s?.atomic?.postfix?this.M(t,(0,S.joinPath)((0,S.dirname)(t),`${(0,S.basename)(t)}${s.atomic.postfix}`),i,s):this.N(t,i,s)}async M(t,i,s,o){await this.N(i,s,o);try{await this.rename(i,t,{overwrite:!0})}catch(l){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}async N(t,i,s){let o;try{const l=this.C(t);if(!s.create||!s.overwrite){if(await d.Promises.exists(l)){if(!s.overwrite)throw(0,a.createFileSystemProviderError)((0,w.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,a.createFileSystemProviderError)((0,w.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(l){throw await this.cb(t,l)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(t){n.R=t}async open(t,i){const s=this.C(t);let o;(0,a.isFileOpenForWriteOptions)(i)&&(o=await this.J(t));let l;try{if((0,a.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:y}=await d.SymlinkSupport.stat(s);y.mode&128||await d.Promises.chmod(s,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let E;if((0,a.isFileOpenForWriteOptions)(i)){if(v.isWindows)try{await d.Promises.truncate(s,0),E="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}E||(E="w")}else E="r";l=await d.Promises.open(s,E)}catch(E){throw o?.dispose(),(0,a.isFileOpenForWriteOptions)(i)?await this.cb(t,E):this.bb(E)}if(this.O.set(l,0),(0,a.isFileOpenForWriteOptions)(i)&&this.Q.set(l,t),o){const E=this.P.get(l);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.P.set(l,o),E&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),E.dispose())}return l}async close(t){const i=this.P.get(t);try{if(this.O.delete(t),this.Q.delete(t)&&n.R)try{await d.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await d.Promises.close(t)}catch(s){throw this.bb(s)}finally{i&&(this.P.get(t)===i&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.P.delete(t)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,o,l){const E=this.S(t,i);let y=null;try{y=(await d.Promises.read(t,s,o,l,E)).bytesRead}catch(c){throw this.bb(c)}finally{this.U(t,E,y)}return y}S(t,i){return i===this.O.get(t)?null:i}U(t,i,s){const o=this.O.get(t);typeof o=="number"&&(typeof i=="number"||(typeof s=="number"?this.O.set(t,o+s):this.O.delete(t)))}async write(t,i,s,o,l){return(0,A.retry)(()=>this.W(t,i,s,o,l),100,3)}async W(t,i,s,o,l){const E=this.S(t,i);let y=null;try{y=(await d.Promises.write(t,s,o,l,E)).bytesWritten}catch(c){throw await this.cb(this.Q.get(t),c)}finally{this.U(t,E,y)}return y}async mkdir(t){try{await d.Promises.mkdir(this.C(t))}catch(i){throw this.bb(i)}}async delete(t,i){try{const s=this.C(t);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,P.join)((0,P.dirname)(s),`${(0,P.basename)(s)}${i.atomic.postfix}`)),await d.Promises.rm(s,d.RimRafMode.MOVE,o)}else try{await d.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:E,symbolicLink:y}=await d.SymlinkSupport.stat(s);l=E.isDirectory()&&!y}catch{}if(l)await d.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.bb(s)}}async rename(t,i,s){const o=this.C(t),l=this.C(i);if(o!==l)try{await this.X(t,i,"move",s.overwrite),await d.Promises.move(o,l)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),E.toString()))),this.bb(E)}}async copy(t,i,s){const o=this.C(t),l=this.C(i);if(o!==l)try{await this.X(t,i,"copy",s.overwrite),await d.Promises.copy(o,l,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),E.toString()))),this.bb(E)}}async X(t,i,s,o){const l=this.C(t),E=this.C(i);let y=!1;if(!!(this.capabilities&1024)||(y=(0,C.isEqual)(l,E,!0)),y){if(s==="copy")throw(0,a.createFileSystemProviderError)((0,w.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const b=await this.G(t);if(!b)throw(0,a.createFileSystemProviderError)((0,w.localize)(5,null),a.FileSystemProviderErrorCode.FileNotFound);const R=await this.G(i);if(R){if(!o)throw(0,a.createFileSystemProviderError)((0,w.localize)(6,null),a.FileSystemProviderErrorCode.FileExists);b.type&a.FileType.File&&R.type&a.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.Y(t,i,!1)}async Y(t,i,s){const o=this.C(t),l=this.C(i),E=!!(this.capabilities&1024);if((0,C.isEqual)(o,l,!E))return;const y=new m.DisposableStore;try{const[c,b]=await Promise.all([this.J(t),this.J(i)]);y.add(c),y.add(b),s&&await d.Promises.mkdir((0,P.dirname)(l),{recursive:!0}),await d.Promises.copyFile(o,l)}catch(c){if(c.code==="ENOENT"&&!s)return this.Y(t,i,!0);throw this.bb(c)}finally{y.dispose()}}p(t,i,s){return new p.UniversalWatcherClient(o=>t(o),o=>i(o),s)}y(t,i,s){return new L.NodeJSWatcherClient(o=>t(o),o=>i(o),s)}bb(t){if(t instanceof a.FileSystemProviderError)return t;let i=t,s;switch(t.code){case"ENOENT":s=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=a.FileSystemProviderErrorCode.Unknown;break;default:s=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(i,s)}async cb(t,i){let s=this.bb(i);if(t&&s.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await d.SymlinkSupport.stat(this.C(t));o.mode&128||(s=(0,a.createFileSystemProviderError)(i,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.DiskFileSystemProvider=n,n.D=!1,n.R=!0}),define(oe[101],ae([0,1,3,2,4,8]),function(ne,e,k,U,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,A.createDecorator)("sharedProcessLifecycleService");let T=e.SharedProcessLifecycleService=class extends U.Disposable{constructor(C){super(),this.b=C,this.a=this.B(new k.Emitter),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.SharedProcessLifecycleService=T=ve([X(0,N.ILogService)],T)}),define(oe[194],ae([0,1,12,3,8,2]),function(ne,e,k,U,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class T extends A.AbstractLoggerService{constructor(v,S,f,d,w){super(S,f,d),this.n=v,this.p=w,this.B(w.listen("onDidChangeLogLevel",v)(a=>{(0,A.isLogLevel)(a)?super.setLogLevel(a):super.setLogLevel(k.URI.revive(a[0]),a[1])})),this.B(w.listen("onDidChangeVisibility",v)(([a,h])=>super.setVisibility(k.URI.revive(a),h))),this.B(w.listen("onDidChangeLoggers",v)(({added:a,removed:h})=>{for(const u of a)super.registerLogger({...u,resource:k.URI.revive(u.resource)});for(const u of h)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new A.AdapterLogger({log:(v,S)=>{this.p.call("consoleLog",[v,S])}})}registerLogger(v){super.registerLogger(v),this.p.call("registerLogger",[v,this.n])}deregisterLogger(v){super.deregisterLogger(v),this.p.call("deregisterLogger",[v,this.n])}setLogLevel(v,S){super.setLogLevel(v,S),this.p.call("setLogLevel",[v,S])}setVisibility(v,S){super.setVisibility(v,S),this.p.call("setVisibility",[this.l(v),S])}m(v,S,f){return new D(this.p,v,S,f,this.n)}static setLogLevel(v,S,f){return v.call("setLogLevel",[S,f])}}e.LoggerChannelClient=T;class D extends A.AbstractMessageLogger{constructor(v,S,f,d,w){super(d?.logLevel==="always"),this.m=v,this.n=S,this.k=!1,this.l=[],this.setLevel(f),this.m.call("createLogger",[S,d,w]).then(()=>{this.r(this.l),this.k=!0})}g(v,S){const f=[[v,S]];this.k?this.r(f):this.l.push(...f)}r(v){this.m.call("log",[this.n,v])}}class C{constructor(v,S){this.a=v,this.b=S}listen(v,S){const f=this.b(v);switch(S){case"onDidChangeLoggers":return U.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(w=>this.c(w,f)),removed:[...d.removed].map(w=>this.c(w,f))}));case"onDidChangeVisibility":return U.Event.map(this.a.onDidChangeVisibility,d=>[f.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return U.Event.map(this.a.onDidChangeLogLevel,d=>(0,A.isLogLevel)(d)?d:[f.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${S}`)}async call(v,S,f){const d=this.b(v);switch(S){case"setLogLevel":return(0,A.isLogLevel)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(k.URI.revive(d.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,d)))}throw new Error(`Call not found: ${S}`)}c(v,S){return{...v,resource:S.transformOutgoingURI(v.resource)}}}e.LoggerChannel=C;class m extends N.Disposable{constructor(v,S){super(),S.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(f=>S.call("setLogLevel",[f]))),S.call("getRegisteredLoggers").then(f=>{for(const d of f)v.registerLogger({...d,resource:k.URI.revive(d.resource)})}),this.B(S.listen("onDidChangeVisibility")(([f,d])=>v.setVisibility(k.URI.revive(f),d))),this.B(S.listen("onDidChangeLoggers")(({added:f,removed:d})=>{for(const w of f)v.registerLogger({...w,resource:k.URI.revive(w.resource)});for(const w of d)v.deregisterLogger(w.resource)}))}}e.RemoteLoggerChannelClient=m}),define(oe[195],ae([0,1,2,8]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class A extends k.Disposable{constructor(T,D=[]){super(),this.a=new U.MultiplexLogger([T,...D]),this.B(T.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...D){this.a.trace(T,...D)}debug(T,...D){this.a.debug(T,...D)}info(T,...D){this.a.info(T,...D)}warn(T,...D){this.a.warn(T,...D)}error(T,...D){this.a.error(T,...D)}flush(){this.a.flush()}}e.LogService=A}),define(oe[54],ae([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(oe[55],ae([0,1,3,60,2,4]),function(ne,e,k,U,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,N.createDecorator)("policy");class T extends A.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new k.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const P=Object.keys(this.f).length;return this.f={...m,...this.f},P!==Object.keys(this.f).length&&await this.i(m),U.Iterable.reduce(this.g.entries(),(v,[S,f])=>({...v,[S]:f}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return U.Iterable.reduce(Object.entries(this.f),(m,[P,v])=>({...m,[P]:{definition:v,value:this.g.get(P)}}),{})}}e.AbstractPolicyService=T;class D{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=D}),define(oe[196],ae([0,1,3,2,55]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class N{constructor(C){this.b=C,this.a=new U.DisposableStore}listen(C,m){switch(m){case"onDidChange":return k.Event.map(this.b.onDidChange,P=>P.reduce((v,S)=>({...v,[S]:this.b.getPolicyValue(S)??null}),{}),this.a)}throw new Error(`Event not found: ${m}`)}call(C,m,P){switch(m){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${m}`)}dispose(){this.a.dispose()}}e.PolicyChannel=N;class T extends A.AbstractPolicyService{constructor(C,m){super(),this.a=m;for(const P in C){const{definition:v,value:S}=C[P];this.f[P]=v,S!==void 0&&this.g.set(P,S)}this.a.listen("onDidChange")(P=>{for(const v in P){const S=P[v];S===null?this.g.delete(v):this.g.set(v,S)}this.h.fire(Object.keys(P))})}async i(C){const m=await this.a.call("updatePolicyDefinitions",C);for(const P in m)this.g.set(P,m[P])}}e.PolicyChannelClient=T}),define(oe[102],ae([0,1,5,37]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.context<"u"){const N=k.globals.vscode.context.configuration();if(N)A=N.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,U.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const N=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:N.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(oe[24],ae([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[197],ae([0,1,6,7,2,15,30,8,24]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let m=e.CodeCacheCleaner=class extends A.Disposable{constructor(v,S,f){super(),this.b=S,this.c=f,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,v&&this.B(new k.RunOnceScheduler(()=>{this.f(v)},3e4)).schedule()}async f(v){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const S=Date.now(),f=(0,N.dirname)(v),d=(0,N.basename)(v),w=await T.Promises.readdir(f);await Promise.all(w.map(async a=>{if(a===d)return;const h=(0,N.join)(f,a),u=await T.Promises.stat(h);if(u.isDirectory()&&S-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${a}.`),T.Promises.rm(h)}))}catch(S){(0,U.onUnexpectedError)(S)}}};e.CodeCacheCleaner=m=ve([X(1,C.IProductService),X(2,D.ILogService)],m)}),define(oe[198],ae([0,1,6,7,2,15,30,14,8,24]),function(ne,e,k,U,A,N,T,D,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=e.LanguagePackCachedDataCleaner=class extends A.Disposable{constructor(S,f,d){super(),this.b=S,this.c=f,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new k.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const S=Object.create(null),f=JSON.parse(await T.Promises.readFile((0,N.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(f)){const I=f[u];S[`${I.hash}.${u}`]=!0}const d=(0,N.join)(this.b.userDataPath,"clp");if(!await T.Promises.exists(d))return;const a=await T.Promises.readdir(d);for(const u of a){if(S[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await T.Promises.rm((0,N.join)(d,u))}const h=Date.now();for(const u of Object.keys(S)){const I=(0,N.join)(d,u),p=await T.Promises.readdir(I);for(const L of p){if(L==="tcf.json")continue;const n=(0,N.join)(I,L),r=await T.Promises.stat(n);r.isDirectory()&&h-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,N.join)(u,L)}`),await T.Promises.rm(n))}}}catch(S){(0,U.onUnexpectedError)(S)}}};e.LanguagePackCachedDataCleaner=P=ve([X(0,D.INativeEnvironmentService),X(1,C.ILogService),X(2,m.IProductService)],P)}),define(oe[199],ae([0,1,15,4]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,U.createDecorator)("IV8InspectProfilingService");var A;(function(N){function T(C){return!!(C.samples&&C.timeDeltas)}N.isValidProfile=T;function D(C,m="noAbsolutePaths"){for(const P of C.nodes)P.callFrame&&P.callFrame.url&&((0,k.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,k.join)(m,(0,k.basename)(P.callFrame.url)));return C}N.rewriteAbsolutePaths=D})(A||(e.Utils=A={}))}),define(oe[200],ae([0,1,32]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class U{constructor(){this.a=new Map}async startProfiling(N){const D=await(await new Promise((m,P)=>{ne(["v8-inspect-profiler"],m,P)})).startProfiling({port:N.port,checkForPaused:!0}),C=(0,k.generateUuid)();return this.a.set(C,D),C}async stopProfiling(N){const T=this.a.get(N);if(!T)throw new Error(`UNKNOWN session '${N}'`);const D=await T.stop();return this.a.delete(N),D.profile}}e.InspectProfilingService=U}),define(oe[40],ae([0,1,122,10]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.a=new Map}add(T,D){k.ok(U.isString(T)),k.ok(U.isObject(D)),k.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,D)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.Registry=new A}),define(oe[103],ae([0,1,3,40]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class N{constructor(){this.b=new k.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(C,m){this.a[A(C)]=m,this.b.fire(C)}notifySchemaChanged(C){this.b.fire(C)}getSchemaContributions(){return{schemas:this.a}}}const T=new N;U.Registry.add(e.Extensions.JSONContribution,T)}),define(oe[48],ae([0,1,21,3,10,142,18,103,40]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(L){L.Multiline="multilineText",L.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(L){L[L.APPLICATION=1]="APPLICATION",L[L.MACHINE=2]="MACHINE",L[L.WINDOW=3]="WINDOW",L[L.RESOURCE=4]="RESOURCE",L[L.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",L[L.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=C.Registry.as(D.Extensions.JSONContribution);class S{constructor(){this.h=new Set,this.i=new U.Emitter,this.onDidSchemaChange=this.i.event,this.j=new U.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=new Set;this.n(n,r,t),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=new Set;this.o(n,r),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=new Set;this.o(r,t),this.n(n,!1,t),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const t=[];for(const{overrides:i,source:s}of n)for(const o in i)if(r.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const l=this.a.get(o),E=l?.valuesSources??new Map;if(s)for(const R of Object.keys(i[o]))E.set(R,s);const y={...l?.value||{},...i[o]};this.a.set(o,{source:s,value:y,valuesSources:E});const c=(0,T.getLanguageTagSettingPlainKey)(o),b={type:"object",default:y,description:N.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:y,source:A.isString(s)?void 0:s,defaultValueSource:s};t.push(...w(o)),this.d[o]=b,this.b.properties[o]=b}else{this.a.set(o,{value:i[o],source:s});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(t)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:t,source:i}of n)for(const s in t){const o=this.a.get(s),l=A.isString(i)?i:i?.id,E=A.isString(o?.source)?o?.source:o?.source?.id;if(l===E)if(r.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const y=this.d[s];y&&(this.w(s,y),this.r(s,y))}}this.u()}deltaConfiguration(n){let r=!1;const t=new Set;n.removedDefaults&&(this.l(n.removedDefaults,t),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,t),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,t),n.addedConfigurations&&this.n(n.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,t){n.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(n,r){const t=i=>{if(i.properties)for(const s in i.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>t(s))};for(const i of n){t(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(n,r=!0,t,i,s=3,o){s=A.isUndefinedOrNull(n.scope)?s:n.scope;const l=n.properties;if(l)for(const y in l){const c=l[y];if(r&&I(y,c)){delete l[y];continue}if(c.source=t,c.defaultDefaultValue=l[y].default,this.w(y,c),e.OVERRIDE_PROPERTY_REGEX.test(y)?c.scope=void 0:(c.scope=A.isUndefinedOrNull(c.scope)?s:c.scope,c.restricted=A.isUndefinedOrNull(c.restricted)?!!i?.includes(y):c.restricted),l[y].hasOwnProperty("included")&&!l[y].included){this.f[y]=l[y],delete l[y];continue}else this.d[y]=l[y],l[y].policy?.name&&this.e.set(l[y].policy.name,y);!l[y].deprecationMessage&&l[y].markdownDeprecationMessage&&(l[y].deprecationMessage=l[y].markdownDeprecationMessage),o.add(y)}const E=n.allOf;if(E)for(const y of E)this.p(y,r,t,i,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=t=>{const i=t.properties;if(i)for(const o in i)this.r(o,i[o]);t.allOf?.forEach(r)};r(n)}r(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}}v(){const n={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}w(n,r){const t=this.a.get(n);let i=t?.value,s=t?.source;A.isUndefined(i)&&(i=r.defaultDefaultValue,s=void 0),A.isUndefined(i)&&(i=h(r.type)),r.default=i,r.defaultValueSource=s}}const f="\\[([^\\]]+)\\]",d=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(L){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(L)){let r=d.exec(L);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=d.exec(L)}}return(0,k.distinct)(n)}e.overrideIdentifiersFromKey=w;function a(L){return L.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=a;function h(L){switch(Array.isArray(L)?L[0]:L){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const u=new S;C.Registry.add(e.Extensions.Configuration,u);function I(L,n){return L.trim()?e.OVERRIDE_PROPERTY_REGEX.test(L)?N.localize(7,null,L):u.getConfigurationProperties()[L]!==void 0?N.localize(8,null,L):n.policy?.name&&u.getPolicyConfigurations().get(n.policy?.name)!==void 0?N.localize(9,null,L,n.policy?.name,u.getPolicyConfigurations().get(n.policy?.name)):null:N.localize(6,null)}e.validateProperty=I;function p(){const L=[],n=u.getConfigurationProperties();for(const r of Object.keys(n))L.push([r,n[r].scope]);return L.push(["launch",4]),L.push(["task",4]),L}e.getScopes=p}),define(oe[73],ae([0,1,21,3,34,2,35,31,10,12,18,48,40]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(r){return Object.isFrozen(r)?r:D.deepFreeze(r)}class d{constructor(t={},i=[],s=[],o){this.b=t,this.c=i,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof d)return i;const s=new w("");return s.parseRaw(i),s.configurationModel});this.f=t.reduce((i,s)=>s===i?s:i.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,P.getConfigurationValue)(this.contents,t):this.contents}inspect(t,i){const s=this.rawConfiguration.getValue(t),o=i?this.rawConfiguration.getOverrideValue(t,i):void 0,l=i?this.rawConfiguration.override(i).getValue(t):s;return{value:s,override:o,merged:l}}getOverrideValue(t,i){const s=this.i(i);return s?t?(0,P.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const s of this.overrides)s.identifiers.includes(t)&&i.push(...s.keys);return k.distinct(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return k.distinct(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=D.deepClone(this.contents),s=D.deepClone(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const E of t)if(l.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(i,E.contents);for(const y of E.overrides){const[c]=s.filter(b=>k.equals(b.identifiers,y.identifiers));c?(this.h(c.contents,y.contents),c.keys.push(...y.keys),c.keys=k.distinct(c.keys)):s.push(D.deepClone(y))}for(const y of E.keys)o.indexOf(y)===-1&&o.push(y)}return new d(i,o,s,l.every(E=>E instanceof d)?void 0:l)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const o of k.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[o];const E=i[o];E&&(typeof l=="object"&&typeof E=="object"?(l=D.deepClone(l),this.h(l,E)):l=E),s[o]=l}return new d(s,this.keys,this.overrides)}h(t,i){for(const s of Object.keys(i)){if(s in t&&C.isObject(t[s])&&C.isObject(i[s])){this.h(t[s],i[s]);continue}t[s]=D.deepClone(i[s])}}i(t){let i=null,s=null;const o=l=>{l&&(s?this.h(s,l):s=D.deepClone(l))};for(const l of this.overrides)k.equals(l.identifiers,[t])?i=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,P.removeFromValueTree)(this.contents,t),v.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>k.equals(s.identifiers,(0,v.overrideIdentifiersFromKey)(t))),1))}j(t,i,s){(0,P.addToValueTree)(this.contents,t,i,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),v.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,v.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,P.toValuesTree)(this.contents[t],o=>console.error(o))})}}e.ConfigurationModel=d;class w{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!C.isUndefinedOrNull(t)){const s=this.g(t);this.parseRaw(s,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:s,keys:o,overrides:l,restricted:E,hasExcludedProperties:y}=this.h(t,i);this.b=new d(s,o,l,y?[t]:void 0),this.c=E||[]}g(t){let i={},s=null,o=[];const l=[],E=[];function y(b){Array.isArray(o)?o.push(b):s!==null&&(o[s]=b)}const c={onObjectBegin:()=>{const b={};y(b),l.push(o),o=b,s=null},onObjectProperty:b=>{s=b},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const b=[];y(b),l.push(o),o=b,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:y,onError:(b,R,M)=>{E.push({error:b,offset:R,length:M})}};if(t)try{A.visit(t,c),i=o[0]||{}}catch(b){console.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return i}h(t,i){const s=S.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,i);t=o.raw;const l=(0,P.toValuesTree)(t,c=>console.error(`Conflict in settings file ${this.f}: ${c}`)),E=Object.keys(t),y=this.j(t,c=>console.error(`Conflict in settings file ${this.f}: ${c}`));return{contents:l,keys:E,overrides:y,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,i,s,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:l};const E={},y=[];for(const c in t)if(v.OVERRIDE_PROPERTY_REGEX.test(c)&&s){const b=this.i(t[c],i,!1,o);E[c]=b.raw,l=l||b.hasExcludedProperties,y.push(...b.restricted)}else{const b=i[c],R=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&y.push(c),(R===void 0||o.scopes===void 0||o.scopes.includes(R))&&!(o.skipRestricted&&b?.restricted)?E[c]=t[c]:l=!0}return{raw:E,restricted:y,hasExcludedProperties:l}}j(t,i){const s=[];for(const o of Object.keys(t))if(v.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const E in t[o])l[E]=t[o][E];s.push({identifiers:(0,v.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,P.toValuesTree)(l,i)})}return s}}e.ConfigurationModelParser=w;class a extends N.Disposable{constructor(t,i,s,o){super(),this.f=t,this.g=i,this.h=o,this.c=this.B(new U.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(U.Event.any(U.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),U.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,t)))(()=>this.c.fire()))}async loadConfiguration(){try{const t=await this.h.readFile(this.f);return this.a.parse(t.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new d}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=a;class h{constructor(t,i,s,o,l,E,y,c,b,R,M,F,H){this.a=t,this.b=i,this.c=s,this.overrideIdentifiers=o,this.d=l,this.f=E,this.g=y,this.h=c,this.i=b,this.j=R,this.k=M,this.l=F,this.m=H}get value(){return f(this.c)}n(t,i,s){const o=t.inspect(i,s);return{get value(){return f(o.value)},get override(){return f(o.override)},get merged(){return f(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(t,i,s,o,l=new d,E=new d,y=new T.ResourceMap,c=new d,b=new T.ResourceMap){this.c=t,this.d=i,this.f=s,this.g=o,this.h=l,this.i=E,this.j=y,this.l=c,this.m=b,this.a=null,this.b=new T.ResourceMap,this.n=null}getValue(t,i,s){return this.q(t,i,s).getValue(t)}updateValue(t,i,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new d,this.m.set(s.resource,o))):o=this.l,i===void 0?o.removeValue(t):o.setValue(t,i),s.resource||(this.a=null)}inspect(t,i,s){const o=this.q(t,i,s),l=this.u(i.resource,s),E=i.resource?this.m.get(i.resource)||this.l:this.l,y=new Set;for(const c of o.overrides)for(const b of c.identifiers)o.getOverrideValue(t,b)!==void 0&&y.add(b);return new h(t,i,o.getValue(t),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,E)}keys(t){const i=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=[];if(!i){const{added:o,updated:l,removed:E}=L(this.c,t);i=[...o,...l,...E]}for(const o of i)for(const l of(0,v.overrideIdentifiersFromKey)(o)){const E=this.c.getKeysForOverrideIdentifier(l),y=t.getKeysForOverrideIdentifier(l),c=[...y.filter(b=>E.indexOf(b)===-1),...E.filter(b=>y.indexOf(b)===-1),...E.filter(b=>!D.equals(this.c.override(l).getValue(b),t.override(l).getValue(b)))];s.push([l,c])}return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:s,removed:o}=L(this.d,t),l=[...i,...s,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:s,removed:o,overrides:l}=L(this.applicationConfiguration,t),E=[...i,...s,...o];return E.length&&this.updateApplicationConfiguration(t),{keys:E,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:l}=L(this.localUserConfiguration,t),E=[...i,...s,...o];return E.length&&this.updateLocalUserConfiguration(t),{keys:E,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:l}=L(this.remoteUserConfiguration,t),E=[...i,...s,...o];return E.length&&this.updateRemoteUserConfiguration(t),{keys:E,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:o,overrides:l}=L(this.workspaceConfiguration,t),E=[...i,...s,...o];return E.length&&this.updateWorkspaceConfiguration(t),{keys:E,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const s=this.p.get(t),{added:o,updated:l,removed:E,overrides:y}=L(s,i),c=[...o,...l,...E];return(c.length||!s)&&this.updateFolderConfiguration(t,i),{keys:c,overrides:y}}compareAndDeleteFolderConfiguration(t){const i=this.p.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:l,overrides:E}=L(i,void 0);return{keys:[...s,...o,...l],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,i,s){let o=this.r(i,s);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}r({resource:t},i){let s=this.s();if(i&&t){const o=i.getFolder(t);o&&(s=this.t(o.uri)||s);const l=this.m.get(t);l&&(s=s.merge(l))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let i=this.b.get(t);if(!i){const s=this.s(),o=this.j.get(t);o?(i=s.merge(o),this.b.set(t,i)):i=s}return i}u(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:s,overrides:o,keys:l}=this.j.get(i);return t.push([i,{contents:s,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(s=>t.add(s))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}w(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.x(t.defaults),s=this.x(t.policy),o=this.x(t.application),l=this.x(t.user),E=this.x(t.workspace),y=t.folders.reduce((c,b)=>(c.set(m.URI.revive(b[0]),this.x(b[1])),c),new T.ResourceMap);return new u(i,s,o,l,new d,E,y,new d,new T.ResourceMap)}static x(t){return new d(t.contents,t.keys,t.overrides)}}e.Configuration=u;function I(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,E])=>{const y=(0,T.getOrSet)(i,l,new Set);E.forEach(c=>y.add(c))});const s=[];return i.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=I;class p{constructor(t,i,s,o){this.change=t,this.f=i,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const E of l)this.affectedKeys.add(E);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(t,i){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const l=o+s.length;if(l>=this.d.length)return!1;const E=this.d.charCodeAt(l);if(E!==this.b&&E!==this.c)return!1;if(i){const y=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,c=this.g.getValue(t,i,this.h);return!D.equals(y,c)}return!0}}e.ConfigurationChangeEvent=p;function L(r,t){const{added:i,removed:s,updated:o}=n(t?.rawConfiguration,r?.rawConfiguration),l=[],E=r?.getAllOverrideIdentifiers()||[],y=t?.getAllOverrideIdentifiers()||[];if(t){const c=y.filter(b=>!E.includes(b));for(const b of c)l.push([b,t.getKeysForOverrideIdentifier(b)])}if(r){const c=E.filter(b=>!y.includes(b));for(const b of c)l.push([b,r.getKeysForOverrideIdentifier(b)])}if(t&&r){for(const c of E)if(y.includes(c)){const b=n({contents:r.getOverrideValue(void 0,c)||{},keys:r.getKeysForOverrideIdentifier(c)},{contents:t.getOverrideValue(void 0,c)||{},keys:t.getKeysForOverrideIdentifier(c)});l.push([c,[...b.added,...b.removed,...b.updated]])}}return{added:i,removed:s,updated:o,overrides:l}}function n(r,t){const i=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],s=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(r&&t){for(const l of t.keys)if(r.keys.indexOf(l)!==-1){const E=(0,P.getConfigurationValue)(t.contents,l),y=(0,P.getConfigurationValue)(r.contents,l);D.equals(E,y)||o.push(l)}}return{added:i,removed:s,updated:o}}}),define(oe[201],ae([0,1,21,3,2,31,10,73,48,8,55,40]),function(ne,e,k,U,A,N,T,D,C,m,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class S extends A.Disposable{constructor(){super(...arguments),this.a=this.B(new U.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new D.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:h})=>this.c(Array.from(a),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(a,h){this.h(a,v.Registry.as(C.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:a})}f(){return{}}g(){this.b=new D.ConfigurationModel;const a=v.Registry.as(C.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(a),a)}h(a,h){const u=this.f();for(const I of a){const p=u[I],L=h[I];p!==void 0?this.b.addValue(I,p):L?this.b.addValue(I,L.default):this.b.removeValue(I)}}}e.DefaultConfiguration=S;class f{constructor(){this.onDidChangeConfiguration=U.Event.None,this.configurationModel=new D.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let d=e.PolicyConfiguration=class extends A.Disposable{get configurationModel(){return this.b}constructor(a,h,u){super(),this.c=a,this.f=h,this.g=u,this.a=this.B(new U.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new D.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(a=>this.i(a))),this.B(this.c.onDidChangeConfiguration(async({properties:a})=>this.j(await this.h(a),!0))),this.b}async h(a){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",a);const h={},u=[],I=v.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(const p of a){const L=I[p];if(!L){u.push(p);continue}if(L.policy){if(L.type!=="string"&&L.type!=="number"){this.g.warn(`Policy ${L.policy.name} has unsupported type ${L.type}`);continue}u.push(p),h[L.policy.name]={type:L.type}}}return(0,T.isEmptyObject)(h)||await this.f.updatePolicyDefinitions(h),u}i(a){this.g.trace("PolicyConfiguration#onDidChangePolicies",a);const h=v.Registry.as(C.Extensions.Configuration).getPolicyConfigurations(),u=(0,k.coalesce)(a.map(I=>h.get(I)));this.j(u,!0)}j(a,h){this.g.trace("PolicyConfiguration#update",a);const u=v.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),I=[],p=this.b.isEmpty();for(const L of a){const n=u[L]?.policy?.name;if(n){const r=this.f.getPolicyValue(n);(p?r!==void 0:!(0,N.equals)(this.b.getValue(L),r))&&I.push([L,r])}else this.b.getValue(L)!==void 0&&I.push([L,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const L=this.b;this.b=new D.ConfigurationModel;for(const n of L.keys)this.b.setValue(n,L.getValue(n));for(const[n,r]of I)r===void 0?this.b.removeValue(n):this.b.setValue(n,r);h&&this.a.fire(this.b)}}};e.PolicyConfiguration=d=ve([X(1,P.IPolicyService),X(2,m.ILogService)],d)}),define(oe[202],ae([0,1,6,3,2,22,18,73,201,55]),function(ne,e,k,U,A,N,T,D,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends A.Disposable{constructor(S,f,d,w){super(),this.i=S,this.h=this.B(new U.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new C.DefaultConfiguration),this.c=d instanceof m.NullPolicyService?new C.NullPolicyConfiguration:this.B(new C.PolicyConfiguration(this.b,d,w)),this.f=this.B(new D.UserSettings(this.i,void 0,N.extUriBiasedIgnorePathCase,f)),this.a=new D.Configuration(this.b.configurationModel,this.c.configurationModel,new D.ConfigurationModel,new D.ConfigurationModel),this.g=this.B(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:h})=>this.k(a,h))),this.B(this.c.onDidChangeConfiguration(a=>this.l(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[S,f,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new D.Configuration(S,f,new D.ConfigurationModel,d)}getConfigurationData(){return this.a.toData()}getValue(S,f){const d=typeof S=="string"?S:void 0,w=(0,T.isConfigurationOverrides)(S)?S:(0,T.isConfigurationOverrides)(f)?f:{};return this.a.getValue(d,w,void 0)}updateValue(S,f,d,w){return Promise.reject(new Error("not supported"))}inspect(S){return this.a.inspect(S,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const S=await this.f.loadConfiguration();this.j(S)}j(S){const f=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(S);this.m(d,f,2)}k(S,f){const d=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(S,f);this.m(w,d,7)}l(S){const f=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(S);this.m(d,f,7)}m(S,f,d){const w=new D.ConfigurationChangeEvent(S,{data:f},this.a);w.source=d,w.sourceConfig=this.n(d),this.h.fire(w)}n(S){switch(S){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(oe[203],ae([0,1,16]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const U=(A,N,T)=>{const D=new Uint8Array(16);for(let P=0;P<16;P++)D[P]=Math.round(Math.random()*256);const C=(0,k.encodeBase64)(k.VSBuffer.wrap(D));return[`GET ws://localhost${A}?${N}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${C}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=U,e.socketRawEndHeaderSequence=k.VSBuffer.fromString(`\r
\r
`)}),define(oe[204],ae([0,1,7,4]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,U.createDecorator)("remoteAuthorityResolverService");var A;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class N{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=N;class T{constructor(v,S){this.host=v,this.port=S,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=T;var D;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(D||(e.RemoteAuthorityResolverErrorCode=D={}));class C extends k.ErrorNoTelemetry{static isNotAvailable(v){return v instanceof C&&v._code===D.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof C&&v._code===D.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof C&&v._code===D.NoResolverFound}static isHandled(v){return v instanceof C&&v.isHandled}constructor(v,S=D.Unknown,f){super(v),this._message=v,this._code=S,this._detail=f,this.isHandled=S===D.NotAvailable&&f===!0,Object.setPrototypeOf(this,C.prototype)}}e.RemoteAuthorityResolverError=C;function m(P){const v=P.indexOf("+");return v===-1?P:P.substring(0,v)}e.getRemoteAuthorityPrefix=m}),define(oe[74],ae([0,1,25]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function U(m){return m.scheme===k.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=U;function A(m){if(!m)return;const P=m.indexOf("+");return P<0?m:m.substr(0,P)}e.getRemoteName=A;function N(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=N;function T(m){const{host:P,port:v}=C(m);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:v}}e.parseAuthorityWithPort=T;function D(m,P){let{host:v,port:S}=C(m);return typeof S>"u"&&(S=P),{host:v,port:S}}e.parseAuthorityWithOptionalPort=D;function C(m){const P=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const v=m.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(oe[49],ae([0,1,27,4,74]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(T||(e.ExtensionType=T={}));var D;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(D||(e.TargetPlatform=D={}));class C{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,h){if(typeof a>"u"||a===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof a=="string"||typeof h=="string"){const u=typeof a=="string"?a:a.value,I=typeof h=="string"?h:h.value;return k.equalsIgnoreCase(u,I)}return a._lower===h._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.ExtensionIdentifier=C;class m{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const h of a)this.add(h)}add(a){this.c.add(C.toKey(a))}delete(a){return this.c.delete(C.toKey(a))}has(a){return this.c.has(C.toKey(a))}}e.ExtensionIdentifierSet=m;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(C.toKey(a))}get(a){return this.c.get(C.toKey(a))}has(a){return this.c.has(C.toKey(a))}set(a,h){this.c.set(C.toKey(a),h)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function v(w){return S(w)}e.isApplicationScopedExtension=v;function S(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function f(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function d(w,a){if(a){const h=`onResolveRemoteAuthority:${(0,A.getRemoteName)(a)}`;return!!w.activationEvents?.includes(h)}return!1}e.isResolverExtension=d,e.IBuiltinExtensionsScannerService=(0,U.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[205],ae([0,1,2,49,13]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends k.Disposable{constructor(D,C,m,P,v){super(),this.a=D,this.b=C,this.c=m,this.f=v,this.B(P.onDidInstallExtensions(S=>this.g(S))),this.B(P.onDidUninstallExtension(S=>this.h(S)))}g(D){for(const C of D)C.local&&this.invalidate(C.profileLocation)}h(D){D.error||this.invalidate(D.profileLocation)}async invalidate(D){if(D)for(const C of this.a.profiles)this.c.extUri.isEqual(C.extensionsResource,D)&&await this.i(C);else await this.i(this.a.defaultProfile)}async i(D){try{await this.b.del(this.c.extUri.joinPath(D.cacheHome,U.USER_MANIFEST_CACHE_FILE))}catch(C){(0,A.toFileOperationResult)(C)!==1&&this.f.error(C)}}}e.ExtensionsManifestCache=N}),define(oe[206],ae([0,1,6,16,26,7,3,2,100,88,32,92,204,74]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const d=30*1e3;var w;(function(g){g[g.Management=1]="Management",g[g.ExtensionHost=2]="ExtensionHost",g[g.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function a(g){switch(g){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(g){const O=new A.CancellationTokenSource;return setTimeout(()=>O.cancel(),g),O.token}function u(g,O){if(g.isCancellationRequested||O.isCancellationRequested)return A.CancellationToken.Cancelled;const B=new A.CancellationTokenSource;return g.onCancellationRequested(()=>B.cancel()),O.onCancellationRequested(()=>B.cancel()),B.token}class I{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new D.DisposableStore,this.promise=new Promise((B,W)=>{this.f=B,this.g=W}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function p(g,O){const B=new I(O);return B.registerDisposable(g.onControlMessage(W=>{const z=JSON.parse(W.toString()),J=Z(z);J?B.reject(J):B.resolve(z)})),B.promise}function L(g,O,B,W,z,J,ee,ce){const ue=new I(ce),de=m.StopWatch.create(!1);return g.info(`Creating a socket (${ee})...`),C.mark(`code/willCreateSocket/${J}`),O.connect(B,W,z,ee).then(Se=>{ue.didTimeout?(C.mark(`code/didCreateSocketError/${J}`),g.info(`Creating a socket (${ee}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),Se?.dispose()):(C.mark(`code/didCreateSocketOK/${J}`),g.info(`Creating a socket (${ee}) was successful after ${de.elapsed()} ms.`),ue.resolve(Se))},Se=>{C.mark(`code/didCreateSocketError/${J}`),g.info(`Creating a socket (${ee}) returned an error after ${de.elapsed()} ms.`),g.error(Se),ue.reject(Se)}),ue.promise}function n(g,O){const B=new I(O);return g.then(W=>{B.didTimeout||B.resolve(W)},W=>{B.didTimeout||B.reject(W)}),B.promise}async function r(g,O,B,W){const z=_(g,O);g.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let J;try{J=await L(g.logService,g.remoteSocketFactoryService,g.connectTo,(0,f.getRemoteServerRootPath)(g),`reconnectionToken=${g.reconnectionToken}&reconnection=${g.reconnectionProtocol?"true":"false"}`,a(O),`renderer-${a(O)}-${g.reconnectionToken}`,W)}catch(Se){throw g.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),g.logService.error(Se),Se}g.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let ee,ce;g.reconnectionProtocol?(g.reconnectionProtocol.beginAcceptReconnection(J,null),ee=g.reconnectionProtocol,ce=!1):(ee=new v.PersistentProtocol({socket:J,measureRoundTripTime:!0}),ce=!0),g.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const ue=await n(g.signService.createNewMessage((0,P.generateUuid)()),W),de={type:"auth",auth:g.connectionToken||"00000000000000000000",data:ue.data};ee.sendControl(U.VSBuffer.fromString(JSON.stringify(de)));try{const Se=await p(ee,u(W,h(1e4)));if(Se.type!=="sign"||typeof Se.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(g.logService.trace(`${z} 4/6. received SignRequest control message.`),!await n(g.signService.validate(ue,Se.signedData),W)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const be=await n(g.signService.sign(Se.data),W),De={type:"connectionType",commit:g.commit,signedData:be,desiredConnectionType:O};return B&&(De.args=B),g.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(U.VSBuffer.fromString(JSON.stringify(De))),{protocol:ee,ownsProtocol:ce}}catch(Se){throw Se&&Se.code==="ETIMEDOUT"&&(g.logService.error(`${z} the handshake timed out. Error:`),g.logService.error(Se)),Se&&Se.code==="VSCODE_CONNECTION_ERROR"&&(g.logService.error(`${z} received error control message when negotiating connection. Error:`),g.logService.error(Se)),ce&&j(ee),Se}}async function t(g,O,B,W){const z=Date.now(),J=_(g,O),{protocol:ee,ownsProtocol:ce}=await r(g,O,B,W),ue=new I(W);return ue.registerDisposable(ee.onControlMessage(de=>{const Se=JSON.parse(de.toString()),we=Z(Se);we?(g.logService.error(`${J} received error control message when negotiating connection. Error:`),g.logService.error(we),ce&&j(ee),ue.reject(we)):(g.reconnectionProtocol?.endAcceptReconnection(),g.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${$(z)}!`),ue.resolve({protocol:ee,firstMessage:Se}))})),ue.promise}async function i(g,O){const{protocol:B}=await t(g,1,void 0,O);return{protocol:B}}async function s(g,O,B){const{protocol:W,firstMessage:z}=await t(g,2,O,B),J=z&&z.debugPort;return{protocol:W,debugPort:J}}async function o(g,O,B){const W=Date.now(),z=_(g,3),{protocol:J}=await r(g,3,O,B);return g.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${$(W)}!`),J}async function l(g,O,B){const{connectTo:W,connectionToken:z}=await g.addressProvider.getAddress();return{commit:g.commit,quality:g.quality,connectTo:W,connectionToken:z,reconnectionToken:O,reconnectionProtocol:B,remoteSocketFactoryService:g.remoteSocketFactoryService,signService:g.signService,logService:g.logService}}async function E(g,O,B){return c(g,async W=>{const{protocol:z}=await i(W,A.CancellationToken.None);return new x(g,O,B,W.reconnectionToken,z)})}e.connectRemoteAgentManagement=E;async function y(g,O){return c(g,async B=>{const{protocol:W,debugPort:z}=await s(B,O,A.CancellationToken.None);return new G(g,O,B.reconnectionToken,W,z)})}e.connectRemoteAgentExtensionHost=y;async function c(g,O){for(let W=1;;W++)try{const z=(0,P.generateUuid)(),J=await l(g,z,null);return await O(J)}catch(z){if(W<5)g.logService.error(`[remote-connection][attempt ${W}] An error occurred in initial connection! Will retry... Error:`),g.logService.error(z);else throw g.logService.error(`[remote-connection][attempt ${W}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),g.logService.error(z),Y.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(z)),z}}async function b(g,O,B){const W=await l(g,(0,P.generateUuid)(),null);return await o(W,{host:O,port:B},A.CancellationToken.None)}e.connectRemoteAgentTunnel=b;function R(g){return(0,k.createCancelablePromise)(O=>new Promise((B,W)=>{const z=setTimeout(B,g*1e3);O.onCancellationRequested(()=>{clearTimeout(z),B()})}))}var M;(function(g){g[g.ConnectionLost=0]="ConnectionLost",g[g.ReconnectionWait=1]="ReconnectionWait",g[g.ReconnectionRunning=2]="ReconnectionRunning",g[g.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",g[g.ConnectionGain=4]="ConnectionGain",g[g.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(M||(e.PersistentConnectionEventType=M={}));class F{constructor(O,B){this.reconnectionToken=O,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=F;class H{constructor(O,B,W,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=B,this.durationSeconds=W,this.c=z,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=H;class q{constructor(O,B,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=B,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=q;class V{constructor(O,B,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=B,this.attempt=W,this.type=4}}e.ConnectionGainEvent=V;class Q{constructor(O,B){this.reconnectionToken=O,this.connectionHealth=B,this.type=5}}e.ConnectionHealthChangedEvent=Q;class te{constructor(O,B,W,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=B,this.attempt=W,this.handled=z,this.type=3}}e.ReconnectionPermanentFailureEvent=te;class Y extends D.Disposable{static triggerPermanentFailure(O,B,W){this._permanentFailure=!0,this.f=O,this.g=B,this.h=W,this.i.forEach(z=>z.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(O=>O.s())}static debugPauseSocketWriting(){this.i.forEach(O=>O.w())}get k(){return this.c||Y._permanentFailure}constructor(O,B,W,z,J){super(),this.n=O,this.p=B,this.reconnectionToken=W,this.protocol=z,this.r=J,this.j=this.B(new T.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new V(this.reconnectionToken,0,0)),this.B(z.onSocketClose(ee=>{const ce=K(this.n,this.reconnectionToken,!0);ee?ee.type===0?(this.p.logService.info(`${ce} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.p.logService.error(ee.error)):(this.p.logService.info(`${ce} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.p.logService.error(ee.event)):this.p.logService.info(`${ce} received socket close event.`),this.s()})),this.B(z.onSocketTimeout(ee=>{const ce=K(this.n,this.reconnectionToken,!0);this.p.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.s()})),this.B(z.onHighRoundTripTime(ee=>{const ce=se(this.n,this.reconnectionToken);this.p.logService.info(`${ce} high roundtrip time: ${ee.roundTripTime}ms (${ee.recentHighRoundTripCount} of 5 recent samples)`)})),this.B(z.onDidChangeConnectionHealth(ee=>{this.j.fire(new Q(this.reconnectionToken,ee))})),Y.i.push(this),this.B((0,D.toDisposable)(()=>{const ee=Y.i.indexOf(this);ee>=0&&Y.i.splice(ee,1)})),this.k&&this.v(Y.f,Y.g,Y.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const O=K(this.n,this.reconnectionToken,!0);this.p.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const z=W<B.length?B[W]:B[B.length-1];try{if(z>0){const ee=R(z);this.j.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,ee)),this.p.logService.info(`${O} waiting for ${z} seconds before reconnecting...`);try{await ee}catch{}}if(this.k){this.p.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this.p.logService.info(`${O} resolving connection...`);const J=await l(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${O} connecting to ${J.connectTo}...`),await this.y(J,h(d)),this.p.logService.info(`${O} reconnected!`),this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(J),this.u(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this.p.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(J),this.u(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(J)){this.p.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this.p.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(J);continue}if((0,N.isCancellationError)(J)){this.p.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(J);continue}if(J instanceof S.RemoteAuthorityResolverError){this.p.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(J),this.u(this.protocol.getMillisSinceLastIncomingData(),W+1,S.RemoteAuthorityResolverError.isHandled(J));break}this.p.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(J),this.u(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this.k&&!this.m)}u(O,B,W){this.r?Y.triggerPermanentFailure(O,B,W):this.v(O,B,W)}v(O,B,W){this.j.fire(new te(this.reconnectionToken,O,B,W)),j(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=Y,Y._permanentFailure=!1,Y.f=0,Y.g=0,Y.h=!1,Y.i=[];class x extends Y{constructor(O,B,W,z,J){super(1,O,z,J,!0),this.client=this.B(new v.Client(J,{remoteAuthority:B,clientId:W},O.ipcLogger))}async y(O,B){await i(O,B)}}e.ManagementPersistentConnection=x;class G extends Y{constructor(O,B,W,z,J){super(2,O,W,z,!1),this.z=B,this.debugPort=J}async y(O,B){await s(O,this.z,B)}}e.ExtensionHostPersistentConnection=G;function j(g){try{g.acceptDisconnect();const O=g.getSocket();g.dispose(),O.dispose()}catch(O){(0,N.onUnexpectedError)(O)}}function Z(g){if(g&&g.type==="error"){const O=new Error(`Connection error: ${g.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function ie(g,O){for(;g.length<O;)g+=" ";return g}function se(g,O){return`[remote-connection][${ie(a(g),13)}][${O.substr(0,5)}\u2026]`}function K(g,O,B){return`${se(g,O)}[${B?"reconnect":"initial"}]`}function _(g,O){return`${K(O,g.reconnectionToken,!!g.reconnectionProtocol)}[${g.connectTo}]`}function $(g){return`${Date.now()-g} ms`}}),define(oe[104],ae([0,1,2,4]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,U.createDecorator)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(T,D){return this.a[T]??=[],this.a[T].push(D),(0,k.toDisposable)(()=>{const C=this.a[T]?.indexOf(D);typeof C=="number"&&C>=0&&this.a[T]?.splice(C,1)})}b(T){return(this.a[T.type]||[]).find(C=>C.supports(T))}connect(T,D,C,m){const P=this.b(T);if(!P)throw new Error(`No socket factory found for ${T}`);return P.connect(T,D,C,m)}}e.RemoteSocketFactoryService=A}),define(oe[207],ae([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,157]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,k.createDecorator)("IRemoteTunnelService");var A;(function(N){N.disconnected=T=>({type:"disconnected",onTokenFailed:T}),N.connected=T=>({type:"connected",info:T}),N.connecting=T=>({type:"connecting",progress:T}),N.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,U.localize)(0,null)}),define(oe[56],ae([0,1,16,7,2,159,48,4,8,40]),function(ne,e,k,U,A,N,T,D,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");class P{constructor(L){this.b=L}toJSON(){if(!this.a){const L=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?L[n]="*****":L[n]=this.b[n];this.a=L}return this.a}}class v extends A.Disposable{constructor(L){super(),this.b=0,this.a=L.createLogger("network",{name:(0,N.localize)(0,null),when:C.CONTEXT_LOG_LEVEL.isEqualTo((0,C.LogLevelToString)(C.LogLevel.Trace)).serialize()})}async c(L,n,r){const t=`${L} #${++this.b}: ${n.url}`;this.a.trace(`${t} - begin`,n.type,new P(n.headers??{}));try{const i=await r();return this.a.trace(`${t} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,n.type,(0,U.getErrorMessage)(i)),i}}}e.AbstractRequestService=v;function S(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=S;function f(p){return p.res.statusCode===204}async function d(p){return f(p)?null:(await(0,k.streamToBuffer)(p.stream)).toString()}e.asText=d;async function w(p){if(!S(p))throw new Error("Server returned "+p.res.statusCode);return d(p)}e.asTextOrError=w;async function a(p){if(!S(p))throw new Error("Server returned "+p.res.statusCode);if(f(p))return null;const n=(await(0,k.streamToBuffer)(p.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}e.asJson=a;function h(p){I(p)}e.updateProxyConfigurationsScope=h;let u;function I(p){const L=m.Registry.as(T.Extensions.Configuration),n=u;u={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(5,null),(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null)],default:"override",description:(0,N.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(10,null),restricted:!0}}},L.updateConfigurations({add:[u],remove:n?[n]:[]})}I(1)}),define(oe[208],ae([0,1,26,25,13,56]),function(ne,e,k,U,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=e.DownloadService=class{constructor(C,m){this.a=C,this.b=m}async download(C,m,P=k.CancellationToken.None){if(C.scheme===U.Schemas.file||C.scheme===U.Schemas.vscodeRemote){await this.b.copy(C,m);return}const v={type:"GET",url:C.toString(!0)},S=await this.a.request(v,P);if(S.res.statusCode===200)await this.b.writeFile(m,S.stream);else{const f=await(0,N.asTextOrError)(S);throw new Error(`Expected 200, got back ${S.res.statusCode} instead.

${f}`)}}};e.DownloadService=T=ve([X(0,N.IRequestService),X(1,A.IFileService)],T)}),define(oe[209],ae([0,1,16,26]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class A{constructor(D){this.a=D}listen(D,C){throw new Error("Invalid listen")}call(D,C,m,P=U.CancellationToken.None){switch(C){case"request":return this.a.request(m[0],P).then(async({res:v,stream:S})=>{const f=await(0,k.streamToBuffer)(S);return[{statusCode:v.statusCode,headers:v.headers},f]});case"resolveProxy":return this.a.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=A;class N{constructor(D){this.a=D}async request(D,C){const[m,P]=await this.a.call("request",[D],C);return{res:m,stream:(0,k.bufferToStream)(P)}}async resolveProxy(D){return this.a.call("resolveProxy",[D])}}e.RequestChannelClient=N}),define(oe[210],ae([0,1,59,25,175]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class N extends A.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:U.Schemas.vscodeUserData})}}e.SharedProcessEnvironmentService=N,ve([k.memoize],N.prototype,"userRoamingDataHome",null)}),define(oe[211],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class k{constructor(){this.b=new Map}async createNewMessage(A){try{const N=await this.c();if(N){const T=String(k.a++);return this.b.set(T,N),{id:T,data:N.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,N){if(!A.id)return!0;const T=this.b.get(A.id);if(!T)return!1;this.b.delete(A.id);try{return T.validate(N)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.AbstractSignService=k,k.a=1}),define(oe[106],ae([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[212],ae([0,1,211]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class U extends k.AbstractSignService{c(){return this.h().then(N=>new N.validator)}d(N){return this.h().then(T=>new T.signer().sign(N))}h(){return new Promise((N,T)=>ne(["vsda"],N,T))}}e.SignService=U}),define(oe[75],ae([0,1,3,2]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class A extends U.Disposable{constructor(v,S,f){super(),this.a=v,this.b=S,this.c=f}async getItems(){const v={profile:this.b,workspace:this.c},S=await this.a.call("getItems",v);return new Map(S)}updateItems(v){const S={profile:this.b,workspace:this.c};return v.insert&&(S.insert=Array.from(v.insert.entries())),v.delete&&(S.delete=Array.from(v.delete.values())),this.a.call("updateItems",S)}}class N extends A{constructor(v,S){super(v,S,void 0),this.f=this.B(new k.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(v=>this.h(v)))}h(v){(Array.isArray(v.changed)||Array.isArray(v.deleted))&&this.f.fire({changed:v.changed?new Map(v.changed):void 0,deleted:v.deleted?new Set(v.deleted):void 0})}}class T extends N{constructor(v){super(v,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class D extends N{constructor(v,S){super(v,S)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=D;class C extends A{constructor(v,S){super(v,void 0,S),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=C;class m{constructor(v){this.a=v}isUsed(v){const S={payload:v,profile:void 0,workspace:void 0};return this.a.call("isUsed",S)}}e.StorageClient=m}),define(oe[107],ae([0,1,5,37,32]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(C){if(k.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}function T(C,m,P,v,S,f,d,w){const a=Object.create(null);a["common.machineId"]=f,a.sessionID=(0,A.generateUuid)()+Date.now(),a.commitHash=v,a.version=S,a["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,k.PlatformToString)(k.platform),a["common.nodePlatform"]=U.platform,a["common.nodeArch"]=P,a["common.product"]=w||"desktop",d&&(a["common.msftInternal"]=d);let h=0;const u=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),k.isLinuxSnap&&(a["common.snap"]="true");const I=N(m);return I&&(a["common.platformDetail"]=I),a}e.resolveCommonProperties=T;function D(C){const m=U.env.USERDNSDOMAIN;if(!m)return!1;const P=m.toLowerCase();return C.some(v=>P===v)}e.verifyMicrosoftInternalDomain=D}),define(oe[20],ae([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var U;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(U||(e.TelemetryLevel=U={}));var A;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(oe[213],ae([0,1,36,6,34,25,15,5,12,136,30,139,95,13,24,20]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const a=new Map;async function h(n,r){const t=`${n}::${r.join(":")}`,i=a.get(t);if(i)return i;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,l=new Map,E=2e4;function y(b,R,M,F){const H=R.substring(b.length+1);return U.Promises.withAsyncBody(async q=>{let V;try{V=await P.Promises.readdir(R,{withFileTypes:!0})}catch{q();return}if(F.count>=E){F.count+=V.length,F.maxReached=!0,q();return}let Q=V.length;if(Q===0){q();return}let te=V;F.count+V.length>E&&(F.maxReached=!0,Q=E-F.count,te=V.slice(0,Q)),F.count+=V.length;for(const Y of te)if(Y.isDirectory()){if(M.includes(Y.name)||await y(b,(0,T.join)(R,Y.name),M,F),--Q===0){q();return}}else{const x=Y.name.lastIndexOf(".");if(x>=0){const G=Y.name.substring(x+1);G&&o.set(G,(o.get(G)??0)+1)}for(const G of s)G.relativePathPattern?.test(H)!==!1&&G.filePattern.test(Y.name)&&l.set(G.tag,(l.get(G.tag)??0)+1);if(--Q===0){q();return}}})}const c=U.Promises.withAsyncBody(async b=>{const R={count:0,maxReached:!1};await y(n,n,r,R);const M=await p(n);b({configFiles:u(l),fileTypes:u(o),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:M})});return a.set(t,c),c}e.collectWorkspaceStats=h;function u(n){return Array.from(n.entries(),([r,t])=>({name:r,count:t})).sort((r,t)=>t.count-r.count)}function I(){const n={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},r=k.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=I;async function p(n){try{const r=new Map,t=(0,T.join)(n,".vscode","launch.json"),i=await P.Promises.readFile(t),s=[],o=(0,A.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,A.getNodeType)(o)==="object"&&o.configurations)for(const l of o.configurations){const E=l.type;E&&(r.has(E)?r.set(E,r.get(E)+1):r.set(E,1))}return u(r)}catch{return[]}}e.collectLaunchConfigs=p;let L=e.DiagnosticsService=class{constructor(r,t){this.c=r,this.d=t}f(r){const t=[];return t.push(`OS Version:       ${r.os}`),t.push(`CPUs:             ${r.cpus}`),t.push(`Memory (System):  ${r.memory}`),t.push(`VM:               ${r.vmHint}`),t.join(`
`)}g(r){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const i=k.cpus();return i&&i.length>0&&t.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),t.push(`Memory (System):  ${(k.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),D.isWindows||t.push(`Load (avg):       ${k.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${r.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(r,t){return Promise.all([(0,v.listProcesses)(r.mainPID),this.k(r)]).then(async i=>{let[s,o]=i,l=this.m(r,s);return t.forEach(E=>{if((0,S.isRemoteDiagnosticError)(E))l+=`
${E.errorMessage}`,o+=`
${E.errorMessage}`;else if(l+=`

Remote: ${E.hostName}`,E.processes&&(l+=`
${this.m(r,E.processes)}`),E.workspaceMetadata){o+=`
|  Remote: ${E.hostName}`;for(const y of Object.keys(E.workspaceMetadata)){const c=E.workspaceMetadata[y];let b=`${c.fileCount} files`;c.maxFilesReached&&(b=`more than ${b}`),o+=`|    Folder (${y}): ${b}`,o+=this.h(c)}}}),{processInfo:l,workspaceInfo:o}})}async getSystemInfo(r,t){const{memory:i,vmHint:s,os:o,cpus:l}=I(),E={os:o,memory:i,cpus:l,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:t};return D.isWindows||(E.load=`${k.loadavg().map(y=>Math.round(y)).join(", ")}`),D.isLinux&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(r,t){const i=[];return(0,v.listProcesses)(r.mainPID).then(async s=>(i.push(""),i.push(this.g(r)),i.push(""),i.push(this.m(r,s)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(r))),t.forEach(o=>{if((0,S.isRemoteDiagnosticError)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.f(o.machineInfo)),o.processes&&i.push(this.m(r,o.processes)),o.workspaceMetadata)for(const l of Object.keys(o.workspaceMetadata)){const E=o.workspaceMetadata[l];let y=`${E.fileCount} files`;E.maxFilesReached&&(y=`more than ${y}`),i.push(`Folder (${l}): ${y}`),i.push(this.h(E))}}),i.push(""),i.push(""),i.join(`
`)))}h(r){const t=[];let s=0;const o=(c,b)=>{const R=` ${c}(${b})`;s+R.length>60?(t.push(l),l="|                 ",s=l.length):s+=R.length,l+=R};let l="|      File types:";const E=10,y=r.fileTypes.length>E?E:r.fileTypes.length;for(let c=0;c<y;c++){const b=r.fileTypes[c];o(b.name,b.count)}if(t.push(l),r.configFiles.length>=0&&(l="|      Conf files:",s=0,r.configFiles.forEach(c=>{o(c.name,c.count)}),t.push(l)),r.launchConfigFiles.length>0){let c="|      Launch Configs:";r.launchConfigFiles.forEach(b=>{const R=b.count>1?` ${b.name}(${b.count})`:` ${b.name}`;c+=R}),t.push(c)}return t.join(`
`)}j(r){const t=Math.max(...Object.keys(r).map(i=>i.length));return Object.keys(r).map(i=>`${i}:  ${" ".repeat(t-i.length)}  ${r[i]}`).join(`
                  `)}k(r){const t=[],i=[];return r.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const l=C.URI.revive(o);if(l.scheme===N.Schemas.file){const E=l.fsPath;i.push(h(E,["node_modules",".git"]).then(y=>{let c=`${y.fileCount} files`;y.maxFilesReached&&(c=`more than ${c}`),t.push(`|    Folder (${(0,T.basename)(E)}): ${c}`),t.push(this.h(y))}).catch(y=>{t.push(`|      Error: Unable to collect workspace stats for folder ${E} (${y.toString()})`)}))}else t.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(r,t){const i=new Map;r.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:l})=>i.set(o,l));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.n(r.mainPID,i,s,t,0),s.join(`
`)}n(r,t,i,s,o){const l=o===0;let E;l?E=s.pid===r?`${this.d.applicationName} main`:"remote agent":t.has(s.pid)?E=t.get(s.pid):E=`${"  ".repeat(o)} ${s.name}`;const y=process.platform==="win32"?s.mem:k.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(y/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(s.children)&&s.children.forEach(c=>this.n(r,t,i,c,o+1))}async getWorkspaceFileExtensions(r){const t=new Set;for(const{uri:i}of r.folders){const s=C.URI.revive(i);if(s.scheme!==N.Schemas.file)continue;const o=s.fsPath;try{(await h(o,["node_modules",".git"])).fileTypes.forEach(E=>t.add(E.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(r){for(const{uri:t}of r.folders){const i=C.URI.revive(t);if(i.scheme!==N.Schemas.file)continue;const s=i.fsPath;try{const o=await h(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(l=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})}),o.launchConfigFiles.forEach(l=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})}),o.configFiles.forEach(l=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};e.DiagnosticsService=L=ve([X(0,w.ITelemetryService),X(1,d.IProductService)],L)}),define(oe[108],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(N){this.b=N}listen(N,T){throw new Error(`Event not found: ${T}`)}call(N,T,{eventName:D,data:C}){return this.b.forEach(m=>m.log(D,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class U{constructor(N){this.b=N}log(N,T){return this.b.call("log",{eventName:N,data:T}).then(void 0,D=>`Failed to log telemetry: ${console.warn(D)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=U}),define(oe[45],ae([0,1,31,10,3,18,74,107,20]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class v{async publicLog(s,o,l){}async publicLogError(s,o,l){}}e.NullEndpointTelemetryService=v,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(i,s){return A.Event.debounce(s.onDidChangeConfiguration,(l,E)=>{const y=l?new Set([...l.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:y}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,N.ConfigurationTargetToString)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.configurationTelemetry=S;function f(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=f;function d(i,s){return!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=d;function w(i){const s=i.getValue(C.TELEMETRY_SETTING_ID),o=i.getValue(C.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function a(i){const s={},o={},l={};I(i,l);for(let E in l){E=E.length>150?E.substr(E.length-149):E;const y=l[E];typeof y=="number"?o[E]=y:typeof y=="boolean"?o[E]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${y.length}`),s[E]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(s[E]=y)}return{properties:s,measurements:o}}e.validateTelemetryData=a;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const s=(0,T.getRemoteName)(i);return h.has(s)?s:"other"}e.cleanRemoteAuthority=u;function I(i,s,o=0,l){if(i)for(const E of Object.getOwnPropertyNames(i)){const y=i[E],c=l?l+E:E;Array.isArray(y)?s[c]=(0,k.safeStringify)(y):y instanceof Date?s[c]=y.toISOString():(0,U.isObject)(y)?o<2?I(y,s,o+1,c+"."):s[c]=(0,k.safeStringify)(y):s[c]=y}}function p(i,s){const o=i.msftInternalDomains||[],l=s.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(o)||l}e.isInternalTelemetry=p;function L(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=L;function n(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const l=[];for(const b of s)for(;;){const R=b.exec(i);if(!R)break;l.push([R.index,b.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(o="";;){const b=y.exec(i);if(!b)break;const R=l.some(([M,F])=>b.index<F&&M<y.lastIndex);!E.test(b[0])&&!R&&(o+=i.substring(c,b.index)+"<REDACTED: user-file-path>",c=y.lastIndex)}return c<i.length&&(o+=i.substr(c)),o}function r(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of s)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function t(i,s){return(0,k.cloneAndChange)(i,o=>{if(o instanceof m||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let l=o.replaceAll("%20"," ");l=n(l,s);for(const E of s)l=l.replace(E,"");return l=r(l),l}})}e.cleanData=t}),define(oe[33],ae([0,1,27,28,49,5,12,7,37,45]),function(ne,e,k,U,A,N,T,D,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,k.compareIgnoreCase)(t.id,i.id)===0}e.areSameExtensions=P;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(i){const s=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new S(i.identifier,s,o)}static parse(i){const s=v.exec(i);return s&&s[1]&&s[2]?new S({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof S?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=S;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(t){const i=f.exec(t);return i&&i[1]?[a(i[1]),i[2]]:[a(t),void 0]}e.getIdAndVersion=d;function w(t,i){return`${t}.${i}`}e.getExtensionId=w;function a(t){return t.toLowerCase()}e.adoptToGalleryExtensionId=a;function h(t,i){return a(w(t??A.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=h;function u(t,i){const s=[],o=l=>{for(const E of s)if(E.some(y=>P(i(y),i(l))))return E;return null};for(const l of t){const E=o(l);E?E.push(l):s.push([l])}return s}e.groupByExtension=u;function I(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function p(t){return{id:new m.TelemetryTrustedValue(t.identifier.id),name:new m.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function L(t,i){const s=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(E=>!P(E.identifier,{id:l}))){const E=t.filter(y=>P(y.identifier,{id:l}));E.length===1&&(s.push(E[0]),o.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=L;async function n(t,i){if(!N.isLinux)return!1;let s;try{s=(await t.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,i){const s=await n(t,i),o=(0,U.getTargetPlatform)(s?"alpine":N.platform,C.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=r}),define(oe[214],ae([0,1,21,2,22,12,13,24,6,3,15,5,37,33]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let d=e.ExtensionTipsService=class extends U.Disposable{constructor(I,p){super(),this.b=I,this.c=p,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,L])=>this.a.set(L.configPath,L))}getConfigBasedTips(I){return this.f(I)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(I){const p=[];for(const[L,n]of this.a)if(!(n.configScheme&&n.configScheme!==I.scheme))try{const r=(await this.b.readFile((0,A.joinPath)(I,L))).value.toString();for(const[t,i]of Object.entries(n.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(r))&&p.push({extensionId:t,extensionName:i.name,configName:n.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return p}};e.ExtensionTipsService=d=ve([X(0,T.IFileService),X(1,D.IProductService)],d);const w="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";class h extends d{constructor(I,p,L,n,r,t,i,s){super(i,s),this.m=I,this.n=p,this.r=L,this.s=n,this.t=r,this.u=t,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,s.exeBasedExtensionTips&&Object.entries(s.exeBasedExtensionTips).forEach(([o,l])=>{const E=[],y=[],c=[];Object.entries(l.recommendations).forEach(([b,R])=>{R.important?l.important?E.push({extensionId:b,extensionName:R.name,isExtensionPack:!!R.isExtensionPack}):y.push({extensionId:b,extensionName:R.name,isExtensionPack:!!R.isExtensionPack}):c.push({extensionId:b,extensionName:R.name,isExtensionPack:!!R.isExtensionPack})}),E.length&&this.g.set(o,{exeFriendlyName:l.friendlyName,windowsPath:l.windowsPath,recommendations:E}),y.length&&this.h.set(o,{exeFriendlyName:l.friendlyName,windowsPath:l.windowsPath,recommendations:y}),c.length&&this.j.set(o,{exeFriendlyName:l.friendlyName,windowsPath:l.windowsPath,recommendations:c})}),(0,C.timeout)(3e3).then(async()=>{await this.v(),this.z(),this.C()})}async getImportantExecutableBasedTips(){const I=await this.L(this.g),p=await this.L(this.h);return[...I,...p]}getOtherExecutableBasedTips(){return this.L(this.j)}async v(){const I=await this.L(this.g),p=await this.L(this.h),L=await this.s.getInstalled();this.k=this.w(I,L),this.l=this.w(p,L)}w(I,p){const L=new Map;I.forEach(s=>L.set(s.extensionId.toLowerCase(),s));const{installed:n,uninstalled:r}=this.J([...L.keys()],p);for(const s of n){const o=L.get(s);o&&this.r.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:s,exeName:o.exeName})}for(const s of r){const o=L.get(s);o&&this.r.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:s,exeName:o.exeName})}const t=this.H(),i=new Map;for(const s of r){const o=L.get(s);if(o&&(!t[o.exeName]||!t[o.exeName].includes(o.extensionId))){let l=i.get(o.exeName);l||(l=[],i.set(o.exeName,l)),l.push(o)}}return i}z(){if(this.k.size===0)return;const[I,p]=[...this.k.entries()][0];this.D(p).then(L=>{switch(L){case"reacted":this.I(p[0].exeName,p);break;case"ignored":this.k.delete(I);break;case"incompatibleWindow":{const n=m.Event.once(m.Event.latch(m.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(n(()=>this.z()));break}case"toomany":{const n=this.B((0,C.disposableTimeout)(()=>{n.dispose(),this.z()},36e5));break}}})}C(){if(this.l.size===0)return;const I=this.F(),p=Date.now()-I,L=7*24*60*60*1e3;if(p<L){const t=this.B((0,C.disposableTimeout)(()=>{t.dispose(),this.C()},L-p));return}const[n,r]=[...this.l.entries()][0];this.D(r).then(t=>{switch(t){case"reacted":{this.G(Date.now()),this.l.delete(n),this.I(r[0].exeName,r);const i=this.B((0,C.disposableTimeout)(()=>{i.dispose(),this.C()},L));break}case"ignored":this.l.delete(n),this.C();break;case"incompatibleWindow":{const i=m.Event.once(m.Event.latch(m.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(i(()=>this.C()));break}case"toomany":{const i=this.B((0,C.disposableTimeout)(()=>{i.dispose(),this.C()},36e5));break}}})}async D(I){const p=await this.s.getInstalled(1),L=I.filter(n=>!n.whenNotInstalled||n.whenNotInstalled.every(r=>p.every(t=>!(0,f.areSameExtensions)(t.identifier,{id:r})))).map(({extensionId:n})=>n.toLowerCase());return this.u.promptImportantExtensionsInstallNotification({extensions:L,source:3,name:I[0].exeFriendlyName,searchValue:`@exe:"${I[0].exeName}"`})}F(){let I=this.t.getNumber(a,-1);return I||(I=Date.now(),this.G(I)),I}G(I){this.t.store(a,I,-1,1)}H(){return JSON.parse(this.t.get(w,-1,"{}"))}I(I,p){const L=this.H();L[I]=p.map(({extensionId:n})=>n.toLowerCase()),this.t.store(w,JSON.stringify(L),-1,0)}J(I,p){const L=[],n=[],r=p.reduce((t,i)=>(t.add(i.identifier.id.toLowerCase()),t),new Set);return I.forEach(t=>{r.has(t.toLowerCase())?L.push(t):n.push(t)}),{installed:L,uninstalled:n}}async L(I){const p=[],L=new Map;for(const n of I.keys()){const r=I.get(n);if(!r||!(0,k.isNonEmptyArray)(r.recommendations))continue;const t=[];v.isWindows?r.windowsPath&&t.push(r.windowsPath.replace("%USERPROFILE%",()=>S.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>S.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>S.env.ProgramFiles).replace("%APPDATA%",()=>S.env.APPDATA).replace("%WINDIR%",()=>S.env.WINDIR)):(t.push((0,P.join)("/usr/local/bin",n)),t.push((0,P.join)("/usr/bin",n)),t.push((0,P.join)(this.m.fsPath,n)));for(const i of t){let s=L.get(i);if(s===void 0&&(s=await this.b.exists(N.URI.file(i)),L.set(i,s)),s)for(const{extensionId:o,extensionName:l,isExtensionPack:E,whenNotInstalled:y}of r.recommendations)p.push({extensionId:o,extensionName:l,isExtensionPack:E,exeName:n,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:y})}}return p}}e.AbstractNativeExtensionTipsService=h}),define(oe[215],ae([0,1,26,33]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function A(N,T,D,C,m){try{const P=await N.getExtensionsControlManifest();if(!P.deprecated)return;const v=await N.getInstalled(1);for(const[S,f]of Object.entries(P.deprecated)){if(!f?.extension)continue;const{id:d,autoMigrate:w,preRelease:a}=f.extension;if(!w)continue;const h=v.find(I=>(0,U.areSameExtensions)(I.identifier,{id:S}));if(!h)continue;const u=(await T.getExtensions([{id:d,preRelease:a}],{targetPlatform:await N.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!u){m.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{m.info(`Migrating '${h.identifier.id}' extension to '${d}' extension...`);const I=!C.getDisabledExtensions().some(L=>(0,U.areSameExtensions)(L,h.identifier));await N.uninstall(h),m.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let p=v.find(L=>(0,U.areSameExtensions)(L.identifier,{id:d}));(!p||!p.isPreReleaseVersion&&I)&&(p=await N.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),m.info(`Installed the pre-release extension '${p.identifier.id}'`),I||(await C.disableExtension(p.identifier),m.info(`Disabled the pre-release extension '${p.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),w.storage&&(D.addToMigrationList((0,U.getExtensionId)(h.manifest.publisher,h.manifest.name),(0,U.getExtensionId)(p.manifest.publisher,p.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${h.identifier.id}' extension to '${d}' extension.`)}catch(I){m.error(I)}}}catch(P){m.error(P)}}e.migrateUnsupportedExtensions=A}),define(oe[216],ae([0,1,3,2,35,33,49]),function(ne,e,k,U,A,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class D extends U.Disposable{constructor(m,P,v,S,f,d,w){super(),this.f=m,this.g=P,this.h=v,this.i=S,this.j=f,this.k=d,this.l=w,this.a=this.B(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new U.DisposableMap),this.m().then(null,a=>w.error(a))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(m=>this.p(m.added,m.removed))),this.B(this.i.onAddExtensions(m=>this.r(m))),this.B(this.i.onDidAddExtensions(m=>this.s(m))),this.B(this.i.onRemoveExtensions(m=>this.t(m))),this.B(this.i.onDidRemoveExtensions(m=>this.u(m))),this.B(this.k.onDidFilesChange(m=>this.v(m)))}async p(m,P){try{await Promise.all(P.map(v=>(this.c.deleteAndDispose(v.id),this.z(v.extensionsResource)))),m.length&&await Promise.all(m.map(v=>(this.c.set(v.id,(0,U.combinedDisposable)(this.k.watch(this.j.extUri.dirname(v.extensionsResource)),this.k.watch(v.extensionsResource))),this.y(v.extensionsResource))))}catch(v){throw this.l.error(v),v}}async r(m){for(const P of m.extensions)this.D(this.G(P.identifier,P.version),m.profileLocation)}async s(m){for(const P of m.extensions){const v=this.G(P.identifier,P.version);m.error?this.F(v,m.profileLocation):this.D(v,m.profileLocation)}}async t(m){for(const P of m.extensions)this.F(this.G(P.identifier,P.version),m.profileLocation)}async u(m){const P=[],v=[];for(const S of m.extensions){const f=this.G(S.identifier,S.version);m.error?this.D(f,m.profileLocation):(this.F(f,m.profileLocation),this.b.has(f)||(this.l.debug("Extension is removed from all profiles",S.identifier.id,S.version),v.push(this.f.scanInstalledExtensionAtLocation(S.location).then(d=>{d?P.push(d):this.l.info("Extension not found at the location",S.location.toString())},d=>this.l.error(d)))))}try{await Promise.all(v),P.length&&await this.C(P)}catch(S){this.l.error(S)}}v(m){for(const P of this.h.profiles)m.contains(P.extensionsResource,0,1)&&this.w(P.extensionsResource)}async w(m){const P=[],v=[],S=await this.i.scanProfileExtensions(m),f=new Set,d=new Set;for(const[w,a]of this.b)a.has(m)&&d.add(w);for(const w of S){const a=this.G(w.identifier,w.version);f.add(a),d.has(a)||(P.push(w.identifier),this.D(a,m))}for(const w of d)if(!f.has(w)){const a=this.H(w);a&&(v.push(a.identifier),this.F(w,m))}(P.length||v.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:m}:void 0,removed:v.length?{extensions:v,profileLocation:m}:void 0})}async y(m){const P=await this.i.scanProfileExtensions(m);for(const v of P)this.D(this.G(v.identifier,v.version),m)}async z(m){for(const P of[...this.b.keys()])this.F(P,m);await this.C()}async C(m){m||(m=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.G(v.identifier,v.manifest.version)))),m.length&&await this.f.markAsUninstalled(...m)}D(m,P){let v=this.b.get(m);v||this.b.set(m,v=new A.ResourceSet(S=>this.j.extUri.getComparisonKey(S))),v.add(P)}F(m,P){const v=this.b.get(m);v&&v.delete(P),v?.size||this.b.delete(m)}G(m,P){return`${T.ExtensionIdentifier.toKey(m.id)}@${P}`}H(m){const[P,v]=(0,N.getIdAndVersion)(m);return v?{identifier:{id:P},version:v}:void 0}}e.ExtensionsWatcher=D}),define(oe[217],ae([0,1,44,45]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function A(N,T,D,C,m,P,v){const S={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${T.nameShort})`};if((0,U.supportsTelemetry)(T,D)&&(0,U.getTelemetryLevel)(C)===3){const f=await(0,k.getServiceMachineId)(D,m,P);S["X-Market-User-Id"]=f,S["VSCode-SessionId"]=v.machineId||f}return S}e.resolveMarketplaceHeaders=A}),define(oe[218],ae([0,1,69,21,6,2,25,15,30,14,28,33,8,72,12]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let w=e.NativeLanguagePackService=class extends f.LanguagePackBaseService{constructor(I,p,L,n){super(L),this.h=I,this.i=n,this.g=this.B(new a(p,n)),this.h.registerParticipant({postInstall:async r=>this.j(r),postUninstall:async r=>this.k(r)})}async getBuiltInExtensionTranslationsUri(I,p){const n=(await this.g.getLanguagePacks())[p];if(!n){this.i.warn(`No language pack found for ${p}`);return}const r=n.translations[I];return r?d.URI.file(r):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),p=Object.keys(I).map(L=>{const n=I[L];return{...this.f(L,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((L,n)=>L.label.localeCompare(n.label)),p}async j(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",I.identifier.id),await this.update())}async k(I){const p=await this.g.getLanguagePacks();Object.keys(p).some(L=>p[L]&&p[L].extensions.some(n=>(0,v.areSameExtensions)(n.extensionIdentifier,I.identifier)))&&(this.i.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),L=await this.g.update(p);return!(0,U.equals)(Object.keys(I),Object.keys(L))}};e.NativeLanguagePackService=w=ve([X(0,P.IExtensionManagementService),X(1,m.INativeEnvironmentService),X(2,P.IExtensionGalleryService),X(3,S.ILogService)],w);let a=class extends N.Disposable{constructor(I,p){super(),this.i=p,this.c={},this.f=(0,D.join)(I.userDataPath,"languagepacks.json"),this.g=new A.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.m(p=>{Object.keys(p).forEach(L=>delete p[L]),this.j(p,...I)}).then(()=>this.c)}j(I,...p){for(const L of p)L&&L.manifest&&L.manifest.contributes&&L.manifest.contributes.localizations&&L.manifest.contributes.localizations.length&&this.k(I,L);Object.keys(I).forEach(L=>this.l(I[L]))}k(I,p){const L=p.identifier,n=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const r of n)if(p.location.scheme===T.Schemas.file&&h(r)){let t=I[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},I[r.languageId]=t);const i=t.extensions.filter(s=>(0,v.areSameExtensions)(s.extensionIdentifier,L))[0];i?i.version=p.manifest.version:t.extensions.push({extensionIdentifier:L,version:p.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,D.join)(p.location.fsPath,s.path)}}l(I){if(I){const p=(0,k.createHash)("md5");for(const L of I.extensions)p.update(L.extensionIdentifier.uuid||L.extensionIdentifier.id).update(L.version);I.hash=p.digest("hex")}}m(I=()=>null){return this.g.queue(()=>{let p=null;return C.Promises.readFile(this.f,"utf8").then(void 0,L=>L.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(L)).then(L=>{try{return JSON.parse(L)}catch{return{}}}).then(L=>(p=I(L),L)).then(L=>{for(const r of Object.keys(L))L[r]||delete L[r];this.c=L,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),C.Promises.writeFile(this.f,n)}).then(()=>p,L=>this.i.error(L))})}};a=ve([X(0,m.INativeEnvironmentService),X(1,S.ILogService)],a);function h(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const I of u.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(oe[219],ae([0,1,7,31,45]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",T="https://mobile.events.data.microsoft.com/ping";async function D(m,P,v){const S=await new Promise((h,u)=>{ne(["@microsoft/1ds-core-js"],h,u)}),f=await new Promise((h,u)=>{ne(["@microsoft/1ds-post-js"],h,u)}),d=new S.AppInsightsCore,w=new f.PostChannel,a={instrumentationKey:m,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(v){a.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:v};a.extensionConfig[w.identifier]=h}return d.initialize(a,[]),d.addTelemetryInitializer(h=>{P&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),d}class C{constructor(P,v,S,f,d){this.e=P,this.f=v,this.g=S,this.h=d,this.c=N,this.d=T,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(P){if(this.a){if(typeof this.a!="string"){P(this.a);return}this.b||(this.b=D(this.a,this.e,this.h)),this.b.then(v=>{P(v)},v=>{(0,k.onUnexpectedError)(v),console.error(v)})}}log(P,v){if(!this.a)return;v=(0,U.mixin)(v,this.g),v=(0,A.validateTelemetryData)(v);const S=this.f+"/"+P;try{this.i(f=>{f.pluginVersionString=v?.properties.version??"Unknown",f.track({name:S,baseData:{name:S,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(P=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=C}),define(oe[109],ae([0,1,2,160,14,8,24,45]),function(ne,e,k,U,A,N,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let C=e.TelemetryLogAppender=class extends k.Disposable{constructor(P,v,S,f,d=""){super(),this.b=d;const w=v.getLogger(D.telemetryLogId);if(w)this.a=this.B(w);else{const h=(0,D.isLoggingOnly)(f,S)?" (Not Sent)":"",u=()=>(0,D.supportsTelemetry)(f,S)&&P.getLevel()===N.LogLevel.Trace;this.a=this.B(v.createLogger(D.telemetryLogId,{name:(0,U.localize)(0,null,h),hidden:!u()})),this.B(P.onDidChangeLogLevel(()=>v.setVisibility(D.telemetryLogId,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,v){this.a.trace(`${this.b}telemetry/${P}`,(0,D.validateTelemetryData)(v))}};e.TelemetryLogAppender=C=ve([X(0,N.ILogService),X(1,N.ILoggerService),X(2,A.IEnvironmentService),X(3,T.IProductService)],C)}),define(oe[110],ae([0,1,2,31,5,27,161,18,48,102,24,40,20,45]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=e.TelemetryService=class{constructor(h,u,I){this.k=u,this.l=I,this.d={},this.i=new k.DisposableStore,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,N.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,N.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(S.TELEMETRY_SETTING_ID)||p.affectsConfiguration(S.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(S.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(h,u){this.d[h]=u}m(){let h=(0,f.getTelemetryLevel)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const I=u.usage?3:u.error?2:0;h=Math.min(h,I)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,u,I){this.g<u||(I=(0,U.mixin)(I,this.d),I=(0,f.cleanData)(I,this.j),I=(0,U.mixin)(I,this.c),this.b.forEach(p=>p.log(h,I)))}publicLog(h,u){this.n(h,3,u)}publicLog2(h,u){this.publicLog(h,u)}publicLogError(h,u){this.h&&this.n(h,2,u)}publicLogError2(h,u){this.publicLogError(h,u)}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=d=ve([X(1,D.IConfigurationService),X(2,P.IProductService)],d);function w(){const a=(0,T.localize)(0,null,m.default.nameLong),h=m.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=A.isWeb?"":(0,T.localize)(3,null),I=(0,T.localize)(4,null),p=(0,T.localize)(5,null),L=(0,T.localize)(6,null),n=(0,T.localize)(7,null),r=`
|       | ${I} | ${p} | ${L} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,T.localize)(8,null);return`
${a} ${h} ${u}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}v.Registry.as(C.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(C.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,T.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,T.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[220],ae([0,1,264,219]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class A extends U.AbstractOneDataSystemAppender{constructor(T,D,C,m){const P={sendPOST:(v,S)=>{const f={method:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data)}};try{const d=k.request(v.urlString,f,w=>{w.on("data",function(a){S(w.statusCode??200,w.headers,a.toString())}),w.on("error",function(a){S(0,{})})});d.write(v.data),d.end()}catch{S(0,{})}}};super(T,D,C,m,P)}}e.OneDataSystemAppender=A}),define(oe[221],ae([0,1,25,93,18,14,8,24,20,108,109,110]),function(ne,e,k,U,A,N,T,D,C,m,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let S=e.CustomEndpointTelemetryService=class{constructor(d,w,a,h,u,I){this.b=d,this.c=w,this.d=a,this.e=h,this.f=u,this.g=I,this.a=new Map}h(d){if(!this.a.has(d.id)){const w=Object.create(null);w["common.vscodemachineid"]=this.c.machineId,w["common.vscodesessionid"]=this.c.sessionId;const a=[d.id,JSON.stringify(w),d.aiKey],u=new U.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:a,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),I=[new m.TelemetryAppenderClient(u),new P.TelemetryLogAppender(this.d,this.e,this.f,this.g,`[${d.id}] `)];this.a.set(d.id,new v.TelemetryService({appenders:I,sendErrorTelemetry:d.sendErrorTelemetry},this.b,this.g))}return this.a.get(d.id)}publicLog(d,w,a){this.h(d).publicLog(w,a)}publicLogError(d,w,a){this.h(d).publicLogError(w,a)}};e.CustomEndpointTelemetryService=S=ve([X(0,A.IConfigurationService),X(1,C.ITelemetryService),X(2,T.ILogService),X(3,T.ILoggerService),X(4,N.IEnvironmentService),X(5,D.IProductService)],S)}),define(oe[76],ae([0,1,3,18,4,8]),function(ne,e,k,U,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,A.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,A.createDecorator)("sharedTunnelsService");var T;(function(w){w.Http="http",w.Https="https"})(T||(e.TunnelProtocol=T={}));var D;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(D||(e.TunnelPrivacyId=D={}));var C;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(C||(e.ProvidedOnAutoForward=C={}));function m(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(w){return e.LOCALHOST_ADDRESSES.indexOf(w)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(w){return e.ALL_INTERFACES_ADDRESSES.indexOf(w)>=0}e.isAllInterfaces=v;function S(w,a,h,u){if(h===1)return!1;if(h===2&&v(a)){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(I?.length===4&&parseInt(I[1])>=18)return!1}return w<1024}e.isPortPrivileged=S;class f{constructor(a,h,u){this.remoteAddress=a,this.localAddress=h,this.b=u,this.a=new k.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=f;let d=e.AbstractTunnelService=class{constructor(a,h){this.i=a,this.j=h,this.a=new k.Emitter,this.onTunnelOpened=this.a.event,this.b=new k.Emitter,this.onTunnelClosed=this.b.event,this.c=new k.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const a=this.j.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this.e=a,a?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this.f=a.elevation,this.g=a.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const a=[],h=Array.from(this.d.values());for(const u of h){const I=Array.from(u.values());for(const p of I){const L=await p.value;L&&a.push(L)}}return a}async dispose(){for(const a of this.d.values()){for(const{value:h}of a.values())await h.then(u=>u?.dispose());a.clear()}this.d.clear()}setEnvironmentTunnel(a,h,u,I,p){this.o(a,h,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:h,localAddress:u,privacy:I,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,h){(v(a)||P(a))&&(a=e.LOCALHOST_ADDRESSES[0]);const u=this.q(a,h);if(u)return++u.refcount,u.value}openTunnel(a,h,u,I,p,L=!1,n,r){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${u} on local port ${p}.`),!a)return;if(h||(h="localhost"),I||(I=this.k),this.e&&this.h.has(u)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.r(a,h,u,I,p,L,n,r);return t?t.then(i=>{if(!i){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,u);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(i);return(i.tunnelRemoteHost!==h||i.tunnelRemotePort!==u)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&i.privacy!==n&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}m(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const h=this.d.get(a.tunnelRemoteHost);if(h){const u=h.get(a.tunnelRemotePort);u&&(u.refcount--,await this.n(a.tunnelRemoteHost,a.tunnelRemotePort,u))}}}}async n(a,h,u){if(u.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${h}.`);const I=u.value.then(async p=>{p&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.d.has(a)&&this.d.get(a).delete(h),I}}async closeTunnel(a,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${h} `);const u=this.d.get(a);if(u&&u.has(h)){const I=u.get(h);I.refcount=0,await this.n(a,h,I)}}o(a,h,u){this.d.has(a)||this.d.set(a,new Map),this.d.get(a).set(h,{refcount:1,value:u})}async p(a,h){const u=this.d.get(a);u&&(await u.get(h)||u.delete(h),u.size===0&&this.d.delete(a))}q(a,h){const u=[a];P(a)?(u.push(...e.LOCALHOST_ADDRESSES),u.push(...e.ALL_INTERFACES_ADDRESSES)):v(a)&&u.push(...e.ALL_INTERFACES_ADDRESSES);const I=u.map(p=>this.d.get(p));for(const p of I){const L=p?.get(h);if(L)return L}}canTunnel(a){return!!m(a)}s(a,h,u,I,p,L,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${u} on local port ${I}.`);const r=u;this.h.add(r);const t=I===void 0?u:I,i={elevationRequired:p?this.isPortPrivileged(t):!1},s={remoteAddress:{host:h,port:u},localAddressPort:I,privacy:L,public:L?L!==D.Private:void 0,protocol:n},o=a.forwardPort(s,i);return o?(this.o(h,u,o),o.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),o}};e.AbstractTunnelService=d=ve([X(0,N.ILogService),X(1,U.IConfigurationService)],d)}),define(oe[222],ae([0,1,8,76,2,7,6]),function(ne,e,k,U,A,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class D extends A.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.DeferredPromise),this.b.p)}setAddress(P){this.a=P,this.b&&(this.b.complete(P),this.b=null)}setTunnel(P){this.B(P)}}let C=e.SharedProcessTunnelService=class bt extends A.Disposable{constructor(P,v){super(),this.f=P,this.g=v,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++bt.a)}}async startTunnel(P,v,S,f,d,w,a){const h=new D,u=await Promise.resolve(this.f.openTunnel(P,h,S,f,d,w,a));if(!u)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${S}:${f} (remote).`),h.dispose(),new Error("Could not create tunnel");if(this.c.has(v))throw this.c.delete(v),h.dispose(),await u.dispose(),(0,N.canceled)();return h.setTunnel(u),this.b.set(v,h),this.g.info(`[SharedProcessTunnelService] Created tunnel ${v}: ${u.localAddress} (local) to ${S}:${f} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(P,v){const S=this.b.get(P);S&&S.setAddress(v)}async destroyTunnel(P){const v=this.b.get(P);if(v){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this.b.delete(P),await v.dispose();return}this.c.add(P)}};C.a=0,e.SharedProcessTunnelService=C=ve([X(0,U.ISharedTunnelsService),X(1,k.ILogService)],C)}),define(oe[223],ae([0,1,61,36,126,6,2,18,8,24,206,76,106,5,104]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(p,L,n,r,t){let i;for(let s=3;s&&(i?.dispose(),i=await new a(p,L,n,r,t).waitForReady(),!(t&&A.BROWSER_RESTRICTED_PORTS[t]||!A.BROWSER_RESTRICTED_PORTS[i.tunnelLocalPort]));s--);return i}class a extends T.Disposable{constructor(L,n,r,t,i){super(),this.j=n,this.k=i,this.privacy=v.TunnelPrivacyId.Private,this.i=new Map,this.a=L,this.b=k.createServer(),this.c=new N.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const L=this.k??this.tunnelRemotePort,n=(0,v.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,A.findFreePortFaster)(L,2,1e3,n),t=null;return this.b.listen(r,this.j),await this.c.wait(),t=this.b.address(),t||(r=0,this.b.listen(r,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(L){L.pause();const n=(0,v.isLocalhost)(this.tunnelRemoteHost)||(0,v.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,P.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),t=r.getSocket().socket,i=r.readEntireBuffer();r.dispose(),i.byteLength>0&&L.write(i.buffer),L.on("end",()=>{L.localAddress&&this.i.delete(L.localAddress),t.end()}),L.on("close",()=>t.end()),L.on("error",()=>{L.localAddress&&this.i.delete(L.localAddress),t.destroy()}),t.on("end",()=>L.end()),t.on("close",()=>L.end()),t.on("error",()=>{L.destroy()}),L.pipe(t),t.pipe(L),L.localAddress&&this.i.set(L.localAddress,()=>{L.end(),t.end()})}}let h=e.BaseTunnelService=class extends v.AbstractTunnelService{constructor(L,n,r,t,i){super(n,i),this.t=L,this.u=r,this.v=t}isPortPrivileged(L){return(0,v.isPortPrivileged)(L,this.k,f.OS,U.release())}r(L,n,r,t,i,s,o,l){const E=this.q(n,r);if(E)return++E.refcount,E.value;if(this.e)return this.s(this.e,n,r,i,s,o,l);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${i}.`);const y={commit:this.v.commit,quality:this.v.quality,addressProvider:L,remoteSocketFactoryService:this.t,signService:this.u,logService:this.i,ipcLogger:null},c=w(y,t,n,r,i);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,r,c),c}}};e.BaseTunnelService=h=ve([X(0,d.IRemoteSocketFactoryService),X(1,C.ILogService),X(2,S.ISignService),X(3,m.IProductService),X(4,D.IConfigurationService)],h);let u=e.TunnelService=class extends h{constructor(L,n,r,t,i){super(L,n,r,t,i)}};e.TunnelService=u=ve([X(0,d.IRemoteSocketFactoryService),X(1,C.ILogService),X(2,S.ISignService),X(3,m.IProductService),X(4,D.IConfigurationService)],u);let I=e.SharedTunnelsService=class extends T.Disposable{constructor(L,n,r,t,i){super(),this.b=L,this.c=n,this.f=r,this.g=t,this.h=i,this.a=new Map}async openTunnel(L,n,r,t,i,s,o,l,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${t} on local port ${s}.`),!this.a.has(L)){const y=new u(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(L,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(L))})}return this.a.get(L).openTunnel(n,r,t,i,s,o,l,E)}};e.SharedTunnelsService=I=ve([X(0,d.IRemoteSocketFactoryService),X(1,C.ILogService),X(2,m.IProductService),X(3,S.ISignService),X(4,D.IConfigurationService)],I)}),define(oe[29],ae([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(oe[224],ae([0,1,29,178,13,22,123,3,2]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(S){this.uri=S,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let P=e.UriIdentityService=class{constructor(S){this.g=S,this.c=new C.DisposableStore,this.f=2**16;const f=new Map,d=w=>{let a=f.get(w.scheme);return a===void 0&&(a=S.hasProvider(w)&&!this.g.hasCapability(w,1024),f.set(w.scheme,a)),a};this.c.add(D.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(w=>{f.delete(w.scheme)})),this.extUri=new N.ExtUri(d),this.d=new T.SkipList((w,a)=>this.extUri.compare(w,a,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(S){this.g.hasProvider(S)&&(S=(0,N.normalizePath)(S));const f=this.d.get(S);return f?f.touch().uri.with({fragment:S.fragment}):(this.d.set(S,new m(S)),this.h(),S)}h(){if(this.d.size<this.f)return;const S=[...this.d.entries()].sort((d,w)=>d[1].time<w[1].time?1:d[1].time>w[1].time?-1:0);m._clock=0,this.d.clear();const f=this.f*.5;for(let d=0;d<f;d++)this.d.set(S[d][0],S[d][1].touch())}};e.UriIdentityService=P=ve([X(0,A.IFileService)],P),(0,U.registerSingleton)(k.IUriIdentityService,P,1)}),define(oe[225],ae([0,1,3,2,13,42,47,16]),function(ne,e,k,U,A,N,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class C extends U.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(P,v,S,f){super(),this.c=P,this.f=v,this.g=S,this.h=f,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(d=>this.i(d)))}watch(P,v){this.b.set(P,P);const S=this.f.watch(this.j(P),v);return(0,U.toDisposable)(()=>{this.b.delete(P),S.dispose()})}stat(P){return this.f.stat(this.j(P))}mkdir(P){return this.f.mkdir(this.j(P))}rename(P,v,S){return this.f.rename(this.j(P),this.j(v),S)}readFile(P){return this.f.readFile(this.j(P),{atomic:!0})}readFileStream(P,v,S){const f=(0,N.newWriteableStream)(d=>D.VSBuffer.concat(d.map(w=>D.VSBuffer.wrap(w))).buffer);return(async()=>{try{const d=await this.readFile(P);f.end(d)}catch(d){f.error(d),f.end()}})(),f}readdir(P){return this.f.readdir(this.j(P))}writeFile(P,v,S){return this.f.writeFile(this.j(P),v,S)}delete(P,v){return this.f.delete(this.j(P),v)}copy(P,v,S){if((0,A.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(P),this.j(v),S);throw new Error("copy not supported")}i(P){const v=[];for(const S of P){if(S.resource.scheme!==this.c)continue;const f=this.k(S.resource);this.b.findSubstr(f)&&v.push({resource:f,type:S.type})}v.length&&(this.h.debug("User data changed"),this.a.fire(v))}j(P){return P.with({scheme:this.c})}k(P){return P.with({scheme:this.g})}}e.FileUserDataProvider=C}),define(oe[57],ae([0,1,83]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function U(T,D,C,m){const P=(0,k.setProperty)(T,D,C,m)[0];return P&&(T=T.substring(0,P.offset)+P.content+T.substring(P.offset+P.length)),T}e.edit=U;function A(T,D,C){let m=C;for(;m>=0;){if(T.charAt(m)===D.charAt(D.length-1)&&D.length===1)return m+1;if(m--,D.length===2&&m>=0&&T.charAt(m)===D.charAt(0))return m+2}return 0}e.getLineStartOffset=A;function N(T,D,C){let m=C;for(;m>=0;)if(T.charAt(m)===D.charAt(D.length-1)&&D.length===1||(m++,D.length===2&&m>=0&&T.charAt(m)===D.charAt(1)))return m;return T.length-1}e.getLineEndOffset=N}),define(oe[226],ae([0,1,31,52,10]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function N(f,d,w,a,h,u){const I=[],p=[],L=[];if(!d){const q=f.filter(({identifier:V})=>h.every(Q=>Q.toLowerCase()!==V.id.toLowerCase()));return{local:{added:I,removed:p,updated:L},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}f=f.map(v),d=d.map(v),w=w?w.map(v):null;const n=new Map,r=q=>{q.uuid&&n.set(q.id.toLowerCase(),q.uuid)};f.forEach(({identifier:q})=>r(q)),d.forEach(({identifier:q})=>r(q)),w?.forEach(({identifier:q})=>r(q));const t=q=>{const V=q.identifier.uuid||n.get(q.identifier.id.toLowerCase());return V?`uuid:${V}`:`id:${q.identifier.id.toLowerCase()}`},i=(q,V)=>(q.set(t(V),V),q),s=f.reduce(i,new Map),o=d.reduce(i,new Map),l=d.reduce((q,V)=>i(q,(0,k.deepClone)(V)),new Map),E=w?w.reduce(i,new Map):null,y=a.reduce(i,new Map),c=h.reduce((q,V)=>{const Q=n.get(V.toLowerCase());return q.add(Q?`uuid:${Q}`:`id:${V.toLowerCase()}`)},new Set),b=u?u.reduce((q,{id:V,uuid:Q})=>(Q=Q??n.get(V.toLowerCase()),q.add(Q?`uuid:${Q}`:`id:${V.toLowerCase()}`)),new Set):null,R=T(s,o,c,!1);if(R.added.size>0||R.removed.size>0||R.updated.size>0){const q=T(E,s,c,!1),V=T(E,o,c,!0),Q=(te,Y,x,G)=>{let j,Z,ie;return Y.installed?(j=G.pinned,ie=G.preRelease,j&&(Z=G.version)):(j=x.pinned,ie=x.preRelease,j&&(Z=x.version)),j===void 0&&(j=Y.pinned,j&&(Z=Y.version)),ie===void 0&&(ie=Y.preRelease),{...G,installed:Y.installed||x.installed,pinned:j,preRelease:ie,version:Z??(x.version&&(!Y.installed||U.gt(x.version,Y.version))?x.version:Y.version),state:C(Y,x,E?.get(te))}};for(const te of V.removed.values()){const Y=s.get(te);if(!Y)continue;const x=(0,A.assertIsDefined)(E?.get(te)),G=b&&!b.has(te)&&x.installed;Y.installed&&G?p.push(Y.identifier):l.set(te,Y)}for(const te of V.added.values()){const Y=(0,A.assertIsDefined)(o.get(te)),x=s.get(te);if(x){if(R.updated.has(te)){const G=Q(te,x,Y,Y);D(x,Y,!1,!1)||L.push(S(G,te)),l.set(te,G)}}else Y.installed&&I.push(S(Y,te))}for(const te of V.updated.values()){const Y=(0,A.assertIsDefined)(o.get(te)),x=(0,A.assertIsDefined)(E?.get(te)),G=s.get(te);if(G)if(b&&!b.has(te)&&x.installed&&G.installed&&!Y.installed)p.push(G.identifier);else{const Z=Q(te,G,Y,Y);L.push(S(Z,te)),l.set(te,Z)}else Y.installed&&I.push(S(Y,te))}for(const te of q.added.values())V.added.has(te)||l.set(te,(0,A.assertIsDefined)(s.get(te)));for(const te of q.updated.values()){if(V.removed.has(te)||V.updated.has(te))continue;const Y=(0,A.assertIsDefined)(s.get(te)),x=(0,A.assertIsDefined)(o.get(te));l.set(te,Q(te,Y,x,Y))}for(const te of q.removed.values())V.updated.has(te)||V.removed.has(te)||y.has(te)||(0,A.assertIsDefined)(o.get(te)).installed&&b&&(b.has(te)||!(0,A.assertIsDefined)(E?.get(te)).installed||l.delete(te))}const M=[],F=T(o,l,new Set,!0),H=F.added.size>0||F.updated.size>0||F.removed.size>0;return H&&l.forEach((q,V)=>M.push(S(q,V))),{local:{added:I,removed:p,updated:L},remote:H?{added:[...F.added].map(q=>l.get(q)),updated:[...F.updated].map(q=>l.get(q)),removed:[...F.removed].map(q=>o.get(q)),all:M}:null}}e.merge=N;function T(f,d,w,a){const h=f?[...f.keys()].filter(n=>!w.has(n)):[],u=[...d.keys()].filter(n=>!w.has(n)),I=u.filter(n=>!h.includes(n)).reduce((n,r)=>(n.add(r),n),new Set),p=h.filter(n=>!u.includes(n)).reduce((n,r)=>(n.add(r),n),new Set),L=new Set;for(const n of h){if(p.has(n))continue;const r=f.get(n),t=d.get(n);(!t||!D(r,t,a,!0))&&L.add(n)}return{added:I,removed:p,updated:L}}function D(f,d,w,a){return!(f.disabled!==d.disabled||a&&f.installed!==d.installed||f.installed&&d.installed&&(f.preRelease!==d.preRelease||f.pinned!==d.pinned||d.pinned&&f.version!==d.version)||!P(f.state,d.state)||w&&f.version!==d.version)}function C(f,d,w){const a=f.state,h=d.state,u=w?.state;if(!d.version||a&&U.gt(f.version,d.version))return a;if(h&&U.gt(d.version,f.version)||!a)return h;if(!h)return a;const I=(0,k.deepClone)(a),p=u?m(u,h):{added:Object.keys(h).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set},L=u?m(u,a):{added:Object.keys(a).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set};for(const n of[...p.added.values(),...p.updated.values()])I[n]=h[n];for(const n of p.removed.values())L.updated.has(n)||delete I[n];return I}function m(f,d){const w=Object.keys(f),a=Object.keys(d),h=a.filter(p=>!w.includes(p)).reduce((p,L)=>(p.add(L),p),new Set),u=w.filter(p=>!a.includes(p)).reduce((p,L)=>(p.add(L),p),new Set),I=new Set;for(const p of w){if(u.has(p))continue;const L=f[p],n=d[p];(0,k.equals)(L,n)||I.add(p)}return{added:h,removed:u,updated:I}}function P(f={},d={}){const{added:w,removed:a,updated:h}=m(f,d);return w.size===0&&a.size===0&&h.size===0}function v(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function S(f,d){const w={identifier:{id:f.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},version:f.version,preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled&&(w.disabled=!0),f.installed&&(w.installed=!0),f.state&&(w.state=f.state),w}}),define(oe[111],ae([0,1,21,18,4]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let N=e.IgnoredExtensionsManagementService=class{constructor(D){this.a=D}hasToNeverSyncExtension(D){return this.b().includes(D.toLowerCase())}hasToAlwaysSyncExtension(D){return this.b().includes(`-${D.toLowerCase()}`)}updateIgnoredExtensions(D,C){let m=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return m=m.filter(P=>P!==D&&P!==`-${D}`),C&&m.push(D.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}updateSynchronizedExtensions(D,C){let m=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return m=m.filter(P=>P!==D&&P!==`-${D}`),C&&m.push(`-${D.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}getIgnoredExtensions(D){const C=D.filter(S=>S.isMachineScoped).map(S=>S.identifier.id.toLowerCase()),m=this.b().map(S=>S.toLowerCase()),P=[],v=[];if(Array.isArray(m))for(const S of m)S.startsWith("-")?v.push(S.substring(1)):P.push(S);return(0,k.distinct)([...C,...P].filter(S=>!v.includes(S)))}b(){let D=this.a.inspect("settingsSync.ignoredExtensions").userValue;return D!==void 0||(D=this.a.inspect("sync.ignoredExtensions").userValue,D!==void 0)?D:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};e.IgnoredExtensionsManagementService=N=ve([X(0,U.IConfigurationService)],N)}),define(oe[227],ae([0,1,21,34,31,94,57]),function(ne,e,k,U,A,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(p){return(0,U.parse)(p)||[]}async function C(p,L,n,r,t){const i=D(p),s=D(L),o=n?D(n):null,l=[...i,...s,...o||[]].map(Q=>Q.key),E=await t.resolveUserBindings(l),y=P(i,s,o,E);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:L,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const c=S(i),b=S(s),R=o?S(o):null,M=d(c,b,E),F=R?d(R,c,E):{added:[...c.keys()].reduce((Q,te)=>(Q.add(te),Q),new Set),removed:new Set,updated:new Set},H=R?d(R,b,E):{added:[...b.keys()].reduce((Q,te)=>(Q.add(te),Q),new Set),removed:new Set,updated:new Set},q=m(M,F,H);let V=p;for(const Q of q.removed.values())q.conflicts.has(Q)||(V=u(V,Q,r));for(const Q of q.added.values()){if(q.conflicts.has(Q))continue;const te=b.get(Q);if(te.some(Y=>Y.command!==`-${Q}`&&y.conflicts.has(E[Y.key]))){q.conflicts.add(Q);continue}V=h(V,te,r)}for(const Q of q.updated.values()){if(q.conflicts.has(Q))continue;const te=b.get(Q);if(te.some(Y=>Y.command!==`-${Q}`&&y.conflicts.has(E[Y.key]))){q.conflicts.add(Q);continue}V=I(V,Q,te,r)}return{mergeContent:V,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.merge=C;function m(p,L,n){const r=new Set,t=new Set,i=new Set,s=new Set;for(const o of L.removed.values())n.updated.has(o)&&s.add(o);for(const o of n.removed.values())s.has(o)||(L.updated.has(o)?s.add(o):t.add(o));for(const o of L.added.values())s.has(o)||n.added.has(o)&&p.updated.has(o)&&s.add(o);for(const o of n.added.values())s.has(o)||(L.added.has(o)?p.updated.has(o)&&s.add(o):r.add(o));for(const o of L.updated.values())s.has(o)||n.updated.has(o)&&p.updated.has(o)&&s.add(o);for(const o of n.updated.values())s.has(o)||(L.updated.has(o)?p.updated.has(o)&&s.add(o):i.add(o));return{added:r,removed:t,updated:i,conflicts:s}}function P(p,L,n,r){const t=new Set,i=v(p,r),s=v(L,r),o=n?v(n,r):null,l=f(i,s);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const E=o?f(o,i):{added:[...i.keys()].reduce((F,H)=>(F.add(H),F),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const y=o?f(o,s):{added:[...s.keys()].reduce((F,H)=>(F.add(H),F),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:c,removed:b,updated:R,conflicts:M}=m(l,E,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:c,removed:b,updated:R,conflicts:M}}function v(p,L){const n=new Map;for(const r of p){const t=L[r.key];let i=n.get(t);i||(i=[],n.set(t,i)),i.push(r)}return n}function S(p){const L=new Map;for(const n of p){const r=n.command[0]==="-"?n.command.substring(1):n.command;let t=L.get(r);t||(t=[],L.set(r,t)),t.push(n)}return L}function f(p,L){const n=[...p.keys()],r=[...L.keys()],t=r.filter(o=>!n.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),i=n.filter(o=>!r.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),s=new Set;for(const o of n){if(i.has(o))continue;const l=p.get(o).map(y=>({...y,key:o})),E=L.get(o).map(y=>({...y,key:o}));(0,k.equals)(l,E,(y,c)=>a(y,c))||s.add(o)}return{added:t,removed:i,updated:s}}function d(p,L,n){const r=[...p.keys()],t=[...L.keys()],i=t.filter(l=>!r.includes(l)).reduce((l,E)=>(l.add(E),l),new Set),s=r.filter(l=>!t.includes(l)).reduce((l,E)=>(l.add(E),l),new Set),o=new Set;for(const l of r){if(s.has(l))continue;const E=p.get(l).map(c=>({...c,key:n[c.key]})),y=L.get(l).map(c=>({...c,key:n[c.key]}));w(E,y)||o.add(l)}return{added:i,removed:s,updated:o}}function w(p,L){return!(!(0,k.equals)(p.filter(({command:n})=>n[0]!=="-"),L.filter(({command:n})=>n[0]!=="-"),(n,r)=>a(n,r))||!(0,k.equals)(p.filter(({command:n})=>n[0]==="-"),L.filter(({command:n})=>n[0]==="-"),(n,r)=>a(n,r)))}function a(p,L){if(p.command!==L.command||p.key!==L.key)return!1;const n=N.ContextKeyExpr.deserialize(p.when),r=N.ContextKeyExpr.deserialize(L.when);return!(n&&!r||!n&&r||n&&r&&!n.equals(r)||!A.equals(p.args,L.args))}function h(p,L,n){for(const r of L)p=T.edit(p,[-1],r,n);return p}function u(p,L,n){const r=D(p);for(let t=r.length-1;t>=0;t--)(r[t].command===L||r[t].command===`-${L}`)&&(p=T.edit(p,[t],void 0,n));return p}function I(p,L,n,r){const t=D(p),i=t.findIndex(s=>s.command===L||s.command===`-${L}`);for(let s=t.length-1;s>=0;s--)(t[s].command===L||t[s].command===`-${L}`)&&(p=T.edit(p,[s],void 0,r));for(let s=n.length-1;s>=0;s--)p=T.edit(p,[i],n[s],r);return p}}),define(oe[228],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(N,T,D){const C={},m={},P=new Set;if(!T)return{local:{added:C,updated:m,removed:[...P.values()]},remote:{added:N,updated:{},removed:[]},conflicts:[]};const v=U(N,T);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{local:{added:C,updated:m,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const S=U(D,N),f=U(D,T),d={},w={},a=new Set,h=new Set;for(const u of S.removed.values())f.updated.has(u)?C[u]=T[u]:a.add(u);for(const u of f.removed.values())h.has(u)||(S.updated.has(u)?h.add(u):P.add(u));for(const u of S.updated.values())h.has(u)||(f.updated.has(u)?v.updated.has(u)&&h.add(u):w[u]=N[u]);for(const u of f.updated.values())h.has(u)||(S.updated.has(u)?v.updated.has(u)&&h.add(u):N[u]!==void 0&&(m[u]=T[u]));for(const u of S.added.values())h.has(u)||(f.added.has(u)?v.updated.has(u)&&h.add(u):d[u]=N[u]);for(const u of f.added.values())h.has(u)||(S.added.has(u)?v.updated.has(u)&&h.add(u):C[u]=T[u]);return{local:{added:C,removed:[...P.values()],updated:m},remote:{added:d,removed:[...a.values()],updated:w},conflicts:[...h.values()]}}e.merge=k;function U(N,T){const D=N?Object.keys(N):[],C=T?Object.keys(T):[],m=C.filter(S=>!D.includes(S)).reduce((S,f)=>(S.add(f),S),new Set),P=D.filter(S=>!C.includes(S)).reduce((S,f)=>(S.add(f),S),new Set),v=new Set;for(const S of D){if(P.has(S))continue;const f=N[S],d=T[S];f!==d&&v.add(S)}return{added:m,removed:P,updated:v}}function A(N,T){const{added:D,removed:C,updated:m}=U(N,T);return D.size===0&&C.size===0&&m.size===0}e.areSame=A}),define(oe[229],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(A,N,T,D){const C={added:[],removed:[],updated:[]};let m={added:[],removed:[],updated:[]};if(!N){const v=A.filter(({id:S})=>!D.includes(S));return v.length?m.added=v:m=null,{local:C,remote:m}}const P=U(A,N,D);if(P.added.length>0||P.removed.length>0||P.updated.length>0){const v=U(T,A,D),S=U(T,N,D);for(const f of S.removed){const d=A.find(w=>w.id===f);d&&C.removed.push(d)}for(const f of S.added){const d=N.find(w=>w.id===f);v.added.includes(f)?P.updated.includes(f)&&C.updated.push(d):C.added.push(d)}for(const f of S.updated)C.updated.push(N.find(d=>d.id===f));for(const f of v.added)S.added.includes(f)||m.added.push(A.find(d=>d.id===f));for(const f of v.updated)S.removed.includes(f)||S.updated.includes(f)||m.updated.push(A.find(d=>d.id===f));for(const f of v.removed){const d=N.find(w=>w.id===f);d&&m.removed.push(d)}}return m.added.length===0&&m.removed.length===0&&m.updated.length===0&&(m=null),{local:C,remote:m}}e.merge=k;function U(A,N,T){A=A?A.filter(({id:S})=>!T.includes(S)):[],N=N.filter(({id:S})=>!T.includes(S));const D=A.map(({id:S})=>S),C=N.map(({id:S})=>S),m=C.filter(S=>!D.includes(S)),P=D.filter(S=>!C.includes(S)),v=[];for(const{id:S,name:f,shortName:d}of A){if(P.includes(S))continue;const w=N.find(a=>a.id===S);(!w||w.name!==f||w.shortName!==d)&&v.push(S)}return{added:m,removed:P,updated:v}}}),define(oe[23],ae([0,1,21,10,167,48,28,4,103,40]),function(ne,e,k,U,A,N,T,D,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function P(){const s=m.Registry.as(N.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(o=>!!s[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function v(){const s=m.Registry.as(N.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(s).filter(y=>!!s[y].ignoreSync),l=Object.keys(s).filter(y=>s[y].scope===2||s[y].scope===6),E=P();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...l,...E])}e.getDefaultIgnoredSettings=v,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function S(){const s="vscode://schemas/ignoredSettings",o=m.Registry.as(N.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=m.Registry.as(C.Extensions.JSONContribution),E=()=>{const y=P(),c=v().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),b=Object.keys(N.allSettings.properties).filter(F=>!c.includes(F)),R=c.filter(F=>!y.includes(F)),M={items:{type:"string",enum:[...b,...R.map(F=>`-${F}`)]}};l.registerSchema(s,M)};return o.onDidUpdateConfiguration(()=>E())}e.registerConfiguration=S;function f(s){return s&&(0,U.isObject)(s)&&(0,U.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=f;var d;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles",s.WorkspaceState="workspaceState"})(d||(e.SyncResource=d={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function w(s,...o){return s?[s,...o]:o}e.getPathSegments=w;function a(s,o,l,E){return E.joinPath(l.userDataSyncHome,...w(s,o,`lastSync${o}.json`))}e.getLastSyncResourceUri=a,e.IUserDataSyncStoreManagementService=(0,D.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,D.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,D.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function h(s){const o={};return o[e.HEADER_EXECUTION_ID]=s,o}e.createSyncHeaders=h;var u;(function(s){s.Unauthorized="Unauthorized",s.Forbidden="Forbidden",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class I extends Error{constructor(o,l,E,y){super(o),this.code=l,this.resource=E,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=I;class p extends I{constructor(o,l,E,y,c){super(o,E,void 0,c),this.url=l,this.serverCode=y}}e.UserDataSyncStoreError=p;class L extends I{constructor(o,l){super(o,l)}}e.UserDataAutoSyncError=L,function(s){function o(l){if(l instanceof s)return l;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(E&&E[1]){const y=E[2]==="unknown"?void 0:E[2],c=E[3]==="unknown"?void 0:E[3];return new s(l.message,E[1],y,c)}return new s(l.message,"Unknown")}s.toUserDataSyncError=o}(I||(e.UserDataSyncError=I={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r||(e.Change=r={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t||(e.MergeState=t={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(s){return`sync.enable.${s}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,D.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,D.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,D.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,D.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,D.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,D.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(oe[230],ae([0,1,31,23]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(T,D,C,m,P){if(!D)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const v=N(T,D);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const S=C?N(C,D):{added:Object.keys(D).reduce((u,I)=>(u.add(I),u),new Set),removed:new Set,updated:new Set},f=C?N(C,T):{added:Object.keys(T).reduce((u,I)=>(u.add(I),u),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},w=k.deepClone(D),a=!C;for(const u of f.added.values())u!==U.SYNC_SERVICE_URL_TYPE&&a&&S.added.has(u)||(w[u]=T[u]);for(const u of f.updated.values())w[u]=T[u];for(const u of f.removed.values())m.unregistered.includes(u)||delete w[u];for(const u of S.added.values()){const I=D[u];if(m.machine.includes(u)){P.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(C&&f.added.has(u))continue;const p=T[u];p&&p.value===I.value||u===U.SYNC_SERVICE_URL_TYPE&&a&&f.added.has(u)||(p?d.updated[u]=I:d.added[u]=I)}for(const u of S.updated.values()){const I=D[u];if(m.machine.includes(u)){P.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(u)||f.removed.has(u))continue;const p=T[u];p&&p.value===I.value||(d.updated[u]=I)}for(const u of S.removed.values()){if(m.machine.includes(u)){P.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}f.updated.has(u)||f.removed.has(u)||d.removed.push(u)}const h=N(D,w);return{local:d,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:w}}}e.merge=A;function N(T,D){const C=Object.keys(T),m=Object.keys(D),P=m.filter(f=>!C.includes(f)).reduce((f,d)=>(f.add(d),f),new Set),v=C.filter(f=>!m.includes(f)).reduce((f,d)=>(f.add(d),f),new Set),S=new Set;for(const f of C){if(v.has(f))continue;const d=T[f],w=D[f];k.equals(d,w)||S.add(f)}return{added:P,removed:v,updated:S}}}),define(oe[231],ae([0,1,21,34,83,41,31,57,23]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function m(l,E,y){let c=[];y?c=v(y):c=P(E);const b=[],R=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(c))for(const M of c)M.startsWith("-")?R.push(M.substring(1)):b.push(M);return(0,k.distinct)([...l,...b].filter(M=>!R.includes(M)))}e.getIgnoredSettings=m;function P(l){let E=l.inspect("settingsSync.ignoredSettings").userValue;return E!==void 0||(E=l.inspect("sync.ignoredSettings").userValue,E!==void 0)?E:l.getValue("settingsSync.ignoredSettings")||[]}function v(l){const E=(0,U.parse)(l);return E?E["settingsSync.ignoredSettings"]||E["sync.ignoredSettings"]||[]:[]}function S(l,E){const y=(0,U.parse)(l)||{};let c="{}";for(const b of Object.keys(y)){const R=(0,A.setProperty)(c,[b],y[b],E);c=(0,A.applyEdits)(c,R)}return c}e.removeComments=S;function f(l,E,y,c){if(y.length){const b=o(E),R=(0,U.parse)(E)||{},M=(0,U.parse)(l);if(!M)return l;const F=[];for(const H of y){const q=R[H],V=M[H];q===void 0?l=D.edit(l,[H],void 0,c):V!==void 0?l=D.edit(l,[H],q,c):F.push(n(H,b))}F.sort((H,q)=>H.startOffset-q.startOffset),F.forEach(H=>l=u(H.setting.key,E,l,c))}return l}e.updateIgnoredSettings=f;function d(l,E,y,c,b,R){const M=f(l,E,c,R),F=y!==M,H=y!==E;if(!F&&!H)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!H)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(H&&!F)return{conflictsSettings:[],localContent:f(E,l,c,R),remoteContent:null,hasConflicts:!1};if(y===null&&a(l)){const O=w(l,E,c)?null:f(E,l,c,R);return{conflictsSettings:[],localContent:O,remoteContent:null,hasConflicts:!1}}let q=l,V=E;const Q=(0,U.parse)(l),te=(0,U.parse)(E),Y=y?(0,U.parse)(y):null,x=c.reduce((O,B)=>(O.add(B),O),new Set),G=h(Q,te,x),j=h(Y,Q,x),Z=h(Y,te,x),ie=new Map,se=new Set,K=O=>{se.add(O);const B=b.filter(({key:W})=>W===O)[0];B?(q=D.edit(q,[O],B.value,R),V=D.edit(V,[O],B.value,R)):ie.set(O,{key:O,localValue:Q[O],remoteValue:te[O]})};for(const O of j.removed.values())Z.updated.has(O)?K(O):V=D.edit(V,[O],void 0,R);for(const O of Z.removed.values())se.has(O)||(j.updated.has(O)?K(O):q=D.edit(q,[O],void 0,R));for(const O of j.updated.values())se.has(O)||(Z.updated.has(O)?G.updated.has(O)&&K(O):V=D.edit(V,[O],Q[O],R));for(const O of Z.updated.values())se.has(O)||(j.updated.has(O)?G.updated.has(O)&&K(O):q=D.edit(q,[O],te[O],R));for(const O of j.added.values())se.has(O)||(Z.added.has(O)?G.updated.has(O)&&K(O):V=u(O,q,V,R));for(const O of Z.added.values())se.has(O)||(j.added.has(O)?G.updated.has(O)&&K(O):q=u(O,V,q,R));const _=ie.size>0||!w(q,V,c),$=_||!w(q,l,[]),g=_||!w(V,E,[]);return{localContent:$?q:null,remoteContent:g?V:null,conflictsSettings:[...ie.values()],hasConflicts:_}}e.merge=d;function w(l,E,y){if(l===E)return!0;const c=(0,U.parse)(l),b=(0,U.parse)(E),R=y.reduce((H,q)=>(H.add(q),H),new Set),M=o(l).filter(H=>!(H.setting&&R.has(H.setting.key))),F=o(E).filter(H=>!(H.setting&&R.has(H.setting.key)));if(M.length!==F.length)return!1;for(let H=0;H<M.length;H++){const q=M[H],V=F[H];if(q.setting&&V.setting){if(q.setting.key!==V.setting.key||!T.equals(c[q.setting.key],b[q.setting.key]))return!1}else if(!q.setting&&!V.setting){if(q.value!==V.value)return!1}else return!1}return!0}function a(l){return l?o(l).length===0:!0}e.isEmpty=a;function h(l,E,y){const c=l?Object.keys(l).filter(H=>!y.has(H)):[],b=Object.keys(E).filter(H=>!y.has(H)),R=b.filter(H=>!c.includes(H)).reduce((H,q)=>(H.add(q),H),new Set),M=c.filter(H=>!b.includes(H)).reduce((H,q)=>(H.add(q),H),new Set),F=new Set;if(l)for(const H of c){if(M.has(H))continue;const q=l[H],V=E[H];T.equals(q,V)||F.add(H)}return{added:R,removed:M,updated:F}}function u(l,E,y,c){const b=(0,U.parse)(E),R=o(E),M=o(y),F=I(l,R,M);return p(y,l,b[l],F,M,c)}e.addSetting=u;function I(l,E,y){const c=E.findIndex(R=>R.setting?.key===l),b=E[c-1];if(b){if(b.setting){const M=n(b.setting.key,y);if(M)return{index:y.indexOf(M),insertAfter:!0}}else{const M=r(c,E);if(M){const F=n(M.setting.key,y);if(F){const H=t(y.indexOf(F),y),q=i(E,M,E[c]);if(H){const V=i(y,F,H),Q=s(q,V);return Q?{index:y.indexOf(Q),insertAfter:!0}:{index:y.indexOf(H),insertAfter:!1}}else{const V=i(y,F,y[y.length-1]),Q=s(q,V);return Q?{index:y.indexOf(Q),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const R=E[c+1];if(R)if(R.setting){const M=n(R.setting.key,y);if(M)return{index:y.indexOf(M),insertAfter:!1}}else{const M=t(c,E);if(M){const F=n(M.setting.key,y);if(F){const H=r(y.indexOf(F),y),q=i(E,E[c],M);if(H){const V=i(y,H,F),Q=s(q.reverse(),V.reverse());return Q?{index:y.indexOf(Q),insertAfter:!1}:{index:y.indexOf(H),insertAfter:!0}}else{const V=i(y,y[0],F),Q=s(q.reverse(),V.reverse());return Q?{index:y.indexOf(Q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function p(l,E,y,c,b,R){let M;return c.index===-1?M=(0,A.setProperty)(l,[E],y,R):M=L(l,E,y,c,b,R).map(F=>(0,A.withFormatting)(l,F,R)[0]),(0,A.applyEdits)(l,M)}function L(l,E,y,c,b,R){const M=`${JSON.stringify(E)}: ${JSON.stringify(y)}`,F=(0,N.getEOL)(R,l),H=b[c.index];if(c.insertAfter){const q=[];if(H.setting)q.push({offset:H.endOffset,length:0,content:","+M});else{const V=t(c.index,b),Q=r(c.index,b),te=Q?.setting?.commaOffset;Q&&te===void 0&&q.push({offset:Q.endOffset,length:0,content:","});const Y=te!==void 0&&te>H.endOffset;q.push({offset:Y?te+1:H.endOffset,length:0,content:V?F+M+",":F+M})}return q}else{if(H.setting)return[{offset:H.startOffset,length:0,content:M+","}];const q=(b[c.index-1]&&!b[c.index-1].setting?F:"")+M+(t(c.index,b)?",":"")+F;return[{offset:H.startOffset,length:0,content:q}]}}function n(l,E){return E.filter(y=>y.setting?.key===l)[0]}function r(l,E){for(let y=l-1;y>=0;y--)if(E[y].setting)return E[y]}function t(l,E){for(let y=l+1;y<E.length;y++)if(E[y].setting)return E[y]}function i(l,E,y){const c=l.indexOf(E),b=l.indexOf(y);return l.filter((R,M)=>c<M&&M<b)}function s(l,E){if(l.length&&E.length){let y=0;for(;y<E.length&&y<l.length;y++)if(l[y].value!==E[y].value)return E[y-1];return E[y-1]}}function o(l){const E=[];let y=-1,c,b;const R={onObjectBegin:M=>{y++},onObjectProperty:(M,F,H)=>{y===0&&(c=F,b=M)},onObjectEnd:(M,F)=>{y--,y===0&&E.push({startOffset:c,endOffset:M+F,value:l.substring(c,M+F),setting:{key:b,commaOffset:void 0}})},onArrayBegin:(M,F)=>{y++},onArrayEnd:(M,F)=>{y--,y===0&&E.push({startOffset:c,endOffset:M+F,value:l.substring(c,M+F),setting:{key:b,commaOffset:void 0}})},onLiteralValue:(M,F,H)=>{y===0&&E.push({startOffset:c,endOffset:F+H,value:l.substring(c,F+H),setting:{key:b,commaOffset:void 0}})},onSeparator:(M,F,H)=>{if(y===0&&M===","){let q=E.length-1;for(;q>=0&&!E[q].setting;q--);const V=E[q];V&&E.splice(q,1,{startOffset:V.startOffset,endOffset:V.endOffset,value:V.value,setting:{key:V.setting.key,commaOffset:F}})}},onComment:(M,F)=>{y===0&&E.push({startOffset:M,endOffset:M+F,value:l.substring(M,M+F)})}};return(0,U.visit)(l,R),E}}),define(oe[77],ae([0,1,3,2,4,23]),function(ne,e,k,U,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,A.createDecorator)("IUserDataSyncAccountService");let T=e.UserDataSyncAccountService=class extends U.Disposable{get account(){return this.a}constructor(C,m){super(),this.g=C,this.h=m,this.b=this.B(new k.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new k.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(C.onTokenFailed(P=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,P),this.updateAccount(void 0),P==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(C.onTokenSucceed(()=>this.f=!1))}async updateAccount(C){(C&&this.a?C.token!==this.a.token||C.authenticationProviderId!==this.a.authenticationProviderId:C!==this.a)&&(this.a=C,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(C))}};e.UserDataSyncAccountService=T=ve([X(0,N.IUserDataSyncStoreService),X(1,N.IUserDataSyncLogService)],T)}),define(oe[232],ae([0,1,2,12]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class A{constructor(S){this.a=S}listen(S,f){switch(f){case"onError":return this.a.onError}throw new Error(`Event not found: ${f}`)}call(S,f,d){switch(f){case"triggerSync":return this.a.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=A;class N{constructor(S){this.a=S}listen(S,f){throw new Error(`Event not found: ${f}`)}call(S,f,d){switch(f){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(U.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=N;class T{constructor(S){this.a=S}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(S){return this.a.call("resolveUserKeybindings",[S])}async resolveFormattingOptions(S){return this.a.call("resolveFormattingOptions",[S])}}e.UserDataSyncUtilServiceClient=T;class D{constructor(S){this.a=S}listen(S,f){switch(f){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${f}`)}async call(S,f,d){switch(f){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(d[0],d[1]);case"setEnablements":return this.a.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=D;class C{constructor(S){this.a=S}listen(S,f){switch(f){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${f}`)}call(S,f,d){switch(f){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class m{constructor(S){this.a=S}listen(S,f){switch(f){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${f}`)}call(S,f,d){switch(f){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=m;class P extends k.Disposable{constructor(S){super(),this.a=S,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(S){return this.a.call("switch",[S])}async getPreviousUserDataSyncStore(){const S=await this.a.call("getPreviousUserDataSyncStore");return this.b(S)}b(S){return{url:U.URI.revive(S.url),type:S.type,defaultUrl:U.URI.revive(S.defaultUrl),insidersUrl:U.URI.revive(S.insidersUrl),stableUrl:U.URI.revive(S.stableUrl),canSwitch:S.canSwitch,authenticationProviders:S.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(oe[233],ae([0,1,168,8,23]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let N=e.UserDataSyncLogService=class extends U.AbstractLogger{constructor(D){super(),this.g=this.B(D.createLogger(A.USER_DATA_SYNC_LOG_ID,{name:(0,k.localize)(0,null)}))}trace(D,...C){this.g.trace(D,...C)}debug(D,...C){this.g.debug(D,...C)}info(D,...C){this.g.info(D,...C)}warn(D,...C){this.g.warn(D,...C)}error(D,...C){this.g.error(D,...C)}flush(){this.g.flush()}};e.UserDataSyncLogService=N=ve([X(0,U.ILoggerService)],N)}),define(oe[234],ae([0,1,6,3,2]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class N extends A.Disposable{constructor({onDidOpenWindow:D,onDidFocusWindow:C,getActiveWindowId:m}){super(),this.a=this.B(new A.DisposableStore),U.Event.latch(U.Event.any(D,C))(this.f,this,this.a),this.b=(0,k.createCancelablePromise)(()=>m()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(D){this.b&&(this.b.cancel(),this.b=void 0),this.c=D}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=N}),define(oe[112],ae([0,1,171,15,47,22,12,4,25]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function m(i){const s=i;return typeof s?.id=="string"&&T.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=m;function P(i){return typeof i?.id=="string"&&!m(i)&&!S(i)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function v(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,U.basename)(i)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=v;function S(i){const s=i;return typeof s?.id=="string"&&T.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=S;function f(i){const s=i;if(s?.uri)return{id:s.id,uri:T.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=f;var d;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function w(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=w;function a(i){const s=i;return!!(s&&typeof s=="object"&&T.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=a;class h{constructor(s,o,l,E,y){this.h=s,this.j=l,this.k=E,this.l=y,this.c=A.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=A.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class u{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,N.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function I(i){return new u({uri:i,index:0,name:(0,N.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=I,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(i,s){return N.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function L(i){let s;return T.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===C.Schemas.tmp}e.isTemporaryWorkspace=L,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=n;function r(i,s){return!p(i,s)&&!L(i)}e.isSavedWorkspace=r;function t(i){return(typeof i=="string"?(0,U.extname)(i):(0,N.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(oe[17],ae([0,1,63,3,2,22,12,162,14,13,4,8,112,35,29,6,32,27,10]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function I(t){const i=t;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&T.URI.isUri(i.location)&&T.URI.isUri(i.globalStorageHome)&&T.URI.isUri(i.settingsResource)&&T.URI.isUri(i.keybindingsResource)&&T.URI.isUri(i.tasksResource)&&T.URI.isUri(i.snippetsHome)&&T.URI.isUri(i.extensionsResource))}e.isUserDataProfile=I,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function p(t,i){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:T.URI.revive(t.location).with({scheme:i}),globalStorageHome:T.URI.revive(t.globalStorageHome).with({scheme:i}),settingsResource:T.URI.revive(t.settingsResource).with({scheme:i}),keybindingsResource:T.URI.revive(t.keybindingsResource).with({scheme:i}),tasksResource:T.URI.revive(t.tasksResource).with({scheme:i}),snippetsHome:T.URI.revive(t.snippetsHome).with({scheme:i}),extensionsResource:T.URI.revive(t.extensionsResource).with({scheme:i}),cacheHome:T.URI.revive(t.cacheHome).with({scheme:i}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=p;function L(t,i,s,o,l){return{id:t,name:i,location:s,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,N.joinPath)(s,"globalStorage"),settingsResource:(0,N.joinPath)(s,"settings.json"),keybindingsResource:(0,N.joinPath)(s,"keybindings.json"),tasksResource:(0,N.joinPath)(s,"tasks.json"),snippetsHome:(0,N.joinPath)(s,"snippets"),extensionsResource:(0,N.joinPath)(s,"extensions.json"),cacheHome:(0,N.joinPath)(o,t),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=L;let n=e.UserDataProfilesService=class extends A.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,s,o,l){super(),this.n=i,this.r=s,this.s=o,this.t=l,this.f=!0,this.h=this.B(new U.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new U.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new U.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new U.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,N.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,N.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=[];if(this.f)try{for(const E of this.J()){if(!E.name||!(0,u.isString)(E.name)||!E.location){this.t.warn("Skipping the invalid stored profile",E.location||E.name);continue}i.push(L((0,N.basename)(E.location),E.name,E.location,this.g,{shortName:E.shortName,useDefaultFlags:E.useDefaultFlags}))}}catch(E){this.t.error(E)}const s=new f.ResourceMap,o=new Map,l=this.w();if(i.unshift({...l,extensionsResource:this.O()??l.extensionsResource,isDefault:!0}),i.length)try{const E=this.M();if(E.workspaces)for(const[y,c]of Object.entries(E.workspaces)){const b=T.URI.parse(y),R=i.find(M=>M.id===c);R&&s.set(b,R)}if(E.emptyWindows)for(const[y,c]of Object.entries(E.emptyWindows)){const b=i.find(R=>R.id===c);b&&o.set(y,b)}}catch(E){this.t.error(E)}this.u={profiles:i,workspaces:s,emptyWindows:o}}return this.u}w(){return L("__default__profile__",(0,D.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(i){const s="Temp",o=new RegExp(`${(0,h.escapeRegExpCharacters)(s)}\\s(\\d+)`);let l=0;for(const y of this.profiles){const c=o.exec(y.name),b=c?parseInt(c[1]):0;l=b>l?b:l}const E=`${s} ${l+1}`;return this.createProfile((0,k.hash)((0,a.generateUuid)()).toString(16),E,{transient:!0},i)}async createNamedProfile(i,s,o){return this.createProfile((0,k.hash)((0,a.generateUuid)()).toString(16),i,s,o)}async createProfile(i,s,o,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=await this.y(i,s,o);return l&&await this.setProfileForWorkspace(l,E),E}async y(i,s,o){if(!(0,u.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let l=this.l.get(s);return l||(l=(async()=>{try{const E=this.profiles.find(b=>b.name===s||b.id===i);if(E)return E;const y=L(i,s,(0,N.joinPath)(this.profilesHome,i),this.g,o);await this.r.createFolder(y.location);const c=[];return this.i.fire({profile:y,join(b){c.push(b)}}),await w.Promises.settled(c),this.D([y],[],[]),y}finally{this.l.delete(s)}})(),this.l.set(s,l)),l}async updateProfile(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(l=>l.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);return o=L(o.id,s.name??o.name,o.location,this.g,{shortName:s.shortName??o.shortName,transient:s.transient??o.isTransient,useDefaultFlags:s.useDefaultFlags??o.useDefaultFlags}),this.D([],[],[o]),o}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(l=>l.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);const o=[];this.j.fire({profile:s,join(l){o.push(l)}});try{await Promise.allSettled(o)}catch(l){this.t.error(l)}for(const l of[...this.v.emptyWindows.keys()])s.id===this.v.emptyWindows.get(l)?.id&&this.v.emptyWindows.delete(l);for(const l of[...this.v.workspaces.keys()])s.id===this.v.workspaces.get(l)?.id&&this.v.workspaces.delete(l);this.H(),this.D([],[s],[]);try{await this.r.del(s.cacheHome,{recursive:!0})}catch(l){(0,m.toFileOperationResult)(l)!==1&&this.t.error(l)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(s.location,{recursive:!0})}catch(l){this.t.error(l)}}async setProfileForWorkspace(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(l=>l.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);this.G(i,o)}unsetWorkspace(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,s)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(s=>s.isDirectory&&this.profiles.every(o=>!this.s.extUri.isEqual(o.location,s.resource))).map(s=>this.r.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(s=>!this.C(s));await Promise.allSettled(i.map(s=>this.removeProfile(s)))}getProfileForWorkspace(i){const s=this.z(i);return T.URI.isUri(s)?this.m.workspaces.get(s)??this.v.workspaces.get(s):this.m.emptyWindows.get(s)??this.v.emptyWindows.get(s)}z(i){return(0,S.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,S.isWorkspaceIdentifier)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(s=>this.s.extUri.isEqual(s.location,i.location))||[...this.m.workspaces.values()].some(s=>this.s.extUri.isEqual(s.location,i.location))||[...this.v.emptyWindows.values()].some(s=>this.s.extUri.isEqual(s.location,i.location))||[...this.v.workspaces.values()].some(s=>this.s.extUri.isEqual(s.location,i.location)))}D(i,s,o){const l=[...this.profiles,...i],E=[];this.m.profiles=[];for(let y of l)y.isDefault||s.some(c=>y.id===c.id)||(y=o.find(c=>y.id===c.id)??y,y.isTransient?this.m.profiles.push(y):E.push({location:y.location,name:y.name,shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}));this.L(E),this.u=void 0,this.F(i,s,o)}F(i,s,o){this.h.fire({added:i,removed:s,updated:o,all:this.profiles})}G(i,s,o){o=s?.isTransient?!0:o,o||this.G(i,void 0,!0);const l=this.z(i),E=o?this.m:this.v;T.URI.isUri(l)?(E.workspaces.delete(l),s&&E.workspaces.set(l,s)):(E.emptyWindows.delete(l),s&&E.emptyWindows.set(l,s)),o||this.H()}H(){const i={};for(const[o,l]of this.v.workspaces.entries())i[o.toString()]=l.id;const s={};for(const[o,l]of this.v.emptyWindows.entries())s[o.toString()]=l.id;this.N({workspaces:i,emptyWindows:s}),this.u=void 0}I(i){const s={},o=this.w();if(i.workspaces)for(const[E,y]of Object.entries(i.workspaces)){const c=T.URI.parse(y);s[E]=this.s.extUri.isEqual(c,o.location)?o.id:this.s.extUri.basename(c)}const l={};if(i.emptyWindows)for(const[E,y]of Object.entries(i.emptyWindows)){const c=T.URI.parse(y);l[E]=this.s.extUri.isEqual(c,o.location)?o.id:this.s.extUri.basename(c)}return{workspaces:s,emptyWindows:l}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};n.b="userDataProfiles",n.c="profileAssociations",e.UserDataProfilesService=n=ve([X(0,C.IEnvironmentService),X(1,m.IFileService),X(2,d.IUriIdentityService),X(3,v.ILogService)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.InMemoryUserDataProfilesService=r}),define(oe[235],ae([0,1,6,2,17]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let N=e.UserDataProfilesCleaner=class extends U.Disposable{constructor(D){super(),this.B(new k.RunOnceScheduler(()=>{D.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=N=ve([X(0,A.IUserDataProfilesService)],N)}),define(oe[236],ae([0,1,21,6,26,7,3,2,5,10,12,145,28,33,49,8,24,20,17]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let I=e.AbstractExtensionManagementService=class extends D.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,s,o,l,E){super(),this.t=i,this.u=s,this.v=o,this.w=l,this.y=E,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new T.Emitter),this.m=this.B(new T.Emitter),this.n=this.B(new T.Emitter),this.p=this.B(new T.Emitter),this.s=[],this.B((0,D.toDisposable)(()=>{this.j.forEach(({task:y})=>y.cancel()),this.k.forEach(y=>y.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const s=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,S.isTargetPlatformCompatible)(o,i.allTargetPlatforms,s))}async installFromGallery(i,s={}){try{if(!this.t.isEnabled())throw new S.ExtensionManagementError(v.localize(0,null),S.ExtensionManagementErrorCode.Internal);const o=await this.G(i,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.z(o.manifest,o.extension,s)}catch(o){throw n(this.u,"extensionGallery:install",{extensionData:(0,f.getGalleryExtensionTelemetryData)(i),error:o}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(o),L(o)}}async uninstall(i,s={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,s)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,s,o){const l=o.isApplicationScoped||o.isBuiltin||(0,d.isApplicationScopedExtension)(i),E={...o,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(s)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:l,profileLocation:l?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},y=H=>`${f.ExtensionKey.create(H).toString()}${E.profileLocation?`-${E.profileLocation.toString()}`:""}`;if(!P.URI.isUri(s)){const H=this.j.get(y(s));if(H)return this.v.info("Extensions is already requested to install",s.identifier.id),H.task.waitUntilTaskIsFinished()}const c=[],b=[],R=[],M=this.Q(i,s,E);P.URI.isUri(s)||this.j.set(y(s),{task:M,waitingTasks:[]}),this.l.fire({identifier:M.identifier,source:s,profileLocation:E.profileLocation}),this.v.info("Installing extension:",M.identifier.id),c.push({task:M,manifest:i});let F=!1;try{if(E.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const q=await this.F(M.identifier,i,!!E.installOnlyNewlyAddedFromExtensionPack,!!E.installPreReleaseVersion,E.profileLocation),V=await this.getInstalled(void 0,E.profileLocation);for(const{gallery:Q,manifest:te}of(0,k.distinct)(q,({gallery:Y})=>Y.identifier.id)){F=F||!!te.extensionDependencies?.some(G=>(0,f.areSameExtensions)({id:G},M.identifier));const Y=y(Q),x=this.j.get(Y);if(x){if(this.C(M,x.task)){const G=x.task.identifier;this.v.info("Waiting for already requested installing extension",G.id,M.identifier.id),x.waitingTasks.push(M),b.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,j=>j.some(Z=>(0,f.areSameExtensions)(Z.identifier,G)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",G.id,M.identifier.id),!j.find(ie=>(0,f.areSameExtensions)(ie.identifier,G))?.local)throw new Error(`Extension ${G.id} is not installed`)}))}}else if(!V.some(({identifier:G})=>(0,f.areSameExtensions)(G,Q.identifier))){const G=this.Q(te,Q,{...E,donotIncludePackAndDependencies:!0});this.j.set(Y,{task:G,waitingTasks:[M]}),this.l.fire({identifier:G.identifier,source:Q,profileLocation:E.profileLocation}),this.v.info("Installing extension:",G.identifier.id,M.identifier.id),c.push({task:G,manifest:te})}}}catch(q){if(P.URI.isUri(M.source))(0,k.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",M.identifier.id,q.message),(0,k.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",M.identifier.id,q.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),q}const H=c.reduce((q,{task:V,manifest:Q})=>(q.set(V.identifier.id.toLowerCase(),{task:V,manifest:Q}),q),new Map);for(;H.size;){let q;const V=[...H.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(te=>H.has(te.toLowerCase())));V.length?q=H.size===1?V:V.filter(({task:Q})=>!(Q===M&&!F)):(this.v.info("Found extensions with circular dependencies",V.map(({task:Q})=>Q.identifier.id)),q=[...H.values()]),await this.D(q.map(async({task:Q})=>{const te=new Date().getTime();try{const Y=await Q.run();if(await this.D(this.s.map(x=>x.postInstall(Y,Q.source,E,A.CancellationToken.None))),!P.URI.isUri(Q.source)){const x=Q.operation===3,G=x?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(n(this.u,x?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.getGalleryExtensionTelemetryData)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-te,durationSinceUpdate:G}),C.isWeb&&Q.operation!==3)try{await this.t.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,"install")}catch{}}R.push({local:Y,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:E.context,profileLocation:Q.profileLocation,applicationScoped:Y.isApplicationScoped})}catch(Y){throw P.URI.isUri(Q.source)||n(this.u,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.getGalleryExtensionTelemetryData)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-te,error:Y}),this.v.error("Error while installing the extension:",Q.identifier.id),Y}finally{H.delete(Q.identifier.id.toLowerCase())}}))}return b.length&&await this.D(b),R.forEach(({identifier:q})=>this.v.info("Extension installed successfully:",q.id)),this.m.fire(R),R.filter(({identifier:q})=>(0,f.areSameExtensions)(q,M.identifier))[0].local}catch(H){if(c.forEach(({task:q})=>q.cancel()),R.length)try{const q=await Promise.allSettled(R.map(({local:V})=>this.R(V,{versionOnly:!0,profileLocation:E.profileLocation}).run()));for(let V=0;V<q.length;V++){const Q=q[V],{identifier:te}=R[V];Q.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",te.id):this.v.warn("Rollback: Error while uninstalling extension",te.id,(0,N.getErrorMessage)(Q.reason))}}catch(q){this.v.warn("Error while rolling back extensions",(0,N.getErrorMessage)(q),R.map(({identifier:V})=>V.id))}throw this.m.fire(c.map(({task:q})=>({identifier:q.identifier,operation:2,source:q.source,context:E.context,profileLocation:E.profileLocation}))),H}finally{for(const{task:H}of c)H.source&&!P.URI.isUri(H.source)&&this.j.delete(y(H.source))}}C(i,s){for(const[,{task:o,waitingTasks:l}]of this.j.entries())if(o===i&&(l.includes(s)||l.some(E=>this.C(E,s)))||o===s&&l[0]&&!this.C(i,l[0]))return!1;return!0}async D(i){const s=[],o=[],l=await Promise.allSettled(i);for(const E of l)E.status==="fulfilled"?s.push(E.value):o.push(E.reason);if(o.length)throw p(o);return s}async F(i,s,o,l,E){if(!this.t.isEnabled())return[];const y=await this.getInstalled(void 0,E),c=[],b=[],R=async(M,F)=>{c.push(M);const H=F.extensionDependencies||[],q=[...H];if(F.extensionPack){const V=o?y.find(Q=>(0,f.areSameExtensions)(Q.identifier,M)):void 0;for(const Q of F.extensionPack)V&&V.manifest.extensionPack&&V.manifest.extensionPack.some(te=>(0,f.areSameExtensions)({id:te},{id:Q}))||q.every(te=>!(0,f.areSameExtensions)({id:te},{id:Q}))&&q.push(Q)}if(q.length){const V=q.filter(Q=>c.every(te=>!(0,f.areSameExtensions)(te,{id:Q})));if(V.length){const Q=await this.t.getExtensions(V.map(te=>({id:te,preRelease:l})),A.CancellationToken.None);for(const te of Q){if(c.find(G=>(0,f.areSameExtensions)(G,te.identifier)))continue;const Y=H.some(G=>(0,f.areSameExtensions)({id:G},te.identifier));let x;try{x=await this.G(te,!1,l)}catch(G){if(G instanceof S.ExtensionManagementError&&G.code===S.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Y){this.v.info("Skipping the packed extension as it cannot be installed",te.identifier.id);continue}else throw G}b.push({gallery:x.extension,manifest:x.manifest}),await R(x.extension.identifier,x.manifest)}}}};return await R(i,s),b}async G(i,s,o){if((await this.getExtensionsControlManifest()).malicious.some(c=>(0,f.areSameExtensions)(i.identifier,c)))throw new S.ExtensionManagementError(v.localize(1,null,i.identifier.id),S.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const c=await this.getTargetPlatform();throw new S.ExtensionManagementError(v.localize(2,null,i.identifier.id,this.w.nameLong,(0,S.TargetPlatformToString)(c)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const E=await this.H(i,s,o);if(E){if(o&&!s&&i.hasPreReleaseVersion&&!E.properties.isPreReleaseVersion)throw new S.ExtensionManagementError(v.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),S.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],A.CancellationToken.None))[0]?new S.ExtensionManagementError(v.localize(4,null,i.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(v.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),S.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",E.identifier.id);const y=await this.t.getManifest(E,A.CancellationToken.None);if(y===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(y.version!==E.version)throw new S.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:E,manifest:y}}async H(i,s,o){const l=await this.getTargetPlatform();let E=null;return!s&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(E=(await this.t.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:l,compatible:!0},A.CancellationToken.None))[0]||null),!E&&await this.t.isExtensionCompatible(i,o,l)&&(E=i),E||(s?E=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:l,compatible:!0},A.CancellationToken.None))[0]||null:E=await this.t.getCompatibleExtension(i,o,l)),E}async I(i,s){const o={...s,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},l=M=>`${M.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,E=this.k.get(l(i.identifier));if(E)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),E.waitUntilTaskIsFinished();const y=M=>{const F=this.R(M,o);return this.k.set(l(F.extension.identifier),F),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.n.fire({identifier:M.identifier,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped}),F},c=(M,F)=>{F?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString(),F.message):this.v.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,F.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),n(this.u,"extensionGallery:uninstall",{extensionData:(0,f.getLocalExtensionTelemetryData)(M),error:F}),this.p.fire({identifier:M.identifier,error:F?.code,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})},b=[],R=[];try{b.push(y(i));const M=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const F=this.M(i,M);for(const H of F)this.k.has(l(H.identifier))?this.v.info("Extensions is already requested to uninstall",H.identifier.id):b.push(y(H))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(b.map(F=>F.extension),M,i),await this.D(b.map(async F=>{try{if(await F.run(),await this.D(this.s.map(H=>H.postUninstall(F.extension,o,A.CancellationToken.None))),F.extension.identifier.uuid)try{await this.t.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}c(F.extension)}catch(H){const q=H instanceof S.ExtensionManagementError?H:new S.ExtensionManagementError((0,N.getErrorMessage)(H),S.ExtensionManagementErrorCode.Internal);throw c(F.extension,q),q}finally{R.push(F)}}))}catch(M){const F=M instanceof S.ExtensionManagementError?M:new S.ExtensionManagementError((0,N.getErrorMessage)(M),S.ExtensionManagementErrorCode.Internal);for(const H of b){try{H.cancel()}catch{}R.includes(H)||c(H.extension,F)}throw F}finally{for(const M of b)this.k.delete(l(M.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}J(i,s,o){for(const l of i){const E=this.N(l,s);if(E.length){const y=E.filter(c=>!i.some(b=>(0,f.areSameExtensions)(b.identifier,c.identifier)));if(y.length)throw new Error(this.L(l,y,o))}}}L(i,s,o){return o===i?s.length===1?v.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?v.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):v.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?v.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?v.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):v.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}M(i,s,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const l=i.manifest.extensionPack?i.manifest.extensionPack:[];if(l.length){const E=s.filter(c=>!c.isBuiltin&&l.some(b=>(0,f.areSameExtensions)({id:b},c.identifier))),y=[];for(const c of E)y.push(...this.M(c,s,o));return[...E,...y]}return[]}N(i,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(l=>(0,f.areSameExtensions)({id:l},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};e.AbstractExtensionManagementService=I=ve([X(0,S.IExtensionGalleryService),X(1,h.ITelemetryService),X(2,w.ILogService),X(3,a.IProductService),X(4,u.IUserDataProfilesService)],I);function p(t){const i=Array.isArray(t)?t:[t];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((s,o)=>new Error(`${s.message}${s.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=p;function L(t){if(t instanceof S.ExtensionManagementError)return t;const i=new S.ExtensionManagementError(t.message,S.ExtensionManagementErrorCode.Internal);return i.stack=t.stack,i}function n(t,i,{extensionData:s,verificationStatus:o,duration:l,error:E,durationSinceUpdate:y}){let c,b;(0,m.isDefined)(o)&&(o===!0?o="Verified":(o===!1||(c=S.ExtensionManagementErrorCode.Signature,b=o),o="Unverified")),E&&(E instanceof S.ExtensionManagementError?(c=E.code,E.code===S.ExtensionManagementErrorCode.Signature&&(b=E.message)):c=S.ExtensionManagementErrorCode.Internal),t.publicLog(i,{...s,verificationStatus:o,success:!E,duration:l,errorcode:c,errorcodeDetail:b,durationSinceUpdate:y})}class r{constructor(){this.d=new U.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,U.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,U.createCancelablePromise)(i=>new Promise((s,o)=>{const l=i.onCancellationRequested(()=>{l.dispose(),o(new N.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=r}),define(oe[50],ae([0,1,6,16,2,3,35,12,28,33,13,4,8,17,29,10,7,20]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class I extends Error{constructor(t,i){super(t),this.code=i}}e.ExtensionsProfileScanningError=I,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let p=e.AbstractExtensionsProfileScannerService=class extends A.Disposable{constructor(t,i,s,o,l,E){super(),this.i=t,this.j=i,this.k=s,this.l=o,this.m=l,this.n=E,this.b=this.B(new N.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new N.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new N.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new N.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new T.ResourceMap}scanProfileExtensions(t,i){return this.p(t,void 0,i)}async addExtensionsToProfile(t,i){const s=[],o=[];try{return await this.p(i,l=>{const E=[];for(const y of l)t.some(([c])=>(0,m.areSameExtensions)(c.identifier,y.identifier)&&c.manifest.version!==y.version)?s.push(y):E.push(y);for(const[y,c]of t)if(!E.some(b=>(0,m.areSameExtensions)(b.identifier,y.identifier)&&b.version===y.manifest.version)){const b={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:c};o.push(b),E.push(b)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),s.length&&this.f.fire({extensions:s,profileLocation:i}),E}),o.length&&this.c.fire({extensions:o,profileLocation:i}),s.length&&this.g.fire({extensions:s,profileLocation:i}),o}catch(l){throw o.length&&this.c.fire({extensions:o,error:l,profileLocation:i}),s.length&&this.g.fire({extensions:s,error:l,profileLocation:i}),l}}async updateMetadata(t,i){const s=[];return await this.p(i,o=>{const l=[];for(const E of o){const y=t.find(([c])=>(0,m.areSameExtensions)(c.identifier,E.identifier)&&c.manifest.version===E.version);y&&(E.metadata={...E.metadata,...y[1]},s.push(E)),l.push(E)}return l}),s}async removeExtensionFromProfile(t,i){const s=[];this.f.fire({extensions:s,profileLocation:i});try{await this.p(i,o=>{const l=[];for(const E of o)(0,m.areSameExtensions)(E.identifier,t.identifier)?s.push(E):l.push(E);return s.length&&this.f.fire({extensions:s,profileLocation:i}),l}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:i}),o}}async p(t,i,s){return this.w(t).queue(async()=>{let o=[],l;try{const E=await this.j.readFile(t);l=JSON.parse(E.value.toString().trim()||"[]")}catch(E){if((0,P.toFileOperationResult)(E)!==1)throw E;if(this.l.extUri.isEqual(t,this.k.defaultProfile.extensionsResource)&&(l=await this.v()),!l&&s?.bailOutWhenFileNotFound)throw new I((0,a.getErrorMessage)(E),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.r(t);let E=!1;for(const y of l){L(y)||this.r(t);let c;if((0,w.isString)(y.relativeLocation)&&y.relativeLocation)c=this.t(y.relativeLocation);else if((0,w.isString)(y.location))c=this.t(y.location),E=!0,y.relativeLocation=y.location,y.location=c.toJSON();else{c=D.URI.revive(y.location);const b=this.s(c);b&&(E=!0,y.relativeLocation=b)}o.push({identifier:y.identifier,location:c,version:y.version,metadata:y.metadata})}E&&await this.j.writeFile(t,U.VSBuffer.fromString(JSON.stringify(l)))}if(i){o=i(o);const E=o.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.s(y.location),metadata:y.metadata}));await this.j.writeFile(t,U.VSBuffer.fromString(JSON.stringify(E)))}return o})}r(t){const i=new I(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(t){return this.l.extUri.isEqual(this.l.extUri.dirname(t),this.i)?this.l.extUri.basename(t):void 0}t(t){return this.l.extUri.joinPath(this.i,t)}async v(){return this.u||(this.u=(async()=>{const t=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let s;try{s=(await this.j.readFile(t)).value.toString()}catch(l){if((0,P.toFileOperationResult)(l)===1)return;throw l}this.n.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(E=>L(E))?o=l:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.n.error(l)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,U.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",t.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(l){if((0,P.toFileOperationResult)(l)===3)this.n.info("Migration from old default profile location to new location is done by another window",t.toString(),this.k.defaultProfile.extensionsResource.toString());else throw l}try{await this.j.del(t)}catch(l){(0,P.toFileOperationResult)(l)!==1&&this.n.error(l)}try{await this.j.del(i)}catch(l){(0,P.toFileOperationResult)(l)!==1&&this.n.error(l)}return o})()),this.u}w(t){let i=this.h.get(t);return i||(i=new k.Queue,this.h.set(t,i)),i}};e.AbstractExtensionsProfileScannerService=p=ve([X(1,P.IFileService),X(2,f.IUserDataProfilesService),X(3,d.IUriIdentityService),X(4,h.ITelemetryService),X(5,S.ILogService)],p);function L(r){return(0,w.isObject)(r)&&(0,C.isIExtensionIdentifier)(r.identifier)&&(n(r.location)||(0,w.isString)(r.location)&&r.location)&&((0,w.isUndefined)(r.relativeLocation)||(0,w.isString)(r.relativeLocation))&&r.version&&(0,w.isString)(r.version)}function n(r){return r?(0,w.isString)(r.path)&&(0,w.isString)(r.scheme):!1}}),define(oe[78],ae([0,1,21,6,31,16,7,34,131,2,25,15,5,22,52,89,10,12,148,14,33,49,67,13,4,8,24,3,64,50,17,29,176]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u,I,p,L,n,r,t,i,s,o,l,E,y,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var R;(function(te){function Y(x,G){if(x===G)return!0;const j=Object.keys(x),Z=new Set;for(const ie of Object.keys(G))Z.add(ie);if(j.length!==Z.size)return!1;for(const ie of j){if(x[ie]!==G[ie])return!1;Z.delete(ie)}return Z.size===0}te.equals=Y})(R||(e.Translations=R={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let M=e.AbstractExtensionsScannerService=class extends m.Disposable{constructor(Y,x,G,j,Z,ie,se,K,_,$,g,O){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=x,this.l=G,this.m=j,this.n=Z,this.r=ie,this.s=se,this.t=K,this.u=_,this.v=$,this.w=g,this.y=O,this.g=this.B(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(q,this.m,this.h)),this.j=this.B(this.y.createInstance(q,this.m,this.h)),this.k=this.B(this.y.createInstance(H,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,p.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions(Y,x,G){const[j,Z]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(x)]),ie=G?await this.scanExtensionsUnderDevelopment(Y,[...j,...Z]):[];return this.G(j,Z,ie,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const x=[];x.push(this.H(!!Y.useCache,Y.language)),x.push(this.I(Y.language,!!Y.checkControlFile));const[G,j]=await Promise.all(x);return this.F([...G,...j],0,Y,!1)}async scanUserExtensions(Y){const x=Y.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",x);const G=this.w.extUri.isEqual(Y.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.L(x,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,G),Z=Y.useCache&&!j.devMode&&j.excludeObsolete?this.j:this.k;let ie;try{ie=await Z.scanExtensions(j)}catch(se){if(se instanceof E.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),ie=await Z.scanExtensions(j);else throw se}return ie=await this.F(ie,1,Y,!0),this.t.trace("Scanned user extensions:",ie.length),ie}async scanExtensionsUnderDevelopment(Y,x){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const G=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(j=>j.scheme===P.Schemas.file).map(async j=>{const Z=await this.L(j,!1,1,!0,Y.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Z)).map(se=>(se.type=x.find(K=>(0,p.areSameExtensions)(K.identifier,se.identifier))?.type??se.type,this.k.validate(se,Z)))}))).flat();return this.F(G,"development",Y,!0)}return[]}async scanExistingExtension(Y,x,G){const j=await this.L(Y,!1,x,!0,G.language,!0,void 0),Z=await this.k.scanExtension(j);return!Z||!G.includeInvalid&&!Z.isValid?null:Z}async scanOneOrMultipleExtensions(Y,x,G){const j=await this.L(Y,!1,x,!0,G.language,!0,void 0),Z=await this.k.scanOneOrMultipleExtensions(j);return this.F(Z,x,G,!0)}async scanMetadata(Y){const x=(0,f.joinPath)(Y,"package.json"),G=(await this.s.readFile(x)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(Y,x){const G=(0,f.joinPath)(Y,"package.json"),j=(await this.s.readFile(G)).value.toString(),Z=JSON.parse(j);x.isMachineScoped=x.isMachineScoped||void 0,x.isBuiltin=x.isBuiltin||void 0,Z.__metadata={...Z.__metadata,...x},await this.s.writeFile((0,f.joinPath)(Y,"package.json"),N.VSBuffer.fromString(JSON.stringify(Z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof E.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw Y}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.r.addExtensionsToProfile(Y.map(x=>[x,x.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,N.VSBuffer.fromString(JSON.stringify([])))}catch(x){(0,r.toFileOperationResult)(x)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)(x))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.t.error(Y)}finally{this.C=void 0}})()),this.C}async F(Y,x,G,j){return G.includeAllVersions||(Y=this.G(x===0?Y:void 0,x===1?Y:void 0,x==="development"?Y:void 0,await this.getTargetPlatform(),j)),G.includeInvalid||(Y=Y.filter(Z=>Z.isValid)),Y.sort((Z,ie)=>{const se=v.basename(Z.location.fsPath),K=v.basename(ie.location.fsPath);return se<K?-1:se>K?1:0})}G(Y,x,G,j,Z){const ie=(K,_,$)=>{if(K.isValid&&!_.isValid)return!1;if(K.isValid===_.isValid){if(Z&&d.gt(K.manifest.version,_.manifest.version))return this.t.debug(`Skipping extension ${_.location.path} with lower version ${_.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(d.eq(K.manifest.version,_.manifest.version)){if(K.type===0)return this.t.debug(`Skipping extension ${_.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===j)return this.t.debug(`Skipping extension ${_.location.path} from different target platform ${_.targetPlatform}`),!1}}return $?this.t.warn(`Overwriting user extension ${K.location.path} with ${_.location.path}.`):this.t.debug(`Overwriting user extension ${K.location.path} with ${_.location.path}.`),!0},se=new L.ExtensionIdentifierMap;return Y?.forEach(K=>{const _=se.get(K.identifier.id);(!_||ie(_,K,!1))&&se.set(K.identifier.id,K)}),x?.forEach(K=>{const _=se.get(K.identifier.id);if(!_&&Y&&K.type===0){this.t.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!_||ie(_,K,!1))&&se.set(K.identifier.id,K)}),G?.forEach(K=>{const _=se.get(K.identifier.id);(!_||ie(_,K,!0))&&se.set(K.identifier.id,K),se.set(K.identifier.id,K)}),[...se.values()]}async H(Y,x){this.t.trace("Started scanning system extensions");const G=await this.L(this.systemExtensionsLocation,!1,0,!0,x,!0,void 0),Z=await(Y&&!G.devMode?this.i:this.k).scanExtensions(G);return this.t.trace("Scanned system extensions:",Z.length),Z}async I(Y,x){const G=this.u.isBuilt?[]:this.v.builtInExtensions;if(!G?.length)return[];this.t.trace("Started scanning dev system extensions");const j=x?await this.J():{},Z=[],ie=h.URI.file(v.normalize(v.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of G){const _=j[K.name]||"marketplace";switch(_){case"disabled":break;case"marketplace":Z.push((0,f.joinPath)(ie,K.name));break;default:Z.push(h.URI.file(_));break}}const se=await Promise.all(Z.map(async K=>this.k.scanExtension(await this.L(K,!1,0,!0,Y,!0,void 0))));return this.t.trace("Scanned dev system extensions:",se.length),(0,k.coalesce)(se)}async J(){try{const Y=await this.s.readFile(this.l);return JSON.parse(Y.value.toString())}catch{return{}}}async L(Y,x,G,j,Z,ie,se){const K=await this.f(Z??S.language),_=await this.M(Y),$=x&&!this.w.extUri.isEqual(Y,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,g=$?await this.M($):void 0;return new F(Y,_,$,g,x,se,G,j,ie,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,Z,K)}async M(Y){try{const x=await this.s.stat(Y);if(typeof x.mtime=="number")return x.mtime}catch{}}};e.AbstractExtensionsScannerService=M=ve([X(4,y.IUserDataProfilesService),X(5,E.IExtensionsProfileScannerService),X(6,r.IFileService),X(7,i.ILogService),X(8,I.IEnvironmentService),X(9,s.IProductService),X(10,c.IUriIdentityService),X(11,t.IInstantiationService)],M);class F{constructor(Y,x,G,j,Z,ie,se,K,_,$,g,O,B,W,z){this.location=Y,this.mtime=x,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=j,this.profile=Z,this.profileScanOptions=ie,this.type=se,this.excludeObsolete=K,this.validate=_,this.productVersion=$,this.productDate=g,this.productCommit=O,this.devMode=B,this.language=W,this.translations=z}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,x){return(0,f.isEqual)(Y.location,x.location)&&Y.mtime===x.mtime&&(0,f.isEqual)(Y.applicationExtensionslocation,x.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===x.applicationExtensionslocationMtime&&Y.profile===x.profile&&A.equals(Y.profileScanOptions,x.profileScanOptions)&&Y.type===x.type&&Y.excludeObsolete===x.excludeObsolete&&Y.validate===x.validate&&Y.productVersion===x.productVersion&&Y.productDate===x.productDate&&Y.productCommit===x.productCommit&&Y.devMode===x.devMode&&Y.language===x.language&&R.equals(Y.translations,x.translations)}}e.ExtensionScannerInput=F;let H=class extends m.Disposable{constructor(Y,x,G,j,Z){super(),this.f=Y,this.g=x,this.h=G,this.i=j,this.j=Z}async scanExtensions(Y){const x=Y.profile?await this.l(Y):await this.k(Y);let G={};if(Y.excludeObsolete&&Y.type===1)try{const j=(await this.i.readFile(this.f)).value.toString();G=JSON.parse(j)}catch{}return(0,a.isEmptyObject)(G)?x:x.filter(j=>!G[p.ExtensionKey.create(j).toString()])}async k(Y){const x=await this.i.resolve(Y.location);if(!x.children?.length)return[];const G=await Promise.all(x.children.map(async j=>{if(!j.isDirectory||Y.type===1&&(0,f.basename)(j.resource).indexOf(".")===0)return null;const Z=new F(j.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(Z)}));return(0,k.coalesce)(G).sort((j,Z)=>j.location.path<Z.location.path?-1:1)}async l(Y){let x=await this.m(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.h.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){x=x.filter(j=>!j.metadata?.isApplicationScoped);const G=await this.m(Y.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,Y);x.push(...G)}return x}async m(Y,x,G){const j=await this.g.scanProfileExtensions(Y,G.profileScanOptions);if(!j.length)return[];const Z=await Promise.all(j.map(async ie=>{if(x(ie)){const se=new F(ie.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(se,ie.metadata)}return null}));return(0,k.coalesce)(Z)}async scanOneOrMultipleExtensions(Y){try{if(await this.i.exists((0,f.joinPath)(Y.location,"package.json"))){const x=await this.scanExtension(Y);return x?[x]:[]}else return await this.scanExtensions(Y)}catch(x){return this.j.error(`Error scanning extensions at ${Y.location.path}:`,(0,T.getErrorMessage)(x)),[]}}async scanExtension(Y,x){try{let G=await this.scanExtensionManifest(Y.location);if(G){G.publisher||(G.publisher=L.UNDEFINED_PUBLISHER),x=x??G.__metadata,delete G.__metadata;const j=(0,p.getGalleryExtensionId)(G.publisher,G.name),Z=x?.id?{id:j,uuid:x.id}:{id:j},ie=x?.isSystem?0:Y.type,se=ie===0||!!x?.isBuiltin;G=await this.n(Y.location,G,F.createNlsConfiguration(Y));const K={type:ie,identifier:Z,manifest:G,location:Y.location,isBuiltin:se,targetPlatform:x?.targetPlatform??"undefined",metadata:x,isValid:!0,validations:[]};return Y.validate?this.validate(K,Y):K}}catch(G){Y.type!==0&&this.j.error(G)}return null}validate(Y,x){let G=!0;const j=(0,n.validateExtensionManifest)(x.productVersion,x.productDate,x.location,Y.manifest,Y.isBuiltin);for(const[Z,ie]of j)Z===w.default.Error&&(G=!1,this.j.error(this.u(x.location,ie)));return Y.isValid=G,Y.validations=j,Y}async scanExtensionManifest(Y){const x=(0,f.joinPath)(Y,"package.json");let G;try{G=(await this.i.readFile(x)).value.toString()}catch(Z){return(0,r.toFileOperationResult)(Z)!==1&&this.j.error(this.u(Y,(0,u.localize)(0,null,x.path,Z.message))),null}let j;try{j=JSON.parse(G)}catch{const ie=[];(0,D.parse)(G,ie);for(const se of ie)this.j.error(this.u(Y,(0,u.localize)(1,null,x.path,se.offset,se.length,(0,C.getParseErrorMessage)(se.error))));return null}return(0,D.getNodeType)(j)!=="object"?(this.j.error(this.u(Y,(0,u.localize)(2,null,x.path))),null):j}async n(Y,x,G){const j=await this.r(Y,x,G);if(j)try{const Z=[],ie=await this.s(j.default,Z);if(Z.length>0)return Z.forEach(K=>{this.j.error(this.u(Y,(0,u.localize)(3,null,j.default?.path,(0,C.getParseErrorMessage)(K.error))))}),x;if((0,D.getNodeType)(j)!=="object")return this.j.error(this.u(Y,(0,u.localize)(4,null,j.default?.path))),x;const se=j.values||Object.create(null);return(0,b.localizeManifest)(x,se,ie)}catch{}return x}async r(Y,x,G){const j=(0,f.joinPath)(Y,"package.nls.json"),Z=(_,$)=>{$.forEach(g=>{this.j.error(this.u(Y,(0,u.localize)(5,null,_?.path,(0,C.getParseErrorMessage)(g.error))))})},ie=_=>{this.j.error(this.u(Y,(0,u.localize)(6,null,_?.path)))},se=`${x.publisher}.${x.name}`,K=G.translations[se];if(K)try{const _=h.URI.file(K),$=(await this.i.readFile(_)).value.toString(),g=[],O=(0,D.parse)($,g);return g.length>0?(Z(_,g),{values:void 0,default:j}):(0,D.getNodeType)(O)!=="object"?(ie(_),{values:void 0,default:j}):{values:O.contents?O.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.i.exists(j))return;let $;try{$=await this.t(Y,G)}catch{return}if(!$.localized)return{values:void 0,default:$.original};try{const g=(await this.i.readFile($.localized)).value.toString(),O=[],B=(0,D.parse)(g,O);return O.length>0?(Z($.localized,O),{values:void 0,default:$.original}):(0,D.getNodeType)(B)!=="object"?(ie($.localized),{values:void 0,default:$.original}):{values:B,default:$.original}}catch{return{values:void 0,default:$.original}}}}async s(Y,x){if(Y)try{const G=(await this.i.readFile(Y)).value.toString();return(0,D.parse)(G,x)}catch{}}t(Y,x){return new Promise((G,j)=>{const Z=ie=>{const se=(0,f.joinPath)(Y,`package.nls.${ie}.json`);this.i.exists(se).then(K=>{K&&G({localized:se,original:(0,f.joinPath)(Y,"package.nls.json")});const _=ie.lastIndexOf("-");_===-1?G({localized:(0,f.joinPath)(Y,"package.nls.json"),original:null}):(ie=ie.substring(0,_),Z(ie))})};if(x.devMode||x.pseudo||!x.language)return G({localized:(0,f.joinPath)(Y,"package.nls.json"),original:null});Z(x.language)})}u(Y,x){return`[${Y.path}]: ${x}`}};H=ve([X(1,E.IExtensionsProfileScannerService),X(2,c.IUriIdentityService),X(3,r.IFileService),X(4,i.ILogService)],H);let q=class extends H{constructor(Y,x,G,j,Z,ie,se){super(x,j,Z,ie,se),this.z=Y,this.C=G,this.w=this.B(new U.ThrottledDelayer(3e3)),this.y=this.B(new o.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions(Y){const x=this.H(Y),G=await this.D(x);if(this.v=Y,G&&G.input&&F.equals(G.input,this.v))return this.j.debug("Using cached extensions scan result",Y.location.toString()),this.w.trigger(()=>this.G()),G.result.map(Z=>(Z.location=h.URI.revive(Z.location),Z));const j=await super.scanExtensions(Y);return await this.F(x,{input:Y,result:j}),j}async D(Y){try{const x=await this.i.readFile(Y),G=JSON.parse(x.value.toString());return{result:G.result,input:(0,l.revive)(G.input)}}catch(x){this.j.debug("Error while reading the extension cache file:",Y.path,(0,T.getErrorMessage)(x))}return null}async F(Y,x){try{await this.i.writeFile(Y,N.VSBuffer.fromString(JSON.stringify(x)))}catch(G){this.j.debug("Error while writing the extension cache file:",Y.path,(0,T.getErrorMessage)(G))}}async G(){if(!this.v)return;const Y=this.H(this.v),x=await this.D(Y);if(!x)return;const G=x.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!A.equals(j,G))try{this.j.info("Invalidating Cache",G,j),await this.i.del(Y),this.y.fire()}catch(Z){this.j.error(Z)}}H(Y){const x=this.I(Y);return this.h.extUri.joinPath(x.cacheHome,Y.type===0?L.BUILTIN_MANIFEST_CACHE_FILE:L.USER_MANIFEST_CACHE_FILE)}I(Y){return Y.type===0?this.C.defaultProfile:Y.profile?this.h.extUri.isEqual(Y.location,this.z.extensionsResource)?this.z:this.C.profiles.find(x=>this.h.extUri.isEqual(Y.location,x.extensionsResource))??this.z:this.C.defaultProfile}};q=ve([X(2,y.IUserDataProfilesService),X(3,E.IExtensionsProfileScannerService),X(4,c.IUriIdentityService),X(5,r.IFileService),X(6,i.ILogService)],q);function V(te,Y){const x=(0,p.getExtensionId)(te.manifest.publisher,te.manifest.name);return{id:x,identifier:new L.ExtensionIdentifier(x),isBuiltin:te.type===0,isUserBuiltin:te.type===1&&te.isBuiltin,isUnderDevelopment:Y,extensionLocation:te.location,uuid:te.identifier.uuid,targetPlatform:te.targetPlatform,...te.manifest}}e.toExtensionDescription=V;class Q extends M{constructor(Y,x,G,j,Z,ie,se,K,_,$,g,O){super(Y,x,(0,f.joinPath)(G,".vscode-oss-dev","extensions","control.json"),j,Z,ie,se,K,_,$,g,O),this.N=(async()=>{if(S.translationsConfigFile)try{const B=await this.s.readFile(h.URI.file(S.translationsConfigFile));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(Y){return this.N}}e.NativeExtensionsScannerService=Q}),define(oe[237],ae([0,1,65,6,38,3,2,25,15,30,8,17]),function(ne,e,k,U,A,N,T,D,C,m,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let S=e.ExtensionsLifecycle=class extends T.Disposable{constructor(d,w){super(),this.b=d,this.f=w,this.a=new U.Limiter(5)}async postUninstall(d){const w=this.g(d,"uninstall");w&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(w.script,"uninstall",w.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(a){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(a)}}));try{await m.Promises.rm(this.j(d))}catch(a){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(a)}}g(d,w){const a=`vscode:${w}`;if(d.location.scheme===D.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[a]=="string"){const h=d.manifest.scripts[a].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${a} should be a node script`),null):{script:(0,C.join)(d.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(d,w,a,h,u){return new Promise((I,p)=>{const L=this.i(d,w,a,u);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?p(t):I(void 0)};L.on("error",t=>{r((0,A.toErrorMessage)(t)||"Unknown")}),L.on("exit",(t,i)=>{r(t?`post-${w} process exited with code ${t}`:void 0)}),h&&(n=setTimeout(()=>{n=null,L.kill(),p("timed out")},5e3))})}i(d,w,a,h){const u={silent:!0,execArgv:void 0},I=(0,k.fork)(d,[`--type=extension-post-${w}`,...a],u);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const p=N.Event.fromNodeEventEmitter(I.stdout,"data"),L=N.Event.fromNodeEventEmitter(I.stderr,"data");p(t=>this.f.info(h.identifier.id,h.manifest.version,`post-${w}`,t)),L(t=>this.f.error(h.identifier.id,h.manifest.version,`post-${w}`,t));const n=N.Event.any(N.Event.map(p,t=>({data:`%c${t}`,format:[""]})),N.Event.map(L,t=>({data:`%c${t}`,format:["color: red"]})));return N.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(h.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),I}j(d){return(0,C.join)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=S=ve([X(0,v.IUserDataProfilesService),X(1,P.ILogService)],S)}),define(oe[238],ae([0,1,8,17,29,20,50,13,14,12]),function(ne,e,k,U,A,N,T,D,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=e.ExtensionsProfileScannerService=class extends T.AbstractExtensionsProfileScannerService{constructor(S,f,d,w,a,h){super(m.URI.file(S.extensionsPath),f,d,w,a,h)}};e.ExtensionsProfileScannerService=P=ve([X(0,C.INativeEnvironmentService),X(1,D.IFileService),X(2,U.IUserDataProfilesService),X(3,A.IUriIdentityService),X(4,N.ITelemetryService),X(5,k.ILogService)],P)}),define(oe[239],ae([0,1,12,14,50,78,13,4,8,24,29,17]),function(ne,e,k,U,A,N,T,D,C,m,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=e.ExtensionsScannerService=class extends N.NativeExtensionsScannerService{constructor(d,w,a,h,u,I,p,L){super(k.URI.file(u.builtinExtensionsPath),k.URI.file(u.extensionsPath),u.userHome,d.defaultProfile,d,w,a,h,u,I,p,L)}};e.ExtensionsScannerService=S=ve([X(0,v.IUserDataProfilesService),X(1,A.IExtensionsProfileScannerService),X(2,T.IFileService),X(3,C.ILogService),X(4,U.INativeEnvironmentService),X(5,m.IProductService),X(6,P.IUriIdentityService),X(7,D.IInstantiationService)],S)}),define(oe[19],ae([0,1,6,3,2,100,10,66,4,17]),function(ne,e,k,U,A,N,T,D,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,C.createDecorator)("storageService");var P;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var v;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var S;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(S||(e.StorageTarget=S={}));function f(u){const I=u.get(e.TARGET_KEY);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}e.loadKeyTargets=f;class d extends A.Disposable{constructor(I={flushInterval:d.a}){super(),this.j=I,this.b=this.B(new U.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new U.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new U.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new k.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new A.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,k.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,A.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.J()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(I,p){if(p===e.TARGET_KEY){switch(I){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:p,target:this.F(I)[p]})}r(I){this.f.fire({reason:I})}get(I,p,L){return this.L(p)?.get(I,L)}getBoolean(I,p,L){return this.L(p)?.getBoolean(I,L)}getNumber(I,p,L){return this.L(p)?.getNumber(I,L)}getObject(I,p,L){return this.L(p)?.getObject(I,L)}store(I,p,L,n){if((0,T.isUndefinedOrNull)(p)){this.remove(I,L);return}this.t(()=>{this.u(I,L,n),this.L(L)?.set(I,p)})}remove(I,p){this.t(()=>{this.u(I,p,void 0),this.L(p)?.delete(I)})}t(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,p){const L=[],n=this.F(I);for(const r of Object.keys(n))n[r]===p&&L.push(r);return L}u(I,p,L){const n=this.F(p);typeof L=="number"?n[I]!==L&&(n[I]=L,this.L(p)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[I]=="number"&&(delete n[I],this.L(p)?.set(e.TARGET_KEY,JSON.stringify(n)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(I){switch(I){case-1:return this.D;case 0:return this.z;default:return this.w}}G(I){const p=this.L(I);return p?f(p):Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(I=P.NONE){this.f.fire({reason:I});const p=this.L(-1),L=this.L(0),n=this.L(1);switch(I){case P.NONE:await k.Promises.settled([p?.whenFlushed()??Promise.resolve(),L?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await k.Promises.settled([p?.flush(0)??Promise.resolve(),L?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.L(-1)?.items??new Map,p=this.L(0)?.items??new Map,L=this.L(1)?.items??new Map;return h(I,p,L,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(I,p){return this.r(P.NONE),(0,m.isUserDataProfile)(I)?this.N(I,p):this.O(I,p)}H(I,p){return!(I.id===p.id||w(p)&&w(I))}I(I,p,L,n){this.t(()=>{if(n)for(const[r,t]of I)p.set(r,t);else{const r=new Set;for(const[t,i]of I)r.add(t),p.get(t)!==i&&this.n(L,t);for(const[t]of p.items)r.has(t)||this.n(L,t)}})}}e.AbstractStorageService=d,d.a=60*1e3;function w(u){return u.isDefault||!!u.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=w;class a extends d{constructor(){super(),this.p=this.B(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(I=>this.n(1,I))),this.B(this.P.onDidChangeStorage(I=>this.n(0,I))),this.B(this.p.onDidChangeStorage(I=>this.n(-1,I)))}L(I){switch(I){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(I){switch(I){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(I){return!1}}e.InMemoryStorageService=a;async function h(u,I,p,L,n,r){const t=R=>{try{return JSON.parse(R)}catch{return R}},i=new Map,s=new Map;u.forEach((R,M)=>{i.set(M,R),s.set(M,t(R))});const o=new Map,l=new Map;I.forEach((R,M)=>{o.set(M,R),l.set(M,t(R))});const E=new Map,y=new Map;p.forEach((R,M)=>{E.set(M,R),y.set(M,t(R))}),console.group(L!==n?`Storage: Application (path: ${L})`:`Storage: Application & Profile (path: ${L}, default profile)`);const c=[];if(i.forEach((R,M)=>{c.push({key:M,value:R})}),console.table(c),console.groupEnd(),console.log(s),L!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const R=[];o.forEach((M,F)=>{R.push({key:F,value:M})}),console.table(R),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const b=[];E.forEach((R,M)=>{b.push({key:M,value:R})}),console.table(b),console.groupEnd(),console.log(y)}e.logStorage=h}),define(oe[113],ae([0,1,3,2,10,28,33,19]),function(ne,e,k,U,A,N,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=e.GlobalExtensionEnablementService=class extends U.Disposable{constructor(v,S){super(),this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new m(v)),this.B(this.b.onDidChange(f=>this.a.fire({extensions:f,source:"storage"}))),this.B(S.onDidInstallExtensions(f=>f.forEach(({local:d,operation:w})=>{d&&w===4&&this.f(d.identifier)})))}async enableExtension(v,S){return this.f(v)?(this.a.fire({extensions:[v],source:S}),!0):!1}async disableExtension(v,S){return this.c(v)?(this.a.fire({extensions:[v],source:S}),!0):!1}getDisabledExtensions(){return this.h(N.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(v){const S=this.getDisabledExtensions();return S.every(f=>!(0,T.areSameExtensions)(f,v))?(S.push(v),this.g(S),!0):!1}f(v){const S=this.getDisabledExtensions();for(let f=0;f<S.length;f++){const d=S[f];if((0,T.areSameExtensions)(d,v))return S.splice(f,1),this.g(S),!0}return!1}g(v){this.i(N.DISABLED_EXTENSIONS_STORAGE_PATH,v)}h(v){return this.b.get(v,0)}i(v,S){this.b.set(v,S,0)}};e.GlobalExtensionEnablementService=C=ve([X(0,D.IStorageService),X(1,N.IExtensionManagementService)],C);class m extends U.Disposable{constructor(v){super(),this.c=v,this.a=Object.create(null),this.b=this.B(new k.Emitter),this.onDidChange=this.b.event,this.B(v.onDidChangeValue(S=>this.f(S)))}get(v,S){let f;return S===0?((0,A.isUndefinedOrNull)(this.a[v])&&(this.a[v]=this.g(v,S)),f=this.a[v]):f=this.g(v,S),JSON.parse(f)}set(v,S,f){const d=JSON.stringify(S.map(({id:a,uuid:h})=>({id:a,uuid:h})));this.g(v,f)!==d&&(f===0&&(S.length?this.a[v]=d:delete this.a[v]),this.h(v,S.length?d:void 0,f))}f(v){if(v.scope===0&&!(0,A.isUndefinedOrNull)(this.a[v.key])&&this.g(v.key,v.scope)!==this.a[v.key]){const f=this.get(v.key,v.scope);delete this.a[v.key];const d=this.get(v.key,v.scope),w=f.filter(h=>!d.some(u=>(0,T.areSameExtensions)(h,u))),a=d.filter(h=>!f.some(u=>(0,T.areSameExtensions)(u,h)));(w.length||a.length)&&this.b.fire([...w,...a])}}g(v,S){return this.c.get(v,S,"[]")}h(v,S,f){S?this.c.store(v,S,f,1):this.c.remove(v,f)}}e.StorageManager=m}),define(oe[240],ae([0,1,21,26,7,5,37,10,12,18,14,28,33,67,13,8,24,56,217,19,20]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const L=N.isWeb?"web":(0,v.getTargetPlatform)(N.platform,T.arch),n="X-Market-Search-Activity-Id";var r;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished",$[$.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function t(...$){return String($.reduce((g,O)=>g|O,0))}var i;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},E={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class y{constructor(g=E){this.d=g}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(g,O=this.d.pageSize){return new y({...this.d,pageNumber:g,pageSize:O})}withFilter(g,...O){const B=[...this.d.criteria,...O.length?O.map(W=>({filterType:g,value:W})):[{filterType:g}]];return new y({...this.d,criteria:B})}withSortBy(g){return new y({...this.d,sortBy:g})}withSortOrder(g){return new y({...this.d,sortOrder:g})}withFlags(...g){return new y({...this.d,flags:g.reduce((O,B)=>O|B,0)})}withAssetTypes(...g){return new y({...this.d,assetTypes:g})}withSource(g){return new y({...this.d,source:g})}get raw(){const{criteria:g,pageNumber:O,pageSize:B,sortBy:W,sortOrder:z,flags:J,assetTypes:ee}=this.d;return{filters:[{criteria:g,pageNumber:O,pageSize:B,sortBy:W,sortOrder:z}],assetTypes:ee,flags:J}}get searchText(){const g=this.d.criteria.filter(O=>O.filterType===i.SearchText)[0];return g&&g.value?g.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(g=>String(g.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function c($,g){const O=($||[]).filter(B=>B.statisticName===g)[0];return O?O.value:0}function b($){const g="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(B=>B.assetType.indexOf(g)===0).reduce((B,W)=>{const z=F($,W.assetType);return z&&B.push([W.assetType.substring(g.length),z]),B},[])}function R($){if($.properties){const g=$.properties.filter(W=>W.key===s.Repository),O=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=g.filter(W=>O.test(W.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return F($,s.Repository)}function M($){return{uri:`${$.fallbackAssetUri}/${s.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${s.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function F($,g){return $.files.filter(B=>B.assetType===g)[0]?{uri:`${$.assetUri}/${g}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${g}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}:null}function H($,g){const O=$.properties?$.properties.filter(W=>W.key===g):[],B=O.length>0&&O[0].value;return B?B.split(",").map(W=>(0,S.adoptToGalleryExtensionId)(W)):[]}function q($){const g=$.properties?$.properties.filter(O=>O.key===o.Engine):[];return g.length>0&&g[0].value||""}function V($){const g=$.properties?$.properties.filter(O=>O.key===o.PreRelease):[];return g.length>0&&g[0].value==="true"}function Q($){const g=$.properties?$.properties.filter(B=>B.key===o.LocalizedLanguages):[],O=g.length>0&&g[0].value||"";return O?O.split(","):[]}function te($){return $.properties?.find(g=>g.key===o.SponsorLink)?.value}function Y($){return $.indexOf("preview")!==-1}function x($){return $.targetPlatform?(0,v.toTargetPlatform)($.targetPlatform):"undefined"}function G($){const g=(0,k.distinct)($.versions.map(x)),O=!!$.tags?.includes(v.WEB_EXTENSION_TAG),B=g.indexOf("web");return O?B===-1&&g.push("web"):B!==-1&&g.splice(B,1),g}function j($,g){const O=(0,v.getFallbackTargetPlarforms)(g);for(let B=0;B<$.length;B++){const W=$[B];if(W.version===$[B-1]?.version){let z=B;const J=x(W);if(J===g)for(;z>0&&$[z-1].version===W.version;)z--;else if(O.includes(J))for(;z>0&&$[z-1].version===W.version&&x($[z-1])!==g;)z--;z!==B&&($.splice(B,1),$.splice(z,0,W))}}return $}e.sortExtensionVersions=j;function Z($,g,O){$.telemetryData={index:g,querySource:O,queryActivityId:$.queryContext?.[n]}}function ie($,g,O,B){const W=$.versions[0],z={manifest:F(g,s.Manifest),readme:F(g,s.Details),changelog:F(g,s.Changelog),license:F(g,s.License),repository:R(g),download:M(g),icon:F(g,s.Icon),signature:F(g,s.Signature),coreTranslations:b(g)};return{identifier:{id:(0,S.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:g.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,publisherDomain:$.publisher.domain?{link:$.publisher.domain,verified:!!$.publisher.isDomainVerified}:void 0,publisherSponsorLink:te(W),description:$.shortDescription||"",installCount:c($.statistics,"install"),rating:c($.statistics,"averagerating"),ratingCount:c($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:O,assets:z,properties:{dependencies:H(g,o.Dependency),extensionPack:H(g,o.ExtensionPack),engine:q(g),localizedLanguages:Q(g),targetPlatform:x(g),isPreReleaseVersion:V(g)},hasPreReleaseVersion:V(W),hasReleaseVersion:!0,preview:Y($.flags),isSigned:!!z.signature,queryContext:B}}let se=class{constructor(g,O,B,W,z,J,ee,ce){this.k=O,this.l=B,this.n=W,this.o=z,this.q=J,this.u=ee,this.w=ce;const ue=ee.extensionsGallery,de=ue?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=de?ue.servicePPEUrl:ue?.serviceUrl,this.g=de?void 0:ue?.searchUrl,this.h=ue?.controlUrl,this.j=(0,u.resolveMarketplaceHeaders)(ee.version,ee,this.n,this.w,this.q,g,this.o)}x(g=""){return`${this.d}${g}`}isEnabled(){return!!this.d}async getExtensions(g,O,B){const W=U.CancellationToken.isCancellationToken(O)?{}:O,z=U.CancellationToken.isCancellationToken(O)?O:B,J=[],ee=[],ce=[],ue=[];let de=!0;for(const be of g){be.uuid?ee.push(be.uuid):J.push(be.id);const De=!!(be.version||be.preRelease);ce.push({id:be.id,uuid:be.uuid,includePreRelease:De}),be.version&&ue.push({id:be.id,uuid:be.uuid,version:be.version}),de=de&&!!be.hasPreRelease&&!De}if(!ee.length&&!J.length)return[];let Se=new y().withPage(1,g.length);ee.length&&(Se=Se.withFilter(i.ExtensionId,...ee)),J.length&&(Se=Se.withFilter(i.ExtensionName,...J)),(W.queryAllVersions||de)&&(Se=Se.withFlags(Se.flags,r.IncludeVersions)),W.source&&(Se=Se.withSource(W.source));const{extensions:we}=await this.z(Se,{targetPlatform:W.targetPlatform??L,includePreRelease:ce,versions:ue,compatible:!!W.compatible},z);return W.source&&we.forEach((be,De)=>Z(be,De,W.source)),we}async getCompatibleExtension(g,O,B){if((0,v.isNotWebExtensionInWebTargetPlatform)(g.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(g,O,B))return g;const W=new y().withFlags(r.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,g.identifier.uuid),{extensions:z}=await this.z(W,{targetPlatform:B,compatible:!0,includePreRelease:O},U.CancellationToken.None);return z[0]||null}async isExtensionCompatible(g,O,B){if(!(0,v.isTargetPlatformCompatible)(g.properties.targetPlatform,g.allTargetPlatforms,B)||!O&&g.properties.isPreReleaseVersion)return!1;let W=g.properties.engine;if(!W){const z=await this.getManifest(g,U.CancellationToken.None);if(!z)throw new Error("Manifest was not found");W=z.engines.vscode}return(0,f.isEngineValid)(W,this.u.version,this.u.date)}async y(g,O,B,W,z){if(!(0,v.isTargetPlatformCompatible)(x(g),W,z)||O!=="any"&&V(g)!==(O==="prerelease"))return!1;if(B)try{const J=await this.E(g);if(!(0,f.isEngineValid)(J,this.u.version,this.u.date))return!1}catch(J){return this.l.error(`Error while getting the engine for the version ${g.version}.`,(0,A.getErrorMessage)(J)),!1}return!0}async query(g,O){let B=g.text||"";const W=g.pageSize??50;let z=new y().withPage(1,W);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,Se,we)=>(z=z.withFilter(i.Category,we||Se),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,Se,we)=>(z=z.withFilter(i.Tag,we||Se),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(z=z.withFilter(i.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),z=z.withFilter(i.SearchText,B)),z=z.withSortBy(0)):g.ids?z=z.withFilter(i.ExtensionId,...g.ids):g.names?z=z.withFilter(i.ExtensionName,...g.names):z=z.withSortBy(4),typeof g.sortBy=="number"&&(z=z.withSortBy(g.sortBy)),typeof g.sortOrder=="number"&&(z=z.withSortOrder(g.sortOrder)),g.source&&(z=z.withSource(g.source));const J=async(de,Se)=>{const{extensions:we,total:be}=await this.z(de,{targetPlatform:L,compatible:!1,includePreRelease:!!g.includePreRelease},Se);return we.forEach((De,ke)=>Z(De,(de.pageNumber-1)*de.pageSize+ke,g.source)),{extensions:we,total:be}},{extensions:ee,total:ce}=await J(z,O),ue=async(de,Se)=>{if(Se.isCancellationRequested)throw new A.CancellationError;const{extensions:we}=await J(z.withPage(de+1),Se);return we};return{firstPage:ee,total:ce,pageSize:z.pageSize,getPage:ue}}async z(g,O,B){const W=g.flags;g.flags&r.IncludeLatestVersionOnly&&g.flags&r.IncludeVersions&&(g=g.withFlags(g.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(g.flags&r.IncludeLatestVersionOnly)&&!(g.flags&r.IncludeVersions)&&(g=g.withFlags(g.flags,r.IncludeLatestVersionOnly)),O.versions?.length&&(g=g.withFlags(g.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),g=g.withFlags(g.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:z,total:J,context:ee}=await this.B(g,B);if(!(g.flags&r.IncludeLatestVersionOnly)){const Se=[];for(const we of z){const be=await this.A(we,O,ee);be&&Se.push(be)}return{extensions:Se,total:J}}const ue=[],de=new Map;for(let Se=0;Se<z.length;Se++){const we=z[Se],be={id:(0,S.getGalleryExtensionId)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},De=(0,D.isBoolean)(O.includePreRelease)?O.includePreRelease:!!O.includePreRelease.find(ze=>(0,S.areSameExtensions)(ze,be))?.includePreRelease;if(O.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(G(we),O.targetPlatform))continue;const ke=await this.A(we,O,ee);!ke||ke.properties.isPreReleaseVersion&&(!De||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==O.targetPlatform&&ke.hasPreReleaseVersion?de.set(we.extensionId,Se):ue.push([Se,ke])}if(de.size){const Se=new Date().getTime(),we=new y().withFlags(W&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,de.size).withFilter(i.ExtensionId,...de.keys()),{extensions:be}=await this.z(we,O,B);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-Se,count:de.size});for(const De of be){const ke=de.get(De.identifier.uuid);ue.push([ke,De])}}return{extensions:ue.sort((Se,we)=>Se[0]-we[0]).map(([,Se])=>Se),total:J}}async A(g,O,B){const W={id:(0,S.getGalleryExtensionId)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},z=O.versions?.find(ue=>(0,S.areSameExtensions)(ue,W))?.version,J=(0,D.isBoolean)(O.includePreRelease)?O.includePreRelease:!!O.includePreRelease.find(ue=>(0,S.areSameExtensions)(ue,W))?.includePreRelease,ee=G(g),ce=j(g.versions,O.targetPlatform);if(O.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(ee,O.targetPlatform))return null;for(let ue=0;ue<ce.length;ue++){const de=ce[ue];if(!(z&&de.version!==z)){if(await this.y(de,J?"any":"release",O.compatible,ee,O.targetPlatform))return ie(g,de,ee,B);if(z&&de.version===z)return null}}return z||O.compatible?null:ie(g,g.versions[0],ee)}async B(g,O){if(!this.isEnabled())throw new Error("No extension gallery service configured.");g=g.withFlags(g.flags,r.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,t(r.Unpublished));const B=await this.j,W=JSON.stringify(g.raw),z={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)},J=new Date().getTime();let ee,ce,ue=0;try{if(ee=await this.k.request({type:"POST",url:this.g&&g.criteria.some(Se=>Se.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:W,headers:z},O),ee.res.statusCode&&ee.res.statusCode>=400&&ee.res.statusCode<500)return{galleryExtensions:[],total:ue};const de=await(0,h.asJson)(ee);if(de){const Se=de.results[0],we=Se.extensions,be=Se.resultMetadata&&Se.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return ue=be&&be.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ue,context:{[n]:ee.res.headers.activityid}}}return{galleryExtensions:[],total:ue}}catch(de){throw ce=de,de}finally{this.o.publicLog2("galleryService:query",{...g.telemetryData,requestBodySize:String(W.length),duration:new Date().getTime()-J,success:!!ee&&(0,h.isSuccess)(ee),responseBodySize:ee?.res.headers["Content-Length"],statusCode:ee?String(ee.res.statusCode):void 0,errorCode:ce?(0,A.isCancellationError)(ce)?"canceled":(0,A.getErrorMessage)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(g,O,B,W){if(!this.isEnabled())return;const z=N.isWeb?this.x(`/itemName/${g}.${O}/version/${B}/statType/${W==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${g}/extensions/${O}/${B}/stats?statType=${W}`),J=N.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:J};try{await this.k.request({type:"POST",url:z,headers:ce},U.CancellationToken.None)}catch{}}async download(g,O,B){this.l.trace("ExtensionGalleryService#download",g.identifier.id);const W=(0,S.getGalleryExtensionTelemetryData)(g),z=new Date().getTime(),J=Se=>this.o.publicLog("galleryService:downloadVSIX",{...W,duration:Se}),ee=B===2?"install":B===3?"update":"",ce=ee?{uri:`${g.assets.download.uri}${C.URI.parse(g.assets.download.uri).query?"&":"?"}${ee}=true`,fallbackUri:`${g.assets.download.fallbackUri}${C.URI.parse(g.assets.download.fallbackUri).query?"&":"?"}${ee}=true`}:g.assets.download,ue=g.queryContext?.[n]?{[n]:g.queryContext[n]}:void 0,de=await this.D(ce,ue?{headers:ue}:void 0);await this.q.writeFile(O,de.stream),J(new Date().getTime()-z)}async downloadSignatureArchive(g,O){if(!g.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",g.identifier.id);const B=await this.D(g.assets.signature);await this.q.writeFile(O,B.stream)}async getReadme(g,O){if(g.assets.readme){const B=await this.D(g.assets.readme,{},O);return await(0,h.asTextOrError)(B)||""}return""}async getManifest(g,O){if(g.assets.manifest){const B=await this.D(g.assets.manifest,{},O),W=await(0,h.asTextOrError)(B);return W?JSON.parse(W):null}return null}async C(g,O){const B=F(g,s.Manifest);if(!B)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},z=await this.D(B,{headers:W});return await(0,h.asJson)(z)}async getCoreTranslation(g,O){const B=g.assets.coreTranslations.filter(W=>W[0]===O.toUpperCase())[0];if(B){const W=await this.D(B[1]),z=await(0,h.asTextOrError)(W);return z?JSON.parse(z):null}return null}async getChangelog(g,O){if(g.assets.changelog){const B=await this.D(g.assets.changelog,{},O);return await(0,h.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(g,O,B){let W=new y().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);g.identifier.uuid?W=W.withFilter(i.ExtensionId,g.identifier.uuid):W=W.withFilter(i.ExtensionName,g.identifier.id);const{galleryExtensions:z}=await this.B(W,U.CancellationToken.None);if(!z.length)return[];const J=G(z[0]);if((0,v.isNotWebExtensionInWebTargetPlatform)(J,B))return[];const ee=[];await Promise.all(z[0].versions.map(async de=>{try{await this.y(de,O?"any":"release",!0,J,B)&&ee.push(de)}catch{}}));const ce=[],ue=new Set;for(const de of j(ee,B))ue.has(de.version)||(ue.add(de.version),ce.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:V(de)}));return ce}async D(g,O={},B=U.CancellationToken.None){const W=await this.j,z={type:"GET"},J={...W,...O.headers||{}};O={...O,...z,headers:J};const ee=g.uri,ce=g.fallbackUri,ue={...O,url:ee};try{const de=await this.k.request(ue,B);if(de.res.statusCode===200)return de;const Se=await(0,h.asTextOrError)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${Se}`)}catch(de){if((0,A.isCancellationError)(de))throw de;const Se=(0,A.getErrorMessage)(de);this.o.publicLog2("galleryService:cdnFallback",{url:ee,message:Se});const we={...O,url:ce};return this.k.request(we,B)}}async E(g){let O=q(g);if(!O){const B=await this.C(g,U.CancellationToken.None);if(!B)throw new Error("Manifest was not found");O=B.engines.vscode}return O}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const g=await this.k.request({type:"GET",url:this.h},U.CancellationToken.None);if(g.res.statusCode!==200)throw new Error("Could not get extensions report.");const O=await(0,h.asJson)(g),B=[],W={};if(O){for(const z of O.malicious)B.push({id:z});if(O.migrateToPreRelease)for(const[z,J]of Object.entries(O.migrateToPreRelease))(!J.engine||(0,f.isEngineValid)(J.engine,this.u.version,this.u.date))&&(W[z.toLowerCase()]={disallowInstall:!0,extension:{id:J.id,displayName:J.displayName,autoMigrate:{storage:!!J.migrateStorage},preRelease:!0}});if(O.deprecated)for(const[z,J]of Object.entries(O.deprecated))J&&(W[z.toLowerCase()]=(0,D.isBoolean)(J)?{}:J)}return{malicious:B,deprecated:W}}};se=ve([X(1,h.IRequestService),X(2,w.ILogService),X(3,P.IEnvironmentService),X(4,p.ITelemetryService),X(5,d.IFileService),X(6,a.IProductService),X(7,m.IConfigurationService)],se);let K=e.ExtensionGalleryService=class extends se{constructor(g,O,B,W,z,J,ee,ce){super(g,O,B,W,z,J,ee,ce)}};e.ExtensionGalleryService=K=ve([X(0,I.IStorageService),X(1,h.IRequestService),X(2,w.ILogService),X(3,P.IEnvironmentService),X(4,p.ITelemetryService),X(5,d.IFileService),X(6,a.IProductService),X(7,m.IConfigurationService)],K);let _=e.ExtensionGalleryServiceWithNoStorageService=class extends se{constructor(g,O,B,W,z,J,ee){super(void 0,g,O,B,W,z,J,ee)}};e.ExtensionGalleryServiceWithNoStorageService=_=ve([X(0,h.IRequestService),X(1,w.ILogService),X(2,P.IEnvironmentService),X(3,p.ITelemetryService),X(4,d.IFileService),X(5,a.IProductService),X(6,m.IConfigurationService)],_)}),define(oe[79],ae([0,1,4,3,2,19,33,24,21,8,10]),function(ne,e,k,U,A,N,T,D,C,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const v=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let S=e.ExtensionStorageService=class xe extends A.Disposable{static b(d){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static c(d){const w=v.exec(d);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(d,w){const a=await d.getInstalled(),h=[];for(const[u,I]of xe.f(w)){const p=a.find(L=>(0,T.areSameExtensions)(L.identifier,{id:u}))?.manifest.version;for(const L of I)p!==L&&h.push(xe.b({id:u,version:L}))}for(const u of h)w.remove(u,0)}static f(d){const w=new Map,a=d.keys(0,1);for(const h of a){const u=xe.c(h);if(u){let I=w.get(u.id.toLowerCase());I||w.set(u.id.toLowerCase(),I=[]),I.push(u.version)}}return w}constructor(d,w,a){super(),this.i=d,this.j=w,this.k=a,this.g=this.B(new U.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=xe.f(d),this.B(this.i.onDidChangeValue(h=>this.l(h)))}l(d){if(d.scope!==0)return;if(this.h.has(d.key.toLowerCase())){this.g.fire();return}const w=xe.c(d.key);if(w){if(this.i.get(d.key,0)===void 0)this.h.delete(w.id.toLowerCase());else{let a=this.h.get(w.id.toLowerCase());a||this.h.set(w.id.toLowerCase(),a=[]),a.push(w.version),this.g.fire()}return}}m(d){if((0,P.isString)(d))return d;const w=d.manifest?d.manifest.publisher:d.publisher,a=d.manifest?d.manifest.name:d.name;return(0,T.getExtensionId)(w,a)}getExtensionState(d,w){const a=this.m(d),h=this.getExtensionStateRaw(d,w);if(h)try{return JSON.parse(h)}catch(u){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${a}, global: ${w}): ${u}`)}}getExtensionStateRaw(d,w){const a=this.m(d),h=this.i.get(a,w?0:1);return h&&h?.length>xe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${a}, global: ${w}): ${h.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),h}setExtensionState(d,w,a){const h=this.m(d);w===void 0?this.i.remove(h,a?0:1):this.i.store(h,JSON.stringify(w),a?0:1,1)}setKeysForSync(d,w){this.i.store(xe.b(d),JSON.stringify(w),0,1)}getKeysForSync(d){const w=this.j.extensionSyncedKeys?.[d.id.toLowerCase()],a=this.i.get(xe.b(d),0),h=a?JSON.parse(a):void 0;return h&&w?(0,C.distinct)([...h,...w]):h||w}addToMigrationList(d,w){if(d!==w){const a=this.n.filter(h=>!h.includes(d)&&!h.includes(w));a.push([d,w]),this.n=a}}getSourceExtensionToMigrate(d){const w=this.n.find(([,a])=>d===a);return w?w[0]:void 0}get n(){const d=this.i.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(d);if(Array.isArray(w))return w}catch{}return[]}set n(d){d.length?this.i.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};S.a=512*1024,e.ExtensionStorageService=S=ve([X(0,N.IStorageService),X(1,D.IProductService),X(2,m.ILogService)],S)}),define(oe[241],ae([0,1,28,13,24,14,98,54,19,20,214]),function(ne,e,k,U,A,N,T,D,C,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let v=e.ExtensionTipsService=class extends P.AbstractNativeExtensionTipsService{constructor(f,d,w,a,h,u,I,p){super(f.userHome,h,d,w,a,u,I,p)}};e.ExtensionTipsService=v=ve([X(0,N.INativeEnvironmentService),X(1,m.ITelemetryService),X(2,k.IExtensionManagementService),X(3,C.IStorageService),X(4,D.INativeHostService),X(5,T.IExtensionRecommendationNotificationService),X(6,U.IFileService),X(7,A.IProductService)],v)}),define(oe[242],ae([0,1,105,3,20,14,2,8,15,65,24,5,6,101,18,158,36,19,10]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const I=[k.CONFIGURATION_KEY_HOST_NAME,k.CONFIGURATION_KEY_PREVENT_SLEEP],p="remoteTunnelSession";let L=e.RemoteTunnelService=class extends T.Disposable{constructor(t,i,s,o,l,E,y){super(),this.s=t,this.t=i,this.u=s,this.v=E,this.w=y,this.b=new U.Emitter,this.onDidTokenFailed=this.b.event,this.f=new U.Emitter,this.onDidChangeTunnelStatus=this.f.event,this.g=new U.Emitter,this.onDidChangeSession=this.g.event,this.r=!1,this.h=this.B(o.createLogger(k.LOG_ID,{name:k.LOGGER_NAME})),this.n=new S.Delayer(100),this.B(this.h.onDidChangeLogLevel(c=>this.h.info("Log level changed to "+(0,D.LogLevelToString)(c)))),this.B(l.onWillShutdown(()=>{this.j?.cancel(),this.j=void 0,this.dispose()})),this.B(E.onDidChangeConfiguration(c=>{I.some(b=>c.affectsConfiguration(b))&&this.n.trigger(()=>this.D())})),this.i=this.I(),this.k=k.TunnelStates.uninitialized}async getTunnelStatus(){return this.k}y(t){this.k=t,this.f.fire(t)}z(t){n(t,this.i)||(this.i=t,this.g.fire(t),this.J(t),t?(this.h.info(`Session updated: ${t.accountLabel} (${t.providerId})`),t.token&&this.h.info(`Session token updated: ${t.accountLabel} (${t.providerId})`)):this.h.info("Session reset"))}async getSession(){return this.i}async initialize(t){if(this.r)return this.k;this.r=!0,this.z(t);try{await this.n.trigger(()=>this.D())}catch(i){this.h.error(i)}return this.k}C(){if(!this.p){let t;v.isMacintosh?t=this.u.appRoot:t=(0,C.dirname)((0,C.dirname)(this.u.appRoot)),this.p=(0,C.join)(t,"bin",`${this.t.tunnelApplicationName}${v.isWindows?".exe":""}`)}return this.p}async startTunnel(t){if(n(t,this.i))return this.k;this.z(t);try{await this.n.trigger(()=>this.D())}catch(i){this.h.error(i)}return this.k}async stopTunnel(){this.z(void 0),this.j&&(this.j.cancel(),this.j=void 0);const t=(i,s)=>{s?this.h.error(i):this.h.info(i)};try{await this.F("stop",["kill"],t)}catch(i){this.h.error(i)}this.y(k.TunnelStates.disconnected())}async D(){this.s.publicLog2("remoteTunnel.enablement",{enabled:!!this.i}),this.j&&(this.j.cancel(),this.j=void 0);let t=!1;const i=(c,b)=>{b?this.h.error(c):this.h.info(c),!this.u.isBuilt&&c.startsWith("   Compiling")&&this.y(k.TunnelStates.connecting((0,w.localize)(0,null)))},s=this.F("status",["status"],i);this.j=s;try{const c=await s;if(this.j!==s)return;if(t=c===0,this.h.info(t?"Other tunnel running, attaching...":"No other tunnel running"),!t&&!this.i){this.j=void 0,this.y(k.TunnelStates.disconnected());return}}catch(c){this.h.error(c),this.j=void 0,this.y(k.TunnelStates.disconnected());return}const o=this.i;if(o&&o.token){const c=o.token;this.y(k.TunnelStates.connecting((0,w.localize)(1,null,o.accountLabel,o.providerId)));const b=(M,F)=>{M=M.replaceAll(c,"*".repeat(4)),i(M,F)},R=this.F("login",["user","login","--provider",o.providerId,"--access-token",c,"--log",(0,D.LogLevelToString)(this.h.getLevel())],b);this.j=R;try{if(await R,this.j!==R)return}catch(M){this.h.error(M),this.j=void 0,this.b.fire(o),this.y(k.TunnelStates.disconnected(o));return}}const l=this.H();l?this.y(k.TunnelStates.connecting((0,w.localize)(2,null,l))):this.y(k.TunnelStates.connecting((0,w.localize)(3,null)));const E=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,D.LogLevelToString)(this.h.getLevel())];l?E.push("--name",l):E.push("--random-name"),this.G()&&E.push("--no-sleep");const y=this.F("tunnel",E,(c,b)=>{b?this.h.error(c):this.h.info(c);const R=c.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(R){const M={link:R[1],domain:R[2],tunnelName:R[4],isAttached:t};this.y(k.TunnelStates.connected(M))}else c.match(/error refreshing token/)&&(y.cancel(),this.b.fire(o),this.y(k.TunnelStates.disconnected(o)))});this.j=y,y.finally(()=>{y===this.j&&(this.h.info("tunnel process terminated"),this.j=void 0,this.i=void 0,this.y(k.TunnelStates.disconnected()))})}F(t,i,s=()=>{}){return(0,S.createCancelablePromise)(o=>new Promise((l,E)=>{o.isCancellationRequested&&l(-1);let y;const c=["ignore","pipe","pipe"];if(o.onCancellationRequested(()=>{y&&(this.h.info(`${t} terminating(${y.pid})`),y.kill())}),!this.u.isBuilt)s("Building tunnel CLI from sources and run",!1),s(`${t} Spawning: cargo run -- tunnel ${i.join(" ")}`,!1),y=(0,m.spawn)("cargo",["run","--","tunnel",...i],{cwd:(0,C.join)(this.u.appRoot,"cli"),stdio:c});else{s("Running tunnel CLI",!1);const b=this.C();s(`${t} Spawning: ${b} tunnel ${i.join(" ")}`,!1),y=(0,m.spawn)(b,["tunnel",...i],{cwd:(0,a.homedir)(),stdio:c})}y.stdout.on("data",b=>{if(y){const R=b.toString();s(R,!1)}}),y.stderr.on("data",b=>{if(y){const R=b.toString();s(R,!0)}}),y.on("exit",b=>{y&&(s(`${t} exit(${y.pid}): + ${b} `,!1),y=void 0,l(b||0))}),y.on("error",b=>{y&&(s(`${t} error(${y.pid}): + ${b} `,!0),y=void 0,E())})}))}async getTunnelName(){return this.H()}G(){return!!this.v.getValue(k.CONFIGURATION_KEY_PREVENT_SLEEP)}H(){let t=this.v.getValue(k.CONFIGURATION_KEY_HOST_NAME)||(0,a.hostname)();return t=t.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),t||void 0}I(){try{const t=this.w.get(p,-1);if(t){const i=JSON.parse(t);if(i&&(0,u.isString)(i.accountLabel)&&(0,u.isString)(i.sessionId)&&(0,u.isString)(i.providerId))return i;this.h.error("Problems restoring session from storage, invalid format",i)}}catch(t){this.h.error("Problems restoring session from storage",t)}}J(t){if(t){const i={providerId:t.providerId,sessionId:t.sessionId,accountLabel:t.accountLabel};this.w.store(p,JSON.stringify(i),-1,1)}else this.w.remove(p,-1)}};e.RemoteTunnelService=L=ve([X(0,A.ITelemetryService),X(1,P.IProductService),X(2,N.INativeEnvironmentService),X(3,D.ILoggerService),X(4,f.ISharedProcessLifecycleService),X(5,d.IConfigurationService),X(6,h.IStorageService)],L);function n(r,t){return r&&t?r.sessionId===t.sessionId&&r.providerId===t.providerId&&r.token===t.token:r===t}}),define(oe[243],ae([0,1,6,2,22,66,19,75,17]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class m extends T.AbstractStorageService{constructor(v,S,f,d){super(),this.X=v,this.Y=S,this.Z=f,this.ab=d,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new U.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new U.DisposableStore),this.W=this.db(this.X)}bb(){const v=this.B(new D.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),S=this.B(new N.Storage(v));return this.B(S.onDidChangeStorage(f=>this.n(-1,f))),S}cb(v){this.Q.clear(),this.P=v;let S;if((0,T.isProfileUsingDefaultStorage)(v))S=this.s;else{const f=this.Q.add(new D.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),v));S=this.Q.add(new N.Storage(f))}return this.Q.add(S.onDidChangeStorage(f=>this.n(0,f))),S}db(v){this.U.clear(),this.S=v?.id;let S;if(v){const f=this.U.add(new D.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),v));S=this.U.add(new N.Storage(f)),this.U.add(S.onDidChangeStorage(d=>this.n(1,d)))}return S}async J(){await k.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(v){switch(v){case-1:return this.s;case 0:return this.R;default:return this.W}}M(v){switch(v){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,A.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(T.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(v,S){if(!this.H(this.P,v))return;const f=this.R,d=f.items;f!==this.s&&await f.close(),this.R=this.cb(v),await this.R.init(),this.I(d,this.R,0,S)}async O(v,S){const f=this.W,d=f?.items??new Map;await f?.close(),this.W=this.db(v),await this.W.init(),this.I(d,this.W,1,S)}hasScope(v){return(0,C.isUserDataProfile)(v)?this.P.id===v.id:this.S===v.id}}e.RemoteStorageService=m}),define(oe[244],ae([0,1,3,2,17,91]),function(ne,e,k,U,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class T{constructor(m,P){this.a=m,this.b=P}listen(m,P){const v=this.b(m);switch(P){case"onDidChangeProfiles":return k.Event.map(this.a.onDidChangeProfiles,S=>({all:S.all.map(f=>(0,N.transformOutgoingURIs)({...f},v)),added:S.added.map(f=>(0,N.transformOutgoingURIs)({...f},v)),removed:S.removed.map(f=>(0,N.transformOutgoingURIs)({...f},v)),updated:S.updated.map(f=>(0,N.transformOutgoingURIs)({...f},v))}))}throw new Error(`Invalid listen ${P}`)}async call(m,P,v){const S=this.b(m);switch(P){case"createProfile":{const f=await this.a.createProfile(v[0],v[1],v[2]);return(0,N.transformOutgoingURIs)({...f},S)}case"updateProfile":{let f=(0,A.reviveProfile)((0,N.transformIncomingURIs)(v[0],S),this.a.profilesHome.scheme);return f=await this.a.updateProfile(f,v[1]),(0,N.transformOutgoingURIs)({...f},S)}case"removeProfile":{const f=(0,A.reviveProfile)((0,N.transformIncomingURIs)(v[0],S),this.a.profilesHome.scheme);return this.a.removeProfile(f)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=T;class D extends U.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(m,P,v){super(),this.profilesHome=P,this.f=v,this.a=[],this.b=this.B(new k.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=m.map(S=>(0,A.reviveProfile)(S,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(S=>{const f=S.added.map(a=>(0,A.reviveProfile)(a,this.profilesHome.scheme)),d=S.removed.map(a=>(0,A.reviveProfile)(a,this.profilesHome.scheme)),w=S.updated.map(a=>(0,A.reviveProfile)(a,this.profilesHome.scheme));this.a=S.all.map(a=>(0,A.reviveProfile)(a,this.profilesHome.scheme)),this.b.fire({added:f,removed:d,updated:w,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(m){this.c=m}isEnabled(){return this.c}async createNamedProfile(m,P,v){const S=await this.f.call("createNamedProfile",[m,P,v]);return(0,A.reviveProfile)(S,this.profilesHome.scheme)}async createProfile(m,P,v,S){const f=await this.f.call("createProfile",[m,P,v,S]);return(0,A.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(m){const P=await this.f.call("createTransientProfile",[m]);return(0,A.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(m,P){await this.f.call("setProfileForWorkspace",[m,P])}removeProfile(m){return this.f.call("removeProfile",[m])}async updateProfile(m,P){const v=await this.f.call("updateProfile",[m,P]);return(0,A.reviveProfile)(v,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=D}),define(oe[58],ae([0,1,2,66,4,19,3,75,17]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,A.createDecorator)("IUserDataProfileStorageService");let m=e.AbstractUserDataProfileStorageService=class extends k.Disposable{constructor(f){super(),this.a=f}async readStorageData(f){return this.withProfileScopedStorageService(f,async d=>this.b(d))}async updateStorageData(f,d,w){return this.withProfileScopedStorageService(f,async a=>this.c(a,d,w))}async withProfileScopedStorageService(f,d){if(this.a.hasScope(f))return d(this.a);const w=await this.g(f),a=new v(w);try{await a.initialize();const h=await d(a);return await a.flush(),h}finally{a.dispose(),await this.f(w)}}b(f){const d=new Map,w=a=>{for(const h of f.keys(0,a))d.set(h,{value:f.get(h,0),target:a})};return w(0),w(1),d}c(f,d,w){for(const[a,h]of d)f.store(a,h,0,w)}async f(f){try{await f.close()}finally{(0,k.isDisposable)(f)&&f.dispose()}}};e.AbstractUserDataProfileStorageService=m=ve([X(0,N.IStorageService)],m);class P extends m{constructor(f,d,w,a){super(w),this.i=f;const h=f.getChannel("profileStorageListener"),u=this.B(new k.MutableDisposable);this.h=this.B(new T.Emitter({onWillAddFirstListener:()=>{u.value=h.listen("onDidChange")(I=>{a.trace("profile storage changes",I),this.h.fire({targetChanges:I.targetChanges.map(p=>(0,C.reviveProfile)(p,d.profilesHome.scheme)),valueChanges:I.valueChanges.map(p=>({...p,profile:(0,C.reviveProfile)(p.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(f){const d=this.i.getChannel("storage");return(0,N.isProfileUsingDefaultStorage)(f)?new D.ApplicationStorageDatabaseClient(d):new D.ProfileStorageDatabaseClient(d,f)}}e.RemoteUserDataProfileStorageService=P;class v extends N.AbstractStorageService{constructor(f){super({flushInterval:100}),this.p=this.B(new U.Storage(f))}J(){return this.p.init()}L(f){return f===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(oe[245],ae([0,1,19,8,17,71,58]),function(ne,e,k,U,A,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let D=e.NativeUserDataProfileStorageService=class extends T.RemoteUserDataProfileStorageService{constructor(m,P,v,S){super(m,P,v,S)}};e.NativeUserDataProfileStorageService=D=ve([X(0,N.IMainProcessService),X(1,A.IUserDataProfilesService),X(2,k.IStorageService),X(3,U.ILogService)],D)}),define(oe[39],ae([0,1,21,6,16,26,3,34,2,27,10,163,18,14,13,8,44,19,20,29,23,17]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u,I,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(E){return!!(E&&E.ref!==void 0&&typeof E.ref=="string"&&E.ref!==""&&E.syncData!==void 0&&(E.syncData===null||r(E.syncData)))}e.isRemoteUserData=n;function r(E){return!!(E&&E.version!==void 0&&typeof E.version=="number"&&E.content!==void 0&&typeof E.content=="string"&&(Object.keys(E).length===2||Object.keys(E).length===3&&E.machineId!==void 0&&typeof E.machineId=="string"))}e.isSyncData=r;function t(E,y){return`${(0,m.uppercaseFirstLetter)(E)}${y.isDefault?"":` (${y.name})`}`}e.getSyncResourceLogLabel=t;let i=e.AbstractSynchroniser=class extends C.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(y,c,b,R,M,F,H,q,V,Q,te,Y){super(),this.syncResource=y,this.collection=c,this.C=b,this.D=R,this.F=M,this.G=F,this.H=H,this.I=q,this.J=V,this.L=Q,this.M=te,this.c=null,this.k="idle",this.l=this.B(new T.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new T.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new U.ThrottledDelayer(50),this.t=this.B(new T.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(y.syncResource,y.profile),this.h=Y.extUri,this.f=this.h.joinPath(R.userDataSyncHome,...(0,p.getPathSegments)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,p.PREVIEW_DIR_NAME),this.u=(0,p.getLastSyncResourceUri)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,R,this.h),this.j=(0,a.getServiceMachineId)(R,b,M)}N(){this.s.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const c=await this.U(y.remoteUserData,y.lastSyncUserData,!0,this.mb());this.P(c)}else{this.L.trace(`${this.y}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.sb(y):!0)&&this.t.fire()}}P(y){this.k!==y&&(this.k=y,this.l.fire(y))}async sync(y,c={}){await this.Q(y,!0,this.mb(),c)}async preview(y,c,b={}){return this.Q(y,!1,c,b)}async apply(y,c={}){try{this.z={...c};const b=await this.Y(y);return this.P(b),this.c}finally{this.z={}}}async Q(y,c,b,R){try{if(this.z={...R},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let M="idle";try{const F=await this.getLastSyncUserData(),H=await this.S(y,F);return M=await this.U(H,F,c,b),M==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(M)}}finally{this.z={}}}async replace(y){const c=this.ib(y);if(!c)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const b=await this.getLastSyncUserData(),R=await this.S(null,b),M=await this.R(R),F=await this.ob({ref:R.ref,syncData:c},b,M,this.mb(),N.CancellationToken.None),H=[];for(const q of F){const V=await this.qb(q,q.remoteResource,void 0,N.CancellationToken.None),{remoteChange:Q}=await this.qb(q,q.previewResource,q.remoteContent,N.CancellationToken.None);H.push([q,{...V,remoteChange:Q!==0?Q:2}])}await this.rb(R,b,H,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(y){const c=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===c}async S(y,c){if(c){const b=y?y[this.resource]:void 0;if(c.ref===b||b===void 0&&c.syncData===null)return c}return this.getRemoteUserData(c)}async U(y,c,b,R){if(y.syncData&&y.syncData.version>this.nb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new p.UserDataSyncError((0,v.localize)(0,null,this.resource,this.nb,y.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(y,c,b,R)}catch(M){if(M instanceof p.UserDataSyncError)switch(M.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.U(y,c,b,R);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),c=await this.getLastSyncUserData(),this.U(y,c,b,R)}throw M}}async W(y,c,b,R){try{const M=await this.R(y),F=!M&&c===null&&this.eb()!==void 0,H=b&&!F;this.c||(this.c=(0,U.createCancelablePromise)(V=>this.cb(y,c,M,H,R,V)));let q=await this.c;if(b&&F){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const V of q.resourcePreviews)q=await this.accept(V.remoteResource)||q}return this.ab(q.resourcePreviews),q.resourcePreviews.some(({mergeState:V})=>V==="conflict")?"hasConflicts":b?await this.Y(!1):"syncing"}catch(M){throw this.c=null,M}}async merge(y){return await this.X(y,async c=>{const b=await this.pb(c,N.CancellationToken.None);await this.C.writeFile(c.previewResource,A.VSBuffer.fromString(b?.content||""));const R=b&&!b.hasConflicts?await this.qb(c,c.previewResource,void 0,N.CancellationToken.None):void 0;return c.acceptResult=R,c.mergeState=b.hasConflicts?"conflict":R?"accepted":"preview",c.localChange=R?R.localChange:b.localChange,c.remoteChange=R?R.remoteChange:b.remoteChange,c}),this.c}async accept(y,c){return await this.X(y,async b=>{const R=await this.qb(b,y,c,N.CancellationToken.None);return b.acceptResult=R,b.mergeState="accepted",b.localChange=R.localChange,b.remoteChange=R.remoteChange,b}),this.c}async discard(y){return await this.X(y,async c=>{const b=await this.pb(c,N.CancellationToken.None);return await this.C.writeFile(c.previewResource,A.VSBuffer.fromString(b.content||"")),c.acceptResult=void 0,c.mergeState="preview",c.localChange=b.localChange,c.remoteChange=b.remoteChange,c}),this.c}async X(y,c){if(!this.c)return;let b=await this.c;const R=b.resourcePreviews.findIndex(({localResource:M,remoteResource:F,previewResource:H})=>this.h.isEqual(M,y)||this.h.isEqual(F,y)||this.h.isEqual(H,y));R!==-1&&(this.c=(0,U.createCancelablePromise)(async M=>{const F=[...b.resourcePreviews];return F[R]=await c(F[R]),{...b,resourcePreviews:F}}),b=await this.c,this.ab(b.resourcePreviews),b.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(y){if(!this.c)return"idle";const c=await this.c;return c.resourcePreviews.some(({mergeState:b})=>b==="conflict")?"hasConflicts":c.resourcePreviews.some(({mergeState:b})=>b!=="accepted")?"syncing":(await this.rb(c.remoteUserData,c.lastSyncUserData,c.resourcePreviews.map(b=>[b,b.acceptResult]),y),this.c=null,await this.Z(),"idle")}async Z(){try{await this.C.del(this.g,{recursive:!0})}catch{}}ab(y){const c=y.filter(({mergeState:b})=>b==="conflict");(0,k.equals)(this.m,c,(b,R)=>this.h.isEqual(b.previewResource,R.previewResource))||(this.m=c,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async bb(y){const c=this.c?await this.c:null;if(c)for(const b of c.resourcePreviews){if(this.h.isEqual(b.acceptedResource,y))return b.acceptResult?b.acceptResult.content:null;if(this.h.isEqual(b.remoteResource,y))return b.remoteContent;if(this.h.isEqual(b.localResource,y))return b.localContent;if(this.h.isEqual(b.baseResource,y))return b.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(y){(0,d.toFileOperationResult)(y)!==1&&this.L.error(y)}}async cb(y,c,b,R,M,F){const H=await this.ob(y,c,b,M,F),q=[];for(const V of H){const Q=V.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(V.localChange===0&&V.remoteChange===0)q.push({...V,acceptedResource:Q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const te=R?await this.pb(V,F):void 0;if(F.isCancellationRequested)break;await this.C.writeFile(V.previewResource,A.VSBuffer.fromString(te?.content||""));const Y=te&&!te.hasConflicts?await this.qb(V,V.previewResource,void 0,F):void 0;q.push({...V,acceptResult:Y,mergeState:te?.hasConflicts?"conflict":Y?"accepted":"preview",localChange:Y?Y.localChange:te?te.localChange:V.localChange,remoteChange:Y?Y.remoteChange:te?te.remoteChange:V.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:c,resourcePreviews:q,isLastSyncFromCurrentMachine:b}}async getLastSyncUserData(){let y=this.eb();if(y||(y=await this.hb()),!y)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const c=JSON.parse(y),b=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!c.version&&!!b&&c.version!==b,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${c.version} is not compatible with current sync state version ${b}.`),await this.resetLocal(),null;let R,M=1;for(;R===void 0&&M++<6;)try{const F=await this.fb();F&&(F.ref===c.ref?R=F.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof d.FileOperationError&&F.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(F instanceof p.UserDataSyncError)throw F;this.L.error(F,M)}}if(R===void 0)try{const F=await this.G.resolveResourceContent(this.resource,c.ref,this.collection,this.z);R=F===null?null:this.ib(F),await this.gb({ref:c.ref,syncData:R})}catch(F){if(F instanceof p.UserDataSyncError&&F.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw F}return R===void 0?null:{...c,syncData:R}}async db(y,c={}){if(c.ref||c.version)throw new Error("Cannot have core properties as additional");const b=this.I.getResourceSyncStateVersion(this.resource),R={ref:y.ref,version:b,...c};this.F.store(this.v,JSON.stringify(R),-1,1),await this.gb(y)}eb(){return this.F.get(this.v,-1)}async fb(){const y=(await this.C.readFile(this.u)).value.toString();try{const c=y?JSON.parse(y):void 0;if(n(c))return c}catch(c){this.L.error(c)}}async gb(y){await this.C.writeFile(this.u,A.VSBuffer.fromString(JSON.stringify(y)))}async hb(){try{const y=await this.C.readFile(this.u),c=JSON.parse(y.value.toString());await this.C.del(this.u),c.ref&&c.content!==void 0?(this.F.store(this.v,JSON.stringify({...c,content:void 0}),-1,1),await this.gb({ref:c.ref,syncData:c.content===null?null:JSON.parse(c.content)})):this.L.info(`${this.y}: Migrating last sync user data. Invalid data.`,c)}catch(y){y instanceof d.FileOperationError&&y.fileOperationResult===1?this.L.info(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(y)}return this.F.get(this.v,-1)}async getRemoteUserData(y){const{ref:c,content:b}=await this.jb(y);let R=null;return b!==null&&(R=this.ib(b)),{ref:c,syncData:R}}ib(y){try{const c=JSON.parse(y);if(r(c))return c}catch(c){this.L.error(c)}throw new p.UserDataSyncError((0,v.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async jb(y){const c=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.G.readResource(this.resource,c,this.collection,this.z)}async kb(y,c){const b=await this.j,R={version:this.nb,machineId:b,content:y};try{return c=await this.G.writeResource(this.resource,JSON.stringify(R),c,this.collection,this.z),{ref:c,syncData:R}}catch(M){throw M instanceof p.UserDataSyncError&&M.code==="TooLarge"&&(M=new p.UserDataSyncError(M.message,M.code,this.resource)),M}}async lb(y){const c={version:this.nb,content:y};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(c))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.ab([]),await this.Z(),this.P("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}mb(){return this.M.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=i=ve([X(2,d.IFileService),X(3,f.IEnvironmentService),X(4,h.IStorageService),X(5,p.IUserDataSyncStoreService),X(6,p.IUserDataSyncBackupStoreService),X(7,p.IUserDataSyncEnablementService),X(8,u.ITelemetryService),X(9,p.IUserDataSyncLogService),X(10,S.IConfigurationService),X(11,I.IUriIdentityService)],i);let s=e.AbstractFileSynchroniser=class extends i{constructor(y,c,b,R,M,F,H,q,V,Q,te,Y,x){super(c,b,R,M,F,H,q,V,Q,te,Y,x),this.i=y,this.B(this.C.watch(this.h.dirname(y))),this.B(this.C.onDidFilesChange(G=>this.ub(G)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(y,c,b){try{c?await this.C.writeFile(this.i,A.VSBuffer.fromString(y),b?void 0:c):await this.C.createFile(this.i,A.VSBuffer.fromString(y),{overwrite:b})}catch(R){throw R instanceof d.FileOperationError&&R.fileOperationResult===1||R instanceof d.FileOperationError&&R.fileOperationResult===3?new p.UserDataSyncError(R.message,"LocalPreconditionFailed"):R}}async tb(){try{await this.C.del(this.i)}catch(y){if(!(y instanceof d.FileOperationError&&y.fileOperationResult===1))throw y}}ub(y){y.contains(this.i)&&this.N()}};e.AbstractFileSynchroniser=s=ve([X(3,d.IFileService),X(4,f.IEnvironmentService),X(5,h.IStorageService),X(6,p.IUserDataSyncStoreService),X(7,p.IUserDataSyncBackupStoreService),X(8,p.IUserDataSyncEnablementService),X(9,u.ITelemetryService),X(10,p.IUserDataSyncLogService),X(11,S.IConfigurationService),X(12,I.IUriIdentityService)],s);let o=e.AbstractJsonFileSynchroniser=class extends s{constructor(y,c,b,R,M,F,H,q,V,Q,te,Y,x,G){super(y,c,b,R,M,F,H,q,V,Q,te,x,G),this.vb=Y,this.xb=void 0}wb(y,c){const b=[],R=(0,D.parse)(y,b,{allowEmptyContent:!0,allowTrailingComma:!0});return b.length>0||!(0,P.isUndefined)(R)&&c!==Array.isArray(R)}yb(){return this.xb||(this.xb=this.vb.resolveFormattingOptions(this.i)),this.xb}};e.AbstractJsonFileSynchroniser=o=ve([X(3,d.IFileService),X(4,f.IEnvironmentService),X(5,h.IStorageService),X(6,p.IUserDataSyncStoreService),X(7,p.IUserDataSyncBackupStoreService),X(8,p.IUserDataSyncEnablementService),X(9,u.ITelemetryService),X(10,p.IUserDataSyncLogService),X(11,p.IUserDataSyncUtilService),X(12,S.IConfigurationService),X(13,I.IUriIdentityService)],o);let l=e.AbstractInitializer=class{constructor(y,c,b,R,M,F,H){this.resource=y,this.g=c,this.h=b,this.j=R,this.k=M,this.l=F,this.d=H.extUri,this.f=(0,p.getLastSyncResourceUri)(void 0,this.resource,b,this.d)}async initialize({ref:y,content:c}){if(!c){this.j.info("Remote content does not exist.",this.resource);return}const b=this.m(c);if(b)try{await this.o({ref:y,syncData:b})}catch(R){this.j.error(R)}}m(y){try{const c=JSON.parse(y);if(r(c))return c}catch(c){this.j.error(c)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,c={}){if(c.ref||c.version)throw new Error("Cannot have core properties as additional");const b={ref:y.ref,version:void 0,...c};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(b),-1,1),await this.k.writeFile(this.f,A.VSBuffer.fromString(JSON.stringify(y)))}};e.AbstractInitializer=l=ve([X(1,L.IUserDataProfilesService),X(2,f.IEnvironmentService),X(3,w.ILogService),X(4,d.IFileService),X(5,h.IStorageService),X(6,I.IUriIdentityService)],l)}),define(oe[114],ae([0,1,6,26,7,3,41,2,27,18,14,113,28,33,79,13,4,70,8,19,20,29,17,39,226,111,23,58]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u,I,p,L,n,r,t,i,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function l(M,F){const H=JSON.parse(M.content);if(M.version===1||M.version===2){const q=(await F.getInstalled(0)).filter(V=>V.isBuiltin);for(const V of H)M.version===1&&(V.enabled===!1&&(V.disabled=!0),delete V.enabled),M.version===2&&q.every(Q=>!(0,f.areSameExtensions)(Q.identifier,V.identifier))&&(V.installed=!0)}return H}function E(M){return JSON.parse(M.content)}e.parseExtensions=E;function y(M,F){return M.sort((H,q)=>!H.identifier.uuid&&q.identifier.uuid?-1:H.identifier.uuid&&!q.identifier.uuid?1:(0,C.compare)(H.identifier.id,q.identifier.id)),F?(0,T.toFormattedString)(M,{}):JSON.stringify(M)}e.stringify=y;let c=e.ExtensionsSynchroniser=class extends r.AbstractSynchroniser{constructor(F,H,q,V,Q,te,Y,x,G,j,Z,ie,se,K,_,$,g){super({syncResource:"extensions",profile:F},H,V,q,Q,te,Y,ie,se,j,Z,_),this.zb=x,this.Ab=G,this.Bb=g,this.nb=5,this.tb=this.h.joinPath(this.g,"extensions.json"),this.ub=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.vb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.wb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.xb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.yb=this.Bb.createInstance(b),this.B(N.Event.any(N.Event.filter(this.zb.onDidInstallExtensions,O=>O.some(({local:B})=>!!B)),N.Event.filter(this.zb.onDidUninstallExtension,O=>!O.error),N.Event.filter($.onDidChange,O=>O.valueChanges.some(({profile:B,changes:W})=>this.syncResource.profile.id===B.id&&W.some(z=>z.key===S.DISABLED_EXTENSIONS_STORAGE_PATH))),K.onDidChangeExtensionStorageToSync)(()=>this.N()))}async ob(F,H){const q=F.syncData?await l(F.syncData,this.zb):null,V=H?.skippedExtensions??[],Q=H?.builtinExtensions??null,te=H?.syncData?await l(H.syncData,this.zb):null,{localExtensions:Y,ignoredExtensions:x}=await this.yb.getLocalExtensions(this.syncResource.profile);q?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:G,remote:j}=(0,t.merge)(Y,q,te,V,x,Q),Z={local:G,remote:j,content:this.Eb(Y,G.added,G.updated,G.removed),localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:j!==null?2:0},ie=this.Lb(Y,!1);return[{skippedExtensions:V,builtinExtensions:Q,baseResource:this.ub,baseContent:te?this.Lb(te,!1):ie,localResource:this.vb,localContent:ie,localExtensions:Y,remoteResource:this.wb,remoteExtensions:q,remoteContent:q?this.Lb(q,!1):null,previewResource:this.tb,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.xb}]}async sb(F){const H=F.syncData?await l(F.syncData,this.zb):null,{localExtensions:q,ignoredExtensions:V}=await this.yb.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,t.merge)(q,H,H,F.skippedExtensions||[],V,F.builtinExtensions||[]);return Q!==null}Eb(F,H,q,V){const Q=[...H,...q],te=new Set,Y=x=>{te.add(x.id.toLowerCase()),x.uuid&&te.add(x.uuid)};Q.forEach(({identifier:x})=>Y(x)),V.forEach(Y);for(const x of F)te.has(x.identifier.id.toLowerCase())||x.identifier.uuid&&te.has(x.identifier.uuid)||Q.push(x);return this.Lb(Q,!1)}async pb(F,H){return{...F.previewResult,hasConflicts:!1}}async qb(F,H,q,V){if(this.h.isEqual(H,this.vb))return this.Hb(F);if(this.h.isEqual(H,this.wb))return this.Ib(F);if(this.h.isEqual(H,this.tb))return F.previewResult;throw new Error(`Invalid Resource: ${H.toString()}`)}async Hb(F){const H=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),q=this.Ab.getIgnoredExtensions(H),V=(0,t.merge)(F.localExtensions,null,null,F.skippedExtensions,q,F.builtinExtensions),{local:Q,remote:te}=V;return{content:F.localContent,local:Q,remote:te,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:te!==null?2:0}}async Ib(F){const H=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),q=this.Ab.getIgnoredExtensions(H),V=F.remoteContent?JSON.parse(F.remoteContent):null;if(V!==null){const Q=(0,t.merge)(F.localExtensions,V,F.localExtensions,[],q,F.builtinExtensions),{local:te,remote:Y}=Q;return{content:F.remoteContent,local:te,remote:Y,localChange:te.added.length>0||te.removed.length>0||te.updated.length>0?2:0,remoteChange:Y!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(F,H,q,V){let{skippedExtensions:Q,builtinExtensions:te,localExtensions:Y}=q[0][0];const{local:x,remote:G,localChange:j,remoteChange:Z}=q[0][1];if(j===0&&Z===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),j!==0&&(await this.lb(JSON.stringify(Y)),Q=await this.yb.updateLocalExtensions(x.added,x.removed,x.updated,Q,this.syncResource.profile)),G){this.L.trace(`${this.y}: Updating remote extensions...`);const ie=JSON.stringify(G.all);F=await this.kb(ie,V?null:F.ref),this.L.info(`${this.y}: Updated remote extensions.${G.added.length?` Added: ${JSON.stringify(G.added.map(se=>se.identifier.id))}.`:""}${G.updated.length?` Updated: ${JSON.stringify(G.updated.map(se=>se.identifier.id))}.`:""}${G.removed.length?` Removed: ${JSON.stringify(G.removed.map(se=>se.identifier.id))}.`:""}`)}H?.ref!==F.ref&&(this.L.trace(`${this.y}: Updating last synchronized extensions...`),te=this.Kb(Y,te),await this.db(F,{skippedExtensions:Q,builtinExtensions:te}),this.L.info(`${this.y}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(ie=>ie.identifier.id))}.`:""}`))}Kb(F,H){const q=new Set,V=[];for(const Q of F)q.add(Q.identifier.id.toLowerCase()),Q.installed||V.push(Q.identifier);if(H)for(const Q of H)q.has(Q.id.toLowerCase())||V.push(Q);return V}async resolveContent(F){if(this.h.isEqual(this.wb,F)||this.h.isEqual(this.ub,F)||this.h.isEqual(this.vb,F)||this.h.isEqual(this.xb,F)){const H=await this.bb(F);return H&&this.Lb(JSON.parse(H),!0)}return null}Lb(F,H){return y(F,H)}async hasLocalData(){try{const{localExtensions:F}=await this.yb.getLocalExtensions(this.syncResource.profile);if(F.some(H=>H.installed||H.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=c=ve([X(2,P.IEnvironmentService),X(3,w.IFileService),X(4,I.IStorageService),X(5,s.IUserDataSyncStoreService),X(6,s.IUserDataSyncBackupStoreService),X(7,S.IExtensionManagementService),X(8,i.IIgnoredExtensionsManagementService),X(9,s.IUserDataSyncLogService),X(10,m.IConfigurationService),X(11,s.IUserDataSyncEnablementService),X(12,p.ITelemetryService),X(13,d.IExtensionStorageService),X(14,L.IUriIdentityService),X(15,o.IUserDataProfileStorageService),X(16,a.IInstantiationService)],c);let b=e.LocalExtensionsProvider=class{constructor(F,H,q,V,Q,te){this.a=F,this.b=H,this.c=q,this.d=V,this.f=Q,this.g=te}async getLocalExtensions(F){const H=await this.a.getInstalled(void 0,F.extensionsResource),q=this.d.getIgnoredExtensions(H);return{localExtensions:await this.j(F,async(Q,te)=>{const Y=Q.getDisabledExtensions();return H.map(x=>{const{identifier:G,isBuiltin:j,manifest:Z,preRelease:ie,pinned:se}=x,K={identifier:G,preRelease:ie,version:Z.version,pinned:!!se};Y.some(_=>(0,f.areSameExtensions)(_,G))&&(K.disabled=!0),j||(K.installed=!0);try{const _=te.getKeysForSync({id:G.id,version:Z.version});if(_){const $=te.getExtensionState(x,!0)||{};K.state=Object.keys($).reduce((g,O)=>(_.includes(O)&&(g[O]=$[O]),g),{})}}catch(_){this.g.info(`${(0,r.getSyncResourceLogLabel)("extensions",F)}: Error while parsing extension state`,(0,A.getErrorMessage)(_))}return K})}),ignoredExtensions:q}}async updateLocalExtensions(F,H,q,V,Q){const te=(0,r.getSyncResourceLogLabel)("extensions",Q),Y=[],x=[],G=[],j=await this.a.getInstalled(void 0,Q.extensionsResource);if((F.length||q.length)&&await this.j(Q,async(ie,se)=>{await k.Promises.settled([...F,...q].map(async K=>{const _=j.find(O=>(0,f.areSameExtensions)(O.identifier,K.identifier));if(_&&_.isBuiltin){K.state&&_.manifest.version===K.version&&this.h(K.state,_,_.manifest.version,se),ie.getDisabledExtensions().some(B=>(0,f.areSameExtensions)(B,K.identifier))!==!!K.disabled&&(K.disabled?(this.g.trace(`${te}: Disabling extension...`,K.identifier.id),await ie.disableExtension(K.identifier),this.g.info(`${te}: Disabled extension`,K.identifier.id)):(this.g.trace(`${te}: Enabling extension...`,K.identifier.id),await ie.enableExtension(K.identifier),this.g.info(`${te}: Enabled extension`,K.identifier.id))),x.push(K.identifier);return}const $=K.pinned?K.version:void 0,g=(await this.c.getExtensions([{...K.identifier,version:$,preRelease:$?void 0:K.preRelease}],U.CancellationToken.None))[0];if(K.state&&(_?_.manifest.version===K.version:g)&&this.h(K.state,_||g,_?.manifest.version,se),g)try{ie.getDisabledExtensions().some(B=>(0,f.areSameExtensions)(B,K.identifier))!==!!K.disabled&&(K.disabled?(this.g.trace(`${te}: Disabling extension...`,K.identifier.id,g.version),await ie.disableExtension(g.identifier),this.g.info(`${te}: Disabled extension`,K.identifier.id,g.version)):(this.g.trace(`${te}: Enabling extension...`,K.identifier.id,g.version),await ie.enableExtension(g.identifier),this.g.info(`${te}: Enabled extension`,K.identifier.id,g.version))),(!_||_.preRelease!==K.preRelease||_.pinned!==K.pinned||$&&_.manifest.version!==$)&&(await this.a.canInstall(g)?Y.push([K,g]):(this.g.info(`${te}: Skipped synchronizing extension because it cannot be installed.`,g.displayName||g.identifier.id),G.push(K)))}catch(O){G.push(K),this.g.error(O),this.g.info(`${te}: Skipped synchronizing extension`,g.displayName||g.identifier.id)}else G.push(K),this.g.info(`${te}: Skipped synchronizing extension because the extension is not found.`,K.identifier.id)}))}),H.length){const ie=j.filter(({identifier:se,isBuiltin:K})=>!K&&H.some(_=>(0,f.areSameExtensions)(se,_)));await k.Promises.settled(ie.map(async se=>{this.g.trace(`${te}: Uninstalling local extension...`,se.identifier.id),await this.a.uninstall(se,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.g.info(`${te}: Uninstalled local extension.`,se.identifier.id),x.push(se.identifier)}))}for(const[ie,se]of Y)try{this.g.trace(`${te}: Installing extension...`,se.identifier.id,se.version),await this.a.installFromGallery(se,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:ie.pinned&&!!ie.version,installPreReleaseVersion:ie.preRelease,profileLocation:Q.extensionsResource,context:{[S.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[S.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.g.info(`${te}: Installed extension.`,se.identifier.id,se.version),x.push(se.identifier)}catch(K){G.push(ie),K instanceof S.ExtensionManagementError&&[S.ExtensionManagementErrorCode.Incompatible,S.ExtensionManagementErrorCode.IncompatiblePreRelease,S.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(K.code)?this.g.info(`${te}: Skipped synchronizing extension because the compatible extension is not found.`,se.displayName||se.identifier.id):(this.g.error(K),this.g.info(`${te}: Skipped synchronizing extension`,se.displayName||se.identifier.id))}const Z=[];for(const ie of V)x.some(se=>(0,f.areSameExtensions)(se,ie.identifier))||Z.push(ie);for(const ie of G)Z.some(se=>(0,f.areSameExtensions)(se.identifier,ie.identifier))||Z.push(ie);return Z}h(F,H,q,V){const Q=V.getExtensionState(H,!0)||{},te=q?V.getKeysForSync({id:H.identifier.id,version:q}):void 0;te?te.forEach(Y=>{Q[Y]=F[Y]}):Object.keys(F).forEach(Y=>Q[Y]=F[Y]),V.setExtensionState(H,Q,!0)}async j(F,H){return this.b.withProfileScopedStorageService(F,async q=>{const V=new D.DisposableStore,Q=this.f.createChild(new h.ServiceCollection([I.IStorageService,q])),te=V.add(Q.createInstance(v.GlobalExtensionEnablementService)),Y=V.add(Q.createInstance(d.ExtensionStorageService));try{return await H(te,Y)}finally{V.dispose()}})}};e.LocalExtensionsProvider=b=ve([X(0,S.IExtensionManagementService),X(1,o.IUserDataProfileStorageService),X(2,S.IExtensionGalleryService),X(3,i.IIgnoredExtensionsManagementService),X(4,a.IInstantiationService),X(5,s.IUserDataSyncLogService)],b);let R=e.AbstractExtensionsInitializer=class extends r.AbstractInitializer{constructor(F,H,q,V,Q,te,Y,x){super("extensions",V,Q,te,q,Y,x),this.p=F,this.q=H}async t(F){return F.syncData?await l(F.syncData,this.p):null}u(F,H){const q=[],V=[],Q=[];for(const te of F){if(this.q.hasToNeverSyncExtension(te.identifier.id))continue;const Y=H.find(x=>(0,f.areSameExtensions)(x.identifier,te.identifier));Y?(q.push(Y),te.disabled&&Q.push(te.identifier)):te.installed&&(V.push({...te.identifier,preRelease:!!te.preRelease}),te.disabled&&Q.push(te.identifier))}return{installedExtensions:q,newExtensions:V,disabledExtensions:Q,remoteExtensions:F}}};e.AbstractExtensionsInitializer=R=ve([X(0,S.IExtensionManagementService),X(1,i.IIgnoredExtensionsManagementService),X(2,w.IFileService),X(3,n.IUserDataProfilesService),X(4,P.IEnvironmentService),X(5,u.ILogService),X(6,I.IStorageService),X(7,L.IUriIdentityService)],R)}),define(oe[115],ae([0,1,16,7,3,34,41,5,32,18,14,13,8,44,19,20,29,39,57,230,23,17,58,4]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u,I,p,L,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",i=["locale"];function s(b,R){const M=b.storage?Object.keys(b.storage).sort():[],F={};return M.forEach(H=>F[H]=b.storage[H]),b.storage=F,R?(0,T.toFormattedString)(b,{}):JSON.stringify(b)}e.stringify=s;const o=1;let l=e.GlobalStateSynchroniser=class extends h.AbstractSynchroniser{constructor(R,M,F,H,q,V,Q,te,Y,x,G,j,Z,ie){super({syncResource:"globalState",profile:R},M,H,te,j,q,V,Y,x,Q,G,Z),this.xb=F,this.nb=o,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.tb=this.p.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.ub=this.p.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.vb=this.p.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.wb=ie.createInstance(E),this.B(H.watch(this.h.dirname(this.D.argvResource))),this.B(A.Event.any(A.Event.filter(H.onDidFilesChange,se=>se.contains(this.D.argvResource)),A.Event.filter(F.onDidChange,se=>!!(se.targetChanges.some(K=>this.syncResource.profile.id===K.id)||se.valueChanges.some(({profile:K,changes:_})=>this.syncResource.profile.id===K.id&&_.some($=>$.target===0)))))(()=>this.N()))}async ob(R,M,F){const H=R.syncData?JSON.parse(R.syncData.content):null;M=M===null&&F?R:M;const q=M&&M.syncData?JSON.parse(M.syncData.content):null,V=await this.wb.getLocalGlobalState(this.syncResource.profile);H?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Q=await this.Fb(q),{local:te,remote:Y}=(0,I.merge)(V.storage,H?H.storage:null,q?q.storage:null,Q,this.L),x={content:null,local:te,remote:Y,localChange:Object.keys(te.added).length>0||Object.keys(te.updated).length>0||te.removed.length>0?2:0,remoteChange:Y.all!==null?2:0},G=s(V,!1);return[{baseResource:this.r,baseContent:q?s(q,!1):G,localResource:this.tb,localContent:G,localUserData:V,remoteResource:this.ub,remoteContent:H?s(H,!1):null,previewResource:this.p,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.vb,storageKeys:Q}]}async sb(R){const M=R.syncData?JSON.parse(R.syncData.content):null;if(M===null)return!0;const F=await this.wb.getLocalGlobalState(this.syncResource.profile),H=await this.Fb(M),{remote:q}=(0,I.merge)(F.storage,M.storage,M.storage,H,this.L);return q.all!==null}async pb(R,M){return{...R.previewResult,hasConflicts:!1}}async qb(R,M,F,H){if(this.h.isEqual(M,this.tb))return this.Cb(R);if(this.h.isEqual(M,this.ub))return this.Db(R);if(this.h.isEqual(M,this.p))return R.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Cb(R){return{content:R.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(R.localUserData.storage),removed:[],updated:[],all:R.localUserData.storage},localChange:0,remoteChange:2}}async Db(R){if(R.remoteContent!==null){const M=JSON.parse(R.remoteContent),{local:F,remote:H}=(0,I.merge)(R.localUserData.storage,M.storage,null,R.storageKeys,this.L);return{content:R.remoteContent,local:F,remote:H,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:H!==null?2:0}}else return{content:R.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async rb(R,M,F,H){const{localUserData:q}=F[0][0],{local:V,remote:Q,localChange:te,remoteChange:Y}=F[0][1];if(te===0&&Y===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),te!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.lb(JSON.stringify(q)),await this.wb.writeLocalGlobalState(V,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),Y!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const x=JSON.stringify({storage:Q.all});R=await this.kb(x,H?null:R.ref),this.L.info(`${this.y}: Updated remote ui state.${Q.added.length?` Added: ${Q.added}.`:""}${Q.updated.length?` Updated: ${Q.updated}.`:""}${Q.removed.length?` Removed: ${Q.removed}.`:""}`)}M?.ref!==R.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.db(R),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(R){if(this.h.isEqual(this.ub,R)||this.h.isEqual(this.r,R)||this.h.isEqual(this.tb,R)||this.h.isEqual(this.vb,R)){const M=await this.bb(R);return M&&s(JSON.parse(M),!0)}return null}async hasLocalData(){try{const{storage:R}=await this.wb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(R).length>1||R[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Fb(R){const M=await this.xb.readStorageData(this.syncResource.profile),F=[],H=[];for(const[Q,te]of M)te.target===0?F.push(Q):te.target===1&&H.push(Q);const q=[...F,...H],V=R?.storage?Object.keys(R.storage).filter(Q=>!Q.startsWith(t)&&!q.includes(Q)&&M.get(Q)!==void 0):[];if(!D.isWeb){const Q=[...p.ALL_SYNC_RESOURCES.map(te=>(0,p.getEnablementKey)(te)),p.SYNC_SERVICE_URL_TYPE];V.push(...Q),H.push(...Q)}return{user:F,machine:H,unregistered:V}}};e.GlobalStateSynchroniser=l=ve([X(2,n.IUserDataProfileStorageService),X(3,v.IFileService),X(4,p.IUserDataSyncStoreService),X(5,p.IUserDataSyncBackupStoreService),X(6,p.IUserDataSyncLogService),X(7,P.IEnvironmentService),X(8,p.IUserDataSyncEnablementService),X(9,w.ITelemetryService),X(10,m.IConfigurationService),X(11,d.IStorageService),X(12,a.IUriIdentityService),X(13,r.IInstantiationService)],l);let E=e.LocalGlobalStateProvider=class{constructor(R,M,F,H){this.a=R,this.b=M,this.c=F,this.d=H}async getLocalGlobalState(R){const M={};if(R.isDefault){const H=await this.f(),q=(0,N.parse)(H);for(const V of i)q[V]!==void 0&&(M[`${t}${V}`]={version:1,value:q[V]})}const F=await this.c.readStorageData(R);for(const[H,q]of F)q.value&&q.target===0&&(M[H]={version:1,value:q.value});return{storage:M}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const R=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),R.value.toString()}catch(R){this.d.debug((0,U.getErrorMessage)(R))}return"{}"}async writeLocalGlobalState({added:R,removed:M,updated:F},H){const q=(0,h.getSyncResourceLogLabel)("globalState",H),V={},Q=new Map,te=await this.c.readStorageData(H),Y=(x,G)=>{for(const j of x){if(j.startsWith(t)){V[j.substring(t.length)]=G?G[j].value:void 0;continue}if(G){const Z=G[j];Z.value!==te.get(j)?.value&&Q.set(j,Z.value)}else te.get(j)!==void 0&&Q.set(j,void 0)}};if(Y(Object.keys(R),R),Y(Object.keys(F),F),Y(M),Object.keys(V).length){this.d.trace(`${q}: Updating locale...`);const x=await this.f();let G=x;for(const j of Object.keys(V))G=(0,u.edit)(G,[j],V[j],{});x!==G&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,k.VSBuffer.fromString(G)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}Q.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(H,Q,0),this.d.info(`${q}: Updated global state`,[...Q.keys()]))}};e.LocalGlobalStateProvider=E=ve([X(0,v.IFileService),X(1,P.IEnvironmentService),X(2,n.IUserDataProfileStorageService),X(3,p.IUserDataSyncLogService)],E);let y=e.GlobalStateInitializer=class extends h.AbstractInitializer{constructor(R,M,F,H,q,V){super("globalState",F,H,q,M,R,V)}async o(R){const M=R.syncData?JSON.parse(R.syncData.content):null;if(!M){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},H={};for(const q of Object.keys(M.storage))q.startsWith(t)?F[q.substring(t.length)]=M.storage[q].value:this.l.get(q,0)===void 0&&(H[q]=M.storage[q].value);if(Object.keys(F).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const V of Object.keys(F))q=(0,u.edit)(q,[V],F[V],{});await this.k.writeFile(this.h.argvResource,k.VSBuffer.fromString(q))}if(Object.keys(H).length)for(const q of Object.keys(H))this.l.store(q,H[q],0,0)}};e.GlobalStateInitializer=y=ve([X(0,d.IStorageService),X(1,v.IFileService),X(2,L.IUserDataProfilesService),X(3,P.IEnvironmentService),X(4,p.IUserDataSyncLogService),X(5,a.IUriIdentityService)],y);let c=e.UserDataSyncStoreTypeSynchronizer=class{constructor(R,M,F,H,q){this.a=R,this.b=M,this.c=F,this.d=H,this.f=q}getSyncStoreType(R){return this.h(R)?.storage[p.SYNC_SERVICE_URL_TYPE]?.value}async sync(R){const M=(0,p.createSyncHeaders)((0,C.generateUuid)());try{return await this.g(R,M)}catch(F){if(F instanceof p.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(R,M)}throw F}}async g(R,M){const F=await this.a.readResource("globalState",null,void 0,M),H=this.h(F)||{storage:{}};H.storage[p.SYNC_SERVICE_URL_TYPE]={value:R,version:o};const q=await(0,f.getServiceMachineId)(this.c,this.d,this.b),V={version:o,machineId:q,content:s(H,!1)};await this.a.writeResource("globalState",JSON.stringify(V),F.ref,void 0,M)}h({content:R}){if(!R)return null;const M=JSON.parse(R);if((0,h.isSyncData)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=c=ve([X(1,d.IStorageService),X(2,P.IEnvironmentService),X(3,v.IFileService),X(4,S.ILogService)],c)}),define(oe[116],ae([0,1,21,16,3,34,5,10,164,18,14,13,19,20,29,17,39,227,23]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function I(n,r,t){try{const i=JSON.parse(n);if(!r)return(0,D.isUndefined)(i.all)?null:i.all;switch(T.OS){case 2:return(0,D.isUndefined)(i.mac)?null:i.mac;case 3:return(0,D.isUndefined)(i.linux)?null:i.linux;case 1:return(0,D.isUndefined)(i.windows)?null:i.windows}}catch(i){return t.error(i),null}}e.getKeybindingsContentFromSyncContent=I;let p=e.KeybindingsSynchroniser=class extends a.AbstractJsonFileSynchroniser{constructor(r,t,i,s,o,l,E,y,c,b,R,M,F){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},t,y,c,b,i,s,E,M,o,R,l,F),this.nb=2,this.Ab=this.h.joinPath(this.g,"keybindings.json"),this.Bb=this.Ab.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Cb=this.Ab.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Db=this.Ab.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Eb=this.Ab.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(A.Event.filter(l.onDidChangeConfiguration,H=>H.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.N()))}async ob(r,t,i,s){const o=r.syncData?I(r.syncData.content,s.keybindingsPerPlatform??this.Mb(),this.L):null;t=t===null&&i?r:t;const l=t?this.Kb(t):null,E=await this.p(),y=await this.yb();let c=null,b=!1,R=!1,M=!1;if(o){let q=E?E.value.toString():"[]";if(q=q||"[]",this.wb(q,!0))throw new u.UserDataSyncError((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!l||l!==q||l!==o){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const V=await(0,h.merge)(q,o,l,y,this.vb);V.hasChanges&&(c=V.mergeContent,M=V.hasConflicts,b=M||V.mergeContent!==q,R=M||V.mergeContent!==o)}}else E&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),c=E.value.toString(),R=!0);const F={content:M?l:c,localChange:b?E?2:1:0,remoteChange:R?2:0,hasConflicts:M},H=E?E.value.toString():null;return[{fileContent:E,baseResource:this.Bb,baseContent:l,localResource:this.Cb,localContent:H,localChange:F.localChange,remoteResource:this.Db,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.Ab,previewResult:F,acceptedResource:this.Eb}]}async sb(r){const t=this.Kb(r);if(t===null)return!0;const i=await this.p(),s=i?i.value.toString():"",o=await this.yb(),l=await(0,h.merge)(s||"[]",t,t,o,this.vb);return l.hasConflicts||l.mergeContent!==t}async pb(r,t){return r.previewResult}async qb(r,t,i,s){if(this.h.isEqual(t,this.Cb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Db))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.Ab))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(r,t,i,s){const{fileContent:o}=i[0][0];let{content:l,localChange:E,remoteChange:y}=i[0][1];if(E===0&&y===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.wb(l,!0)))throw new u.UserDataSyncError((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(E!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),o&&await this.lb(this.Lb(o.value.toString())),await this.r(l||"[]",o,s),this.L.info(`${this.y}: Updated local keybindings`)),y!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const c=this.Lb(l||"[]",r.syncData?.content);r=await this.kb(c,s?null:r.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.Ab)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.db(r,{platformSpecific:this.Mb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=(0,N.parse)(r.value.toString());if((0,k.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Db,r)||this.h.isEqual(this.Bb,r)||this.h.isEqual(this.Cb,r)||this.h.isEqual(this.Eb,r)?this.bb(r):null}Kb(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Mb()?null:I(r.syncData.content,this.Mb(),this.L)}Lb(r,t){let i={};try{i=JSON.parse(t||"{}")}catch(s){this.L.error(s)}switch(this.Mb()?delete i.all:i.all=r,T.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}Mb(){return!!this.M.getValue(u.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=p=ve([X(2,u.IUserDataSyncStoreService),X(3,u.IUserDataSyncBackupStoreService),X(4,u.IUserDataSyncLogService),X(5,m.IConfigurationService),X(6,u.IUserDataSyncEnablementService),X(7,v.IFileService),X(8,P.IEnvironmentService),X(9,S.IStorageService),X(10,u.IUserDataSyncUtilService),X(11,f.ITelemetryService),X(12,d.IUriIdentityService)],p);let L=e.KeybindingsInitializer=class extends a.AbstractInitializer{constructor(r,t,i,s,o,l){super("keybindings",t,i,s,r,o,l)}async o(r){const t=r.syncData?this.p(r.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,U.VSBuffer.fromString(t)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,N.parse)(r.value.toString());return!(0,k.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}p(r){try{return I(r,!0,this.j)}catch(t){return this.j.error(t),null}}};e.KeybindingsInitializer=L=ve([X(0,v.IFileService),X(1,w.IUserDataProfilesService),X(2,P.IEnvironmentService),X(3,u.IUserDataSyncLogService),X(4,S.IStorageService),X(5,d.IUriIdentityService)],L)}),define(oe[117],ae([0,1,16,3,165,18,73,14,28,13,19,20,29,17,39,57,231,23]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function u(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function I(n){const r=JSON.parse(n);return u(r)?r:{settings:n}}e.parseSettingsSyncContent=I;let p=e.SettingsSynchroniser=class extends d.AbstractJsonFileSynchroniser{constructor(r,t,i,s,o,l,E,y,c,b,R,M,F,H){super(r.settingsResource,{syncResource:"settings",profile:r},t,i,s,o,l,E,R,M,y,c,b,H),this.Ab=F,this.nb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Kb=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),i=await this.S(r,t),s=this.Hb(i),o=new T.ConfigurationModelParser(h.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&o.parse(s.settings),o.configurationModel.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async ob(r,t,i){const s=await this.p(),o=await this.yb(),l=this.Hb(r);t=t===null&&i?r:t;const E=t?this.Hb(t):null,y=await this.Lb();let c=null,b=!1,R=!1,M=!1;if(l){let V=s?s.value.toString().trim():"{}";V=V||"{}",this.Mb(V),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const Q=(0,a.merge)(V,l.settings,E?E.settings:null,y,[],o);c=Q.localContent||Q.remoteContent,b=Q.localContent!==null,R=Q.remoteContent!==null,M=Q.hasConflicts}else s&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),c=s.value.toString().trim()||"{}",this.Mb(c),R=!0);const F=s?s.value.toString():null,H=E?.settings??null,q={content:M?H:c,localChange:b?2:0,remoteChange:R?2:0,hasConflicts:M};return[{fileContent:s,baseResource:this.baseResource,baseContent:H,localResource:this.localResource,localContent:F,localChange:q.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:q.remoteChange,previewResource:this.previewResource,previewResult:q,acceptedResource:this.acceptedResource}]}async sb(r){const t=this.Hb(r);if(t===null)return!0;const i=await this.p(),s=i?i.value.toString().trim():"",o=await this.Lb(),l=await this.yb();return(0,a.merge)(s||"{}",t.settings,t.settings,o,[],l).remoteContent!==null}async pb(r,t){const i=await this.yb(),s=await this.Lb();return{...r.previewResult,content:r.previewResult.content?(0,a.updateIgnoredSettings)(r.previewResult.content,"{}",s,i):null}}async qb(r,t,i,s){const o=await this.yb(),l=await this.Lb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,a.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",l,o):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,a.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",l,o):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,a.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",l,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(r,t,i,s){const{fileContent:o}=i[0][0];let{content:l,localChange:E,remoteChange:y}=i[0][1];if(E===0&&y===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.Mb(l),E!==0&&(this.L.trace(`${this.y}: Updating local settings...`),o&&await this.lb(JSON.stringify(this.Jb(o.value.toString()))),await this.r(l,o,s),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),y!==0){const c=await this.yb(),b=this.Hb(r),R=await this.Lb(l);l=(0,a.updateIgnoredSettings)(l,b?b.settings:"{}",R,c),this.L.trace(`${this.y}: Updating remote settings...`),r=await this.kb(JSON.stringify(this.Jb(l)),s?null:r.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.db(r),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=await this.yb(),i=(0,w.edit)(r.value.toString(),[h.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,a.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.bb(r):null}async bb(r){let t=await super.bb(r);if(t){const i=await this.yb(),s=await this.Lb();t=(0,a.updateIgnoredSettings)(t,"{}",s,i)}return t}Hb(r){return r.syncData?this.Ib(r.syncData.content):null}Ib(r){try{return I(r)}catch(t){this.L.error(t)}return null}Jb(r){return{settings:r}}async Lb(r){if(!this.Kb){this.Kb=this.vb.resolveDefaultIgnoredSettings();const i=U.Event.any(U.Event.filter(this.Ab.onDidInstallExtensions,s=>s.some(({local:o})=>!!o)),U.Event.filter(this.Ab.onDidUninstallExtension,s=>!s.error))(()=>{i.dispose(),this.Kb=void 0})}const t=await this.Kb;return(0,a.getIgnoredSettings)(t,this.M,r)}Mb(r){if(this.wb(r,!1))throw new h.UserDataSyncError((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=p=ve([X(2,m.IFileService),X(3,D.IEnvironmentService),X(4,P.IStorageService),X(5,h.IUserDataSyncStoreService),X(6,h.IUserDataSyncBackupStoreService),X(7,h.IUserDataSyncLogService),X(8,h.IUserDataSyncUtilService),X(9,N.IConfigurationService),X(10,h.IUserDataSyncEnablementService),X(11,v.ITelemetryService),X(12,C.IExtensionManagementService),X(13,S.IUriIdentityService)],p);let L=e.SettingsInitializer=class extends d.AbstractInitializer{constructor(r,t,i,s,o,l){super("settings",t,i,s,r,o,l)}async o(r){const t=r.syncData?this.p(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,k.VSBuffer.fromString(t.settings)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,a.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}p(r){try{return I(r)}catch(t){this.j.error(t)}return null}};e.SettingsInitializer=L=ve([X(0,m.IFileService),X(1,f.IUserDataProfilesService),X(2,D.IEnvironmentService),X(3,h.IUserDataSyncLogService),X(4,P.IStorageService),X(5,S.IUriIdentityService)],L)}),define(oe[118],ae([0,1,16,3,31,18,14,13,19,20,29,17,39,228,23]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function w(u){return JSON.parse(u.content)}e.parseSnippets=w;let a=e.SnippetsSynchroniser=class extends S.AbstractSynchroniser{constructor(I,p,L,n,r,t,i,s,o,l,E,y){super({syncResource:"snippets",profile:I},p,n,L,r,t,i,l,E,s,o,y),this.nb=1,this.p=I.snippetsHome,this.B(this.C.watch(L.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(U.Event.filter(this.C.onDidFilesChange,c=>c.affects(this.p))(()=>this.N()))}async ob(I,p,L){const n=await this.Db(),r=this.Cb(n),t=I.syncData?this.Bb(I.syncData):null;p=p===null&&L?I:p;const i=p&&p.syncData?this.Bb(p.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,f.merge)(r,t,i);return this.xb(s,n,t||{},i||{})}async sb(I){const p=I.syncData?this.Bb(I.syncData):null;if(p===null)return!0;const L=await this.Db(),n=this.Cb(L),r=(0,f.merge)(n,p,p);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async pb(I,p){return I.previewResult}async qb(I,p,L,n){if(this.h.isEqualOrParent(p,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:I.fileContent?I.fileContent.value.toString():null,localChange:0,remoteChange:I.fileContent?I.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(p,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:I.remoteContent,localChange:I.remoteContent!==null?I.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(p,this.g))return L===void 0?{content:I.previewResult.content,localChange:I.previewResult.localChange,remoteChange:I.previewResult.remoteChange}:{content:L,localChange:L===null?I.fileContent!==null?3:0:2,remoteChange:L===null?I.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async rb(I,p,L,n){const r=L.map(([t,i])=>({...t,acceptResult:i}));r.every(({localChange:t,remoteChange:i})=>t===0&&i===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),r.some(({localChange:t})=>t!==0)&&(await this.yb(r),await this.zb(r,n)),r.some(({remoteChange:t})=>t!==0)&&(I=await this.Ab(r,I,n)),p?.ref!==I.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.db(I),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of r)try{await this.C.del(t)}catch{}}xb(I,p,L,n){const r=new Map;for(const t of Object.keys(I.local.added)){const i={content:I.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(I.local.updated)){const i={content:I.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=p[t]?p[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of I.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=p[t]?p[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(I.remote.added)){const i={content:I.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=p[t]?p[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(I.remote.updated)){const i={content:I.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=p[t]?p[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of I.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of I.conflicts){const i={content:n[t]??null,hasConflicts:!0,localChange:p[t]?2:1,remoteChange:L[t]?2:1},s=p[t]?p[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p))if(!r.has(t)){const i={content:p[t]?p[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=p[t]?p[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(I){return this.h.isEqualOrParent(I,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(I,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(I,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(I,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.bb(I):null}async hasLocalData(){try{const I=await this.Db();if(Object.keys(I).length)return!0}catch{}return!1}async yb(I){const p={};for(const L of I)L.fileContent&&(p[this.h.basename(L.localResource)]=L.fileContent);await this.lb(JSON.stringify(this.Cb(p)))}async zb(I,p){for(const{fileContent:L,acceptResult:n,localResource:r,remoteResource:t,localChange:i}of I)if(i!==0){const s=t?this.h.basename(t):this.h.basename(r),o=this.h.joinPath(this.p,s);i===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(o)),await this.C.del(o),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(o))):i===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(o)),await this.C.createFile(o,k.VSBuffer.fromString(n.content),{overwrite:p}),this.L.info(`${this.y}: Created snippet`,this.h.basename(o))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(o)),await this.C.writeFile(o,k.VSBuffer.fromString(n.content),p?void 0:L),this.L.info(`${this.y}: Updated snippet`,this.h.basename(o)))}}async Ab(I,p,L){const n=p.syncData?this.Bb(p.syncData):{},r=(0,A.deepClone)(n);for(const{acceptResult:t,localResource:i,remoteResource:s,remoteChange:o}of I)if(o!==0){const l=i?this.h.basename(i):this.h.basename(s);o===3?delete r[l]:r[l]=t.content}return(0,f.areSame)(n,r)||(this.L.trace(`${this.y}: Updating remote snippets...`),p=await this.kb(JSON.stringify(r),L?null:p.ref),this.L.info(`${this.y}: Updated remote snippets`)),p}Bb(I){return w(I)}Cb(I){const p={};for(const L of Object.keys(I))p[L]=I[L].value.toString();return p}async Db(){const I={};let p;try{p=await this.C.resolve(this.p)}catch(L){if(L instanceof D.FileOperationError&&L.fileOperationResult===1)return I;throw L}for(const L of p.children||[]){const n=L.resource,r=this.h.extname(n);if(r===".json"||r===".code-snippets"){const t=this.h.relativePath(this.p,n),i=await this.C.readFile(n);I[t]=i}}return I}};e.SnippetsSynchroniser=a=ve([X(2,T.IEnvironmentService),X(3,D.IFileService),X(4,C.IStorageService),X(5,d.IUserDataSyncStoreService),X(6,d.IUserDataSyncBackupStoreService),X(7,d.IUserDataSyncLogService),X(8,N.IConfigurationService),X(9,d.IUserDataSyncEnablementService),X(10,m.ITelemetryService),X(11,P.IUriIdentityService)],a);let h=e.SnippetsInitializer=class extends S.AbstractInitializer{constructor(I,p,L,n,r,t){super("snippets",p,L,n,I,r,t)}async o(I){const p=I.syncData?JSON.parse(I.syncData.content):null;if(!p){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(p)){const r=p[n];if(r){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(t,k.VSBuffer.fromString(r)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(I)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(I){return I.fileOperationResult===1}}};e.SnippetsInitializer=h=ve([X(0,D.IFileService),X(1,v.IUserDataProfilesService),X(2,T.IEnvironmentService),X(3,d.IUserDataSyncLogService),X(4,C.IStorageService),X(5,P.IUriIdentityService)],h)}),define(oe[119],ae([0,1,16,18,14,13,19,20,29,17,39,23]),function(ne,e,k,U,A,N,T,D,C,m,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function S(a,h){try{return JSON.parse(a).tasks??null}catch(u){return h.error(u),null}}e.getTasksContentFromSyncContent=S;let f=e.TasksSynchroniser=class extends P.AbstractFileSynchroniser{constructor(h,u,I,p,L,n,r,t,i,s,o,l){super(h.tasksResource,{syncResource:"tasks",profile:h},u,t,i,s,I,p,r,o,L,n,l),this.nb=1,this.wb=this.h.joinPath(this.g,"tasks.json"),this.xb=this.wb.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.yb=this.wb.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.zb=this.wb.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Ab=this.wb.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async ob(h,u,I,p){const L=h.syncData?S(h.syncData.content,this.L):null;u=u===null&&I?h:u;const n=u?.syncData?S(u.syncData.content,this.L):null,r=await this.p();let t=null,i=!1,s=!1,o=!1;if(h.syncData){const y=r?r.value.toString():null;if(!n||n!==y||n!==L){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const c=w(y,L,n);t=c.content,o=c.hasConflicts,i=c.hasLocalChanged,s=c.hasRemoteChanged}}else r&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),s=!0);const l={content:o?n:t,localChange:i?r?2:1:0,remoteChange:s?2:0,hasConflicts:o},E=r?r.value.toString():null;return[{fileContent:r,baseResource:this.xb,baseContent:n,localResource:this.yb,localContent:E,localChange:l.localChange,remoteResource:this.zb,remoteContent:L,remoteChange:l.remoteChange,previewResource:this.wb,previewResult:l,acceptedResource:this.Ab}]}async sb(h){const u=h?.syncData?S(h.syncData.content,this.L):null;if(u===null)return!0;const I=await this.p(),p=I?I.value.toString():null,L=w(p,u,u);return L.hasLocalChanged||L.hasRemoteChanged}async pb(h,u){return h.previewResult}async qb(h,u,I,p){if(this.h.isEqual(u,this.yb))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.zb))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.wb))return I===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:I,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async rb(h,u,I,p){const{fileContent:L}=I[0][0],{content:n,localChange:r,remoteChange:t}=I[0][1];if(r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),r!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),L&&await this.lb(JSON.stringify(this.Gb(L.value.toString()))),n?await this.r(n,L,p):await this.tb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const i=JSON.stringify(this.Gb(n));h=await this.kb(i,p?null:h.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.wb)}catch{}u?.ref!==h.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.db(h),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(h){return this.h.isEqual(this.zb,h)||this.h.isEqual(this.xb,h)||this.h.isEqual(this.yb,h)||this.h.isEqual(this.Ab,h)?this.bb(h):null}Gb(h){return h?{tasks:h}:{}}};e.TasksSynchroniser=f=ve([X(2,v.IUserDataSyncStoreService),X(3,v.IUserDataSyncBackupStoreService),X(4,v.IUserDataSyncLogService),X(5,U.IConfigurationService),X(6,v.IUserDataSyncEnablementService),X(7,N.IFileService),X(8,A.IEnvironmentService),X(9,T.IStorageService),X(10,D.ITelemetryService),X(11,C.IUriIdentityService)],f);let d=e.TasksInitializer=class extends P.AbstractInitializer{constructor(h,u,I,p,L,n){super("tasks",u,I,p,h,L,n),this.c=this.g.defaultProfile.tasksResource}async o(h){const u=h.syncData?S(h.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,k.VSBuffer.fromString(u)),await this.n(h)}async p(){return this.k.exists(this.c)}};e.TasksInitializer=d=ve([X(0,N.IFileService),X(1,m.IUserDataProfilesService),X(2,A.IEnvironmentService),X(3,v.IUserDataSyncLogService),X(4,T.IStorageService),X(5,C.IUriIdentityService)],d);function w(a,h,u){if(a===null&&h===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(a===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const I=u!==a,p=u!==h;return!I&&!p?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:I&&!p?{content:a,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:p&&!I?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:a,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[120],ae([0,1,41,18,14,13,19,20,29,17,39,229,23]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let f=e.UserDataProfilesManifestSynchroniser=class extends P.AbstractSynchroniser{constructor(h,u,I,p,L,n,r,t,i,s,o,l,E){super({syncResource:"profiles",profile:h},u,p,L,n,r,t,o,l,i,s,E),this.r=I,this.nb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?w(h.syncData):null}async getRemoteSyncedProfiles(h){const u=await this.getLastSyncUserData(),I=await this.S(h,u);return I?.syncData?w(I.syncData):null}async ob(h,u,I){if(!this.r.isEnabled())throw new S.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const p=h.syncData?w(h.syncData):null,L=u?.syncData?w(u.syncData):null,n=this.Ab(),{local:r,remote:t}=(0,v.merge)(n,p,L,[]),i={local:r,remote:t,content:L?this.Bb(L):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:t!==null?2:0},s=d(n,!1);return[{baseResource:this.baseResource,baseContent:L?this.Bb(L):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:p?this.Bb(p):null,remoteProfiles:p,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async sb(h){const u=h?.syncData?w(h.syncData):null,I=this.Ab(),{remote:p}=(0,v.merge)(I,u,u,[]);return!!p?.added.length||!!p?.removed.length||!!p?.updated.length}async pb(h,u){return{...h.previewResult,hasConflicts:!1}}async qb(h,u,I,p){if(this.h.isEqual(u,this.localResource))return this.xb(h);if(this.h.isEqual(u,this.remoteResource))return this.yb(h);if(this.h.isEqual(u,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async xb(h){const u=this.Ab(),I=(0,v.merge)(u,null,null,[]),{local:p,remote:L}=I;return{content:h.localContent,local:p,remote:L,localChange:p.added.length>0||p.removed.length>0||p.updated.length>0?2:0,remoteChange:L!==null?2:0}}async yb(h){const u=h.remoteContent?JSON.parse(h.remoteContent):null,I=[],p=[];for(const L of this.Ab()){const n=u?.find(r=>r.id===L.id);n&&(I.push({id:L.id,name:L.name,collection:n.collection}),p.push(L))}if(u!==null){const L=(0,v.merge)(p,u,I,[]),{local:n,remote:r}=L;return{content:h.remoteContent,local:n,remote:r,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(h,u,I,p){const{local:L,remote:n,localChange:r,remoteChange:t}=I[0][1];r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const i=I[0][0].remoteProfiles||[];if(i.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new S.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0){await this.lb(d(this.Ab(),!1));const s=[];for(const o of L.added)s.push((async()=>{this.L.trace(`${this.y}: Creating '${o.name}' profile...`),await this.r.createProfile(o.id,o.name,{shortName:o.shortName}),this.L.info(`${this.y}: Created profile '${o.name}'.`)})());for(const o of L.removed)s.push((async()=>{this.L.trace(`${this.y}: Removing '${o.name}' profile...`),await this.r.removeProfile(o),this.L.info(`${this.y}: Removed profile '${o.name}'.`)})());for(const o of L.updated){const l=this.r.profiles.find(E=>E.id===o.id);l?s.push((async()=>{this.L.trace(`${this.y}: Updating '${o.name}' profile...`),await this.r.updateProfile(l,{name:o.name,shortName:o.shortName}),this.L.info(`${this.y}: Updated profile '${o.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${o.id}' to update.`)}await Promise.all(s)}if(t!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const s=[],o=i.length+(n?.added.length??0)<=20;if(o)for(const l of n?.added||[]){const E=await this.G.createCollection(this.z);s.push(E),i.push({id:l.id,name:l.name,collection:E,shortName:l.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const l of n?.removed||[])i.splice(i.findIndex(({id:E})=>l.id===E),1);for(const l of n?.updated||[]){const E=i.find(({id:y})=>l.id===y);E&&i.splice(i.indexOf(E),1,{id:l.id,name:l.name,collection:E.collection,shortName:l.shortName})}try{h=await this.updateRemoteProfiles(i,p?null:h.ref),this.L.info(`${this.y}: Updated remote profiles.${o&&n?.added.length?` Added: ${JSON.stringify(n.added.map(l=>l.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(l=>l.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(l=>l.name))}.`:""}`)}catch(l){if(s.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const E of s)await this.G.deleteCollection(E,this.z)}throw l}for(const l of n?.removed||[])await this.G.deleteCollection(l.collection,this.z)}u?.ref!==h.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.db(h),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,u){return this.kb(this.Bb(h),u)}async hasLocalData(){return this.Ab().length>0}async resolveContent(h){if(this.h.isEqual(this.remoteResource,h)||this.h.isEqual(this.baseResource,h)||this.h.isEqual(this.localResource,h)||this.h.isEqual(this.acceptedResource,h)){const u=await this.bb(h);return u&&(0,k.toFormattedString)(JSON.parse(u),{})}return null}Ab(){return this.r.profiles.filter(h=>!h.isDefault&&!h.isTransient)}Bb(h){return JSON.stringify([...h].sort((u,I)=>u.name.localeCompare(I.name)))}};e.UserDataProfilesManifestSynchroniser=f=ve([X(2,m.IUserDataProfilesService),X(3,N.IFileService),X(4,A.IEnvironmentService),X(5,T.IStorageService),X(6,S.IUserDataSyncStoreService),X(7,S.IUserDataSyncBackupStoreService),X(8,S.IUserDataSyncLogService),X(9,U.IConfigurationService),X(10,S.IUserDataSyncEnablementService),X(11,D.ITelemetryService),X(12,C.IUriIdentityService)],f);function d(a,h){const u=[...a].sort((I,p)=>I.name.localeCompare(p.name)).map(I=>({id:I.id,name:I.name}));return h?(0,k.toFormattedString)(u,{}):JSON.stringify(u)}e.stringifyLocalProfiles=d;function w(a){return JSON.parse(a.content)}e.parseUserDataProfilesManifest=w}),define(oe[246],ae([0,1,6,16,62,2,22,18,14,13,17,23]),function(ne,e,k,U,A,N,T,D,C,m,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let S=e.UserDataSyncBackupStoreService=class extends N.Disposable{constructor(d,w,a,h,u){super(),this.a=d,this.b=w,this.c=a,this.f=h,this.g=u,this.h()}async h(){for(const w of this.g.profiles)for(const a of v.ALL_SYNC_RESOURCES)try{await this.j(this.i(w,a))}catch(h){this.f.error(h)}let d;try{d=await this.b.resolve(this.a.userDataSyncHome)}catch(w){(0,m.toFileOperationResult)(w)!==1&&this.f.error(w);return}if(d.children){for(const w of d.children)if(w.isDirectory&&!this.g.profiles.some(a=>a.id===w.name))try{this.f.info("Deleting non existing profile from backup",w.resource.path),await this.b.del(w.resource,{recursive:!0})}catch(a){this.f.error(a)}}}async getAllRefs(d,w){const a=this.i(d,w);try{const h=await this.b.resolve(a);if(h.children)return h.children.filter(I=>I.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(I.name)).sort().reverse().map(I=>({ref:I.name,created:this.k(I)}))}catch(h){if((0,m.toFileOperationResult)(h)!==1)throw h}return[]}async resolveContent(d,w,a){const h=this.i(d,w),u=(0,T.joinPath)(h,a);try{return(await this.b.readFile(u)).value.toString()}catch(I){return this.f.error(I),null}}async backup(d,w,a){const h=this.i(d,w),u=(0,T.joinPath)(h,`${(0,A.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(u,U.VSBuffer.fromString(a))}catch(I){this.f.error(I)}try{this.j(h)}catch{}}i(d,w){return(0,T.joinPath)(this.a.userDataSyncHome,...d.isDefault?[w]:[d.id,w])}async j(d){try{try{if(!await this.b.exists(d))return}catch{return}const w=await this.b.resolve(d);if(w.children){const a=w.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),h=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=a.filter(p=>Date.now()-this.k(p)>h);const I=a.length-u.length;I<10&&(u=u.slice(10-I)),await k.Promises.settled(u.map(async p=>{this.f.info("Deleting from backup",p.resource.path),await this.b.del(p.resource)}))}}catch(w){this.f.error(w)}}k(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};e.UserDataSyncBackupStoreService=S=ve([X(0,C.IEnvironmentService),X(1,m.IFileService),X(2,D.IConfigurationService),X(3,v.IUserDataSyncLogService),X(4,P.IUserDataProfilesService)],S)}),define(oe[247],ae([0,1,3,2,5,14,19,20,23]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const m="sync.enable";let P=e.UserDataSyncEnablementService=class extends U.Disposable{constructor(S,f,d,w){super(),this.c=S,this.f=f,this.g=d,this.h=w,this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new k.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(S.onDidChangeValue(a=>this.j(a)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(m,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(S){S&&!this.canToggleEnablement()||(this.f.publicLog2(m,{enabled:S}),this.c.store(m,S,-1,1))}isResourceEnabled(S){return this.c.getBoolean((0,C.getEnablementKey)(S),-1,!0)}setResourceEnablement(S,f){if(this.isResourceEnabled(S)!==f){const d=(0,C.getEnablementKey)(S);this.i(d,f)}}getResourceSyncStateVersion(S){}i(S,f){this.c.store(S,f,-1,A.isWeb?0:1)}j(S){if(S.scope!==-1)return;if(m===S.key){this.a.fire(this.isEnabled());return}const f=C.ALL_SYNC_RESOURCES.filter(d=>(0,C.getEnablementKey)(d)===S.key)[0];if(f){this.b.fire([f,this.isResourceEnabled(f)]);return}}};e.UserDataSyncEnablementService=P=ve([X(0,T.IStorageService),X(1,D.ITelemetryService),X(2,N.IEnvironmentService),X(3,C.IUserDataSyncStoreManagementService)],P)}),define(oe[80],ae([0,1,3,2,5,27,169,14,13,4,24,44,19,23]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,m.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",w="Safari",a="Chrome",h="Edge",u="Firefox",I="Android";function p(r){switch(r){case w:case a:case h:case u:case I:case(0,A.PlatformToString)(0):return!0}return!1}e.isWebPlatform=p;function L(){return A.isSafari?w:A.isChrome?a:A.isEdge?h:A.isFirefox?u:A.isAndroid?I:(0,A.PlatformToString)(A.isWeb?0:A.platform)}let n=e.UserDataSyncMachinesService=class it extends U.Disposable{constructor(t,i,s,o,l,E){super(),this.h=s,this.i=o,this.j=l,this.k=E,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,v.getServiceMachineId)(t,i,s)}async getMachines(t){const i=await this.f;return(await this.m(t)).machines.map(o=>({...o,isCurrent:o.id===i}))}async addCurrentMachine(t){const i=await this.f,s=await this.m(t);s.machines.some(({id:o})=>o===i)||(s.machines.push({id:i,name:this.l(s.machines),platform:L()}),await this.n(s))}async removeCurrentMachine(t){const i=await this.f,s=await this.m(t),o=s.machines.filter(({id:l})=>l!==i);o.length!==s.machines.length&&(s.machines=o,await this.n(s))}async renameMachine(t,i,s){const o=await this.m(s),l=o.machines.find(({id:E})=>E===t);if(l){l.name=i,await this.n(o);const E=await this.f;t===E&&this.h.store(d,i,-1,1)}}async setEnablements(t){const i=await this.m();for(const[s,o]of t){const l=i.machines.find(E=>E.id===s);l&&(l.disabled=o?void 0:!0)}await this.n(i)}l(t){const i=this.h.get(d,-1);if(i)return i;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${L()} (${this.k.nameShort})`,o=new RegExp(`${(0,N.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let l=0;for(const E of t){const y=o.exec(E.name),c=y?parseInt(y[1]):0;l=c>l?c:l}return`${s} #${l+1}`}async m(t){this.g=await this.p(t);const i=this.r(this.g);if(i.version!==it.a)throw new Error((0,T.localize)(0,null,this.k.nameLong));return i}async n(t){const i=JSON.stringify(t),s=await this.i.writeResource(it.b,i,this.g?.ref||null);this.g={ref:s,content:i},this.c.fire()}async p(t){if(this.g){const i=t&&t.latest?t.latest[it.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.i.readResource(it.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(i){this.j.error(i)}return{version:it.a,machines:[]}}};n.a=1,n.b="machines",e.UserDataSyncMachinesService=n=ve([X(0,D.IEnvironmentService),X(1,C.IFileService),X(2,S.IStorageService),X(3,f.IUserDataSyncStoreService),X(4,f.IUserDataSyncLogService),X(5,P.IProductService)],n)}),define(oe[248],ae([0,1,6,62,38,7,3,2,5,22,12,166,24,19,20,23,77,80]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const u="sync.disableMachineEventually",I="sync.sessionId",p="sync.storeUrl",L="sync.productQuality";let n=e.UserDataAutoSyncService=class extends D.Disposable{get j(){const i=this.z.get(p,-1);return i?P.URI.parse(i):void 0}set j(i){i?this.z.store(p,i.toString(),-1,1):this.z.remove(p,-1)}get l(){return this.z.get(L,-1)}set l(i){i?this.z.store(L,i,-1,1):this.z.remove(L,-1)}constructor(i,s,o,l,E,y,c,b,R,M){super(),this.n=s,this.p=o,this.r=l,this.s=E,this.u=y,this.v=c,this.w=b,this.y=R,this.z=M,this.a=this.B(new D.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new k.ThrottledDelayer(this.O())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=i.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,m.isEqual)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(c.onDidChangeAccount(()=>this.C())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(E.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(T.Event.filter(this.r.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:i,message:s}=this.F();i?this.a.value===void 0&&(this.a.value=new r(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.w,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.I(o))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.u.info(s),this.a.clear()):s&&this.r.isEnabled()&&this.u.info(s))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,U.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(i,s,o){try{this.v.account&&!o&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(I,-1),i?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(l){if(this.u.error(l),s)this.G(!1);else throw l}}G(i){this.r.isEnabled()!==i&&(this.r.setEnablement(i),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(i){if(!i){this.b=0;return}const s=w.UserDataSyncError.toUserDataSyncError(i);s instanceof w.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?C.isWeb&&s.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(s),this.b++),this.h.fire(s)}async J(){this.z.store(u,!0,-1,1),await(0,k.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(u,-1,!1)}M(){this.z.remove(u,-1)}async triggerSync(i,s,o){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...i),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const l=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:l}),this.N=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};e.UserDataAutoSyncService=n=ve([X(0,S.IProductService),X(1,w.IUserDataSyncStoreManagementService),X(2,w.IUserDataSyncStoreService),X(3,w.IUserDataSyncEnablementService),X(4,w.IUserDataSyncService),X(5,w.IUserDataSyncLogService),X(6,a.IUserDataSyncAccountService),X(7,d.ITelemetryService),X(8,h.IUserDataSyncMachinesService),X(9,f.IStorageService)],n);class r extends D.Disposable{constructor(i,s,o,l,E,y,c,b,R){super(),this.j=i,this.k=s,this.l=o,this.m=l,this.n=E,this.p=y,this.r=c,this.s=b,this.u=R,this.b=this.B(new D.MutableDisposable),this.c=this.B(new T.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new T.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.v())),this.B((0,D.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}v(){this.b.value=(0,k.disposableTimeout)(()=>this.sync(r.a,!1),this.k)}sync(i,s){const o=(0,k.createCancelablePromise)(async l=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(E){if((0,N.isCancellationError)(E))return}return this.z(i,s,l)});return this.i=o,this.i.finally(()=>this.i=void 0),this.i}w(){return this.j!==void 0&&!(0,m.isEqual)(this.j,this.l.userDataSyncStore?.url)}async y(){const i=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!i&&(!(0,m.isEqual)(s.defaultUrl,i.defaultUrl)||!(0,m.isEqual)(s.insidersUrl,i.insidersUrl)||!(0,m.isEqual)(s.stableUrl,i.stableUrl))}async z(i,s,o){this.r.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let l;try{await this.C(s,o)}catch(E){if(this.r.error(E),l=E,w.UserDataSyncError.toUserDataSyncError(E).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.C(s,o),l=void 0}catch(y){this.r.error(y),l=y}}this.f.fire(l)}async C(i,s){if(this.h=await this.n.createSyncTask(this.g,i),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.w()?await this.y()?new w.UserDataAutoSyncError((0,v.localize)(0,null),"DefaultServiceChanged"):new w.UserDataAutoSyncError((0,v.localize)(1,null),"ServiceChanged"):new w.UserDataAutoSyncError((0,v.localize)(2,null),"TurnedOff");const o=this.u.get(I,-1);if(o&&this.g&&o!==this.g.session)throw this.w()?await this.y()?new w.UserDataAutoSyncError((0,v.localize)(3,null),"DefaultServiceChanged"):new w.UserDataAutoSyncError((0,v.localize)(4,null),"ServiceChanged"):new w.UserDataAutoSyncError((0,v.localize)(5,null),"SessionExpired");const l=await this.p.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const E=l.find(c=>c.isCurrent);if(E?.disabled)throw new w.UserDataAutoSyncError((0,v.localize)(6,null),"TurnedOff");const y=new Date().getTime();if(await this.h.run(),this.s.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.m.manifest(null)}catch(c){throw new w.UserDataAutoSyncError((0,A.toErrorMessage)(c),c instanceof w.UserDataSyncError?c.code:"Unknown")}this.g&&this.g.session!==o&&this.u.store(I,this.g.session,-1,1),!s.isCancellationRequested&&(E||await this.p.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}r.a="Interval"}),define(oe[249],ae([0,1,12,170,14,13,44,19,29,23,17,39,118,117,116,18,119,114,115,4,120,41]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u,I,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=e.UserDataSyncResourceProviderService=class Ve{constructor(t,i,s,o,l,E,y,c,b,R){this.e=t,this.f=i,this.g=s,this.h=l,this.i=E,this.j=y,this.k=c,this.l=b,this.m=R,this.d=o.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const i=this.K(t.content,"profiles");return(0,p.parseUserDataProfilesManifest)(i)}return[]}async getRemoteSyncResourceHandles(t,i){return(await this.e.getAllResourceRefs(t,i?.collection)).map(({created:o,ref:l})=>({created:o,uri:this.I({remote:!0,syncResource:t,profile:i?.id??this.k.defaultProfile.id,collection:i?.collection,ref:l,node:void 0})}))}async getLocalSyncResourceHandles(t,i){return(await this.f.getAllRefs(i,t)).map(({created:o,ref:l})=>({created:o,uri:this.I({remote:!1,syncResource:t,profile:i.id,collection:void 0,ref:l,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const i=this.J(t),s=i?this.k.profiles.find(o=>o.id===i.profile):void 0;return i&&s?{profile:s,syncResource:i?.syncResource}:void 0}async getAssociatedResources({uri:t}){const i=this.J(t);if(!i)return[];const s=this.k.profiles.find(o=>o.id===i.profile);switch(i.syncResource){case"settings":return this.r(t,s);case"keybindings":return this.t(t,s);case"tasks":return this.v(t,s);case"snippets":return this.x(t,s);case"globalState":return this.C(t,s);case"extensions":return this.z(t,s);case"profiles":return this.F(t,s);case"workspaceState":return[]}}async getMachineId({uri:t}){const i=this.J(t);if(i){if(i.remote){if(i.ref){const{content:s}=await this.L(i.syncResource,i.ref,i.collection);if(s)return this.K(s,i.syncResource)?.machineId}return}return(0,T.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const i=this.J(t);if(!i||i.node===Ve.a)return null;if(i.ref){const s=await this.n(i.remote,i.syncResource,i.profile,i.collection,i.ref);return i.node&&s?this.o(i.syncResource,s,i.node):s}return!i.remote&&!i.node?this.q(i.syncResource,i.profile):null}async n(t,i,s,o,l){if(t){const{content:y}=await this.L(i,l,o);return y}const E=this.k.profiles.find(y=>y.id===s);return E?this.f.resolveContent(E,i,l):null}o(t,i,s){const o=this.K(i,t);switch(t){case"settings":return this.s(o,s);case"keybindings":return this.u(o,s);case"tasks":return this.w(o,s);case"snippets":return this.y(o,s);case"globalState":return this.D(o,s);case"extensions":return this.A(o,s);case"profiles":return this.G(o,s);case"workspaceState":return null}}async q(t,i){const s=this.k.profiles.find(o=>o.id===i);if(!s)return null;switch(t){case"globalState":return this.E(s);case"extensions":return this.B(s);case"profiles":return this.H(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}r(t,i){const s=this.d.joinPath(t,"settings.json"),o=i?i.settingsResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:o}]}s(t,i){switch(i){case"settings.json":return(0,f.parseSettingsSyncContent)(t.content).settings}return null}t(t,i){const s=this.d.joinPath(t,"keybindings.json"),o=i?i.keybindingsResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:o}]}u(t,i){switch(i){case"keybindings.json":return(0,d.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(m.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,i){const s=this.d.joinPath(t,"tasks.json"),o=i?i.tasksResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:o}]}w(t,i){switch(i){case"tasks.json":return(0,a.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,i){const s=await this.resolveContent(t);if(s){const o=this.K(s,"snippets");if(o){const l=(0,S.parseSnippets)(o),E=[];for(const y of Object.keys(l)){const c=this.d.joinPath(t,y),b=i?this.d.joinPath(i.snippetsHome,y):this.d.joinPath(t,Ve.a);E.push({resource:c,comparableResource:b})}return E}}return[]}y(t,i){return(0,S.parseSnippets)(t)[i]||null}z(t,i){const s=this.d.joinPath(t,"extensions.json"),o=i?this.I({remote:!1,syncResource:"extensions",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:o}]}A(t,i){switch(i){case"extensions.json":return(0,h.stringify)((0,h.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:i}=await this.m.createInstance(h.LocalExtensionsProvider).getLocalExtensions(t);return(0,h.stringify)(i,!0)}C(t,i){const s=this.d.joinPath(t,"globalState.json"),o=i?this.I({remote:!1,syncResource:"globalState",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:o}]}D(t,i){switch(i){case"globalState.json":return(0,u.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const i=await this.m.createInstance(u.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,u.stringify)(i,!0)}F(t,i){const s=this.d.joinPath(t,"profiles.json"),o=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:o}]}G(t,i){switch(i){case"profiles.json":return(0,L.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,p.stringifyLocalProfiles)(this.k.profiles.filter(i=>!i.isDefault&&!i.isTransient),!0)}I(t){const i=t.remote?Ve.b:Ve.c,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.d.joinPath(k.URI.from({scheme:m.USER_DATA_SYNC_SCHEME,authority:i,path:"/"}),...s)}J(t){if(t.scheme!==m.USER_DATA_SYNC_SCHEME||t.authority!==Ve.c&&t.authority!==Ve.b)return;const i=[];for(;t.path!=="/";)i.unshift(this.d.basename(t)),t=this.d.dirname(t);if(i.length<2)return;const s=t.authority===Ve.b,o=i.shift(),l=i.shift();let E,y,c;for(;i.length;){const b=i.shift();b.startsWith("collection:")?E=b.substring(11):b.startsWith("ref:")?y=b.substring(4):c=b}return{remote:s,syncResource:o,profile:l,collection:E,ref:y,node:c}}K(t,i){try{const s=JSON.parse(t);if((0,v.isSyncData)(s))return s}catch(s){this.g.error(s)}throw new m.UserDataSyncError((0,U.localize)(0,null),"IncompatibleRemoteContent",i)}async L(t,i,s){const o=await this.e.resolveResourceContent(t,i,s);return{ref:i,content:o}}};n.a="not-existing-resource",n.b="remote-backup",n.c="local-backup",e.UserDataSyncResourceProviderService=n=ve([X(0,m.IUserDataSyncStoreService),X(1,m.IUserDataSyncBackupStoreService),X(2,m.IUserDataSyncLogService),X(3,C.IUriIdentityService),X(4,A.IEnvironmentService),X(5,D.IStorageService),X(6,N.IFileService),X(7,P.IUserDataProfilesService),X(8,w.IConfigurationService),X(9,I.IInstantiationService)],n)}),define(oe[250],ae([0,1,21,6,26,38,3,2,22,10,32,18,28,4,19,20,17,114,115,116,117,118,119,120,23]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u,I,p,L,n,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const i="sync.lastSyncTime";let s=e.UserDataSyncService=class extends D.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(c,b,R,M,F,H,q,V,Q){super(),this.v=c,this.w=b,this.y=R,this.z=M,this.C=F,this.D=H,this.F=q,this.G=V,this.H=Q,this.f="uninitialized",this.g=this.B(new T.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new T.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new T.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new T.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new T.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new T.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=b.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(i,-1,void 0),this.B((0,D.toDisposable)(()=>this.W()))}async createSyncTask(c,b){this.X(),this.z.info("Sync started.");const R=new Date().getTime(),M=(0,P.generateUuid)();try{const V=(0,t.createSyncHeaders)(M);b&&(V["Cache-Control"]="no-cache"),c=await this.v.manifest(c,V)}catch(V){const Q=t.UserDataSyncError.toUserDataSyncError(V);throw E(Q,M,this.w,this.C),Q}const F=!1,H=this;let q;return{manifest:c,async run(){if(F)throw new Error("Can run a task only once");q=(0,U.createCancelablePromise)(V=>H.I(c,!1,M,V)),await q.finally(()=>q=void 0),H.z.info(`Sync done. Took ${new Date().getTime()-R}ms`),H.S()},stop(){return q?.cancel(),H.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const c=new Date().getTime(),b=(0,P.generateUuid)(),R=(0,t.createSyncHeaders)(b);let M;try{M=await this.v.manifest(null,R)}catch(q){const V=t.UserDataSyncError.toUserDataSyncError(q);throw E(V,b,this.w,this.C),V}await this.resetLocal();const F=this,H=new A.CancellationTokenSource;return{id:b,async merge(){return F.I(M,!0,b,H.token)},async apply(){try{try{await F.L(M,b,H.token)}catch(q){if(t.UserDataSyncError.toUserDataSyncError(q).code==="MethodNotFound")F.z.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.z.info("Applying manual sync again..."),await F.L(M,b,H.token);else throw q}}catch(q){throw F.z.error(q),q}F.z.info(`Sync done. Took ${new Date().getTime()-c}ms`),F.S()},async stop(){H.cancel(),await F.N(),await F.resetLocal()}}}async I(c,b,R,M){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(F,c,b,R,M));const H=F.enabled.find(q=>q.resource==="profiles");if(H){const q=await H.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.J(q,c,b,R,M)}}finally{this.l.fire(this.k)}}async J(c,b,R,M,F){for(const H of c){if(F.isCancellationRequested)return;const q=this.G.profiles.find(Q=>Q.id===H.id);if(!q){this.z.error(`Profile with id:${H.id} and name: ${H.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",H.name);const V=this.getOrCreateActiveProfileSynchronizer(q,H);this.k.push(...await this.M(V,b,R,M,F))}for(const[H,q]of this.u.entries())this.G.profiles.some(V=>V.id===q[0].profile.id)||(q[1].dispose(),this.u.delete(H))}async L(c,b,R){const M=this.U();for(const Q of M){if(R.isCancellationRequested)return;await Q.apply(b,R)}const F=M.find(Q=>Q.profile.isDefault);if(!F)return;const H=F.enabled.find(Q=>Q.resource==="profiles");if(!H)return;const V=(await H.getRemoteSyncedProfiles(c?.latest??null)||[]).filter(Q=>M.every(te=>te.profile.id!==Q.id));V.length&&await this.J(V,c,!1,b,R)}async M(c,b,R,M,F){return(await c.sync(b,R,M,F)).map(([q,V])=>({profile:c.profile,syncResource:q,error:V}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(c=>c.stop()))}async resolveContent(c){const b=await this.H.resolveContent(c);if(b)return b;for(const R of this.U())for(const M of R.enabled){const F=await M.resolveContent(c);if(F)return F}return null}async replace(c){this.X();const b=this.H.resolveUserDataSyncResource(c);if(!b)return;const R=await this.resolveContent(c.uri);R&&await this.O(b.profile,async M=>{if(b.syncResource===M.resource)return await M.replace(R),!0})}async accept(c,b,R,M){this.X(),await this.O(c.profile,async F=>{if(c.syncResource===F.resource)return await F.accept(b,R),M&&await F.apply((0,m.isBoolean)(M)?!1:M.force,(0,t.createSyncHeaders)((0,P.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(c,b){return this.H.getRemoteSyncResourceHandles(c,b)}async getLocalSyncResourceHandles(c,b){return this.H.getLocalSyncResourceHandles(c,b??this.G.defaultProfile)}async getAssociatedResources(c){return this.H.getAssociatedResources(c)}async getMachineId(c){return this.H.getMachineId(c)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async b=>{if(b.resource!=="globalState"&&await b.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async b=>{if(await b.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(c){this.z.error(c)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(i,-1);for(const[c]of this.u.values())try{await c.resetLocal()}catch(b){this.z.error(b)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const c=await this.H.getRemoteSyncedProfiles(),b=c.map(H=>H.collection),R=await this.v.getAllCollections(),M=R.filter(H=>!b.includes(H));M.length&&(this.z.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(H=>this.v.deleteCollection(H))),this.z.info("Deleted redundant collections on server"));const F=c.filter(H=>R.includes(H.collection));if(F.length!==c.length){this.z.info("Updating remote profiles with invalid collections on server");const H=this.y.createInstance(r.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await H.updateRemoteProfiles(F,null),this.z.info("Updated remote profiles on server")}finally{H.dispose()}}}async O(c,b){const R=new D.DisposableStore;try{const M=this.u.get(c.id);if(M){const Q=await this.P(M[0],b,R);return(0,m.isUndefined)(Q)?null:Q}if(c.isDefault){const Q=R.add(this.y.createInstance(o,c,void 0)),te=await this.P(Q,b,R);return(0,m.isUndefined)(te)?null:te}if(this.G.isEnabled())return null;const F=R.add(this.y.createInstance(r.UserDataProfilesManifestSynchroniser,c,void 0)),H=await this.v.manifest(null),V=(await F.getRemoteSyncedProfiles(H?.latest??null)||[]).find(Q=>Q.id===c.id);if(V){const Q=R.add(this.y.createInstance(o,c,V.collection)),te=await this.P(Q,b,R);return(0,m.isUndefined)(te)?null:te}return null}finally{R.dispose()}}async P(c,b,R){const M=[...c.enabled,...c.disabled.reduce((F,H)=>(H!=="workspaceState"&&F.push(R.add(c.createSynchronizer(H))),F),[])];for(const F of M){const H=await b(F);if(!(0,m.isUndefined)(H))return H}}Q(c){const b=this.f;this.f!==c&&(this.f=c,this.g.fire(c),b==="hasConflicts"&&this.S())}R(){const c=this.U().map(b=>b.conflicts).flat();(0,k.equals)(this.i,c,(b,R)=>b.profile.id===R.profile.id&&b.syncResource===R.syncResource&&(0,k.equals)(b.conflicts,R.conflicts,(M,F)=>(0,C.isEqual)(M.previewResource,F.previewResource)))||(this.i=c,this.j.fire(c))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(i,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(c,b){let R=this.u.get(c.id);if(R&&R[0].collection!==b?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),R[1].dispose(),R=void 0,this.u.delete(c.id)),!R){const M=new D.DisposableStore,F=M.add(this.y.createInstance(o,c,b?.collection));M.add(F.onDidChangeStatus(H=>this.Q(H))),M.add(F.onDidChangeConflicts(H=>this.R())),M.add(F.onDidChangeLocal(H=>this.h.fire(H))),this.u.set(c.id,R=[F,M])}return R[0]}U(){const c=[];for(const[b]of this.u.values())c.push(b);return c}W(){this.u.forEach(([,c])=>c.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=s=ve([X(0,t.IUserDataSyncStoreService),X(1,t.IUserDataSyncStoreManagementService),X(2,f.IInstantiationService),X(3,t.IUserDataSyncLogService),X(4,w.ITelemetryService),X(5,d.IStorageService),X(6,t.IUserDataSyncEnablementService),X(7,a.IUserDataProfilesService),X(8,t.IUserDataSyncResourceProviderService)],s);let o=class extends D.Disposable{get enabled(){return this.f.sort((c,b)=>c[1]-b[1]).map(([c])=>c)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(c=>!this.l.isResourceEnabled(c))}get status(){return this.g}get conflicts(){return this.j}constructor(c,b,R,M,F,H,q,V,Q,te){super(),this.profile=c,this.collection=b,this.l=R,this.m=M,this.n=F,this.r=H,this.t=q,this.u=V,this.v=Q,this.w=te,this.f=[],this.g="idle",this.h=this.B(new T.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new T.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new T.Emitter),this.onDidChangeConflicts=this.k.event,this.B(R.onDidChangeResourceEnablement(([Y,x])=>this.y(Y,x))),this.B((0,D.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,Y])=>Y.dispose())));for(const Y of t.ALL_SYNC_RESOURCES)R.isResourceEnabled(Y)&&this.z(Y)}y(c,b){b?this.z(c):this.C(c)}z(c){if(this.f.some(([F])=>F.resource===c))return;if(c==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(c==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled())||c==="workspaceState")return;const b=new D.DisposableStore,R=b.add(this.createSynchronizer(c));b.add(R.onDidChangeStatus(()=>this.G())),b.add(R.onDidChangeConflicts(()=>this.H())),b.add(R.onDidChangeLocal(()=>this.i.fire(c)));const M=this.I(c);this.f.push([R,M,b])}C(c){const b=this.f.findIndex(([R])=>R.resource===c);if(b!==-1){const[[R,,M]]=this.f.splice(b,1);M.dispose(),this.G(),Promise.allSettled([R.stop(),R.resetLocal()]).then(null,F=>this.u.error(F))}}createSynchronizer(c){switch(c){case"settings":return this.m.createInstance(p.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(I.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(L.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(u.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(h.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(r.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(c,b,R,M){if(M.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const H=[],q=(0,t.createSyncHeaders)(R),V=(this.collection?c?.collections?.[this.collection]?.latest:c?.latest)??null,Q=b?await this.D(V):{};for(const te of F){if(M.isCancellationRequested)return[];if(!this.l.isResourceEnabled(te.resource))return[];try{if(b){const Y=await te.preview(V,Q,q);if(Y)for(const x of Y.resourcePreviews)(x.localChange!==0||x.remoteChange!==0)&&x.mergeState==="preview"&&await te.merge(x.previewResource)}else await te.sync(V,q)}catch(Y){const x=t.UserDataSyncError.toUserDataSyncError(Y);if(E(x,R,this.r,this.t),l(Y))throw x;this.u.error(Y),this.u.error(`${te.resource}: ${(0,N.toErrorMessage)(Y)}`),H.push([te.resource,x])}}return H}finally{this.G()}}async apply(c,b){const R=(0,t.createSyncHeaders)(c);for(const M of this.enabled){if(b.isCancellationRequested)return;try{await M.apply(!1,R)}catch(F){const H=t.UserDataSyncError.toUserDataSyncError(F);if(E(H,c,this.r,this.t),l(F))throw H;this.u.error(F),this.u.error(`${M.resource}: ${(0,N.toErrorMessage)(F)}`)}}}async stop(){for(const c of this.enabled)try{c.status!=="idle"&&await c.stop()}catch(b){this.u.error(b)}}async resetLocal(){for(const c of this.enabled)try{await c.resetLocal()}catch(b){this.u.error(`${c.resource}: ${(0,N.toErrorMessage)(b)}`),this.u.error(b)}}async D(c){if(!this.profile.isDefault)return{};const b=this.w.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),R=this.enabled.find(M=>M instanceof p.SettingsSynchroniser);if(R){const M=await R.getRemoteUserDataSyncConfiguration(c);return{...b,...M}}return b}F(c){this.g!==c&&(this.g=c,this.h.fire(c))}G(){return this.H(),this.enabled.some(c=>c.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(c=>c.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const c=this.enabled.filter(b=>b.status==="hasConflicts").filter(b=>b.conflicts.conflicts.length>0).map(b=>b.conflicts);(0,k.equals)(this.j,c,(b,R)=>b.syncResource===R.syncResource&&(0,k.equals)(b.conflicts,R.conflicts,(M,F)=>(0,C.isEqual)(M.previewResource,F.previewResource)))||(this.j=c,this.k.fire(c))}I(c){switch(c){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=ve([X(2,t.IUserDataSyncEnablementService),X(3,f.IInstantiationService),X(4,S.IExtensionGalleryService),X(5,t.IUserDataSyncStoreManagementService),X(6,w.ITelemetryService),X(7,t.IUserDataSyncLogService),X(8,a.IUserDataProfilesService),X(9,v.IConfigurationService)],o);function l(y){if(y instanceof t.UserDataSyncError)switch(y.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function E(y,c,b,R){R.publicLog2("sync/error",{code:y.code,serverCode:y instanceof t.UserDataSyncStoreError?String(y.serverCode):void 0,url:y instanceof t.UserDataSyncStoreError?y.url:void 0,resource:y.resource,executionId:c,service:b.userDataSyncStore.url.toString()})}}),define(oe[251],ae([0,1,3,2,12,17,23]),function(ne,e,k,U,A,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function D(S,f){return{...S,profile:(0,N.reviveProfile)(S.profile,f.profilesHome.scheme)}}function C(S){return{created:S.created,uri:A.URI.revive(S.uri)}}class m{constructor(f,d,w){this.c=f,this.d=d,this.f=w,this.a=new Map,this.b=new k.Emitter}listen(f,d){switch(d){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${d}`)}async call(f,d,w){try{return await this.g(f,d,w)}catch(a){throw this.f.error(a),a}}async g(f,d,w){switch(d){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(A.URI.revive(w[0]));case"accept":return this.c.accept(D(w[0],this.d),A.URI.revive(w[1]),w[2],w[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(w[0],w[1]?(0,N.reviveProfile)(w[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(w[0],w[1]);case"replace":return this.c.replace(C(w[0]));case"getAssociatedResources":return this.c.getAssociatedResources(C(w[0]));case"getMachineId":return this.c.getMachineId(C(w[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(d.startsWith("manualSync/")){const a=d.substring(11),h=w[0],u=this.h(h);switch(w=w.slice(1),a){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(f){const d=this.a.get(this.j(f));if(!d)throw new Error(`Manual sync taks not found: ${f}`);return d}async i(){const f=await this.c.createManualSyncTask();return this.a.set(this.j(f.id),f),f.id}j(f){return`manualSyncTask-${f}`}}e.UserDataSyncChannel=m;let P=e.UserDataSyncChannelClient=class extends U.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(f,d){super(),this.k=d,this.b="uninitialized",this.c=this.B(new k.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new k.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new k.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new k.Emitter),this.onSyncErrors=this.j.event,this.a={call(w,a,h){return f.call(w,a,h).then(null,u=>{throw T.UserDataSyncError.toUserDataSyncError(u)})},listen(w,a){return f.listen(w,a)}},this.a.call("_getInitialData").then(([w,a,h])=>{this.l(w),this.m(a),h&&this.n(h),this.B(this.a.listen("onDidChangeStatus")(u=>this.l(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.n(u)))}),this.B(this.a.listen("onDidChangeConflicts")(w=>this.m(w))),this.B(this.a.listen("onSyncErrors")(w=>this.j.fire(w.map(a=>({...a,error:T.UserDataSyncError.toUserDataSyncError(a.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.a.call("createManualSyncTask"),d=this;return new v(f,{async call(a,h,u){return d.a.call(`manualSync/${a}`,[f,...Array.isArray(h)?h:[h]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(f,d,w,a){return this.a.call("accept",[f,d,w,a])}resolveContent(f){return this.a.call("resolveContent",[f])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(f,d){return(await this.a.call("getLocalSyncResourceHandles",[f,d])).map(({created:a,uri:h})=>({created:a,uri:A.URI.revive(h)}))}async getRemoteSyncResourceHandles(f,d){return(await this.a.call("getRemoteSyncResourceHandles",[f,d])).map(({created:a,uri:h})=>({created:a,uri:A.URI.revive(h)}))}async getAssociatedResources(f){return(await this.a.call("getAssociatedResources",[f])).map(({resource:w,comparableResource:a})=>({resource:A.URI.revive(w),comparableResource:A.URI.revive(a)}))}getMachineId(f){return this.a.call("getMachineId",[f])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(f){return this.a.call("replace",[f])}async l(f){this.b=f,this.c.fire(f)}async m(f){this.f=f.map(d=>({syncResource:d.syncResource,profile:(0,N.reviveProfile)(d.profile,this.k.profilesHome.scheme),conflicts:d.conflicts.map(w=>({...w,baseResource:A.URI.revive(w.baseResource),localResource:A.URI.revive(w.localResource),remoteResource:A.URI.revive(w.remoteResource),previewResource:A.URI.revive(w.previewResource)}))})),this.g.fire(this.f)}n(f){this.h!==f&&(this.h=f,this.i.fire(f))}};e.UserDataSyncChannelClient=P=ve([X(1,N.IUserDataProfilesService)],P);class v extends U.Disposable{constructor(f,d){super(),this.id=f,this.a=d}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[252],ae([0,1,6,26,7,3,2,133,5,22,10,12,32,18,14,13,24,56,44,19,23]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const L="sync.previous.store",n="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",i=100,s=1e3*60*5;let o=e.AbstractUserDataSyncStoreManagementService=class extends T.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(p.SYNC_SERVICE_URL_TYPE,-1)}set c(R){this.h.store(p.SYNC_SERVICE_URL_TYPE,R,-1,C.isWeb?0:1)}constructor(R,M,F){super(),this.f=R,this.g=M,this.h=F,this.a=this.B(new N.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(N.Event.filter(F.onDidChangeValue,H=>H.key===p.SYNC_SERVICE_URL_TYPE&&H.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[p.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(p.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(R,M){R=C.isWeb&&R?.web?{...R,...R.web}:R;const F={...R||{},...M||{}};if(F&&(0,P.isString)(F.url)&&(0,P.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(H=>Array.isArray(F.authenticationProviders[H].scopes))){const H=F,q=!!H.canSwitch&&!M?.url,V=H.url===H.insidersUrl?"insiders":"stable",Q=(q?this.c:void 0)||V,te=M?.url||(Q==="insiders"?H.insidersUrl:Q==="stable"?H.stableUrl:H.url);return{url:v.URI.parse(te),type:Q,defaultType:V,defaultUrl:v.URI.parse(H.url),stableUrl:v.URI.parse(H.stableUrl),insidersUrl:v.URI.parse(H.insidersUrl),canSwitch:q,authenticationProviders:Object.keys(H.authenticationProviders).reduce((Y,x)=>(Y.push({id:x,scopes:H.authenticationProviders[x].scopes}),Y),[])}}}};e.AbstractUserDataSyncStoreManagementService=o=ve([X(0,a.IProductService),X(1,f.IConfigurationService),X(2,I.IStorageService)],o);let l=e.UserDataSyncStoreManagementService=class extends o{constructor(R,M,F){super(R,M,F);const H=this.h.get(L,-1);H&&(this.k=JSON.parse(H));const q=this.f[p.CONFIGURATION_SYNC_STORE_KEY];q?this.h.store(L,JSON.stringify(q),-1,1):this.h.remove(L,-1)}async switch(R){R!==this.c&&(this.c=R,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};e.UserDataSyncStoreManagementService=l=ve([X(0,a.IProductService),X(1,f.IConfigurationService),X(2,I.IStorageService)],l);let E=e.UserDataSyncStoreClient=class extends T.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(R,M,F,H,q,V,Q){super(),this.k=F,this.l=H,this.m=Q,this.g=this.B(new N.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new N.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new N.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.r=void 0,this.n(R),this.c=(0,u.getServiceMachineId)(q,V,Q).then(te=>{const Y={"X-Client-Name":`${M.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(Y["X-Client-Commit"]=M.commit),Y}),this.f=new c(i,s,this.k,this.l),this.p(),this.B((0,T.toDisposable)(()=>{this.r&&(this.r.cancel(),this.r=void 0)}))}setAuthToken(R,M){this.b={token:R,type:M}}n(R){this.a=R?(0,m.joinPath)(R,"v1"):void 0}p(){const R=this.m.getNumber(n,-1);R&&Date.now()<R&&this.s(new Date(R))}s(R){this.i?.getTime()!==R?.getTime()&&(this.i=R,this.r&&(this.r.cancel(),this.r=void 0),this.i?(this.m.store(n,this.i.getTime(),-1,1),this.r=(0,k.createCancelablePromise)(M=>(0,k.timeout)(this.i.getTime()-Date.now(),M).then(()=>this.s(void 0))),this.r.then(null,M=>null)):this.m.remove(n,-1),this.j.fire())}async getAllCollections(R={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,m.joinPath)(this.a,"collection").toString();R={...R},R["Content-Type"]="application/json";const F=await this.v(M,{type:"GET",headers:R},[],U.CancellationToken.None);return(await(0,h.asJson)(F))?.map(({id:H})=>H)||[]}async createCollection(R={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,m.joinPath)(this.a,"collection").toString();R={...R},R["Content-Type"]=D.Mimes.text;const F=await this.v(M,{type:"POST",headers:R},[],U.CancellationToken.None),H=await(0,h.asTextOrError)(F);if(!H)throw new p.UserDataSyncStoreError("Server did not return the collection id",M,"NoCollection",F.res.statusCode,F.res.headers[p.HEADER_OPERATION_ID]);return H}async deleteCollection(R,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=R?(0,m.joinPath)(this.a,"collection",R).toString():(0,m.joinPath)(this.a,"collection").toString();M={...M},await this.v(F,{type:"DELETE",headers:M},[],U.CancellationToken.None)}async getAllResourceRefs(R,M){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.t(this.a,M,R),H={},q=await this.v(F.toString(),{type:"GET",headers:H},[],U.CancellationToken.None);return(await(0,h.asJson)(q)||[]).map(({url:Q,created:te})=>({ref:(0,m.relativePath)(F,F.with({path:Q})),created:te*1e3}))}async resolveResourceContent(R,M,F,H={}){if(!this.a)throw new Error("No settings sync store url configured.");const q=(0,m.joinPath)(this.t(this.a,F,R),M).toString();H={...H},H["Cache-Control"]="no-cache";const V=await this.v(q,{type:"GET",headers:H},[],U.CancellationToken.None);return await(0,h.asTextOrError)(V)}async deleteResource(R,M,F){if(!this.a)throw new Error("No settings sync store url configured.");const H=M!==null?(0,m.joinPath)(this.t(this.a,F,R),M).toString():this.t(this.a,F,R).toString(),q={};await this.v(H,{type:"DELETE",headers:q},[],U.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const R=(0,m.joinPath)(this.a,"resource").toString(),M={"Content-Type":D.Mimes.text};await this.v(R,{type:"DELETE",headers:M},[],U.CancellationToken.None)}async readResource(R,M,F,H={}){if(!this.a)throw new Error("No settings sync store url configured.");const q=(0,m.joinPath)(this.t(this.a,F,R),"latest").toString();H={...H},H["Cache-Control"]="no-cache",M&&(H["If-None-Match"]=M.ref);const V=await this.v(q,{type:"GET",headers:H},[304],U.CancellationToken.None);let Q=null;if(V.res.statusCode===304&&(Q=M),Q===null){const te=V.res.headers.etag;if(!te)throw new p.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",V.res.statusCode,V.res.headers[p.HEADER_OPERATION_ID]);const Y=await(0,h.asTextOrError)(V);if(!Y&&V.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",q,"EmptyResponse",V.res.statusCode,V.res.headers[p.HEADER_OPERATION_ID]);Q={ref:te,content:Y}}return Q}async writeResource(R,M,F,H,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=this.t(this.a,H,R).toString();q={...q},q["Content-Type"]=D.Mimes.text,F&&(q["If-Match"]=F);const Q=await this.v(V,{type:"POST",data:M,headers:q},[],U.CancellationToken.None),te=Q.res.headers.etag;if(!te)throw new p.UserDataSyncStoreError("Server did not return the ref",V,"NoRef",Q.res.statusCode,Q.res.headers[p.HEADER_OPERATION_ID]);return te}async manifest(R,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,m.joinPath)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",R&&(M["If-None-Match"]=R.ref);const H=await this.v(F,{type:"GET",headers:M},[304],U.CancellationToken.None);let q=null;if(H.res.statusCode===304&&(q=R),!q){const Q=H.res.headers.etag;if(!Q)throw new p.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",H.res.statusCode,H.res.headers[p.HEADER_OPERATION_ID]);const te=await(0,h.asTextOrError)(H);if(!te&&H.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",F,"EmptyResponse",H.res.statusCode,H.res.headers[p.HEADER_OPERATION_ID]);te&&(q={...JSON.parse(te),ref:Q})}const V=this.m.get(r,-1);return V&&q&&V!==q.session&&this.u(),q===null&&V&&this.u(),q&&this.m.store(r,q.session,-1,1),q}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.u()}t(R,M,F){return M?(0,m.joinPath)(R,"collection",M,"resource",F):(0,m.joinPath)(R,"resource",F)}u(){this.m.remove(r,-1),this.m.remove(t,-1)}async v(R,M,F,H){if(!this.b)throw new p.UserDataSyncStoreError("No Auth Token Available",R,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new p.UserDataSyncStoreError(`${M.type} request '${R}' failed because of too many requests (429).`,R,"TooManyRequestsAndRetryAfter",void 0,void 0);this.s(void 0);const q=await this.c;M.headers={...M.headers||{},...q,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.w(M.headers),this.l.trace("Sending request to server",{url:R,type:M.type,headers:{...M.headers,authorization:void 0}});let V;try{V=await this.f.request(R,M,H)}catch(G){if(!(G instanceof p.UserDataSyncStoreError)){let j="RequestFailed";const Z=(0,A.getErrorMessage)(G).toLowerCase();Z.includes("xhr timeout")?j="RequestTimeout":Z.includes("protocol")&&Z.includes("not supported")?j="RequestProtocolNotSupported":Z.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":Z.includes("headers must be an object")?j="RequestHeadersNotObject":(0,A.isCancellationError)(G)&&(j="RequestCanceled"),G=new p.UserDataSyncStoreError(`Connection refused for the request '${R}'.`,R,j,void 0,void 0)}throw this.l.info("Request failed",R),G}const Q=V.res.headers[p.HEADER_OPERATION_ID],te={url:R,status:V.res.statusCode,"execution-id":M.headers[p.HEADER_EXECUTION_ID],"operation-id":Q},Y=(0,h.isSuccess)(V)||V.res.statusCode&&F.includes(V.res.statusCode);let x="";if(Y?this.l.trace("Request succeeded",te):(this.l.info("Request failed",te),x=await(0,h.asText)(V)||""),V.res.statusCode===401||V.res.statusCode===403){if(this.b=void 0,V.res.statusCode===401)throw this.g.fire("Unauthorized"),new p.UserDataSyncStoreError(`${M.type} request '${R}' failed because of Unauthorized (401).`,R,"Unauthorized",V.res.statusCode,Q);if(V.res.statusCode===403)throw this.g.fire("Forbidden"),new p.UserDataSyncStoreError(`${M.type} request '${R}' failed because the access is forbidden (403).`,R,"Forbidden",V.res.statusCode,Q)}if(this.h.fire(),V.res.statusCode===404)throw new p.UserDataSyncStoreError(`${M.type} request '${R}' failed because the requested resource is not found (404).`,R,"NotFound",V.res.statusCode,Q);if(V.res.statusCode===405)throw new p.UserDataSyncStoreError(`${M.type} request '${R}' failed because the requested endpoint is not found (405). ${x}`,R,"MethodNotFound",V.res.statusCode,Q);if(V.res.statusCode===409)throw new p.UserDataSyncStoreError(`${M.type} request '${R}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,R,"Conflict",V.res.statusCode,Q);if(V.res.statusCode===410)throw new p.UserDataSyncStoreError(`${M.type} request '${R}' failed because the requested resource is not longer available (410).`,R,"Gone",V.res.statusCode,Q);if(V.res.statusCode===412)throw new p.UserDataSyncStoreError(`${M.type} request '${R}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,R,"PreconditionFailed",V.res.statusCode,Q);if(V.res.statusCode===413)throw new p.UserDataSyncStoreError(`${M.type} request '${R}' failed because of too large payload (413).`,R,"TooLarge",V.res.statusCode,Q);if(V.res.statusCode===426)throw new p.UserDataSyncStoreError(`${M.type} request '${R}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,R,"UpgradeRequired",V.res.statusCode,Q);if(V.res.statusCode===429){const G=V.res.headers["retry-after"];throw G?(this.s(new Date(Date.now()+parseInt(G)*1e3)),new p.UserDataSyncStoreError(`${M.type} request '${R}' failed because of too many requests (429).`,R,"TooManyRequestsAndRetryAfter",V.res.statusCode,Q)):new p.UserDataSyncStoreError(`${M.type} request '${R}' failed because of too many requests (429).`,R,"RemoteTooManyRequests",V.res.statusCode,Q)}if(!Y)throw new p.UserDataSyncStoreError("Server returned "+V.res.statusCode,R,"Unknown",V.res.statusCode,Q);return V}w(R){let M=this.m.get(t,-1);M===void 0&&(M=(0,S.generateUuid)(),this.m.store(t,M,-1,1)),R["X-Machine-Session-Id"]=M;const F=this.m.get(r,-1);F!==void 0&&(R["X-User-Session-Id"]=F)}};e.UserDataSyncStoreClient=E=ve([X(1,a.IProductService),X(2,h.IRequestService),X(3,p.IUserDataSyncLogService),X(4,d.IEnvironmentService),X(5,w.IFileService),X(6,I.IStorageService)],E);let y=e.UserDataSyncStoreService=class extends E{constructor(R,M,F,H,q,V,Q){super(R.userDataSyncStore?.url,M,F,H,q,V,Q),this.B(R.onDidChangeUserDataSyncStore(()=>this.n(R.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=y=ve([X(0,p.IUserDataSyncStoreManagementService),X(1,a.IProductService),X(2,h.IRequestService),X(3,p.IUserDataSyncLogService),X(4,d.IEnvironmentService),X(5,w.IFileService),X(6,I.IStorageService)],y);class c{constructor(R,M,F,H){this.c=R,this.d=M,this.f=F,this.g=H,this.a=[],this.b=void 0}request(R,M,F){if(this.h()&&this.i(),M.url=R,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new p.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,R,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(R),this.f.request(M,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=c}),define(oe[253],ae([0,1,3,54,24,19,20,248,23,77,80]),function(ne,e,k,U,A,N,T,D,C,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let v=e.UserDataAutoSyncService=class extends D.UserDataAutoSyncService{constructor(f,d,w,a,h,u,I,p,L,n,r){super(f,d,w,a,h,I,p,L,n,r),this.B(k.Event.debounce(k.Event.any(k.Event.map(u.onDidFocusWindow,()=>"windowFocus"),k.Event.map(u.onDidOpenWindow,()=>"windowOpen")),(t,i)=>t?[...t,i]:[i],1e3)(t=>this.triggerSync(t,!0,!1)))}};e.UserDataAutoSyncService=v=ve([X(0,A.IProductService),X(1,C.IUserDataSyncStoreManagementService),X(2,C.IUserDataSyncStoreService),X(3,C.IUserDataSyncEnablementService),X(4,C.IUserDataSyncService),X(5,U.INativeHostService),X(6,C.IUserDataSyncLogService),X(7,m.IUserDataSyncAccountService),X(8,T.ITelemetryService),X(9,P.IUserDataSyncMachinesService),X(10,N.IStorageService)],v)}),define(oe[254],ae([0,1,69,25,5,22]),function(ne,e,k,U,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(m){function P(){let v=m.scheme===U.Schemas.file?(0,N.originalFSPath)(m):m.toString();return A.isLinux||(v=v.toLowerCase()),(0,k.createHash)("md5").update(v).digest("hex")}return{id:P(),configPath:m}}e.getWorkspaceIdentifier=T;function D(m,P){function v(){if(m.scheme!==U.Schemas.file)return(0,k.createHash)("md5").update(m.toString()).digest("hex");if(!P)return;let f;return A.isLinux?f=P.ino:A.isMacintosh?f=P.birthtime.getTime():A.isWindows&&(typeof P.birthtimeMs=="number"?f=Math.floor(P.birthtimeMs):f=P.birthtime.getTime()),(0,k.createHash)("md5").update(m.fsPath).update(f?String(f):"").digest("hex")}const S=v();if(typeof S=="string")return{id:S,uri:m}}e.getSingleFolderWorkspaceIdentifier=D;function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=C}),define(oe[255],ae([0,1,6,7,2,15,30,14,8,75,112,254,54,71]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let d=e.UnusedWorkspaceStorageDataCleaner=class extends A.Disposable{constructor(a,h,u,I){super(),this.a=a,this.b=h,this.c=u,this.f=I,this.B(new k.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const a=await T.Promises.readdir(this.a.workspaceStorageHome.fsPath),h=new m.StorageClient(this.f.getChannel("storage"));await Promise.all(a.map(async u=>{const I=(0,N.join)(this.a.workspaceStorageHome.fsPath,u);u.length===v.NON_EMPTY_WORKSPACE_ID_LENGTH||u===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(n=>n.workspace?.id===u)||await h.isUsed(I)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${u} as it seems to be an unused empty workspace.`),await T.Promises.rm(I))}))}catch(a){(0,U.onUnexpectedError)(a)}}};e.UnusedWorkspaceStorageDataCleaner=d=ve([X(0,D.INativeEnvironmentService),X(1,C.ILogService),X(2,S.INativeHostService),X(3,f.IMainProcessService)],d)}),define(oe[81],ae([0,1,51,6,15,10,30,141,265,266]),function(ne,e,k,U,A,N,T,D,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const P=new RegExp(e.CorruptZipMessage);class v extends Error{constructor(r,t){let i=t.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=r,this.cause=t}}e.ExtractError=v;function S(n){const r=n.externalFileAttributes>>16||33188;return[448,56,7].map(t=>r&t).reduce((t,i)=>t+i,r&61440)}function f(n){if(n instanceof v)return n;let r;return P.test(n.message)&&(r="CorruptZip"),new v(r,n)}function d(n,r,t,i,s,o){const l=A.dirname(r),E=A.join(i,l);if(!E.startsWith(i))return Promise.reject(new Error(D.localize(0,null,r)));const y=A.join(i,r);let c;return o.onCancellationRequested(()=>{c?.destroy()}),Promise.resolve(T.Promises.mkdir(E,{recursive:!0})).then(()=>new Promise((b,R)=>{if(!o.isCancellationRequested)try{c=(0,k.createWriteStream)(y,{mode:t}),c.once("close",()=>b()),c.once("error",R),n.once("error",R),n.pipe(c)}catch(M){R(M)}}))}function w(n,r,t,i){let s=(0,U.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{s.cancel(),n.close()}),new Promise((l,E)=>{const y=new U.Sequencer,c=b=>{b.isCancellationRequested||(o++,n.readEntry())};n.once("error",E),n.once("close",()=>s.then(()=>{i.isCancellationRequested||n.entryCount===o?l():E(new v("Incomplete",new Error(D.localize(1,null,o,n.entryCount))))},E)),n.readEntry(),n.on("entry",b=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(b.fileName)){c(i);return}const R=b.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(R)){const H=A.join(r,R);s=(0,U.createCancelablePromise)(q=>T.Promises.mkdir(H,{recursive:!0}).then(()=>c(q)).then(void 0,E));return}const M=h(n,b),F=S(b);s=(0,U.createCancelablePromise)(H=>y.queue(()=>M.then(q=>d(q,R,F,r,t,H).then(()=>c(H)))).then(null,E))})})}function a(n,r=!1){return new Promise((t,i)=>{(0,C.open)(n,r?{lazyEntries:!0}:void 0,(s,o)=>{s?i(f(s)):t((0,N.assertIsDefined)(o))})})}function h(n,r){return new Promise((t,i)=>{n.openReadStream(r,(s,o)=>{s?i(f(s)):t((0,N.assertIsDefined)(o))})})}function u(n,r){return new Promise((t,i)=>{const s=new m.ZipFile;r.forEach(l=>{l.contents?s.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&s.addFile(l.localPath,l.path)}),s.end();const o=(0,k.createWriteStream)(n);s.outputStream.pipe(o),s.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>t(n))})}e.zip=u;function I(n,r,t={},i){const s=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let o=a(n,!0);return t.overwrite&&(o=o.then(l=>T.Promises.rm(r).then(()=>l))),o.then(l=>w(l,r,{sourcePathRegex:s},i))}e.extract=I;function p(n,r){return a(n).then(t=>new Promise((i,s)=>{t.on("entry",o=>{o.fileName===r&&h(t,o).then(l=>i(l),l=>s(l))}),t.once("close",()=>s(new Error(D.localize(2,null,r))))}))}function L(n,r){return p(n,r).then(t=>new Promise((i,s)=>{const o=[];t.once("error",s),t.on("data",l=>o.push(l)),t.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=L}),define(oe[256],ae([0,1,6,7,2,25,5,22,52,10,32,30,81,18,14,28,33,97,13,8]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=e.ExtensionsDownloader=class gt extends A.Disposable{constructor(n,r,t,i,s,o){super(),this.h=r,this.i=t,this.j=i,this.k=s,this.l=o,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(n,r,t){await this.g;const i=(0,D.joinPath)(this.extensionsDownloadDir,this.v(n));try{await this.r(n,i,o=>this.i.download(n,o,r))}catch(o){throw new w.ExtensionManagementError(o.message,w.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.m(n)){const o=await this.n(n);try{s=await this.k.verify(i.fsPath,o.fsPath,this.l.getLevel()===I.LogLevel.Trace)}catch(l){const E=l;if(s=E.code,E.output&&this.l.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${E.output}`),s===w.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===w.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new w.ExtensionManagementError(S.CorruptZipMessage,w.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(l){this.l.error(l)}}}return s===!0?this.l.info(`Extension signature is verified: ${n.identifier.id}`):s===!1?this.l.info(`Extension signature verification is not done: ${n.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${s}': ${n.identifier.id}`),{location:i,verificationStatus:s}}m(n){if(!n.isSigned)return!1;const r=this.j.getValue("extensions.verifySignature");return(0,m.isBoolean)(r)?r:!0}async n(n){await this.g;const r=(0,D.joinPath)(this.extensionsDownloadDir,`${this.v(n)}${gt.c}`);return await this.r(n,r,t=>this.i.downloadSignatureArchive(n,t)),r}async r(n,r,t){if(await this.h.exists(r))return;if(r.scheme!==N.Schemas.file){await t(r);return}const i=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.h.exists(i)||await t(i);try{await this.t(i,r,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(i)}catch{}if(s.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,r.path);else throw this.l.info(`Rename failed because of ${(0,U.getErrorMessage)(s)}. Deleted the file from downloaded location`,i.path),s}}async delete(n){await this.g,await this.h.del(n)}async t(n,r,t){try{await v.Promises.rename(n.fsPath,r.fsPath)}catch(i){if(T.isWindows&&i&&i.code==="EPERM"&&Date.now()<t)return this.l.info(`Failed renaming ${n} to ${r} with 'EPERM' error. Trying again...`),this.t(n,r,t);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const r=[],t=[],i=[];for(const l of n.children)if(l.name.endsWith(gt.c))i.push(l.resource);else{const E=a.ExtensionKey.parse(l.name);E&&t.push([E,l])}const s=(0,a.groupByExtension)(t,([l])=>l),o=[];for(const l of s)l.sort((E,y)=>C.rcompare(E[0].version,y[0].version)),r.push(...l.slice(1).map(E=>E[1].resource)),o.push(l[0][1]);o.sort((l,E)=>l.mtime-E.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),r.push(...i),await k.Promises.settled(r.map(l=>(this.l.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(n){this.l.error(n)}}v(n){return this.f?a.ExtensionKey.create(n).toString().toLowerCase():(0,P.generateUuid)()}};p.c=".sigzip",e.ExtensionsDownloader=p=ve([X(0,d.INativeEnvironmentService),X(1,u.IFileService),X(2,w.IExtensionGalleryService),X(3,f.IConfigurationService),X(4,h.IExtensionSignatureVerificationService),X(5,I.ILogService)],p)}),define(oe[257],ae([0,1,81,150]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function A(N){return(0,k.buffer)(N,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,U.localize)(0,null))}})}e.getManifest=A}),define(oe[121],ae([0,1,6,16,26,38,7,3,2,35,25,15,5,22,52,10,12,32,30,81,149,96,14,236,28,33,50,78,256,237,257,205,216,67,13,4,8,24,20,29,17]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u,I,p,L,n,r,t,i,s,o,l,E,y,c,b,R,M,F,H,q,V,Q,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,F.refineServiceDecorator)(t.IExtensionManagementService);let Y=e.ExtensionManagementService=class extends r.AbstractExtensionManagementService{constructor(K,_,$,g,O,B,W,z,J,ee,ce,ue){super(K,_,$,ee,ue),this.Z=O,this.ab=B,this.bb=W,this.cb=J,this.db=ce,this.X=this.B(new D.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new m.ResourceSet;const de=this.B(z.createInstance(E.ExtensionsLifecycle));this.S=this.B(z.createInstance(x,we=>de.postUninstall(we))),this.U=this.B(new c.ExtensionsManifestCache(ue,J,ce,this,this.v)),this.W=this.B(z.createInstance(l.ExtensionsDownloader));const Se=this.B(new b.ExtensionsWatcher(this,this.Z,ue,B,ce,J,$));this.B(Se.onDidChangeExtensionsByAnotherSource(we=>this.kb(we))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(K){this.v.trace("ExtensionManagementService#zip",K.identifier.id);const _=await this.jb(K),$=await(0,I.zip)((0,f.joinPath)(this.W.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,_);return a.URI.file($)}async unzip(K){return this.v.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:_,cleanup:$}=await this.fb(K),g=v.resolve(_.fsPath);try{return await(0,y.getManifest)(g)}finally{await $()}}getInstalled(K,_=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(K??null,_)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.S.scanUserExtensionAtLocation(K)}async install(K,_={}){this.v.trace("ExtensionManagementService#install",K.toString());const{location:$,cleanup:g}=await this.fb(K);try{const O=await(0,y.getManifest)(v.resolve($.fsPath));if(O.engines&&O.engines.vscode&&!(0,R.isEngineValid)(O.engines.vscode,this.w.version,this.w.date))throw new Error(p.localize(0,null,(0,i.getGalleryExtensionId)(O.publisher,O.name),this.w.version));return await this.z(O,$,_)}finally{await g()}}async installFromLocation(K,_){this.v.trace("ExtensionManagementService#installFromLocation",K.toString());const $=await this.S.scanUserExtensionAtLocation(K);if(!$)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.ob([[$,void 0]],_),this.v.info("Successfully installed extension",$.identifier.id,_.toString()),$}async installExtensionsFromProfile(K,_,$){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",K,_.toString(),$.toString());const g=(await this.S.scanExtensions(1,_)).filter(O=>K.some(B=>(0,i.areSameExtensions)(B,O.identifier)));if(g.length){const O=await Promise.all(g.map(B=>this.S.scanMetadata(B,_)));await this.ob(g.map((B,W)=>[B,O[W]]),$),this.v.info("Successfully installed extensions",g.map(B=>B.identifier.id),$.toString())}return g}async updateMetadata(K,_,$=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",K.identifier.id),_.isPreReleaseVersion&&(_.preRelease=!0),_.isMachineScoped=_.isMachineScoped||void 0,_.isBuiltin=_.isBuiltin||void 0,_.pinned=_.pinned||void 0,K=await this.S.updateMetadata(K,_,$),this.U.invalidate($),this.X.fire(K),K}async reinstallFromGallery(K){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.t.isEnabled())throw new Error(p.localize(1,null));const _=await this.getTargetPlatform(),[$]=await this.t.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:_,compatible:!0},A.CancellationToken.None);if(!$)throw new Error(p.localize(2,null));await this.S.setUninstalled(K);try{await this.S.removeUninstalledExtension(K)}catch(g){throw new Error(p.localize(3,null,(0,N.toErrorMessage)(g)))}return this.installFromGallery($)}copyExtensions(K,_){return this.S.copyExtensions(K,_)}markAsUninstalled(...K){return this.S.setUninstalled(...K)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(K){this.v.error(K)}}async download(K,_,$){const{location:g}=await this.W.download(K,_,!$);return g}async fb(K){if(K.scheme===P.Schemas.file)return{location:K,async cleanup(){}};this.v.trace("Downloading extension from",K.toString());const _=(0,f.joinPath)(this.W.extensionsDownloadDir,(0,h.generateUuid)());return await this.bb.download(K,_),this.v.info("Downloaded extension to",_.toString()),{location:_,cleanup:async()=>{try{await this.cb.del(_)}catch(g){this.v.error(g)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(K,_,$){if(a.URI.isUri(_))return new Z(K,_,$,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const g=i.ExtensionKey.create(_).toString();let O=this.Y.get(g);return O||(this.Y.set(g,O=new j(K,_,$,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),O.waitUntilTaskIsFinished().finally(()=>this.Y.delete(g))),O}R(K,_){return new ie(K,_.profileLocation,this.ab)}async jb(K){const _=async g=>{let O=await u.Promises.readdir(g);O=O.map(z=>v.join(g,z));const B=await Promise.all(O.map(z=>u.Promises.stat(z)));let W=Promise.resolve([]);return B.forEach((z,J)=>{const ee=O[J];z.isFile()&&(W=W.then(ce=>[...ce,ee])),z.isDirectory()&&(W=W.then(ce=>_(ee).then(ue=>[...ce,...ue])))}),W};return(await _(K.location.fsPath)).map(g=>({path:`extension/${v.relative(K.location.fsPath,g)}`,localPath:g}))}async kb({added:K,removed:_}){if(_)for(const $ of _.extensions)this.v.info("Extensions removed from another source",$.id,_.profileLocation.toString()),this.p.fire({identifier:$,profileLocation:_.profileLocation});if(K){const g=(await this.S.scanExtensions(1,K.profileLocation)).filter(O=>K.extensions.some(B=>(0,i.areSameExtensions)(B,O.identifier)));this.m.fire(g.map(O=>(this.v.info("Extensions added from another source",O.identifier.id,K.profileLocation.toString()),{identifier:O.identifier,local:O,profileLocation:K.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(_=>this.lb.add(_)));const K=await this.cb.resolve(this.Z.userExtensionsLocation);for(const _ of K.children??[])_.isDirectory&&this.lb.add(_.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(_=>this.nb(_)))}async nb(K){if(!K.affects(this.Z.userExtensionsLocation,1))return;const _=[];for(const $ of K.rawAdded){if(this.lb.has($)||!this.db.extUri.isEqual(this.db.extUri.dirname($),this.Z.userExtensionsLocation)||this.db.extUri.isEqual($,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename($).startsWith(".")||!(await this.cb.stat($)).isDirectory)continue;const g=await this.S.scanUserExtensionAtLocation($);g&&g.installedTimestamp===void 0&&(this.lb.add($),_.push(g))}_.length&&(await this.ob(_.map($=>[$,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",_.map($=>$.identifier.id)))}async ob(K,_){const $=K.map(g=>g[0]);await this.pb($),await this.ab.addExtensionsToProfile(K,_),this.m.fire($.map(g=>({local:g,identifier:g.identifier,operation:1,profileLocation:_})))}async pb(K){const _=await this.S.getUninstalledExtensions();for(const $ of K){const g=i.ExtensionKey.create($);_[g.toString()]&&(this.v.trace("Removing the extension from uninstalled list:",g.id),await this.S.setInstalled(g),this.v.info("Removed the extension from uninstalled list:",g.id))}}};e.ExtensionManagementService=Y=ve([X(0,t.IExtensionGalleryService),X(1,V.ITelemetryService),X(2,H.ILogService),X(3,n.INativeEnvironmentService),X(4,o.IExtensionsScannerService),X(5,s.IExtensionsProfileScannerService),X(6,L.IDownloadService),X(7,F.IInstantiationService),X(8,M.IFileService),X(9,q.IProductService),X(10,Q.IUriIdentityService),X(11,te.IUserDataProfilesService)],Y);let x=e.ExtensionsScanner=class extends C.Disposable{constructor(K,_,$,g,O,B){super(),this.k=K,this.l=_,this.m=$,this.n=g,this.p=O,this.s=B,this.h=this.B(new D.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,f.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new k.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(K,_){const $={includeInvalid:!0,profileLocation:_};let g=[];return K===null||K===0?g.push(...await this.m.scanAllExtensions({includeInvalid:!0},$,!1)):K===1&&g.push(...await this.m.scanUserExtensions($)),g=K!==null?g.filter(O=>O.type===K):g,Promise.all(g.map(O=>this.y(O)))}async scanAllUserExtensions(K){const _=await this.m.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(_.map($=>this.y($)))}async scanUserExtensionAtLocation(K){try{const _=await this.m.scanExistingExtension(K,1,{includeInvalid:!0});if(_)return await this.y(_)}catch(_){this.s.error(_)}return null}async extractUserExtension(K,_,$,g){await this.j.catch(()=>{});const O=K.toString(),B=v.join(this.m.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`),W=v.join(this.m.userExtensionsLocation.fsPath,O);try{await u.Promises.rm(W)}catch{throw new t.ExtensionManagementError(p.localize(4,null,W,K.id),t.ExtensionManagementErrorCode.Delete)}await this.u(K,_,B,g),await this.m.updateMetadata(a.URI.file(B),$);try{this.h.fire(a.URI.file(W)),await this.v(K,B,W,Date.now()+2*60*1e3),this.s.info("Renamed to",W)}catch(z){try{await u.Promises.rm(B)}catch{}if(z.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.s.info(`Rename failed because of ${(0,T.getErrorMessage)(z)}. Deleted from extracted location`,B),z}return this.w(a.URI.file(W),1)}async scanMetadata(K,_){return _?(await this.n.scanProfileExtensions(_)).find(g=>(0,i.areSameExtensions)(g.identifier,K.identifier))?.metadata:this.m.scanMetadata(K.location)}async updateMetadata(K,_,$){return $?await this.n.updateMetadata([[K,_]],$):await this.m.updateMetadata(K.location,_),this.w(K.location,K.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...K){const _=K.map($=>i.ExtensionKey.create($));await this.t($=>_.forEach(g=>{$[g.toString()]=!0,this.s.info("Marked extension as uninstalled",g.toString())}))}async setInstalled(K){await this.t(_=>delete _[K.toString()])}async removeExtension(K,_){this.s.trace(`Deleting ${_} extension from disk`,K.identifier.id,K.location.fsPath);const $=this.p.extUri.joinPath(this.p.extUri.dirname(K.location),`._${(0,h.generateUuid)()}`);await this.v(K.identifier,K.location.fsPath,$.fsPath,Date.now()+2*60*1e3),await this.l.del($,{recursive:!0}),this.s.info("Deleted from disk",K.identifier.id,K.location.fsPath)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.t(_=>delete _[i.ExtensionKey.create(K).toString()])}async copyExtensions(K,_){const $=await this.scanExtensions(1,K),g=await Promise.all($.filter(O=>!O.isApplicationScoped).map(async O=>[O,await this.scanMetadata(O,K)]));await this.n.addExtensionsToProfile(g,_)}async t(K){return this.g.queue(async()=>{let _;try{_=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(g){if((0,M.toFileOperationResult)(g)!==1)throw g}let $={};if(_)try{$=JSON.parse(_)}catch{}return K&&(K($),Object.keys($).length?await this.l.writeFile(this.c,U.VSBuffer.fromString(JSON.stringify($))):await this.l.del(this.c)),$})}async u(K,_,$,g){this.s.trace(`Started extracting the extension from ${_} to ${$}`);try{await u.Promises.rm($)}catch(O){throw new t.ExtensionManagementError(this.D(O).message,t.ExtensionManagementErrorCode.Delete)}try{await(0,I.extract)(_,$,{sourcePath:"extension",overwrite:!0},g),this.s.info(`Extracted extension to ${$}:`,K.id)}catch(O){try{await u.Promises.rm($)}catch{}let B=t.ExtensionManagementErrorCode.Extract;throw O instanceof I.ExtractError&&(O.type==="CorruptZip"?B=t.ExtensionManagementErrorCode.CorruptZip:O.type==="Incomplete"&&(B=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(O.message,B)}}async v(K,_,$,g){try{await u.Promises.rename(_,$)}catch(O){if(S.isWindows&&O&&O.code==="EPERM"&&Date.now()<g)return this.s.info(`Failed renaming ${_} to ${$} with 'EPERM' error. Trying again...`,K.id),this.v(K,_,$,g);throw new t.ExtensionManagementError(O.message||p.localize(5,null,_,$),O.code||t.ExtensionManagementErrorCode.Rename)}}async w(K,_){const $=await this.m.scanExistingExtension(K,_,{includeInvalid:!0});if($)return this.y($);throw new Error(p.localize(6,null,K.path))}async y(K){const _=await this.l.resolve(K.location);let $,g;return _.children&&($=_.children.find(({name:O})=>/^readme(\.txt|\.md|)$/i.test(O))?.resource,g=_.children.find(({name:O})=>/^changelog(\.txt|\.md|)$/i.test(O))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:$,changelogUrl:g,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned}}async z(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys(K));const _=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),$=new Set;for(const O of _)K[i.ExtensionKey.create(O).toString()]||$.add(O.identifier.id.toLowerCase());try{const O=(0,i.groupByExtension)(_,B=>B.identifier);await k.Promises.settled(O.map(async B=>{const W=B.sort((z,J)=>d.rcompare(z.manifest.version,J.manifest.version))[0];$.has(W.identifier.id.toLowerCase())||await this.k(await this.y(W))}))}catch(O){this.s.error(O)}const g=_.filter(O=>O.metadata&&K[i.ExtensionKey.create(O).toString()]);await Promise.allSettled(g.map(O=>this.removeUninstalledExtension(O)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const K=[];let _;try{_=await this.l.resolve(this.m.userExtensionsLocation)}catch($){(0,M.toFileOperationResult)($)!==1&&this.s.error($)}for(const $ of _?.children??[])$.isDirectory&&$.name.startsWith("._")&&(0,h.isUUID)($.name.substring(2))&&K.push((async()=>{this.s.trace("Deleting the generated extension folder",$.resource.toString());try{await this.l.del($.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",$.resource.toString())}catch(g){this.s.error(g)}})());await Promise.allSettled(K)}D(K){const _=Array.isArray(K)?K:[K];return _.length===1?_[0]instanceof Error?_[0]:new Error(_[0]):_.reduce(($,g)=>new Error(`${$.message}${$.message?",":""}${g instanceof Error?g.message:g}`),new Error(""))}};e.ExtensionsScanner=x=ve([X(1,M.IFileService),X(2,o.IExtensionsScannerService),X(3,s.IExtensionsProfileScannerService),X(4,Q.IUriIdentityService),X(5,H.ILogService)],x);class G extends r.AbstractExtensionTask{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,w.isUndefined)(this.m.operation)?this.l:this.m.operation}constructor(K,_,$,g,O,B,W,z,J){super(),this.identifier=K,this.source=_,this.m=$,this.n=g,this.o=O,this.p=B,this.q=W,this.s=z,this.t=J,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(K){const[_,$]=await this.y(K);return this.j=_.isBuiltin||_.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[_,$]],this.j),_}async v({zipPath:K,key:_,metadata:$},g){let O=await this.w(_);return O||(this.t.trace("Extracting extension...",_.id),O=await this.n.extractUserExtension(_,K,$,g),this.t.info("Extracting extension completed.",_.id)),O}async w(K){return await this.x(K)?(this.t.trace("Removing the extension from uninstalled list:",K.id),await this.n.setInstalled(K),this.t.info("Removed the extension from uninstalled list:",K.id),(await this.n.scanAllUserExtensions(!0)).find(g=>i.ExtensionKey.create(g).equals(K))):void 0}async x(K){return!!(await this.n.getUninstalledExtensions())[K.toString()]}}class j extends G{constructor(K,_,$,g,O,B,W,z,J,ee){super(_.identifier,_,$,O,B,W,z,J,ee),this.z=_,this.A=g}async y(K){const $=(await this.n.scanExtensions(null,this.m.profileLocation)).find(W=>(0,i.areSameExtensions)(W.identifier,this.z.identifier));$&&(this.l=3);const g={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||$?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||$?.isMachineScoped,isBuiltin:this.m.isBuiltin||$?.isBuiltin,isSystem:$?.type===0?!0:void 0,updated:!!$,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,w.isBoolean)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:$?.preRelease)};if($?.manifest.version===this.z.version)return[await this.n.updateMetadata($,g),g];const{location:O,verificationStatus:B}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=B,this.C(O.fsPath),[await this.v({zipPath:O.fsPath,key:i.ExtensionKey.create(this.z),metadata:g},K),g]}catch(W){try{await this.A.delete(O)}catch(z){this.t.warn("Error while deleting the downloaded file",O.toString(),(0,T.getErrorMessage)(z))}throw W}}async C(K){try{await(0,y.getManifest)(K)}catch(_){throw new t.ExtensionManagementError((0,r.joinErrors)(_).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=j;class Z extends G{constructor(K,_,$,g,O,B,W,z,J,ee){super({id:(0,i.getGalleryExtensionId)(K.publisher,K.name)},_,$,O,B,W,z,J,ee),this.z=K,this.A=_,this.B=g}async h(K){const _=await super.h(K);return this.E(_,K),_}async y(K){const _=new i.ExtensionKey(this.identifier,this.z.version),g=(await this.n.scanExtensions(1,this.m.profileLocation)).find(W=>(0,i.areSameExtensions)(this.identifier,W.identifier)),O={isApplicationScoped:this.m.isApplicationScoped||g?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||g?.isMachineScoped,isBuiltin:this.m.isBuiltin||g?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(g)if(this.l=3,_.equals(new i.ExtensionKey(g.identifier,g.manifest.version)))try{await this.n.removeExtension(g,"existing")}catch{throw new Error(p.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&d.gt(g.manifest.version,this.z.version)&&await this.n.setUninstalled(g);else{const W=await this.w(_);if(W)try{await this.n.removeExtension(W,"existing")}catch{throw new Error(p.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:v.resolve(this.A.fsPath),key:_,metadata:O},K),O]}async E(K,_){try{let[$]=await this.B.getExtensions([{id:K.identifier.id,version:K.manifest.version}],_);if($||([$]=await this.B.getExtensions([{id:K.identifier.id}],_)),$){const g={id:$.identifier.uuid,publisherDisplayName:$.publisherDisplayName,publisherId:$.publisherId,isPreReleaseVersion:$.properties.isPreReleaseVersion,preRelease:$.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(K,g,this.m.profileLocation)}}catch{}}}class ie extends r.AbstractExtensionTask{constructor(K,_,$){super(),this.extension=K,this.j=_,this.k=$}async h(K){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[258],ae([0,1,2,28,79,215,121,8,19]),function(ne,e,k,U,A,N,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let m=e.ExtensionsContributions=class extends k.Disposable{constructor(v,S,f,d,w,a){super(),v.cleanUp(),(0,N.migrateUnsupportedExtensions)(v,S,f,d,a),A.ExtensionStorageService.removeOutdatedExtensionVersions(v,w)}};e.ExtensionsContributions=m=ve([X(0,T.INativeServerExtensionManagementService),X(1,U.IExtensionGalleryService),X(2,A.IExtensionStorageService),X(3,U.IGlobalExtensionEnablementService),X(4,C.IStorageService),X(5,D.ILogService)],m)}),define(oe[259],ae([0,1,69,61,36,267,16,7,3,2,15,5,32,43,92]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{traceSocketEvent(c,b){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,c,b)}constructor(c,b=""){this.f=!0,this.debugLabel=b,this.socket=c,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=R=>{if(this.traceSocketEvent("error",{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,D.onUnexpectedError)(R)}},this.socket.on("error",this.a),this.b=R=>{this.traceSocketEvent("close",{hadError:R}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(c){const b=R=>{this.traceSocketEvent("read",R),c(T.VSBuffer.wrap(R))};return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(c){const b=R=>{c({type:0,hadError:R,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(c){const b=()=>{c()};return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(c){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",c),this.socket.write(c.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,D.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,D.onUnexpectedError)(b)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((c,b)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),c();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent("nodeDrainEnd"),c()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=w;var a;(function(y){y[y.MinHeaderByteSize=2]="MinHeaderByteSize",y[y.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(a||(a={}));var h;(function(y){y[y.PeekHeader=1]="PeekHeader",y[y.ReadHeader=2]="ReadHeader",y[y.ReadBody=3]="ReadBody",y[y.Fin=4]="Fin"})(h||(h={}));class u extends m.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(c,b){this.socket.traceSocketEvent(c,b)}constructor(c,b,R,M){super(),this.f=this.B(new C.Emitter),this.g=this.B(new C.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:b,inflateBytesLength:R?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new I(this,b,R,M,this.f,(F,H)=>this.k(F,H))),this.B(this.a.onError(F=>{console.error(F),(0,D.onUnexpectedError)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new d.ChunkStream,this.B(this.socket.onData(F=>this.l(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this.f.event(c)}onClose(c){return this.g.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){let b=0;for(;b<c.byteLength;)this.a.writeMessage(c.slice(b,Math.min(b+262144,c.byteLength))),b+=262144}k(c,b){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",c);let R=2;c.byteLength<126?R+=0:c.byteLength<2**16?R+=2:R+=8;const M=T.VSBuffer.alloc(R);if(b?M.writeUInt8(194,0):M.writeUInt8(130,0),c.byteLength<126)M.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){M.writeUInt8(126,1);let F=1;M.writeUInt8(c.byteLength>>>8&255,++F),M.writeUInt8(c.byteLength>>>0&255,++F)}else{M.writeUInt8(127,1);let F=1;M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(c.byteLength>>>24&255,++F),M.writeUInt8(c.byteLength>>>16&255,++F),M.writeUInt8(c.byteLength>>>8&255,++F),M.writeUInt8(c.byteLength>>>0&255,++F)}this.socket.write(T.VSBuffer.concat([M,c]))}end(){this.h=!0,this.socket.end()}l(c){if(c.byteLength!==0){for(this.b.acceptChunk(c);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const b=this.b.peek(this.j.readLen),R=b.readUInt8(0),M=(R&128)>>>7,F=(R&64)>>>6,H=b.readUInt8(1),q=(H&128)>>>7,V=H&127;this.j.state=2,this.j.readLen=2+(q?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!M,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const b=this.b.read(this.j.readLen),R=b.readUInt8(1),M=(R&128)>>>7;let F=R&127,H=1;F===126?F=b.readUInt8(++H)*2**8+b.readUInt8(++H):F===127&&(F=b.readUInt8(++H)*0+b.readUInt8(++H)*0+b.readUInt8(++H)*0+b.readUInt8(++H)*0+b.readUInt8(++H)*2**24+b.readUInt8(++H)*2**16+b.readUInt8(++H)*2**8+b.readUInt8(++H));let q=0;M&&(q=b.readUInt8(++H)*2**24+b.readUInt8(++H)*2**16+b.readUInt8(++H)*2**8+b.readUInt8(++H)),this.j.state=3,this.j.readLen=F,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const b=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",b),n(b,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",b),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(b,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=u;class I extends m.Disposable{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.VSBuffer.alloc(0)}constructor(c,b,R,M,F,H){super(),this.l=c,this.m=F,this.n=H,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new C.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,b?(this.b=this.B(new p(this.l,M,R,{windowBits:15})),this.f=this.B(new L(this.l,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(c){this.g.push(c),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const c=this.g.shift();if(this.f){const b=await this.s(this.f,c);this.n(b,!0)}else this.n(c,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(c,b){return new Promise((R,M)=>{c.write(b),c.flush(F=>R(F))})}acceptFrame(c,b,R){this.h.push({data:c,isCompressed:b,isLastFrameOfMessage:R}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const c=this.h.shift();if(this.b&&c.isCompressed){const b=await this.w(this.b,c.data,c.isLastFrameOfMessage);this.m.fire(b)}else this.m.fire(c.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(c,b,R){return new Promise((M,F)=>{c.write(b),R&&c.write(T.VSBuffer.fromByteArray([0,0,255,255])),c.flush(H=>M(H))})}}class p extends m.Disposable{get recordedInflateBytes(){return this.j?T.VSBuffer.concat(this.f):T.VSBuffer.alloc(0)}constructor(c,b,R,M){super(),this.h=c,this.j=b,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,N.createInflateRaw)(M),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(T.VSBuffer.wrap(F))}),R&&(this.h.traceSocketEvent("zlibInflateInitialWrite",R.buffer),this.b.write(R.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(c){this.j&&this.f.push(c.clone()),this.h.traceSocketEvent("zlibInflateWrite",c),this.b.write(c.buffer)}flush(c){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const b=T.VSBuffer.concat(this.g);this.g.length=0,c(b)})}}class L extends m.Disposable{constructor(c,b){super(),this.g=c,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,N.createDeflateRaw)({windowBits:15}),this.b.on("error",R=>{this.g.traceSocketEvent("zlibDeflateError",{message:R?.message,code:R?.code}),this.a.fire(R)}),this.b.on("data",R=>{this.g.traceSocketEvent("zlibDeflateData",R),this.f.push(T.VSBuffer.wrap(R))})}write(c){this.g.traceSocketEvent("zlibDeflateWrite",c.buffer),this.b.write(c.buffer)}flush(c){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let b=T.VSBuffer.concat(this.f);this.f.length=0,b=b.slice(0,b.byteLength-4),c(b)})}}function n(y,c){if(c===0)return;const b=y.byteLength>>>2;for(let V=0;V<b;V++){const Q=y.readUInt32BE(V*4);y.writeUInt32BE(Q^c,V*4)}const R=b*4,M=y.byteLength-R,F=c>>>24&255,H=c>>>16&255,q=c>>>8&255;M>=1&&y.writeUInt8(y.readUInt8(R)^F,R),M>=2&&y.writeUInt8(y.readUInt8(R+1)^H,R+1),M>=3&&y.writeUInt8(y.readUInt8(R+2)^q,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function t(){const y=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${y}-sock`;const c=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,A.tmpdir)(),b=(0,P.join)(c,`vscode-ipc-${y}.sock`);return s(b),b}e.createRandomIPCHandle=t;function i(y,c,b){const R=(0,k.createHash)("md5").update(y).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${b}-${c}-sock`;const M=b.substr(0,4),F=c.substr(0,6),H=R.substr(0,8);let q;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?q=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${H}-${M}-${F}.sock`):q=(0,P.join)(y,`${M}-${F}.sock`),s(q),q}e.createStaticIPCHandle=i;function s(y){const c=r[v.platform];typeof c=="number"&&y.length>=c&&console.warn(`WARNING: IPC handle "${y}" is longer than ${c} chars, try a shorter --user-data-dir`)}class o extends f.IPCServer{static b(c){const b=C.Event.fromNodeEventEmitter(c,"connection");return C.Event.map(b,R=>({protocol:new d.Protocol(new w(R,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(R,"close"))}))}constructor(c){super(o.b(c)),this.d=c}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=o;function l(y){return new Promise((c,b)=>{const R=(0,U.createServer)();R.on("error",b),R.listen(y,()=>{R.removeListener("error",b),c(new o(R))})})}e.serve=l;function E(y,c){return new Promise((b,R)=>{const M=(0,U.createConnection)(y,()=>{M.removeListener("error",R),b(d.Client.fromSocket(new w(M,`ipc-client${c}`),c))});M.once("error",R)})}e.connect=E}),define(oe[260],ae([0,1,61,259,203]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{supports(N){return!0}connect({host:N,port:T},D,C,m){return new Promise((P,v)=>{const S=k.createConnection({host:N,port:T},()=>{S.removeListener("error",v),S.write((0,A.makeRawSocketHeaders)(D,C,m));const f=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",f),P(new U.NodeSocket(S,m)))};S.on("data",f)});S.setNoDelay(!0),S.once("error",v)})}}}),define(oe[268],ae([0,1,36,38,7,2,25,12,43,140,197,198,189,190,255,180,182,18,202,95,213,96,208,14,210,113,240,28,97,181,121,98,13,192,193,68,4,188,70,72,218,8,194,102,24,56,19,107,20,108,109,110,45,221,79,111,23,77,246,232,233,80,247,250,251,252,58,245,234,106,212,76,223,207,222,29,224,5,225,183,200,199,78,239,17,50,196,55,244,220,235,105,249,258,9,195,101,242,238,209,177,54,253,241,71,243,104,260]),function(ne,e,k,U,A,N,T,D,C,m,P,v,S,f,d,w,a,h,u,I,p,L,n,r,t,i,s,o,l,E,y,c,b,R,M,F,H,q,V,Q,te,Y,x,G,j,Z,ie,se,K,_,$,g,O,B,W,z,J,ee,ce,ue,de,Se,we,be,De,ke,ze,Je,le,fe,ge,Ce,Pe,Me,Le,Be,Ne,je,Fe,Ae,re,he,me,ye,pe,Ie,Re,Oe,qe,Te,$e,We,_e,nt,It,Ct,mt,Pt,Rt,Dt,kt,Lt,At,Tt,yt,Ot,St,Nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ut extends N.Disposable{constructor(Ee){super(),this.c=Ee,this.a=this.B(new m.Server),this.b=void 0,this.f()}f(){let Ee=!1;const Ue=()=>{Ee||(Ee=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ue),(0,m.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Ue)}async init(){const Ee=await this.g();(0,J.registerConfiguration)(),Ee.invokeFunction(Ue=>{const Xe=Ue.get(Y.ILogService);Xe.trace("sharedProcess configuration",JSON.stringify(this.c)),this.h(Ue),this.i(Xe)}),this.B((0,N.combinedDisposable)(Ee.createInstance(P.CodeCacheCleaner,this.c.codeCachePath),Ee.createInstance(v.LanguagePackCachedDataCleaner),Ee.createInstance(d.UnusedWorkspaceStorageDataCleaner),Ee.createInstance(f.LogsDataCleaner),Ee.createInstance(S.LocalizationsUpdater),Ee.createInstance(nt.ExtensionsContributions),Ee.createInstance($e.UserDataProfilesCleaner)))}async g(){const Ee=new V.ServiceCollection,Ue={_serviceBrand:void 0,...G.default};Ee.set(j.IProductService,Ue);const Xe=new C.StaticRouter(He=>He==="main"),Ge=new yt.MainProcessService(this.a,Xe);Ee.set(yt.IMainProcessService,Ge);const at=this.c.policiesData?new Re.PolicyChannelClient(this.c.policiesData,Ge.getChannel("policy")):new Oe.NullPolicyService;Ee.set(Oe.IPolicyService,at);const Ke=new t.SharedProcessEnvironmentService(this.c.args,Ue);Ee.set(r.INativeEnvironmentService,Ke);const et=new x.LoggerChannelClient(void 0,this.c.logLevel,Ke.logsHome,this.c.loggers.map(He=>({...He,resource:D.URI.revive(He.resource)})),Ge.getChannel("logger"));Ee.set(Y.ILoggerService,et);const ct=this.B(et.createLogger("sharedprocess",{name:(0,It.localize)(0,null)})),ht=this.B(new Y.ConsoleLogger(ct.getLevel())),Ye=this.B(new Ct.LogService(ct,[ht]));Ee.set(Y.ILogService,Ye),this.b=this.B(new mt.SharedProcessLifecycleService(Ye)),Ee.set(mt.ISharedProcessLifecycleService,this.b);const Qe=this.B(new R.FileService(Ye));Ee.set(b.IFileService,Qe);const ft=this.B(new M.DiskFileSystemProvider(Ye));Qe.registerProvider(T.Schemas.file,ft);const dt=this.B(new Fe.FileUserDataProvider(T.Schemas.file,this.B(new Ae.DiskFileSystemProviderClient(Ge.getChannel(Ae.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:je.isLinux})),T.Schemas.vscodeUserData,Ye));Qe.registerProvider(T.Schemas.vscodeUserData,dt);const tt=this.B(new qe.UserDataProfilesService(this.c.profiles.all,D.URI.revive(this.c.profiles.home).with({scheme:Ke.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Ee.set(pe.IUserDataProfilesService,tt);const Ze=this.B(new u.ConfigurationService(tt.defaultProfile.settingsResource,Qe,at,Ye));Ee.set(h.IConfigurationService,Ze);const st=new Ot.RemoteStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},Ge,Ke);Ee.set(ie.IStorageService,st),this.B((0,N.toDisposable)(()=>st.flush())),await Promise.all([Ze.initialize(),st.initialize()]);const Mt=new Ne.UriIdentityService(Qe);Ee.set(Be.IUriIdentityService,Mt),Ee.set(Z.IRequestService,new Dt.RequestChannelClient(Ge.getChannel("request"))),Ee.set(w.IChecksumService,new F.SyncDescriptor(a.ChecksumService,void 0,!1)),Ee.set(he.IV8InspectProfilingService,new F.SyncDescriptor(re.InspectProfilingService,void 0,!1));const pt=C.ProxyChannel.toService(Ge.getChannel("nativeHost"));Ee.set(Lt.INativeHostService,pt),Ee.set(L.IDownloadService,new F.SyncDescriptor(n.DownloadService,void 0,!0));const Ft=this.B(new le.ActiveWindowManager(pt)),jt=new C.StaticRouter(He=>Ft.getActiveClientId().then(ut=>He===ut));Ee.set(c.IExtensionRecommendationNotificationService,new kt.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",jt)));let lt;const rt=[],wt=(0,O.isInternalTelemetry)(Ue,Ze);if((0,O.supportsTelemetry)(Ue,Ke)){const He=new $.TelemetryLogAppender(Ye,et,Ke,Ue);if(rt.push(He),Ue.aiConfig?.ariaKey){const ut=new Te.OneDataSystemAppender(wt,"monacoworkbench",null,Ue.aiConfig.ariaKey);this.B((0,N.toDisposable)(()=>ut.flush())),rt.push(ut)}lt=new g.TelemetryService({appenders:rt,commonProperties:(0,se.resolveCommonProperties)((0,k.release)(),(0,k.hostname)(),process.arch,Ue.commit,Ue.version,this.c.machineId,wt),sendErrorTelemetry:!0,piiPaths:(0,O.getPiiPathsFromEnvironment)(Ke)},Ze,Ue)}else{lt=O.NullTelemetryService;const He=O.NullAppender;rt.push(He)}this.a.registerChannel("telemetryAppender",new _.TelemetryAppenderChannel(rt)),Ee.set(K.ITelemetryService,lt);const $t=new B.CustomEndpointTelemetryService(Ze,lt,Ye,et,Ke,Ue);Ee.set(K.ICustomEndpointTelemetryService,$t),Ee.set(Ie.IExtensionsProfileScannerService,new F.SyncDescriptor(Rt.ExtensionsProfileScannerService,void 0,!0)),Ee.set(me.IExtensionsScannerService,new F.SyncDescriptor(ye.ExtensionsScannerService,void 0,!0)),Ee.set(l.IExtensionSignatureVerificationService,new F.SyncDescriptor(l.ExtensionSignatureVerificationService,void 0,!0)),Ee.set(y.INativeServerExtensionManagementService,new F.SyncDescriptor(y.ExtensionManagementService,void 0,!0)),Ee.set(o.IExtensionGalleryService,new F.SyncDescriptor(s.ExtensionGalleryService,void 0,!0)),Ee.set(o.IExtensionTipsService,new F.SyncDescriptor(Tt.ExtensionTipsService,void 0,!1)),Ee.set(Q.ILanguagePackService,new F.SyncDescriptor(te.NativeLanguagePackService,void 0,!1)),Ee.set(I.IDiagnosticsService,new F.SyncDescriptor(p.DiagnosticsService,void 0,!1)),Ee.set(ee.IUserDataSyncAccountService,new F.SyncDescriptor(ee.UserDataSyncAccountService,void 0,!0)),Ee.set(J.IUserDataSyncLogService,new F.SyncDescriptor(de.UserDataSyncLogService,void 0,!0)),Ee.set(J.IUserDataSyncUtilService,new ue.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),Ee.set(o.IGlobalExtensionEnablementService,new F.SyncDescriptor(i.GlobalExtensionEnablementService,void 0,!1)),Ee.set(z.IIgnoredExtensionsManagementService,new F.SyncDescriptor(z.IgnoredExtensionsManagementService,void 0,!0)),Ee.set(W.IExtensionStorageService,new F.SyncDescriptor(W.ExtensionStorageService)),Ee.set(J.IUserDataSyncStoreManagementService,new F.SyncDescriptor(ke.UserDataSyncStoreManagementService,void 0,!0)),Ee.set(J.IUserDataSyncStoreService,new F.SyncDescriptor(ke.UserDataSyncStoreService,void 0,!0)),Ee.set(Se.IUserDataSyncMachinesService,new F.SyncDescriptor(Se.UserDataSyncMachinesService,void 0,!0)),Ee.set(J.IUserDataSyncBackupStoreService,new F.SyncDescriptor(ce.UserDataSyncBackupStoreService,void 0,!1)),Ee.set(J.IUserDataSyncEnablementService,new F.SyncDescriptor(we.UserDataSyncEnablementService,void 0,!0)),Ee.set(J.IUserDataSyncService,new F.SyncDescriptor(be.UserDataSyncService,void 0,!1)),Ee.set(ze.IUserDataProfileStorageService,new F.SyncDescriptor(Je.NativeUserDataProfileStorageService,void 0,!0)),Ee.set(J.IUserDataSyncResourceProviderService,new F.SyncDescriptor(_e.UserDataSyncResourceProviderService,void 0,!0)),Ee.set(fe.ISignService,new F.SyncDescriptor(ge.SignService,void 0,!1));const Et=new St.RemoteSocketFactoryService;return Ee.set(St.IRemoteSocketFactoryService,Et),Et.register(0,Nt.nodeSocketFactory),Ee.set(Ce.ISharedTunnelsService,new F.SyncDescriptor(Pe.SharedTunnelsService)),Ee.set(Me.ISharedProcessTunnelService,new F.SyncDescriptor(Le.SharedProcessTunnelService)),Ee.set(We.IRemoteTunnelService,new F.SyncDescriptor(Pt.RemoteTunnelService)),new q.InstantiationService(Ee)}h(Ee){const Ue=new E.ExtensionManagementChannel(Ee.get(o.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",Ue);const Xe=C.ProxyChannel.fromService(Ee.get(Q.ILanguagePackService));this.a.registerChannel("languagePacks",Xe);const Ge=C.ProxyChannel.fromService(Ee.get(I.IDiagnosticsService));this.a.registerChannel("diagnostics",Ge);const at=new E.ExtensionTipsChannel(Ee.get(o.IExtensionTipsService));this.a.registerChannel("extensionTipsService",at);const Ke=C.ProxyChannel.fromService(Ee.get(w.IChecksumService));this.a.registerChannel("checksum",Ke);const et=C.ProxyChannel.fromService(Ee.get(he.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",et);const ct=new ue.UserDataSyncMachinesServiceChannel(Ee.get(Se.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ct);const ht=C.ProxyChannel.fromService(Ee.get(K.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",ht);const Ye=new ue.UserDataSyncAccountServiceChannel(Ee.get(ee.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",Ye);const Qe=new ue.UserDataSyncStoreManagementServiceChannel(Ee.get(J.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",Qe);const ft=new De.UserDataSyncChannel(Ee.get(J.IUserDataSyncService),Ee.get(pe.IUserDataProfilesService),Ee.get(Y.ILogService));this.a.registerChannel("userDataSync",ft);const dt=this.B(Ee.get(H.IInstantiationService).createInstance(At.UserDataAutoSyncService)),tt=new ue.UserDataAutoSyncChannel(dt);this.a.registerChannel("userDataAutoSync",tt);const Ze=C.ProxyChannel.fromService(Ee.get(Me.ISharedProcessTunnelService));this.a.registerChannel(Me.ipcSharedProcessTunnelChannelName,Ze);const st=C.ProxyChannel.fromService(Ee.get(We.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",st)}i(Ee){process.on("uncaughtException",Ue=>(0,A.onUnexpectedError)(Ue)),process.on("unhandledRejection",Ue=>(0,A.onUnexpectedError)(Ue)),(0,A.setUnexpectedErrorHandler)(Ue=>{const Xe=(0,U.toErrorMessage)(Ue,!0);Xe&&Ee.error(`[uncaught exception in sharedProcess]: ${Xe}`)})}}async function vt(ot){const Ee=new Ut(ot);process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"),await Ee.init(),process.parentPort.postMessage("vscode:shared-process->electron-main=init-done")}e.main=vt,process.parentPort.once("message",ot=>{vt(ot.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b380da4ef1ee00e224a15c1d4d9793e27c2b6302/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
