/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/workbench/services/extensions/common/extensions","vs/base/common/platform","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Oe=function(te){for(var e=[],i=0,k=te.length;i<k;i++)e[i]=Re[te[i]];return e};define(Re[64],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(F,R){const S=Object.create(null);for(const m of F){const O=R(m);let w=S[O];w||(w=S[O]=[]),w.push(m)}return S}e.groupBy=i;function k(F,R){const S=[],m=[];for(const O of F)R.has(O)||S.push(O);for(const O of R)F.has(O)||m.push(O);return{removed:S,added:m}}e.diffSets=k;function D(F,R){const S=[],m=[];for(const[O,w]of F)R.has(O)||S.push(w);for(const[O,w]of R)F.has(O)||m.push(w);return{removed:S,added:m}}e.diffMaps=D;class N{constructor(){this.a=new Map}add(R,S){let m=this.a.get(R);m||(m=new Set,this.a.set(R,m)),m.add(S)}delete(R,S){const m=this.a.get(R);m&&(m.delete(S),m.size===0&&this.a.delete(R))}forEach(R,S){const m=this.a.get(R);m&&m.forEach(S)}}e.SetMap=N}),define(Re[65],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(F){return(R,S,m)=>{let O=null,w=null;if(typeof m.value=="function"?(O="value",w=m.value):typeof m.get=="function"&&(O="get",w=m.get),!w)throw new Error("not supported");m[O]=F(w,S)}}function k(F,R,S){let m=null,O=null;if(typeof S.value=="function"?(m="value",O=S.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(m="get",O=S.get),!O)throw new Error("not supported");const w=`$memoize$${R}`;S[m]=function(...c){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,c)}),this[w]}}e.memoize=k;function D(F,R,S){return i((m,O)=>{const w=`$debounce$${O}`,c=`$debounce$result$${O}`;return function(...p){this[c]||(this[c]=S?S():void 0),clearTimeout(this[w]),R&&(this[c]=R(this[c],...p),p=[this[c]]),this[w]=setTimeout(()=>{m.apply(this,p),this[c]=S?S():void 0},F)}})}e.debounce=D;function N(F,R,S){return i((m,O)=>{const w=`$throttle$timer$${O}`,c=`$throttle$result$${O}`,p=`$throttle$lastRun$${O}`,g=`$throttle$pending$${O}`;return function(...d){if(this[c]||(this[c]=S?S():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),R&&(this[c]=R(this[c],...d)),this[g])return;const t=this[p]+F;t<=Date.now()?(this[p]=Date.now(),m.apply(this,[this[c]]),this[c]=S?S():void 0):(this[g]=!0,this[w]=setTimeout(()=>{this[g]=!1,this[p]=Date.now(),m.apply(this,[this[c]]),this[c]=S?S():void 0},t-Date.now()))}})}e.throttle=N}),define(Re[86],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(D){this.a=D,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(Re[115],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var k;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(k||(e.SyntaxKind=k={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var N;(function(n){n.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function F(n,l=!1){let r=0;const a=n.length;let b="",I=0,f=16,P=0;function E(W){let U=0,q=0;for(;U<W;){const z=n.charCodeAt(r);if(z>=48&&z<=57)q=q*16+z-48;else if(z>=65&&z<=70)q=q*16+z-65+10;else if(z>=97&&z<=102)q=q*16+z-97+10;else break;r++,U++}return U<W&&(q=-1),q}function o(W){r=W,b="",I=0,f=16,P=0}function s(){const W=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&m(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&m(n.charCodeAt(r)))for(r++;r<n.length&&m(n.charCodeAt(r));)r++;else return P=3,n.substring(W,r);let U=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&m(n.charCodeAt(r))){for(r++;r<n.length&&m(n.charCodeAt(r));)r++;U=r}else P=3;return n.substring(W,U)}function M(){let W="",U=r;for(;;){if(r>=a){W+=n.substring(U,r),P=2;break}const q=n.charCodeAt(r);if(q===34){W+=n.substring(U,r),r++;break}if(q===92){if(W+=n.substring(U,r),r++,r>=a){P=2;break}switch(n.charCodeAt(r++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const V=E(4);V>=0?W+=String.fromCharCode(V):P=4;break}default:P=5}U=r;continue}if(q>=0&&q<=31)if(S(q)){W+=n.substring(U,r),P=2;break}else P=6;r++}return W}function B(){if(b="",P=0,I=r,r>=a)return I=a,f=17;let W=n.charCodeAt(r);if(R(W)){do r++,b+=String.fromCharCode(W),W=n.charCodeAt(r);while(R(W));return f=15}if(S(W))return r++,b+=String.fromCharCode(W),W===13&&n.charCodeAt(r)===10&&(r++,b+=`
`),f=14;switch(W){case 123:return r++,f=1;case 125:return r++,f=2;case 91:return r++,f=3;case 93:return r++,f=4;case 58:return r++,f=6;case 44:return r++,f=5;case 34:return r++,b=M(),f=10;case 47:{const U=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<a&&!S(n.charCodeAt(r));)r++;return b=n.substring(U,r),f=12}if(n.charCodeAt(r+1)===42){r+=2;const q=a-1;let z=!1;for(;r<q;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,z=!0;break}r++}return z||(r++,P=1),b=n.substring(U,r),f=13}return b+=String.fromCharCode(W),r++,f=16}case 45:if(b+=String.fromCharCode(W),r++,r===a||!m(n.charCodeAt(r)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=s(),f=11;default:for(;r<a&&X(W);)r++,W=n.charCodeAt(r);if(I!==r){switch(b=n.substring(I,r),b){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return b+=String.fromCharCode(W),r++,f=16}}function X(W){if(R(W)||S(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let W;do W=B();while(W>=12&&W<=15);return W}return{setPosition:o,getPosition:()=>r,scan:l?G:B,getToken:()=>f,getTokenValue:()=>b,getTokenOffset:()=>I,getTokenLength:()=>r-I,getTokenError:()=>P}}e.createScanner=F;function R(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function S(n){return n===10||n===13||n===8232||n===8233}function m(n){return n>=48&&n<=57}var O;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(O||(O={}));function w(n,l){const r=[],a=new Object;let b;const I={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function P(E,o,s,M){I.value=E,I.offset=o,I.length=s,I.type=M,I.colonOffset=void 0,b=I}try{y(n,{onObjectBegin:(E,o)=>{if(l<=E)throw a;b=void 0,f=l>E,r.push("")},onObjectProperty:(E,o,s)=>{if(l<o||(P(E,o,s,"property"),r[r.length-1]=E,l<=o+s))throw a},onObjectEnd:(E,o)=>{if(l<=E)throw a;b=void 0,r.pop()},onArrayBegin:(E,o)=>{if(l<=E)throw a;b=void 0,r.push(0)},onArrayEnd:(E,o)=>{if(l<=E)throw a;b=void 0,r.pop()},onLiteralValue:(E,o,s)=>{if(l<o||(P(E,o,s,v(E)),l<=o+s))throw a},onSeparator:(E,o,s)=>{if(l<=o)throw a;if(E===":"&&b&&b.type==="property")b.colonOffset=o,f=!1,b=void 0;else if(E===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(f=!0,r[r.length-1]=""),b=void 0}}})}catch(E){if(E!==a)throw E}return{path:r,previousNode:b,isAtPropertyKey:f,matches:E=>{let o=0;for(let s=0;o<E.length&&s<r.length;s++)if(E[o]===r[s]||E[o]==="*")o++;else if(E[o]!=="**")return!1;return o===E.length}}}e.getLocation=w;function c(n,l=[],r=N.DEFAULT){let a=null,b=[];const I=[];function f(E){Array.isArray(b)?b.push(E):a!==null&&(b[a]=E)}return y(n,{onObjectBegin:()=>{const E={};f(E),I.push(b),b=E,a=null},onObjectProperty:E=>{a=E},onObjectEnd:()=>{b=I.pop()},onArrayBegin:()=>{const E=[];f(E),I.push(b),b=E,a=null},onArrayEnd:()=>{b=I.pop()},onLiteralValue:f,onError:(E,o,s)=>{l.push({error:E,offset:o,length:s})}},r),b[0]}e.parse=c;function p(n,l=[],r=N.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(E){a.type==="property"&&(a.length=E-a.offset,a=a.parent)}function I(E){return a.children.push(E),E}y(n,{onObjectBegin:E=>{a=I({type:"object",offset:E,length:-1,parent:a,children:[]})},onObjectProperty:(E,o,s)=>{a=I({type:"property",offset:o,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:E,offset:o,length:s,parent:a})},onObjectEnd:(E,o)=>{a.length=E+o-a.offset,a=a.parent,b(E+o)},onArrayBegin:(E,o)=>{a=I({type:"array",offset:E,length:-1,parent:a,children:[]})},onArrayEnd:(E,o)=>{a.length=E+o-a.offset,a=a.parent,b(E+o)},onLiteralValue:(E,o,s)=>{I({type:v(E),offset:o,length:s,parent:a,value:E}),b(o+s)},onSeparator:(E,o,s)=>{a.type==="property"&&(E===":"?a.colonOffset=o:E===","&&b(o))},onError:(E,o,s)=>{l.push({error:E,offset:o,length:s})}},r);const P=a.children[0];return P&&delete P.parent,P}e.parseTree=p;function g(n,l){if(!n)return;let r=n;for(const a of l)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let b=!1;for(const I of r.children)if(Array.isArray(I.children)&&I.children[0].value===a){r=I.children[1],b=!0;break}if(!b)return}else{const b=a;if(r.type!=="array"||b<0||!Array.isArray(r.children)||b>=r.children.length)return;r=r.children[b]}return r}e.findNodeAtLocation=g;function d(n){if(!n.parent||!n.parent.children)return[];const l=d(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;l.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&l.push(r)}return l}e.getNodePath=d;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const l=Object.create(null);for(const r of n.children){const a=r.children[1];a&&(l[r.children[0].value]=t(a))}return l}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=t;function u(n,l,r=!1){return l>=n.offset&&l<n.offset+n.length||r&&l===n.offset+n.length}e.contains=u;function h(n,l,r=!1){if(u(n,l,r)){const a=n.children;if(Array.isArray(a))for(let b=0;b<a.length&&a[b].offset<=l;b++){const I=h(a[b],l,r);if(I)return I}return n}}e.findNodeAtOffset=h;function y(n,l,r=N.DEFAULT){const a=F(n,!1);function b(ue){return ue?()=>ue(a.getTokenOffset(),a.getTokenLength()):()=>!0}function I(ue){return ue?Ie=>ue(Ie,a.getTokenOffset(),a.getTokenLength()):()=>!0}const f=b(l.onObjectBegin),P=I(l.onObjectProperty),E=b(l.onObjectEnd),o=b(l.onArrayBegin),s=b(l.onArrayEnd),M=I(l.onLiteralValue),B=I(l.onSeparator),X=b(l.onComment),G=I(l.onError),W=r&&r.disallowComments,U=r&&r.allowTrailingComma;function q(){for(;;){const ue=a.scan();switch(a.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:W||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ue){case 12:case 13:W?z(10):X();break;case 16:z(1);break;case 15:case 14:break;default:return ue}}}function z(ue,Ie=[],Pe=[]){if(G(ue),Ie.length+Pe.length>0){let be=a.getToken();for(;be!==17;){if(Ie.indexOf(be)!==-1){q();break}else if(Pe.indexOf(be)!==-1)break;be=q()}}}function V(ue){const Ie=a.getTokenValue();return ue?M(Ie):P(Ie),q(),!0}function ee(){switch(a.getToken()){case 11:{let ue=0;try{ue=JSON.parse(a.getTokenValue()),typeof ue!="number"&&(z(2),ue=0)}catch{z(2)}M(ue);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return q(),!0}function Ce(){return a.getToken()!==10?(z(3,[],[2,5]),!1):(V(!1),a.getToken()===6?(B(":"),q(),Q()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function oe(){f(),q();let ue=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(ue||z(4,[],[]),B(","),q(),a.getToken()===2&&U)break}else ue&&z(6,[],[]);Ce()||z(4,[],[2,5]),ue=!0}return E(),a.getToken()!==2?z(7,[2],[]):q(),!0}function le(){o(),q();let ue=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(ue||z(4,[],[]),B(","),q(),a.getToken()===4&&U)break}else ue&&z(6,[],[]);Q()||z(4,[],[4,5]),ue=!0}return s(),a.getToken()!==4?z(8,[4],[]):q(),!0}function Q(){switch(a.getToken()){case 3:return le();case 1:return oe();case 10:return V(!0);default:return ee()}}return q(),a.getToken()===17?r.allowEmptyContent?!0:(z(4,[],[]),!1):Q()?(a.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=y;function C(n,l){const r=F(n),a=[];let b,I=0,f;do switch(f=r.getPosition(),b=r.scan(),b){case 12:case 13:case 17:I!==f&&a.push(n.substring(I,f)),l!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,l)),I=r.getPosition();break}while(b!==17);return a.join("")}e.stripComments=C;function v(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Re[28],Oe([1,0]),function(te,e){"use strict";var i,k,D;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function N(d,t,u){let h=d.get(t);return h===void 0&&(h=u,d.set(t,h)),h}e.getOrSet=N;function F(d){const t=[];return d.forEach((u,h)=>{t.push(`${h} => ${u}`)}),`Map(${d.size}) {${t.join(", ")}}`}e.mapToString=F;function R(d){const t=[];return d.forEach(u=>{t.push(u)}),`Set(${d.size}) {${t.join(", ")}}`}e.setToString=R;class S{constructor(t,u){this.uri=t,this.value=u}}class m{constructor(t,u){this[i]="ResourceMap",t instanceof m?(this.b=new Map(t.b),this.c=u??m.a):(this.b=new Map,this.c=t??m.a)}set(t,u){return this.b.set(this.c(t),new S(t,u)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,u){typeof u<"u"&&(t=t.bind(u));for(const[h,y]of this.b)t(y.value,y.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.ResourceMap=m,m.a=d=>d.toString();class O{constructor(t,u){this[k]="ResourceSet",!t||typeof t=="function"?this.a=new m(t):(this.a=new m(u),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,u){this.a.forEach((h,y)=>t.call(u,y,y,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var w;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class c{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,u=0){const h=this.a.get(t);if(h)return u!==0&&this.j(h,u),h.value}set(t,u,h=0){let y=this.a.get(t);if(y)y.value=u,h!==0&&this.j(y,h);else{switch(y={key:t,value:u,next:void 0,previous:void 0},h){case 0:this.h(y);break;case 1:this.g(y);break;case 2:this.h(y);break;default:this.h(y);break}this.a.set(t,y),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const u=this.a.get(t);if(u)return this.a.delete(t),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,u){const h=this.e;let y=this.b;for(;y;){if(u?t.bind(u)(y.value,y.key,this):t(y.value,y.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const t=this,u=this.e;let h=this.b;const y={[Symbol.iterator](){return y},next(){if(t.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const C={value:h.key,done:!1};return h=h.next,C}else return{value:void 0,done:!0}}};return y}values(){const t=this,u=this.e;let h=this.b;const y={[Symbol.iterator](){return y},next(){if(t.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const C={value:h.value,done:!1};return h=h.next,C}else return{value:void 0,done:!0}}};return y}entries(){const t=this,u=this.e;let h=this.b;const y={[Symbol.iterator](){return y},next(){if(t.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const C={value:[h.key,h.value],done:!1};return h=h.next,C}else return{value:void 0,done:!0}}};return y}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let u=this.b,h=this.size;for(;u&&h>t;)this.a.delete(u.key),u=u.next,h--;this.b=u,this.d=h,u&&(u.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const u=t.next,h=t.previous;if(!u||!h)throw new Error("Invalid list");u.previous=h,h.next=u}t.next=void 0,t.previous=void 0,this.e++}j(t,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(t===this.b)return;const h=t.next,y=t.previous;t===this.c?(y.next=void 0,this.c=y):(h.previous=y,y.next=h),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(u===2){if(t===this.c)return;const h=t.next,y=t.previous;t===this.b?(h.previous=void 0,this.b=h):(h.previous=y,y.next=h),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((u,h)=>{t.push([h,u])}),t}fromJSON(t){this.clear();for(const[u,h]of t)this.set(u,h)}}e.LinkedMap=c;class p extends c{constructor(t,u=1){super(),this.k=t,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,u=2){return super.get(t,u)}peek(t){return super.get(t,0)}set(t,u){return super.set(t,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=p;class g{constructor(){this.a=new Map}add(t){return this.a.set(t,(this.a.get(t)||0)+1),this}delete(t){let u=this.a.get(t)||0;return u===0?!1:(u--,u===0?this.a.delete(t):this.a.set(t,u),!0)}has(t){return this.a.has(t)}}e.CounterSet=g}),function(te,e){typeof define=="function"&&define.amd?define(Re[116],Oe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(we,ge){for(var ke=0;ke<ge.length;ke++){var ae=ge[ke];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(we,ae.key,ae)}}function i(we,ge,ke){return ge&&e(we.prototype,ge),ke&&e(we,ke),Object.defineProperty(we,"prototype",{writable:!1}),we}function k(we,ge){if(we){if(typeof we=="string")return D(we,ge);var ke=Object.prototype.toString.call(we).slice(8,-1);if(ke==="Object"&&we.constructor&&(ke=we.constructor.name),ke==="Map"||ke==="Set")return Array.from(we);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return D(we,ge)}}function D(we,ge){(ge==null||ge>we.length)&&(ge=we.length);for(var ke=0,ae=new Array(ge);ke<ge;ke++)ae[ke]=we[ke];return ae}function N(we,ge){var ke=typeof Symbol<"u"&&we[Symbol.iterator]||we["@@iterator"];if(ke)return(ke=ke.call(we)).next.bind(ke);if(Array.isArray(we)||(ke=k(we))||ge&&we&&typeof we.length=="number"){ke&&(we=ke);var ae=0;return function(){return ae>=we.length?{done:!0}:{done:!1,value:we[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function F(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=F();function R(we){te.defaults=we}var S=/[&<>"']/,m=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ge){return c[ge]};function g(we,ge){if(ge){if(S.test(we))return we.replace(m,p)}else if(O.test(we))return we.replace(w,p);return we}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(we){return we.replace(d,function(ge,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var u=/(^|[^\[])\^/g;function h(we,ge){we=typeof we=="string"?we:we.source,ge=ge||"";var ke={replace:function(de,Z){return Z=Z.source||Z,Z=Z.replace(u,"$1"),we=we.replace(de,Z),ke},getRegex:function(){return new RegExp(we,ge)}};return ke}var y=/[^\w:]/g,C=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(we,ge,ke){if(we){var ae;try{ae=decodeURIComponent(t(ke)).replace(y,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}ge&&!C.test(ke)&&(ke=b(ge,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var n={},l=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(we,ge){n[" "+we]||(l.test(we)?n[" "+we]=we+"/":n[" "+we]=E(we,"/",!0)),we=n[" "+we];var ke=we.indexOf(":")===-1;return ge.substring(0,2)==="//"?ke?ge:we.replace(r,"$1")+ge:ge.charAt(0)==="/"?ke?ge:we.replace(a,"$1")+ge:we+ge}var I={exec:function(){}};function f(we){for(var ge=1,ke,ae;ge<arguments.length;ge++){ke=arguments[ge];for(ae in ke)Object.prototype.hasOwnProperty.call(ke,ae)&&(we[ae]=ke[ae])}return we}function P(we,ge){var ke=we.replace(/\|/g,function(Z,ne,T){for(var H=!1,j=ne;--j>=0&&T[j]==="\\";)H=!H;return H?"|":" |"}),ae=ke.split(/ \|/),de=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>ge)ae.splice(ge);else for(;ae.length<ge;)ae.push("");for(;de<ae.length;de++)ae[de]=ae[de].trim().replace(/\\\|/g,"|");return ae}function E(we,ge,ke){var ae=we.length;if(ae===0)return"";for(var de=0;de<ae;){var Z=we.charAt(ae-de-1);if(Z===ge&&!ke)de++;else if(Z!==ge&&ke)de++;else break}return we.slice(0,ae-de)}function o(we,ge){if(we.indexOf(ge[1])===-1)return-1;for(var ke=we.length,ae=0,de=0;de<ke;de++)if(we[de]==="\\")de++;else if(we[de]===ge[0])ae++;else if(we[de]===ge[1]&&(ae--,ae<0))return de;return-1}function s(we){we&&we.sanitize&&!we.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(we,ge){if(ge<1)return"";for(var ke="";ge>1;)ge&1&&(ke+=we),ge>>=1,we+=we;return ke+we}function B(we,ge,ke,ae){var de=ge.href,Z=ge.title?g(ge.title):null,ne=we[1].replace(/\\([\[\]])/g,"$1");if(we[0].charAt(0)!=="!"){ae.state.inLink=!0;var T={type:"link",raw:ke,href:de,title:Z,text:ne,tokens:ae.inlineTokens(ne)};return ae.state.inLink=!1,T}return{type:"image",raw:ke,href:de,title:Z,text:g(ne)}}function X(we,ge){var ke=we.match(/^(\s+)(?:```)/);if(ke===null)return ge;var ae=ke[1];return ge.split(`
`).map(function(de){var Z=de.match(/^\s+/);if(Z===null)return de;var ne=Z[0];return ne.length>=ae.length?de.slice(ae.length):de}).join(`
`)}var G=function(){function we(ke){this.options=ke||te.defaults}var ge=we.prototype;return ge.space=function(ae){var de=this.rules.block.newline.exec(ae);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},ge.code=function(ae){var de=this.rules.block.code.exec(ae);if(de){var Z=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:E(Z,`
`)}}},ge.fences=function(ae){var de=this.rules.block.fences.exec(ae);if(de){var Z=de[0],ne=X(Z,de[3]||"");return{type:"code",raw:Z,lang:de[2]?de[2].trim():de[2],text:ne}}},ge.heading=function(ae){var de=this.rules.block.heading.exec(ae);if(de){var Z=de[2].trim();if(/#$/.test(Z)){var ne=E(Z,"#");(this.options.pedantic||!ne||/ $/.test(ne))&&(Z=ne.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:Z,tokens:this.lexer.inline(Z)}}},ge.hr=function(ae){var de=this.rules.block.hr.exec(ae);if(de)return{type:"hr",raw:de[0]}},ge.blockquote=function(ae){var de=this.rules.block.blockquote.exec(ae);if(de){var Z=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(Z,[]),text:Z}}},ge.list=function(ae){var de=this.rules.block.list.exec(ae);if(de){var Z,ne,T,H,j,x,ce,pe,ie,ye,Se,Be,je=de[1].trim(),Ze=je.length>1,Qe={type:"list",raw:"",ordered:Ze,start:Ze?+je.slice(0,-1):"",loose:!1,items:[]};je=Ze?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Ze?je:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Be=!1,!(!(de=Ke.exec(ae))||this.rules.block.hr.test(ae)));){if(Z=de[0],ae=ae.substring(Z.length),pe=de[2].split(`
`,1)[0],ie=ae.split(`
`,1)[0],this.options.pedantic?(H=2,Se=pe.trimLeft()):(H=de[2].search(/[^ ]/),H=H>4?1:H,Se=pe.slice(H),H+=de[1].length),x=!1,!pe&&/^ *$/.test(ie)&&(Z+=ie+`
`,ae=ae.substring(ie.length+1),Be=!0),!Be)for(var it=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),Ne=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");ae&&(ye=ae.split(`
`,1)[0],pe=ye,this.options.pedantic&&(pe=pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(pe)||Ne.test(pe)||it.test(pe)||st.test(ae)));){if(pe.search(/[^ ]/)>=H||!pe.trim())Se+=`
`+pe.slice(H);else if(!x)Se+=`
`+pe;else break;!x&&!pe.trim()&&(x=!0),Z+=ye+`
`,ae=ae.substring(ye.length+1)}Qe.loose||(ce?Qe.loose=!0:/\n *\n *$/.test(Z)&&(ce=!0)),this.options.gfm&&(ne=/^\[[ xX]\] /.exec(Se),ne&&(T=ne[0]!=="[ ] ",Se=Se.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:Z,task:!!ne,checked:T,loose:!1,text:Se}),Qe.raw+=Z}Qe.items[Qe.items.length-1].raw=Z.trimRight(),Qe.items[Qe.items.length-1].text=Se.trimRight(),Qe.raw=Qe.raw.trimRight();var dt=Qe.items.length;for(j=0;j<dt;j++){this.lexer.state.top=!1,Qe.items[j].tokens=this.lexer.blockTokens(Qe.items[j].text,[]);var J=Qe.items[j].tokens.filter(function(fe){return fe.type==="space"}),_=J.every(function(fe){for(var $e=fe.raw.split(""),qe=0,We=N($e),_e;!(_e=We()).done;){var mt=_e.value;if(mt===`
`&&(qe+=1),qe>1)return!0}return!1});!Qe.loose&&J.length&&_&&(Qe.loose=!0,Qe.items[j].loose=!0)}return Qe}},ge.html=function(ae){var de=this.rules.block.html.exec(ae);if(de){var Z={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ne=this.options.sanitizer?this.options.sanitizer(de[0]):g(de[0]);Z.type="paragraph",Z.text=ne,Z.tokens=this.lexer.inline(ne)}return Z}},ge.def=function(ae){var de=this.rules.block.def.exec(ae);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var Z=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Z,raw:de[0],href:de[2],title:de[3]}}},ge.table=function(ae){var de=this.rules.block.table.exec(ae);if(de){var Z={type:"table",header:P(de[1]).map(function(ce){return{text:ce}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=de[0];var ne=Z.align.length,T,H,j,x;for(T=0;T<ne;T++)/^ *-+: *$/.test(Z.align[T])?Z.align[T]="right":/^ *:-+: *$/.test(Z.align[T])?Z.align[T]="center":/^ *:-+ *$/.test(Z.align[T])?Z.align[T]="left":Z.align[T]=null;for(ne=Z.rows.length,T=0;T<ne;T++)Z.rows[T]=P(Z.rows[T],Z.header.length).map(function(ce){return{text:ce}});for(ne=Z.header.length,H=0;H<ne;H++)Z.header[H].tokens=this.lexer.inline(Z.header[H].text);for(ne=Z.rows.length,H=0;H<ne;H++)for(x=Z.rows[H],j=0;j<x.length;j++)x[j].tokens=this.lexer.inline(x[j].text);return Z}}},ge.lheading=function(ae){var de=this.rules.block.lheading.exec(ae);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},ge.paragraph=function(ae){var de=this.rules.block.paragraph.exec(ae);if(de){var Z=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:Z,tokens:this.lexer.inline(Z)}}},ge.text=function(ae){var de=this.rules.block.text.exec(ae);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},ge.escape=function(ae){var de=this.rules.inline.escape.exec(ae);if(de)return{type:"escape",raw:de[0],text:g(de[1])}},ge.tag=function(ae){var de=this.rules.inline.tag.exec(ae);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):g(de[0]):de[0]}},ge.link=function(ae){var de=this.rules.inline.link.exec(ae);if(de){var Z=de[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var ne=E(Z.slice(0,-1),"\\");if((Z.length-ne.length)%2===0)return}else{var T=o(de[2],"()");if(T>-1){var H=de[0].indexOf("!")===0?5:4,j=H+de[1].length+T;de[2]=de[2].substring(0,T),de[0]=de[0].substring(0,j).trim(),de[3]=""}}var x=de[2],ce="";if(this.options.pedantic){var pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(x);pe&&(x=pe[1],ce=pe[3])}else ce=de[3]?de[3].slice(1,-1):"";return x=x.trim(),/^</.test(x)&&(this.options.pedantic&&!/>$/.test(Z)?x=x.slice(1):x=x.slice(1,-1)),B(de,{href:x&&x.replace(this.rules.inline._escapes,"$1"),title:ce&&ce.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ge.reflink=function(ae,de){var Z;if((Z=this.rules.inline.reflink.exec(ae))||(Z=this.rules.inline.nolink.exec(ae))){var ne=(Z[2]||Z[1]).replace(/\s+/g," ");if(ne=de[ne.toLowerCase()],!ne||!ne.href){var T=Z[0].charAt(0);return{type:"text",raw:T,text:T}}return B(Z,ne,Z[0],this.lexer)}},ge.emStrong=function(ae,de,Z){Z===void 0&&(Z="");var ne=this.rules.inline.emStrong.lDelim.exec(ae);if(ne&&!(ne[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var T=ne[1]||ne[2]||"";if(!T||T&&(Z===""||this.rules.inline.punctuation.exec(Z))){var H=ne[0].length-1,j,x,ce=H,pe=0,ie=ne[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ie.lastIndex=0,de=de.slice(-1*ae.length+H);(ne=ie.exec(de))!=null;)if(j=ne[1]||ne[2]||ne[3]||ne[4]||ne[5]||ne[6],!!j){if(x=j.length,ne[3]||ne[4]){ce+=x;continue}else if((ne[5]||ne[6])&&H%3&&!((H+x)%3)){pe+=x;continue}if(ce-=x,!(ce>0)){if(x=Math.min(x,x+ce+pe),Math.min(H,x)%2){var ye=ae.slice(1,H+ne.index+x);return{type:"em",raw:ae.slice(0,H+ne.index+x+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}var Se=ae.slice(2,H+ne.index+x-1);return{type:"strong",raw:ae.slice(0,H+ne.index+x+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}}}}},ge.codespan=function(ae){var de=this.rules.inline.code.exec(ae);if(de){var Z=de[2].replace(/\n/g," "),ne=/[^ ]/.test(Z),T=/^ /.test(Z)&&/ $/.test(Z);return ne&&T&&(Z=Z.substring(1,Z.length-1)),Z=g(Z,!0),{type:"codespan",raw:de[0],text:Z}}},ge.br=function(ae){var de=this.rules.inline.br.exec(ae);if(de)return{type:"br",raw:de[0]}},ge.del=function(ae){var de=this.rules.inline.del.exec(ae);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},ge.autolink=function(ae,de){var Z=this.rules.inline.autolink.exec(ae);if(Z){var ne,T;return Z[2]==="@"?(ne=g(this.options.mangle?de(Z[1]):Z[1]),T="mailto:"+ne):(ne=g(Z[1]),T=ne),{type:"link",raw:Z[0],text:ne,href:T,tokens:[{type:"text",raw:ne,text:ne}]}}},ge.url=function(ae,de){var Z;if(Z=this.rules.inline.url.exec(ae)){var ne,T;if(Z[2]==="@")ne=g(this.options.mangle?de(Z[0]):Z[0]),T="mailto:"+ne;else{var H;do H=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(H!==Z[0]);ne=g(Z[0]),Z[1]==="www."?T="http://"+ne:T=ne}return{type:"link",raw:Z[0],text:ne,href:T,tokens:[{type:"text",raw:ne,text:ne}]}}},ge.inlineText=function(ae,de){var Z=this.rules.inline.text.exec(ae);if(Z){var ne;return this.lexer.state.inRawBlock?ne=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):g(Z[0]):Z[0]:ne=g(this.options.smartypants?de(Z[0]):Z[0]),{type:"text",raw:Z[0],text:ne}}},we}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=h(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=h(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=h(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=h(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=h(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=h(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=f({},W),W.gfm=f({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=h(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=h(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=f({},W.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:h(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=h(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=h(W._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=h(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=h(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=h(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=h(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=h(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=h(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=h(U.reflink).replace("label",U._label).replace("ref",W._label).getRegex(),U.nolink=h(U.nolink).replace("ref",W._label).getRegex(),U.reflinkSearch=h(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=f({},U),U.pedantic=f({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=f({},U.normal,{escape:h(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=h(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=f({},U.gfm,{br:h(U.br).replace("{2,}","*").getRegex(),text:h(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function q(we){return we.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(we){var ge="",ke,ae,de=we.length;for(ke=0;ke<de;ke++)ae=we.charCodeAt(ke),Math.random()>.5&&(ae="x"+ae.toString(16)),ge+="&#"+ae+";";return ge}var V=function(){function we(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||te.defaults,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:W.normal,inline:U.normal};this.options.pedantic?(ae.block=W.pedantic,ae.inline=U.pedantic):this.options.gfm&&(ae.block=W.gfm,this.options.breaks?ae.inline=U.breaks:ae.inline=U.gfm),this.tokenizer.rules=ae}we.lex=function(ae,de){var Z=new we(de);return Z.lex(ae)},we.lexInline=function(ae,de){var Z=new we(de);return Z.inlineTokens(ae)};var ge=we.prototype;return ge.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ge.blockTokens=function(ae,de){var Z=this;de===void 0&&(de=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(ce,pe,ie){return pe+"    ".repeat(ie.length)});for(var ne,T,H,j;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ce){return(ne=ce.call({lexer:Z},ae,de))?(ae=ae.substring(ne.raw.length),de.push(ne),!0):!1}))){if(ne=this.tokenizer.space(ae)){ae=ae.substring(ne.raw.length),ne.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ne);continue}if(ne=this.tokenizer.code(ae)){ae=ae.substring(ne.raw.length),T=de[de.length-1],T&&(T.type==="paragraph"||T.type==="text")?(T.raw+=`
`+ne.raw,T.text+=`
`+ne.text,this.inlineQueue[this.inlineQueue.length-1].src=T.text):de.push(ne);continue}if(ne=this.tokenizer.fences(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.heading(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.hr(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.blockquote(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.list(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.html(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.def(ae)){ae=ae.substring(ne.raw.length),T=de[de.length-1],T&&(T.type==="paragraph"||T.type==="text")?(T.raw+=`
`+ne.raw,T.text+=`
`+ne.raw,this.inlineQueue[this.inlineQueue.length-1].src=T.text):this.tokens.links[ne.tag]||(this.tokens.links[ne.tag]={href:ne.href,title:ne.title});continue}if(ne=this.tokenizer.table(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.lheading(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(H=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var ce=1/0,pe=ae.slice(1),ie=void 0;Z.options.extensions.startBlock.forEach(function(ye){ie=ye.call({lexer:this},pe),typeof ie=="number"&&ie>=0&&(ce=Math.min(ce,ie))}),ce<1/0&&ce>=0&&(H=ae.substring(0,ce+1))}(),this.state.top&&(ne=this.tokenizer.paragraph(H))){T=de[de.length-1],j&&T.type==="paragraph"?(T.raw+=`
`+ne.raw,T.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=T.text):de.push(ne),j=H.length!==ae.length,ae=ae.substring(ne.raw.length);continue}if(ne=this.tokenizer.text(ae)){ae=ae.substring(ne.raw.length),T=de[de.length-1],T&&T.type==="text"?(T.raw+=`
`+ne.raw,T.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=T.text):de.push(ne);continue}if(ae){var x="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return this.state.top=!0,de},ge.inline=function(ae,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:ae,tokens:de}),de},ge.inlineTokens=function(ae,de){var Z=this;de===void 0&&(de=[]);var ne,T,H,j=ae,x,ce,pe;if(this.tokens.links){var ie=Object.keys(this.tokens.links);if(ie.length>0)for(;(x=this.tokenizer.rules.inline.reflinkSearch.exec(j))!=null;)ie.includes(x[0].slice(x[0].lastIndexOf("[")+1,-1))&&(j=j.slice(0,x.index)+"["+M("a",x[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(x=this.tokenizer.rules.inline.blockSkip.exec(j))!=null;)j=j.slice(0,x.index)+"["+M("a",x[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(x=this.tokenizer.rules.inline.escapedEmSt.exec(j))!=null;)j=j.slice(0,x.index)+"++"+j.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(ce||(pe=""),ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Se){return(ne=Se.call({lexer:Z},ae,de))?(ae=ae.substring(ne.raw.length),de.push(ne),!0):!1}))){if(ne=this.tokenizer.escape(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.tag(ae)){ae=ae.substring(ne.raw.length),T=de[de.length-1],T&&ne.type==="text"&&T.type==="text"?(T.raw+=ne.raw,T.text+=ne.text):de.push(ne);continue}if(ne=this.tokenizer.link(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(ne.raw.length),T=de[de.length-1],T&&ne.type==="text"&&T.type==="text"?(T.raw+=ne.raw,T.text+=ne.text):de.push(ne);continue}if(ne=this.tokenizer.emStrong(ae,j,pe)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.codespan(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.br(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.del(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.autolink(ae,z)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(!this.state.inLink&&(ne=this.tokenizer.url(ae,z))){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(H=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var Se=1/0,Be=ae.slice(1),je=void 0;Z.options.extensions.startInline.forEach(function(Ze){je=Ze.call({lexer:this},Be),typeof je=="number"&&je>=0&&(Se=Math.min(Se,je))}),Se<1/0&&Se>=0&&(H=ae.substring(0,Se+1))}(),ne=this.tokenizer.inlineText(H,q)){ae=ae.substring(ne.raw.length),ne.raw.slice(-1)!=="_"&&(pe=ne.raw.slice(-1)),ce=!0,T=de[de.length-1],T&&T.type==="text"?(T.raw+=ne.raw,T.text+=ne.text):de.push(ne);continue}if(ae){var ye="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return de},i(we,null,[{key:"rules",get:function(){return{block:W,inline:U}}}]),we}(),ee=function(){function we(ke){this.options=ke||te.defaults}var ge=we.prototype;return ge.code=function(ae,de,Z){var ne=(de||"").match(/\S*/)[0];if(this.options.highlight){var T=this.options.highlight(ae,ne);T!=null&&T!==ae&&(Z=!0,ae=T)}return ae=ae.replace(/\n$/,"")+`
`,ne?'<pre><code class="'+this.options.langPrefix+g(ne,!0)+'">'+(Z?ae:g(ae,!0))+`</code></pre>
`:"<pre><code>"+(Z?ae:g(ae,!0))+`</code></pre>
`},ge.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},ge.html=function(ae){return ae},ge.heading=function(ae,de,Z,ne){if(this.options.headerIds){var T=this.options.headerPrefix+ne.slug(Z);return"<h"+de+' id="'+T+'">'+ae+"</h"+de+`>
`}return"<h"+de+">"+ae+"</h"+de+`>
`},ge.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ge.list=function(ae,de,Z){var ne=de?"ol":"ul",T=de&&Z!==1?' start="'+Z+'"':"";return"<"+ne+T+`>
`+ae+"</"+ne+`>
`},ge.listitem=function(ae){return"<li>"+ae+`</li>
`},ge.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ge.paragraph=function(ae){return"<p>"+ae+`</p>
`},ge.table=function(ae,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+de+`</table>
`},ge.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},ge.tablecell=function(ae,de){var Z=de.header?"th":"td",ne=de.align?"<"+Z+' align="'+de.align+'">':"<"+Z+">";return ne+ae+("</"+Z+`>
`)},ge.strong=function(ae){return"<strong>"+ae+"</strong>"},ge.em=function(ae){return"<em>"+ae+"</em>"},ge.codespan=function(ae){return"<code>"+ae+"</code>"},ge.br=function(){return this.options.xhtml?"<br/>":"<br>"},ge.del=function(ae){return"<del>"+ae+"</del>"},ge.link=function(ae,de,Z){if(ae=v(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Z;var ne='<a href="'+g(ae)+'"';return de&&(ne+=' title="'+de+'"'),ne+=">"+Z+"</a>",ne},ge.image=function(ae,de,Z){if(ae=v(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Z;var ne='<img src="'+ae+'" alt="'+Z+'"';return de&&(ne+=' title="'+de+'"'),ne+=this.options.xhtml?"/>":">",ne},ge.text=function(ae){return ae},we}(),Ce=function(){function we(){}var ge=we.prototype;return ge.strong=function(ae){return ae},ge.em=function(ae){return ae},ge.codespan=function(ae){return ae},ge.del=function(ae){return ae},ge.html=function(ae){return ae},ge.text=function(ae){return ae},ge.link=function(ae,de,Z){return""+Z},ge.image=function(ae,de,Z){return""+Z},ge.br=function(){return""},we}(),oe=function(){function we(){this.seen={}}var ge=we.prototype;return ge.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ge.getNextSafeSlug=function(ae,de){var Z=ae,ne=0;if(this.seen.hasOwnProperty(Z)){ne=this.seen[ae];do ne++,Z=ae+"-"+ne;while(this.seen.hasOwnProperty(Z))}return de||(this.seen[ae]=ne,this.seen[Z]=0),Z},ge.slug=function(ae,de){de===void 0&&(de={});var Z=this.serialize(ae);return this.getNextSafeSlug(Z,de.dryrun)},we}(),le=function(){function we(ke){this.options=ke||te.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ce,this.slugger=new oe}we.parse=function(ae,de){var Z=new we(de);return Z.parse(ae)},we.parseInline=function(ae,de){var Z=new we(de);return Z.parseInline(ae)};var ge=we.prototype;return ge.parse=function(ae,de){de===void 0&&(de=!0);var Z="",ne,T,H,j,x,ce,pe,ie,ye,Se,Be,je,Ze,Qe,Ke,it,st,tt,Ne,dt=ae.length;for(ne=0;ne<dt;ne++){if(Se=ae[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Se.type]&&(Ne=this.options.extensions.renderers[Se.type].call({parser:this},Se),Ne!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Se.type))){Z+=Ne||"";continue}switch(Se.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(Se.tokens),Se.depth,t(this.parseInline(Se.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(Se.text,Se.lang,Se.escaped);continue}case"table":{for(ie="",pe="",j=Se.header.length,T=0;T<j;T++)pe+=this.renderer.tablecell(this.parseInline(Se.header[T].tokens),{header:!0,align:Se.align[T]});for(ie+=this.renderer.tablerow(pe),ye="",j=Se.rows.length,T=0;T<j;T++){for(ce=Se.rows[T],pe="",x=ce.length,H=0;H<x;H++)pe+=this.renderer.tablecell(this.parseInline(ce[H].tokens),{header:!1,align:Se.align[H]});ye+=this.renderer.tablerow(pe)}Z+=this.renderer.table(ie,ye);continue}case"blockquote":{ye=this.parse(Se.tokens),Z+=this.renderer.blockquote(ye);continue}case"list":{for(Be=Se.ordered,je=Se.start,Ze=Se.loose,j=Se.items.length,ye="",T=0;T<j;T++)Ke=Se.items[T],it=Ke.checked,st=Ke.task,Qe="",Ke.task&&(tt=this.renderer.checkbox(it),Ze?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=tt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=tt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:tt}):Qe+=tt),Qe+=this.parse(Ke.tokens,Ze),ye+=this.renderer.listitem(Qe,st,it);Z+=this.renderer.list(ye,Be,je);continue}case"html":{Z+=this.renderer.html(Se.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(Se.tokens));continue}case"text":{for(ye=Se.tokens?this.parseInline(Se.tokens):Se.text;ne+1<dt&&ae[ne+1].type==="text";)Se=ae[++ne],ye+=`
`+(Se.tokens?this.parseInline(Se.tokens):Se.text);Z+=de?this.renderer.paragraph(ye):ye;continue}default:{var J='Token with "'+Se.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return Z},ge.parseInline=function(ae,de){de=de||this.renderer;var Z="",ne,T,H,j=ae.length;for(ne=0;ne<j;ne++){if(T=ae[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[T.type]&&(H=this.options.extensions.renderers[T.type].call({parser:this},T),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(T.type))){Z+=H||"";continue}switch(T.type){case"escape":{Z+=de.text(T.text);break}case"html":{Z+=de.html(T.text);break}case"link":{Z+=de.link(T.href,T.title,this.parseInline(T.tokens,de));break}case"image":{Z+=de.image(T.href,T.title,T.text);break}case"strong":{Z+=de.strong(this.parseInline(T.tokens,de));break}case"em":{Z+=de.em(this.parseInline(T.tokens,de));break}case"codespan":{Z+=de.codespan(T.text);break}case"br":{Z+=de.br();break}case"del":{Z+=de.del(this.parseInline(T.tokens,de));break}case"text":{Z+=de.text(T.text);break}default:{var x='Token with "'+T.type+'" type was not found.';if(this.options.silent){console.error(x);return}else throw new Error(x)}}}return Z},we}();function Q(we,ge,ke){if(typeof we>"u"||we===null)throw new Error("marked(): input parameter is undefined or null");if(typeof we!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(we)+", string expected");if(typeof ge=="function"&&(ke=ge,ge=null),ge=f({},Q.defaults,ge||{}),s(ge),ke){var ae=ge.highlight,de;try{de=V.lex(we,ge)}catch(j){return ke(j)}var Z=function(x){var ce;if(!x)try{ge.walkTokens&&Q.walkTokens(de,ge.walkTokens),ce=le.parse(de,ge)}catch(pe){x=pe}return ge.highlight=ae,x?ke(x):ke(null,ce)};if(!ae||ae.length<3||(delete ge.highlight,!de.length))return Z();var ne=0;Q.walkTokens(de,function(j){j.type==="code"&&(ne++,setTimeout(function(){ae(j.text,j.lang,function(x,ce){if(x)return Z(x);ce!=null&&ce!==j.text&&(j.text=ce,j.escaped=!0),ne--,ne===0&&Z()})},0))}),ne===0&&Z();return}function T(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+g(j.message+"",!0)+"</pre>";throw j}try{var H=V.lex(we,ge);if(ge.walkTokens){if(ge.async)return Promise.all(Q.walkTokens(H,ge.walkTokens)).then(function(){return le.parse(H,ge)}).catch(T);Q.walkTokens(H,ge.walkTokens)}return le.parse(H,ge)}catch(j){T(j)}}Q.options=Q.setOptions=function(we){return f(Q.defaults,we),R(Q.defaults),Q},Q.getDefaults=F,Q.defaults=te.defaults,Q.use=function(){for(var we=arguments.length,ge=new Array(we),ke=0;ke<we;ke++)ge[ke]=arguments[ke];var ae=f.apply(void 0,[{}].concat(ge)),de=Q.defaults.extensions||{renderers:{},childTokens:{}},Z;ge.forEach(function(ne){if(ne.extensions&&(Z=!0,ne.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var j=de.renderers?de.renderers[H.name]:null;j?de.renderers[H.name]=function(){for(var x=arguments.length,ce=new Array(x),pe=0;pe<x;pe++)ce[pe]=arguments[pe];var ie=H.renderer.apply(this,ce);return ie===!1&&(ie=j.apply(this,ce)),ie}:de.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[H.level]?de[H.level].unshift(H.tokenizer):de[H.level]=[H.tokenizer],H.start&&(H.level==="block"?de.startBlock?de.startBlock.push(H.start):de.startBlock=[H.start]:H.level==="inline"&&(de.startInline?de.startInline.push(H.start):de.startInline=[H.start]))}H.childTokens&&(de.childTokens[H.name]=H.childTokens)})),ne.renderer&&function(){var H=Q.defaults.renderer||new ee,j=function(pe){var ie=H[pe];H[pe]=function(){for(var ye=arguments.length,Se=new Array(ye),Be=0;Be<ye;Be++)Se[Be]=arguments[Be];var je=ne.renderer[pe].apply(H,Se);return je===!1&&(je=ie.apply(H,Se)),je}};for(var x in ne.renderer)j(x);ae.renderer=H}(),ne.tokenizer&&function(){var H=Q.defaults.tokenizer||new G,j=function(pe){var ie=H[pe];H[pe]=function(){for(var ye=arguments.length,Se=new Array(ye),Be=0;Be<ye;Be++)Se[Be]=arguments[Be];var je=ne.tokenizer[pe].apply(H,Se);return je===!1&&(je=ie.apply(H,Se)),je}};for(var x in ne.tokenizer)j(x);ae.tokenizer=H}(),ne.walkTokens){var T=Q.defaults.walkTokens;ae.walkTokens=function(H){var j=[];return j.push(ne.walkTokens.call(this,H)),T&&(j=j.concat(T.call(this,H))),j}}Z&&(ae.extensions=de),Q.setOptions(ae)})},Q.walkTokens=function(we,ge){for(var ke=[],ae=function(){var T=Z.value;switch(ke=ke.concat(ge.call(Q,T)),T.type){case"table":{for(var H=N(T.header),j;!(j=H()).done;){var x=j.value;ke=ke.concat(Q.walkTokens(x.tokens,ge))}for(var ce=N(T.rows),pe;!(pe=ce()).done;)for(var ie=pe.value,ye=N(ie),Se;!(Se=ye()).done;){var Be=Se.value;ke=ke.concat(Q.walkTokens(Be.tokens,ge))}break}case"list":{ke=ke.concat(Q.walkTokens(T.items,ge));break}default:Q.defaults.extensions&&Q.defaults.extensions.childTokens&&Q.defaults.extensions.childTokens[T.type]?Q.defaults.extensions.childTokens[T.type].forEach(function(je){ke=ke.concat(Q.walkTokens(T[je],ge))}):T.tokens&&(ke=ke.concat(Q.walkTokens(T.tokens,ge)))}},de=N(we),Z;!(Z=de()).done;)ae();return ke},Q.parseInline=function(we,ge){if(typeof we>"u"||we===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof we!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(we)+", string expected");ge=f({},Q.defaults,ge||{}),s(ge);try{var ke=V.lexInline(we,ge);return ge.walkTokens&&Q.walkTokens(ke,ge.walkTokens),le.parseInline(ke,ge)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+g(ae.message+"",!0)+"</pre>";throw ae}},Q.Parser=le,Q.parser=le.parse,Q.Renderer=ee,Q.TextRenderer=Ce,Q.Lexer=V,Q.lexer=V.lex,Q.Tokenizer=G,Q.Slugger=oe,Q.parse=Q;var ue=Q.options,Ie=Q.setOptions,Pe=Q.use,be=Q.walkTokens,A=Q.parseInline,K=Q,he=le.parse,De=V.lex;te.Lexer=V,te.Parser=le,te.Renderer=ee,te.Slugger=oe,te.TextRenderer=Ce,te.Tokenizer=G,te.getDefaults=F,te.lexer=De,te.marked=Q,te.options=ue,te.parse=K,te.parseInline=A,te.parser=he,te.setOptions=Ie,te.use=Pe,te.walkTokens=be,Object.defineProperty(te,"__esModule",{value:!0})}),define(Re[117],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(R,S,m){return Math.min(Math.max(R,S),m)}e.clamp=i;function k(R,S){return(S+R%S)%S}e.rot=k;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class N{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=N;class F{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const m=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=F}),function(){function te(D){const N=[];typeof D=="number"&&N.push("code/timeOrigin",D);function F(S){N.push(S,Date.now())}function R(){const S=[];for(let m=0;m<N.length;m+=2)S.push({name:N[m],startTime:N[m+1]});return S}return{mark:F,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const F of performance.getEntriesByType("mark"))N.push({name:F.name,startTime:Math.round(D+F.startTime)});return N}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function i(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=i(k))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var k in i)(typeof exports=="object"?exports:te)[k]=i[k]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function i(k){if(e[k])return e[k].exports;var D=e[k]={i:k,l:!1,exports:{}};return te[k].call(D.exports,D,D.exports,i),D.l=!0,D.exports}return i.m=te,i.c=e,i.d=function(k,D,N){i.o(k,D)||Object.defineProperty(k,D,{enumerable:!0,get:N})},i.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},i.t=function(k,D){if(1&D&&(k=i(k)),8&D||4&D&&typeof k=="object"&&k&&k.__esModule)return k;var N=Object.create(null);if(i.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:k}),2&D&&typeof k!="string")for(var F in k)i.d(N,F,function(R){return k[R]}.bind(null,F));return N},i.n=function(k){var D=k&&k.__esModule?function(){return k.default}:function(){return k};return i.d(D,"a",D),D},i.o=function(k,D){return Object.prototype.hasOwnProperty.call(k,D)},i.p="",i(i.s=0)}([function(te,e,i){(function(k){var D;e=te.exports=Pe,D=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,F=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],m=0,O=m++;S[O]="0|[1-9]\\d*";var w=m++;S[w]="[0-9]+";var c=m++;S[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=m++;S[p]="("+S[O]+")\\.("+S[O]+")\\.("+S[O]+")";var g=m++;S[g]="("+S[w]+")\\.("+S[w]+")\\.("+S[w]+")";var d=m++;S[d]="(?:"+S[O]+"|"+S[c]+")";var t=m++;S[t]="(?:"+S[w]+"|"+S[c]+")";var u=m++;S[u]="(?:-("+S[d]+"(?:\\."+S[d]+")*))";var h=m++;S[h]="(?:-?("+S[t]+"(?:\\."+S[t]+")*))";var y=m++;S[y]="[0-9A-Za-z-]+";var C=m++;S[C]="(?:\\+("+S[y]+"(?:\\."+S[y]+")*))";var v=m++,n="v?"+S[p]+S[u]+"?"+S[C]+"?";S[v]="^"+n+"$";var l="[v=\\s]*"+S[g]+S[h]+"?"+S[C]+"?",r=m++;S[r]="^"+l+"$";var a=m++;S[a]="((?:<|>)?=?)";var b=m++;S[b]=S[w]+"|x|X|\\*";var I=m++;S[I]=S[O]+"|x|X|\\*";var f=m++;S[f]="[v=\\s]*("+S[I]+")(?:\\.("+S[I]+")(?:\\.("+S[I]+")(?:"+S[u]+")?"+S[C]+"?)?)?";var P=m++;S[P]="[v=\\s]*("+S[b]+")(?:\\.("+S[b]+")(?:\\.("+S[b]+")(?:"+S[h]+")?"+S[C]+"?)?)?";var E=m++;S[E]="^"+S[a]+"\\s*"+S[f]+"$";var o=m++;S[o]="^"+S[a]+"\\s*"+S[P]+"$";var s=m++;S[s]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=m++;S[M]="(?:~>?)";var B=m++;S[B]="(\\s*)"+S[M]+"\\s+",R[B]=new RegExp(S[B],"g");var X=m++;S[X]="^"+S[M]+S[f]+"$";var G=m++;S[G]="^"+S[M]+S[P]+"$";var W=m++;S[W]="(?:\\^)";var U=m++;S[U]="(\\s*)"+S[W]+"\\s+",R[U]=new RegExp(S[U],"g");var q=m++;S[q]="^"+S[W]+S[f]+"$";var z=m++;S[z]="^"+S[W]+S[P]+"$";var V=m++;S[V]="^"+S[a]+"\\s*("+l+")$|^$";var ee=m++;S[ee]="^"+S[a]+"\\s*("+n+")$|^$";var Ce=m++;S[Ce]="(\\s*)"+S[a]+"\\s*("+l+"|"+S[f]+")",R[Ce]=new RegExp(S[Ce],"g");var oe=m++;S[oe]="^\\s*("+S[f]+")\\s+-\\s+("+S[f]+")\\s*$";var le=m++;S[le]="^\\s*("+S[P]+")\\s+-\\s+("+S[P]+")\\s*$";var Q=m++;S[Q]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)D(ue,S[ue]),R[ue]||(R[ue]=new RegExp(S[ue]));function Ie(ie,ye){if(ie instanceof Pe)return ie;if(typeof ie!="string"||ie.length>N||!(ye?R[r]:R[v]).test(ie))return null;try{return new Pe(ie,ye)}catch{return null}}function Pe(ie,ye){if(ie instanceof Pe){if(ie.loose===ye)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof Pe))return new Pe(ie,ye);D("SemVer",ie,ye),this.loose=ye;var Se=ie.trim().match(ye?R[r]:R[v]);if(!Se)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+Se[1],this.minor=+Se[2],this.patch=+Se[3],this.major>F||this.major<0)throw new TypeError("Invalid major version");if(this.minor>F||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>F||this.patch<0)throw new TypeError("Invalid patch version");Se[4]?this.prerelease=Se[4].split(".").map(function(Be){if(/^[0-9]+$/.test(Be)){var je=+Be;if(je>=0&&je<F)return je}return Be}):this.prerelease=[],this.build=Se[5]?Se[5].split("."):[],this.format()}e.parse=Ie,e.valid=function(ie,ye){var Se=Ie(ie,ye);return Se?Se.version:null},e.clean=function(ie,ye){var Se=Ie(ie.trim().replace(/^[=v]+/,""),ye);return Se?Se.version:null},e.SemVer=Pe,Pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Pe.prototype.toString=function(){return this.version},Pe.prototype.compare=function(ie){return D("SemVer.compare",this.version,this.loose,ie),ie instanceof Pe||(ie=new Pe(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},Pe.prototype.compareMain=function(ie){return ie instanceof Pe||(ie=new Pe(ie,this.loose)),A(this.major,ie.major)||A(this.minor,ie.minor)||A(this.patch,ie.patch)},Pe.prototype.comparePre=function(ie){if(ie instanceof Pe||(ie=new Pe(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ye=0;do{var Se=this.prerelease[ye],Be=ie.prerelease[ye];if(D("prerelease compare",ye,Se,Be),Se===void 0&&Be===void 0)return 0;if(Be===void 0)return 1;if(Se===void 0)return-1;if(Se!==Be)return A(Se,Be)}while(++ye)},Pe.prototype.inc=function(ie,ye){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ye);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ye);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ye),this.inc("pre",ye);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ye),this.inc("pre",ye);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Se=this.prerelease.length;--Se>=0;)typeof this.prerelease[Se]=="number"&&(this.prerelease[Se]++,Se=-2);Se===-1&&this.prerelease.push(0)}ye&&(this.prerelease[0]===ye?isNaN(this.prerelease[1])&&(this.prerelease=[ye,0]):this.prerelease=[ye,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ye,Se,Be){typeof Se=="string"&&(Be=Se,Se=void 0);try{return new Pe(ie,Se).inc(ye,Be).version}catch{return null}},e.diff=function(ie,ye){if(we(ie,ye))return null;var Se=Ie(ie),Be=Ie(ye);if(Se.prerelease.length||Be.prerelease.length){for(var je in Se)if((je==="major"||je==="minor"||je==="patch")&&Se[je]!==Be[je])return"pre"+je;return"prerelease"}for(var je in Se)if((je==="major"||je==="minor"||je==="patch")&&Se[je]!==Be[je])return je},e.compareIdentifiers=A;var be=/^[0-9]+$/;function A(ie,ye){var Se=be.test(ie),Be=be.test(ye);return Se&&Be&&(ie=+ie,ye=+ye),Se&&!Be?-1:Be&&!Se?1:ie<ye?-1:ie>ye?1:0}function K(ie,ye,Se){return new Pe(ie,Se).compare(new Pe(ye,Se))}function he(ie,ye,Se){return K(ie,ye,Se)>0}function De(ie,ye,Se){return K(ie,ye,Se)<0}function we(ie,ye,Se){return K(ie,ye,Se)===0}function ge(ie,ye,Se){return K(ie,ye,Se)!==0}function ke(ie,ye,Se){return K(ie,ye,Se)>=0}function ae(ie,ye,Se){return K(ie,ye,Se)<=0}function de(ie,ye,Se,Be){var je;switch(ye){case"===":typeof ie=="object"&&(ie=ie.version),typeof Se=="object"&&(Se=Se.version),je=ie===Se;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof Se=="object"&&(Se=Se.version),je=ie!==Se;break;case"":case"=":case"==":je=we(ie,Se,Be);break;case"!=":je=ge(ie,Se,Be);break;case">":je=he(ie,Se,Be);break;case">=":je=ke(ie,Se,Be);break;case"<":je=De(ie,Se,Be);break;case"<=":je=ae(ie,Se,Be);break;default:throw new TypeError("Invalid operator: "+ye)}return je}function Z(ie,ye){if(ie instanceof Z){if(ie.loose===ye)return ie;ie=ie.value}if(!(this instanceof Z))return new Z(ie,ye);D("comparator",ie,ye),this.loose=ye,this.parse(ie),this.semver===ne?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ie,ye){return A(ye,ie)},e.major=function(ie,ye){return new Pe(ie,ye).major},e.minor=function(ie,ye){return new Pe(ie,ye).minor},e.patch=function(ie,ye){return new Pe(ie,ye).patch},e.compare=K,e.compareLoose=function(ie,ye){return K(ie,ye,!0)},e.rcompare=function(ie,ye,Se){return K(ye,ie,Se)},e.sort=function(ie,ye){return ie.sort(function(Se,Be){return e.compare(Se,Be,ye)})},e.rsort=function(ie,ye){return ie.sort(function(Se,Be){return e.rcompare(Se,Be,ye)})},e.gt=he,e.lt=De,e.eq=we,e.neq=ge,e.gte=ke,e.lte=ae,e.cmp=de,e.Comparator=Z;var ne={};function T(ie,ye){if(ie instanceof T)return ie.loose===ye?ie:new T(ie.raw,ye);if(ie instanceof Z)return new T(ie.value,ye);if(!(this instanceof T))return new T(ie,ye);if(this.loose=ye,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(Se){return this.parseRange(Se.trim())},this).filter(function(Se){return Se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function H(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function j(ie,ye,Se,Be,je,Ze,Qe,Ke,it,st,tt,Ne,dt){return((ye=H(Se)?"":H(Be)?">="+Se+".0.0":H(je)?">="+Se+"."+Be+".0":">="+ye)+" "+(Ke=H(it)?"":H(st)?"<"+(+it+1)+".0.0":H(tt)?"<"+it+"."+(+st+1)+".0":Ne?"<="+it+"."+st+"."+tt+"-"+Ne:"<="+Ke)).trim()}function x(ie,ye){for(var Se=0;Se<ie.length;Se++)if(!ie[Se].test(ye))return!1;if(ye.prerelease.length){for(Se=0;Se<ie.length;Se++)if(D(ie[Se].semver),ie[Se].semver!==ne&&ie[Se].semver.prerelease.length>0){var Be=ie[Se].semver;if(Be.major===ye.major&&Be.minor===ye.minor&&Be.patch===ye.patch)return!0}return!1}return!0}function ce(ie,ye,Se){try{ye=new T(ye,Se)}catch{return!1}return ye.test(ie)}function pe(ie,ye,Se,Be){var je,Ze,Qe,Ke,it;switch(ie=new Pe(ie,Be),ye=new T(ye,Be),Se){case">":je=he,Ze=ae,Qe=De,Ke=">",it=">=";break;case"<":je=De,Ze=ke,Qe=he,Ke="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ce(ie,ye,Be))return!1;for(var st=0;st<ye.set.length;++st){var tt=ye.set[st],Ne=null,dt=null;if(tt.forEach(function(J){J.semver===ne&&(J=new Z(">=0.0.0")),Ne=Ne||J,dt=dt||J,je(J.semver,Ne.semver,Be)?Ne=J:Qe(J.semver,dt.semver,Be)&&(dt=J)}),Ne.operator===Ke||Ne.operator===it||(!dt.operator||dt.operator===Ke)&&Ze(ie,dt.semver)||dt.operator===it&&Qe(ie,dt.semver))return!1}return!0}Z.prototype.parse=function(ie){var ye=this.loose?R[V]:R[ee],Se=ie.match(ye);if(!Se)throw new TypeError("Invalid comparator: "+ie);this.operator=Se[1],this.operator==="="&&(this.operator=""),Se[2]?this.semver=new Pe(Se[2],this.loose):this.semver=ne},Z.prototype.toString=function(){return this.value},Z.prototype.test=function(ie){return D("Comparator.test",ie,this.loose),this.semver===ne||(typeof ie=="string"&&(ie=new Pe(ie,this.loose)),de(ie,this.operator,this.semver,this.loose))},Z.prototype.intersects=function(ie,ye){if(!(ie instanceof Z))throw new TypeError("a Comparator is required");var Se;if(this.operator==="")return Se=new T(ie.value,ye),ce(this.value,Se,ye);if(ie.operator==="")return Se=new T(this.value,ye),ce(ie.semver,Se,ye);var Be=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),Ze=this.semver.version===ie.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Ke=de(this.semver,"<",ie.semver,ye)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),it=de(this.semver,">",ie.semver,ye)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return Be||je||Ze&&Qe||Ke||it},e.Range=T,T.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},T.prototype.toString=function(){return this.range},T.prototype.parseRange=function(ie){var ye=this.loose;ie=ie.trim(),D("range",ie,ye);var Se=ye?R[le]:R[oe];ie=ie.replace(Se,j),D("hyphen replace",ie),ie=ie.replace(R[Ce],"$1$2$3"),D("comparator trim",ie,R[Ce]),ie=(ie=(ie=ie.replace(R[B],"$1~")).replace(R[U],"$1^")).split(/\s+/).join(" ");var Be=ye?R[V]:R[ee],je=ie.split(" ").map(function(Ze){return function(Qe,Ke){return D("comp",Qe),Qe=function(it,st){return it.trim().split(/\s+/).map(function(tt){return function(Ne,dt){D("caret",Ne,dt);var J=dt?R[z]:R[q];return Ne.replace(J,function(_,fe,$e,qe,We){var _e;return D("caret",Ne,_,fe,$e,qe,We),H(fe)?_e="":H($e)?_e=">="+fe+".0.0 <"+(+fe+1)+".0.0":H(qe)?_e=fe==="0"?">="+fe+"."+$e+".0 <"+fe+"."+(+$e+1)+".0":">="+fe+"."+$e+".0 <"+(+fe+1)+".0.0":We?(D("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),_e=fe==="0"?$e==="0"?">="+fe+"."+$e+"."+qe+We+" <"+fe+"."+$e+"."+(+qe+1):">="+fe+"."+$e+"."+qe+We+" <"+fe+"."+(+$e+1)+".0":">="+fe+"."+$e+"."+qe+We+" <"+(+fe+1)+".0.0"):(D("no pr"),_e=fe==="0"?$e==="0"?">="+fe+"."+$e+"."+qe+" <"+fe+"."+$e+"."+(+qe+1):">="+fe+"."+$e+"."+qe+" <"+fe+"."+(+$e+1)+".0":">="+fe+"."+$e+"."+qe+" <"+(+fe+1)+".0.0"),D("caret return",_e),_e})}(tt,st)}).join(" ")}(Qe,Ke),D("caret",Qe),Qe=function(it,st){return it.trim().split(/\s+/).map(function(tt){return function(Ne,dt){var J=dt?R[G]:R[X];return Ne.replace(J,function(_,fe,$e,qe,We){var _e;return D("tilde",Ne,_,fe,$e,qe,We),H(fe)?_e="":H($e)?_e=">="+fe+".0.0 <"+(+fe+1)+".0.0":H(qe)?_e=">="+fe+"."+$e+".0 <"+fe+"."+(+$e+1)+".0":We?(D("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),_e=">="+fe+"."+$e+"."+qe+We+" <"+fe+"."+(+$e+1)+".0"):_e=">="+fe+"."+$e+"."+qe+" <"+fe+"."+(+$e+1)+".0",D("tilde return",_e),_e})}(tt,st)}).join(" ")}(Qe,Ke),D("tildes",Qe),Qe=function(it,st){return D("replaceXRanges",it,st),it.split(/\s+/).map(function(tt){return function(Ne,dt){Ne=Ne.trim();var J=dt?R[o]:R[E];return Ne.replace(J,function(_,fe,$e,qe,We,_e){D("xRange",Ne,_,fe,$e,qe,We,_e);var mt=H($e),St=mt||H(qe),kt=St||H(We);return fe==="="&&kt&&(fe=""),mt?_=fe===">"||fe==="<"?"<0.0.0":"*":fe&&kt?(St&&(qe=0),kt&&(We=0),fe===">"?(fe=">=",St?($e=+$e+1,qe=0,We=0):kt&&(qe=+qe+1,We=0)):fe==="<="&&(fe="<",St?$e=+$e+1:qe=+qe+1),_=fe+$e+"."+qe+"."+We):St?_=">="+$e+".0.0 <"+(+$e+1)+".0.0":kt&&(_=">="+$e+"."+qe+".0 <"+$e+"."+(+qe+1)+".0"),D("xRange return",_),_})}(tt,st)}).join(" ")}(Qe,Ke),D("xrange",Qe),Qe=function(it,st){return D("replaceStars",it,st),it.trim().replace(R[Q],"")}(Qe,Ke),D("stars",Qe),Qe}(Ze,ye)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Ze){return!!Ze.match(Be)})),je=je.map(function(Ze){return new Z(Ze,ye)})},T.prototype.intersects=function(ie,ye){if(!(ie instanceof T))throw new TypeError("a Range is required");return this.set.some(function(Se){return Se.every(function(Be){return ie.set.some(function(je){return je.every(function(Ze){return Be.intersects(Ze,ye)})})})})},e.toComparators=function(ie,ye){return new T(ie,ye).set.map(function(Se){return Se.map(function(Be){return Be.value}).join(" ").trim().split(" ")})},T.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new Pe(ie,this.loose));for(var ye=0;ye<this.set.length;ye++)if(x(this.set[ye],ie))return!0;return!1},e.satisfies=ce,e.maxSatisfying=function(ie,ye,Se){var Be=null,je=null;try{var Ze=new T(ye,Se)}catch{return null}return ie.forEach(function(Qe){Ze.test(Qe)&&(Be&&je.compare(Qe)!==-1||(je=new Pe(Be=Qe,Se)))}),Be},e.minSatisfying=function(ie,ye,Se){var Be=null,je=null;try{var Ze=new T(ye,Se)}catch{return null}return ie.forEach(function(Qe){Ze.test(Qe)&&(Be&&je.compare(Qe)!==1||(je=new Pe(Be=Qe,Se)))}),Be},e.validRange=function(ie,ye){try{return new T(ie,ye).range||"*"}catch{return null}},e.ltr=function(ie,ye,Se){return pe(ie,ye,"<",Se)},e.gtr=function(ie,ye,Se){return pe(ie,ye,">",Se)},e.outside=pe,e.prerelease=function(ie,ye){var Se=Ie(ie,ye);return Se&&Se.prerelease.length?Se.prerelease:null},e.intersects=function(ie,ye,Se){return ie=new T(ie,Se),ye=new T(ye,Se),ie.intersects(ye)},e.coerce=function(ie){if(ie instanceof Pe)return ie;if(typeof ie!="string")return null;var ye=ie.match(R[s]);return ye==null?null:Ie((ye[1]||"0")+"."+(ye[2]||"0")+"."+(ye[3]||"0"))}}).call(this,i(1))},function(te,e){var i,k,D=te.exports={};function N(){throw new Error("setTimeout has not been defined")}function F(){throw new Error("clearTimeout has not been defined")}function R(t){if(i===setTimeout)return setTimeout(t,0);if((i===N||!i)&&setTimeout)return i=setTimeout,setTimeout(t,0);try{return i(t,0)}catch{try{return i.call(null,t,0)}catch{return i.call(this,t,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:N}catch{i=N}try{k=typeof clearTimeout=="function"?clearTimeout:F}catch{k=F}})();var S,m=[],O=!1,w=-1;function c(){O&&S&&(O=!1,S.length?m=S.concat(m):w=-1,m.length&&p())}function p(){if(!O){var t=R(c);O=!0;for(var u=m.length;u;){for(S=m,m=[];++w<u;)S&&S[w].run();w=-1,u=m.length}S=null,O=!1,function(h){if(k===clearTimeout)return clearTimeout(h);if((k===F||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(h);try{k(h)}catch{try{return k.call(null,h)}catch{return k.call(this,h)}}}(t)}}function g(t,u){this.fun=t,this.array=u}function d(){}D.nextTick=function(t){var u=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)u[h-1]=arguments[h];m.push(new g(t,u)),m.length!==1||O||R(p)},g.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=d,D.addListener=d,D.once=d,D.off=d,D.removeListener=d,D.removeAllListeners=d,D.emit=d,D.prependListener=d,D.prependOnceListener=d,D.listeners=function(t){return[]},D.binding=function(t){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(t){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Re[118],Oe([1,0,10,6]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(C){const v=C;return v?typeof v.read=="function":!1}e.isReadable=D;function N(C){const v=C;return v?[v.on,v.pause,v.resume,v.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=N;function F(C){const v=C;return v?N(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=F;function R(C,v){return new S(C,v)}e.newWriteableStream=R;class S{constructor(v,n){this.e=v,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(n=>n(v))}h(v){this.c.error.length===0?(0,i.onUnexpectedError)(v):this.c.error.slice(0).forEach(n=>n(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,n){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(v,n){if(this.a.destroyed)return;let l;switch(v){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const r=l.indexOf(n);r>=0&&l.splice(r,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(C,v){const n=[];let l;for(;(l=C.read())!==null;)n.push(l);return v(n)}e.consumeReadable=m;function O(C,v,n){const l=[];let r;for(;(r=C.read())!==null&&l.length<n;)l.push(r);return r===null&&l.length>0?v(l):{read:()=>{if(l.length>0)return l.shift();if(typeof r<"u"){const a=r;return r=void 0,a}return C.read()}}}e.peekReadable=O;function w(C,v){return new Promise((n,l)=>{const r=[];c(C,{onData:a=>{v&&r.push(a)},onError:a=>{v?l(a):n(void 0)},onEnd:()=>{n(v?v(r):void 0)}})})}e.consumeStream=w;function c(C,v){let n=!1;return C.on("error",l=>{n||v.onError(l)}),C.on("end",()=>{n||v.onEnd()}),C.on("data",l=>{n||v.onData(l)}),(0,k.toDisposable)(()=>n=!0)}e.listenStream=c;function p(C,v){return new Promise((n,l)=>{const r=new k.DisposableStore,a=[],b=P=>{if(a.push(P),a.length>v)return r.dispose(),C.pause(),n({stream:C,buffer:a,ended:!1})},I=P=>l(P),f=()=>n({stream:C,buffer:a,ended:!0});r.add((0,k.toDisposable)(()=>C.removeListener("error",I))),C.on("error",I),r.add((0,k.toDisposable)(()=>C.removeListener("end",f))),C.on("end",f),r.add((0,k.toDisposable)(()=>C.removeListener("data",b))),C.on("data",b)})}e.peekStream=p;function g(C,v){const n=R(v);return n.end(C),n}e.toStream=g;function d(){const C=R(()=>{throw new Error("not supported")});return C.end(),C}e.emptyStream=d;function t(C){let v=!1;return{read:()=>v?null:(v=!0,C)}}e.toReadable=t;function u(C,v,n){const l=R(n);return c(C,{onData:r=>l.write(v.data(r)),onError:r=>l.error(v.error?v.error(r):r),onEnd:()=>l.end()}),l}e.transform=u;function h(C,v,n){let l=!1;return{read:()=>{const r=v.read();return l?r:(l=!0,r!==null?n([C,r]):C)}}}e.prefixedReadable=h;function y(C,v,n){let l=!1;const r=R(n);return c(v,{onData:a=>l?r.write(a):(l=!0,r.write(n([C,a]))),onError:a=>r.error(a),onEnd:()=>{l||(l=!0,r.write(C)),r.end()}}),r}e.prefixedStream=y}),define(Re[24],Oe([1,0,66,118]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer<"u",N=new i.Lazy(()=>new Uint8Array(256));let F,R;class S{static alloc(o){return D?new S(Buffer.allocUnsafe(o)):new S(new Uint8Array(o))}static wrap(o){return D&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new S(o)}static fromString(o,s){return!(s?.dontUseNodeBuffer||!1)&&D?new S(Buffer.from(o)):(F||(F=new TextEncoder),new S(F.encode(o)))}static fromByteArray(o){const s=S.alloc(o.length);for(let M=0,B=o.length;M<B;M++)s.buffer[M]=o[M];return s}static concat(o,s){if(typeof s>"u"){s=0;for(let X=0,G=o.length;X<G;X++)s+=o[X].byteLength}const M=S.alloc(s);let B=0;for(let X=0,G=o.length;X<G;X++){const W=o[X];M.set(W,B),B+=W.byteLength}return M}constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}clone(){const o=S.alloc(this.byteLength);return o.set(this),o}toString(){return D?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(o,s){return new S(this.buffer.subarray(o,s))}set(o,s){if(o instanceof S)this.buffer.set(o.buffer,s);else if(o instanceof Uint8Array)this.buffer.set(o,s);else if(o instanceof ArrayBuffer)this.buffer.set(new Uint8Array(o),s);else if(ArrayBuffer.isView(o))this.buffer.set(new Uint8Array(o.buffer,o.byteOffset,o.byteLength),s);else throw new Error("Unknown argument 'array'")}readUInt32BE(o){return w(this.buffer,o)}writeUInt32BE(o,s){c(this.buffer,o,s)}readUInt32LE(o){return p(this.buffer,o)}writeUInt32LE(o,s){g(this.buffer,o,s)}readUInt8(o){return d(this.buffer,o)}writeUInt8(o,s){t(this.buffer,o,s)}indexOf(o){const s=o instanceof S?o.buffer:o,M=s.byteLength,B=this.buffer,X=B.byteLength;if(M===0)return 0;if(M===1)return B.indexOf(s[0]);if(M>X)return-1;const G=N.value;G.fill(s.length);for(let z=0;z<s.length;z++)G[s[z]]=s.length-z-1;let W=s.length-1,U=W,q=-1;for(;W<X;)if(B[W]===s[U]){if(U===0){q=W;break}W--,U--}else W+=Math.max(s.length-U,G[B[W]]),U=s.length-1;return q}}e.VSBuffer=S;function m(E,o){return E[o+0]<<0>>>0|E[o+1]<<8>>>0}e.readUInt16LE=m;function O(E,o,s){E[s+0]=o&255,o=o>>>8,E[s+1]=o&255}e.writeUInt16LE=O;function w(E,o){return E[o]*2**24+E[o+1]*2**16+E[o+2]*2**8+E[o+3]}e.readUInt32BE=w;function c(E,o,s){E[s+3]=o,o=o>>>8,E[s+2]=o,o=o>>>8,E[s+1]=o,o=o>>>8,E[s]=o}e.writeUInt32BE=c;function p(E,o){return E[o+0]<<0>>>0|E[o+1]<<8>>>0|E[o+2]<<16>>>0|E[o+3]<<24>>>0}e.readUInt32LE=p;function g(E,o,s){E[s+0]=o&255,o=o>>>8,E[s+1]=o&255,o=o>>>8,E[s+2]=o&255,o=o>>>8,E[s+3]=o&255}e.writeUInt32LE=g;function d(E,o){return E[o]}e.readUInt8=d;function t(E,o,s){E[s]=o}e.writeUInt8=t;function u(E){return k.consumeReadable(E,o=>S.concat(o))}e.readableToBuffer=u;function h(E){return k.toReadable(E)}e.bufferToReadable=h;function y(E){return k.consumeStream(E,o=>S.concat(o))}e.streamToBuffer=y;async function C(E){return E.ended?S.concat(E.buffer):S.concat([...E.buffer,await y(E.stream)])}e.bufferedStreamToBuffer=C;function v(E){return k.toStream(E,o=>S.concat(o))}e.bufferToStream=v;function n(E){return k.transform(E,{data:o=>typeof o=="string"?S.fromString(o):S.wrap(o)},o=>S.concat(o))}e.streamToBufferReadableStream=n;function l(E){return k.newWriteableStream(o=>S.concat(o),E)}e.newWriteableBufferStream=l;function r(E,o){return k.prefixedReadable(E,o,s=>S.concat(s))}e.prefixedBufferReadable=r;function a(E,o){return k.prefixedStream(E,o,s=>S.concat(s))}e.prefixedBufferStream=a;function b(E){let o=0,s=0,M=0;const B=new Uint8Array(Math.floor(E.length/4*3)),X=W=>{switch(s){case 3:B[M++]=o|W,s=0;break;case 2:B[M++]=o|W>>>2,o=W<<6,s=3;break;case 1:B[M++]=o|W>>>4,o=W<<4,s=2;break;default:o=W<<2,s=1}};for(let W=0;W<E.length;W++){const U=E.charCodeAt(W);if(U>=65&&U<=90)X(U-65);else if(U>=97&&U<=122)X(U-97+26);else if(U>=48&&U<=57)X(U-48+52);else if(U===43||U===45)X(62);else if(U===47||U===95)X(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${E[W]}`)}}const G=M;for(;s>0;)X(0);return S.wrap(B).slice(0,G)}e.decodeBase64=b;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function P({buffer:E},o=!0,s=!1){const M=s?f:I;let B="";const X=E.byteLength%3;let G=0;for(;G<E.byteLength-X;G+=3){const W=E[G+0],U=E[G+1],q=E[G+2];B+=M[W>>>2],B+=M[(W<<4|U>>>4)&63],B+=M[(U<<2|q>>>6)&63],B+=M[q&63]}if(X===1){const W=E[G+0];B+=M[W>>>2],B+=M[W<<4&63],o&&(B+="==")}else if(X===2){const W=E[G+0],U=E[G+1];B+=M[W>>>2],B+=M[(W<<4|U>>>4)&63],B+=M[U<<2&63],o&&(B+="=")}return B}e.encodeBase64=P}),define(Re[119],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Re[39],Oe([1,0,87]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var k;(function(F){function R(S){return S&&typeof S=="object"&&typeof S.id=="string"}F.isThemeColor=R})(k||(e.ThemeColor=k={}));function D(F){return{id:F}}e.themeColorFromId=D;var N;(function(F){F.iconNameSegment="[A-Za-z0-9]+",F.iconNameExpression="[A-Za-z0-9-]+",F.iconModifierExpression="~[A-Za-z]+",F.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${F.iconNameExpression})(${F.iconModifierExpression})?$`);function S(h){const y=R.exec(h.id);if(!y)return S(i.Codicon.error);const[,C,v]=y,n=["codicon","codicon-"+C];return v&&n.push("codicon-modifier-"+v.substring(1)),n}F.asClassNameArray=S;function m(h){return S(h).join(" ")}F.asClassName=m;function O(h){return"."+S(h).join(".")}F.asCSSSelector=O;function w(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||k.isThemeColor(h.color))}F.isThemeIcon=w;const c=new RegExp(`^\\$\\((${F.iconNameExpression}(?:${F.iconModifierExpression})?)\\)$`);function p(h){const y=c.exec(h);if(!y)return;const[,C]=y;return{id:C}}F.fromString=p;function g(h){return{id:h}}F.fromId=g;function d(h,y){let C=h.id;const v=C.lastIndexOf("~");return v!==-1&&(C=C.substring(0,v)),y&&(C=`${C}~${y}`),{id:C}}F.modify=d;function t(h){const y=h.id.lastIndexOf("~");if(y!==-1)return h.id.substring(y+1)}F.getModifier=t;function u(h,y){return h.id===y.id&&h.color?.id===y.color?.id}F.isEqual=u})(N||(e.ThemeIcon=N={}))}),define(Re[36],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(D){return i.test(D)}e.isUUID=k,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const N=new Uint8Array(16),F=[];for(let R=0;R<256;R++)F.push(R.toString(16).padStart(2,"0"));return function(){D(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let S=0,m="";return m+=F[N[S++]],m+=F[N[S++]],m+=F[N[S++]],m+=F[N[S++]],m+="-",m+=F[N[S++]],m+=F[N[S++]],m+="-",m+=F[N[S++]],m+=F[N[S++]],m+="-",m+=F[N[S++]],m+=F[N[S++]],m+="-",m+=F[N[S++]],m+=F[N[S++]],m+=F[N[S++]],m+=F[N[S++]],m+=F[N[S++]],m+=F[N[S++]],m}}()}),define(Re[120],Oe([1,0,18,88,36]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function N(w){return{asString:async()=>w,asFile:()=>{},value:typeof w=="string"?w:void 0}}e.createStringDataTransferItem=N;function F(w,c,p){const g={id:(0,D.generateUuid)(),name:w,uri:c,data:p};return{asString:async()=>"",asFile:()=>g,value:void 0}}e.createFileDataTransferItem=F;class R{constructor(){this.a=new Map}get size(){let c=0;for(const p of this.a)c++;return c}has(c){return this.a.has(this.b(c))}matches(c){const p=[...this.a.keys()];return k.Iterable.some(this,([g,d])=>d.asFile())&&p.push("files"),O(S(c),p)}get(c){return this.a.get(this.b(c))?.[0]}append(c,p){const g=this.a.get(c);g?g.push(p):this.a.set(this.b(c),[p])}replace(c,p){this.a.set(this.b(c),[p])}delete(c){this.a.delete(this.b(c))}*[Symbol.iterator](){for(const[c,p]of this.a)for(const g of p)yield[c,g]}b(c){return S(c)}}e.VSDataTransfer=R;function S(w){return w.toLowerCase()}function m(w,c){return O(S(w),c.map(S))}e.matchesMimeType=m;function O(w,c){if(w==="*/*")return c.length>0;if(c.includes(w))return!0;const p=w.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[g,d,t]=p;return t==="*"?c.some(u=>u.startsWith(d+"/")):!1}e.UriList=Object.freeze({create:w=>(0,i.distinct)(w.map(c=>c.toString())).join(`\r
`),split:w=>w.split(`\r
`),parse:w=>e.UriList.split(w).filter(c=>!c.startsWith("#"))})}),define(Re[121],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[122],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(i||(e.IndentAction=i={}));class k{constructor(R){if(this.e=null,this.f=!1,this.open=R.open,this.close=R.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(R.notIn))for(let S=0,m=R.notIn.length;S<m;S++)switch(R.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(R){switch(R){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(R,S){if(R.getTokenCount()===0)return!0;const m=R.findTokenIndexAtOffset(S-2),O=R.getStandardTokenType(m);return this.isOK(O)}g(R,S){for(let m=R;m<=S;m++){const O=String.fromCharCode(m);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=k;class D{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of R)N(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),N(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),N(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),N(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&N(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=D;function N(F,R,S){F.has(R)?F.get(R).push(S):F.set(R,[S])}}),define(Re[123],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class i{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const F=this.a.get(N);return this.a.delete(N),F}}addDragOperationTransfer(N,F){this.a.set(N,F)}}e.TreeViewsDnDService=i;class k{constructor(N){this.identifier=N}}e.DraggedTreeItemsIdentifier=k}),define(Re[124],Oe([11,12]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Re[125],Oe([11,12]),function(te,e){return te.create("vs/base/common/date",e)}),define(Re[126],Oe([1,0,125]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,D=k*60,N=D*24,F=N*7,R=N*30,S=N*365;function m(w,c,p,g){typeof w!="number"&&(w=w.getTime());const d=Math.round((new Date().getTime()-w)/1e3);if(d<-30)return(0,i.localize)(0,null,m(new Date().getTime()+d*1e3,!1));if(!g&&d<30)return(0,i.localize)(1,null);let t;return d<k?(t=d,c?t===1?p?(0,i.localize)(2,null,t):(0,i.localize)(3,null,t):p?(0,i.localize)(4,null,t):(0,i.localize)(5,null,t):t===1?p?(0,i.localize)(6,null,t):(0,i.localize)(7,null,t):p?(0,i.localize)(8,null,t):(0,i.localize)(9,null,t)):d<D?(t=Math.floor(d/k),c?t===1?p?(0,i.localize)(10,null,t):(0,i.localize)(11,null,t):p?(0,i.localize)(12,null,t):(0,i.localize)(13,null,t):t===1?p?(0,i.localize)(14,null,t):(0,i.localize)(15,null,t):p?(0,i.localize)(16,null,t):(0,i.localize)(17,null,t)):d<N?(t=Math.floor(d/D),c?t===1?p?(0,i.localize)(18,null,t):(0,i.localize)(19,null,t):p?(0,i.localize)(20,null,t):(0,i.localize)(21,null,t):t===1?p?(0,i.localize)(22,null,t):(0,i.localize)(23,null,t):p?(0,i.localize)(24,null,t):(0,i.localize)(25,null,t)):d<F?(t=Math.floor(d/N),c?t===1?(0,i.localize)(26,null,t):(0,i.localize)(27,null,t):t===1?(0,i.localize)(28,null,t):(0,i.localize)(29,null,t)):d<R?(t=Math.floor(d/F),c?t===1?p?(0,i.localize)(30,null,t):(0,i.localize)(31,null,t):p?(0,i.localize)(32,null,t):(0,i.localize)(33,null,t):t===1?p?(0,i.localize)(34,null,t):(0,i.localize)(35,null,t):p?(0,i.localize)(36,null,t):(0,i.localize)(37,null,t)):d<S?(t=Math.floor(d/R),c?t===1?p?(0,i.localize)(38,null,t):(0,i.localize)(39,null,t):p?(0,i.localize)(40,null,t):(0,i.localize)(41,null,t):t===1?p?(0,i.localize)(42,null,t):(0,i.localize)(43,null,t):p?(0,i.localize)(44,null,t):(0,i.localize)(45,null,t)):(t=Math.floor(d/S),c?t===1?p?(0,i.localize)(46,null,t):(0,i.localize)(47,null,t):p?(0,i.localize)(48,null,t):(0,i.localize)(49,null,t):t===1?p?(0,i.localize)(50,null,t):(0,i.localize)(51,null,t):p?(0,i.localize)(52,null,t):(0,i.localize)(53,null,t))}e.fromNow=m;function O(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Re[127],Oe([11,12]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Re[40],Oe([1,0,18,9,127]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(w,c){return c&&(w.stack||w.stacktrace)?D.localize(0,null,R(w),F(w.stack)||F(w.stacktrace)):R(w)}function F(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?D.localize(1,null,w.message):w.message||D.localize(2,null)}function S(w=null,c=!1){if(!w)return D.localize(3,null);if(Array.isArray(w)){const p=i.coalesce(w),g=S(p[0],c);return p.length>1?D.localize(4,null,g,p.length):g}if(k.isString(w))return w;if(w.detail){const p=w.detail;if(p.error)return N(p.error,c);if(p.exception)return N(p.exception,c)}return w.stack?N(w,c):w.message?w.message:D.localize(5,null)}e.toErrorMessage=S;function m(w){const c=w;return c instanceof Error&&Array.isArray(c.actions)}e.isErrorWithActions=m;function O(w,c){let p;return typeof w=="string"?p=new Error(w):p=w,p.actions=c,p}e.createErrorWithActions=O}),define(Re[128],Oe([1,0,66,19]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new i.Lazy(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),N=new i.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new i.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(P,E,o=!1){const s=P||"",M=E||"",B=D.value.collator.compare(s,M);return D.value.collatorIsNumeric&&B===0&&s!==M?s<M?-1:1:B}e.compareFileNames=R;function S(P,E){const o=N.value.collator;return P=P||"",E=E||"",C(o,P,E)}e.compareFileNamesDefault=S;function m(P,E){const o=N.value.collator;return P=P||"",E=E||"",r(P,E)||C(o,P,E)}e.compareFileNamesUpper=m;function O(P,E){const o=N.value.collator;return P=P||"",E=E||"",l(P,E)||C(o,P,E)}e.compareFileNamesLower=O;function w(P,E){return P=P||"",E=E||"",P===E?0:P<E?-1:1}e.compareFileNamesUnicode=w;function c(P,E){const[o,s]=h(P),[M,B]=h(E);let X=D.value.collator.compare(s,B);if(X===0){if(D.value.collatorIsNumeric&&s!==B)return s<B?-1:1;if(X=D.value.collator.compare(o,M),D.value.collatorIsNumeric&&X===0&&o!==M)return o<M?-1:1}return X}e.compareFileExtensions=c;function p(P,E){P=P||"",E=E||"";const o=y(P),s=y(E),M=N.value.collator,B=F.value.collator;return C(B,o,s)||C(M,P,E)}e.compareFileExtensionsDefault=p;function g(P,E){P=P||"",E=E||"";const o=y(P),s=y(E),M=N.value.collator,B=F.value.collator;return C(B,o,s)||r(P,E)||C(M,P,E)}e.compareFileExtensionsUpper=g;function d(P,E){P=P||"",E=E||"";const o=y(P),s=y(E),M=N.value.collator,B=F.value.collator;return C(B,o,s)||l(P,E)||C(M,P,E)}e.compareFileExtensionsLower=d;function t(P,E){P=P||"",E=E||"";const o=y(P).toLowerCase(),s=y(E).toLowerCase();return o!==s?o<s?-1:1:P!==E?P<E?-1:1:0}e.compareFileExtensionsUnicode=t;const u=/^(.*?)(\.([^.]*))?$/;function h(P,E=!1){const o=P?u.exec(P):[];let s=[o&&o[1]||"",o&&o[3]||""];return E&&(!s[0]&&s[1]||s[0]&&s[0].charAt(0)===".")&&(s=[s[0]+"."+s[1],""]),s}function y(P){const E=P?u.exec(P):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function C(P,E,o){const s=P.compare(E,o);return s!==0?s:E.length!==o.length?E.length<o.length?-1:1:0}function v(P){const E=P.charAt(0);return E.toLocaleUpperCase()!==E}function n(P){const E=P.charAt(0);return E.toLocaleLowerCase()!==E}function l(P,E){return v(P)&&n(E)?-1:n(P)&&v(E)?1:0}function r(P,E){return n(P)&&v(E)?-1:v(P)&&n(E)?1:0}function a(P,E,o=!1){return o||(P=P&&P.toLowerCase(),E=E&&E.toLowerCase()),P===E?0:P<E?-1:1}function b(P,E,o=!1){const s=P.split(k.sep),M=E.split(k.sep),B=s.length-1,X=M.length-1;let G,W;for(let U=0;;U++){if(G=B===U,W=X===U,G&&W)return R(s[U],M[U],o);if(G)return-1;if(W)return 1;const q=a(s[U],M[U],o);if(q!==0)return q}}e.comparePaths=b;function I(P,E,o){const s=P.toLowerCase(),M=E.toLowerCase(),B=f(P,E,o);if(B)return B;const X=s.endsWith(o),G=M.endsWith(o);if(X!==G)return X?-1:1;const W=R(s,M);return W!==0?W:s.localeCompare(M)}e.compareAnything=I;function f(P,E,o){const s=P.toLowerCase(),M=E.toLowerCase(),B=s.startsWith(o),X=M.startsWith(o);if(B!==X)return B?-1:1;if(B&&X){if(s.length<M.length)return-1;if(s.length>M.length)return 1}return 0}e.compareByPrefix=f}),define(Re[67],Oe([1,0,19]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(O){const w=(0,i.extname)(O),c=k[w.toLowerCase()];return c!==void 0?c:F(O)}e.getMediaOrTextMime=N;function F(O){const w=(0,i.extname)(O);return D[w.toLowerCase()]}e.getMediaMime=F;function R(O){for(const w in D)if(D[w]===O)return w}e.getExtensionForMimeType=R;const S=/^(.+)\/(.+?)(;.+)?$/;function m(O,w){const c=S.exec(O);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:w?void 0:O}e.normalizeMimeType=m}),define(Re[129],Oe([1,0,5,6,124]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class N extends k.Disposable{constructor(c,p="",g="",d=!0,t){super(),this.h=this.B(new i.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=p,this.u=g,this.w=d,this.C=t}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,p){this.C&&await this.C(c)}}e.Action=N;class F extends k.Disposable{constructor(){super(...arguments),this.f=this.B(new i.Emitter),this.onWillRun=this.f.event,this.h=this.B(new i.Emitter),this.onDidRun=this.h.event}async run(c,p){if(!c.enabled)return;this.f.fire({action:c});let g;try{await this.k(c,p)}catch(d){g=d}this.h.fire({action:c,error:g})}async k(c,p){await c.run(p)}}e.ActionRunner=F;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let p=[];for(const g of c)g.length&&(p.length?p=[...p,new R,...g]:p=g);return p}async run(){}}e.Separator=R,R.ID="vs.actions.separator";class S{get actions(){return this.a}constructor(c,p,g,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=p,this.class=d,this.a=g}async run(){}}e.SubmenuAction=S;class m extends N{constructor(){super(m.ID,D.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=m,m.ID="vs.actions.empty";function O(w){return{id:w.id,label:w.label,class:void 0,enabled:w.enabled??!0,checked:w.checked??!1,run:async()=>w.run(),tooltip:w.label}}e.toAction=O}),define(Re[41],Oe([1,0,19,21,13,9]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(I){return I===47||I===92}e.isPathSeparator=F;function R(I){return I.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=R;function S(I){return I.indexOf("/")===-1&&(I=R(I)),/^[a-zA-Z]:(\/|$)/.test(I)&&(I="/"+I),I}e.toPosixPath=S;function m(I,f=i.posix.sep){if(!I)return"";const P=I.length,E=I.charCodeAt(0);if(F(E)){if(F(I.charCodeAt(1))&&!F(I.charCodeAt(2))){let s=3;const M=s;for(;s<P&&!F(I.charCodeAt(s));s++);if(M!==s&&!F(I.charCodeAt(s+1))){for(s+=1;s<P;s++)if(F(I.charCodeAt(s)))return I.slice(0,s+1).replace(/[\\/]/g,f)}}return f}else if(u(E)&&I.charCodeAt(1)===58)return F(I.charCodeAt(2))?I.slice(0,2)+f:I.slice(0,2);let o=I.indexOf("://");if(o!==-1){for(o+=3;o<P;o++)if(F(I.charCodeAt(o)))return I.slice(0,o+1)}return""}e.getRoot=m;function O(I){if(!k.isWindows||!I||I.length<5)return!1;let f=I.charCodeAt(0);if(f!==92||(f=I.charCodeAt(1),f!==92))return!1;let P=2;const E=P;for(;P<I.length&&(f=I.charCodeAt(P),f!==92);P++);return!(E===P||(f=I.charCodeAt(P+1),isNaN(f)||f===92))}e.isUNC=O;const w=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(I,f=k.isWindows){const P=f?w:c;return!(!I||I.length===0||/^\s+$/.test(I)||(P.lastIndex=0,P.test(I))||f&&p.test(I)||I==="."||I===".."||f&&I[I.length-1]==="."||f&&I.length!==I.trim().length||I.length>255)}e.isValidBasename=g;function d(I,f,P){const E=I===f;return!P||E?E:!I||!f?!1:(0,D.equalsIgnoreCase)(I,f)}e.isEqual=d;function t(I,f,P,E=i.sep){if(I===f)return!0;if(!I||!f||f.length>I.length)return!1;if(P){if(!(0,D.startsWithIgnoreCase)(I,f))return!1;if(f.length===I.length)return!0;let s=f.length;return f.charAt(f.length-1)===E&&s--,I.charAt(s)===E}return f.charAt(f.length-1)!==E&&(f+=E),I.indexOf(f)===0}e.isEqualOrParent=t;function u(I){return I>=65&&I<=90||I>=97&&I<=122}e.isWindowsDriveLetter=u;function h(I,f){return k.isWindows&&I.endsWith(":")&&(I+=i.sep),(0,i.isAbsolute)(I)||(I=(0,i.join)(f,I)),I=(0,i.normalize)(I),k.isWindows?(I=(0,D.rtrim)(I,i.sep),I.endsWith(":")&&(I+=i.sep)):(I=(0,D.rtrim)(I,i.sep),I||(I=i.sep)),I}e.sanitizeFilePath=h;function y(I){const f=(0,i.normalize)(I);return k.isWindows?I.length>3?!1:C(f)&&(I.length===2||f.charCodeAt(2)===92):f===i.posix.sep}e.isRootOrDriveLetter=y;function C(I,f=k.isWindows){return f?u(I.charCodeAt(0))&&I.charCodeAt(1)===58:!1}e.hasDriveLetter=C;function v(I,f=k.isWindows){return C(I,f)?I[0]:void 0}e.getDriveLetter=v;function n(I,f,P){return f.length>I.length?-1:I===f?0:(P&&(I=I.toLowerCase(),f=f.toLowerCase()),I.indexOf(f))}e.indexOfPath=n;function l(I){const f=I.split(":");let P,E,o;for(const s of f){const M=Number(s);(0,N.isNumber)(M)?E===void 0?E=M:o===void 0&&(o=M):P=P?[P,s].join(":"):s}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:E!==void 0?E:void 0,column:o!==void 0?o:E!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",a="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(I,f,P=8){let E="";for(let s=0;s<P;s++){let M;s===0&&k.isWindows&&!f&&(P===3||P===4)?M=a:M=r,E+=M.charAt(Math.floor(Math.random()*M.length))}let o;return f?o=`${f}-${E}`:o=E,I?(0,i.join)(I,o):o}e.randomPath=b}),define(Re[130],Oe([1,0,28,13]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...Z){return function(ne,T){for(let H=0,j=Z.length;H<j;H++){const x=Z[H](ne,T);if(x)return x}return null}}e.or=D,e.matchesStrictPrefix=N.bind(void 0,!1),e.matchesPrefix=N.bind(void 0,!0);function N(Z,ne,T){if(!T||T.length<ne.length)return null;let H;return Z?H=k.startsWithIgnoreCase(T,ne):H=T.indexOf(ne)===0,H?ne.length>0?[{start:0,end:ne.length}]:[]:null}function F(Z,ne){const T=ne.toLowerCase().indexOf(Z.toLowerCase());return T===-1?null:[{start:T,end:T+Z.length}]}e.matchesContiguousSubString=F;function R(Z,ne){return S(Z.toLowerCase(),ne.toLowerCase(),0,0)}e.matchesSubString=R;function S(Z,ne,T,H){if(T===Z.length)return[];if(H===ne.length)return null;if(Z[T]===ne[H]){let j=null;return(j=S(Z,ne,T+1,H+1))?u({start:H,end:H+1},j):null}return S(Z,ne,T,H+1)}function m(Z){return 97<=Z&&Z<=122}function O(Z){return 65<=Z&&Z<=90}e.isUpper=O;function w(Z){return 48<=Z&&Z<=57}function c(Z){return Z===32||Z===9||Z===10||Z===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>p.add(Z.charCodeAt(0)));function g(Z){return c(Z)||p.has(Z)}function d(Z,ne){return Z===ne||g(Z)&&g(ne)}function t(Z){return m(Z)||O(Z)||w(Z)}function u(Z,ne){return ne.length===0?ne=[Z]:Z.end===ne[0].start?ne[0].start=Z.start:ne.unshift(Z),ne}function h(Z,ne){for(let T=ne;T<Z.length;T++){const H=Z.charCodeAt(T);if(O(H)||w(H)||T>0&&!t(Z.charCodeAt(T-1)))return T}return Z.length}function y(Z,ne,T,H){if(T===Z.length)return[];if(H===ne.length)return null;if(Z[T]!==ne[H].toLowerCase())return null;{let j=null,x=H+1;for(j=y(Z,ne,T+1,H+1);!j&&(x=h(ne,x))<ne.length;)j=y(Z,ne,T+1,x),x++;return j===null?null:u({start:H,end:H+1},j)}}function C(Z){let ne=0,T=0,H=0,j=0,x=0;for(let Se=0;Se<Z.length;Se++)x=Z.charCodeAt(Se),O(x)&&ne++,m(x)&&T++,t(x)&&H++,w(x)&&j++;const ce=ne/Z.length,pe=T/Z.length,ie=H/Z.length,ye=j/Z.length;return{upperPercent:ce,lowerPercent:pe,alphaPercent:ie,numericPercent:ye}}function v(Z){const{upperPercent:ne,lowerPercent:T}=Z;return T===0&&ne>.6}function n(Z){const{upperPercent:ne,lowerPercent:T,alphaPercent:H,numericPercent:j}=Z;return T>.2&&ne<.8&&H>.6&&j<.2}function l(Z){let ne=0,T=0,H=0,j=0;for(let x=0;x<Z.length;x++)H=Z.charCodeAt(x),O(H)&&ne++,m(H)&&T++,c(H)&&j++;return(ne===0||T===0)&&j===0?Z.length<=30:ne<=5}function r(Z,ne){if(!ne||(ne=ne.trim(),ne.length===0)||!l(Z)||ne.length>60)return null;const T=C(ne);if(!n(T)){if(!v(T))return null;ne=ne.toLowerCase()}let H=null,j=0;for(Z=Z.toLowerCase();j<ne.length&&(H=y(Z,ne,0,j))===null;)j=h(ne,j+1);return H}e.matchesCamelCase=r;function a(Z,ne,T=!1){if(!ne||ne.length===0)return null;let H=null,j=0;for(Z=Z.toLowerCase(),ne=ne.toLowerCase();j<ne.length&&(H=b(Z,ne,0,j,T))===null;)j=I(ne,j+1);return H}e.matchesWords=a;function b(Z,ne,T,H,j){if(T===Z.length)return[];if(H===ne.length)return null;if(d(Z.charCodeAt(T),ne.charCodeAt(H))){let x=null,ce=H+1;if(x=b(Z,ne,T+1,H+1,j),!j)for(;!x&&(ce=I(ne,ce))<ne.length;)x=b(Z,ne,T+1,ce,j),ce++;return x?Z.charCodeAt(T)!==ne.charCodeAt(H)?x:u({start:H,end:H+1},x):null}else return null}function I(Z,ne){for(let T=ne;T<Z.length;T++)if(g(Z.charCodeAt(T))||T>0&&g(Z.charCodeAt(T-1)))return T;return Z.length}const f=D(e.matchesPrefix,r,F),P=D(e.matchesPrefix,r,R),E=new i.LRUCache(1e4);function o(Z,ne,T=!1){if(typeof Z!="string"||typeof ne!="string")return null;let H=E.get(Z);H||(H=new RegExp(k.convertSimple2RegExpPattern(Z),"i"),E.set(Z,H));const j=H.exec(ne);return j?[{start:j.index,end:j.index+j[0].length}]:T?P(Z,ne):f(Z,ne)}e.matchesFuzzy=o;function s(Z,ne){const T=he(Z,Z.toLowerCase(),0,ne,ne.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return T?B(T):null}e.matchesFuzzy2=s;function M(Z,ne,T,H,j,x){const ce=Math.min(13,Z.length);for(;T<ce;T++){const pe=he(Z,ne,T,H,j,x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(pe)return pe}return[0,x]}e.anyScore=M;function B(Z){if(typeof Z>"u")return[];const ne=[],T=Z[1];for(let H=Z.length-1;H>1;H--){const j=Z[H]+T,x=ne[ne.length-1];x&&x.end===j?x.end=j+1:ne.push({start:j,end:j+1})}return ne}e.createMatches=B;const X=128;function G(){const Z=[],ne=[];for(let T=0;T<=X;T++)ne[T]=0;for(let T=0;T<=X;T++)Z.push(ne.slice(0));return Z}function W(Z){const ne=[];for(let T=0;T<=Z;T++)ne[T]=0;return ne}const U=W(2*X),q=W(2*X),z=G(),V=G(),ee=G(),Ce=!1;function oe(Z,ne,T,H,j){function x(pe,ie,ye=" "){for(;pe.length<ie;)pe=ye+pe;return pe}let ce=` |   |${H.split("").map(pe=>x(pe,3)).join("|")}
`;for(let pe=0;pe<=T;pe++)pe===0?ce+=" |":ce+=`${ne[pe-1]}|`,ce+=Z[pe].slice(0,j+1).map(ie=>x(ie.toString(),3)).join("|")+`
`;return ce}function le(Z,ne,T,H){Z=Z.substr(ne),T=T.substr(H),console.log(oe(V,Z,Z.length,T,T.length)),console.log(oe(ee,Z,Z.length,T,T.length)),console.log(oe(z,Z,Z.length,T,T.length))}function Q(Z,ne){if(ne<0||ne>=Z.length)return!1;const T=Z.codePointAt(ne);switch(T){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(T)}}function ue(Z,ne){if(ne<0||ne>=Z.length)return!1;switch(Z.charCodeAt(ne)){case 32:case 9:return!0;default:return!1}}function Ie(Z,ne,T){return ne[Z]!==T[Z]}function Pe(Z,ne,T,H,j,x,ce=!1){for(;ne<T&&j<x;)Z[ne]===H[j]&&(ce&&(U[ne]=j),ne+=1),j+=1;return ne===T}e.isPatternInWord=Pe;var be;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(be||(be={}));var A;(function(Z){Z.Default=[-100,0];function ne(T){return!T||T.length===2&&T[0]===-100&&T[1]===0}Z.isDefault=ne})(A||(e.FuzzyScore=A={}));class K{constructor(ne,T){this.firstMatchCanBeWeak=ne,this.boostFullMatch=T}}e.FuzzyScoreOptions=K,K.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function he(Z,ne,T,H,j,x,ce=K.default){const pe=Z.length>X?X:Z.length,ie=H.length>X?X:H.length;if(T>=pe||x>=ie||pe-T>ie-x||!Pe(ne,T,pe,j,x,ie,!0))return;De(pe,ie,T,x,ne,j);let ye=1,Se=1,Be=T,je=x;const Ze=[!1];for(ye=1,Be=T;Be<pe;ye++,Be++){const tt=U[Be],Ne=q[Be],dt=Be+1<pe?q[Be+1]:ie;for(Se=tt-x+1,je=tt;je<dt;Se++,je++){let J=Number.MIN_SAFE_INTEGER,_=!1;je<=Ne&&(J=we(Z,ne,Be,T,H,j,je,ie,x,z[ye-1][Se-1]===0,Ze));let fe=0;J!==Number.MAX_SAFE_INTEGER&&(_=!0,fe=J+V[ye-1][Se-1]);const $e=je>tt,qe=$e?V[ye][Se-1]+(z[ye][Se-1]>0?-5:0):0,We=je>tt+1&&z[ye][Se-1]>0,_e=We?V[ye][Se-2]+(z[ye][Se-2]>0?-5:0):0;if(We&&(!$e||_e>=qe)&&(!_||_e>=fe))V[ye][Se]=_e,ee[ye][Se]=3,z[ye][Se]=0;else if($e&&(!_||qe>=fe))V[ye][Se]=qe,ee[ye][Se]=2,z[ye][Se]=0;else if(_)V[ye][Se]=fe,ee[ye][Se]=1,z[ye][Se]=z[ye-1][Se-1]+1;else throw new Error("not possible")}}if(Ce&&le(Z,T,H,x),!Ze[0]&&!ce.firstMatchCanBeWeak)return;ye--,Se--;const Qe=[V[ye][Se],x];let Ke=0,it=0;for(;ye>=1;){let tt=Se;do{const Ne=ee[ye][tt];if(Ne===3)tt=tt-2;else if(Ne===2)tt=tt-1;else break}while(tt>=1);Ke>1&&ne[T+ye-1]===j[x+Se-1]&&!Ie(tt+x-1,H,j)&&Ke+1>z[ye][tt]&&(tt=Se),tt===Se?Ke++:Ke=1,it||(it=tt),ye--,Se=tt-1,Qe.push(Se)}ie===pe&&ce.boostFullMatch&&(Qe[0]+=2);const st=it-pe;return Qe[0]-=st,Qe}e.fuzzyScore=he;function De(Z,ne,T,H,j,x){let ce=Z-1,pe=ne-1;for(;ce>=T&&pe>=H;)j[ce]===x[pe]&&(q[ce]=pe,ce--),pe--}function we(Z,ne,T,H,j,x,ce,pe,ie,ye,Se){if(ne[T]!==x[ce])return Number.MIN_SAFE_INTEGER;let Be=1,je=!1;return ce===T-H?Be=Z[T]===j[ce]?7:5:Ie(ce,j,x)&&(ce===0||!Ie(ce-1,j,x))?(Be=Z[T]===j[ce]?7:5,je=!0):Q(x,ce)&&(ce===0||!Q(x,ce-1))?Be=5:(Q(x,ce-1)||ue(x,ce-1))&&(Be=5,je=!0),Be>1&&T===H&&(Se[0]=!0),je||(je=Ie(ce,j,x)||Q(x,ce-1)||ue(x,ce-1)),T===H?ce>ie&&(Be-=je?3:5):ye?Be+=je?2:0:Be+=je?0:1,ce+1===pe&&(Be-=je?3:5),Be}function ge(Z,ne,T,H,j,x,ce){return ae(Z,ne,T,H,j,x,!0,ce)}e.fuzzyScoreGracefulAggressive=ge;function ke(Z,ne,T,H,j,x,ce){return ae(Z,ne,T,H,j,x,!1,ce)}e.fuzzyScoreGraceful=ke;function ae(Z,ne,T,H,j,x,ce,pe){let ie=he(Z,ne,T,H,j,x,pe);if(ie&&!ce)return ie;if(Z.length>=3){const ye=Math.min(7,Z.length-1);for(let Se=T+1;Se<ye;Se++){const Be=de(Z,Se);if(Be){const je=he(Be,Be.toLowerCase(),T,H,j,x,pe);je&&(je[0]-=3,(!ie||je[0]>ie[0])&&(ie=je))}}}return ie}function de(Z,ne){if(ne+1>=Z.length)return;const T=Z[ne],H=Z[ne+1];if(T!==H)return Z.slice(0,ne)+H+T+Z.slice(ne+2)}}),define(Re[131],Oe([1,0,130,13,39]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const N="$(",F=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${F.source}`,"g");function S(u){return u.replace(R,(h,y)=>y?h:`\\${h}`)}e.escapeIcons=S;const m=new RegExp(`\\\\${F.source}`,"g");function O(u){return u.replace(m,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=O;const w=new RegExp(`(\\s)?(\\\\)?${F.source}(\\s)?`,"g");function c(u){return u.indexOf(N)===-1?u:u.replace(w,(h,y,C,v)=>C?h:y||v||"")}e.stripIcons=c;function p(u){return u?u.replace(/\$\((.*?)\)/g,(h,y)=>` ${y} `).trim():""}e.getCodiconAriaLabel=p;const g=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(u){g.lastIndex=0;let h="";const y=[];let C=0;for(;;){const v=g.lastIndex,n=g.exec(u),l=u.substring(v,n?.index);if(l.length>0){h+=l;for(let r=0;r<l.length;r++)y.push(C)}if(!n)break;C+=n[0].length}return{text:h,iconOffsets:y}}e.parseLabelWithIcons=d;function t(u,h,y=!1){const{text:C,iconOffsets:v}=h;if(!v||v.length===0)return(0,i.matchesFuzzy)(u,C,y);const n=(0,k.ltrim)(C," "),l=C.length-n.length,r=(0,i.matchesFuzzy)(u,n,y);if(r)for(const a of r){const b=v[a.start+l]+l;a.start+=b,a.end+=b}return r}e.matchesFuzzyIconAware=t}),define(Re[29],Oe([1,0,13]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(k||(k={})),function(D){const N="error",F="warning",R="warn",S="info",m="ignore";function O(c){return c?i.equalsIgnoreCase(N,c)?D.Error:i.equalsIgnoreCase(F,c)||i.equalsIgnoreCase(R,c)?D.Warning:i.equalsIgnoreCase(S,c)?D.Info:D.Ignore:D.Ignore}D.fromValue=O;function w(c){switch(c){case D.Error:return N;case D.Warning:return F;case D.Info:return S;default:return m}}D.toString=w}(k||(k={})),e.default=k}),define(Re[48],Oe([1,0,18,13]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const g=p.charCodeAt(0),d=this.b.charCodeAt(this.c);return g-d}value(){return this.b[this.c]}}e.StringIterator=D;class N{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,k.compareSubstring)(p,this.b,0,p.length,this.c,this.d):(0,k.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=N;class F{constructor(p=!0,g=!0){this.f=p,this.g=g}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let g=p.length-1;g>=0;g--,this.c--){const d=this.b.charCodeAt(g);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,k.compareSubstring)(p,this.b,0,p.length,this.d,this.e):(0,k.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=F;var R;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(R||(R={}));class S{constructor(p,g){this.f=p,this.g=g,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new F(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,k.compareIgnoreCase)(p,this.c.scheme);if(this.d[this.e]===2)return(0,k.compareIgnoreCase)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,k.compare)(p,this.c.query);if(this.d[this.e]===5)return(0,k.compare)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(O||(O={}));class w{static forUris(p=()=>!1,g=()=>!1){return new w(new S(p,g))}static forPaths(p=!1){return new w(new F(void 0,!p))}static forStrings(){return new w(new D)}static forConfigKeys(){return new w(new N)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,g){if(g){const d=g.slice(0);(0,i.shuffle)(d);for(const t of d)this.set(t,p)}else{const d=p.slice(0);(0,i.shuffle)(d);for(const t of d)this.set(t[0],t[1])}}set(p,g){const d=this.b.reset(p);let t;this.c||(this.c=new m,this.c.segment=d.value());const u=[];for(t=this.c;;){const y=d.cmp(t.segment);if(y>0)t.left||(t.left=new m,t.left.segment=d.value()),u.push([-1,t]),t=t.left;else if(y<0)t.right||(t.right=new m,t.right.segment=d.value()),u.push([1,t]),t=t.right;else if(d.hasNext())d.next(),t.mid||(t.mid=new m,t.mid.segment=d.value()),u.push([0,t]),t=t.mid;else break}const h=t.value;t.value=g,t.key=p;for(let y=u.length-1;y>=0;y--){const C=u[y][1];C.updateHeight();const v=C.balanceFactor();if(v<-1||v>1){const n=u[y][0],l=u[y+1][0];if(n===1&&l===1)u[y][1]=C.rotateLeft();else if(n===-1&&l===-1)u[y][1]=C.rotateRight();else if(n===1&&l===-1)C.right=u[y+1][1]=u[y+1][1].rotateRight(),u[y][1]=C.rotateLeft();else if(n===-1&&l===1)C.left=u[y+1][1]=u[y+1][1].rotateLeft(),u[y][1]=C.rotateRight();else throw new Error;if(y>0)switch(u[y-1][0]){case-1:u[y-1][1].left=u[y][1];break;case 1:u[y-1][1].right=u[y][1];break;case 0:u[y-1][1].mid=u[y][1];break}else this.c=u[0][1]}}return h}get(p){return this.d(p)?.value}d(p){const g=this.b.reset(p);let d=this.c;for(;d;){const t=g.cmp(d.segment);if(t>0)d=d.left;else if(t<0)d=d.right;else if(g.hasNext())g.next(),d=d.mid;else break}return d}has(p){const g=this.d(p);return!(g?.value===void 0&&g?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,g){const d=this.b.reset(p),t=[];let u=this.c;for(;u;){const h=d.cmp(u.segment);if(h>0)t.push([-1,u]),u=u.left;else if(h<0)t.push([1,u]),u=u.right;else if(d.hasNext())d.next(),t.push([0,u]),u=u.mid;else break}if(u){if(g?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const h=this.f(u.right);if(h.key){const{key:y,value:C,segment:v}=h;this.e(h.key,!1),u.key=y,u.value=C,u.segment=v}}else{const h=u.left??u.right;if(t.length>0){const[y,C]=t[t.length-1];switch(y){case-1:C.left=h;break;case 0:C.mid=h;break;case 1:C.right=h;break}}else this.c=h}for(let h=t.length-1;h>=0;h--){const y=t[h][1];y.updateHeight();const C=y.balanceFactor();if(C>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),t[h][1]=y.rotateLeft()):C<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),t[h][1]=y.rotateRight()),h>0)switch(t[h-1][0]){case-1:t[h-1][1].left=t[h][1];break;case 1:t[h-1][1].right=t[h][1];break;case 0:t[h-1][1].mid=t[h][1];break}else this.c=t[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const g=this.b.reset(p);let d=this.c,t;for(;d;){const u=g.cmp(d.segment);if(u>0)d=d.left;else if(u<0)d=d.right;else if(g.hasNext())g.next(),t=d.value||t,d=d.mid;else break}return d&&d.value||t}findSuperstr(p){return this.g(p,!1)}g(p,g){const d=this.b.reset(p);let t=this.c;for(;t;){const u=d.cmp(t.segment);if(u>0)t=t.left;else if(u<0)t=t.right;else if(d.hasNext())d.next(),t=t.mid;else return t.mid?this.h(t.mid):g?t.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[g,d]of this)p(d,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const g=[];return this.j(p,g),g[Symbol.iterator]()}j(p,g){p&&(p.left&&this.j(p.left,g),p.value&&g.push([p.key,p.value]),p.mid&&this.j(p.mid,g),p.right&&this.j(p.right,g))}_isBalanced(){const p=g=>{if(!g)return!0;const d=g.balanceFactor();return d<-1||d>1?!1:p(g.left)&&p(g.right)};return p(this.c)}}e.TernarySearchTree=w}),define(Re[68],Oe([1,0,24,13,2]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function N(m){return JSON.stringify(m,R)}e.stringify=N;function F(m){let O=JSON.parse(m);return O=S(O),O}e.parse=F;function R(m,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,k.regExpFlags)(O)}:O}function S(m,O=0){if(!m||O>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return D.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof i.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let w=0;w<m.length;++w)m[w]=S(m[w],O+1);else for(const w in m)Object.hasOwnProperty.call(m,w)&&(m[w]=S(m[w],O+1))}return m}e.revive=S}),define(Re[15],Oe([1,0,10,21,2]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var N;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractive="vscode-interactive",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(N||(e.Schemas=N={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class F{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${N.vscodeRemoteResource}`}setPreferredWebSchema(O){this.d=O}setDelegate(O){this.e=O}setServerRootPath(O){this.f=`${O}/${N.vscodeRemoteResource}`}set(O,w,c){this.a[O]=w,this.b[O]=c}setConnectionToken(O,w){this.c[O]=w}getPreferredWebSchema(){return this.d}rewrite(O){if(this.e)try{return this.e(O)}catch(t){return i.onUnexpectedError(t),O}const w=O.authority;let c=this.a[w];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const p=this.b[w],g=this.c[w];let d=`path=${encodeURIComponent(O.path)}`;return typeof g=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),D.URI.from({scheme:k.isWeb?this.d:N.vscodeRemoteResource,authority:`${c}:${p}`,path:this.f,query:d})}}e.RemoteAuthorities=new F,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(O){const w=this.b(O,te);return this.uriToBrowserUri(w)}uriToBrowserUri(O){return O.scheme===N.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===N.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${N.vscodeFileResource}://${R.a}`)?O.with({scheme:N.vscodeFileResource,authority:O.authority||R.a,query:null,fragment:null}):O}asFileUri(O){const w=this.b(O,te);return this.uriToFileUri(w)}uriToFileUri(O){return O.scheme===N.vscodeFileResource?O.with({scheme:N.file,authority:O.authority!==R.a?O.authority:null,query:null,fragment:null}):O}b(O,w){return D.URI.isUri(O)?O:D.URI.parse(w.toUrl(O))}}R.a="vscode-app",e.FileAccess=new R;var S;(function(m){const O=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(O.get("3"));const w="vscode-coi";function c(g){let d;typeof g=="string"?d=new URL(g).searchParams:g instanceof URL?d=g.searchParams:D.URI.isUri(g)&&(d=new URL(g.toString(!0)).searchParams);const t=d?.get(w);if(t)return O.get(t)}m.getHeadersFromQuery=c;function p(g,d,t){if(!globalThis.crossOriginIsolated)return;const u=d&&t?"3":t?"2":"1";g instanceof URLSearchParams?g.set(w,u):g[w]=u}m.addSearchParam=p})(S||(e.COI=S={}))}),define(Re[25],Oe([1,0,41,15,19,21,13,2]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(p){return(0,R.uriToFsPath)(p,!0)}e.originalFSPath=S;class m{constructor(g){this.a=g}compare(g,d,t=!1){return g===d?0:(0,F.compare)(this.getComparisonKey(g,t),this.getComparisonKey(d,t))}isEqual(g,d,t=!1){return g===d?!0:!g||!d?!1:this.getComparisonKey(g,t)===this.getComparisonKey(d,t)}getComparisonKey(g,d=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,d,t=!1){if(g.scheme===d.scheme){if(g.scheme===k.Schemas.file)return i.isEqualOrParent(S(g),S(d),this.a(g))&&g.query===d.query&&(t||g.fragment===d.fragment);if((0,e.isEqualAuthority)(g.authority,d.authority))return i.isEqualOrParent(g.path,d.path,this.a(g),"/")&&g.query===d.query&&(t||g.fragment===d.fragment)}return!1}joinPath(g,...d){return R.URI.joinPath(g,...d)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return D.posix.basename(g.path)}extname(g){return D.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let d;return g.scheme===k.Schemas.file?d=R.URI.file(D.dirname(S(g))).path:(d=D.posix.dirname(g.path),g.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),d="/")),g.with({path:d})}normalizePath(g){if(!g.path.length)return g;let d;return g.scheme===k.Schemas.file?d=R.URI.file(D.normalize(S(g))).path:d=D.posix.normalize(g.path),g.with({path:d})}relativePath(g,d){if(g.scheme!==d.scheme||!(0,e.isEqualAuthority)(g.authority,d.authority))return;if(g.scheme===k.Schemas.file){const h=D.relative(S(g),S(d));return N.isWindows?i.toSlashes(h):h}let t=g.path||"/";const u=d.path||"/";if(this.a(g)){let h=0;for(const y=Math.min(t.length,u.length);h<y&&!(t.charCodeAt(h)!==u.charCodeAt(h)&&t.charAt(h).toLowerCase()!==u.charAt(h).toLowerCase());h++);t=u.substr(0,h)+t.substr(h)}return D.posix.relative(t,u)}resolvePath(g,d){if(g.scheme===k.Schemas.file){const t=R.URI.file(D.resolve(S(g),d));return g.with({authority:t.authority,path:t.path})}return d=i.toPosixPath(d),g.with({path:D.posix.resolve(g.path,d)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,d){return g===d||g!==void 0&&d!==void 0&&(0,F.equalsIgnoreCase)(g,d)}hasTrailingPathSeparator(g,d=D.sep){if(g.scheme===k.Schemas.file){const t=S(g);return t.length>i.getRoot(t).length&&t[t.length-1]===d}else{const t=g.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,d=D.sep){return(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,d=D.sep){let t=!1;if(g.scheme===k.Schemas.file){const u=S(g);t=u!==void 0&&u.length===i.getRoot(u).length&&u[u.length-1]===d}else{d="/";const u=g.path;t=u.length===1&&u.charCodeAt(u.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path+"/"}):g}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(p=>p.scheme===k.Schemas.file?!N.isLinux:!0),e.extUriIgnorePathCase=new m(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(p,g){const d=[];for(let t=0;t<p.length;t++){const u=g(p[t]);p.some((h,y)=>y===t?!1:(0,e.isEqualOrParent)(u,g(h)))||d.push(p[t])}return d}e.distinctParents=O;var w;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function g(d){const t=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(y=>{const[C,v]=y.split(":");C&&v&&t.set(C,v)});const h=d.path.substring(0,d.path.indexOf(";"));return h&&t.set(p.META_DATA_MIME,h),t}p.parseMetaData=g})(w||(e.DataUri=w={}));function c(p,g,d){if(g){let t=p.path;return t&&t[0]!==D.posix.sep&&(t=D.posix.sep+t),p.with({scheme:d,authority:g,path:t})}return p.with({scheme:d})}e.toLocalResource=c}),define(Re[16],Oe([1,0,22,10,5,6,25,21,119]),function(te,e,i,k,D,N,F,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(be){return!!be&&typeof be.then=="function"}e.isThenable=m;function O(be){const A=new i.CancellationTokenSource,K=be(A.token),he=new Promise((De,we)=>{const ge=A.token.onCancellationRequested(()=>{ge.dispose(),A.dispose(),we(new k.CancellationError)});Promise.resolve(K).then(ke=>{ge.dispose(),A.dispose(),De(ke)},ke=>{ge.dispose(),A.dispose(),we(ke)})});return new class{cancel(){A.cancel()}then(De,we){return he.then(De,we)}catch(De){return this.then(void 0,De)}finally(De){return he.finally(De)}}}e.createCancelablePromise=O;function w(be,A,K){return new Promise((he,De)=>{const we=A.onCancellationRequested(()=>{we.dispose(),he(K)});be.then(he,De).finally(()=>we.dispose())})}e.raceCancellation=w;function c(be,A){return new Promise((K,he)=>{const De=A.onCancellationRequested(()=>{De.dispose(),he(new k.CancellationError)});be.then(K,he).finally(()=>De.dispose())})}e.raceCancellationError=c;async function p(be){let A=-1;const K=be.map((he,De)=>he.then(we=>(A=De,we)));try{return await Promise.race(K)}finally{be.forEach((he,De)=>{De!==A&&he.cancel()})}}e.raceCancellablePromises=p;function g(be,A,K){let he;const De=setTimeout(()=>{he?.(void 0),K?.()},A);return Promise.race([be.finally(()=>clearTimeout(De)),new Promise(we=>he=we)])}e.raceTimeout=g;function d(be){return new Promise((A,K)=>{const he=be();m(he)?he.then(A,K):A(he)})}e.asPromise=d;class t{constructor(){this.a=null,this.b=null,this.d=null}queue(A){if(this.a){if(this.d=A,!this.b){const K=()=>{this.b=null;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(K,K).then(he)})}return new Promise((K,he)=>{this.b.then(K,he)})}return this.a=A(),new Promise((K,he)=>{this.a.then(De=>{this.a=null,K(De)},De=>{this.a=null,he(De)})})}}e.Throttler=t;class u{constructor(){this.a=Promise.resolve(null)}queue(A){return this.a=this.a.then(()=>A(),()=>A())}}e.Sequencer=u;class h{constructor(){this.a=new Map}queue(A,K){const De=(this.a.get(A)??Promise.resolve()).catch(()=>{}).then(K).finally(()=>{this.a.get(A)===De&&this.a.delete(A)});return this.a.set(A,De),De}}e.SequencerByKey=h;const y=(be,A)=>{let K=!0;const he=setTimeout(()=>{K=!1,A()},be);return{isTriggered:()=>K,dispose:()=>{clearTimeout(he),K=!1}}},C=be=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,be())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};class v{constructor(A){this.defaultDelay=A,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(A,K=this.defaultDelay){this.g=A,this.h(),this.b||(this.b=new Promise((De,we)=>{this.d=De,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const De=this.g;return this.g=null,De()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=K===S.MicrotaskDelay?C(he):y(K,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=v;class n{constructor(A){this.a=new v(A),this.b=new t}trigger(A,K){return this.a.trigger(()=>this.b.queue(A),K)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=n;class l{constructor(){this.a=!1,this.b=new Promise((A,K)=>{this.d=A})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=l;class r extends l{constructor(A){super(),this.f=setTimeout(()=>this.open(),A)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function a(be,A){return A?new Promise((K,he)=>{const De=setTimeout(()=>{we.dispose(),K()},be),we=A.onCancellationRequested(()=>{clearTimeout(De),we.dispose(),he(new k.CancellationError)})}):O(K=>a(be,K))}e.timeout=a;function b(be,A=0){const K=setTimeout(be,A);return(0,N.toDisposable)(()=>clearTimeout(K))}e.disposableTimeout=b;function I(be){const A=[];let K=0;const he=be.length;function De(){return K<he?be[K++]():null}function we(ge){ge!=null&&A.push(ge);const ke=De();return ke?ke.then(we):Promise.resolve(A)}return Promise.resolve(null).then(we)}e.sequence=I;function f(be,A=he=>!!he,K=null){let he=0;const De=be.length,we=()=>{if(he>=De)return Promise.resolve(K);const ge=be[he++];return Promise.resolve(ge()).then(ae=>A(ae)?Promise.resolve(ae):we())};return we()}e.first=f;function P(be,A=he=>!!he,K=null){if(be.length===0)return Promise.resolve(K);let he=be.length;const De=()=>{he=-1;for(const we of be)we.cancel?.()};return new Promise((we,ge)=>{for(const ke of be)ke.then(ae=>{--he>=0&&A(ae)?(De(),we(ae)):he===0&&we(K)}).catch(ae=>{--he>=0&&(De(),ge(ae))})})}e.firstParallel=P;class E{constructor(A){this.a=0,this.d=A,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(A){return this.a++,new Promise((K,he)=>{this.f.push({factory:A,c:K,e:he}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const A=this.f.shift();this.b++;const K=A.factory();K.then(A.c,A.e),K.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=E;class o extends E{constructor(){super(1)}}e.Queue=o;class s{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const A=new oe;return this.b.add(A),A.p}d(){for(const[,A]of this.a)if(A.size>0)return!1;return!0}queueFor(A,K=F.extUri){const he=K.getComparisonKey(A);let De=this.a.get(he);return De||(De=new o,D.Event.once(De.onDrained)(()=>{De?.dispose(),this.a.delete(he),this.f()}),this.a.set(he,De)),De}f(){this.d()&&this.g()}g(){for(const A of this.b)A.complete();this.b.clear()}dispose(){for(const[,A]of this.a)A.dispose();this.a.clear(),this.g()}}e.ResourceQueue=s;class M{constructor(A,K){this.a=-1,typeof A=="function"&&typeof K=="number"&&this.setIfNotSet(A,K)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(A,K){this.cancel(),this.a=setTimeout(()=>{this.a=-1,A()},K)}setIfNotSet(A,K){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,A()},K))}}e.TimeoutTimer=M;class B{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(A,K){this.cancel(),this.a=setInterval(()=>{A()},K)}}e.IntervalTimer=B;class X{constructor(A,K){this.b=-1,this.a=A,this.d=K,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(A=this.d){this.cancel(),this.b=setTimeout(this.f,A)}get delay(){return this.d}set delay(A){this.d=A}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=X;class G{constructor(A,K){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.a=A,this.b=K,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(A=this.b){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(A/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=G;class W extends X{constructor(A,K){super(A,K),this.j=[]}work(A){this.j.push(A),this.isScheduled()||this.schedule()}h(){const A=this.j;this.j=[],this.a?.(A)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=W;class U extends N.Disposable{constructor(A,K){super(),this.g=A,this.h=K,this.a=[],this.b=this.B(new N.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(A){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+A.length>this.g.maxBufferedWork)return!1}else if(this.pending+A.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const K of A)this.a.push(K);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new X(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=be=>{(0,R.setTimeout0)(()=>{if(A)return;const K=Date.now()+15;be(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,K-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(be,A)=>{const K=requestIdleCallback(be,typeof A=="number"?{timeout:A}:void 0);let he=!1;return{dispose(){he||(he=!0,cancelIdleCallback(K))}}}}();class q{constructor(A){this.d=!1,this.a=()=>{try{this.f=A()}catch(K){this.g=K}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=q;async function z(be,A,K){let he;for(let De=0;De<K;De++)try{return await be()}catch(we){he=we,await a(A)}throw he}e.retry=z;class V{hasPending(A){return this.a?typeof A=="number"?this.a.taskId===A:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(A,K,he){return this.a={taskId:A,cancel:()=>he?.(),promise:K},K.then(()=>this.d(A),()=>this.d(A)),K}d(A){this.a&&A===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const A=this.b;this.b=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this.b)this.b.run=A;else{let K,he;const De=new Promise((we,ge)=>{K=we,he=ge});this.b={run:A,promise:De,promiseResolve:K,promiseReject:he}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=V;class ee{constructor(A,K=()=>Date.now()){this.d=A,this.f=K,this.a=0,this.b=0}increment(){const A=this.f();return A-this.a>this.d&&(this.a=A,this.b=0),this.b++,this.b}}e.IntervalCounter=ee;var Ce;(function(be){be[be.Resolved=0]="Resolved",be[be.Rejected=1]="Rejected"})(Ce||(Ce={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((A,K)=>{this.a=A,this.b=K})}complete(A){return new Promise(K=>{this.a(A),this.d={outcome:0,value:A},K()})}error(A){return new Promise(K=>{this.b(A),this.d={outcome:1,value:A},K()})}cancel(){return this.error(new k.CancellationError)}}e.DeferredPromise=oe;var le;(function(be){async function A(he){let De;const we=await Promise.all(he.map(ge=>ge.then(ke=>ke,ke=>{De||(De=ke)})));if(typeof De<"u")throw De;return we}be.settled=A;function K(he){return new Promise(async(De,we)=>{try{await he(De,we)}catch(ge){we(ge)}})}be.withAsyncBody=K})(le||(e.Promises=le={}));var Q;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(Q||(Q={}));class ue{static fromArray(A){return new ue(K=>{K.emitMany(A)})}static fromPromise(A){return new ue(async K=>{K.emitMany(await A)})}static fromPromises(A){return new ue(async K=>{await Promise.all(A.map(async he=>K.emitOne(await he)))})}static merge(A){return new ue(async K=>{await Promise.all(A.map(async he=>{for await(const De of he)K.emitOne(De)}))})}constructor(A){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const K={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(A(K)),this.j()}catch(he){this.k(he)}finally{K.emitOne=void 0,K.emitMany=void 0,K.reject=void 0}})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(A<this.b.length)return{done:!1,value:this.b[A++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(A,K){return new ue(async he=>{for await(const De of A)he.emitOne(K(De))})}map(A){return ue.map(this,A)}static filter(A,K){return new ue(async he=>{for await(const De of A)K(De)&&he.emitOne(De)})}filter(A){return ue.filter(this,A)}static coalesce(A){return ue.filter(A,K=>!!K)}coalesce(){return ue.coalesce(this)}static async toPromise(A){const K=[];for await(const he of A)K.push(he);return K}toPromise(){return ue.toPromise(this)}g(A){this.a===0&&(this.b.push(A),this.f.fire())}h(A){this.a===0&&(this.b=this.b.concat(A),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(A){this.a===0&&(this.a=2,this.d=A,this.f.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class Ie extends ue{constructor(A,K){super(K),this.l=A}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Ie;function Pe(be){const A=new i.CancellationTokenSource,K=be(A.token);return new Ie(A,async he=>{const De=A.token.onCancellationRequested(()=>{De.dispose(),A.dispose(),he.reject(new k.CancellationError)});try{for await(const we of K){if(A.token.isCancellationRequested)return;he.emitOne(we)}De.dispose(),A.dispose()}catch(we){De.dispose(),A.dispose(),he.reject(we)}})}e.createCancelableAsyncIterable=Pe}),define(Re[37],Oe([1,0,18,16,41,28,19,21,13]),function(te,e,i,k,D,N,F,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",w="[^/\\\\]",c=/\//g;function p(ee,Ce){switch(ee){case 0:return"";case 1:return`${w}*?`;default:return`(?:${O}|${w}+${O}${Ce?`|${O}${w}+`:""})*?`}}function g(ee,Ce){if(!ee)return[];const oe=[];let le=!1,Q=!1,ue="";for(const Ie of ee){switch(Ie){case Ce:if(!le&&!Q){oe.push(ue),ue="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}ue+=Ie}return ue&&oe.push(ue),oe}e.splitGlobAware=g;function d(ee){if(!ee)return"";let Ce="";const oe=g(ee,e.GLOB_SPLIT);if(oe.every(le=>le===e.GLOBSTAR))Ce=".*";else{let le=!1;oe.forEach((Q,ue)=>{if(Q===e.GLOBSTAR){if(le)return;Ce+=p(2,ue===oe.length-1)}else{let Ie=!1,Pe="",be=!1,A="";for(const K of Q){if(K!=="}"&&Ie){Pe+=K;continue}if(be&&(K!=="]"||!A)){let he;K==="-"?he=K:(K==="^"||K==="!")&&!A?he="^":K===e.GLOB_SPLIT?he="":he=(0,S.escapeRegExpCharacters)(K),A+=he;continue}switch(K){case"{":Ie=!0;continue;case"[":be=!0;continue;case"}":{const De=`(?:${g(Pe,",").map(we=>d(we)).join("|")})`;Ce+=De,Ie=!1,Pe="";break}case"]":{Ce+="["+A+"]",be=!1,A="";break}case"?":Ce+=w;continue;case"*":Ce+=p(1);continue;default:Ce+=(0,S.escapeRegExpCharacters)(K)}}ue<oe.length-1&&(oe[ue+1]!==e.GLOBSTAR||ue+2<oe.length)&&(Ce+=O)}le=Q===e.GLOBSTAR})}return Ce}const t=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new N.LRUCache(1e4),l=function(){return!1},r=function(){return null};function a(ee,Ce){if(!ee)return r;let oe;typeof ee!="string"?oe=ee.pattern:oe=ee,oe=oe.trim();const le=`${oe}_${!!Ce.trimForExclusions}`;let Q=n.get(le);if(Q)return b(Q,ee);let ue;return t.test(oe)?Q=f(oe.substr(4),oe):(ue=u.exec(I(oe,Ce)))?Q=P(ue[1],oe):(Ce.trimForExclusions?y:h).test(oe)?Q=E(oe,Ce):(ue=C.exec(I(oe,Ce)))?Q=o(ue[1].substr(1),oe,!0):(ue=v.exec(I(oe,Ce)))?Q=o(ue[1],oe,!1):Q=s(oe),n.set(le,Q),b(Q,ee)}function b(ee,Ce){if(typeof Ce=="string")return ee;const oe=function(le,Q){return(0,D.isEqualOrParent)(le,Ce.base,!R.isLinux)?ee((0,S.ltrim)(le.substr(Ce.base.length),F.sep),Q):null};return oe.allBasenames=ee.allBasenames,oe.allPaths=ee.allPaths,oe.basenames=ee.basenames,oe.patterns=ee.patterns,oe}function I(ee,Ce){return Ce.trimForExclusions&&ee.endsWith("/**")?ee.substr(0,ee.length-2):ee}function f(ee,Ce){return function(oe,le){return typeof oe=="string"&&oe.endsWith(ee)?Ce:null}}function P(ee,Ce){const oe=`/${ee}`,le=`\\${ee}`,Q=function(Ie,Pe){return typeof Ie!="string"?null:Pe?Pe===ee?Ce:null:Ie===ee||Ie.endsWith(oe)||Ie.endsWith(le)?Ce:null},ue=[ee];return Q.basenames=ue,Q.patterns=[Ce],Q.allBasenames=ue,Q}function E(ee,Ce){const oe=z(ee.slice(1,-1).split(",").map(Pe=>a(Pe,Ce)).filter(Pe=>Pe!==r),ee),le=oe.length;if(!le)return r;if(le===1)return oe[0];const Q=function(Pe,be){for(let A=0,K=oe.length;A<K;A++)if(oe[A](Pe,be))return ee;return null},ue=oe.find(Pe=>!!Pe.allBasenames);ue&&(Q.allBasenames=ue.allBasenames);const Ie=oe.reduce((Pe,be)=>be.allPaths?Pe.concat(be.allPaths):Pe,[]);return Ie.length&&(Q.allPaths=Ie),Q}function o(ee,Ce,oe){const le=F.sep===F.posix.sep,Q=le?ee:ee.replace(c,F.sep),ue=F.sep+Q,Ie=F.posix.sep+ee;let Pe;return oe?Pe=function(be,A){return typeof be=="string"&&(be===Q||be.endsWith(ue)||!le&&(be===ee||be.endsWith(Ie)))?Ce:null}:Pe=function(be,A){return typeof be=="string"&&(be===Q||!le&&be===ee)?Ce:null},Pe.allPaths=[(oe?"*/":"./")+ee],Pe}function s(ee){try{const Ce=new RegExp(`^${d(ee)}$`);return function(oe){return Ce.lastIndex=0,typeof oe=="string"&&Ce.test(oe)?ee:null}}catch{return r}}function M(ee,Ce,oe){return!ee||typeof Ce!="string"?!1:B(ee)(Ce,void 0,oe)}e.match=M;function B(ee,Ce={}){if(!ee)return l;if(typeof ee=="string"||X(ee)){const oe=a(ee,Ce);if(oe===r)return l;const le=function(Q,ue){return!!oe(Q,ue)};return oe.allBasenames&&(le.allBasenames=oe.allBasenames),oe.allPaths&&(le.allPaths=oe.allPaths),le}return U(ee,Ce)}e.parse=B;function X(ee){const Ce=ee;return Ce?typeof Ce.base=="string"&&typeof Ce.pattern=="string":!1}e.isRelativePattern=X;function G(ee){return ee.allBasenames||[]}e.getBasenameTerms=G;function W(ee){return ee.allPaths||[]}e.getPathTerms=W;function U(ee,Ce){const oe=z(Object.getOwnPropertyNames(ee).map(Pe=>q(Pe,ee[Pe],Ce)).filter(Pe=>Pe!==r)),le=oe.length;if(!le)return r;if(!oe.some(Pe=>!!Pe.requiresSiblings)){if(le===1)return oe[0];const Pe=function(K,he){let De;for(let we=0,ge=oe.length;we<ge;we++){const ke=oe[we](K,he);if(typeof ke=="string")return ke;(0,k.isThenable)(ke)&&(De||(De=[]),De.push(ke))}return De?(async()=>{for(const we of De){const ge=await we;if(typeof ge=="string")return ge}return null})():null},be=oe.find(K=>!!K.allBasenames);be&&(Pe.allBasenames=be.allBasenames);const A=oe.reduce((K,he)=>he.allPaths?K.concat(he.allPaths):K,[]);return A.length&&(Pe.allPaths=A),Pe}const Q=function(Pe,be,A){let K,he;for(let De=0,we=oe.length;De<we;De++){const ge=oe[De];ge.requiresSiblings&&A&&(be||(be=(0,F.basename)(Pe)),K||(K=be.substr(0,be.length-(0,F.extname)(Pe).length)));const ke=ge(Pe,be,K,A);if(typeof ke=="string")return ke;(0,k.isThenable)(ke)&&(he||(he=[]),he.push(ke))}return he?(async()=>{for(const De of he){const we=await De;if(typeof we=="string")return we}return null})():null},ue=oe.find(Pe=>!!Pe.allBasenames);ue&&(Q.allBasenames=ue.allBasenames);const Ie=oe.reduce((Pe,be)=>be.allPaths?Pe.concat(be.allPaths):Pe,[]);return Ie.length&&(Q.allPaths=Ie),Q}function q(ee,Ce,oe){if(Ce===!1)return r;const le=a(ee,oe);if(le===r)return r;if(typeof Ce=="boolean")return le;if(Ce){const Q=Ce.when;if(typeof Q=="string"){const ue=(Ie,Pe,be,A)=>{if(!A||!le(Ie,Pe))return null;const K=Q.replace("$(basename)",()=>be),he=A(K);return(0,k.isThenable)(he)?he.then(De=>De?ee:null):he?ee:null};return ue.requiresSiblings=!0,ue}}return le}function z(ee,Ce){const oe=ee.filter(Pe=>!!Pe.basenames);if(oe.length<2)return ee;const le=oe.reduce((Pe,be)=>{const A=be.basenames;return A?Pe.concat(A):Pe},[]);let Q;if(Ce){Q=[];for(let Pe=0,be=le.length;Pe<be;Pe++)Q.push(Ce)}else Q=oe.reduce((Pe,be)=>{const A=be.patterns;return A?Pe.concat(A):Pe},[]);const ue=function(Pe,be){if(typeof Pe!="string")return null;if(!be){let K;for(K=Pe.length;K>0;K--){const he=Pe.charCodeAt(K-1);if(he===47||he===92)break}be=Pe.substr(K)}const A=le.indexOf(be);return A!==-1?Q[A]:null};ue.basenames=le,ue.patterns=Q,ue.allBasenames=le;const Ie=ee.filter(Pe=>!Pe.basenames);return Ie.push(ue),Ie}function V(ee,Ce){return(0,i.equals)(ee,Ce,(oe,le)=>typeof oe=="string"&&typeof le=="string"?oe===le:typeof oe!="string"&&typeof le!="string"?oe.base===le.base&&oe.pattern===le.pattern:!1)}e.patternsEquals=V}),define(Re[89],Oe([1,0,10,131,25,13,2]),function(te,e,i,k,D,N,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class S{constructor(u="",h=!1){if(this.value=u,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(u,h=0){return this.value+=c(this.supportThemeIcons?(0,k.escapeIcons)(u):u).replace(/([ \t]+)/g,(y,C)=>"&nbsp;".repeat(C.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,h){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(u,h,y){return this.value+="[",this.value+=this.c(h,"]"),this.value+="](",this.value+=this.c(String(u),")"),y&&(this.value+=` "${this.c(this.c(y,'"'),")")}"`),this.value+=")",this}c(u,h){const y=new RegExp((0,N.escapeRegExpCharacters)(h),"g");return u.replace(y,(C,v)=>u.charAt(v-1)!=="\\"?`\\${C}`:C)}}e.MarkdownString=S;function m(t){return O(t)?!t.value:Array.isArray(t)?t.every(m):!0}e.isEmptyMarkdownString=m;function O(t){return t instanceof S?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function w(t,u){return t===u?!0:!t||!u?!1:t.value===u.value&&t.isTrusted===u.isTrusted&&t.supportThemeIcons===u.supportThemeIcons&&t.supportHtml===u.supportHtml&&(t.baseUri===u.baseUri||!!t.baseUri&&!!u.baseUri&&(0,D.isEqual)(F.URI.from(t.baseUri),F.URI.from(u.baseUri)))}e.markdownStringEqual=w;function c(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=c;function p(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=p;function g(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=g;function d(t){const u=[],h=t.split("|").map(C=>C.trim());t=h[0];const y=h[1];if(y){const C=/height=(\d+)/.exec(y),v=/width=(\d+)/.exec(y),n=C?C[1]:"",l=v?v[1]:"",r=isFinite(parseInt(l)),a=isFinite(parseInt(n));r&&u.push(`width="${l}"`),a&&u.push(`height="${n}"`)}return{href:t,dimensions:u}}e.parseHrefAndDimensions=d}),define(Re[90],Oe([1,0,18,41,19,21,25,13]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(a,b){const{os:I,tildify:f,relative:P}=b;if(P){const s=m(a,P,I);if(typeof s=="string")return s}let E=a.fsPath;if(I===1&&!N.isWindows?E=E.replace(/\//g,"\\"):I!==1&&N.isWindows&&(E=E.replace(/\\/g,"/")),I!==1&&f?.userHome){const s=f.userHome.fsPath;let M;a.scheme!==f.userHome.scheme&&a.path.startsWith(D.posix.sep)?M=f.userHome.with({path:a.path}).fsPath:M=a.fsPath,E=c(M,s,I)}return(I===1?D.win32:D.posix).normalize(O(E,I===1))}e.getPathLabel=S;function m(a,b,I){const f=I===1?D.win32:D.posix,P=I===3?F.extUri:F.extUriIgnorePathCase,E=b.getWorkspace(),o=(0,i.firstOrDefault)(E.folders);if(!o)return;a.scheme!==o.uri.scheme&&a.path.startsWith(D.posix.sep)&&(a=o.uri.with({path:a.path}));const s=b.getWorkspaceFolder(a);if(!s)return;let M;if(P.isEqual(s.uri,a)?M="":M=P.relativePath(s.uri,a)??"",M&&(M=f.normalize(M)),E.folders.length>1&&!b.noPrefix){const B=s.name?s.name:P.basenameOrAuthority(s.uri);M=M?`${B} \u2022 ${M}`:B}return M}function O(a,b=N.isWindows){return(0,k.hasDriveLetter)(a,b)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=O;let w=Object.create(null);function c(a,b,I=N.OS){if(I===1||!a||!b)return a;let f=w.original===b?w.normalized:void 0;f||(f=b,N.isWindows&&(f=(0,k.toSlashes)(f)),f=`${(0,R.rtrim)(f,D.posix.sep)}${D.posix.sep}`,w={original:b,normalized:f});let P=a;return N.isWindows&&(P=(0,k.toSlashes)(P)),(I===3?P.startsWith(f):(0,R.startsWithIgnoreCase)(P,f))?`~/${P.substr(f.length)}`:a}e.tildify=c;function p(a,b){return a.replace(/^~($|\/|\\)/,`${b}$1`)}e.untildify=p;const g="\u2026",d="\\\\",t="~";function u(a,b=D.sep){const I=new Array(a.length);let f=!1;for(let P=0;P<a.length;P++){const E=a[P];if(E===""){I[P]=`.${b}`;continue}if(!E){I[P]=E;continue}f=!0;let o="",s=E;s.indexOf(d)===0?(o=s.substr(0,s.indexOf(d)+d.length),s=s.substr(s.indexOf(d)+d.length)):s.indexOf(b)===0?(o=s.substr(0,s.indexOf(b)+b.length),s=s.substr(s.indexOf(b)+b.length)):s.indexOf(t)===0&&(o=s.substr(0,s.indexOf(t)+t.length),s=s.substr(s.indexOf(t)+t.length));const M=s.split(b);for(let B=1;f&&B<=M.length;B++)for(let X=M.length-B;f&&X>=0;X--){f=!1;let G=M.slice(X,X+B).join(b);for(let W=0;!f&&W<a.length;W++)if(W!==P&&a[W]&&a[W].indexOf(G)>-1){const U=X+B===M.length,q=X>0&&a[W].indexOf(b)>-1?b+G:G,z=a[W].endsWith(q);f=!U||z}if(!f){let W="";(M[0].endsWith(":")||o!=="")&&(X===1&&(X=0,B++,G=M[0]+b+G),X>0&&(W=M[0]+b),W=o+W),X>0&&(W=W+g+b),W=W+G,X+B<M.length&&(W=W+b+g),I[P]=W}}f&&(I[P]=E)}return I}e.shorten=u;var h;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function y(a,b=Object.create(null)){const I=[];let f=!1,P="";for(const E of a)if(E==="$"||f&&E==="{")P&&I.push({value:P,type:h.TEXT}),P="",f=!0;else if(E==="}"&&f){const o=b[P];if(typeof o=="string")o.length&&I.push({value:o,type:h.VARIABLE});else if(o){const s=I[I.length-1];(!s||s.type!==h.SEPARATOR)&&I.push({value:o.label,type:h.SEPARATOR})}P="",f=!1}else P+=E;return P&&!f&&I.push({value:P,type:h.TEXT}),I.filter((E,o)=>{if(E.type===h.SEPARATOR){const s=I[o-1],M=I[o+1];return[s,M].every(B=>B&&(B.type===h.VARIABLE||B.type===h.TEXT)&&B.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=y;function C(a,b){return N.isMacintosh||b?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.isMacintosh?"&":"&&"):a.replace(/&&|&/g,I=>I==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function v(a,b){return N.isMacintosh||b?a.replace(/\(&&\w\)|&&/g,""):N.isWindows?a.replace(/&&|&/g,I=>I==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function n(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=n;function l(a){if(a.endsWith("]")){const b=a.lastIndexOf(" [",a.length-2);if(b!==-1){const I=r(a.substring(0,b));return{name:I.name,parentPath:I.parentPath+a.substring(b)}}}return r(a)}e.splitRecentLabel=l;function r(a){const b=a.indexOf("/")!==-1?D.posix:D.win32,I=b.basename(a),f=b.dirname(a);return I.length?{name:I,parentPath:f}:{name:f,parentPath:""}}}),define(Re[132],Oe([1,0,24,2]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(w){return w.toJSON()}class N{constructor(c){this.a=c}transformIncoming(c){const p=this.a.transformIncoming(c);return p===c?c:D(k.URI.from(p))}transformOutgoing(c){const p=this.a.transformOutgoing(c);return p===c?c:D(k.URI.from(p))}transformOutgoingURI(c){const p=this.a.transformOutgoing(c);return p===c?c:k.URI.from(p)}transformOutgoingScheme(c){return this.a.transformOutgoingScheme(c)}}e.URITransformer=N,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function F(w,c,p){if(!w||p>200)return null;if(typeof w=="object"){if(w instanceof k.URI)return c.transformOutgoing(w);for(const g in w)if(Object.hasOwnProperty.call(w,g)){const d=F(w[g],c,p+1);d!==null&&(w[g]=d)}}return null}function R(w,c){const p=F(w,c,0);return p===null?w:p}e.transformOutgoingURIs=R;function S(w,c,p,g){if(!w||g>200)return null;if(typeof w=="object"){if(w.$mid===1)return p?k.URI.revive(c.transformIncoming(w)):c.transformIncoming(w);if(w instanceof i.VSBuffer)return null;for(const d in w)if(Object.hasOwnProperty.call(w,d)){const t=S(w[d],c,p,g+1);t!==null&&(w[d]=t)}}return null}function m(w,c){const p=S(w,c,!1,0);return p===null?w:p}e.transformIncomingURIs=m;function O(w,c){const p=S(w,c,!0,0);return p===null?w:p}e.transformAndReviveIncomingURIs=O}),define(Re[133],Oe([1,0,37,19]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(N,F,R,S,m,O){if(Array.isArray(N)){let w=0;for(const c of N){const p=D(c,F,R,S,m,O);if(p===10)return p;p>w&&(w=p)}return w}else{if(typeof N=="string")return S?N==="*"?5:N===R?10:0:0;if(N){const{language:w,pattern:c,scheme:p,hasAccessToAllModels:g,notebookType:d}=N;if(!S&&!g)return 0;d&&m&&(F=m);let t=0;if(p)if(p===F.scheme)t=10;else if(p==="*")t=5;else return 0;if(w)if(w===R)t=10;else if(w==="*")t=Math.max(t,5);else return 0;if(d)if(d===O)t=10;else if(d==="*"&&O!==void 0)t=Math.max(t,5);else return 0;if(c){let u;if(typeof c=="string"?u=c:u={...c,base:(0,k.normalize)(c.base)},u===F.fsPath||(0,i.match)(u,F.fsPath))t=10;else return 0}return t}else return 0}}e.score=D}),define(Re[91],Oe([1,0,24,21]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(D||(D={}));function N(w){for(let c=0,p=w.length;c<p;c+=4){const g=w[c+0],d=w[c+1],t=w[c+2],u=w[c+3];w[c+0]=u,w[c+1]=t,w[c+2]=d,w[c+3]=g}}function F(w){const c=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return k.isLittleEndian()||N(c),i.VSBuffer.wrap(c)}function R(w){const c=w.buffer;if(k.isLittleEndian()||N(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const p=new Uint8Array(c.byteLength);return p.set(c),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function S(w){const c=new Uint32Array(m(w));let p=0;if(c[p++]=w.id,w.type==="full")c[p++]=1,c[p++]=w.data.length,c.set(w.data,p),p+=w.data.length;else{c[p++]=2,c[p++]=w.deltas.length;for(const g of w.deltas)c[p++]=g.start,c[p++]=g.deleteCount,g.data?(c[p++]=g.data.length,c.set(g.data,p),p+=g.data.length):c[p++]=0}return F(c)}e.encodeSemanticTokensDto=S;function m(w){let c=0;if(c+=1+1,w.type==="full")c+=1+w.data.length;else{c+=1,c+=(1+1+1)*w.deltas.length;for(const p of w.deltas)p.data&&(c+=p.data.length)}return c}function O(w){const c=R(w);let p=0;const g=c[p++];if(c[p++]===1){const h=c[p++],y=c.subarray(p,p+h);return p+=h,{id:g,type:"full",data:y}}const t=c[p++],u=[];for(let h=0;h<t;h++){const y=c[p++],C=c[p++],v=c[p++];let n;v>0&&(n=c.subarray(p,p+v),p+=v),u[h]={start:y,deleteCount:C,data:n}}return{id:g,type:"delta",deltas:u}}e.decodeSemanticTokensDto=O}),define(Re[134],Oe([11,12]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Re[135],Oe([1,0,134,21,136,18,26,121]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=m;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class w{constructor(_,fe,$e,qe){this.id=_,this.name=fe,this.defaultValue=$e,this.schema=qe}applyUpdate(_,fe){return p(_,fe)}compute(_,fe,$e){return $e}}class c{constructor(_,fe){this.newValue=_,this.didChange=fe}}e.ApplyUpdateResult=c;function p(J,_){if(typeof J!="object"||typeof _!="object"||!J||!_)return new c(_,J!==_);if(Array.isArray(J)||Array.isArray(_)){const $e=Array.isArray(J)&&Array.isArray(_)&&N.equals(J,_);return new c(_,!$e)}let fe=!1;for(const $e in _)if(_.hasOwnProperty($e)){const qe=p(J[$e],_[$e]);qe.didChange&&(J[$e]=qe.newValue,fe=!0)}return new c(J,fe)}class g{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,fe){return p(_,fe)}validate(_){return this.defaultValue}}class d{constructor(_,fe,$e,qe){this.id=_,this.name=fe,this.defaultValue=$e,this.schema=qe}applyUpdate(_,fe){return p(_,fe)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,fe,$e){return $e}}function t(J,_){return typeof J>"u"?_:J==="false"?!1:!!J}e.boolean=t;class u extends d{constructor(_,fe,$e,qe=void 0){typeof qe<"u"&&(qe.type="boolean",qe.default=$e),super(_,fe,$e,qe)}validate(_){return t(_,this.defaultValue)}}function h(J,_,fe,$e){if(typeof J>"u")return _;let qe=parseInt(J,10);return isNaN(qe)?_:(qe=Math.max(fe,qe),qe=Math.min($e,qe),qe|0)}e.clampedInt=h;class y extends d{static clampedInt(_,fe,$e,qe){return h(_,fe,$e,qe)}constructor(_,fe,$e,qe,We,_e=void 0){typeof _e<"u"&&(_e.type="integer",_e.default=$e,_e.minimum=qe,_e.maximum=We),super(_,fe,$e,_e),this.minimum=qe,this.maximum=We}validate(_){return y.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function C(J,_,fe,$e){if(typeof J>"u")return _;const qe=v.float(J,_);return v.clamp(qe,fe,$e)}e.clampedFloat=C;class v extends d{static clamp(_,fe,$e){return _<fe?fe:_>$e?$e:_}static float(_,fe){if(typeof _=="number")return _;if(typeof _>"u")return fe;const $e=parseFloat(_);return isNaN($e)?fe:$e}constructor(_,fe,$e,qe,We){typeof We<"u"&&(We.type="number",We.default=$e),super(_,fe,$e,We),this.validationFn=qe}validate(_){return this.validationFn(v.float(_,this.defaultValue))}}class n extends d{static string(_,fe){return typeof _!="string"?fe:_}constructor(_,fe,$e,qe=void 0){typeof qe<"u"&&(qe.type="string",qe.default=$e),super(_,fe,$e,qe)}validate(_){return n.string(_,this.defaultValue)}}function l(J,_,fe,$e){return typeof J!="string"?_:$e&&J in $e?$e[J]:fe.indexOf(J)===-1?_:J}e.stringSet=l;class r extends d{constructor(_,fe,$e,qe,We=void 0){typeof We<"u"&&(We.type="string",We.enum=qe,We.default=$e),super(_,fe,$e,We),this.c=qe}validate(_){return l(_,this.defaultValue,this.c)}}class a extends w{constructor(_,fe,$e,qe,We,_e,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=We,mt.default=qe),super(_,fe,$e,mt),this.c=We,this.d=_e}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function b(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class I extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,fe,$e){return $e===0?_.accessibilitySupport:$e}}class f extends w{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:i.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{insertSpace:t(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var P;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(P||(e.TextEditorCursorBlinkingStyle=P={}));function E(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(o||(e.TextEditorCursorStyle=o={}));function s(J){switch(J){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=s;function M(J){switch(J){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class B extends g{constructor(){super(137)}compute(_,fe,$e){const qe=["monaco-editor"];return fe.get(37)&&qe.push(fe.get(37)),_.extraEditorClassName&&qe.push(_.extraEditorClassName),fe.get(71)==="default"?qe.push("mouse-default"):fe.get(71)==="copy"&&qe.push("mouse-copy"),fe.get(107)&&qe.push("showUnused"),fe.get(135)&&qe.push("showDeprecated"),qe.join(" ")}}class X extends u{constructor(){super(35,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(_,fe,$e){return $e&&_.emptySelectionClipboard}}class G extends w{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:i.localize(16,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:i.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{cursorMoveOnType:t(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":l(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":l(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(fe.loop,this.defaultValue.loop)}}}class W extends w{constructor(){super(49,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?W.OFF:_==="true"?W.ON:_:_?W.ON:W.OFF}}e.EditorFontLigatures=W,W.OFF='"liga" off, "calt" off',W.ON='"liga" on, "calt" on';class U extends w{constructor(){super(52,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:i.localize(22,null)},{type:"string",description:i.localize(23,null)}],description:i.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?U.OFF:_==="true"?U.TRANSLATE:_:_?U.TRANSLATE:U.OFF}compute(_,fe,$e){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=U,U.OFF="normal",U.TRANSLATE="translate";class q extends g{constructor(){super(48)}compute(_,fe,$e){return _.fontInfo}}class z extends d{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(25,null)})}validate(_){const fe=v.float(_,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(fe,6,100)}compute(_,fe,$e){return _.fontInfo.fontSize}}class V extends w{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:i.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(y.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}V.c=["normal","bold","100","200","300","400","500","600","700","800","900"],V.d=1,V.e=1e3;class ee extends w{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[i.localize(28,null),i.localize(29,null),i.localize(30,null)]},$e=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(32,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(33,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:i.localize(34,null),...fe},"editor.gotoLocation.multipleImplementations":{description:i.localize(35,null),...fe},"editor.gotoLocation.multipleReferences":{description:i.localize(36,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:$e,description:i.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:$e,description:i.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:$e,description:i.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:$e,description:i.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:$e,description:i.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{multiple:l(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??l(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??l(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??l(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??l(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??l(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Ce extends w{constructor(){const _={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:i.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:i.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:i.localize(44,null)},"editor.hover.above":{type:"boolean",default:_.above,description:i.localize(45,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{enabled:t(fe.enabled,this.defaultValue.enabled),delay:y.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:t(fe.sticky,this.defaultValue.sticky),above:t(fe.above,this.defaultValue.above)}}}var oe;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(oe||(e.RenderMinimap=oe={}));class le extends g{constructor(){super(140)}compute(_,fe,$e){return le.computeLayout(fe,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const fe=_.height/_.lineHeight,$e=Math.floor(_.paddingTop/_.lineHeight);let qe=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(qe=Math.max(qe,fe-1));const We=($e+_.viewLineCount+qe)/(_.pixelRatio*_.height),_e=Math.floor(_.viewLineCount/We);return{typicalViewportLineCount:fe,extraLinesBeforeFirstLine:$e,extraLinesBeyondLastLine:qe,desiredRatio:We,minimapLineCount:_e}}static c(_,fe){const $e=_.outerWidth,qe=_.outerHeight,We=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(We*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const _e=fe.stableMinimapLayoutInput,mt=_e&&_.outerHeight===_e.outerHeight&&_.lineHeight===_e.lineHeight&&_.typicalHalfwidthCharacterWidth===_e.typicalHalfwidthCharacterWidth&&_.pixelRatio===_e.pixelRatio&&_.scrollBeyondLastLine===_e.scrollBeyondLastLine&&_.paddingTop===_e.paddingTop&&_.paddingBottom===_e.paddingBottom&&_.minimap.enabled===_e.minimap.enabled&&_.minimap.side===_e.minimap.side&&_.minimap.size===_e.minimap.size&&_.minimap.showSlider===_e.minimap.showSlider&&_.minimap.renderCharacters===_e.minimap.renderCharacters&&_.minimap.maxColumn===_e.minimap.maxColumn&&_.minimap.scale===_e.minimap.scale&&_.verticalScrollbarWidth===_e.verticalScrollbarWidth&&_.isViewportWrapping===_e.isViewportWrapping,St=_.lineHeight,kt=_.typicalHalfwidthCharacterWidth,Gt=_.scrollBeyondLastLine,Bt=_.minimap.renderCharacters;let yt=We>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Wt=_.minimap.maxColumn,Mt=_.minimap.size,qt=_.minimap.side,Ot=_.verticalScrollbarWidth,Lt=_.viewLineCount,Ht=_.remainingWidth,at=_.isViewportWrapping,ht=Bt?2:3;let Nt=Math.floor(We*qe);const Ut=Nt/We;let Et=!1,lt=!1,Ct=ht*yt,$t=yt/We,Ae=1;if(Mt==="fill"||Mt==="fit"){const{typicalViewportLineCount:He,extraLinesBeforeFirstLine:et,extraLinesBeyondLastLine:wt,desiredRatio:At,minimapLineCount:Tt}=le.computeContainedMinimapLineCount({viewLineCount:Lt,scrollBeyondLastLine:Gt,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:qe,lineHeight:St,pixelRatio:We});if(Lt/Tt>1)Et=!0,lt=!0,yt=1,Ct=1,$t=yt/We;else{let ot=!1,gt=yt+1;if(Mt==="fit"){const pt=Math.ceil((et+Lt+wt)*Ct);at&&mt&&Ht<=fe.stableFitRemainingWidth?(ot=!0,gt=fe.stableFitMaxMinimapScale):ot=pt>Nt}if(Mt==="fill"||ot){Et=!0;const pt=yt;Ct=Math.min(St*We,Math.max(1,Math.floor(1/At))),at&&mt&&Ht<=fe.stableFitRemainingWidth&&(gt=fe.stableFitMaxMinimapScale),yt=Math.min(gt,Math.max(1,Math.floor(Ct/ht))),yt>pt&&(Ae=Math.min(2,yt/pt)),$t=yt/We/Ae,Nt=Math.ceil(Math.max(He,et+Lt+wt)*Ct),at?(fe.stableMinimapLayoutInput=_,fe.stableFitRemainingWidth=Ht,fe.stableFitMaxMinimapScale=yt):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const Ee=Math.floor(Wt*$t),ve=Math.min(Ee,Math.max(0,Math.floor((Ht-Ot-2)*$t/(kt+$t)))+e.MINIMAP_GUTTER_WIDTH);let Y=Math.floor(We*ve);const Me=Y/We;Y=Math.floor(Y*Ae);const ze=Bt?1:2,Xe=qt==="left"?0:$e-ve-Ot;return{renderMinimap:ze,minimapLeft:Xe,minimapWidth:ve,minimapHeightIsEditorHeight:Et,minimapIsSampling:lt,minimapScale:yt,minimapLineHeight:Ct,minimapCanvasInnerWidth:Y,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:Me,minimapCanvasOuterHeight:Ut}}static computeLayout(_,fe){const $e=fe.outerWidth|0,qe=fe.outerHeight|0,We=fe.lineHeight|0,_e=fe.lineNumbersDigitCount|0,mt=fe.typicalHalfwidthCharacterWidth,St=fe.maxDigitWidth,kt=fe.pixelRatio,Gt=fe.viewLineCount,Bt=_.get(132),yt=Bt==="inherit"?_.get(131):Bt,Wt=yt==="inherit"?_.get(127):yt,Mt=_.get(130),qt=fe.isDominatedByLongLines,Ot=_.get(55),Lt=_.get(65).renderType!==0,Ht=_.get(66),at=_.get(101),ht=_.get(81),Nt=_.get(70),Ut=_.get(99),Et=Ut.verticalScrollbarSize,lt=Ut.verticalHasArrows,Ct=Ut.arrowSize,$t=Ut.horizontalScrollbarSize,Ae=_.get(41),Ee=_.get(106)!=="never";let ve=_.get(63);Ae&&Ee&&(ve+=16);let Y=0;if(Lt){const oi=Math.max(_e,Ht);Y=Math.round(oi*St)}let Me=0;Ot&&(Me=We*fe.glyphMarginDecorationLaneCount);let ze=0,Xe=ze+Me,He=Xe+Y,et=He+ve;const wt=$e-Me-Y-ve;let At=!1,Tt=!1,vt=-1;yt==="inherit"&&qt?(At=!0,Tt=!0):Wt==="on"||Wt==="bounded"?Tt=!0:Wt==="wordWrapColumn"&&(vt=Mt);const ot=le.c({outerWidth:$e,outerHeight:qe,lineHeight:We,typicalHalfwidthCharacterWidth:mt,pixelRatio:kt,scrollBeyondLastLine:at,paddingTop:ht.top,paddingBottom:ht.bottom,minimap:Nt,verticalScrollbarWidth:Et,viewLineCount:Gt,remainingWidth:wt,isViewportWrapping:Tt},fe.memory||new O);ot.renderMinimap!==0&&ot.minimapLeft===0&&(ze+=ot.minimapWidth,Xe+=ot.minimapWidth,He+=ot.minimapWidth,et+=ot.minimapWidth);const gt=wt-ot.minimapWidth,pt=Math.max(1,Math.floor((gt-Et-2)/mt)),bt=lt?Ct:0;return Tt&&(vt=Math.max(1,pt),Wt==="bounded"&&(vt=Math.min(vt,Mt))),{width:$e,height:qe,glyphMarginLeft:ze,glyphMarginWidth:Me,glyphMarginDecorationLaneCount:fe.glyphMarginDecorationLaneCount,lineNumbersLeft:Xe,lineNumbersWidth:Y,decorationsLeft:He,decorationsWidth:ve,contentLeft:et,contentWidth:gt,minimap:ot,viewportColumn:pt,isWordWrapMinified:At,isViewportWrapping:Tt,wrappingColumn:vt,verticalScrollbarWidth:Et,horizontalScrollbarHeight:$t,overviewRuler:{top:bt,width:Et,height:qe-2*bt,right:0}}}}e.EditorLayoutInfoComputer=le;class Q extends w{constructor(){super(134,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(46,null),i.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(48,null)}})}validate(_){return l(_,"simple",["simple","advanced"])}compute(_,fe,$e){return fe.get(2)===2?"advanced":$e}}class ue extends w{constructor(){const _={enabled:!0};super(62,"lightbulb",_,{"editor.lightbulb.enabled":{type:"boolean",default:_.enabled,description:i.localize(49,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:t(_.enabled,this.defaultValue.enabled)}}}class Ie extends w{constructor(){const _={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(111,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:i.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:i.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:i.localize(52,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{enabled:t(fe.enabled,this.defaultValue.enabled),maxLineCount:y.clampedInt(fe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:l(fe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class Pe extends w{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(136,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:i.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(54,null),i.localize(55,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(56,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:i.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:i.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:i.localize(60,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return typeof fe.enabled=="boolean"&&(fe.enabled=fe.enabled?"on":"off"),{enabled:l(fe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:y.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(fe.fontFamily,this.defaultValue.fontFamily),padding:t(fe.padding,this.defaultValue.padding)}}}class be extends w{constructor(){super(63,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):y.clampedInt(_,this.defaultValue,0,1e3)}compute(_,fe,$e){return $e<0?y.clampedInt(-$e*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):$e}}class A extends v{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>v.clamp(_,0,150),{markdownDescription:i.localize(61,null)})}compute(_,fe,$e){return _.fontInfo.lineHeight}}class K extends w{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:i.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:i.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(64,null),i.localize(65,null),i.localize(66,null)],default:_.size,description:i.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:i.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:i.localize(69,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:i.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:i.localize(72,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{enabled:t(fe.enabled,this.defaultValue.enabled),autohide:t(fe.autohide,this.defaultValue.autohide),size:l(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:l(fe.side,this.defaultValue.side,["right","left"]),showSlider:l(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(fe.renderCharacters,this.defaultValue.renderCharacters),scale:y.clampedInt(fe.scale,1,1,3),maxColumn:y.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function he(J){return J==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class De extends w{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(74,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{top:y.clampedInt(fe.top,0,0,1e3),bottom:y.clampedInt(fe.bottom,0,0,1e3)}}}class we extends w{constructor(){const _={enabled:!0,cycle:!0};super(83,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:i.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:i.localize(76,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{enabled:t(fe.enabled,this.defaultValue.enabled),cycle:t(fe.cycle,this.defaultValue.cycle)}}}class ge extends g{constructor(){super(138)}compute(_,fe,$e){return _.pixelRatio}}class ke extends w{constructor(){const _={other:"on",comments:"off",strings:"off"},fe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(77,null),i.localize(78,null),i.localize(79,null)]}];super(86,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:fe,default:_.strings,description:i.localize(80,null)},comments:{anyOf:fe,default:_.comments,description:i.localize(81,null)},other:{anyOf:fe,default:_.other,description:i.localize(82,null)}},default:_,markdownDescription:i.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const kt=_?"on":"off";return{comments:kt,strings:kt,other:kt}}if(!_||typeof _!="object")return this.defaultValue;const{other:fe,comments:$e,strings:qe}=_,We=["on","inline","off"];let _e,mt,St;return typeof fe=="boolean"?_e=fe?"on":"off":_e=l(fe,this.defaultValue.other,We),typeof $e=="boolean"?mt=$e?"on":"off":mt=l($e,this.defaultValue.comments,We),typeof qe=="boolean"?St=qe?"on":"off":St=l(qe,this.defaultValue.strings,We),{other:_e,comments:mt,strings:St}}}var ae;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(ae||(e.RenderLineNumbersType=ae={}));class de extends w{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(84,null),i.localize(85,null),i.localize(86,null),i.localize(87,null)],default:"on",description:i.localize(88,null)})}validate(_){let fe=this.defaultValue.renderType,$e=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(fe=4,$e=_):_==="interval"?fe=3:_==="relative"?fe=2:_==="on"?fe=1:fe=0),{renderType:fe,renderFn:$e}}}function Z(J){const _=J.get(94);return _==="editable"?J.get(88):_!=="on"}e.filterValidationDecorations=Z;class ne extends w{constructor(){const _=[],fe={type:"number",description:i.localize(89,null)};super(98,"rulers",_,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:i.localize(90,null),format:"color-hex"}}}]},default:_,description:i.localize(91,null)})}validate(_){if(Array.isArray(_)){const fe=[];for(const $e of _)if(typeof $e=="number")fe.push({column:y.clampedInt($e,0,0,1e4),color:null});else if($e&&typeof $e=="object"){const qe=$e;fe.push({column:y.clampedInt(qe.column,0,0,1e4),color:qe.color})}return fe.sort(($e,qe)=>$e.column-qe.column),fe}return this.defaultValue}}function T(J,_){if(typeof J!="string")return _;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends w{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(99,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(92,null),i.localize(93,null),i.localize(94,null)],default:"auto",description:i.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(96,null),i.localize(97,null),i.localize(98,null)],default:"auto",description:i.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:i.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:i.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:i.localize(102,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_,$e=y.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=y.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:y.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:T(fe.vertical,this.defaultValue.vertical),horizontal:T(fe.horizontal,this.defaultValue.horizontal),useShadows:t(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:$e,horizontalSliderSize:y.clampedInt(fe.horizontalSliderSize,$e,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:y.clampedInt(fe.verticalSliderSize,qe,0,1e3),scrollByPage:t(fe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class j extends w{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(121,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:i.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:i.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:i.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:i.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:i.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:i.localize(109,null)}})}applyUpdate(_,fe){let $e=!1;fe.allowedCharacters&&_&&(F.equals(_.allowedCharacters,fe.allowedCharacters)||(_={..._,allowedCharacters:fe.allowedCharacters},$e=!0)),fe.allowedLocales&&_&&(F.equals(_.allowedLocales,fe.allowedLocales)||(_={..._,allowedLocales:fe.allowedLocales},$e=!0));const qe=super.applyUpdate(_,fe);return $e?new c(qe.newValue,!0):qe}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{nonBasicASCII:ie(fe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(fe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(fe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ie(fe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ie(fe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,fe){if(typeof _!="object"||!_)return fe;const $e={};for(const[qe,We]of Object.entries(_))We===!0&&($e[qe]=!0);return $e}}class x extends w{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(60,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:i.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover"],enumDescriptions:[i.localize(111,null),i.localize(112,null)],description:i.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:i.localize(114,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{enabled:t(fe.enabled,this.defaultValue.enabled),mode:l(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:l(fe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(fe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(fe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class ce extends w{constructor(){const _={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:i.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:i.localize(116,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{enabled:t(fe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(fe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class pe extends w{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(117,null),i.localize(118,null),i.localize(119,null)],default:_.bracketPairs,description:i.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(121,null),i.localize(122,null),i.localize(123,null)],default:_.bracketPairsHorizontal,description:i.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:i.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:i.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(127,null),i.localize(128,null),i.localize(129,null)],default:_.highlightActiveIndentation,description:i.localize(130,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{bracketPairs:ie(fe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ie(fe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(fe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(fe.indentation,this.defaultValue.indentation),highlightActiveIndentation:ie(fe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ie(J,_,fe){const $e=fe.indexOf(J);return $e===-1?_:fe[$e]}class ye extends w{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(114,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(131,null),i.localize(132,null)],default:_.insertMode,description:i.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:i.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:i.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:i.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[i.localize(137,null),i.localize(138,null),i.localize(139,null),i.localize(140,null)],default:_.selectionMode,markdownDescription:i.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:i.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:i.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:i.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:i.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:i.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(178,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{insertMode:l(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:l(fe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(fe.showIcons,this.defaultValue.showIcons),showStatusBar:t(fe.showStatusBar,this.defaultValue.showStatusBar),preview:t(fe.preview,this.defaultValue.preview),previewMode:l(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(fe.showMethods,this.defaultValue.showMethods),showFunctions:t(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:t(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(fe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(fe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(fe.showFields,this.defaultValue.showFields),showVariables:t(fe.showVariables,this.defaultValue.showVariables),showClasses:t(fe.showClasses,this.defaultValue.showClasses),showStructs:t(fe.showStructs,this.defaultValue.showStructs),showInterfaces:t(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:t(fe.showModules,this.defaultValue.showModules),showProperties:t(fe.showProperties,this.defaultValue.showProperties),showEvents:t(fe.showEvents,this.defaultValue.showEvents),showOperators:t(fe.showOperators,this.defaultValue.showOperators),showUnits:t(fe.showUnits,this.defaultValue.showUnits),showValues:t(fe.showValues,this.defaultValue.showValues),showConstants:t(fe.showConstants,this.defaultValue.showConstants),showEnums:t(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:t(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(fe.showKeywords,this.defaultValue.showKeywords),showWords:t(fe.showWords,this.defaultValue.showWords),showColors:t(fe.showColors,this.defaultValue.showColors),showFiles:t(fe.showFiles,this.defaultValue.showFiles),showReferences:t(fe.showReferences,this.defaultValue.showReferences),showFolders:t(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:t(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(fe.showSnippets,this.defaultValue.showSnippets),showUsers:t(fe.showUsers,this.defaultValue.showUsers),showIssues:t(fe.showIssues,this.defaultValue.showIssues)}}}class Se extends w{constructor(){super(109,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(179,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var Be;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class je extends w{constructor(){super(133,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(180,null),i.localize(181,null),i.localize(182,null),i.localize(183,null)],description:i.localize(184,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,fe,$e){return fe.get(2)===2?0:$e}}class Ze extends g{constructor(){super(141)}compute(_,fe,$e){const qe=fe.get(140);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}class Qe extends w{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(34,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:i.localize(185,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:i.localize(186,null),enum:["afterDrop","never"],enumDescriptions:[i.localize(187,null),i.localize(188,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{enabled:t(fe.enabled,this.defaultValue.enabled),showDropSelector:l(fe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ke extends w{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(82,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:i.localize(189,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:i.localize(190,null),enum:["afterPaste","never"],enumDescriptions:[i.localize(191,null),i.localize(192,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const fe=_;return{enabled:t(fe.enabled,this.defaultValue.enabled),showPasteSelector:l(fe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?st:k.isLinux?tt:it,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(J){return e.editorOptionsRegistry[J.id]=J,J}var dt;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",J[J.autoClosingDelete=7]="autoClosingDelete",J[J.autoClosingOvertype=8]="autoClosingOvertype",J[J.autoClosingQuotes=9]="autoClosingQuotes",J[J.autoIndent=10]="autoIndent",J[J.automaticLayout=11]="automaticLayout",J[J.autoSurround=12]="autoSurround",J[J.bracketPairColorization=13]="bracketPairColorization",J[J.guides=14]="guides",J[J.codeLens=15]="codeLens",J[J.codeLensFontFamily=16]="codeLensFontFamily",J[J.codeLensFontSize=17]="codeLensFontSize",J[J.colorDecorators=18]="colorDecorators",J[J.colorDecoratorsLimit=19]="colorDecoratorsLimit",J[J.columnSelection=20]="columnSelection",J[J.comments=21]="comments",J[J.contextmenu=22]="contextmenu",J[J.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",J[J.cursorBlinking=24]="cursorBlinking",J[J.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",J[J.cursorStyle=26]="cursorStyle",J[J.cursorSurroundingLines=27]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",J[J.cursorWidth=29]="cursorWidth",J[J.disableLayerHinting=30]="disableLayerHinting",J[J.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",J[J.domReadOnly=32]="domReadOnly",J[J.dragAndDrop=33]="dragAndDrop",J[J.dropIntoEditor=34]="dropIntoEditor",J[J.emptySelectionClipboard=35]="emptySelectionClipboard",J[J.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",J[J.extraEditorClassName=37]="extraEditorClassName",J[J.fastScrollSensitivity=38]="fastScrollSensitivity",J[J.find=39]="find",J[J.fixedOverflowWidgets=40]="fixedOverflowWidgets",J[J.folding=41]="folding",J[J.foldingStrategy=42]="foldingStrategy",J[J.foldingHighlight=43]="foldingHighlight",J[J.foldingImportsByDefault=44]="foldingImportsByDefault",J[J.foldingMaximumRegions=45]="foldingMaximumRegions",J[J.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=47]="fontFamily",J[J.fontInfo=48]="fontInfo",J[J.fontLigatures=49]="fontLigatures",J[J.fontSize=50]="fontSize",J[J.fontWeight=51]="fontWeight",J[J.fontVariations=52]="fontVariations",J[J.formatOnPaste=53]="formatOnPaste",J[J.formatOnType=54]="formatOnType",J[J.glyphMargin=55]="glyphMargin",J[J.gotoLocation=56]="gotoLocation",J[J.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",J[J.hover=58]="hover",J[J.inDiffEditor=59]="inDiffEditor",J[J.inlineSuggest=60]="inlineSuggest",J[J.letterSpacing=61]="letterSpacing",J[J.lightbulb=62]="lightbulb",J[J.lineDecorationsWidth=63]="lineDecorationsWidth",J[J.lineHeight=64]="lineHeight",J[J.lineNumbers=65]="lineNumbers",J[J.lineNumbersMinChars=66]="lineNumbersMinChars",J[J.linkedEditing=67]="linkedEditing",J[J.links=68]="links",J[J.matchBrackets=69]="matchBrackets",J[J.minimap=70]="minimap",J[J.mouseStyle=71]="mouseStyle",J[J.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=73]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",J[J.multiCursorModifier=75]="multiCursorModifier",J[J.multiCursorPaste=76]="multiCursorPaste",J[J.multiCursorLimit=77]="multiCursorLimit",J[J.occurrencesHighlight=78]="occurrencesHighlight",J[J.overviewRulerBorder=79]="overviewRulerBorder",J[J.overviewRulerLanes=80]="overviewRulerLanes",J[J.padding=81]="padding",J[J.pasteAs=82]="pasteAs",J[J.parameterHints=83]="parameterHints",J[J.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",J[J.quickSuggestions=86]="quickSuggestions",J[J.quickSuggestionsDelay=87]="quickSuggestionsDelay",J[J.readOnly=88]="readOnly",J[J.renameOnType=89]="renameOnType",J[J.renderControlCharacters=90]="renderControlCharacters",J[J.renderFinalNewline=91]="renderFinalNewline",J[J.renderLineHighlight=92]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=93]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=94]="renderValidationDecorations",J[J.renderWhitespace=95]="renderWhitespace",J[J.revealHorizontalRightPadding=96]="revealHorizontalRightPadding",J[J.roundedSelection=97]="roundedSelection",J[J.rulers=98]="rulers",J[J.scrollbar=99]="scrollbar",J[J.scrollBeyondLastColumn=100]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=101]="scrollBeyondLastLine",J[J.scrollPredominantAxis=102]="scrollPredominantAxis",J[J.selectionClipboard=103]="selectionClipboard",J[J.selectionHighlight=104]="selectionHighlight",J[J.selectOnLineNumbers=105]="selectOnLineNumbers",J[J.showFoldingControls=106]="showFoldingControls",J[J.showUnused=107]="showUnused",J[J.snippetSuggestions=108]="snippetSuggestions",J[J.smartSelect=109]="smartSelect",J[J.smoothScrolling=110]="smoothScrolling",J[J.stickyScroll=111]="stickyScroll",J[J.stickyTabStops=112]="stickyTabStops",J[J.stopRenderingLineAfter=113]="stopRenderingLineAfter",J[J.suggest=114]="suggest",J[J.suggestFontSize=115]="suggestFontSize",J[J.suggestLineHeight=116]="suggestLineHeight",J[J.suggestOnTriggerCharacters=117]="suggestOnTriggerCharacters",J[J.suggestSelection=118]="suggestSelection",J[J.tabCompletion=119]="tabCompletion",J[J.tabIndex=120]="tabIndex",J[J.unicodeHighlighting=121]="unicodeHighlighting",J[J.unusualLineTerminators=122]="unusualLineTerminators",J[J.useShadowDOM=123]="useShadowDOM",J[J.useTabStops=124]="useTabStops",J[J.wordBreak=125]="wordBreak",J[J.wordSeparators=126]="wordSeparators",J[J.wordWrap=127]="wordWrap",J[J.wordWrapBreakAfterCharacters=128]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=129]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=130]="wordWrapColumn",J[J.wordWrapOverride1=131]="wordWrapOverride1",J[J.wordWrapOverride2=132]="wordWrapOverride2",J[J.wrappingIndent=133]="wrappingIndent",J[J.wrappingStrategy=134]="wrappingStrategy",J[J.showDeprecated=135]="showDeprecated",J[J.inlayHints=136]="inlayHints",J[J.editorClassName=137]="editorClassName",J[J.pixelRatio=138]="pixelRatio",J[J.tabFocusMode=139]="tabFocusMode",J[J.layoutInfo=140]="layoutInfo",J[J.wrappingInfo=141]="wrappingInfo",J[J.defaultColorDecorators=142]="defaultColorDecorators"})(dt||(e.EditorOption=dt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(193,null)})),acceptSuggestionOnEnter:Ne(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(194,null),""],markdownDescription:i.localize(195,null)})),accessibilitySupport:Ne(new I),accessibilityPageSize:Ne(new y(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(196,null),tags:["accessibility"]})),ariaLabel:Ne(new n(4,"ariaLabel",i.localize(197,null))),screenReaderAnnounceInlineSuggestion:Ne(new u(6,"screenReaderAnnounceInlineSuggestion",!0,{description:i.localize(198,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(199,null),i.localize(200,null),""],description:i.localize(201,null)})),autoClosingDelete:Ne(new r(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(202,null),""],description:i.localize(203,null)})),autoClosingOvertype:Ne(new r(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(204,null),""],description:i.localize(205,null)})),autoClosingQuotes:Ne(new r(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(206,null),i.localize(207,null),""],description:i.localize(208,null)})),autoIndent:Ne(new a(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[i.localize(209,null),i.localize(210,null),i.localize(211,null),i.localize(212,null),i.localize(213,null)],description:i.localize(214,null)})),automaticLayout:Ne(new u(11,"automaticLayout",!1)),autoSurround:Ne(new r(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(215,null),i.localize(216,null),i.localize(217,null),""],description:i.localize(218,null)})),bracketPairColorization:Ne(new ce),bracketPairGuides:Ne(new pe),stickyTabStops:Ne(new u(112,"stickyTabStops",!1,{description:i.localize(219,null)})),codeLens:Ne(new u(15,"codeLens",!0,{description:i.localize(220,null)})),codeLensFontFamily:Ne(new n(16,"codeLensFontFamily","",{description:i.localize(221,null)})),codeLensFontSize:Ne(new y(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(222,null)})),colorDecorators:Ne(new u(18,"colorDecorators",!0,{description:i.localize(223,null)})),colorDecoratorsLimit:Ne(new y(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:i.localize(224,null)})),columnSelection:Ne(new u(20,"columnSelection",!1,{description:i.localize(225,null)})),comments:Ne(new f),contextmenu:Ne(new u(22,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new u(23,"copyWithSyntaxHighlighting",!0,{description:i.localize(226,null)})),cursorBlinking:Ne(new a(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],E,{description:i.localize(227,null)})),cursorSmoothCaretAnimation:Ne(new r(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[i.localize(228,null),i.localize(229,null),i.localize(230,null)],description:i.localize(231,null)})),cursorStyle:Ne(new a(26,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:i.localize(232,null)})),cursorSurroundingLines:Ne(new y(27,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(233,null)})),cursorSurroundingLinesStyle:Ne(new r(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(234,null),i.localize(235,null)],description:i.localize(236,null)})),cursorWidth:Ne(new y(29,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(237,null)})),disableLayerHinting:Ne(new u(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new u(31,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new u(32,"domReadOnly",!1)),dragAndDrop:Ne(new u(33,"dragAndDrop",!0,{description:i.localize(238,null)})),emptySelectionClipboard:Ne(new X),dropIntoEditor:Ne(new Qe),stickyScroll:Ne(new Ie),experimentalWhitespaceRendering:Ne(new r(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[i.localize(239,null),i.localize(240,null),i.localize(241,null)],description:i.localize(242,null)})),extraEditorClassName:Ne(new n(37,"extraEditorClassName","")),fastScrollSensitivity:Ne(new v(38,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:i.localize(243,null)})),find:Ne(new G),fixedOverflowWidgets:Ne(new u(40,"fixedOverflowWidgets",!1)),folding:Ne(new u(41,"folding",!0,{description:i.localize(244,null)})),foldingStrategy:Ne(new r(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(245,null),i.localize(246,null)],description:i.localize(247,null)})),foldingHighlight:Ne(new u(43,"foldingHighlight",!0,{description:i.localize(248,null)})),foldingImportsByDefault:Ne(new u(44,"foldingImportsByDefault",!1,{description:i.localize(249,null)})),foldingMaximumRegions:Ne(new y(45,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(250,null)})),unfoldOnClickAfterEndOfLine:Ne(new u(46,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(251,null)})),fontFamily:Ne(new n(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(252,null)})),fontInfo:Ne(new q),fontLigatures2:Ne(new W),fontSize:Ne(new z),fontWeight:Ne(new V),fontVariations:Ne(new U),formatOnPaste:Ne(new u(53,"formatOnPaste",!1,{description:i.localize(253,null)})),formatOnType:Ne(new u(54,"formatOnType",!1,{description:i.localize(254,null)})),glyphMargin:Ne(new u(55,"glyphMargin",!0,{description:i.localize(255,null)})),gotoLocation:Ne(new ee),hideCursorInOverviewRuler:Ne(new u(57,"hideCursorInOverviewRuler",!1,{description:i.localize(256,null)})),hover:Ne(new Ce),inDiffEditor:Ne(new u(59,"inDiffEditor",!1)),letterSpacing:Ne(new v(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>v.clamp(J,-5,20),{description:i.localize(257,null)})),lightbulb:Ne(new ue),lineDecorationsWidth:Ne(new be),lineHeight:Ne(new A),lineNumbers:Ne(new de),lineNumbersMinChars:Ne(new y(66,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new u(67,"linkedEditing",!1,{description:i.localize(258,null)})),links:Ne(new u(68,"links",!0,{description:i.localize(259,null)})),matchBrackets:Ne(new r(69,"matchBrackets","always",["always","near","never"],{description:i.localize(260,null)})),minimap:Ne(new K),mouseStyle:Ne(new r(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new v(72,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:i.localize(261,null)})),mouseWheelZoom:Ne(new u(73,"mouseWheelZoom",!1,{markdownDescription:i.localize(262,null)})),multiCursorMergeOverlapping:Ne(new u(74,"multiCursorMergeOverlapping",!0,{description:i.localize(263,null)})),multiCursorModifier:Ne(new a(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[i.localize(264,null),i.localize(265,null)],markdownDescription:i.localize(266,null)})),multiCursorPaste:Ne(new r(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(267,null),i.localize(268,null)],markdownDescription:i.localize(269,null)})),multiCursorLimit:Ne(new y(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:i.localize(270,null)})),occurrencesHighlight:Ne(new u(78,"occurrencesHighlight",!0,{description:i.localize(271,null)})),overviewRulerBorder:Ne(new u(79,"overviewRulerBorder",!0,{description:i.localize(272,null)})),overviewRulerLanes:Ne(new y(80,"overviewRulerLanes",3,0,3)),padding:Ne(new De),pasteAs:Ne(new Ke),parameterHints:Ne(new we),peekWidgetDefaultFocus:Ne(new r(84,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(273,null),i.localize(274,null)],description:i.localize(275,null)})),definitionLinkOpensInPeek:Ne(new u(85,"definitionLinkOpensInPeek",!1,{description:i.localize(276,null)})),quickSuggestions:Ne(new ke),quickSuggestionsDelay:Ne(new y(87,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(277,null)})),readOnly:Ne(new u(88,"readOnly",!1)),renameOnType:Ne(new u(89,"renameOnType",!1,{description:i.localize(278,null),markdownDeprecationMessage:i.localize(279,null)})),renderControlCharacters:Ne(new u(90,"renderControlCharacters",!0,{description:i.localize(280,null),restricted:!0})),renderFinalNewline:Ne(new r(91,"renderFinalNewline",k.isLinux?"dimmed":"on",["off","on","dimmed"],{description:i.localize(281,null)})),renderLineHighlight:Ne(new r(92,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(282,null)],description:i.localize(283,null)})),renderLineHighlightOnlyWhenFocus:Ne(new u(93,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(284,null)})),renderValidationDecorations:Ne(new r(94,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new r(95,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(285,null),i.localize(286,null),i.localize(287,null),""],description:i.localize(288,null)})),revealHorizontalRightPadding:Ne(new y(96,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new u(97,"roundedSelection",!0,{description:i.localize(289,null)})),rulers:Ne(new ne),scrollbar:Ne(new H),scrollBeyondLastColumn:Ne(new y(100,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(290,null)})),scrollBeyondLastLine:Ne(new u(101,"scrollBeyondLastLine",!0,{description:i.localize(291,null)})),scrollPredominantAxis:Ne(new u(102,"scrollPredominantAxis",!0,{description:i.localize(292,null)})),selectionClipboard:Ne(new u(103,"selectionClipboard",!0,{description:i.localize(293,null),included:k.isLinux})),selectionHighlight:Ne(new u(104,"selectionHighlight",!0,{description:i.localize(294,null)})),selectOnLineNumbers:Ne(new u(105,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new r(106,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(295,null),i.localize(296,null),i.localize(297,null)],description:i.localize(298,null)})),showUnused:Ne(new u(107,"showUnused",!0,{description:i.localize(299,null)})),showDeprecated:Ne(new u(135,"showDeprecated",!0,{description:i.localize(300,null)})),inlayHints:Ne(new Pe),snippetSuggestions:Ne(new r(108,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(301,null),i.localize(302,null),i.localize(303,null),i.localize(304,null)],description:i.localize(305,null)})),smartSelect:Ne(new Se),smoothScrolling:Ne(new u(110,"smoothScrolling",!1,{description:i.localize(306,null)})),stopRenderingLineAfter:Ne(new y(113,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new ye),inlineSuggest:Ne(new x),suggestFontSize:Ne(new y(115,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(307,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new y(116,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(308,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new u(117,"suggestOnTriggerCharacters",!0,{description:i.localize(309,null)})),suggestSelection:Ne(new r(118,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(310,null),i.localize(311,null),i.localize(312,null)],description:i.localize(313,null)})),tabCompletion:Ne(new r(119,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(314,null),i.localize(315,null),i.localize(316,null)],description:i.localize(317,null)})),tabIndex:Ne(new y(120,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new j),unusualLineTerminators:Ne(new r(122,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(318,null),i.localize(319,null),i.localize(320,null)],description:i.localize(321,null)})),useShadowDOM:Ne(new u(123,"useShadowDOM",!0)),useTabStops:Ne(new u(124,"useTabStops",!0,{description:i.localize(322,null)})),wordBreak:Ne(new r(125,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[i.localize(323,null),i.localize(324,null)],description:i.localize(325,null)})),wordSeparators:Ne(new n(126,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:i.localize(326,null)})),wordWrap:Ne(new r(127,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(327,null),i.localize(328,null),i.localize(329,null),i.localize(330,null)],description:i.localize(331,null)})),wordWrapBreakAfterCharacters:Ne(new n(128,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new n(129,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new y(130,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(332,null)})),wordWrapOverride1:Ne(new r(131,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new r(132,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new B),defaultColorDecorators:Ne(new u(142,"defaultColorDecorators",!1,{markdownDescription:i.localize(333,null)})),pixelRatio:Ne(new ge),tabFocusMode:Ne(new u(139,"tabFocusMode",!1,{markdownDescription:i.localize(334,null)})),layoutInfo:Ne(new le),wrappingInfo:Ne(new Ze),wrappingIndent:Ne(new je),wrappingStrategy:Ne(new Q)}}),define(Re[137],Oe([11,12]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[138],Oe([11,12]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[139],Oe([11,12]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(Re[140],Oe([11,12]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[141],Oe([11,12]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[142],Oe([11,12]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Re[143],Oe([11,12]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Re[144],Oe([11,12]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[145],Oe([11,12]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Re[146],Oe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostChat",e)}),define(Re[147],Oe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[148],Oe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[149],Oe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[150],Oe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[151],Oe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Re[152],Oe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[153],Oe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[154],Oe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[155],Oe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[156],Oe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[157],Oe([11,12]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Re[158],Oe([11,12]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Re[159],Oe([11,12]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[160],Oe([11,12]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[161],Oe([11,12]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[162],Oe([11,12]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[163],Oe([11,12]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[164],Oe([11,12]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[165],Oe([11,12]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[166],Oe([1,0,10,139]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var D;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(D||(e.TokenType=D={}));function N(...m){switch(m.length){case 1:return(0,k.localize)(0,null,m[0]);case 2:return(0,k.localize)(1,null,m[0],m[1]);case 3:return(0,k.localize)(2,null,m[0],m[1],m[2]);default:return}}const F=(0,k.localize)(3,null),R=(0,k.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,i.illegalState)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const w=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:w})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const w=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:w})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const w=this.d,c=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:c};this.g.push({offset:w,lexeme:c,additionalInfo:O}),this.f.push(p)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const w=this.c.substring(this.d,this.e),c=S.b.get(w);c?this.k(c):this.f.push({type:17,lexeme:w,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(F);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,w=!1,c=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(R);return}const g=this.c.charCodeAt(O);if(w)w=!1;else if(g===47&&!c){O++;break}else g===91?c=!0:g===92?w=!0:g===93&&(c=!1);O++}for(;O<this.c.length&&S.a.has(this.c.charCodeAt(O));)O++;this.e=O;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=S,S.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0))),S.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Re[167],Oe([1,0,25,29,141,270]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(u){return u=u.trim(),u==="*"||F.test(u)}e.isValidVersionStr=S;function m(u){if(!S(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=u.match(F);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=m;function O(u){if(!u)return null;const h=u.majorBase,y=u.majorMustEqual,C=u.minorBase;let v=u.minorMustEqual;const n=u.patchBase;let l=u.patchMustEqual;u.hasCaret&&(h===0||(v=!1),l=!1);let r=0;if(u.preRelease){const a=R.exec(u.preRelease);if(a){const[,b,I,f]=a;r=Date.UTC(Number(b),Number(I)-1,Number(f))}}return{majorBase:h,majorMustEqual:y,minorBase:C,minorMustEqual:v,patchBase:n,patchMustEqual:l,isMinimum:u.hasGreaterEquals,notBefore:r}}e.normalizeVersion=O;function w(u,h,y){let C;typeof u=="string"?C=O(m(u)):C=u;let v;h instanceof Date?v=h.getTime():typeof h=="string"&&(v=new Date(h).getTime());let n;if(typeof y=="string"?n=O(m(y)):n=y,!C||!n)return!1;const l=C.majorBase,r=C.minorBase,a=C.patchBase;let b=n.majorBase,I=n.minorBase,f=n.patchBase;const P=n.notBefore;let E=n.majorMustEqual,o=n.minorMustEqual,s=n.patchMustEqual;return n.isMinimum?l>b?!0:l<b?!1:r>I?!0:r<I||v&&v<P?!1:a>=f:(l===1&&b===0&&(!E||!o||!s)&&(b=1,I=0,f=0,E=!0,o=!1,s=!1),l<b?!1:l>b?!E:r<I?!1:r>I?!o:a<f?!1:a>f?!s:!(v&&v<P))}e.isValidVersion=w;function c(u,h,y,C,v){const n=[];if(typeof C.publisher<"u"&&typeof C.publisher!="string")return n.push([k.default.Error,D.localize(0,null)]),n;if(typeof C.name!="string")return n.push([k.default.Error,D.localize(1,null,"name")]),n;if(typeof C.version!="string")return n.push([k.default.Error,D.localize(2,null,"version")]),n;if(!C.engines)return n.push([k.default.Error,D.localize(3,null,"engines")]),n;if(typeof C.engines.vscode!="string")return n.push([k.default.Error,D.localize(4,null,"engines.vscode")]),n;if(typeof C.extensionDependencies<"u"&&!t(C.extensionDependencies))return n.push([k.default.Error,D.localize(5,null,"extensionDependencies")]),n;if(typeof C.activationEvents<"u"){if(!t(C.activationEvents))return n.push([k.default.Error,D.localize(6,null,"activationEvents")]),n;if(typeof C.main>"u"&&typeof C.browser>"u")return n.push([k.default.Error,D.localize(7,null,"activationEvents","main","browser")]),n}if(typeof C.extensionKind<"u"&&typeof C.main>"u"&&n.push([k.default.Warning,D.localize(8,null,"extensionKind")]),typeof C.main<"u"){if(typeof C.main!="string")return n.push([k.default.Error,D.localize(9,null,"main")]),n;{const a=(0,i.joinPath)(y,C.main);(0,i.isEqualOrParent)(a,y)||n.push([k.default.Warning,D.localize(10,null,a.path,y.path)])}}if(typeof C.browser<"u"){if(typeof C.browser!="string")return n.push([k.default.Error,D.localize(11,null,"browser")]),n;{const a=(0,i.joinPath)(y,C.browser);(0,i.isEqualOrParent)(a,y)||n.push([k.default.Warning,D.localize(12,null,a.path,y.path)])}}if(!N.valid(C.version))return n.push([k.default.Error,D.localize(13,null)]),n;const l=[];if(!p(u,h,C,v,l))for(const a of l)n.push([k.default.Error,a]);return n}e.validateExtensionManifest=c;function p(u,h,y,C,v){return C||typeof y.main>"u"&&typeof y.browser>"u"?!0:d(u,h,y.engines.vscode,v)}e.isValidExtensionVersion=p;function g(u,h,y){return u==="*"||d(h,y,u)}e.isEngineValid=g;function d(u,h,y,C=[]){const v=O(m(y));if(!v)return C.push(D.localize(14,null,y)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return C.push(D.localize(15,null,y)),!1}else if(!v.majorMustEqual)return C.push(D.localize(16,null,y)),!1;return w(u,h,v)?!0:(C.push(D.localize(17,null,u,y)),!1)}function t(u){if(!Array.isArray(u))return!1;for(let h=0,y=u.length;h<y;h++)if(typeof u[h]!="string")return!1;return!0}}),define(Re[69],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(D,N=[],F=!1){this.ctor=D,this.staticArguments=N,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=i}),define(Re[70],Oe([1,0,69]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const k=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function N(R,S,m){S instanceof i.SyncDescriptor||(S=new i.SyncDescriptor(S,[],!!m)),k.push([R,S])}e.registerSingleton=N;function F(){return k}e.getSingletonServiceDescriptors=F}),define(Re[168],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(N,F){this.key=N,this.data=F,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class k{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const F of this.a.values())F.outgoing.size===0&&N.push(F);return N}insertEdge(N,F){const R=this.lookupOrInsertNode(N),S=this.lookupOrInsertNode(F);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(N){const F=this.b(N);this.a.delete(F);for(const R of this.a.values())R.outgoing.delete(F),R.incoming.delete(F)}lookupOrInsertNode(N){const F=this.b(N);let R=this.a.get(F);return R||(R=new i(F,N),this.a.set(F,R)),R}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[F,R]of this.a)N.push(`${F}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,F]of this.a){const R=new Set([N]),S=this.c(F,R);if(S)return S}}c(N,F){for(const[R,S]of N.outgoing){if(F.has(R))return[...F,R].join(" -> ");F.add(R);const m=this.c(S,F);if(m)return m;F.delete(R)}}}e.Graph=k}),define(Re[3],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(F){F.serviceIds=new Map,F.DI_TARGET="$di$target",F.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[F.DI_DEPENDENCIES]||[]}F.getServiceDependencies=R})(i||(e._util=i={})),e.IInstantiationService=D("instantiationService");function k(F,R,S){R[i.DI_TARGET]===R?R[i.DI_DEPENDENCIES].push({id:F,index:S}):(R[i.DI_DEPENDENCIES]=[{id:F,index:S}],R[i.DI_TARGET]=R)}function D(F){if(i.serviceIds.has(F))return i.serviceIds.get(F);const R=function(S,m,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(R,S,O)};return R.toString=()=>F,i.serviceIds.set(F,R),R}e.createDecorator=D;function N(F){return F}e.refineServiceDecorator=N}),define(Re[42],Oe([1,0,9,2,3]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function N(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof k.URI)}e.isConfigurationOverrides=N;function F(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof k.URI)}e.isConfigurationUpdateOverrides=F;var R;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function S(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function m(t,u){const h=Object.create(null);for(const y in t)O(h,y,t[y],u);return h}e.toValuesTree=m;function O(t,u,h,y){const C=u.split("."),v=C.pop();let n=t;for(let l=0;l<C.length;l++){const r=C[l];let a=n[r];switch(typeof a){case"undefined":a=n[r]=Object.create(null);break;case"object":break;default:y(`Ignoring ${u} as ${C.slice(0,l+1).join(".")} is ${JSON.stringify(a)}`);return}n=a}if(typeof n=="object"&&n!==null)try{n[v]=h}catch{y(`Ignoring ${u} as ${C.join(".")} is ${JSON.stringify(n)}`)}else y(`Ignoring ${u} as ${C.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=O;function w(t,u){const h=u.split(".");c(t,h)}e.removeFromValueTree=w;function c(t,u){const h=u.shift();if(u.length===0){delete t[h];return}if(Object.keys(t).indexOf(h)!==-1){const y=t[h];typeof y=="object"&&!Array.isArray(y)&&(c(y,u),Object.keys(y).length===0&&delete t[h])}}function p(t,u,h){function y(n,l){let r=n;for(const a of l){if(typeof r!="object"||r===null)return;r=r[a]}return r}const C=u.split("."),v=y(t,C);return typeof v>"u"?h:v}e.getConfigurationValue=p;function g(t,u,h){Object.keys(u).forEach(y=>{y!=="__proto__"&&(y in t?i.isObject(t[y])&&i.isObject(u[y])?g(t[y],u[y],h):h&&(t[y]=u[y]):t[y]=u[y])})}e.merge=g;function d(t){return t.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(Re[31],Oe([1,0,21,13,166,3,138,10]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",i.isMacintosh),S.set("isLinux",i.isLinux),S.set("isWindows",i.isWindows),S.set("isWeb",i.isWeb),S.set("isMacNative",i.isMacintosh&&!i.isWeb),S.set("isEdge",i.isEdge),S.set("isFirefox",i.isFirefox),S.set("isChrome",i.isChrome),S.set("isSafari",i.isSafari);function m(be,A){if(S.get(be)!==void 0)throw(0,R.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(be,A)}e.setConstant=m;const O=Object.prototype.hasOwnProperty;var w;(function(be){be[be.False=0]="False",be[be.True=1]="True",be[be.Defined=2]="Defined",be[be.Not=3]="Not",be[be.Equals=4]="Equals",be[be.NotEquals=5]="NotEquals",be[be.And=6]="And",be[be.Regex=7]="Regex",be[be.NotRegex=8]="NotRegex",be[be.Or=9]="Or",be[be.In=10]="In",be[be.NotIn=11]="NotIn",be[be.Greater=12]="Greater",be[be.GreaterEquals=13]="GreaterEquals",be[be.Smaller=14]="Smaller",be[be.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const c={regexParsingWithErrorRecovery:!0},p=(0,F.localize)(0,null),g=(0,F.localize)(1,null),d=(0,F.localize)(2,null),t=(0,F.localize)(3,null),u=(0,F.localize)(4,null),h=(0,F.localize)(5,null),y=(0,F.localize)(6,null),C=(0,F.localize)(7,null);class v{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(A=c){this.k=A,this.d=new D.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(A){if(A===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(A).scan(),this.g=0,this.h=[];try{const K=this.l();if(!this.E()){const he=this.D(),De=he.type===17?h:void 0;throw this.h.push({message:u,offset:he.offset,lexeme:D.Scanner.getLexeme(he),additionalInfo:De}),v.c}return K}catch(K){if(K!==v.c)throw K;return}}l(){return this.m()}m(){const A=[this.o()];for(;this.y(16);){const K=this.o();A.push(K)}return A.length===1?A[0]:n.or(...A)}o(){const A=[this.s()];for(;this.y(15);){const K=this.s();A.push(K)}return A.length===1?A[0]:n.and(...A)}s(){if(this.y(2)){const A=this.D();switch(A.type){case 11:return this.z(),b.INSTANCE;case 12:return this.z(),I.INSTANCE;case 0:{this.z();const K=this.l();return this.A(1,t),K?.negate()}case 17:return this.z(),M.create(A.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",A)}}return this.t()}t(){const A=this.D();switch(A.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const K=this.l();return this.A(1,t),K}case 17:{const K=A.lexeme;if(this.z(),this.y(9)){const De=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),De.type!==10)throw this.B("REGEX",De);const we=De.lexeme,ge=we.lastIndexOf("/"),ke=ge===we.length-1?void 0:this.w(we.substring(ge+1));let ae;try{ae=new RegExp(we.substring(1,ge),ke)}catch{throw this.B("REGEX",De)}return q.create(K,ae)}switch(De.type){case 10:case 19:{const we=[De.lexeme];this.z();let ge=this.D(),ke=0;for(let T=0;T<De.lexeme.length;T++)De.lexeme.charCodeAt(T)===40?ke++:De.lexeme.charCodeAt(T)===41&&ke--;for(;!this.E()&&ge.type!==15&&ge.type!==16;){switch(ge.type){case 0:ke++;break;case 1:ke--;break;case 10:case 18:for(let T=0;T<ge.lexeme.length;T++)ge.lexeme.charCodeAt(T)===40?ke++:De.lexeme.charCodeAt(T)===41&&ke--}if(ke<0)break;we.push(D.Scanner.getLexeme(ge)),this.z(),ge=this.D()}const ae=we.join(""),de=ae.lastIndexOf("/"),Z=de===ae.length-1?void 0:this.w(ae.substring(de+1));let ne;try{ne=new RegExp(ae.substring(1,de),Z)}catch{throw this.B("REGEX",De)}return n.regex(K,ne)}case 18:{const we=De.lexeme;this.z();let ge=null;if(!(0,k.isFalsyOrWhitespace)(we)){const ke=we.indexOf("/"),ae=we.lastIndexOf("/");if(ke!==ae&&ke>=0){const de=we.slice(ke+1,ae),Z=we[ae+1]==="i"?"i":"";try{ge=new RegExp(de,Z)}catch{throw this.B("REGEX",De)}}}if(ge===null)throw this.B("REGEX",De);return q.create(K,ge)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,d);const De=this.u();return n.notIn(K,De)}switch(this.D().type){case 3:{this.z();const De=this.u();if(this.x().type===18)return n.equals(K,De);switch(De){case"true":return n.has(K);case"false":return n.not(K);default:return n.equals(K,De)}}case 4:{this.z();const De=this.u();if(this.x().type===18)return n.notEquals(K,De);switch(De){case"true":return n.not(K);case"false":return n.has(K);default:return n.notEquals(K,De)}}case 5:return this.z(),W.create(K,this.u());case 6:return this.z(),U.create(K,this.u());case 7:return this.z(),X.create(K,this.u());case 8:return this.z(),G.create(K,this.u());case 13:return this.z(),n.in(K,this.u());default:return n.has(K)}}case 20:throw this.h.push({message:y,offset:A.offset,lexeme:"",additionalInfo:C}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const A=this.D();switch(A.type){case 17:case 18:return this.z(),A.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(A){return A.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(A){return this.C(A)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(A,K){if(this.C(A))return this.z();throw this.B(K,this.D())}B(A,K,he){const De=(0,F.localize)(8,null,A,D.Scanner.getLexeme(K)),we=K.offset,ge=D.Scanner.getLexeme(K);return this.h.push({message:De,offset:we,lexeme:ge,additionalInfo:he}),v.c}C(A){return this.D().type===A}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=v,v.c=new Error;class n{static false(){return b.INSTANCE}static true(){return I.INSTANCE}static has(A){return f.create(A)}static equals(A,K){return P.create(A,K)}static notEquals(A,K){return s.create(A,K)}static regex(A,K){return q.create(A,K)}static in(A,K){return E.create(A,K)}static notIn(A,K){return o.create(A,K)}static not(A){return M.create(A)}static and(...A){return ee.create(A,null,!0)}static or(...A){return Ce.create(A,null,!0)}static greater(A,K){return X.create(A,K)}static greaterEquals(A,K){return G.create(A,K)}static smaller(A,K){return W.create(A,K)}static smallerEquals(A,K){return U.create(A,K)}static deserialize(A){return A==null?void 0:this.c.parse(A)}}e.ContextKeyExpr=n,n.c=new v({regexParsingWithErrorRecovery:!1});function l(be){const A=new v({regexParsingWithErrorRecovery:!1});return be.map(K=>(A.parse(K),A.lexingErrors.length>0?A.lexingErrors.map(he=>({errorMessage:he.additionalInfo?(0,F.localize)(9,null,he.additionalInfo):(0,F.localize)(10,null),offset:he.offset,length:he.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(he=>({errorMessage:he.additionalInfo?`${he.message}. ${he.additionalInfo}`:he.message,offset:he.offset,length:he.lexeme.length})):[]))}e.validateWhenClauses=l;function r(be,A){const K=be?be.substituteConstants():void 0,he=A?A.substituteConstants():void 0;return!K&&!he?!0:!K||!he?!1:K.equals(he)}e.expressionsAreEqualWithConstantSubstitution=r;function a(be,A){return be.cmp(A)}class b{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return I.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class I{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=I,I.INSTANCE=new I;class f{static create(A,K=null){const he=S.get(A);return typeof he=="boolean"?he?I.INSTANCE:b.INSTANCE:new f(A,K)}constructor(A,K){this.key=A,this.c=K,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:le(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=S.get(this.key);return typeof A=="boolean"?A?I.INSTANCE:b.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=f;class P{static create(A,K,he=null){if(typeof K=="boolean")return K?f.create(A,he):M.create(A,he);const De=S.get(A);return typeof De=="boolean"?K===(De?"true":"false")?I.INSTANCE:b.INSTANCE:new P(A,K,he)}constructor(A,K,he){this.c=A,this.d=K,this.f=he,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=S.get(this.c);if(typeof A=="boolean"){const K=A?"true":"false";return this.d===K?I.INSTANCE:b.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=P;class E{static create(A,K){return new E(A,K)}constructor(A,K){this.d=A,this.f=K,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const K=A.getValue(this.f),he=A.getValue(this.d);return Array.isArray(K)?K.includes(he):typeof he=="string"&&typeof K=="object"&&K!==null?O.call(K,he):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=o.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=E;class o{static create(A,K){return new o(A,K)}constructor(A,K){this.d=A,this.f=K,this.type=11,this.c=E.create(A,K)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=o;class s{static create(A,K,he=null){if(typeof K=="boolean")return K?M.create(A,he):f.create(A,he);const De=S.get(A);return typeof De=="boolean"?K===(De?"true":"false")?b.INSTANCE:I.INSTANCE:new s(A,K,he)}constructor(A,K,he){this.c=A,this.d=K,this.f=he,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=S.get(this.c);if(typeof A=="boolean"){const K=A?"true":"false";return this.d===K?b.INSTANCE:I.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=s;class M{static create(A,K=null){const he=S.get(A);return typeof he=="boolean"?he?b.INSTANCE:I.INSTANCE:new M(A,K)}constructor(A,K){this.c=A,this.d=K,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:le(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=S.get(this.c);return typeof A=="boolean"?A?b.INSTANCE:I.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.ContextKeyNotExpr=M;function B(be,A){if(typeof be=="string"){const K=parseFloat(be);isNaN(K)||(be=K)}return typeof be=="string"||typeof be=="number"?A(be):b.INSTANCE}class X{static create(A,K,he=null){return B(K,De=>new X(A,De,he))}constructor(A,K,he){this.c=A,this.d=K,this.f=he,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=X;class G{static create(A,K,he=null){return B(K,De=>new G(A,De,he))}constructor(A,K,he){this.c=A,this.d=K,this.f=he,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=G;class W{static create(A,K,he=null){return B(K,De=>new W(A,De,he))}constructor(A,K,he){this.c=A,this.d=K,this.f=he,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=W;class U{static create(A,K,he=null){return B(K,De=>new U(A,De,he))}constructor(A,K,he){this.c=A,this.d=K,this.f=he,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=U;class q{static create(A,K){return new q(A,K)}constructor(A,K){this.d=A,this.f=K,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const K=this.f?this.f.source:"",he=A.f?A.f.source:"";return K<he?-1:K>he?1:0}equals(A){if(A.type===this.type){const K=this.f?this.f.source:"",he=A.f?A.f.source:"";return this.d===A.d&&K===he}return!1}substituteConstants(){return this}evaluate(A){const K=A.getValue(this.d);return this.f?this.f.test(K):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=z.create(this)),this.c}}e.ContextKeyRegexExpr=q;class z{static create(A){return new z(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(A){return new z(this.c.map(A))}negate(){return this.c}}e.ContextKeyNotRegexExpr=z;function V(be){let A=null;for(let K=0,he=be.length;K<he;K++){const De=be[K].substituteConstants();if(be[K]!==De&&A===null){A=[];for(let we=0;we<K;we++)A[we]=be[we]}A!==null&&(A[K]=De)}return A===null?be:A}class ee{static create(A,K,he){return ee.d(A,K,he)}constructor(A,K){this.expr=A,this.c=K,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let K=0,he=this.expr.length;K<he;K++){const De=a(this.expr[K],A.expr[K]);if(De!==0)return De}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let K=0,he=this.expr.length;K<he;K++)if(!this.expr[K].equals(A.expr[K]))return!1;return!0}return!1}substituteConstants(){const A=V(this.expr);return A===this.expr?this:ee.create(A,this.c,!1)}evaluate(A){for(let K=0,he=this.expr.length;K<he;K++)if(!this.expr[K].evaluate(A))return!1;return!0}static d(A,K,he){const De=[];let we=!1;for(const ge of A)if(ge){if(ge.type===1){we=!0;continue}if(ge.type===0)return b.INSTANCE;if(ge.type===6){De.push(...ge.expr);continue}De.push(ge)}if(De.length===0&&we)return I.INSTANCE;if(De.length!==0){if(De.length===1)return De[0];De.sort(a);for(let ge=1;ge<De.length;ge++)De[ge-1].equals(De[ge])&&(De.splice(ge,1),ge--);if(De.length===1)return De[0];for(;De.length>1;){const ge=De[De.length-1];if(ge.type!==9)break;De.pop();const ke=De.pop(),ae=De.length===0,de=Ce.create(ge.expr.map(Z=>ee.create([Z,ke],null,he)),null,ae);de&&(De.push(de),De.sort(a))}if(De.length===1)return De[0];if(he){for(let ge=0;ge<De.length;ge++)for(let ke=ge+1;ke<De.length;ke++)if(De[ge].negate().equals(De[ke]))return b.INSTANCE;if(De.length===1)return De[0]}return new ee(De,K)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const K of this.expr)A.push(...K.keys());return A}map(A){return new ee(this.expr.map(K=>K.map(A)),null)}negate(){if(!this.c){const A=[];for(const K of this.expr)A.push(K.negate());this.c=Ce.create(A,this,!0)}return this.c}}e.ContextKeyAndExpr=ee;class Ce{static create(A,K,he){return Ce.d(A,K,he)}constructor(A,K){this.expr=A,this.c=K,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let K=0,he=this.expr.length;K<he;K++){const De=a(this.expr[K],A.expr[K]);if(De!==0)return De}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let K=0,he=this.expr.length;K<he;K++)if(!this.expr[K].equals(A.expr[K]))return!1;return!0}return!1}substituteConstants(){const A=V(this.expr);return A===this.expr?this:Ce.create(A,this.c,!1)}evaluate(A){for(let K=0,he=this.expr.length;K<he;K++)if(this.expr[K].evaluate(A))return!0;return!1}static d(A,K,he){let De=[],we=!1;if(A){for(let ge=0,ke=A.length;ge<ke;ge++){const ae=A[ge];if(ae){if(ae.type===0){we=!0;continue}if(ae.type===1)return I.INSTANCE;if(ae.type===9){De=De.concat(ae.expr);continue}De.push(ae)}}if(De.length===0&&we)return b.INSTANCE;De.sort(a)}if(De.length!==0){if(De.length===1)return De[0];for(let ge=1;ge<De.length;ge++)De[ge-1].equals(De[ge])&&(De.splice(ge,1),ge--);if(De.length===1)return De[0];if(he){for(let ge=0;ge<De.length;ge++)for(let ke=ge+1;ke<De.length;ke++)if(De[ge].negate().equals(De[ke]))return I.INSTANCE;if(De.length===1)return De[0]}return new Ce(De,K)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const K of this.expr)A.push(...K.keys());return A}map(A){return new Ce(this.expr.map(K=>K.map(A)),null)}negate(){if(!this.c){const A=[];for(const K of this.expr)A.push(K.negate());for(;A.length>1;){const K=A.shift(),he=A.shift(),De=[];for(const we of Pe(K))for(const ge of Pe(he))De.push(ee.create([we,ge],null,!1));A.unshift(Ce.create(De,null,!1))}this.c=Ce.create(A,this,!0)}return this.c}}e.ContextKeyOrExpr=Ce;class oe extends f{static all(){return oe.d.values()}constructor(A,K,he){super(A,null),this.f=K,typeof he=="object"?oe.d.push({...he,key:A}):he!==!0&&oe.d.push({key:A,description:he,type:K!=null?typeof K:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return P.create(this.key,A)}notEqualsTo(A){return s.create(this.key,A)}}e.RawContextKey=oe,oe.d=[],e.IContextKeyService=(0,N.createDecorator)("contextKeyService");function le(be,A){return be<A?-1:be>A?1:0}function Q(be,A,K,he){return be<K?-1:be>K?1:A<he?-1:A>he?1:0}function ue(be,A){if(be.type===0||A.type===1)return!0;if(be.type===9)return A.type===9?Ie(be.expr,A.expr):!1;if(A.type===9){for(const K of A.expr)if(ue(be,K))return!0;return!1}if(be.type===6){if(A.type===6)return Ie(A.expr,be.expr);for(const K of be.expr)if(ue(K,A))return!0;return!1}return be.equals(A)}e.implies=ue;function Ie(be,A){let K=0,he=0;for(;K<be.length&&he<A.length;){const De=be[K].cmp(A[he]);if(De<0)return!1;De===0&&K++,he++}return K===be.length}function Pe(be){return be.type===9?be.expr:[be]}}),define(Re[169],Oe([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(Re[92],Oe([1,0,140,3]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function D(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function N(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function F(h,y){switch(h){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=F;function R(h,y){return y==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function S(h,y,C){return R(y,C)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===C?!0:m(C).includes(h)}e.isTargetPlatformCompatible=S;function m(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function O(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=O;var w;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var c;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(c||(e.SortOrder=c={}));var p;(function(h){h.Install="install",h.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var g;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var d;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var t;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class u extends Error{constructor(y,C){super(y),this.code=C,this.name=C}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,i.localize)(1,null),original:"Preferences"}}),define(Re[43],Oe([1,0,48,19,13,9,2,142,3,21,15]),function(te,e,i,k,D,N,F,R,S,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function w(oe){return oe.create===!0}e.isFileOpenForWriteOptions=w;var c;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var p;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var g;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function d(oe){return!!(oe.capabilities&2)}e.hasReadWriteCapability=d;function t(oe){return!!(oe.capabilities&8)}e.hasFileFolderCopyCapability=t;function u(oe){return!!(oe.capabilities&131072)}e.hasFileCloneCapability=u;function h(oe){return!!(oe.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function y(oe){return!!(oe.capabilities&16)}e.hasFileReadStreamCapability=y;function C(oe){return d(oe)?!!(oe.capabilities&16384):!1}e.hasFileAtomicReadCapability=C;function v(oe){return d(oe)?!!(oe.capabilities&32768):!1}e.hasFileAtomicWriteCapability=v;function n(oe){return!!(oe.capabilities&65536)}e.hasFileAtomicDeleteCapability=n;var l;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class r extends Error{static create(le,Q){const ue=new r(le.toString(),Q);return I(ue,Q),ue}constructor(le,Q){super(le),this.code=Q}}e.FileSystemProviderError=r;function a(oe,le){return r.create(oe,le)}e.createFileSystemProviderError=a;function b(oe){return oe||a((0,R.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=b;function I(oe,le){return oe.name=le?`${le} (FileSystemError)`:"FileSystemError",oe}e.markAsFileSystemProviderError=I;function f(oe){if(!oe)return l.Unknown;if(oe instanceof r)return oe.code;const le=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!le)return l.Unknown;switch(le[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=f;function P(oe){if(oe instanceof X)return oe.fileOperationResult;switch(f(oe)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=P;var E;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(E||(e.FileOperation=E={}));class o{constructor(le,Q,ue){this.resource=le,this.operation=Q,this.target=ue}isOperation(le){return this.operation===le}}e.FileOperationEvent=o;var s;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(s||(e.FileChangeType=s={}));class M{constructor(le,Q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ue=new Map;for(const Ie of le){const Pe=ue.get(Ie.type);switch(Pe?Pe.push([Ie.resource,Ie]):ue.set(Ie.type,[[Ie.resource,Ie]]),Ie.type){case 1:this.rawAdded.push(Ie.resource);break;case 0:this.rawUpdated.push(Ie.resource);break;case 2:this.rawDeleted.push(Ie.resource);break}}for(const[Ie,Pe]of ue)switch(Ie){case 1:this.a=i.TernarySearchTree.forUris(()=>Q),this.a.fill(Pe);break;case 0:this.b=i.TernarySearchTree.forUris(()=>Q),this.b.fill(Pe);break;case 2:this.c=i.TernarySearchTree.forUris(()=>Q),this.c.fill(Pe);break}}contains(le,...Q){return this.d(le,{includeChildren:!1},...Q)}affects(le,...Q){return this.d(le,{includeChildren:!0},...Q)}d(le,Q,...ue){if(!le)return!1;const Ie=ue.length>0;return!!((!Ie||ue.includes(1))&&(this.a?.get(le)||Q.includeChildren&&this.a?.findSuperstr(le))||(!Ie||ue.includes(0))&&(this.b?.get(le)||Q.includeChildren&&this.b?.findSuperstr(le))||(!Ie||ue.includes(2))&&(this.c?.findSubstr(le)||Q.includeChildren&&this.c?.findSuperstr(le)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=M;function B(oe,le,Q){return!oe||!le||oe===le||le.length>oe.length?!1:(le.charAt(le.length-1)!==k.sep&&(le+=k.sep),Q?(0,D.startsWithIgnoreCase)(oe,le):oe.indexOf(le)===0)}e.isParent=B;class X extends Error{constructor(le,Q,ue){super(le),this.fileOperationResult=Q,this.options=ue}}e.FileOperationError=X;class G extends X{constructor(le,Q,ue,Ie){super(le,Q,Ie),this.fileOperationResult=Q,this.size=ue}}e.TooLargeFileOperationError=G;class W extends X{constructor(le,Q,ue){super(le,2,ue),this.stat=Q}}e.NotModifiedSinceFileOperationError=W;var U;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(U||(e.FileOperationResult=U={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var q;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.ETAG_DISABLED="";function z(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}e.etag=z;async function V(oe,le){if(!le.hasProvider(F.URI.from({scheme:oe.scheme})))return new Promise(Q=>{const ue=le.onDidChangeFileSystemProviderRegistrations(Ie=>{Ie.scheme===oe.scheme&&Ie.added&&(ue.dispose(),Q())})})}e.whenProviderRegistered=V;class ee{static formatSize(le){return(0,N.isNumber)(le)||(le=0),le<ee.KB?(0,R.localize)(1,null,le.toFixed(0)):le<ee.MB?(0,R.localize)(2,null,(le/ee.KB).toFixed(2)):le<ee.GB?(0,R.localize)(3,null,(le/ee.MB).toFixed(2)):le<ee.TB?(0,R.localize)(4,null,(le/ee.GB).toFixed(2)):(0,R.localize)(5,null,(le/ee.TB).toFixed(2))}}e.ByteSize=ee,ee.KB=1024,ee.MB=ee.KB*ee.KB,ee.GB=ee.MB*ee.KB,ee.TB=ee.GB*ee.KB;function Ce(oe){const le=typeof oe=="string"||oe?.scheme===O.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===O.Schemas.file?1024*ee.MB:le?10*ee.MB:m.isWeb?50*ee.MB:1024*ee.MB}e.getLargeFileConfirmationLimit=Ce}),define(Re[71],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...D){this.a=new Map;for(const[N,F]of D)this.set(N,F)}set(D,N){const F=this.a.get(D);return this.a.set(D,N),F}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=i}),define(Re[170],Oe([1,0,16,10,6,69,168,3,71,171]),function(te,e,i,k,D,N,F,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class w extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class c{constructor(t=new S.ServiceCollection,u=!1,h,y=O){this.f=t,this.g=u,this.h=h,this.i=y,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=y?h?._globalGraph??new F.Graph(C=>C):void 0}createChild(t){return new c(t,this.g,this,this.i)}invokeFunction(t,...u){const h=g.traceInvocation(this.i,t);let y=!1;try{return t({get:v=>{if(y)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(v,h);if(!n)throw new Error(`[invokeFunction] unknown service '${v}'`);return n}},...u)}finally{y=!0,h.stop()}}createInstance(t,...u){let h,y;return t instanceof N.SyncDescriptor?(h=g.traceCreation(this.i,t.ctor),y=this.j(t.ctor,t.staticArguments.concat(u),h)):(h=g.traceCreation(this.i,t),y=this.j(t,u,h)),h.stop(),y}j(t,u=[],h){const y=R._util.getServiceDependencies(t).sort((n,l)=>n.index-l.index),C=[];for(const n of y){const l=this.m(n.id,h);l||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),C.push(l)}const v=y.length>0?y[0].index:u.length;if(u.length!==v){console.trace(`[createInstance] First service dependency of ${t.name} at position ${v+1} conflicts with ${u.length} static arguments`);const n=v-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,v)}return Reflect.construct(t,u.concat(C))}k(t,u){if(this.f.get(t)instanceof N.SyncDescriptor)this.f.set(t,u);else if(this.h)this.h.k(t,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const u=this.f.get(t);return!u&&this.h?this.h.l(t):u}m(t,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const h=this.l(t);return h instanceof N.SyncDescriptor?this.q(t,h,u.branch(t,!0)):(u.branch(t,!1),h)}q(t,u,h){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,u,h)}finally{this.o.delete(t)}}r(t,u,h){const y=new F.Graph(n=>n.id.toString());let C=0;const v=[{id:t,desc:u,_trace:h}];for(;v.length;){const n=v.pop();if(y.lookupOrInsertNode(n),C++>1e3)throw new w(y);for(const l of R._util.getServiceDependencies(n.desc.ctor)){const r=this.l(l.id);if(r||this.u(`[createInstance] ${t} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(l.id)),r instanceof N.SyncDescriptor){const a={id:l.id,desc:r,_trace:n._trace.branch(l.id,!0)};y.insertEdge(n,a),v.push(a)}}}for(;;){const n=y.roots();if(n.length===0){if(!y.isEmpty())throw new w(y);break}for(const{data:l}of n){if(this.l(l.id)instanceof N.SyncDescriptor){const a=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,a)}y.removeNode(l)}}return this.l(t)}s(t,u,h=[],y,C){if(this.f.get(t)instanceof N.SyncDescriptor)return this.t(t,u,h,y,C);if(this.h)return this.h.s(t,u,h,y,C);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(t,u,h=[],y,C){if(y){const v=new c(void 0,this.g,this,this.i);v.c=String(t);const n=new Map,l=new i.IdleValue(()=>{const r=v.j(u,h,C);for(const[a,b]of n){const I=r[a];if(typeof I=="function")for(const f of b)I.apply(r,f)}return n.clear(),r});return new Proxy(Object.create(null),{get(r,a){if(!l.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let f=n.get(a);return f||(f=new m.LinkedList,n.set(a,f)),(E,o,s)=>{const M=f.push([E,o,s]);return(0,D.toDisposable)(M)}}if(a in r)return r[a];const b=l.value;let I=b[a];return typeof I!="function"||(I=I.bind(b),r[a]=I),I},set(r,a,b){return l.value[a]=b,!0},getPrototypeOf(r){return u.prototype}})}else return this.j(u,h,C)}u(t,u){if(u&&console.warn(t),this.g)throw new Error(t)}}e.InstantiationService=c;var p;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(p||(p={}));class g{static traceInvocation(t,u){return t?new g(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(t,u){return t?new g(1,u.name):g.c}constructor(t,u){this.type=t,this.name=u,this.g=Date.now(),this.h=[]}branch(t,u){const h=new g(3,t.toString());return this.h.push([t,u,h]),h}stop(){const t=Date.now()-this.g;g.f+=t;let u=!1;function h(C,v){const n=[],l=new Array(C+1).join("	");for(const[r,a,b]of v.h)if(a&&b){u=!0,n.push(`${l}CREATES -> ${r}`);const I=h(C+1,b);I&&n.push(I)}else n.push(`${l}uses -> ${r}`);return n.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(t>2||u)&&g.all.add(y.join(`
`))}}e.Trace=g,g.all=new Set,g.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g.f=0}),define(Re[14],Oe([1,0,40,5,93,6,28,21,25,9,2,31,3]),function(te,e,i,k,D,N,F,R,S,m,O,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,c.createDecorator)("logService"),e.ILoggerService=(0,c.createDecorator)("loggerService");function p(){return new Date().toISOString()}function g(E){return(0,m.isNumber)(E)}e.isLogLevel=g;var d;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(d||(e.LogLevel=d={})),e.DEFAULT_LOG_LEVEL=d.Info;function t(E,o,s){switch(o){case d.Trace:E.trace(s);break;case d.Debug:E.debug(s);break;case d.Info:E.info(s);break;case d.Warning:E.warn(s);break;case d.Error:E.error(s);break;case d.Off:break;default:throw new Error(`Invalid log level ${o}`)}}e.log=t;function u(E,o=!1){let s="";for(let M=0;M<E.length;M++){let B=E[M];if(B instanceof Error&&(B=(0,i.toErrorMessage)(B,o)),typeof B=="object")try{B=JSON.stringify(B)}catch{}s+=(M>0?" ":"")+B}return s}class h extends N.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new k.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}f(o){return this.b!==d.Off&&this.b<=o}}e.AbstractLogger=h;class y extends h{constructor(o){super(),this.h=o}f(o){return this.h||super.f(o)}trace(o,...s){this.f(d.Trace)&&this.g(d.Trace,u([o,...s],!0))}debug(o,...s){this.f(d.Debug)&&this.g(d.Debug,u([o,...s]))}info(o,...s){this.f(d.Info)&&this.g(d.Info,u([o,...s]))}warn(o,...s){this.f(d.Warning)&&this.g(d.Warning,u([o,...s]))}error(o,...s){if(this.f(d.Error))if(o instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=o.stack,this.g(d.Error,u(M))}else this.g(d.Error,u([o,...s]))}flush(){}}e.AbstractMessageLogger=y;class C extends h{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.g=!R.isWindows}trace(o,...s){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,o,...s):console.log(`[main ${p()}]`,o,...s))}debug(o,...s){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,o,...s):console.log(`[main ${p()}]`,o,...s))}info(o,...s){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,o,...s):console.log(`[main ${p()}]`,o,...s))}warn(o,...s){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,o,...s):console.warn(`[main ${p()}]`,o,...s))}error(o,...s){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,o,...s):console.error(`[main ${p()}]`,o,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class v extends h{constructor(o=e.DEFAULT_LOG_LEVEL,s=!0){super(),this.g=s,this.setLevel(o)}trace(o,...s){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",o,...s):console.log(o,...s))}debug(o,...s){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",o,...s):console.log(o,...s))}info(o,...s){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",o,...s):console.log(o,...s))}warn(o,...s){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",o,...s):console.log(o,...s))}error(o,...s){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",o,...s):console.error(o,...s))}dispose(){}flush(){}}e.ConsoleLogger=v;class n extends h{constructor(o,s=e.DEFAULT_LOG_LEVEL){super(),this.g=o,this.setLevel(s)}trace(o,...s){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(o),...s])}debug(o,...s){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(o),...s])}info(o,...s){this.f(d.Info)&&this.g.log(d.Info,[this.h(o),...s])}warn(o,...s){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(o),...s])}error(o,...s){this.f(d.Error)&&this.g.log(d.Error,[this.h(o),...s])}h(o){return typeof o=="string"?o:(0,i.toErrorMessage)(o,this.f(d.Trace))}dispose(){}flush(){}}e.AdapterLogger=n;class l extends h{constructor(o){super(),this.g=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const s of this.g)s.setLevel(o);super.setLevel(o)}trace(o,...s){for(const M of this.g)M.trace(o,...s)}debug(o,...s){for(const M of this.g)M.debug(o,...s)}info(o,...s){for(const M of this.g)M.info(o,...s)}warn(o,...s){for(const M of this.g)M.warn(o,...s)}error(o,...s){for(const M of this.g)M.error(o,...s)}flush(){for(const o of this.g)o.flush()}dispose(){for(const o of this.g)o.dispose()}}e.MultiplexLogger=l;class r extends N.Disposable{constructor(o,s,M){if(super(),this.h=o,this.j=s,this.b=new F.ResourceMap,this.c=this.B(new k.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeVisibility=this.g.event,M)for(const B of M)this.b.set(B.resource,{logger:void 0,info:B})}k(o){return(0,m.isString)(o)?[...this.b.values()].find(s=>s.info.id===o):this.b.get(o)}getLogger(o){return this.k(o)?.logger}createLogger(o,s){const M=this.l(o),B=(0,m.isString)(o)?o:s?.id??(0,D.hash)(M.toString()).toString(16);let X=this.b.get(M)?.logger;const G=s?.logLevel==="always"?d.Trace:s?.logLevel;X||(X=this.m(M,G??this.getLogLevel(M)??this.h,{...s,id:B}));const W={logger:X,info:{resource:M,id:B,logLevel:G,name:s?.name,hidden:s?.hidden,extensionId:s?.extensionId,when:s?.when}};return this.registerLogger(W.info),this.b.set(M,W),X}l(o){return(0,m.isString)(o)?(0,S.joinPath)(this.j,`${o}.log`):o}setLogLevel(o,s){if(O.URI.isUri(o)){const M=o,B=s,X=this.b.get(M);X&&B!==X.info.logLevel&&(X.info.logLevel=B===this.h?void 0:B,X.logger?.setLevel(B),this.b.set(X.info.resource,X),this.f.fire([M,B]))}else{this.h=o;for(const[M,B]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(o,s){const M=this.k(o);M&&s!==!M.info.hidden&&(M.info.hidden=!s,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,s]))}getLogLevel(o){let s;return o&&(s=this.b.get(o)?.info.logLevel),s??this.h}registerLogger(o){const s=this.b.get(o.resource);s?s.info.hidden!==o.hidden&&this.setVisibility(o.resource,!o.hidden):(this.b.set(o.resource,{info:o,logger:void 0}),this.c.fire({added:[o],removed:[]}))}deregisterLogger(o){const s=this.b.get(o);s&&(s.logger&&s.logger.dispose(),this.b.delete(o),this.c.fire({added:[],removed:[s.info]}))}*getRegisteredLoggers(){for(const o of this.b.values())yield o.info}getRegisteredLogger(o){return this.b.get(o)?.info}dispose(){this.b.forEach(o=>o.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=r;class a{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(o){}getLevel(){return d.Info}trace(o,...s){}debug(o,...s){}info(o,...s){}warn(o,...s){}error(o,...s){}critical(o,...s){}dispose(){}flush(){}}e.NullLogger=a;class b extends a{}e.NullLogService=b;function I(E){if(E.verbose)return d.Trace;if(typeof E.logLevel=="string"){const o=P(E.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function f(E){switch(E){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=f;function P(E){switch(E){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=P,e.CONTEXT_LOG_LEVEL=new w.RawContextKey("logLevel",f(d.Info))}),define(Re[172],Oe([1,0,6,14]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends i.Disposable{constructor(F,R=[]){super(),this.a=new k.MultiplexLogger([F,...R]),this.B(F.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(F){this.a.setLevel(F)}getLevel(){return this.a.getLevel()}trace(F,...R){this.a.trace(F,...R)}debug(F,...R){this.a.debug(F,...R)}info(F,...R){this.a.info(F,...R)}warn(F,...R){this.a.warn(F,...R)}error(F,...R){this.a.error(F,...R)}flush(){this.a.flush()}}e.LogService=D}),define(Re[94],Oe([1,0,29,143,3]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var F;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(F||(e.MarkerSeverity=F={})),function(S){function m(g,d){return d-g}S.compare=m;const O=Object.create(null);O[S.Error]=(0,k.localize)(0,null),O[S.Warning]=(0,k.localize)(1,null),O[S.Info]=(0,k.localize)(2,null);function w(g){return O[g]||""}S.toString=w;function c(g){switch(g){case i.default.Error:return S.Error;case i.default.Warning:return S.Warning;case i.default.Info:return S.Info;case i.default.Ignore:return S.Hint}}S.fromSeverity=c;function p(g){switch(g){case S.Error:return i.default.Error;case S.Warning:return i.default.Warning;case S.Info:return i.default.Info;case S.Hint:return i.default.Ignore}}S.toSeverity=p}(F||(e.MarkerSeverity=F={}));var R;(function(S){const m="";function O(c){return w(c,!0)}S.makeKey=O;function w(c,p){const g=[m];return c.source?g.push(c.source.replace("\xA6","\\\xA6")):g.push(m),c.code?typeof c.code=="string"?g.push(c.code.replace("\xA6","\\\xA6")):g.push(c.code.value.replace("\xA6","\\\xA6")):g.push(m),c.severity!==void 0&&c.severity!==null?g.push(F.toString(c.severity)):g.push(m),c.message&&p?g.push(c.message.replace("\xA6","\\\xA6")):g.push(m),c.startLineNumber!==void 0&&c.startLineNumber!==null?g.push(c.startLineNumber.toString()):g.push(m),c.startColumn!==void 0&&c.startColumn!==null?g.push(c.startColumn.toString()):g.push(m),c.endLineNumber!==void 0&&c.endLineNumber!==null?g.push(c.endLineNumber.toString()):g.push(m),c.endColumn!==void 0&&c.endColumn!==null?g.push(c.endColumn.toString()):g.push(m),g.push(m),g.join("\xA6")}S.makeKeyOptionalMessage=w})(R||(e.IMarkerData=R={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(Re[173],Oe([1,0,5,29,3]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=k.default,e.INotificationService=(0,D.createDecorator)("notificationService");var N;(function(O){O[O.DEFAULT=0]="DEFAULT",O[O.SILENT=1]="SILENT",O[O.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var F;(function(O){O[O.WORKSPACE=0]="WORKSPACE",O[O.PROFILE=1]="PROFILE",O[O.APPLICATION=2]="APPLICATION"})(F||(e.NeverShowAgainScope=F={}));var R;(function(O){O[O.OFF=0]="OFF",O[O.SILENT=1]="SILENT",O[O.ERROR=2]="ERROR"})(R||(e.NotificationsFilter=R={}));class S{constructor(){this.progress=new m,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(w){}updateMessage(w){}updateActions(w){}close(){}}e.NoOpNotification=S;class m{infinite(){}done(){}total(w){}worked(w){}}e.NoOpProgress=m}),define(Re[95],Oe([1,0,13,2,3]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService");function N(m,O){return k.URI.isUri(m)?(0,i.equalsIgnoreCase)(m.scheme,O):(0,i.startsWithIgnoreCase)(m,O+":")}e.matchesScheme=N;function F(m,...O){return O.some(w=>N(m,w))}e.matchesSomeScheme=F;function R(m,O){return m.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=R;function S(m){let O;const w=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return w&&(O={startLineNumber:parseInt(w[1]),startColumn:w[2]?parseInt(w[2]):1,endLineNumber:w[4]?parseInt(w[4]):void 0,endColumn:w[4]?w[5]?parseInt(w[5]):1:void 0},m=m.with({fragment:""})),{selection:O,uri:m}}e.extractSelection=S}),define(Re[174],Oe([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var xe=this&&this.__decorate||function(te,e,i,k){var D=arguments.length,N=D<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,i):k,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(te,e,i,k);else for(var R=te.length-1;R>=0;R--)(F=te[R])&&(N=(D<3?F(N):D>3?F(e,i,N):F(e,i))||N);return D>3&&N&&Object.defineProperty(e,i,N),N},Ve=this&&this.__param||function(te,e){return function(i,k){e(i,k,te)}};define(Re[175],Oe([1,0,16,22,6,3]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,N.createDecorator)("progressService");var F;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(F||(e.ProgressLocation=F={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}e.Progress=R,R.None=Object.freeze({report(){}});let S=e.UnmanagedProgress=class extends D.Disposable{constructor(w,c){super(),this.a=new i.DeferredPromise,c.withProgress(w,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,D.toDisposable)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};e.UnmanagedProgress=S=xe([Ve(1,e.IProgressService)],S);class m extends D.Disposable{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new D.DisposableStore)}start(w){this.stop();const c=++this.a,p=new k.CancellationTokenSource;return this.f=setTimeout(()=>{c===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,D.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,D.toDisposable)(()=>p.cancel())),this.b.add((0,D.toDisposable)(()=>this.c?this.c.done():void 0)),{id:c,token:p.token,stop:()=>this.h(c),isCurrent:()=>this.a===c}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.LongRunningOperation=m,e.IEditorProgressService=(0,N.createDecorator)("editorProgressService")}),define(Re[30],Oe([1,0,49,9]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(F,R){i.ok(k.isString(F)),i.ok(k.isObject(R)),i.ok(!this.a.has(F),"There is already an extension with this id"),this.a.set(F,R)}knows(F){return this.a.has(F)}as(F){return this.a.get(F)||null}}e.Registry=new D}),define(Re[72],Oe([1,0,5,30]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class N{constructor(){this.b=new i.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,m){this.a[D(S)]=m,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const F=new N;k.Registry.add(e.Extensions.JSONContribution,F)}),define(Re[96],Oe([1,0,18,5,9,137,42,72,30]),function(te,e,i,k,D,N,F,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O||(e.ConfigurationScope=O={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=S.Registry.as(R.Extensions.JSONContribution);class c{constructor(){this.h=new Set,this.i=new k.Emitter,this.onDidSchemaChange=this.i.event,this.j=new k.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(n,l=!0){this.registerConfigurations([n],l)}registerConfigurations(n,l=!0){const r=new Set;this.n(n,l,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(n){const l=new Set;this.o(n,l),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:n,remove:l}){const r=new Set;this.o(l,r),this.n(n,!1,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(n){const l=new Set;this.k(n,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(n,l){const r=[];for(const{overrides:a,source:b}of n)for(const I in a)if(l.add(I),e.OVERRIDE_PROPERTY_REGEX.test(I)){const f=this.a.get(I),P=f?.valuesSources??new Map;if(b)for(const M of Object.keys(a[I]))P.set(M,b);const E={...f?.value||{},...a[I]};this.a.set(I,{source:b,value:E,valuesSources:P});const o=(0,F.getLanguageTagSettingPlainKey)(I),s={type:"object",default:E,description:N.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:D.isString(b)?void 0:b,defaultValueSource:b};r.push(...d(I)),this.d[I]=s,this.b.properties[I]=s}else{this.a.set(I,{value:a[I],source:b});const f=this.d[I];f&&(this.w(I,f),this.r(I,f))}this.m(r)}deregisterDefaultConfigurations(n){const l=new Set;this.l(n,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(n,l){for(const{overrides:r,source:a}of n)for(const b in r){const I=this.a.get(b),f=D.isString(a)?a:a?.id,P=D.isString(I?.source)?I?.source:I?.source?.id;if(f===P)if(l.add(b),this.a.delete(b),e.OVERRIDE_PROPERTY_REGEX.test(b))delete this.d[b],delete this.b.properties[b];else{const E=this.d[b];E&&(this.w(b,E),this.r(b,E))}}this.u()}deltaConfiguration(n){let l=!1;const r=new Set;n.removedDefaults&&(this.l(n.removedDefaults,r),l=!0),n.addedDefaults&&(this.k(n.addedDefaults,r),l=!0),n.removedConfigurations&&this.o(n.removedConfigurations,r),n.addedConfigurations&&this.n(n.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const l of n)this.h.add(l);this.u()}n(n,l,r){n.forEach(a=>{this.p(a,l,a.extensionInfo,a.restrictedProperties,void 0,r),this.c.push(a),this.q(a)})}o(n,l){const r=a=>{if(a.properties)for(const b in a.properties){l.add(b);const I=this.d[b];I?.policy?.name&&this.e.delete(I.policy.name),delete this.d[b],this.s(b,a.properties[b])}a.allOf?.forEach(b=>r(b))};for(const a of n){r(a);const b=this.c.indexOf(a);b!==-1&&this.c.splice(b,1)}}p(n,l=!0,r,a,b=3,I){b=D.isUndefinedOrNull(n.scope)?b:n.scope;const f=n.properties;if(f)for(const E in f){const o=f[E];if(l&&y(E,o)){delete f[E];continue}if(o.source=r,o.defaultDefaultValue=f[E].default,this.w(E,o),e.OVERRIDE_PROPERTY_REGEX.test(E)?o.scope=void 0:(o.scope=D.isUndefinedOrNull(o.scope)?b:o.scope,o.restricted=D.isUndefinedOrNull(o.restricted)?!!a?.includes(E):o.restricted),f[E].hasOwnProperty("included")&&!f[E].included){this.f[E]=f[E],delete f[E];continue}else this.d[E]=f[E],f[E].policy?.name&&this.e.set(f[E].policy.name,E);!f[E].deprecationMessage&&f[E].markdownDeprecationMessage&&(f[E].deprecationMessage=f[E].markdownDeprecationMessage),I.add(E)}const P=n.allOf;if(P)for(const E of P)this.p(E,l,r,a,b,I)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const l=r=>{const a=r.properties;if(a)for(const I in a)this.r(I,a[I]);r.allOf?.forEach(l)};l(n)}r(n,l){switch(e.allSettings.properties[n]=l,l.scope){case 1:e.applicationSettings.properties[n]=l;break;case 2:e.machineSettings.properties[n]=l;break;case 6:e.machineOverridableSettings.properties[n]=l;break;case 3:e.windowSettings.properties[n]=l;break;case 4:e.resourceSettings.properties[n]=l;break;case 5:e.resourceSettings.properties[n]=l,this.g.properties[n]=l;break}}s(n,l){switch(delete e.allSettings.properties[n],l.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const l=`[${n}]`,r={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(l,r),e.allSettings.properties[l]=r,e.applicationSettings.properties[l]=r,e.machineSettings.properties[l]=r,e.machineOverridableSettings.properties[l]=r,e.windowSettings.properties[l]=r,e.resourceSettings.properties[l]=r}}v(){const n={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}w(n,l){const r=this.a.get(n);let a=r?.value,b=r?.source;D.isUndefined(a)&&(a=l.defaultDefaultValue,b=void 0),D.isUndefined(a)&&(a=u(l.type)),l.default=a,l.defaultValueSource=b}}const p="\\[([^\\]]+)\\]",g=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(v){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let l=g.exec(v);for(;l?.length;){const r=l[1].trim();r&&n.push(r),l=g.exec(v)}}return(0,i.distinct)(n)}e.overrideIdentifiersFromKey=d;function t(v){return v.reduce((n,l)=>`${n}[${l}]`,"")}e.keyFromOverrideIdentifiers=t;function u(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const h=new c;S.Registry.add(e.Extensions.Configuration,h);function y(v,n){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?N.localize(7,null,v):h.getConfigurationProperties()[v]!==void 0?N.localize(8,null,v):n.policy?.name&&h.getPolicyConfigurations().get(n.policy?.name)!==void 0?N.localize(9,null,v,n.policy?.name,h.getPolicyConfigurations().get(n.policy?.name)):null:N.localize(6,null)}e.validateProperty=y;function C(){const v=[],n=h.getConfigurationProperties();for(const l of Object.keys(n))v.push([l,n[l].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=C}),define(Re[176],Oe([1,0,18,5,115,6,28,26,9,2,42,96,30]),function(te,e,i,k,D,N,F,R,S,m,O,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function p(l){return Object.isFrozen(l)?l:R.deepFreeze(l)}class g{constructor(r={},a=[],b=[],I){this.b=r,this.c=a,this.d=b,this.raw=I,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(a=>{if(a instanceof g)return a;const b=new d("");return b.parseRaw(a),b.configurationModel});this.f=r.reduce((a,b)=>b===a?b:a.merge(b),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,O.getConfigurationValue)(this.contents,r):this.contents}inspect(r,a){const b=this.rawConfiguration.getValue(r),I=a?this.rawConfiguration.getOverrideValue(r,a):void 0,f=a?this.rawConfiguration.override(a).getValue(r):b;return{value:b,override:I,merged:f}}getOverrideValue(r,a){const b=this.i(a);return b?r?(0,O.getConfigurationValue)(b,r):b:void 0}getKeysForOverrideIdentifier(r){const a=[];for(const b of this.overrides)b.identifiers.includes(r)&&a.push(...b.keys);return i.distinct(a)}getAllOverrideIdentifiers(){const r=[];for(const a of this.overrides)r.push(...a.identifiers);return i.distinct(r)}override(r){let a=this.a.get(r);return a||(a=this.g(r),this.a.set(r,a)),a}merge(...r){const a=R.deepClone(this.contents),b=R.deepClone(this.overrides),I=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const P of r)if(f.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(a,P.contents);for(const E of P.overrides){const[o]=b.filter(s=>i.equals(s.identifiers,E.identifiers));o?(this.h(o.contents,E.contents),o.keys.push(...E.keys),o.keys=i.distinct(o.keys)):b.push(R.deepClone(E))}for(const E of P.keys)I.indexOf(E)===-1&&I.push(E)}return new g(a,I,b,f.every(P=>P instanceof g)?void 0:f)}g(r){const a=this.i(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const b={};for(const I of i.distinct([...Object.keys(this.contents),...Object.keys(a)])){let f=this.contents[I];const P=a[I];P&&(typeof f=="object"&&typeof P=="object"?(f=R.deepClone(f),this.h(f,P)):f=P),b[I]=f}return new g(b,this.keys,this.overrides)}h(r,a){for(const b of Object.keys(a)){if(b in r&&S.isObject(r[b])&&S.isObject(a[b])){this.h(r[b],a[b]);continue}r[b]=R.deepClone(a[b])}}i(r){let a=null,b=null;const I=f=>{f&&(b?this.h(b,f):b=R.deepClone(f))};for(const f of this.overrides)i.equals(f.identifiers,[r])?a=f.contents:f.identifiers.includes(r)&&I(f.contents);return I(a),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,a){this.j(r,a,!0)}setValue(r,a){this.j(r,a,!1)}removeValue(r){const a=this.keys.indexOf(r);a!==-1&&(this.keys.splice(a,1),(0,O.removeFromValueTree)(this.contents,r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(b=>i.equals(b.identifiers,(0,w.overrideIdentifiersFromKey)(r))),1))}j(r,a,b){(0,O.addToValueTree)(this.contents,r,a,I=>console.error(I)),b=b||this.keys.indexOf(r)===-1,b&&this.keys.push(r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,O.toValuesTree)(this.contents[r],I=>console.error(I))})}}e.ConfigurationModel=g;class d{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,a){if(!S.isUndefinedOrNull(r)){const b=this.g(r);this.parseRaw(b,a)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,a){this.a=r;const{contents:b,keys:I,overrides:f,restricted:P,hasExcludedProperties:E}=this.h(r,a);this.b=new g(b,I,f,E?[r]:void 0),this.c=P||[]}g(r){let a={},b=null,I=[];const f=[],P=[];function E(s){Array.isArray(I)?I.push(s):b!==null&&(I[b]=s)}const o={onObjectBegin:()=>{const s={};E(s),f.push(I),I=s,b=null},onObjectProperty:s=>{b=s},onObjectEnd:()=>{I=f.pop()},onArrayBegin:()=>{const s=[];E(s),f.push(I),I=s,b=null},onArrayEnd:()=>{I=f.pop()},onLiteralValue:E,onError:(s,M,B)=>{P.push({error:s,offset:M,length:B})}};if(r)try{D.visit(r,o),a=I[0]||{}}catch(s){console.error(`Error while parsing settings file ${this.f}: ${s}`),this.d=[s]}return a}h(r,a){const b=c.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),I=this.i(r,b,!0,a);r=I.raw;const f=(0,O.toValuesTree)(r,o=>console.error(`Conflict in settings file ${this.f}: ${o}`)),P=Object.keys(r),E=this.j(r,o=>console.error(`Conflict in settings file ${this.f}: ${o}`));return{contents:f,keys:P,overrides:E,restricted:I.restricted,hasExcludedProperties:I.hasExcludedProperties}}i(r,a,b,I){let f=!1;if(!I?.scopes&&!I?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:f};const P={},E=[];for(const o in r)if(w.OVERRIDE_PROPERTY_REGEX.test(o)&&b){const s=this.i(r[o],a,!1,I);P[o]=s.raw,f=f||s.hasExcludedProperties,E.push(...s.restricted)}else{const s=a[o],M=s?typeof s.scope<"u"?s.scope:3:void 0;s?.restricted&&E.push(o),(M===void 0||I.scopes===void 0||I.scopes.includes(M))&&!(I.skipRestricted&&s?.restricted)?P[o]=r[o]:f=!0}return{raw:P,restricted:E,hasExcludedProperties:f}}j(r,a){const b=[];for(const I of Object.keys(r))if(w.OVERRIDE_PROPERTY_REGEX.test(I)){const f={};for(const P in r[I])f[P]=r[I][P];b.push({identifiers:(0,w.overrideIdentifiersFromKey)(I),keys:Object.keys(f),contents:(0,O.toValuesTree)(f,a)})}return b}}e.ConfigurationModelParser=d;class t extends N.Disposable{constructor(r,a,b,I){super(),this.f=r,this.g=a,this.h=I,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.a=new d(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(b.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(k.Event.any(k.Event.filter(this.h.onDidFilesChange,f=>f.contains(this.f)),k.Event.filter(this.h.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&b.isEqual(f.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new g}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=t;class u{constructor(r,a,b,I,f,P,E,o,s,M,B,X,G){this.a=r,this.b=a,this.c=b,this.overrideIdentifiers=I,this.d=f,this.f=P,this.g=E,this.h=o,this.i=s,this.j=M,this.k=B,this.l=X,this.m=G}get value(){return p(this.c)}n(r,a,b){const I=r.inspect(a,b);return{get value(){return p(I.value)},get override(){return p(I.override)},get merged(){return p(I.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(r,a,b,I,f=new g,P=new g,E=new F.ResourceMap,o=new g,s=new F.ResourceMap){this.c=r,this.d=a,this.f=b,this.g=I,this.h=f,this.i=P,this.j=E,this.l=o,this.m=s,this.a=null,this.b=new F.ResourceMap,this.n=null}getValue(r,a,b){return this.q(r,a,b).getValue(r)}updateValue(r,a,b={}){let I;b.resource?(I=this.m.get(b.resource),I||(I=new g,this.m.set(b.resource,I))):I=this.l,a===void 0?I.removeValue(r):I.setValue(r,a),b.resource||(this.a=null)}inspect(r,a,b){const I=this.q(r,a,b),f=this.u(a.resource,b),P=a.resource?this.m.get(a.resource)||this.l:this.l,E=new Set;for(const o of I.overrides)for(const s of o.identifiers)I.getOverrideValue(r,s)!==void 0&&E.add(s);return new u(r,a,I.getValue(r),E.size?[...E]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this.i:void 0,f||void 0,P)}keys(r){const a=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,a){this.j.set(r,a),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const b=[];if(!a){const{added:I,updated:f,removed:P}=v(this.c,r);a=[...I,...f,...P]}for(const I of a)for(const f of(0,w.overrideIdentifiersFromKey)(I)){const P=this.c.getKeysForOverrideIdentifier(f),E=r.getKeysForOverrideIdentifier(f),o=[...E.filter(s=>P.indexOf(s)===-1),...P.filter(s=>E.indexOf(s)===-1),...P.filter(s=>!R.equals(this.c.override(f).getValue(s),r.override(f).getValue(s)))];b.push([f,o])}return this.updateDefaultConfiguration(r),{keys:a,overrides:b}}compareAndUpdatePolicyConfiguration(r){const{added:a,updated:b,removed:I}=v(this.d,r),f=[...a,...b,...I];return f.length&&this.updatePolicyConfiguration(r),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:a,updated:b,removed:I,overrides:f}=v(this.applicationConfiguration,r),P=[...a,...b,...I];return P.length&&this.updateApplicationConfiguration(r),{keys:P,overrides:f}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:b,removed:I,overrides:f}=v(this.localUserConfiguration,r),P=[...a,...b,...I];return P.length&&this.updateLocalUserConfiguration(r),{keys:P,overrides:f}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:b,removed:I,overrides:f}=v(this.remoteUserConfiguration,r),P=[...a,...b,...I];return P.length&&this.updateRemoteUserConfiguration(r),{keys:P,overrides:f}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:b,removed:I,overrides:f}=v(this.workspaceConfiguration,r),P=[...a,...b,...I];return P.length&&this.updateWorkspaceConfiguration(r),{keys:P,overrides:f}}compareAndUpdateFolderConfiguration(r,a){const b=this.p.get(r),{added:I,updated:f,removed:P,overrides:E}=v(b,a),o=[...I,...f,...P];return(o.length||!b)&&this.updateFolderConfiguration(r,a),{keys:o,overrides:E}}compareAndDeleteFolderConfiguration(r){const a=this.p.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:b,updated:I,removed:f,overrides:P}=v(a,void 0);return{keys:[...b,...I,...f],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,a,b){let I=this.r(a,b);return a.overrideIdentifier&&(I=I.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(I=I.merge(this.d)),I}r({resource:r},a){let b=this.s();if(a&&r){const I=a.getFolder(r);I&&(b=this.t(I.uri)||b);const f=this.m.get(r);f&&(b=b.merge(f))}return b}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let a=this.b.get(r);if(!a){const b=this.s(),I=this.j.get(r);I?(a=b.merge(I),this.b.set(r,a)):a=b}return a}u(r,a){if(a&&r){const b=a.getFolder(r);if(b)return this.j.get(b.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,a)=>{const{contents:b,overrides:I,keys:f}=this.j.get(a);return r.push([a,{contents:b,overrides:I,keys:f}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(a=>r.add(a)),this.userConfiguration.keys.forEach(a=>r.add(a)),this.i.keys.forEach(a=>r.add(a)),this.j.forEach(a=>a.keys.forEach(b=>r.add(b))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.i.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.j.forEach(a=>a.getAllOverrideIdentifiers().forEach(b=>r.add(b))),[...r.values()]}w(r){const a=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(b=>a.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(b=>a.add(b)),this.i.getKeysForOverrideIdentifier(r).forEach(b=>a.add(b)),this.j.forEach(b=>b.getKeysForOverrideIdentifier(r).forEach(I=>a.add(I))),[...a.values()]}static parse(r){const a=this.x(r.defaults),b=this.x(r.policy),I=this.x(r.application),f=this.x(r.user),P=this.x(r.workspace),E=r.folders.reduce((o,s)=>(o.set(m.URI.revive(s[0]),this.x(s[1])),o),new F.ResourceMap);return new h(a,b,I,f,new g,P,E,new g,new F.ResourceMap)}static x(r){return new g(r.contents,r.keys,r.overrides)}}e.Configuration=h;function y(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,a=new Map;for(const I of l)I.keys.forEach(f=>r.add(f)),I.overrides.forEach(([f,P])=>{const E=(0,F.getOrSet)(a,f,new Set);P.forEach(o=>E.add(o))});const b=[];return a.forEach((I,f)=>b.push([f,[...I.values()]])),{keys:[...r.values()],overrides:b}}e.mergeChanges=y;class C{constructor(r,a,b,I){this.change=r,this.f=a,this.g=b,this.h=I,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const f of r.keys)this.affectedKeys.add(f);for(const[,f]of r.overrides)for(const P of f)this.affectedKeys.add(P);this.d=this.a;for(const f of this.affectedKeys)this.d+=f+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(r,a){const b=this.a+r,I=this.d.indexOf(b);if(I<0)return!1;const f=I+b.length;if(f>=this.d.length)return!1;const P=this.d.charCodeAt(f);if(P!==this.b&&P!==this.c)return!1;if(a){const E=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.f?.workspace):void 0,o=this.g.getValue(r,a,this.h);return!R.equals(E,o)}return!0}}e.ConfigurationChangeEvent=C;function v(l,r){const{added:a,removed:b,updated:I}=n(r?.rawConfiguration,l?.rawConfiguration),f=[],P=l?.getAllOverrideIdentifiers()||[],E=r?.getAllOverrideIdentifiers()||[];if(r){const o=E.filter(s=>!P.includes(s));for(const s of o)f.push([s,r.getKeysForOverrideIdentifier(s)])}if(l){const o=P.filter(s=>!E.includes(s));for(const s of o)f.push([s,l.getKeysForOverrideIdentifier(s)])}if(r&&l){for(const o of P)if(E.includes(o)){const s=n({contents:l.getOverrideValue(void 0,o)||{},keys:l.getKeysForOverrideIdentifier(o)},{contents:r.getOverrideValue(void 0,o)||{},keys:r.getKeysForOverrideIdentifier(o)});f.push([o,[...s.added,...s.removed,...s.updated]])}}return{added:a,removed:b,updated:I,overrides:f}}function n(l,r){const a=l?r?l.keys.filter(f=>r.keys.indexOf(f)===-1):[...l.keys]:[],b=r?l?r.keys.filter(f=>l.keys.indexOf(f)===-1):[...r.keys]:[],I=[];if(l&&r){for(const f of r.keys)if(l.keys.indexOf(f)!==-1){const P=(0,O.getConfigurationValue)(r.contents,f),E=(0,O.getConfigurationValue)(l.contents,f);R.equals(P,E)||I.push(f)}}return{added:a,removed:b,updated:I}}}),define(Re[97],Oe([1,0,10,3]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var D;(function(O){O[O.WebSocket=0]="WebSocket",O[O.Managed=1]="Managed"})(D||(e.RemoteConnectionType=D={}));class N{constructor(w){this.id=w,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=N;class F{constructor(w,c){this.host=w,this.port=c,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=F;var R;(function(O){O.Unknown="Unknown",O.NotAvailable="NotAvailable",O.TemporarilyNotAvailable="TemporarilyNotAvailable",O.NoResolverFound="NoResolverFound"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class S extends i.ErrorNoTelemetry{static isNotAvailable(w){return w instanceof S&&w._code===R.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof S&&w._code===R.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof S&&w._code===R.NoResolverFound}static isHandled(w){return w instanceof S&&w.isHandled}constructor(w,c=R.Unknown,p){super(w),this._message=w,this._code=c,this._detail=p,this.isHandled=c===R.NotAvailable&&p===!0,Object.setPrototypeOf(this,S.prototype)}}e.RemoteAuthorityResolverError=S;function m(O){const w=O.indexOf("+");return w===-1?O:O.substring(0,w)}e.getRemoteAuthorityPrefix=m}),define(Re[50],Oe([1,0,15]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function k(m){return m.scheme===i.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=k;function D(m){if(!m)return;const O=m.indexOf("+");return O<0?m:m.substr(0,O)}e.getRemoteName=D;function N(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=N;function F(m){const{host:O,port:w}=S(m);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:w}}e.parseAuthorityWithPort=F;function R(m,O){let{host:w,port:c}=S(m);return typeof c>"u"&&(c=O),{host:w,port:c}}e.parseAuthorityWithOptionalPort=R;function S(m){const O=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const w=m.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const c=m.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:m,port:void 0}}}),define(Re[23],Oe([1,0,13,3,50]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(F||(e.ExtensionType=F={}));var R;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class S{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,u){if(typeof t>"u"||t===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof t=="string"||typeof u=="string"){const h=typeof t=="string"?t:t.value,y=typeof u=="string"?u:u.value;return i.equalsIgnoreCase(h,y)}return t._lower===u._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=S;class m{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const u of t)this.add(u)}add(t){this.c.add(S.toKey(t))}delete(t){return this.c.delete(S.toKey(t))}has(t){return this.c.has(S.toKey(t))}}e.ExtensionIdentifierSet=m;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(S.toKey(t))}get(t){return this.c.get(S.toKey(t))}has(t){return this.c.has(S.toKey(t))}set(t,u){this.c.set(S.toKey(t),u)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=O;function w(d){return c(d)}e.isApplicationScopedExtension=w;function c(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=c;function p(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function g(d,t){if(t){const u=`onResolveRemoteAuthority:${(0,D.getRemoteName)(t)}`;return!!d.activationEvents?.includes(u)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Re[98],Oe([1,0,10,23]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class D{constructor(){this.a=new Map,this.b=new WeakMap}register(F,R){this.a.set(F,R)}readActivationEvents(F){return this.b.has(F)||this.b.set(F,this.c(F)),this.b.get(F)}createActivationEventsMap(F){const R=Object.create(null);for(const S of F){const m=this.readActivationEvents(S);m.length>0&&(R[k.ExtensionIdentifier.toKey(S.identifier)]=m)}return R}c(F){if(typeof F.main>"u"&&typeof F.browser>"u")return[];const R=Array.isArray(F.activationEvents)?F.activationEvents.slice(0):[];if(!F.contributes)return R;for(const S in F.contributes){const m=this.a.get(S);if(!m)continue;const O=F.contributes[S],w=Array.isArray(O)?O:[O];try{m(w,R)}catch(c){(0,i.onUnexpectedError)(c)}}return R}}e.ImplicitActivationEventsImpl=D,e.ImplicitActivationEvents=new D}),define(Re[177],Oe([1,0,21,51,36]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(S){if(i.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function F(S,m,O,w,c,p,g,d){const t=Object.create(null);t["common.machineId"]=p,t.sessionID=(0,D.generateUuid)()+Date.now(),t.commitHash=w,t.version=c,t["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,i.PlatformToString)(i.platform),t["common.nodePlatform"]=k.platform,t["common.nodeArch"]=O,t["common.product"]=d||"desktop",g&&(t["common.msftInternal"]=g);let u=0;const h=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),i.isLinuxSnap&&(t["common.snap"]="true");const y=N(m);return y&&(t["common.platformDetail"]=y),t}e.resolveCommonProperties=F;function R(S){const m=k.env.USERDNSDOMAIN;if(!m)return!1;const O=m.toLowerCase();return S.some(w=>O===w)}e.verifyMicrosoftInternalDomain=R}),define(Re[178],Oe([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(k||(e.TelemetryLevel=k={}));var D;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(Re[52],Oe([1,0,26,9,5,42,50,177,178]),function(te,e,i,k,D,N,F,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class O{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=O,e.NullTelemetryService=new O;class w{async publicLog(b,I,f){}async publicLogError(b,I,f){}}e.NullEndpointTelemetryService=w,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(a,b){return D.Event.debounce(b.onDidChangeConfiguration,(f,P)=>{const E=f?new Set([...f.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:E}},1e3,!0)(f=>{f.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,N.ConfigurationTargetToString)(f.source),configurationKeys:Array.from(f.affectedKeys)})})}e.configurationTelemetry=c;function p(a,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!a.enableTelemetry||b.extensionTestsLocationURI)}e.supportsTelemetry=p;function g(a,b){return!(b.isBuilt||b.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=g;function d(a){const b=a.getValue(S.TELEMETRY_SETTING_ID),I=a.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||I===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=d;function t(a){const b={},I={},f={};y(a,f);for(let P in f){P=P.length>150?P.substr(P.length-149):P;const E=f[P];typeof E=="number"?I[P]=E:typeof E=="boolean"?I[P]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${E.length}`),b[P]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(b[P]=E)}return{properties:b,measurements:I}}e.validateTelemetryData=t;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(a){if(!a)return"none";const b=(0,F.getRemoteName)(a);return u.has(b)?b:"other"}e.cleanRemoteAuthority=h;function y(a,b,I=0,f){if(a)for(const P of Object.getOwnPropertyNames(a)){const E=a[P],o=f?f+P:P;Array.isArray(E)?b[o]=(0,i.safeStringify)(E):E instanceof Date?b[o]=E.toISOString():(0,k.isObject)(E)?I<2?y(E,b,I+1,o+"."):b[o]=(0,i.safeStringify)(E):b[o]=E}}function C(a,b){const I=a.msftInternalDomains||[],f=b.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(I)||f}e.isInternalTelemetry=C;function v(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=v;function n(a,b){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let I=a;const f=[];for(const s of b)for(;;){const M=s.exec(a);if(!M)break;f.push([M.index,s.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(I="";;){const s=E.exec(a);if(!s)break;const M=f.some(([B,X])=>s.index<X&&B<E.lastIndex);!P.test(s[0])&&!M&&(I+=a.substring(o,s.index)+"<REDACTED: user-file-path>",o=E.lastIndex)}return o<a.length&&(I+=a.substr(o)),I}function l(a){if(!a)return a;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const I of b)if(I.regex.test(a))return`<REDACTED: ${I.label}>`;return a}function r(a,b){return(0,i.cloneAndChange)(a,I=>{if(I instanceof m||Object.hasOwnProperty.call(I,"isTrustedTelemetryValue"))return I.value;if(typeof I=="string"){let f=I.replaceAll("%20"," ");f=n(f,b);for(const P of b)f=f.replace(P,"");return f=l(f),f}})}e.cleanData=r}),define(Re[179],Oe([1,0,13,92,23,21,2,10,51,52]),function(te,e,i,k,D,N,F,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(r,a){return r.uuid&&a.uuid?r.uuid===a.uuid:r.id===a.id?!0:(0,i.compareIgnoreCase)(r.id,a.id)===0}e.areSameExtensions=O;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(a){const b=a.manifest?a.manifest.version:a.version,I=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new c(a.identifier,b,I)}static parse(a){const b=w.exec(a);return b&&b[1]&&b[2]?new c({id:b[1]},b[2],b[4]||void 0):null}constructor(a,b,I="undefined"){this.version=b,this.targetPlatform=I,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof c?O(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=c;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(r){const a=p.exec(r);return a&&a[1]?[t(a[1]),a[2]]:[t(r),void 0]}e.getIdAndVersion=g;function d(r,a){return`${r}.${a}`}e.getExtensionId=d;function t(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=t;function u(r,a){return t(d(r??D.UNDEFINED_PUBLISHER,a))}e.getGalleryExtensionId=u;function h(r,a){const b=[],I=f=>{for(const P of b)if(P.some(E=>O(a(E),a(f))))return P;return null};for(const f of r){const P=I(f);P?P.push(f):b.push([f])}return b}e.groupByExtension=h;function y(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function C(r){return{id:new m.TelemetryTrustedValue(r.identifier.id),name:new m.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function v(r,a){const b=[],I=a.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const f=I.shift();if(f&&b.every(P=>!O(P.identifier,{id:f}))){const P=r.filter(E=>O(E.identifier,{id:f}));P.length===1&&(b.push(P[0]),I.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=v;async function n(r,a){if(!N.isLinux)return!1;let b;try{b=(await r.readFile(F.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await r.readFile(F.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){a.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(f))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(r,a){const b=await n(r,a),I=(0,k.getTargetPlatform)(b?"alpine":N.platform,S.arch);return a.debug("ComputeTargetPlatform:",I),I}e.computeTargetPlatform=l}),define(Re[180],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function i(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=i;function k(S){return S?[...S.entries()]:[]}e.serializeEnvironmentDescriptionMap=k;function D(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=D;function N(S){return new Map(S??[])}e.deserializeEnvironmentDescriptionMap=N;function F(S){return Array.from(S.entries()).map(m=>[m[0],i(m[1].map),k(m[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=F;function R(S){return new Map(S.map(m=>[m[0],{map:D(m[1]),descriptionMap:N(m[2])}]))}e.deserializeEnvironmentVariableCollections=R}),define(Re[181],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(D){this.b=D,this.a=new Map}dispose(){for(const D of this.a.values())D.dispose()}startBuffering(D,N,F=5){const R=N(S=>{const m=typeof S=="string"?S:S.data;let O=this.a.get(D);if(O){O.data.push(m);return}const w=setTimeout(()=>this.flushBuffer(D),F);O={data:[m],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(D),R.dispose()}},this.a.set(D,O)});return R}stopBuffering(D){this.a.get(D)?.dispose()}flushBuffer(D){const N=this.a.get(D);N&&(this.a.delete(D),this.b(D,N.data.join("")))}}e.TerminalDataBufferer=i}),define(Re[182],Oe([1,0,16,87,39,5,9,2,144,72,30]),function(te,e,i,k,D,N,F,R,S,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var w;(function(C){function v(n,l){let r=n.defaults;for(;D.ThemeIcon.isThemeIcon(r);){const a=g.getIcon(r.id);if(!a)return;r=a.defaults}return r}C.getDefinition=v})(w||(e.IconContribution=w={}));var c;(function(C){function v(l){return{weight:l.weight,style:l.style,src:l.src.map(r=>({format:r.format,location:r.location.toString()}))}}C.toJSONObject=v;function n(l){const r=a=>(0,F.isString)(a)?a:void 0;if(l&&Array.isArray(l.src)&&l.src.every(a=>(0,F.isString)(a.format)&&(0,F.isString)(a.location)))return{weight:r(l.weight),style:r(l.style),src:l.src.map(a=>({format:a.format,location:R.URI.parse(a.location)}))}}C.fromJSONObject=n})(c||(e.IconFontDefinition=c={}));class p{constructor(){this.a=new N.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${D.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,n,l,r){const a=this.b[v];if(a){if(l&&!a.description){a.description=l,this.d.properties[v].markdownDescription=`${l} $(${v})`;const f=this.e.enum.indexOf(v);f!==-1&&(this.e.enumDescriptions[f]=l),this.a.fire()}return a}const b={id:v,description:l,defaults:n,deprecationMessage:r};this.b[v]=b;const I={$ref:"#/definitions/icons"};return r&&(I.deprecationMessage=r),l&&(I.markdownDescription=`${l}: $(${v})`),this.d.properties[v]=I,this.e.enum.push(v),this.e.enumDescriptions.push(l||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const n=this.e.enum.indexOf(v);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,n){const l=this.f[v];return l||(this.f[v]=n,this.a.fire(),n)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(a,b)=>a.id.localeCompare(b.id),n=a=>{for(;D.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(a=>this.b[a]);for(const a of r.filter(b=>!!b.description).sort(v))l.push(`|<i class="${n(a)}"></i>|${a.id}|${D.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const a of r.filter(b=>!D.ThemeIcon.isThemeIcon(b.defaults)).sort(v))l.push(`|<i class="${n(a)}"></i>|${a.id}|`);return l.join(`
`)}}const g=new p;O.Registry.add(e.Extensions.IconContribution,g);function d(C,v,n,l){return g.registerIcon(C,v,n,l)}e.registerIcon=d;function t(){return g}e.getIconRegistry=t;function u(){const C=(0,k.getCodiconFontCharacters)();for(const v in C){const n="\\"+C[v].toString(16);g.registerIcon(v,{fontCharacter:n})}}u(),e.iconsSchemaId="vscode://schemas/icons";const h=O.Registry.as(m.Extensions.JSONContribution);h.registerSchema(e.iconsSchemaId,g.getIconSchema());const y=new i.RunOnceScheduler(()=>h.notifySchemaChanged(e.iconsSchemaId),200);g.onDidChange(()=>{y.isScheduled()||y.schedule()}),e.widgetClose=d("widget-close",k.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=d("goto-previous-location",k.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=d("goto-next-location",k.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=D.ThemeIcon.modify(k.Codicon.sync,"spin"),e.spinningLoading=D.ThemeIcon.modify(k.Codicon.loading,"spin")}),define(Re[183],Oe([1,0,5,42,3,14]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var F;(function(d){d.Http="http",d.Https="https"})(F||(e.TunnelProtocol=F={}));var R;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(R||(e.TunnelPrivacyId=R={}));var S;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(S||(e.ProvidedOnAutoForward=S={}));function m(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(t)return{address:t[1],port:+t[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=w;function c(d,t,u,h){if(u===1)return!1;if(u===2&&w(t)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(y?.length===4&&parseInt(y[1])>=18)return!1}return d<1024}e.isPortPrivileged=c;class p{constructor(t,u,h){this.remoteAddress=t,this.localAddress=u,this.b=h,this.a=new i.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=p;let g=e.AbstractTunnelService=class{constructor(t,u){this.i=t,this.j=u,this.a=new i.Emitter,this.onTunnelOpened=this.a.event,this.b=new i.Emitter,this.onTunnelClosed=this.b.event,this.c=new i.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const t=this.j.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.e=t,t?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.f=t.elevation,this.g=t.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const t=[],u=Array.from(this.d.values());for(const h of u){const y=Array.from(h.values());for(const C of y){const v=await C.value;v&&t.push(v)}}return t}async dispose(){for(const t of this.d.values()){for(const{value:u}of t.values())await u.then(h=>h?.dispose());t.clear()}this.d.clear()}setEnvironmentTunnel(t,u,h,y,C){this.o(t,u,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:u,localAddress:h,privacy:y,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,u){(w(t)||O(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const h=this.q(t,u);if(h)return++h.refcount,h.value}openTunnel(t,u,h,y,C,v=!1,n,l){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${h} on local port ${C}.`),!t)return;if(u||(u="localhost"),y||(y=this.k),this.e&&this.h.has(h)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(t,u,h,y,C,v,n,l);return r?r.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,h);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.m(a);return(a.tunnelRemoteHost!==u||a.tunnelRemotePort!==h)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&a.privacy!==n&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const u=this.d.get(t.tunnelRemoteHost);if(u){const h=u.get(t.tunnelRemotePort);h&&(h.refcount--,await this.n(t.tunnelRemoteHost,t.tunnelRemotePort,h))}}}}async n(t,u,h){if(h.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${u}.`);const y=h.value.then(async C=>{C&&(await C.dispose(!0),this.b.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this.d.has(t)&&this.d.get(t).delete(u),y}}async closeTunnel(t,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${u} `);const h=this.d.get(t);if(h&&h.has(u)){const y=h.get(u);y.refcount=0,await this.n(t,u,y)}}o(t,u,h){this.d.has(t)||this.d.set(t,new Map),this.d.get(t).set(u,{refcount:1,value:h})}async p(t,u){const h=this.d.get(t);h&&(await h.get(u)||h.delete(u),h.size===0&&this.d.delete(t))}q(t,u){const h=[t];O(t)?(h.push(...e.LOCALHOST_ADDRESSES),h.push(...e.ALL_INTERFACES_ADDRESSES)):w(t)&&h.push(...e.ALL_INTERFACES_ADDRESSES);const y=h.map(C=>this.d.get(C));for(const C of y){const v=C?.get(u);if(v)return v}}canTunnel(t){return!!m(t)}s(t,u,h,y,C,v,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${h} on local port ${y}.`);const l=h;this.h.add(l);const r=y===void 0?h:y,a={elevationRequired:C?this.isPortPrivileged(r):!1},b={remoteAddress:{host:u,port:h},localAddressPort:y,privacy:v,public:v?v!==R.Private:void 0,protocol:n},I=t.forwardPort(b,a);return I?(this.o(u,h,I),I.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(l)})):this.h.delete(l),I}};e.AbstractTunnelService=g=xe([Ve(0,N.ILogService),Ve(1,k.IConfigurationService)],g)}),define(Re[184],Oe([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var k;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(k||(e.EditSessionIdentityMatch=k={}))}),define(Re[185],Oe([1,0,15]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function k(S){return S.scheme!==i.Schemas.file&&S.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=k;function D(S){if(S.folders.length)return S.folders.every(m=>k(m.uri))?S.folders[0].uri:void 0;if(S.configuration&&k(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=D;function N(S){return D(S)?.scheme}e.getVirtualWorkspaceScheme=N;function F(S){return D(S)?.authority}e.getVirtualWorkspaceAuthority=F;function R(S){return D(S)!==void 0}e.isVirtualWorkspace=R}),define(Re[53],Oe([1,0,145,19,48,25,2,3,15]),function(te,e,i,k,D,N,F,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function m(a){const b=a;return typeof b?.id=="string"&&F.URI.isUri(b.uri)}e.isSingleFolderWorkspaceIdentifier=m;function O(a){return typeof a?.id=="string"&&!m(a)&&!c(a)}e.isEmptyWorkspaceIdentifier=O,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(a,b){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,k.basename)(a)}:b?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const I=a;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}e.toWorkspaceIdentifier=w;function c(a){const b=a;return typeof b?.id=="string"&&F.URI.isUri(b.configPath)}e.isWorkspaceIdentifier=c;function p(a){const b=a;if(b?.uri)return{id:b.id,uri:F.URI.revive(b.uri)};const I=a;if(I?.configPath)return{id:I.id,configPath:F.URI.revive(I.configPath)};if(a?.id)return{id:a.id}}e.reviveIdentifier=p;var g;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function d(a){const b=a;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=d;function t(a){const b=a;return!!(b&&typeof b=="object"&&F.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=t;class u{constructor(b,I,f,P,E){this.h=b,this.j=f,this.k=P,this.l=E,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=I}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class h{constructor(b,I){this.raw=I,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,N.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function y(a){return new h({uri:a,index:0,name:(0,N.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function C(a,b){return N.extUriBiasedIgnorePathCase.isEqualOrParent(a,b.untitledWorkspacesHome)}e.isUntitledWorkspace=C;function v(a){let b;return F.URI.isUri(a)?b=a:b=a.configuration,b?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=v,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(a){return a.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=n;function l(a,b){return!C(a,b)&&!v(a)}e.isSavedWorkspace=l;function r(a){return(typeof a=="string"?(0,k.extname)(a):(0,N.extname)(a))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Re[54],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(D){this.d=D,this.b=new Map,this.c=1}add(D){const N=this.c++;return this.b.set(N,D),this.e(),N}get(D,N){return this.b.has(D)?this.b.get(D)[N]:void 0}delete(D){this.b.delete(D),this.e()}e(){i.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=i,i.a=!1}),define(Re[38],Oe([1,0,15,25,3]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class N{constructor(){this.a=new Set(Object.keys(i.Schemas)),this.b=new Map,this.extUri=new k.ExtUri(R=>{const S=this.b.get(R.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(R,S){S===null?this.b.delete(R.scheme):this.b.set(R.scheme,S)}isFreeScheme(R){return!this.b.has(R)&&!this.a.has(R)}getCapabilities(R){return this.b.get(R)}}e.ExtHostFileSystemInfo=N,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(Re[27],Oe([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(Re[186],Oe([1,0,150,14,172,27]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=e.ExtHostLogService=class extends D.LogService{constructor(S,m,O){const w=O.remote.isRemote?"remoteexthost":S?"workerexthost":"exthost",c=O.remote.isRemote?(0,i.localize)(0,null):S?(0,i.localize)(1,null):(0,i.localize)(2,null);super(m.createLogger(w,{name:c}))}};e.ExtHostLogService=F=xe([Ve(1,k.ILoggerService),Ve(2,N.IExtHostInitDataService)],F)}),define(Re[187],Oe([1,0,16]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(F,R,S){this.h=new Map,this.a=F,this.b=R,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(m=>(this.f=m,this)),this.g=this.c.onDidChangeStorage(m=>{m.shared===this.b&&m.key===this.a&&(this.f=m.value)}),this.i=new i.RunOnceScheduler(()=>{const m=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of m.values())O.complete()}catch(O){for(const w of m.values())w.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this.d}get(F,R){let S=this.f[F];return typeof S>"u"&&(S=R),S}update(F,R){this.f[F]=R;const S=this.h.get(F);if(S!==void 0)return S.p;const m=new i.DeferredPromise;return this.h.set(F,m),this.i.isScheduled()||this.i.schedule(),m.p}dispose(){this.g.dispose()}}e.ExtensionMemento=k;class D extends k{setKeysForSync(F){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},F)}constructor(F,R){super(F.identifier.value,!0,R),this.j=F}}e.ExtensionGlobalMemento=D}),define(Re[188],Oe([1,0,5,2]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(F){this.c=F,this.a=new i.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new i.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(F,R,S,m){const w=this.c.getNotebookDocument(k.URI.revive(F)).acceptModelChanged(R.value,S,m);this.b.fire(w)}$acceptDirtyStateChanged(F,R){this.c.getNotebookDocument(k.URI.revive(F)).acceptDirty(R)}$acceptModelSaved(F){const R=this.c.getNotebookDocument(k.URI.revive(F));this.a.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(Re[17],Oe([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class k{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.ExtHostRpcService=k});var Ye=this&&this.__classPrivateFieldSet||function(te,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Fe=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(Re[189],Oe([1,0,23,5]),function(te,e,i,k){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class N{constructor(R,S){D.set(this,void 0),this.b=new k.Emitter,this.onDidChange=this.b.event,this.a=i.ExtensionIdentifier.toKey(R.identifier),Ye(this,D,S,"f"),Fe(this,D,"f").onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(R){return Fe(this,D,"f").get(this.a,R)}store(R,S){return Fe(this,D,"f").store(this.a,R,S)}delete(R){return Fe(this,D,"f").delete(this.a,R)}}e.ExtensionSecrets=N,D=new WeakMap}),define(Re[73],Oe([1,0,3,183,5,17]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var F;(function(S){function m(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:w.protocol}}S.fromApiTunnel=m;function O(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==k.TunnelPrivacyId.ConstantPrivate&&w.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}S.fromServiceTunnel=O})(F||(e.TunnelDtoConverter=F={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let R=e.ExtHostTunnelService=class{constructor(m){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(m){return m}async openTunnel(m,O){}async getTunnels(){return[]}async setTunnelFactory(m){return{dispose:()=>{}}}registerPortsAttributesProvider(m,O){return{dispose:()=>{}}}async $providePortAttributes(m,O,w,c,p){return[]}async $forwardPort(m,O){}async $closeTunnel(m){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.ExtHostTunnelService=R=xe([Ve(0,N.IExtHostRpcService)],R)}),define(Re[55],Oe([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class k{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=k}),define(Re[190],Oe([1,0,24]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(S){let m=this.buffers.indexOf(S);return m<0&&(m=this.buffers.length,this.buffers.push(S)),m}}function D(R,S){if(S.serializeBuffersForPostMessage){const m=new k,w=JSON.stringify(R,(p,g)=>{if(g instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:m.add(g)};if(ArrayBuffer.isView(g)){const d=N(g);if(d)return{$$vscode_array_buffer_reference$$:!0,index:m.add(g.buffer),view:{type:d,byteLength:g.byteLength,byteOffset:g.byteOffset}}}return g}),c=m.buffers.map(p=>{const g=new Uint8Array(p);return i.VSBuffer.wrap(g)});return{message:w,buffers:c}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=D;function N(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(R,S){const m=S.map(c=>{const p=new ArrayBuffer(c.byteLength);return new Uint8Array(p).set(c.buffer),p}),O=S.length?(c,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const g=p,{index:d}=g,t=m[d];if(g.view)switch(g.view.type){case 1:return new Int8Array(t,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return p}:void 0;return{message:JSON.parse(R,O),arrayBuffers:m}}e.deserializeWebviewMessage=F}),define(Re[99],Oe([1,0,157,9,2,6,3,30,43,15,40,129,29]),function(te,e,i,k,D,N,F,R,S,m,O,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var p;(function(Q){Q[Q.PROGRAMMATIC=1]="PROGRAMMATIC",Q[Q.USER=2]="USER",Q[Q.EDIT=3]="EDIT",Q[Q.NAVIGATION=4]="NAVIGATION",Q[Q.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var g;(function(Q){Q[Q.IDENTICAL=1]="IDENTICAL",Q[Q.SIMILAR=2]="SIMILAR",Q[Q.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function d(Q){const ue=Q;return!!ue&&typeof ue.getSelection=="function"&&!!ue.onDidChangeSelection}e.isEditorPaneWithSelection=d;function t(Q,ue,Ie){for(const Pe of Ie.visibleEditorPanes)if(Pe.group.id===ue&&Q.matches(Pe.input))return Pe.getViewState()}e.findViewStateForEditor=t;function u(Q){if(I(Q))return!1;const ue=Q;return D.URI.isUri(ue?.resource)}e.isResourceEditorInput=u;function h(Q){if(I(Q))return!1;const ue=Q;return ue?.original!==void 0&&ue.modified!==void 0}e.isResourceDiffEditorInput=h;function y(Q){if(I(Q)||h(Q))return!1;const ue=Q;return ue?.primary!==void 0&&ue.secondary!==void 0}e.isResourceSideBySideEditorInput=y;function C(Q){if(I(Q))return!1;const ue=Q;return ue?ue.resource===void 0||ue.resource.scheme===m.Schemas.untitled||ue.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=C;function v(Q){if(I(Q))return!1;const ue=Q;return D.URI.isUri(ue?.base?.resource)&&D.URI.isUri(ue?.input1?.resource)&&D.URI.isUri(ue?.input2?.resource)&&D.URI.isUri(ue?.result?.resource)}e.isResourceMergeEditorInput=v;var n;(function(Q){Q[Q.SHORT=0]="SHORT",Q[Q.MEDIUM=1]="MEDIUM",Q[Q.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var l;(function(Q){Q[Q.EXPLICIT=1]="EXPLICIT",Q[Q.AUTO=2]="AUTO",Q[Q.FOCUS_CHANGE=3]="FOCUS_CHANGE",Q[Q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class r{constructor(){this.a=new Map}registerSource(ue,Ie){let Pe=this.a.get(ue);return Pe||(Pe={source:ue,label:Ie},this.a.set(ue,Pe)),Pe.source}getSourceLabel(ue){return this.a.get(ue)?.label??ue}}e.SaveSourceRegistry=new r;var a;(function(Q){Q[Q.None=0]="None",Q[Q.Readonly=2]="Readonly",Q[Q.Untitled=4]="Untitled",Q[Q.Singleton=8]="Singleton",Q[Q.RequiresTrust=16]="RequiresTrust",Q[Q.CanSplitInGroup=32]="CanSplitInGroup",Q[Q.ForceDescription=64]="ForceDescription",Q[Q.CanDropIntoEditor=128]="CanDropIntoEditor",Q[Q.MultipleEditors=256]="MultipleEditors",Q[Q.Scratchpad=512]="Scratchpad"})(a||(e.EditorInputCapabilities=a={}));class b extends N.Disposable{}e.AbstractEditorInput=b;function I(Q){return Q instanceof b}e.isEditorInput=I;function f(Q){const ue=Q;return D.URI.isUri(ue?.preferredResource)}function P(Q){const ue=Q;return I(ue?.primary)&&I(ue?.secondary)}e.isSideBySideEditorInput=P;function E(Q){const ue=Q;return I(ue?.modified)&&I(ue?.original)}e.isDiffEditorInput=E;function o(Q,ue,Ie,Pe,be){return le(Pe,[(0,w.toAction)({id:"workbench.action.openLargeFile",label:(0,i.localize)(2,null),run:()=>{const A={...Ie,limits:{size:Number.MAX_VALUE}};Q.openEditor(ue,A)}}),(0,w.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,i.localize)(3,null),run:()=>be.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}e.createTooLargeFileError=o;function s(Q){return I(Q?.editor)}e.isEditorInputWithOptions=s;function M(Q){const ue=Q;return s(Q)&&ue?.group!==void 0}e.isEditorInputWithOptionsAndGroup=M;function B(Q){const ue=Q;return typeof ue?.groupId=="number"&&I(ue.editor)}e.isEditorIdentifier=B;var X;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.REPLACE=1]="REPLACE",Q[Q.MOVE=2]="MOVE",Q[Q.UNPIN=3]="UNPIN"})(X||(e.EditorCloseContext=X={}));var G;(function(Q){Q[Q.GROUP_ACTIVE=0]="GROUP_ACTIVE",Q[Q.GROUP_INDEX=1]="GROUP_INDEX",Q[Q.GROUP_LOCKED=2]="GROUP_LOCKED",Q[Q.EDITOR_OPEN=3]="EDITOR_OPEN",Q[Q.EDITOR_CLOSE=4]="EDITOR_CLOSE",Q[Q.EDITOR_MOVE=5]="EDITOR_MOVE",Q[Q.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",Q[Q.EDITOR_LABEL=7]="EDITOR_LABEL",Q[Q.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",Q[Q.EDITOR_PIN=9]="EDITOR_PIN",Q[Q.EDITOR_STICKY=10]="EDITOR_STICKY",Q[Q.EDITOR_DIRTY=11]="EDITOR_DIRTY",Q[Q.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(G||(e.GroupModelChangeKind=G={}));var W;(function(Q){Q[Q.PRIMARY=1]="PRIMARY",Q[Q.SECONDARY=2]="SECONDARY",Q[Q.BOTH=3]="BOTH",Q[Q.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class U{getOriginalUri(ue,Ie){if(!ue)return;if(v(ue))return e.EditorResourceAccessor.getOriginalUri(ue.result,Ie);if(Ie?.supportSideBySide){const{primary:be,secondary:A}=this.a(ue);if(be&&A){if(Ie?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:Ie.filterByScheme}),secondary:this.getOriginalUri(A,{filterByScheme:Ie.filterByScheme})};if(Ie?.supportSideBySide===W.ANY)return this.getOriginalUri(be,{filterByScheme:Ie.filterByScheme})??this.getOriginalUri(A,{filterByScheme:Ie.filterByScheme});ue=Ie.supportSideBySide===W.PRIMARY?be:A}}if(h(ue)||y(ue)||v(ue))return;const Pe=f(ue)?ue.preferredResource:ue.resource;return!Pe||!Ie||!Ie.filterByScheme?Pe:this.b(Pe,Ie.filterByScheme)}a(ue){return P(ue)||y(ue)?{primary:ue.primary,secondary:ue.secondary}:E(ue)||h(ue)?{primary:ue.modified,secondary:ue.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ue,Ie){if(!ue)return;if(v(ue))return e.EditorResourceAccessor.getCanonicalUri(ue.result,Ie);if(Ie?.supportSideBySide){const{primary:be,secondary:A}=this.a(ue);if(be&&A){if(Ie?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:Ie.filterByScheme}),secondary:this.getCanonicalUri(A,{filterByScheme:Ie.filterByScheme})};if(Ie?.supportSideBySide===W.ANY)return this.getCanonicalUri(be,{filterByScheme:Ie.filterByScheme})??this.getCanonicalUri(A,{filterByScheme:Ie.filterByScheme});ue=Ie.supportSideBySide===W.PRIMARY?be:A}}if(h(ue)||y(ue)||v(ue))return;const Pe=ue.resource;return!Pe||!Ie||!Ie.filterByScheme?Pe:this.b(Pe,Ie.filterByScheme)}b(ue,Ie){if(Array.isArray(Ie)){if(Ie.some(Pe=>ue.scheme===Pe))return ue}else if(Ie===ue.scheme)return ue}}e.EditorResourceAccessor=new U;var q;(function(Q){Q[Q.LEFT=0]="LEFT",Q[Q.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class z{constructor(){this.c=new Map,this.d=new Map}start(ue){const Ie=this.a=ue.get(F.IInstantiationService);for(const[Pe,be]of this.c)this.e(Pe,be,Ie);this.c.clear()}e(ue,Ie,Pe){const be=Pe.createInstance(Ie);this.d.set(ue,be)}registerFileEditorFactory(ue){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ue}getFileEditorFactory(){return(0,k.assertIsDefined)(this.b)}registerEditorSerializer(ue,Ie){if(this.c.has(ue)||this.d.has(ue))throw new Error(`A editor serializer with type ID '${ue}' was already registered.`);return this.a?this.e(ue,Ie,this.a):this.c.set(ue,Ie),(0,N.toDisposable)(()=>{this.c.delete(ue),this.d.delete(ue)})}getEditorSerializer(ue){return this.d.get(typeof ue=="string"?ue:ue.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new z);async function V(Q,ue,Ie){return!Q||!Q.length?[]:await Promise.all(Q.map(async Pe=>{const be=D.URI.revive(Pe.fileUri);if(!be){Ie.info("Cannot resolve the path because it is not valid.",Pe);return}if(!await ue.canHandleResource(be)){Ie.info("Cannot resolve the path because it cannot be handled",Pe);return}let K=Pe.exists,he=Pe.type;if(typeof K!="boolean"||typeof he!="number")try{he=(await ue.stat(be)).isDirectory?S.FileType.Directory:S.FileType.Unknown,K=!0}catch(we){Ie.error(we),K=!1}if(!K&&Pe.openOnlyIfExists){Ie.info("Cannot resolve the path because it does not exist",Pe);return}if(he===S.FileType.Directory){Ie.info("Cannot resolve the path because it is a directory",Pe);return}const De={...Pe.options,pinned:!0};return K?{resource:be,options:De}:{resource:be,options:De,forceUntitled:!0}}))}e.pathsToEditors=V;var ee;(function(Q){Q[Q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Q[Q.SEQUENTIAL=1]="SEQUENTIAL"})(ee||(e.EditorsOrder=ee={}));function Ce(Q){const ue=Q;if(!ue)return!1;const Ie=ue;if(Ie.modified)return Ce(Ie.modified);const Pe=ue;return!!(Pe.contributionsState&&Pe.viewState&&Array.isArray(Pe.cursorState))}e.isTextEditorViewState=Ce;function oe(Q){return(0,O.isErrorWithActions)(Q)}e.isEditorOpenError=oe;function le(Q,ue,Ie){const Pe=(0,O.createErrorWithActions)(Q,ue);return Pe.forceMessage=Ie?.forceMessage,Pe.forceSeverity=Ie?.forceSeverity,Pe.allowDialog=Ie?.allowDialog,Pe}e.createEditorOpenError=le}),define(Re[191],Oe([1,0,5,158,3,6,28,30,18,64,26,87,182]),function(te,e,i,k,D,N,F,R,S,m,O,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,c.registerIcon)("default-view-icon",w.Codicon.window,(0,k.localize)(0,null));var p;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var g;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(g||(e.ViewContainerLocation=g={})),e.ViewContainerLocations=[0,1,2];function d(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=d;class t extends N.Disposable{constructor(){super(...arguments),this.c=this.B(new i.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new i.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.flatten)([...this.g.values()])}registerViewContainer(a,b,I){const f=this.get(a.id);if(f)return f;const P=a;return P.openCommandActionDescriptor=I?.doNotRegisterOpenCommand?void 0:P.openCommandActionDescriptor??{id:P.id},(0,F.getOrSet)(this.g,b,[]).push(P),I?.isDefault&&this.h.push(P),this.c.fire({viewContainer:P,viewContainerLocation:b}),P}deregisterViewContainer(a){for(const b of this.g.keys()){const I=this.g.get(b),f=I?.indexOf(a);if(f!==-1){I?.splice(f,1),I.length===0&&this.g.delete(b),this.f.fire({viewContainer:a,viewContainerLocation:b});return}}}get(a){return this.all.filter(b=>b.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(b=>this.getViewContainers(b).filter(I=>I?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(b=>this.getViewContainerLocation(b)===a)}}R.Registry.add(p.ViewContainersRegistry,new t);var u;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(u||(e.ViewContentGroups=u={}));function h(r,a){const b=r.group??u.More,I=a.group??u.More;return b!==I?b.localeCompare(I):(r.order??5)-(a.order??5)}class y extends N.Disposable{constructor(){super(...arguments),this.c=this.B(new i.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new i.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new i.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new i.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new m.SetMap}registerViews(a,b){this.registerViews2([{views:a,viewContainer:b}])}registerViews2(a){a.forEach(({views:b,viewContainer:I})=>this.l(b,I)),this.c.fire(a)}deregisterViews(a,b){const I=this.m(a,b);I.length&&this.f.fire({views:I,viewContainer:b})}moveViews(a,b){for(const I of this.j.keys())if(I!==b){const f=this.m(a,I);f.length&&(this.l(f,b),this.g.fire({views:f,from:I,to:b}))}}getViews(a){return this.j.get(a)||[]}getView(a){for(const b of this.i){const I=(this.j.get(b)||[]).filter(f=>f.id===a)[0];if(I)return I}return null}getViewContainer(a){for(const b of this.i)if((this.j.get(b)||[]).filter(f=>f.id===a)[0])return b;return null}registerViewWelcomeContent(a,b){return this.k.add(a,b),this.h.fire(a),(0,N.toDisposable)(()=>{this.k.delete(a,b),this.h.fire(a)})}registerViewWelcomeContent2(a,b){const I=new Map;for(const[f,P]of b)this.k.add(a,P),I.set(f,(0,N.toDisposable)(()=>{this.k.delete(a,P),this.h.fire(a)}));return this.h.fire(a),I}getViewWelcomeContent(a){const b=[];return this.k.forEach(a,I=>b.push(I)),b.sort(h)}l(a,b){let I=this.j.get(b);I||(I=[],this.j.set(b,I),this.i.push(b));for(const f of a){if(this.getView(f.id)!==null)throw new Error((0,k.localize)(1,null,f.id));I.push(f)}}m(a,b){const I=this.j.get(b);if(!I)return[];const f=[],P=[];for(const E of I)a.includes(E)?f.push(E):P.push(E);return f.length&&(P.length?this.j.set(b,P):(this.j.delete(b),this.i.splice(this.i.indexOf(b),1))),f}}R.Registry.add(p.ViewsRegistry,new y),e.IViewsService=(0,D.createDecorator)("viewsService"),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var C;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(C||(e.ViewVisibilityState=C={}));var v;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(v||(e.TreeItemCollapsibleState=v={}));class n{constructor(a,b){this.c=!1,this.d=!1,(0,O.mixin)(this,a),this.d=!!b,this.resolve=async I=>{if(b&&!this.c){const f=await b(I);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}I.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n;class l extends Error{constructor(a){super((0,k.localize)(2,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.NoTreeViewError=l}),define(Re[192],Oe([1,0,5,16,159]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class N{constructor(){this.f=new Map,this.k=[],this.m=new i.Emitter,this.n=new i.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(R){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=R}onEvent(R){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=R}onRequest(R){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.s("response",R)}sendRequest(R,S,m,O){const w={command:R};if(S&&Object.keys(S).length>0&&(w.arguments=S),this.s("request",w),typeof O=="number"){const c=setTimeout(()=>{clearTimeout(c);const p=this.f.get(w.seq);if(p){this.f.delete(w.seq);const g={type:"response",seq:0,request_seq:w.seq,success:!1,command:R,message:(0,D.localize)(0,null,O,R)};p(g)}},O)}return m&&this.f.set(w.seq,m),w.seq}acceptMessage(R){this.j?this.j(R):(this.k.push(R),this.k.length===1&&this.q())}o(R,S){return R.type!=="event"||S.type!=="event"}async q(){let R;for(;this.k.length;){if((!R||this.o(this.k[0],R))&&await(0,k.timeout)(0),R=this.k.shift(),!R)return;switch(R.type){case"event":this.i?.(R);break;case"request":this.g?.(R);break;case"response":{const S=R,m=this.f.get(S.request_seq);m&&(this.f.delete(S.request_seq),m(S));break}}}}s(R,S){S.type=R,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((S,m)=>R.set(m,S)),await(0,k.timeout)(500),R.forEach((S,m)=>{S({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.f.delete(m)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=N}),define(Re[193],Oe([1,0,160,31,3]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new k.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new k.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new k.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new k.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new k.RawContextKey("hasDebugged",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new k.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new k.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new k.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new k.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new k.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new k.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new k.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new k.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new k.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new k.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new k.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new k.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new k.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new k.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new k.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new k.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new k.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new k.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new k.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new k.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new k.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new k.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new k.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new k.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new k.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new k.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new k.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new k.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new k.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new k.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new k.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new k.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new k.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new k.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new k.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new k.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new k.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new k.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new k.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new k.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new k.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new k.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new k.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new k.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new k.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new k.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(50,null)});const N=c=>i.localize(51,null,c);e.debuggerDisabledMessage=N,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(52,null)};var F;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(F||(e.State=F={}));function R(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=R;var S;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var m;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var O;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(O||(e.DebuggerString=O={})),e.IDebugService=(0,D.createDecorator)("debugService");var w;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE"})(w||(e.BreakpointWidgetContext=w={}))}),define(Re[194],Oe([1,0,13,2,19,26,15,44,22,18]),function(te,e,i,k,D,N,F,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function w(f,P,E){return f.replace(O,function(o,s){return P&&s.length>0&&s[0]!=="_"?o:E&&E.hasOwnProperty(s)?E[s]:o})}e.formatPII=w;function c(f){const P={};for(const E of Object.keys(f))E.startsWith("!")||(P[E]=f[E]);return P}e.filterExceptionsFromTelemetry=c;function p(f){return f.configuration.request==="attach"&&!g(f)&&(!f.parentSession||p(f.parentSession))}e.isSessionAttach=p;function g(f){let P=f.configuration.type;if(P)return P==="vslsShare"&&(P=f.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(P,"extensionhost")||(0,i.equalsIgnoreCase)(P,"pwa-extensionhost")?f:f.parentSession?g(f.parentSession):void 0}e.getExtensionHostDebugSession=g;function d(f){return f.type&&(f.label||f.program||f.runtime)}e.isDebuggerMainContribution=d;function t(f,P,E){let o,s=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let B=null;for(;B=M.exec(f);){const X=B.index+1,G=X+B[0].length;if(X<=P&&G>=E){o=B[0],s=X;break}}if(o){const X=/\w+/g;let G=null;for(;(G=X.exec(o))&&!(G.index+1+s+G[0].length>=E););G&&(o=o.substring(0,X.lastIndex))}return o?{start:s,end:s+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function u(f,P,E,o){if(f.evaluatableExpressionProvider.has(P)){const s=f.evaluatableExpressionProvider.ordered(P),M=(0,m.coalesce)(await Promise.all(s.map(async B=>{try{return await B.provideEvaluatableExpression(P,E,o??S.CancellationToken.None)}catch{return}})));if(M.length>0){let B=M[0].expression;const X=M[0].range;return B||(B=P.getLineContent(E.lineNumber).substring(X.startColumn-1,X.endColumn-1)),{range:X,matchingExpression:B}}}else{const s=P.getLineContent(E.lineNumber),{start:M,end:B}=t(s,E.column,E.column),X=s.substring(M-1,B);return{matchingExpression:X,range:new R.Range(E.lineNumber,M,E.lineNumber,M+X.length)}}return null}e.getEvaluatableExpressionAtPosition=u;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function y(f){return!!(f&&f.match(h))}e.isUri=y;function C(f){if(typeof f.path=="string"&&!(typeof f.sourceReference=="number"&&f.sourceReference>0)){if(y(f.path))return k.URI.parse(f.path);if((0,D.isAbsolute)(f.path))return k.URI.file(f.path)}return f.path}function v(f){if(typeof f.path=="object"){const P=k.URI.revive(f.path);if(P)return P.scheme===F.Schemas.file?P.fsPath:P.toString()}return f.path}function n(f,P){const E=P?C:v,o=(0,N.deepClone)(f);return r(o,(s,M)=>{s&&M&&(M.path=E(M))}),o}e.convertToDAPaths=n;function l(f,P){const E=P?C:v,o=(0,N.deepClone)(f);return r(o,(s,M)=>{!s&&M&&(M.path=E(M))}),o}e.convertToVSCPaths=l;function r(f,P){switch(f.type){case"event":{const E=f;switch(E.event){case"output":P(!1,E.body.source);break;case"loadedSource":P(!1,E.body.source);break;case"breakpoint":P(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=f;switch(E.command){case"setBreakpoints":P(!0,E.arguments.source);break;case"breakpointLocations":P(!0,E.arguments.source);break;case"source":P(!0,E.arguments.source);break;case"gotoTargets":P(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(o=>P(!1,o));break;default:break}break}case"response":{const E=f;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(o=>P(!1,o.source));break;case"loadedSources":E.body.sources.forEach(o=>P(!1,o));break;case"scopes":E.body.scopes.forEach(o=>P(!1,o.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(o=>P(!1,o.source));break;case"setBreakpoints":E.body.breakpoints.forEach(o=>P(!1,o.source));break;case"disassemble":E.body?.instructions.forEach(s=>P(!1,s.location));break;default:break}break}}}function a(f){return f.filter(P=>!P.presentation?.hidden).sort((P,E)=>P.presentation?E.presentation?P.presentation.group?E.presentation.group?P.presentation.group!==E.presentation.group?P.presentation.group.localeCompare(E.presentation.group):b(P.presentation.order,E.presentation.order):-1:E.presentation.group?1:b(P.presentation.order,E.presentation.order):-1:E.presentation?1:0)}e.getVisibleAndSorted=a;function b(f,P){return typeof f!="number"?typeof P!="number"?0:1:typeof P!="number"?-1:f-P}async function I(f,P){const E=f.getValue("debug.saveBeforeStart",{overrideIdentifier:P.activeTextEditorLanguageId});if(E!=="none"&&(await P.saveAll(),E==="allEditorsInActiveGroup")){const o=P.activeEditorPane;o&&o.input.resource?.scheme===F.Schemas.untitled&&await P.save({editor:o.input,groupId:o.group.id})}await f.reloadConfiguration()}e.saveAllBeforeDebugStart=I}),define(Re[74],Oe([1,0,24,37,88,67,15,19,21,31]),function(te,e,i,k,D,N,F,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(O||(e.CellKind=O={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",N.Mimes.latex,N.Mimes.markdown,"image/png","image/jpeg",N.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[N.Mimes.latex,N.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(w||(e.NotebookRunState=w={}));var c;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(c||(e.NotebookCellExecutionState=c={}));var p;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var g;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(g||(e.NotebookRendererMatch=g={}));var d;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(d||(e.RendererMessagingSpec=d={}));var t;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var u;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(u||(e.SelectionStateType=u={}));var h;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(h||(e.CellEditType=h={}));var y;(function(z){z.scheme=F.Schemas.vscodeNotebookCell;const V=["W","X","Y","Z","a","b","c","d","e","f"],ee=new RegExp(`^[${V.join("")}]+`),Ce=7;function oe(be,A){const K=A.toString(Ce),De=`${K.length<V.length?V[K.length-1]:"z"}${K}s${(0,i.encodeBase64)(i.VSBuffer.fromString(be.scheme),!0,!0)}`;return be.with({scheme:z.scheme,fragment:De})}z.generate=oe;function le(be){if(be.scheme!==z.scheme)return;const A=be.fragment.indexOf("s");if(A<0)return;const K=parseInt(be.fragment.substring(0,A).replace(ee,""),Ce),he=(0,i.decodeBase64)(be.fragment.substring(A+1)).toString();if(!isNaN(K))return{handle:K,notebook:be.with({scheme:he,fragment:null})}}z.parse=le;function Q(be,A){return be.with({scheme:F.Schemas.vscodeNotebookCellOutput,fragment:`op${A??""},${be.scheme!==F.Schemas.file?be.scheme:""}`})}z.generateCellOutputUri=Q;function ue(be){if(be.scheme!==F.Schemas.vscodeNotebookCellOutput)return;const A=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(be.fragment);if(!A)return;const K=A[1]&&A[1]!==""?A[1]:void 0,he=A[2];return{outputId:K,notebook:be.with({scheme:he||F.Schemas.file,fragment:null})}}z.parseCellOutputUri=ue;function Ie(be,A,K){return z.generate(be,A).with({scheme:K})}z.generateCellPropertyUri=Ie;function Pe(be,A){if(be.scheme===A)return z.parse(be.with({scheme:z.scheme}))}z.parseCellPropertyUri=Pe})(y||(e.CellUri=y={}));const C=z=>S.isWindows?z.replace(/\//g,"\\"):z;class v{constructor(V=[],ee=e.NOTEBOOK_DISPLAY_ORDER){this.e=ee,this.d=[...new Set(V)].map(Ce=>({pattern:Ce,matches:k.parse(C(Ce))}))}sort(V){const ee=new Map(D.Iterable.map(V,oe=>[oe,C(oe)]));let Ce=[];for(const{matches:oe}of this.d)for(const[le,Q]of ee)if(oe(Q)){Ce.push(le),ee.delete(le);break}return ee.size&&(Ce=Ce.concat([...ee.keys()].sort((oe,le)=>this.e.indexOf(oe)-this.e.indexOf(le)))),Ce}prioritize(V,ee){const Ce=this.f(V);if(Ce===-1){this.d.unshift({pattern:V,matches:k.parse(C(V))});return}const oe=new Set(ee.map(Q=>this.f(Q,Ce)));oe.delete(-1);const le=Array.from(oe).sort();this.d.splice(Ce+1,0,...le.map(Q=>this.d[Q]));for(let Q=le.length-1;Q>=0;Q--)this.d.splice(le[Q],1)}toArray(){return this.d.map(V=>V.pattern)}f(V,ee=this.d.length){const Ce=C(V);for(let oe=0;oe<ee;oe++)if(this.d[oe].matches(Ce))return oe;return-1}}e.MimeTypeDisplayOrder=v;function n(z,V,ee,Ce=(oe,le)=>oe===le){const oe=[];function le(Ie,Pe,be){if(Pe===0&&be.length===0)return;const A=oe[oe.length-1];A&&A.start+A.deleteCount===Ie?(A.deleteCount+=Pe,A.toInsert.push(...be)):oe.push({start:Ie,deleteCount:Pe,toInsert:be})}let Q=0,ue=0;for(;;){if(Q===z.length){le(Q,0,V.slice(ue));break}if(ue===V.length){le(Q,z.length-Q,[]);break}const Ie=z[Q],Pe=V[ue];if(Ce(Ie,Pe)){Q+=1,ue+=1;continue}ee(Pe)?(le(Q,1,[]),Q+=1):(le(Q,0,[Pe]),ue+=1)}return oe}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtBoundary","none");var l;(function(z){z.default="default",z.option="option"})(l||(e.NotebookEditorPriority=l={}));function r(z){const V=z;return!!((typeof V.include=="string"||k.isRelativePattern(V.include))&&(typeof V.exclude=="string"||k.isRelativePattern(V.exclude)))}e.isDocumentExcludePattern=r;function a(z,V,ee){if(Array.isArray(z.viewType)&&z.viewType.indexOf(V)>=0||z.viewType===V)return!0;if(z.filenamePattern){const Ce=r(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,oe=r(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(k.match(Ce,(0,R.basename)(ee.fsPath).toLowerCase()))return!(oe&&k.match(oe,(0,R.basename)(ee.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var b;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(b||(e.CellStatusbarAlignment=b={}));class I{static create(V){return`${I.d}${V}`}static parse(V){if(V.startsWith(I.d))return V.substring(I.d.length)}}e.NotebookWorkingCopyTypeIdentifier=I,I.d="notebook/";function f(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.isTextStreamMime=f;const P=new TextDecoder;function E(z){const V=[];let ee=!1;for(const Ce of z)(V.length===0||ee)&&(V.push(Ce),ee=!0);return B(V),q(i.VSBuffer.concat(V.map(Ce=>i.VSBuffer.wrap(Ce))))}e.compressOutputItemStreams=E;const o=`${String.fromCharCode(27)}[A`,s=o.split("").map(z=>z.charCodeAt(0)),M=10;function B(z){z.forEach((V,ee)=>{if(ee===0||V.length<o.length)return;const Ce=z[ee-1],oe=V.subarray(0,o.length);if(oe[0]===s[0]&&oe[1]===s[1]&&oe[2]===s[2]){const le=Ce.lastIndexOf(M);if(le===-1)return;z[ee-1]=Ce.subarray(0,le),z[ee]=V.subarray(o.length)}})}function X(z){let V=z;do z=V,V=z.replace(/[^\n]\x08/gm,"");while(V.length<z.length);return z}function G(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const V=z.match(/^(.*)\r+/m)[1];let ee=z.match(/\r+(.*)$/m)[1];ee=ee+V.slice(ee.length,V.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return z}const W="\b".charCodeAt(0),U="\r".charCodeAt(0);function q(z){return!z.buffer.includes(W)&&!z.buffer.includes(U)?z:i.VSBuffer.fromString(G(X(P.decode(z.buffer))))}}),define(Re[195],Oe([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var k;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(k||(e.CellExecutionUpdateType=k={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(Re[45],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(N){N.Delimiter="\0"})(i||(e.TestIdPathParts=i={}));var k;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(k||(e.TestPosition=k={}));class D{static fromExtHostTestItem(F,R,S=F.parent){if(F._isRoot)return new D([R]);const m=[F.id];for(let O=S;O&&O.id!==R;O=O.parent)m.push(O.id);return m.push(R),new D(m.reverse())}static isRoot(F){return!F.includes("\0")}static root(F){const R=F.indexOf("\0");return R===-1?F:F.slice(0,R)}static fromString(F){return new D(F.split("\0"))}static join(F,R){return new D([...F.path,R])}static joinToString(F,R){return F.toString()+"\0"+R}static parentId(F){const R=F.lastIndexOf("\0");return R===-1?void 0:F.slice(0,R)}static localId(F){const R=F.lastIndexOf("\0");return R===-1?F:F.slice(R+1)}static isChild(F,R){return R.startsWith(F)&&R[F.length]==="\0"}static compare(F,R){return F===R?0:D.isChild(F,R)?2:D.isChild(R,F)?3:1}constructor(F,R=F.length){if(this.path=F,this.d=R,F.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new D(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let F=1;F<=this.d;F++)yield new D(this.path,F)}*idsToRoot(){for(let F=this.d;F>0;F--)yield new D(this.path,F)}compare(F){if(typeof F=="string")return D.compare(this.toString(),F);for(let R=0;R<F.d&&R<this.d;R++)if(F.path[R]!==this.path[R])return 1;return F.d>this.d?2:F.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let F=1;F<this.d;F++)this.c+="\0",this.c+=this.path[F]}return this.c}}e.TestId=D}),define(Re[56],Oe([1,0,2,44,45]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var N;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(N||(e.TestResultState=N={}));var F;(function(P){P[P.Run=1]="Run",P[P.Debug=2]="Debug",P[P.Coverage=3]="Coverage"})(F||(e.ExtTestRunProfileKind=F={}));var R;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable",P[P.SupportsContinuousRun=64]="SupportsContinuousRun"})(R||(e.TestRunProfileBitset=R={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const S=P=>"runId"in P;e.isStartControllerTests=S;var m;(function(P){P.serialize=E=>({range:E.range.toJSON(),uri:E.uri.toJSON()}),P.deserialize=E=>({range:k.Range.lift(E.range),uri:i.URI.revive(E.uri)})})(m||(e.IRichLocation=m={}));var O;(function(P){P[P.Error=0]="Error",P[P.Output=1]="Output"})(O||(e.TestMessageType=O={}));var w;(function(P){P.serialize=E=>({message:E.message,type:0,expected:E.expected,actual:E.actual,location:E.location&&m.serialize(E.location)}),P.deserialize=E=>({message:E.message,type:0,expected:E.expected,actual:E.actual,location:E.location&&m.deserialize(E.location)})})(w||(e.ITestErrorMessage=w={}));const c=(P,E)=>`${E?"s":"e"}${P}`;e.getMarkId=c;var p;(function(P){P.serialize=E=>({message:E.message,type:1,offset:E.offset,length:E.length,location:E.location&&m.serialize(E.location)}),P.deserialize=E=>({message:E.message,type:1,offset:E.offset,length:E.length,location:E.location&&m.deserialize(E.location)})})(p||(e.ITestOutputMessage=p={}));var g;(function(P){P.serialize=E=>E.type===0?w.serialize(E):p.serialize(E),P.deserialize=E=>E.type===0?w.deserialize(E):p.deserialize(E)})(g||(e.ITestMessage=g={}));var d;(function(P){P.serializeWithoutMessages=E=>({state:E.state,duration:E.duration,messages:[]}),P.serialize=E=>({state:E.state,duration:E.duration,messages:E.messages.map(g.serialize)}),P.deserialize=E=>({state:E.state,duration:E.duration,messages:E.messages.map(g.deserialize)})})(d||(e.ITestTaskState=d={}));const t="\0",u=(P,E)=>P+t+E;e.namespaceTestTag=u;const h=P=>{const E=P.indexOf(t);return{ctrlId:P.slice(0,E),tagId:P.slice(E+1)}};e.denamespaceTestTag=h;var y;(function(P){P.serialize=E=>({extId:E.extId,label:E.label,tags:E.tags,busy:E.busy,children:void 0,uri:E.uri?.toJSON(),range:E.range?.toJSON()||null,description:E.description,error:E.error,sortText:E.sortText}),P.deserialize=E=>({extId:E.extId,label:E.label,tags:E.tags,busy:E.busy,children:void 0,uri:E.uri?i.URI.revive(E.uri):void 0,range:E.range?k.Range.lift(E.range):null,description:E.description,error:E.error,sortText:E.sortText})})(y||(e.ITestItem=y={}));var C;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(C||(e.TestItemExpandState=C={}));var v;(function(P){P.serialize=E=>({expand:E.expand,item:y.serialize(E.item)}),P.deserialize=E=>({controllerId:D.TestId.root(E.item.extId),expand:E.expand,item:y.deserialize(E.item)})})(v||(e.InternalTestItem=v={}));var n;(function(P){P.serialize=E=>{let o;return E.item&&(o={},E.item.label!==void 0&&(o.label=E.item.label),E.item.tags!==void 0&&(o.tags=E.item.tags),E.item.busy!==void 0&&(o.busy=E.item.busy),E.item.uri!==void 0&&(o.uri=E.item.uri?.toJSON()),E.item.range!==void 0&&(o.range=E.item.range?.toJSON()),E.item.description!==void 0&&(o.description=E.item.description),E.item.error!==void 0&&(o.error=E.item.error),E.item.sortText!==void 0&&(o.sortText=E.item.sortText)),{extId:E.extId,expand:E.expand,item:o}},P.deserialize=E=>{let o;return E.item&&(o={},E.item.label!==void 0&&(o.label=E.item.label),E.item.tags!==void 0&&(o.tags=E.item.tags),E.item.busy!==void 0&&(o.busy=E.item.busy),E.item.range!==void 0&&(o.range=E.item.range?k.Range.lift(E.item.range):null),E.item.description!==void 0&&(o.description=E.item.description),E.item.error!==void 0&&(o.error=E.item.error),E.item.sortText!==void 0&&(o.sortText=E.item.sortText)),{extId:E.extId,expand:E.expand,item:o}}})(n||(e.ITestItemUpdate=n={}));const l=(P,E)=>{E.expand!==void 0&&(P.expand=E.expand),E.item!==void 0&&(P.item=P.item?Object.assign(P.item,E.item):E.item)};e.applyTestItemUpdate=l;var r;(function(P){P.serializeWithoutMessages=E=>({...v.serialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(d.serializeWithoutMessages)}),P.serialize=E=>({...v.serialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(d.serialize)}),P.deserialize=E=>({...v.deserialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(d.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var a;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(a||(e.DetailType=a={}));var b;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.DocumentSynced=2]="DocumentSynced",P[P.Remove=3]="Remove",P[P.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",P[P.Retire=5]="Retire",P[P.AddTag=6]="AddTag",P[P.RemoveTag=7]="RemoveTag"})(b||(e.TestDiffOpType=b={}));var I;(function(P){P.deserialize=E=>E.op===0?{op:E.op,item:v.deserialize(E.item)}:E.op===1?{op:E.op,item:n.deserialize(E.item)}:E.op===2?{op:E.op,uri:i.URI.revive(E.uri),docv:E.docv}:E,P.serialize=E=>E.op===0?{op:E.op,item:v.serialize(E.item)}:E.op===1?{op:E.op,item:n.serialize(E.item)}:E})(I||(e.TestsDiffOp=I={}));class f{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(E){const o=this.o();for(const s of E)switch(s.op){case 0:this.j(v.deserialize(s.item),o);break;case 1:this.k(n.deserialize(s.item),o);break;case 3:this.l(s.itemId,o);break;case 5:this.m(s.itemId);break;case 4:this.updatePendingRoots(s.amount);break;case 6:this.c.set(s.tag.id,s.tag);break;case 7:this.c.delete(s.id);break}o.complete?.()}j(E,o){const s=D.TestId.parentId(E.item.extId)?.toString();let M;if(!s)M=this.p(E),this.f.add(M),this.d.set(E.item.extId,M);else if(this.d.has(s)){const B=this.d.get(s);B.children.add(E.item.extId),M=this.p(E,B),this.d.set(E.item.extId,M)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(E)}`);return}return o.add?.(M),E.expand===2&&this.g++,M}k(E,o){const s=this.d.get(E.extId);if(s)return E.expand!==void 0&&(s.expand===2&&this.g--,E.expand===2&&this.g++),(0,e.applyTestItemUpdate)(s,E),o.update?.(s),s}l(E,o){const s=this.d.get(E);if(!s)return;const M=D.TestId.parentId(s.item.extId)?.toString();M?this.d.get(M).children.delete(s.item.extId):this.f.delete(s);const B=[[E]];for(;B.length;)for(const X of B.pop()){const G=this.d.get(X);G&&(B.push(G.children),this.d.delete(X),o.remove?.(G,G!==s),G.expand===2&&this.g--)}}m(E){}updatePendingRoots(E){this.h+=E}o(){return{}}}e.AbstractIncrementalTestCollection=f}),define(Re[75],Oe([1,0,16,5,6,49,56,45]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(S||(e.TestItemEventOp=S={}));const m=(h,y)=>h===y,w=Object.entries({range:(h,y)=>h===y?!0:!h||!y?!1:h.equalsRange(y),busy:m,label:m,description:m,error:m,sortText:m,tags:(h,y)=>!(h.length!==y.length||h.some(C=>!y.includes(C)))}),c=(h,y)=>{let C;for(const[v,n]of w)n(h[v],y[v])||(C?C[v]=y[v]:C={[v]:y[v]});return C};class p extends D.Disposable{get root(){return this.m.root}constructor(y){super(),this.m=y,this.f=this.B(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new k.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(y){this.h=y;for(const C of this.tree.values())this.G(C)}get resolveHandler(){return this.h}collectDiff(){const y=this.k;return this.k=[],y}pushDiff(y){switch(y.op){case 2:{for(const C of this.k)if(C.op===2&&C.uri===y.uri){C.docv=y.docv;return}break}case 1:{const C=this.k[this.k.length-1];if(C){if(C.op===1&&C.item.extId===y.item.extId){(0,F.applyTestItemUpdate)(C.item,y.item);return}if(C.op===0&&C.item.item.extId===y.item.extId){(0,F.applyTestItemUpdate)(C.item,y.item);return}}break}}this.k.push(y),this.f.isScheduled()||this.f.schedule()}expand(y,C){const v=this.tree.get(y);if(v){if((v.expandLevels===void 0||C>v.expandLevels)&&(v.expandLevels=C),v.expand===1){const n=this.I(v);return n.isOpen()?this.H(v,C-1):n.wait().then(()=>this.H(v,C-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.H(v,C-1)):this.H(v,C-1)}}dispose(){for(const y of this.tree.values())this.m.getApiFor(y.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(y,C){switch(C.op){case 3:this.L(R.TestId.joinToString(y.fullId,C.id));break;case 0:this.u(C.item,y);break;case 5:for(const v of C.ops)this.p(y,v);break;case 1:this.w(C.new,C.old,y.fullId.toString());break;case 2:this.G(y);break;case 4:this.pushDiff({op:1,item:{extId:y.fullId.toString(),item:C.update}});break;case 6:this.s(y.actual.uri);break;default:(0,N.assertNever)(C)}}s(y){y&&this.pushDiff({op:2,uri:y,docv:this.m.getDocumentVersion(y)})}u(y,C){const v=R.TestId.fromExtHostTestItem(y,this.root.id,C?.actual),n=this.m.getApiFor(y);n.parent&&n.parent!==C?.actual&&this.m.getChildren(n.parent).delete(y.id);let l=this.tree.get(v.toString());if(!l){l={fullId:v,actual:y,expandLevels:C?.expandLevels?C.expandLevels-1:void 0,expand:0},y.tags.forEach(this.y,this),this.tree.set(l.fullId.toString(),l),this.C(y,C),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:l.expand,item:this.m.toITestItem(y)}}),this.F(y,l,C);return}if(l.actual===y){this.D(y,l,C);return}if(l.actual.uri?.toString()!==y.uri?.toString())return this.L(v.toString()),this.u(y,C);const r=this.m.getChildren(l.actual),a=l.actual,b=c(this.m.toITestItem(a),this.m.toITestItem(y));this.m.getApiFor(a).listener=void 0,l.actual=y,l.expand=0,b&&(b.hasOwnProperty("tags")&&(this.w(y.tags,a.tags,v.toString()),delete b.tags),this.p(l,{op:4,update:b})),this.F(y,l,C);for(const[I,f]of r)this.m.getChildren(y).get(f.id)||this.L(R.TestId.joinToString(v,f.id));this.s(l.actual.uri)}w(y,C,v){const n=new Set(C.map(l=>l.id));for(const l of y)n.delete(l.id)||this.y(l);this.pushDiff({op:1,item:{extId:v,item:{tags:y.map(l=>(0,F.namespaceTestTag)(this.m.controllerId,l.id))}}}),n.forEach(this.z,this)}y(y){const C=this.j.get(y.id);C?C.refCount++:(this.j.set(y.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,F.namespaceTestTag)(this.m.controllerId,y.id)}}))}z(y){const C=this.j.get(y);C&&!--C.refCount&&(this.j.delete(y),this.pushDiff({op:7,id:(0,F.namespaceTestTag)(this.m.controllerId,y)}))}C(y,C){this.m.getApiFor(y).parent=C&&C.actual!==this.root?C.actual:void 0}D(y,C,v){this.C(y,v);const n=this.m.getApiFor(y);n.parent=v?.actual,n.listener=l=>this.p(C,l),this.G(C)}F(y,C,v){this.D(y,C,v);for(const[n,l]of this.m.getChildren(y))this.u(l,C)}G(y){let C;this.h?y.resolveBarrier?C=y.resolveBarrier.isOpen()?3:2:C=y.actual.canResolveChildren?1:0:C=0,C!==y.expand&&(y.expand=C,this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:C}}),C===1&&y.expandLevels!==void 0&&this.I(y))}H(y,C){if(C<0)return;const v=[];for(const[n,l]of this.m.getChildren(y.actual)){const r=this.expand(R.TestId.joinToString(y.fullId,l.id),C);(0,i.isThenable)(r)&&v.push(r)}if(v.length)return Promise.all(v).then(()=>{})}I(y){if(y.resolveBarrier)return y.resolveBarrier;if(!this.h){const l=new i.Barrier;return l.open(),l}y.expand=2,this.J(y);const C=y.resolveBarrier=new i.Barrier,v=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,l)};let n;try{n=this.h(y.actual===this.root?void 0:y.actual)}catch(l){v(l)}return(0,i.isThenable)(n)?n.catch(v).then(()=>{C.open(),this.G(y)}):(C.open(),this.G(y)),y.resolveBarrier}J(y){this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:y.expand}})}L(y){const C=this.tree.get(y);if(!C)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:y});const v=[C];for(;v.length;){const n=v.pop();if(n){this.m.getApiFor(n.actual).listener=void 0;for(const l of n.actual.tags)this.z(l.id);this.tree.delete(n.fullId.toString());for(const[l,r]of this.m.getChildren(n.actual))v.push(this.tree.get(R.TestId.joinToString(n.fullId,r.id)))}}}flushDiff(){const y=this.collectDiff();y.length&&this.g.fire(y)}}e.TestItemCollection=p;class g extends Error{constructor(y){super(`Attempted to insert a duplicate test item ID ${y}`)}}e.DuplicateTestItemError=g;class d extends Error{constructor(y){super(`TestItem with ID "${y}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class t extends Error{constructor(y,C,v){super(`TestItem with ID "${y}" is from controller "${C}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=t;const u=(h,y,C)=>{let v=new Map;return{get size(){return v.size},forEach(n,l){for(const r of v.values())n.call(l,r,this)},[Symbol.iterator](){return v.entries()},replace(n){const l=new Map,r=new Set(v.keys()),a={op:5,ops:[]};for(const b of n){if(!(b instanceof C))throw new d(b.id);const I=y(b).controllerId;if(I!==h.controllerId)throw new t(b.id,I,h.controllerId);if(l.has(b.id))throw new g(b.id);l.set(b.id,b),r.delete(b.id),a.ops.push({op:0,item:b})}for(const b of r.keys())a.ops.push({op:3,id:b});h.listener?.(a),v=l},add(n){if(!(n instanceof C))throw new d(n.id);v.set(n.id,n),h.listener?.({op:0,item:n})},delete(n){v.delete(n)&&h.listener?.({op:3,id:n})},get(n){return v.get(n)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=u}),define(Re[100],Oe([1,0,75]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const k=new WeakMap,D=(F,R)=>{const S={controllerId:R};return k.set(F,S),S};e.createPrivateApiFor=D;const N=F=>{const R=k.get(F);if(!R)throw new i.InvalidTestItemError(F?.id||"<unknown>");return R};e.getPrivateApiFor=N}),define(Re[76],Oe([1,0,15,2]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(R,S){return R.scheme===i.Schemas.http||R.scheme===i.Schemas.https?R:(S&&S.authority&&S.isRemote&&R.scheme===i.Schemas.file&&(R=k.URI.from({scheme:i.Schemas.vscodeRemote,authority:S.authority,path:R.path})),k.URI.from({scheme:i.Schemas.https,authority:`${R.scheme}+${N(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=D;function N(R){return R.replace(/./g,S=>{const m=S.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?S:"-"+m.toString(16).padStart(4,"0")})}function F(R){return R.replace(/-([0-9a-f]{4})/g,(S,m)=>String.fromCharCode(parseInt(m,16)))}e.decodeAuthority=F}),define(Re[196],Oe([1,0,5,6,76]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class N{constructor(R,S,m){this.d=R,this.e=S,this.f=m,this.a=0,this.b=new k.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const O=S.getVisibleTextEditors();for(const w of this.c.values())O.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,S,m,O,w){let c;for(const y of this.e.getVisibleTextEditors(!0))if(y.value===R){c=y;break}if(!c)throw new Error("not a visible editor");const p=this,g=this.a++,d=new i.Emitter,t=new i.Emitter,u=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(y){return(0,D.asWebviewUri)(y,p.f)}get cspSource(){return D.webviewGenericCspSource}set options(y){this.b=y,p.d.$setOptions(g,y)}get options(){return this.b}set html(y){this.a=y,p.d.$setHtml(g,y)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(y){return p.d.$postMessage(g,y)}},h=new class{constructor(){this.editor=R,this.line=S,this.height=m,this.webview=u,this.onDidDispose=t.event}dispose(){p.c.has(g)&&(p.c.delete(g),p.d.$disposeEditorInset(g),t.fire(),t.dispose(),d.dispose())}};return this.d.$createEditorInset(g,c.id,c.value.document.uri,S+1,m,O||{},w.identifier,w.extensionLocation),this.c.set(g,{editor:R,inset:h,onDidReceiveMessage:d}),h}$onDidDispose(R){const S=this.c.get(R);S&&S.inset.dispose()}$onDidReceiveMessage(R,S){this.c.get(R)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=N}),define(Re[197],Oe([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var k;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator"})(k||(e.VariableKind=k={}));class D extends Error{constructor(F,R){super(R),this.variable=F}}e.VariableError=D}),define(Re[198],Oe([1,0,19,51,9,26,21,90,163,197,13]),function(te,e,i,k,D,N,F,R,S,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(p,g,d,t){this.h=new Map,this.a=p,this.b=g,this.g=d,t&&(this.c=t.then(u=>this.i(u)))}i(p){if(F.isWindows){const g=Object.create(null);return Object.keys(p).forEach(d=>{g[d.toLowerCase()]=p[d]}),g}return p}resolveWithEnvironment(p,g,d){return this.l({env:this.i(p),userHome:void 0},g?g.uri:void 0,d)}async resolveAsync(p,g){const d={env:await this.c,userHome:await this.g};return this.l(d,p?p.uri:void 0,g)}async j(p,g,d,t){const u=N.deepClone(g);F.isWindows&&u.windows?Object.keys(u.windows).forEach(y=>u[y]=u.windows[y]):F.isMacintosh&&u.osx?Object.keys(u.osx).forEach(y=>u[y]=u.osx[y]):F.isLinux&&u.linux&&Object.keys(u.linux).forEach(y=>u[y]=u.linux[y]),delete u.windows,delete u.osx,delete u.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,p?p.uri:void 0,u,d,t)}async resolveAnyAsync(p,g,d){return this.j(p,g,d)}async resolveAnyMap(p,g,d){const t=new Map;return{newConfig:await this.j(p,g,d,t),resolvedVariables:t}}resolveWithInteractionReplace(p,g,d,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,g,d,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,g){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,g)}async l(p,g,d,t,u){if(D.isString(d))return this.m(p,g,d,t,u);if(Array.isArray(d))return Promise.all(d.map(h=>this.l(p,g,h,t,u)));if(D.isObject(d)){const h=Object.create(null),y=await Promise.all(Object.keys(d).map(async C=>[await this.m(p,g,C,t,u),await this.l(p,g,d[C],t,u)]));for(const[C,v]of y)h[C]=v;return h}return d}m(p,g,d,t,u){return(0,O.replaceAsync)(d,w.VARIABLE_REGEXP,async(h,y)=>{if(y.includes(w.VARIABLE_LHS))return h;let C=await this.o(p,h,y,g,t);return u?.set(y,C),C!==h&&D.isString(C)&&C.match(w.VARIABLE_REGEXP)&&(C=await this.m(p,g,C,t,u)),C})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,g,d,t,u){let h;const y=d.split(":");y.length>1&&(d=y[0],h=y[1]);const C=l=>{const r=this.a.getFilePath();if(r)return(0,R.normalizeDriveLetter)(r);throw new m.VariableError(l,(0,S.localize)(0,null,g))},v=l=>{const r=C(l);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,R.normalizeDriveLetter)(a)}throw new m.VariableError(l,(0,S.localize)(1,null,g,i.basename(r)))},n=l=>{if(h){const r=this.a.getFolderUri(h);if(r)return r;throw new m.VariableError(l,(0,S.localize)(2,null,g,h))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new m.VariableError(l,(0,S.localize)(3,null,g)):new m.VariableError(l,(0,S.localize)(4,null,g))};switch(d){case"env":if(h){if(p.env){const l=p.env[F.isWindows?h.toLowerCase():h];if(D.isString(l))return l}return""}throw new m.VariableError(m.VariableKind.Env,(0,S.localize)(5,null,g));case"config":if(h){const l=this.a.getConfigurationValue(t,h);if(D.isUndefinedOrNull(l))throw new m.VariableError(m.VariableKind.Config,(0,S.localize)(6,null,g,h));if(D.isObject(l))throw new m.VariableError(m.VariableKind.Config,(0,S.localize)(7,null,g,h));return l}throw new m.VariableError(m.VariableKind.Config,(0,S.localize)(8,null,g));case"command":return this.p(m.VariableKind.Command,g,h,u,"command");case"input":return this.p(m.VariableKind.Input,g,h,u,"input");case"extensionInstallFolder":if(h){const l=await this.a.getExtension(h);if(!l)throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,g,h));return this.n(l.extensionLocation)}throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,g));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.n(n(m.VariableKind.WorkspaceFolder)));case"cwd":return t||h?(0,R.normalizeDriveLetter)(this.n(n(m.VariableKind.Cwd))):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(i.basename(this.n(n(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new m.VariableError(m.VariableKind.UserHome,(0,S.localize)(11,null,g))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new m.VariableError(m.VariableKind.LineNumber,(0,S.localize)(12,null,g))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new m.VariableError(m.VariableKind.SelectedText,(0,S.localize)(13,null,g))}case"file":return C(m.VariableKind.File);case"fileWorkspaceFolder":return v(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||h?i.relative(this.n(n(m.VariableKind.RelativeFile)),C(m.VariableKind.RelativeFile)):C(m.VariableKind.RelativeFile);case"relativeFileDirname":{const l=i.dirname(C(m.VariableKind.RelativeFileDirname));if(t||h){const r=i.relative(this.n(n(m.VariableKind.RelativeFileDirname)),l);return r.length===0?".":r}return l}case"fileDirname":return i.dirname(C(m.VariableKind.FileDirname));case"fileExtname":return i.extname(C(m.VariableKind.FileExtname));case"fileBasename":return i.basename(C(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=i.basename(C(m.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-i.extname(l).length)}case"fileDirnameBasename":return i.basename(i.dirname(C(m.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||g}case"execInstallFolder":{const l=this.a.getAppRoot();return l||g}case"pathSeparator":return i.sep;default:try{const l=h?`${d}:${h}`:d;return this.p(m.VariableKind.Unknown,g,l,u,void 0)}catch{return g}}}}p(p,g,d,t,u){if(d&&t){const h=u===void 0?t[d]:t[u+":"+d];if(typeof h=="string")return h;throw new m.VariableError(p,(0,S.localize)(14,null,g))}return g}}e.AbstractVariableResolverService=w,w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Re[101],Oe([1,0,3,99]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var D;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(D||(e.GroupDirection=D={}));var N;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var F;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(F||(e.GroupLocation=F={}));var R;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(R||(e.GroupsArrangement=R={}));var S;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(S||(e.MergeGroupMode=S={}));function m(g){const d=g;return(0,k.isEditorInput)(d?.editor)&&(0,k.isEditorInput)(d?.replacement)}e.isEditorReplacement=m;var O;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O||(e.GroupsOrder=O={}));var w;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(w||(e.OpenEditorContext=w={}));function c(g){const d=g;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=c;function p(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(Re[199],Oe([1,0,3,101]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(N){const F=N;return typeof N=="number"||(0,k.isEditorGroup)(F)}e.isPreferredGroup=D}),define(Re[200],Oe([1,0,3,169]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(k.IEnvironmentService)}),define(Re[102],Oe([1,0,23,5,19,6]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class F{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=F;class R{static isHostExtension(t,u,h){if(u.getExtensionDescription(t))return!1;const y=h.getExtensionDescription(t);return y?!!((y.main||y.browser)&&y.api==="none"):!1}constructor(t,u){this.h=t,this.c=new k.Emitter,this.onDidChange=this.c.event,this.d=u,this.j()}j(){this.d.sort(p),this.e=new i.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const u=this.h.readActivationEvents(t);if(Array.isArray(u))for(let h of u)h==="onUri"&&(h=`onUri:${i.ExtensionIdentifier.toKey(t.identifier)}`),this.g.has(h)||this.g.set(h,[]),this.g.get(h).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,u){this.d=g(this.d,u),this.d=this.d.concat(t);const h=R.k(this.d);return this.d=g(this.d,h.map(y=>y.identifier)),this.j(),this.c.fire(void 0),new F(h)}static k(t){const u=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,l){this.addNode(n),this.addNode(l),this.c.has(n)?this.c.get(n).push(l):this.c.set(n,[l])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,l){const r=u.getArcs(n);for(let a=0;a<r.length;a++)if(!l.has(r[a]))return!1;return!0}getNodes(){return this.e}},h=new i.ExtensionIdentifierMap;for(const n of t)if(h.set(n.identifier,n),n.extensionDependencies)for(const l of n.extensionDependencies)u.addArc(i.ExtensionIdentifier.toKey(n.identifier),i.ExtensionIdentifier.toKey(l));const y=new Set;u.getNodes().filter(n=>u.getArcs(n).length===0).forEach(n=>y.add(n));const C=u.getNodes().filter(n=>!y.has(n));let v;do{v=!1;for(let n=0;n<C.length;n++){const l=C[n];u.hasOnlyGoodArcs(l,y)&&(C.splice(n,1),n--,y.add(l),v=!0)}}while(v);return C.map(n=>h.get(n))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const u=this.g.get(t);return u?u.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const u=this.e.get(t);return u||void 0}getExtensionDescriptionByUUID(t){for(const u of this.f)if(u.uuid===t)return u}getExtensionDescriptionByIdOrUUID(t,u){return this.getExtensionDescription(t)??(u?this.getExtensionDescriptionByUUID(u):void 0)}}e.ExtensionDescriptionRegistry=R,e.basicActivationEventsReader={readActivationEvents:d=>d.activationEvents};class S{constructor(t){this.d=new w,this.c=new R(t,[])}async acquireLock(t){const u=await this.d.acquire(t);return new m(this,u)}deltaExtensions(t,u,h){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(u,h)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,u){return this.c.getExtensionDescriptionByIdOrUUID(t,u)}}e.LockableExtensionDescriptionRegistry=S;class m extends N.Disposable{constructor(t,u){super(),this.f=t,this.c=!1,this.B(u)}isAcquiredFor(t){return!this.c&&this.f===t}}e.ExtensionDescriptionRegistryLock=m;class O{constructor(t){this.name=t,this.promise=new Promise((u,h)=>{this.c=u})}resolve(t){this.c(t)}}class w{constructor(){this.c=[],this.d=!1}async acquire(t){const u=new O(t);return this.c.push(u),this.e(),u.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let u=!0;const h=setTimeout(()=>{u&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),y=()=>{u&&(clearTimeout(h),u=!1,this.d=!1,this.e())};t.resolve((0,N.toDisposable)(y))}}var c;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(c||(c={}));function p(d,t){const u=d.isBuiltin?0:d.isUnderDevelopment?2:1,h=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(u!==h)return u-h;const y=D.posix.basename(d.extensionLocation.path),C=D.posix.basename(t.extensionLocation.path);return y<C?-1:y>C?1:0}function g(d,t){const u=new i.ExtensionIdentifierSet(t);return d.filter(h=>!u.has(h.identifier))}}),define(Re[77],Oe([1,0,24]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var k;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(k||(e.UIKind=k={}));var D;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(D||(e.ExtensionHostExitCode=D={}));var N;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function F(m){const O=i.VSBuffer.alloc(1);switch(m){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=F;function R(m,O){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=R;var S;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(S||(e.NativeLogMarkers=S={}))}),define(Re[57],Oe([1,0,3,5,14,27,77,50,52,26,2,6,153]),function(te,e,i,k,D,N,F,R,S,m,O,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let p=e.ExtHostTelemetry=class extends w.Disposable{constructor(u,h){super(),this.n=u,this.p=h,this.a=this.B(new k.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new k.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=O.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=h.createLogger(this.j,{id:S.extensionTelemetryLogChannelId,name:(0,c.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(h.onDidChangeLogLevel(y=>{(0,D.isLogLevel)(y)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===D.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,h,y){const C=this.getTelemetryDetails(),v=new g(h,y,u,this.k,this.i,this.getBuiltInCommonProperties(u),{isUsageEnabled:C.isUsageEnabled,isErrorsEnabled:C.isErrorsEnabled}),n=this.m.get(u.identifier.value)??[];return this.m.set(u.identifier.value,[...n,v]),v.apiTelemetryLogger}$initializeTelemetryLevel(u,h,y){this.f=u,this.g=h,this.c=y??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(u){const h=Object.create(null);switch(h["common.extname"]=`${u.publisher}.${u.name}`,h["common.extversion"]=u.version,h["common.vscodemachineid"]=this.n.telemetryInfo.machineId,h["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,h["common.vscodeversion"]=this.n.version,h["common.isnewappinstall"]=d(this.n.telemetryInfo.firstSessionDate),h["common.product"]=this.n.environment.appHost,this.n.uiKind){case F.UIKind.Web:h["common.uikind"]="web";break;case F.UIKind.Desktop:h["common.uikind"]="desktop";break;default:h["common.uikind"]="unknown"}return h["common.remotename"]=(0,R.getRemoteName)((0,S.cleanRemoteAuthority)(this.n.remote.authority)),h}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const h=this.getTelemetryDetails();this.m.forEach((y,C)=>{const v=y.filter(n=>!n.isDisposed);v.length===0?this.m.delete(C):this.m.set(C,v)}),this.m.forEach(y=>{for(const C of y)C.updateTelemetryEnablements(h.isUsageEnabled,h.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(u,h){const C=this.m.get(u.value)?.filter(n=>!n.isDisposed);if(!C)return this.m.delete(u.value),!1;let v=!1;for(const n of C)n.ignoreUnhandledExtHostErrors||(n.logError(h),v=!0);return v}};e.ExtHostTelemetry=p=xe([Ve(0,N.IExtHostInitDataService),Ve(1,D.ILoggerService)],p);class g{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,h,y,C,v,n,l){this.g=y,this.h=C,this.i=v,this.j=n,this.a=new k.Emitter,this.ignoreUnhandledExtHostErrors=h?.ignoreUnhandledErrors??!1,this.b=h?.ignoreBuiltInCommonProperties??!1,this.c=h?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}}updateTelemetryEnablements(u,h){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:h},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let h="properties"in u?u.properties??{}:u;return h=(0,S.cleanData)(h,[]),this.c&&(h=(0,m.mixin)(h,this.c)),this.b||(h=(0,m.mixin)(h,this.j)),"properties"in u?u.properties=h:u=h,u}k(u,h){this.f&&(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,h=this.mixInCommonPropsAndCleanData(h||{}),this.i||this.f?.sendEventData(u,h),this.h.trace(u,h))}logUsage(u,h){this.d.isUsageEnabled&&this.k(u,h)}logError(u,h){!this.d.isErrorsEnabled||!this.f||(typeof u=="string"?this.k(u,h):this.f.sendErrorData(u,h))}get apiTelemetryLogger(){if(!this.e){const u=this,h={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(h)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let u=this.f;this.f=void 0,Promise.resolve(u.flush()).then(u=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=g;function d(t){const u=Date.now()-new Date(t).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.isNewAppInstall=d,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(Re[20],Oe([1,0,5,2,179,98,23,3]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new F.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class S{constructor(v){this.dependency=v}}e.MissingExtensionDependency=S;var m;(function(C){C[C.EagerAutoStart=1]="EagerAutoStart",C[C.EagerManualStart=2]="EagerManualStart",C[C.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class O{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:N.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(v,n){const l=[],r=[],a=[],b=[],I=w(this.c),f=w(v),P=(B,X)=>B.extensionLocation.toString()===X.extensionLocation.toString()||B.isBuiltin===X.isBuiltin||B.isUserBuiltin===X.isUserBuiltin||B.isUnderDevelopment===X.isUnderDevelopment;for(const B of this.c){const X=f.get(B.identifier);if(!X){l.push(B.identifier),I.delete(B.identifier);continue}if(!P(B,X)){l.push(B.identifier),I.delete(B.identifier);continue}}for(const B of v){const X=I.get(B.identifier);if(!X){r.push(B);continue}if(!P(X,B)){l.push(X.identifier),I.delete(X.identifier);continue}}const E=new F.ExtensionIdentifierSet(this.d),o=new F.ExtensionIdentifierSet(n);for(const B of this.d)o.has(B)||a.push(B);for(const B of n)E.has(B)||b.push(B);const s=N.ImplicitActivationEvents.createActivationEventsMap(r),M={toRemove:l,toAdd:r,addActivationEvents:s,myToRemove:a,myToAdd:b};return this.delta(M),M}delta(v){const{toRemove:n,toAdd:l,myToRemove:r,myToAdd:a}=v,b=new F.ExtensionIdentifierSet(n),I=new F.ExtensionIdentifierSet(r);for(let f=0;f<this.c.length;f++)b.has(this.c[f].identifier)&&(this.c.splice(f,1),f--);for(let f=0;f<this.d.length;f++)I.has(this.d[f])&&(this.d.splice(f,1),f--);for(const f of l)this.c.push(f);for(const f of a)this.d.push(f)}containsExtension(v){for(const n of this.d)if(F.ExtensionIdentifier.equals(n,v))return!0;return!1}}e.ExtensionHostExtensions=O;function w(C){const v=new F.ExtensionIdentifierMap;for(const n of C)v.set(n.identifier,n);return v}function c(C,v){return C.enabledApiProposals?C.enabledApiProposals.includes(v):!1}e.isProposedApiEnabled=c;function p(C,v){if(!c(C,v))throw new Error(`Extension '${C.identifier.value}' CANNOT use API proposal: ${v}.
Its package.json#enabledApiProposals-property declares: ${C.enabledApiProposals?.join(", ")??"[]"} but NOT ${v}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${C.identifier.value}`)}e.checkProposedApiEnabled=p;class g{constructor(v,n,l,r){this.codeLoadingTime=v,this.activateCallTime=n,this.activateResolvedTime=l,this.activationReason=r}}e.ActivationTimes=g;class d{constructor(v,n){this.description=v,this.value=n}}e.ExtensionPointContribution=d;var t;(function(C){C[C.Normal=0]="Normal",C[C.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function u(C){return{type:C.isBuiltin?0:1,isBuiltin:C.isBuiltin||C.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(C.publisher,C.name),uuid:C.uuid},manifest:C,location:C.extensionLocation,targetPlatform:C.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function h(C,v){return{identifier:new F.ExtensionIdentifier((0,D.getExtensionId)(C.manifest.publisher,C.manifest.name)),isBuiltin:C.type===0,isUserBuiltin:C.type===1&&C.isBuiltin,isUnderDevelopment:!!v,extensionLocation:C.location,...C.manifest,uuid:C.identifier.uuid,targetPlatform:C.targetPlatform}}e.toExtensionDescription=h;class y{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.onWillStop=i.Event.None,this.extensions=[]}activateByEvent(v){return Promise.resolve(void 0)}activationEventIsDone(v){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(v,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=y}),define(Re[201],Oe([1,0,10,102,23,20,14,16]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(u,h,y,C){this.startup=u,this.codeLoadingTime=h,this.activateCallTime=y,this.activateResolvedTime=C}}e.ExtensionActivationTimes=S,S.NONE=new S(!1,-1,-1,-1);class m{constructor(u){this.a=u,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(u,h){return u===-1||h===-1?-1:h-u}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=m;class O{constructor(u,h,y,C,v,n){this.activationFailed=u,this.activationFailedError=h,this.activationTimes=y,this.module=C,this.exports=v,this.subscriptions=n}}e.ActivatedExtension=O;class w extends O{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=w;class c extends O{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=c;class p extends O{constructor(u){super(!0,u,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=e.ExtensionsActivator=class{constructor(u,h,y,C){this.g=C,this.a=u,this.b=h,this.c=y,this.d=new D.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[u,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const u=[];for(const[h,y]of this.d)u.push(y.wait());await Promise.all(u)}isActivated(u){const h=this.d.get(u);return!!(h&&h.value)}getActivatedExtension(u){const h=this.d.get(u);if(!h||!h.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return h.value}async activateByEvent(u,h){if(this.f[u])return;const y=this.a.getExtensionDescriptionsForActivationEvent(u);await this.h(y.map(C=>({id:C.identifier,reason:{startup:h,extensionId:C.identifier,activationEvent:u}}))),this.f[u]=!0}activateById(u,h){const y=this.a.getExtensionDescription(u);if(!y)throw new Error(`Extension '${u}' is not known`);return this.h([{id:y.identifier,reason:h}])}async h(u){const h=u.filter(y=>!this.isActivated(y.id)).map(y=>this.j(y));await Promise.all(h.map(y=>y.wait()))}j(u){if(this.d.has(u.id))return this.d.get(u.id);if(this.l(u.id))return this.k(u,null,[],null);const h=this.a.getExtensionDescription(u.id);if(!h){const v=new Error(`Cannot activate unknown extension '${u.id.value}'`),n=this.k(u,null,[],new p(v));return this.c.onExtensionActivationError(u.id,v,new N.MissingExtensionDependency(u.id.value)),n}const y=[],C=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const v of C){if(this.m(v))continue;const n=this.d.get(v);if(n){y.push(n);continue}if(this.l(v)){y.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:u.reason}));continue}const l=this.a.getExtensionDescription(v);if(l){if(!l.main&&!l.browser)continue;y.push(this.j({id:l.identifier,reason:u.reason}));continue}const r=h.displayName||h.identifier.value,a=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${v}'`),b=this.k(u,h.displayName,[],new p(a));return this.c.onExtensionActivationError(h.identifier,a,new N.MissingExtensionDependency(v)),b}return this.k(u,h.displayName,y,null)}k(u,h,y,C){const v=new d(u.id,h,u.reason,y,C,this.c,this.g);return this.d.set(u.id,v),v}l(u){return k.ExtensionDescriptionRegistry.isHostExtension(u,this.a,this.b)}m(u){const h=this.b.getExtensionDescription(u);return h?!h.main&&!h.browser:!1}};e.ExtensionsActivator=g=xe([Ve(3,F.ILogService)],g);let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(u,h,y,C,v,n,l){this.c=u,this.d=h,this.f=y,this.g=C,this.h=v,this.j=n,this.k=l,this.a=new R.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let u=0;u<this.g.length;u++){const h=this.g[u];if(h.value&&!h.value.activationFailed){this.g.splice(u,1),u--;continue}if(h.value&&h.value.activationFailed){const y=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);y.detail=h.value.activationFailedError,this.h=new p(y),this.j.onExtensionActivationError(this.c,y,null);return}}this.g.length>0&&await Promise.race(this.g.map(u=>u.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(u){const h=new Error;if(u&&u.name&&(h.name=u.name),u&&u.message?h.message=`Activating extension '${this.c.value}' failed: ${u.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${u}.`,u&&u.stack&&(h.stack=u.stack),this.h=new p(h),this.b&&i.isCancellationError(u))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(u)}}};d=xe([Ve(6,F.ILogService)],d)});var Ye=this&&this.__classPrivateFieldSet||function(te,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Fe=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(Re[7],Oe([1,0,18,10,89,28,67,13,9,2,36,23,43,97,74,20]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d){"use strict";var t,u,h,y,C,v,n,l,r,a,b,I,f,P,E,o,s,M,B,X,G,W,U,q,z,V;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.NotebookCodeActionKind=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function ee($){return Object.assign($,{apply:function(){const se=arguments.length===1?[]:arguments[1];return Reflect.construct($,se,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct($,[]);{const[se,...Te]=arguments;return Reflect.construct($,Te,se.constructor)}}})}var Ce;(function($){$[$.Top=0]="Top",$[$.Bottom=1]="Bottom"})(Ce||(e.TerminalOutputAnchor=Ce={}));var oe;(function($){$[$.Command=0]="Command",$[$.Opener=1]="Opener"})(oe||(e.TerminalQuickFixType=oe={}));let le=e.Disposable=r=class{static from(...L){let se=L;return new r(function(){if(se){for(const Te of se)Te&&typeof Te.dispose=="function"&&Te.dispose();se=void 0}})}constructor(L){t.set(this,void 0),Ye(this,t,L,"f")}dispose(){typeof Fe(this,t,"f")=="function"&&(Fe(this,t,"f").call(this),Ye(this,t,void 0,"f"))}};t=new WeakMap,e.Disposable=le=r=xe([ee],le);let Q=e.Position=a=class{static Min(...L){if(L.length===0)throw new TypeError;let se=L[0];for(let Te=1;Te<L.length;Te++){const Ge=L[Te];Ge.isBefore(se)&&(se=Ge)}return se}static Max(...L){if(L.length===0)throw new TypeError;let se=L[0];for(let Te=1;Te<L.length;Te++){const Ge=L[Te];Ge.isAfter(se)&&(se=Ge)}return se}static isPosition(L){if(!L)return!1;if(L instanceof a)return!0;const{line:se,character:Te}=L;return typeof se=="number"&&typeof Te=="number"}static of(L){if(L instanceof a)return L;if(this.isPosition(L))return new a(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,se){if(L<0)throw(0,k.illegalArgument)("line must be non-negative");if(se<0)throw(0,k.illegalArgument)("character must be non-negative");this.c=L,this.e=se}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,se=0){if(L===null||se===null)throw(0,k.illegalArgument)();let Te;return typeof L>"u"?Te=0:typeof L=="number"?Te=L:(Te=typeof L.lineDelta=="number"?L.lineDelta:0,se=typeof L.characterDelta=="number"?L.characterDelta:0),Te===0&&se===0?this:new a(this.line+Te,this.character+se)}with(L,se=this.character){if(L===null||se===null)throw(0,k.illegalArgument)();let Te;return typeof L>"u"?Te=this.line:typeof L=="number"?Te=L:(Te=typeof L.line=="number"?L.line:this.line,se=typeof L.character=="number"?L.character:this.character),Te===this.line&&se===this.character?this:new a(Te,se)}toJSON(){return{line:this.line,character:this.character}}};e.Position=Q=a=xe([ee],Q);let ue=e.Range=b=class{static isRange(L){return L instanceof b?!0:L?Q.isPosition(L.start)&&Q.isPosition(L.end):!1}static of(L){if(L instanceof b)return L;if(this.isRange(L))return new b(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,se,Te,Ge){let Je,rt;if(typeof L=="number"&&typeof se=="number"&&typeof Te=="number"&&typeof Ge=="number"?(Je=new Q(L,se),rt=new Q(Te,Ge)):Q.isPosition(L)&&Q.isPosition(se)&&(Je=Q.of(L),rt=Q.of(se)),!Je||!rt)throw new Error("Invalid arguments");Je.isBefore(rt)?(this.c=Je,this.e=rt):(this.c=rt,this.e=Je)}contains(L){return b.isRange(L)?this.contains(L.start)&&this.contains(L.end):Q.isPosition(L)?!(Q.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const se=Q.Max(L.start,this.c),Te=Q.Min(L.end,this.e);if(!se.isAfter(Te))return new b(se,Te)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const se=Q.Min(L.start,this.c),Te=Q.Max(L.end,this.end);return new b(se,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,se=this.end){if(L===null||se===null)throw(0,k.illegalArgument)();let Te;return L?Q.isPosition(L)?Te=L:(Te=L.start||this.start,se=L.end||this.end):Te=this.start,Te.isEqual(this.c)&&se.isEqual(this.end)?this:new b(Te,se)}toJSON(){return[this.start,this.end]}};e.Range=ue=b=xe([ee],ue);let Ie=e.Selection=I=class extends ue{static isSelection(L){return L instanceof I?!0:L?ue.isRange(L)&&Q.isPosition(L.anchor)&&Q.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,se,Te,Ge){let Je,rt;if(typeof L=="number"&&typeof se=="number"&&typeof Te=="number"&&typeof Ge=="number"?(Je=new Q(L,se),rt=new Q(Te,Ge)):Q.isPosition(L)&&Q.isPosition(se)&&(Je=Q.of(L),rt=Q.of(se)),!Je||!rt)throw new Error("Invalid arguments");super(Je,rt),this.f=Je,this.g=rt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=Ie=I=xe([ee],Ie);const Pe=$=>{if(typeof $!="string"||$.length===0||!/^[0-9A-Za-z_\-]+$/.test($))throw(0,k.illegalArgument)("connectionToken")};class be{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,se,Te){if(typeof L!="string"||L.length===0)throw(0,k.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,k.illegalArgument)("port");typeof Te<"u"&&Pe(Te),this.host=L,this.port=Math.round(se),this.connectionToken=Te}}e.ResolvedAuthority=be;class A{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,se){this.makeConnection=L,this.connectionToken=se,typeof se<"u"&&Pe(se)}}e.ManagedResolvedAuthority=A;class K extends Error{static NotAvailable(L,se){return new K(L,p.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(L){return new K(L,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,se=p.RemoteAuthorityResolverErrorCode.Unknown,Te){super(L),this._message=L,this._code=se,this._detail=Te,Object.setPrototypeOf(this,K.prototype)}}e.RemoteAuthorityResolverError=K;var he;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(he||(e.EndOfLine=he={}));var De;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(De||(e.EnvironmentVariableMutatorType=De={}));let we=e.TextEdit=f=class{static isTextEdit(L){return L instanceof f?!0:L?ue.isRange(L)&&typeof L.newText=="string":!1}static replace(L,se){return new f(L,se)}static insert(L,se){return f.replace(new ue(L,L),se)}static delete(L){return f.replace(L,"")}static setEndOfLine(L){const se=new f(new ue(new Q(0,0),new Q(0,0)),"");return se.newEol=L,se}get range(){return this.c}set range(L){if(L&&!ue.isRange(L))throw(0,k.illegalArgument)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,k.illegalArgument)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,k.illegalArgument)("newEol");this.f=L}constructor(L,se){this.c=L,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.TextEdit=we=f=xe([ee],we);let ge=e.NotebookEdit=P=class{static isNotebookCellEdit(L){return L instanceof P?!0:L?_t.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,se){return new P(L,se)}static insertCells(L,se){return new P(new _t(L,L),se)}static deleteCells(L){return new P(L,[])}static updateCellMetadata(L,se){const Te=new P(new _t(L,L),[]);return Te.newCellMetadata=se,Te}static updateNotebookMetadata(L){const se=new P(new _t(0,0),[]);return se.newNotebookMetadata=L,se}constructor(L,se){this.range=L,this.newCells=se}};e.NotebookEdit=ge=P=xe([ee],ge);class ke{static isSnippetTextEdit(L){return L instanceof ke?!0:L?ue.isRange(L.range)&&Z.isSnippetString(L.snippet):!1}static replace(L,se){return new ke(L,se)}static insert(L,se){return ke.replace(new ue(L,L),se)}constructor(L,se){this.range=L,this.snippet=se}}e.SnippetTextEdit=ke;var ae;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace",$[$.Snippet=6]="Snippet"})(ae||(e.FileEditType=ae={}));let de=e.WorkspaceEdit=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,se,Te,Ge){this.c.push({_type:1,from:L,to:se,options:Te,metadata:Ge})}createFile(L,se,Te){this.c.push({_type:1,from:void 0,to:L,options:se,metadata:Te})}deleteFile(L,se,Te){this.c.push({_type:1,from:L,to:void 0,options:se,metadata:Te})}e(L,se,Te){this.c.push({_type:3,metadata:Te,uri:L,edit:{editType:5,metadata:se},notebookMetadata:se})}f(L,se,Te,Ge){const Je=se.start,rt=se.end;(Je!==rt||Te.length>0)&&this.c.push({_type:5,uri:L,index:Je,count:rt-Je,cells:Te,metadata:Ge})}g(L,se,Te,Ge){this.c.push({_type:3,metadata:Ge,uri:L,edit:{editType:8,index:se,metadata:Te}})}replace(L,se,Te,Ge){this.c.push({_type:2,uri:L,edit:new we(se,Te),metadata:Ge})}insert(L,se,Te,Ge){this.replace(L,new ue(se,se),Te,Ge)}delete(L,se,Te){this.replace(L,se,"",Te)}has(L){return this.c.some(se=>se._type===2&&se.uri.toString()===L.toString())}set(L,se){if(se)for(const Te of se){if(!Te)continue;let Ge,Je;Array.isArray(Te)?(Ge=Te[0],Je=Te[1]):Ge=Te,ge.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(L,Ge.range.start,Ge.newCellMetadata,Je):Ge.newNotebookMetadata?this.e(L,Ge.newNotebookMetadata,Je):this.f(L,Ge.range,Ge.newCells,Je):ke.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:L,range:Ge.range,edit:Ge.snippet,metadata:Je}):this.c.push({_type:2,uri:L,edit:Ge,metadata:Je})}else{for(let Te=0;Te<this.c.length;Te++){const Ge=this.c[Te];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===L.toString()&&(this.c[Te]=void 0);break}}(0,i.coalesceInPlace)(this.c)}}get(L){const se=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===L.toString()&&se.push(Te.edit);return se}entries(){const L=new N.ResourceMap;for(const se of this.c)if(se._type===2){let Te=L.get(se.uri);Te||(Te=[se.uri,[]],L.set(se.uri,Te)),Te[1].push(se.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=de=xe([ee],de);let Z=e.SnippetString=E=class{static isSnippetString(L){return L instanceof E?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=E.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,se=this.e++){if(typeof L=="function"){const Te=new E;Te.e=this.e,L(Te),this.e=Te.e,L=Te.value}else L=E.c(L);return this.value+="${",this.value+=se,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,se=this.e++){const Te=L.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(L,se){if(typeof se=="function"){const Te=new E;Te.e=this.e,se(Te),this.e=Te.e,se=Te.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.SnippetString=Z=E=xe([ee],Z);var ne;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var T;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(T||(e.DiagnosticSeverity=T={}));let H=e.Location=o=class{static isLocation(L){return L instanceof o?!0:L?ue.isRange(L.range)&&m.URI.isUri(L.uri):!1}constructor(L,se){if(this.uri=L,se)if(ue.isRange(se))this.range=ue.of(se);else if(Q.isPosition(se))this.range=new ue(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=H=o=xe([ee],H);let j=e.DiagnosticRelatedInformation=class{static is(L){return L?typeof L.message=="string"&&L.location&&ue.isRange(L.location.range)&&m.URI.isUri(L.location.uri):!1}constructor(L,se){this.location=L,this.message=se}static isEqual(L,se){return L===se?!0:!L||!se?!1:L.message===se.message&&L.location.range.isEqual(se.location.range)&&L.location.uri.toString()===se.location.uri.toString()}};e.DiagnosticRelatedInformation=j=xe([ee],j);let x=e.Diagnostic=class{constructor(L,se,Te=T.Error){if(!ue.isRange(L))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=L,this.message=se,this.severity=Te}toJSON(){return{severity:T[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,se){return L===se?!0:!L||!se?!1:L.message===se.message&&L.severity===se.severity&&L.code===se.code&&L.severity===se.severity&&L.source===se.source&&L.range.isEqual(se.range)&&(0,i.equals)(L.tags,se.tags)&&(0,i.equals)(L.relatedInformation,se.relatedInformation,j.isEqual)}};e.Diagnostic=x=xe([ee],x);let ce=e.Hover=class{constructor(L,se){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=se}};e.Hover=ce=xe([ee],ce);var pe;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(pe||(e.DocumentHighlightKind=pe={}));let ie=e.DocumentHighlight=class{constructor(L,se=pe.Text){this.range=L,this.kind=se}toJSON(){return{range:this.range,kind:pe[this.kind]}}};e.DocumentHighlight=ie=xe([ee],ie);var ye;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(ye||(e.SymbolKind=ye={}));var Se;(function($){$[$.Deprecated=1]="Deprecated"})(Se||(e.SymbolTag=Se={}));let Be=e.SymbolInformation=s=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,se,Te,Ge,Je){this.name=L,this.kind=se,this.containerName=Je,typeof Te=="string"&&(this.containerName=Te),Ge instanceof H?this.location=Ge:Te instanceof ue&&(this.location=new H(Ge,Te)),s.validate(this)}toJSON(){return{name:this.name,kind:ye[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Be=s=xe([ee],Be);let je=e.DocumentSymbol=M=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(M.validate)}constructor(L,se,Te,Ge,Je){this.name=L,this.detail=se,this.kind=Te,this.range=Ge,this.selectionRange=Je,this.children=[],M.validate(this)}};e.DocumentSymbol=je=M=xe([ee],je);var Ze;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(Ze||(e.CodeActionTriggerKind=Ze={}));let Qe=e.CodeAction=class{constructor(L,se){this.title=L,this.kind=se}};e.CodeAction=Qe=xe([ee],Qe);let Ke=e.CodeActionKind=B=class{constructor(L){this.value=L}append(L){return new B(this.value?this.value+B.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+B.c)}};Ke.c=".",e.CodeActionKind=Ke=B=xe([ee],Ke);class it extends Ke{constructor(L){super(L),this.value=L}}e.NotebookCodeActionKind=it,Ke.Empty=new Ke(""),Ke.QuickFix=Ke.Empty.append("quickfix"),Ke.Refactor=Ke.Empty.append("refactor"),Ke.RefactorExtract=Ke.Refactor.append("extract"),Ke.RefactorInline=Ke.Refactor.append("inline"),Ke.RefactorMove=Ke.Refactor.append("move"),Ke.RefactorRewrite=Ke.Refactor.append("rewrite"),Ke.Source=Ke.Empty.append("source"),Ke.SourceOrganizeImports=Ke.Source.append("organizeImports"),Ke.SourceFixAll=Ke.Source.append("fixAll"),Ke.Notebook=Ke.Empty.append("notebook");let st=e.SelectionRange=class{constructor(L,se){if(this.range=L,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=st=xe([ee],st);class tt{constructor(L,se,Te,Ge,Je,rt){this.kind=L,this.name=se,this.detail=Te,this.uri=Ge,this.range=Je,this.selectionRange=rt}}e.CallHierarchyItem=tt;class Ne{constructor(L,se){this.fromRanges=se,this.from=L}}e.CallHierarchyIncomingCall=Ne;class dt{constructor(L,se){this.fromRanges=se,this.to=L}}e.CallHierarchyOutgoingCall=dt;var J;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(J||(e.LanguageStatusSeverity=J={}));let _=e.CodeLens=class{constructor(L,se){this.range=L,this.command=se}get isResolved(){return!!this.command}};e.CodeLens=_=xe([ee],_);let fe=e.MarkdownString=X=class{static isMarkdownString(L){return L instanceof X?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,se=!1){u.set(this,void 0),Ye(this,u,new D.MarkdownString(L,{supportThemeIcons:se}),"f")}get value(){return Fe(this,u,"f").value}set value(L){Fe(this,u,"f").value=L}get isTrusted(){return Fe(this,u,"f").isTrusted}set isTrusted(L){Fe(this,u,"f").isTrusted=L}get supportThemeIcons(){return Fe(this,u,"f").supportThemeIcons}set supportThemeIcons(L){Fe(this,u,"f").supportThemeIcons=L}get supportHtml(){return Fe(this,u,"f").supportHtml}set supportHtml(L){Fe(this,u,"f").supportHtml=L}get baseUri(){return Fe(this,u,"f").baseUri}set baseUri(L){Fe(this,u,"f").baseUri=L}appendText(L){return Fe(this,u,"f").appendText(L),this}appendMarkdown(L){return Fe(this,u,"f").appendMarkdown(L),this}appendCodeblock(L,se){return Fe(this,u,"f").appendCodeblock(se??"",L),this}};u=new WeakMap,e.MarkdownString=fe=X=xe([ee],fe);let $e=e.ParameterInformation=class{constructor(L,se){this.label=L,this.documentation=se}};e.ParameterInformation=$e=xe([ee],$e);let qe=e.SignatureInformation=class{constructor(L,se){this.label=L,this.documentation=se,this.parameters=[]}};e.SignatureInformation=qe=xe([ee],qe);let We=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=We=xe([ee],We);var _e;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(_e||(e.SignatureHelpTriggerKind=_e={}));var mt;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(mt||(e.InlayHintKind=mt={}));let St=e.InlayHintLabelPart=class{constructor(L){this.value=L}};e.InlayHintLabelPart=St=xe([ee],St);let kt=e.InlayHint=class{constructor(L,se,Te){this.position=L,this.label=se,this.kind=Te}};e.InlayHint=kt=xe([ee],kt);var Gt;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Gt||(e.CompletionTriggerKind=Gt={}));var Bt;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(Bt||(e.CompletionItemKind=Bt={}));var yt;(function($){$[$.Deprecated=1]="Deprecated"})(yt||(e.CompletionItemTag=yt={}));let Wt=e.CompletionItem=class{constructor(L,se){this.label=L,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Bt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Wt=xe([ee],Wt);let Mt=e.CompletionList=class{constructor(L=[],se=!1){this.items=L,this.isIncomplete=se}};e.CompletionList=Mt=xe([ee],Mt);let qt=e.InlineSuggestion=class{constructor(L,se,Te){this.insertText=L,this.range=se,this.command=Te}};e.InlineSuggestion=qt=xe([ee],qt);let Ot=e.InlineSuggestionList=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.InlineSuggestionList=Ot=xe([ee],Ot);var Lt;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(Lt||(e.ViewColumn=Lt={}));var Ht;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(Ht||(e.StatusBarAlignment=Ht={}));function at($,L){return`${w.ExtensionIdentifier.toKey($)}.${L}`}e.asStatusBarItemIdentifier=at;var ht;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(ht||(e.TextEditorLineNumbersStyle=ht={}));var Nt;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(Nt||(e.TextDocumentSaveReason=Nt={}));var Ut;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Ut||(e.TextEditorRevealType=Ut={}));var Et;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var lt;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})(lt||(e.TextDocumentChangeReason=lt={}));var Ct;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(Ct||(e.DecorationRangeBehavior=Ct={})),function($){function L(se){switch(se){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=L}(Et||(e.TextEditorSelectionChangeKind=Et={}));let $t=e.DocumentLink=class{constructor(L,se){if(se&&!m.URI.isUri(se))throw(0,k.illegalArgument)("target");if(!ue.isRange(L)||L.isEmpty)throw(0,k.illegalArgument)("range");this.range=L,this.target=se}};e.DocumentLink=$t=xe([ee],$t);let Ae=e.Color=class{constructor(L,se,Te,Ge){this.red=L,this.green=se,this.blue=Te,this.alpha=Ge}};e.Color=Ae=xe([ee],Ae);let Ee=e.ColorInformation=class{constructor(L,se){if(se&&!(se instanceof Ae))throw(0,k.illegalArgument)("color");if(!ue.isRange(L)||L.isEmpty)throw(0,k.illegalArgument)("range");this.range=L,this.color=se}};e.ColorInformation=Ee=xe([ee],Ee);let ve=e.ColorPresentation=class{constructor(L){if(!L||typeof L!="string")throw(0,k.illegalArgument)("label");this.label=L}};e.ColorPresentation=ve=xe([ee],ve);var Y;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(Y||(e.ColorFormat=Y={}));var Me;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(Me||(e.SourceControlInputBoxValidationType=Me={}));var ze;(function($){$[$.Unknown=0]="Unknown",$[$.Shutdown=1]="Shutdown",$[$.Process=2]="Process",$[$.User=3]="User",$[$.Extension=4]="Extension"})(ze||(e.TerminalExitReason=ze={}));class Xe{constructor(L,se,Te){if(this.startIndex=L,this.length=se,this.tooltip=Te,typeof L!="number"||L<0)throw(0,k.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,k.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=Xe;class He{constructor(L){this.uri=L}}e.TerminalQuickFixOpener=He;class et{constructor(L){this.terminalCommand=L}}e.TerminalQuickFixCommand=et;var wt;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(wt||(e.TerminalLocation=wt={}));class At{constructor(L){if(this.options=L,typeof L!="object")throw(0,k.illegalArgument)("options")}}e.TerminalProfile=At;var Tt;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(Tt||(e.TaskRevealKind=Tt={}));var vt;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(vt||(e.TaskPanelKind=vt={}));let ot=e.TaskGroup=G=class{static from(L){switch(L){case"clean":return G.Clean;case"build":return G.Build;case"rebuild":return G.Rebuild;case"test":return G.Test;default:return}}constructor(L,se){if(this.label=se,typeof L!="string"||typeof se!="string")throw(0,k.illegalArgument)("name");this.c=L}get id(){return this.c}};ot.Clean=new G("clean","Clean"),ot.Build=new G("build","Build"),ot.Rebuild=new G("rebuild","Rebuild"),ot.Test=new G("test","Test"),e.TaskGroup=ot=G=xe([ee],ot);function gt($){let L="";for(let se=0;se<$.length;se++)L+=$[se].replace(/,/g,",,")+",";return L}let pt=e.ProcessExecution=class{constructor(L,se,Te){if(typeof L!="string")throw(0,k.illegalArgument)("process");this.e=[],this.c=L,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=Te):this.f=se)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,k.illegalArgument)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const se of this.e)L.push(se);return gt(L)}};e.ProcessExecution=pt=xe([ee],pt);let bt=e.ShellExecution=class{constructor(L,se,Te){if(this.f=[],Array.isArray(se)){if(!L)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,k.illegalArgument)("command");this.e=L,this.f=se,this.g=Te}else{if(typeof L!="string")throw(0,k.illegalArgument)("commandLine");this.c=L,this.g=se}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,k.illegalArgument)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,k.illegalArgument)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)L.push(typeof se=="string"?se:se.value);return gt(L)}};e.ShellExecution=bt=xe([ee],bt);var oi;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(oi||(e.ShellQuoting=oi={}));var Vt;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(Vt||(e.TaskScope=Vt={}));class Fi{constructor(L){this.c=L}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(L){this.c=L}get callback(){return this.c}}e.CustomExecution=Fi;let Kt=e.Task=W=class{constructor(L,se,Te,Ge,Je,rt){this.j=!1,this.k=this.definition=L;let ut;typeof se=="string"?(this.m=this.name=se,this.t=this.source=Te,this.execution=Ge,ut=Je,this.j=!0):se===Vt.Global||se===Vt.Workspace?(this.target=se,this.m=this.name=Te,this.t=this.source=Ge,this.execution=Je,ut=rt):(this.target=se,this.m=this.name=Te,this.t=this.source=Ge,this.execution=Je,ut=rt),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(L){this.h=L}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof pt?this.k={type:W.e,id:this.n.computeId()}:this.n instanceof bt?this.k={type:W.f,id:this.n.computeId()}:this.n instanceof Fi?this.k={type:W.c,id:this.n.computeId()}:this.k={type:W.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(L){if(L==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=L}get scope(){return this.l}set target(L){this.y(),this.l=L}get name(){return this.m}set name(L){if(typeof L!="string")throw(0,k.illegalArgument)("name");this.y(),this.m=L}get execution(){return this.n}set execution(L){L===null&&(L=void 0),this.y(),this.n=L;const se=this.k.type;(W.g===se||W.e===se||W.f===se||W.c===se)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(L){if(Array.isArray(L))this.y(),this.o=L,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.y(),this.r=L}get source(){return this.t}set source(L){if(typeof L!="string"||L.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.y(),this.t=L}get group(){return this.u}set group(L){L===null&&(L=void 0),this.y(),this.u=L}get detail(){return this.x}set detail(L){L===null&&(L=void 0),this.x=L}get presentationOptions(){return this.v}set presentationOptions(L){L==null&&(L=Object.create(null)),this.y(),this.v=L}get runOptions(){return this.w}set runOptions(L){L==null&&(L=Object.create(null)),this.y(),this.w=L}};Kt.c="customExecution",Kt.e="process",Kt.f="shell",Kt.g="$empty",e.Task=Kt=W=xe([ee],Kt);var Ei;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(Ei||(e.ProgressLocation=Ei={}));var Pt;(function($){function L(se){const Te=se;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}$.isViewBadge=L})(Pt||(e.ViewBadge=Pt={}));let Mi=e.TreeItem=U=class{static isTreeItem(L,se){const Te=L;if(Te.checkboxState!==void 0){(0,d.checkProposedApiEnabled)(se,"treeItemCheckbox");const Ge=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Je=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Dt.Checked&&Ge!==Dt.Unchecked||Je!==void 0&&!(0,S.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(L instanceof U)return!0;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!m.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const Ge=Te.iconPath;if(!Ge||!(0,S.isString)(Ge.light)&&!m.URI.isUri(Ge.light)&&!(0,S.isString)(Ge.dark)&&!m.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!m.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof fe)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<ai.None&&Te.collapsibleState>ai.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(L,se=ai.None){this.collapsibleState=se,m.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.TreeItem=Mi=U=xe([ee],Mi);var ai;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(ai||(e.TreeItemCollapsibleState=ai={}));var Dt;(function($){$[$.Unchecked=0]="Unchecked",$[$.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let di=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.DataTransferItem=di=xe([ee],di);class wi extends di{}e.InternalDataTransferItem=wi;class hi extends wi{constructor(L){super(""),h.set(this,void 0),Ye(this,h,L,"f")}asFile(){return Fe(this,h,"f")}}e.InternalFileDataTransferItem=hi,h=new WeakMap;class cn{constructor(L,se,Te,Ge){this.name=L,this.uri=se,this._itemId=Te,this.c=Ge}data(){return this.c()}}e.DataTransferFile=cn;let Li=e.DataTransfer=class{constructor(L){y.add(this),C.set(this,new Map);for(const[se,Te]of L??[]){const Ge=Fe(this,C,"f").get(Fe(this,y,"m",v).call(this,se));Ge?Ge.push(Te):Fe(this,C,"f").set(Fe(this,y,"m",v).call(this,se),[Te])}}get(L){return Fe(this,C,"f").get(Fe(this,y,"m",v).call(this,L))?.[0]}set(L,se){Fe(this,C,"f").set(Fe(this,y,"m",v).call(this,L),[se])}forEach(L,se){for(const[Te,Ge]of Fe(this,C,"f"))for(const Je of Ge)L.call(se,Je,Te,this)}*[(C=new WeakMap,y=new WeakSet,Symbol.iterator)](){for(const[L,se]of Fe(this,C,"f"))for(const Te of se)yield[L,Te]}};v=function(L){return L.toLowerCase()},e.DataTransfer=Li=xe([ee],Li);let Ft=e.DocumentDropEdit=class{constructor(L){this.insertText=L}};e.DocumentDropEdit=Ft=xe([ee],Ft);let Si=e.DocumentPasteEdit=class{constructor(L,se,Te){this.id=se,this.label=Te,this.insertText=L}};e.DocumentPasteEdit=Si=xe([ee],Si);let Yt=e.ThemeIcon=class{constructor(L,se){this.id=L,this.color=se}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.ThemeIcon=Yt=xe([ee],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let ci=e.ThemeColor=class{constructor(L){this.id=L}};e.ThemeColor=ci=xe([ee],ci);var ui;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(ui||(e.ConfigurationTarget=ui={}));let ct=e.RelativePattern=class{get base(){return this.c}set base(L){this.c=L,this.e=m.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,se){if(typeof L!="string"&&(!L||!m.URI.isUri(L)&&!m.URI.isUri(L.uri)))throw(0,k.illegalArgument)("base");if(typeof se!="string")throw(0,k.illegalArgument)("pattern");typeof L=="string"?this.baseUri=m.URI.file(L):m.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=ct=xe([ee],ct);const Ni=new WeakMap;function ei($,L){Ni.set($,L)}e.setBreakpointId=ei;let Xt=e.Breakpoint=class{constructor(L,se,Te,Ge){this.enabled=typeof L=="boolean"?L:!0,typeof se=="string"&&(this.condition=se),typeof Te=="string"&&(this.hitCondition=Te),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Ni.get(this)??(0,O.generateUuid)()),this.c}};e.Breakpoint=Xt=xe([ee],Xt);let yi=e.SourceBreakpoint=class extends Xt{constructor(L,se,Te,Ge,Je){if(super(se,Te,Ge,Je),L===null)throw(0,k.illegalArgument)("location");this.location=L}};e.SourceBreakpoint=yi=xe([ee],yi);let Ui=e.FunctionBreakpoint=class extends Xt{constructor(L,se,Te,Ge,Je){super(se,Te,Ge,Je),this.functionName=L}};e.FunctionBreakpoint=Ui=xe([ee],Ui);let $i=e.DataBreakpoint=class extends Xt{constructor(L,se,Te,Ge,Je,rt,ut){if(super(Ge,Je,rt,ut),!se)throw(0,k.illegalArgument)("dataId");this.label=L,this.dataId=se,this.canPersist=Te}};e.DataBreakpoint=$i=xe([ee],$i);let zi=e.DebugAdapterExecutable=class{constructor(L,se,Te){this.command=L,this.args=se||[],this.options=Te}};e.DebugAdapterExecutable=zi=xe([ee],zi);let Di=e.DebugAdapterServer=class{constructor(L,se){this.port=L,this.host=se}};e.DebugAdapterServer=Di=xe([ee],Di);let Bi=e.DebugAdapterNamedPipeServer=class{constructor(L){this.path=L}};e.DebugAdapterNamedPipeServer=Bi=xe([ee],Bi);let Ii=e.DebugAdapterInlineImplementation=class{constructor(L){this.implementation=L}};e.DebugAdapterInlineImplementation=Ii=xe([ee],Ii);let ni=e.StackFrameFocus=class{constructor(L,se,Te){this.session=L,this.threadId=se,this.frameId=Te}};e.StackFrameFocus=ni=xe([ee],ni);let Wi=e.ThreadFocus=class{constructor(L,se){this.session=L,this.threadId=se}};e.ThreadFocus=Wi=xe([ee],Wi);let fi=e.EvaluatableExpression=class{constructor(L,se){this.range=L,this.expression=se}};e.EvaluatableExpression=fi=xe([ee],fi);var mi;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(mi||(e.InlineCompletionTriggerKind=mi={}));let Hi=e.InlineValueText=class{constructor(L,se){this.range=L,this.text=se}};e.InlineValueText=Hi=xe([ee],Hi);let Vi=e.InlineValueVariableLookup=class{constructor(L,se,Te=!0){this.range=L,this.variableName=se,this.caseSensitiveLookup=Te}};e.InlineValueVariableLookup=Vi=xe([ee],Vi);let ri=e.InlineValueEvaluatableExpression=class{constructor(L,se){this.range=L,this.expression=se}};e.InlineValueEvaluatableExpression=ri=xe([ee],ri);let ji=e.InlineValueContext=class{constructor(L,se){this.frameId=L,this.stoppedLocation=se}};e.InlineValueContext=ji=xe([ee],ji);var qi;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(qi||(e.FileChangeType=qi={}));let xi=e.FileSystemError=q=class extends Error{static FileExists(L){return new q(L,c.FileSystemProviderErrorCode.FileExists,q.FileExists)}static FileNotFound(L){return new q(L,c.FileSystemProviderErrorCode.FileNotFound,q.FileNotFound)}static FileNotADirectory(L){return new q(L,c.FileSystemProviderErrorCode.FileNotADirectory,q.FileNotADirectory)}static FileIsADirectory(L){return new q(L,c.FileSystemProviderErrorCode.FileIsADirectory,q.FileIsADirectory)}static NoPermissions(L){return new q(L,c.FileSystemProviderErrorCode.NoPermissions,q.NoPermissions)}static Unavailable(L){return new q(L,c.FileSystemProviderErrorCode.Unavailable,q.Unavailable)}constructor(L,se=c.FileSystemProviderErrorCode.Unknown,Te){super(m.URI.isUri(L)?L.toString(!0):L),this.code=Te?.name??"Unknown",(0,c.markAsFileSystemProviderError)(this,se),Object.setPrototypeOf(this,q.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};e.FileSystemError=xi=q=xe([ee],xi);let si=e.FoldingRange=class{constructor(L,se,Te){this.start=L,this.end=se,this.kind=Te}};e.FoldingRange=si=xe([ee],si);var Gi;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(Gi||(e.FoldingRangeKind=Gi={}));var Ki;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(Ki||(e.CommentThreadCollapsibleState=Ki={}));var ki;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(ki||(e.CommentMode=ki={}));var Xi;(function($){$[$.Published=0]="Published",$[$.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var Qi;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(Qi||(e.CommentThreadState=Qi={}));class un{constructor(L,se=[]){this.tokenTypes=L,this.tokenModifiers=se}}e.SemanticTokensLegend=un;function Ci($){return typeof $>"u"||(0,S.isStringArray)($)}class gi{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,L){this.l=!0;for(let se=0,Te=L.tokenTypes.length;se<Te;se++)this.j.set(L.tokenTypes[se],se);for(let se=0,Te=L.tokenModifiers.length;se<Te;se++)this.k.set(L.tokenModifiers[se],se)}}push(L,se,Te,Ge,Je){if(typeof L=="number"&&typeof se=="number"&&typeof Te=="number"&&typeof Ge=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this.n(L,se,Te,Ge,Je);if(ue.isRange(L)&&typeof se=="string"&&Ci(Te))return this.m(L,se,Te);throw(0,k.illegalArgument)()}m(L,se,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(se))throw new Error("`tokenType` is not in the provided legend");const Ge=L.start.line,Je=L.start.character,rt=L.end.character-L.start.character,ut=this.j.get(se);let zt=0;if(Te)for(const xt of Te){if(!this.k.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const Qt=this.k.get(xt);zt|=1<<Qt>>>0}this.n(Ge,Je,rt,ut,zt)}n(L,se,Te,Ge,Je){if(this.f&&(L<this.c||L===this.c&&se<this.e)){this.f=!1;const zt=this.g.length/5|0;let xt=0,Qt=0;for(let Zt=0;Zt<zt;Zt++){let ti=this.g[5*Zt],Ri=this.g[5*Zt+1];ti===0?(ti=xt,Ri+=Qt):ti+=xt,this.g[5*Zt]=ti,this.g[5*Zt+1]=Ri,xt=ti,Qt=Ri}}let rt=L,ut=se;this.f&&this.h>0&&(rt-=this.c,rt===0&&(ut-=this.e)),this.g[this.h++]=rt,this.g[this.h++]=ut,this.g[this.h++]=Te,this.g[this.h++]=Ge,this.g[this.h++]=Je,this.c=L,this.e=se}static o(L){const se=[],Te=L.length/5|0;for(let ut=0;ut<Te;ut++)se[ut]=ut;se.sort((ut,zt)=>{const xt=L[5*ut],Qt=L[5*zt];if(xt===Qt){const Zt=L[5*ut+1],ti=L[5*zt+1];return Zt-ti}return xt-Qt});const Ge=new Uint32Array(L.length);let Je=0,rt=0;for(let ut=0;ut<Te;ut++){const zt=5*se[ut],xt=L[zt+0],Qt=L[zt+1],Zt=L[zt+2],ti=L[zt+3],Ri=L[zt+4],Rn=xt-Je,Kn=Rn===0?Qt-rt:Qt,Oi=5*ut;Ge[Oi+0]=Rn,Ge[Oi+1]=Kn,Ge[Oi+2]=Zt,Ge[Oi+3]=ti,Ge[Oi+4]=Ri,Je=xt,rt=Qt}return Ge}build(L){return this.f?new Ue(new Uint32Array(this.g),L):new Ue(gi.o(this.g),L)}}e.SemanticTokensBuilder=gi;class Ue{constructor(L,se){this.resultId=se,this.data=L}}e.SemanticTokens=Ue;class Jt{constructor(L,se,Te){this.start=L,this.deleteCount=se,this.data=Te}}e.SemanticTokensEdit=Jt;class Yi{constructor(L,se){this.resultId=se,this.edits=L}}e.SemanticTokensEdits=Yi;var ft;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(ft||(e.DebugConsoleMode=ft={}));let Ti=e.QuickInputButtons=class{constructor(){}};Ti.Back={iconPath:new Yt("arrow-left")},e.QuickInputButtons=Ti=xe([ee],Ti);var Ji;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(Ji||(e.QuickPickItemKind=Ji={}));var Pi;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(Pi||(e.InputBoxValidationSeverity=Pi={}));var _i;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class pi{static validate(L){if(typeof L.badge=="string"){let se=(0,R.nextCharLength)(L.badge,0);if(se<L.badge.length&&(se+=(0,R.nextCharLength)(L.badge,se)),L.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!Yt.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,se,Te){this.badge=L,this.tooltip=se,this.color=Te}}e.FileDecoration=pi;let Zi=e.ColorTheme=class{constructor(L){this.kind=L}};e.ColorTheme=Zi=xe([ee],Zi);var en;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class _t{static isNotebookRange(L){return L instanceof _t?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,se){if(L<0)throw(0,k.illegalArgument)("start must be positive");if(se<0)throw(0,k.illegalArgument)("end must be positive");L<=se?(this.c=L,this.e=se):(this.c=se,this.e=L)}with(L){let se=this.c,Te=this.e;return L.start!==void 0&&(se=L.start),L.end!==void 0&&(Te=L.end),se===this.c&&Te===this.e?this:new _t(se,Te)}}e.NotebookRange=_t;class li{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(se=>li.isNotebookCellData(se))}static isNotebookCellData(L){return!0}constructor(L,se,Te,Ge,Je,rt,ut){this.kind=L,this.value=se,this.languageId=Te,this.mime=Ge,this.outputs=Je??[],this.metadata=rt,this.executionSummary=ut,li.validate(this)}}e.NotebookCellData=li;class ln{constructor(L){this.cells=L}}e.NotebookData=ln;class jt{static isNotebookCellOutputItem(L){return L instanceof jt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const se={name:L.name,message:L.message,stack:L.stack};return jt.json(se,"application/vnd.code.notebook.error")}static stdout(L){return jt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return jt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,se="application/octet-stream"){return new jt(L,se)}static text(L,se=F.Mimes.text){const Te=Fe(jt,n,"f",l).encode(String(L));return new jt(Te,se)}static json(L,se="text/x-json"){const Te=JSON.stringify(L,void 0,"	");return jt.text(Te,se)}constructor(L,se){this.data=L,this.mime=se;const Te=(0,F.normalizeMimeType)(se,!0);if(!Te)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=jt,n=jt,l={value:new TextEncoder};class vi{static isNotebookCellOutput(L){return L instanceof vi?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,se=!1){const Te=new Set,Ge=new Set;for(let Je=0;Je<L.length;Je++){const rt=L[Je],ut=(0,F.normalizeMimeType)(rt.mime);if(!Te.has(ut)||(0,g.isTextStreamMime)(ut)){Te.add(ut);continue}Ge.add(Je),se&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Ge.size===0?L:L.filter((Je,rt)=>!Ge.has(rt))}constructor(L,se,Te){this.items=vi.ensureUniqueMimeTypes(L,!0),typeof se=="string"?(this.id=se,this.metadata=Te):(this.id=(0,O.generateUuid)(),this.metadata=se??Te)}}e.NotebookCellOutput=vi;var tn;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var sn;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class dn{constructor(L,se){this.text=L,this.alignment=se}}e.NotebookCellStatusBarItem=dn;var on;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(on||(e.NotebookControllerAffinity=on={}));var re;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred",$[$.Hidden=-1]="Hidden"})(re||(e.NotebookControllerAffinity2=re={}));class me{constructor(L,se=[]){this.uri=L,this.provides=(0,i.asArray)(se)}}e.NotebookRendererScript=me;class Le{constructor(L){this.label=L}}e.NotebookKernelSourceAction=Le;let nt=e.TimelineItem=class{constructor(L,se){this.label=L,this.timestamp=se}};e.TimelineItem=nt=xe([ee],nt);var It;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(It||(e.ExtensionMode=It={}));var Rt;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(Rt||(e.ExtensionRuntime=Rt={}));var mn;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(mn||(e.StandardTokenType=mn={}));class Nn{constructor(L,se){this.ranges=L,this.wordPattern=se}}e.LinkedEditingRanges=Nn;class Un{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.PortAttributes=Un;var gn;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(gn||(e.TestResultState=gn={}));var pn;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(pn||(e.TestRunProfileKind=pn={}));let hn=e.TestRunRequest=class{constructor(L=void 0,se=void 0,Te=void 0,Ge=!1){this.include=L,this.exclude=se,this.profile=Te,this.continuous=Ge}};e.TestRunRequest=hn=xe([ee],hn);let vn=e.TestRunRequest2=class extends hn{};e.TestRunRequest2=vn=xe([ee],vn);let bn=e.TestMessage=z=class{static diff(L,se,Te){const Ge=new z(L);return Ge.expectedOutput=se,Ge.actualOutput=Te,Ge}constructor(L){this.message=L}};e.TestMessage=bn=z=xe([ee],bn);let En=e.TestTag=class{constructor(L){this.id=L}};e.TestTag=En=xe([ee],En);let Ai=e.CoveredCount=class{constructor(L,se){this.covered=L,this.total=se}};e.CoveredCount=Ai=xe([ee],Ai);let wn=e.FileCoverage=V=class{static fromDetails(L,se){const Te=new Ai(0,0),Ge=new Ai(0,0),Je=new Ai(0,0);for(const ut of se)if("branches"in ut){Te.total+=1,Te.covered+=ut.executionCount>0?1:0;for(const zt of ut.branches)Ge.total+=1,Ge.covered+=zt.executionCount>0?1:0}else Je.total+=1,Je.covered+=ut.executionCount>0?1:0;const rt=new V(L,Te,Ge.total>0?Ge:void 0,Je.total>0?Je:void 0);return rt.detailedCoverage=se,rt}constructor(L,se,Te,Ge){this.uri=L,this.statementCoverage=se,this.branchCoverage=Te,this.functionCoverage=Ge}};e.FileCoverage=wn=V=xe([ee],wn);let Sn=e.StatementCoverage=class{constructor(L,se,Te=[]){this.executionCount=L,this.location=se,this.branches=Te}};e.StatementCoverage=Sn=xe([ee],Sn);let yn=e.BranchCoverage=class{constructor(L,se){this.executionCount=L,this.location=se}};e.BranchCoverage=yn=xe([ee],yn);let Dn=e.FunctionCoverage=class{constructor(L,se){this.executionCount=L,this.location=se}};e.FunctionCoverage=Dn=xe([ee],Dn);var In;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(In||(e.ExternalUriOpenerPriority=In={}));var kn;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(kn||(e.WorkspaceTrustState=kn={}));var Cn;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(Cn||(e.PortAutoForwardAction=Cn={}));class $n{constructor(L,se,Te,Ge,Je,rt){this.kind=L,this.name=se,this.detail=Te,this.uri=Ge,this.range=Je,this.selectionRange=rt}}e.TypeHierarchyItem=$n;class zn{constructor(L){this.uri=L}}e.TextTabInput=zn;class Bn{constructor(L,se){this.original=L,this.modified=se}}e.TextDiffTabInput=Bn;class Wn{constructor(L,se,Te,Ge){this.base=L,this.input1=se,this.input2=Te,this.result=Ge}}e.TextMergeTabInput=Wn;class Hn{constructor(L,se){this.uri=L,this.viewType=se}}e.CustomEditorTabInput=Hn;class Vn{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=Vn;class jn{constructor(L,se){this.uri=L,this.notebookType=se}}e.NotebookEditorTabInput=jn;class qn{constructor(L,se,Te){this.original=L,this.modified=se,this.notebookType=Te}}e.NotebookDiffEditorTabInput=qn;class xn{constructor(){}}e.TerminalEditorTabInput=xn;class Gn{constructor(L,se){this.uri=L,this.inputBoxUri=se}}e.InteractiveWindowInput=Gn;var Tn;(function($){$[$.Up=1]="Up",$[$.Down=2]="Down"})(Tn||(e.InteractiveSessionVoteDirection=Tn={}));var Pn;(function($){$[$.Action=1]="Action",$[$.Toolbar=2]="Toolbar"})(Pn||(e.InteractiveSessionCopyKind=Pn={}));var An;(function($){$[$.Unhelpful=0]="Unhelpful",$[$.Helpful=1]="Helpful",$[$.Undone=2]="Undone"})(An||(e.InteractiveEditorResponseFeedbackKind=An={}))}),define(Re[103],Oe([1,0,49,15,13,271,136,7,18]),function(te,e,i,k,D,N,F,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const m=new Map;function O(g,d){d?m.set(g,d):m.delete(g)}e.setWordDefinitionFor=O;function w(g){return m.get(g)}class c extends N.MirrorTextModel{constructor(d,t,u,h,y,C,v,n){super(t,u,h,y),this.c=d,this.m=C,this.q=v,this.notebook=n,this.b=!1}dispose(){(0,i.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,S.equals)(this.f,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.d},get fileName(){return d.d.fsPath},get isUntitled(){return d.d.scheme===k.Schemas.untitled},get languageId(){return d.m},get version(){return d.h},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(t){return t?d.s(t):d.getText()},get eol(){return d.g===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return d.f.length},lineAt(t){return d.t(t)},offsetAt(t){return d.u(t)},positionAt(t){return d.v(t)},validateRange(t){return d.w(t)},validatePosition(t){return d.x(t)},getWordRangeAtPosition(t,u){return d.y(t,u)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,i.ok)(!this.b),this.m=d}_acceptIsDirty(d){(0,i.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(d){const t=this.w(d);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const u=this.g,h=t.start.line,y=t.end.line,C=[];C.push(this.f[h].substring(t.start.character));for(let v=h+1;v<y;v++)C.push(this.f[v]);return C.push(this.f[y].substring(0,t.end.character)),C.join(u)}t(d){let t;if(d instanceof R.Position?t=d.line:typeof d=="number"&&(t=d),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new p(t,this.f[t],t===this.f.length-1)}u(d){return d=this.x(d),this.l(),this.j.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.l();const t=this.j.getIndexOf(d),u=this.f[t.index].length;return new R.Position(t.index,Math.min(t.remainder,u))}w(d){if(!(d instanceof R.Range))throw new Error("Invalid argument");const t=this.x(d.start),u=this.x(d.end);return t===d.start&&u===d.end?d:new R.Range(t.line,t.character,u.line,u.character)}x(d){if(!(d instanceof R.Position))throw new Error("Invalid argument");if(this.f.length===0)return d.with(0,0);let{line:t,character:u}=d,h=!1;if(t<0)t=0,u=0,h=!0;else if(t>=this.f.length)t=this.f.length-1,u=this.f[t].length,h=!0;else{const y=this.f[t].length;u<0?(u=0,h=!0):u>y&&(u=y,h=!0)}return h?new R.Position(t,u):d}y(d,t){const u=this.x(d);if(!t)t=w(this.m);else if((0,D.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const h=(0,F.getWordAtText)(u.character+1,(0,F.ensureValidWordDefinition)(t),this.f[u.line],0);if(h)return new R.Range(u.line,h.startColumn-1,u.line,h.endColumn-1)}}e.ExtHostDocumentData=c;class p{constructor(d,t,u){this.a=d,this.b=t,this.c=u}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=p}),define(Re[202],Oe([1,0,7,17,5]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let N=e.ExtHostTheming=class{constructor(R){this.a=new i.ColorTheme(i.ColorThemeKind.Dark),this.b=new D.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(R){let S;switch(R){case"light":S=i.ColorThemeKind.Light;break;case"hcDark":S=i.ColorThemeKind.HighContrast;break;case"hcLight":S=i.ColorThemeKind.HighContrastLight;break;default:S=i.ColorThemeKind.Dark}this.a=new i.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.ExtHostTheming=N=xe([Ve(0,k.IExtHostRpcService)],N)}),define(Re[8],Oe([1,0,18,24,120,203,89,28,116,68,67,26,9,2,44,78,94,100,99,74,45,56,199,7]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t,u,h,y,C,v,n,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Ae){function Ee(Y){const{selectionStartLineNumber:Me,selectionStartColumn:ze,positionLineNumber:Xe,positionColumn:He}=Y,et=new l.Position(Me-1,ze-1),wt=new l.Position(Xe-1,He-1);return new l.Selection(et,wt)}Ae.to=Ee;function ve(Y){const{anchor:Me,active:ze}=Y;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Ae.from=ve})(r||(e.Selection=r={}));var a;(function(Ae){function Ee(Y){if(!Y)return;const{start:Me,end:ze}=Y;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Ae.from=Ee;function ve(Y){if(!Y)return;const{startLineNumber:Me,startColumn:ze,endLineNumber:Xe,endColumn:He}=Y;return new l.Range(Me-1,ze-1,Xe-1,He-1)}Ae.to=ve})(a||(e.Range=a={}));var b;(function(Ae){function Ee(ve){switch(ve){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Ae.to=Ee})(b||(e.TokenType=b={}));var I;(function(Ae){function Ee(Y){return new l.Position(Y.lineNumber-1,Y.column-1)}Ae.to=Ee;function ve(Y){return{lineNumber:Y.line+1,column:Y.character+1}}Ae.from=ve})(I||(e.Position=I={}));var f;(function(Ae){function Ee(Me,ze,Xe){return(0,i.coalesce)((0,i.asArray)(Me).map(He=>ve(He,ze,Xe)))}Ae.from=Ee;function ve(Me,ze,Xe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Xe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:Y(Me.scheme,ze),pattern:J.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Xe?.isBuiltin}}function Y(Me,ze){return ze&&typeof Me=="string"?ze.transformOutgoingScheme(Me):Me}})(f||(e.DocumentSelector=f={}));var P;(function(Ae){function Ee(Y){switch(Y){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Ae.from=Ee;function ve(Y){switch(Y){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Ae.to=ve})(P||(e.DiagnosticTag=P={}));var E;(function(Ae){function Ee(Y){let Me;return Y.code&&((0,c.isString)(Y.code)||(0,c.isNumber)(Y.code)?Me=String(Y.code):Me={value:String(Y.code.value),target:Y.code.target}),{...a.from(Y.range),message:Y.message,source:Y.source,code:Me,severity:s.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(o.from),tags:Array.isArray(Y.tags)?(0,i.coalesce)(Y.tags.map(P.from)):void 0}}Ae.from=Ee;function ve(Y){const Me=new l.Diagnostic(a.to(Y),Y.message,s.to(Y.severity));return Me.source=Y.source,Me.code=(0,c.isString)(Y.code)?Y.code:Y.code?.value,Me.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(o.to),Me.tags=Y.tags&&(0,i.coalesce)(Y.tags.map(P.to)),Me}Ae.to=ve})(E||(e.Diagnostic=E={}));var o;(function(Ae){function Ee(Y){return{...a.from(Y.location.range),message:Y.message,resource:Y.location.uri}}Ae.from=Ee;function ve(Y){return new l.DiagnosticRelatedInformation(new l.Location(Y.resource,a.to(Y)),Y.message)}Ae.to=ve})(o||(e.DiagnosticRelatedInformation=o={}));var s;(function(Ae){function Ee(Y){switch(Y){case l.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ae.from=Ee;function ve(Y){switch(Y){case t.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Ae.to=ve})(s||(e.DiagnosticSeverity=s={}));var M;(function(Ae){function Ee(Y){return typeof Y=="number"&&Y>=l.ViewColumn.One?Y-1:Y===l.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}Ae.from=Ee;function ve(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=ve})(M||(e.ViewColumn=M={}));function B(Ae){return typeof Ae.range<"u"}function X(Ae){return Ae.length===0?!0:!!B(Ae[0])}e.isDecorationOptionsArr=X;var G;(function(Ae){function Ee(He){return He.map(Ae.from)}Ae.fromMany=Ee;function ve(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function Y(He){let et;if(ve(He)){const{language:vt,value:ot}=He;et={value:"```"+vt+`
`+ot+"\n```\n"}}else l.MarkdownString.isMarkdownString(He)?et={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?et={value:He}:et={value:""};const wt=Object.create(null);et.uris=wt;const At=vt=>{try{let ot=p.URI.parse(vt,!0);ot=ot.with({query:Me(ot.query,wt)}),wt[vt]=ot}catch{}return""},Tt=new S.marked.Renderer;return Tt.link=At,Tt.image=vt=>typeof vt=="string"?At(F.parseHrefAndDimensions(vt).href):"",(0,S.marked)(et.value,{renderer:Tt}),et}Ae.from=Y;function Me(He,et){if(!He)return He;let wt;try{wt=(0,m.parse)(He)}catch{}if(!wt)return He;let At=!1;return wt=(0,w.cloneAndChange)(wt,Tt=>{if(p.URI.isUri(Tt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[vt]=Tt,At=!0,vt}else return}),At?JSON.stringify(wt):He}function ze(He){const et=new l.MarkdownString(He.value,He.supportThemeIcons);return et.isTrusted=He.isTrusted,et.supportHtml=He.supportHtml,et.baseUri=He.baseUri?p.URI.from(He.baseUri):void 0,et}Ae.to=ze;function Xe(He){if(He)return typeof He=="string"?He:Ae.from(He)}Ae.fromStrict=Xe})(G||(e.MarkdownString=G={}));function W(Ae){return X(Ae)?Ae.map(Ee=>({range:a.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?G.fromMany(Ee.hoverMessage):Ee.hoverMessage?G.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):Ae.map(Ee=>({range:a.from(Ee)}))}e.fromRangeOrRangeWithMessage=W;function U(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?p.URI.file(Ae):Ae}e.pathOrURIToURI=U;var q;(function(Ae){function Ee(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?U(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Ae.from=Ee})(q||(e.ThemableDecorationAttachmentRenderOptions=q={}));var z;(function(Ae){function Ee(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?U(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?q.from(ve.before):void 0,after:ve.after?q.from(ve.after):void 0}}Ae.from=Ee})(z||(e.ThemableDecorationRenderOptions=z={}));var V;(function(Ae){function Ee(ve){if(typeof ve>"u")return ve;switch(ve){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Ee})(V||(e.DecorationRangeBehavior=V={}));var ee;(function(Ae){function Ee(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?V.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?z.from(ve.light):void 0,dark:ve.dark?z.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?U(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?q.from(ve.before):void 0,after:ve.after?q.from(ve.after):void 0}}Ae.from=Ee})(ee||(e.DecorationRenderOptions=ee={}));var Ce;(function(Ae){function Ee(Y){return{text:Y.newText,eol:Y.newEol&&it.from(Y.newEol),range:a.from(Y.range)}}Ae.from=Ee;function ve(Y){const Me=new l.TextEdit(a.to(Y.range),Y.text);return Me.newEol=typeof Y.eol>"u"?void 0:it.to(Y.eol),Me}Ae.to=ve})(Ce||(e.TextEdit=Ce={}));var oe;(function(Ae){function Ee(Y,Me){const ze={edits:[]};if(Y instanceof l.WorkspaceEdit){const Xe=new R.ResourceSet;for(const He of Y._allEntries())He._type===1&&p.URI.isUri(He.to)&&He.from===void 0&&Xe.add(He.to);for(const He of Y._allEntries())if(He._type===1){let et;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?et={type:"base64",value:(0,k.encodeBase64)(k.VSBuffer.wrap(He.options.contents))}:et={type:"dataTransferItem",id:He.options.contents._itemId}),ze.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:et},metadata:He.metadata})}else He._type===2?ze.edits.push({resource:He.uri,textEdit:Ce.from(He.edit),versionId:Xe.has(He.uri)?void 0:Me?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?ze.edits.push({resource:He.uri,textEdit:{range:a.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Xe.has(He.uri)?void 0:Me?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?ze.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(He.uri)}):He._type===5&&ze.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Me?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(mt.from)}})}return ze}Ae.from=Ee;function ve(Y){const Me=new l.WorkspaceEdit,ze=new R.ResourceMap;for(const Xe of Y.edits)if(Xe.textEdit){const He=Xe,et=p.URI.revive(He.resource),wt=a.to(He.textEdit.range),At=He.textEdit.text,Tt=He.textEdit.insertAsSnippet;let vt;Tt?vt=l.SnippetTextEdit.replace(wt,new l.SnippetString(At)):vt=l.TextEdit.replace(wt,At);const ot=ze.get(et);ot?ot.push(vt):ze.set(et,[vt])}else Me.renameFile(p.URI.revive(Xe.oldResource),p.URI.revive(Xe.newResource),Xe.options);for(const[Xe,He]of ze)Me.set(Xe,He);return Me}Ae.to=ve})(oe||(e.WorkspaceEdit=oe={}));var le;(function(Ae){const Ee=Object.create(null);Ee[l.SymbolKind.File]=0,Ee[l.SymbolKind.Module]=1,Ee[l.SymbolKind.Namespace]=2,Ee[l.SymbolKind.Package]=3,Ee[l.SymbolKind.Class]=4,Ee[l.SymbolKind.Method]=5,Ee[l.SymbolKind.Property]=6,Ee[l.SymbolKind.Field]=7,Ee[l.SymbolKind.Constructor]=8,Ee[l.SymbolKind.Enum]=9,Ee[l.SymbolKind.Interface]=10,Ee[l.SymbolKind.Function]=11,Ee[l.SymbolKind.Variable]=12,Ee[l.SymbolKind.Constant]=13,Ee[l.SymbolKind.String]=14,Ee[l.SymbolKind.Number]=15,Ee[l.SymbolKind.Boolean]=16,Ee[l.SymbolKind.Array]=17,Ee[l.SymbolKind.Object]=18,Ee[l.SymbolKind.Key]=19,Ee[l.SymbolKind.Null]=20,Ee[l.SymbolKind.EnumMember]=21,Ee[l.SymbolKind.Struct]=22,Ee[l.SymbolKind.Event]=23,Ee[l.SymbolKind.Operator]=24,Ee[l.SymbolKind.TypeParameter]=25;function ve(Me){return typeof Ee[Me]=="number"?Ee[Me]:6}Ae.from=ve;function Y(Me){for(const ze in Ee)if(Ee[ze]===Me)return Number(ze);return l.SymbolKind.Property}Ae.to=Y})(le||(e.SymbolKind=le={}));var Q;(function(Ae){function Ee(Y){switch(Y){case l.SymbolTag.Deprecated:return 1}}Ae.from=Ee;function ve(Y){switch(Y){case 1:return l.SymbolTag.Deprecated}}Ae.to=ve})(Q||(e.SymbolTag=Q={}));var ue;(function(Ae){function Ee(Y){return{name:Y.name,kind:le.from(Y.kind),tags:Y.tags&&Y.tags.map(Q.from),containerName:Y.containerName,location:K.from(Y.location)}}Ae.from=Ee;function ve(Y){const Me=new l.SymbolInformation(Y.name,le.to(Y.kind),Y.containerName,K.to(Y.location));return Me.tags=Y.tags&&Y.tags.map(Q.to),Me}Ae.to=ve})(ue||(e.WorkspaceSymbol=ue={}));var Ie;(function(Ae){function Ee(Y){const Me={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:a.from(Y.range),selectionRange:a.from(Y.selectionRange),kind:le.from(Y.kind),tags:Y.tags?.map(Q.from)??[]};return Y.children&&(Me.children=Y.children.map(Ee)),Me}Ae.from=Ee;function ve(Y){const Me=new l.DocumentSymbol(Y.name,Y.detail,le.to(Y.kind),a.to(Y.range),a.to(Y.selectionRange));return(0,i.isNonEmptyArray)(Y.tags)&&(Me.tags=Y.tags.map(Q.to)),Y.children&&(Me.children=Y.children.map(ve)),Me}Ae.to=ve})(Ie||(e.DocumentSymbol=Ie={}));var Pe;(function(Ae){function Ee(Y){const Me=new l.CallHierarchyItem(le.to(Y.kind),Y.name,Y.detail||"",p.URI.revive(Y.uri),a.to(Y.range),a.to(Y.selectionRange));return Me._sessionId=Y._sessionId,Me._itemId=Y._itemId,Me}Ae.to=Ee;function ve(Y,Me,ze){if(Me=Me??Y._sessionId,ze=ze??Y._itemId,Me===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:ze,name:Y.name,detail:Y.detail,kind:le.from(Y.kind),uri:Y.uri,range:a.from(Y.range),selectionRange:a.from(Y.selectionRange),tags:Y.tags?.map(Q.from)}}Ae.from=ve})(Pe||(e.CallHierarchyItem=Pe={}));var be;(function(Ae){function Ee(ve){return new l.CallHierarchyIncomingCall(Pe.to(ve.from),ve.fromRanges.map(Y=>a.to(Y)))}Ae.to=Ee})(be||(e.CallHierarchyIncomingCall=be={}));var A;(function(Ae){function Ee(ve){return new l.CallHierarchyOutgoingCall(Pe.to(ve.to),ve.fromRanges.map(Y=>a.to(Y)))}Ae.to=Ee})(A||(e.CallHierarchyOutgoingCall=A={}));var K;(function(Ae){function Ee(Y){return{range:Y.range&&a.from(Y.range),uri:Y.uri}}Ae.from=Ee;function ve(Y){return new l.Location(p.URI.revive(Y.uri),a.to(Y.range))}Ae.to=ve})(K||(e.location=K={}));var he;(function(Ae){function Ee(Y){const Me=Y,ze=Y;return{originSelectionRange:Me.originSelectionRange?a.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:ze.uri,range:a.from(Me.targetRange?Me.targetRange:ze.range),targetSelectionRange:Me.targetSelectionRange?a.from(Me.targetSelectionRange):void 0}}Ae.from=Ee;function ve(Y){return{targetUri:p.URI.revive(Y.uri),targetRange:a.to(Y.range),targetSelectionRange:Y.targetSelectionRange?a.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?a.to(Y.originSelectionRange):void 0}}Ae.to=ve})(he||(e.DefinitionLink=he={}));var De;(function(Ae){function Ee(Y){return{range:a.from(Y.range),contents:G.fromMany(Y.contents)}}Ae.from=Ee;function ve(Y){return new l.Hover(Y.contents.map(G.to),a.to(Y.range))}Ae.to=ve})(De||(e.Hover=De={}));var we;(function(Ae){function Ee(Y){return{range:a.from(Y.range),expression:Y.expression}}Ae.from=Ee;function ve(Y){return new l.EvaluatableExpression(a.to(Y.range),Y.expression)}Ae.to=ve})(we||(e.EvaluatableExpression=we={}));var ge;(function(Ae){function Ee(Y){if(Y instanceof l.InlineValueText)return{type:"text",range:a.from(Y.range),text:Y.text};if(Y instanceof l.InlineValueVariableLookup)return{type:"variable",range:a.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Ee;function ve(Y){switch(Y.type){case"text":return{range:a.to(Y.range),text:Y.text};case"variable":return{range:a.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:a.to(Y.range),expression:Y.expression}}}Ae.to=ve})(ge||(e.InlineValue=ge={}));var ke;(function(Ae){function Ee(Y){return{frameId:Y.frameId,stoppedLocation:a.from(Y.stoppedLocation)}}Ae.from=Ee;function ve(Y){return new l.InlineValueContext(Y.frameId,a.to(Y.stoppedLocation))}Ae.to=ve})(ke||(e.InlineValueContext=ke={}));var ae;(function(Ae){function Ee(Y){return{range:a.from(Y.range),kind:Y.kind}}Ae.from=Ee;function ve(Y){return new l.DocumentHighlight(a.to(Y.range),Y.kind)}Ae.to=ve})(ae||(e.DocumentHighlight=ae={}));var de;(function(Ae){function Ee(ve){switch(ve){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Ae.to=Ee})(de||(e.CompletionTriggerKind=de={}));var Z;(function(Ae){function Ee(ve){return{triggerKind:de.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Ae.to=Ee})(Z||(e.CompletionContext=Z={}));var ne;(function(Ae){function Ee(Y){switch(Y){case l.CompletionItemTag.Deprecated:return 1}}Ae.from=Ee;function ve(Y){switch(Y){case 1:return l.CompletionItemTag.Deprecated}}Ae.to=ve})(ne||(e.CompletionItemTag=ne={}));var T;(function(Ae){const Ee=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function ve(ze){return Ee.get(ze)??9}Ae.from=ve;const Y=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Me(ze){return Y.get(ze)??l.CompletionItemKind.Property}Ae.to=Me})(T||(e.CompletionItemKind=T={}));var H;(function(Ae){function Ee(ve,Y){const Me=new l.CompletionItem(ve.label);return Me.insertText=ve.insertText,Me.kind=T.to(ve.kind),Me.tags=ve.tags?.map(ne.to),Me.detail=ve.detail,Me.documentation=F.isMarkdownString(ve.documentation)?G.to(ve.documentation):ve.documentation,Me.sortText=ve.sortText,Me.filterText=ve.filterText,Me.preselect=ve.preselect,Me.commitCharacters=ve.commitCharacters,g.Range.isIRange(ve.range)?Me.range=a.to(ve.range):typeof ve.range=="object"&&(Me.range={inserting:a.to(ve.range.insert),replacing:a.to(ve.range.replace)}),Me.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Me.insertText=new l.SnippetString(ve.insertText):(Me.insertText=ve.insertText,Me.textEdit=Me.range instanceof l.Range?new l.TextEdit(Me.range,Me.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Me.additionalTextEdits=ve.additionalTextEdits.map(ze=>Ce.to(ze))),Me.command=Y&&ve.command?Y.fromInternal(ve.command):void 0,Me}Ae.to=Ee})(H||(e.CompletionItem=H={}));var j;(function(Ae){function Ee(Y){if(typeof Y.label!="string"&&!Array.isArray(Y.label))throw new TypeError("Invalid label");return{label:Y.label,documentation:G.fromStrict(Y.documentation)}}Ae.from=Ee;function ve(Y){return{label:Y.label,documentation:F.isMarkdownString(Y.documentation)?G.to(Y.documentation):Y.documentation}}Ae.to=ve})(j||(e.ParameterInformation=j={}));var x;(function(Ae){function Ee(Y){return{label:Y.label,documentation:G.fromStrict(Y.documentation),parameters:Array.isArray(Y.parameters)?Y.parameters.map(j.from):[],activeParameter:Y.activeParameter}}Ae.from=Ee;function ve(Y){return{label:Y.label,documentation:F.isMarkdownString(Y.documentation)?G.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(j.to):[],activeParameter:Y.activeParameter}}Ae.to=ve})(x||(e.SignatureInformation=x={}));var ce;(function(Ae){function Ee(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(x.from):[]}}Ae.from=Ee;function ve(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(x.to):[]}}Ae.to=ve})(ce||(e.SignatureHelp=ce={}));var pe;(function(Ae){function Ee(ve,Y){const Me=new l.InlayHint(I.to(Y.position),typeof Y.label=="string"?Y.label:Y.label.map(ie.to.bind(void 0,ve)),Y.kind&&ye.to(Y.kind));return Me.textEdits=Y.textEdits&&Y.textEdits.map(Ce.to),Me.tooltip=F.isMarkdownString(Y.tooltip)?G.to(Y.tooltip):Y.tooltip,Me.paddingLeft=Y.paddingLeft,Me.paddingRight=Y.paddingRight,Me}Ae.to=Ee})(pe||(e.InlayHint=pe={}));var ie;(function(Ae){function Ee(ve,Y){const Me=new l.InlayHintLabelPart(Y.label);return Me.tooltip=F.isMarkdownString(Y.tooltip)?G.to(Y.tooltip):Y.tooltip,d.Command.is(Y.command)&&(Me.command=ve.fromInternal(Y.command)),Y.location&&(Me.location=K.to(Y.location)),Me}Ae.to=Ee})(ie||(e.InlayHintLabelPart=ie={}));var ye;(function(Ae){function Ee(Y){return Y}Ae.from=Ee;function ve(Y){return Y}Ae.to=ve})(ye||(e.InlayHintKind=ye={}));var Se;(function(Ae){function Ee(Y){return{range:a.from(Y.range),url:Y.target,tooltip:Y.tooltip}}Ae.from=Ee;function ve(Y){let Me;if(Y.url)try{Me=typeof Y.url=="string"?p.URI.parse(Y.url,!0):p.URI.revive(Y.url)}catch{}return new l.DocumentLink(a.to(Y.range),Me)}Ae.to=ve})(Se||(e.DocumentLink=Se={}));var Be;(function(Ae){function Ee(Y){const Me=new l.ColorPresentation(Y.label);return Y.textEdit&&(Me.textEdit=Ce.to(Y.textEdit)),Y.additionalTextEdits&&(Me.additionalTextEdits=Y.additionalTextEdits.map(ze=>Ce.to(ze))),Me}Ae.to=Ee;function ve(Y){return{label:Y.label,textEdit:Y.textEdit?Ce.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Me=>Ce.from(Me)):void 0}}Ae.from=ve})(Be||(e.ColorPresentation=Be={}));var je;(function(Ae){function Ee(Y){return new l.Color(Y[0],Y[1],Y[2],Y[3])}Ae.to=Ee;function ve(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}Ae.from=ve})(je||(e.Color=je={}));var Ze;(function(Ae){function Ee(Y){return{range:a.from(Y.range)}}Ae.from=Ee;function ve(Y){return new l.SelectionRange(a.to(Y.range))}Ae.to=ve})(Ze||(e.SelectionRange=Ze={}));var Qe;(function(Ae){function Ee(ve){switch(ve){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Ae.to=Ee})(Qe||(e.TextDocumentSaveReason=Qe={}));var Ke;(function(Ae){function Ee(Y){switch(Y){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Ee;function ve(Y){switch(Y){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Ae.to=ve})(Ke||(e.TextEditorLineNumbersStyle=Ke={}));var it;(function(Ae){function Ee(Y){if(Y===l.EndOfLine.CRLF)return 1;if(Y===l.EndOfLine.LF)return 0}Ae.from=Ee;function ve(Y){if(Y===1)return l.EndOfLine.CRLF;if(Y===0)return l.EndOfLine.LF}Ae.to=ve})(it||(e.EndOfLine=it={}));var st;(function(Ae){function Ee(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Ee})(st||(e.ProgressLocation=st={}));var tt;(function(Ae){function Ee(Y){const Me={start:Y.start+1,end:Y.end+1};return Y.kind&&(Me.kind=Ne.from(Y.kind)),Me}Ae.from=Ee;function ve(Y){const Me={start:Y.start-1,end:Y.end-1};return Y.kind&&(Me.kind=Ne.to(Y.kind)),Me}Ae.to=ve})(tt||(e.FoldingRange=tt={}));var Ne;(function(Ae){function Ee(Y){if(Y)switch(Y){case l.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Ae.from=Ee;function ve(Y){if(Y)switch(Y.value){case d.FoldingRangeKind.Comment.value:return l.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports.value:return l.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region.value:return l.FoldingRangeKind.Region}}Ae.to=ve})(Ne||(e.FoldingRangeKind=Ne={}));var dt;(function(Ae){function Ee(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?a.from(ve.selection):void 0,override:typeof ve.override=="boolean"?h.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Ee})(dt||(e.TextEditorOpenOptions=dt={}));var J;(function(Ae){function Ee(ze){return ze instanceof l.RelativePattern?ze.toJSON():typeof ze=="string"?ze:ve(ze)||Y(ze)?new l.RelativePattern(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Ae.from=Ee;function ve(ze){const Xe=ze;return Xe?p.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function Y(ze){const Xe=ze;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Me(ze){return typeof ze=="string"?ze:new l.RelativePattern(p.URI.revive(ze.baseUri),ze.pattern)}Ae.to=Me})(J||(e.GlobPattern=J={}));var _;(function(Ae){function Ee(ve){if(ve){if(Array.isArray(ve))return ve.map(Ee);if(typeof ve=="string")return ve;{const Y=ve;return{language:Y.language,scheme:Y.scheme,pattern:J.from(Y.pattern),exclusive:Y.exclusive,notebookType:Y.notebookType}}}else return}Ae.from=Ee})(_||(e.LanguageSelector=_={}));var fe;(function(Ae){function Ee(Y){return{start:Y.start,end:Y.end}}Ae.from=Ee;function ve(Y){return new l.NotebookRange(Y.start,Y.end)}Ae.to=ve})(fe||(e.NotebookRange=fe={}));var $e;(function(Ae){function Ee(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}Ae.to=Ee;function ve(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}Ae.from=ve})($e||(e.NotebookCellExecutionSummary=$e={}));var qe;(function(Ae){function Ee(ve){if(ve===y.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(ve===y.NotebookCellExecutionState.Pending)return;if(ve===y.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Ae.to=Ee})(qe||(e.NotebookCellExecutionState=qe={}));var We;(function(Ae){function Ee(Y){switch(Y){case l.NotebookCellKind.Markup:return y.CellKind.Markup;case l.NotebookCellKind.Code:default:return y.CellKind.Code}}Ae.from=Ee;function ve(Y){switch(Y){case y.CellKind.Markup:return l.NotebookCellKind.Markup;case y.CellKind.Code:default:return l.NotebookCellKind.Code}}Ae.to=ve})(We||(e.NotebookCellKind=We={}));var _e;(function(Ae){function Ee(Y){const Me={metadata:Y.metadata??Object.create(null),cells:[]};for(const ze of Y.cells)l.NotebookCellData.validate(ze),Me.cells.push(mt.from(ze));return Me}Ae.from=Ee;function ve(Y){const Me=new l.NotebookData(Y.cells.map(mt.to));return(0,c.isEmptyObject)(Y.metadata)||(Me.metadata=Y.metadata),Me}Ae.to=ve})(_e||(e.NotebookData=_e={}));var mt;(function(Ae){function Ee(Y){return{cellKind:We.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:$e.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(kt.from):[]}}Ae.from=Ee;function ve(Y){return new l.NotebookCellData(We.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(kt.to):void 0,Y.metadata,Y.internalMetadata?$e.to(Y.internalMetadata):void 0)}Ae.to=ve})(mt||(e.NotebookCellData=mt={}));var St;(function(Ae){function Ee(Y){return{mime:Y.mime,valueBytes:k.VSBuffer.wrap(Y.data)}}Ae.from=Ee;function ve(Y){return new l.NotebookCellOutputItem(Y.valueBytes.buffer,Y.mime)}Ae.to=ve})(St||(e.NotebookCellOutputItem=St={}));var kt;(function(Ae){function Ee(Y){return{outputId:Y.id,items:Y.items.map(St.from),metadata:Y.metadata}}Ae.from=Ee;function ve(Y){const Me=Y.items.map(St.to);return new l.NotebookCellOutput(Me,Y.outputId,Y.metadata)}Ae.to=ve})(kt||(e.NotebookCellOutput=kt={}));var Gt;(function(Ae){function Ee(Me){return Y(Me)?{include:(0,c.withNullAsUndefined)(J.from(Me.include)),exclude:(0,c.withNullAsUndefined)(J.from(Me.exclude))}:(0,c.withNullAsUndefined)(J.from(Me))}Ae.from=Ee;function ve(Me){return Y(Me)?{include:J.to(Me.include),exclude:J.to(Me.exclude)}:J.to(Me)}Ae.to=ve;function Y(Me){const ze=Me;return ze?!(0,c.isUndefinedOrNull)(ze.include)&&!(0,c.isUndefinedOrNull)(ze.exclude):!1}})(Gt||(e.NotebookExclusiveDocumentPattern=Gt={}));var Bt;(function(Ae){function Ee(ve,Y,Me){const ze=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(ze,Me),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Ae.from=Ee})(Bt||(e.NotebookStatusBarItem=Bt={}));var yt;(function(Ae){function Ee(ve,Y,Me){const ze=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:Y.toInternal(ze,Me),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Ae.from=Ee})(yt||(e.NotebookKernelSourceAction=yt={}));var Wt;(function(Ae){function Ee(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Ae.from=Ee})(Wt||(e.NotebookDocumentContentOptions=Wt={}));var Mt;(function(Ae){function Ee(Y){return{uri:Y.uri,provides:Y.provides}}Ae.from=Ee;function ve(Y){return new l.NotebookRendererScript(p.URI.revive(Y.uri),Y.provides)}Ae.to=ve})(Mt||(e.NotebookRendererScript=Mt={}));var qt;(function(Ae){function Ee(Y){return{message:G.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,location:Y.location&&{range:a.from(Y.location.range),uri:Y.location.uri}}}Ae.from=Ee;function ve(Y){const Me=new l.TestMessage(typeof Y.message=="string"?Y.message:G.to(Y.message));return Me.actualOutput=Y.actual,Me.expectedOutput=Y.expected,Me.location=Y.location?K.to(Y.location):void 0,Me}Ae.to=ve})(qt||(e.TestMessage=qt={}));var Ot;(function(Ae){Ae.namespace=v.namespaceTestTag,Ae.denamespace=v.denamespaceTestTag})(Ot||(e.TestTag=Ot={}));var Lt;(function(Ae){function Ee(Y){const Me=(0,u.getPrivateApiFor)(Y).controllerId;return{extId:C.TestId.fromExtHostTestItem(Y,Me).toString(),label:Y.label,uri:p.URI.revive(Y.uri),busy:Y.busy,tags:Y.tags.map(ze=>Ot.namespace(Me,ze.id)),range:g.Range.lift(a.from(Y.range)),description:Y.description||null,sortText:Y.sortText||null,error:Y.error&&G.fromStrict(Y.error)||null}}Ae.from=Ee;function ve(Y){return{parent:void 0,error:void 0,id:C.TestId.fromString(Y.extId).localId,label:Y.label,uri:p.URI.revive(Y.uri),tags:(Y.tags||[]).map(Me=>{const{tagId:ze}=Ot.denamespace(Me);return new l.TestTag(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(Y.range||void 0),canResolveChildren:!1,busy:Y.busy,description:Y.description||void 0,sortText:Y.sortText||void 0}}Ae.toPlain=ve})(Lt||(e.TestItem=Lt={})),function(Ae){function Ee(Y){return{id:Y.id}}Ae.from=Ee;function ve(Y){return new l.TestTag(Y.id)}Ae.to=ve}(Ot||(e.TestTag=Ot={}));var Ht;(function(Ae){const Ee=(Y,Me)=>{const ze=[];for(const[He,et]of Me)C.TestId.compare(et.item.extId,He)===2&&(Me.delete(He),ze.push(et));const Xe={...Lt.toPlain(Y.item),parent:void 0,taskStates:Y.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(et=>et.type===0).map(qt.to)})),children:ze.map(He=>Ee(He,Me))};for(const He of Xe.children)He.parent=Xe;return Xe};function ve(Y){const Me=[],ze=new Map;for(const Xe of Y.items){ze.set(Xe.item.extId,Xe);const He=C.TestId.root(Xe.item.extId);Y.request.targets.some(et=>et.controllerId===He&&et.testIds.includes(Xe.item.extId))&&Me.push(Xe)}return{completedAt:Y.completedAt,results:Me.map(Xe=>Ee(Xe,ze))}}Ae.to=ve})(Ht||(e.TestResults=Ht={}));var at;(function(Ae){function Ee(ze){return{covered:ze.covered,total:ze.covered}}function ve(ze){return"line"in ze?I.from(ze):a.from(ze)}function Y(ze){return"branches"in ze?{count:ze.executionCount,location:ve(ze.location),type:1,branches:ze.branches.length?ze.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&ve(Xe.location)})):void 0}:{type:0,count:ze.executionCount,location:ve(ze.location)}}Ae.fromDetailed=Y;function Me(ze){return{uri:ze.uri,statement:Ee(ze.statementCoverage),branch:ze.branchCoverage&&Ee(ze.branchCoverage),function:ze.functionCoverage&&Ee(ze.functionCoverage),details:ze.detailedCoverage?.map(Y)}}Ae.fromFile=Me})(at||(e.TestCoverage=at={}));var ht;(function(Ae){function Ee(ve){switch(ve){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Ae.to=Ee})(ht||(e.CodeActionTriggerKind=ht={}));var Nt;(function(Ae){function Ee(Y){const Me=new l.TypeHierarchyItem(le.to(Y.kind),Y.name,Y.detail||"",p.URI.revive(Y.uri),a.to(Y.range),a.to(Y.selectionRange));return Me._sessionId=Y._sessionId,Me._itemId=Y._itemId,Me}Ae.to=Ee;function ve(Y,Me,ze){if(Me=Me??Y._sessionId,ze=ze??Y._itemId,Me===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:ze,kind:le.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:a.from(Y.range),selectionRange:a.from(Y.selectionRange),tags:Y.tags?.map(Q.from)}}Ae.from=ve})(Nt||(e.TypeHierarchyItem=Nt={}));var Ut;(function(Ae){function Ee(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Ae.from=Ee})(Ut||(e.ViewBadge=Ut={}));var Et;(function(Ae){function Ee(ze,Xe,He){const et=Xe.fileData;return et?new l.InternalFileDataTransferItem(new l.DataTransferFile(et.name,p.URI.revive(et.uri),et.id,(0,N.once)(()=>He(et.id)))):ze===O.Mimes.uriList&&Xe.uriListData?new l.InternalDataTransferItem(Me(Xe.uriListData)):new l.InternalDataTransferItem(Xe.asString)}Ae.to=Ee;async function ve(ze,Xe){const He=await Xe.asString();if(ze===O.Mimes.uriList)return{asString:He,fileData:void 0,uriListData:Y(He)};const et=Xe.asFile();return{asString:He,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ae.from=ve;function Y(ze){return D.UriList.split(ze).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return p.URI.parse(Xe)}catch{}return Xe})}function Me(ze){return D.UriList.create(ze.map(Xe=>typeof Xe=="string"?Xe:p.URI.revive(Xe)))}})(Et||(e.DataTransferItem=Et={}));var lt;(function(Ae){function Ee(Y,Me){const ze=Y.items.map(([Xe,He])=>[Xe,Et.to(Xe,He,Me)]);return new l.DataTransfer(ze)}Ae.toDataTransfer=Ee;async function ve(Y){const Me={items:[]},ze=[];for(const[Xe,He]of Y)ze.push((async()=>{Me.items.push([Xe,await Et.from(Xe,He)])})());return await Promise.all(ze),Me}Ae.from=ve})(lt||(e.DataTransfer=lt={}));var Ct;(function(Ae){function Ee(Y){return{message:Y.message,metadata:Y.metadata,title:Y.title,tooltip:Y.tooltip}}Ae.to=Ee;function ve(Y){return{kind:"reply",message:Y.message,metadata:Y.metadata,title:Y.title,tooltip:Y.tooltip}}Ae.from=ve})(Ct||(e.ChatReplyFollowup=Ct={}));var $t;(function(Ae){function Ee(ve){return typeof ve=="string"?{title:ve,message:ve,kind:"reply"}:"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",args:ve.args}:Ct.from(ve)}Ae.from=Ee})($t||(e.ChatFollowup=$t={}))}),define(Re[204],Oe([1,0,2,10,7,8,171]),function(te,e,i,k,D,N,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(m,O,w,c={timeout:1500,errors:3}){this.c=m,this.d=O,this.f=w,this.g=c,this.a=new F.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(m){return(O,w,c)=>{const g={dispose:this.a.push([O,w,m])};return Array.isArray(c)&&c.push(g),g}}async $participateInSave(m,O){const w=i.URI.revive(m);let c=!1;const p=setTimeout(()=>c=!0,this.g.timeout),g=[];try{for(const d of[...this.a]){if(c)break;const t=this.d.getDocument(w),u=await this.h(d,{document:t,reason:N.TextDocumentSaveReason.to(O)});g.push(u)}}finally{clearTimeout(p)}return g}h([m,O,w],c){const p=this.b.get(m);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(w,m,O,c).then(()=>!0,g=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this.c.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const d=this.b.get(m);this.b.set(m,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(m,O,w,c){const p=[],g=Date.now(),{document:d,reason:t}=c,{version:u}=d,h=Object.freeze({document:d,reason:t,waitUntil(y){if(Object.isFrozen(p))throw(0,k.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(y))}});try{O.apply(w,[h])}catch(y){return Promise.reject(y)}return Object.freeze(p),new Promise((y,C)=>{const v=setTimeout(()=>C(new Error("timeout")),this.g.timeout);return Promise.all(p).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(v),y(n)}).catch(n=>{clearTimeout(v),C(n)})}).then(y=>{const C={edits:[]};for(const v of y)if(Array.isArray(v)&&v.every(n=>n instanceof D.TextEdit))for(const{newText:n,newEol:l,range:r}of v)C.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:r&&N.Range.from(r),text:n,eol:l&&N.EndOfLine.from(l)}});if(C.edits.length!==0)return u===d.version?this.f.$tryApplyWorkspaceEdit(C):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(Re[205],Oe([1,0,15,2,8,7,74]),function(te,e,i,k,D,N,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(w,c,p,g){this.start=w,this.deletedCount=c,this.deletedItems=p,this.items=g}asApiEvent(){return{range:new N.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(w,c){return{EOL:c.eol,lines:c.source,languageId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:w}}constructor(w,c,p){this.notebook=w,this.h=c,this.j=p,this.handle=p.handle,this.uri=k.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(D.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(D.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const w=this,c=this.h.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:D.NotebookCellKind.to(this.j.cellKind),document:c.document,get mime(){return w.g},set mime(g){w.g=g},get outputs(){return w.a.slice(0)},get metadata(){return w.b},get executionSummary(){return w.d}};this.f=Object.freeze(p)}return this.f}setOutputs(w){this.a=w.map(D.NotebookCellOutput.to)}setOutputItems(w,c,p){const g=p.map(D.NotebookCellOutputItem.to),d=this.a.find(t=>t.id===w);if(d&&(c||(d.items.length=0),d.items.push(...g),d.items.length>1&&d.items.every(t=>F.isTextStreamMime(t.mime)))){const t=new Map,u=[];d.items.forEach(h=>{let y;t.has(h.mime)?y=t.get(h.mime):(y=[],t.set(h.mime,y),u.push(h.mime)),y.push(h.data)}),d.items.length=0,u.forEach(h=>{const y=F.compressOutputItemStreams(t.get(h));d.items.push({mime:h,data:y.buffer})})}}setMetadata(w){this.b=Object.freeze(w)}setInternalMetadata(w){this.e=w,this.d=Object.freeze(D.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=S;class m{constructor(w,c,p,g,d){this.k=w,this.l=c,this.m=p,this.uri=g,this.handle=m.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const w=this,c={get uri(){return w.uri},get version(){return w.g},get notebookType(){return w.d},get isDirty(){return w.h},get isUntitled(){return w.uri.scheme===i.Schemas.untitled},get isClosed(){return w.j},get metadata(){return w.f},get cellCount(){return w.b.length},cellAt(p){return p=w.n(p),w.b[p].apiCell},getCells(p){return(p?w.p(p):w.b).map(d=>d.apiCell)},save(){return w.q()}};this.e=Object.freeze(c)}return this.e}acceptDocumentPropertiesChanged(w){w.metadata&&(this.f=Object.freeze({...this.f,...w.metadata}))}acceptDirty(w){this.h=w}acceptModelChanged(w,c,p){this.g=w.versionId,this.h=c,this.acceptDocumentPropertiesChanged({metadata:p});const g={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},d=[];for(const u of w.rawEvents)u.kind===F.NotebookCellsChangeType.ModelChange?this.r(u.changes,!1,g.contentChanges):u.kind===F.NotebookCellsChangeType.Move?this.s(u.index,u.length,u.newIdx,g.contentChanges):u.kind===F.NotebookCellsChangeType.Output?(this.t(u.index,u.outputs),d.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===F.NotebookCellsChangeType.OutputItem?(this.u(u.index,u.outputId,u.append,u.outputItems),d.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===F.NotebookCellsChangeType.ChangeCellLanguage?(this.v(u.index,u.language),d.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document})):u.kind===F.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document}):u.kind===F.NotebookCellsChangeType.ChangeCellMime?this.w(u.index,u.mime):u.kind===F.NotebookCellsChangeType.ChangeCellMetadata?(this.x(u.index,u.metadata),d.push({cell:this.b[u.index].apiCell,metadata:this.b[u.index].apiCell.metadata})):u.kind===F.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(u.index,u.internalMetadata),d.push({cell:this.b[u.index].apiCell,executionSummary:this.b[u.index].apiCell.executionSummary}));const t=new Map;for(let u=0;u<d.length;u++){const h=d[u],y=t.get(h.cell);if(y===void 0){const C=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});t.set(h.cell,C-1)}else g.cellChanges[y]={...g.cellChanges[y],...h}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}n(w){return w=w|0,w<0?0:w>=this.b.length?this.b.length-1:w}o(w){let c=w.start|0,p=w.end|0;return c<0&&(c=0),p>this.b.length&&(p=this.b.length),w.with({start:c,end:p})}p(w){w=this.o(w);const c=[];for(let p=w.start;p<w.end;p++)c.push(this.b[p]);return c}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(w,c,p){if(this.j)return;const g=[],d=[],t=[];if(w.reverse().forEach(u=>{const y=u[2].map(n=>{const l=new S(this,this.l,n);return c||d.push(S.asModelAddData(this.apiNotebook,n)),l}),C=new R(u[0],u[1],[],y),v=this.b.splice(u[0],u[1],...y);for(const n of v)t.push(n.uri),C.deletedItems.push(n.apiCell);g.push(C)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:t}),p)for(const u of g)p.push(u.asApiEvent())}s(w,c,p,g){const d=this.b.splice(w,c);this.b.splice(p,0,...d);const t=[new R(w,c,d.map(u=>u.apiCell),[]),new R(p,0,[],d)];for(const u of t)g.push(u.asApiEvent())}t(w,c){this.b[w].setOutputs(c)}u(w,c,p,g){this.b[w].setOutputItems(c,p,g)}v(w,c){const p=this.b[w];p.apiCell.document.languageId!==c&&this.m.$acceptModelLanguageChanged(p.uri,c)}w(w,c){const p=this.b[w];p.apiCell.mime=c}x(w,c){this.b[w].setMetadata(c)}y(w,c){this.b[w].setInternalMetadata(c)}getCellFromApiCell(w){return this.b.find(c=>c.apiCell===w)}getCellFromIndex(w){return this.b[w]}getCell(w){return this.b.find(c=>c.handle===w)}getCellIndex(w){return this.b.indexOf(w)}}e.ExtHostNotebookDocument=m,m.a=0}),define(Re[206],Oe([1,0,5,2,8,7]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class F{constructor(S,m,O,w={timeout:1500,errors:3}){this.b=S,this.c=m,this.d=O,this.f=w,this.a=new i.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(m,O,w)=>{const c=function(g){m.call(O,g)};return c.extension=S,this.a.event(c,void 0,w)}}async $participateInSave(S,m,O){const w=k.URI.revive(S),c=this.c.getNotebookDocument(w);if(!c)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:c.apiNotebook,reason:D.TextDocumentSaveReason.to(m)},O,async(d,t)=>{const u=Date.now(),h=await await Promise.resolve(d);Date.now()-u>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!O.isCancellationRequested&&h&&(h instanceof N.WorkspaceEdit?p.push(h):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),O.isCancellationRequested)return!1;if(p.length===0)return!0;const g={edits:[]};for(const d of p){const{edits:t}=D.WorkspaceEdit.from(d);g.edits=g.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(g)}}e.ExtHostNotebookDocumentSaveParticipant=F}),define(Re[104],Oe([1,0,10,8,7]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class N{constructor(R,S,m,O,w,c){this.id=R,this.f=S,this.notebookData=m,this.a=[],this.b=[],this.d=!1,this.a=w,this.b=O,this.c=c}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(S){this.selections=[S]},get selections(){return R.a},set selections(S){if(!Array.isArray(S)||!S.every(D.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");R.a=S,R.g(S)},get visibleRanges(){return R.b},revealRange(S,m){R.f.$tryRevealRange(R.id,k.NotebookRange.from(S),m??D.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(k.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}e.ExtHostNotebookEditor=N,N.apiEditorsToExtHost=new WeakMap}),define(Re[207],Oe([1,0,10,5,14,8]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let F=e.ExtHostNotebookEditors=class{constructor(S,m){this.c=S,this.d=m,this.a=new k.Emitter({onListenerError:i.onUnexpectedExternalError}),this.b=new k.Emitter({onListenerError:i.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(S,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",S,m);const O=this.d.getEditorById(S);m.visibleRanges&&O._acceptVisibleRanges(m.visibleRanges.ranges.map(N.NotebookRange.to)),m.selections&&O._acceptSelections(m.selections.selections.map(N.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:O.apiEditor,visibleRanges:O.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:O.apiEditor,selections:O.apiEditor.selections}))}$acceptEditorViewColumns(S){for(const m in S)this.d.getEditorById(m)._acceptViewColumn(N.ViewColumn.to(S[m]))}};e.ExtHostNotebookEditors=F=xe([Ve(0,D.ILogService)],F)}),define(Re[208],Oe([1,0,8,175,151,22,65,10]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(c){this.b=0,this.c=new Map,this.a=c}async withProgress(c,p,g){const d=this.b++,{title:t,location:u,cancellable:h}=p,y={label:(0,D.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this.a.$startProgress(d,{location:i.ProgressLocation.from(u),title:t,source:y,cancellable:h},c.isUnderDevelopment?void 0:c.identifier.value).catch(R.onUnexpectedExternalError),this.d(d,g,!!h)}d(c,p,g){let d;g&&(d=new N.CancellationTokenSource,this.c.set(c,d));const t=h=>{this.a.$progressEnd(h),this.c.delete(h),d?.dispose()};let u;try{u=p(new O(this.a,c),g&&d?d.token:N.CancellationToken.None)}catch(h){throw t(c),h}return u.then(h=>t(c),h=>t(c)),u}$acceptProgressCanceled(c){const p=this.c.get(c);p&&(p.cancel(),this.c.delete(c))}}e.ExtHostProgress=S;function m(w,c){return w.message=c.message,typeof c.increment=="number"&&(typeof w.increment=="number"?w.increment+=c.increment:w.increment=c.increment),w}class O extends k.Progress{constructor(c,p){super(g=>this.throttledReport(g)),this.c=c,this.d=p}throttledReport(c){this.c.$progressReport(this.d,c)}}xe([(0,F.throttle)(100,(w,c)=>m(w,c),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Re[105],Oe([1,0,44,100,45,75,56,8,2]),function(te,e,i,k,D,N,F,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const m=(y,C,v,n)=>{let l=C;return{enumerable:!0,configurable:!1,get(){return l},set(r){if(!v(l,r)){const a=l;l=r,y.listener?.(n(r,a))}}}},O=(y,C)=>y===C,w={range:(y,C)=>y===C?!0:!y||!C?!1:y.isEqual(C),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(y,C)=>!(y.length!==C.length||y.some(v=>!C.find(n=>v.id===n.id)))},c=y=>C=>({op:4,update:y(C)}),p=(y,C)=>({range:(()=>{let v;const n=c(l=>({range:i.Range.lift(R.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return v},set(l){y.listener?.({op:6}),w.range(v,l)||(v=l,y.listener?.(n(l)))}}})(),label:m(y,C,w.label,c(v=>({label:v}))),description:m(y,void 0,w.description,c(v=>({description:v}))),sortText:m(y,void 0,w.sortText,c(v=>({sortText:v}))),canResolveChildren:m(y,!1,w.canResolveChildren,v=>({op:2,state:v})),busy:m(y,!1,w.busy,c(v=>({busy:v}))),error:m(y,void 0,w.error,c(v=>({error:R.MarkdownString.fromStrict(v)||null}))),tags:m(y,[],w.tags,(v,n)=>({op:1,new:v.map(R.TestTag.from),old:n.map(R.TestTag.from)}))}),g=y=>{const C=D.TestId.fromString(y.extId),v=new t(C.controllerId,C.localId,y.label,S.URI.revive(y.uri)||void 0);return v.range=R.Range.to(y.range||void 0),v.description=y.description||void 0,v.sortText=y.sortText||void 0,v.tags=y.tags.map(n=>R.TestTag.to({id:(0,F.denamespaceTestTag)(n).tagId})),v},d=y=>{let C;for(const v of y.tests){const n=g(v.item);(0,k.getPrivateApiFor)(n).parent=C,C=n}return C};e.toItemFromContext=d;class t{constructor(C,v,n,l){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const r=(0,k.createPrivateApiFor)(this,C);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof u?void 0:r.parent}},children:{value:(0,N.createTestItemChildren)(r,k.getPrivateApiFor,t),enumerable:!0,writable:!1},...p(r,n)})}}e.TestItemImpl=t;class u extends t{constructor(C,v){super(C,C,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=u;class h extends N.TestItemCollection{constructor(C,v,n){super({controllerId:C,getDocumentVersion:l=>l&&n.getDocument(l)?.version,getApiFor:k.getPrivateApiFor,getChildren:l=>l.children,root:new u(C,v),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=h}),define(Re[106],Oe([1,0,49,10,86,8,7]),function(te,e,i,k,D,N,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class R{constructor(c,p,g){const d=R.c.nextId();c.$registerTextEditorDecorationType(p.identifier,d,N.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:d,dispose(){c.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=R,R.c=new D.IdGenerator("TextEditorDecorationType");class S{constructor(c,p){this.g=[],this.h=void 0,this.j=!1,this.c=c,this.d=c.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(c,p){this.k();let g=null;if(c instanceof F.Position)g=new F.Range(c,c);else if(c instanceof F.Range)g=c;else throw new Error("Unrecognized location");this.l(g,p,!1)}insert(c,p){this.k(),this.l(new F.Range(c,c),p,!0)}delete(c){this.k();let p=null;if(c instanceof F.Range)p=c;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(c,p,g){const d=this.c.validateRange(c);this.g.push({range:d,text:p,forceMoveMarkers:g})}setEndOfLine(c){if(this.k(),c!==F.EndOfLine.LF&&c!==F.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this.h=c}}class m{constructor(c,p,g,d){this.c=c,this.d=p,this._accept(g),this.e=d;const t=this;this.value={get tabSize(){return t.f},set tabSize(u){t.m(u)},get indentSize(){return t.g},set indentSize(u){t.o(u)},get insertSpaces(){return t.h},set insertSpaces(u){t.q(u)},get cursorStyle(){return t.j},set cursorStyle(u){t.s(u)},get lineNumbers(){return t.k},set lineNumbers(u){t.t(u)}}}_accept(c){this.f=c.tabSize,this.g=c.indentSize,this.h=c.insertSpaces,this.j=c.cursorStyle,this.k=N.TextEditorLineNumbersStyle.to(c.lineNumbers)}l(c){if(c==="auto")return"auto";if(typeof c=="number"){const p=Math.floor(c);return p>0?p:null}if(typeof c=="string"){const p=parseInt(c,10);return isNaN(p)?null:p>0?p:null}return null}m(c){const p=this.l(c);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const p=Math.floor(c);return p>0?p:null}if(typeof c=="string"){const p=parseInt(c,10);return isNaN(p)?null:p>0?p:null}return null}o(c){const p=this.n(c);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(c){return c==="auto"?"auto":c==="false"?!1:!!c}q(c){const p=this.p(c);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(c){this.j!==c&&(this.j=c,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:c})))}t(c){this.k!==c&&(this.k=c,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(c)})))}assign(c){const p={};let g=!1;if(typeof c.tabSize<"u"){const d=this.l(c.tabSize);d==="auto"?(g=!0,p.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,g=!0,p.tabSize=d)}if(typeof c.indentSize<"u"){const d=this.n(c.indentSize);d==="tabSize"?(g=!0,p.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,g=!0,p.indentSize=d)}if(typeof c.insertSpaces<"u"){const d=this.p(c.insertSpaces);d==="auto"?(g=!0,p.insertSpaces=d):this.h!==d&&(this.h=d,g=!0,p.insertSpaces=d)}typeof c.cursorStyle<"u"&&this.j!==c.cursorStyle&&(this.j=c.cursorStyle,g=!0,p.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this.k!==c.lineNumbers&&(this.k=c.lineNumbers,g=!0,p.lineNumbers=N.TextEditorLineNumbersStyle.from(c.lineNumbers)),g&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(c,p){p.catch(g=>{this.e.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this.e.warn(g)})}}e.ExtHostTextEditorOptions=m;class O{constructor(c,p,g,d,t,u,h,y){this.id=c,this.j=p,this.k=g,this.g=!1,this.h=new Set,this.c=t,this.d=new m(this.j,this.id,u,g),this.e=h,this.f=y;const C=this;this.value=Object.freeze({get document(){return d.value},set document(v){throw(0,k.readonly)("document")},get selection(){return C.c&&C.c[0]},set selection(v){if(!(v instanceof F.Selection))throw(0,k.illegalArgument)("selection");C.c=[v],C.l()},get selections(){return C.c},set selections(v){if(!Array.isArray(v)||v.some(n=>!(n instanceof F.Selection)))throw(0,k.illegalArgument)("selections");C.c=v,C.l()},get visibleRanges(){return C.e},set visibleRanges(v){throw(0,k.readonly)("visibleRanges")},get options(){return C.d.value},set options(v){C.g||C.d.assign(v)},get viewColumn(){return C.f},set viewColumn(v){throw(0,k.readonly)("viewColumn")},edit(v,n={undoStopBefore:!0,undoStopAfter:!0}){if(C.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new S(d.value,n);return v(l),C.m(l)},insertSnippet(v,n,l={undoStopBefore:!0,undoStopAfter:!0}){if(C.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=C.c.map(a=>N.Range.from(a));else if(n instanceof F.Position){const{lineNumber:a,column:b}=N.Position.from(n);r=[{startLineNumber:a,startColumn:b,endLineNumber:a,endColumn:b}]}else if(n instanceof F.Range)r=[N.Range.from(n)];else{r=[];for(const a of n)if(a instanceof F.Range)r.push(N.Range.from(a));else{const{lineNumber:b,column:I}=N.Position.from(a);r.push({startLineNumber:b,startColumn:I,endLineNumber:b,endColumn:I})}}return p.$tryInsertSnippet(c,d.value.version,v.value,r,l)},setDecorations(v,n){const l=n.length===0;l&&!C.h.has(v.key)||(l?C.h.delete(v.key):C.h.add(v.key),C.n(()=>{if(N.isDecorationOptionsArr(n))return p.$trySetDecorations(c,v.key,N.fromRangeOrRangeWithMessage(n));{const r=new Array(4*n.length);for(let a=0,b=n.length;a<b;a++){const I=n[a];r[4*a]=I.start.line+1,r[4*a+1]=I.start.character+1,r[4*a+2]=I.end.line+1,r[4*a+3]=I.end.character+1}return p.$trySetDecorationsFast(c,v.key,r)}}))},revealRange(v,n){C.n(()=>p.$tryRevealRange(c,N.Range.from(v),n||F.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(c,N.ViewColumn.from(v))},hide(){p.$tryHideEditor(c)}})}dispose(){(0,i.ok)(!this.g),this.g=!0}_acceptOptions(c){(0,i.ok)(!this.g),this.d._accept(c)}_acceptVisibleRanges(c){(0,i.ok)(!this.g),this.e=c}_acceptViewColumn(c){(0,i.ok)(!this.g),this.f=c}_acceptSelections(c){(0,i.ok)(!this.g),this.c=c}async l(){const c=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,c)),this.value}m(c){const p=c.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const g=p.edits.map(t=>t.range);g.sort((t,u)=>t.end.line===u.end.line?t.end.character===u.end.character?t.start.line===u.start.line?t.start.character-u.start.character:t.start.line-u.start.line:t.end.character-u.end.character:t.end.line-u.end.line);for(let t=0,u=g.length-1;t<u;t++){const h=g[t].end;if(g[t+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=p.edits.map(t=>({range:N.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,d,{setEndOfLine:typeof p.setEndOfLine=="number"?N.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(c){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.ExtHostTextEditor=O}),define(Re[209],Oe([1,0,155,7,25,2,5,6,191,16,7,9,18,8,22,20,123]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(C,v){if((0,w.isString)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let n;return Array.isArray(C.highlights)&&(n=C.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),n=n.length?n:void 0),{label:C.label,highlights:n}}}class h{constructor(v,n,l){this.d=v,this.e=n,this.f=l,this.a=new Map,this.b=new t.TreeViewsDnDService;function r(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:a=>r(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(b=>r(b)?this.i(b):b):a})}registerTreeDataProvider(v,n,l){const r=this.createTreeView(v,{treeDataProvider:n},l);return{dispose:()=>r.dispose()}}createTreeView(v,n,l){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=n.dragAndDropController?.dropMimeTypes??[],a=n.dragAndDropController?.dragMimeTypes??[],b=!!n.dragAndDropController?.handleDrag,I=!!n.dragAndDropController?.handleDrop,f=this.h(v,n,l),P={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:r,dragMimeTypes:a,hasHandleDrag:b,hasHandleDrop:I,manuallyManageCheckboxes:!!n.manuallyManageCheckboxSelection},E=this.d.$registerTreeViewDataProvider(v,P);return{get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(l,"treeItemCheckbox"),f.onDidChangeCheckboxState},get message(){return f.message},set message(o){f.message=o},get title(){return f.title},set title(o){f.title=o},get description(){return f.description},set description(o){f.description=o},get badge(){return f.badge},set badge(o){o!==void 0&&O.ViewBadge.isViewBadge(o)?f.badge={value:Math.floor(Math.abs(o.value)),tooltip:o.tooltip}:o===void 0&&(f.badge=void 0)},reveal:(o,s)=>f.reveal(o,s),dispose:async()=>{await E,this.a.delete(v),f.dispose()}}}$getChildren(v,n){const l=this.a.get(v);return l?l.getChildren(n):Promise.reject(new S.NoTreeViewError(v))}async $handleDrop(v,n,l,r,a,b,I,f){const P=this.a.get(v);if(!P)return Promise.reject(new S.NoTreeViewError(v));const E=p.DataTransfer.toDataTransfer(l,async o=>(await this.d.$resolveDropFileData(v,n,o)).buffer);return I===v&&f&&await this.g(E,P,f,a,b),P.onDrop(E,r,a)}async g(v,n,l,r,a){const b=this.b.removeDragOperationTransfer(a);if(b)(await b)?.forEach((I,f)=>{I&&v.set(f,I)});else if(a&&n.handleDrag){const I=n.handleDrag(l,v,r);this.b.addDragOperationTransfer(a,I),await I}return v}async $handleDrag(v,n,l,r){const a=this.a.get(v);if(!a)return Promise.reject(new S.NoTreeViewError(v));const b=await this.g(new k.DataTransfer,a,n,r,l);if(!(!b||r.isCancellationRequested))return p.DataTransfer.from(b)}async $hasResolve(v){const n=this.a.get(v);if(!n)throw new S.NoTreeViewError(v);return n.hasResolve}$resolve(v,n,l){const r=this.a.get(v);if(!r)throw new S.NoTreeViewError(v);return r.resolveTreeItem(n,l)}$setExpanded(v,n,l){const r=this.a.get(v);if(!r)throw new S.NoTreeViewError(v);r.setExpanded(n,l)}$setSelection(v,n){const l=this.a.get(v);if(!l)throw new S.NoTreeViewError(v);l.setSelection(n)}$setFocus(v,n){const l=this.a.get(v);if(!l)throw new S.NoTreeViewError(v);l.setFocus(n)}$setVisible(v,n){const l=this.a.get(v);if(!l)throw new S.NoTreeViewError(v);l.setVisible(n)}$changeCheckboxState(v,n){const l=this.a.get(v);if(!l)throw new S.NoTreeViewError(v);l.setCheckboxState(n)}h(v,n,l){const r=new y(v,n,this.d,this.e.converter,this.f,l);return this.a.set(v,r),r}i(v){const n=this.a.get(v.$treeViewId);return n&&"$treeItemHandle"in v?n.getExtensionElement(v.$treeItemHandle):n&&"$focusedTreeItem"in v&&v.$focusedTreeItem?n.focusedElement:null}}e.ExtHostTreeViews=h;class y extends R.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(v=>this.getExtensionElement(v)).filter(v=>!(0,w.isUndefinedOrNull)(v))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(v,n,l,r,a,b){if(super(),this.C=v,this.D=l,this.F=r,this.G=a,this.H=b,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new F.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new F.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new F.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new F.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new F.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new F.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new g.CancellationTokenSource,b.contributes&&b.contributes.views)for(const P in b.contributes.views)for(const E of b.contributes.views[P])E.id===v&&(this.J=E.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(P=>this.w.fire({message:!1,element:P})));let I,f;this.B(F.Event.debounce(this.w.event,(P,E)=>(P||(P={message:!1,elements:[]}),E.element!==!1&&(I||(I=new Promise(o=>f=o),this.y=this.y.then(()=>I)),Array.isArray(E.element)?P.elements.push(...E.element):P.elements.push(E.element)),E.message&&(P.message=!0),P),200,!0)(({message:P,elements:E})=>{E.length&&(this.z=this.z.then(()=>{const o=f;return I=null,this.U(E).then(()=>o())})),P&&this.D.$setMessage(this.C,this.I)}))}async getChildren(v){const n=v?this.getExtensionElement(v):void 0;if(v&&!n)return this.G.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let l=this.Q(v);return l||(l=await this.R(n)),l?l.map(r=>r.item):void 0}getExtensionElement(v){return this.i.get(v)}reveal(v,n){n=n||{select:!0,focus:!1};const l=(0,w.isUndefinedOrNull)(n.select)?!0:n.select,r=(0,w.isUndefinedOrNull)(n.focus)?!1:n.focus,a=(0,w.isUndefinedOrNull)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.y.then(()=>this.N(v)).then(b=>this.P(v,b[b.length-1]).then(I=>this.D.$reveal(this.C,{item:I.item,parentChain:b.map(f=>f.item)},{select:l,focus:r,expand:a})),b=>this.G.error(b)):this.D.$reveal(this.C,void 0,{select:l,focus:r,expand:a})}get message(){return this.I}set message(v){this.I=v,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(v){this.J=v,this.D.$setTitle(this.C,v,this.L)}get description(){return this.L}set description(v){this.L=v,this.D.$setTitle(this.C,this.J,v)}get badge(){return this.M}set badge(v){this.M?.value===v?.value&&this.M?.tooltip===v?.tooltip||(this.M=p.ViewBadge.from(v),this.D.$setBadge(this.C,v))}setExpanded(v,n){const l=this.getExtensionElement(v);l&&(n?this.r.fire(Object.freeze({element:l})):this.s.fire(Object.freeze({element:l})))}setSelection(v){(0,c.equals)(this.l,v)||(this.l=v,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this.m=v}setVisible(v){v!==this.k&&(this.k=v,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(v){const n=(await Promise.all(v.map(async l=>{const r=this.getExtensionElement(l.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:l.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);n.forEach(l=>{l.treeItem.checkboxState=l.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}),this.v.fire({items:n.map(l=>[l.extensionItem,l.newState])})}async handleDrag(v,n,l){const r=[];for(const a of v){const b=this.getExtensionElement(a);b&&r.push(b)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,n,l),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,n,l){const r=n?this.getExtensionElement(n):void 0;if(!(!r&&n||!this.g?.handleDrop))return(0,m.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,v,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,n){if(!this.f.resolveTreeItem)return;const l=this.i.get(v);if(l){const r=this.j.get(l);if(r){const a=await this.f.resolveTreeItem(r.extensionItem,l,n)??r.extensionItem;return this.db(a),r.item.tooltip=this.ab(a.tooltip),r.item.command=this.bb(r.disposableStore,a.command),r.item}}}N(v){return this.O(v).then(n=>n?this.N(n).then(l=>this.P(n,l[l.length-1]).then(r=>(l.push(r),l))):Promise.resolve([]))}O(v){const n=this.j.get(v);return n?Promise.resolve(n.parent?this.i.get(n.parent.item.handle):void 0):(0,m.asPromise)(()=>this.f.getParent(v))}P(v,n){const l=this.j.get(v);return l?Promise.resolve(l):(0,m.asPromise)(()=>this.f.getTreeItem(v)).then(r=>this.gb(v,r,n,!0)).then(r=>this.getChildren(n?n.item.handle:void 0).then(()=>{const a=this.getExtensionElement(r);if(a){const b=this.j.get(a);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(v){if(v){let n;if(typeof v=="string"){const l=this.getExtensionElement(v);n=l?this.j.get(l):void 0}else n=v;return n&&n.children||void 0}return this.h}async R(v){this.nb(v);const n=new g.CancellationTokenSource(this.S.token);try{const l=v?this.j.get(v):void 0,r=await this.f.getChildren(v);if(n.token.isCancellationRequested)return;const a=await Promise.all((0,c.coalesce)(r||[]).map(async b=>{const I=await this.f.getTreeItem(b);return I&&!n.token.isCancellationRequested?this.Z(b,I,l):null}));return n.token.isCancellationRequested?void 0:(0,c.coalesce)(a)}finally{n.dispose()}}U(v){if(v.some(l=>!l))return this.S.dispose(!0),this.S=new g.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const l=this.W(v);if(l.length)return this.X(l)}return Promise.resolve(void 0)}W(v){const n=new Set,l=v.map(a=>this.j.get(a));for(const a of l)if(a&&!n.has(a.item.handle)){let b=a;for(;b&&b.parent&&l.findIndex(I=>b&&b.parent&&I&&I.item.handle===b.parent.item.handle)===-1;){const I=this.i.get(b.parent.item.handle);b=I?this.j.get(I):void 0}b&&!b.parent&&n.add(a.item.handle)}const r=[];return n.forEach(a=>{const b=this.i.get(a);if(b){const I=this.j.get(b);I&&(!I.parent||!n.has(I.parent.item.handle))&&r.push(a)}}),r}X(v){const n={};return Promise.all(v.map(l=>this.Y(l).then(r=>{r&&(n[l]=r.item)}))).then(()=>Object.keys(n).length?this.D.$refresh(this.C,n):void 0)}Y(v){const n=this.getExtensionElement(v);if(n){const l=this.j.get(n);if(l)return this.nb(n),(0,m.asPromise)(()=>this.f.getTreeItem(n)).then(r=>{if(r){const a=this.eb(n,r,l.parent);return this.lb(n,a,l,l.parent),l.dispose(),a}return null})}return Promise.resolve(null)}Z(v,n,l){const r=this.eb(v,n,l);if(n.id&&this.i.has(r.item.handle))throw new Error((0,i.localize)(0,null,n.id));return this.kb(v,r),this.mb(r,l),r}ab(v){return O.MarkdownString.isMarkdownString(v)?p.MarkdownString.from(v):v}bb(v,n){return n?{...this.F.toInternal(n,v),originalId:n.command}:void 0}cb(v){if(v.checkboxState===void 0)return;let n,l,r;return typeof v.checkboxState=="number"?n=v.checkboxState:(n=v.checkboxState.state,l=v.checkboxState.tooltip,r=v.checkboxState.accessibilityInformation),{isChecked:n===O.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:r}}db(v){if(!O.TreeItem.isTreeItem(v,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(v,n,l){this.db(n);const r=new R.DisposableStore,a=this.gb(v,n,l),b=this.hb(n);return{item:{handle:a,parentHandle:l?l.item.handle:void 0,label:u(n.label,this.H),description:n.description,resourceUri:n.resourceUri,tooltip:this.ab(n.tooltip),command:this.bb(r,n.command),contextValue:n.contextValue,icon:b,iconDark:this.ib(n)||b,themeIcon:this.fb(n),collapsibleState:(0,w.isUndefinedOrNull)(n.collapsibleState)?O.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.cb(n)},extensionItem:n,parent:l,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(v){return v.iconPath instanceof O.ThemeIcon?v.iconPath:void 0}gb(v,{id:n,label:l,resourceUri:r},a,b){if(n)return`${y.b}/${n}`;const I=u(l,this.H),f=a?a.item.handle:y.a;let P=I?I.label:r?(0,D.basename)(r):"";P=P.indexOf("/")!==-1?P.replace("/","//"):P;const E=this.j.has(v)?this.j.get(v).item.handle:void 0,o=this.Q(a)||[];let s,M=0;do{if(s=`${f}/${M}:${P}`,b||!this.i.has(s)||E===s)break;M++}while(M<=o.length);return s}hb(v){if(v.iconPath&&!(v.iconPath instanceof O.ThemeIcon))return typeof v.iconPath=="string"||N.URI.isUri(v.iconPath)?this.jb(v.iconPath):this.jb(v.iconPath.light)}ib(v){if(v.iconPath&&!(v.iconPath instanceof O.ThemeIcon)&&v.iconPath.dark)return this.jb(v.iconPath.dark)}jb(v){return N.URI.isUri(v)?v:N.URI.file(v)}kb(v,n){this.i.set(n.item.handle,v),this.j.set(v,n)}lb(v,n,l,r){this.i.delete(n.item.handle),this.j.delete(v),n.item.handle!==l.item.handle&&this.i.delete(l.item.handle),this.kb(v,n);const a=this.Q(r)||[],b=a.filter(I=>I.item.handle===l.item.handle)[0];b&&a.splice(a.indexOf(b),1,n)}mb(v,n){n?(n.children||(n.children=[]),n.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}nb(v){if(v){const n=this.j.get(v);if(n){if(n.children)for(const l of n.children){const r=this.i.get(l.item.handle);r&&this.ob(r)}n.children=void 0}}else this.pb()}ob(v){const n=this.j.get(v);if(n){if(n.children)for(const l of n.children){const r=this.i.get(l.item.handle);r&&this.ob(r)}this.j.delete(v),this.i.delete(n.item.handle),n.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(v=>v.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}y.a="0",y.b="1"}),define(Re[210],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testInvalidateResults:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testInvalidateResults.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[211],Oe([1,0,164,10,29,92,72,30,23,210,174,98]),function(te,e,i,k,D,N,F,R,S,m,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const c=R.Registry.as(F.Extensions.JSONContribution);class p{constructor(v,n,l){this.a=v,this.b=n,this.c=l}d(v,n){this.a({type:v,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(D.default.Error,v)}warn(v){this.d(D.default.Warning,v)}info(v){this.d(D.default.Info,v)}}e.ExtensionMessageCollector=p;class g{static a(v){const n=new S.ExtensionIdentifierSet;for(let l=0,r=v.length;l<r;l++)n.add(v[l].description.identifier);return n}static compute(v,n){if(!v||!v.length)return new g(n,[]);if(!n||!n.length)return new g([],v);const l=this.a(v),r=this.a(n),a=n.filter(I=>!l.has(I.description.identifier)),b=v.filter(I=>!r.has(I.description.identifier));return new g(a,b)}constructor(v,n){this.added=v,this.removed=n}}e.ExtensionPointUserDelta=g;class d{constructor(v,n){this.name=v,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=g.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,k.onUnexpectedError)(v)}}}e.ExtensionPoint=d;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:i.localize(15,null),type:"string",enum:["none"],enumDescriptions:[i.localize(16,null)]},activationEvents:{description:i.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(32,null)},{label:"onUri",body:"onUri",description:i.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(37,null)},{label:"onRenderer",description:i.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:i.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(41,null)},{label:"*",description:i.localize(42,null),body:"*"}]}},badges:{type:"array",description:i.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(44,null)},href:{type:"string",description:i.localize(45,null)},description:{type:"string",description:i.localize(46,null)}}}},markdown:{type:"string",description:i.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(52,null)},{body:["workspace"],description:i.localize(53,null)},{body:["ui","workspace"],description:i.localize(54,null)},{body:["workspace","ui"],description:i.localize(55,null)},{body:[],description:i.localize(56,null)}]},capabilities:{description:i.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)]},description:{type:"string",markdownDescription:i.localize(63,null)}}},untrustedWorkspaces:{description:i.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(66,null),i.localize(67,null),i.localize(68,null)]},restrictedConfigurations:{description:i.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(70,null)}}}}},sponsor:{description:i.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(73,null),type:"string"},"vscode:uninstall":{description:i.localize(74,null),type:"string"}}},icon:{type:"string",description:i.localize(75,null)},l10n:{type:"string",description:i.localize(76,null)}}};class h{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const n=new d(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,n),v.activationEventsGenerator&&w.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,c.registerSchema(u,e.schema),n}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=h;const y={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(y.ExtensionsRegistry,new h),e.ExtensionsRegistry=R.Registry.as(y.ExtensionsRegistry),c.registerSchema(u,e.schema),c.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(Re[212],Oe([1,0,161,9,26,211,31,5]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var m;(function(c){function p(g,d,t){if(!g)return;const u=k.isString(g.type)?g.type:void 0;if(!u||u.length===0){t.error(i.localize(3,null));return}const h=[];if(Array.isArray(g.required))for(const y of g.required)k.isString(y)&&h.push(y);return{extensionId:d.value,taskType:u,required:h,properties:g.properties?D.deepClone(g.properties):{},when:g.when?F.ContextKeyExpr.deserialize(g.when):void 0}}c.from=p})(m||(m={}));const O=N.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,p)=>{for(const g of c)g.type&&p.push(`onTaskType:${g.type}`)},jsonSchema:{description:i.localize(4,null),type:"array",items:S}});class w{constructor(){this.d=new R.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,g)=>{O.setHandler((d,t)=>{this.c=void 0;try{for(const u of t.removed){const h=u.value;for(const y of h)this.a&&y.type&&this.a[y.type]&&delete this.a[y.type]}for(const u of t.added){const h=u.value;for(const y of h){const C=m.from(y,u.description.identifier,u.collector);C&&(this.a[C.taskType]=C)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const g of this.all()){const d={type:"object",additionalProperties:!1};g.required.length>0&&(d.required=g.required.slice(0)),g.properties!==void 0?d.properties=D.deepClone(g.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[g.taskType]},p.push(d)}this.c={oneOf:p}}return this.c}}e.TaskDefinitionRegistry=new w}),define(Re[213],Oe([1,0,162,9,25,26,31,212]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new F.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var S;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(S||(e.ShellQuoting=S={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function q(z){if(!z)return U.Strong;switch(z.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=q}(S||(e.ShellQuoting=S={}));var m;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(m||(e.CommandOptions=m={}));var O;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(O||(e.RevealKind=O={})),function(U){function q(z){switch(z.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=q}(O||(e.RevealKind=O={}));var w;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(w||(e.RevealProblemKind=w={})),function(U){function q(z){switch(z.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=q}(w||(e.RevealProblemKind=w={}));var c;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(c||(e.PanelKind=c={})),function(U){function q(z){switch(z.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=q}(c||(e.PanelKind=c={}));var p;(function(U){U.defaults={echo:!0,reveal:O.Always,revealProblems:w.Never,focus:!1,panel:c.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var g;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(g||(e.RuntimeType=g={})),function(U){function q(V){switch(V.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=q;function z(V){switch(V){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=z}(g||(e.RuntimeType=g={}));var d;(function(U){function q(z){return k.isString(z)?z:z.value}U.value=q})(d||(e.CommandString=d={}));var t;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function q(V){return V===U.Clean._id||V===U.Build._id||V===U.Rebuild._id||V===U.Test._id}U.is=q;function z(V){if(V!==void 0)return k.isString(V)?q(V)?{_id:V,isDefault:!1}:void 0:V}U.from=z})(t||(e.TaskGroup=t={}));var u;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(u||(e.TaskScope=u={}));var h;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function q(z){switch(z){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=q})(h||(e.TaskSourceKind=h={}));var y;(function(U){U.parallel="parallel",U.sequence="sequence"})(y||(e.DependsOrder=y={}));var C;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(C||(e.RunOnOptions=C={}));var v;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:C.default,instanceLimit:1}})(v||(e.RunOptions=v={}));class n{constructor(q,z,V,ee,Ce,oe){this._label="",this._id=q,z&&(this._label=z),V&&(this.type=V),this.runOptions=ee,this.configurationProperties=Ce,this._source=oe}getDefinition(q){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const q={folder:this.d(),id:this._id};return JSON.stringify(q)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(q,z=!1){if(q===void 0)return!1;if(k.isString(q))return q===this._label||q===this.configurationProperties.identifier||z&&q===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===q._key}getQualifiedLabel(){const q=this.getWorkspaceFolder();return q?`${this._label} (${q.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(q){this.c===void 0&&(this.c=[]),q&&(this.c=this.c.concat(q))}get taskLoadMessages(){return this.c}}e.CommonTask=n;class l extends n{constructor(q,z,V,ee,Ce,oe,le,Q){super(q,V,void 0,le,Q,z),this.command={},this._source=z,this.hasDefinedMatchers=oe,Ce&&(this.command=Ce)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(q=!1){if(q&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case g.Shell:z="shell";break;case g.Process:z="process";break;case g.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(q){return q instanceof l}getMapKey(){const q=this._source.config.workspaceFolder;return q?`${q.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===h.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const q=this.d();if(!q)return;let z=this.configurationProperties.identifier;this._source.kind!==h.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:z};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(q){return new l(q._id,q._source,q._label,q.type,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.CustomTask=l;class r extends n{constructor(q,z,V,ee,Ce,oe,le){super(q,V,ee,oe,le,z),this._source=z,this.configures=Ce}static is(q){return q instanceof r}f(q){return q}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===h.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const q=this.d();if(!q)return;let z=this.configurationProperties.identifier;this._source.kind!==h.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:z};return JSON.stringify(V)}}e.ConfiguringTask=r;class a extends n{constructor(q,z,V,ee,Ce,oe,le,Q,ue){super(q,V,ee,Q,ue,z),this.defines=Ce,this.hasDefinedMatchers=le,this.command=oe,this.icon=ue.icon,this.hide=ue.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(q){return q instanceof a}getMapKey(){const q=this._source.workspaceFolder;return q?`${this._source.scope.toString()}|${q.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const q={type:"contributed",scope:this._source.scope,id:this._id};return q.folder=this.d(),JSON.stringify(q)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(q){return new a(q._id,q._source,q._label,q.type,q.defines,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.ContributedTask=a;class b extends n{constructor(q,z,V,ee,Ce,oe){super(q,V,ee,Ce,oe,z),this._source=z}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(q){return q instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(q){return new b(q._id,q._source,q._label,q.type,q.runOptions,q.configurationProperties)}}e.InMemoryTask=b;var I;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(I||(e.ExecutionEngine=I={})),function(U){U._default=U.Terminal}(I||(e.ExecutionEngine=I={}));var f;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(f||(e.JsonSchemaVersion=f={}));class P{constructor(q){this.c=new Map;for(let z=0;z<q.length;z++)this.c.set(q[z].uri.toString(),z)}compare(q,z){const V=q.getWorkspaceFolder(),ee=z.getWorkspaceFolder();if(V&&ee){let Ce=this.c.get(V.uri.toString());Ce=Ce===void 0?0:Ce+1;let oe=this.c.get(ee.uri.toString());return oe=oe===void 0?0:oe+1,Ce===oe?q._label.localeCompare(z._label):Ce-oe}else return!V&&ee?-1:V&&!ee?1:0}}e.TaskSorter=P;var E;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(E||(e.TaskEventKind=E={}));var o;(function(U){U.SingleRun="singleRun",U.Background="background"})(o||(e.TaskRunType=o={}));var s;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(s||(e.TaskRunSource=s={}));var M;(function(U){function q(z,V,ee,Ce){if(V){const oe={kind:z,taskId:V._id,taskName:V.configurationProperties.name,runType:V.configurationProperties.isBackground?"background":"singleRun",group:V.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ee,__task:V};return z==="start"?oe.resolvedVariables=Ce:z==="processStarted"?oe.processId=Ce:z==="processEnded"&&(oe.exitCode=Ce),Object.freeze(oe)}else return Object.freeze({kind:"changed"})}U.create=q})(M||(e.TaskEvent=M={}));var B;(function(U){function q(V){const ee=Object.keys(V).sort();let Ce="";for(const oe of ee){let le=V[oe];le instanceof Object?le=q(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),Ce+=oe+","+le+","}return Ce}function z(V){const Ce={_key:q(V),type:V.taskType};return Object.assign(Ce,V),Ce}U.create=z})(B||(e.KeyedTaskIdentifier=B={}));var X;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(X||(e.TaskSettingId=X={}));var G;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(G||(e.TasksSchemaProperties=G={}));var W;(function(U){function q(z,V){const ee=R.TaskDefinitionRegistry.get(z.type);if(ee===void 0){const Q=N.deepClone(z);return delete Q._key,B.create(Q)}const Ce=Object.create(null);Ce.type=ee.taskType;const oe=new Set;ee.required.forEach(Q=>oe.add(Q));const le=ee.properties;for(const Q of Object.keys(le)){const ue=z[Q];if(ue!=null)Ce[Q]=ue;else if(oe.has(Q)){const Ie=le[Q];if(Ie.default!==void 0)Ce[Q]=N.deepClone(Ie.default);else switch(Ie.type){case"boolean":Ce[Q]=!1;break;case"number":case"integer":Ce[Q]=0;break;case"string":Ce[Q]="";break;default:V.error(i.localize(2,null,JSON.stringify(z,void 0,0),Q));return}}}return B.create(Ce)}U.createTaskIdentifier=q})(W||(e.TaskDefinition=W={}))}),define(Re[214],Oe([1,0,10]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class k{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((F,R)=>{this.b=F,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(F){this.f||this.h||(this.f=!0,this.g=F,this.a&&this.b(F))}resolveErr(F){this.f||this.h||(this.h=!0,this.i=F,this.a?this.d(F):(0,i.onUnexpectedError)(F))}then(F,R){return this.j().then(F,R)}catch(F){return this.j().then(void 0,F)}finally(F){return this.j().finally(F)}}e.LazyPromise=k;class D extends k{constructor(){super(),this.h=!0,this.i=new i.CancellationError}}e.CanceledLazyPromise=D}),define(Re[46],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const k=[];function D(R){const S=new i(R);return k[S.nid]=S,S}e.createProxyIdentifier=D;function N(R){return k[R].sid}e.getStringIdentifierForProxy=N;class F{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=F}),define(Re[4],Oe([1,0,46]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var k;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(k||(e.TextEditorRevealType=k={}));var D;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(D||(e.TabInputKind=D={}));var N;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var F;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(F||(e.WebviewEditorCapabilities=F={}));var R;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var S;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(S||(e.CellOutputKind=S={}));var m;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var O;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(O||(e.CandidatePortSource=O={}));class w{static mixin(t){return t._id=w.a++,t}}e.IdObject=w,w.a=0;var c;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var p;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var g;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,i.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,i.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,i.createProxyIdentifier)("MainThreadChat"),MainThreadInteractiveEditor:(0,i.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,i.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,i.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,i.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,i.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,i.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,i.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,i.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostChat:(0,i.createProxyIdentifier)("ExtHostChat"),ExtHostSemanticSimilarity:(0,i.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,i.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,i.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Re[79],Oe([1,0,3,14,4,17]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let F=e.ExtHostApiDeprecationService=class{constructor(S,m){this.c=m,this.a=new Set,this.b=S.getProxy(D.MainContext.MainThreadTelemetry)}report(S,m,O){const w=this.d(S,m);this.a.has(w)||(this.a.add(w),m.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:S}))}d(S,m){return`${S}-${m.identifier.value}`}};e.ExtHostApiDeprecationService=F=xe([Ve(0,N.IExtHostRpcService),Ve(1,k.ILogService)],F),e.NullApiDeprecationService=Object.freeze(new class{report(R,S,m){}})}),define(Re[215],Oe([1,0,5,4,7,23]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(m){this.b=new Map,this.c=[],this.d=new i.Emitter,this.onDidChangeSessions=this.d.event,this.f=new R,this.g=new R,this.a=m.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(m){return this.c=m,Promise.resolve()}async getSession(m,O,w,c={}){const p=N.ExtensionIdentifier.toKey(m.identifier),g=[...w].sort().join(" ");return await this.f.getOrCreate(`${p} ${O} ${g}`,async()=>{await this.a.$ensureProvider(O);const d=m.displayName||m.name;return this.a.$getSession(O,w,p,d,c)})}async getSessions(m,O,w){const c=N.ExtensionIdentifier.toKey(m.identifier),p=[...w].sort().join(" ");return await this.g.getOrCreate(`${c} ${p}`,async()=>{await this.a.$ensureProvider(O);const g=m.displayName||m.name;return this.a.$getSessions(O,w,c,g)})}async removeSession(m,O){const w=this.b.get(m);return w?w.provider.removeSession(O):this.a.$removeSession(m,O)}registerAuthenticationProvider(m,O,w,c){if(this.b.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this.b.set(m,{label:O,provider:w,options:c??{supportsMultipleAccounts:!1}}),this.c.find(g=>g.id===m)||this.c.push({id:m,label:O});const p=w.onDidChangeSessions(g=>{this.a.$sendDidChangeSessions(m,{added:g.added??[],changed:g.changed??[],removed:g.removed??[]})});return this.a.$registerAuthenticationProvider(m,O,c?.supportsMultipleAccounts??!1),new D.Disposable(()=>{p.dispose(),this.b.delete(m);const g=this.c.findIndex(d=>d.id===m);g>-1&&this.c.splice(g),this.a.$unregisterAuthenticationProvider(m)})}$createSession(m,O,w){const c=this.b.get(m);if(c)return Promise.resolve(c.provider.createSession(O,w));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,O){const w=this.b.get(m);if(w)return Promise.resolve(w.provider.removeSession(O));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,O){const w=this.b.get(m);if(w)return Promise.resolve(w.provider.getSessions(O));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,O){return this.d.fire({provider:{id:m,label:O}}),Promise.resolve()}}e.ExtHostAuthentication=F;class R{constructor(){this.a=new Map}getOrCreate(m,O){const w=this.a.get(m);if(w)return w;const c=O().finally(()=>this.a.delete(m));return this.a.set(m,c),c}}}),define(Re[216],Oe([1,0,4,17,8]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let N=e.ExtHostBulkEdits=class{constructor(R,S){this.a=R.getProxy(i.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:m=>S.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(R,S,m){const O=D.WorkspaceEdit.from(R,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,m?.isRefactoring??!1)}};e.ExtHostBulkEdits=N=xe([Ve(0,k.IExtHostRpcService)],N)}),define(Re[217],Oe([1,0,5,6,58,9,146,4,8]),function(te,e,i,k,D,N,F,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class m{constructor(c,p){this.extension=c,this.provider=p,this.handle=m.a++}}m.a=0;class O{constructor(c,p){this.i=p,this.b=new Map,this.d=new Map,this.e=new Map,this.g=new i.Emitter,this.onDidPerformUserAction=this.g.event,this.h=c.getProxy(R.MainContext.MainThreadChat)}registerChatProvider(c,p,g){const d=new m(c,g);return this.b.set(d.handle,d),this.h.$registerChatProvider(d.handle,p),(0,k.toDisposable)(()=>{this.h.$unregisterChatProvider(d.handle),this.b.delete(d.handle)})}addChatRequest(c){this.h.$addRequest(c)}sendInteractiveRequestToProvider(c,p){this.h.$sendRequestToProvider(c,p)}async $prepareChat(c,p,g){const d=this.b.get(c);if(!d)return;const t=await d.provider.prepareSession(p,g);if(!t)return;const u=O.a++;return this.e.set(u,t),{id:u,requesterUsername:t.requester?.name,requesterAvatarIconUri:t.requester?.icon,responderUsername:t.responder?.name,responderAvatarIconUri:t.responder?.icon,inputPlaceholder:t.inputPlaceholder}}async $resolveRequest(c,p,g,d){const t=this.b.get(c);if(!t)return;const u=this.e.get(p);if(!u||!t.provider.resolveRequest)return;const h=await t.provider.resolveRequest(u,g,d);if(h)return{message:typeof h.message=="string"?h.message:S.ChatReplyFollowup.from(h.message)}}async $provideWelcomeMessage(c,p){const g=this.b.get(c);if(!g||!g.provider.provideWelcomeMessage)return;const d=await g.provider.provideWelcomeMessage(p);if(d)return d.map(t=>typeof t=="string"?t:t.map(u=>S.ChatReplyFollowup.from(u)))}async $provideFollowups(c,p,g){const d=this.b.get(c);if(!d)return;const t=this.e.get(p);return!t||!d.provider.provideFollowups?void 0:(await d.provider.provideFollowups(t,g))?.map(h=>S.ChatFollowup.from(h))}$removeRequest(c,p,g){const d=this.b.get(c);if(!d)return;const t=this.e.get(p);t&&d.provider.removeRequest&&d.provider.removeRequest(t,g)}async $provideReply(c,p,g,d){const t=this.b.get(c);if(!t)return;const u=this.e.get(p);if(!u)return;const h={session:u,message:typeof g.message=="string"?g.message:S.ChatReplyFollowup.to(g.message)},y=D.StopWatch.create(!1);let C;const v={report:r=>{if(d.isCancellationRequested)return;typeof C>"u"&&(C=y.elapsed());const a="responseId"in r?{requestId:r.responseId}:r;this.h.$acceptResponseProgress(c,p,a)}};let n;try{n=await t.provider.provideResponseWithProgress(h,v,d),n||(n={errorDetails:{message:(0,F.localize)(0,null)}})}catch(r){n={errorDetails:{message:(0,F.localize)(1,null,r.message),responseIsIncomplete:!0}},this.i.error(r)}try{if(u.saveState&&this.e.has(p)){const r=u.saveState();this.h.$acceptChatState(p,r)}}catch(r){this.i.warn(r)}const l={firstProgress:C??0,totalElapsed:y.elapsed()};return{errorDetails:n.errorDetails,timings:l}}async $provideSlashCommands(c,p,g){const d=this.b.get(c);if(!d)return;const t=this.e.get(p);return!t||!d.provider.provideSlashCommands?void 0:(await d.provider.provideSlashCommands(t,g))?.map(h=>({...h,kind:S.CompletionItemKind.from(h.kind)}))}$releaseSession(c){this.e.delete(c)}async $onDidPerformUserAction(c){this.g.fire(c)}registerSlashCommandProvider(c,p,g){const d=new m(c,g);return this.d.set(d.handle,d),this.h.$registerSlashCommandProvider(d.handle,p),(0,k.toDisposable)(()=>{this.h.$unregisterSlashCommandProvider(d.handle),this.d.delete(d.handle)})}async $provideProviderSlashCommands(c,p){const g=this.d.get(c);return g?(await g.provider.provideSlashCommands(p))?.map(t=>({...t,kind:S.CompletionItemKind.from(t.kind)})):void 0}async $resolveSlashCommand(c,p,g){const d=this.d.get(c);if(!d)return;const t=await d.provider.resolveSlashCommand(p,g);return(0,N.withNullAsUndefined)(t)}}e.ExtHostChat=O,O.a=0}),define(Re[218],Oe([1,0,4]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(N){const F=N.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(R){return F.$writeText(R)}})}}e.ExtHostClipboard=k});var Ye=this&&this.__classPrivateFieldSet||function(te,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Fe=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(Re[32],Oe([1,0,9,7,8,26,4,18,14,68,44,272,2,6,3,17,105,24,46,40,58,52,57]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t,u,h,y,C,v,n){"use strict";var l,r,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let b=e.ExtHostCommands=class{constructor(s,M,B){l.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),a.set(this,void 0),Ye(this,l,s.getProxy(F.MainContext.MainThreadCommands),"f"),this.d=M,Ye(this,a,B,"f"),Ye(this,r,s.getProxy(F.MainContext.MainThreadTelemetry),"f"),this.converter=new I(this,X=>{const G=this.c.get(X);return G?.result===P.Void?G:void 0},M),this.f=[{processArgument(X){return(0,m.revive)(X)}},{processArgument(X){return(0,N.cloneAndChange)(X,function(G){if(O.Range.isIRange(G))return D.Range.to(G);if(w.Position.isIPosition(G))return D.Position.to(G);if(O.Range.isIRange(G.range)&&c.URI.isUri(G.uri))return D.location.to(G);if(G instanceof u.VSBuffer)return G.buffer.buffer;if(!Array.isArray(G))return G})}}]}registerArgumentProcessor(s){this.f.push(s)}registerApiCommand(s){const M=this.registerCommand(!1,s.id,async(...B)=>{const X=s.args.map((W,U)=>{if(!W.validate(B[U]))throw new Error(`Invalid argument '${W.name}' when running '${s.id}', received: ${B[U]}`);return W.convert(B[U])}),G=await this.executeCommand(s.internalId,...X);return s.result.convert(G,B,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this.c.set(s.id,s),new k.Disposable(()=>{M.dispose(),this.c.delete(s.id)})}registerCommand(s,M,B,X,G,W){if(this.d.trace("ExtHostCommands#registerCommand",M),!M.trim().length)throw new Error("invalid id");if(this.b.has(M))throw new Error(`command '${M}' already exists`);return this.b.set(M,{callback:B,thisArg:X,description:G,extension:W}),s&&Fe(this,l,"f").$registerCommand(M),new k.Disposable(()=>{this.b.delete(M)&&s&&Fe(this,l,"f").$unregisterCommand(M)})}executeCommand(s,...M){return this.d.trace("ExtHostCommands#executeCommand",s),this.g(s,M,!0)}async g(s,M,B){if(this.b.has(s))return Fe(this,l,"f").$fireCommandActivationEvent(s),this.h(s,M,!1);{let X=!1;const G=(0,N.cloneAndChange)(M,function(W){if(W instanceof k.Position)return D.Position.from(W);if(W instanceof k.Range)return D.Range.from(W);if(W instanceof k.Location)return D.location.from(W);if(k.NotebookRange.isNotebookRange(W))return D.NotebookRange.from(W);if(W instanceof ArrayBuffer)return X=!0,u.VSBuffer.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return X=!0,u.VSBuffer.wrap(W);if(W instanceof u.VSBuffer)return X=!0,W;if(!Array.isArray(W))return W});try{const W=await Fe(this,l,"f").$executeCommand(s,X?new h.SerializableObjectWithBuffers(G):G,B);return(0,m.revive)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(s,M,!1);throw W}}}async h(s,M,B){const X=this.b.get(s);if(!X)throw new Error("Unknown command");const{callback:G,thisArg:W,description:U}=X;if(U)for(let z=0;z<U.args.length;z++)try{(0,i.validateConstraint)(M[z],U.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${U.args[z].name}' - ${U.args[z].description}`)}const q=C.StopWatch.create();try{return await G.apply(W,M)}catch(z){if(s===this.converter.delegatingCommandId){const V=this.converter.getActualCommand(...M);V&&(s=V.command)}if(this.d.error(z,s,X.extension?.identifier),!B)throw z;if(X.extension?.identifier){const V=Fe(this,a,"f").onExtensionError(X.extension.identifier,z);this.d.trace("forwarded error to extension?",V,X.extension?.identifier)}throw new class extends Error{constructor(){super((0,y.toErrorMessage)(z)),this.id=s,this.source=X.extension?.displayName??X.extension?.name}}}finally{this.j(X,s,q.elapsed())}}j(s,M,B){s.extension&&Fe(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:s.extension.identifier.value,id:new v.TelemetryTrustedValue(M),duration:B})}$executeContributedCommand(s,...M){this.d.trace("ExtHostCommands#$executeContributedCommand",s);const B=this.b.get(s);return B?(M=M.map(X=>this.f.reduce((G,W)=>W.processArgument(G,B.extension?.identifier),X)),this.h(s,M,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this.d.trace("ExtHostCommands#getCommands",s),Fe(this,l,"f").$getCommands().then(M=>(s&&(M=M.filter(B=>B[0]!=="_")),M))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(const[M,B]of this.b){const{description:X}=B;X&&(s[M]=X)}return Promise.resolve(s)}};l=new WeakMap,r=new WeakMap,a=new WeakMap,e.ExtHostCommands=b=xe([Ve(0,d.IExtHostRpcService),Ve(1,S.ILogService),Ve(2,n.IExtHostTelemetry)],b),e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class I{constructor(s,M,B){this.d=s,this.f=M,this.g=B,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(s,M){if(!s)return;const B={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return B;const X=this.f(s.command);if(X)B.id=X.internalId,B.arguments=X.args.map((G,W)=>G.convert(s.arguments&&s.arguments[W]));else if((0,R.isNonEmptyArray)(s.arguments)){const G=`${s.command}/${++this.c}`;this.b.set(G,s),M.add((0,p.toDisposable)(()=>{this.b.delete(G),this.g.trace("CommandsConverter#DISPOSE",G)})),B.$ident=G,B.id=this.delegatingCommandId,B.arguments=[G],this.g.trace("CommandsConverter#CREATE",s.command,G)}return B}fromInternal(s){return typeof s.$ident=="string"?this.b.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this.b.get(s[0])}h(...s){const M=this.getActualCommand(...s);return this.g.trace("CommandsConverter#EXECUTE",s[0],M?M.command:"MISSING"),M?this.d.executeCommand(M.command,...M.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${s[0]}`)}}e.CommandsConverter=I;class f{constructor(s,M,B,X){this.name=s,this.description=M,this.validate=B,this.convert=X}optional(){return new f(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,M){return new f(s??this.name,M??this.description,this.validate,this.convert)}}e.ApiCommandArgument=f,f.Uri=new f("uri","Uri of a text document",o=>c.URI.isUri(o),o=>o),f.Position=new f("position","A position in a text document",o=>k.Position.isPosition(o),D.Position.from),f.Range=new f("range","A range in a text document",o=>k.Range.isRange(o),D.Range.from),f.Selection=new f("selection","A selection in a text document",o=>k.Selection.isSelection(o),D.Selection.from),f.Number=new f("number","",o=>typeof o=="number",o=>o),f.String=new f("string","",o=>typeof o=="string",o=>o),f.CallHierarchyItem=new f("item","A call hierarchy item",o=>o instanceof k.CallHierarchyItem,D.CallHierarchyItem.from),f.TypeHierarchyItem=new f("item","A type hierarchy item",o=>o instanceof k.TypeHierarchyItem,D.TypeHierarchyItem.from),f.TestItem=new f("testItem","A VS Code TestItem",o=>o instanceof t.TestItemImpl,D.TestItem.from);class P{constructor(s,M){this.description=s,this.convert=M}}e.ApiCommandResult=P,P.Void=new P("no result",o=>o);class E{constructor(s,M,B,X,G){this.id=s,this.internalId=M,this.description=B,this.args=X,this.result=G}}e.ApiCommand=E}),define(Re[219],Oe([1,0,18,15,2,78,91,31,95,32,8,7]),function(te,e,i,k,D,N,F,R,S,m,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const c=[new m.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(O.DocumentHighlight.to))),new m.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,u)=>{if((0,i.isFalsyOrEmpty)(t))return;class h extends w.SymbolInformation{static to(C){const v=new h(C.name,O.SymbolKind.to(C.kind),C.containerName||"",new w.Location(u[0],O.Range.to(C.range)));return v.detail=C.detail,v.range=v.location.range,v.selectionRange=O.Range.to(C.selectionRange),v.children=C.children?C.children.map(h.to):[],v}}return t.map(h.to)})),new m.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(O.TextEdit.to))),new m.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(O.TextEdit.to))),new m.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,new m.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(O.TextEdit.to))),new m.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new m.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new m.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new m.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new m.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(O.location.to))),new m.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(O.Hover.to))),new m.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(u=>w.Position.isPosition(u)),t=>t.map(O.Position.from))],new m.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(u=>{let h;for(const y of u.reverse())h=new w.SelectionRange(O.Range.to(y),h);return h}))),new m.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.ApiCommandArgument.String.with("query","Search string")],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(O.WorkspaceSymbol.to))),new m.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(O.CallHierarchyItem.to))),new m.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(O.CallHierarchyIncomingCall.to))),new m.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(O.CallHierarchyOutgoingCall.to))),new m.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:O.Range.to(t.range),placeholder:t.text}})),new m.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("newName","The new symbol name")],new m.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return O.WorkspaceEdit.to(t)}})),new m.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(O.DocumentLink.to))),new m.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new w.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const u=(0,F.decodeSemanticTokensDto)(t);if(u.type==="full")return new w.SemanticTokens(u.data,void 0)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range.optional()],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new w.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const u=(0,F.decodeSemanticTokensDto)(t);if(u.type==="full")return new w.SemanticTokens(u.data,void 0)})),new m.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,u,h)=>{if(!t)return new w.CompletionList([]);const y=t.suggestions.map(C=>O.CompletionItem.to(C,h));return new w.CompletionList(y,t.incomplete)})),new m.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return O.SignatureHelp.to(t)})),new m.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,u,h)=>g(y=>new w.CodeLens(O.Range.to(y.range),y.command&&h.fromInternal(y.command)))(t))),new m.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>w.Range.isRange(t),t=>w.Selection.isSelection(t)?O.Selection.from(t):O.Range.from(t)),m.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,u,h)=>g(y=>{if(y._isSynthetic){if(!y.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(y.command)}else{const C=new w.CodeAction(y.title,y.kind?new w.CodeActionKind(y.kind):void 0);return y.edit&&(C.edit=O.WorkspaceEdit.to(y.edit)),y.command&&(C.command=h.fromInternal(y.command)),C.isPreferred=y.isPreferred,C}})(t))),new m.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(u=>new w.ColorInformation(O.Range.to(u.range),O.Color.to(u.color))):[])),new m.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.ApiCommandArgument("color","The color to show and insert",t=>t instanceof w.Color,O.Color.from),new m.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:O.Range.from(t.range)}))],new m.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(O.ColorPresentation.to):[])),new m.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,u,h)=>t.map(O.InlayHint.to.bind(void 0,h)))),new m.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,u)=>{if(t)return t.map(O.FoldingRange.to)})),new m.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(u=>O.NotebookExclusiveDocumentPattern.to(u))})))),new m.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(O.InlineValue.to))),new m.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>D.URI.isUri(t)||typeof t=="string"&&(0,S.matchesSomeScheme)(t,k.Schemas.http,k.Schemas.https),t=>t),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[O.ViewColumn.from(t),void 0]:[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)])).optional(),m.ApiCommandArgument.String.with("label","").optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.ApiCommandArgument.Uri.with("resource","Resource to open"),m.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[O.ViewColumn.from(t),void 0]:[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)])).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),m.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),m.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)]).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new m.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.ApiCommandArgument.TestItem],m.ApiCommandResult.Void),new m.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.ApiCommandResult.Void),new m.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.ApiCommandArgument.String.with("name","The context key name"),new m.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],m.ApiCommandResult.Void)];class p{static register(u){c.forEach(u.registerApiCommand,u),this.a(u)}static a(u){u.registerCommand(!1,"_validateWhenClauses",R.validateWhenClauses)}}e.ExtHostApiCommands=p;function g(t){return u=>{if(Array.isArray(u))return u.map(t)}}function d(t){if(!Array.isArray(t))return;const u=[];for(const h of t)N.isLocationLink(h)?u.push(O.DefinitionLink.to(h)):u.push(O.location.to(h));return u}}),define(Re[220],Oe([1,0,16,65,5,6,2,78,23,8,7,4,20,9]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function g(d,t,u){const h=d.getProxy(w.MainContext.MainThreadComments);class y{constructor(){this.b=new Map,this.c=new S.ExtensionIdentifierMap,t.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const P=this.b.get(f.handle);return P?P.value:f}else if(f&&f.$mid===7){const P=this.b.get(f.commentControlHandle);if(!P)return f;const E=P.getCommentThread(f.commentThreadHandle);return E?E.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const P=this.b.get(f.thread.commentControlHandle);if(!P)return f;const E=P.getCommentThread(f.thread.commentThreadHandle);return E?f.$mid===8?E.value:{thread:E.value,text:f.text}:f}else if(f&&f.$mid===10){const P=this.b.get(f.thread.commentControlHandle);if(!P)return f;const E=P.getCommentThread(f.thread.commentThreadHandle);if(!E)return f;const o=f.commentUniqueId,s=E.getCommentByUniqueId(o);return s||f}else if(f&&f.$mid===11){const P=this.b.get(f.thread.commentControlHandle);if(!P)return f;const E=P.getCommentThread(f.thread.commentThreadHandle);if(!E)return f;const o=f.text,s=f.commentUniqueId,M=E.getCommentByUniqueId(s);return M?(typeof M.body=="string"?M.body=o:M.body=new O.MarkdownString(o),M):f}return f}})}createCommentController(f,P,E){const o=y.a++,s=new v(f,o,P,E);this.b.set(s.handle,s);const M=this.c.get(f.identifier)||[];return M.push(s),this.c.set(f.identifier,M),s.value}$createCommentThreadTemplate(f,P,E){const o=this.b.get(f);o&&o.$createCommentThreadTemplate(P,E)}async $updateCommentThreadTemplate(f,P,E){const o=this.b.get(f);o&&o.$updateCommentThreadTemplate(P,E)}$deleteCommentThread(f,P){this.b.get(f)?.$deleteCommentThread(P)}$provideCommentingRanges(f,P,E){const o=this.b.get(f);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const s=u.getDocument(F.URI.revive(P));return(0,i.asPromise)(async()=>{const M=await o.commentingRangeProvider.provideCommentingRanges(s,E);let B;return Array.isArray(M)?B={ranges:M,fileComments:!1}:M?B={ranges:M.ranges||[],fileComments:M.fileComments||!1}:B=(0,p.withNullAsUndefined)(M),B}).then(M=>{let B;return M&&(B={ranges:M.ranges.map(X=>m.Range.from(X)),fileComments:M.fileComments}),B})}$toggleReaction(f,P,E,o,s){const M=this.b.get(f);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const B=M.getCommentThread(P);if(B){const X=B.getCommentByUniqueId(o.uniqueIdInThread);if(M!==void 0&&X&&M.reactionHandler)return M.reactionHandler(X,r(s))}return Promise.resolve(void 0)})}}y.a=0;class C{set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,P,E,o,s,M,B,X){this.m=P,this.n=E,this.o=o,this.p=s,this.q=M,this.extensionDescription=B,this.r=X,this.handle=C.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new D.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.MutableDisposable,this.l.value=new N.DisposableStore,this.n===void 0&&(this.n=`${f}.${this.handle}`),h.$createCommentThread(P,this.handle,this.n,this.o,m.Range.from(this.p),B.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=M,this.i.push({dispose:()=>{h.$deleteCommentThread(P,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(W){G.range=W},get comments(){return G.comments},set comments(W){G.comments=W},get collapsibleState(){return G.collapsibleState},set collapsibleState(W){G.collapsibleState=W},get canReply(){return G.canReply},set canReply(W){G.canReply=W},get contextValue(){return G.contextValue},set contextValue(W){G.contextValue=W},get label(){return G.label},set label(W){G.label=W},get state(){return G.state},set state(W){G.state=W},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.DisposableStore);const f=E=>Object.prototype.hasOwnProperty.call(this.b,E),P={};f("range")&&(P.range=m.Range.from(this.p)),f("label")&&(P.label=this.label),f("contextValue")&&(P.contextValue=this.contextValue??null),f("comments")&&(P.comments=this.q.map(E=>n(this,E,this.k,this.extensionDescription))),f("collapsibleState")&&(P.collapseState=a(this.g)),f("canReply")&&(P.canReply=this.canReply),f("state")&&(P.state=b(this.h)),f("isTemplate")&&(P.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,P)}getCommentByUniqueId(f){for(const P of this.k){const E=P[0],o=P[1];if(f===o)return E}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}C.a=0,xe([(0,k.debounce)(100)],C.prototype,"eventuallyUpdateCommentThread",null);class v{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,P,E,o){this.f=f,this.g=P,this.h=E,this.i=o,this.a=new Map,h.$registerCommentController(this.handle,E,o);const s=this;this.value=Object.freeze({id:s.id,label:s.label,get options(){return s.options},set options(M){s.options=M},get commentingRangeProvider(){return s.commentingRangeProvider},set commentingRangeProvider(M){s.commentingRangeProvider=M},get reactionHandler(){return s.reactionHandler},set reactionHandler(M){s.reactionHandler=M},createCommentThread(M,B,X){return s.createCommentThread(M,B,X).value},dispose:()=>{s.dispose()}}),this.e=[],this.e.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(f,P,E){P===void 0&&(0,c.checkProposedApiEnabled)(this.f,"fileComments");const o=new C(this.id,this.handle,void 0,f,P,E,this.f,!1);return this.a.set(o.handle,o),o}$createCommentThreadTemplate(f,P){const E=new C(this.id,this.handle,void 0,F.URI.revive(f),m.Range.to(P),[],this.f,!0);return E.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this.a.set(E.handle,E),E}$updateCommentThreadTemplate(f,P){const E=this.a.get(f);E&&(E.range=m.Range.to(P))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function n(I,f,P,E){let o=P.get(f);return o||(o=++I.commentHandle,P.set(f,o)),f.state!==void 0&&(0,c.checkProposedApiEnabled)(E,"commentsDraftState"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:o,body:typeof f.body=="string"?f.body:m.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(s=>l(s)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function l(I){return{label:I.label,iconPath:I.iconPath?m.pathOrURIToURI(I.iconPath):void 0,count:I.count,hasReacted:I.authorHasReacted}}function r(I){return{label:I.label||"",count:I.count||0,iconPath:I.iconPath?F.URI.revive(I.iconPath):"",authorHasReacted:I.hasReacted||!1}}function a(I){if(I!==void 0)switch(I){case O.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}function b(I){if(I!==void 0)switch(I){case O.CommentThreadState.Unresolved:return R.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return R.CommentThreadState.Resolved}return R.CommentThreadState.Unresolved}return new y}e.createExtHostComments=g}),define(Re[221],Oe([1,0,26,4,27,17]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let F=e.AbstractExtHostConsoleForwarder=class{constructor(O,w){this.a=O.getProxy(k.MainContext.MainThreadConsole),this.b=w.consoleForward.includeStack,this.c=w.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,w){const c=this,p=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){c.e(O,w,p,arguments)}})}e(O,w,c,p){this.a.$logExtensionHostMessage({type:"__$console",severity:w,arguments:S(p,this.b)}),this.c&&this.f(O,c,p)}};e.AbstractExtHostConsoleForwarder=F=xe([Ve(0,N.IExtHostRpcService),Ve(1,D.IExtHostInitDataService)],F);const R=1e5;function S(m,O){const w=[];if(m.length)for(let c=0;c<m.length;c++){let p=m[c];if(typeof p>"u")p="undefined";else if(p instanceof Error){const g=p;g.stack?p=g.stack:p=g.toString()}w.push(p)}if(O){const c=new Error().stack;c&&w.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,i.safeStringify)(w);return c.length>R?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(Re[107],Oe([1,0,2,4,7,3,17,14,18,13,19,20]),function(te,e,i,k,D,N,F,R,S,m,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let c=e.ExtHostDecorations=class an{constructor(g,d){this.h=d,this.f=new Map,this.g=g.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,d){const t=an.c++;this.f.set(t,{provider:g,extensionDescription:d}),this.g.$registerDecorationProvider(t,d.identifier.value);const u=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(h=>{if(!h){this.g.$onDidChange(t,null);return}const y=(0,S.asArray)(h);if(y.length<=an.d){this.g.$onDidChange(t,y);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,y.length);const C=y.map(l=>({uri:l,rank:(0,m.count)(l.path,"/")})),v=(0,S.groupBy)(C,(l,r)=>l.rank-r.rank||(0,m.compare)(l.uri.path,r.uri.path)),n=[];e:for(const l of v){let r;for(const a of l){const b=(0,O.dirname)(a.uri.path);if(r!==b&&(r=b,n.push(a.uri)>=an.d))break e}}this.g.$onDidChange(t,n)});return new D.Disposable(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(g,d,t){if(!this.f.has(g))return Object.create(null);const u=Object.create(null),{provider:h,extensionDescription:y}=this.f.get(g);return await Promise.all(d.map(async C=>{try{const{uri:v,id:n}=C,l=await Promise.resolve(h.provideFileDecoration(i.URI.revive(v),t));if(!l)return;try{D.FileDecoration.validate(l),l.badge&&typeof l.badge!="string"&&(0,w.checkProposedApiEnabled)(y,"codiconDecoration"),u[n]=[l.propagate,l.tooltip,l.badge,l.color]}catch(r){this.h.warn(`INVALID decoration from extension '${y}': ${r}`)}}catch(v){this.h.error(v)}})),u}};c.c=0,c.d=250,e.ExtHostDecorations=c=xe([Ve(0,F.IExtHostRpcService),Ve(1,R.ILogService)],c),e.IExtHostDecorations=(0,N.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(te,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Fe=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(Re[222],Oe([1,0,147,94,2,4,7,8,5,14,28,38]),function(te,e,i,k,D,N,F,R,S,m,O,w){"use strict";var c,p,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(h,y,C,v,n,l,r){this.d=h,this.e=y,this.f=C,this.g=v,c.set(this,void 0),p.set(this,void 0),g.set(this,void 0),this.c=!1,Ye(this,g,new O.ResourceMap(a=>n.getComparisonKey(a)),"f"),Ye(this,c,l,"f"),Ye(this,p,r,"f")}dispose(){this.c||(Fe(this,p,"f").fire([...Fe(this,g,"f").keys()]),Fe(this,c,"f")?.$clear(this.e),Fe(this,g,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(h,y){if(!h){this.clear();return}this.h();let C=[];if(D.URI.isUri(h)){if(!y){this.delete(h);return}Fe(this,g,"f").set(h,y.slice()),C=[h]}else if(Array.isArray(h)){C=[];let n;h=[...h].sort(d.j);for(const l of h){const[r,a]=l;if((!n||r.toString()!==n.toString())&&(n&&Fe(this,g,"f").get(n).length===0&&Fe(this,g,"f").delete(n),n=r,C.push(r),Fe(this,g,"f").set(r,[])),a)Fe(this,g,"f").get(r)?.push(...a);else{const b=Fe(this,g,"f").get(r);b&&(b.length=0)}}}if(Fe(this,p,"f").fire(C),!Fe(this,c,"f"))return;const v=[];for(const n of C){let l=[];const r=Fe(this,g,"f").get(n);if(r)if(r.length>this.f){l=[];const a=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let b=0;b<4;b++)for(const I of r)if(I.severity===a[b]&&l.push({...R.Diagnostic.from(I),modelVersionId:this.g(n)})===this.f)break e;l.push({severity:k.MarkerSeverity.Info,message:(0,i.localize)(0,null,r.length-this.f),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=r.map(a=>({...R.Diagnostic.from(a),modelVersionId:this.g(n)}));v.push([n,l])}Fe(this,c,"f").$changeMany(this.e,v)}delete(h){this.h(),Fe(this,p,"f").fire([h]),Fe(this,g,"f").delete(h),Fe(this,c,"f")?.$changeMany(this.e,[[h,void 0]])}clear(){this.h(),Fe(this,p,"f").fire([...Fe(this,g,"f").keys()]),Fe(this,g,"f").clear(),Fe(this,c,"f")?.$clear(this.e)}forEach(h,y){this.h();for(const[C,v]of this)h.call(y,C,v,this)}*[(c=new WeakMap,p=new WeakMap,g=new WeakMap,Symbol.iterator)](){this.h();for(const h of Fe(this,g,"f").keys())yield[h,this.get(h)]}get(h){this.h();const y=Fe(this,g,"f").get(h);return Array.isArray(y)?Object.freeze(y.slice(0)):[]}has(h){return this.h(),Array.isArray(Fe(this,g,"f").get(h))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(h,y){return h[0].toString()<y[0].toString()?-1:h[0].toString()>y[0].toString()?1:0}}e.DiagnosticCollection=d;let t=e.ExtHostDiagnostics=class bi{static _mapper(h){const y=new O.ResourceMap;for(const C of h)y.set(C,C);return{uris:Object.freeze(Array.from(y.values()))}}constructor(h,y,C,v){this.h=y,this.j=C,this.k=v,this.f=new Map,this.g=new S.DebounceEmitter({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,bi._mapper),this.e=h.getProxy(N.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(h,y){const{f:C,e:v,g:n,h:l,j:r,k:a}=this,b=new class{$changeMany(P,E){v.$changeMany(P,E),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",h.value,P,E.length===0?"CLEARING":E)}$clear(P){v.$clear(P),l.trace("[DiagnosticCollection] remove all (extension, owner)",h.value,P)}dispose(){v.dispose()}};let I;if(!y)y="_generated_diagnostic_collection_name_#"+bi.c++,I=y;else if(!C.has(y))I=y;else{this.h.warn(`DiagnosticCollection with name '${y}' does already exist.`);do I=y+bi.c++;while(C.has(I))}return new class extends d{constructor(){super(y,I,bi.d,P=>a.getDocument(P)?.version,r.extUri,b,n),C.set(I,this)}dispose(){super.dispose(),C.delete(I)}}}getDiagnostics(h){if(h)return this.l(h);{const y=new Map,C=[];for(const v of this.f.values())v.forEach((n,l)=>{let r=y.get(n.toString());typeof r>"u"&&(r=C.length,y.set(n.toString(),r),C.push([n,[]])),C[r][1]=C[r][1].concat(...l)});return C}}l(h){let y=[];for(const C of this.f.values())C.has(h)&&(y=y.concat(C.get(h)));return y}$acceptMarkersChange(h){if(!this.m){const y="_generated_mirror",C=new d(y,y,bi.d,v=>{},this.j.extUri,void 0,this.g);this.f.set(y,C),this.m=C}for(const[y,C]of h)this.m.set(D.URI.revive(y),C.map(R.Diagnostic.to))}};t.c=0,t.d=1e3,e.ExtHostDiagnostics=t=xe([Ve(1,m.ILogService),Ve(2,w.IExtHostFileSystemInfo)],t)}),define(Re[223],Oe([1,0,2,4,20]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class N{constructor(R){this.a=R.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(R,S){return S?.allowUIResources&&(0,D.checkProposedApiEnabled)(R,"showLocal"),this.a.$showOpenDialog(S).then(m=>m?m.map(O=>i.URI.revive(O)):void 0)}showSaveDialog(R){return this.a.$showSaveDialog(R).then(S=>S?i.URI.revive(S):void 0)}}e.ExtHostDialogs=N}),define(Re[224],Oe([1,0,10,2,7,4,15,22,13]),function(te,e,i,k,D,N,F,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class m{constructor(w,c,p){this.d=c,this.e=p,this.b=new Map,this.c=w.getProxy(N.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,c){if(Object.keys(F.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const p=m.a++;this.b.set(p,c),this.c.$registerTextContentProvider(p,w);let g;return typeof c.onDidChange=="function"&&(g=c.onDidChange(d=>{if(d.scheme!==w){this.e.warn(`Provider for scheme '${w}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(p,d).then(t=>{if(!t&&typeof t!="string")return;const u=this.d.getDocument(d);if(!u)return;const h=(0,S.splitLines)(t);if(!u.equalLines(h))return this.c.$onVirtualDocumentChange(d,t)},i.onUnexpectedError)})),new D.Disposable(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(w,c){const p=this.b.get(w);return p?Promise.resolve(p.provideTextDocumentContent(k.URI.revive(c),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=m,m.a=0}),define(Re[225],Oe([1,0,5,6,2,4,103,8,9,26,7]),function(te,e,i,k,D,N,F,R,S,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(p,g){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new k.DisposableStore,this.h=new Map,this.f=p.getProxy(N.MainContext.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(d=>{for(const t of d)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const t of d)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const g=this.g.getDocument(p);if(g)return g}getDocument(p){const g=this.getDocumentData(p);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return g.document}ensureDocumentData(p){const g=this.g.getDocument(p);if(g)return Promise.resolve(g);let d=this.h.get(p.toString());return d||(d=this.f.$tryOpenDocument(p).then(t=>{this.h.delete(p.toString());const u=D.URI.revive(t);return(0,S.assertIsDefined)(this.g.getDocument(u))},t=>(this.h.delete(p.toString()),Promise.reject(t))),this.h.set(p.toString(),d)),d}createDocumentData(p){return this.f.$tryCreateDocument(p).then(g=>D.URI.revive(g))}$acceptModelLanguageChanged(p,g){const d=D.URI.revive(p),t=this.g.getDocument(d);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(g),this.a.fire(t.document)}$acceptModelSaved(p){const g=D.URI.revive(p),d=this.g.getDocument(g);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(p,g){const d=D.URI.revive(p),t=this.g.getDocument(d);if(!t)throw new Error("unknown document");t._acceptIsDirty(g),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,g,d){const t=D.URI.revive(p),u=this.g.getDocument(t);if(!u)throw new Error("unknown document");u._acceptIsDirty(d),u.onEvents(g);let h;g.isUndoing?h=O.TextDocumentChangeReason.Undo:g.isRedoing&&(h=O.TextDocumentChangeReason.Redo),this.c.fire((0,m.deepFreeze)({document:u.document,contentChanges:g.changes.map(y=>({range:R.Range.to(y.range),rangeOffset:y.rangeOffset,rangeLength:y.rangeLength,text:y.text})),reason:h}))}setWordDefinitionFor(p,g){(0,F.setWordDefinitionFor)(p,g)}}e.ExtHostDocuments=w}),define(Re[59],Oe([1,0,49,5,6,2,3,4,103,17,106,8,14,28,15,88,66]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(C){this.value=C,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=e.ExtHostDocumentsAndEditors=class{constructor(C,v){this.h=C,this.i=v,this.a=null,this.b=new Map,this.c=new p.ResourceMap,this.d=new k.Emitter,this.e=new k.Emitter,this.f=new k.Emitter,this.g=new k.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(C){this.acceptDocumentsAndEditorsDelta(C)}acceptDocumentsAndEditorsDelta(C){const v=[],n=[],l=[];if(C.removedDocuments)for(const r of C.removedDocuments){const a=N.URI.revive(r),b=this.c.get(a);b?.unref()&&(this.c.delete(a),v.push(b.value))}if(C.addedDocuments)for(const r of C.addedDocuments){const a=N.URI.revive(r.uri);let b=this.c.get(a);if(b&&a.scheme!==g.Schemas.vscodeNotebookCell&&a.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);b||(b=new u(new S.ExtHostDocumentData(this.h.getProxy(R.MainContext.MainThreadDocuments),a,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(a,b),n.push(b.value)),b.ref()}if(C.removedEditors)for(const r of C.removedEditors){const a=this.b.get(r);this.b.delete(r),a&&l.push(a)}if(C.addedEditors)for(const r of C.addedEditors){const a=N.URI.revive(r.documentUri);i.ok(this.c.has(a),`document '${a}' does not exist`),i.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const b=this.c.get(a).value,I=new O.ExtHostTextEditor(r.id,this.h.getProxy(R.MainContext.MainThreadTextEditors),this.i,new t.Lazy(()=>b.document),r.selections.map(w.Selection.to),r.options,r.visibleRanges.map(f=>w.Range.to(f)),typeof r.editorPosition=="number"?w.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,I)}C.newActiveEditor!==void 0&&(i.ok(C.newActiveEditor===null||this.b.has(C.newActiveEditor),`active editor '${C.newActiveEditor}' does not exist`),this.a=C.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(l),C.removedDocuments&&this.e.fire(v),C.addedDocuments&&this.d.fire(n),(C.removedEditors||C.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),C.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(C){return this.c.get(C)?.value}allDocuments(){return d.Iterable.map(this.c.values(),C=>C.value)}getEditor(C){return this.b.get(C)}activeEditor(C){if(!this.a)return;const v=this.b.get(this.a);return C?v:v?.value}allEditors(){return[...this.b.values()]}};e.ExtHostDocumentsAndEditors=h=xe([Ve(0,m.IExtHostRpcService),Ve(1,c.ILogService)],h),e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(Re[60],Oe([1,0,8,4,2,5,3,7,17,9,64]),function(te,e,i,k,D,N,F,R,S,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,F.createDecorator)("IExtHostEditorTabs");class w{constructor(t,u,h){this.e=h,this.d=u,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,u={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(u)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.TextTabInput(D.URI.revive(this.b.input.uri));case 2:return new R.TextDiffTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified));case 3:return new R.TextMergeTabInput(D.URI.revive(this.b.input.base),D.URI.revive(this.b.input.input1),D.URI.revive(this.b.input.input2),D.URI.revive(this.b.input.result));case 6:return new R.CustomEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.WebviewEditorTabInput(this.b.input.viewType);case 4:return new R.NotebookEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(D.URI.revive(this.b.input.uri),D.URI.revive(this.b.input.inputBoxUri));default:return}}}class c{constructor(t,u){this.c=[],this.d="",this.b=t,this.e=u;for(const h of t.tabs)h.isActive&&(this.d=h.id),this.c.push(new w(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,u={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return i.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(h=>h.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(h=>h.apiObject))}};this.a=Object.freeze(u)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const h=new w(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,h),t.tabDto.isActive&&(this.d=h.tabId),h}else if(t.kind===1){const h=this.c.splice(t.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(t.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,h),h}const u=this.c.find(h=>h.tabId===t.tabDto.id);if(!u)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),u.acceptDtoUpdate(t.tabDto),u}activeTabId(){return this.d}}let p=e.ExtHostEditorTabs=class{constructor(t){this.b=new N.Emitter,this.c=new N.Emitter,this.e=[],this.a=t.getProxy(k.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,u={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(h=>h.apiObject))},get activeTabGroup(){const h=t.d;return(0,m.assertIsDefined)(t.e.find(C=>C.groupId===h)?.apiObject)},close:async(h,y)=>{const C=Array.isArray(h)?h:[h];return C.length?g(C[0])?this.j(C,y):this.i(C,y):!0}};this.f=Object.freeze(u)}return this.f}$acceptEditorTabModel(t){const u=new Set(this.e.map(r=>r.groupId)),h=new Set(t.map(r=>r.groupId)),y=(0,O.diffSets)(u,h),C=this.e.filter(r=>y.removed.includes(r.groupId)).map(r=>r.apiObject),v=[],n=[];this.e=t.map(r=>{const a=new c(r,()=>this.d);return y.added.includes(a.groupId)?v.push(a.apiObject):n.push(a.apiObject),a});const l=(0,m.assertIsDefined)(t.find(r=>r.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:v,closed:C,changed:n}))}$acceptTabGroupUpdate(t){const u=this.e.find(h=>h.groupId===t.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const u=this.e.find(y=>y.groupId===t.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const h=u.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(t){for(const u of this.e)for(const h of u.tabs)if(h.apiObject===t)return h}h(t){return this.e.find(u=>u.apiObject===t)}async i(t,u){const h=[];for(const y of t){const C=this.g(y);if(!C)throw new Error("Tab close: Invalid tab not found!");h.push(C.tabId)}return this.a.$closeTab(h,u)}async j(t,u){const h=[];for(const y of t){const C=this.h(y);if(!C)throw new Error("Group close: Invalid group not found!");h.push(C.groupId)}return this.a.$closeGroup(h,u)}};e.ExtHostEditorTabs=p=xe([Ve(0,S.IExtHostRpcService)],p);function g(d){return d.tabs!==void 0}}),define(Re[226],Oe([1,0,2,4,6,7,8,273,13,24,20]),function(te,e,i,k,D,N,F,R,S,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const d=this.a.indexOf(g);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),d=[];let t,u,h=14,y=14;for(const C of g){let v=t?(0,S.commonPrefixLength)(t,C):0;for(v===0?u=1:u=y;v<C.length;v++)v+1===C.length?(h=y,y=9):y+=1,d.push([u,C.toUpperCase().charCodeAt(v),y]),d.push([u,C.toLowerCase().charCodeAt(v),y]),u=y;t=C,y=h}d.push([9,58,10]),d.push([10,47,12]),this.b=new R.StateMachine(d)}}provideDocumentLinks(g){this.c();const d=[],t=R.LinkComputer.computeLinks({getLineContent(u){return g.lineAt(u-1).text},getLineCount(){return g.lineCount}},this.b);for(const u of t){const h=F.DocumentLink.to(u);h.target&&d.push(h)}return d}}class c{constructor(g,d){this.i=d,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,d,t,u={}){if(c.j(t),this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const h=this.h++;this.b.add(d),this.d.add(d),this.c.set(h,t);let y=2;u.isCaseSensitive&&(y+=1024),u.isReadonly&&(y+=2048),typeof t.copy=="function"&&(y+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,O.checkProposedApiEnabled)(g,"fsChunks"),y+=4),this.a.$registerFileSystemProvider(h,d,y).catch(v=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${d}`),console.error(v)});const C=t.onDidChangeFile(v=>{const n=[];for(const l of v){const{uri:r,type:a}=l;if(r.scheme!==d)continue;let b;switch(a){case N.FileChangeType.Changed:b=0;break;case N.FileChangeType.Created:b=1;break;case N.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:r,type:b})}this.a.$onFileSystemChange(h,n)});return(0,D.toDisposable)(()=>{C.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(h),this.a.$unregisterProvider(h)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:d,ctime:t,mtime:u,size:h,permissions:y}=g;return{type:d,ctime:t,mtime:u,size:h,permissions:y}}$stat(g,d){return Promise.resolve(this.l(g).stat(i.URI.revive(d))).then(t=>c.k(t))}$readdir(g,d){return Promise.resolve(this.l(g).readDirectory(i.URI.revive(d)))}$readFile(g,d){return Promise.resolve(this.l(g).readFile(i.URI.revive(d))).then(t=>m.VSBuffer.wrap(t))}$writeFile(g,d,t,u){return Promise.resolve(this.l(g).writeFile(i.URI.revive(d),t.buffer,u))}$delete(g,d,t){return Promise.resolve(this.l(g).delete(i.URI.revive(d),t))}$rename(g,d,t,u){return Promise.resolve(this.l(g).rename(i.URI.revive(d),i.URI.revive(t),u))}$copy(g,d,t,u){const h=this.l(g);if(!h.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(h.copy(i.URI.revive(d),i.URI.revive(t),u))}$mkdir(g,d){return Promise.resolve(this.l(g).createDirectory(i.URI.revive(d)))}$watch(g,d,t,u){const h=this.l(g).watch(i.URI.revive(t),u);this.f.set(d,h)}$unwatch(g,d){const t=this.f.get(d);t&&(t.dispose(),this.f.delete(d))}$open(g,d,t){const u=this.l(g);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(i.URI.revive(d),t))}$close(g,d){const t=this.l(g);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(d))}$read(g,d,t,u){const h=this.l(g);if(!h.read)throw new Error('FileSystemProvider does not implement "read"');const y=m.VSBuffer.alloc(u);return Promise.resolve(h.read(d,t,y.buffer,0,u)).then(C=>y.slice(0,C))}$write(g,d,t,u){const h=this.l(g);if(!h.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(h.write(d,t,u.buffer,0,u.byteLength))}l(g){const d=this.c.get(g);if(!d){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return d}}e.ExtHostFileSystem=c}),define(Re[61],Oe([1,0,4,43,7,24,3,17,38,6]),function(te,e,i,k,D,N,F,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=e.ExtHostConsumerFileSystem=class ii{constructor(c,p){this.b=new Map,this.a=c.getProxy(i.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(d){try{let t;const u=g.b.get(d.scheme);return u?(await g.a.$ensureActivation(d.scheme),t=await u.stat(d)):t=await g.a.$stat(d),{type:t.type,ctime:t.ctime,mtime:t.mtime,size:t.size,permissions:t.permissions===k.FilePermission.Readonly?1:void 0}}catch(t){ii.c(t)}},async readDirectory(d){try{const t=g.b.get(d.scheme);return t?(await g.a.$ensureActivation(d.scheme),(await t.readDirectory(d)).slice()):await g.a.$readdir(d)}catch(t){return ii.c(t)}},async createDirectory(d){try{return await g.a.$mkdir(d)}catch(t){return ii.c(t)}},async readFile(d){try{const t=g.b.get(d.scheme);return t?(await g.a.$ensureActivation(d.scheme),(await t.readFile(d)).slice()):(await g.a.$readFile(d)).buffer}catch(t){return ii.c(t)}},async writeFile(d,t){try{return await g.a.$writeFile(d,N.VSBuffer.wrap(t))}catch(u){return ii.c(u)}},async delete(d,t){try{const u=g.b.get(d.scheme);return u?(await g.a.$ensureActivation(d.scheme),await u.delete(d,{recursive:!1,...t})):await g.a.$delete(d,{recursive:!1,useTrash:!1,atomic:!1,...t})}catch(u){return ii.c(u)}},async rename(d,t,u){try{return await g.a.$rename(d,t,{overwrite:!1,...u})}catch(h){return ii.c(h)}},async copy(d,t,u){try{return await g.a.$copy(d,t,{overwrite:!1,...u})}catch(h){return ii.c(h)}},isWritableFileSystem(d){const t=p.getCapabilities(d);if(typeof t=="number")return!(t&2048)}})}static c(c){if(c instanceof D.FileSystemError)throw c;if(c instanceof k.FileSystemProviderError)switch(c.code){case k.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(c.message);case k.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(c.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(c.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(c.message);case k.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(c.message);case k.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(c.message);default:throw new D.FileSystemError(c.message,c.name)}if(!(c instanceof Error))throw new D.FileSystemError(String(c));if(c.name==="ENOPRO"||c.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(c.message);switch(c.name){case k.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(c.message);case k.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(c.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(c.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(c.message);case k.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(c.message);case k.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(c.message);default:throw new D.FileSystemError(c.message,c.name)}}addFileSystemProvider(c,p){return this.b.set(c,p),(0,m.toDisposable)(()=>this.b.delete(c))}};e.ExtHostConsumerFileSystem=O=xe([Ve(0,R.IExtHostRpcService),Ve(1,S.IExtHostFileSystemInfo)],O),e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(Re[227],Oe([1,0,5,37,2,4,8,7]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(w,c,p,g,d,t,u,h){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter;const y=this.h(w,p,d);this.g=0,t&&(this.g+=1),u&&(this.g+=2),h&&(this.g+=4);const C=(0,k.parse)(d),v=typeof d=="string",n=g(l=>{if(!t)for(const r of l.created){const a=D.URI.revive(r);C(a.fsPath)&&(!v||c.getWorkspaceFolder(a))&&this.a.fire(a)}if(!u)for(const r of l.changed){const a=D.URI.revive(r);C(a.fsPath)&&(!v||c.getWorkspaceFolder(a))&&this.b.fire(a)}if(!h)for(const r of l.deleted){const a=D.URI.revive(r);C(a.fsPath)&&(!v||c.getWorkspaceFolder(a))&&this.c.fire(a)}});this.d=R.Disposable.from(y,this.a,this.b,this.c,n)}h(w,c,p){const g=R.Disposable.from();if(typeof p=="string")return g;const d=w.getProxy(N.MainContext.MainThreadFileSystem);let t=!1;(p.pattern.includes(k.GLOBSTAR)||p.pattern.includes(k.GLOB_SPLIT))&&(t=!0);const u=Math.random();return d.$watch(c.identifier.value,u,p.baseUri,{recursive:t,excludes:[]}),R.Disposable.from({dispose:()=>d.$unwatch(u)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class m{constructor(w,c,p){this.j=w,this.k=c,this.l=p,this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.g=new i.AsyncEmitter,this.h=new i.AsyncEmitter,this.i=new i.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,c,p,g,d,t){return new S(this.j,w,c,this.a.event,F.GlobPattern.from(p),g,d,t)}$onFileEvent(w){this.a.fire(w)}$onDidRunFileOperation(w,c){switch(w){case 2:this.b.fire(Object.freeze({files:c.map(p=>({oldUri:D.URI.revive(p.source),newUri:D.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:c.map(p=>D.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:c.map(p=>D.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,c){return(p,g,d)=>{const t=function(h){p.call(g,h)};return t.extension=w,c.event(t,void 0,d)}}async $onWillRunFileOperation(w,c,p,g){switch(w){case 2:return await this.n(this.g,{files:c.map(d=>({oldUri:D.URI.revive(d.source),newUri:D.URI.revive(d.target)}))},p,g);case 1:return await this.n(this.i,{files:c.map(d=>D.URI.revive(d.target))},p,g);case 0:case 3:return await this.n(this.h,{files:c.map(d=>D.URI.revive(d.target))},p,g)}}async n(w,c,p,g){const d=new Set,t=[];if(await w.fireAsync(c,g,async(h,y)=>{const C=Date.now(),v=await Promise.resolve(h);v instanceof R.WorkspaceEdit&&(t.push([y.extension,v]),d.add(y.extension.displayName??y.extension.identifier.value)),Date.now()-C>p&&this.k.warn("SLOW file-participant",y.extension.identifier)}),g.isCancellationRequested||t.length===0)return;const u={edits:[]};for(const[,h]of t){const{edits:y}=F.WorkspaceEdit.from(h,{getTextDocumentVersion:C=>this.l.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(y)}return{edit:u,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=m}),define(Re[228],Oe([1,0,2,32]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(F,R,S,m,O){this.a=R,this.b=S,this.c=m;const w=new k.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.ApiCommandArgument("showOptions","Show Options",c=>!0,c=>c),new k.ApiCommandArgument("resource","Interactive resource Uri",c=>!0,c=>c),new k.ApiCommandArgument("controllerId","Notebook controller Id",c=>!0,c=>c),new k.ApiCommandArgument("title","Interactive editor title",c=>!0,c=>c)],new k.ApiCommandResult("Notebook and input URI",c=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const p=this.a.getEditorById(c.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:i.URI.revive(c.notebookUri),inputUri:i.URI.revive(c.inputUri),notebookEditor:p.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:i.URI.revive(c.notebookUri),inputUri:i.URI.revive(c.inputUri)}}));this.c.registerApiCommand(w)}$willAddInteractiveDocument(F,R,S,m){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:S,uri:F,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(i.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=D}),define(Re[229],Oe([1,0,6,2,4,8,7,32]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class S{constructor(c,p){this.extension=c,this.provider=p,this.handle=S.a++}}S.a=0;class m{constructor(c){this.session=c,this.responses=[]}}class O{constructor(c,p,g,d){this.f=g,this.g=d,this.b=new Map,this.d=new Map,this.e=c.getProxy(D.MainContext.MainThreadInteractiveEditor),p.registerApiCommand(new R.ApiCommand("vscode.editorChat.start","interactiveEditor.start","Invoke a new editor chat session",[new R.ApiCommandArgument("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?N.Range.from(t.initialRange):void 0,message:t.message,autoSend:t.autoSend}})],R.ApiCommandResult.Void))}registerProvider(c,p){const g=new S(c,p);return this.b.set(g.handle,g),this.e.$registerInteractiveEditorProvider(g.handle,c.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,i.toDisposable)(()=>{this.e.$unregisterInteractiveEditorProvider(g.handle),this.b.delete(g.handle)})}async $prepareInteractiveSession(c,p,g,d){const t=this.b.get(c);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const u=this.f.getDocument(k.URI.revive(p)),h=N.Selection.to(g),y=await t.provider.prepareInteractiveEditorSession({document:u,selection:h},d);if(!y)return;if(y.wholeRange&&!y.wholeRange.contains(h))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const C=O.a++;return this.d.set(C,new m(y)),{id:C,placeholder:y.placeholder,slashCommands:y.slashCommands?.map(v=>({command:v.command,detail:v.detail,refer:v.refer})),wholeRange:N.Range.from(y.wholeRange)}}async $provideResponse(c,p,g,d){const t=this.b.get(c);if(!t)return;const u=this.d.get(p.id);if(!u)return;const h=await t.provider.provideInteractiveEditorResponse({session:u.session,prompt:g.prompt,selection:N.Selection.to(g.selection),wholeRange:N.Range.to(g.wholeRange),attempt:g.attempt},d);if(h){const y=u.responses.push(h)-1,C={wholeRange:N.Range.from(h.wholeRange),placeholder:h.placeholder};if(O.h(h))return{...C,id:y,type:"message",message:N.MarkdownString.from(h.contents)};const{edits:v}=h;if(v instanceof F.WorkspaceEdit)return{...C,id:y,type:"bulkEdit",edits:N.WorkspaceEdit.from(v)};if(Array.isArray(v))return{...C,id:y,type:"editorEdit",edits:v.map(N.TextEdit.from)}}}$handleFeedback(c,p,g,d){const t=this.b.get(c),u=this.d.get(p),h=u?.responses[g];if(t&&h){let y;switch(d){case 1:y=F.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:y=F.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:y=F.InteractiveEditorResponseFeedbackKind.Undone;break}t.provider.handleInteractiveEditorResponseFeedback?.(u.session,h,y)}}$releaseSession(c,p){const g=this.d.get(p),d=this.b.get(c);g&&d&&d.provider.releaseInteractiveEditorSession?.(g.session),this.d.delete(p)}static h(c){return typeof c=="object"&&typeof c.contents=="object"}}e.ExtHostInteractiveEditor=O,O.a=0}),define(Re[230],Oe([1,0,4,7]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class D{constructor(F){this.a=new Map,this.b=F.getProxy(i.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(F,R){if(this.a.size===0)throw new Error("No issue request handlers registered");const S=this.a.get(F);if(!S)throw new Error("Issue request handler not found");const m=await S.handleIssueUrlRequest();if(!m)throw new Error("Issue request handler returned no result");return m}registerIssueUriRequestHandler(F,R){const S=F.identifier.value;return this.a.set(S,R),this.b.$registerIssueUriRequestHandler(S),new k.Disposable(()=>{this.b.$unregisterIssueUriRequestHandler(S),this.a.delete(S)})}}e.ExtHostIssueReporter=D}),define(Re[231],Oe([1,0,6,4]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(F){this.b=0,this.a=F.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,F),(0,i.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=D}),define(Re[232],Oe([1,0,2,26,8,7,78,4,13,44,18,9,274,22,6,91,86,54,58,10,16,20,149]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t,u,h,y,C,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class l{constructor(T,H){this.d=T,this.e=H}async provideDocumentSymbols(T,H){const j=this.d.getDocument(T),x=await this.e.provideDocumentSymbols(j,H);if(!(0,O.isFalsyOrEmpty)(x))return x[0]instanceof N.DocumentSymbol?x.map(D.DocumentSymbol.from):l.f(x)}static f(T){T=T.slice(0).sort((x,ce)=>{let pe=x.location.range.start.compareTo(ce.location.range.start);return pe===0&&(pe=ce.location.range.end.compareTo(x.location.range.end)),pe});const H=[],j=[];for(const x of T){const ce={name:x.name||"!!MISSING: name!!",kind:D.SymbolKind.from(x.kind),tags:x.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:D.Range.from(x.location.range),selectionRange:D.Range.from(x.location.range),children:[]};for(;;){if(j.length===0){j.push(ce),H.push(ce);break}const pe=j[j.length-1];if(m.Range.containsRange(pe.range,ce.range)&&!m.Range.equalsRange(pe.range,ce.range)){pe.children?.push(ce),j.push(ce);break}j.pop()}}return H}}class r{constructor(T,H,j){this.g=T,this.h=H,this.j=j,this.e=new u.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(T,H){const j=this.g.getDocument(T),x=await this.j.provideCodeLenses(j,H);if(!x||H.isCancellationRequested)return;const ce=this.e.add(x),pe=new g.DisposableStore;this.f.set(ce,pe);const ie={cacheId:ce,lenses:[]};for(let ye=0;ye<x.length;ye++)ie.lenses.push({cacheId:[ce,ye],range:D.Range.from(x[ye].range),command:this.h.toInternal(x[ye].command,pe)});return ie}async resolveCodeLens(T,H){const j=T.cacheId&&this.e.get(...T.cacheId);if(!j)return;let x;if(typeof this.j.resolveCodeLens!="function"||j.isResolved?x=j:x=await this.j.resolveCodeLens(j,H),x||(x=j),H.isCancellationRequested)return;const ce=T.cacheId&&this.f.get(T.cacheId[0]);if(ce)return T.command=this.h.toInternal(x.command??r.d,ce),T}releaseCodeLenses(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}}r.d={command:"missing",title:"!!MISSING: command!!"};function a(ne){return Array.isArray(ne)?ne.map(D.DefinitionLink.from):ne?[D.DefinitionLink.from(ne)]:[]}class b{constructor(T,H){this.d=T,this.e=H}async provideDefinition(T,H,j){const x=this.d.getDocument(T),ce=D.Position.to(H),pe=await this.e.provideDefinition(x,ce,j);return a(pe)}}class I{constructor(T,H){this.d=T,this.e=H}async provideDeclaration(T,H,j){const x=this.d.getDocument(T),ce=D.Position.to(H),pe=await this.e.provideDeclaration(x,ce,j);return a(pe)}}class f{constructor(T,H){this.d=T,this.e=H}async provideImplementation(T,H,j){const x=this.d.getDocument(T),ce=D.Position.to(H),pe=await this.e.provideImplementation(x,ce,j);return a(pe)}}class P{constructor(T,H){this.d=T,this.e=H}async provideTypeDefinition(T,H,j){const x=this.d.getDocument(T),ce=D.Position.to(H),pe=await this.e.provideTypeDefinition(x,ce,j);return a(pe)}}class E{constructor(T,H){this.d=T,this.e=H}async provideHover(T,H,j){const x=this.d.getDocument(T),ce=D.Position.to(H),pe=await this.e.provideHover(x,ce,j);if(!(!pe||(0,O.isFalsyOrEmpty)(pe.contents)))return pe.range||(pe.range=x.getWordRangeAtPosition(ce)),pe.range||(pe.range=new N.Range(ce,ce)),D.Hover.from(pe)}}class o{constructor(T,H){this.d=T,this.e=H}async provideEvaluatableExpression(T,H,j){const x=this.d.getDocument(T),ce=D.Position.to(H),pe=await this.e.provideEvaluatableExpression(x,ce,j);if(pe)return D.EvaluatableExpression.from(pe)}}class s{constructor(T,H){this.d=T,this.e=H}async provideInlineValues(T,H,j,x){const ce=this.d.getDocument(T),pe=await this.e.provideInlineValues(ce,D.Range.to(H),D.InlineValueContext.to(j),x);if(Array.isArray(pe))return pe.map(ie=>D.InlineValue.from(ie))}}class M{constructor(T,H){this.d=T,this.e=H}async provideDocumentHighlights(T,H,j){const x=this.d.getDocument(T),ce=D.Position.to(H),pe=await this.e.provideDocumentHighlights(x,ce,j);if(Array.isArray(pe))return pe.map(D.DocumentHighlight.from)}}class B{constructor(T,H){this.d=T,this.e=H}async provideLinkedEditingRanges(T,H,j){const x=this.d.getDocument(T),ce=D.Position.to(H),pe=await this.e.provideLinkedEditingRanges(x,ce,j);if(pe&&Array.isArray(pe.ranges))return{ranges:(0,O.coalesce)(pe.ranges.map(D.Range.from)),wordPattern:pe.wordPattern}}}class X{constructor(T,H){this.d=T,this.e=H}async provideReferences(T,H,j,x){const ce=this.d.getDocument(T),pe=D.Position.to(H),ie=await this.e.provideReferences(ce,pe,j,x);if(Array.isArray(ie))return ie.map(D.location.from)}}class G{constructor(T,H,j,x,ce,pe,ie){this.g=T,this.h=H,this.j=j,this.k=x,this.l=ce,this.m=pe,this.n=ie,this.e=new u.Cache("CodeAction"),this.f=new Map}async provideCodeActions(T,H,j,x){const ce=this.g.getDocument(T),pe=c.Selection.isISelection(H)?D.Selection.to(H):D.Range.to(H),ie=[];for(const Qe of this.j.getDiagnostics(T))if(pe.intersection(Qe.range)&&ie.push(Qe)>G.d)break;const ye={diagnostics:ie,only:j.only?new N.CodeActionKind(j.only):void 0,triggerKind:D.CodeActionTriggerKind.to(j.trigger)},Se=await this.k.provideCodeActions(ce,pe,ye,x);if(!(0,O.isNonEmptyArray)(Se)||x.isCancellationRequested)return;const Be=this.e.add(Se),je=new g.DisposableStore;this.f.set(Be,je);const Ze=[];for(let Qe=0;Qe<Se.length;Qe++){const Ke=Se[Qe];Ke&&(G.o(Ke)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:Ke.title,command:this.h.toInternal(Ke,je)})):(ye.only&&(Ke.kind?ye.only.contains(Ke.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ye.only.value} 'requested but returned code action is of kind '${Ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ye.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[Be,Qe],title:Ke.title,command:Ke.command&&this.h.toInternal(Ke.command,je),diagnostics:Ke.diagnostics&&Ke.diagnostics.map(D.Diagnostic.from),edit:Ke.edit&&D.WorkspaceEdit.from(Ke.edit,void 0),kind:Ke.kind&&Ke.kind.value,isPreferred:Ke.isPreferred,disabled:Ke.disabled?.reason})))}return{cacheId:Be,actions:Ze}}async resolveCodeAction(T,H){const[j,x]=T,ce=this.e.get(j,x);if(!ce||G.o(ce))return{};if(!this.k.resolveCodeAction)return{};const pe=await this.k.resolveCodeAction(ce,H)??ce;let ie;pe.edit&&(ie=D.WorkspaceEdit.from(pe.edit,void 0));let ye;if(pe.command){const Se=this.f.get(j);Se&&(ye=this.h.toInternal(pe.command,Se))}return{edit:ie,command:ye}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}G.d=1e3;class W{constructor(T,H,j,x,ce){this.d=T,this.e=H,this.f=j,this.g=x,this.h=ce}async prepareDocumentPaste(T,H,j,x){if(!this.f.prepareDocumentPaste)return;const ce=this.e.getDocument(T),pe=H.map(Se=>D.Range.to(Se)),ie=D.DataTransfer.toDataTransfer(j,()=>{throw new y.NotImplementedError});if(await this.f.prepareDocumentPaste(ce,pe,ie,x),x.isCancellationRequested)return;const ye=Array.from(ie).filter(([,Se])=>!(Se instanceof N.InternalDataTransferItem));return D.DataTransfer.from(ye)}async providePasteEdits(T,H,j,x,ce){if(!this.f.provideDocumentPasteEdits)return;const pe=this.e.getDocument(H),ie=j.map(Be=>D.Range.to(Be)),ye=D.DataTransfer.toDataTransfer(x,async Be=>(await this.d.$resolvePasteFileData(this.g,T,Be)).buffer),Se=await this.f.provideDocumentPasteEdits(pe,ie,ye,ce);if(Se)return{id:Se.id?this.h.identifier.value+"."+Se.id:this.h.identifier.value,label:Se.label??(0,n.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,priority:Se.priority??0,insertText:typeof Se.insertText=="string"?Se.insertText:{snippet:Se.insertText.value},additionalEdit:Se.additionalEdit?D.WorkspaceEdit.from(Se.additionalEdit,void 0):void 0}}}class U{constructor(T,H){this.d=T,this.e=H}async provideDocumentFormattingEdits(T,H,j){const x=this.d.getDocument(T),ce=await this.e.provideDocumentFormattingEdits(x,H,j);if(Array.isArray(ce))return ce.map(D.TextEdit.from)}}class q{constructor(T,H){this.d=T,this.e=H}async provideDocumentRangeFormattingEdits(T,H,j,x){const ce=this.d.getDocument(T),pe=D.Range.to(H),ie=await this.e.provideDocumentRangeFormattingEdits(ce,pe,j,x);if(Array.isArray(ie))return ie.map(D.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,H,j,x){(0,w.assertType)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ce=this.d.getDocument(T),pe=H.map(D.Range.to),ie=await this.e.provideDocumentRangesFormattingEdits(ce,pe,j,x);if(Array.isArray(ie))return ie.map(D.TextEdit.from)}}class z{constructor(T,H){this.d=T,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,H,j,x,ce){const pe=this.d.getDocument(T),ie=D.Position.to(H),ye=await this.e.provideOnTypeFormattingEdits(pe,ie,j,x,ce);if(Array.isArray(ye))return ye.map(D.TextEdit.from)}}class V{constructor(T,H){this.e=T,this.f=H,this.d=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(T,H){const j=await this.e.provideWorkspaceSymbols(T,H);if(!(0,O.isNonEmptyArray)(j))return{symbols:[]};const x=this.d.add(j),ce={cacheId:x,symbols:[]};for(let pe=0;pe<j.length;pe++){const ie=j[pe];if(!ie||!ie.name){this.f.warn("INVALID SymbolInformation",ie);continue}ce.symbols.push({...D.WorkspaceSymbol.from(ie),cacheId:[x,pe]})}return ce}async resolveWorkspaceSymbol(T,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const j=this.d.get(...T.cacheId);if(j){const x=await this.e.resolveWorkspaceSymbol(j,H);return x&&(0,k.mixin)(T,D.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class ee{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,H,j){this.d=T,this.e=H,this.f=j}async provideRenameEdits(T,H,j,x){const ce=this.d.getDocument(T),pe=D.Position.to(H);try{const ie=await this.e.provideRenameEdits(ce,pe,j,x);return ie?D.WorkspaceEdit.from(ie):void 0}catch(ie){const ye=ee.g(ie);return ye?{rejectReason:ye,edits:void 0}:Promise.reject(ie)}}async resolveRenameLocation(T,H,j){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(T),ce=D.Position.to(H);try{const pe=await this.e.prepareRename(x,ce,j);let ie,ye;if(N.Range.isRange(pe)?(ie=pe,ye=x.getText(pe)):(0,w.isObject)(pe)&&(ie=pe.range,ye=pe.placeholder),!ie||!ye)return;if(ie.start.line>ce.line||ie.end.line<ce.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ie),text:ye}}catch(pe){const ie=ee.g(pe);return ie?{rejectReason:ie,range:void 0,text:void 0}:Promise.reject(pe)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class Ce{constructor(T,H){this.resultId=T,this.tokens=H}}class oe{constructor(T,H){this.f=T,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,H,j){const x=this.f.getDocument(T),ce=H!==0?this.d.get(H):null;let pe=typeof ce?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,ce.resultId,j):await this.g.provideDocumentSemanticTokens(x,j);return ce&&this.d.delete(H),pe?(pe=oe.h(pe),this.o(oe.n(ce,pe),pe)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return oe.j(T)?oe.k(T)?T:new N.SemanticTokens(new Uint32Array(T.data),T.resultId):oe.l(T)?oe.m(T)?T:new N.SemanticTokensEdits(T.edits.map(H=>new N.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const H of T.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(T,H){if(!oe.j(H)||!T||!T.tokens)return H;const j=T.tokens,x=j.length,ce=H.data,pe=ce.length;let ie=0;const ye=Math.min(x,pe);for(;ie<ye&&j[ie]===ce[ie];)ie++;if(ie===x&&ie===pe)return new N.SemanticTokensEdits([],H.resultId);let Se=0;const Be=ye-ie;for(;Se<Be&&j[x-Se-1]===ce[pe-Se-1];)Se++;return new N.SemanticTokensEdits([{start:ie,deleteCount:x-ie-Se,data:ce.subarray(ie,pe-Se)}],H.resultId)}o(T,H){if(oe.j(T)){const j=this.e++;return this.d.set(j,new Ce(T.resultId,T.data)),(0,d.encodeSemanticTokensDto)({id:j,type:"full",data:T.data})}if(oe.l(T)){const j=this.e++;return oe.j(H)?this.d.set(j,new Ce(H.resultId,H.data)):this.d.set(j,new Ce(T.resultId)),(0,d.encodeSemanticTokensDto)({id:j,type:"delta",deltas:(T.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class le{constructor(T,H){this.d=T,this.e=H}async provideDocumentRangeSemanticTokens(T,H,j){const x=this.d.getDocument(T),ce=await this.e.provideDocumentRangeSemanticTokens(x,D.Range.to(H),j);return ce?this.f(ce):null}f(T){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:T.data})}}class Q{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,H,j,x,ce){this.f=T,this.g=H,this.h=j,this.j=x,this.k=ce,this.d=new u.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(T,H,j,x){const ce=this.f.getDocument(T),pe=D.Position.to(H),ie=ce.getWordRangeAtPosition(pe)||new N.Range(pe,pe),ye=ie.with({end:pe}),Se=new h.StopWatch(!0),Be=await this.h.provideCompletionItems(ce,pe,x,D.CompletionContext.to(j));if(!Be||x.isCancellationRequested)return;const je=Array.isArray(Be)?new N.CompletionList(Be):Be,Ze=Q.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),Qe=new g.DisposableStore;this.e.set(Ze,Qe);const Ke=[],it={x:Ze,b:Ke,a:{replace:D.Range.from(ie),insert:D.Range.from(ye)},c:je.isIncomplete||void 0,d:Se.elapsed()};for(let st=0;st<je.items.length;st++){const tt=je.items[st],Ne=this.l(tt,[Ze,st],ye,ie);Ke.push(Ne)}return it}async resolveCompletionItem(T,H){if(typeof this.h.resolveCompletionItem!="function")return;const j=this.d.get(...T);if(!j)return;const x=await this.h.resolveCompletionItem(j,H);if(!x)return;const ce={...j,documentation:x.documentation,detail:x.detail,additionalTextEdits:x.additionalTextEdits};return j.insertText!==x.insertText&&(this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),ce.insertText=x.insertText),this.l(ce,T)}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,H,j,x){const ce=this.e.get(H[0]);if(!ce)throw Error("DisposableStore is missing...");const pe=this.g.toInternal(T.command,ce),ie={x:H,a:T.label,b:T.kind!==void 0?D.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(D.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:D.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(D.TextEdit.from),n:pe?.$ident,o:pe?.id,p:pe?.$ident?void 0:pe?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=T.textEdit.newText):typeof T.insertText=="string"?ie.h=T.insertText:T.insertText instanceof N.SnippetString&&(ie.h=T.insertText.value,ie.i|=4);let ye;return T.textEdit?ye=T.textEdit.range:T.range&&(ye=T.range),N.Range.isRange(ye)?ie.j=D.Range.from(ye):ye&&(!j?.isEqual(ye.inserting)||!x?.isEqual(ye.replacing))&&(ie.j={insert:D.Range.from(ye.inserting),replace:D.Range.from(ye.replacing)}),ie}}class ue{async provideInlineCompletions(T,H,j,x){}disposeCompletions(T){}handleDidShowCompletionItem(T,H,j){}handlePartialAccept(T,H,j){}}class Ie extends ue{constructor(T,H,j,x){super(),this.f=T,this.g=H,this.h=j,this.j=x,this.d=new Pe,this.e=(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[F.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKind.Automatic,[F.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,H,j,x){const ce=this.g.getDocument(T),pe=D.Position.to(H),ie=await this.h.provideInlineCompletionItems(ce,pe,{selectedCompletionInfo:j.selectedSuggestionInfo?{range:D.Range.to(j.selectedSuggestionInfo.range),text:j.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[j.triggerKind]},x);if(!ie||x.isCancellationRequested)return;const ye=Array.isArray(ie)?ie:ie.items,Se=this.e?Array.isArray(ie)?[]:ie.commands||[]:[],Be=this.e&&!Array.isArray(ie)?ie.suppressSuggestions:void 0,je=this.e&&!Array.isArray(ie)?ie.enableForwardStability:void 0;let Ze;return{pid:this.d.createReferenceId({dispose(){Ze?.dispose()},items:ye}),items:ye.map((Ke,it)=>{let st;Ke.command&&(Ze||(Ze=new g.DisposableStore),st=this.j.toInternal(Ke.command,Ze));const tt=Ke.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ke.filterText,range:Ke.range?D.Range.from(Ke.range):void 0,command:st,idx:it,completeBracketPairs:this.e?Ke.completeBracketPairs:!1}}),commands:Se.map(Ke=>(Ze||(Ze=new g.DisposableStore),this.j.toInternal(Ke,Ze))),suppressSuggestions:Be,enableForwardStability:je}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,H,j){const x=this.d.get(T)?.items[H];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,j)}handlePartialAccept(T,H,j){const x=this.d.get(T)?.items[H];x&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(x,j)}}class Pe{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const H=this.e++;return this.d.set(H,T),H}disposeReferenceId(T){const H=this.d.get(T);return this.d.delete(T),H}get(T){return this.d.get(T)}}class be{constructor(T,H){this.e=T,this.f=H,this.d=new u.Cache("SignatureHelp")}async provideSignatureHelp(T,H,j,x){const ce=this.e.getDocument(T),pe=D.Position.to(H),ie=this.g(j),ye=await this.f.provideSignatureHelp(ce,pe,x,ie);if(ye){const Se=this.d.add([ye]);return{...D.SignatureHelp.from(ye),id:Se}}}g(T){let H;if(T.activeSignatureHelp){const j=D.SignatureHelp.to(T.activeSignatureHelp),x=this.d.get(T.activeSignatureHelp.id,0);x?(H=x,H.activeSignature=j.activeSignature,H.activeParameter=j.activeParameter):H=j}return{...T,activeSignatureHelp:H}}releaseSignatureHelp(T){this.d.delete(T)}}class A{constructor(T,H,j,x,ce){this.f=T,this.g=H,this.h=j,this.j=x,this.k=ce,this.d=new u.Cache("InlayHints"),this.e=new Map}async provideInlayHints(T,H,j){const x=this.f.getDocument(T),ce=D.Range.to(H),pe=await this.h.provideInlayHints(x,ce,j);if(!Array.isArray(pe)||pe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${H}`);return}if(j.isCancellationRequested)return;const ie=this.d.add(pe);this.e.set(ie,new g.DisposableStore);const ye={hints:[],cacheId:ie};for(let Se=0;Se<pe.length;Se++)this.l(pe[Se],ce)&&ye.hints.push(this.m(pe[Se],[ie,Se]));return this.j.trace(`[InlayHints] ${ye.hints.length} inlay hints from '${this.k.identifier.value}' for ${H}`),ye}async resolveInlayHint(T,H){if(typeof this.h.resolveInlayHint!="function")return;const j=this.d.get(...T);if(!j)return;const x=await this.h.resolveInlayHint(j,H);if(x&&this.l(x))return this.m(x,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,H){return T.label.length===0||Array.isArray(T.label)&&T.label.every(j=>j.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(H&&!H.contains(T.position))}m(T,H){const j=this.e.get(H[0]);if(!j)throw Error("DisposableStore is missing...");const x={label:"",cacheId:H,tooltip:D.MarkdownString.fromStrict(T.tooltip),position:D.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(D.TextEdit.from),kind:T.kind&&D.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?x.label=T.label:x.label=T.label.map(ce=>{const pe={label:ce.value};return pe.tooltip=D.MarkdownString.fromStrict(ce.tooltip),N.Location.isLocation(ce.location)&&(pe.location=D.location.from(ce.location)),ce.command&&(pe.command=this.g.toInternal(ce.command,j)),pe}),x}}class K{constructor(T,H){this.e=T,this.f=H,this.d=new u.Cache("DocumentLink")}async provideLinks(T,H){const j=this.e.getDocument(T),x=await this.f.provideDocumentLinks(j,H);if(!(!Array.isArray(x)||x.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(K.g).map(D.DocumentLink.from)};{const ce=this.d.add(x),pe={links:[],cacheId:ce};for(let ie=0;ie<x.length;ie++){if(!K.g(x[ie]))continue;const ye=D.DocumentLink.from(x[ie]);ye.cacheId=[ce,ie],pe.links.push(ye)}return pe}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,H){if(typeof this.f.resolveDocumentLink!="function")return;const j=this.d.get(...T);if(!j)return;const x=await this.f.resolveDocumentLink(j,H);if(!(!x||!K.g(x)))return D.DocumentLink.from(x)}releaseLinks(T){this.d.delete(T)}}class he{constructor(T,H){this.d=T,this.e=H}async provideColors(T,H){const j=this.d.getDocument(T),x=await this.e.provideDocumentColors(j,H);return Array.isArray(x)?x.map(pe=>({color:D.Color.from(pe.color),range:D.Range.from(pe.range)})):[]}async provideColorPresentations(T,H,j){const x=this.d.getDocument(T),ce=D.Range.to(H.range),pe=D.Color.to(H.color),ie=await this.e.provideColorPresentations(pe,{document:x,range:ce},j);if(Array.isArray(ie))return ie.map(D.ColorPresentation.from)}}class De{constructor(T,H){this.d=T,this.e=H}async provideFoldingRanges(T,H,j){const x=this.d.getDocument(T),ce=await this.e.provideFoldingRanges(x,H,j);if(Array.isArray(ce))return ce.map(D.FoldingRange.from)}}class we{constructor(T,H,j){this.d=T,this.e=H,this.f=j}async provideSelectionRanges(T,H,j){const x=this.d.getDocument(T),ce=H.map(D.Position.to),pe=await this.e.provideSelectionRanges(x,ce,j);if(!(0,O.isNonEmptyArray)(pe))return[];if(pe.length!==ce.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ie=[];for(let ye=0;ye<ce.length;ye++){const Se=[];ie.push(Se);let Be=ce[ye],je=pe[ye];for(;;){if(!je.range.contains(Be))throw new Error("INVALID selection range, must contain the previous range");if(Se.push(D.SelectionRange.from(je)),!je.parent)break;Be=je.range,je=je.parent}}return ie}}class ge{constructor(T,H){this.f=T,this.g=H,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(T,H,j){const x=this.f.getDocument(T),ce=D.Position.to(H),pe=await this.g.prepareCallHierarchy(x,ce,j);if(!pe)return;const ie=this.d.nextId();return this.e.set(ie,new Map),Array.isArray(pe)?pe.map(ye=>this.h(ie,ye)):[this.h(ie,pe)]}async provideCallsTo(T,H,j){const x=this.j(T,H);if(!x)throw new Error("missing call hierarchy item");const ce=await this.g.provideCallHierarchyIncomingCalls(x,j);if(ce)return ce.map(pe=>({from:this.h(T,pe.from),fromRanges:pe.fromRanges.map(ie=>D.Range.from(ie))}))}async provideCallsFrom(T,H,j){const x=this.j(T,H);if(!x)throw new Error("missing call hierarchy item");const ce=await this.g.provideCallHierarchyOutgoingCalls(x,j);if(ce)return ce.map(pe=>({to:this.h(T,pe.to),fromRanges:pe.fromRanges.map(ie=>D.Range.from(ie))}))}releaseSession(T){this.e.delete(T)}h(T,H){const j=this.e.get(T),x=D.CallHierarchyItem.from(H,T,j.size.toString(36));return j.set(x._itemId,H),x}j(T,H){return this.e.get(T)?.get(H)}}class ke{constructor(T,H){this.f=T,this.g=H,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(T,H,j){const x=this.f.getDocument(T),ce=D.Position.to(H),pe=await this.g.prepareTypeHierarchy(x,ce,j);if(!pe)return;const ie=this.d.nextId();return this.e.set(ie,new Map),Array.isArray(pe)?pe.map(ye=>this.h(ie,ye)):[this.h(ie,pe)]}async provideSupertypes(T,H,j){const x=this.j(T,H);if(!x)throw new Error("missing type hierarchy item");const ce=await this.g.provideTypeHierarchySupertypes(x,j);if(ce)return ce.map(pe=>this.h(T,pe))}async provideSubtypes(T,H,j){const x=this.j(T,H);if(!x)throw new Error("missing type hierarchy item");const ce=await this.g.provideTypeHierarchySubtypes(x,j);if(ce)return ce.map(pe=>this.h(T,pe))}releaseSession(T){this.e.delete(T)}h(T,H){const j=this.e.get(T),x=D.TypeHierarchyItem.from(H,T,j.size.toString(36));return j.set(x._itemId,H),x}j(T,H){return this.e.get(T)?.get(H)}}class ae{constructor(T,H,j,x,ce){this.d=T,this.e=H,this.f=j,this.g=x,this.h=ce}async provideDocumentOnDropEdits(T,H,j,x,ce){const pe=this.e.getDocument(H),ie=D.Position.to(j),ye=D.DataTransfer.toDataTransfer(x,async Be=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,Be)).buffer),Se=await this.f.provideDocumentDropEdits(pe,ie,ye,ce);if(Se)return{id:Se.id?this.h.identifier.value+"."+Se.id:this.h.identifier.value,label:Se.label??(0,n.localize)(1,null,this.h.displayName||this.h.name),priority:Se.priority??0,insertText:typeof Se.insertText=="string"?Se.insertText:{snippet:Se.insertText.value},additionalEdit:Se.additionalEdit?D.WorkspaceEdit.from(Se.additionalEdit,void 0):void 0}}}class de{constructor(T,H){this.adapter=T,this.extension=H}}class Z{constructor(T,H,j,x,ce,pe,ie,ye){this.g=H,this.h=j,this.j=x,this.k=ce,this.l=pe,this.m=ie,this.n=ye,this.f=new Map,this.e=T.getProxy(R.MainContext.MainThreadLanguageFeatures)}o(T,H){return D.DocumentSelector.from(T,this.g,H)}p(T){return new N.Disposable(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return Z.d++}async s(T,H,j,x,ce,pe=!1){const ie=this.f.get(T);if(!ie||!(ie.adapter instanceof H))return x;const ye=Date.now();pe||this.l.trace(`[${ie.extension.identifier.value}] INVOKE provider '${j.toString().replace(/[\r\n]/g,"")}'`);const Se=j(ie.adapter,ie.extension);return Promise.resolve(Se).catch(Be=>{(0,y.isCancellationError)(Be)||(this.l.error(`[${ie.extension.identifier.value}] provider FAILED`),this.l.error(Be),this.n.onExtensionError(ie.extension.identifier,Be))}).finally(()=>{pe||this.l.trace(`[${ie.extension.identifier.value}] provider DONE after ${Date.now()-ye}ms`)}),p.CancellationToken.isCancellationToken(ce)?(0,C.raceCancellationError)(Se,ce):Se}t(T,H){const j=this.q();return this.f.set(j,new de(T,H)),j}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,H,j,x){const ce=this.t(new l(this.h,j),T),pe=x&&x.label||Z.u(T);return this.e.$registerDocumentSymbolProvider(ce,this.o(H,T),pe),this.p(ce)}$provideDocumentSymbols(T,H,j){return this.s(T,l,x=>x.provideDocumentSymbols(i.URI.revive(H),j),void 0,j)}registerCodeLensProvider(T,H,j){const x=this.q(),ce=typeof j.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new de(new r(this.h,this.j.converter,j),T)),this.e.$registerCodeLensSupport(x,this.o(H,T),ce);let pe=this.p(x);if(ce!==void 0){const ie=j.onDidChangeCodeLenses(ye=>this.e.$emitCodeLensEvent(ce));pe=N.Disposable.from(pe,ie)}return pe}$provideCodeLenses(T,H,j){return this.s(T,r,x=>x.provideCodeLenses(i.URI.revive(H),j),void 0,j)}$resolveCodeLens(T,H,j){return this.s(T,r,x=>x.resolveCodeLens(H,j),void 0,void 0)}$releaseCodeLenses(T,H){this.s(T,r,j=>Promise.resolve(j.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(T,H,j){const x=this.t(new b(this.h,j),T);return this.e.$registerDefinitionSupport(x,this.o(H,T)),this.p(x)}$provideDefinition(T,H,j,x){return this.s(T,b,ce=>ce.provideDefinition(i.URI.revive(H),j,x),[],x)}registerDeclarationProvider(T,H,j){const x=this.t(new I(this.h,j),T);return this.e.$registerDeclarationSupport(x,this.o(H,T)),this.p(x)}$provideDeclaration(T,H,j,x){return this.s(T,I,ce=>ce.provideDeclaration(i.URI.revive(H),j,x),[],x)}registerImplementationProvider(T,H,j){const x=this.t(new f(this.h,j),T);return this.e.$registerImplementationSupport(x,this.o(H,T)),this.p(x)}$provideImplementation(T,H,j,x){return this.s(T,f,ce=>ce.provideImplementation(i.URI.revive(H),j,x),[],x)}registerTypeDefinitionProvider(T,H,j){const x=this.t(new P(this.h,j),T);return this.e.$registerTypeDefinitionSupport(x,this.o(H,T)),this.p(x)}$provideTypeDefinition(T,H,j,x){return this.s(T,P,ce=>ce.provideTypeDefinition(i.URI.revive(H),j,x),[],x)}registerHoverProvider(T,H,j,x){const ce=this.t(new E(this.h,j),T);return this.e.$registerHoverProvider(ce,this.o(H,T)),this.p(ce)}$provideHover(T,H,j,x){return this.s(T,E,ce=>ce.provideHover(i.URI.revive(H),j,x),void 0,x)}registerEvaluatableExpressionProvider(T,H,j,x){const ce=this.t(new o(this.h,j),T);return this.e.$registerEvaluatableExpressionProvider(ce,this.o(H,T)),this.p(ce)}$provideEvaluatableExpression(T,H,j,x){return this.s(T,o,ce=>ce.provideEvaluatableExpression(i.URI.revive(H),j,x),void 0,x)}registerInlineValuesProvider(T,H,j,x){const ce=typeof j.onDidChangeInlineValues=="function"?this.q():void 0,pe=this.t(new s(this.h,j),T);this.e.$registerInlineValuesProvider(pe,this.o(H,T),ce);let ie=this.p(pe);if(ce!==void 0){const ye=j.onDidChangeInlineValues(Se=>this.e.$emitInlineValuesEvent(ce));ie=N.Disposable.from(ie,ye)}return ie}$provideInlineValues(T,H,j,x,ce){return this.s(T,s,pe=>pe.provideInlineValues(i.URI.revive(H),j,x,ce),void 0,ce)}registerDocumentHighlightProvider(T,H,j){const x=this.t(new M(this.h,j),T);return this.e.$registerDocumentHighlightProvider(x,this.o(H,T)),this.p(x)}$provideDocumentHighlights(T,H,j,x){return this.s(T,M,ce=>ce.provideDocumentHighlights(i.URI.revive(H),j,x),void 0,x)}registerLinkedEditingRangeProvider(T,H,j){const x=this.t(new B(this.h,j),T);return this.e.$registerLinkedEditingRangeProvider(x,this.o(H,T)),this.p(x)}$provideLinkedEditingRanges(T,H,j,x){return this.s(T,B,async ce=>{const pe=await ce.provideLinkedEditingRanges(i.URI.revive(H),j,x);if(pe)return{ranges:pe.ranges,wordPattern:pe.wordPattern?Z.w(pe.wordPattern):void 0}},void 0,x)}registerReferenceProvider(T,H,j){const x=this.t(new X(this.h,j),T);return this.e.$registerReferenceSupport(x,this.o(H,T)),this.p(x)}$provideReferences(T,H,j,x,ce){return this.s(T,X,pe=>pe.provideReferences(i.URI.revive(H),j,x,ce),void 0,ce)}registerCodeActionProvider(T,H,j,x){const ce=new g.DisposableStore,pe=this.t(new G(this.h,this.j.converter,this.k,j,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(pe,this.o(H,T),{providedKinds:x?.providedCodeActionKinds?.map(ie=>ie.value),documentation:x?.documentation?.map(ie=>({kind:ie.kind.value,command:this.j.converter.toInternal(ie.command,ce)}))},Z.u(T),!!j.resolveCodeAction),ce.add(this.p(pe)),ce}$provideCodeActions(T,H,j,x,ce){return this.s(T,G,pe=>pe.provideCodeActions(i.URI.revive(H),j,x,ce),void 0,ce)}$resolveCodeAction(T,H,j){return this.s(T,G,x=>x.resolveCodeAction(H,j),{},void 0)}$releaseCodeActions(T,H){this.s(T,G,j=>Promise.resolve(j.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(T,H,j){const x=this.t(new U(this.h,j),T);return this.e.$registerDocumentFormattingSupport(x,this.o(H,T),T.identifier,T.displayName||T.name),this.p(x)}$provideDocumentFormattingEdits(T,H,j,x){return this.s(T,U,ce=>ce.provideDocumentFormattingEdits(i.URI.revive(H),j,x),void 0,x)}registerDocumentRangeFormattingEditProvider(T,H,j){const x=typeof j.provideDocumentRangesFormattingEdits=="function";x&&(0,v.checkProposedApiEnabled)(T,"formatMultipleRanges");const ce=this.t(new q(this.h,j),T);return this.e.$registerRangeFormattingSupport(ce,this.o(H,T),T.identifier,T.displayName||T.name,x),this.p(ce)}$provideDocumentRangeFormattingEdits(T,H,j,x,ce){return this.s(T,q,pe=>pe.provideDocumentRangeFormattingEdits(i.URI.revive(H),j,x,ce),void 0,ce)}$provideDocumentRangesFormattingEdits(T,H,j,x,ce){return this.s(T,q,pe=>pe.provideDocumentRangesFormattingEdits(i.URI.revive(H),j,x,ce),void 0,ce)}registerOnTypeFormattingEditProvider(T,H,j,x){const ce=this.t(new z(this.h,j),T);return this.e.$registerOnTypeFormattingSupport(ce,this.o(H,T),x,T.identifier),this.p(ce)}$provideOnTypeFormattingEdits(T,H,j,x,ce,pe){return this.s(T,z,ie=>ie.provideOnTypeFormattingEdits(i.URI.revive(H),j,x,ce,pe),void 0,pe)}registerWorkspaceSymbolProvider(T,H){const j=this.t(new V(H,this.l),T);return this.e.$registerNavigateTypeSupport(j,typeof H.resolveWorkspaceSymbol=="function"),this.p(j)}$provideWorkspaceSymbols(T,H,j){return this.s(T,V,x=>x.provideWorkspaceSymbols(H,j),{symbols:[]},j)}$resolveWorkspaceSymbol(T,H,j){return this.s(T,V,x=>x.resolveWorkspaceSymbol(H,j),void 0,void 0)}$releaseWorkspaceSymbols(T,H){this.s(T,V,j=>j.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(T,H,j){const x=this.t(new ee(this.h,j,this.l),T);return this.e.$registerRenameSupport(x,this.o(H,T),ee.supportsResolving(j)),this.p(x)}$provideRenameEdits(T,H,j,x,ce){return this.s(T,ee,pe=>pe.provideRenameEdits(i.URI.revive(H),j,x,ce),void 0,ce)}$resolveRenameLocation(T,H,j,x){return this.s(T,ee,ce=>ce.resolveRenameLocation(i.URI.revive(H),j,x),void 0,x)}registerDocumentSemanticTokensProvider(T,H,j,x){const ce=this.t(new oe(this.h,j),T),pe=typeof j.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ce,this.o(H,T),x,pe);let ie=this.p(ce);if(pe){const ye=j.onDidChangeSemanticTokens(Se=>this.e.$emitDocumentSemanticTokensEvent(pe));ie=N.Disposable.from(ie,ye)}return ie}$provideDocumentSemanticTokens(T,H,j,x){return this.s(T,oe,ce=>ce.provideDocumentSemanticTokens(i.URI.revive(H),j,x),null,x)}$releaseDocumentSemanticTokens(T,H){this.s(T,oe,j=>j.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,H,j,x){const ce=this.t(new le(this.h,j),T);return this.e.$registerDocumentRangeSemanticTokensProvider(ce,this.o(H,T),x),this.p(ce)}$provideDocumentRangeSemanticTokens(T,H,j,x){return this.s(T,le,ce=>ce.provideDocumentRangeSemanticTokens(i.URI.revive(H),j,x),null,x)}registerCompletionItemProvider(T,H,j,x){const ce=this.t(new Q(this.h,this.j.converter,j,this.m,T),T);return this.e.$registerCompletionsProvider(ce,this.o(H,T),x,Q.supportsResolving(j),`${T.identifier.value}(${x.join("")})`),this.p(ce)}$provideCompletionItems(T,H,j,x,ce){return this.s(T,Q,pe=>pe.provideCompletionItems(i.URI.revive(H),j,x,ce),void 0,ce)}$resolveCompletionItem(T,H,j){return this.s(T,Q,x=>x.resolveCompletionItem(H,j),void 0,j)}$releaseCompletionItems(T,H){this.s(T,Q,j=>j.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(T,H,j){const x=new Ie(T,this.h,j,this.j.converter),ce=this.t(x,T);return this.e.$registerInlineCompletionsSupport(ce,this.o(H,T),x.supportsHandleEvents),this.p(ce)}$provideInlineCompletions(T,H,j,x,ce){return this.s(T,ue,pe=>pe.provideInlineCompletions(i.URI.revive(H),j,x,ce),void 0,ce)}$handleInlineCompletionDidShow(T,H,j,x){this.s(T,ue,async ce=>{ce.handleDidShowCompletionItem(H,j,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,H,j,x){this.s(T,ue,async ce=>{ce.handlePartialAccept(H,j,x)},void 0,void 0)}$freeInlineCompletionsList(T,H){this.s(T,ue,async j=>{j.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(T,H,j,x){const ce=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,pe=this.t(new be(this.h,j),T);return this.e.$registerSignatureHelpProvider(pe,this.o(H,T),ce),this.p(pe)}$provideSignatureHelp(T,H,j,x,ce){return this.s(T,be,pe=>pe.provideSignatureHelp(i.URI.revive(H),j,x,ce),void 0,ce)}$releaseSignatureHelp(T,H){this.s(T,be,j=>j.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(T,H,j){const x=typeof j.onDidChangeInlayHints=="function"?this.q():void 0,ce=this.t(new A(this.h,this.j.converter,j,this.l,T),T);this.e.$registerInlayHintsProvider(ce,this.o(H,T),typeof j.resolveInlayHint=="function",x,Z.u(T));let pe=this.p(ce);if(x!==void 0){const ie=j.onDidChangeInlayHints(ye=>this.e.$emitInlayHintsEvent(x));pe=N.Disposable.from(pe,ie)}return pe}$provideInlayHints(T,H,j,x){return this.s(T,A,ce=>ce.provideInlayHints(i.URI.revive(H),j,x),void 0,x)}$resolveInlayHint(T,H,j){return this.s(T,A,x=>x.resolveInlayHint(H,j),void 0,j)}$releaseInlayHints(T,H){this.s(T,A,j=>j.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(T,H,j){const x=this.t(new K(this.h,j),T);return this.e.$registerDocumentLinkProvider(x,this.o(H,T),typeof j.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(T,H,j){return this.s(T,K,x=>x.provideLinks(i.URI.revive(H),j),void 0,j,H.scheme==="output")}$resolveDocumentLink(T,H,j){return this.s(T,K,x=>x.resolveLink(H,j),void 0,void 0,!0)}$releaseDocumentLinks(T,H){this.s(T,K,j=>j.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(T,H,j){const x=this.t(new he(this.h,j),T);return this.e.$registerDocumentColorProvider(x,this.o(H,T)),this.p(x)}$provideDocumentColors(T,H,j){return this.s(T,he,x=>x.provideColors(i.URI.revive(H),j),[],j)}$provideColorPresentations(T,H,j,x){return this.s(T,he,ce=>ce.provideColorPresentations(i.URI.revive(H),j,x),void 0,x)}registerFoldingRangeProvider(T,H,j){const x=this.q(),ce=typeof j.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new de(new De(this.h,j),T)),this.e.$registerFoldingRangeProvider(x,this.o(H,T),T.identifier,ce);let pe=this.p(x);if(ce!==void 0){const ie=j.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ce));pe=N.Disposable.from(pe,ie)}return pe}$provideFoldingRanges(T,H,j,x){return this.s(T,De,ce=>ce.provideFoldingRanges(i.URI.revive(H),j,x),void 0,x)}registerSelectionRangeProvider(T,H,j){const x=this.t(new we(this.h,j,this.l),T);return this.e.$registerSelectionRangeProvider(x,this.o(H,T)),this.p(x)}$provideSelectionRanges(T,H,j,x){return this.s(T,we,ce=>ce.provideSelectionRanges(i.URI.revive(H),j,x),[],x)}registerCallHierarchyProvider(T,H,j){const x=this.t(new ge(this.h,j),T);return this.e.$registerCallHierarchyProvider(x,this.o(H,T)),this.p(x)}$prepareCallHierarchy(T,H,j,x){return this.s(T,ge,ce=>Promise.resolve(ce.prepareSession(i.URI.revive(H),j,x)),void 0,x)}$provideCallHierarchyIncomingCalls(T,H,j,x){return this.s(T,ge,ce=>ce.provideCallsTo(H,j,x),void 0,x)}$provideCallHierarchyOutgoingCalls(T,H,j,x){return this.s(T,ge,ce=>ce.provideCallsFrom(H,j,x),void 0,x)}$releaseCallHierarchy(T,H){this.s(T,ge,j=>Promise.resolve(j.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(T,H,j){const x=this.t(new ke(this.h,j),T);return this.e.$registerTypeHierarchyProvider(x,this.o(H,T)),this.p(x)}$prepareTypeHierarchy(T,H,j,x){return this.s(T,ke,ce=>Promise.resolve(ce.prepareSession(i.URI.revive(H),j,x)),void 0,x)}$provideTypeHierarchySupertypes(T,H,j,x){return this.s(T,ke,ce=>ce.provideSupertypes(H,j,x),void 0,x)}$provideTypeHierarchySubtypes(T,H,j,x){return this.s(T,ke,ce=>ce.provideSubtypes(H,j,x),void 0,x)}$releaseTypeHierarchy(T,H){this.s(T,ke,j=>Promise.resolve(j.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(T,H,j,x){const ce=this.q();return this.f.set(ce,new de(new ae(this.e,this.h,j,ce,T),T)),this.e.$registerDocumentOnDropEditProvider(ce,this.o(H,T),(0,v.isProposedApiEnabled)(T,"dropMetadata")?x:void 0),this.p(ce)}$provideDocumentOnDropEdits(T,H,j,x,ce,pe){return this.s(T,ae,ie=>Promise.resolve(ie.provideDocumentOnDropEdits(H,i.URI.revive(j),x,ce,pe)),void 0,void 0)}registerDocumentPasteEditProvider(T,H,j,x){const ce=this.q();return this.f.set(ce,new de(new W(this.e,this.h,j,ce,T),T)),this.e.$registerPasteEditProvider(ce,this.o(H,T),{supportsCopy:!!j.prepareDocumentPaste,supportsPaste:!!j.provideDocumentPasteEdits,copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(ce)}$prepareDocumentPaste(T,H,j,x,ce){return this.s(T,W,pe=>pe.prepareDocumentPaste(i.URI.revive(H),j,x,ce),void 0,ce)}$providePasteEdits(T,H,j,x,ce,pe){return this.s(T,W,ie=>ie.providePasteEdits(H,i.URI.revive(j),x,ce,pe),void 0,pe)}static w(T){return{pattern:T.source,flags:(0,S.regExpFlags)(T)}}static y(T){return{decreaseIndentPattern:Z.w(T.decreaseIndentPattern),increaseIndentPattern:Z.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?Z.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?Z.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:Z.w(T.beforeText),afterText:T.afterText?Z.w(T.afterText):void 0,previousLineText:T.previousLineText?Z.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(Z.z)}setLanguageConfiguration(T,H,j){const{wordPattern:x}=j;if(x&&(0,S.regExpLeadsToEndlessLoop)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(H,x):this.h.setWordDefinitionFor(H,void 0),j.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),j.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const ce=this.q(),pe={comments:j.comments,brackets:j.brackets,wordPattern:j.wordPattern?Z.w(j.wordPattern):void 0,indentationRules:j.indentationRules?Z.y(j.indentationRules):void 0,onEnterRules:j.onEnterRules?Z.B(j.onEnterRules):void 0,__electricCharacterSupport:j.__electricCharacterSupport,__characterPairSupport:j.__characterPairSupport};return this.e.$setLanguageConfiguration(ce,H,pe),this.p(ce)}$setWordDefinitions(T){for(const H of T)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=Z,Z.d=0}),define(Re[233],Oe([1,0,4,8,7,29,16,6]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(O,w,c,p){this.c=w,this.d=c,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,w){await this.a.$changeLanguage(O,w);const c=this.c.getDocumentData(O);if(!c)throw new Error(`document '${O.toString()}' NOT found`);return c.document}async tokenAtPosition(O,w){const c=O.version,p=k.Position.from(w),g=await this.a.$tokensAtPosition(O.uri,p),d={type:D.StandardTokenType.Other,range:O.getWordRangeAtPosition(w)??new D.Range(w.line,w.character,w.line,w.character)};if(!g)return d;const t={range:k.Range.to(g.range),type:k.TokenType.to(g.type)};return!t.range.contains(w)||c!==O.version?d:t}createLanguageStatusItem(O,w,c){const p=this.f++,g=this.a,d=this.g,t=`${O.identifier.value}/${w}`;if(d.has(t))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);d.add(t);const u={selector:c,id:w,name:O.displayName??O.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let h;const y=new R.DisposableStore,C=()=>{h?.dispose(),h=(0,F.disposableTimeout)(()=>{y.clear(),this.a.$setLanguageStatus(p,{id:t,name:u.name??O.displayName??O.name,source:O.displayName??O.name,selector:k.DocumentSelector.from(u.selector,this.e),label:u.text,detail:u.detail??"",severity:u.severity===D.LanguageStatusSeverity.Error?N.default.Error:u.severity===D.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:u.command&&this.d.toInternal(u.command,y),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},v={dispose(){y.dispose(),h?.dispose(),g.$removeLanguageStatus(p),d.delete(t)},get id(){return u.id},get name(){return u.name},set name(n){u.name=n,C()},get selector(){return u.selector},set selector(n){u.selector=n,C()},get text(){return u.text},set text(n){u.text=n,C()},get detail(){return u.detail},set detail(n){u.detail=n,C()},get severity(){return u.severity},set severity(n){u.severity=n,C()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(n){u.accessibilityInformation=n,C()},get command(){return u.command},set command(n){u.command=n,C()},get busy(){return u.busy},set busy(n){u.busy=n,C()}};return C(),v}}e.ExtHostLanguages=S}),define(Re[80],Oe([1,0,21,13,2,3,14,4,27,17]),function(te,e,i,k,D,N,F,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=e.ExtHostLocalizationService=class{constructor(c,p,g){this.f=g,this.d=new Map,this.a=p.getProxy(R.MainContext.MainThreadLocalization),this.b=c.environment.appLanguage,this.c=this.b===i.LANGUAGE_DEFAULT}getMessage(c,p){const{message:g,args:d,comment:t}=p;if(this.c)return(0,k.format2)(g,d??{});let u=g;t&&t.length>0&&(u+=`/${Array.isArray(t)?t.join(""):t}`);const h=this.d.get(c)?.contents[u];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,k.format2)(h??g,d??{})}getBundle(c){return this.d.get(c)?.contents}getBundleUri(c){return this.d.get(c)?.uri}async initializeLocalizedMessages(c){if(this.c||!c.l10n&&!c.isBuiltin||this.d.has(c.identifier.value))return;let p;const g=await this.g(c);if(!g){this.f.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(g),t=JSON.parse(d);p=c.isBuiltin?t.contents?.bundle:t}catch(d){this.f.error(`Failed to load translations for ${c.identifier.value} from ${g}: ${d.message}`);return}p&&this.d.set(c.identifier.value,{contents:p,uri:g})}async g(c){if(c.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(c.identifier.value,this.b);return D.URI.revive(p)}return c.l10n?D.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.ExtHostLocalizationService=O=xe([Ve(0,S.IExtHostInitDataService),Ve(1,m.IExtHostRpcService),Ve(2,F.ILogService)],O),e.IExtHostLocalizationService=(0,N.createDecorator)("IExtHostLocalizationService")}),define(Re[234],Oe([1,0,14,4,27,17,2,68]),function(te,e,i,k,D,N,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let S=e.ExtHostLoggerService=class extends i.AbstractLoggerService{constructor(w,c){super(c.logLevel,c.logsLocation,c.loggers.map(p=>(0,R.revive)(p))),this.n=w.getProxy(k.MainContext.MainThreadLogger)}$setLogLevel(w,c){c?this.setLogLevel(F.URI.revive(c),w):this.setLogLevel(w)}setVisibility(w,c){super.setVisibility(w,c),this.n.$setVisibility(w,c)}m(w,c,p){return new m(this.n,w,c,p)}};e.ExtHostLoggerService=S=xe([Ve(0,N.IExtHostRpcService),Ve(1,D.IExtHostInitDataService)],S);class m extends i.AbstractMessageLogger{constructor(w,c,p,g){super(g?.logLevel==="always"),this.m=w,this.n=c,this.k=!1,this.l=[],this.setLevel(p),this.m.$createLogger(c,g).then(()=>{this.r(this.l),this.k=!0})}g(w,c){const p=[[w,c]];this.k?this.r(p):this.l.push(...p)}r(w){this.m.$log(this.n,w)}flush(){this.m.$flush(this.n)}}}),define(Re[81],Oe([1,0,4,3,6,17,24]),function(te,e,i,k,D,N,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,k.createDecorator)("IExtHostManagedSockets");let R=e.ExtHostManagedSockets=class{constructor(w){this.b=0,this.c=null,this.d=new Map,this.a=w.getProxy(i.MainContext.MainThreadManagedSockets)}setFactory(w,c){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new S(w,c),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(w){if(!this.c||this.c.socketFactoryId!==w)throw new Error(`No socket factory with id ${w}`);const c=++this.b,p=await this.c.makeConnection(),g=new D.DisposableStore;return this.d.set(c,new m(c,p,g)),g.add((0,D.toDisposable)(()=>this.d.delete(c))),g.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(c),g.dispose()})),g.add(p.onDidClose(d=>{this.a.$onDidManagedSocketClose(c,d?.stack??d?.message),g.dispose()})),g.add(p.onDidReceiveMessage(d=>this.a.$onDidManagedSocketHaveData(c,F.VSBuffer.wrap(d)))),c}$remoteSocketWrite(w,c){this.d.get(w)?.actual.send(c.buffer)}$remoteSocketEnd(w){const c=this.d.get(w);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(w){await this.d.get(w)?.actual.drain?.()}};e.ExtHostManagedSockets=R=xe([Ve(0,N.IExtHostRpcService)],R);class S{constructor(w,c){this.socketFactoryId=w,this.makeConnection=c}}class m extends D.Disposable{constructor(w,c,p){super(),this.socketId=w,this.actual=c,this.B(p)}}}),define(Re[235],Oe([1,0,4,14,20]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function N(R){return R&&R.title}let F=e.ExtHostMessageService=class{constructor(S,m){this.b=m,this.a=S.getProxy(i.MainContext.MainThreadMessageService)}showMessage(S,m,O,w,c){const p={source:{identifier:S.identifier,label:S.displayName||S.name}};let g;typeof w=="string"||N(w)?g=[w,...c]:(p.modal=w?.modal,p.useCustom=w?.useCustom,p.detail=w?.detail,g=c),p.useCustom&&(0,D.checkProposedApiEnabled)(S,"resolvers");const d=[];for(let t=0;t<g.length;t++){const u=g[t];if(typeof u=="string")d.push({title:u,handle:t,isCloseAffordance:!1});else if(typeof u=="object"){const{title:h,isCloseAffordance:y}=u;d.push({title:h,isCloseAffordance:!!y,handle:t})}else this.b.warn("Invalid message item:",u)}return this.a.$showMessage(m,O,p,d).then(t=>{if(typeof t=="number")return g[t]})}};e.ExtHostMessageService=F=xe([Ve(1,k.ILogService)],F)}),define(Re[236],Oe([1,0,24,5,6,28,13,9,2,54,4,32,8,7,46,205,104,10]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(C=>C.apiEditor)}constructor(C,v,n,l){this.q=n,this.r=l,this.f=new Map,this.g=new N.ResourceMap,this.h=new Map,this.j=new k.Emitter({onListenerError:u.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new k.Emitter({onListenerError:u.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this.m.event,this.n=new k.Emitter({onListenerError:u.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this.n.event,this.o=new k.Emitter({onListenerError:u.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new m.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=C.getProxy(O.MainContext.MainThreadNotebook),this.c=C.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=C.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=v.converter,v.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const a=r.notebookEditor?.notebookUri,b=r.cell.handle,f=this.g.get(a)?.getCell(b);if(f)return f.apiCell}if(r&&r.$mid===14){const a=r.uri,b=this.g.get(a);if(b)return b.apiNotebook}return r}}),h.x(v)}getEditorById(C){const v=this.h.get(C);if(!v)throw new Error(`unknown text editor: ${C}. known editors: ${[...this.h.keys()]} `);return v}getIdByEditor(C){for(const[v,n]of this.h)if(n.apiEditor===C)return v}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(C,v){const n=this.g.get(C);if(!n&&!v)throw new Error(`NO notebook document for '${C}'`);return n}static s(C,v){if(!v)return;const n=v.filenamePattern.map(l=>c.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(v.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:C.identifier,providerDisplayName:C.displayName||C.name,displayName:v.displayName,filenamePattern:n,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(C,v,n){const l=h.a++,r=typeof n.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(l,n),this.b.$registerNotebookCellStatusBarItemProvider(l,r,v);let a;return r!==void 0&&(a=n.onDidChangeCellStatusBarItems(b=>this.b.$emitCellStatusBarEvent(r))),new p.Disposable(()=>{this.f.delete(l),this.b.$unregisterNotebookCellStatusBarItemProvider(l,r),a?.dispose()})}async createNotebookDocument(C){const v=await this.c.$tryCreateNotebook({viewType:C.viewType,content:C.content&&c.NotebookData.from(C.content)});return S.URI.revive(v)}async openNotebookDocument(C){const v=this.g.get(C);if(v)return v.apiNotebook;const n=await this.c.$tryOpenNotebook(C),l=this.g.get(S.URI.revive(n));return(0,R.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(C,v){S.URI.isUri(C)&&(C=await this.openNotebookDocument(C));let n;typeof v=="object"?n={position:c.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(c.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:n={preserveFocus:!1};const l=await this.d.$tryShowNotebookDocument(C.uri,C.notebookType,n),r=l&&this.h.get(l)?.apiEditor;if(r)return r;throw l?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(C,v,n,l){const r=this.f.get(C),a=S.URI.revive(v),b=this.g.get(a);if(!b||!r)return;const I=b.getCellFromIndex(n);if(!I)return;const f=await r.provideCellStatusBarItems(I.apiCell,l);if(!f)return;const P=new D.DisposableStore,E=this.p.add([P]),s=(Array.isArray(f)?f:[f]).map(M=>c.NotebookStatusBarItem.from(M,this.i,P));return{cacheId:E,items:s}}$releaseNotebookCellStatusBarItems(C){this.p.delete(C)}registerNotebookSerializer(C,v,n,l,r){if((0,F.isFalsyOrWhitespace)(v))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,n),this.b.$registerNotebookSerializer(a,{id:C.identifier,location:C.extensionLocation},v,c.NotebookDocumentContentOptions.from(l),h.s(C,r)),(0,D.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(C,v,n){const l=this.u.get(C);if(!l)throw new Error("NO serializer found");const r=await l.deserializeNotebook(v.buffer,n);return new g.SerializableObjectWithBuffers(c.NotebookData.from(r))}async $notebookToData(C,v,n){const l=this.u.get(C);if(!l)throw new Error("NO serializer found");const r=await l.serializeNotebook(c.NotebookData.to(v.value),n);return i.VSBuffer.wrap(r)}w(C,v,n){if(this.h.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const l=new t.ExtHostNotebookEditor(v,this.d,C,n.visibleRanges.map(c.NotebookRange.to),n.selections.map(c.NotebookRange.to),typeof n.viewColumn=="number"?c.ViewColumn.to(n.viewColumn):void 0);this.h.set(v,l)}$acceptDocumentAndEditorsDelta(C){if(C.value.removedDocuments)for(const n of C.value.removedDocuments){const l=S.URI.revive(n),r=this.g.get(l);r&&(r.dispose(),this.g.delete(l),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(r.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===l.toString()&&this.h.delete(a.id)}if(C.value.addedDocuments){const n=[];for(const l of C.value.addedDocuments){const r=S.URI.revive(l.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const a=new d.ExtHostNotebookDocument(this.c,this.q,this.r,r,l);n.push(...l.cells.map(b=>d.ExtHostCell.asModelAddData(a.apiNotebook,b))),this.g.get(r)?.dispose(),this.g.set(r,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:n}),this.m.fire(a.apiNotebook)}}if(C.value.addedEditors)for(const n of C.value.addedEditors){if(this.h.has(n.id))return;const l=S.URI.revive(n.documentUri),r=this.g.get(l);r&&this.w(r,n.id,n)}const v=[];if(C.value.removedEditors)for(const n of C.value.removedEditors){const l=this.h.get(n);l&&(this.h.delete(n),this.k?.id===l.id&&(this.k=void 0),v.push(l))}if(C.value.visibleEditors){this.l=C.value.visibleEditors.map(l=>this.h.get(l)).filter(l=>!!l);const n=new Set;this.l.forEach(l=>n.add(l.id));for(const l of this.h.values()){const r=n.has(l.id);l._acceptVisibility(r)}this.l=[...this.h.values()].map(l=>l).filter(l=>l.visible),this.o.fire(this.visibleNotebookEditors)}C.value.newActiveEditor===null?this.k=void 0:C.value.newActiveEditor&&(this.h.get(C.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${C.value.newActiveEditor}`),this.k=this.h.get(C.value.newActiveEditor)),C.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(C){const v=w.ApiCommandArgument.String.with("notebookType","A notebook type"),n=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new w.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>i.VSBuffer.wrap(r))],new w.ApiCommandResult("Notebook Data",r=>c.NotebookData.to(r.value))),l=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new g.SerializableObjectWithBuffers(c.NotebookData.from(r)))],new w.ApiCommandResult("Bytes",r=>r.buffer));C.registerApiCommand(n),C.registerApiCommand(l)}}e.ExtHostNotebookController=h,h.a=0}),define(Re[237],Oe([1,0,18,16,22,5,6,28,2,23,14,54,4,32,8,7,76,195,20,46]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t,u,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let C=e.ExtHostNotebookKernels=class{constructor(f,P,E,o,s){this.m=P,this.n=E,this.o=o,this.q=s,this.b=new R.ResourceMap,this.c=new R.ResourceMap,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new w.Cache("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new N.Emitter,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=f.getProxy(c.MainContext.MainThreadNotebookKernels);const M=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",B=>!0,B=>{if(B&&"notebookEditor"in B&&"id"in B){const X=this.n.getIdByEditor(B.notebookEditor);return{id:B.id,extension:B.extension,notebookEditorId:X}}else if(B&&"notebookEditor"in B){const X=this.n.getIdByEditor(B.notebookEditor);if(X===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${B.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:X}}return B})],p.ApiCommandResult.Void);this.o.registerApiCommand(M)}createNotebookController(f,P,E,o,s,M){for(const Ie of this.j.values())if(Ie.controller.id===P&&m.ExtensionIdentifier.equals(f.identifier,Ie.extensionId))throw new Error(`notebook controller with id '${P}' ALREADY exist`);const B=this.k++,X=this;this.q.trace(`NotebookController[${B}], CREATED by ${f.identifier.value}, ${P}`);const G=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${f.identifier}'`);let W=!1;const U=new F.DisposableStore,q=new N.Emitter,z=new N.Emitter,V={id:b(f.identifier,P),notebookType:E,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:o||f.identifier.value,preloads:M?M.map(g.NotebookRendererScript.from):[]};let ee=s??G,Ce;this.a.$addKernel(B,V).catch(Ie=>{console.log(Ie),W=!0});let oe=0;const le=()=>{if(W)return;const Ie=++oe;Promise.resolve().then(()=>{Ie===oe&&this.a.$updateKernel(B,V)})},Q=new R.ResourceMap,ue={get id(){return P},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:q.event,get label(){return V.label},set label(Ie){V.label=Ie??f.displayName??f.name,le()},get detail(){return V.detail??""},set detail(Ie){V.detail=Ie,le()},get description(){return V.description??""},set description(Ie){V.description=Ie,le()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(Ie){V.supportedLanguages=Ie,le()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(Ie){V.supportsExecutionOrder=Ie,le()},get rendererScripts(){return V.preloads?V.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return ee},set executeHandler(Ie){ee=Ie??G},get interruptHandler(){return Ce},set interruptHandler(Ie){Ce=Ie,V.supportsInterrupt=!!Ie,le()},createNotebookCellExecution(Ie){if(W)throw new Error("notebook controller is DISPOSED");if(!Q.has(Ie.notebook.uri))throw X.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ie.notebook.uri.toString()}`);return X._createNotebookCellExecution(Ie,b(f.identifier,this.id))},createNotebookExecution(Ie){if((0,h.checkProposedApiEnabled)(f,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!Q.has(Ie.uri))throw X.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ie.uri.toString()}`);return X._createNotebookExecution(Ie,b(f.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${B}], DISPOSED`),W=!0,this.j.delete(B),U.dispose(),q.dispose(),z.dispose(),this.a.$removeKernel(B))},updateNotebookAffinity(Ie,Pe){Pe===d.NotebookControllerAffinity2.Hidden&&(0,h.checkProposedApiEnabled)(f,"notebookControllerAffinityHidden"),X.a.$updateNotebookPriority(B,Ie.uri,Pe)},onDidReceiveMessage:z.event,postMessage(Ie,Pe){return(0,h.checkProposedApiEnabled)(f,"notebookMessaging"),X.a.$postMessage(B,Pe&&X.n.getIdByEditor(Pe),Ie)},asWebviewUri(Ie){return(0,h.checkProposedApiEnabled)(f,"notebookMessaging"),(0,t.asWebviewUri)(Ie,X.m.remote)}};return this.j.set(B,{extensionId:f.identifier,controller:ue,onDidReceiveMessage:z,onDidChangeSelection:q,associatedNotebooks:Q}),ue}getIdByController(f){for(const[P,E]of this.j)if(E.controller===f)return b(E.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,P){const E=this.f++,o=this;this.q.trace(`NotebookControllerDetectionTask[${E}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(E,P);const s={dispose:()=>{this.e.delete(E),o.a.$removeKernelDetectionTask(E)}};return this.e.set(E,s),s}registerKernelSourceActionProvider(f,P,E){const o=this.h++,s=typeof E.onDidChangeNotebookKernelSourceActions=="function"?o:void 0,M=this;this.g.set(o,E),this.q.trace(`NotebookKernelSourceActionProvider[${o}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(o,o,P);let B;return s!==void 0&&(B=E.onDidChangeNotebookKernelSourceActions(X=>this.a.$emitNotebookKernelSourceActionsChangeEvent(s))),{dispose:()=>{this.g.delete(o),M.a.$removeKernelSourceActionProvider(o,o),B?.dispose()}}}async $provideKernelSourceActions(f,P){const E=this.g.get(f);if(E){const o=new F.DisposableStore;return this.i.add([o]),(await E.provideNotebookKernelSourceActions(P)??[]).map(M=>g.NotebookKernelSourceAction.from(M,this.o.converter,o))}return[]}$acceptNotebookAssociation(f,P,E){const o=this.j.get(f);if(o){const s=this.n.getNotebookDocument(S.URI.revive(P));E?o.associatedNotebooks.set(s.uri,!0):o.associatedNotebooks.delete(s.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,s.uri.toString(),E),o.onDidChangeSelection.fire({selected:E,notebook:s.apiNotebook})}}async $executeCells(f,P,E){const o=this.j.get(f);if(!o)return;const s=this.n.getNotebookDocument(S.URI.revive(P)),M=[];for(const B of E){const X=s.getCell(B);X&&M.push(X.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,s.uri.toString(),M.length),await o.controller.executeHandler.call(o.controller,M,s.apiNotebook,o.controller)}catch(B){this.q.error(`NotebookController[${f}] execute cells FAILED`,B),console.error(B)}}async $cancelCells(f,P,E){const o=this.j.get(f);if(!o)return;const s=this.n.getNotebookDocument(S.URI.revive(P));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,s.apiNotebook);else for(const M of E){const B=s.getCell(M);B&&this.b.get(B.uri)?.cancel()}if(o.controller.interruptHandler){const M=this.c.get(s.uri);E.length&&Array.isArray(M)&&M.length&&M.forEach(B=>B.dispose())}}$acceptKernelMessageFromRenderer(f,P,E){const o=this.j.get(f);if(!o)return;const s=this.n.getEditorById(P);o.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:E}))}$cellExecutionChanged(f,P,E){const s=this.n.getNotebookDocument(S.URI.revive(f)).getCell(P);if(s){const M=E?g.NotebookCellExecutionState.to(E):d.NotebookCellExecutionState.Idle;M!==void 0&&this.l.fire({cell:s.apiCell,state:M})}}_createNotebookCellExecution(f,P){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!o)throw new Error("invalid cell");if(this.b.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const s=new n(P,o,this.a);this.b.set(o.uri,s);const M=s.onDidChangeState(()=>{s.state===v.Resolved&&(s.dispose(),M.dispose(),this.b.delete(o.uri))});return s.asApiObject()}_createNotebookExecution(f,P){const E=this.n.getNotebookDocument(f.uri),o=f.getCells().find(B=>{const X=E.getCellFromApiCell(B);return X&&this.b.has(X.uri)});if(o)throw new Error(`duplicate cell execution for ${o.document.uri}`);if(this.c.has(E.uri))throw new Error(`duplicate notebook execution for ${E.uri}`);const s=new r(P,E,this.a),M=s.onDidChangeState(()=>{s.state===l.Resolved&&(s.dispose(),M.dispose(),this.c.delete(E.uri))});return this.c.set(E.uri,[s,M]),s.asApiObject()}};e.ExtHostNotebookKernels=C=xe([Ve(4,O.ILogService)],C);var v;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(v||(v={}));class n extends F.Disposable{get state(){return this.f}constructor(f,P,E){super(),this.j=P,this.k=E,this.b=n.a++,this.c=new N.Emitter,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new D.CancellationTokenSource),this.h=new a(10,o=>this.m(o)),this.i=P.internalMetadata.executionOrder,this.k.$createExecution(this.b,f,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(f){await this.h.addItem(f)}async m(f){const P=Array.isArray(f)?f:[f];return this.k.$updateExecution(this.b,new y.SerializableObjectWithBuffers(P))}n(){if(this.f===v.Init)throw new Error("Must call start before modifying cell output");if(this.f===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(f){let P=this.j;if(f&&(P=this.j.notebook.getCellFromApiCell(f)),!P)throw new Error("INVALID cell");return P.handle}s(f){return f.map(P=>{const E=d.NotebookCellOutput.ensureUniqueMimeTypes(P.items,!0);return E===P.items?g.NotebookCellOutput.from(P):g.NotebookCellOutput.from({items:E,id:P.id,metadata:P.metadata})})}async t(f,P,E){const o=this.r(P),s=this.s((0,i.asArray)(f));return this.l({editType:u.CellExecutionUpdateType.Output,cellHandle:o,append:E,outputs:s})}async w(f,P,E){return f=d.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(f),!0),this.l({editType:u.CellExecutionUpdateType.OutputItems,items:f.map(g.NotebookCellOutputItem.from),outputId:P.id,append:E})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.j.apiCell},get executionOrder(){return f.i},set executionOrder(E){f.i=E,f.m([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:f.i}])},start(E){if(f.f===v.Resolved||f.f===v.Started)throw new Error("Cannot call start again");f.f=v.Started,f.c.fire(),f.m({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:E})},end(E,o){if(f.f===v.Resolved)throw new Error("Cannot call resolve twice");f.f=v.Resolved,f.c.fire(),f.h.flush(),f.k.$completeExecution(f.b,new y.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:E}))},clearOutput(E){return f.n(),f.t([],E,!1)},appendOutput(E,o){return f.n(),f.t(E,o,!0)},replaceOutput(E,o){return f.n(),f.t(E,o,!1)},appendOutputItems(E,o){return f.n(),f.w(E,o,!0)},replaceOutputItems(E,o){return f.n(),f.w(E,o,!1)}})}}n.a=0;var l;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(l||(l={}));class r extends F.Disposable{get state(){return this.f}constructor(f,P,E){super(),this.h=P,this.i=E,this.b=r.a++,this.c=new N.Emitter,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new D.CancellationTokenSource),this.i.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}r.a=0;class a{constructor(f,P){this.e=f,this.f=P,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new k.DeferredPromise,this.b=Date.now(),(0,k.timeout)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const P=this.a;return this.a=[],this.f(P).finally(()=>f.complete())}}function b(I,f){return`${I.value}/${f}`}e.createKernelId=b}),define(Re[238],Oe([1,0,5,4,104]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class N{constructor(R,S){this.c=S,this.a=new Map,this.b=R.getProxy(k.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,S,m){const O=this.c.getEditorById(R);this.a.get(S)?.fire({editor:O.apiEditor,message:m})}createRendererMessaging(R,S){if(!R.contributes?.notebookRenderer?.some(O=>O.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(O,w,c)=>this.d(S).event(O,w,c),postMessage:(O,w)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,w]=[w,O]);const c=w&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.b.$postMessage(c?.id,S,O)}}}d(R){let S=this.a.get(R);return S||(S=new i.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(R)}}),this.a.set(R,S),S)}}e.ExtHostNotebookRenderers=N}),define(Re[239],Oe([1,0,6,9,2,20,4]),function(te,e,i,k,D,N,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(m){this.b=new Map,this.a=m.getProxy(F.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,O,w){if((0,N.checkProposedApiEnabled)(m,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,w),this.a.$registerProfileContentHandler(O,w.name,w.description,m.identifier.value),(0,i.toDisposable)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(m,O,w,c){const p=this.b.get(m);if(!p)throw new Error(`Unknown handler with id: ${m}`);return p.saveProfile(O,w,c)}async $readProfile(m,O,w){const c=this.b.get(m);if(!c)throw new Error(`Unknown handler with id: ${m}`);return c.readProfile((0,k.isString)(O)?O:D.URI.revive(O),w)}}e.ExtHostProfileContentHandlers=R}),define(Re[240],Oe([1,0,2,4,16,8]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class F{constructor(S,m){this.d=m,this.c=new Map,this.b=S.getProxy(k.MainContext.MainThreadQuickDiff)}$provideOriginalResource(S,m,O){const w=i.URI.revive(m),c=this.c.get(S);return c?(0,D.asPromise)(()=>c.provideOriginalResource(w,O)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(S,m,O,w){const c=F.a++;return this.c.set(c,m),this.b.$registerQuickDiffProvider(c,N.DocumentSelector.from(S,this.d),O,w),{dispose:()=>{this.b.$unregisterQuickDiffProvider(c),this.c.delete(c)}}}}e.ExtHostQuickDiff=F,F.a=0}),define(Re[241],Oe([1,0,22,5,6,4,2,7,10,18,29,39,20,8]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(d,t,u){const h=d.getProxy(N.MainContext.MainThreadQuickOpen);class y{constructor(f,P){this.e=new Map,this.f=0,this.a=f,this.b=P}showQuickPick(f,P,E,o=i.CancellationToken.None){this.c=void 0;const s=Promise.resolve(P),M=++this.f,B=h.$show(M,{title:E?.title,placeHolder:E?.placeHolder,matchOnDescription:E?.matchOnDescription,matchOnDetail:E?.matchOnDetail,ignoreFocusLost:E?.ignoreFocusOut,canPickMany:E?.canPickMany},o),X={},G=B.then(()=>X);return Promise.race([G,s]).then(W=>{if(W===X)return;const U=(0,c.isProposedApiEnabled)(f,"quickPickItemTooltip");return s.then(q=>{const z=[];for(let V=0;V<q.length;V++){const ee=q[V];typeof ee=="string"?z.push({label:ee,handle:V}):ee.kind===R.QuickPickItemKind.Separator?z.push({type:"separator",label:ee.label}):(ee.tooltip&&!U&&console.warn(`Extension '${f.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`),z.push({label:ee.label,description:ee.description,detail:ee.detail,picked:ee.picked,alwaysShow:ee.alwaysShow,tooltip:U?p.MarkdownString.fromStrict(ee.tooltip):void 0,handle:V}))}return E&&typeof E.onDidSelectItem=="function"&&(this.c=V=>{E.onDidSelectItem(q[V])}),h.$setItems(M,z),B.then(V=>{if(typeof V=="number")return q[V];if(Array.isArray(V))return V.map(ee=>q[ee])})})}).then(void 0,W=>{if(!(0,S.isCancellationError)(W))return h.$setError(M,W),Promise.reject(W)})}$onItemSelected(f){this.c?.(f)}showInput(f,P=i.CancellationToken.None){return this.d=f?.validateInput,h.$input(f,typeof this.d=="function",P).then(void 0,E=>{if(!(0,S.isCancellationError)(E))return Promise.reject(E)})}async $validateInput(f){if(!this.d)return;const P=await this.d(f);if(!P||typeof P=="string")return P;let E;switch(P.severity){case R.InputBoxValidationSeverity.Info:E=O.default.Info;break;case R.InputBoxValidationSeverity.Warning:E=O.default.Warning;break;case R.InputBoxValidationSeverity.Error:E=O.default.Error;break;default:E=P.message?O.default.Error:O.default.Ignore;break}return{content:P.message,severity:E}}async showWorkspaceFolderPick(f,P=i.CancellationToken.None){const E=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!E)return;const o=await this.a.getWorkspaceFolders2();if(o)return o.find(s=>s.uri.toString()===E.uri.toString())}createQuickPick(f){const P=new a(f,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}createInputBox(f){const P=new b(f,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}$onDidChangeValue(f,P){this.e.get(f)?._fireDidChangeValue(P)}$onDidAccept(f){this.e.get(f)?._fireDidAccept()}$onDidChangeActive(f,P){const E=this.e.get(f);E instanceof a&&E._fireDidChangeActive(P)}$onDidChangeSelection(f,P){const E=this.e.get(f);E instanceof a&&E._fireDidChangeSelection(P)}$onDidTriggerButton(f,P){this.e.get(f)?._fireDidTriggerButton(P)}$onDidTriggerItemButton(f,P,E){const o=this.e.get(f);o instanceof a&&o._fireDidTriggerItemButton(P,E)}$onDidHide(f){this.e.get(f)?._fireDidHide()}}class C{constructor(f,P){this.x=f,this.y=P,this._id=a.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new k.Emitter,this.q=new k.Emitter,this.r=new k.Emitter,this.s=new k.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(f){this.b=f,this.z({title:f})}get step(){return this.c}set step(f){this.c=f,this.z({step:f})}get totalSteps(){return this.d}set totalSteps(f){this.d=f,this.z({totalSteps:f})}get enabled(){return this.g}set enabled(f){this.g=f,this.z({enabled:f})}get busy(){return this.j}set busy(f){this.j=f,this.z({busy:f})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(f){this.k=f,this.z({ignoreFocusOut:f})}get value(){return this.l}set value(f){this.l=f,this.z({value:f})}get placeholder(){return this.m}set placeholder(f){this.m=f,this.z({placeholder:f})}get buttons(){return this.n}set buttons(f){this.n=f.slice(),this.o.clear(),f.forEach((P,E)=>{const o=P===R.QuickInputButtons.Back?-1:E;this.o.set(o,P)}),this.z({buttons:f.map((P,E)=>({...r(P),tooltip:P.tooltip,handle:P===R.QuickInputButtons.Back?-1:E}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(f){this.l=f,this.q.fire(f)}_fireDidTriggerButton(f){const P=this.o.get(f);P&&this.r.fire(P)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,D.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(f){if(!this.v){for(const P of Object.keys(f)){const E=f[P];this.u[P]=E===void 0?null:E}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}C.a=1;function v(I){if(I instanceof R.ThemeIcon)return{id:I.id};const f=l(I),P=n(I);return{dark:typeof f=="string"?F.URI.file(f):f,light:typeof P=="string"?F.URI.file(P):P}}function n(I){return typeof I=="object"&&"light"in I?I.light:I}function l(I){return typeof I=="object"&&"dark"in I?I.dark:I}function r(I){const f=v(I.iconPath);let P,E;return"id"in f?E=w.ThemeIcon.asClassName(f):P=f,{iconPath:P,iconClass:E}}class a extends C{constructor(f,P){super(f.identifier,P),this.O=f,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new k.Emitter,this.L=[],this.M=new k.Emitter,this.N=new k.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(f){this.B=f.slice(),this.C.clear(),this.D.clear(),f.forEach((o,s)=>{this.C.set(s,o),this.D.set(o,s)});const P=(0,c.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),E=[];for(let o=0;o<f.length;o++){const s=f[o];s.kind===R.QuickPickItemKind.Separator?E.push({type:"separator",label:s.label}):(s.tooltip&&!P&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),E.push({handle:o,label:s.label,description:s.description,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow,tooltip:P?p.MarkdownString.fromStrict(s.tooltip):void 0,buttons:s.buttons?.map((M,B)=>({...r(M),tooltip:M.tooltip,handle:B}))}))}this.z({items:E})}get canSelectMany(){return this.E}set canSelectMany(f){this.E=f,this.z({canSelectMany:f})}get matchOnDescription(){return this.F}set matchOnDescription(f){this.F=f,this.z({matchOnDescription:f})}get matchOnDetail(){return this.G}set matchOnDetail(f){this.G=f,this.z({matchOnDetail:f})}get sortByLabel(){return this.H}set sortByLabel(f){this.H=f,this.z({sortByLabel:f})}get keepScrollPosition(){return this.I}set keepScrollPosition(f){this.I=f,this.z({keepScrollPosition:f})}get activeItems(){return this.J}set activeItems(f){this.J=f.filter(P=>this.D.has(P)),this.z({activeItems:this.J.map(P=>this.D.get(P))})}get selectedItems(){return this.L}set selectedItems(f){this.L=f.filter(P=>this.D.has(P)),this.z({selectedItems:this.L.map(P=>this.D.get(P))})}_fireDidChangeActive(f){const P=(0,m.coalesce)(f.map(E=>this.C.get(E)));this.J=P,this.K.fire(P)}_fireDidChangeSelection(f){const P=(0,m.coalesce)(f.map(E=>this.C.get(E)));this.L=P,this.M.fire(P)}_fireDidTriggerItemButton(f,P){const E=this.C.get(f);if(!E||!E.buttons||!E.buttons.length)return;const o=E.buttons[P];o&&this.N.fire({button:o,item:E})}}class b extends C{constructor(f,P){super(f.identifier,P),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(f){this.B=f,this.z({password:f})}get prompt(){return this.C}set prompt(f){this.C=f,this.z({prompt:f})}get valueSelection(){return this.D}set valueSelection(f){this.D=f,this.z({valueSelection:f})}get validationMessage(){return this.E}set validationMessage(f){this.E=f,f?typeof f=="string"?this.z({validationMessage:f,severity:O.default.Error}):this.z({validationMessage:f.message,severity:f.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new y(t,u)}e.createExtHostQuickOpen=g});var Fe=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)},Ye=this&&this.__classPrivateFieldSet||function(te,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i};define(Re[242],Oe([1,0,2,5,65,6,16,4,18,128,14,23,39,8,20,15]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d){"use strict";var t,u,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function y(o){if(o)return typeof o.iconPath=="string"?i.URI.file(o.iconPath):i.URI.isUri(o.iconPath)||c.ThemeIcon.isThemeIcon(o.iconPath)?o.iconPath:void 0}function C(o,s){if(!o.iconPath&&!s.iconPath)return 0;if(o.iconPath){if(!s.iconPath)return 1}else return-1;const M=typeof o.iconPath=="string"?o.iconPath:i.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id,B=typeof s.iconPath=="string"?s.iconPath:i.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id;return(0,m.comparePaths)(M,B)}function v(o,s){let M=0;if(o.strikeThrough!==s.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==s.faded)return o.faded?1:-1;if(o.tooltip!==s.tooltip)return(o.tooltip||"").localeCompare(s.tooltip||"");if(M=C(o,s),M!==0)return M;if(o.light&&s.light)M=C(o.light,s.light);else{if(o.light)return 1;if(s.light)return-1}if(M!==0)return M;if(o.dark&&s.dark)M=C(o.dark,s.dark);else{if(o.dark)return 1;if(s.dark)return-1}return M}function n(o,s){if(o.command!==s.command)return o.command<s.command?-1:1;if(o.title!==s.title)return o.title<s.title?-1:1;if(o.tooltip!==s.tooltip){if(o.tooltip!==void 0&&s.tooltip!==void 0)return o.tooltip<s.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(o.arguments===s.arguments)return 0;if(o.arguments)if(s.arguments){if(o.arguments.length!==s.arguments.length)return o.arguments.length-s.arguments.length}else return 1;else return-1;for(let M=0;M<o.arguments.length;M++){const B=o.arguments[M],X=s.arguments[M];if(B!==X)return B<X?-1:1}return 0}function l(o,s){let M=(0,m.comparePaths)(o.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(M!==0)return M;if(o.command&&s.command)M=n(o.command,s.command);else{if(o.command)return 1;if(s.command)return-1}if(M!==0)return M;if(o.decorations&&s.decorations)M=v(o.decorations,s.decorations);else{if(o.decorations)return 1;if(s.decorations)return-1}return M}function r(o,s){for(let M=0;M<o.length;M++)if(o[M]!==s[M])return!1;return!0}function a(o,s){return o.command===s.command&&o.title===s.title&&o.tooltip===s.tooltip&&(o.arguments&&s.arguments?r(o.arguments,s.arguments):o.arguments===s.arguments)}function b(o,s){return(0,S.equals)(o,s,a)}class I{get value(){return this.d}set value(s){s=s??"",Fe(this,t,"f").$setInputBoxValue(this.l,s),this.n(s)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(s){Fe(this,t,"f").$setInputBoxPlaceholder(this.l,s),this.f=s}get validateInput(){return(0,g.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(s){if((0,g.checkProposedApiEnabled)(this.k,"scmValidation"),s&&typeof s!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=s,Fe(this,t,"f").$setValidationProviderIsEnabled(this.l,!!s)}get enabled(){return this.h}set enabled(s){s=!!s,this.h!==s&&(this.h=s,Fe(this,t,"f").$setInputBoxEnablement(this.l,s))}get visible(){return this.j}set visible(s){s=!!s,this.j!==s&&(this.j=s,Fe(this,t,"f").$setInputBoxVisibility(this.l,s))}get document(){return(0,g.checkProposedApiEnabled)(this.k,"scmTextDocument"),Fe(this,u,"f").getDocument(this.m)}constructor(s,M,B,X,G){this.k=s,this.l=X,this.m=G,t.set(this,void 0),u.set(this,void 0),this.d="",this.e=new k.Emitter,this.f="",this.h=!0,this.j=!0,Ye(this,u,M,"f"),Ye(this,t,B,"f")}showValidationMessage(s,M){(0,g.checkProposedApiEnabled)(this.k,"scmValidation"),Fe(this,t,"f").$showValidationMessage(this.l,s,M)}$onInputBoxValueChange(s){this.n(s)}n(s){this.d=s,this.e.fire(s)}}e.ExtHostSCMInputBox=I,t=new WeakMap,u=new WeakMap;class f{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(s){this.v=s,this.q.$updateGroupLabel(this.t,this.handle,s)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(s){this.p=s,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(s){this.f=[...s],this.k.fire()}constructor(s,M,B,X,G){this.q=s,this.s=M,this.t=B,this.u=X,this.v=G,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new k.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new k.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=f.d++}getResourceState(s){return this.g.get(s)}$executeResourceCommand(s,M){const B=this.h.get(s);return B?(0,F.asPromise)(()=>this.s.executeCommand(B.command,...B.arguments||[],M)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const s=[...this.f].sort(l),B=(0,S.sortedDiff)(this.o,s,l).map(W=>{const U=W.toInsert.map(q=>{const z=this.e++;this.g.set(z,q);const V=q.resourceUri;let ee;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"){const K=new N.DisposableStore;ee=this.s.converter.toInternal(q.command,K),this.j.set(z,K)}else this.h.set(z,q.command);const Ce=y(q.decorations),oe=q.decorations&&y(q.decorations.light)||Ce,le=q.decorations&&y(q.decorations.dark)||Ce,Q=[oe,le],ue=q.decorations&&q.decorations.tooltip||"",Ie=q.decorations&&!!q.decorations.strikeThrough,Pe=q.decorations&&!!q.decorations.faded,be=q.contextValue||"";return{rawResource:[z,V,Q,ue,Ie,Pe,be,ee],handle:z}});return{start:W.start,deleteCount:W.deleteCount,toInsert:U}}),X=B.map(({start:W,deleteCount:U,toInsert:q})=>[W,U,q.map(z=>z.rawResource)]),G=B.reverse();for(const{start:W,deleteCount:U,toInsert:q}of G){const z=q.map(ee=>ee.handle),V=this.n.splice(W,U,...z);for(const ee of V)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.o=s,X}dispose(){this.l=!0,this.m.fire()}}f.d=0;class P{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(s){this.g!==s&&(this.g=s,Fe(this,h,"f").$updateSourceControl(this.t,{count:s}))}get quickDiffProvider(){return this.h}set quickDiffProvider(s){this.h=s;let M;(0,g.isProposedApiEnabled)(this.u,"quickDiffProvider")&&(M=s?.label),Fe(this,h,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!s,quickDiffLabel:M})}get commitTemplate(){return this.j}set commitTemplate(s){s!==this.j&&(this.j=s,Fe(this,h,"f").$updateSourceControl(this.t,{commitTemplate:s}))}get acceptInputCommand(){return this.l}set acceptInputCommand(s){this.k.value=new N.DisposableStore,this.l=s;const M=this.v.converter.toInternal(s,this.k.value);Fe(this,h,"f").$updateSourceControl(this.t,{acceptInputCommand:M})}get actionButton(){return(0,g.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(s){(0,g.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new N.DisposableStore,this.n=s;const M=s!==void 0?{command:this.v.converter.toInternal(s.command,this.m.value),secondaryCommands:s.secondaryCommands?.map(B=>B.map(X=>this.v.converter.toInternal(X,this.m.value))),description:s.description,enabled:s.enabled}:void 0;Fe(this,h,"f").$updateSourceControl(this.t,{actionButton:M??null})}get statusBarCommands(){return this.p}set statusBarCommands(s){if(this.p&&s&&b(this.p,s))return;this.o.value=new N.DisposableStore,this.p=s;const M=(s||[]).map(B=>this.v.converter.toInternal(B,this.o.value));Fe(this,h,"f").$updateSourceControl(this.t,{statusBarCommands:M})}get selected(){return this.q}constructor(s,M,B,X,G,W,U){this.u=s,this.v=X,this.w=G,this.x=W,this.y=U,h.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new N.MutableDisposable,this.l=void 0,this.m=new N.MutableDisposable,this.o=new N.MutableDisposable,this.p=void 0,this.q=!1,this.s=new k.Emitter,this.onDidChangeSelection=this.s.event,this.t=P.d++,this.z=new Map,this.A=new Set,Ye(this,h,B,"f");const q=i.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${G}/scm${this.t}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new I(s,M,Fe(this,h,"f"),this.t,q),Fe(this,h,"f").$registerSourceControl(this.t,G,W,U,q)}createResourceGroup(s,M){const B=new f(Fe(this,h,"f"),this.v,this.t,s,M),X=k.Event.once(B.onDidDispose)(()=>this.z.delete(B));return this.z.set(B,X),this.eventuallyAddResourceGroups(),B}eventuallyAddResourceGroups(){const s=[],M=[];for(const[B,X]of this.z){X.dispose();const G=B.onDidUpdateResourceStates(()=>{this.A.add(B),this.eventuallyUpdateResourceStates()});k.Event.once(B.onDidDispose)(()=>{this.A.delete(B),G.dispose(),this.e.delete(B.handle),Fe(this,h,"f").$unregisterGroup(this.t,B.handle)}),s.push([B.handle,B.id,B.label,B.features]);const W=B._takeResourceStateSnapshot();W.length>0&&M.push([B.handle,W]),this.e.set(B.handle,B)}Fe(this,h,"f").$registerGroups(this.t,s,M),this.z.clear()}eventuallyUpdateResourceStates(){const s=[];this.A.forEach(M=>{const B=M._takeResourceStateSnapshot();B.length!==0&&s.push([M.handle,B])}),s.length>0&&Fe(this,h,"f").$spliceResourceStates(this.t,s),this.A.clear()}getResourceGroup(s){return this.e.get(s)}setSelectionState(s){this.q=s,this.s.fire(s)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(s=>s.dispose()),Fe(this,h,"f").$unregisterSourceControl(this.t)}}h=new WeakMap,P.d=0,xe([(0,D.debounce)(100)],P.prototype,"eventuallyAddResourceGroups",null),xe([(0,D.debounce)(100)],P.prototype,"eventuallyUpdateResourceStates",null);let E=e.ExtHostSCM=class On{get onDidChangeActiveProvider(){return this.j.event}constructor(s,M,B,X){this.l=M,this.m=B,this.n=X,this.g=new Map,this.h=new w.ExtensionIdentifierMap,this.j=new k.Emitter,this.e=s.getProxy(R.MainContext.MainThreadSCM),this.f=s.getProxy(R.MainContext.MainThreadTelemetry),M.registerArgumentProcessor({processArgument:G=>{if(G&&G.$mid===3){const W=this.g.get(G.sourceControlHandle);if(!W)return G;const U=W.getResourceGroup(G.groupHandle);return U?U.getResourceState(G.handle):G}else if(G&&G.$mid===4){const W=this.g.get(G.sourceControlHandle);return W?W.getResourceGroup(G.groupHandle):G}else if(G&&G.$mid===5){const W=this.g.get(G.handle);return W||G}return G}})}createSourceControl(s,M,B,X){this.n.trace("ExtHostSCM#createSourceControl",s.identifier.value,M,B,X),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const G=On.d++,W=new P(s,this.m,this.e,this.l,M,B,X);this.g.set(G,W);const U=this.h.get(s.identifier)||[];return U.push(W),this.h.set(s.identifier,U),W}getLastInputBox(s){this.n.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const M=this.h.get(s.identifier),B=M&&M[M.length-1];return B&&B.inputBox}$provideOriginalResource(s,M,B){const X=i.URI.revive(M);this.n.trace("ExtHostSCM#$provideOriginalResource",s,X.toString());const G=this.g.get(s);return!G||!G.quickDiffProvider||!G.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>G.quickDiffProvider.provideOriginalResource(X,B)).then(W=>W||null)}$onInputBoxValueChange(s,M){this.n.trace("ExtHostSCM#$onInputBoxValueChange",s);const B=this.g.get(s);return B&&B.inputBox.$onInputBoxValueChange(M),Promise.resolve(void 0)}$executeResourceCommand(s,M,B,X){this.n.trace("ExtHostSCM#$executeResourceCommand",s,M,B);const G=this.g.get(s);if(!G)return Promise.resolve(void 0);const W=G.getResourceGroup(M);return W?W.$executeResourceCommand(B,X):Promise.resolve(void 0)}$validateInput(s,M,B){this.n.trace("ExtHostSCM#$validateInput",s);const X=this.g.get(s);return!X||!X.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>X.inputBox.validateInput(M,B)).then(G=>{if(!G)return Promise.resolve(void 0);const W=p.MarkdownString.fromStrict(G.message);return W?Promise.resolve([W,G.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(s){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&this.g.get(s)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=s,Promise.resolve(void 0)}};E.d=0,e.ExtHostSCM=E=xe([Ve(3,O.ILogService)],E)}),define(Re[82],Oe([1,0,4,5,3]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class N{constructor(R){this.b=new k.Emitter,this.onDidChangePassword=this.b.event,this.a=R.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,S){return this.a.$getPassword(R,S)}store(R,S,m){return this.a.$setPassword(R,S,m)}delete(R,S){return this.a.$deletePassword(R,S)}}e.ExtHostSecretState=N,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(Re[243],Oe([1,0,4,7]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSemanticSimilarity=void 0;class D{constructor(F){this.a=new Map,this.b=0,this.c=F.getProxy(i.MainContext.MainThreadSemanticSimilarity)}async $provideSimilarityScore(F,R,S,m){if(this.a.size===0)throw new Error("No semantic similarity providers registered");const O=this.a.get(F);if(!O)throw new Error("Semantic similarity provider not found");return await O.provideSimilarityScore(R,S,m)}registerSemanticSimilarityProvider(F,R){const S=this.b;return this.b++,this.a.set(S,R),this.c.$registerSemanticSimilarityProvider(S),new k.Disposable(()=>{this.c.$unregisterSemanticSimilarityProvider(S),this.a.delete(S)})}}e.ExtHostSemanticSimilarity=D}),define(Re[244],Oe([1,0,4,8,2]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class N{constructor(R,S){this.d=S,this.c=new Map,this.b=R.getProxy(i.MainContext.MainThreadShare)}async $provideShare(R,S,m){return await this.c.get(R)?.provideShare({selection:k.Range.to(S.range),resourceUri:D.URI.revive(S.resourceUri)},m)??void 0}registerShareProvider(R,S){const m=N.a++;return this.c.set(m,S),this.b.$registerShareProvider(m,k.DocumentSelector.from(R,this.d),S.id,S.label,S.priority),{dispose:()=>{this.b.$unregisterShareProvider(m),this.c.delete(m)}}}}e.ExtHostShare=N,N.a=0});var Ye=this&&this.__classPrivateFieldSet||function(te,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Fe=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(Re[245],Oe([1,0,7,4,152,6,8,9]),function(te,e,i,k,D,N,F,R){"use strict";var S,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(g,d,t,u,h,y=i.StatusBarAlignment.Left,C){if(S.set(this,void 0),m.set(this,void 0),this.i=!1,this.k="",this.q=new N.DisposableStore,Ye(this,S,g,"f"),Ye(this,m,d,"f"),h&&u){this.c=(0,i.asStatusBarItemIdentifier)(u.identifier,h);const v=t.get(this.c);v&&(this.j=!0,this.g=v.alignLeft?i.StatusBarAlignment.Left:i.StatusBarAlignment.Right,this.h=v.priority,this.name=v.name,this.text=v.text,this.command=v.command)}else this.c=String(O.a++);this.e=u,this.f=h,this.g=y,this.h=this.u(C)}u(g){if((0,R.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(g){this.k=g,this.v()}set name(g){this.m=g,this.v()}set tooltip(g){this.l=g,this.v()}set color(g){this.n=g,this.v()}set backgroundColor(g){g&&!O.b.has(g.id)&&(g=void 0),this.o=g,this.v()}set command(g){this.r?.fromApi!==g&&(this.p&&this.q.add(this.p),this.p=new N.DisposableStore,typeof g=="string"?this.r={fromApi:g,internal:Fe(this,m,"f").toInternal({title:"",command:g},this.p)}:g?this.r={fromApi:g,internal:Fe(this,m,"f").toInternal(g,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(g){this.t=g,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Fe(this,S,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let g;this.e?this.f?g=`${this.e.identifier.value}.${this.f}`:g=this.e.identifier.value:g=this.f;let d;this.m?d=this.m:d=(0,D.localize)(0,null,this.e.displayName||this.e.name);let t=this.n;this.o&&(t=O.b.get(this.o.id));const u=F.MarkdownString.fromStrict(this.l);Fe(this,S,"f").$setEntry(this.c,g,this.e?.identifier.value,d,this.k,u,this.r?.internal,t,this.o,this.g===i.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=O,S=new WeakMap,m=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class w{constructor(g){this.b=[],this.a=g.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,D.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(g){const d={message:g};return this.b.unshift(d),this.c(),new i.Disposable(()=>{const t=this.b.indexOf(d);t>=0&&(this.b.splice(t,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class c{constructor(g,d){this.e=new Map,this.a=g.getProxy(k.MainContext.MainThreadStatusBar),this.b=d,this.c=new w(this)}$acceptStaticEntries(g){for(const d of g)this.e.set(d.entryId,d)}createStatusBarEntry(g,d,t,u){return new O(this.a,this.b,this.e,g,d,t,u)}setStatusBarMessage(g,d){const t=this.c.setMessage(g);let u;return typeof d=="number"?u=setTimeout(()=>t.dispose(),d):typeof d<"u"&&d.then(()=>t.dispose(),()=>t.dispose()),new i.Disposable(()=>{t.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=c}),define(Re[83],Oe([1,0,4,5,3]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class N{constructor(R,S){this.c=S,this.b=new k.Emitter,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,S){this.a.$registerExtensionStorageKeysToSync(R,S)}async initializeExtensionStorage(R,S,m){const O=await this.a.$initializeExtensionStorage(R,S);let w;return O&&(w=this.d(R,S,O)),w||m}setValue(R,S,m){return this.a.$setValue(R,S,m)}$acceptValue(R,S,m){const O=this.d(R,S,m);O&&this.b.fire({shared:R,key:S,value:O})}d(R,S,m){try{return JSON.parse(m)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${R}): ${O}`)}}}e.ExtHostStorage=N,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Re[84],Oe([1,0,3,27,14,61,2]),function(te,e,i,k,D,N,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let R=e.ExtensionStoragePaths=class{constructor(m,O,w){this.d=O,this.f=w,this.a=m.workspace??void 0,this.b=m.environment,this.whenReady=this.h().then(c=>this.c=c)}async g(m){return F.URI.joinPath(this.b.workspaceStorageHome,m)}async h(){if(!this.a)return Promise.resolve(void 0);const m=this.a.id,O=await this.g(m);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(F.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:F.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(w){this.d.error("[ExtHostStorage]",w);return}}workspaceValue(m){if(this.c)return F.URI.joinPath(this.c,m.identifier.value)}globalValue(m){return F.URI.joinPath(this.b.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=R=xe([Ve(0,k.IExtHostInitDataService),Ve(1,D.ILogService),Ve(2,N.IExtHostConsumerFileSystem)],R)}),define(Re[62],Oe([1,0,5,4,3,2,17,6,7,154,10,180,22,36,181,39,9,16,8,20]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t,u,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class C{constructor(o,s,M,B){this.k=o,this._id=s,this.l=M,this.m=B,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(G=>this.f=G);const X=this;this.value={get name(){return X.m||""},get processId(){return X.b},get creationOptions(){return X.l},get exitStatus(){return X.h},get state(){return X.j},sendText(G,W=!0){X.o(),X.k.$sendText(X._id,G,W)},show(G){X.o(),X.k.$show(X._id,G)},hide(){X.o(),X.k.$hide(X._id)},dispose(){X.a||(X.a=!0,X.k.$dispose(X._id))},get dimensions(){if(!(X.d===void 0||X.g===void 0))return{columns:X.d,rows:X.g}}}}async create(o,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:o.name,shellPath:(0,t.withNullAsUndefined)(o.shellPath),shellArgs:(0,t.withNullAsUndefined)(o.shellArgs),cwd:(0,t.withNullAsUndefined)(o.cwd),env:(0,t.withNullAsUndefined)(o.env),icon:(0,t.withNullAsUndefined)(I(o.iconPath)),color:d.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,t.withNullAsUndefined)(o.message),strictEnv:(0,t.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,t.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,t.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this.n(o.location,s?.resolvedExtHostIdentifier),isTransient:(0,t.withNullAsUndefined)(o.isTransient)})}async createExtensionTerminal(o,s,M,B){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:M,color:d.ThemeColor.isThemeColor(B)?B.id:void 0,location:this.n(o,s),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(o,s){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in o?{viewColumn:h.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus}:void 0:o}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(o){this.m=o}setExitStatus(o,s){this.h=Object.freeze({code:o,reason:s})}setDimensions(o,s){return o===this.d&&s===this.g||o===0||s===0?!1:(this.d=o,this.g=s,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(o){this.f?(this.f(o),this.f=void 0):this.b.then(s=>{s!==o&&(this.b=Promise.resolve(o))})}}e.ExtHostTerminal=C;class v{get onProcessReady(){return this.b.event}constructor(o){this.g=o,this.id=0,this.shouldPersist=!1,this.a=new i.Emitter,this.onProcessData=this.a.event,this.b=new i.Emitter,this.d=new i.Emitter,this.onDidChangeProperty=this.d.event,this.f=new i.Emitter,this.onProcessExit=this.f.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${s}`)}async start(){}shutdown(){this.g.close()}input(o){this.g.handleInput?.(o)}resize(o,s){this.g.setDimensions?.({columns:o,rows:s})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this.g.onDidWrite(s=>this.a.fire(s)),this.g.onDidClose?.((s=void 0)=>{this.f.fire(s===void 0?void 0:s)}),this.g.onDidOverrideDimensions?.(s=>{s&&this.d.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this.g.onDidChangeName?.(s=>{this.d.fire({type:"title",value:s})}),this.g.open(o||void 0),o&&this.g.setDimensions?.(o),this.b.fire({pid:-1,cwd:""})}}let n=1,l=e.BaseExtHostTerminalService=class extends R.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(o=>o.value)}get onDidWriteTerminalData(){return this.I.event}constructor(o,s){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new i.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new i.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new i.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new i.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new i.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new i.Emitter,this.onDidChangeShell=this.J.event,this.a=s.getProxy(k.MainContext.MainThreadTerminalService),this.s=new g.TerminalDataBufferer(this.a.$sendProcessData),this.I=new i.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(o),this.B({dispose:()=>{for(const[M,B]of this.g)B.shutdown(!0)}})}getDefaultShell(o){return(o?this.n:this.m)?.path||""}getDefaultShellArgs(o){return(o?this.n:this.m)?.args||[]}createExtensionTerminal(o,s){const M=new C(this.a,(0,p.generateUuid)(),o,o.name),B=new v(o.pty);return M.createExtensionTerminal(o.location,this.L(o,s).resolvedExtHostIdentifier,I(o.iconPath),f(o.color)).then(X=>{const G=this.M(X,B);this.h[X]=G}),this.f.push(M),M.value}L(o,s){if(s=s||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const M=o.location.parentTerminal;if(M){const B=this.f.find(X=>X.value===M);B&&(s.resolvedExtHostIdentifier=B._id)}}else o.location&&typeof o.location!="object"?s.location=o.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(o,s){if(!this.O(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const B=new v(s),X=this.M(o,B);this.h[o]=X}async $acceptActiveTerminalChanged(o){const s=this.b;if(o===null){this.b=void 0,s!==this.b&&this.F.fire(this.b);return}const M=this.O(o);M&&(this.b=M,s!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(o,s){const M=this.O(o);M&&this.I.fire({terminal:M.value,data:s})}async $acceptTerminalDimensions(o,s,M){const B=this.O(o);B&&B.setDimensions(s,M)&&this.G.fire({terminal:B.value,dimensions:B.value.dimensions})}async $acceptTerminalMaximumDimensions(o,s,M){this.g.get(o)?.resize(s,M)}async $acceptTerminalTitleChange(o,s){const M=this.O(o);M&&(M.name=s)}async $acceptTerminalClosed(o,s,M){const B=this.Q(this.f,o);if(B!==null){const X=this.f.splice(B,1)[0];X.setExitStatus(s,M),this.C.fire(X.value)}}$acceptTerminalOpened(o,s,M,B){if(s){const W=this.Q(this.f,s);if(W!==null){this.f[W]._id=o,this.D.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const X={name:B.name,shellPath:B.executable,shellArgs:B.args,cwd:typeof B.cwd=="string"?B.cwd:N.URI.revive(B.cwd),env:B.env,hideFromUser:B.hideFromUser},G=new C(this.a,o,X,M);this.f.push(G),this.D.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(o,s){this.O(o)?._setProcessId(s)}async $startExtensionTerminal(o,s){const M=this.O(o);if(!M)return{message:(0,m.localize)(0,null,o)};M.isOpen||await new Promise(X=>{const G=this.onDidOpenTerminal(async W=>{W===M.value&&(G.dispose(),X())})});const B=this.g.get(o);B?B.startSendingEvents(s):this.j[o]={initialDimensions:s}}M(o,s){const M=new R.DisposableStore;M.add(s.onProcessReady(X=>this.a.$sendProcessReady(o,X.pid,X.cwd))),M.add(s.onDidChangeProperty(X=>this.a.$sendProcessProperty(o,X))),this.s.startBuffering(o,s.onProcessData),M.add(s.onProcessExit(X=>this.N(o,X))),this.g.set(o,s);const B=this.j[o];return B&&s instanceof v&&(s.startSendingEvents(B.initialDimensions),delete this.j[o]),M}$acceptProcessAckDataEvent(o,s){this.g.get(o)?.acknowledgeDataEvent(s)}$acceptProcessInput(o,s){this.g.get(o)?.input(s)}$acceptTerminalInteraction(o){const s=this.O(o);s?.setInteractedWith()&&this.H.fire(s.value)}$acceptProcessResize(o,s,M){try{this.g.get(o)?.resize(s,M)}catch(B){if(B.code!=="EPIPE"&&B.code!=="ERR_IPC_CHANNEL_CLOSED")throw B}}$acceptProcessShutdown(o,s){this.g.get(o)?.shutdown(s)}$acceptProcessRequestInitialCwd(o){this.g.get(o)?.getInitialCwd().then(s=>this.a.$sendProcessProperty(o,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(o){this.g.get(o)?.getCwd().then(s=>this.a.$sendProcessProperty(o,{type:"cwd",value:s}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this.u.add(o),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(o),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(o,s,M){if(this.v.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this.v.set(s,M),this.a.$registerProfileProvider(s,o.identifier.value),new S.Disposable(()=>{this.v.delete(s),this.a.$unregisterProfileProvider(s)})}registerTerminalQuickFixProvider(o,s,M){if(this.w.has(o))throw new Error(`Terminal quick fix provider "${o}" is already registered`);return this.w.set(o,M),this.a.$registerQuickFixProvider(o,s),new S.Disposable(()=>{this.w.delete(o),this.a.$unregisterQuickFixProvider(o)})}async $provideTerminalQuickFixes(o,s){const M=new c.CancellationTokenSource().token;if(M.isCancellationRequested)return;const B=this.w.get(o);if(!B)return;const X=await B.provideTerminalQuickFixes(s,M);if(X!==null)return X}async $createContributedProfileTerminal(o,s){const M=new c.CancellationTokenSource().token;let B=await this.v.get(o)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(B&&!("options"in B)&&(B={options:B}),!B||!("options"in B))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in B.options){this.createExtensionTerminal(B.options,s);return}this.createTerminalFromOptions(B.options,s)}}async $provideLinks(o,s){const M=this.O(o);if(!M)return[];this.y.delete(o),this.z.get(o)?.dispose(!0);const X=new c.CancellationTokenSource;this.z.set(o,X);const G=[],W={terminal:M.value,line:s},U=[];for(const V of this.u)U.push(u.Promises.withAsyncBody(async ee=>{X.token.onCancellationRequested(()=>ee({provider:V,links:[]}));const Ce=await V.provideTerminalLinks(W,X.token)||[];X.token.isCancellationRequested||ee({provider:V,links:Ce})}));const q=await Promise.all(U);if(X.token.isCancellationRequested)return[];const z=new Map;for(const V of q)V&&V.links.length>0&&G.push(...V.links.map(ee=>{const Ce={id:n++,startIndex:ee.startIndex,length:ee.length,label:ee.tooltip};return z.set(Ce.id,{provider:V.provider,link:ee}),Ce}));return this.y.set(o,z),G}$activateLink(o,s){const M=this.y.get(o)?.get(s);M&&M.provider.handleTerminalLink(M.link)}N(o,s){this.s.stopBuffering(o),this.g.delete(o),delete this.j[o];const M=this.h[o];M&&(M.dispose(),delete this.h[o]),this.a.$sendProcessExit(o,s)}O(o){return this.P(this.f,o)}P(o,s){const M=this.Q(o,s);return M!==null?o[M]:null}Q(o,s){let M=null;return o.some((B,X)=>B._id===s?(M=X,!0):!1),M}getEnvironmentVariableCollection(o){let s=this.l.get(o.identifier.value);return s||(s=new r(o),this.S(o.identifier.value,s)),s.getScopedEnvironmentVariableCollection(void 0)}R(o,s){const M=(0,w.serializeEnvironmentVariableCollection)(s.map),B=(0,w.serializeEnvironmentDescriptionMap)(s.descriptionMap);this.a.$setEnvironmentVariableCollection(o,s.persistent,M.length===0?void 0:M,B)}$initEnvironmentVariableCollections(o){o.forEach(s=>{const M=s[0],B=new r(void 0,s[1]);this.S(M,B)})}$acceptDefaultProfile(o,s){const M=this.m;this.m=o,this.n=s,M?.path!==o.path&&this.J.fire(o.path)}S(o,s){this.l.set(o,s),s.onDidChangeCollection(()=>{this.R(o,s)})}};e.BaseExtHostTerminalService=l=xe([Ve(1,F.IExtHostRpcService)],l);class r{get persistent(){return this.b}set persistent(o){this.b=o,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(o,s){this.f=o,this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new i.Emitter,this.map=new Map(s)}getScopedEnvironmentVariableCollection(o){this.f&&o&&(0,y.checkProposedApiEnabled)(this.f,"envCollectionWorkspace");const s=this.j(o);let M=this.a.get(s);return M||(M=new a(this,o),this.a.set(s,M),M.onDidChangeCollection(()=>this.d.fire())),M}replace(o,s,M,B){this.f&&M&&(0,y.checkProposedApiEnabled)(this.f,"envCollectionOptions"),this.g(o,{value:s,type:S.EnvironmentVariableMutatorType.Replace,options:M??{},scope:B})}append(o,s,M,B){this.f&&M&&(0,y.checkProposedApiEnabled)(this.f,"envCollectionOptions"),this.g(o,{value:s,type:S.EnvironmentVariableMutatorType.Append,options:M??{},scope:B})}prepend(o,s,M,B){this.f&&M&&(0,y.checkProposedApiEnabled)(this.f,"envCollectionOptions"),this.g(o,{value:s,type:S.EnvironmentVariableMutatorType.Prepend,options:M??{},scope:B})}g(o,s){if(s.options&&s.options.applyAtProcessCreation===!1&&!s.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h(o,s.scope),B=this.map.get(M);if(!B||B.value!==s.value||B.type!==s.type||B.options?.applyAtProcessCreation!==(s.options.applyAtProcessCreation??!0)||B.options?.applyAtShellIntegration!==(s.options.applyAtShellIntegration??!1)||B.scope?.workspaceFolder?.index!==s.scope?.workspaceFolder?.index){const X=this.h(o,s.scope),G={variable:o,...s,options:{applyAtProcessCreation:s.options.applyAtProcessCreation??!0,applyAtShellIntegration:s.options.applyAtShellIntegration??!1}};this.map.set(X,G),this.d.fire()}}get(o,s){const M=this.h(o,s),B=this.map.get(M);return B?P(B):void 0}h(o,s){const M=this.j(s);return M.length?`${o}:::${M}`:o}j(o){return this.k(o?.workspaceFolder)??""}k(o){return o?o.uri.toString():void 0}getVariableMap(o){const s=new Map;for(const[M,B]of this.map)this.j(B.scope)===this.j(o)&&s.set(M,P(B));return s}delete(o,s){const M=this.h(o,s);this.map.delete(M),this.d.fire()}clear(o){if(o?.workspaceFolder){for(const[s,M]of this.map)M.scope?.workspaceFolder?.index===o.workspaceFolder.index&&this.map.delete(s);this.l(o)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(o,s){const M=this.j(s),B=this.descriptionMap.get(M);if(!B||B.description!==o){let X;typeof o=="string"?X=o:X=o?.value.split(`

`)[0];const G={description:X,scope:s};this.descriptionMap.set(M,G),this.d.fire()}}getDescription(o){const s=this.j(o);return this.descriptionMap.get(s)?.description}l(o){const s=this.j(o);this.descriptionMap.delete(s)}}class a{get persistent(){return this.b.persistent}set persistent(o){this.b.persistent=o}get onDidChangeCollection(){return this.a&&this.a.event}constructor(o,s){this.b=o,this.d=s,this.a=new i.Emitter}getScopedEnvironmentVariableCollection(o){return this.b.getScopedEnvironmentVariableCollection(o)}replace(o,s,M){this.b.replace(o,s,M,this.d)}append(o,s,M){this.b.append(o,s,M,this.d)}prepend(o,s,M){this.b.prepend(o,s,M,this.d)}get(o){return this.b.get(o,this.d)}forEach(o,s){this.b.getVariableMap(this.d).forEach((M,B)=>o.call(s,B,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(o){this.b.delete(o,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(o){this.b.setDescription(o,this.d)}get description(){return this.b.getDescription(this.d)}}let b=e.WorkerExtHostTerminalService=class extends l{constructor(o){super(!1,o)}createTerminal(o,s,M){throw new O.NotSupportedError}createTerminalFromOptions(o,s){throw new O.NotSupportedError}};e.WorkerExtHostTerminalService=b=xe([Ve(0,F.IExtHostRpcService)],b);function I(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function f(E){return d.ThemeColor.isThemeColor(E)?E:void 0}function P(E){const o={...E};return delete o.scope,o.options=o.options??void 0,delete o.variable,o}});var Fe=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)},Ye=this&&this.__classPrivateFieldSet||function(te,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i};define(Re[246],Oe([1,0,18,16,24,22,5,203,93,6,26,9,36,4,17,105,8,7,45,75,56,20]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t,u,h,y,C,v){"use strict";var n,l;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=e.ExtHostTesting=class{constructor(U,q,z){this.j=z,this.c=new F.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=U.getProxy(p.MainContext.MainThreadTesting),this.h=new B(this.f),this.g=new f(this.f),q.registerArgumentProcessor({processArgument:V=>{if(V?.$mid!==15)return V;const ee=V,Ce=ee.tests[ee.tests.length-1].item.extId;return this.d.get(h.TestId.root(Ce))?.collection.tree.get(Ce)?.actual??(0,d.toItemFromContext)(V)}}),q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const V=await q.executeCommand("_testing.getExplorerSelection"),ee=Ce=>{const oe=this.d.get(h.TestId.root(Ce));if(oe)return h.TestId.isRoot(Ce)?oe.controller:oe.collection.tree.get(Ce)?.actual};return{include:V?.include.map(ee).filter(w.isDefined)||[],exclude:V?.exclude.map(ee).filter(w.isDefined)||[]}})}createTestController(U,q,z,V){if(this.d.has(q))throw new Error(`Attempt to insert a duplicate controller with ID "${q}"`);const ee=new m.DisposableStore,Ce=ee.add(new d.ExtHostTestItemCollection(q,z,this.j));Ce.root.label=z;const oe=new Map,le=this.f,Q={items:Ce.root.children,get label(){return z},set label(Ie){z=Ie,Ce.root.label=Ie,le.$updateController(q,{label:z})},get refreshHandler(){return V},set refreshHandler(Ie){V=Ie,le.$updateController(q,{canRefresh:!!Ie})},get id(){return q},createRunProfile:(Ie,Pe,be,A,K,he)=>{let De=(0,S.hash)(Ie);for(;oe.has(De);)De++;return new X(this.f,oe,q,De,Ie,Pe,be,A,K,he)},createTestItem(Ie,Pe,be){return new d.TestItemImpl(q,Ie,Pe,be)},createTestRun:(Ie,Pe,be=!0)=>this.g.createTestRun(q,Ce,Ie,Pe,be),invalidateTestResults:Ie=>{(0,v.checkProposedApiEnabled)(U,"testInvalidateResults");for(const Pe of Ie instanceof Array?Ie:[Ie]){const be=Pe?h.TestId.fromExtHostTestItem(Pe,q).toString():q;this.f.$markTestRetired(be)}},set resolveHandler(Ie){Ce.resolveHandler=Ie},get resolveHandler(){return Ce.resolveHandler},dispose:()=>{ee.dispose()}};le.$registerTestController(q,z,!!V),ee.add((0,m.toDisposable)(()=>le.$unregisterTestController(q)));const ue={controller:Q,collection:Ce,profiles:oe};return this.d.set(q,ue),ee.add((0,m.toDisposable)(()=>this.d.delete(q))),ee.add(Ce.onDidGenerateDiff(Ie=>le.$publishDiff(q,Ie.map(C.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.h.checkout()}async runTests(U,q=N.CancellationToken.None){const z=P(U);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.d.get(z.controllerId);if(!V)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(ee=>h.TestId.fromExtHostTestItem(ee,V.collection.root.id).toString())??[V.collection.root.id],profileGroup:G[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:U.exclude?.map(ee=>ee.id)},q)}$syncTests(){for(const{collection:U}of this.d.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,q,z){return(0,i.mapFind)(this.g.trackers,ee=>ee.id===U?ee.getCoverage(q):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(U,q,z,V){return(0,i.mapFind)(this.g.trackers,Ce=>Ce.id===U?Ce.getCoverage(q):void 0)?.resolveFileCoverage(z,V)??Promise.resolve([])}$configureRunProfile(U,q){this.d.get(U)?.profiles.get(q)?.configureHandler?.()}async $refreshTests(U,q){await this.d.get(U)?.controller.refreshHandler?.(q)}$publishTestResults(U){this.results=Object.freeze(U.map(q=>(0,O.deepFreeze)(t.TestResults.to(q))).concat(this.results).sort((q,z)=>z.completedAt-q.completedAt).slice(0,32)),this.c.fire()}async $expandTest(U,q){const z=this.d.get(h.TestId.fromString(U).controllerId)?.collection;z&&(await z.expand(U,q<0?1/0:q),z.flushDiff())}$acceptDiff(U){this.h.applyDiff(U.map(C.TestsDiffOp.deserialize))}async $runControllerTests(U,q){return Promise.all(U.map(z=>this.k(z,!1,q)))}async $startContinuousRun(U,q){const z=new N.CancellationTokenSource(q),V=await Promise.all(U.map(ee=>this.k(ee,!0,z.token)));return!q.isCancellationRequested&&!V.some(ee=>ee.error)&&await new Promise(ee=>q.onCancellationRequested(ee)),z.dispose(!0),V}async k(U,q,z){const V=this.d.get(U.controllerId);if(!V)return{};const{collection:ee,profiles:Ce}=V,oe=Ce.get(U.profileId);if(!oe)return{};const le=U.testIds.map(Pe=>ee.tree.get(Pe)).filter(w.isDefined),Q=U.excludeExtIds.map(Pe=>V.collection.tree.get(Pe)).filter(w.isDefined).filter(Pe=>le.some(be=>be.fullId.compare(Pe.fullId)===2));if(!le.length)return{};const ue=new u.TestRunRequest(le.some(Pe=>Pe.actual instanceof d.TestItemRootImpl)?void 0:le.map(Pe=>Pe.actual),Q.map(Pe=>Pe.actual),oe,q),Ie=(0,C.isStartControllerTests)(U)&&this.g.prepareForMainThreadTestRun(ue,E.fromInternal(U,V.collection),z);try{return await oe.runHandler(ue,z),{}}catch(Pe){return{error:String(Pe)}}finally{Ie&&(Ie.hasRunningTasks&&!z.isCancellationRequested&&await F.Event.toPromise(Ie.onEnd),Ie.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.g.cancelAllRuns():this.g.cancelRunById(U)}};e.ExtHostTesting=r=xe([Ve(0,g.IExtHostRpcService)],r);const a=1e4;var b;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(b||(b={}));class I extends m.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(U,q,z){super(),this.k=U,this.l=q,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new F.Emitter),this.onEnd=this.j.event,this.h=this.B(new N.CancellationTokenSource(z));const V=this.B(new k.RunOnceScheduler(()=>this.m(),a));this.B(this.h.token.onCancellationRequested(()=>V.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const q=this.k.id,z=this.k.controllerId,V=(0,c.generateUuid)(),ee=new o(this.l,q,V),Ce=ue=>(Ie,...Pe)=>{if(le){console.warn(`Setting the state of test "${Ie.id}" is a no-op after the run ends.`);return}this.k.isIncluded(Ie)&&(this.s(Ie),ue(Ie,...Pe))},oe=(ue,Ie)=>{const Pe=Ie instanceof Array?Ie.map(t.TestMessage.from):[t.TestMessage.from(Ie)];if(ue.uri&&ue.range){const be={range:t.Range.from(ue.range),uri:ue.uri};for(const A of Pe)A.location=A.location||be}this.l.$appendTestMessagesInRun(q,V,h.TestId.fromExtHostTestItem(ue,z).toString(),Pe)};let le=!1;const Q={isPersisted:this.k.isPersisted,token:this.h.token,name:U,get coverageProvider(){return ee.coverageProvider},set coverageProvider(ue){ee.coverageProvider=ue},enqueued:Ce(ue=>{this.l.$updateTestStateInRun(q,V,h.TestId.fromExtHostTestItem(ue,z).toString(),1)}),skipped:Ce(ue=>{this.l.$updateTestStateInRun(q,V,h.TestId.fromExtHostTestItem(ue,z).toString(),5)}),started:Ce(ue=>{this.l.$updateTestStateInRun(q,V,h.TestId.fromExtHostTestItem(ue,z).toString(),2)}),errored:Ce((ue,Ie,Pe)=>{oe(ue,Ie),this.l.$updateTestStateInRun(q,V,h.TestId.fromExtHostTestItem(ue,z).toString(),6,Pe)}),failed:Ce((ue,Ie,Pe)=>{oe(ue,Ie),this.l.$updateTestStateInRun(q,V,h.TestId.fromExtHostTestItem(ue,z).toString(),4,Pe)}),passed:Ce((ue,Ie)=>{this.l.$updateTestStateInRun(q,V,h.TestId.fromExtHostTestItem(ue,this.k.controllerId).toString(),3,Ie)}),appendOutput:(ue,Ie,Pe)=>{le||(Pe&&(this.k.isIncluded(Pe)?this.s(Pe):Pe=void 0),this.l.$appendOutputToRun(q,V,D.VSBuffer.fromString(ue),Ie&&t.location.from(Ie),Pe&&h.TestId.fromExtHostTestItem(Pe,z).toString()))},end:()=>{le||(le=!0,this.l.$finishedTestRunTask(q,V),this.f.delete(V),this.f.size||this.p())}};return this.f.set(V,{run:Q,coverage:ee}),this.l.$startedTestRunTask(q,{id:V,name:U,running:!0}),Q}m(){for(const{run:U}of this.f.values())U.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(U){if(!(U instanceof d.TestItemImpl))throw new y.InvalidTestItemError(U.id);if(this.g.has(h.TestId.fromExtHostTestItem(U,this.k.controllerId).toString()))return;const q=[],z=this.k.colllection.root;for(;;){const V=t.TestItem.from(U);if(q.unshift(V),this.g.has(V.extId)||(this.g.add(V.extId),U===z))break;U=U.parent||z}this.l.$addTestsToRun(this.k.controllerId,this.k.id,q)}}class f{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,q,z){return this.f(U,q,z)}cancelRunById(U){for(const q of this.c.values())if(q.id===U){q.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,q,z,V,ee){const Ce=this.c.get(z);if(Ce)return Ce.createRun(V);const oe=E.fromPublic(U,q,z,ee),le=P(z);this.d.$startedExtensionTestRun({controllerId:U,continuous:!!z.continuous,profile:le&&{group:G[le.kind],id:le.profileId},exclude:z.exclude?.map(ue=>h.TestId.fromExtHostTestItem(ue,q.root.id).toString())??[],id:oe.id,include:z.include?.map(ue=>h.TestId.fromExtHostTestItem(ue,q.root.id).toString())??[q.root.id],persist:ee});const Q=this.f(z,oe);return Q.onEnd(()=>{this.d.$finishedExtensionTestRun(oe.id),Q.dispose()}),Q.createRun(V)}f(U,q,z){const V=new I(q,this.d,z);return this.c.set(U,V),V.onEnd(()=>this.c.delete(U)),V}}e.TestRunCoordinator=f;const P=W=>{if(W.profile){if(!(W.profile instanceof X))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class E{static fromPublic(U,q,z,V){return new E(U,(0,c.generateUuid)(),z.include?.map(ee=>h.TestId.fromExtHostTestItem(ee,U).toString())??[U],z.exclude?.map(ee=>h.TestId.fromExtHostTestItem(ee,U).toString())??[],V,q)}static fromInternal(U,q){return new E(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,q)}constructor(U,q,z,V,ee,Ce){this.controllerId=U,this.id=q,this.isPersisted=ee,this.colllection=Ce,this.c=z.map(oe=>oe+"\0"),this.d=V.map(oe=>oe+"\0")}isIncluded(U){const q=h.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const z of this.d)if(q===z||q.startsWith(z))return!1;for(const z of this.c)if(q===z||q.startsWith(z))return!0;return!1}}e.TestRunDto=E;class o{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,q,z){this.f=U,this.g=q,this.h=z}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(q){throw this.d=void 0,q}}async resolveFileCoverage(U,q){const z=await this.d;let V=z?.[U];return!this.c||!z||!V?[]:(V.detailedCoverage||(V=z[U]=await this.c.resolveFileCoverage?.(V,q)??V),V.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class s{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const q=h.TestId.parentId(U.item.extId);if(q&&this.g.has(q.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:q,f:z}=this;return{get added(){return[...U].map(V=>V.revived)},get updated(){return[...q].map(V=>V.revived)},get removed(){return[...z].map(V=>V.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class M extends C.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new F.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,q){return{...U,revived:t.TestItem.toPlain(U.item),depth:q?q.depth+1:0,children:new Set}}o(){return new s(this.q)}}class B{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(q=>q.revived)},dispose:(0,R.once)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new M;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class X{get label(){return this.d}set label(U){U!==this.d&&(this.d=U,Fe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,Fe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,Fe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Fe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,Fe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,q,z,V,ee,Ce,oe,le=!1,Q=void 0,ue=!1){this.controllerId=z,this.profileId=V,this.d=ee,this.kind=Ce,this.runHandler=oe,this.f=le,this._tag=Q,this.g=ue,n.set(this,void 0),l.set(this,void 0),Ye(this,n,U,"f"),Ye(this,l,q,"f"),q.set(V,this);const Ie=G[Ce];if(typeof Ie!="number")throw new Error(`Unknown TestRunProfile.group ${Ce}`);Fe(this,n,"f").$publishTestRunProfile({profileId:V,controllerId:z,tag:Q?t.TestTag.namespace(this.controllerId,Q.id):null,label:ee,group:Ie,isDefault:le,hasConfigurationHandler:!1,supportsContinuousRun:ue})}dispose(){Fe(this,l,"f")?.delete(this.profileId)&&(Ye(this,l,void 0,"f"),Fe(this,n,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=X,n=new WeakMap,l=new WeakMap;const G={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(Re[247],Oe([1,0,18,10,5,4,106,8,7]),function(te,e,i,k,D,N,F,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class m{constructor(w,c){this.i=c,this.a=new D.Emitter({onListenerError:k.onUnexpectedExternalError}),this.b=new D.Emitter({onListenerError:k.onUnexpectedExternalError}),this.c=new D.Emitter({onListenerError:k.onUnexpectedExternalError}),this.d=new D.Emitter({onListenerError:k.onUnexpectedExternalError}),this.f=new D.Emitter({onListenerError:k.onUnexpectedExternalError}),this.g=new D.Emitter({onListenerError:k.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=w.getProxy(N.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(w){const c=this.i.allEditors();return w?c:c.map(p=>p.value)}async showTextDocument(w,c,p){let g;typeof c=="number"?g={position:R.ViewColumn.from(c),preserveFocus:p}:typeof c=="object"?g={position:R.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:typeof c.selection=="object"?R.Range.from(c.selection):void 0,pinned:typeof c.preview=="boolean"?!c.preview:void 0}:g={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(w.uri,g),t=d&&this.i.getEditor(d);if(t)return t.value;throw d?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}createTextEditorDecorationType(w,c){return new F.TextEditorDecorationType(this.h,w,c).value}$acceptEditorPropertiesChanged(w,c){const p=this.i.getEditor(w);if(!p)throw new Error("unknown text editor");if(c.options&&p._acceptOptions(c.options),c.selections){const g=c.selections.selections.map(R.Selection.to);p._acceptSelections(g)}if(c.visibleRanges){const g=i.coalesce(c.visibleRanges.map(R.Range.to));p._acceptVisibleRanges(g)}if(c.options&&this.b.fire({textEditor:p.value,options:{...c.options,lineNumbers:R.TextEditorLineNumbersStyle.to(c.options.lineNumbers)}}),c.selections){const g=S.TextEditorSelectionChangeKind.fromValue(c.selections.source),d=c.selections.selections.map(R.Selection.to);this.a.fire({textEditor:p.value,selections:d,kind:g})}if(c.visibleRanges){const g=i.coalesce(c.visibleRanges.map(R.Range.to));this.c.fire({textEditor:p.value,visibleRanges:g})}}$acceptEditorPositionData(w){for(const c in w){const p=this.i.getEditor(c);if(!p)throw new Error("Unknown text editor");const g=R.ViewColumn.to(w[c]);p.value.viewColumn!==g&&(p._acceptViewColumn(g),this.d.fire({textEditor:p.value,viewColumn:g}))}}getDiffInformation(w){return Promise.resolve(this.h.$getDiffInformation(w))}}e.ExtHostEditors=m}),define(Re[248],Oe([1,0,2,3,4,6,7,8,23,9]),function(te,e,i,k,D,N,F,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class O{constructor(p,g){this.b=new Map,this.c=new Map,this.a=p.getProxy(D.MainContext.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(d,t)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&S.ExtensionIdentifier.equals(t,this.b.get(d.source)?.extension)){const u=d.uri===void 0?void 0:i.URI.revive(d.uri);return this.c.get(d.source)?.get(w(u))?.get(d.handle)}else return;return d}})}async $getTimeline(p,g,d,t){return this.b.get(p)?.provider.provideTimeline(i.URI.revive(g),d,t)}registerTimelineProvider(p,g,d,t){const u=new N.DisposableStore,h=this.d(g.id,t,u).bind(this);let y;g.onDidChange&&(y=g.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:g.id}),this));const C=this.c;return this.f({...g,scheme:p,onDidChange:void 0,async provideTimeline(v,n,l){n?.resetCache&&(u.clear(),C.get(g.id)?.clear());const r=await g.provideTimeline(v,n,l);if(r==null)return;const a=h(v,n);return{...r,source:g.id,items:r.items.map(a)}},dispose(){for(const v of C.values())v.get(g.id)?.clear();y?.dispose(),u.dispose()}},d)}d(p,g,d){return(t,u)=>{let h;if(u?.cacheResults){let y=this.c.get(p);y===void 0&&(y=new Map,this.c.set(p,y));const C=w(t);h=y.get(C),h===void 0&&(h=new Map,y.set(C,h))}return y=>{const{iconPath:C,...v}=y,n=`${p}|${y.id??y.timestamp}`;h?.set(n,y);let l,r,a;y.iconPath&&(C instanceof F.ThemeIcon?a={id:C.id,color:C.color}:i.URI.isUri(C)?(l=C,r=C):{light:l,dark:r}=C);let b;return F.MarkdownString.isMarkdownString(v.tooltip)?b=R.MarkdownString.from(v.tooltip):(0,m.isString)(v.tooltip)?b=v.tooltip:F.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=R.MarkdownString.from(v.detail)):(0,m.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=v.detail),{...v,id:v.id??void 0,handle:n,source:p,command:y.command?g.toInternal(y.command,d):void 0,icon:l,iconDark:r,themeIcon:a,tooltip:b,accessibilityInformation:y.accessibilityInformation}}}}f(p,g){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:g}),(0,N.toDisposable)(()=>{for(const t of this.c.values())t.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=O;function w(c){return c?.toString()}}),define(Re[249],Oe([1,0,6,15,2,4]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(S){this.c=new Map,this.b=S.getProxy(N.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,m,O,w){if(this.c.has(m))throw new Error(`Opener with id '${m}' already registered`);const c=w.schemes.find(p=>!F.a.has(p));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this.c.set(m,O),this.b.$registerUriOpener(m,w.schemes,S,w.label),(0,i.toDisposable)(()=>{this.c.delete(m),this.b.$unregisterUriOpener(m)})}async $canOpenUri(S,m,O){const w=this.c.get(S);if(!w)throw new Error(`Unknown opener with id: ${S}`);const c=D.URI.revive(m);return w.canOpenExternalUri(c,O)}async $openUri(S,m,O){const w=this.c.get(S);if(!w)throw new Error(`Unknown opener id: '${S}'`);return w.openExternalUri(D.URI.revive(m.resolvedUri),{sourceUri:D.URI.revive(m.sourceUri)},O)}}e.ExtHostUriOpeners=F,F.a=new Set([k.Schemas.http,k.Schemas.https])}),define(Re[250],Oe([1,0,4,2,6,10,23]),function(te,e,i,k,D,N,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(m){this.c=new F.ExtensionIdentifierSet,this.d=new Map,this.b=m.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(m,O){const w=m.identifier;if(this.c.has(w))throw new Error(`Protocol handler already registered for extension ${w}`);const c=R.a++;return this.c.add(w),this.d.set(c,O),this.b.$registerUriHandler(c,w,m.displayName||m.name),(0,D.toDisposable)(()=>{this.c.delete(w),this.d.delete(c),this.b.$unregisterUriHandler(c)})}$handleExternalUri(m,O){const w=this.d.get(m);if(!w)return Promise.resolve(void 0);try{w.handleUri(k.URI.revive(O))}catch(c){(0,N.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(m){return k.URI.revive(await this.b.$createAppUri(m))}}e.ExtHostUrls=R,R.a=0});var Ye=this&&this.__classPrivateFieldSet||function(te,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Fe=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(Re[63],Oe([1,0,5,15,26,2,167,190,76,4]),function(te,e,i,k,D,N,F,R,S,m){"use strict";var O,w,c,p,g,d,t,u,h,y,C,v,n;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(s,M,B,X,G,W,U){O.set(this,void 0),w.set(this,void 0),c.set(this,void 0),p.set(this,void 0),g.set(this,void 0),d.set(this,void 0),t.set(this,""),u.set(this,void 0),h.set(this,!1),y.set(this,!1),C.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,n.set(this,new i.Emitter),this._onDidDispose=Fe(this,n,"f").event,Ye(this,O,s,"f"),Ye(this,w,M,"f"),Ye(this,u,B,"f"),Ye(this,p,X,"f"),Ye(this,g,G,"f"),Ye(this,d,W,"f"),Ye(this,C,r(W),"f"),Ye(this,v,a(W),"f"),Ye(this,c,U,"f")}dispose(){Ye(this,h,!0,"f"),Fe(this,n,"f").fire(),Fe(this,n,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return Ye(this,y,!0,"f"),(0,S.asWebviewUri)(s,Fe(this,p,"f"))}get cspSource(){const s=Fe(this,d,"f").extensionLocation;if(s.scheme===k.Schemas.https||s.scheme===k.Schemas.http){let M=s.toString();return M.endsWith("/")||(M+="/"),M+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Fe(this,t,"f")}set html(s){this.a(),Fe(this,t,"f")!==s&&(Ye(this,t,s,"f"),Fe(this,v,"f")&&!Fe(this,y,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(Ye(this,y,!0,"f"),Fe(this,c,"f").report("Webview vscode-resource: uris",Fe(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,w,"f").$setHtml(Fe(this,O,"f"),this.b(s)))}get options(){return this.a(),Fe(this,u,"f")}set options(s){this.a(),D.equals(Fe(this,u,"f"),s)||Fe(this,w,"f").$setOptions(Fe(this,O,"f"),f(Fe(this,d,"f"),Fe(this,g,"f"),s)),Ye(this,u,s,"f")}async postMessage(s){if(Fe(this,h,"f"))return!1;const M=(0,R.serializeWebviewMessage)(s,{serializeBuffersForPostMessage:Fe(this,C,"f")});return Fe(this,w,"f").$postMessage(Fe(this,O,"f"),M.message,...M.buffers)}a(){if(Fe(this,h,"f"))throw new Error("Webview is disposed")}b(s){if(!Fe(this,v,"f"))return s;const M=Fe(this,d,"f").extensionLocation?.scheme===k.Schemas.vscodeRemote,B=Fe(this,d,"f").extensionLocation.scheme===k.Schemas.vscodeRemote?Fe(this,d,"f").extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(X,G,W,U,q,z)=>{const V=N.URI.from({scheme:U||"file",path:decodeURIComponent(q)}),ee=(0,S.asWebviewUri)(V,{isRemote:M,authority:B}).toString();return`${G}${ee}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(X,G,W,U,q,z)=>{const V=N.URI.from({scheme:U||"file",path:decodeURIComponent(q)}),ee=(0,S.asWebviewUri)(V,{isRemote:M,authority:B}).toString();return`${G}${ee}${z}`})}}e.ExtHostWebview=l,O=new WeakMap,w=new WeakMap,c=new WeakMap,p=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap,u=new WeakMap,h=new WeakMap,y=new WeakMap,C=new WeakMap,v=new WeakMap,n=new WeakMap;function r(o){try{const s=(0,F.normalizeVersion)((0,F.parseVersion)(o.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function a(o){try{const s=(0,F.normalizeVersion)((0,F.parseVersion)(o.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class b{constructor(s,M,B,X,G){this.c=M,this.d=B,this.e=X,this.f=G,this.b=new Map,this.a=s.getProxy(m.MainContext.MainThreadWebviews)}$onMessage(s,M,B){const X=this.g(s);if(X){const{message:G}=(0,R.deserializeWebviewMessage)(M,B.value);X._onMessageEmitter.fire(G)}}$onMissingCsp(s,M){this.e.warn(`${M} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,M,B){const X=new l(s,this.a,P(M),this.c,this.d,B,this.f);return this.b.set(s,X),X._onDidDispose(()=>{this.b.delete(s)}),X}deleteWebview(s){this.b.delete(s)}g(s){return this.b.get(s)}}e.ExtHostWebviews=b;function I(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=I;function f(o,s,M){return{enableCommandUris:M.enableCommandUris,enableScripts:M.enableScripts,enableForms:M.enableForms,portMapping:M.portMapping,localResourceRoots:M.localResourceRoots||E(o,s)}}e.serializeWebviewOptions=f;function P(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(s=>N.URI.from(s))}}function E(o,s){return[...(s?.getWorkspaceFolders()||[]).map(M=>M.uri),o.extensionLocation]}}),define(Re[251],Oe([1,0,22,93,6,15,25,2,8,63,54,4,7]),function(te,e,i,k,D,N,F,R,S,m,O,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(l,r){this.document=l,this.b=r,this.a=1,this.c=new O.Cache("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,r){await this.f(l).undo(),r||this.disposeBackup()}async redo(l,r){await this.f(l).redo(),r||this.disposeBackup()}disposeEdits(l){for(const r of l)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=v(this.document.uri)+this.a++;return(0,F.joinPath)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const r=this.c.get(l,0);if(!r)throw new Error("No edit found");return r}}class g{constructor(){this.a=new Map}get(l,r){return this.a.get(this.b(l,r))}add(l,r,a){const b=this.b(l,r.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${l} resource:${r.uri}`);const I=new p(r,a);return this.a.set(b,I),I}delete(l,r){const a=this.b(l,r.uri);this.a.delete(a)}b(l,r){return`${l}@@@${r}`}}var d;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(d||(d={}));class t{constructor(){this.a=new Map}addTextProvider(l,r,a){return this.b(0,l,r,a)}addCustomProvider(l,r,a){return this.b(1,l,r,a)}get(l){return this.a.get(l)}b(l,r,a,b){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:l,extension:a,provider:b}),new c.Disposable(()=>this.a.delete(r))}}class u{constructor(l,r,a,b,I){this.d=r,this.f=a,this.g=b,this.h=I,this.b=new t,this.c=new g,this.a=l.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,r,a,b){const I=new D.DisposableStore;return y(a)?(I.add(this.b.addTextProvider(r,l,a)),this.a.$registerTextEditorProvider((0,m.toExtensionData)(l),r,b.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,m.shouldSerializeBuffersForPostMessage)(l))):(I.add(this.b.addCustomProvider(r,l,a)),h(a)&&I.add(a.onDidChangeCustomDocument(f=>{const P=this.i(r,f.document.uri);if(C(f)){const E=P.addEdit(f);this.a.$onDidEdit(f.document.uri,r,E,f.label)}else this.a.$onContentChange(f.document.uri,r)})),this.a.$registerCustomEditorProvider((0,m.toExtensionData)(l),r,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,m.shouldSerializeBuffersForPostMessage)(l))),c.Disposable.from(I,new c.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(l,r,a,b,I){const f=this.b.get(r);if(!f)throw new Error(`No provider found for '${r}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${r}'`);const P=R.URI.revive(l),E=await f.provider.openCustomDocument(P,{backupId:a,untitledDocumentData:b?.buffer},I);let o;return h(f.provider)&&this.f&&(o=this.f.workspaceValue(f.extension)??this.f.globalValue(f.extension)),this.c.add(r,E,o),{editable:h(f.provider)}}async $disposeCustomDocument(l,r){const a=this.b.get(r);if(!a)throw new Error(`No provider found for '${r}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${r}'`);const b=R.URI.revive(l),{document:I}=this.i(r,b);this.c.delete(r,I),I.dispose()}async $resolveCustomEditor(l,r,a,b,I,f){const P=this.b.get(a);if(!P)throw new Error(`No provider found for '${a}'`);const E=S.ViewColumn.to(I),o=this.g.createNewWebview(r,b.contentOptions,P.extension),s=this.h.createNewWebviewPanel(r,a,b.title,E,b.options,o,b.active),M=R.URI.revive(l);switch(P.type){case 1:{const{document:B}=this.i(a,M);return P.provider.resolveCustomEditor(B,s,f)}case 0:{const B=this.d.getDocument(M);return P.provider.resolveCustomTextEditor(B,s,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,r,a){this.i(r,l).disposeEdits(a)}async $onMoveCustomEditor(l,r,a){const b=this.b.get(a);if(!b)throw new Error(`No provider found for '${a}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const I=this.h.getWebviewPanel(l);if(!I)throw new Error("No webview found");const f=R.URI.revive(r),P=this.d.getDocument(f);await b.provider.moveCustomTextEditor(P,I,i.CancellationToken.None)}async $undo(l,r,a,b){return this.i(r,l).undo(a,b)}async $redo(l,r,a,b){return this.i(r,l).redo(a,b)}async $revert(l,r,a){const b=this.i(r,l);await this.j(r).revertCustomDocument(b.document,a),b.disposeBackup()}async $onSave(l,r,a){const b=this.i(r,l);await this.j(r).saveCustomDocument(b.document,a),b.disposeBackup()}async $onSaveAs(l,r,a,b){const I=this.i(r,l);return this.j(r).saveCustomDocumentAs(I.document,R.URI.revive(a),b)}async $backup(l,r,a){const b=this.i(r,l),f=await this.j(r).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},a);return b.updateBackup(f),f.id}i(l,r){const a=this.c.get(l,R.URI.revive(r));if(!a)throw new Error("No custom document found");return a}j(l){const a=this.b.get(l)?.provider;if(!a||!h(a))throw new Error("Custom document is not editable");return a}}e.ExtHostCustomEditors=u;function h(n){return!!n.onDidChangeCustomDocument}function y(n){return typeof n.resolveCustomTextEditor=="function"}function C(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function v(n){const l=n.scheme===N.Schemas.file||n.scheme===N.Schemas.untitled?n.fsPath:n.toString();return(0,k.hash)(l)+""}});var Ye=this&&this.__classPrivateFieldSet||function(te,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Fe=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(Re[252],Oe([1,0,5,6,2,36,8,63,4,7]),function(te,e,i,k,D,N,F,R,S,m){"use strict";var O,w,c,p,g,d,t,u,h,y,C,v,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class l extends k.Disposable{constructor(I,f,P,E){super(),O.set(this,void 0),w.set(this,void 0),c.set(this,void 0),p.set(this,void 0),g.set(this,void 0),d.set(this,void 0),t.set(this,void 0),u.set(this,void 0),h.set(this,!0),y.set(this,void 0),C.set(this,!1),v.set(this,this.B(new i.Emitter)),this.onDidDispose=Fe(this,v,"f").event,n.set(this,this.B(new i.Emitter)),this.onDidChangeViewState=Fe(this,n,"f").event,Ye(this,O,I,"f"),Ye(this,w,f,"f"),Ye(this,p,P,"f"),Ye(this,c,E.viewType,"f"),Ye(this,g,E.panelOptions,"f"),Ye(this,u,E.viewColumn,"f"),Ye(this,d,E.title,"f"),Ye(this,y,E.active,"f")}dispose(){Fe(this,C,"f")||(Ye(this,C,!0,"f"),Fe(this,v,"f").fire(),Fe(this,w,"f").$disposeWebview(Fe(this,O,"f")),Fe(this,p,"f").dispose(),super.dispose())}get webview(){return this.c(),Fe(this,p,"f")}get viewType(){return this.c(),Fe(this,c,"f")}get title(){return this.c(),Fe(this,d,"f")}set title(I){this.c(),Fe(this,d,"f")!==I&&(Ye(this,d,I,"f"),Fe(this,w,"f").$setTitle(Fe(this,O,"f"),I))}get iconPath(){return this.c(),Fe(this,t,"f")}set iconPath(I){this.c(),Fe(this,t,"f")!==I&&(Ye(this,t,I,"f"),Fe(this,w,"f").$setIconPath(Fe(this,O,"f"),D.URI.isUri(I)?{light:I,dark:I}:I))}get options(){return Fe(this,g,"f")}get viewColumn(){if(this.c(),!(typeof Fe(this,u,"f")=="number"&&Fe(this,u,"f")<0))return Fe(this,u,"f")}get active(){return this.c(),Fe(this,y,"f")}get visible(){return this.c(),Fe(this,h,"f")}_updateViewState(I){Fe(this,C,"f")||(this.active!==I.active||this.visible!==I.visible||this.viewColumn!==I.viewColumn)&&(Ye(this,y,I.active,"f"),Ye(this,h,I.visible,"f"),Ye(this,u,I.viewColumn,"f"),Fe(this,n,"f").fire({webviewPanel:this}))}reveal(I,f){this.c(),Fe(this,w,"f").$reveal(Fe(this,O,"f"),{viewColumn:typeof I>"u"?void 0:F.ViewColumn.from(I),preserveFocus:!!f})}c(){if(Fe(this,C,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,w=new WeakMap,c=new WeakMap,p=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap,u=new WeakMap,h=new WeakMap,y=new WeakMap,C=new WeakMap,v=new WeakMap,n=new WeakMap;class r{static c(){return(0,N.generateUuid)()}constructor(I,f,P){this.g=f,this.h=P,this.e=new Map,this.f=new Map,this.d=I.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(I,f,P,E,o={}){const s=typeof E=="object"?E.viewColumn:E,M={viewColumn:F.ViewColumn.from(s),preserveFocus:typeof E=="object"&&!!E.preserveFocus},B=(0,R.shouldSerializeBuffersForPostMessage)(I),X=r.c();this.d.$createWebviewPanel((0,R.toExtensionData)(I),X,f,{title:P,panelOptions:a(o),webviewOptions:(0,R.serializeWebviewOptions)(I,this.h,o),serializeBuffersForPostMessage:B},M);const G=this.g.createNewWebview(X,o,I);return this.createNewWebviewPanel(X,f,P,s,o,G,!0)}$onDidChangeWebviewPanelViewStates(I){const f=Object.keys(I);f.sort((P,E)=>{const o=I[P],s=I[E];return o.active?1:s.active?-1:+o.visible-+s.visible});for(const P of f){const E=this.getWebviewPanel(P);if(!E)continue;const o=I[P];E._updateViewState({active:o.active,visible:o.visible,viewColumn:F.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(I){this.getWebviewPanel(I)?.dispose(),this.e.delete(I),this.g.deleteWebview(I)}registerWebviewPanelSerializer(I,f,P){if(this.f.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.f.set(f,{serializer:P,extension:I}),this.d.$registerSerializer(f,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(I)}),new m.Disposable(()=>{this.f.delete(f),this.d.$unregisterSerializer(f)})}async $deserializeWebviewPanel(I,f,P,E){const o=this.f.get(f);if(!o)throw new Error(`No serializer found for '${f}'`);const{serializer:s,extension:M}=o,B=this.g.createNewWebview(I,P.webviewOptions,M),X=this.createNewWebviewPanel(I,f,P.title,E,P.panelOptions,B,P.active);await s.deserializeWebviewPanel(X,P.state)}createNewWebviewPanel(I,f,P,E,o,s,M){const B=new l(I,this.d,s,{viewType:f,title:P,viewColumn:E,panelOptions:o,active:M});return this.e.set(I,B),B}getWebviewPanel(I){return this.e.get(I)}}e.ExtHostWebviewPanels=r;function a(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(te,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Fe=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(Re[253],Oe([1,0,5,6,63,8,4,7]),function(te,e,i,k,D,N,F,R){"use strict";var S,m,O,w,c,p,g,d,t,u,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends k.Disposable{constructor(n,l,r,a,b,I){super(),S.set(this,void 0),m.set(this,void 0),O.set(this,void 0),w.set(this,void 0),c.set(this,!1),p.set(this,void 0),g.set(this,void 0),d.set(this,void 0),t.set(this,void 0),u.set(this,this.B(new i.Emitter)),this.onDidChangeVisibility=Fe(this,u,"f").event,h.set(this,this.B(new i.Emitter)),this.onDidDispose=Fe(this,h,"f").event,Ye(this,O,r,"f"),Ye(this,g,a,"f"),Ye(this,S,n,"f"),Ye(this,m,l,"f"),Ye(this,w,b,"f"),Ye(this,p,I,"f")}dispose(){Fe(this,c,"f")||(Ye(this,c,!0,"f"),Fe(this,h,"f").fire(),Fe(this,w,"f").dispose(),super.dispose())}get title(){return this.a(),Fe(this,g,"f")}set title(n){this.a(),Fe(this,g,"f")!==n&&(Ye(this,g,n,"f"),Fe(this,m,"f").$setWebviewViewTitle(Fe(this,S,"f"),n))}get description(){return this.a(),Fe(this,d,"f")}set description(n){this.a(),Fe(this,d,"f")!==n&&(Ye(this,d,n,"f"),Fe(this,m,"f").$setWebviewViewDescription(Fe(this,S,"f"),n))}get visible(){return Fe(this,p,"f")}get webview(){return Fe(this,w,"f")}get viewType(){return Fe(this,O,"f")}_setVisible(n){n===Fe(this,p,"f")||Fe(this,c,"f")||(Ye(this,p,n,"f"),Fe(this,u,"f").fire())}get badge(){return this.a(),Fe(this,t,"f")}set badge(n){this.a(),!(n?.value===Fe(this,t,"f")?.value&&n?.tooltip===Fe(this,t,"f")?.tooltip)&&(Ye(this,t,N.ViewBadge.from(n),"f"),Fe(this,m,"f").$setWebviewViewBadge(Fe(this,S,"f"),n))}show(n){this.a(),Fe(this,m,"f").$show(Fe(this,S,"f"),!!n)}a(){if(Fe(this,c,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,m=new WeakMap,O=new WeakMap,w=new WeakMap,c=new WeakMap,p=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap,u=new WeakMap,h=new WeakMap;class C{constructor(n,l){this.d=l,this.b=new Map,this.c=new Map,this.a=n.getProxy(F.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,l,r,a){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:r,extension:n}),this.a.$registerWebviewViewProvider((0,D.toExtensionData)(n),l,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(n)}),new R.Disposable(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(n,l,r,a,b){const I=this.b.get(l);if(!I)throw new Error(`No view provider found for '${l}'`);const{provider:f,extension:P}=I,E=this.d.createNewWebview(n,{},P),o=new y(n,this.a,l,r,E,!0);this.c.set(n,o),await f.resolveWebviewView(o,{state:a},b)}async $onDidChangeWebviewViewVisibility(n,l){this.e(n)._setVisible(l)}async $disposeWebviewView(n){const l=this.e(n);this.c.delete(n),l.dispose(),this.d.deleteWebview(n)}e(n){const l=this.c.get(n);if(!l)throw new Error("No webview found");return l}}e.ExtHostWebviewViews=C}),define(Re[108],Oe([1,0,5,4,2,15,13,3,17,20]),function(te,e,i,k,D,N,F,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let O=e.ExtHostWindow=class Fn{getState(c){const p=this.d;return{get focused(){return p.focused},get active(){return(0,m.checkProposedApiEnabled)(c,"windowActivity"),p.active}}}constructor(c){this.c=new i.Emitter,this.onDidChangeWindowState=this.c.event,this.d=Fn.a,this.b=c.getProxy(k.MainContext.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:g})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(c){this.onDidChangeWindowProperty("focused",c)}$onDidChangeWindowActive(c){this.onDidChangeWindowProperty("active",c)}onDidChangeWindowProperty(c,p){p!==this.d[c]&&(this.d={...this.d,[c]:p},this.c.fire(this.d))}openUri(c,p){let g;if(typeof c=="string"){g=c;try{c=D.URI.parse(c)}catch{return Promise.reject(`Invalid uri - '${c}'`)}}return(0,F.isFalsyOrWhitespace)(c.scheme)?Promise.reject("Invalid scheme - cannot be empty"):c.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${c.scheme}'`):this.b.$openUri(c,g,p)}async asExternalUri(c,p){if((0,F.isFalsyOrWhitespace)(c.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(c,p);return D.URI.from(g)}};O.a={focused:!0,active:!0},e.ExtHostWindow=O=xe([Ve(0,S.IExtHostRpcService)],O),e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(Re[254],Oe([1,0,221,27,17]),function(te,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let N=e.ExtHostConsoleForwarder=class extends i.AbstractExtHostConsoleForwarder{constructor(R,S){super(R,S)}f(R,S,m){S.apply(console,m)}};e.ExtHostConsoleForwarder=N=xe([Ve(0,D.IExtHostRpcService),Ve(1,k.IExtHostInitDataService)],N)}),define(Re[255],Oe([1,0,16,24,22,10,5,6,132,214,46]),function(te,e,i,k,D,N,F,R,S,m,O){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(o,s){try{return JSON.stringify(o,s)}catch{return"null"}}const p="$$ref$$",g={[p]:-1};class d{constructor(s,M){this.jsonString=s,this.referencedBuffers=M}}function t(o,s=null,M=!1){const B=[];return{jsonString:(M?c:JSON.stringify)(o,(G,W)=>{if(typeof W>"u")return g;if(typeof W=="object"){if(W instanceof k.VSBuffer){const U=B.push(W)-1;return{[p]:U}}if(s)return s(G,W)}return W}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=t;function u(o,s,M){return JSON.parse(o,(B,X)=>{if(X){const G=X[p];if(typeof G=="number")return s[G];if(M&&X.$mid===1)return M.transformIncoming(X)}return X})}e.parseJsonAndRestoreBufferRefs=u;function h(o,s){return JSON.stringify(o,s)}function y(o){return o?(s,M)=>M&&M.$mid===1?o.transformOutgoing(M):M:null}var C;(function(o){o[o.LocalSide=0]="LocalSide",o[o.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));var v;(function(o){o[o.Responsive=0]="Responsive",o[o.Unresponsive=1]="Unresponsive"})(v||(e.ResponsiveState=v={}));const n=()=>{},l=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class a extends R.Disposable{constructor(s,M=null,B=null){super(),this[w]=!0,this.b=this.B(new F.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=s,this.f=M,this.g=B,this.h=y(this.g),this.j=!1,this.k=[],this.l=[];for(let X=0,G=O.ProxyIdentifier.count;X<G;X++)this.k[X]=null,this.l[X]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new i.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(X=>this.G(X))}dispose(){this.j=!0,Object.keys(this.s).forEach(s=>{this.s[s].resolveErr(N.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(s){this.u===0&&(this.v=Date.now()+a.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(s){this.v=Date.now()+a.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(s){this.t!==s&&(this.t=s,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(s){return this.g?(0,S.transformIncomingURIs)(s,this.g):s}getProxy(s){const{nid:M,sid:B}=s;return this.l[M]||(this.l[M]=this.F(M,B)),this.l[M]}F(s,M){const B={get:(X,G)=>(typeof G=="string"&&!X[G]&&G.charCodeAt(0)===36&&(X[G]=(...W)=>this.O(s,G,W)),G===r?M:X[G])};return new Proxy(Object.create(null),B)}set(s,M){return this.k[s.nid]=M,M}assertRegistered(s){for(let M=0,B=s.length;M<B;M++){const X=s[M];if(!this.k[X.nid])throw new Error(`Missing proxy instance ${X.sid}`)}}G(s){if(this.j)return;const M=s.byteLength,B=b.read(s,0),X=B.readUInt8(),G=B.readUInt32();switch(X){case 1:case 2:{let{rpcId:W,method:U,args:q}=f.deserializeRequestJSONArgs(B);this.g&&(q=(0,S.transformIncomingURIs)(q,this.g)),this.H(M,G,W,U,q,X===2);break}case 3:case 4:{let{rpcId:W,method:U,args:q}=f.deserializeRequestMixedArgs(B);this.g&&(q=(0,S.transformIncomingURIs)(q,this.g)),this.H(M,G,W,U,q,X===4);break}case 5:{this.f?.logIncoming(M,G,0,"ack"),this.z(G);break}case 6:{this.I(M,G);break}case 7:{this.J(M,G,void 0);break}case 9:{let W=f.deserializeReplyOKJSON(B);this.g&&(W=(0,S.transformIncomingURIs)(W,this.g)),this.J(M,G,W);break}case 10:{const W=f.deserializeReplyOKJSONWithBuffers(B,this.g);this.J(M,G,W);break}case 8:{const W=f.deserializeReplyOKVSBuffer(B);this.J(M,G,W);break}case 11:{let W=f.deserializeReplyErrError(B);this.g&&(W=(0,S.transformIncomingURIs)(W,this.g)),this.L(M,G,W);break}case 12:{this.L(M,G,void 0);break}default:console.error("received unexpected message"),console.error(s)}}H(s,M,B,X,G,W){this.f?.logIncoming(s,M,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(B)}.${X}(`,G);const U=String(M);let q,z;if(W){const ee=new D.CancellationTokenSource;G.push(ee.token),q=this.M(B,X,G),z=()=>ee.cancel()}else q=this.M(B,X,G),z=n;this.p[U]=z;const V=f.serializeAcknowledged(M);this.f?.logOutgoing(V.byteLength,M,1,"ack"),this.c.send(V),q.then(ee=>{delete this.p[U];const Ce=f.serializeReplyOK(M,ee,this.h);this.f?.logOutgoing(Ce.byteLength,M,1,"reply:",ee),this.c.send(Ce)},ee=>{delete this.p[U];const Ce=f.serializeReplyErr(M,ee);this.f?.logOutgoing(Ce.byteLength,M,1,"replyErr:",ee),this.c.send(Ce)})}I(s,M){this.f?.logIncoming(s,M,1,"receiveCancel");const B=String(M);this.p[B]?.()}J(s,M,B){this.f?.logIncoming(s,M,0,"receiveReply:",B);const X=String(M);if(!this.s.hasOwnProperty(X))return;const G=this.s[X];delete this.s[X],G.resolveOk(B)}L(s,M,B){this.f?.logIncoming(s,M,0,"receiveReplyErr:",B);const X=String(M);if(!this.s.hasOwnProperty(X))return;const G=this.s[X];delete this.s[X];let W;B&&(B.$isError?(W=new Error,W.name=B.name,W.message=B.message,W.stack=B.stack):W=B),G.resolveErr(W)}M(s,M,B){try{return Promise.resolve(this.N(s,M,B))}catch(X){return Promise.reject(X)}}N(s,M,B){const X=this.k[s];if(!X)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(s));const G=X[M];if(typeof G!="function")throw new Error("Unknown method "+M+" on actor "+(0,O.getStringIdentifierForProxy)(s));return G.apply(X,B)}O(s,M,B){if(this.j)return new m.CanceledLazyPromise;let X=null;if(B.length>0&&D.CancellationToken.isCancellationToken(B[B.length-1])&&(X=B.pop()),X&&X.isCancellationRequested)return Promise.reject(N.canceled());const G=f.serializeRequestArguments(B,this.h),W=++this.m,U=String(W),q=new m.LazyPromise;X&&X.onCancellationRequested(()=>{const V=f.serializeCancel(W);this.f?.logOutgoing(V.byteLength,W,0,"cancel"),this.c.send(f.serializeCancel(W))}),this.s[U]=q,this.y(W);const z=f.serializeRequest(W,s,M,G,!!X);return this.f?.logOutgoing(z.byteLength,W,0,`request: ${(0,O.getStringIdentifierForProxy)(s)}.${M}(`,B),this.c.send(z),q}}e.RPCProtocol=a,w=l,a.a=3*1e3;class b{static alloc(s,M,B){const X=new b(k.VSBuffer.alloc(B+1+4),0);return X.writeUInt8(s),X.writeUInt32(M),X}static read(s,M){return new b(s,M)}get buffer(){return this.a}constructor(s,M){this.a=s,this.b=M}static sizeUInt8(){return 1}writeUInt8(s){this.a.writeUInt8(s,this.b),this.b+=1}readUInt8(){const s=this.a.readUInt8(this.b);return this.b+=1,s}writeUInt32(s){this.a.writeUInt32BE(s,this.b),this.b+=4}readUInt32(){const s=this.a.readUInt32BE(this.b);return this.b+=4,s}static sizeShortString(s){return 1+s.byteLength}writeShortString(s){this.a.writeUInt8(s.byteLength,this.b),this.b+=1,this.a.set(s,this.b),this.b+=s.byteLength}readShortString(){const s=this.a.readUInt8(this.b);this.b+=1;const B=this.a.slice(this.b,this.b+s).toString();return this.b+=s,B}static sizeLongString(s){return 4+s.byteLength}writeLongString(s){this.a.writeUInt32BE(s.byteLength,this.b),this.b+=4,this.a.set(s,this.b),this.b+=s.byteLength}readLongString(){const s=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+s).toString();return this.b+=s,B}writeBuffer(s){this.a.writeUInt32BE(s.byteLength,this.b),this.b+=4,this.a.set(s,this.b),this.b+=s.byteLength}static sizeVSBuffer(s){return 4+s.byteLength}writeVSBuffer(s){this.a.writeUInt32BE(s.byteLength,this.b),this.b+=4,this.a.set(s,this.b),this.b+=s.byteLength}readVSBuffer(){const s=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+s);return this.b+=s,M}static sizeMixedArray(s){let M=0;M+=1;for(let B=0,X=s.length;B<X;B++){const G=s[B];switch(M+=1,G.type){case 1:M+=this.sizeLongString(G.value);break;case 2:M+=this.sizeVSBuffer(G.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(G.value);for(let W=0;W<G.buffers.length;++W)M+=this.sizeVSBuffer(G.buffers[W]);break;case 4:break}}return M}writeMixedArray(s){this.a.writeUInt8(s.length,this.b),this.b+=1;for(let M=0,B=s.length;M<B;M++){const X=s[M];switch(X.type){case 1:this.writeUInt8(1),this.writeLongString(X.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(X.value);break;case 3:this.writeUInt8(3),this.writeUInt32(X.buffers.length),this.writeLongString(X.value);for(let G=0;G<X.buffers.length;++G)this.writeBuffer(X.buffers[G]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const s=this.a.readUInt8(this.b);this.b+=1;const M=new Array(s);for(let B=0;B<s;B++)switch(this.readUInt8()){case 1:M[B]=this.readLongString();break;case 2:M[B]=this.readVSBuffer();break;case 3:{const G=this.readUInt32(),W=this.readLongString(),U=[];for(let q=0;q<G;++q)U.push(this.readVSBuffer());M[B]=new O.SerializableObjectWithBuffers(u(W,U,null));break}case 4:M[B]=void 0;break}return M}}b.sizeUInt32=4;var I;(function(o){o[o.Simple=0]="Simple",o[o.Mixed=1]="Mixed"})(I||(I={}));class f{static a(s){for(let M=0,B=s.length;M<B;M++)if(s[M]instanceof k.VSBuffer||s[M]instanceof O.SerializableObjectWithBuffers||typeof s[M]>"u")return!0;return!1}static serializeRequestArguments(s,M){if(this.a(s)){const B=[];for(let X=0,G=s.length;X<G;X++){const W=s[X];if(W instanceof k.VSBuffer)B[X]={type:2,value:W};else if(typeof W>"u")B[X]={type:4};else if(W instanceof O.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:q}=t(W.value,M);B[X]={type:3,value:k.VSBuffer.fromString(U),buffers:q}}else B[X]={type:1,value:k.VSBuffer.fromString(h(W,M))}}return{type:1,args:B}}return{type:0,args:h(s,M)}}static serializeRequest(s,M,B,X,G){switch(X.type){case 0:return this.b(s,M,B,X.args,G);case 1:return this.c(s,M,B,X.args,G)}}static b(s,M,B,X,G){const W=k.VSBuffer.fromString(B),U=k.VSBuffer.fromString(X);let q=0;q+=b.sizeUInt8(),q+=b.sizeShortString(W),q+=b.sizeLongString(U);const z=b.alloc(G?2:1,s,q);return z.writeUInt8(M),z.writeShortString(W),z.writeLongString(U),z.buffer}static deserializeRequestJSONArgs(s){const M=s.readUInt8(),B=s.readShortString(),X=s.readLongString();return{rpcId:M,method:B,args:JSON.parse(X)}}static c(s,M,B,X,G){const W=k.VSBuffer.fromString(B);let U=0;U+=b.sizeUInt8(),U+=b.sizeShortString(W),U+=b.sizeMixedArray(X);const q=b.alloc(G?4:3,s,U);return q.writeUInt8(M),q.writeShortString(W),q.writeMixedArray(X),q.buffer}static deserializeRequestMixedArgs(s){const M=s.readUInt8(),B=s.readShortString(),X=s.readMixedArray(),G=new Array(X.length);for(let W=0,U=X.length;W<U;W++){const q=X[W];typeof q=="string"?G[W]=JSON.parse(q):G[W]=q}return{rpcId:M,method:B,args:G}}static serializeAcknowledged(s){return b.alloc(5,s,0).buffer}static serializeCancel(s){return b.alloc(6,s,0).buffer}static serializeReplyOK(s,M,B){if(typeof M>"u")return this.d(s);if(M instanceof k.VSBuffer)return this.e(s,M);if(M instanceof O.SerializableObjectWithBuffers){const{jsonString:X,referencedBuffers:G}=t(M.value,B,!0);return this.g(s,X,G)}else return this.f(s,c(M,B))}static d(s){return b.alloc(7,s,0).buffer}static e(s,M){let B=0;B+=b.sizeVSBuffer(M);const X=b.alloc(8,s,B);return X.writeVSBuffer(M),X.buffer}static deserializeReplyOKVSBuffer(s){return s.readVSBuffer()}static f(s,M){const B=k.VSBuffer.fromString(M);let X=0;X+=b.sizeLongString(B);const G=b.alloc(9,s,X);return G.writeLongString(B),G.buffer}static g(s,M,B){const X=k.VSBuffer.fromString(M);let G=0;G+=b.sizeUInt32,G+=b.sizeLongString(X);for(const U of B)G+=b.sizeVSBuffer(U);const W=b.alloc(10,s,G);W.writeUInt32(B.length),W.writeLongString(X);for(const U of B)W.writeBuffer(U);return W.buffer}static deserializeReplyOKJSON(s){const M=s.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(s,M){const B=s.readUInt32(),X=s.readLongString(),G=[];for(let W=0;W<B;++W)G.push(s.readVSBuffer());return new O.SerializableObjectWithBuffers(u(X,G,M))}static serializeReplyErr(s,M){const B=M?c(N.transformErrorForSerialization(M),null):void 0;if(typeof B!="string")return this.h(s);const X=k.VSBuffer.fromString(B);let G=0;G+=b.sizeLongString(X);const W=b.alloc(11,s,G);return W.writeLongString(X),W.buffer}static deserializeReplyErrError(s){const M=s.readLongString();return JSON.parse(M)}static h(s){return b.alloc(12,s,0).buffer}}var P;(function(o){o[o.RequestJSONArgs=1]="RequestJSONArgs",o[o.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",o[o.RequestMixedArgs=3]="RequestMixedArgs",o[o.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",o[o.Acknowledged=5]="Acknowledged",o[o.Cancel=6]="Cancel",o[o.ReplyOKEmpty=7]="ReplyOKEmpty",o[o.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",o[o.ReplyOKJSON=9]="ReplyOKJSON",o[o.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",o[o.ReplyErrError=11]="ReplyErrError",o[o.ReplyErrEmpty=12]="ReplyErrEmpty"})(P||(P={}));var E;(function(o){o[o.String=1]="String",o[o.VSBuffer=2]="VSBuffer",o[o.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",o[o.Undefined=4]="Undefined"})(E||(E={}))}),define(Re[256],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(N){const F=R=>{globalThis.removeEventListener("message",F);const S=R.data;Object.defineProperties(globalThis,{postMessage:{value(m,O){S.postMessage(m,O)}},onmessage:{get(){return S.onmessage},set(m){S.onmessage=m}}}),S.addEventListener("message",m=>{globalThis.dispatchEvent(new MessageEvent("message",{data:m.data,ports:m.ports?[...m.ports]:void 0}))}),S.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",F)}.toString();class k extends EventTarget{constructor(N,F,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${i})('${F}'))`,m=new Blob([S],{type:"application/javascript"}),O=URL.createObjectURL(m),w=new MessageChannel,c=O,p={type:"_newWorker",id:c,port:w.port2,url:O,options:R};N(p,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{N({type:"_terminateWorker",id:c}),URL.revokeObjectURL(O),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(g){w.port1.onmessage=g}},onmessageerror:{get(){return w.port1.onmessageerror},set(g){w.port1.onmessageerror=g}}}),w.port1.addEventListener("messageerror",g=>{const d=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(d)}),w.port1.addEventListener("message",g=>{const d=new MessageEvent("message",{data:g.data});this.dispatchEvent(d)}),w.port1.start()}}e.NestedWorker=k}),define(Re[257],Oe([1,0,5,30,31,3]),function(te,e,i,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,N.createDecorator)("outputService");var F;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(F||(e.OutputChannelUpdateMode=F={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new i.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new i.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(m){this.a.has(m.id)||(this.a.set(m.id,m),this.b.fire(m.id))}getChannels(){const m=[];return this.a.forEach(O=>m.push(O)),m}getChannel(m){return this.a.get(m)}removeChannel(m){this.a.delete(m),this.c.fire(m)}}k.Registry.add(e.Extensions.OutputChannels,new R),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(Re[109],Oe([1,0,4,3,17,23,14,257,61,27,38,126,24,9,43,5,6]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class u extends F.AbstractMessageLogger{get disposed(){return this.l}constructor(v,n,l,r,a){super(),this.id=v,this.name=n,this.m=l,this.n=r,this.extension=a,this.k=0,this.l=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.k;this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Clear,v)}replace(v){const n=this.k;this.info(v),this.n.$update(this.id,R.OutputChannelUpdateMode.Replace,n),this.visible&&this.m.flush()}show(v,n){this.m.flush(),this.n.$reveal(this.id,!!(typeof v=="boolean"?v:n))}hide(){this.n.$close(this.id)}g(v,n){this.k+=c.VSBuffer.fromString(n).byteLength,(0,F.log)(this.m,v,n),this.visible&&(this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class h extends u{appendLine(v){this.append(v)}}let y=e.ExtHostOutputService=class{constructor(v,n,l,r,a,b){this.i=n,this.j=l,this.k=r,this.l=a,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(i.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[n,l]of this.g)l.visible=n===this.h}createOutputChannel(v,n,l){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const r=typeof n=="object"&&n.log,a=(0,p.isString)(n)?n:void 0;if((0,p.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const I=this.i.environment.extensionLogLevel?.find(([P])=>N.ExtensionIdentifier.equals(l.identifier,P))?.[1];I&&(b=(0,F.parseLogLevel)(I));const f=r?this.o(v,b,l):this.n(v,a,l);return f.then(P=>{this.g.set(P.id,P),P.visible=P.id===this.h}),r?this.r(v,b??this.m.getLevel(),f):this.q(v,f)}async n(v,n,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,a=this.k.extUri.joinPath(r,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.a.$register(v,a,n,l.identifier.value);return new u(I,v,b,this.a,l)}async o(v,n,l){const r=await this.p(l),a=v.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(r,`${a}.log`),I=`${l.identifier.value}.${a}`,f=this.l.createLogger(b,{id:I,name:v,logLevel:n,extensionId:l.identifier.value});return new h(I,v,f,this.a,l)}p(v){let n=this.d.get(v.identifier.value);if(!n){const l=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(l)}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileExists)throw r}return l})())}return n}q(v,n){let l=!1;const r=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return v},append(a){r(),n.then(b=>b.append(a))},appendLine(a){r(),n.then(b=>b.appendLine(a))},clear(){r(),n.then(a=>a.clear())},replace(a){r(),n.then(b=>b.replace(a))},show(a,b){r(),n.then(I=>I.show(a,b))},hide(){r(),n.then(a=>a.hide())},dispose(){l=!0,n.then(a=>a.dispose())}}}r(v,n,l){const r=new t.DisposableStore,a=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},b=r.add(new d.Emitter);function I(f){n=f,b.fire(f)}return l.then(f=>{r.add(f),f.logLevel!==n&&I(f.logLevel),r.add(f.onDidChangeLogLevel(P=>I(P)))}),{...this.q(v,l),get logLevel(){return n},onDidChangeLogLevel:b.event,trace(f,...P){a(),l.then(E=>E.trace(f,...P))},debug(f,...P){a(),l.then(E=>E.debug(f,...P))},info(f,...P){a(),l.then(E=>E.info(f,...P))},warn(f,...P){a(),l.then(E=>E.warn(f,...P))},error(f,...P){a(),l.then(E=>E.error(f,...P))},dispose(){r.dispose()}}}};e.ExtHostOutputService=y=xe([Ve(0,D.IExtHostRpcService),Ve(1,m.IExtHostInitDataService),Ve(2,S.IExtHostConsumerFileSystem),Ve(3,O.IExtHostFileSystemInfo),Ve(4,F.ILoggerService),Ve(5,F.ILogService)],y),e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")});var Fe=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)},Ye=this&&this.__classPrivateFieldSet||function(te,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i};define(Re[258],Oe([1,0,3,16]),function(te,e,i,k){"use strict";var D,N,F,R,S,m,O,w,c,p,g;Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new(g=class{constructor(){D.set(this,5),N.set(this,2e3),F.set(this,[]),R.set(this,3),S.set(this,[]),m.set(this,100),O.set(this,2),w.set(this,500),c.set(this,1500),p.set(this,void 0)}get latency(){return Fe(this,p,"f")}async measure(d){let t=1/0;for(let h=0;h<Fe(this,D,"f");h++){const y=await d.getRoundTripTime();if(y===void 0)return;t=Math.min(t,y/2),await(0,k.timeout)(Fe(this,N,"f"))}Fe(this,S,"f").push(t),Fe(this,S,"f").length>Fe(this,m,"f")&&Fe(this,S,"f").shift();let u;return Fe(this,F,"f").length<Fe(this,R,"f")?Fe(this,F,"f").push(t):u=Fe(this,F,"f").reduce((h,y)=>h+y,0)/Fe(this,F,"f").length,Ye(this,p,{initial:u,current:t,average:Fe(this,S,"f").reduce((h,y)=>h+y,0)/Fe(this,S,"f").length,high:(()=>typeof u>"u"?!1:t>Fe(this,c,"f")||t>Fe(this,w,"f")&&t>u*Fe(this,O,"f"))()},"f"),Fe(this,p,"f")}},D=new WeakMap,N=new WeakMap,F=new WeakMap,R=new WeakMap,S=new WeakMap,m=new WeakMap,O=new WeakMap,w=new WeakMap,c=new WeakMap,p=new WeakMap,g)}),define(Re[259],Oe([1,0,41,15,19,21,25,2,3,185,53,200,258]),function(te,e,i,k,D,N,F,R,S,m,O,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let p=e.AbstractPathService=class Mn{constructor(d,t,u,h){this.d=d,this.e=t,this.f=u,this.g=h,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const y=await this.e.getEnvironment();return this.c=y?.userHome??d})()}hasValidBasename(d,t,u){return typeof t=="string"||typeof t>"u"?this.a.then(h=>this.h(d,h,t)):this.h(d,t,u)}h(d,t,u){return d.scheme===k.Schemas.file||d.scheme===k.Schemas.vscodeRemote?(0,i.isValidBasename)(u??(0,F.basename)(d),t===1):!0}get defaultUriScheme(){return Mn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,t){if(d.remoteAuthority)return k.Schemas.vscodeRemote;const u=(0,m.getVirtualWorkspaceScheme)(t.getWorkspace());if(u)return u;const h=t.getWorkspace().folders[0];if(h)return h.uri.scheme;const y=t.getWorkspace().configuration;return y?y.scheme:k.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?D.win32:D.posix)}async fileURI(d){let t="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const h=d.indexOf("/",2);h===-1?(t=d.substring(2),d="/"):(t=d.substring(2,h),d=d.substring(h)||"/")}return R.URI.from({scheme:k.Schemas.file,authority:t,path:d,query:"",fragment:""})}};e.AbstractPathService=p=xe([Ve(1,c.IRemoteAgentService),Ve(2,w.IWorkbenchEnvironmentService),Ve(3,O.IWorkspaceContextService)],p)}),define(Re[110],Oe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(F,R){this.line=F,this.character=R}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,R){return new i(0,0)}with(F){return new i(0,0)}}e.Position=i;class k{constructor(F,R,S,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(F,R),this.end=new i(S,m)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new k(0,0,0,0)}with(F){return new k(0,0,0,0)}}e.Range=k;var D;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(D||(e.TextSearchCompleteMessageType=D={}))}),define(Re[47],Oe([1,0,18,37,26,41,13,3,19,10,110,16]),function(te,e,i,k,D,N,F,R,S,m,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",p=" characters skipped \u27EB",g=(c.length+p.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var d;(function(le){le[le.file=0]="file",le[le.text=1]="text"})(d||(e.SearchProviderType=d={}));var t;(function(le){le[le.File=1]="File",le[le.Text=2]="Text"})(t||(e.QueryType=t={}));function u(le){return!!le.preview}e.resultIsMatch=u;function h(le){return!!le.resource}e.isFileMatch=h;function y(le){return!!le.message}e.isProgressMessage=y;var C;(function(le){le[le.Normal=0]="Normal",le[le.NewSearchStarted=1]="NewSearchStarted"})(C||(e.SearchCompletionExitCode=C={}));class v{constructor(Q){this.resource=Q,this.results=[]}}e.FileMatch=v;class n{constructor(Q,ue,Ie,Pe){this.ranges=ue,this.webviewIndex=Pe;const be=Array.isArray(ue)?ue:[ue];if(Ie&&Ie.matchLines===1&&l(be)){Q=(0,F.getNLines)(Q,Ie.matchLines);let A="",K=0,he=0;const De=Math.floor(Ie.charsPerLine/5),we=[];for(const ge of be){const ke=Math.max(ge.startColumn-De,0),ae=ge.startColumn+Ie.charsPerLine;if(ke>he+De+g){const de=c+(ke-he)+p;A+=de+Q.slice(ke,ae),K+=ke-(he+de.length)}else A+=Q.slice(he,ae);we.push(new a(0,ge.startColumn-K,ge.endColumn-K)),he=ae}this.preview={text:A,matches:Array.isArray(this.ranges)?we:we[0]}}else{const A=Array.isArray(ue)?ue[0].startLineNumber:ue.startLineNumber;this.preview={text:Q,matches:(0,i.mapArrayOrNot)(ue,K=>new r(K.startLineNumber-A,K.startColumn,K.endLineNumber-A,K.endColumn))}}}}e.TextSearchMatch=n;function l(le){const Q=le[0].startLineNumber;for(const ue of le)if(ue.startLineNumber!==Q||ue.endLineNumber!==Q)return!1;return!0}class r{constructor(Q,ue,Ie,Pe){this.startLineNumber=Q,this.startColumn=ue,this.endLineNumber=Ie,this.endColumn=Pe}}e.SearchRange=r;class a extends r{constructor(Q,ue,Ie){super(Q,ue,Q,Ie)}}e.OneLineRange=a;var b;(function(le){le.List="list",le.Tree="tree"})(b||(e.ViewMode=b={}));var I;(function(le){le.Default="default",le.FileNames="fileNames",le.Type="type",le.Modified="modified",le.CountDescending="countDescending",le.CountAscending="countAscending"})(I||(e.SearchSortOrder=I={}));function f(le,Q=!0){const ue=le&&le.files&&le.files.exclude,Ie=Q&&le&&le.search&&le.search.exclude;if(!ue&&!Ie)return;if(!ue||!Ie)return ue||Ie;let Pe=Object.create(null);return Pe=D.mixin(Pe,D.deepClone(ue)),Pe=D.mixin(Pe,D.deepClone(Ie),!0),Pe}e.getExcludes=f;function P(le,Q){return le.excludePattern&&k.match(le.excludePattern,Q)?!1:le.includePattern||le.usingSearchPaths?le.includePattern&&k.match(le.includePattern,Q)?!0:le.usingSearchPaths?!!le.folderQueries&&le.folderQueries.some(ue=>{const Ie=ue.folder.fsPath;if(N.isEqualOrParent(Q,Ie)){const Pe=S.relative(Ie,Q);return!ue.includePattern||!!k.match(ue.includePattern,Pe)}else return!1}):!1:!0}e.pathIncludedInQuery=P;var E;(function(le){le[le.unknownEncoding=1]="unknownEncoding",le[le.regexParseError=2]="regexParseError",le[le.globParseError=3]="globParseError",le[le.invalidLiteral=4]="invalidLiteral",le[le.rgProcessError=5]="rgProcessError",le[le.other=6]="other",le[le.canceled=7]="canceled"})(E||(e.SearchErrorCode=E={}));class o extends Error{constructor(Q,ue){super(Q),this.code=ue}}e.SearchError=o;function s(le){const Q=le.message;if((0,m.isCancellationError)(le))return new o(Q,E.canceled);try{const ue=JSON.parse(Q);return new o(ue.message,ue.code)}catch{return new o(Q,E.other)}}e.deserializeSearchError=s;function M(le){const Q={message:le.message,code:le.code};return new Error(JSON.stringify(Q))}e.serializeSearchError=M;function B(le){return le.type==="error"?!0:le.type==="success"}e.isSerializedSearchComplete=B;function X(le){return le.type==="success"}e.isSerializedSearchSuccess=X;function G(le){return!!le.path}e.isSerializedFileMatch=G;function W(le,Q){const ue=le.searchPath?le.searchPath:le.relativePath;return(0,F.fuzzyContains)(ue,Q)}e.isFilePatternMatch=W;class U{constructor(Q){this.path=Q,this.results=[]}addMatch(Q){this.results.push(Q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function q(le,Q){const ue={...le||{},...Q||{}};return Object.keys(ue).filter(Ie=>{const Pe=ue[Ie];return typeof Pe=="boolean"&&Pe})}e.resolvePatternsForProvider=q;class z{constructor(Q,ue){this.c=null,this.a={...Q.excludePattern||{},...ue.excludePattern||{}},this.b=k.parse(this.a);let Ie=Q.includePattern;ue.includePattern&&(Ie?Ie={...Ie,...ue.includePattern}:Ie=ue.includePattern),Ie&&(this.c=k.parse(Ie))}matchesExcludesSync(Q,ue,Ie){return!!(this.b&&this.b(Q,ue,Ie))}includedInQuerySync(Q,ue,Ie){return!(this.b&&this.b(Q,ue,Ie)||this.c&&!this.c(Q,ue,Ie))}includedInQuery(Q,ue,Ie){const Pe=this.b(Q,ue,Ie),be=()=>this.c?!!this.c(Q,ue,Ie):!0;return(0,w.isThenable)(Pe)?Pe.then(A=>A?!1:be()):be()}hasSiblingExcludeClauses(){return V(this.a)}}e.QueryGlobTester=z;function V(le){for(const Q in le)if(typeof le[Q]!="boolean")return!0;return!1}function ee(le){if(!le)return;let Q;return ue=>(Q||(Q=(le()||Promise.resolve([])).then(Ie=>Ie?oe(Ie):{})),Q.then(Ie=>!!Ie[ue]))}e.hasSiblingPromiseFn=ee;function Ce(le){if(!le)return;let Q;return ue=>{if(!Q){const Ie=le();Q=Ie?oe(Ie):{}}return!!Q[ue]}}e.hasSiblingFn=Ce;function oe(le){const Q={};for(const ue of le)Q[ue]=!0;return Q}}),define(Re[33],Oe([1,0,18,16,22,5,6,48,15,117,25,13,9,2,156,3,14,173,53,38,27,17,8,7,55,47,4]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t,u,h,y,C,v,n,l,r,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function I(X,G,W){return new O.ExtUri(U=>o(U,W)).isEqual(X,G)}function f(X,G,W){return I(X.uri,G.uri,W)?0:(0,w.compare)(X.uri.toString(),G.uri.toString())}function P(X,G,W){return X.index!==G.index?X.index<G.index?-1:1:I(X.uri,G.uri,W)?(0,w.compare)(X.name,G.name):(0,w.compare)(X.uri.toString(),G.uri.toString())}function E(X,G,W,U){const q=X.slice(0).sort((V,ee)=>W(V,ee,U)),z=G.slice(0).sort((V,ee)=>W(V,ee,U));return(0,i.delta)(q,z,(V,ee)=>W(V,ee,U))}function o(X,G){const W=G.getCapabilities(X.scheme);return!(W&&W&1024)}class s extends h.Workspace{static toExtHostWorkspace(G,W,U,q){if(!G)return{workspace:null,added:[],removed:[]};const{id:z,name:V,folders:ee,configuration:Ce,transient:oe,isUntitled:le}=G,Q=[],ue=W;W?ee.forEach((A,K)=>{const he=p.URI.revive(A.uri),De=s.o(U||W,he,q);De?(De.name=A.name,De.index=A.index,Q.push(De)):Q.push({uri:he,name:A.name,index:K})}):Q.push(...ee.map(({uri:A,name:K,index:he})=>({uri:p.URI.revive(A),name:K,index:he}))),Q.sort((A,K)=>A.index<K.index?-1:1);const Ie=new s(z,V,Q,!!oe,Ce?p.URI.revive(Ce):null,!!le,A=>o(A,q)),{added:Pe,removed:be}=E(ue?ue.workspaceFolders:[],Ie.workspaceFolders,f,q);return{workspace:Ie,added:Pe,removed:be}}static o(G,W,U){for(let q=0;q<G.folders.length;q++){const z=G.workspaceFolders[q];if(I(z.uri,W,U))return z}}constructor(G,W,U,q,z,V,ee){super(G,U.map(Ce=>new h.WorkspaceFolder(Ce)),q,z,ee),this.t=W,this.u=V,this.q=[],this.s=R.TernarySearchTree.forUris(ee),U.forEach(Ce=>{this.q.push(Ce),this.s.set(Ce.uri,Ce)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(G,W){return W&&this.s.get(G)&&(G=(0,O.dirname)(G)),this.s.findSubstr(G)}resolveWorkspaceFolder(G){return this.s.get(G)}}let M=e.ExtHostWorkspace=class{constructor(G,W,U,q,z){this.c=new N.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new N.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new N.AsyncEmitter,this.B=new Map,this.h=q,this.s=U,this.t=z,this.j=new m.Counter,this.k=new k.Barrier,this.o=G.getProxy(b.MainContext.MainThreadWorkspace),this.q=G.getProxy(b.MainContext.MainThreadMessageService);const V=W.workspace;this.l=V?new s(V.id,V.name,[],!!V.transient,V.configuration?p.URI.revive(V.configuration):null,!!V.isUntitled,ee=>o(ee,U)):void 0}$initializeWorkspace(G,W){this.v=W,this.$acceptWorkspaceData(G),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:S.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(G,W,U,...q){const z=[];if(Array.isArray(q)&&q.forEach(le=>{p.URI.isUri(le.uri)&&!z.some(Q=>I(Q.uri,le.uri,this.s))&&z.push({uri:le.uri,name:le.name||(0,O.basenameOrAuthority)(le.uri)})}),this.n||[W,U].some(le=>typeof le!="number"||le<0)||U===0&&z.length===0)return!1;const V=this.x?this.x.workspaceFolders:[];if(W+U>V.length)return!1;const ee=V.slice(0);ee.splice(W,U,...z.map(le=>({uri:le.uri,name:le.name||(0,O.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<ee.length;le++){const Q=ee[le];if(ee.some((ue,Ie)=>Ie!==le&&I(Q.uri,ue.uri,this.s)))return!1}ee.forEach((le,Q)=>le.index=Q);const{added:Ce,removed:oe}=E(V,ee,P,this.s);if(Ce.length===0&&oe.length===0)return!1;if(this.o){const le=G.displayName||G.name;this.o.$updateWorkspaceFolders(le,W,U,z).then(void 0,Q=>{this.n=void 0;const ue={source:{identifier:G.identifier,label:G.displayName||G.name}};this.q.$showMessage(u.Severity.Error,(0,g.localize)(0,null,le,Q.toString()),ue,[])})}return this.y(ee),!0}getWorkspaceFolder(G,W){if(this.x)return this.x.getWorkspaceFolder(G,W)}async getWorkspaceFolder2(G,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(G,W)}async resolveWorkspaceFolder(G){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(G)}getPath(){if(!this.x)return;const{folders:G}=this.x;if(G.length!==0)return G[0].uri.fsPath}getRelativePath(G,W){let U,q="";if(typeof G=="string"?(U=p.URI.file(G),q=G):typeof G<"u"&&(U=G,q=G.fsPath),!U)return q;const z=this.getWorkspaceFolder(U,!0);if(!z)return q;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let V=(0,O.relativePath)(z.uri,U);return W&&z.name&&(V=`${z.name}/${V}`),V}y(G){this.x&&(this.n=s.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:G,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(G){const{workspace:W,added:U,removed:q}=s.toExtHostWorkspace(G,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:U,removed:q}))}findFiles(G,W,U,q,z=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let V;if(W===null?V=!1:W&&(typeof W=="string"?V=W:V=W.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:ee,folder:Ce}=B(n.GlobPattern.from(G));return this.o.$startFileSearch((0,c.withUndefinedAsNull)(ee),(0,c.withUndefinedAsNull)(Ce),(0,c.withUndefinedAsNull)(V),(0,c.withUndefinedAsNull)(U),z).then(oe=>Array.isArray(oe)?oe.map(le=>p.URI.revive(le)):[])}async findTextInFiles(G,W,U,q,z=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const V=this.j.getNext(),ee=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:Ce,folder:oe}=B(n.GlobPattern.from(W.include)),le=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,Q={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:ee,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:Ce,excludePattern:le},ue=!1;if(this.u[V]=Ie=>{if(ue)return;const Pe=p.URI.revive(Ie.resource);Ie.results.forEach(be=>{(0,a.resultIsMatch)(be)?U({uri:Pe,preview:{text:be.preview.text,matches:(0,i.mapArrayOrNot)(be.preview.matches,A=>new l.Range(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn))},ranges:(0,i.mapArrayOrNot)(be.ranges,A=>new l.Range(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn))}):U({uri:Pe,text:be.text,lineNumber:be.lineNumber})})},z.isCancellationRequested)return{};try{const Ie=await this.o.$startTextSearch(G,(0,c.withUndefinedAsNull)(oe),Q,V,z);return delete this.u[V],Ie||{}}catch(Ie){throw delete this.u[V],Ie}}$handleTextSearchResult(G,W){this.u[W]?.(G)}async save(G){const W=await this.o.$save(G,{saveAs:!1});return p.URI.revive(W)}async saveAs(G){const W=await this.o.$save(G,{saveAs:!0});return p.URI.revive(W)}saveAll(G){return this.o.$saveAll(G)}resolveProxy(G){return this.o.$resolveProxy(G)}get trusted(){return this.v}requestWorkspaceTrust(G){return this.o.$requestWorkspaceTrust(G)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(G,W){if(this.w.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.w.set(G,W);const U=this.t.transformOutgoingScheme(G),q=this.z++;return this.o.$registerEditSessionIdentityProvider(q,U),(0,F.toDisposable)(()=>{this.w.delete(G),this.o.$unregisterEditSessionIdentityProvider(q)})}async $getEditSessionIdentifier(G,W){this.h.info("Getting edit session identifier for workspaceFolder",G);const U=await this.resolveWorkspaceFolder(p.URI.revive(G));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const q=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!q),!q)return;const z=await q.provideEditSessionIdentity(U,W);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(G,W,U,q){this.h.info("Getting edit session identifier for workspaceFolder",G);const z=await this.resolveWorkspaceFolder(p.URI.revive(G));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const V=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!V),!V)return;const ee=await V.provideEditSessionIdentityMatch?.(W,U,q);if(this.h.info("Provider returned edit session identifier match result: ",ee),!!ee)return ee}getOnWillCreateEditSessionIdentityEvent(G){return(W,U,q)=>{const z=function(ee){W.call(U,ee)};return z.extension=G,this.A.event(z,void 0,q)}}async $onWillCreateEditSessionIdentity(G,W,U){const q=await this.resolveWorkspaceFolder(p.URI.revive(G));if(q===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:q},W,async(z,V)=>{const ee=Date.now();await Promise.resolve(z),Date.now()-ee>U&&this.h.warn("SLOW edit session create-participant",V.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(G,W){if(this.B.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.B.set(G,W);const U=this.t.transformOutgoingScheme(G),q=this.z++;return this.o.$registerCanonicalUriProvider(q,U),(0,F.toDisposable)(()=>{this.B.delete(G),this.o.$unregisterCanonicalUriProvider(q)})}async provideCanonicalUri(G,W,U){const q=this.B.get(G.scheme);if(!q)return;const z=await q.provideCanonicalUri?.(p.URI.revive(G),W,U);if(z)return z}async $provideCanonicalUri(G,W,U){return this.provideCanonicalUri(p.URI.revive(G),{targetScheme:W},U)}};e.ExtHostWorkspace=M=xe([Ve(0,v.IExtHostRpcService),Ve(1,C.IExtHostInitDataService),Ve(2,y.IExtHostFileSystemInfo),Ve(3,t.ILogService),Ve(4,r.IURITransformerService)],M),e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function B(X){let G,W;return X&&(typeof X=="string"?G=X:(G=X.pattern,W=p.URI.revive(X.baseUri))),{includePattern:G,folder:W}}}),define(Re[34],Oe([1,0,26,5,33,4,7,176,96,9,16,3,17,14,2]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(l,r){if(r){const a=r.split(".");let b=l;for(let I=0;b&&I<a.length;I++)b=b[a[I]];return b}}function t(l){return l instanceof g.URI}function u(l){return l&&l.uri instanceof g.URI&&l.languageId&&typeof l.languageId=="string"}function h(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function y(l){return l&&l.uri instanceof g.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function C(l){if(t(l))return{resource:l};if(u(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(h(l))return{overrideIdentifier:l.languageId};if(y(l))return{resource:l.uri};if(l===null)return{resource:null}}let v=e.ExtHostConfiguration=class{constructor(r,a,b){this.a=r.getProxy(N.MainContext.MainThreadConfiguration),this.c=a,this.b=b,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new n(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,a){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(r,a))}};e.ExtHostConfiguration=v=xe([Ve(0,c.IExtHostRpcService),Ve(1,D.IExtHostWorkspace),Ve(2,p.ILogService)],v);class n{constructor(r,a,b,I){this.a=new k.Emitter,this.b=r,this.f=I,this.c=a,this.e=R.Configuration.parse(b),this.d=this.k(b.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,a){const b={data:this.e.toData(),workspace:this.c.workspace};this.e=R.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(a,b))}getConfiguration(r,a,b){const I=C(a)||{},f=this.g(r?d(this.e.getValue(void 0,I,this.c.workspace),r):this.e.getValue(void 0,I,this.c.workspace));r&&this.h(r,I,b?.identifier);function P(o){if(o==null)return null;if(typeof o=="boolean")return o?2:5;switch(o){case F.ConfigurationTarget.Global:return 2;case F.ConfigurationTarget.Workspace:return 5;case F.ConfigurationTarget.WorkspaceFolder:return 6}}const E={has(o){return typeof d(f,o)<"u"},get:(o,s)=>{this.h(r?`${r}.${o}`:o,I,b?.identifier);let M=d(f,o);if(typeof M>"u")M=s;else{let B;const X=(G,W)=>{if((0,m.isObject)(G)){let U;const q=()=>{B=B||(0,i.deepClone)(f),U=U||d(B,W)};return new Proxy(G,{get:(z,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return q(),()=>U;if(B)return U=U||d(B,W),U[V];const ee=z[V];return typeof V=="string"?X(ee,`${W}.${V}`):ee},set:(z,V,ee)=>(q(),U&&(U[V]=ee),!0),deleteProperty:(z,V)=>(q(),U&&delete U[V],!0),defineProperty:(z,V,ee)=>(q(),U&&Object.defineProperty(U,V,ee),!0)})}return Array.isArray(G)?(0,i.deepClone)(G):G};M=X(M,o)}return M},update:(o,s,M,B)=>{o=r?`${r}.${o}`:o;const X=P(M);return s!==void 0?this.b.$updateConfigurationOption(X,o,s,I,B):this.b.$removeConfigurationOption(X,o,I,B)},inspect:o=>{o=r?`${r}.${o}`:o;const s=this.e.inspect(o,I,this.c.workspace);if(s)return{key:o,defaultValue:(0,i.deepClone)(s.policy?.value??s.default?.value),globalValue:(0,i.deepClone)(s.user?.value??s.application?.value),workspaceValue:(0,i.deepClone)(s.workspace?.value),workspaceFolderValue:(0,i.deepClone)(s.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(s.default?.override),globalLanguageValue:(0,i.deepClone)(s.user?.override??s.application?.override),workspaceLanguageValue:(0,i.deepClone)(s.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(s.workspaceFolder?.override),languageIds:(0,i.deepClone)(s.overrideIdentifiers)}}};return typeof f=="object"&&(0,i.mixin)(E,f,!1),Object.freeze(E)}g(r){const a=b=>(0,m.isObject)(b)?new Proxy(b,{get:(I,f)=>a(I[f]),set:(I,f,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(I,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(I,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:I=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return a(r)}h(r,a,b){const I=S.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),f=b?`[${b.value}] `:"";if(I===4){typeof a?.resource>"u"&&this.f.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(I===3){a?.resource&&this.f.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,a){const b=new R.ConfigurationChangeEvent(r,a,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(I,f)=>b.affectsConfiguration(I,C(f))})}k(r){return r.reduce((a,b)=>(a.set(b[0],b[1]),a),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(te,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Fe=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(Re[111],Oe([1,0,2,16,5,4,7,33,59,34,22,62,17,27,3,15,21,14,79,213,10]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t,u,h,y,C){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(G){function W(q){if(q!=null)return q}G.from=W;function U(q){if(q!=null)return q}G.to=U})(n||(n={}));var l;(function(G){function W(q){if(q!=null)return q}G.from=W;function U(q){if(q!=null)return q}G.to=U})(l||(l={}));var r;(function(G){function W(q){if(q!=null)return q}G.from=W;function U(q){if(q!=null)return q}G.to=U})(r||(r={}));var a;(function(G){function W(z){if(z){const V=z;return V&&!!V.process}else return!1}G.is=W;function U(z){if(z==null)return;const V={process:z.process,args:z.args};return z.options&&(V.options=r.from(z.options)),V}G.from=U;function q(z){if(z!=null)return new F.ProcessExecution(z.process,z.args,z.options)}G.to=q})(a||(a={}));var b;(function(G){function W(q){if(q!=null)return q}G.from=W;function U(q){if(q!=null)return q}G.to=U})(b||(b={}));var I;(function(G){function W(z){if(z){const V=z;return V&&(!!V.commandLine||!!V.command)}else return!1}G.is=W;function U(z){if(z==null)return;const V={};return z.commandLine!==void 0?V.commandLine=z.commandLine:(V.command=z.command,V.args=z.args),z.options&&(V.options=b.from(z.options)),V}G.from=U;function q(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new F.ShellExecution(z.commandLine,z.options):new F.ShellExecution(z.command,z.args?z.args:[],z.options)}G.to=q})(I||(I={}));var f;(function(G){function W(z){if(z){const V=z;return V&&V.customExecution==="customExecution"}else return!1}G.is=W;function U(z){return{customExecution:"customExecution"}}G.from=U;function q(z,V){return V.get(z)}G.to=q})(f||(e.CustomExecutionDTO=f={}));var P;(function(G){function W(U,q){let z;return U.scope!==void 0&&typeof U.scope!="number"?z=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===F.TaskScope.Workspace&&q&&q.workspaceFile?z=q.workspaceFile:z=y.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:z}}G.from=W})(P||(e.TaskHandleDTO=P={}));var E;(function(G){function W(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}G.from=W})(E||(E={}));var o;(function(G){function W(z,V){if(z==null)return[];const ee=[];for(const Ce of z){const oe=U(Ce,V);oe&&ee.push(oe)}return ee}G.fromMany=W;function U(z,V){if(z==null)return;let ee;z.execution instanceof F.ProcessExecution?ee=a.from(z.execution):z.execution instanceof F.ShellExecution?ee=I.from(z.execution):z.execution&&z.execution instanceof F.CustomExecution&&(ee=f.from(z.execution));const Ce=n.from(z.definition);let oe;return z.scope?typeof z.scope=="number"?oe=z.scope:oe=z.scope.uri:oe=F.TaskScope.Workspace,!Ce||!oe?void 0:{_id:z._id,definition:Ce,name:z.name,source:{extensionId:V.identifier.value,label:z.source,scope:oe},execution:ee,isBackground:z.isBackground,group:E.from(z.group),presentationOptions:l.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}G.from=U;async function q(z,V,ee){if(z==null)return;let Ce;a.is(z.execution)?Ce=a.to(z.execution):I.is(z.execution)?Ce=I.to(z.execution):f.is(z.execution)&&(Ce=f.to(z._id,ee));const oe=n.to(z.definition);let le;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?le=z.source.scope:le=await V.resolveWorkspaceFolder(i.URI.revive(z.source.scope)):le=F.TaskScope.Workspace),!oe||!le)return;const Q=new F.Task(oe,le,z.name,z.source.label,Ce,z.problemMatchers);return z.isBackground!==void 0&&(Q.isBackground=z.isBackground),z.group!==void 0&&(Q.group=F.TaskGroup.from(z.group._id),Q.group&&z.group.isDefault&&(Q.group=new F.TaskGroup(Q.group.id,Q.group.label),z.group.isDefault===!0&&(Q.group.isDefault=z.group.isDefault))),z.presentationOptions&&(Q.presentationOptions=l.to(z.presentationOptions)),z._id&&(Q._id=z._id),z.detail&&(Q.detail=z.detail),Q}G.to=q})(o||(e.TaskDTO=o={}));var s;(function(G){function W(q){return q}G.from=W;function U(q){if(q)return Object.assign(Object.create(null),q)}G.to=U})(s||(s={}));class M{constructor(W,U,q){this._id=U,this.a=q,v.set(this,void 0),Ye(this,v,W,"f")}get task(){return this.a}terminate(){Fe(this,v,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}v=new WeakMap;let B=e.ExtHostTaskBase=class{constructor(W,U,q,z,V,ee,Ce,oe){this.q=new D.Emitter,this.r=new D.Emitter,this.s=new D.Emitter,this.t=new D.Emitter,this.a=W.getProxy(N.MainContext.MainThreadTask),this.b=q,this.c=z,this.d=V,this.e=ee,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ce,this.g=oe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,U,q){if(!q)return new F.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:U,provider:q,extension:W}),this.a.$registerTaskProvider(z,U),new F.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(W,U){this.a.$registerTaskSystem(W,U)}fetchTasks(W){return this.a.$fetchTasks(s.from(W)).then(async U=>{const q=[];for(const z of U){const V=await o.to(z,this.b,this.m);V&&q.push(V)}return q})}get taskExecutions(){const W=[];return this.k.forEach(U=>W.push(U)),W}terminateTask(W){if(!(W instanceof M))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,U,q){const z=this.m.get(W.id);z&&(this.o.set(W.id,z),this.e.attachPtyToTerminal(U,await z.callback(q))),this.p=W.id,this.q.fire({execution:await this.y(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){const U=await this.y(W);this.l.delete(W.id),this.k.delete(W.id),this.A(W),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const U=await this.y(W.id);this.s.fire({execution:U,processId:W.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(W){const U=await this.y(W.id);this.t.fire({execution:U,exitCode:W.exitCode})}$provideTasks(W,U){const q=this.j.get(W);if(!q)return Promise.reject(new Error("no handler found"));const z=[],V=(0,k.asPromise)(()=>q.provider.provideTasks(O.CancellationToken.None)).then(ee=>this.u(U,z,q,ee));return new Promise(ee=>{V.then(Ce=>{Promise.all(z).then(()=>{ee(Ce)})})})}async $resolveTask(W,U){const q=this.j.get(W);if(!q)return Promise.reject(new Error("no handler found"));if(U.definition.type!==q.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${q.type}].`);const z=await o.to(U,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const V=await q.provider.resolveTask(z,O.CancellationToken.None);if(!V)return;this.z(V,q);const ee=o.from(V,q.extension);if(!ee)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(ee.execution)&&await this.x(ee,V,!0),await this.v(ee)}w(){return this.h++}async x(W,U,q){const z=await this.a.$createTaskId(W);!q&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,U.execution)),this.m.set(z,U.execution)}async y(W,U){if(typeof W=="string"){const V=this.l.get(W);if(!V)throw new C.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return V}const q=this.l.get(W.id);if(q)return q;const z=new Promise((V,ee)=>{function Ce(oe,le,Q){Q?V(new M(oe,le.id,Q)):ee("Unexpected: Task does not exist.")}U?Ce(this,W,U):o.to(W.task,this.b,this.m).then(oe=>Ce(this,W,oe))});return this.l.set(W.id,z),z.then(V=>(this.k.set(W.id,V),V),V=>Promise.reject(V))}z(W,U){W._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const q=this.n.values();let z=q.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=q.next()}};e.ExtHostTaskBase=B=xe([Ve(0,c.IExtHostRpcService),Ve(1,p.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,m.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,u.ILogService),Ve(7,h.IExtHostApiDeprecationService)],B);let X=e.WorkerExtHostTask=class extends B{constructor(W,U,q,z,V,ee,Ce,oe){super(W,U,q,z,V,ee,Ce,oe),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(W,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const q=o.from(U,W);if(q===void 0)throw new Error("Task is not valid");if(f.is(q.execution))await this.x(q,U,!1);else throw new C.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution(q),U);return this.a.$executeTask(q).catch(V=>{throw new Error(V)}),z}u(W,U,q,z){const V=[];if(z)for(const ee of z){this.z(ee,q),(!ee.definition||!W[ee.definition.type])&&this.f.warn(`The task [${ee.source}, ${ee.name}] uses an undefined task type. The task will be ignored in the future.`);const Ce=o.from(ee,q.extension);Ce&&f.is(Ce.execution)?(V.push(Ce),U.push(this.x(Ce,ee,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:q.extension}}async v(W){if(f.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,U,q){}};e.WorkerExtHostTask=X=xe([Ve(0,c.IExtHostRpcService),Ve(1,p.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,m.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,u.ILogService),Ve(7,h.IExtHostApiDeprecationService)],X),e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(Re[260],Oe([1,0,19,22,40,37,25,58,47]),function(te,e,i,k,D,N,F,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class m{constructor(c,p,g){this.k=c,this.l=p,this.o=g,this.e=!1,this.f=0,this.g=!1,this.a=c.filePattern,this.b=c.includePattern&&N.parse(c.includePattern),this.c=c.maxResults||void 0,this.d=c.exists,this.h=new Set,this.j=c.excludePattern&&N.parse(c.excludePattern)}cancel(){this.g=!0,this.h.forEach(c=>c.cancel()),this.h=new Set}search(c){const p=this.k.folderQueries||[];return new Promise((g,d)=>{const t=u=>{this.f++,c(u)};if(this.g)return g({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(u=>{const h=u.toString(),y=i.basename(h);this.j&&this.j(h,y)||this.v(t,{base:u,basename:y})}),Promise.all(p.map(u=>this.p(u,t))).then(u=>{g({limitHit:this.e,stats:u[0]||void 0})},u=>{d(new Error((0,D.toErrorMessage)(u)))})})}async p(c,p){const g=new k.CancellationTokenSource,d=this.q(c),t=this.r(),u=new S.QueryGlobTester(this.k,c),h=!u.hasSiblingExcludeClauses();let y;try{this.h.add(g),y=R.StopWatch.create();const C=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,g.token),v=y.elapsed(),n=R.StopWatch.create();return this.g&&!this.e||(C&&C.forEach(l=>{const r=i.posix.relative(c.folder.path,l.path);if(h){const a=i.basename(l.path);this.v(p,{base:c.folder,relativePath:r,basename:a});return}this.s(t,c.folder,r,p)}),this.g&&!this.e)?null:(this.u(t,u,p),{providerTime:v,postProcessTime:n.elapsed()})}finally{g.dispose(),this.h.delete(g)}}q(c){const p=(0,S.resolvePatternsForProvider)(this.k.includePattern,c.includePattern),g=(0,S.resolvePatternsForProvider)(this.k.excludePattern,c.excludePattern);return{folder:c.folder,excludes:g,includes:p,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}s({pathToEntries:c},p,g,d){if(g===this.a){const u=i.basename(this.a);this.v(d,{base:p,relativePath:this.a,basename:u})}function t(u){const h=i.basename(u),y=i.dirname(u);let C=c[y];C||(C=c[y]=[],t(y)),C.push({base:p,relativePath:u,basename:h})}t(g)}u({rootEntries:c,pathToEntries:p},g,d){const t=this,u=this.a;function h(y){const C=(0,S.hasSiblingFn)(()=>y.map(v=>v.basename));for(let v=0,n=y.length;v<n;v++){const l=y[v],{relativePath:r,basename:a}=l;if(g.matchesExcludesSync(r,a,u!==a?C:void 0))continue;const b=p[r];if(b)h(b);else{if(r===u)continue;t.v(d,l)}if(t.e)break}}h(c)}v(c,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||c(p))}}class O{constructor(){this.b=new Map}fileSearch(c,p,g,d){const t=this.c(c.cacheKey),u=new m(c,p,t&&t.token);let h=0;const y=C=>{h+=C.length,g(C.map(v=>this.d(v)))};return this.e(u,O.a,y,d).then(C=>({limitHit:C.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:C.stats}}))}clearCache(c){this.c(c)?.cancel()}c(c){if(c)return this.b.has(c)||this.b.set(c,new k.CancellationTokenSource),this.b.get(c)}d(c){return c.relativePath?{resource:F.joinPath(c.base,c.relativePath)}:{resource:c.base}}e(c,p,g,d){d.onCancellationRequested(()=>{c.cancel()});const t=h=>{h&&(u.push(h),p>0&&u.length>=p&&(g(u),u=[]))};let u=[];return c.search(t).then(h=>(u.length&&g(u),h),h=>(u.length&&g(u),Promise.reject(h)))}}e.FileSearchManager=O,O.a=512}),define(Re[261],Oe([1,0,18,64,37,90,28,15,19,25,13,9,2,275,165,42,14,53,101,259,47]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t,u,h,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=e.QueryBuilder=class{constructor(o,s,M,B,X){this.a=o,this.b=s,this.c=M,this.d=B,this.e=X}text(o,s,M={}){o=this.f(o,M);const B=this.a.getValue(),X=s&&s.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(s?.map(u.toWorkspaceFolder),M),type:2,contentPattern:o,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:B.search.usePCRE2||X||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}f(o,s){const M=this.a.getValue();o.isRegExp&&(o.pattern=o.pattern.replace(/\r?\n/g,"\\n"));const B={...o,wordSeparators:M.editor.wordSeparators};return this.j(o,s)&&(B.isCaseSensitive=!0),this.k(o)&&(B.isMultiline=!0),s.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=s.notebookSearchConfig.includeMarkupInput),s.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=s.notebookSearchConfig.includeMarkupPreview),s.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=s.notebookSearchConfig.includeCodeInput),s.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=s.notebookSearchConfig.includeOutput),B}file(o,s={}){return{...this.h(o,s),type:1,filePattern:s.filePattern?s.filePattern.trim():s.filePattern,exists:s.exists,sortByScore:s.sortByScore,cacheKey:s.cacheKey}}g(o,s){return o?(o=Array.isArray(o)?o.map(b):b(o),s?this.parseSearchPaths(o):{pattern:l(...Array.isArray(o)?o:[o])}):{}}h(o=[],s={}){const M=this.g(s.includePattern,s.expandPatterns),B=this.g(s.excludePattern,s.expandPatterns),X=o.length>1,G=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(q=>this.q(q,s,B)):o.map(q=>this.r(q,s,B,X))).filter(q=>!!q),W={_reason:s._reason,folderQueries:G,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:s.extraFileResources,excludePattern:B.pattern,includePattern:M.pattern,onlyOpenEditors:s.onlyOpenEditors,maxResults:s.maxResults};if(s.onlyOpenEditors){const q=i.coalesce(i.flatten(this.c.groups.map(ee=>ee.editors.map(Ce=>Ce.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(q));const z=q.filter(ee=>(0,C.pathIncludedInQuery)(W,ee.fsPath)),V=this.i(z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...W,...V}}const U=s.extraFileResources&&s.extraFileResources.filter(q=>(0,C.pathIncludedInQuery)(W,q.fsPath));return W.extraFileResources=U&&U.length?U:void 0,W}i(o){const s=[],M=new F.ResourceMap,B={};let X=!1;return o.forEach(G=>{if(G.scheme===R.Schemas.walkThrough)return;if((0,m.isAbsolutePath)(G)){const U=this.b.getWorkspaceFolder(G)?.uri??G.with({path:S.dirname(G.fsPath)});let q=M.get(U);q||(X=!0,q={folder:U,includePattern:{}},s.push(q),M.set(U,q));const z=S.relative(U.fsPath,G.fsPath);(0,w.assertIsDefined)(q.includePattern)[z.replace(/\\/g,"/")]=!0}else G.fsPath&&(X=!0,B[G.fsPath]=!0)}),{folderQueries:s,includePattern:B,usingSearchPaths:!0,excludePattern:X?void 0:{"**/*":!0}}}j(o,s){if(s.isSmartCase){if(o.isRegExp){if(O.containsUppercaseCharacter(o.pattern,!0))return!0}else if(O.containsUppercaseCharacter(o.pattern))return!0}return!!o.isCaseSensitive}k(o){return o.isMultiline||o.isRegExp&&(0,p.isMultilineRegexSource)(o.pattern)||o.pattern.indexOf(`
`)>=0?!0:!!o.isMultiline}parseSearchPaths(o){const s=V=>S.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),B=(Array.isArray(o)?o:r(o)).map(V=>{const ee=this.e.resolvedUserHome;return ee?(0,N.untildify)(V,ee.scheme===R.Schemas.file?ee.fsPath:ee.path):V}),X=k.groupBy(B,V=>s(V)?"searchPaths":"exprSegments"),G=(X.exprSegments||[]).map(V=>O.rtrim(V,"/")).map(V=>O.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),a(V))),W={},U=this.m(X.searchPaths||[]);U&&U.length&&(W.searchPaths=U);const q=i.flatten(G),z=l(...q);return z&&(W.pattern=z),W}l(o,s){return s.disregardExcludeSettings?void 0:(0,C.getExcludes)(o,!s.disregardSearchExcludeSettings)}m(o){if(!o||!o.length)return[];const s=o.flatMap(B=>{let{pathPortion:X,globPortion:G}=n(B);return G&&(G=I(G)),this.n(X).flatMap(U=>this.o(U,G))}),M=new Map;return s.forEach(B=>{const X=B.searchPath.toString(),G=M.get(X);G?B.pattern&&(G.pattern=G.pattern||{},G.pattern[B.pattern]=!0):M.set(X,{searchPath:B.searchPath,pattern:B.pattern?l(B.pattern):void 0})}),Array.from(M.values())}n(o){if(S.isAbsolute(o)){const s=this.b.getWorkspace().folders;return s[0]&&s[0].uri.scheme!==R.Schemas.file?[{searchPath:s[0].uri.with({path:o})}]:[{searchPath:c.URI.file(S.normalize(o))}]}if(this.b.getWorkbenchState()===2){const s=this.b.getWorkspace().folders[0].uri;if(o=b(o),o.startsWith("../")||o===".."){const B=S.posix.resolve(s.path,o);return[{searchPath:s.with({path:B})}]}const M=I(o);return[{searchPath:s,pattern:M}]}else{if(o==="./"||o===".\\")return[];{const s=o.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(X=>{const G=s.match(new RegExp(`^${O.escapeRegExpCharacters(X.name)}(?:/(.*)|$)`));return G?{match:G,folder:X}:null}).filter(w.isDefined);if(B.length)return B.map(X=>{const G=X.match[1];return{searchPath:X.folder.uri,pattern:G&&I(G)}});{const X=o.match(/\.[\/\\](.+)[\/\\]?/),G=X?X[1]:o,W=g.localize(0,null,G);throw new Error(W)}}}}o(o,s){const M=o.pattern&&s?`${o.pattern}/${s}`:o.pattern||s,B=[{searchPath:o.searchPath,pattern:M}];return M&&!M.endsWith("**")&&B.push({searchPath:o.searchPath,pattern:M+"/**"}),B}q(o,s,M){const B=this.r((0,u.toWorkspaceFolder)(o.searchPath),s,M,!1);return B?{...B,includePattern:o.pattern}:null}r(o,s,M,B){let X;const G=c.URI.isUri(o)?o:o.uri;if(M.searchPaths){const V=M.searchPaths.filter(ee=>(0,m.isEqual)(ee.searchPath,G))[0];if(V&&!V.pattern)return null;V&&(X=V.pattern)}const W=this.a.getValue({resource:G}),q={...this.l(W,s)||{},...X||{}},z=c.URI.isUri(o)?(0,m.basename)(o):o.name;return{folder:G,folderName:B?z:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof s.disregardIgnoreFiles=="boolean"?s.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof s.disregardGlobalIgnoreFiles=="boolean"?s.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof s.disregardParentIgnoreFiles=="boolean"?s.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof s.ignoreSymlinks=="boolean"?s.ignoreSymlinks:!W.search.followSymlinks}}};e.QueryBuilder=v=xe([Ve(0,d.IConfigurationService),Ve(1,u.IWorkspaceContextService),Ve(2,h.IEditorGroupsService),Ve(3,t.ILogService),Ve(4,y.IPathService)],v);function n(E){const o=E.match(/[\*\{\}\(\)\[\]\?]/);if(o){const s=o.index,M=E.substr(0,s).match(/[/|\\][^/\\]*$/);if(M){let B=E.substr(0,M.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:E.substr((M.index||0)+1)}}}return{pathPortion:E}}function l(...E){return E.length?E.reduce((o,s)=>(o[s]=!0,o),Object.create(null)):void 0}function r(E){return D.splitGlobAware(E,",").map(o=>o.trim()).filter(o=>!!o.length)}function a(E){return[`**/${E}/**`,`**/${E}`].map(s=>s.replace(/\*\*\/\*\*/g,"**"))}function b(E){return E.replace(/\\/g,"/")}function I(E){return b(E).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(E){return E.replace(/([?*[\]])/g,"[$1]")}function P(E,o){E=i.distinct(E,B=>B.toString());const s=[],M=o.getWorkspace();return E&&E.forEach(B=>{let X;if(o.getWorkbenchState()===2)X=(0,m.relativePath)(M.folders[0].uri,B),X&&X!=="."&&(X="./"+X);else{const G=o.getWorkspaceFolder(B);if(G){const W=G.name;if(M.folders.filter(q=>q.name===W).length===1){const q=(0,m.relativePath)(G.uri,B);q===""?X=`./${G.name}`:X=`./${G.name}/${q}`}else X=B.fsPath}}X&&s.push(f(X))}),s}e.resolveResourcesForSearchIncludes=P}),define(Re[262],Oe([1,0,25,2,22,10,3,261,47,53]),function(te,e,i,k,D,N,F,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function w(d,t){const u=t.activationEvents;if(!u)return Promise.resolve(void 0);const h=[],y=[];for(const a of u)if(/^workspaceContains:/.test(a)){const b=a.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||d.forceUsingSearch?y.push(b):h.push(b)}if(h.length===0&&y.length===0)return Promise.resolve(void 0);let C;const v=new Promise((a,b)=>{C=a}),n=a=>C({activationEvent:a}),l=Promise.all(h.map(a=>c(d,a,n))).then(()=>{}),r=p(d,t.identifier,y,n);return Promise.all([l,r]).then(()=>{C(void 0)}),v}e.checkActivateWorkspaceContainsExtension=w;async function c(d,t,u){for(const h of d.folders)if(await d.exists(i.joinPath(k.URI.revive(h),t))){u(`workspaceContains:${t}`);return}}async function p(d,t,u,h){if(u.length===0)return Promise.resolve(void 0);const y=new D.CancellationTokenSource,C=d.checkExists(d.folders,u,y.token),v=setTimeout(async()=>{y.cancel(),d.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},O);let n=!1;try{n=await C}catch(l){N.isCancellationError(l)||N.onUnexpectedError(l)}y.dispose(),clearTimeout(v),n&&h(`workspaceContains:${u.join(",")}`)}function g(d,t,u,h){const y=d.get(F.IInstantiationService),C=d.get(S.ISearchService),n=y.createInstance(R.QueryBuilder).file(t.map(l=>(0,m.toWorkspaceFolder)(k.URI.revive(l))),{_reason:"checkExists",includePattern:u,exists:!0});return C.fileSearch(n,h).then(l=>!!l.limitHit,l=>N.isCancellationError(l)?!1:Promise.reject(l))}e.checkGlobFileExists=g});var Ye=this&&this.__classPrivateFieldSet||function(te,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,i):D?D.value=i:e.set(te,i),i},Fe=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(Re[35],Oe([1,0,148,19,85,25,16,6,48,2,14,4,34,201,83,33,20,102,10,23,24,187,7,97,3,27,84,17,71,73,62,5,262,82,189,15,80,58,21,81]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t,u,h,y,C,v,n,l,r,a,b,I,f,P,E,o,s,M,B,X,G,W,U,q){"use strict";var z,V,ee;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let Ce=e.AbstractExtHostExtensionService=class Ln extends R.Disposable{constructor(A,K,he,De,we,ge,ke,ae,de,Z,ne,T){super(),this.R=T,this.a=this.B(new o.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=K,this.g=he,this.f=ke,this.j=De,this.k=we,this.l=ge,this.m=de,this.p=Z,this.s=ne,this.t=this.g.getProxy(w.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(w.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(w.MainContext.MainThreadExtensionService),this.w=new F.Barrier,this.y=new F.Barrier,this.z=new F.Barrier,this.C=new F.Barrier,this.D=new Pe(this.f.activationEvents),this.G=new u.ExtensionDescriptionRegistry(this.D,this.f.allExtensions);const H=new y.ExtensionIdentifierSet(this.f.myExtensions);this.F=new u.ExtensionDescriptionRegistry(this.D,ue(this.G,H)),this.H=new g.ExtHostStorage(this.g,this.l),this.I=new M.ExtHostSecretState(this.g),this.J=ae,this.h=A.createChild(new f.ServiceCollection([g.IExtHostStorage,this.H],[M.IExtHostSecretState,this.I])),this.L=this.B(new p.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:(j,x,ce)=>{this.v.$onExtensionActivationError(j,h.transformErrorForSerialization(x),ce)},actualActivateExtension:async(j,x)=>{if(u.ExtensionDescriptionRegistry.isHostExtension(j,this.F,this.G))return await this.v.$activateExtension(j,x),new p.HostExtension;const ce=this.F.getExtensionDescription(j);return this.ab(ce,x)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.qb(),this.w.open(),await this.j.waitForInitializeCall(),D.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.ob()}catch(A){h.onUnexpectedError(A)}}async S(){this.J.onWillDeactivateAll();let A=[];try{A=this.F.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.Z(we))}catch{}await Promise.all(A)}terminate(A,K=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${A}`),this.l.flush(),this.p.dispose(),this.L.dispose(),h.setUnexpectedErrorHandler(De=>{this.l.error(De)}),this.g.dispose();const he=this.S();Promise.race([(0,F.timeout)(5e3),he]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${K}`):this.l.info(`Extension host exiting with code ${K}`),this.l.flush(),this.l.dispose(),this.c.exit(K)})}isActivated(A){return this.z.isOpen()?this.L.isActivated(A):!1}async getExtension(A){const K=await this.v.$getExtension(A);return K&&{...K,identifier:new y.ExtensionIdentifier(K.identifier.value),extensionLocation:m.URI.revive(K.extensionLocation)}}U(A,K){return this.L.activateByEvent(A,K)}W(A,K){return this.L.activateById(A,K)}activateByIdWithErrors(A,K){return this.W(A,K).then(()=>{const he=this.L.getActivatedExtension(A);if(he.activationFailed)return Promise.reject(he.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(A=>this.F)}getExtensionExports(A){if(this.z.isOpen())return this.L.getActivatedExtension(A).exports;try{return this.L.getActivatedExtension(A).exports}catch{return null}}async X(A){if(A.scheme!==X.Schemas.file)return A;const K=await this.c.realpath(A.fsPath);return m.URI.file(K)}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(A=>new Ie(A))),this.M}async Y(A){const K=S.TernarySearchTree.forUris(he=>N.extUriBiasedIgnorePathCase.ignorePathCasing(he));return await Promise.all(A.map(async he=>{if(this.rb(he)){const De=await this.X(he.extensionLocation);K.set(De,he)}})),K}Z(A){let K=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(A))return K;const he=this.L.getActivatedExtension(A);if(!he)return K;try{typeof he.module.deactivate=="function"&&(K=Promise.resolve(he.module.deactivate()).then(void 0,De=>(this.l.error(De),Promise.resolve(void 0))))}catch(De){this.l.error(`An error occurred when deactivating the extension '${A.value}':`),this.l.error(De)}try{(0,R.dispose)(he.subscriptions)}catch(De){this.l.error(`An error occurred when deactivating the subscriptions for extension '${A.value}':`),this.l.error(De)}return K}async ab(A,K){return this.f.remote.isRemote?this.v.$onWillActivateExtension(A.identifier):await this.v.$onWillActivateExtension(A.identifier),this.cb(A,K).then(he=>{const De=he.activationTimes;return this.v.$onDidActivateExtension(A.identifier,De.codeLoadingTime,De.activateCallTime,De.activateResolvedTime,K),this.bb(A,K,"success",De),he},he=>{throw this.bb(A,K,"failure"),he})}bb(A,K,he,De){const we=le(A,K);this.u.$publicLog2("extensionActivationTimes",{...we,...De||{},outcome:he})}cb(A,K){const he=le(A,K);this.u.$publicLog2("activatePlugin",he);const De=this.rb(A);if(!De)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${A.identifier.value}, startup: ${K.startup}, activationEvent: '${K.activationEvent}'${A.identifier.value!==K.extensionId.value?`, root cause: ${K.extensionId.value}`:""}`),this.l.flush();const we=new p.ExtensionActivationTimesBuilder(K.startup);return Promise.all([this.sb(A,(0,N.joinPath)(A.extensionLocation,De),we),this.db(A)]).then(ge=>(D.mark(`code/extHost/willActivateExtension/${A.identifier.value}`),Ln.eb(this.l,A.identifier,ge[0],ge[1],we))).then(ge=>(D.mark(`code/extHost/didActivateExtension/${A.identifier.value}`),ge))}db(A){const K=new v.ExtensionGlobalMemento(A,this.H),he=new v.ExtensionMemento(A.identifier.value,!1,this.H),De=new B.ExtensionSecrets(A,this.I),we=A.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ge=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${A.identifier.value}`),Promise.all([K.whenReady,he.whenReady,this.J.whenReady]).then(()=>{const ke=this;let ae,de;const Z=(0,t.isProposedApiEnabled)(A,"ipc")?this.f.messagePorts?.get(y.ExtensionIdentifier.toKey(A.identifier)):void 0;return Object.freeze({globalState:K,workspaceState:he,secrets:De,subscriptions:[],get extensionUri(){return A.extensionLocation},get extensionPath(){return A.extensionLocation.fsPath},asAbsolutePath(ne){return k.join(A.extensionLocation.fsPath,ne)},get storagePath(){return ke.J.workspaceValue(A)?.fsPath},get globalStoragePath(){return ke.J.globalValue(A).fsPath},get logPath(){return k.join(ke.f.logsLocation.fsPath,A.identifier.value)},get logUri(){return m.URI.joinPath(ke.f.logsLocation,A.identifier.value)},get storageUri(){return ke.J.workspaceValue(A)},get globalStorageUri(){return ke.J.globalValue(A)},get extensionMode(){return we},get extension(){return ae===void 0&&(ae=new Q(ke,A.identifier,A,ge,!1)),ae},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(A,"extensionRuntime"),ke.extensionRuntime},get environmentVariableCollection(){return ke.p.getEnvironmentVariableCollection(A)},get messagePassingProtocol(){if(!de){if(!Z)return;const ne=o.Event.buffer(o.Event.fromDOMEventEmitter(Z,"message",T=>T.data));Z.start(),de={onDidReceiveMessage:ne,postMessage:Z.postMessage.bind(Z)}}return de}})})}static eb(A,K,he,De,we){return he=he||{activate:void 0,deactivate:void 0},this.fb(A,K,he,De,we).then(ge=>new p.ActivatedExtension(!1,null,we.build(),he,ge,De.subscriptions))}static fb(A,K,he,De,we){if(typeof he.activate=="function")try{we.activateCallStart(),A.trace(`ExtensionService#_callActivateOptional ${K.value}`);const ge=typeof global=="object"?global:self,ke=he.activate.apply(ge,[De]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(ke).then(ae=>(we.activateResolveStop(),ae))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(he)}gb(A,K){this.W(A.identifier,{startup:!1,extensionId:A.identifier,activationEvent:K}).then(void 0,he=>{this.l.error(he)})}hb(A,K=0){const De=Date.now();(0,U.setTimeout0)(()=>{for(let we=K;we<A.length;we+=1){const ge=A[we];for(const ke of ge.activationEvents??[])if(ke==="onStartupFinished")if(Date.now()-De>50){this.hb(A,we);break}else this.gb(ge,ke)}})}ib(){this.v.$setPerformanceMarks(D.getMarks()),this.k.getConfigProvider().then(A=>{const K=A.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),he=this.F.getAllExtensionDescriptions();if(K)this.hb(he);else for(const De of he)if(De.activationEvents)for(const we of De.activationEvents)we==="onStartupFinished"&&this.gb(De,we)})}jb(){const A=this.U("*",!0).then(void 0,ge=>{this.l.error(ge)});this.B(this.j.onDidChangeWorkspace(ge=>this.kb(ge.added)));const K=this.j.workspace?this.j.workspace.folders:[],he=this.kb(K),De=this.mb(),we=Promise.all([De,A,he]).then(()=>{});return Promise.race([we,(0,F.timeout)(1e4)]).then(()=>{this.ib()}),we}kb(A){return A.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(K=>this.lb(A,K))).then(()=>{})}async lb(A,K){if(this.isActivated(K.identifier))return;const he=!this.f.remote.isRemote&&!!this.f.remote.authority,De={logService:this.l,folders:A.map(ge=>ge.uri),forceUsingSearch:he,exists:ge=>this.c.exists(ge.fsPath),checkExists:(ge,ke,ae)=>this.t.$checkExists(ge,ke,ae)},we=await(0,s.checkActivateWorkspaceContainsExtension)(De,K);if(we)return this.W(K.identifier,{startup:!0,extensionId:K.identifier,activationEvent:we.activationEvent}).then(void 0,ge=>this.l.error(ge))}async mb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.nb()}catch(A){throw console.error(A),A}}async nb(){const{extensionDevelopmentLocationURI:A,extensionTestsLocationURI:K}=this.f.environment;if(!A||!K)throw new Error(i.localize(0,null));const he=await this.sb(null,K,new p.ExtensionActivationTimesBuilder(!1));if(!he||typeof he.run!="function")throw new Error(i.localize(1,null,K.toString()));return new Promise((De,we)=>{const ge=(de,Z)=>{de?we(de):De(typeof Z=="number"&&Z>0?1:0)},ke=(0,N.originalFSPath)(K),ae=he.run(ke,ge);ae&&ae.then&&ae.then(()=>{De(0)}).catch(de=>{we(de instanceof Error&&de.stack?de.stack:String(de))})})}ob(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,F.timeout)(1e3)])).then(()=>this.jb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(A,K){return this.N[A]=K,(0,R.toDisposable)(()=>{delete this.N[A]})}async pb(A){const K=A.indexOf("+");if(K===-1)throw new Error("Not an authority that can be resolved!");const he=A.substr(0,K);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${he}`,!1),{authorityPrefix:he,resolver:this.N[he]}}async $resolveAuthority(A,K){const he=W.StopWatch.create(!1),De=()=>`[resolveAuthority(${(0,l.getRemoteAuthorityPrefix)(A)},${K})][${he.elapsed()}ms] `,we=Z=>this.l.info(`${De()}${Z}`),ge=(Z,ne=void 0)=>this.l.error(`${De()}${Z}`,ne);we("activating resolver...");const{authorityPrefix:ke,resolver:ae}=await this.pb(A);if(!ae)return ge("no resolver"),{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ke}.`,detail:void 0}};const de=new F.IntervalTimer;try{we("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(ae)),de.cancelAndSet(()=>we("waiting..."),1e3),we("invoking resolve()..."),D.mark(`code/extHost/willResolveAuthority/${ke}`);const Z=await ae.resolve(A,{resolveAttempt:K});D.mark(`code/extHost/didResolveAuthorityOK/${ke}`),de.dispose();const ne={environmentTunnels:Z.environmentTunnels,features:Z.tunnelFeatures},T={extensionHostEnv:Z.extensionHostEnv,isTrusted:Z.isTrusted,authenticationSession:Z.authenticationSessionForInitializingExtensions?{id:Z.authenticationSessionForInitializingExtensions.id,providerId:Z.authenticationSessionForInitializingExtensions.providerId}:void 0};we(`returned ${n.ManagedResolvedAuthority.isManagedResolvedAuthority(Z)?"managed authority":`${Z.host}:${Z.port}`}`);let H;if(n.ManagedResolvedAuthority.isManagedResolvedAuthority(Z)){const j=K;this.R.setFactory(j,Z.makeConnection),H={authority:A,connectTo:new l.ManagedRemoteConnection(j),connectionToken:Z.connectionToken}}else H={authority:A,connectTo:new l.WebSocketRemoteConnection(Z.host,Z.port),connectionToken:Z.connectionToken};return{type:"ok",value:{authority:H,options:T,tunnelInformation:ne}}}catch(Z){if(D.mark(`code/extHost/didResolveAuthorityError/${ke}`),de.dispose(),ge("returned an error",Z),Z instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:Z._code,message:Z._message,detail:Z._detail}};throw Z}}async $getCanonicalURI(A,K){this.l.info(`$getCanonicalURI invoked for authority (${(0,l.getRemoteAuthorityPrefix)(A)})`);const{resolver:he}=await this.pb(A);if(!he)return null;const De=m.URI.revive(K);if(typeof he.getCanonicalURI>"u")return De;const we=await(0,F.asPromise)(()=>he.getCanonicalURI(De));return we||De}$startExtensionHost(A){A.toAdd.forEach(De=>De.extensionLocation=m.URI.revive(De.extensionLocation));const{globalRegistry:K,myExtensions:he}=oe(this.D,this.G,this.F,A);return this.G.set(K.getAllExtensionDescriptions()),this.F.set(he),this.ob()}$activateByEvent(A,K){return K===1?this.U(A,!1):this.z.wait().then(he=>this.U(A,!1))}async $activate(A,K){return await this.z.wait(),this.F.getExtensionDescription(A)?(await this.W(A,K),!0):!1}async $deltaExtensions(A){A.toAdd.forEach(ge=>ge.extensionLocation=m.URI.revive(ge.extensionLocation));const{globalRegistry:K,myExtensions:he}=oe(this.D,this.G,this.F,A),De=await this.Y(he);return(await this.getExtensionPathIndex()).setSearchTree(De),this.G.set(K.getAllExtensionDescriptions()),this.F.set(he),Promise.resolve(void 0)}async $test_latency(A){return A}async $test_up(A){return A.byteLength}async $test_down(A){const K=C.VSBuffer.alloc(A),he=Math.random()%256;for(let De=0;De<A;De++)K.writeUInt8(he,De);return K}async $updateRemoteConnectionData(A){this.Q=A,this.a.fire()}};e.AbstractExtHostExtensionService=Ce=xe([Ve(0,r.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,I.IExtHostRpcService),Ve(3,d.IExtHostWorkspace),Ve(4,c.IExtHostConfiguration),Ve(5,O.ILogService),Ve(6,a.IExtHostInitDataService),Ve(7,b.IExtensionStoragePaths),Ve(8,P.IExtHostTunnelService),Ve(9,E.IExtHostTerminalService),Ve(10,G.IExtHostLocalizationService),Ve(11,q.IExtHostManagedSockets)],Ce);function oe(be,A,K,he){be.addActivationEvents(he.addActivationEvents);const De=new u.ExtensionDescriptionRegistry(be,A.getAllExtensionDescriptions());De.deltaExtensions(he.toAdd,he.toRemove);const we=new y.ExtensionIdentifierSet(K.getAllExtensionDescriptions().map(ke=>ke.identifier));for(const ke of he.myToRemove)we.delete(ke);for(const ke of he.myToAdd)we.add(ke);const ge=ue(De,we);return{globalRegistry:De,myExtensions:ge}}function le(be,A){return{id:be.identifier.value,name:be.name,extensionVersion:be.version,publisherDisplayName:be.publisher,activationEvents:be.activationEvents?be.activationEvents.join(","):null,isBuiltin:be.isBuiltin,reason:A.activationEvent,reasonId:A.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class Q{constructor(A,K,he,De,we){z.set(this,void 0),V.set(this,void 0),ee.set(this,void 0),Ye(this,z,A,"f"),Ye(this,V,K,"f"),Ye(this,ee,he.identifier,"f"),this.id=he.identifier.value,this.extensionUri=he.extensionLocation,this.extensionPath=k.normalize((0,N.originalFSPath)(he.extensionLocation)),this.packageJSON=he,this.extensionKind=De,this.isFromDifferentExtensionHost=we}get isActive(){return Fe(this,z,"f").isActivated(Fe(this,ee,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Fe(this,z,"f").getExtensionExports(Fe(this,ee,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Fe(this,z,"f").activateByIdWithErrors(Fe(this,ee,"f"),{startup:!1,extensionId:Fe(this,V,"f"),activationEvent:"api"}),this.exports}}e.Extension=Q,z=new WeakMap,V=new WeakMap,ee=new WeakMap;function ue(be,A){return be.getAllExtensionDescriptions().filter(K=>A.has(K.identifier))}class Ie{constructor(A){this.a=A}setSearchTree(A){this.a=A}findSubstr(A){return this.a.findSubstr(A)}forEach(A){return this.a.forEach(A)}}e.ExtensionPaths=Ie;class Pe{constructor(A){this.a=new y.ExtensionIdentifierMap,this.addActivationEvents(A)}readActivationEvents(A){return this.a.get(A.identifier)}addActivationEvents(A){for(const K of Object.keys(A))this.a.set(K,A[K])}}}),define(Re[263],Oe([1,0,85,2,4,34,20,23,17,27,3,35,51,14,13]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=e.RequireInterceptor=class{constructor(v,n,l,r,a,b,I){this.c=v,this.d=n,this.e=l,this.f=r,this.g=a,this.h=b,this.i=I,this.a=new Map,this.b=[]}async install(){this.j(),i.mark("code/extHost/willWaitForConfig");const v=await this.f.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const n=await this.g.getExtensionPathIndex();this.register(new u(this.c,n,this.d,v,this.i)),this.register(this.e.createInstance(h,n)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(y,n,this.h.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const n of v.nodeModuleName)this.a.set(n,v);else this.a.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this.b.push(n=>v.alternativeModuleName(n))}};e.RequireInterceptor=d=xe([Ve(2,O.IInstantiationService),Ve(3,N.IExtHostConfiguration),Ve(4,w.IExtHostExtensionService),Ve(5,m.IExtHostInitDataService),Ve(6,p.ILogService)],d);let t=class fn{constructor(v){if(v.environment.appRoot&&fn.a.size){const n=(0,g.escapeRegExpCharacters)(this.c(v.environment.appRoot.fsPath)),l="[a-z0-9_.-]",r=`@${l}+\\/${l}+|${l}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${n}/${a}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(v){if(!this.b)return;const n=this.b.exec(this.c(v));if(!n)return;const[,l,r,a]=n,b=fn.a.get(r);if(b!==void 0)return console.warn(`${r} as been renamed to ${b}, please update your imports`),l+b+a}c(v){return v.replace(/\\/g,"/")}};t.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=xe([Ve(0,m.IExtHostInitDataService)],t);class u{constructor(v,n,l,r,a){this.c=v,this.d=n,this.e=l,this.f=r,this.g=a,this.nodeModuleName="vscode",this.a=new R.ExtensionIdentifierMap}load(v,n){const l=this.d.findSubstr(n);if(l){let r=this.a.get(l.identifier);return r||(r=this.c(l,this.e,this.f),this.a.set(l.identifier,r)),r}if(!this.b){let r="";this.d.forEach((a,b)=>r+=`	${b} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${r}`),this.b=this.c(F.nullExtensionDescription,this.e,this.f)}return this.b}}let h=class{constructor(v,n,l){this.d=v,this.nodeModuleName="keytar",this.a=n.getProxy(D.MainContext.MainThreadTelemetry);const{environment:r}=l,a=n.getProxy(D.MainContext.MainThreadKeytar);if(r.appRoot){let b=r.appRoot.fsPath;c.platform==="win32"&&(b=b.replace(/\\/g,"/")),b[b.length-1]==="/"&&(b=b.substr(0,b.length-1)),this.b=new Set,this.b.add(`${b}/node_modules.asar/keytar`),this.b.add(`${b}/node_modules/keytar`)}this.c={getPassword:(b,I)=>a.$getPassword(b,I),setPassword:(b,I,f)=>a.$setPassword(b,I,f),deletePassword:(b,I)=>a.$deletePassword(b,I),findPassword:b=>a.$findPassword(b),findCredentials(b){return a.$findCredentials(b)}}}load(v,n){const l=this.d.findSubstr(n);return this.a.$publicLog2("shimming.keytar",{extension:l?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(v){const n=v.length;if(n<=7||!this.b)return;const l=n-7;if((v.charAt(l)==="/"||v.charAt(l)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.b.has(v)))return"keytar"}};h=xe([Ve(1,S.IExtHostRpcService),Ve(2,m.IExtHostInitDataService)],h);let y=class{constructor(v,n,l){this.e=v,this.f=n,this.nodeModuleName=["open","opn"],this.d=l.getProxy(D.MainContext.MainThreadTelemetry);const r=l.getProxy(D.MainContext.MainThreadWindow);this.c=(a,b)=>{const I=k.URI.parse(a);return b?this.g(a,b):I.scheme==="http"||I.scheme==="https"?r.$openUri(I,a,{allowTunneling:!0}):I.scheme==="mailto"||I.scheme===this.f?r.$openUri(I,a,{}):this.g(a,b)}}load(v,n,l){const r=this.e.findSubstr(n);return r&&(this.a=r.identifier.value,this.h()),this.b=l(v),this.c}g(v,n){return this.i(),this.b(v,n)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};y=xe([Ve(2,S.IExtHostRpcService)],y)}),define(Re[112],Oe([1,0,66,6,19,51,3,59,60,35,7,33,198,34]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,F.createDecorator)("IExtHostVariableResolverProvider");class g extends c.AbstractVariableResolverService{constructor(u,h,y,C,v,n,l){function r(){if(y){const a=y.activeEditor();if(a)return a.document.uri;const b=C.tabGroups.all.find(I=>I.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof O.TextDiffTabInput||b.input instanceof O.NotebookDiffEditorTabInput)return b.input.modified;if(b.input instanceof O.TextTabInput||b.input instanceof O.NotebookEditorTabInput||b.input instanceof O.CustomEditorTabInput)return b.input.uri}}}super({getFolderUri:a=>{const b=n.folders.filter(I=>I.name===a);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(a,b)=>v.getConfiguration(void 0,a).get(b),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=r();if(a)return D.normalize(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const a=r();if(a){const b=h.getWorkspaceFolder(a);if(b)return D.normalize(b.uri.fsPath)}}},getSelectedText:()=>{if(y){const a=y.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(y){const a=y.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>u.getExtension(a)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(N.env))}}let d=e.ExtHostVariableResolverProviderService=class extends k.Disposable{constructor(u,h,y,C,v){super(),this.b=u,this.c=h,this.g=y,this.h=C,this.i=v,this.a=new i.Lazy(async()=>{const n=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async a=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new g(this.b,this.c,this.g,this.i,n,r,this.j())})}getResolver(){return this.a.value}j(){}};e.ExtHostVariableResolverProviderService=d=xe([Ve(0,m.IExtHostExtensionService),Ve(1,w.IExtHostWorkspace),Ve(2,R.IExtHostDocumentsAndEditors),Ve(3,p.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs)],d)}),define(Re[113],Oe([1,0,16,5,9,2,3,4,60,35,17,7,33,192,194,34,112]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,F.createDecorator)("IExtHostDebugService");let u=e.ExtHostDebugServiceBase=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,a,b,I,f,P){this.F=a,this.G=b,this.H=I,this.I=f,this.J=P,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new k.Emitter,this.n=new k.Emitter,this.o=new k.Emitter,this.u=new k.Emitter,this.k=r.getProxy(R.MainContext.MainThreadDebugService),this.z=new k.Emitter({onWillAddFirstListener:()=>{this.V()}}),this.B=new k.Emitter,this.v=new y(this.k),this.w=new Map,this.y=!1,this.G.getExtensionRegistry().then(E=>{E.onDidChange(o=>{this.K(E)}),this.K(E)})}asDebugSourceUri(r,a){const b=r;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let I=`debug:${encodeURIComponent(b.path||"")}`,f="?";return a&&(I+=`${f}session=${encodeURIComponent(a.id)}`,f="&"),I+=`${f}ref=${b.sourceReference}`,N.URI.parse(I)}else{if(b.path)return N.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}K(r){const a=[];for(const b of r.getAllExtensionDescriptions())if(b.contributes){const I=b.contributes.debuggers;if(I&&I.length>0)for(const f of I)(0,g.isDebuggerMainContribution)(f)&&a.push(f.type)}this.k.$registerDebugTypes(a)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.V();const r=[];return this.w.forEach(a=>r.push(a)),r}addBreakpoints(r){this.V();const a=r.filter(f=>{const P=f.id;return this.w.has(P)?!1:(this.w.set(P,f),!0)});this.W(a,[],[]);const b=[],I=new Map;for(const f of a)if(f instanceof w.SourceBreakpoint){let P=I.get(f.location.uri.toString());P||(P={type:"sourceMulti",uri:f.location.uri,lines:[]},I.set(f.location.uri.toString(),P),b.push(P)),P.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof w.FunctionBreakpoint&&b.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(b)}removeBreakpoints(r){this.V();const a=r.filter(P=>this.w.delete(P.id));this.W([],a,[]);const b=a.filter(P=>P instanceof w.SourceBreakpoint).map(P=>P.id),I=a.filter(P=>P instanceof w.FunctionBreakpoint).map(P=>P.id),f=a.filter(P=>P instanceof w.DataBreakpoint).map(P=>P.id);return this.k.$unregisterBreakpoints(b,I,f)}startDebugging(r,a,b){return this.k.$startDebugging(r?r.uri:void 0,a,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,a,b){if(!a)return new w.Disposable(()=>{});const I=this.d++;return this.f.push({type:r,handle:I,provider:a}),this.k.$registerDebugConfigurationProvider(r,b,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,I),new w.Disposable(()=>{this.f=this.f.filter(f=>f.provider!==a),this.k.$unregisterDebugConfigurationProvider(I)})}registerDebugAdapterDescriptorFactory(r,a,b){if(!b)return new w.Disposable(()=>{});if(!this.R(r,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.O(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const I=this.g++;return this.h.push({type:a,handle:I,factory:b}),this.k.$registerDebugAdapterDescriptorFactory(a,I),new w.Disposable(()=>{this.h=this.h.filter(f=>f.factory!==b),this.k.$unregisterDebugAdapterDescriptorFactory(I)})}registerDebugAdapterTrackerFactory(r,a){if(!a)return new w.Disposable(()=>{});const b=this.i++;return this.j.push({type:r,handle:b,factory:a}),new w.Disposable(()=>{this.j=this.j.filter(I=>I.factory!==a)})}async $runInTerminal(r,a){return Promise.resolve(void 0)}async $substituteVariables(r,a){let b;const I=await this.Y(r);return I&&(b={uri:I.uri,name:I.name,index:I.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.J.getResolver()).resolveAnyAsync(b,a)}L(r,a){if(r.type==="implementation")return new v(r.implementation)}M(){}async $startDASession(r,a){const b=this,I=await this.X(a);return this.T(this.O(I.type),I).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}' (extension might have failed to activate)`);const P=this.N(f),E=this.L(P,I);if(!E)throw new Error(`Couldn't create a debug adapter for type '${I.type}'.`);const o=E;return this.C.set(r,o),this.S(I).then(s=>(s&&this.D.set(r,s),o.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const B=M,X={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this.E||(this.E=this.M());try{if(this.E){const G=await this.E.sign(B.arguments.value);X.body={signature:G},o.sendResponse(X)}else throw new Error("no signer")}catch(G){X.success=!1,X.message=G.message,o.sendResponse(X)}}else s&&s.onDidSendMessage&&s.onDidSendMessage(M),M=(0,g.convertToVSCPaths)(M,!0),b.k.$acceptDAMessage(r,M)}),o.onError(M=>{s&&s.onError&&s.onError(M),this.k.$acceptDAError(r,M.name,M.message,M.stack)}),o.onExit(M=>{s&&s.onExit&&s.onExit((0,D.withNullAsUndefined)(M),void 0),this.k.$acceptDAExit(r,(0,D.withNullAsUndefined)(M),void 0)}),s&&s.onWillStartSession&&s.onWillStartSession(),o.startSession()))})}$sendDAMessage(r,a){a=(0,g.convertToDAPaths)(a,!1);const b=this.D.get(r);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(a),this.C.get(r)?.sendMessage(a)}$stopDASession(r){const a=this.D.get(r);this.D.delete(r),a&&a.onWillStopSession&&a.onWillStopSession();const b=this.C.get(r);return this.C.delete(r),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const a=[],b=[],I=[];if(r.added)for(const f of r.added){const P=f.id;if(P&&!this.w.has(P)){let E;if(f.type==="function")E=new w.FunctionBreakpoint(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")E=new w.DataBreakpoint(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const o=N.URI.revive(f.uri);E=new w.SourceBreakpoint(new w.Location(o,new w.Position(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,w.setBreakpointId)(E,P),this.w.set(P,E),a.push(E)}}if(r.removed)for(const f of r.removed){const P=this.w.get(f);P&&(this.w.delete(f),b.push(P))}if(r.changed){for(const f of r.changed)if(f.id){const P=this.w.get(f.id);if(P){if(P instanceof w.FunctionBreakpoint&&f.type==="function"){const E=P;E.enabled=f.enabled,E.condition=f.condition,E.hitCondition=f.hitCondition,E.logMessage=f.logMessage,E.functionName=f.functionName}else if(P instanceof w.SourceBreakpoint&&f.type==="source"){const E=P;E.enabled=f.enabled,E.condition=f.condition,E.hitCondition=f.hitCondition,E.logMessage=f.logMessage,E.location=new w.Location(N.URI.revive(f.uri),new w.Position(f.line,f.character))}I.push(P)}}}this.W(a,b,I)}async $acceptStackFrameFocus(r){let a;const b=r.sessionId?await this.X(r.sessionId):void 0;if(!b)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?a=new w.ThreadFocus(b,r.threadId):a=new w.StackFrameFocus(b,r.threadId,r.frameId),this.A=a,this.B.fire(this.A)}$provideDebugConfigurations(r,a,b){return(0,i.asPromise)(async()=>{const I=this.Q(r);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.Y(a);return I.provideDebugConfigurations(f,b)}).then(I=>{if(!I)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return I})}$resolveDebugConfiguration(r,a,b,I){return(0,i.asPromise)(async()=>{const f=this.Q(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.Y(a);return f.resolveDebugConfiguration(P,b,I)})}$resolveDebugConfigurationWithSubstitutedVariables(r,a,b,I){return(0,i.asPromise)(async()=>{const f=this.Q(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.Y(a);return f.resolveDebugConfigurationWithSubstitutedVariables(P,b,I)})}async $provideDebugAdapter(r,a){const b=this.P(r);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const I=await this.X(a);return this.T(b,I).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}'`);return this.N(f)})}async $acceptDebugSessionStarted(r){const a=await this.X(r);this.m.fire(a)}async $acceptDebugSessionTerminated(r){const a=await this.X(r);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.X(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,a){(await this.X(r))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(r,a){const I={session:await this.X(r),event:a.event,body:a.body};this.u.fire(I)}N(r){if(r instanceof w.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof w.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}O(r){const a=this.h.filter(b=>b.type===r);if(a.length>0)return a[0].factory}P(r){const a=this.h.filter(b=>b.handle===r);if(a.length>0)return a[0].factory}Q(r){const a=this.f.filter(b=>b.handle===r);if(a.length>0)return a[0].provider}R(r,a){if(r.contributes){const b=r.contributes.debuggers;if(b&&b.length>0){for(const I of b)if(I.label&&I.type&&I.type===a)return!0}}return!1}S(r){const b=r.configuration.type,I=this.j.filter(f=>f.type===b||f.type==="*").map(f=>(0,i.asPromise)(()=>f.factory.createDebugAdapterTracker(r)).then(P=>P,P=>null));return Promise.race([Promise.all(I).then(f=>{const P=f.filter(E=>!!E);if(P.length>0)return new C(P)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async T(r,a){const b=a.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new w.DebugAdapterServer(b));if(r){const f=await this.G.getExtensionRegistry();return(0,i.asPromise)(()=>r.createDebugAdapterDescriptor(a,this.U(a,f))).then(P=>{if(P)return P})}const I=await this.G.getExtensionRegistry();return Promise.resolve(this.U(a,I))}U(r,a){}V(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}W(r,a,b){(r.length>0||a.length>0||b.length>0)&&this.z.fire(Object.freeze({added:r,removed:a,changed:b}))}async X(r){if(r)if(typeof r=="string"){const a=this.l.get(r);if(a)return a}else{let a=this.l.get(r.id);if(!a){const b=await this.Y(r.folderUri),I=r.parent?this.l.get(r.parent):void 0;a=new h(this.k,r.id,r.type,r.name,b,r.configuration,I),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}Y(r){if(r){const a=N.URI.revive(r);return this.F.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=u=xe([Ve(0,O.IExtHostRpcService),Ve(1,c.IExtHostWorkspace),Ve(2,m.IExtHostExtensionService),Ve(3,d.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,t.IExtHostVariableResolverProvider)],u);class h{constructor(r,a,b,I,f,P,E){this.d=r,this.f=a,this.g=b,this.h=I,this.i=f,this.j=P,this.k=E}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,a){return this.d.$customDebugAdapterRequest(this.f,r,a)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=h;class y{constructor(r){this.value=Object.freeze({append(a){r.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.ExtHostDebugConsole=y;class C{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(a=>a.onError?a.onError(r):void 0)}onExit(r,a){this.d.forEach(b=>b.onExit?b.onExit(r,a):void 0)}}class v extends p.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let n=e.WorkerExtHostDebugService=class extends u{constructor(r,a,b,I,f,P){super(r,a,b,I,f,P)}};e.WorkerExtHostDebugService=n=xe([Ve(0,O.IExtHostRpcService),Ve(1,c.IExtHostWorkspace),Ve(2,m.IExtHostExtensionService),Ve(3,d.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,t.IExtHostVariableResolverProvider)],n)}),define(Re[264],Oe([1,0,10,85,2,4,255,14,70,71,27,170,17,55,35,57]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class t{static async installEarlyHandler(y){const C=y.get(R.ILogService),n=y.get(c.IExtHostRpcService).getProxy(N.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(l=>{C.error(l);const r=i.transformErrorForSerialization(l);n.$onUnexpectedError(r)})}static async installFullHandler(y){const C=y.get(R.ILogService),v=y.get(c.IExtHostRpcService),n=y.get(g.IExtHostExtensionService),l=y.get(d.IExtHostTelemetry),r=v.getProxy(N.MainContext.MainThreadExtensionService),a=v.getProxy(N.MainContext.MainThreadErrors),b=await n.getExtensionPathIndex(),I=new WeakMap;function f(E,o){let s="",M,B;for(const X of o)s+=`
	at ${X.toString()}`,B=X.getFileName(),!M&&B&&(M=b.findSubstr(D.URI.file(B)));return I.set(E,M?.identifier),`${E.name||"Error"}: ${E.message||""}${s}`}let P=f;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return P},set(E){P=function(o,s){return f(o,s),E.call(Error,o,s)}}}),i.setUnexpectedErrorHandler(E=>{C.error(E);const o=i.transformErrorForSerialization(E),s=I.get(E);if(!s){a.$onUnexpectedError(o);return}r.$onExtensionRuntimeError(s,o);const M=l.onExtensionError(s,E);C.trace("forwarded error to extension?",M,s)})}}Error.stackTraceLimit=100;class u{constructor(y,C,v,n,l){this.a=v,this.b=new F.RPCProtocol(y,null,n),C=u.e(C,this.b);const r=new m.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());r.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...C,messagePorts:l}),r.set(c.IExtHostRpcService,new c.ExtHostRpcService(this.b)),r.set(p.IURITransformerService,new p.URITransformerService(n)),r.set(g.IHostUtils,v);const a=new w.InstantiationService(r,!0);a.invokeFunction(t.installEarlyHandler),this.d=a.invokeFunction(b=>b.get(R.ILogService)),k.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",C),this.c=a.invokeFunction(b=>b.get(g.IExtHostExtensionService)),this.c.initialize(),a.invokeFunction(t.installFullHandler)}async asBrowserUri(y){const C=this.b.getProxy(N.MainContext.MainThreadExtensionService);return D.URI.revive(await C.$asBrowserUri(y))}terminate(y){this.c.terminate(y)}static e(y,C){y.allExtensions.forEach(n=>{n.extensionLocation=D.URI.revive(C.transformIncomingURIs(n.extensionLocation))}),y.environment.appRoot=D.URI.revive(C.transformIncomingURIs(y.environment.appRoot));const v=y.environment.extensionDevelopmentLocationURI;return v&&(y.environment.extensionDevelopmentLocationURI=v.map(n=>D.URI.revive(C.transformIncomingURIs(n)))),y.environment.extensionTestsLocationURI=D.URI.revive(C.transformIncomingURIs(y.environment.extensionTestsLocationURI)),y.environment.globalStorageHome=D.URI.revive(C.transformIncomingURIs(y.environment.globalStorageHome)),y.environment.workspaceStorageHome=D.URI.revive(C.transformIncomingURIs(y.environment.workspaceStorageHome)),y.environment.extensionTelemetryLogResource=D.URI.revive(C.transformIncomingURIs(y.environment.extensionTelemetryLogResource)),y.nlsBaseUrl=D.URI.revive(C.transformIncomingURIs(y.nlsBaseUrl)),y.logsLocation=D.URI.revive(C.transformIncomingURIs(y.logsLocation)),y.workspace=C.transformIncomingURIs(y.workspace),y}}e.ExtensionHostMain=u}),define(Re[265],Oe([1,0,18,16,22,40,15,19,25,2,47]),function(te,e,i,k,D,N,F,R,S,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(h,y,C,v){this.d=h,this.e=y,this.f=C,this.g=v,this.a=null,this.b=!1,this.c=0}search(h,y){const C=this.d.folderQueries||[],v=new D.CancellationTokenSource;return y.onCancellationRequested(()=>v.cancel()),new Promise((n,l)=>{this.a=new p(h);let r=!1;const a=(b,I)=>{if(!r&&!this.b){const f=this.h(b);d(b)&&typeof this.d.maxResults=="number"&&this.c+f>this.d.maxResults&&(this.b=!0,r=!0,v.cancel(),b=this.j(b,this.d.maxResults-this.c));const P=this.h(b);this.c+=P,(P>0||!d(b))&&this.a.add(b,I)}};Promise.all(C.map((b,I)=>this.k(b,f=>a(f,I),v.token))).then(b=>{v.dispose(),this.a.flush();const I=b.some(f=>!!f&&!!f.limitHit);n({limitHit:this.b||I,messages:(0,i.flatten)(b.map(f=>f?.message?Array.isArray(f.message)?f.message:[f.message]:[])),stats:{type:this.g}})},b=>{v.dispose();const I=(0,N.toErrorMessage)(b);l(new Error(I))})})}h(h){return d(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,y){const C=Array.isArray(h.ranges)?h.ranges:[h.ranges],v=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:C.slice(0,y),preview:{matches:v.slice(0,y),text:h.preview.text},uri:h.uri}}async k(h,y,C){const v=new O.QueryGlobTester(this.d,h),n=[],l={report:b=>{if(!this.l(b))return;const I=h.folder.scheme===F.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(b.uri))):void 0,f=S.relativePath(h.folder,b.uri);if(f){const P=v.includedInQuery(f,R.basename(f),I);(0,k.isThenable)(P)?n.push(P.then(E=>{E&&y(b)})):P&&y(b)}}},r=this.n(h),a=await this.e.provideTextSearchResults(c(this.d.contentPattern),r,l,C);return n.length&&await Promise.all(n),a}l(h){if(d(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const y=(0,O.resolvePatternsForProvider)(this.d.includePattern,h.includePattern),C=(0,O.resolvePatternsForProvider)(this.d.excludePattern,h.excludePattern),v={folder:m.URI.from(h.folder),excludes:C,includes:y,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.f.toCanonicalName(h.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.TextSearchManager=w;function c(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class p{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new t(512,y=>this.g(y))}add(h,y){this.d&&(this.b!==y||!S.isEqual(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=y,this.d={resource:h.uri,results:[]}),this.d.results.push(g(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.TextSearchResultsCollector=p;function g(u){return d(u)?{preview:{matches:(0,i.mapArrayOrNot)(u.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:u.preview.text},ranges:(0,i.mapArrayOrNot)(u.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function d(u){return!!u.preview}e.extensionResultIsMatch=d;class t{constructor(h,y){this.g=h,this.h=y,this.c=0,this.d=[],this.e=0}addItem(h,y){h&&this.j(h,y)}addItems(h,y){h&&this.k(h,y)}j(h,y){this.d.push(h),this.e+=y,this.l()}k(h,y){this.d=this.d.concat(h),this.e+=y,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=t,t.a=4e3,t.b=50}),define(Re[114],Oe([1,0,6,4,3,260,17,55,14,2,265]),function(te,e,i,k,D,N,F,R,S,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let w=e.ExtHostSearch=class{constructor(d,t,u){this.k=d,this.l=t,this.n=u,this.c=this.k.getProxy(k.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new N.FileSearchManager}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,t){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const u=this.d++;return this.e.set(u,t),this.c.$registerTextSearchProvider(u,this.o(d)),(0,i.toDisposable)(()=>{this.g.delete(d),this.e.delete(u),this.c.$unregisterProvider(u)})}registerFileSearchProvider(d,t){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const u=this.d++;return this.h.set(u,t),this.c.$registerFileSearchProvider(u,this.o(d)),(0,i.toDisposable)(()=>{this.i.delete(d),this.h.delete(u),this.c.$unregisterProvider(u)})}$provideFileSearchResults(d,t,u,h){const y=c(u),C=this.h.get(d);if(C)return this.j.fileSearch(y,C,v=>{this.c.$handleFileMatch(d,t,v.map(n=>n.resource))},h);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,t,u,h){const y=this.e.get(d);if(!y||!y.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const C=c(u);return this.q(C,y).search(n=>this.c.$handleTextMatch(d,t,n),h)}$enableExtensionHostSearch(){}q(d,t){return new O.TextSearchManager(d,t,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};e.ExtHostSearch=w=xe([Ve(0,F.IExtHostRpcService),Ve(1,R.IURITransformerService),Ve(2,S.ILogService)],w);function c(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(p),extraFileResources:g.extraFileResources&&g.extraFileResources.map(d=>m.URI.revive(d))}}e.reviveQuery=c;function p(g){return{...g,folder:m.URI.revive(g.folder)}}}),define(Re[266],Oe([1,0,22,10,5,29,2,135,276,122,133,43,4,77,219,218,32,220,34,222,223,224,204,225,59,35,226,227,232,233,235,109,208,241,242,245,83,62,247,209,8,7,52,250,63,108,33,23,196,231,50,107,111,113,114,14,55,17,27,236,202,73,79,215,248,84,61,253,251,252,216,38,246,249,82,60,57,237,110,238,15,95,207,188,228,6,20,193,80,184,239,240,217,229,206,243,230,81,244]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t,u,h,y,C,v,n,l,r,a,b,I,f,P,E,o,s,M,B,X,G,W,U,q,z,V,ee,Ce,oe,le,Q,ue,Ie,Pe,be,A,K,he,De,we,ge,ke,ae,de,Z,ne,T,H,j,x,ce,pe,ie,ye,Se,Be,je,Ze,Qe,Ke,it,st,tt,Ne,dt,J,_,fe,$e,qe,We,_e,mt,St,kt,Gt,Bt,yt,Wt,Mt,qt,Ot,Lt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ht(at){const ht=at.get(ae.IExtHostInitDataService),Nt=at.get(Be.IExtHostFileSystemInfo),Ut=at.get(ce.IExtHostConsumerFileSystem),Et=at.get(a.IExtHostExtensionService),lt=at.get(Q.IExtHostWorkspace),Ct=at.get(it.IExtHostTelemetry),$t=at.get(h.IExtHostConfiguration),Ae=at.get(ge.IURITransformerService),Ee=at.get(ke.IExtHostRpcService),ve=at.get(G.IExtHostStorage),Y=at.get(x.IExtensionStoragePaths),Me=at.get(we.ILoggerService),ze=at.get(we.ILogService),Xe=at.get(ne.IExtHostTunnelService),He=at.get(T.IExtHostApiDeprecationService),et=at.get(le.IExtHostWindow),wt=at.get(Qe.IExtHostSecretState),At=at.get(Ke.IExtHostEditorTabs),Tt=at.get(Ot.IExtHostManagedSockets);Ee.set(c.ExtHostContext.ExtHostFileSystemInfo,Nt),Ee.set(c.ExtHostContext.ExtHostLogLevelServiceShape,Me),Ee.set(c.ExtHostContext.ExtHostWorkspace,lt),Ee.set(c.ExtHostContext.ExtHostConfiguration,$t),Ee.set(c.ExtHostContext.ExtHostExtensionService,Et),Ee.set(c.ExtHostContext.ExtHostStorage,ve),Ee.set(c.ExtHostContext.ExtHostTunnelService,Xe),Ee.set(c.ExtHostContext.ExtHostWindow,et),Ee.set(c.ExtHostContext.ExtHostSecretState,wt),Ee.set(c.ExtHostContext.ExtHostTelemetry,Ct),Ee.set(c.ExtHostContext.ExtHostEditorTabs,At),Ee.set(c.ExtHostContext.ExtHostManagedSockets,Tt);const vt=Ee.set(c.ExtHostContext.ExtHostDecorations,at.get(A.IExtHostDecorations)),ot=Ee.set(c.ExtHostContext.ExtHostDocumentsAndEditors,at.get(r.IExtHostDocumentsAndEditors)),gt=Ee.set(c.ExtHostContext.ExtHostCommands,at.get(t.IExtHostCommands)),pt=Ee.set(c.ExtHostContext.ExtHostTerminalService,at.get(W.IExtHostTerminalService)),bt=Ee.set(c.ExtHostContext.ExtHostDebugService,at.get(he.IExtHostDebugService)),oi=Ee.set(c.ExtHostContext.ExtHostSearch,at.get(De.IExtHostSearch)),Vt=Ee.set(c.ExtHostContext.ExtHostTask,at.get(K.IExtHostTask)),Fi=Ee.set(c.ExtHostContext.ExtHostOutputService,at.get(o.IExtHostOutputService)),Kt=Ee.set(c.ExtHostContext.ExtHostLocalization,at.get(mt.IExtHostLocalizationService)),Ei=Ee.set(c.ExtHostContext.ExtHostUrls,new Ce.ExtHostUrls(Ee)),Pt=Ee.set(c.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(Ee,ot)),Mi=Ee.set(c.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Ee,ot,ze)),ai=Ee.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(ze,Pt,Ee.getProxy(c.MainContext.MainThreadBulkEdits))),Dt=Ee.set(c.ExtHostContext.ExtHostNotebook,new de.ExtHostNotebookController(Ee,gt,ot,Pt)),di=Ee.set(c.ExtHostContext.ExtHostNotebookDocuments,new fe.ExtHostNotebookDocuments(Dt)),wi=Ee.set(c.ExtHostContext.ExtHostNotebookEditors,new _.ExtHostNotebookEditors(ze,Dt)),hi=Ee.set(c.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Ee,ht,Dt,gt,ze)),cn=Ee.set(c.ExtHostContext.ExtHostNotebookRenderers,new Ne.ExtHostNotebookRenderers(Ee,Dt)),Li=Ee.set(c.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Wt.ExtHostNotebookDocumentSaveParticipant(ze,Dt,Ee.getProxy(c.MainContext.MainThreadBulkEdits))),Ft=Ee.set(c.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Ee,ot)),Si=Ee.set(c.ExtHostContext.ExtHostTreeViews,new q.ExtHostTreeViews(Ee.getProxy(c.MainContext.MainThreadTreeViews),gt,ze)),Yt=Ee.set(c.ExtHostContext.ExtHostEditorInsets,new Ie.ExtHostEditorInsets(Ee.getProxy(c.MainContext.MainThreadEditorInsets),Ft,ht.remote)),ci=Ee.set(c.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(Ee,ze,Nt,ot)),ui=Ee.set(c.ExtHostContext.ExtHostLanguages,new P.ExtHostLanguages(Ee,Pt,gt.converter,Ae)),ct=Ee.set(c.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(Ee,Ae,Pt,gt,ci,ze,He,Ct)),Ni=Ee.set(c.ExtHostContext.ExtHostFileSystem,new b.ExtHostFileSystem(Ee,ct)),ei=Ee.set(c.ExtHostContext.ExtHostFileSystemEventService,new I.ExtHostFileSystemEventService(Ee,ze,ot)),Xt=Ee.set(c.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Ee,lt,gt)),yi=Ee.set(c.ExtHostContext.ExtHostSCM,new B.ExtHostSCM(Ee,gt,Pt,ze)),Ui=Ee.set(c.ExtHostContext.ExtHostQuickDiff,new Gt.ExtHostQuickDiff(Ee,Ae)),$i=Ee.set(c.ExtHostContext.ExtHostShare,new Lt.ExtHostShare(Ee,Ae)),zi=Ee.set(c.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(Ee,gt,Pt)),Di=Ee.set(c.ExtHostContext.ExtHostProgress,new s.ExtHostProgress(Ee.getProxy(c.MainContext.MainThreadProgress))),Bi=Ee.set(c.ExtHostContext.ExtHosLabelService,new Pe.ExtHostLabelService(Ee)),Ii=Ee.set(c.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Ee)),ni=Ee.set(c.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(Ee)),Wi=Ee.set(c.ExtHostContext.ExtHostTimeline,new j.ExtHostTimeline(Ee,gt)),fi=Ee.set(c.ExtHostContext.ExtHostWebviews,new oe.ExtHostWebviews(Ee,ht.remote,lt,ze,He)),mi=Ee.set(c.ExtHostContext.ExtHostWebviewPanels,new ye.ExtHostWebviewPanels(Ee,fi,lt)),Hi=Ee.set(c.ExtHostContext.ExtHostCustomEditors,new ie.ExtHostCustomEditors(Ee,Pt,Y,fi,mi)),Vi=Ee.set(c.ExtHostContext.ExtHostWebviewViews,new pe.ExtHostWebviewViews(Ee,fi)),ri=Ee.set(c.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(Ee,gt,ot)),ji=Ee.set(c.ExtHostContext.ExtHostUriOpeners,new Ze.ExtHostUriOpeners(Ee)),qi=Ee.set(c.ExtHostContext.ExtHostProfileContentHandlers,new kt.ExtHostProfileContentHandlers(Ee));Ee.set(c.ExtHostContext.ExtHostInteractive,new $e.ExtHostInteractive(Ee,Dt,ot,gt,ze));const xi=Ee.set(c.ExtHostContext.ExtHostInteractiveEditor,new yt.ExtHostInteractiveEditor(Ee,gt,Pt,ze)),si=Ee.set(c.ExtHostContext.ExtHostChat,new Bt.ExtHostChat(Ee,ze)),Gi=Ee.set(c.ExtHostContext.ExtHostSemanticSimilarity,new Mt.ExtHostSemanticSimilarity(Ee)),Ki=Ee.set(c.ExtHostContext.ExtHostIssueReporter,new qt.ExtHostIssueReporter(Ee)),ki=Ee.set(c.ExtHostContext.ExtHostStatusBar,new X.ExtHostStatusBar(Ee,gt.converter)),Xi=Object.values(c.ExtHostContext);Ee.assertRegistered(Xi);const Qi=new Se.ExtHostBulkEdits(Ee,ot),un=new d.ExtHostClipboard(Ee),Ci=new E.ExtHostMessageService(Ee,ze),gi=new C.ExtHostDialogs(Ee);return g.ExtHostApiCommands.register(gt),function(Ue,Jt,Yi){const ft=function(){let re=!Ue.isUnderDevelopment;function me(){re||(ze.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Le(nt){if(Array.isArray(nt))nt.forEach(Le);else if(typeof nt=="string")me();else{const It=nt;typeof It.scheme>"u"&&me(),typeof It.exclusive=="boolean"&&(0,We.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return nt}}(),Ti={getSession(re,me,Le){return ni.getSession(Ue,re,me,Le)},getSessions(re,me){return(0,We.checkProposedApiEnabled)(Ue,"authGetSessions"),ni.getSessions(Ue,re,me)},async hasSession(re,me){return(0,We.checkProposedApiEnabled)(Ue,"authSession"),!!await ni.getSession(Ue,re,me,{silent:!0})},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(re,me,Le,nt){return ni.registerAuthenticationProvider(re,me,Le,nt)}},Ji={registerCommand(re,me,Le){return gt.registerCommand(!0,re,me,Le,void 0,Ue)},registerTextEditorCommand(re,me,Le){return gt.registerCommand(!0,re,(...nt)=>{const It=Ft.getActiveTextEditor();if(!It){ze.warn("Cannot execute "+re+" because there is no active text editor.");return}return It.edit(Rt=>{me.apply(Le,[It,Rt,...nt])}).then(Rt=>{Rt||ze.warn("Edits from command "+re+" were not applied.")},Rt=>{ze.warn("An error occurred while running command "+re,Rt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(re,me,Le)=>((0,We.checkProposedApiEnabled)(Ue,"diffCommand"),gt.registerCommand(!0,re,async(...nt)=>{const It=ot.activeEditor(!0);if(!It){ze.warn("Cannot execute "+re+" because there is no active text editor.");return}const Rt=await Ft.getDiffInformation(It.id);me.apply(Le,[Rt,...nt])},void 0,void 0,Ue)),executeCommand(re,...me){return gt.executeCommand(re,...me)},getCommands(re=!1){return gt.getCommands(re)}},Pi={get machineId(){return ht.telemetryInfo.machineId},get sessionId(){return ht.telemetryInfo.sessionId},get language(){return ht.environment.appLanguage},get appName(){return ht.environment.appName},get appRoot(){return ht.environment.appRoot?.fsPath??""},get appHost(){return ht.environment.appHost},get uriScheme(){return ht.environment.appUriScheme},get clipboard(){return un.value},get shell(){return pt.getDefaultShell(!1)},get onDidChangeShell(){return(0,We.checkProposedApiEnabled)(Ue,"envShellEvent"),pt.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Ue,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Ue,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,it.isNewAppInstall)(ht.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,me){return it.ExtHostTelemetryLogger.validateSender(re),Ct.instantiateLogger(Ue,re,me)},openExternal(re,me){return et.openUri(re,{allowTunneling:!!ht.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===ht.environment.appUriScheme)return Ei.createAppUri(re);try{return await et.asExternalUri(re,{allowTunneling:!!ht.remote.authority})}catch(me){if((0,J.matchesScheme)(re,dt.Schemas.http)||(0,J.matchesScheme)(re,dt.Schemas.https))return re;throw me}},get remoteName(){return(0,be.getRemoteName)(ht.remote.authority)},get remoteAuthority(){return(0,We.checkProposedApiEnabled)(Ue,"resolvers"),ht.remote.authority},get uiKind(){return ht.uiKind},get logLevel(){return ze.getLevel()},get onDidChangeLogLevel(){return ze.onDidChangeLogLevel},registerIssueUriRequestHandler(re){return(0,We.checkProposedApiEnabled)(Ue,"handleIssueUri"),Ki.registerIssueUriRequestHandler(Ue,re)},get appQuality(){return(0,We.checkProposedApiEnabled)(Ue,"resolvers"),ht.quality},get appCommit(){return(0,We.checkProposedApiEnabled)(Ue,"resolvers"),ht.commit}};ht.environment.extensionTestsLocationURI||Object.freeze(Pi);const _i={createTestController(re,me,Le){return ri.createTestController(Ue,re,me,Le)},createTestObserver(){return(0,We.checkProposedApiEnabled)(Ue,"testObserver"),ri.createTestObserver()},runTests(re){return(0,We.checkProposedApiEnabled)(Ue,"testObserver"),ri.runTests(re)},get onDidChangeTestResults(){return(0,We.checkProposedApiEnabled)(Ue,"testObserver"),ri.onResultsChanged},get testResults(){return(0,We.checkProposedApiEnabled)(Ue,"testObserver"),ri.results}},pi=ht.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,Zi={getExtension(re,me){(0,We.isProposedApiEnabled)(Ue,"extensionsAny")||(me=!1);const Le=Jt.mine.getExtensionDescription(re);if(Le)return new a.Extension(Et,Ue.identifier,Le,pi,!1);if(me){const nt=Jt.all.getExtensionDescription(re);if(nt)return new a.Extension(Et,Ue.identifier,nt,pi,!0)}},get all(){const re=[];for(const me of Jt.mine.getAllExtensionDescriptions())re.push(new a.Extension(Et,Ue.identifier,me,pi,!1));return re},get allAcrossExtensionHosts(){(0,We.checkProposedApiEnabled)(Ue,"extensionsAny");const re=new ue.ExtensionIdentifierSet(Jt.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),me=[];for(const Le of Jt.all.getAllExtensionDescriptions()){const nt=!re.has(Le.identifier);me.push(new a.Extension(Et,Ue.identifier,Le,pi,nt))}return me},get onDidChange(){return(0,We.isProposedApiEnabled)(Ue,"extensionsAny")?D.Event.any(Jt.mine.onDidChange,Jt.all.onDidChange):Jt.mine.onDidChange}},en={createDiagnosticCollection(re){return ci.createDiagnosticCollection(Ue.identifier,re)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:re=>ci.getDiagnostics(re),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(re,me){return ui.changeLanguage(re.uri,me)},match(re,me){const Le=Pt.getDocumentData(me.uri)?.notebook;return(0,O.score)(z.LanguageSelector.from(re),me.uri,me.languageId,!0,Le?.uri,Le?.notebookType)},registerCodeActionsProvider(re,me,Le){return ct.registerCodeActionProvider(Ue,ft(re),me,Le)},registerDocumentPasteEditProvider(re,me,Le){return(0,We.checkProposedApiEnabled)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,ft(re),me,Le)},registerCodeLensProvider(re,me){return ct.registerCodeLensProvider(Ue,ft(re),me)},registerDefinitionProvider(re,me){return ct.registerDefinitionProvider(Ue,ft(re),me)},registerDeclarationProvider(re,me){return ct.registerDeclarationProvider(Ue,ft(re),me)},registerImplementationProvider(re,me){return ct.registerImplementationProvider(Ue,ft(re),me)},registerTypeDefinitionProvider(re,me){return ct.registerTypeDefinitionProvider(Ue,ft(re),me)},registerHoverProvider(re,me){return ct.registerHoverProvider(Ue,ft(re),me,Ue.identifier)},registerEvaluatableExpressionProvider(re,me){return ct.registerEvaluatableExpressionProvider(Ue,ft(re),me,Ue.identifier)},registerInlineValuesProvider(re,me){return ct.registerInlineValuesProvider(Ue,ft(re),me,Ue.identifier)},registerDocumentHighlightProvider(re,me){return ct.registerDocumentHighlightProvider(Ue,ft(re),me)},registerLinkedEditingRangeProvider(re,me){return ct.registerLinkedEditingRangeProvider(Ue,ft(re),me)},registerReferenceProvider(re,me){return ct.registerReferenceProvider(Ue,ft(re),me)},registerRenameProvider(re,me){return ct.registerRenameProvider(Ue,ft(re),me)},registerDocumentSymbolProvider(re,me,Le){return ct.registerDocumentSymbolProvider(Ue,ft(re),me,Le)},registerWorkspaceSymbolProvider(re){return ct.registerWorkspaceSymbolProvider(Ue,re)},registerDocumentFormattingEditProvider(re,me){return ct.registerDocumentFormattingEditProvider(Ue,ft(re),me)},registerDocumentRangeFormattingEditProvider(re,me){return ct.registerDocumentRangeFormattingEditProvider(Ue,ft(re),me)},registerOnTypeFormattingEditProvider(re,me,Le,...nt){return ct.registerOnTypeFormattingEditProvider(Ue,ft(re),me,[Le].concat(nt))},registerDocumentSemanticTokensProvider(re,me,Le){return ct.registerDocumentSemanticTokensProvider(Ue,ft(re),me,Le)},registerDocumentRangeSemanticTokensProvider(re,me,Le){return ct.registerDocumentRangeSemanticTokensProvider(Ue,ft(re),me,Le)},registerSignatureHelpProvider(re,me,Le,...nt){return typeof Le=="object"?ct.registerSignatureHelpProvider(Ue,ft(re),me,Le):ct.registerSignatureHelpProvider(Ue,ft(re),me,typeof Le>"u"?[]:[Le,...nt])},registerCompletionItemProvider(re,me,...Le){return ct.registerCompletionItemProvider(Ue,ft(re),me,Le)},registerInlineCompletionItemProvider(re,me){return me.handleDidShowCompletionItem&&(0,We.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),me.handleDidPartiallyAcceptCompletionItem&&(0,We.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,ft(re),me)},registerDocumentLinkProvider(re,me){return ct.registerDocumentLinkProvider(Ue,ft(re),me)},registerColorProvider(re,me){return ct.registerColorProvider(Ue,ft(re),me)},registerFoldingRangeProvider(re,me){return ct.registerFoldingRangeProvider(Ue,ft(re),me)},registerSelectionRangeProvider(re,me){return ct.registerSelectionRangeProvider(Ue,re,me)},registerCallHierarchyProvider(re,me){return ct.registerCallHierarchyProvider(Ue,re,me)},registerTypeHierarchyProvider(re,me){return ct.registerTypeHierarchyProvider(Ue,re,me)},setLanguageConfiguration:(re,me)=>ct.setLanguageConfiguration(Ue,re,me),getTokenInformationAtPosition(re,me){return(0,We.checkProposedApiEnabled)(Ue,"tokenInformation"),ui.tokenAtPosition(re,me)},registerInlayHintsProvider(re,me){return ct.registerInlayHintsProvider(Ue,re,me)},createLanguageStatusItem(re,me){return ui.createLanguageStatusItem(Ue,re,me)},registerDocumentDropEditProvider(re,me,Le){return ct.registerDocumentOnDropEditProvider(Ue,re,me,(0,We.isProposedApiEnabled)(Ue,"dropMetadata")?Le:void 0)}},_t={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(re,me,Le){const nt=await(F.URI.isUri(re)?Promise.resolve(li.openTextDocument(re)):Promise.resolve(re));return Ft.showTextDocument(nt,me,Le)},createTextEditorDecorationType(re){return Ft.createTextEditorDecorationType(Ue,re)},onDidChangeActiveTextEditor(re,me,Le){return Ft.onDidChangeActiveTextEditor(re,me,Le)},onDidChangeVisibleTextEditors(re,me,Le){return Ft.onDidChangeVisibleTextEditors(re,me,Le)},onDidChangeTextEditorSelection(re,me,Le){return Ft.onDidChangeTextEditorSelection(re,me,Le)},onDidChangeTextEditorOptions(re,me,Le){return Ft.onDidChangeTextEditorOptions(re,me,Le)},onDidChangeTextEditorVisibleRanges(re,me,Le){return Ft.onDidChangeTextEditorVisibleRanges(re,me,Le)},onDidChangeTextEditorViewColumn(re,me,Le){return Ft.onDidChangeTextEditorViewColumn(re,me,Le)},onDidCloseTerminal(re,me,Le){return pt.onDidCloseTerminal(re,me,Le)},onDidOpenTerminal(re,me,Le){return pt.onDidOpenTerminal(re,me,Le)},onDidChangeActiveTerminal(re,me,Le){return pt.onDidChangeActiveTerminal(re,me,Le)},onDidChangeTerminalDimensions(re,me,Le){return(0,We.checkProposedApiEnabled)(Ue,"terminalDimensions"),pt.onDidChangeTerminalDimensions(re,me,Le)},onDidChangeTerminalState(re,me,Le){return pt.onDidChangeTerminalState(re,me,Le)},onDidWriteTerminalData(re,me,Le){return(0,We.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),pt.onDidWriteTerminalData(re,me,Le)},get state(){return et.getState(Ue)},onDidChangeWindowState(re,me,Le){return et.onDidChangeWindowState(re,me,Le)},showInformationMessage(re,...me){return Ci.showMessage(Ue,N.default.Info,re,me[0],me.slice(1))},showWarningMessage(re,...me){return Ci.showMessage(Ue,N.default.Warning,re,me[0],me.slice(1))},showErrorMessage(re,...me){return Ci.showMessage(Ue,N.default.Error,re,me[0],me.slice(1))},showQuickPick(re,me,Le){return Xt.showQuickPick(Ue,re,me,Le)},showWorkspaceFolderPick(re){return Xt.showWorkspaceFolderPick(re)},showInputBox(re,me){return Xt.showInput(re,me)},showOpenDialog(re){return gi.showOpenDialog(Ue,re)},showSaveDialog(re){return gi.showSaveDialog(re)},createStatusBarItem(re,me,Le){let nt,It,Rt;return typeof re=="string"?(nt=re,It=me,Rt=Le):(It=re,Rt=me),ki.createStatusBarEntry(Ue,nt,It,Rt)},setStatusBarMessage(re,me){return ki.setStatusBarMessage(re,me)},withScmProgress(re){return He.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Di.withProgress(Ue,{location:V.ProgressLocation.SourceControl},(me,Le)=>re({report(nt){}}))},withProgress(re,me){return Di.withProgress(Ue,re,me)},createOutputChannel(re,me){return Fi.createOutputChannel(re,me,Ue)},createWebviewPanel(re,me,Le,nt){return mi.createWebviewPanel(Ue,re,me,Le,nt)},createWebviewTextEditorInset(re,me,Le,nt){return(0,We.checkProposedApiEnabled)(Ue,"editorInsets"),Yt.createWebviewEditorInset(re,me,Le,nt,Ue)},createTerminal(re,me,Le){return typeof re=="object"?"pty"in re?pt.createExtensionTerminal(re):pt.createTerminalFromOptions(re):pt.createTerminal(re,me,Le)},registerTerminalLinkProvider(re){return pt.registerLinkProvider(re)},registerTerminalProfileProvider(re,me){return pt.registerProfileProvider(Ue,re,me)},registerTerminalQuickFixProvider(re,me){return(0,We.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),pt.registerTerminalQuickFixProvider(re,Ue.identifier.value,me)},registerTreeDataProvider(re,me){return Si.registerTreeDataProvider(re,me,Ue)},createTreeView(re,me){return Si.createTreeView(re,me,Ue)},registerWebviewPanelSerializer:(re,me)=>mi.registerWebviewPanelSerializer(Ue,re,me),registerCustomEditorProvider:(re,me,Le={})=>Hi.registerCustomEditorProvider(Ue,re,me,Le),registerFileDecorationProvider(re){return vt.registerFileDecorationProvider(re,Ue)},registerUriHandler(re){return Ei.registerUriHandler(Ue,re)},createQuickPick(){return Xt.createQuickPick(Ue)},createInputBox(){return Xt.createInputBox(Ue)},get activeColorTheme(){return Ii.activeColorTheme},onDidChangeActiveColorTheme(re,me,Le){return Ii.onDidChangeActiveColorTheme(re,me,Le)},registerWebviewViewProvider(re,me,Le){return Vi.registerWebviewViewProvider(Ue,re,me,Le?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,me,Le){return Dt.onDidChangeActiveNotebookEditor(re,me,Le)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,me,Le){return wi.onDidChangeNotebookEditorSelection(re,me,Le)},onDidChangeNotebookEditorVisibleRanges(re,me,Le){return wi.onDidChangeNotebookEditorVisibleRanges(re,me,Le)},showNotebookDocument(re,me){return Dt.showNotebookDocument(re,me)},registerExternalUriOpener(re,me,Le){return(0,We.checkProposedApiEnabled)(Ue,"externalUriOpener"),ji.registerExternalUriOpener(Ue.identifier,re,me,Le)},registerProfileContentHandler(re,me){return(0,We.checkProposedApiEnabled)(Ue,"profileContentHandlers"),qi.registrProfileContentHandler(Ue,re,me)},registerQuickDiffProvider(re,me,Le,nt){return(0,We.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Ui.registerQuickDiffProvider(ft(re),me,Le,nt)},get tabGroups(){return At.tabGroups},registerShareProvider(re,me){return(0,We.checkProposedApiEnabled)(Ue,"shareProvider"),$i.registerShareProvider(ft(re),me)}},li={get rootPath(){return He.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),lt.getPath()},set rootPath(re){throw k.readonly()},getWorkspaceFolder(re){return lt.getWorkspaceFolder(re)},get workspaceFolders(){return lt.getWorkspaceFolders()},get name(){return lt.name},set name(re){throw k.readonly()},get workspaceFile(){return lt.workspaceFile},set workspaceFile(re){throw k.readonly()},updateWorkspaceFolders:(re,me,...Le)=>lt.updateWorkspaceFolders(Ue,re,me||0,...Le),onDidChangeWorkspaceFolders:function(re,me,Le){return lt.onDidChangeWorkspace(re,me,Le)},asRelativePath:(re,me)=>lt.getRelativePath(re,me),findFiles:(re,me,Le,nt)=>lt.findFiles(re,me,Le,Ue.identifier,nt),findTextInFiles:(re,me,Le,nt)=>{(0,We.checkProposedApiEnabled)(Ue,"findTextInFiles");let It,Rt;return typeof me=="object"?(It=me,Rt=Le):(It={},Rt=me,nt=Le),lt.findTextInFiles(re,It||{},Rt,Ue.identifier,nt)},save:re=>((0,We.checkProposedApiEnabled)(Ue,"saveEditor"),lt.save(re)),saveAs:re=>((0,We.checkProposedApiEnabled)(Ue,"saveEditor"),lt.saveAs(re)),saveAll:re=>lt.saveAll(re),applyEdit(re,me){return Qi.applyWorkspaceEdit(re,Ue,me)},createFileSystemWatcher:(re,me,Le,nt)=>ei.createFileSystemWatcher(lt,Ue,re,me,Le,nt),get textDocuments(){return Pt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw k.readonly()},openTextDocument(re){let me;const Le=re;if(typeof re=="string")me=Promise.resolve(F.URI.file(re));else if(F.URI.isUri(re))me=Promise.resolve(re);else if(!Le||typeof Le=="object")me=Pt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(nt=>Pt.ensureDocumentData(nt).then(It=>It.document))},onDidOpenTextDocument:(re,me,Le)=>Pt.onDidAddDocument(re,me,Le),onDidCloseTextDocument:(re,me,Le)=>Pt.onDidRemoveDocument(re,me,Le),onDidChangeTextDocument:(re,me,Le)=>Pt.onDidChangeDocument(re,me,Le),onDidSaveTextDocument:(re,me,Le)=>Pt.onDidSaveDocument(re,me,Le),onWillSaveTextDocument:(re,me,Le)=>ai.getOnWillSaveTextDocumentEvent(Ue)(re,me,Le),get notebookDocuments(){return Dt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,me){let Le;if(F.URI.isUri(re))Le=re,await Dt.openNotebookDocument(re);else if(typeof re=="string")Le=F.URI.revive(await Dt.createNotebookDocument({viewType:re,content:me}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(re,me,Le){return di.onDidSaveNotebookDocument(re,me,Le)},onDidChangeNotebookDocument(re,me,Le){return di.onDidChangeNotebookDocument(re,me,Le)},onWillSaveNotebookDocument(re,me,Le){return Li.getOnWillSaveNotebookDocumentEvent(Ue)(re,me,Le)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(re,me,Le,nt){return Dt.registerNotebookSerializer(Ue,re,me,Le,(0,We.isProposedApiEnabled)(Ue,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(re,me,Le)=>Yi.onDidChangeConfiguration(re,me,Le),getConfiguration(re,me){return me=arguments.length===1?void 0:me,Yi.getConfiguration(re,me,Ue)},registerTextDocumentContentProvider(re,me){return Mi.registerTextDocumentContentProvider(re,me)},registerTaskProvider:(re,me)=>(He.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Vt.registerTaskProvider(Ue,re,me)),registerFileSystemProvider(re,me,Le){return(0,qe.combinedDisposable)(Ni.registerFileSystemProvider(Ue,re,me,Le),Ut.addFileSystemProvider(re,me))},get fs(){return Ut.value},registerFileSearchProvider:(re,me)=>((0,We.checkProposedApiEnabled)(Ue,"fileSearchProvider"),oi.registerFileSearchProvider(re,me)),registerTextSearchProvider:(re,me)=>((0,We.checkProposedApiEnabled)(Ue,"textSearchProvider"),oi.registerTextSearchProvider(re,me)),registerRemoteAuthorityResolver:(re,me)=>((0,We.checkProposedApiEnabled)(Ue,"resolvers"),Et.registerRemoteAuthorityResolver(re,me)),registerResourceLabelFormatter:re=>((0,We.checkProposedApiEnabled)(Ue,"resolvers"),Bi.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,me,Le)=>ei.onDidCreateFile(re,me,Le),onDidDeleteFiles:(re,me,Le)=>ei.onDidDeleteFile(re,me,Le),onDidRenameFiles:(re,me,Le)=>ei.onDidRenameFile(re,me,Le),onWillCreateFiles:(re,me,Le)=>ei.getOnWillCreateFileEvent(Ue)(re,me,Le),onWillDeleteFiles:(re,me,Le)=>ei.getOnWillDeleteFileEvent(Ue)(re,me,Le),onWillRenameFiles:(re,me,Le)=>ei.getOnWillRenameFileEvent(Ue)(re,me,Le),openTunnel:re=>((0,We.checkProposedApiEnabled)(Ue,"tunnels"),Xe.openTunnel(Ue,re).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,We.checkProposedApiEnabled)(Ue,"tunnels"),Xe.getTunnels()},onDidChangeTunnels:(re,me,Le)=>((0,We.checkProposedApiEnabled)(Ue,"tunnels"),Xe.onDidChangeTunnels(re,me,Le)),registerPortAttributesProvider:(re,me)=>((0,We.checkProposedApiEnabled)(Ue,"portsAttributes"),Xe.registerPortsAttributesProvider(re,me)),registerTimelineProvider:(re,me)=>((0,We.checkProposedApiEnabled)(Ue,"timeline"),Wi.registerTimelineProvider(re,me,Ue.identifier,gt.converter)),get isTrusted(){return lt.trusted},requestWorkspaceTrust:re=>((0,We.checkProposedApiEnabled)(Ue,"workspaceTrust"),lt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,me,Le)=>lt.onDidGrantWorkspaceTrust(re,me,Le),registerEditSessionIdentityProvider:(re,me)=>((0,We.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),lt.registerEditSessionIdentityProvider(re,me)),onWillCreateEditSessionIdentity:(re,me,Le)=>((0,We.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),lt.getOnWillCreateEditSessionIdentityEvent(Ue)(re,me,Le)),registerCanonicalUriProvider:(re,me)=>((0,We.checkProposedApiEnabled)(Ue,"canonicalUriProvider"),lt.registerCanonicalUriProvider(re,me)),getCanonicalUri:(re,me,Le)=>((0,We.checkProposedApiEnabled)(Ue,"canonicalUriProvider"),lt.provideCanonicalUri(re,me,Le))},ln={get inputBox(){return He.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(Ue)},createSourceControl(re,me,Le){return yi.createSourceControl(Ue,re,me,Le)}},jt={createCommentController(re,me){return zi.createCommentController(Ue,re,me)}},vi={get activeDebugSession(){return bt.activeDebugSession},get activeDebugConsole(){return bt.activeDebugConsole},get breakpoints(){return bt.breakpoints},get stackFrameFocus(){return bt.stackFrameFocus},onDidStartDebugSession(re,me,Le){return bt.onDidStartDebugSession(re,me,Le)},onDidTerminateDebugSession(re,me,Le){return bt.onDidTerminateDebugSession(re,me,Le)},onDidChangeActiveDebugSession(re,me,Le){return bt.onDidChangeActiveDebugSession(re,me,Le)},onDidReceiveDebugSessionCustomEvent(re,me,Le){return bt.onDidReceiveDebugSessionCustomEvent(re,me,Le)},onDidChangeBreakpoints(re,me,Le){return bt.onDidChangeBreakpoints(re,me,Le)},onDidChangeStackFrameFocus(re,me,Le){return(0,We.checkProposedApiEnabled)(Ue,"debugFocus"),bt.onDidChangeStackFrameFocus(re,me,Le)},registerDebugConfigurationProvider(re,me,Le){return bt.registerDebugConfigurationProvider(re,me,Le||_e.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,me){return bt.registerDebugAdapterDescriptorFactory(Ue,re,me)},registerDebugAdapterTrackerFactory(re,me){return bt.registerDebugAdapterTrackerFactory(re,me)},startDebugging(re,me,Le){return!Le||typeof Le=="object"&&"configuration"in Le?bt.startDebugging(re,me,{parentSession:Le}):bt.startDebugging(re,me,Le||{})},stopDebugging(re){return bt.stopDebugging(re)},addBreakpoints(re){return bt.addBreakpoints(re)},removeBreakpoints(re){return bt.removeBreakpoints(re)},asDebugSourceUri(re,me){return bt.asDebugSourceUri(re,me)}},tn={registerTaskProvider:(re,me)=>Vt.registerTaskProvider(Ue,re,me),fetchTasks:re=>Vt.fetchTasks(re),executeTask:re=>Vt.executeTask(Ue,re),get taskExecutions(){return Vt.taskExecutions},onDidStartTask:(re,me,Le)=>Vt.onDidStartTask(re,me,Le),onDidEndTask:(re,me,Le)=>Vt.onDidEndTask(re,me,Le),onDidStartTaskProcess:(re,me,Le)=>Vt.onDidStartTaskProcess(re,me,Le),onDidEndTaskProcess:(re,me,Le)=>Vt.onDidEndTaskProcess(re,me,Le)},nn={createNotebookController(re,me,Le,nt,It){return hi.createNotebookController(Ue,re,me,Le,nt,(0,We.isProposedApiEnabled)(Ue,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(re,me)=>Dt.registerNotebookCellStatusBarItemProvider(Ue,re,me),createRendererMessaging(re){return cn.createRendererMessaging(Ue,re)},createNotebookControllerDetectionTask(re){return(0,We.checkProposedApiEnabled)(Ue,"notebookKernelSource"),hi.createNotebookControllerDetectionTask(Ue,re)},registerKernelSourceActionProvider(re,me){return(0,We.checkProposedApiEnabled)(Ue,"notebookKernelSource"),hi.registerKernelSourceActionProvider(Ue,re,me)},onDidChangeNotebookCellExecutionState(re,me,Le){return(0,We.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),hi.onDidChangeNotebookCellExecutionState(re,me,Le)}},rn={t(...re){if(typeof re[0]=="string"){const me=re.shift(),Le=!re||typeof re[0]!="object"?re:re[0];return Kt.getMessage(Ue.identifier.value,{message:me,args:Le})}return Kt.getMessage(Ue.identifier.value,re[0])},get bundle(){return Kt.getBundle(Ue.identifier.value)},get uri(){return Kt.getBundleUri(Ue.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(re){return(0,We.checkProposedApiEnabled)(Ue,"interactive"),xi.registerProvider(Ue,re)},registerInteractiveSessionProvider(re,me){return(0,We.checkProposedApiEnabled)(Ue,"interactive"),si.registerChatProvider(Ue,re,me)},addInteractiveRequest(re){return(0,We.checkProposedApiEnabled)(Ue,"interactive"),si.addChatRequest(re)},sendInteractiveRequestToProvider(re,me){return(0,We.checkProposedApiEnabled)(Ue,"interactive"),si.sendInteractiveRequestToProvider(re,me)},get onDidPerformUserAction(){return(0,We.checkProposedApiEnabled)(Ue,"interactiveUserActions"),si.onDidPerformUserAction}},dn={registerSlashCommandProvider(re,me){return(0,We.checkProposedApiEnabled)(Ue,"interactiveSlashCommands"),si.registerSlashCommandProvider(Ue,re,me)}},on={registerSemanticSimilarityProvider(re){return(0,We.checkProposedApiEnabled)(Ue,"semanticSimilarity"),Gi.registerSemanticSimilarityProvider(Ue,re)}};return{version:ht.version,ai:on,authentication:Ti,commands:Ji,comments:jt,debug:vi,env:Pi,extensions:Zi,interactive:sn,interactiveSlashCommands:dn,l10n:rn,languages:en,notebooks:nn,scm:ln,tasks:tn,tests:_i,window:_t,workspace:li,Breakpoint:V.Breakpoint,TerminalOutputAnchor:V.TerminalOutputAnchor,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:k.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentState:V.CommentState,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:_e.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileDecoration2:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestionList,Hover:V.Hover,IndentAction:m.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalQuickFixCommand:V.TerminalQuickFixCommand,TerminalQuickFixOpener:V.TerminalQuickFixOpener,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TerminalExitReason:V.TerminalExitReason,TerminalQuickFixType:V.TerminalQuickFixType,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,SnippetTextEdit:V.SnippetTextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItem2:V.TreeItem,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:p.UIKind,Uri:F.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,DocumentDropEdit:V.DocumentDropEdit,DocumentPasteEdit:V.DocumentPasteEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,ManagedResolvedAuthority:V.ManagedResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.NotebookEdit,NotebookKernelSourceAction:V.NotebookKernelSourceAction,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestRunRequest2:V.TestRunRequest2,TestMessage:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:tt.TextSearchCompleteMessageType,DataTransfer:V.DataTransfer,DataTransferItem:V.DataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.TextTabInput,TabInputTextDiff:V.TextDiffTabInput,TabInputTextMerge:V.TextMergeTabInput,TabInputCustom:V.CustomEditorTabInput,TabInputNotebook:V.NotebookEditorTabInput,TabInputNotebookDiff:V.NotebookDiffEditorTabInput,TabInputWebview:V.WebviewEditorTabInput,TabInputTerminal:V.TerminalEditorTabInput,TabInputInteractiveWindow:V.InteractiveWindowInput,TelemetryTrustedValue:ee.TelemetryTrustedValue,LogLevel:we.LogLevel,EditSessionIdentityMatch:St.EditSessionIdentityMatch,InteractiveSessionVoteDirection:V.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:V.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:V.InteractiveEditorResponseFeedbackKind,StackFrameFocus:V.StackFrameFocus,ThreadFocus:V.ThreadFocus,NotebookCodeActionKind:V.NotebookCodeActionKind}}}e.createApiFactoryAndRegisterActors=Ht}),define(Re[267],Oe([1,0,70,109,33,107,34,32,59,62,111,113,114,83,73,79,108,61,38,82,57,60,234,14,112,80,81]),function(te,e,i,k,D,N,F,R,S,m,O,w,c,p,g,d,t,u,h,y,C,v,n,l,r,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,1),(0,i.registerSingleton)(l.ILoggerService,n.ExtHostLoggerService,1),(0,i.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,0),(0,i.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration,0),(0,i.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,0),(0,i.registerSingleton)(N.IExtHostDecorations,N.ExtHostDecorations,0),(0,i.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(b.IExtHostManagedSockets,b.ExtHostManagedSockets,0),(0,i.registerSingleton)(h.IExtHostFileSystemInfo,h.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService,1),(0,i.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch,0),(0,i.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage,0),(0,i.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,i.registerSingleton)(m.IExtHostTerminalService,m.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService,0),(0,i.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,i.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,0),(0,i.registerSingleton)(y.IExtHostSecretState,y.ExtHostSecretState,0),(0,i.registerSingleton)(C.IExtHostTelemetry,C.ExtHostTelemetry,0),(0,i.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,i.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(Re[268],Oe([1,0,266,35,2,263,7,16,254]),function(te,e,i,k,D,N,F,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class m extends N.RequireInterceptor{j(){}getModule(p,g){for(const d of this.b){const t=d(p);if(t){p=t;break}}if(this.a.has(p))return this.a.get(p).load(p,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends k.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=F.ExtensionRuntime.Webworker}async qb(){this.h.createInstance(S.ExtHostConsoleForwarder);const p=this.h.invokeFunction(i.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(m,p,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.wb()}rb(p){return p.browser}async sb(p,g,d){g=g.with({path:w(g.path,".js")});const t=p?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const u=D.URI.revive(await this.v.$asBrowserUri(g)),h=await fetch(u.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),h.status!==200)throw new Error(h.statusText);const y=await h.text(),C=`${g.toString(!0)}#vscode-extension`,v=`${y}
//# sourceURL=${C}`;let n;try{n=new Function("module","exports","require",v)}catch(b){throw console.error(t?`Loading code for extension ${t} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${g.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}p&&await this.s.initializeLocalizedMessages(p);const l={},r={exports:l},a=b=>{const I=this.r.getModule(b,g);if(I===void 0)throw new Error(`Cannot load module '${b}'`);return I};try{return d.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(r,l,a),r.exports!==l?r.exports:l}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),d.codeLoadingStop()}}async $setRemoteEnvironment(p){}async wb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+p;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=O;function w(c,p){return c.endsWith(p)?c:c+p}}),define(Re[269],Oe([1,0,69,70,14,35,186,84,268]),function(te,e,i,k,D,N,F,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,k.registerSingleton)(D.ILogService,new i.SyncDescriptor(F.ExtHostLogService,[!0],!0)),(0,k.registerSingleton)(N.IExtHostExtensionService,S.ExtHostExtensionService,0),(0,k.registerSingleton)(R.IExtensionStoragePaths,R.ExtensionStoragePaths,0)}),define(Re[277],Oe([1,0,24,5,77,264,256,19,85,15,2,267,269]),function(te,e,i,k,D,N,F,R,S,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(n){return/^(file|vscode-remote):/i.test(n)}const g=fetch.bind(self);function d(n){self.fetch=async function(l,r){return l instanceof Request||p(String(l))&&(l=(await n(O.URI.parse(String(l)))).toString(!0)),g(l,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,r,a,b,I){(async()=>(p(r.toString())&&(r=(await n(O.URI.parse(r.toString()))).toString(!0)),super.open(l,r,a??!0,b,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(l,r){if(/^file:/i.test(l.toString()))l=m.FileAccess.uriToBrowserUri(O.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(E){function o(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const s=fetch.bind(self);self.fetch=function(B,X){return B instanceof Request?s(B,X):s(o(B),X)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,X,G,W,U){return super.open(B,o(X),G??!0,W,U)}};const M=importScripts.bind(self);self.importScripts=(...B)=>{M(...B.map(o))},M(E)}.toString()}('${l}'))`;r=r||{},r.name=r.name||R.basename(l.toString());const I=new Blob([b],{type:"application/javascript"}),f=URL.createObjectURL(I);return new n(f,r)}}else self.Worker=class extends F.NestedWorker{constructor(n,l){super(c,n,{name:R.basename(n.toString()),...l})}};const t=new class{constructor(){this.pid=void 0}exit(n){w()}async exists(n){return!0}async realpath(n){return n}};class u{constructor(){const l=new MessageChannel,r=new k.Emitter;let a=!1;c(l.port2,[l.port2]),l.port1.onmessage=b=>{const{data:I}=b;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const f=i.VSBuffer.wrap(new Uint8Array(I,0,I.byteLength));if((0,D.isMessageOfType)(f,2)){a=!0,y("received terminate message from renderer");return}r.fire(f)},this.protocol={onMessage:r.event,send:b=>{if(!a){const I=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);l.port1.postMessage(I,[I])}}}}}function h(n){return new Promise(l=>{const r=n.onMessage(a=>{r.dispose();const b=JSON.parse(a.toString());n.send((0,D.createMessageOfType)(0)),l({protocol:n,initData:b})});n.send((0,D.createMessageOfType)(1))})}let y=n=>w();function C(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function v(){S.mark("code/extHost/willConnectToRenderer");const n=new u;return{onmessage(l){C(l)&&h(n.protocol).then(r=>{S.mark("code/extHost/didWaitForInitData");const a=new N.ExtensionHostMain(r.protocol,r.initData,t,null,l.data);d(b=>a.asBrowserUri(b)),y=b=>a.terminate(b)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b380da4ef1ee00e224a15c1d4d9793e27c2b6302/core/vs/workbench/api/worker/extensionHostWorker.js.map
