/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var p=["require","exports","vs/base/common/lifecycle","vs/base/common/observableImpl/logging","vs/base/common/errors","vs/base/common/platform","vs/base/common/observableImpl/base","vs/editor/common/tokens/lineTokens","vs/base/common/observableImpl/autorun","vs/base/common/observableImpl/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/uri","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/observableImpl/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/workbench/services/textMate/browser/worker/textMateWorkerModel","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/base/common/stopwatch","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vscode-textmate","vs/workbench/services/textMate/browser/worker/textMate.worker"],_=function(F){for(var e=[],y=0,E=F.length;y<E;y++)e[y]=p[F[y]];return e};define(p[3],_([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let y;function E(a){y=a}e.setLogger=E;function w(){return y}e.getLogger=w;class P{constructor(){this.a=0,this.d=new WeakMap}b(u){return r([h(b("|  ",this.a)),u])}c(u){return u.didChange?[h(" "),i(n(u.oldValue,70),{color:"red",strikeThrough:!0}),h(" "),i(n(u.newValue,60),{color:"green"})]:[h(" (unchanged)")]}handleObservableChanged(u,T){console.log(...this.b([t("observable value changed"),i(u.debugName,{color:"BlueViolet"}),...this.c(T)]))}formatChanges(u){if(u.size!==0)return i(" (changed deps: "+[...u].map(T=>T.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(u){const T=u.handleChange;this.d.set(u,new Set),u.handleChange=(L,D)=>(this.d.get(u).add(L),T.apply(u,[L,D]))}handleDerivedRecomputed(u,T){const L=this.d.get(u);console.log(...this.b([t("derived recomputed"),i(u.debugName,{color:"BlueViolet"}),...this.c(T),this.formatChanges(L)])),L.clear()}handleFromEventObservableTriggered(u,T){console.log(...this.b([t("observable from event triggered"),i(u.debugName,{color:"BlueViolet"}),...this.c(T)]))}handleAutorunCreated(u){const T=u.handleChange;this.d.set(u,new Set),u.handleChange=(L,D)=>(this.d.get(u).add(L),T.apply(u,[L,D]))}handleAutorunTriggered(u){const T=this.d.get(u);console.log(...this.b([t("autorun"),i(u.debugName,{color:"BlueViolet"}),this.formatChanges(T)])),T.clear()}handleBeginTransaction(u){let T=u.getDebugName();T===void 0&&(T=""),console.log(...this.b([t("transaction"),i(T,{color:"BlueViolet"})])),this.a++}handleEndTransaction(){this.a--}}e.ConsoleObservableLogger=P;function r(a){const u=new Array,L={};let D="";function U(d){if("length"in d)for(const g of d)g&&U(g);else"text"in d?(D+=`%c${d.text}`,u.push(d.style),d.data&&Object.assign(L,d.data)):"data"in d&&Object.assign(L,d.data)}U(a);const k=[D,...u];return Object.keys(L).length>0&&k.push(L),k}function h(a){return i(a,{color:"black"})}function t(a){return i(o(`${a}: `,10),{color:"black",bold:!0})}function i(a,u={color:"black"}){function T(D){return Object.entries(D).reduce((U,[k,d])=>`${U}${k}:${d};`,"")}const L={color:u.color};return u.strikeThrough&&(L["text-decoration"]="line-through"),u.bold&&(L["font-weight"]="bold"),{text:a,style:T(L)}}function n(a,u){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=u?`"${a}"`:`"${a.substr(0,u-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?s(a,u):v(a,u);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function s(a,u){let T="[ ",L=!0;for(const D of a){if(L||(T+=", "),T.length-5>u){T+="...";break}L=!1,T+=`${n(D,u-T.length)}`}return T+=" ]",T}function v(a,u){let T="{ ",L=!0;for(const[D,U]of Object.entries(a)){if(L||(T+=", "),T.length-5>u){T+="...";break}L=!1,T+=`${D}: ${n(U,u-T.length)}`}return T+=" }",T}function b(a,u){let T="";for(let L=1;L<=u;L++)T+=a;return T}function o(a,u){for(;a.length<u;)a+=" ";return a}}),define(p[8],_([0,1,39,2,3]),function(F,e,y,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunWithStoreHandleChanges=e.autorunWithStore2=e.autorunHandleChanges=e.autorun=void 0;function P(b,o){return new s(b,o,void 0,void 0)}e.autorun=P;function r(b,o,a){return new s(b,a,o.createEmptyChangeSummary,o.handleChange)}e.autorunHandleChanges=r;function h(b,o){return i(o,b)}e.autorunWithStore2=h;function t(b,o,a){const u=new E.DisposableStore,T=r(b,{createEmptyChangeSummary:o.createEmptyChangeSummary,handleChange:o.handleChange},(L,D)=>{u.clear(),a(L,D,u)});return(0,E.toDisposable)(()=>{T.dispose(),u.dispose()})}e.autorunWithStoreHandleChanges=t;function i(b,o){const a=new E.DisposableStore,u=P(o,T=>{a.clear(),b(T,a)});return(0,E.toDisposable)(()=>{u.dispose(),a.dispose()})}e.autorunWithStore=i;var n;(function(b){b[b.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",b[b.stale=2]="stale",b[b.upToDate=3]="upToDate"})(n||(n={}));class s{constructor(o,a,u,T){this.debugName=o,this.h=a,this.i=u,this.j=T,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,w.getLogger)()?.handleAutorunCreated(this),this.k()}dispose(){this.c=!0;for(const o of this.e)o.removeObserver(this);this.e.clear()}k(){if(this.a===3)return;const o=this.f;this.f=this.e,this.e=o,this.a=3,(0,w.getLogger)()?.handleAutorunTriggered(this);try{const a=this.g;this.g=this.i?.(),this.h(this,a)}finally{for(const a of this.f)a.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const o of this.e)if(o.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,y.assertFn)(()=>this.b>=0)}handlePossibleChange(o){this.a===3&&this.e.has(o)&&!this.f.has(o)&&(this.a=1)}handleChange(o,a){this.e.has(o)&&!this.f.has(o)&&(!this.j||this.j({changedObservable:o,change:a,didChange:T=>T===o},this.g))&&(this.a=2)}readObservable(o){if(this.c)return o.get();o.addObserver(this);const a=o.get();return this.e.add(o),this.f.delete(o),a}}e.AutorunObserver=s,function(b){b.Observer=s}(P||(e.autorun=P={}));function v(b,o,a){let u;return P(b,T=>{const L=o.read(T),D=u;u=L,a({lastValue:D,newValue:L})})}e.autorunDelta=v}),define(p[6],_([0,1,3]),function(F,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.disposableObservableValue=e.ObservableValue=e.observableValue=e.getFunctionName=e.TransactionImpl=e.subtransaction=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerived=void 0;let E;function w(a){E=a}e._setDerived=w;class P{get TChange(){return null}reportChanges(){this.get()}read(u){return u?u.readObservable(this):this.get()}map(u){return E(()=>{const T=n(u);return T!==void 0?T:`${this.debugName} (mapped)`},T=>u(this.read(T),T))}}e.ConvenientObservable=P;class r extends P{constructor(){super(...arguments),this.a=new Set}addObserver(u){const T=this.a.size;this.a.add(u),T===0&&this.b()}removeObserver(u){this.a.delete(u)&&this.a.size===0&&this.c()}b(){}c(){}}e.BaseObservable=r;function h(a,u){const T=new i(a,u);try{(0,y.getLogger)()?.handleBeginTransaction(T),a(T)}finally{T.finish(),(0,y.getLogger)()?.handleEndTransaction()}}e.transaction=h;function t(a,u,T){a?u(a):h(u,T)}e.subtransaction=t;class i{constructor(u,T){this.b=u,this.c=T,this.a=[]}getDebugName(){return this.c?this.c():n(this.b)}updateObserver(u,T){this.a.push({observer:u,observable:T}),u.beginUpdate(T)}finish(){const u=this.a;this.a=null;for(const{observer:T,observable:L}of u)T.endUpdate(L)}}e.TransactionImpl=i;function n(a){const u=a.toString(),L=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(u);return(L?L[1]:void 0)?.trim()}e.getFunctionName=n;function s(a,u){return new v(a,u)}e.observableValue=s;class v extends r{constructor(u,T){super(),this.debugName=u,this.d=T}get(){return this.d}set(u,T,L){if(this.d===u)return;let D;T||(T=D=new i(()=>{},()=>`Setting ${this.debugName}`));try{const U=this.d;this.e(u),(0,y.getLogger)()?.handleObservableChanged(this,{oldValue:U,newValue:u,change:L,didChange:!0});for(const k of this.a)T.updateObserver(k,this),k.handleChange(this,L)}finally{D&&D.finish()}}toString(){return`${this.debugName}: ${this.d}`}e(u){this.d=u}}e.ObservableValue=v;function b(a,u){return new o(a,u)}e.disposableObservableValue=b;class o extends v{e(u){this.d!==u&&(this.d&&this.d.dispose(),this.d=u)}dispose(){this.d?.dispose()}}e.DisposableObservableValue=o}),define(p[9],_([0,1,4,6,3]),function(F,e,y,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derivedHandleChanges=e.derived=void 0;function P(i,n){return new t(i,n,void 0,void 0)}e.derived=P;function r(i,n,s){return new t(i,s,n.createEmptyChangeSummary,n.handleChange)}e.derivedHandleChanges=r,(0,E._setDerived)(P);var h;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(h||(h={}));class t extends E.BaseObservable{get debugName(){return typeof this.k=="function"?this.k():this.k}constructor(n,s,v,b){super(),this.k=n,this.l=s,this.m=v,this.n=b,this.e=0,this.f=void 0,this.g=0,this.h=new Set,this.i=new Set,this.j=void 0,this.j=this.m?.(),(0,w.getLogger)()?.handleDerivedCreated(this)}c(){this.e=0,this.f=void 0;for(const n of this.h)n.removeObserver(this);this.h.clear()}get(){if(this.a.size===0){const n=this.l(this,this.m?.());return this.c(),n}else{do{if(this.e===1){this.e=3;for(const n of this.h)if(n.reportChanges(),this.e===2)break}this.q()}while(this.e!==3);return this.f}}q(){if(this.e===3)return;const n=this.i;this.i=this.h,this.h=n;const s=this.e!==0,v=this.f;this.e=3;const b=this.j;this.j=this.m?.();try{this.f=this.l(this,b)}finally{for(const a of this.i)a.removeObserver(this);this.i.clear()}const o=s&&v!==this.f;if((0,w.getLogger)()?.handleDerivedRecomputed(this,{oldValue:v,newValue:this.f,change:void 0,didChange:o}),o)for(const a of this.a)a.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.g++;const s=this.g===1;if(this.e===3&&(this.e=1,!s))for(const v of this.a)v.handlePossibleChange(this);if(s)for(const v of this.a)v.beginUpdate(this)}endUpdate(n){if(this.g--,this.g===0){const s=[...this.a];for(const v of s)v.endUpdate(this)}if(this.g<0)throw new y.BugIndicatingError}handlePossibleChange(n){if(this.e===3&&this.h.has(n)&&!this.i.has(n)){this.e=1;for(const s of this.a)s.handlePossibleChange(this)}}handleChange(n,s){if(this.h.has(n)&&!this.i.has(n)){const v=this.n?this.n({changedObservable:n,change:s,didChange:o=>o===n},this.j):!0,b=this.e===3;if(v&&(this.e===1||b)&&(this.e=2,b))for(const o of this.a)o.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const s=n.get();return this.h.add(n),this.i.delete(n),s}addObserver(n){const s=!this.a.has(n)&&this.g>0;super.addObserver(n),s&&n.beginUpdate(this)}removeObserver(n){const s=this.a.has(n)&&this.g>0;super.removeObserver(n),s&&n.endUpdate(this)}}e.Derived=t}),define(p[20],_([0,1,2,8,6,9,3]),function(F,e,y,E,w,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.keepAlive=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function h(g){return new t(g)}e.constObservable=h;class t extends w.ConvenientObservable{constructor(m){super(),this.a=m}get debugName(){return this.toString()}get(){return this.a}addObserver(m){}removeObserver(m){}toString(){return`Const: ${this.a}`}}function i(g){const m=(0,w.observableValue)("promiseValue",{});return g.then(A=>{m.set({value:A},void 0)}),m}e.observableFromPromise=i;function n(g,m){return new Promise(A=>{let z=!1,c=!1;const C=(0,E.autorun)("waitForState",B=>{const O=g.read(B);m(O)&&(z?C.dispose():c=!0,A(O))});z=!0,c&&C.dispose()})}e.waitForState=n;function s(g,m){return new v(g,m)}e.observableFromEvent=s;class v extends w.BaseObservable{constructor(m,A){super(),this.h=m,this.i=A,this.f=!1,this.l=z=>{const c=this.i(z),C=!this.f||this.e!==c;(0,r.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:this.e,newValue:c,change:void 0,didChange:C}),C&&(this.e=c,this.f&&(0,w.transaction)(B=>{for(const O of this.a)B.updateObserver(O,this),O.handleChange(this,void 0)},()=>{const B=this.j();return"Event fired"+(B?`: ${B}`:"")}),this.f=!0)}}j(){return(0,w.getFunctionName)(this.i)}get debugName(){const m=this.j();return"From Event"+(m?`: ${m}`:"")}b(){this.g=this.h(this.l)}c(){this.g.dispose(),this.g=void 0,this.f=!1,this.e=void 0}get(){return this.g?(this.f||this.l(void 0),this.e):this.i(void 0)}}e.FromEventObservable=v,function(g){g.Observer=v}(s||(e.observableFromEvent=s={}));function b(g,m){return new o(g,m)}e.observableSignalFromEvent=b;class o extends w.BaseObservable{constructor(m,A){super(),this.debugName=m,this.f=A,this.h=()=>{(0,w.transaction)(z=>{for(const c of this.a)z.updateObserver(c,this),c.handleChange(this,void 0)},()=>this.debugName)}}b(){this.e=this.f(this.h)}c(){this.e.dispose(),this.e=void 0}get(){}}function a(g){return new u(g)}e.observableSignal=a;class u extends w.BaseObservable{constructor(m){super(),this.debugName=m}trigger(m,A){if(!m){(0,w.transaction)(z=>{this.trigger(z,A)},()=>`Trigger signal ${this.debugName}`);return}for(const z of this.a)m.updateObserver(z,this),z.handleChange(this,A)}get(){}}function T(g,m,A){const z=(0,w.observableValue)("debounced",void 0);let c;return A.add((0,E.autorun)("debounce",C=>{const B=g.read(C);c&&clearTimeout(c),c=setTimeout(()=>{(0,w.transaction)(O=>{z.set(B,O)})},m)})),z}e.debouncedObservable=T;function L(g,m,A){const z=(0,w.observableValue)("triggeredRecently",!1);let c;return A.add(g(()=>{z.set(!0,void 0),c&&clearTimeout(c),c=setTimeout(()=>{z.set(!1,void 0)},m)})),z}e.wasEventTriggeredRecently=L;function D(g,m){const A=new U(m??!1);return g.addObserver(A),m&&g.reportChanges(),(0,y.toDisposable)(()=>{g.removeObserver(A)})}e.keepAlive=D;class U{constructor(m){this.b=m,this.a=0}beginUpdate(m){this.a++}endUpdate(m){this.a--,this.a===0&&this.b&&m.reportChanges()}handlePossibleChange(m){}handleChange(m,A){}}function k(g,m){let A;return(0,P.derived)(g,c=>(A=m(c,A),A))}e.derivedObservableWithCache=k;function d(g,m){let A;const z=(0,w.observableValue)("derivedObservableWithWritableCache.counter",0),c=(0,P.derived)(g,C=>(z.read(C),A=m(C,A),A));return Object.assign(c,{clearCache:C=>{A=void 0,z.set(z.get()+1,C)}})}e.derivedObservableWithWritableCache=d});var re=this&&this.__createBinding||(Object.create?function(F,e,y,E){E===void 0&&(E=y);var w=Object.getOwnPropertyDescriptor(e,y);(!w||("get"in w?!e.__esModule:w.writable||w.configurable))&&(w={enumerable:!0,get:function(){return e[y]}}),Object.defineProperty(F,E,w)}:function(F,e,y,E){E===void 0&&(E=y),F[E]=e[y]}),se=this&&this.__exportStar||function(F,e){for(var y in F)y!=="default"&&!Object.prototype.hasOwnProperty.call(e,y)&&re(e,F,y)};define(p[10],_([0,1,6,9,8,20,3]),function(F,e,y,E,w,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derived=e.transaction=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return y.observableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return y.transaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return E.derived}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return w.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return w.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return w.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return w.autorunWithStore}}),se(P,e),!1&&(0,r.setLogger)(new r.ConsoleObservableLogger)}),define(p[21],_([0,1,4,2]),function(F,e,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function w(U){const k=U;return k?typeof k.read=="function":!1}e.isReadable=w;function P(U){const k=U;return k?[k.on,k.pause,k.resume,k.destroy].every(d=>typeof d=="function"):!1}e.isReadableStream=P;function r(U){const k=U;return k?P(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.isReadableBufferedStream=r;function h(U,k){return new t(U,k)}e.newWriteableStream=h;class t{constructor(k,d){this.e=k,this.f=d,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(d=>this.d.push(d))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(d=>d(k))}h(k){this.c.error.length===0?(0,y.onUnexpectedError)(k):this.c.error.slice(0).forEach(d=>d(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,d){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(d),this.resume();break;case"end":this.c.end.push(d),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(d),this.a.flowing&&this.k();break}}removeListener(k,d){if(this.a.destroyed)return;let g;switch(k){case"data":g=this.c.data;break;case"end":g=this.c.end;break;case"error":g=this.c.error;break}if(g){const m=g.indexOf(d);m>=0&&g.splice(m,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const d=[...this.d];this.d.length=0,d.forEach(g=>g())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function i(U,k){const d=[];let g;for(;(g=U.read())!==null;)d.push(g);return k(d)}e.consumeReadable=i;function n(U,k,d){const g=[];let m;for(;(m=U.read())!==null&&g.length<d;)g.push(m);return m===null&&g.length>0?k(g):{read:()=>{if(g.length>0)return g.shift();if(typeof m<"u"){const A=m;return m=void 0,A}return U.read()}}}e.peekReadable=n;function s(U,k){return new Promise((d,g)=>{const m=[];v(U,{onData:A=>{k&&m.push(A)},onError:A=>{k?g(A):d(void 0)},onEnd:()=>{d(k?k(m):void 0)}})})}e.consumeStream=s;function v(U,k){let d=!1;return U.on("error",g=>{d||k.onError(g)}),U.on("end",()=>{d||k.onEnd()}),U.on("data",g=>{d||k.onData(g)}),(0,E.toDisposable)(()=>d=!0)}e.listenStream=v;function b(U,k){return new Promise((d,g)=>{const m=new E.DisposableStore,A=[],z=B=>{if(A.push(B),A.length>k)return m.dispose(),U.pause(),d({stream:U,buffer:A,ended:!1})},c=B=>g(B),C=()=>d({stream:U,buffer:A,ended:!0});m.add((0,E.toDisposable)(()=>U.removeListener("error",c))),U.on("error",c),m.add((0,E.toDisposable)(()=>U.removeListener("end",C))),U.on("end",C),m.add((0,E.toDisposable)(()=>U.removeListener("data",z))),U.on("data",z)})}e.peekStream=b;function o(U,k){const d=h(k);return d.end(U),d}e.toStream=o;function a(){const U=h(()=>{throw new Error("not supported")});return U.end(),U}e.emptyStream=a;function u(U){let k=!1;return{read:()=>k?null:(k=!0,U)}}e.toReadable=u;function T(U,k,d){const g=h(d);return v(U,{onData:m=>g.write(k.data(m)),onError:m=>g.error(k.error?k.error(m):m),onEnd:()=>g.end()}),g}e.transform=T;function L(U,k,d){let g=!1;return{read:()=>{const m=k.read();return g?m:(g=!0,m!==null?d([U,m]):U)}}}e.prefixedReadable=L;function D(U,k,d){let g=!1;const m=h(d);return v(k,{onData:A=>g?m.write(A):(g=!0,m.write(d([U,A]))),onError:A=>m.error(A),onEnd:()=>{g||(g=!0,m.write(U)),m.end()}}),m}e.prefixedStream=D}),define(p[11],_([0,1,40,21]),function(F,e,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const w=typeof Buffer<"u",P=new y.Lazy(()=>new Uint8Array(256));let r,h;class t{static alloc(f){return w?new t(Buffer.allocUnsafe(f)):new t(new Uint8Array(f))}static wrap(f){return w&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new t(f)}static fromString(f,M){return!(M?.dontUseNodeBuffer||!1)&&w?new t(Buffer.from(f)):(r||(r=new TextEncoder),new t(r.encode(f)))}static fromByteArray(f){const M=t.alloc(f.length);for(let j=0,K=f.length;j<K;j++)M.buffer[j]=f[j];return M}static concat(f,M){if(typeof M>"u"){M=0;for(let $=0,V=f.length;$<V;$++)M+=f[$].byteLength}const j=t.alloc(M);let K=0;for(let $=0,V=f.length;$<V;$++){const W=f[$];j.set(W,K),K+=W.byteLength}return j}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=t.alloc(this.byteLength);return f.set(this),f}toString(){return w?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(f,M){return new t(this.buffer.subarray(f,M))}set(f,M){if(f instanceof t)this.buffer.set(f.buffer,M);else if(f instanceof Uint8Array)this.buffer.set(f,M);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),M);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return s(this.buffer,f)}writeUInt32BE(f,M){v(this.buffer,f,M)}readUInt32LE(f){return b(this.buffer,f)}writeUInt32LE(f,M){o(this.buffer,f,M)}readUInt8(f){return a(this.buffer,f)}writeUInt8(f,M){u(this.buffer,f,M)}indexOf(f){const M=f instanceof t?f.buffer:f,j=M.byteLength,K=this.buffer,$=K.byteLength;if(j===0)return 0;if(j===1)return K.indexOf(M[0]);if(j>$)return-1;const V=P.value;V.fill(M.length);for(let J=0;J<M.length;J++)V[M[J]]=M.length-J-1;let W=M.length-1,G=W,Z=-1;for(;W<$;)if(K[W]===M[G]){if(G===0){Z=W;break}W--,G--}else W+=Math.max(M.length-G,V[K[W]]),G=M.length-1;return Z}}e.VSBuffer=t;function i(O,f){return O[f+0]<<0>>>0|O[f+1]<<8>>>0}e.readUInt16LE=i;function n(O,f,M){O[M+0]=f&255,f=f>>>8,O[M+1]=f&255}e.writeUInt16LE=n;function s(O,f){return O[f]*2**24+O[f+1]*2**16+O[f+2]*2**8+O[f+3]}e.readUInt32BE=s;function v(O,f,M){O[M+3]=f,f=f>>>8,O[M+2]=f,f=f>>>8,O[M+1]=f,f=f>>>8,O[M]=f}e.writeUInt32BE=v;function b(O,f){return O[f+0]<<0>>>0|O[f+1]<<8>>>0|O[f+2]<<16>>>0|O[f+3]<<24>>>0}e.readUInt32LE=b;function o(O,f,M){O[M+0]=f&255,f=f>>>8,O[M+1]=f&255,f=f>>>8,O[M+2]=f&255,f=f>>>8,O[M+3]=f&255}e.writeUInt32LE=o;function a(O,f){return O[f]}e.readUInt8=a;function u(O,f,M){O[M]=f}e.writeUInt8=u;function T(O){return E.consumeReadable(O,f=>t.concat(f))}e.readableToBuffer=T;function L(O){return E.toReadable(O)}e.bufferToReadable=L;function D(O){return E.consumeStream(O,f=>t.concat(f))}e.streamToBuffer=D;async function U(O){return O.ended?t.concat(O.buffer):t.concat([...O.buffer,await D(O.stream)])}e.bufferedStreamToBuffer=U;function k(O){return E.toStream(O,f=>t.concat(f))}e.bufferToStream=k;function d(O){return E.transform(O,{data:f=>typeof f=="string"?t.fromString(f):t.wrap(f)},f=>t.concat(f))}e.streamToBufferReadableStream=d;function g(O){return E.newWriteableStream(f=>t.concat(f),O)}e.newWriteableBufferStream=g;function m(O,f){return E.prefixedReadable(O,f,M=>t.concat(M))}e.prefixedBufferReadable=m;function A(O,f){return E.prefixedStream(O,f,M=>t.concat(M))}e.prefixedBufferStream=A;function z(O){let f=0,M=0,j=0;const K=new Uint8Array(Math.floor(O.length/4*3)),$=W=>{switch(M){case 3:K[j++]=f|W,M=0;break;case 2:K[j++]=f|W>>>2,f=W<<6,M=3;break;case 1:K[j++]=f|W>>>4,f=W<<4,M=2;break;default:f=W<<2,M=1}};for(let W=0;W<O.length;W++){const G=O.charCodeAt(W);if(G>=65&&G<=90)$(G-65);else if(G>=97&&G<=122)$(G-97+26);else if(G>=48&&G<=57)$(G-48+52);else if(G===43||G===45)$(62);else if(G===47||G===95)$(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${O[W]}`)}}const V=j;for(;M>0;)$(0);return t.wrap(K).slice(0,V)}e.decodeBase64=z;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function B({buffer:O},f=!0,M=!1){const j=M?C:c;let K="";const $=O.byteLength%3;let V=0;for(;V<O.byteLength-$;V+=3){const W=O[V+0],G=O[V+1],Z=O[V+2];K+=j[W>>>2],K+=j[(W<<4|G>>>4)&63],K+=j[(G<<2|Z>>>6)&63],K+=j[Z&63]}if($===1){const W=O[V+0];K+=j[W>>>2],K+=j[W<<4&63],f&&(K+="==")}else if($===2){const W=O[V+0],G=O[V+1];K+=j[W>>>2],K+=j[(W<<4|G>>>4)&63],K+=j[G<<2&63],f&&(K+="=")}return K}e.encodeBase64=B}),define(p[22],_([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(p[12],_([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var y;(function(w){w[w.Unknown=0]="Unknown",w[w.Invalid=3]="Invalid",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(y||(e.StringEOL=y={}));function E(w){let P=0,r=0,h=0,t=0;for(let i=0,n=w.length;i<n;i++){const s=w.charCodeAt(i);s===13?(P===0&&(r=i),P++,i+1<n&&w.charCodeAt(i+1)===10?(t|=2,i++):t|=3,h=i+1):s===10&&(t|=1,P===0&&(r=i),P++,h=i+1)}return P===0&&(r=w.length),[P,r,w.length-h,t]}e.countEOL=E}),define(p[13],_([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var y;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(y||(e.LanguageId=y={}));var E;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(E||(e.FontStyle=E={}));var w;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(w||(e.ColorId=w={}));var P;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(P||(e.StandardTokenType=P={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class h{static getLanguageId(i){return(i&255)>>>0}static getTokenType(i){return(i&768)>>>8}static containsBalancedBrackets(i){return(i&1024)!==0}static getFontStyle(i){return(i&30720)>>>11}static getForeground(i){return(i&16744448)>>>15}static getBackground(i){return(i&4278190080)>>>24}static getClassNameFromMetadata(i){let s="mtk"+this.getForeground(i);const v=this.getFontStyle(i);return v&1&&(s+=" mtki"),v&2&&(s+=" mtkb"),v&4&&(s+=" mtku"),v&8&&(s+=" mtks"),s}static getInlineStyleFromMetadata(i,n){const s=this.getForeground(i),v=this.getFontStyle(i);let b=`color: ${n[s]};`;v&1&&(b+="font-style: italic;"),v&2&&(b+="font-weight: bold;");let o="";return v&4&&(o+=" underline"),v&8&&(o+=" line-through"),o&&(b+=`text-decoration:${o};`),b}static getPresentationFromMetadata(i){const n=this.getForeground(i),s=this.getFontStyle(i);return{foreground:n,italic:!!(s&1),bold:!!(s&2),underline:!!(s&4),strikethrough:!!(s&8)}}}e.TokenMetadata=h}),define(p[23],_([0,1,24]),function(F,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class E{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,h){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=h}replace(r,h,t){if(r>=this.a.length)return;if(h===0){this.insert(r,t);return}else if(t===0){this.delete(r,h);return}const i=this.a.slice(0,r),n=this.a.slice(r+h),s=w(t,this.b);this.a=i.concat(s,n)}delete(r,h){h===0||r>=this.a.length||this.a.splice(r,h)}insert(r,h){if(h===0||r>=this.a.length)return;const t=[];for(let i=0;i<h;i++)t[i]=this.b;this.a=(0,y.arrayInsert)(this.a,r,t)}}e.FixedArray=E;function w(P,r){const h=[];for(let t=0;t<P;t++)h[t]=r;return h}}),define(p[7],_([0,1,13]),function(F,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class E{static createEmpty(r,h){const t=E.defaultTokenMetadata,i=new Uint32Array(2);return i[0]=r.length,i[1]=t,new E(i,r,h)}constructor(r,h,t){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=h,this.d=t}equals(r){return r instanceof E?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,h,t){if(this.c!==r.c||this.b!==r.b)return!1;const i=h<<1,n=i+(t<<1);for(let s=i;s<n;s++)if(this.a[s]!==r.a[s])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const h=this.a[(r<<1)+1],t=y.TokenMetadata.getLanguageId(h);return this.d.decodeLanguageId(t)}getStandardTokenType(r){const h=this.a[(r<<1)+1];return y.TokenMetadata.getTokenType(h)}getForeground(r){const h=this.a[(r<<1)+1];return y.TokenMetadata.getForeground(h)}getClassName(r){const h=this.a[(r<<1)+1];return y.TokenMetadata.getClassNameFromMetadata(h)}getInlineStyle(r,h){const t=this.a[(r<<1)+1];return y.TokenMetadata.getInlineStyleFromMetadata(t,h)}getPresentation(r){const h=this.a[(r<<1)+1];return y.TokenMetadata.getPresentationFromMetadata(h)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return E.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,h,t){return new w(this,r,h,t)}static convertToEndOffset(r,h){const i=(r.length>>>1)-1;for(let n=0;n<i;n++)r[n<<1]=r[n+1<<1];r[i<<1]=h}static findIndexInTokensArray(r,h){if(r.length<=2)return 0;let t=0,i=(r.length>>>1)-1;for(;t<i;){const n=t+Math.floor((i-t)/2),s=r[n<<1];if(s===h)return n+1;s<h?t=n+1:s>h&&(i=n)}return t}withInserted(r){if(r.length===0)return this;let h=0,t=0,i="";const n=new Array;let s=0;for(;;){const v=h<this.b?this.a[h<<1]:-1,b=t<r.length?r[t]:null;if(v!==-1&&(b===null||v<=b.offset)){i+=this.c.substring(s,v);const o=this.a[(h<<1)+1];n.push(i.length,o),h++,s=v}else if(b){if(b.offset>s){i+=this.c.substring(s,b.offset);const o=this.a[(h<<1)+1];n.push(i.length,o),s=b.offset}i+=b.text,n.push(i.length,b.tokenMetadata),t++}else break}return new E(new Uint32Array(n),i,this.d)}}e.LineTokens=E,E.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0;class w{constructor(r,h,t,i){this.a=r,this.b=h,this.c=t,this.d=i,this.e=r.findTokenIndexAtOffset(h),this.f=0;for(let n=this.e,s=r.getCount();n<s&&!(r.getStartOffset(n)>=t);n++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof w?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const h=this.a.getEndOffset(this.e+r);return Math.min(this.c,h)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,h){return this.a.getInlineStyle(this.e+r,h)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(p[25],_([0,1,7]),function(F,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class E{static deleteBeginning(r,h){return r===null||r===e.EMPTY_LINE_TOKENS?r:E.delete(r,0,h)}static deleteEnding(r,h){if(r===null||r===e.EMPTY_LINE_TOKENS)return r;const t=w(r),i=t[t.length-2];return E.delete(r,h,i)}static delete(r,h,t){if(r===null||r===e.EMPTY_LINE_TOKENS||h===t)return r;const i=w(r),n=i.length>>>1;if(h===0&&i[i.length-2]===t)return e.EMPTY_LINE_TOKENS;const s=y.LineTokens.findIndexInTokensArray(i,h),v=s>0?i[s-1<<1]:0,b=i[s<<1];if(t<b){const L=t-h;for(let D=s;D<n;D++)i[D<<1]-=L;return r}let o,a;v!==h?(i[s<<1]=h,o=s+1<<1,a=h):(o=s<<1,a=v);const u=t-h;for(let L=s+1;L<n;L++){const D=i[L<<1]-u;D>a&&(i[o++]=D,i[o++]=i[(L<<1)+1],a=D)}if(o===i.length)return r;const T=new Uint32Array(o);return T.set(i.subarray(0,o),0),T.buffer}static append(r,h){if(h===e.EMPTY_LINE_TOKENS)return r;if(r===e.EMPTY_LINE_TOKENS)return h;if(r===null)return r;if(h===null)return null;const t=w(r),i=w(h),n=i.length>>>1,s=new Uint32Array(t.length+i.length);s.set(t,0);let v=t.length;const b=t[t.length-2];for(let o=0;o<n;o++)s[v++]=i[o<<1]+b,s[v++]=i[(o<<1)+1];return s.buffer}static insert(r,h,t){if(r===null||r===e.EMPTY_LINE_TOKENS)return r;const i=w(r),n=i.length>>>1;let s=y.LineTokens.findIndexInTokensArray(i,h);s>0&&i[s-1<<1]===h&&s--;for(let v=s;v<n;v++)i[v<<1]+=t;return r}}e.ContiguousTokensEditing=E;function w(P){return P instanceof Uint32Array?P:new Uint32Array(P)}e.toUint32Array=w}),define(p[26],_([0,1,24,11,41,12,25,14]),function(F,e,y,E,w,P,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(n,s,v){const b=new Uint32Array(n.buffer),o=(0,E.readUInt32BE)(n,s);s+=4;const a=(0,E.readUInt32BE)(n,s);s+=4;const u=[];for(let T=0;T<a;T++){const L=(0,E.readUInt32BE)(n,s);s+=4,u.push(b.subarray(s/4,s/4+L/4)),s+=L}return v.push(new t(o,u)),s}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(n,s){this.a=n,this.b=s}getLineRange(){return new h.LineRange(this.a,this.a+this.b.length)}getLineTokens(n){return this.b[n-this.a]}appendLineTokens(n){this.b.push(n)}serializeSize(){let n=0;n+=4,n+=4;for(let s=0;s<this.b.length;s++){const v=this.b[s];if(!(v instanceof Uint32Array))throw new Error("Not supported!");n+=4,n+=v.byteLength}return n}serialize(n,s){(0,E.writeUInt32BE)(n,this.a,s),s+=4,(0,E.writeUInt32BE)(n,this.b.length,s),s+=4;for(let v=0;v<this.b.length;v++){const b=this.b[v];if(!(b instanceof Uint32Array))throw new Error("Not supported!");(0,E.writeUInt32BE)(n,b.byteLength,s),s+=4,n.set(new Uint8Array(b.buffer),s),s+=b.byteLength}return s}applyEdit(n,s){const[v,b]=(0,P.countEOL)(s);this.c(n),this.d(new w.Position(n.startLineNumber,n.startColumn),v,b)}c(n){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return;const s=n.startLineNumber-this.a,v=n.endLineNumber-this.a;if(v<0){const b=v-s;this.a-=b;return}if(!(s>=this.b.length)){if(s<0&&v>=this.b.length){this.a=0,this.b=[];return}if(s===v){this.b[s]=r.ContiguousTokensEditing.delete(this.b[s],n.startColumn-1,n.endColumn-1);return}if(s>=0)if(this.b[s]=r.ContiguousTokensEditing.deleteEnding(this.b[s],n.startColumn-1),v<this.b.length){const b=r.ContiguousTokensEditing.deleteBeginning(this.b[v],n.endColumn-1);this.b[s]=r.ContiguousTokensEditing.append(this.b[s],b),this.b.splice(s+1,v-s)}else this.b[s]=r.ContiguousTokensEditing.append(this.b[s],null),this.b=this.b.slice(0,s+1);else{const b=-s;this.a-=b,this.b[v]=r.ContiguousTokensEditing.deleteBeginning(this.b[v],n.endColumn-1),this.b=this.b.slice(v)}}}d(n,s,v){if(s===0&&v===0)return;const b=n.lineNumber-this.a;if(b<0){this.a+=s;return}if(!(b>=this.b.length)){if(s===0){this.b[b]=r.ContiguousTokensEditing.insert(this.b[b],n.column-1,v);return}this.b[b]=r.ContiguousTokensEditing.deleteEnding(this.b[b],n.column-1),this.b[b]=r.ContiguousTokensEditing.insert(this.b[b],n.column-1,v),this.e(n.lineNumber,s)}}e(n,s){if(s===0)return;const v=[];for(let b=0;b<s;b++)v[b]=null;this.b=y.arrayInsert(this.b,n,v)}}e.ContiguousMultilineTokens=t}),define(p[15],_([0,1,11,26]),function(F,e,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class w{static deserialize(r){let h=0;const t=(0,y.readUInt32BE)(r,h);h+=4;const i=[];for(let n=0;n<t;n++)h=E.ContiguousMultilineTokens.deserialize(r,h,i);return i}constructor(){this.a=[]}add(r,h){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(h);return}}this.a.push(new E.ContiguousMultilineTokens(r,[h]))}finalize(){return this.a}serialize(){const r=this.b(),h=new Uint8Array(r);return this.c(h),h}b(){let r=0;r+=4;for(let h=0;h<this.a.length;h++)r+=this.a[h].serializeSize();return r}c(r){let h=0;(0,y.writeUInt32BE)(r,this.a.length,h),h+=4;for(let t=0;t<this.a.length;t++)h=this.a[t].serialize(r,h)}}e.ContiguousMultilineTokensBuilder=w}),define(p[27],_([0,1,28,5,29,42]),function(F,e,y,E,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function r(c){return c===47||c===92}e.isPathSeparator=r;function h(c){return c.replace(/[\\/]/g,y.posix.sep)}e.toSlashes=h;function t(c){return c.indexOf("/")===-1&&(c=h(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=t;function i(c,C=y.posix.sep){if(!c)return"";const B=c.length,O=c.charCodeAt(0);if(r(O)){if(r(c.charCodeAt(1))&&!r(c.charCodeAt(2))){let M=3;const j=M;for(;M<B&&!r(c.charCodeAt(M));M++);if(j!==M&&!r(c.charCodeAt(M+1))){for(M+=1;M<B;M++)if(r(c.charCodeAt(M)))return c.slice(0,M+1).replace(/[\\/]/g,C)}}return C}else if(T(O)&&c.charCodeAt(1)===58)return r(c.charCodeAt(2))?c.slice(0,2)+C:c.slice(0,2);let f=c.indexOf("://");if(f!==-1){for(f+=3;f<B;f++)if(r(c.charCodeAt(f)))return c.slice(0,f+1)}return""}e.getRoot=i;function n(c){if(!E.isWindows||!c||c.length<5)return!1;let C=c.charCodeAt(0);if(C!==92||(C=c.charCodeAt(1),C!==92))return!1;let B=2;const O=B;for(;B<c.length&&(C=c.charCodeAt(B),C!==92);B++);return!(O===B||(C=c.charCodeAt(B+1),isNaN(C)||C===92))}e.isUNC=n;const s=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(c,C=E.isWindows){const B=C?s:v;return!(!c||c.length===0||/^\s+$/.test(c)||(B.lastIndex=0,B.test(c))||C&&b.test(c)||c==="."||c===".."||C&&c[c.length-1]==="."||C&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=o;function a(c,C,B){const O=c===C;return!B||O?O:!c||!C?!1:(0,w.equalsIgnoreCase)(c,C)}e.isEqual=a;function u(c,C,B,O=y.sep){if(c===C)return!0;if(!c||!C||C.length>c.length)return!1;if(B){if(!(0,w.startsWithIgnoreCase)(c,C))return!1;if(C.length===c.length)return!0;let M=C.length;return C.charAt(C.length-1)===O&&M--,c.charAt(M)===O}return C.charAt(C.length-1)!==O&&(C+=O),c.indexOf(C)===0}e.isEqualOrParent=u;function T(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=T;function L(c,C){return E.isWindows&&c.endsWith(":")&&(c+=y.sep),(0,y.isAbsolute)(c)||(c=(0,y.join)(C,c)),c=(0,y.normalize)(c),E.isWindows?(c=(0,w.rtrim)(c,y.sep),c.endsWith(":")&&(c+=y.sep)):(c=(0,w.rtrim)(c,y.sep),c||(c=y.sep)),c}e.sanitizeFilePath=L;function D(c){const C=(0,y.normalize)(c);return E.isWindows?c.length>3?!1:U(C)&&(c.length===2||C.charCodeAt(2)===92):C===y.posix.sep}e.isRootOrDriveLetter=D;function U(c,C=E.isWindows){return C?T(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=U;function k(c,C=E.isWindows){return U(c,C)?c[0]:void 0}e.getDriveLetter=k;function d(c,C,B){return C.length>c.length?-1:c===C?0:(B&&(c=c.toLowerCase(),C=C.toLowerCase()),c.indexOf(C))}e.indexOfPath=d;function g(c){const C=c.split(":");let B,O,f;for(const M of C){const j=Number(M);(0,P.isNumber)(j)?O===void 0?O=j:f===void 0&&(f=j):B=B?[B,M].join(":"):M}if(!B)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:B,line:O!==void 0?O:void 0,column:f!==void 0?f:O!==void 0?1:void 0}}e.parseLineAndColumnAware=g;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",A="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function z(c,C,B=8){let O="";for(let M=0;M<B;M++){let j;M===0&&E.isWindows&&!C&&(B===3||B===4)?j=A:j=m,O+=j.charAt(Math.floor(Math.random()*j.length))}let f;return C?f=`${C}-${O}`:f=O,c?(0,y.join)(c,f):f}e.randomPath=z}),define(p[30],_([0,1,4,5,16]),function(F,e,y,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var P;(function(i){i.inMemory="inmemory",i.vscode="vscode",i.internal="private",i.walkThrough="walkThrough",i.walkThroughSnippet="walkThroughSnippet",i.http="http",i.https="https",i.file="file",i.mailto="mailto",i.untitled="untitled",i.data="data",i.command="command",i.vscodeRemote="vscode-remote",i.vscodeRemoteResource="vscode-remote-resource",i.vscodeUserData="vscode-userdata",i.vscodeCustomEditor="vscode-custom-editor",i.vscodeNotebookCell="vscode-notebook-cell",i.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",i.vscodeNotebookCellOutput="vscode-notebook-cell-output",i.vscodeInteractive="vscode-interactive",i.vscodeInteractiveInput="vscode-interactive-input",i.vscodeSettings="vscode-settings",i.vscodeWorkspaceTrust="vscode-workspace-trust",i.vscodeTerminal="vscode-terminal",i.vscodeChatSesssion="vscode-chat-editor",i.webviewPanel="webview-panel",i.vscodeWebview="vscode-webview",i.extension="extension",i.vscodeFileResource="vscode-file",i.tmp="tmp",i.vsls="vsls",i.vscodeSourceControl="vscode-scm"})(P||(e.Schemas=P={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class r{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${P.vscodeRemoteResource}`}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n){this.f=`${n}/${P.vscodeRemoteResource}`}set(n,s,v){this.a[n]=s,this.b[n]=v}setConnectionToken(n,s){this.c[n]=s}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(u){return y.onUnexpectedError(u),n}const s=n.authority;let v=this.a[s];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const b=this.b[s],o=this.c[s];let a=`path=${encodeURIComponent(n.path)}`;return typeof o=="string"&&(a+=`&${e.connectionTokenQueryName}=${encodeURIComponent(o)}`),w.URI.from({scheme:E.isWeb?this.d:P.vscodeRemoteResource,authority:`${v}:${b}`,path:this.f,query:a})}}e.RemoteAuthorities=new r,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class h{asBrowserUri(n){const s=this.b(n,F);return this.uriToBrowserUri(s)}uriToBrowserUri(n){return n.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===P.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${P.vscodeFileResource}://${h.a}`)?n.with({scheme:P.vscodeFileResource,authority:n.authority||h.a,query:null,fragment:null}):n}asFileUri(n){const s=this.b(n,F);return this.uriToFileUri(s)}uriToFileUri(n){return n.scheme===P.vscodeFileResource?n.with({scheme:P.file,authority:n.authority!==h.a?n.authority:null,query:null,fragment:null}):n}b(n,s){return w.URI.isUri(n)?n:w.URI.parse(s.toUrl(n))}}h.a="vscode-app",e.FileAccess=new h;var t;(function(i){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);i.CoopAndCoep=Object.freeze(n.get("3"));const s="vscode-coi";function v(o){let a;typeof o=="string"?a=new URL(o).searchParams:o instanceof URL?a=o.searchParams:w.URI.isUri(o)&&(a=new URL(o.toString(!0)).searchParams);const u=a?.get(s);if(u)return n.get(u)}i.getHeadersFromQuery=v;function b(o,a,u){if(!globalThis.crossOriginIsolated)return;const T=a&&u?"3":u?"2":"1";o instanceof URLSearchParams?o.set(s,T):o[s]=T}i.addSearchParam=b})(t||(e.COI=t={}))}),define(p[17],_([0,1,27,30,28,5,29,16]),function(F,e,y,E,w,P,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(b){return(0,h.uriToFsPath)(b,!0)}e.originalFSPath=t;class i{constructor(o){this.a=o}compare(o,a,u=!1){return o===a?0:(0,r.compare)(this.getComparisonKey(o,u),this.getComparisonKey(a,u))}isEqual(o,a,u=!1){return o===a?!0:!o||!a?!1:this.getComparisonKey(o,u)===this.getComparisonKey(a,u)}getComparisonKey(o,a=!1){return o.with({path:this.a(o)?o.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(o){return this.a(o)}isEqualOrParent(o,a,u=!1){if(o.scheme===a.scheme){if(o.scheme===E.Schemas.file)return y.isEqualOrParent(t(o),t(a),this.a(o))&&o.query===a.query&&(u||o.fragment===a.fragment);if((0,e.isEqualAuthority)(o.authority,a.authority))return y.isEqualOrParent(o.path,a.path,this.a(o),"/")&&o.query===a.query&&(u||o.fragment===a.fragment)}return!1}joinPath(o,...a){return h.URI.joinPath(o,...a)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return w.posix.basename(o.path)}extname(o){return w.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let a;return o.scheme===E.Schemas.file?a=h.URI.file(w.dirname(t(o))).path:(a=w.posix.dirname(o.path),o.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),a="/")),o.with({path:a})}normalizePath(o){if(!o.path.length)return o;let a;return o.scheme===E.Schemas.file?a=h.URI.file(w.normalize(t(o))).path:a=w.posix.normalize(o.path),o.with({path:a})}relativePath(o,a){if(o.scheme!==a.scheme||!(0,e.isEqualAuthority)(o.authority,a.authority))return;if(o.scheme===E.Schemas.file){const L=w.relative(t(o),t(a));return P.isWindows?y.toSlashes(L):L}let u=o.path||"/";const T=a.path||"/";if(this.a(o)){let L=0;for(const D=Math.min(u.length,T.length);L<D&&!(u.charCodeAt(L)!==T.charCodeAt(L)&&u.charAt(L).toLowerCase()!==T.charAt(L).toLowerCase());L++);u=T.substr(0,L)+u.substr(L)}return w.posix.relative(u,T)}resolvePath(o,a){if(o.scheme===E.Schemas.file){const u=h.URI.file(w.resolve(t(o),a));return o.with({authority:u.authority,path:u.path})}return a=y.toPosixPath(a),o.with({path:w.posix.resolve(o.path,a)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,a){return o===a||o!==void 0&&a!==void 0&&(0,r.equalsIgnoreCase)(o,a)}hasTrailingPathSeparator(o,a=w.sep){if(o.scheme===E.Schemas.file){const u=t(o);return u.length>y.getRoot(u).length&&u[u.length-1]===a}else{const u=o.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,a=w.sep){return(0,e.hasTrailingPathSeparator)(o,a)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,a=w.sep){let u=!1;if(o.scheme===E.Schemas.file){const T=t(o);u=T!==void 0&&T.length===y.getRoot(T).length&&T[T.length-1]===a}else{a="/";const T=o.path;u=T.length===1&&T.charCodeAt(T.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(o,a)?o.with({path:o.path+"/"}):o}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(b=>b.scheme===E.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new i(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(b,o){const a=[];for(let u=0;u<b.length;u++){const T=o(b[u]);b.some((L,D)=>D===u?!1:(0,e.isEqualOrParent)(T,o(L)))||a.push(b[u])}return a}e.distinctParents=n;var s;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function o(a){const u=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(D=>{const[U,k]=D.split(":");U&&k&&u.set(U,k)});const L=a.path.substring(0,a.path.indexOf(";"));return L&&u.set(b.META_DATA_MIME,L),u}b.parseMetaData=o})(s||(e.DataUri=s={}));function v(b,o,a){if(o){let u=b.path;return u&&u[0]!==w.posix.sep&&(u=w.posix.sep+u),b.with({scheme:a,authority:o,path:u})}return b.with({scheme:a})}e.toLocalResource=v}),define(p[18],_([0,1,43,4,31,2,17,5,22]),function(F,e,y,E,w,P,r,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function i(R){return!!R&&typeof R.then=="function"}e.isThenable=i;function n(R){const l=new y.CancellationTokenSource,S=R(l.token),I=new Promise((N,q)=>{const H=l.token.onCancellationRequested(()=>{H.dispose(),l.dispose(),q(new E.CancellationError)});Promise.resolve(S).then(Q=>{H.dispose(),l.dispose(),N(Q)},Q=>{H.dispose(),l.dispose(),q(Q)})});return new class{cancel(){l.cancel()}then(N,q){return I.then(N,q)}catch(N){return this.then(void 0,N)}finally(N){return I.finally(N)}}}e.createCancelablePromise=n;function s(R,l,S){return new Promise((I,N)=>{const q=l.onCancellationRequested(()=>{q.dispose(),I(S)});R.then(I,N).finally(()=>q.dispose())})}e.raceCancellation=s;function v(R,l){return new Promise((S,I)=>{const N=l.onCancellationRequested(()=>{N.dispose(),I(new E.CancellationError)});R.then(S,I).finally(()=>N.dispose())})}e.raceCancellationError=v;async function b(R){let l=-1;const S=R.map((I,N)=>I.then(q=>(l=N,q)));try{return await Promise.race(S)}finally{R.forEach((I,N)=>{N!==l&&I.cancel()})}}e.raceCancellablePromises=b;function o(R,l,S){let I;const N=setTimeout(()=>{I?.(void 0),S?.()},l);return Promise.race([R.finally(()=>clearTimeout(N)),new Promise(q=>I=q)])}e.raceTimeout=o;function a(R){return new Promise((l,S)=>{const I=R();i(I)?I.then(l,S):l(I)})}e.asPromise=a;class u{constructor(){this.a=null,this.b=null,this.d=null}queue(l){if(this.a){if(this.d=l,!this.b){const S=()=>{this.b=null;const I=this.queue(this.d);return this.d=null,I};this.b=new Promise(I=>{this.a.then(S,S).then(I)})}return new Promise((S,I)=>{this.b.then(S,I)})}return this.a=l(),new Promise((S,I)=>{this.a.then(N=>{this.a=null,S(N)},N=>{this.a=null,I(N)})})}}e.Throttler=u;class T{constructor(){this.a=Promise.resolve(null)}queue(l){return this.a=this.a.then(()=>l(),()=>l())}}e.Sequencer=T;class L{constructor(){this.a=new Map}queue(l,S){const N=(this.a.get(l)??Promise.resolve()).catch(()=>{}).then(S).finally(()=>{this.a.get(l)===N&&this.a.delete(l)});return this.a.set(l,N),N}}e.SequencerByKey=L;const D=(R,l)=>{let S=!0;const I=setTimeout(()=>{S=!1,l()},R);return{isTriggered:()=>S,dispose:()=>{clearTimeout(I),S=!1}}},U=R=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,R())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class k{constructor(l){this.defaultDelay=l,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(l,S=this.defaultDelay){this.g=l,this.h(),this.b||(this.b=new Promise((N,q)=>{this.d=N,this.f=q}).then(()=>{if(this.b=null,this.d=null,this.g){const N=this.g;return this.g=null,N()}}));const I=()=>{this.a=null,this.d?.(null)};return this.a=S===t.MicrotaskDelay?U(I):D(S,I),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new E.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=k;class d{constructor(l){this.a=new k(l),this.b=new u}trigger(l,S){return this.a.trigger(()=>this.b.queue(l),S)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=d;class g{constructor(){this.a=!1,this.b=new Promise((l,S)=>{this.d=l})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=g;class m extends g{constructor(l){super(),this.f=setTimeout(()=>this.open(),l)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=m;function A(R,l){return l?new Promise((S,I)=>{const N=setTimeout(()=>{q.dispose(),S()},R),q=l.onCancellationRequested(()=>{clearTimeout(N),q.dispose(),I(new E.CancellationError)})}):n(S=>A(R,S))}e.timeout=A;function z(R,l=0){const S=setTimeout(R,l);return(0,P.toDisposable)(()=>clearTimeout(S))}e.disposableTimeout=z;function c(R){const l=[];let S=0;const I=R.length;function N(){return S<I?R[S++]():null}function q(H){H!=null&&l.push(H);const Q=N();return Q?Q.then(q):Promise.resolve(l)}return Promise.resolve(null).then(q)}e.sequence=c;function C(R,l=I=>!!I,S=null){let I=0;const N=R.length,q=()=>{if(I>=N)return Promise.resolve(S);const H=R[I++];return Promise.resolve(H()).then(X=>l(X)?Promise.resolve(X):q())};return q()}e.first=C;function B(R,l=I=>!!I,S=null){if(R.length===0)return Promise.resolve(S);let I=R.length;const N=()=>{I=-1;for(const q of R)q.cancel?.()};return new Promise((q,H)=>{for(const Q of R)Q.then(X=>{--I>=0&&l(X)?(N(),q(X)):I===0&&q(S)}).catch(X=>{--I>=0&&(N(),H(X))})})}e.firstParallel=B;class O{constructor(l){this.a=0,this.d=l,this.f=[],this.b=0,this.g=new w.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(l){return this.a++,new Promise((S,I)=>{this.f.push({factory:l,c:S,e:I}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const l=this.f.shift();this.b++;const S=l.factory();S.then(l.c,l.e),S.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=O;class f extends O{constructor(){super(1)}}e.Queue=f;class M{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const l=new ee;return this.b.add(l),l.p}d(){for(const[,l]of this.a)if(l.size>0)return!1;return!0}queueFor(l,S=r.extUri){const I=S.getComparisonKey(l);let N=this.a.get(I);return N||(N=new f,w.Event.once(N.onDrained)(()=>{N?.dispose(),this.a.delete(I),this.f()}),this.a.set(I,N)),N}f(){this.d()&&this.g()}g(){for(const l of this.b)l.complete();this.b.clear()}dispose(){for(const[,l]of this.a)l.dispose();this.a.clear(),this.g()}}e.ResourceQueue=M;class j{constructor(l,S){this.a=-1,typeof l=="function"&&typeof S=="number"&&this.setIfNotSet(l,S)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(l,S){this.cancel(),this.a=setTimeout(()=>{this.a=-1,l()},S)}setIfNotSet(l,S){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,l()},S))}}e.TimeoutTimer=j;class K{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(l,S){this.cancel(),this.a=setInterval(()=>{l()},S)}}e.IntervalTimer=K;class ${constructor(l,S){this.b=-1,this.a=l,this.d=S,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(l=this.d){this.cancel(),this.b=setTimeout(this.f,l)}get delay(){return this.d}set delay(l){this.d=l}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=$;class V{constructor(l,S){S%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${S}ms is not a multiple of 1000ms.`),this.a=l,this.b=S,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(l=this.b){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(l/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class W extends ${constructor(l,S){super(l,S),this.j=[]}work(l){this.j.push(l),this.isScheduled()||this.schedule()}h(){const l=this.j;this.j=[],this.a?.(l)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=W;class G extends P.Disposable{constructor(l,S){super(),this.g=l,this.h=S,this.a=[],this.b=this.B(new P.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(l){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+l.length>this.g.maxBufferedWork)return!1}else if(this.pending+l.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const S of l)this.a.push(S);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new $(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=G,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=R=>{(0,h.setTimeout0)(()=>{if(l)return;const S=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,S-Date.now())}}))});let l=!1;return{dispose(){l||(l=!0)}}}:e.runWhenIdle=(R,l)=>{const S=requestIdleCallback(R,typeof l=="number"?{timeout:l}:void 0);let I=!1;return{dispose(){I||(I=!0,cancelIdleCallback(S))}}}}();class Z{constructor(l){this.d=!1,this.a=()=>{try{this.f=l()}catch(S){this.g=S}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=Z;async function J(R,l,S){let I;for(let N=0;N<S;N++)try{return await R()}catch(q){I=q,await A(l)}throw I}e.retry=J;class ae{hasPending(l){return this.a?typeof l=="number"?this.a.taskId===l:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(l,S,I){return this.a={taskId:l,cancel:()=>I?.(),promise:S},S.then(()=>this.d(l),()=>this.d(l)),S}d(l){this.a&&l===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const l=this.b;this.b=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}setNext(l){if(this.b)this.b.run=l;else{let S,I;const N=new Promise((q,H)=>{S=q,I=H});this.b={run:l,promise:N,promiseResolve:S,promiseReject:I}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=ae;class oe{constructor(l,S=()=>Date.now()){this.d=l,this.f=S,this.a=0,this.b=0}increment(){const l=this.f();return l-this.a>this.d&&(this.a=l,this.b=0),this.b++,this.b}}e.IntervalCounter=oe;var x;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(x||(x={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((l,S)=>{this.a=l,this.b=S})}complete(l){return new Promise(S=>{this.a(l),this.d={outcome:0,value:l},S()})}error(l){return new Promise(S=>{this.b(l),this.d={outcome:1,value:l},S()})}cancel(){return this.error(new E.CancellationError)}}e.DeferredPromise=ee;var te;(function(R){async function l(I){let N;const q=await Promise.all(I.map(H=>H.then(Q=>Q,Q=>{N||(N=Q)})));if(typeof N<"u")throw N;return q}R.settled=l;function S(I){return new Promise(async(N,q)=>{try{await I(N,q)}catch(H){q(H)}})}R.withAsyncBody=S})(te||(e.Promises=te={}));var ne;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(ne||(ne={}));class Y{static fromArray(l){return new Y(S=>{S.emitMany(l)})}static fromPromise(l){return new Y(async S=>{S.emitMany(await l)})}static fromPromises(l){return new Y(async S=>{await Promise.all(l.map(async I=>S.emitOne(await I)))})}static merge(l){return new Y(async S=>{await Promise.all(l.map(async I=>{for await(const N of I)S.emitOne(N)}))})}constructor(l){this.a=0,this.b=[],this.d=null,this.f=new w.Emitter,queueMicrotask(async()=>{const S={emitOne:I=>this.g(I),emitMany:I=>this.h(I),reject:I=>this.k(I)};try{await Promise.resolve(l(S)),this.j()}catch(I){this.k(I)}finally{S.emitOne=void 0,S.emitMany=void 0,S.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(l<this.b.length)return{done:!1,value:this.b[l++]};if(this.a===1)return{done:!0,value:void 0};await w.Event.toPromise(this.f.event)}while(!0)}}}static map(l,S){return new Y(async I=>{for await(const N of l)I.emitOne(S(N))})}map(l){return Y.map(this,l)}static filter(l,S){return new Y(async I=>{for await(const N of l)S(N)&&I.emitOne(N)})}filter(l){return Y.filter(this,l)}static coalesce(l){return Y.filter(l,S=>!!S)}coalesce(){return Y.coalesce(this)}static async toPromise(l){const S=[];for await(const I of l)S.push(I);return S}toPromise(){return Y.toPromise(this)}g(l){this.a===0&&(this.b.push(l),this.f.fire())}h(l){this.a===0&&(this.b=this.b.concat(l),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(l){this.a===0&&(this.a=2,this.d=l,this.f.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class ie extends Y{constructor(l,S){super(S),this.l=l}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ie;function ue(R){const l=new y.CancellationTokenSource,S=R(l.token);return new ie(l,async I=>{const N=l.token.onCancellationRequested(()=>{N.dispose(),l.dispose(),I.reject(new E.CancellationError)});try{for await(const q of S){if(l.token.isCancellationRequested)return;I.emitOne(q)}N.dispose(),l.dispose()}catch(q){N.dispose(),l.dispose(),I.reject(q)}})}e.createCancelableAsyncIterable=ue}),define(p[19],_([0,1,32]),function(F,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(P){return this===P}};function E(P,r){return new y.TokenizationResult([new y.Token(0,"",P)],r)}e.nullTokenize=E;function w(P,r){const h=new Uint32Array(2);return h[0]=0,h[1]=(P<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new y.EncodedTokenizationResult(h,r===null?e.NullState:r)}e.nullTokenizeEncoded=w}),define(p[33],_([0,1,18,4,5,44,12,14,45,19,23,15,7]),function(F,e,y,E,w,P,r,h,t,i,n,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var b;(function(k){k[k.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(b||(b={}));class o{constructor(d,g){this.tokenizationSupport=g,this.a=this.tokenizationSupport.getInitialState(),this.store=new u(d)}getStartState(d){return d===1?this.a:this.store.getEndState(d-1)}}e.TokenizerWithStateStore=o;class a extends o{constructor(d,g,m,A){super(d,g),this._textModel=m,this._languageIdCodec=A}updateTokensUntilLine(d,g){const m=this._textModel.getLanguageId();for(;;){const A=this.store.getFirstInvalidEndStateLineNumber();if(!A||A>g)break;const z=this._textModel.getLineContent(A),c=this.getStartState(A),C=D(this._languageIdCodec,m,this.tokenizationSupport,z,!0,c);d.add(A,C.tokens),this.store.setEndState(A,C.endState)}}getTokenTypeIfInsertingCharacter(d,g){const m=this.getStartState(d.lineNumber);if(!m)return 0;const A=this._textModel.getLanguageId(),z=this._textModel.getLineContent(d.lineNumber),c=z.substring(0,d.column-1)+g+z.substring(d.column-1),C=D(this._languageIdCodec,A,this.tokenizationSupport,c,!0,m),B=new v.LineTokens(C.tokens,c,this._languageIdCodec);if(B.getCount()===0)return 0;const O=B.findTokenIndexAtOffset(d.column-1);return B.getStandardTokenType(O)}tokenizeLineWithEdit(d,g,m){const A=d.lineNumber,z=d.column,c=this.getStartState(A);if(!c)return null;const C=this._textModel.getLineContent(A),B=C.substring(0,z-1)+m+C.substring(z-1+g),O=this._textModel.getLanguageIdAtPosition(A,0),f=D(this._languageIdCodec,O,this.tokenizationSupport,B,!0,c);return new v.LineTokens(f.tokens,B,this._languageIdCodec)}isCheapToTokenize(d){const g=this.store.getFirstInvalidEndStateLineNumberOrMax();return d<g||d===g&&this._textModel.getLineLength(d)<2048}tokenizeHeuristically(d,g,m){if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(g<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(d,m),{heuristicTokens:!1};let A=this.b(g);const z=this._textModel.getLanguageId();for(let c=g;c<=m;c++){const C=this._textModel.getLineContent(c),B=D(this._languageIdCodec,z,this.tokenizationSupport,C,!0,A);d.add(c,B.tokens),A=B.endState}return{heuristicTokens:!0}}b(d){let g=this._textModel.getLineFirstNonWhitespaceColumn(d);const m=[];let A=null;for(let C=d-1;g>1&&C>=1;C--){const B=this._textModel.getLineFirstNonWhitespaceColumn(C);if(B!==0&&B<g&&(m.push(this._textModel.getLineContent(C)),g=B,A=this.getStartState(C),A))break}A||(A=this.tokenizationSupport.getInitialState()),m.reverse();const z=this._textModel.getLanguageId();let c=A;for(const C of m)c=D(this._languageIdCodec,z,this.tokenizationSupport,C,!1,c).endState;return c}}e.TokenizerWithStateStoreAndTextModel=a;class u{constructor(d){this.d=d,this.a=new T,this.b=new L,this.b.addRange(new t.OffsetRange(1,d+1))}getEndState(d){return this.a.getEndState(d)}setEndState(d,g){for(;;){const A=this.b.min;if(A!==null&&A<=d)this.b.removeMin();else break}const m=this.a.setEndState(d,g);return m&&d<this.d&&this.b.addRange(new t.OffsetRange(d+1,d+2)),m}acceptChange(d,g){this.d+=g-d.length,this.a.acceptChange(d,g),this.b.addRangeAndResize(new t.OffsetRange(d.startLineNumber,d.endLineNumberExclusive),g)}acceptChanges(d){for(const g of d){const[m]=(0,r.countEOL)(g.text);this.acceptChange(new h.LineRange(g.range.startLineNumber,g.range.endLineNumber+1),m+1)}}invalidateEndStateRange(d){this.b.addRange(new t.OffsetRange(d.startLineNumber,d.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.b.min||Number.MAX_SAFE_INTEGER}isTokenizationComplete(){return this.b.min===null}}e.TrackingTokenizationStateStore=u;class T{constructor(){this.a=new n.FixedArray(null)}getEndState(d){return this.a.get(d)}setEndState(d,g){const m=this.a.get(d);return m&&m.equals(g)?!1:(this.a.set(d,g),!0)}acceptChange(d,g){let m=d.length;g>0&&m>0&&(m--,g--),this.a.replace(d.startLineNumber,m,g)}acceptChanges(d){for(const g of d){const[m]=(0,r.countEOL)(g.text);this.acceptChange(new h.LineRange(g.range.startLineNumber,g.range.endLineNumber+1),m+1)}}}e.TokenizationStateStore=T;class L{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const d=this.a[0];return d.start+1===d.endExclusive?this.a.shift():this.a[0]=new t.OffsetRange(d.start+1,d.endExclusive),d.start}addRange(d){t.OffsetRange.addRange(d,this.a)}addRangeAndResize(d,g){let m=0;for(;!(m>=this.a.length||d.start<=this.a[m].endExclusive);)m++;let A=m;for(;!(A>=this.a.length||d.endExclusive<this.a[A].start);)A++;const z=g-d.length;for(let c=A;c<this.a.length;c++)this.a[c]=this.a[c].delta(z);if(m===A){const c=new t.OffsetRange(d.start,d.start+g);c.isEmpty||this.a.splice(m,0,c)}else{const c=Math.min(d.start,this.a[m].start),C=Math.max(d.endExclusive,this.a[A-1].endExclusive),B=new t.OffsetRange(c,C+z);B.isEmpty?this.a.splice(m,A-m):this.a.splice(m,A-m,B)}}toString(){return this.a.map(d=>d.toString()).join(" + ")}}e.RangePriorityQueueImpl=L;function D(k,d,g,m,A,z){let c=null;if(g)try{c=g.tokenizeEncoded(m,A,z.clone())}catch(C){(0,E.onUnexpectedError)(C)}return c||(c=(0,i.nullTokenizeEncoded)(k.encodeLanguageId(d),z)),v.LineTokens.convertToEndOffset(c.tokens,m.length),c}class U{constructor(d,g){this.b=d,this.d=g,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,y.runWhenIdle)(d=>{this.f=!1,this.h(d)}))}h(d){const g=Date.now()+d.timeRemaining(),m=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<g?(0,w.setTimeout0)(m):this.g())};m()}j(){const d=this.b._textModel.getLineCount(),g=new s.ContiguousMultilineTokensBuilder,m=P.StopWatch.create(!1);do if(m.elapsed()>1||this.l(g)>=d)break;while(this.k());this.d.setTokens(g.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.isTokenizationComplete():!1}l(d){if(!this.b||!this.k())return this.b._textModel.getLineCount()+1;const g=this.b.store.getFirstInvalidEndStateLineNumber();return this.b.updateTokensUntilLine(d,g),g}checkFinished(){this.a||this.b.store.isTokenizationComplete()&&this.d.backgroundTokenizationFinished()}requestTokens(d,g){this.b.store.invalidateEndStateRange(new h.LineRange(d,g))}}e.DefaultBackgroundTokenizer=U}),define(p[34],_([0,1,31,2,13,32]),function(F,e,y,E,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class r extends E.Disposable{constructor(t,i,n,s,v=()=>!1){super(),this.c=t,this.f=i,this.g=n,this.h=s,this.j=v,this.a=[],this.b=this.B(new y.Emitter),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(t,i,n){throw new Error("Not supported!")}createBackgroundTokenizer(t,i){if(this.h)return this.h(t,i)}tokenizeEncoded(t,i,n){const s=this.c.tokenizeLine2(t,n,500);if(s.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${t.substring(0,100)}`),new P.EncodedTokenizationResult(s.tokens,n);if(this.g){const b=this.a,o=s.tokens;for(let a=0,u=o.length>>>1;a<u;a++){const T=o[(a<<1)+1],L=w.TokenMetadata.getLanguageId(T);b[L]||(b[L]=!0,this.b.fire(L))}}let v;return n.equals(s.ruleStack)?v=n:v=s.ruleStack,new P.EncodedTokenizationResult(s.tokens,v)}}e.TextMateTokenizationSupport=r}),define(p[35],_([0,1,19,2,10]),function(F,e,y,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class P extends E.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(h,t,i){super(),this.a=h,this.b=t,this.c=i,this.B((0,w.keepAlive)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(h,t,i){throw new Error("Not supported!")}tokenizeEncoded(h,t,i){return h.length>=this.c.get()?(0,y.nullTokenizeEncoded)(this.a,i):this.b.tokenizeEncoded(h,t,i)}createBackgroundTokenizer(h,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(h,t)}}e.TokenizationSupportWithLineLimit=P}),define(p[36],_([0,1,17]),function(F,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class E{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(P){if(this.a[P.scopeName]){const r=this.a[P.scopeName];y.isEqual(r.location,P.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${P.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${P.location.toString()}`)}this.a[P.scopeName]=P}getGrammarDefinition(P){return this.a[P]||null}}e.TMScopeRegistry=E}),define(p[37],_([0,1,2,36]),function(F,e,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class w extends y.Disposable{constructor(r,h,t,i){super(),this.a=r,this.b=t.INITIAL,this.c=new E.TMScopeRegistry,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:i,loadGrammar:async n=>{const s=this.c.getGrammarDefinition(n);if(!s)return this.a.logTrace(`No grammar found for scope ${n}`),null;const v=s.location;try{const b=await this.a.readFile(v);return t.parseRawGrammar(b,v.path)}catch(b){return this.a.logError(`Unable to load and parse grammar for scope ${n} from ${v}`,b),null}},getInjections:n=>{const s=n.split(".");let v=[];for(let b=1;b<=s.length;b++){const o=s.slice(0,b).join(".");v=[...v,...this.f[o]||[]]}return v}}));for(const n of h){if(this.c.register(n),n.injectTo){for(const s of n.injectTo){let v=this.f[s];v||(this.f[s]=v=[]),v.push(n.scopeName)}if(n.embeddedLanguages)for(const s of n.injectTo){let v=this.g[s];v||(this.g[s]=v=[]),v.push(n.embeddedLanguages)}}n.language&&this.h.set(n.language,n.scopeName)}}has(r){return this.h.has(r)}setTheme(r,h){this.j.setTheme(r,h)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,h){const t=this.h.get(r);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const i=this.c.getGrammarDefinition(t);if(!i)throw new Error(e.missingTMGrammarErrorMessage);const n=i.embeddedLanguages;if(this.g[t]){const b=this.g[t];for(const o of b)for(const a of Object.keys(o))n[a]=o[a]}const s=Object.keys(n).length>0;let v;try{v=await this.j.loadGrammarWithConfiguration(t,h,{embeddedLanguages:n,tokenTypes:i.tokenTypes,balancedBracketSelectors:i.balancedBracketSelectors,unbalancedBracketSelectors:i.unbalancedBracketSelectors})}catch(b){throw b.message&&b.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):b}return{languageId:r,grammar:v,initialState:this.b,containsEmbeddedLanguages:s}}}e.TMGrammarFactory=w}),define(p[38],_([0,1,46,33,47,15,7,34,18,10,35,14]),function(F,e,y,E,w,P,r,h,t,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerModel=void 0;class v extends y.MirrorTextModel{constructor(a,u,T,L,D,U,k,d){super(a,u,T,L),this.m=D,this.q=U,this.s=k,this.a=null,this.b=!1,this.c=(0,i.observableValue)("_maxTokenizationLineLength",-1),this.t=new t.RunOnceScheduler(()=>this.v(),10),this.c.set(d,void 0),this.u()}dispose(){this.b=!0,super.dispose()}onLanguageId(a,u){this.q=a,this.s=u,this.u()}onEvents(a){super.onEvents(a),this.a&&this.a.store.acceptChanges(a.changes),this.t.schedule()}acceptMaxTokenizationLineLength(a){this.c.set(a,void 0)}retokenize(a,u){this.a&&(this.a.store.invalidateEndStateRange(new s.LineRange(a,u)),this.t.schedule())}u(){this.a=null;const a=this.q,u=this.s;this.m.getOrCreateGrammar(a,u).then(T=>{if(!(this.b||a!==this.q||u!==this.s||!T)){if(T.grammar){const L=new n.TokenizationSupportWithLineLimit(this.s,new h.TextMateTokenizationSupport(T.grammar,T.initialState,!1),this.c);this.a=new E.TokenizerWithStateStore(this.f.length,L)}else this.a=null;this.v()}})}v(){if(this.b||!this.a)return;const a=new Date().getTime();for(;;){let u=0;const T=new P.ContiguousMultilineTokensBuilder,L=new b;for(;;){const k=this.a.store.getFirstInvalidEndStateLineNumber();if(k===null||u>200)break;u++;const d=this.f[k-1],g=this.a.getStartState(k),m=this.a.tokenizationSupport.tokenizeEncoded(d,!0,g);if(this.a.store.setEndState(k,m.endState)){const z=(0,w.diffStateStacksRefEq)(g,m.endState);L.setState(k,z)}else L.setState(k,null);if(r.LineTokens.convertToEndOffset(m.tokens,d.length),T.add(k,m.tokens),new Date().getTime()-a>20)break}if(u===0)break;const D=L.getStateDeltas();if(this.m.setTokensAndStates(this.d,this.h,T.serialize(),D),new Date().getTime()-a>20){setTimeout(()=>this.v(),3);return}}}}e.TextMateWorkerModel=v;class b{constructor(){this.a=-1,this.b=[]}setState(a,u){a===this.a+1?this.b[this.b.length-1].stateDeltas.push(u):this.b.push({startLineNumber:a,stateDeltas:[u]}),this.a=a}getStateDeltas(){return this.b}}}),define(p[48],_([0,1,16,37,38]),function(F,e,y,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.TextMateTokenizationWorker=void 0;class P{constructor(t,i){this.f=i,this.b=Object.create(null),this.c=[],this.a=t.host;const n=i.grammarDefinitions.map(s=>({location:y.URI.revive(s.location),language:s.language,scopeName:s.scopeName,embeddedLanguages:s.embeddedLanguages,tokenTypes:s.tokenTypes,injectTo:s.injectTo,balancedBracketSelectors:s.balancedBracketSelectors,unbalancedBracketSelectors:s.unbalancedBracketSelectors}));this.d=this.g(n)}async g(t){const i=this.f.textmateMainUri,n=await new Promise((a,u)=>{F([i],a,u)}),s=await new Promise((a,u)=>{F([this.f.onigurumaMainUri],a,u)}),b=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await s.loadWASM(b);const o=Promise.resolve({createOnigScanner:a=>s.createOnigScanner(a),createOnigString:a=>s.createOnigString(a)});return new E.TMGrammarFactory({logTrace:a=>{},logError:(a,u)=>console.error(a,u),readFile:a=>this.a.readFile(a)},t,n,o)}acceptNewModel(t){const i=y.URI.revive(t.uri),n=i.toString();this.b[n]=new w.TextMateWorkerModel(i,t.lines,t.EOL,t.versionId,this,t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength)}acceptModelChanged(t,i){this.b[t].onEvents(i)}retokenize(t,i,n){this.b[t].retokenize(i,n)}acceptModelLanguageChanged(t,i,n){this.b[t].onLanguageId(i,n)}acceptRemovedModel(t){this.b[t]&&(this.b[t].dispose(),delete this.b[t])}async acceptTheme(t,i){(await this.d)?.setTheme(t,i)}acceptMaxTokenizationLineLength(t,i){this.b[t].acceptMaxTokenizationLineLength(i)}async getOrCreateGrammar(t,i){const n=await this.d;return n?(this.c[i]||(this.c[i]=n.createGrammar(t,i)),this.c[i]):Promise.resolve(null)}setTokensAndStates(t,i,n,s){this.a.setTokensAndStates(t,i,n,s)}}e.TextMateTokenizationWorker=P;function r(h,t){return new P(h,t)}e.create=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b380da4ef1ee00e224a15c1d4d9793e27c2b6302/core/vs/workbench/services/textMate/browser/worker/textMate.worker.js.map
